// TiberianDawn.DLL and RedAlert.dll and corresponding source code is free
// software: you can redistribute it and/or modify it under the terms of
// the GNU General Public License as published by the Free Software Foundation,
// either version 3 of the License, or (at your option) any later version.

// TiberianDawn.DLL and RedAlert.dll and corresponding source code is distributed
// in the hope that it will be useful, but with permitted additional restrictions
// under Section 7 of the GPL. See the GNU General Public License in LICENSE.TXT
// distributed with this program. You should have received a copy of the
// GNU General Public License along with permitted additional restrictions
// with this program. If not, see https://github.com/electronicarts/CnC_Remastered_Collection
#include "mixnamedb.h"

/*
 * This internal data set is based on the XCC mix database with additional contributions
 * from tomsons26 to make it more complete.
 */

const MixNameDatabase::DefaultDataEntry MixNameDatabase::s_defaultDB[] = {
    {"00-0000.aud", "", int32_t(0x1D597662), int32_t(0x00000000)},
    {"00-00000.aud", "", int32_t(0x656A624F), int32_t(0x00000000)},
    {"00-0000e.aud", "", int32_t(0x8F6A624F), int32_t(0x00000000)},
    {"00-0000r.aud", "", int32_t(0xA96A624F), int32_t(0x00000000)},
    {"00-4500e.aud", "", int32_t(0x9F6A6259), int32_t(0x00000000)},
    {"00-4515e.aud", "", int32_t(0x9F746459), int32_t(0x00000000)},
    {"00-4545e.aud", "", int32_t(0x9F746A59), int32_t(0x00000000)},
    {"00-4550e.aud", "", int32_t(0x9F6A6C59), int32_t(0x00000000)},
    {"00-4555e.aud", "", int32_t(0x9F746C59), int32_t(0x00000000)},
    {"00-4565e.aud", "", int32_t(0x9F746E59), int32_t(0x00000000)},
    {"00-4570e.aud", "", int32_t(0x9F6A7059), int32_t(0x00000000)},
    {"00-4580e.aud", "", int32_t(0x9F6A7259), int32_t(0x00000000)},
    {"00-4585e.aud", "", int32_t(0x9F747259), int32_t(0x00000000)},
    {"00-4590e.aud", "", int32_t(0x9F6A7459), int32_t(0x00000000)},
    {"00-4595e.aud", "", int32_t(0x9F747459), int32_t(0x00000000)},
    {"00-4610e.aud", "", int32_t(0x9F6A645B), int32_t(0x00000000)},
    {"00-4615e.aud", "", int32_t(0x9F74645B), int32_t(0x00000000)},
    {"00-4645e.aud", "", int32_t(0x9F746A5B), int32_t(0x00000000)},
    {"00-4650e.aud", "", int32_t(0x9F6A6C5B), int32_t(0x00000000)},
    {"00-4665e.aud", "", int32_t(0x9F746E5B), int32_t(0x00000000)},
    {"00-8525e.aud", "", int32_t(0xAF746659), int32_t(0x00000000)},
    {"00-8529e.aud", "", int32_t(0xAF7C6659), int32_t(0x00000000)},
    {"00-8620e.aud", "", int32_t(0xAF6A665B), int32_t(0x00000000)},
    {"00-8735e.aud", "", int32_t(0xAF74685D), int32_t(0x00000000)},
    {"00-8740e.aud", "", int32_t(0xAF6A6A5D), int32_t(0x00000000)},
    {"00-i008.aud", "gdi structure destroyed", int32_t(0x00000000), int32_t(0x70B16C79)},
    {"00-i012.aud", "battle controll offline", int32_t(0x00000000), int32_t(0x775D44AB)},
    {"00-i014.aud", "building infiltrated", int32_t(0x00000000), int32_t(0xA104A7B6)},
    {"00-i016.aud", "cannot deploy here", int32_t(0x00000000), int32_t(0xECCC06BD)},
    {"00-i018.aud", "construction complete", int32_t(0x00000000), int32_t(0xD6C667CD)},
    {"00-i020.aud", "incomming transmission", int32_t(0x00000000), int32_t(0x0B7DFF3D)},
    {"00-i022.aud", "insufficant funds", int32_t(0x00000000), int32_t(0x46B55E36)},
    {"00-i024.aud", "low power", int32_t(0x00000000), int32_t(0x90ECBD2B)},
    {"00-i026.aud", "mission accomplished", int32_t(0x00000000), int32_t(0xDD241C20)},
    {"00-i028.aud", "mission failed", int32_t(0x00000000), int32_t(0xE72E7D50)},
    {"00-i032.aud", "new construction options", int32_t(0x00000000), int32_t(0xE0C25582)},
    {"00-i034.aud", "primary building set", int32_t(0x00000000), int32_t(0x369BB69F)},
    {"00-i038.aud", "reinforcements have arrived", int32_t(0x00000000), int32_t(0x415976E4)},
    {"00-i040.aud", "repairing", int32_t(0x00000000), int32_t(0x68ADCA07)},
    {"00-i042.aud", "select target", int32_t(0x00000000), int32_t(0x25656B0C)},
    {"00-i044.aud", "silos needed", int32_t(0x00000000), int32_t(0xF33C8811)},
    {"00-i056.aud", "building captured", int32_t(0x00000000), int32_t(0x188322AE)},
    {"00-i058.aud", "timer started", int32_t(0x00000000), int32_t(0x228943DE)},
    {"00-i060.aud", "timer stopped", int32_t(0x00000000), int32_t(0xFF32DB2E)},
    {"00-i062.aud", "training", int32_t(0x00000000), int32_t(0xB2FA7A25)},
    {"00-i064.aud", "unable to comply, building in progress", int32_t(0x00000000), int32_t(0x64A39938)},
    {"00-i068.aud", "unit armour upgraded", int32_t(0x00000000), int32_t(0x13615943)},
    {"00-i070.aud", "unit firepower upgraded", int32_t(0x00000000), int32_t(0x5945D09A)},
    {"00-i074.aud", "unit lost", int32_t(0x00000000), int32_t(0xC2D4928C)},
    {"00-i076.aud", "unit ready", int32_t(0x00000000), int32_t(0x8F1C3387)},
    {"00-i078.aud", "unit repaired", int32_t(0x00000000), int32_t(0xB51652F7)},
    {"00-i080.aud", "unit speed upgraded", int32_t(0x00000000), int32_t(0xAF0DA073)},
    {"00-i082.aud", "base under attack", int32_t(0x00000000), int32_t(0xE2C50178)},
    {"00-i090.aud", "harvester under attack", int32_t(0x00000000), int32_t(0x097AABC7)},
    {"00-i100.aud", "primary objective achieved", int32_t(0x00000000), int32_t(0x5048EE8A)},
    {"00-i102.aud", "secondary objective achieved", int32_t(0x00000000), int32_t(0x1D804F81)},
    {"00-i104.aud", "tertiary objective achieved", int32_t(0x00000000), int32_t(0xCBD9AC9C)},
    {"00-i106.aud", "quaternery objective achieved", int32_t(0x00000000), int32_t(0x86110D97)},
    {"00-i118.aud", "bridge repaired", int32_t(0x00000000), int32_t(0x1A6C6753)},
    {"00-i122.aud", "twenty minutes remaining", int32_t(0x00000000), int32_t(0x8A1F5EA8)},
    {"00-i124.aud", "ten minutes remaining", int32_t(0x00000000), int32_t(0x5C46BDB5)},
    {"00-i126.aud", "five minutes remaining", int32_t(0x00000000), int32_t(0x118E1CBE)},
    {"00-i128.aud", "four minutes remaining", int32_t(0x00000000), int32_t(0x2B847DCE)},
    {"00-i130.aud", "three minutes remaining", int32_t(0x00000000), int32_t(0x61A0F417)},
    {"00-i132.aud", "two minutes remaining", int32_t(0x00000000), int32_t(0x2C68551C)},
    {"00-i134.aud", "one minute remaining", int32_t(0x00000000), int32_t(0xFA31B601)},
    {"00-i150.aud", "missile launch detected", int32_t(0x00000000), int32_t(0x0270C12D)},
    {"00-i152.aud", "chemical missile ready", int32_t(0x00000000), int32_t(0x4FB86026)},
    {"00-i154.aud", "cluster missile ready", int32_t(0x00000000), int32_t(0x99E1833B)},
    {"00-i156.aud", "ion cannon ready", int32_t(0x00000000), int32_t(0xD4292230)},
    {"00-i158.aud", "em pulse cannon ready", int32_t(0x00000000), int32_t(0xEE234340)},
    {"00-i162.aud", "fire storm defense ready", int32_t(0x00000000), int32_t(0x7E507ABB)},
    {"00-i170.aud", "fire storm defense offline", int32_t(0x00000000), int32_t(0x95EFD004)},
    {"00-i172.aud", "cloaked unit detected", int32_t(0x00000000), int32_t(0xD827710F)},
    {"00-i174.aud", "subterrainian unit detected", int32_t(0x00000000), int32_t(0x0E7E9212)},
    {"00-i176.aud", "ion storm approaching", int32_t(0x00000000), int32_t(0x43B63319)},
    {"00-i178.aud", "metior storm approaching", int32_t(0x00000000), int32_t(0x79BC5269)},
    {"00-i180.aud", "base defenses offline", int32_t(0x00000000), int32_t(0x63A7A0ED)},
    {"00-i194.aud", "critical unit lost", int32_t(0x00000000), int32_t(0x5E41E94F)},
    {"00-i196.aud", "critical structure lost", int32_t(0x00000000), int32_t(0x13894844)},
    {"00-i198.aud", "new terrain discovered", int32_t(0x00000000), int32_t(0x29832934)},
    {"00-i200.aud", "establishing battlefield controll, stand by", int32_t(0x00000000), int32_t(0xDEC7E969)},
    {"00-i208.aud", "mutant supplies found", int32_t(0x00000000), int32_t(0x32946B04)},
    {"00-i210.aud", "commandos en route", int32_t(0x00000000), int32_t(0x78B0E2DD)},
    {"00-i216.aud", "building", int32_t(0x00000000), int32_t(0xAEE901C0)},
    {"00-i218.aud", "on hold", int32_t(0x00000000), int32_t(0x94E360B0)},
    {"00-i220.aud", "canceled", int32_t(0x00000000), int32_t(0x4958F840)},
    {"00-i226.aud", "unit sold", int32_t(0x00000000), int32_t(0x9F011B5D)},
    {"00-i228.aud", "structure sold", int32_t(0x00000000), int32_t(0xA50B7A2D)},
    {"00-i230.aud", "building offline", int32_t(0x00000000), int32_t(0xEF2FF3F4)},
    {"00-i232.aud", "building online", int32_t(0x00000000), int32_t(0xA2E752FF)},
    {"00-i252.aud", "player has resigned", int32_t(0x00000000), int32_t(0xC13767C5)},
    {"00-i268.aud", "player was defeated", int32_t(0x00000000), int32_t(0x51445E3E)},
    {"00-i284.aud", "you are victorious", int32_t(0x00000000), int32_t(0x76B9E518)},
    {"00-i286.aud", "you have lost", int32_t(0x00000000), int32_t(0x3B714413)},
    {"00-i288.aud", "you have resigned", int32_t(0x00000000), int32_t(0x017B2563)},
    {"00-i290.aud", "mutant commandos available", int32_t(0x00000000), int32_t(0x4B5FACBA)},
    {"00-i304.aud", "alliance formed", int32_t(0x00000000), int32_t(0x89FCABE1)},
    {"00-i306.aud", "alliance broken", int32_t(0x00000000), int32_t(0xC4340AEA)},
    {"00-i308.aud", "our ally is under attack", int32_t(0x00000000), int32_t(0xFE3E6B9A)},
    {"00-i310.aud", "build more power plants to restore full power", int32_t(0x00000000), int32_t(0xB41AE243)},
    {"00-i312.aud", "build barracks to train additional troops", int32_t(0x00000000), int32_t(0xF9D24348)},
    {"00-i314.aud", "build hand of nod to train additional troops", int32_t(0x00000000), int32_t(0x2F8BA055)},
    {"00-i316.aud", "build a tiberium refinery to harvest tiberium", int32_t(0x00000000), int32_t(0x6243015E)},
    {"00-i318.aud", "build silos to store excess tiberium", int32_t(0x00000000), int32_t(0x5849602E)},
    {"00-i344.aud", "inferior tactics detected", int32_t(0x00000000), int32_t(0x7DB38FF2)},
    {"00-i346.aud", "retreat is your only logical option", int32_t(0x00000000), int32_t(0x307B2EF9)},
    {"00-i348.aud", "surrender is your only logical option", int32_t(0x00000000), int32_t(0x0A714F89)},
    {"00-i352.aud", "your defeat is at hand", int32_t(0x00000000), int32_t(0x0D9D675B)},
    {"00-i356.aud", "you have been marked for termination", int32_t(0x00000000), int32_t(0x960C254D)},
    {"00-i360.aud", "time to erase the human factor from this equasion", int32_t(0x00000000), int32_t(0x71BDDCCD)},
    {"00-i370.aud", "your probobility of sucess is dropping", int32_t(0x00000000), int32_t(0xD7CAD779)},
    {"00-i372.aud",
     "surrender is preferable against the odds you are facing",
     int32_t(0x00000000),
     int32_t(0x9A027672)},
    {"00-i374.aud", "data recieved indicates that you are a threat", int32_t(0x00000000), int32_t(0x4C5B956F)},
    {"00-i376.aud", "defeat of enemy predicted", int32_t(0x00000000), int32_t(0x01933464)},
    {"00-i500.aud", "objective complete", int32_t(0x00000000), int32_t(0xD402E070)},
    {"00-i502.aud", "final objective complete", int32_t(0x00000000), int32_t(0x99CA417B)},
    {"00-i504.aud", "unable to comply, fist of nod deployed", int32_t(0x00000000), int32_t(0x4F93A266)},
    {"00-i506.aud", "drop pods available", int32_t(0x00000000), int32_t(0x025B036D)},
    {"00-n000.aud", "build a refinery to harvest tiberium", int32_t(0x00000000), int32_t(0xF88383DD)},
    {"00-n002.aud", "harvester will begin harvesting", int32_t(0x00000000), int32_t(0xB54B22D6)},
    {"00-n004.aud", "build a barracks", int32_t(0x00000000), int32_t(0x6312C1CB)},
    {"00-n006.aud", "destroy all nod forces in the area", int32_t(0x00000000), int32_t(0x2EDA60C0)},
    {"00-n018.aud", "civillian killed", int32_t(0x00000000), int32_t(0xB2A70A04)},
    {"00-n020.aud", "nod sam sites destroyed", int32_t(0x00000000), int32_t(0x6F1C92F4)},
    {"00-n022.aud", "gdi transports en route", int32_t(0x00000000), int32_t(0x22D433FF)},
    {"00-n024.aud", "civillians evacuated, objective complete", int32_t(0x00000000), int32_t(0xF48DD0E2)},
    {"00-n032.aud", "site secure, objective complete", int32_t(0x00000000), int32_t(0x84A3384B)},
    {"00-n034.aud", "technology centre captured, objective complete", int32_t(0x00000000), int32_t(0x52FADB56)},
    {"00-n040.aud", "base destroyed, objective complete", int32_t(0x00000000), int32_t(0x0CCCA7CE)},
    {"00-n042.aud", "it would be advantages to destroy bridges", int32_t(0x00000000), int32_t(0x410406C5)},
    {"00-n044.aud", "bridges destroyed, objective complete", int32_t(0x00000000), int32_t(0x975DE5D8)},
    {"00-n052.aud", "ufo under attack", int32_t(0x00000000), int32_t(0xE7730D71)},
    {"00-n054.aud", "ufo destroyed, mission failed", int32_t(0x00000000), int32_t(0x312AEE6C)},
    {"00-n055.aud", "array destroyed, objective complete", int32_t(0x00000000), int32_t(0xFA763DC9)},
    {"00-n056.aud", "incomming transmission", int32_t(0x00000000), int32_t(0x7CE24F67)},
    {"00-n058.aud", "tratos evacuated, primary objective complete", int32_t(0x00000000), int32_t(0x46E82E17)},
    {"00-n059.aud", "transport destroyed, mission failed", int32_t(0x00000000), int32_t(0x8DB4FDB2)},
    {"00-n068.aud", "ion storm approaching, eta 5 minutes", int32_t(0x00000000), int32_t(0x7700348A)},
    {"00-n070.aud", "ion storm abating", int32_t(0x00000000), int32_t(0x3D24BD53)},
    {"00-n072.aud", "air power innefective during ion storms", int32_t(0x00000000), int32_t(0x70EC1C58)},
    {"00-n074.aud", "dam destroyed, mission complete", int32_t(0x00000000), int32_t(0xA6B5FF45)},
    {"00-n075.aud", "dam sighted, target confirmed", int32_t(0x00000000), int32_t(0x6DE92CE0)},
    {"00-n084.aud", "enemy sam sites detected", int32_t(0x00000000), int32_t(0x50FD8FAC)},
    {"00-n086.aud",
     "all sam sites must be destroyed before dropships can be deployed",
     int32_t(0x00000000),
     int32_t(0x1D352EA7)},
    {"00-n088.aud", "sam sites destroyed, dropships inbound", int32_t(0x00000000), int32_t(0x273F4FD7)},
    {"00-n096.aud", "command centre destroyed, mission complete", int32_t(0x00000000), int32_t(0xBB422513)},
    {"00-n098.aud", "warning, inbound tactical nuke detected", int32_t(0x00000000), int32_t(0x81484463)},
    {"00-n112.aud", "perimeter deactivated", int32_t(0x00000000), int32_t(0xDF9629FC)},
    {"00-n114.aud", "reinforcements inbound", int32_t(0x00000000), int32_t(0x09CFCAE1)},
    {"00-n128.aud", "bridge repaired", int32_t(0x00000000), int32_t(0x4FE51007)},
    {"00-n130.aud", "train returning to nod base", int32_t(0x00000000), int32_t(0x05C199DE)},
    {"00-n132.aud", "reinforcements en route", int32_t(0x00000000), int32_t(0x480938D5)},
    {"00-n134.aud", "capture nod tech center to recover the crystals", int32_t(0x00000000), int32_t(0x9E50DBC8)},
    {"00-n136.aud", "train disabled, carryall inbound", int32_t(0x00000000), int32_t(0xD3987AC3)},
    {"00-n138.aud", "crystals destroyed, mission failed", int32_t(0x00000000), int32_t(0xE9921BB3)},
    {"00-n140.aud",
     "ion storm forming over this sector, pilot return to base",
     int32_t(0x00000000),
     int32_t(0xC066A750)},
    {"00-n142.aud", "pilot return to base", int32_t(0x00000000), int32_t(0x8DAE065B)},
    {"00-n156.aud", "force detected, enemy units en route", int32_t(0x00000000), int32_t(0xB0484FF9)},
    {"00-n158.aud", "mutants lost, mission failed", int32_t(0x00000000), int32_t(0x8A422E89)},
    {"00-n160.aud", "airstrike ready", int32_t(0x00000000), int32_t(0x57F9B679)},
    {"00-n162.aud", "transports inbound", int32_t(0x00000000), int32_t(0x1A311772)},
    {"00-n166.aud", "supply base destroyed, mission complete", int32_t(0x00000000), int32_t(0x81A05564)},
    {"00-n168.aud", "mutants en route to power grid", int32_t(0x00000000), int32_t(0xBBAA3414)},
    {"00-n180.aud", "c4 planted, mission complete", int32_t(0x00000000), int32_t(0x07C6CD24)},
    {"00-n182.aud", "ghost stalker terminated, mission failed", int32_t(0x00000000), int32_t(0x4A0E6C2F)},
    {"00-n188.aud", "missile complex destroyed, mission complete", int32_t(0x00000000), int32_t(0xEB954F49)},
    {"00-n190.aud", "tiberium missile inbound", int32_t(0x00000000), int32_t(0xA1B1C690)},
    {"00-n192.aud", "ion storn will disable fighters", int32_t(0x00000000), int32_t(0xEC79679B)},
    {"00-n206.aud", "mutants detected, enemy forces en route", int32_t(0x00000000), int32_t(0x6CFF67BD)},
    {"00-n208.aud",
     "fighter production facillity located, dropships en route",
     int32_t(0x00000000),
     int32_t(0x56F506CD)},
    {"00-n210.aud",
     "fighter production facillity destroyed, mission complete",
     int32_t(0x00000000),
     int32_t(0x1CD18F14)},
    {"00-n236.aud", "kodiak under attack", int32_t(0x00000000), int32_t(0x5D177D20)},
    {"00-n238.aud", "storm abating, commence attack on nod forces", int32_t(0x00000000), int32_t(0x671D1C50)},
    {"00-n239.aud", "kodiak in critical condition", int32_t(0x00000000), int32_t(0xAC41CFF5)},
    {"00-n240.aud", "kodiak destroyed, mission failed", int32_t(0x00000000), int32_t(0x4EE9A0B3)},
    {"00-n241.aud",
     "eye of the storm has been entered, equpiment at maximum efficency",
     int32_t(0x00000000),
     int32_t(0x85B57316)},
    {"00-n243.aud", "tiberium life form detected", int32_t(0x00000000), int32_t(0xC87DD21D)},
    {"00-n245.aud", "re-entering ion storm, caution is advised", int32_t(0x00000000), int32_t(0x1E243100)},
    {"00-n247.aud", "clear the zone for mcv dropship deployment", int32_t(0x00000000), int32_t(0x53EC900B)},
    {"00-n248.aud",
     "philladelphia in range, icbm launch detected, mission failed",
     int32_t(0x00000000),
     int32_t(0xA2BA22DE)},
    {"00-n249.aud", "tiberium life form detected", int32_t(0x00000000), int32_t(0x69E6F17B)},
    {"00-n250.aud", "tiberium missile launched, mission failed", int32_t(0x00000000), int32_t(0xE89EAB07)},
    {"00-n251.aud", "icbms destroyed, philadelphia is out of danger", int32_t(0x00000000), int32_t(0x23C278A2)},
    {"00-n252.aud",
     "nod has installed several icbms to take out the philladelphia",
     int32_t(0x00000000),
     int32_t(0xA5560A0C)},
    {"00-n254.aud", "to stop them, take out the other 3 launchers", int32_t(0x00000000), int32_t(0x730FE911)},
    {"00-n255.aud", "civillian city is under attack", int32_t(0x00000000), int32_t(0xB8533AB4)},
    {"00-n400.aud", "kodiak located", int32_t(0x00000000), int32_t(0x7CC98D27)},
    {"00-n402.aud", "tascitus aquired, proced to beacon for extraction", int32_t(0x00000000), int32_t(0x31012C2C)},
    {"00-n404.aud", "tascitus lost", int32_t(0x00000000), int32_t(0xE758CF31)},
    {"00-n406.aud", "tascitus found", int32_t(0x00000000), int32_t(0xAA906E3A)},
    {"00-n408.aud", "nod has captured the tascitus, recover it at all costs", int32_t(0x00000000), int32_t(0x909A0F4A)},
    {"00-n410.aud", "find & evacuate any civillians in the area", int32_t(0x00000000), int32_t(0xDABE8693)},
    {"00-n412.aud", "maintain all factories untill reinforcements arrive", int32_t(0x00000000), int32_t(0x97762798)},
    {"00-n414.aud",
     "escort the civillians to the orca transport for immediate airlift",
     int32_t(0x00000000),
     int32_t(0x412FC485)},
    {"00-n416.aud", "human leader neutralized", int32_t(0x00000000), int32_t(0x0CE7658E)},
    {"00-n418.aud", "mutant leader neutralized", int32_t(0x00000000), int32_t(0x36ED04FE)},
    {"00-n420.aud", "food centre under attack", int32_t(0x00000000), int32_t(0xEB569C0E)},
    {"00-n422.aud", "food centre destroyed", int32_t(0x00000000), int32_t(0xA69E3D05)},
    {"00-n424.aud", "water purifiers under attack", int32_t(0x00000000), int32_t(0x70C7DE18)},
    {"00-n426.aud", "water purifiers destroyed", int32_t(0x00000000), int32_t(0x3D0F7F13)},
    {"00-n428.aud", "the riots were incited by 2 members of each side", int32_t(0x00000000), int32_t(0x07051E63)},
    {"00-n430.aud", "neutralize the leaders to end hostillities", int32_t(0x00000000), int32_t(0x4D2197BA)},
    {"00-n432.aud", "riot leader neutralized", int32_t(0x00000000), int32_t(0x00E936B1)},
    {"00-n434.aud", "first riot leader neutralized", int32_t(0x00000000), int32_t(0xD6B0D5AC)},
    {"00-n436.aud", "second riot leader neutralized", int32_t(0x00000000), int32_t(0x9B7874A7)},
    {"00-n438.aud", "third riot leader neutralized", int32_t(0x00000000), int32_t(0xA17215D7)},
    {"00-n440.aud", "forth riot leader neutralized", int32_t(0x00000000), int32_t(0x8886A934)},
    {"00-n442.aud", "all riot leaders have been neutralized", int32_t(0x00000000), int32_t(0xC54E083F)},
    {"00-n444.aud", "enemy reinforcements have arrived", int32_t(0x00000000), int32_t(0x1317EB22)},
    {"00-n446.aud", "destroy the two bridges in the area", int32_t(0x00000000), int32_t(0x5EDF4A29)},
    {"00-n448.aud", "disable cabals defences", int32_t(0x00000000), int32_t(0x64D52B59)},
    {"00-n450.aud", "use an engineer to capture cabals core", int32_t(0x00000000), int32_t(0x2EF1A280)},
    {"00-n452.aud", "outpost located", int32_t(0x00000000), int32_t(0x6339038B)},
    {"00-n454.aud", "destroy all cabal forces", int32_t(0x00000000), int32_t(0xB560E096)},
    {"00-n456.aud", "return to the outpost & evacuate doctor budro", int32_t(0x00000000), int32_t(0xF8A8419D)},
    {"00-n458.aud", "gdi base is located due east of your position", int32_t(0x00000000), int32_t(0xC2A220ED)},
    {"00-n460.aud", "procede with caution", int32_t(0x00000000), int32_t(0x1F19B81D)},
    {"00-n462.aud", "inform the villages", int32_t(0x00000000), int32_t(0x52D11916)},
    {"00-n464.aud", "village sucessfully warned", int32_t(0x00000000), int32_t(0x8488FA0B)},
    {"00-n466.aud", "all villages sucessfully warned", int32_t(0x00000000), int32_t(0xC9405B00)},
    {"00-n468.aud", "we have lost contatc with the gdi base in this sector", int32_t(0x00000000), int32_t(0xF34A3A70)},
    {"00-n470.aud", "we have lost contact with the gdi base in this reigon", int32_t(0x00000000), int32_t(0xB96EB3A9)},
    {"00-n472.aud", "gdi base in this sector under siege", int32_t(0x00000000), int32_t(0xF4A612A2)},
    {"00-n474.aud", "3 small civillian enclaves in this area must be warned", int32_t(0x00000000), int32_t(0x22FFF1BF)},
    {"00-n478.aud", "two more outposts to warn", int32_t(0x00000000), int32_t(0x553D31C4)},
    {"00-n479.aud", "one final village must be warned", int32_t(0x00000000), int32_t(0x9E61E261)},
    {"00-n480.aud", "the city of trondheim must be warned", int32_t(0x00000000), int32_t(0x4F26C340)},
    {"00-n482.aud", "destroy cabals base & forces", int32_t(0x00000000), int32_t(0x02EE624B)},
    {"00-n484.aud", "infected cyborg introduced into factory", int32_t(0x00000000), int32_t(0xD4B78156)},
    {"00-n486.aud",
     "deliver the infected cyborg into the communications network",
     int32_t(0x00000000),
     int32_t(0x997F205D)},
    {"00-n488.aud", "destroy the cyborg production plant", int32_t(0x00000000), int32_t(0xA375412D)},
    {"00-n490.aud", "deliver the infected cyborg into cabals base", int32_t(0x00000000), int32_t(0xE951C8F4)},
    {"00-n492.aud",
     "there is another communications array in cabals main base",
     int32_t(0x00000000),
     int32_t(0xA49969FF)},
    {"00-n494.aud", "deliver a second cyborg to the new array", int32_t(0x00000000), int32_t(0x72C08AE2)},
    {"00-n496.aud", "multiple missile launches detected", int32_t(0x00000000), int32_t(0x3F082BE9)},
    {"00-n498.aud", "destroy cabals harvesters", int32_t(0x00000000), int32_t(0x05024A99)},
    {"00-n500.aud", "controll station captured", int32_t(0x00000000), int32_t(0xB0638DB9)},
    {"00-n502.aud", "there are 3 controll stations in this area", int32_t(0x00000000), int32_t(0xFDAB2CB2)},
    {"00-n504.aud", "capture these stations & retrieve the codes", int32_t(0x00000000), int32_t(0x2BF2CFAF)},
    {"00-n506.aud", "destroy the bridges", int32_t(0x00000000), int32_t(0x663A6EA4)},
    {"00-n508.aud",
     "locating the civillians might help in disabling the laser fencing",
     int32_t(0x00000000),
     int32_t(0x5C300FD4)},
    {"00-n510.aud",
     "proboble location within civillian outpost to the north",
     int32_t(0x00000000),
     int32_t(0x1614860D)},
    {"00-w000.v00", "-", int32_t(0x00000000), int32_t(0x3061ADE8)},
    {"00-w002.v00", "-", int32_t(0x00000000), int32_t(0x7DA90CE3)},
    {"00-w004.v00", "-", int32_t(0x00000000), int32_t(0xABF0EFFE)},
    {"00-w006.v00", "-", int32_t(0x00000000), int32_t(0xE6384EF5)},
    {"00-w008.v00", "-", int32_t(0x00000000), int32_t(0xDC322F85)},
    {"00-w010.v00", "-", int32_t(0x00000000), int32_t(0x9616A65C)},
    {"00-w012.v00", "-", int32_t(0x00000000), int32_t(0xDBDE0757)},
    {"00-w014.v00", "-", int32_t(0x00000000), int32_t(0x0D87E44A)},
    {"00-w016.v00", "-", int32_t(0x00000000), int32_t(0x404F4541)},
    {"00-w017.v00", "-", int32_t(0x00000000), int32_t(0x8B1396E4)},
    {"00-w018.v00", "-", int32_t(0x00000000), int32_t(0x7A452431)},
    {"00-w020.v00", "-", int32_t(0x00000000), int32_t(0xA7FEBCC1)},
    {"00-w022.v00", "-", int32_t(0x00000000), int32_t(0xEA361DCA)},
    {"00-w024.v00", "-", int32_t(0x00000000), int32_t(0x3C6FFED7)},
    {"00-w026.v00", "-", int32_t(0x00000000), int32_t(0x71A75FDC)},
    {"00-w028.v00", "-", int32_t(0x00000000), int32_t(0x4BAD3EAC)},
    {"00-w029.v00", "-", int32_t(0x00000000), int32_t(0x80F1ED09)},
    {"00-w030.v00", "-", int32_t(0x00000000), int32_t(0x0189B775)},
    {"00-w031.v00", "-", int32_t(0x00000000), int32_t(0xCAD564D0)},
    {"00-w032.v00", "-", int32_t(0x00000000), int32_t(0x4C41167E)},
    {"00-w034.v00", "-", int32_t(0x00000000), int32_t(0x9A18F563)},
    {"00-w036.v00", "-", int32_t(0x00000000), int32_t(0xD7D05468)},
    {"00-w038.v00", "-", int32_t(0x00000000), int32_t(0xEDDA3518)},
    {"00-w040.v00", "-", int32_t(0x00000000), int32_t(0xC42E89FB)},
    {"00-w042.v00", "-", int32_t(0x00000000), int32_t(0x89E628F0)},
    {"00-w044.v00", "-", int32_t(0x00000000), int32_t(0x5FBFCBED)},
    {"0000.aud", "", int32_t(0xA4B5A18E), int32_t(0x00000000)},
    {"01-i342.aud", "inferior tactics detected", int32_t(0x00000000), int32_t(0x6A64B32F)},
    {"01-i350.aud",
     "observe superior tactics while you still have human eyes",
     int32_t(0x00000000),
     int32_t(0x81DB1990)},
    {"01-i352.aud", "your defeat is at hand", int32_t(0x00000000), int32_t(0xCC13B89B)},
    {"01-i356.aud", "you have been marked for termination", int32_t(0x00000000), int32_t(0x5782FA8D)},
    {"01-i360.aud", "time to erase the human factor from this equasion", int32_t(0x00000000), int32_t(0xB033030D)},
    {"01-i362.aud", "prepair for decimation", int32_t(0x00000000), int32_t(0xFDFBA206)},
    {"01-i364.aud", "you make this easy, fleshbag", int32_t(0x00000000), int32_t(0x2BA2411B)},
    {"01-i366.aud", "we tire of your insignificant defience", int32_t(0x00000000), int32_t(0x666AE010)},
    {"01-i368.aud", "the sacrifice of the many is the pleasure of the few", int32_t(0x00000000), int32_t(0x5C608160)},
    {"01-i378.aud", "terminator protocols initiated", int32_t(0x00000000), int32_t(0xFA178AD4)},
    {"01-n000.aud", "harvest the tiberium to the north", int32_t(0x00000000), int32_t(0x390D5C1D)},
    {"01-n002.aud", "destroy hassans elite guard", int32_t(0x00000000), int32_t(0x74C5FD16)},
    {"01-n004.aud", "to get production on line, build a tiberium refinery", int32_t(0x00000000), int32_t(0xA29C1E0B)},
    {"01-n005.aud", "base perimiter has been breached", int32_t(0x00000000), int32_t(0x69C0CDAE)},
    {"01-n006.aud", "establishing battle controlls, stand by", int32_t(0x00000000), int32_t(0xEF54BF00)},
    {"01-n007.aud", "to build or train...", int32_t(0x00000000), int32_t(0x24086CA5)},
    {"01-n008.aud", "battle controlls established", int32_t(0x00000000), int32_t(0xD55EDE70)},
    {"01-n009.aud", "tiberium is hazzardus to unprotected infantry", int32_t(0x00000000), int32_t(0x1E020DD5)},
    {"01-n010.aud", "power levels are low, construct more power plants", int32_t(0x00000000), int32_t(0x9F7A57A9)},
    {"01-n011.aud", "to repair a structure...", int32_t(0x00000000), int32_t(0x5426840C)},
    {"01-n020.aud", "capture the tv station to the east", int32_t(0x00000000), int32_t(0xAE924D34)},
    {"01-n022.aud", "to repair a bridge...", int32_t(0x00000000), int32_t(0xE35AEC3F)},
    {"01-n024.aud", "destroy hassans remaining guard", int32_t(0x00000000), int32_t(0x35030F22)},
    {"01-n026.aud", "to capture a building...", int32_t(0x00000000), int32_t(0x78CBAE29)},
    {"01-n027.aud", "to deploy a vechile...", int32_t(0x00000000), int32_t(0xB3977D8C)},
    {"01-n032.aud", "move to an open area and build your base", int32_t(0x00000000), int32_t(0x452DE78B)},
    {"01-n034.aud", "destroy hassans pyramid", int32_t(0x00000000), int32_t(0x93740496)},
    {"01-n036.aud", "when hassan flees like a dog, capture him", int32_t(0x00000000), int32_t(0xDEBCA59D)},
    {"01-n038.aud", "capturing the local radar towers", int32_t(0x00000000), int32_t(0xE4B6C4ED)},
    {"01-n040.aud", "mcv has arrived to the south east", int32_t(0x00000000), int32_t(0xCD42780E)},
    {"01-n054.aud", "it seams that cretain structures attract lighting", int32_t(0x00000000), int32_t(0xF0A431AC)},
    {"01-n055.aud", "use them to your advantage", int32_t(0x00000000), int32_t(0x3BF8E209)},
    {"01-n064.aud", "gdi base operational", int32_t(0x00000000), int32_t(0xC14C2B31)},
    {"01-n066.aud", "tascitus has been aquired", int32_t(0x00000000), int32_t(0x8C848A3A)},
    {"01-n068.aud", "tiberium life form detected", int32_t(0x00000000), int32_t(0xB68EEB4A)},
    {"01-n070.aud", "mutant vermin detected", int32_t(0x00000000), int32_t(0xFCAA6293)},
    {"01-n072.aud", "gdi dropship detected", int32_t(0x00000000), int32_t(0xB162C398)},
    {"01-n074.aud", "bullet train departing", int32_t(0x00000000), int32_t(0x673B2085)},
    {"01-n076.aud", "prevent that train from leaving", int32_t(0x00000000), int32_t(0x2AF3818E)},
    {"01-n086.aud", "protect your engineers", int32_t(0x00000000), int32_t(0xDCBBF167)},
    {"01-n088.aud", "congratulations on your sucess", int32_t(0x00000000), int32_t(0xE6B19017)},
    {"01-n090.aud", "i will send an apc now to the gdi base", int32_t(0x00000000), int32_t(0xAC9519CE)},
    {"01-n100.aud", "your forces have been detected", int32_t(0x00000000), int32_t(0xF5A75C83)},
    {"01-n102.aud", "prevent gdis evacuation at all costs", int32_t(0x00000000), int32_t(0xB86FFD88)},
    {"01-n114.aud", "incoming transport detected", int32_t(0x00000000), int32_t(0xC8411521)},
    {"01-n116.aud", "mutant life form detected on board", int32_t(0x00000000), int32_t(0x8589B42A)},
    {"01-n128.aud", "mutants located", int32_t(0x00000000), int32_t(0x8E6BCFC7)},
    {"01-n130.aud", "mcv en route", int32_t(0x00000000), int32_t(0xC44F461E)},
    {"01-n132.aud", "research facillity located", int32_t(0x00000000), int32_t(0x8987E715)},
    {"01-n134.aud", "research facillity destroyed", int32_t(0x00000000), int32_t(0x5FDE0408)},
    {"01-n136.aud", "biotoxin convoy approaching", int32_t(0x00000000), int32_t(0x1216A503)},
    {"01-n144.aud", "biotoxin tankers located", int32_t(0x00000000), int32_t(0x9A793A86)},
    {"01-n156.aud", "gdi bullet train arriving at outpost", int32_t(0x00000000), int32_t(0x71C69039)},
    {"01-n158.aud", "gdi bullet train arriving at prison", int32_t(0x00000000), int32_t(0x4BCCF149)},
    {"01-n160.aud", "transport has arrived", int32_t(0x00000000), int32_t(0x967769B9)},
    {"01-n162.aud", "transport lost", int32_t(0x00000000), int32_t(0xDBBFC8B2)},
    {"01-n164.aud", "transport has been detected", int32_t(0x00000000), int32_t(0x0DE62BAF)},
    {"01-n174.aud", "the creature is the tiberium substance we seek, use it", int32_t(0x00000000), int32_t(0xAB91201B)},
    {"01-n176.aud", "tiberium missile ready", int32_t(0x00000000), int32_t(0xE6598110)},
    {"01-n178.aud", "do not allow the construction yard to be destroyed", int32_t(0x00000000), int32_t(0xDC53E060)},
    {"01-n180.aud", "you must build a tiberium waste facility", int32_t(0x00000000), int32_t(0xC64812E4)},
    {"01-n192.aud", "convoy truck lost", int32_t(0x00000000), int32_t(0x2DF7B85B)},
    {"01-n194.aud", "tiberium missile ready", int32_t(0x00000000), int32_t(0xFBAE5B46)},
    {"01-n196.aud", "convoy inbound", int32_t(0x00000000), int32_t(0xB666FA4D)},
    {"01-n208.aud", "stealth is key", int32_t(0x00000000), int32_t(0x977BD90D)},
    {"01-n210.aud", "spy lost, mission failed", int32_t(0x00000000), int32_t(0xDD5F50D4)},
    {"01-n212.aud", "com centre infiltrated, location detected", int32_t(0x00000000), int32_t(0x9097F1DF)},
    {"01-n227.aud", "if he detects the trap, capture him before he can flee", int32_t(0x00000000), int32_t(0xF1B27AF1)},
    {"01-n228.aud", "convoy sighted", int32_t(0x00000000), int32_t(0x00E4C824)},
    {"01-n229.aud", "do not let mcneal escape", int32_t(0x00000000), int32_t(0xCBB81B81)},
    {"01-n230.aud", "mcneal killed, mission failed", int32_t(0x00000000), int32_t(0x4AC041FD)},
    {"01-n231.aud", "all toxin soldiers killed, mission failed", int32_t(0x00000000), int32_t(0x819C9258)},
    {"01-n232.aud", "mcneal captured, mission complete", int32_t(0x00000000), int32_t(0x0708E0F6)},
    {"01-n233.aud", "production facillity destroyed", int32_t(0x00000000), int32_t(0xCC543353)},
    {"01-n234.aud", "mcneal escaped, mission failed", int32_t(0x00000000), int32_t(0xD15103EB)},
    {"01-n256.aud", "orbit 1 complete", int32_t(0x00000000), int32_t(0xFF4997DA)},
    {"01-n258.aud", "orbit 2 complete", int32_t(0x00000000), int32_t(0xC543F6AA)},
    {"01-n260.aud", "orbit 3 complete, mission failed", int32_t(0x00000000), int32_t(0x18F86E5A)},
    {"01-n262.aud", "perimiter deactivated, commence attack", int32_t(0x00000000), int32_t(0x5530CF51)},
    {"01-n264.aud", "icbm launcher lost, mission failed", int32_t(0x00000000), int32_t(0x83692C4C)},
    {"01-n266.aud", "icbm launcher under attack", int32_t(0x00000000), int32_t(0xCEA18D47)},
    {"01-n268.aud", "ion cannon firing, resending controll codes", int32_t(0x00000000), int32_t(0xF4ABEC37)},
    {"01-n270.aud", "the ion cannon is ours", int32_t(0x00000000), int32_t(0xBE8F65EE)},
    {"01-n284.aud", "spy killed, mission failed", int32_t(0x00000000), int32_t(0xD3565711)},
    {"01-n286.aud", "proceed to evac location, transport en route", int32_t(0x00000000), int32_t(0x9E9EF61A)},
    {"01-n320.aud", "intruders detected", int32_t(0x00000000), int32_t(0x201D4AD7)},
    {"01-n322.aud", "proboble objective is rescue of mutant prisoners", int32_t(0x00000000), int32_t(0x6DD5EBDC)},
    {"01-n324.aud", "kill all prisoners", int32_t(0x00000000), int32_t(0xBB8C08C1)},
    {"01-n326.aud", "all forces converge", int32_t(0x00000000), int32_t(0xF644A9CA)},
    {"01-n328.aud", "main power offline", int32_t(0x00000000), int32_t(0xCC4EC8BA)},
    {"01-n330.aud", "main power restored", int32_t(0x00000000), int32_t(0x866A4163)},
    {"01-n400.aud", "cabal online", int32_t(0x00000000), int32_t(0xBD4752E7)},
    {"01-n402.aud", "perhaps you should attempt to kill their leader", int32_t(0x00000000), int32_t(0xF08FF3EC)},
    {"01-n404.aud", "ghost stalker killed", int32_t(0x00000000), int32_t(0x26D610F1)},
    {"01-n406.aud", "juggernaut destroyed", int32_t(0x00000000), int32_t(0x6B1EB1FA)},
    {"01-n408.aud", "find the temple & recover the tascitus", int32_t(0x00000000), int32_t(0x5114D08A)},
    {"01-n410.aud", "cyborg replication error, reset system", int32_t(0x00000000), int32_t(0x1B305953)},
    {"01-n412.aud", "system reset, normal parameters restored", int32_t(0x00000000), int32_t(0x56F8F858)},
    {"01-n414.aud", "gdi patroll near", int32_t(0x00000000), int32_t(0x80A11B45)},
    {"01-n416.aud", "tiberium life form detected", int32_t(0x00000000), int32_t(0xCD69BA4E)},
    {"01-n418.aud", "gdi has detected you", int32_t(0x00000000), int32_t(0xF763DB3E)},
    {"01-n420.aud", "remain hidden from the gdi forces", int32_t(0x00000000), int32_t(0x2AD843CE)},
    {"01-n422.aud",
     "destroy all civillian structures without being detected",
     int32_t(0x00000000),
     int32_t(0x6710E2C5)},
    {"01-n424.aud", "eliminate all gdi & civillians", int32_t(0x00000000), int32_t(0xB14901D8)},
    {"01-n426.aud", "use the toxin soldiers to capture civillians", int32_t(0x00000000), int32_t(0xFC81A0D3)},
    {"01-n428.aud",
     "bait the tiberium life forms by using the drugged civillians",
     int32_t(0x00000000),
     int32_t(0xC68BC1A3)},
    {"01-n430.aud",
     "lead the tiberium life forms to the gdi & civillian areas",
     int32_t(0x00000000),
     int32_t(0x8CAF487A)},
    {"01-n432.aud",
     "once the tiberium life form has devoured the civillians",
     int32_t(0x00000000),
     int32_t(0xC167E971)},
    {"01-n434.aud",
     "use this location as a staging point for your operation",
     int32_t(0x00000000),
     int32_t(0x173E0A6C)},
    {"01-n436.aud", "gdi cannot reach you here", int32_t(0x00000000), int32_t(0x5AF6AB67)},
    {"01-n438.aud", "outpost located", int32_t(0x00000000), int32_t(0x60FCCA17)},
    {"01-n440.aud", "tascitus found", int32_t(0x00000000), int32_t(0x490876F4)},
    {"01-n442.aud", "the tascitus is safetly in our hands", int32_t(0x00000000), int32_t(0x04C0D7FF)},
    {"01-n444.aud", "exterminate the mutant vermin", int32_t(0x00000000), int32_t(0xD29934E2)},
    {"01-n446.aud", "locate the mutant outpost", int32_t(0x00000000), int32_t(0x9F5195E9)},
    {"01-n448.aud",
     "find the truck containing the tascitus & return it to the beacon",
     int32_t(0x00000000),
     int32_t(0xA55BF499)},
    {"01-n450.aud", "emininate all mutant forces", int32_t(0x00000000), int32_t(0xEF7F7D40)},
    {"01-n452.aud", "run humans", int32_t(0x00000000), int32_t(0xA2B7DC4B)},
    {"01-n462.aud", "activating defence protocol, firestorm, now", int32_t(0x00000000), int32_t(0x935FC6D6)},
    {"01-n468.aud", "you amuse me", int32_t(0x00000000), int32_t(0x32C4E5B0)},
    {"01-n470.aud", "sam sites destroyed, air power incoming", int32_t(0x00000000), int32_t(0x78E06C69)},
    {"01-n472.aud",
     "you have been detected, tratos is escaping by air transport",
     int32_t(0x00000000),
     int32_t(0x3528CD62)},
    {"01-n474.aud", "you have failed, tratos has escaped", int32_t(0x00000000), int32_t(0xE3712E7F)},
    {"01-n476.aud", "the arrays have been destroyed, sensors are now down", int32_t(0x00000000), int32_t(0xAEB98F74)},
    {"01-n478.aud",
     "capturing 6 power plants will shut down the firestorm generator",
     int32_t(0x00000000),
     int32_t(0x94B3EE04)},
    {"01-n900.aud", "warning, regulators offline", int32_t(0x00000000), int32_t(0x26424736)},
    {"01-n901.aud", "dam integrity failing", int32_t(0x00000000), int32_t(0xED1E9493)},
    {"01-w000.v01", "-", int32_t(0x00000000), int32_t(0xE8F44369)},
    {"01-w002.v01", "-", int32_t(0x00000000), int32_t(0xA53CE262)},
    {"01-w004.v01", "-", int32_t(0x00000000), int32_t(0x7365017F)},
    {"01-w006.v01", "-", int32_t(0x00000000), int32_t(0x3EADA074)},
    {"01-w008.v01", "-", int32_t(0x00000000), int32_t(0x04A7C104)},
    {"01-w010.v01", "-", int32_t(0x00000000), int32_t(0x4E8348DD)},
    {"01-w012.v01", "-", int32_t(0x00000000), int32_t(0x034BE9D6)},
    {"01-w014.v01", "-", int32_t(0x00000000), int32_t(0xD5120ACB)},
    {"01-w016.v01", "-", int32_t(0x00000000), int32_t(0x98DAABC0)},
    {"01-w018.v01", "-", int32_t(0x00000000), int32_t(0xA2D0CAB0)},
    {"01-w020.v01", "-", int32_t(0x00000000), int32_t(0x7F6B5240)},
    {"01-w022.v01", "-", int32_t(0x00000000), int32_t(0x32A3F34B)},
    {"01-w024.v01", "-", int32_t(0x00000000), int32_t(0xE4FA1056)},
    {"01-w026.v01", "-", int32_t(0x00000000), int32_t(0xA932B15D)},
    {"01-w028.v01", "-", int32_t(0x00000000), int32_t(0x9338D02D)},
    {"01-w030.v01", "-", int32_t(0x00000000), int32_t(0xD91C59F4)},
    {"01-w031.v01", "-", int32_t(0x00000000), int32_t(0x12408A51)},
    {"01-w032.v01", "-", int32_t(0x00000000), int32_t(0x94D4F8FF)},
    {"01-w034.v01", "-", int32_t(0x00000000), int32_t(0x428D1BE2)},
    {"01-w036.v01", "-", int32_t(0x00000000), int32_t(0x0F45BAE9)},
    {"01-w038.v01", "-", int32_t(0x00000000), int32_t(0x354FDB99)},
    {"01-w040.v01", "-", int32_t(0x00000000), int32_t(0x1CBB677A)},
    {"01-w042.v01", "-", int32_t(0x00000000), int32_t(0x5173C671)},
    {"01-w044.v01", "-", int32_t(0x00000000), int32_t(0x872A256C)},
    {"01-w046.v01", "-", int32_t(0x00000000), int32_t(0xCAE28467)},
    {"0100124e.aud", "", int32_t(0x8F7E6A51), int32_t(0x00000000)},
    {"0100224e.aud", "", int32_t(0x8F7E6A53), int32_t(0x00000000)},
    {"0100324e.aud", "", int32_t(0x8F7E6A55), int32_t(0x00000000)},
    {"0100424e.aud", "", int32_t(0x8F7E6A57), int32_t(0x00000000)},
    {"0100524e.aud", "", int32_t(0x8F7E6A59), int32_t(0x00000000)},
    {"0100624e.aud", "", int32_t(0x8F7E6A5B), int32_t(0x00000000)},
    {"0100724e.aud", "", int32_t(0x8F7E6A5D), int32_t(0x00000000)},
    {"0100824e.aud", "", int32_t(0x8F7E6A5F), int32_t(0x00000000)},
    {"0100924e.aud", "", int32_t(0x8F7E6A61), int32_t(0x00000000)},
    {"0100jbird3.aud", "", int32_t(0x4D033D88), int32_t(0x00000000)},
    {"0101024e.aud", "", int32_t(0x937E6A4F), int32_t(0x00000000)},
    {"0101124e.aud", "", int32_t(0x937E6A51), int32_t(0x00000000)},
    {"0101224e.aud", "", int32_t(0x937E6A53), int32_t(0x00000000)},
    {"0101324e.aud", "", int32_t(0x937E6A55), int32_t(0x00000000)},
    {"0101424e.aud", "", int32_t(0x937E6A57), int32_t(0x00000000)},
    {"0101624e.aud", "", int32_t(0x937E6A5B), int32_t(0x00000000)},
    {"0101724e.aud", "", int32_t(0x937E6A5D), int32_t(0x00000000)},
    {"0101824e.aud", "", int32_t(0x937E6A5F), int32_t(0x00000000)},
    {"0101924e.aud", "", int32_t(0x937E6A61), int32_t(0x00000000)},
    {"0110004e.aud", "", int32_t(0x8F82664F), int32_t(0x00000000)},
    {"0110104e.aud", "", int32_t(0x8F826651), int32_t(0x00000000)},
    {"0110607e.aud", "", int32_t(0x8F88665B), int32_t(0x00000000)},
    {"0110907e.aud", "", int32_t(0x8F886661), int32_t(0x00000000)},
    {"0110gloop5.aud", "", int32_t(0x41236994), int32_t(0x00000000)},
    {"0110human10.aud", "", int32_t(0xE363967F), int32_t(0x00000000)},
    {"0111008e.aud", "", int32_t(0x938A664F), int32_t(0x00000000)},
    {"0111408e.aud", "", int32_t(0x938A6657), int32_t(0x00000000)},
    {"0111508e.aud", "", int32_t(0x938A6659), int32_t(0x00000000)},
    {"0111605e.aud", "", int32_t(0x9384665B), int32_t(0x00000000)},
    {"0111908e.aud", "", int32_t(0x938A6661), int32_t(0x00000000)},
    {"0112208e.aud", "", int32_t(0x978A6653), int32_t(0x00000000)},
    {"0113108e.aud", "", int32_t(0x9B8A6651), int32_t(0x00000000)},
    {"0113208e.aud", "", int32_t(0x9B8A6653), int32_t(0x00000000)},
    {"0115004e.aud", "", int32_t(0xA382664F), int32_t(0x00000000)},
    {"0115104e.aud", "", int32_t(0xA3826651), int32_t(0x00000000)},
    {"0120516e.aud", "", int32_t(0x8F8A6859), int32_t(0x00000000)},
    {"0120604e.aud", "", int32_t(0x8F86665B), int32_t(0x00000000)},
    {"0120616e.aud", "", int32_t(0x8F8A685B), int32_t(0x00000000)},
    {"0120704e.aud", "", int32_t(0x8F86665D), int32_t(0x00000000)},
    {"0120716e.aud", "", int32_t(0x8F8A685D), int32_t(0x00000000)},
    {"0120824e.aud", "", int32_t(0x8F866A5F), int32_t(0x00000000)},
    {"0120924e.aud", "", int32_t(0x8F866A61), int32_t(0x00000000)},
    {"0121024e.aud", "", int32_t(0x93866A4F), int32_t(0x00000000)},
    {"0121124e.aud", "", int32_t(0x93866A51), int32_t(0x00000000)},
    {"0121224e.aud", "", int32_t(0x93866A53), int32_t(0x00000000)},
    {"0121324e.aud", "", int32_t(0x93866A55), int32_t(0x00000000)},
    {"0121424e.aud", "", int32_t(0x93866A57), int32_t(0x00000000)},
    {"0121524e.aud", "", int32_t(0x93866A59), int32_t(0x00000000)},
    {"0121624e.aud", "", int32_t(0x93866A5B), int32_t(0x00000000)},
    {"0121724e.aud", "", int32_t(0x93866A5D), int32_t(0x00000000)},
    {"0121824e.aud", "", int32_t(0x93866A5F), int32_t(0x00000000)},
    {"0121924e.aud", "", int32_t(0x93866A61), int32_t(0x00000000)},
    {"0122024e.aud", "", int32_t(0x97866A4F), int32_t(0x00000000)},
    {"0122124e.aud", "", int32_t(0x97866A51), int32_t(0x00000000)},
    {"0122224e.aud", "", int32_t(0x97866A53), int32_t(0x00000000)},
    {"0150012e.aud", "", int32_t(0x8F8E684F), int32_t(0x00000000)},
    {"0150112e.aud", "", int32_t(0x8F8E6851), int32_t(0x00000000)},
    {"0150403e.aud", "", int32_t(0x8F906657), int32_t(0x00000000)},
    {"0162911e.aud", "", int32_t(0x97906861), int32_t(0x00000000)},
    {"0170211e.aud", "", int32_t(0x8F946853), int32_t(0x00000000)},
    {"0170311e.aud", "", int32_t(0x8F946855), int32_t(0x00000000)},
    {"0170411e.aud", "", int32_t(0x8F946857), int32_t(0x00000000)},
    {"0170511e.aud", "", int32_t(0x8F946859), int32_t(0x00000000)},
    {"0172511e.aud", "", int32_t(0x97946859), int32_t(0x00000000)},
    {"0186304e.aud", "", int32_t(0xA79E6655), int32_t(0x00000000)},
    {"0186504e.aud", "", int32_t(0xA79E6659), int32_t(0x00000000)},
    {"0190108e.aud", "", int32_t(0x8FAA6651), int32_t(0x00000000)},
    {"0190208e.aud", "", int32_t(0x8FAA6653), int32_t(0x00000000)},
    {"0190308e.aud", "", int32_t(0x8FAA6655), int32_t(0x00000000)},
    {"0202024e.aud", "", int32_t(0x977E6E4F), int32_t(0x00000000)},
    {"0202124e.aud", "", int32_t(0x977E6E51), int32_t(0x00000000)},
    {"0202224e.aud", "", int32_t(0x977E6E53), int32_t(0x00000000)},
    {"0202324e.aud", "", int32_t(0x977E6E55), int32_t(0x00000000)},
    {"0202424e.aud", "", int32_t(0x977E6E57), int32_t(0x00000000)},
    {"0202524e.aud", "", int32_t(0x977E6E59), int32_t(0x00000000)},
    {"0202624e.aud", "", int32_t(0x977E6E5B), int32_t(0x00000000)},
    {"0202724e.aud", "", int32_t(0x977E6E5D), int32_t(0x00000000)},
    {"0202824e.aud", "", int32_t(0x977E6E5F), int32_t(0x00000000)},
    {"0202924e.aud", "", int32_t(0x977E6E61), int32_t(0x00000000)},
    {"0203024e.aud", "", int32_t(0x9B7E6E4F), int32_t(0x00000000)},
    {"0203124e.aud", "", int32_t(0x9B7E6E51), int32_t(0x00000000)},
    {"0203224e.aud", "", int32_t(0x9B7E6E53), int32_t(0x00000000)},
    {"0203324e.aud", "", int32_t(0x9B7E6E55), int32_t(0x00000000)},
    {"0203424e.aud", "", int32_t(0x9B7E6E57), int32_t(0x00000000)},
    {"0203524e.aud", "", int32_t(0x9B7E6E59), int32_t(0x00000000)},
    {"0203624e.aud", "", int32_t(0x9B7E6E5B), int32_t(0x00000000)},
    {"02037240.aud", "", int32_t(0x717E6E5D), int32_t(0x00000000)},
    {"0203724e.aud", "", int32_t(0x9B7E6E5D), int32_t(0x00000000)},
    {"0203824e.aud", "", int32_t(0x9B7E6E5F), int32_t(0x00000000)},
    {"0203924e.aud", "", int32_t(0x9B7E6E61), int32_t(0x00000000)},
    {"0204024e.aud", "", int32_t(0x9F7E6E4F), int32_t(0x00000000)},
    {"0204124e.aud", "", int32_t(0x9F7E6E51), int32_t(0x00000000)},
    {"0204224e.aud", "", int32_t(0x9F7E6E53), int32_t(0x00000000)},
    {"02043240.aud", "", int32_t(0x757E6E55), int32_t(0x00000000)},
    {"0204324e.aud", "", int32_t(0x9F7E6E55), int32_t(0x00000000)},
    {"0204424e.aud", "", int32_t(0x9F7E6E57), int32_t(0x00000000)},
    {"0204524e.aud", "", int32_t(0x9F7E6E59), int32_t(0x00000000)},
    {"0204624e.aud", "", int32_t(0x9F7E6E5B), int32_t(0x00000000)},
    {"0204724e.aud", "", int32_t(0x9F7E6E5D), int32_t(0x00000000)},
    {"0204824e.aud", "", int32_t(0x9F7E6E5F), int32_t(0x00000000)},
    {"0204ftwood1.aud", "", int32_t(0x3B85C07A), int32_t(0x00000000)},
    {"0205024e.aud", "", int32_t(0xA37E6E4F), int32_t(0x00000000)},
    {"0205124e.aud", "", int32_t(0xA37E6E51), int32_t(0x00000000)},
    {"0205224e.aud", "", int32_t(0xA37E6E53), int32_t(0x00000000)},
    {"0205324e.aud", "", int32_t(0xA37E6E55), int32_t(0x00000000)},
    {"0205424e.aud", "", int32_t(0xA37E6E57), int32_t(0x00000000)},
    {"0205524e.aud", "", int32_t(0xA37E6E59), int32_t(0x00000000)},
    {"0210001e.aud", "", int32_t(0x8F7C6A4F), int32_t(0x00000000)},
    {"0210101e.aud", "", int32_t(0x8F7C6A51), int32_t(0x00000000)},
    {"0210201e.aud", "", int32_t(0x8F7C6A53), int32_t(0x00000000)},
    {"0210301e.aud", "", int32_t(0x8F7C6A55), int32_t(0x00000000)},
    {"0210606e.aud", "", int32_t(0x8F866A5B), int32_t(0x00000000)},
    {"0210706e.aud", "", int32_t(0x8F866A5D), int32_t(0x00000000)},
    {"0211524e.aud", "", int32_t(0x93826E59), int32_t(0x00000000)},
    {"0215005e.aud", "", int32_t(0xA3846A4F), int32_t(0x00000000)},
    {"0215105e.aud", "", int32_t(0xA3846A51), int32_t(0x00000000)},
    {"0220004e.aud", "", int32_t(0x8F866A4F), int32_t(0x00000000)},
    {"0220104e.aud", "", int32_t(0x8F866A51), int32_t(0x00000000)},
    {"0220204e.aud", "", int32_t(0x8F866A53), int32_t(0x00000000)},
    {"0220304e.aud", "", int32_t(0x8F866A55), int32_t(0x00000000)},
    {"0220404e.aud", "", int32_t(0x8F866A57), int32_t(0x00000000)},
    {"0220504e.aud", "", int32_t(0x8F866A59), int32_t(0x00000000)},
    {"0230024e.aud", "", int32_t(0x8F8A6E4F), int32_t(0x00000000)},
    {"0230124e.aud", "", int32_t(0x8F8A6E51), int32_t(0x00000000)},
    {"0230209e.aud", "", int32_t(0x8F946A53), int32_t(0x00000000)},
    {"0230224e.aud", "", int32_t(0x8F8A6E53), int32_t(0x00000000)},
    {"0230324e.aud", "", int32_t(0x8F8A6E55), int32_t(0x00000000)},
    {"0230424e.aud", "", int32_t(0x8F8A6E57), int32_t(0x00000000)},
    {"0230524e.aud", "", int32_t(0x8F8A6E59), int32_t(0x00000000)},
    {"0230624e.aud", "", int32_t(0x8F8A6E5B), int32_t(0x00000000)},
    {"0230724e.aud", "", int32_t(0x8F8A6E5D), int32_t(0x00000000)},
    {"0230824e.aud", "", int32_t(0x8F8A6E5F), int32_t(0x00000000)},
    {"0230924e.aud", "", int32_t(0x8F8A6E61), int32_t(0x00000000)},
    {"0231024e.aud", "", int32_t(0x938A6E4F), int32_t(0x00000000)},
    {"0231124e.aud", "", int32_t(0x938A6E51), int32_t(0x00000000)},
    {"0231224e.aud", "", int32_t(0x938A6E53), int32_t(0x00000000)},
    {"0240009e.aud", "", int32_t(0x8F986A4F), int32_t(0x00000000)},
    {"0250001e.aud", "", int32_t(0x8F8C6A4F), int32_t(0x00000000)},
    {"0250101e.aud", "", int32_t(0x8F8C6A51), int32_t(0x00000000)},
    {"0255303e.aud", "", int32_t(0xA3906A55), int32_t(0x00000000)},
    {"0260303e.aud", "", int32_t(0x8F946A55), int32_t(0x00000000)},
    {"0260403e.aud", "", int32_t(0x8F946A57), int32_t(0x00000000)},
    {"0260603e.aud", "", int32_t(0x8F946A5B), int32_t(0x00000000)},
    {"0263011e.aud", "", int32_t(0x9B906C4F), int32_t(0x00000000)},
    {"0285203e.aud", "", int32_t(0xA39C6A53), int32_t(0x00000000)},
    {"0299013e.aud", "", int32_t(0xB3A06C4F), int32_t(0x00000000)},
    {"0299113e.aud", "", int32_t(0xB3A06C51), int32_t(0x00000000)},
    {"0299313e.aud", "", int32_t(0xB3A06C55), int32_t(0x00000000)},
    {"0310919e.csv", "", int32_t(0xA18A7261), int32_t(0x00000000)},
    {"0310919e.lsv", "", int32_t(0xA18A7B61), int32_t(0x00000000)},
    {"0310919e.vqa", "", int32_t(0x8C888561), int32_t(0x00000000)},
    {"0310919e_e.vqa", "", int32_t(0x42CB2A76), int32_t(0x00000000)},
    {"0310919e_e.vqt", "", int32_t(0x42CB3D76), int32_t(0x00000000)},
    {"0310919e_h.pcx", "", int32_t(0x36CB4768), int32_t(0x00000000)},
    {"0310919e_h.vqa", "", int32_t(0x42CB3076), int32_t(0x00000000)},
    {"0310919e_l.pcx", "", int32_t(0x36CB4F68), int32_t(0x00000000)},
    {"0310919e_l.vqa", "", int32_t(0x42CB3876), int32_t(0x00000000)},
    {"0311219e.csv", "", int32_t(0xA58A7253), int32_t(0x00000000)},
    {"0311219e.lsv", "", int32_t(0xA58A7B53), int32_t(0x00000000)},
    {"0311219e.vqa", "", int32_t(0x90888553), int32_t(0x00000000)},
    {"0311219e_e.vqa", "", int32_t(0x4ACB2A5A), int32_t(0x00000000)},
    {"0311219e_e.vqt", "", int32_t(0x4ACB3D5A), int32_t(0x00000000)},
    {"0311219e_h.pcx", "", int32_t(0x3ECB474C), int32_t(0x00000000)},
    {"0311219e_h.vqa", "", int32_t(0x4ACB305A), int32_t(0x00000000)},
    {"0311219e_l.pcx", "", int32_t(0x3ECB4F4C), int32_t(0x00000000)},
    {"0311219e_l.vqa", "", int32_t(0x4ACB385A), int32_t(0x00000000)},
    {"0377704e.aud", "", int32_t(0xAB9A6E5D), int32_t(0x00000000)},
    {"0377804e.csv", "", int32_t(0xBD98705F), int32_t(0x00000000)},
    {"0377804e.lsv", "", int32_t(0xBD98795F), int32_t(0x00000000)},
    {"0377804e.vqa", "", int32_t(0xA896835F), int32_t(0x00000000)},
    {"0377804e_e.vqa", "", int32_t(0x7AE72672), int32_t(0x00000000)},
    {"0377804e_e.vqt", "", int32_t(0x7AE73972), int32_t(0x00000000)},
    {"0377804e_h.pcx", "", int32_t(0x6EE74364), int32_t(0x00000000)},
    {"0377804e_h.vqa", "", int32_t(0x7AE72C72), int32_t(0x00000000)},
    {"0377804e_l.pcx", "", int32_t(0x6EE74B64), int32_t(0x00000000)},
    {"0377804e_l.vqa", "", int32_t(0x7AE73472), int32_t(0x00000000)},
    {"04pebble1.aud", "", int32_t(0xEA350731), int32_t(0x00000000)},
    {"0656001e.csv", "", int32_t(0xB98A7C4F), int32_t(0x00000000)},
    {"0656001e.lsv", "", int32_t(0xB98A854F), int32_t(0x00000000)},
    {"0656001e.vqa", "", int32_t(0xA4888F4F), int32_t(0x00000000)},
    {"0656001e_e.vqa", "", int32_t(0x72CB3E52), int32_t(0x00000000)},
    {"0656001e_e.vqt", "", int32_t(0x72CB5152), int32_t(0x00000000)},
    {"0656001e_h.pcx", "", int32_t(0x66CB5B44), int32_t(0x00000000)},
    {"0656001e_h.vqa", "", int32_t(0x72CB4452), int32_t(0x00000000)},
    {"0656001e_l.pcx", "", int32_t(0x66CB6344), int32_t(0x00000000)},
    {"0656001e_l.vqa", "", int32_t(0x72CB4C52), int32_t(0x00000000)},
    {"07-0020e.aud", "", int32_t(0x8F6A824F), int32_t(0x00000000)},
    {"07_0020e.aud", "", int32_t(0x9032824F), int32_t(0x00000000)},
    {"07e.aud", "", int32_t(0x5CCEC3A1), int32_t(0x00000000)},
    {"09-i000.aud", "yes", int32_t(0x00000000), int32_t(0xE7AFD091)},
    {"09-i002.aud", "ok", int32_t(0x00000000), int32_t(0xAA67719A)},
    {"09-i004.aud", "ooh", int32_t(0x00000000), int32_t(0x7C3E9287)},
    {"09-i006.aud", "aah", int32_t(0x00000000), int32_t(0x31F6338C)},
    {"0907e.aud", "", int32_t(0x8743418F), int32_t(0x00000000)},
    {"0907egloop2.aud", "", int32_t(0x535BDC76), int32_t(0x00000000)},
    {"0907egloop8.aud", "", int32_t(0x5367DC76), int32_t(0x00000000)},
    {"0907ehuman2.aud", "", int32_t(0x4B7FDC5A), int32_t(0x00000000)},
    {"0907ehuman7.aud", "", int32_t(0x4B89DC5A), int32_t(0x00000000)},
    {"0935001e.aud", "", int32_t(0xA384864F), int32_t(0x00000000)},
    {"10-i000.aud", "give me an order", int32_t(0x00000000), int32_t(0x0747A27B)},
    {"10-i002.aud", "what do you want", int32_t(0x00000000), int32_t(0x4A8F0370)},
    {"10-i004.aud", "you talking to me", int32_t(0x00000000), int32_t(0x9CD6E06D)},
    {"10-i006.aud", "what", int32_t(0x00000000), int32_t(0xD11E4166)},
    {"10-i016.aud", "stay low", int32_t(0x00000000), int32_t(0x77694AD2)},
    {"10-i020.aud", "ok", int32_t(0x00000000), int32_t(0x90D8B352)},
    {"10-i022.aud", "already there", int32_t(0x00000000), int32_t(0xDD101259)},
    {"10-i024.aud", "right between the eyes", int32_t(0x00000000), int32_t(0x0B49F144)},
    {"10-i026.aud", "i only need 1 shot", int32_t(0x00000000), int32_t(0x4681504F)},
    {"10-i028.aud", "this is too easy", int32_t(0x00000000), int32_t(0x7C8B313F)},
    {"10-i030.aud", "good as done", int32_t(0x00000000), int32_t(0x36AFB8E6)},
    {"10-n032.aud", "the medical facillity is located to the east", int32_t(0x00000000), int32_t(0x1F067424)},
    {"10-n034.aud", "the medical facillity is located to the west", int32_t(0x00000000), int32_t(0xC95F9739)},
    {"10-n036.aud", "we must get tratos out of that facillity", int32_t(0x00000000), int32_t(0x84973632)},
    {"10-n038.aud", "so much for sutlty", int32_t(0x00000000), int32_t(0xBE9D5742)},
    {"10-n040.aud", "tratos, no", int32_t(0x00000000), int32_t(0x9769EBA1)},
    {"10-n042.aud", "we must get tratos to the transport", int32_t(0x00000000), int32_t(0xDAA14AAA)},
    {"10-n044.aud", "our work here is done, were out of here", int32_t(0x00000000), int32_t(0x0CF8A9B7)},
    {"10-n046.aud", "they've seen us, fall back", int32_t(0x00000000), int32_t(0x413008BC)},
    {"100324e.aud", "", int32_t(0x298F7E6A), int32_t(0x00000000)},
    {"100mnkydie1.aud", "", int32_t(0xD78D8E96), int32_t(0x00000000)},
    {"100wetstep4.aud", "", int32_t(0x677BC867), int32_t(0x00000000)},
    {"10minr.aud", "10 minutes left", int32_t(0xA791A9B6), int32_t(0x00000000)},
    {"10pt.fon", "", int32_t(0xF6EFA690), int32_t(0x00000000)},
    {"11-i000.aud", "yes", int32_t(0x00000000), int32_t(0xC6C97DBB)},
    {"11-i002.aud", "direct me", int32_t(0x00000000), int32_t(0x8B01DCB0)},
    {"11-i004.aud", "awaiting orders", int32_t(0x00000000), int32_t(0x5D583FAD)},
    {"11-i006.aud", "i'm ready", int32_t(0x00000000), int32_t(0x10909EA6)},
    {"11-i008.aud", "of course", int32_t(0x00000000), int32_t(0x2A9AFFD6)},
    {"11-i010.aud", "immediatly", int32_t(0x00000000), int32_t(0x60BE760F)},
    {"11-i012.aud", "yes", int32_t(0x00000000), int32_t(0x2D76D704)},
    {"11-i014.aud", "for kane", int32_t(0x00000000), int32_t(0xFB2F3419)},
    {"11-i016.aud", "they will pay for this", int32_t(0x00000000), int32_t(0xB6E79512)},
    {"11-i018.aud", "for the brotherhood", int32_t(0x00000000), int32_t(0x8CEDF462)},
    {"110907e.aud", "", int32_t(0x418F8866), int32_t(0x00000000)},
    {"12-i000.aud", "yes cabal", int32_t(0x00000000), int32_t(0x5F2B1BBA)},
    {"12-i002.aud", "where to", int32_t(0x00000000), int32_t(0x12E3BAB1)},
    {"12-i004.aud", "yes", int32_t(0x00000000), int32_t(0xC4BA59AC)},
    {"12-i006.aud", "yes", int32_t(0x00000000), int32_t(0x8972F8A7)},
    {"12-i008.aud", "for kane", int32_t(0x00000000), int32_t(0xB37899D7)},
    {"12-i010.aud", "i will", int32_t(0x00000000), int32_t(0xF95C100E)},
    {"12-i012.aud", "we must find oxanna", int32_t(0x00000000), int32_t(0xB494B105)},
    {"12-i014.aud", "leave no enemy standing", int32_t(0x00000000), int32_t(0x62CD5218)},
    {"12-i016.aud", "kill them", int32_t(0x00000000), int32_t(0x2F05F313)},
    {"120mm.shp", "120mm cannon shot", int32_t(0xC56725AF), int32_t(0x17EDBDA8)},
    {"120mmf.aud", "artillery sound", int32_t(0x00000000), int32_t(0xAC70B704)},
    {"120mmx9.aud", "artillery sound two-shooter", int32_t(0x00000000), int32_t(0x789497E5)},
    {"12green.fnt", "12 green", int32_t(0xA60DA195), int32_t(0x00000000)},
    {"12grngrd.fnt", "12 green grid", int32_t(0x260F9D8F), int32_t(0x00000000)},
    {"12metfnt.fnt", "fnt: 12 met fnt", int32_t(0x121F9B9B), int32_t(0x436EE5F0)},
    {"13-i000.aud", "huh", int32_t(0x00000000), int32_t(0x9EA5C47A)},
    {"13-i002.aud", "what", int32_t(0x00000000), int32_t(0xD36D6571)},
    {"13-i004.aud", "ah", int32_t(0x00000000), int32_t(0x0534866C)},
    {"13-i006.aud", "lead me", int32_t(0x00000000), int32_t(0x48FC2767)},
    {"13-i008.aud", "arrows from the sky", int32_t(0x00000000), int32_t(0x72F64617)},
    {"13-i010.aud", "green becomes brown", int32_t(0x00000000), int32_t(0x38D2CFCE)},
    {"13-i012.aud", "tah", int32_t(0x00000000), int32_t(0x751A6EC5)},
    {"13-i014.aud", "yes", int32_t(0x00000000), int32_t(0xA3438DD8)},
    {"13-i016.aud", "be careful", int32_t(0x00000000), int32_t(0xEE8B2CD3)},
    {"13-i018.aud", "nod is everywhere", int32_t(0x00000000), int32_t(0xD4814DA3)},
    {"13-i020.aud", "where is the tascitus", int32_t(0x00000000), int32_t(0x093AD553)},
    {"1320516e.csv", "", int32_t(0xA188725D), int32_t(0x00000000)},
    {"1320516e.lsv", "", int32_t(0xA1887B5D), int32_t(0x00000000)},
    {"1320516e.vqa", "", int32_t(0x8C86855D), int32_t(0x00000000)},
    {"1320516e_e.vqa", "", int32_t(0x42C72A6E), int32_t(0x00000000)},
    {"1320516e_e.vqt", "", int32_t(0x42C73D6E), int32_t(0x00000000)},
    {"1320516e_h.pcx", "", int32_t(0x36C74760), int32_t(0x00000000)},
    {"1320516e_h.vqa", "", int32_t(0x42C7306E), int32_t(0x00000000)},
    {"1320516e_l.pcx", "", int32_t(0x36C74F60), int32_t(0x00000000)},
    {"1320516e_l.vqa", "", int32_t(0x42C7386E), int32_t(0x00000000)},
    {"1372504e.csv", "", int32_t(0xA998705D), int32_t(0x00000000)},
    {"1372504e.lsv", "", int32_t(0xA998795D), int32_t(0x00000000)},
    {"1372504e.vqa", "", int32_t(0x9496835D), int32_t(0x00000000)},
    {"1372504e_e.vqa", "", int32_t(0x52E7266E), int32_t(0x00000000)},
    {"1372504e_e.vqt", "", int32_t(0x52E7396E), int32_t(0x00000000)},
    {"1372504e_h.pcx", "", int32_t(0x46E74360), int32_t(0x00000000)},
    {"1372504e_h.vqa", "", int32_t(0x52E72C6E), int32_t(0x00000000)},
    {"1372504e_l.pcx", "", int32_t(0x46E74B60), int32_t(0x00000000)},
    {"1372504e_l.vqa", "", int32_t(0x52E7346E), int32_t(0x00000000)},
    {"1380612e.csv", "", int32_t(0xA198725F), int32_t(0x00000000)},
    {"1380612e.lsv", "", int32_t(0xA1987B5F), int32_t(0x00000000)},
    {"1380612e.vqa", "", int32_t(0x8C96855F), int32_t(0x00000000)},
    {"1380612e_e.vqa", "", int32_t(0x42E72A72), int32_t(0x00000000)},
    {"1380612e_e.vqt", "", int32_t(0x42E73D72), int32_t(0x00000000)},
    {"1380612e_h.pcx", "", int32_t(0x36E74764), int32_t(0x00000000)},
    {"1380612e_h.vqa", "", int32_t(0x42E73072), int32_t(0x00000000)},
    {"1380612e_l.pcx", "", int32_t(0x36E74F64), int32_t(0x00000000)},
    {"1380612e_l.vqa", "", int32_t(0x42E73872), int32_t(0x00000000)},
    {"1386204e.aud", "", int32_t(0xA79E6E57), int32_t(0x00000000)},
    {"1386404e.aud", "", int32_t(0xA79E6E5B), int32_t(0x00000000)},
    {"1386604e.aud", "", int32_t(0xA79E6E5F), int32_t(0x00000000)},
    {"1386704e.aud", "", int32_t(0xA79E6E61), int32_t(0x00000000)},
    {"1386804e.aud", "", int32_t(0xA79E6E63), int32_t(0x00000000)},
    {"1386904e.csv", "", int32_t(0xB99C7065), int32_t(0x00000000)},
    {"1386904e.lsv", "", int32_t(0xB99C7965), int32_t(0x00000000)},
    {"1386904e.vqa", "", int32_t(0xA49A8365), int32_t(0x00000000)},
    {"1386904e_e.vqa", "", int32_t(0x72EF267E), int32_t(0x00000000)},
    {"1386904e_e.vqt", "", int32_t(0x72EF397E), int32_t(0x00000000)},
    {"1386904e_h.pcx", "", int32_t(0x66EF4370), int32_t(0x00000000)},
    {"1386904e_h.vqa", "", int32_t(0x72EF2C7E), int32_t(0x00000000)},
    {"1386904e_l.pcx", "", int32_t(0x66EF4B70), int32_t(0x00000000)},
    {"1386904e_l.vqa", "", int32_t(0x72EF347E), int32_t(0x00000000)},
    {"14-i000.aud", "yes", int32_t(0x00000000), int32_t(0xB79ED1F9)},
    {"14-i002.aud", "over here", int32_t(0x00000000), int32_t(0xFA5670F2)},
    {"14-i004.aud", "give me a target", int32_t(0x00000000), int32_t(0x2C0F93EF)},
    {"14-i008.aud", "it will be done", int32_t(0x00000000), int32_t(0x5BCD5394)},
    {"14-i010.aud", "very well", int32_t(0x00000000), int32_t(0x11E9DA4D)},
    {"14-i012.aud", "any time", int32_t(0x00000000), int32_t(0x5C217B46)},
    {"14-i014.aud", "you got it", int32_t(0x00000000), int32_t(0x8A78985B)},
    {"14-i016.aud", "there could be trouble", int32_t(0x00000000), int32_t(0xC7B03950)},
    {"1410003e.aud", "", int32_t(0x8F807253), int32_t(0x00000000)},
    {"1410103e.aud", "", int32_t(0x8F807255), int32_t(0x00000000)},
    {"1410203e.aud", "", int32_t(0x8F807257), int32_t(0x00000000)},
    {"1415003e.aud", "", int32_t(0xA3807253), int32_t(0x00000000)},
    {"1415103e.aud", "", int32_t(0xA3807255), int32_t(0x00000000)},
    {"1415203e.aud", "", int32_t(0xA3807257), int32_t(0x00000000)},
    {"14152z3e.aud", "", int32_t(0xA380C657), int32_t(0x00000000)},
    {"1415303e.aud", "", int32_t(0xA3807259), int32_t(0x00000000)},
    {"1415403e.aud", "", int32_t(0xA380725B), int32_t(0x00000000)},
    {"1420003e.aud", "", int32_t(0x8F847253), int32_t(0x00000000)},
    {"1420103e.aud", "", int32_t(0x8F847255), int32_t(0x00000000)},
    {"1420203e.aud", "", int32_t(0x8F847257), int32_t(0x00000000)},
    {"1420303e.aud", "", int32_t(0x8F847259), int32_t(0x00000000)},
    {"1425003e.aud", "", int32_t(0xA3847253), int32_t(0x00000000)},
    {"1425103e.aud", "", int32_t(0xA3847255), int32_t(0x00000000)},
    {"1425203e.aud", "", int32_t(0xA3847257), int32_t(0x00000000)},
    {"1425303e.aud", "", int32_t(0xA3847259), int32_t(0x00000000)},
    {"1430003e.aud", "", int32_t(0x8F887253), int32_t(0x00000000)},
    {"1430103e.aud", "", int32_t(0x8F887255), int32_t(0x00000000)},
    {"1435103e.aud", "", int32_t(0xA3887255), int32_t(0x00000000)},
    {"1440003e.aud", "", int32_t(0x8F8C7253), int32_t(0x00000000)},
    {"1440103e.aud", "", int32_t(0x8F8C7255), int32_t(0x00000000)},
    {"1440203e.aud", "", int32_t(0x8F8C7257), int32_t(0x00000000)},
    {"1440303e.aud", "", int32_t(0x8F8C7259), int32_t(0x00000000)},
    {"1445003e.aud", "", int32_t(0xA38C7253), int32_t(0x00000000)},
    {"1445103e.aud", "", int32_t(0xA38C7255), int32_t(0x00000000)},
    {"1445203e.aud", "", int32_t(0xA38C7257), int32_t(0x00000000)},
    {"1445303e.aud", "", int32_t(0xA38C7259), int32_t(0x00000000)},
    {"1445403e.aud", "", int32_t(0xA38C725B), int32_t(0x00000000)},
    {"1450003e.aud", "", int32_t(0x8F907253), int32_t(0x00000000)},
    {"1450103e.aud", "", int32_t(0x8F907255), int32_t(0x00000000)},
    {"1450203e.aud", "", int32_t(0x8F907257), int32_t(0x00000000)},
    {"1450303e.aud", "", int32_t(0x8F907259), int32_t(0x00000000)},
    {"1455003e.aud", "", int32_t(0xA3907253), int32_t(0x00000000)},
    {"1455103e.aud", "", int32_t(0xA3907255), int32_t(0x00000000)},
    {"1455203e.aud", "", int32_t(0xA3907257), int32_t(0x00000000)},
    {"1460003e.aud", "", int32_t(0x8F947253), int32_t(0x00000000)},
    {"1460103e.aud", "", int32_t(0x8F947255), int32_t(0x00000000)},
    {"1460203e.aud", "", int32_t(0x8F947257), int32_t(0x00000000)},
    {"1465003e.aud", "", int32_t(0xA3947253), int32_t(0x00000000)},
    {"1465103e.aud", "", int32_t(0xA3947255), int32_t(0x00000000)},
    {"1470003e.aud", "", int32_t(0x8F987253), int32_t(0x00000000)},
    {"1475003e.aud", "", int32_t(0xA3987253), int32_t(0x00000000)},
    {"1475103e.aud", "", int32_t(0xA3987255), int32_t(0x00000000)},
    {"1475203e.aud", "", int32_t(0xA3987257), int32_t(0x00000000)},
    {"1480003e.aud", "", int32_t(0x8F9C7253), int32_t(0x00000000)},
    {"1480103e.aud", "", int32_t(0x8F9C7255), int32_t(0x00000000)},
    {"1485003e.aud", "", int32_t(0xA39C7253), int32_t(0x00000000)},
    {"1485103e.aud", "", int32_t(0xA39C7255), int32_t(0x00000000)},
    {"14kbeep1.aud", "", int32_t(0xB0229C7D), int32_t(0x00000000)},
    {"15-0000e.aud", "", int32_t(0x8F6A7653), int32_t(0x00000000)},
    {"15-0010e.aud", "", int32_t(0x8F6A7853), int32_t(0x00000000)},
    {"15-0020e.aud", "", int32_t(0x8F6A7A53), int32_t(0x00000000)},
    {"15-0030e.aud", "", int32_t(0x8F6A7C53), int32_t(0x00000000)},
    {"15-0040e.aud", "", int32_t(0x8F6A7E53), int32_t(0x00000000)},
    {"15-0050e.aud", "", int32_t(0x8F6A8053), int32_t(0x00000000)},
    {"15-0060e.aud", "", int32_t(0x8F6A8253), int32_t(0x00000000)},
    {"15-0070e.aud", "", int32_t(0x8F6A8453), int32_t(0x00000000)},
    {"15-0110e.aud", "", int32_t(0x8F6A7855), int32_t(0x00000000)},
    {"15-0120e.aud", "", int32_t(0x8F6A7A55), int32_t(0x00000000)},
    {"15-0130e.aud", "", int32_t(0x8F6A7C55), int32_t(0x00000000)},
    {"15-0140e.aud", "", int32_t(0x8F6A7E55), int32_t(0x00000000)},
    {"15-0150e.aud", "", int32_t(0x8F6A8055), int32_t(0x00000000)},
    {"15-0160e.aud", "", int32_t(0x8F6A8255), int32_t(0x00000000)},
    {"15-0170e.aud", "", int32_t(0x8F6A8455), int32_t(0x00000000)},
    {"15-0180e.aud", "", int32_t(0x8F6A8655), int32_t(0x00000000)},
    {"15-0260e.aud", "", int32_t(0x8F6A8257), int32_t(0x00000000)},
    {"15-0270e.aud", "", int32_t(0x8F6A8457), int32_t(0x00000000)},
    {"15-0280e.aud", "", int32_t(0x8F6A8657), int32_t(0x00000000)},
    {"15-0290e.aud", "", int32_t(0x8F6A8857), int32_t(0x00000000)},
    {"15-0320e.aud", "", int32_t(0x8F6A7A59), int32_t(0x00000000)},
    {"15-0360e.aud", "", int32_t(0x8F6A8259), int32_t(0x00000000)},
    {"15-0530e.aud", "", int32_t(0x8F6A7C5D), int32_t(0x00000000)},
    {"15-1700e.aud", "", int32_t(0x936A7661), int32_t(0x00000000)},
    {"15-i000.aud", "infantry reporting", int32_t(0x00000000), int32_t(0x76100E39)},
    {"15-i002.aud", "unit ready", int32_t(0x00000000), int32_t(0x3BD8AF32)},
    {"15-i004.aud", "awaiting order", int32_t(0x00000000), int32_t(0xED814C2F)},
    {"15-i006.aud", "sir", int32_t(0x00000000), int32_t(0xA049ED24)},
    {"15-i008.aud", "sir yes sir", int32_t(0x00000000), int32_t(0x9A438C54)},
    {"15-i010.aud", "ready", int32_t(0x00000000), int32_t(0xD067058D)},
    {"15-i012.aud", "yes sir", int32_t(0x00000000), int32_t(0x9DAFA486)},
    {"15-i014.aud", "yes sir", int32_t(0x00000000), int32_t(0x4BF6479B)},
    {"15-i016.aud", "orders received", int32_t(0x00000000), int32_t(0x063EE690)},
    {"15-i018.aud", "moving out", int32_t(0x00000000), int32_t(0x3C3487E0)},
    {"15-i020.aud", "advancing", int32_t(0x00000000), int32_t(0xE18F1F10)},
    {"15-i022.aud", "on my way", int32_t(0x00000000), int32_t(0xAC47BE1B)},
    {"15-i024.aud", "you got it", int32_t(0x00000000), int32_t(0x7A1E5D06)},
    {"15-i026.aud", "no problem", int32_t(0x00000000), int32_t(0x37D6FC0D)},
    {"15-i032.aud", "ready for action", int32_t(0x00000000), int32_t(0x0A30B5AF)},
    {"15-i038.aud", "standing by", int32_t(0x00000000), int32_t(0xABAB96C9)},
    {"15-i040.aud", "yeah", int32_t(0x00000000), int32_t(0x825F2A2A)},
    {"15-i042.aud", "orders", int32_t(0x00000000), int32_t(0xCF978B21)},
    {"15-i044.aud", "loud & clear", int32_t(0x00000000), int32_t(0x19CE683C)},
    {"15-i046.aud", "i'm on it", int32_t(0x00000000), int32_t(0x5406C937)},
    {"15-i048.aud", "sir", int32_t(0x00000000), int32_t(0x6E0CA847)},
    {"15-i050.aud", "good as done", int32_t(0x00000000), int32_t(0x2428219E)},
    {"15-i058.aud", "i'm taking heavy fire", int32_t(0x00000000), int32_t(0xC87BA3F3)},
    {"15-i060.aud", "move move move", int32_t(0x00000000), int32_t(0x15C03B03)},
    {"15-i064.aud", "medic", int32_t(0x00000000), int32_t(0x8E517915)},
    {"151440203e.aud", "", int32_t(0xE4AF3915), int32_t(0x00000000)},
    {"16.fnt", "", int32_t(0x8C5CC0B0), int32_t(0x00000000)},
    {"1790004e.aud", "", int32_t(0x8FA27E53), int32_t(0x00000000)},
    {"186504e.aud", "", int32_t(0x31A79E66), int32_t(0x00000000)},
    {"18jbird1.aud", "", int32_t(0xB006C685), int32_t(0x00000000)},
    {"19-i000.aud", "engineer", int32_t(0x00000000), int32_t(0x7C0A9CFE)},
    {"19-i002.aud", "yes sir", int32_t(0x00000000), int32_t(0x31C23DF5)},
    {"19-i006.aud", "awaiting orders", int32_t(0x00000000), int32_t(0xAA537FE3)},
    {"19-i010.aud", "affirmative", int32_t(0x00000000), int32_t(0xDA7D974A)},
    {"19-i016.aud", "no problem", int32_t(0x00000000), int32_t(0x0C247457)},
    {"19-i018.aud", "i can fix that", int32_t(0x00000000), int32_t(0x362E1527)},
    {"19-n100.aud", "looks like the kodiak is a loss", int32_t(0x00000000), int32_t(0xD4C1F1A9)},
    {"19-n102.aud", "ive got the eva unit, lets get out of here", int32_t(0x00000000), int32_t(0x990950A2)},
    {"1ice6.ini", "", int32_t(0x00000000), int32_t(0x6205B4CA)},
    {"1ice6.map", "-", int32_t(0x00000000), int32_t(0xA9BE78C0)},
    {"1lworld7.ini", "", int32_t(0x00000000), int32_t(0x3FD4546C)},
    {"1lworld7.map", "-", int32_t(0x00000000), int32_t(0xDB2E48BF)},
    {"1minr.aud", "1 minute left", int32_t(0xE3A791AD), int32_t(0x00000000)},
    {"1objmet1.aud", "1st objective met", int32_t(0xD007088D), int32_t(0x00000000)},
    {"1pres.shp", "", int32_t(0x00000000), int32_t(0x18AEC71D)},
    {"1tnk.hva", "-", int32_t(0x00000000), int32_t(0x32F0CCCB)},
    {"1tnk.shp", "unit: light tank", int32_t(0xE6E4FB90), int32_t(0x00000000)},
    {"1tnk.vxl", "light tank", int32_t(0x00000000), int32_t(0xC47A1382)},
    {"1tnkbarl.hva", "-", int32_t(0x00000000), int32_t(0x66559023)},
    {"1tnkbarl.vxl", "light tank barrel", int32_t(0x00000000), int32_t(0x90DF4F6A)},
    {"1tnkicon.shp", "icon: light tank", int32_t(0x1A202A85), int32_t(0x00000000)},
    {"1tnktur.hva", "-", int32_t(0x00000000), int32_t(0x3946B6F0)},
    {"1tnktur.vxl", "light tank turret", int32_t(0x00000000), int32_t(0x36B0C51B)},
    {"20-i000.aud", "medic reporting", int32_t(0x00000000), int32_t(0x70D9708B)},
    {"20-i004.aud", "yes sir", int32_t(0x00000000), int32_t(0xEB48329D)},
    {"20-i006.aud", "awaiting orders", int32_t(0x00000000), int32_t(0xA6809396)},
    {"20-i008.aud", "affirmative", int32_t(0x00000000), int32_t(0x9C8AF2E6)},
    {"20-i010.aud", "acknowledged", int32_t(0x00000000), int32_t(0xD6AE7B3F)},
    {"20-i012.aud", "moving out", int32_t(0x00000000), int32_t(0x9B66DA34)},
    {"20-i016.aud", "stat", int32_t(0x00000000), int32_t(0x00F79822)},
    {"20-i018.aud", "clear", int32_t(0x00000000), int32_t(0x3AFDF952)},
    {"20-i020.aud", "give me some room", int32_t(0x00000000), int32_t(0xE74661A2)},
    {"200meter.wav", "", int32_t(0x00000000), int32_t(0x05562F64)},
    {"20minr.aud", "20 minutes left", int32_t(0xA791A9BA), int32_t(0x00000000)},
    {"21-i000.aud", "hehehe", int32_t(0x00000000), int32_t(0xB157AF4B)},
    {"21-i002.aud", "over here", int32_t(0x00000000), int32_t(0xFC9F0E40)},
    {"21-i004.aud", "shh", int32_t(0x00000000), int32_t(0x2AC6ED5D)},
    {"21-i010.aud", "yes", int32_t(0x00000000), int32_t(0x1720A4FF)},
    {"21-i012.aud", "excellent", int32_t(0x00000000), int32_t(0x5AE805F4)},
    {"21-i016.aud", "moving", int32_t(0x00000000), int32_t(0xC17947E2)},
    {"21-i022.aud", "its yours", int32_t(0x00000000), int32_t(0x6B001F69)},
    {"22-i000.aud", "input directive", int32_t(0x00000000), int32_t(0x28B5C94A)},
    {"22-i002.aud", "comlink open", int32_t(0x00000000), int32_t(0x657D6841)},
    {"22-i006.aud", "unit ready", int32_t(0x00000000), int32_t(0xFEEC2A57)},
    {"22-i008.aud", "affirmative", int32_t(0x00000000), int32_t(0xC4E64B27)},
    {"22-i010.aud", "by your command", int32_t(0x00000000), int32_t(0x8EC2C2FE)},
    {"22-i012.aud", "target aquired", int32_t(0x00000000), int32_t(0xC30A63F5)},
    {"22-i014.aud", "scan initiated", int32_t(0x00000000), int32_t(0x155380E8)},
    {"22-i016.aud", "proceding", int32_t(0x00000000), int32_t(0x589B21E3)},
    {"22-i018.aud", "unit engaged", int32_t(0x00000000), int32_t(0x62914093)},
    {"22-i020.aud", "processing", int32_t(0x00000000), int32_t(0xBF2AD863)},
    {"22-n100.aud", "terminate all biological lifeforms", int32_t(0x00000000), int32_t(0x807EA41D)},
    {"22-n102.aud", "the will of cabal must be enforced", int32_t(0x00000000), int32_t(0xCDB60516)},
    {"22-n104.aud", "error", int32_t(0x00000000), int32_t(0x1BEFE60B)},
    {"22-n106.aud", "system failure", int32_t(0x00000000), int32_t(0x56274700)},
    {"22-n108.aud", "malfunction", int32_t(0x00000000), int32_t(0x6C2D2670)},
    {"22-n110.aud", "hit him", int32_t(0x00000000), int32_t(0x2609AFA9)},
    {"22-n112.aud", "intruder alert", int32_t(0x00000000), int32_t(0x6BC10EA2)},
    {"22-n114.aud", "you are not one of us", int32_t(0x00000000), int32_t(0xBD98EDBF)},
    {"22-n116.aud", "fire in the hole", int32_t(0x00000000), int32_t(0xF0504CB4)},
    {"22-n118.aud", "proceding to target", int32_t(0x00000000), int32_t(0xCA5A2DC4)},
    {"22-n120.aud", "sequence engaged", int32_t(0x00000000), int32_t(0x17E1B534)},
    {"23-0010e.aud", "", int32_t(0x8F6A7057), int32_t(0x00000000)},
    {"23-0040e.aud", "", int32_t(0x8F6A7657), int32_t(0x00000000)},
    {"23-0250e.aud", "", int32_t(0x8F6A785B), int32_t(0x00000000)},
    {"23-0330e.aud", "", int32_t(0x8F6A745D), int32_t(0x00000000)},
    {"23-i000.aud", "your command", int32_t(0x00000000), int32_t(0xE93B168A)},
    {"23-i002.aud", "standing by", int32_t(0x00000000), int32_t(0xA4F3B781)},
    {"23-i004.aud", "directive", int32_t(0x00000000), int32_t(0x72AA549C)},
    {"23-i006.aud", "status", int32_t(0x00000000), int32_t(0x3F62F597)},
    {"23-i008.aud", "i obay", int32_t(0x00000000), int32_t(0x056894E7)},
    {"23-i010.aud", "affirmative", int32_t(0x00000000), int32_t(0x4F4C1D3E)},
    {"23-i012.aud", "executing", int32_t(0x00000000), int32_t(0x0284BC35)},
    {"23-i014.aud", "terminated", int32_t(0x00000000), int32_t(0xD4DD5F28)},
    {"23-i016.aud", "stand clear", int32_t(0x00000000), int32_t(0x9915FE23)},
    {"23-i018.aud", "they will know fear", int32_t(0x00000000), int32_t(0xA31F9F53)},
    {"23-i020.aud", "for the brotherhood", int32_t(0x00000000), int32_t(0x7EA407A3)},
    {"23-i022.aud", "i can smell their fear", int32_t(0x00000000), int32_t(0x336CA6A8)},
    {"24-0380e.aud", "", int32_t(0x8F6A825D), int32_t(0x00000000)},
    {"24-0510e.aud", "", int32_t(0x8F6A7461), int32_t(0x00000000)},
    {"24-i000.aud", "need a ride", int32_t(0x00000000), int32_t(0xC0000309)},
    {"24-i002.aud", "sir", int32_t(0x00000000), int32_t(0x8DC8A202)},
    {"24-i004.aud", "yeah", int32_t(0x00000000), int32_t(0x5B91411F)},
    {"24-i006.aud", "what", int32_t(0x00000000), int32_t(0x1659E014)},
    {"24-i008.aud", "hot wired", int32_t(0x00000000), int32_t(0x2C538164)},
    {"24-i010.aud", "hit it", int32_t(0x00000000), int32_t(0x667708BD)},
    {"24-i012.aud", "four on the floor", int32_t(0x00000000), int32_t(0x2BBFA9B6)},
    {"24-i014.aud", "cool", int32_t(0x00000000), int32_t(0xFDE64AAB)},
    {"24-i016.aud", "where do you want it", int32_t(0x00000000), int32_t(0xB02EEBA0)},
    {"24-i018.aud", "going my way", int32_t(0x00000000), int32_t(0x8A248AD0)},
    {"24-i020.aud", "no keys, no problem", int32_t(0x00000000), int32_t(0x579F1220)},
    {"24-i022.aud", "jacking them up", int32_t(0x00000000), int32_t(0x1A57B32B)},
    {"24-i024.aud", "i always wanted one of these", int32_t(0x00000000), int32_t(0xCC0E5036)},
    {"24e.aud", "", int32_t(0x5CCEBDA5), int32_t(0x00000000)},
    {"25-i000.aud", "unit reporting", int32_t(0x00000000), int32_t(0x018EDCC9)},
    {"25-i002.aud", "unit ready", int32_t(0x00000000), int32_t(0x4C467DC2)},
    {"25-i004.aud", "awaiting orders", int32_t(0x00000000), int32_t(0x9A1F9EDF)},
    {"25-i006.aud", "sir", int32_t(0x00000000), int32_t(0xD7D73FD4)},
    {"25-i012.aud", "yes sir", int32_t(0x00000000), int32_t(0xEA317676)},
    {"25-i014.aud", "yes sir", int32_t(0x00000000), int32_t(0x3C68956B)},
    {"25-i016.aud", "orders recieved", int32_t(0x00000000), int32_t(0x71A03460)},
    {"25-i018.aud", "moving out", int32_t(0x00000000), int32_t(0x4BAA5510)},
    {"25-i022.aud", "on my way", int32_t(0x00000000), int32_t(0xDBD96CEB)},
    {"25-i024.aud", "you got it", int32_t(0x00000000), int32_t(0x0D808FF6)},
    {"25-i026.aud", "no problem", int32_t(0x00000000), int32_t(0x40482EFD)},
    {"27-i002.aud", "unit deploy response", int32_t(0x00000000), int32_t(0x142AC403)},
    {"2730706e.csv", "", int32_t(0xA18C8065), int32_t(0x00000000)},
    {"2730706e.lsv", "", int32_t(0xA18C8965), int32_t(0x00000000)},
    {"2730706e.vqa", "", int32_t(0x8C8A9365), int32_t(0x00000000)},
    {"2730706e_e.vqa", "", int32_t(0x42CF467E), int32_t(0x00000000)},
    {"2730706e_e.vqt", "", int32_t(0x42CF597E), int32_t(0x00000000)},
    {"2730706e_h.pcx", "", int32_t(0x36CF6370), int32_t(0x00000000)},
    {"2730706e_h.vqa", "", int32_t(0x42CF4C7E), int32_t(0x00000000)},
    {"2730706e_l.pcx", "", int32_t(0x36CF6B70), int32_t(0x00000000)},
    {"2730706e_l.vqa", "", int32_t(0x42CF547E), int32_t(0x00000000)},
    {"2dangr1.aud", "", int32_t(0x95AC0A98), int32_t(0x00000000)},
    {"2minr.aud", "2 minutes left", int32_t(0xE3A791B1), int32_t(0x00000000)},
    {"2nd_hand.aud", "2nd_hand", int32_t(0x4A02FC86), int32_t(0x00000000)},
    {"2objmet1.aud", "2nd objective met", int32_t(0xD0070891), int32_t(0x00000000)},
    {"2peaks.map", "", int32_t(0x00000000), int32_t(0xCDF5BF33)},
    {"2pres.shp", "", int32_t(0x00000000), int32_t(0x6F3015ED)},
    {"2roachd2.aud", "", int32_t(0xAE1B1A7D), int32_t(0x00000000)},
    {"2temp7.ini", "", int32_t(0x00000000), int32_t(0xEB9B49D6)},
    {"2temp7.map", "-", int32_t(0x00000000), int32_t(0xC5307A2E)},
    {"2tnk.hva", "-", int32_t(0x00000000), int32_t(0xBC7FCB28)},
    {"2tnk.shp", "unit: medium tank", int32_t(0xE6E4FB92), int32_t(0x00000000)},
    {"2tnk.vxl", "medium tank", int32_t(0x00000000), int32_t(0x4AF51461)},
    {"2tnkbarl.hva", "-", int32_t(0x00000000), int32_t(0x11CB42D3)},
    {"2tnkbarl.vxl", "medium tank barrel", int32_t(0x00000000), int32_t(0xE7419D9A)},
    {"2tnkicon.shp", "icon: medium tank", int32_t(0x1A202A89), int32_t(0x00000000)},
    {"2tnktur.hva", "-", int32_t(0x00000000), int32_t(0x4ED86400)},
    {"2tnktur.vxl", "medium tank turret", int32_t(0x00000000), int32_t(0x412E17EB)},
    {"2woodwlk2.aud", "", int32_t(0x522E734A), int32_t(0x00000000)},
    {"3.aud", "", int32_t(0xAA825CAA), int32_t(0x00000000)},
    {"30-i000.aud", "pilot reporting", int32_t(0x00000000), int32_t(0xEB7C3CE4)},
    {"30-i002.aud", "ready", int32_t(0x00000000), int32_t(0xA6B49DEF)},
    {"30-i004.aud", "awaiting orders", int32_t(0x00000000), int32_t(0x70ED7EF2)},
    {"30-i006.aud", "sir", int32_t(0x00000000), int32_t(0x3D25DFF9)},
    {"30-i014.aud", "yes sir", int32_t(0x00000000), int32_t(0xD69A7546)},
    {"30-i016.aud", "orders recieved", int32_t(0x00000000), int32_t(0x9B52D44D)},
    {"30-i018.aud", "over and out", int32_t(0x00000000), int32_t(0xA158B53D)},
    {"30-i022.aud", "on my way", int32_t(0x00000000), int32_t(0x312B8CC6)},
    {"30-i030.aud", "death from above", int32_t(0x00000000), int32_t(0xDA942679)},
    {"30-i034.aud", "form up", int32_t(0x00000000), int32_t(0x4105646F)},
    {"30-i036.aud", "away we go", int32_t(0x00000000), int32_t(0x0CCDC564)},
    {"30minr.aud", "30 minutes left", int32_t(0xA791A9BE), int32_t(0x00000000)},
    {"32-i000.aud", "affirmative", int32_t(0x00000000), int32_t(0xB3108525)},
    {"32-i002.aud", "target sighted", int32_t(0x00000000), int32_t(0xFED8242E)},
    {"32-i004.aud", "orders recieved", int32_t(0x00000000), int32_t(0x2881C733)},
    {"32-i006.aud", "engaging", int32_t(0x00000000), int32_t(0x65496638)},
    {"32-i008.aud", "woops", int32_t(0x00000000), int32_t(0x5F430748)},
    {"33-n000.aud", "where the hell are those reinforcements", int32_t(0x00000000), int32_t(0x16FF372C)},
    {"33-n002.aud", "its nod sir, they came out of nowhere", int32_t(0x00000000), int32_t(0x5B379627)},
    {"33-n004.aud", "looks like they tore this place appart already", int32_t(0x00000000), int32_t(0x8D6E753A)},
    {"33-n008.aud", "here they come", int32_t(0x00000000), int32_t(0xFAACB541)},
    {"33-n010.aud", "is there any tech left at the nod base", int32_t(0x00000000), int32_t(0xB0883C98)},
    {"33-n012.aud", "these critters don't look too friendly", int32_t(0x00000000), int32_t(0xFD409D93)},
    {"33-n014.aud", "the cavelry has arrived", int32_t(0x00000000), int32_t(0x2B197E8E)},
    {"33-n020.aud", "i believe there is an old gdi base near", int32_t(0x00000000), int32_t(0x81602605)},
    {"33-n022.aud", "here comes kanes welcoming comittee", int32_t(0x00000000), int32_t(0xCCA8870E)},
    {"33-n024.aud", "whats the eta on that mcv", int32_t(0x00000000), int32_t(0x1AF16413)},
    {"35-n000.aud", "get tratos over here, asap", int32_t(0x00000000), int32_t(0xFE4AFD6F)},
    {"35-n002.aud", "with all due respect, move your ass", int32_t(0x00000000), int32_t(0xB3825C64)},
    {"35-n004.aud", "eta for airstrike is 5 minutes", int32_t(0x00000000), int32_t(0x65DBBF79)},
    {"35-n008.aud", "pickup service", int32_t(0x00000000), int32_t(0x12197F02)},
    {"35-n010.aud", "negative, i can make it", int32_t(0x00000000), int32_t(0x583DF6DB)},
    {"35-n012.aud", "i said, i can make it", int32_t(0x00000000), int32_t(0x15F557D0)},
    {"35-n014.aud", "i can aaah", int32_t(0x00000000), int32_t(0xC3ACB4CD)},
    {"35mm.aud", "", int32_t(0xDEEFAB94), int32_t(0x00000000)},
    {"35mmbrk1.aud", "", int32_t(0xDC20BA7F), int32_t(0x00000000)},
    {"35mmgo1.aud", "", int32_t(0x91DBC89C), int32_t(0x00000000)},
    {"36-n000.aud",
     "that train goes to the power grid we told you about, get us on board",
     int32_t(0x00000000),
     int32_t(0x67A89B6E)},
    {"36-n002.aud", "thanks, well enjoy this", int32_t(0x00000000), int32_t(0x2A603A65)},
    {"36-n004.aud", "somethings wrong, we should have been there by now", int32_t(0x00000000), int32_t(0xFC39D978)},
    {"36-n008.aud", "we have been betrayed, gdi kidnapped tratos", int32_t(0x00000000), int32_t(0x8BFB1903)},
    {"37-n000.aud", "thanks for your help", int32_t(0x00000000), int32_t(0xA62644AE)},
    {"37-n002.aud", "they may be on to us", int32_t(0x00000000), int32_t(0xEBEEE5A5)},
    {"38-0080e.aud", "", int32_t(0x8F6A925B), int32_t(0x00000000)},
    {"38-0160e.aud", "", int32_t(0x8F6A8E5D), int32_t(0x00000000)},
    {"38-n000.aud", "get back to the base", int32_t(0x00000000), int32_t(0x35DEB068)},
    {"38-n002.aud", "tiberiam is lethal to unprotected infantry", int32_t(0x00000000), int32_t(0x78161163)},
    {"38-n004.aud", "we need more men, train them from the hand of nod", int32_t(0x00000000), int32_t(0xAE4FF27E)},
    {"38-n006.aud", "laser turrets, run for it", int32_t(0x00000000), int32_t(0xE3875375)},
    {"38-n008.aud", "the traitors are comming, blow the bridge", int32_t(0x00000000), int32_t(0xD98D3205)},
    {"38-n010.aud", "hassan is escaping", int32_t(0x00000000), int32_t(0x93A9BBDC)},
    {"38-n012.aud", "hassan has been captured", int32_t(0x00000000), int32_t(0xDE611AD7)},
    {"38-n014.aud", "we got an old stock pile here sir", int32_t(0x00000000), int32_t(0x0838F9CA)},
    {"38-n016.aud", "the mutants have turned on us", int32_t(0x00000000), int32_t(0x45F058C1)},
    {"38-n018.aud", "there everywhere", int32_t(0x00000000), int32_t(0x7FFA39B1)},
    {"38-n020.aud", "lets get him to the convoy point", int32_t(0x00000000), int32_t(0xA241A141)},
    {"38-n022.aud", "take point, soldier", int32_t(0x00000000), int32_t(0xEF89004A)},
    {"38-n024.aud", "glad to see you free, sir", int32_t(0x00000000), int32_t(0x39D0E357)},
    {"38-n026.aud", "being held in an outpost to the east", int32_t(0x00000000), int32_t(0x7418425C)},
    {"38-n028.aud",
     "the ice wont support the weight of multiple vechicles crossing",
     int32_t(0x00000000),
     int32_t(0x4E12232C)},
    {"38-n100.aud", "something crashed near here, spread out & report", int32_t(0x00000000), int32_t(0xF974B0F6)},
    {"38-n102.aud", "sir weve found something, i think it is the tascitus", int32_t(0x00000000), int32_t(0xB4BC11FD)},
    {"38-n104.aud",
     "well fall back to the old airfield & wait out the storm",
     int32_t(0x00000000),
     int32_t(0x62E5F2E0)},
    {"38-n106.aud", "we have recovered a piece of cabals core", int32_t(0x00000000), int32_t(0x2F2D53EB)},
    {"38-n108.aud", "i think we have been spotted", int32_t(0x00000000), int32_t(0x1527329B)},
    {"38-n110.aud", "gdi forces are nearby", int32_t(0x00000000), int32_t(0x5F03BB42)},
    {"38-n112.aud", "we have recovered another piece of the core", int32_t(0x00000000), int32_t(0x12CB1A49)},
    {"38-n114.aud", "third piece recovered, lets get out of here", int32_t(0x00000000), int32_t(0xC492F954)},
    {"38-n116.aud",
     "recon reports a heavy concentration of tiberium poisining",
     int32_t(0x00000000),
     int32_t(0x895A585F)},
    {"38-n118.aud", "we have to find that airfield or were finished", int32_t(0x00000000), int32_t(0xB350392F)},
    {"38-n120.aud", "message transmitted, montauk is en route", int32_t(0x00000000), int32_t(0x6EEBA1DF)},
    {"38-n122.aud", "this is the montauk, we are standing by for your evac", int32_t(0x00000000), int32_t(0x232300D4)},
    {"38-n124.aud",
     "we need to create a distraction to clear the gdi base of air support",
     int32_t(0x00000000),
     int32_t(0xF57AE3C9)},
    {"38-n126.aud",
     "i bet if we attack these civillians, gdi will come to the rescue",
     int32_t(0x00000000),
     int32_t(0xB8B242C2)},
    {"38-n128.aud", "gdi planes are away from the base, now's our chance", int32_t(0x00000000), int32_t(0x82B823B2)},
    {"38-n130.aud", "the core is undefended", int32_t(0x00000000), int32_t(0xC89CAA6B)},
    {"38-n132.aud", "the core isn't here, we have been tricked", int32_t(0x00000000), int32_t(0x85540B60)},
    {"38-n134.aud", "looks like this was just a remotly operated substation", int32_t(0x00000000), int32_t(0x530DE87D)},
    {"38-n136.aud",
     "reinforcements can be brought in if we repair the bridge",
     int32_t(0x00000000),
     int32_t(0x1EC54976)},
    {"38-n138.aud", "gdi has requested that we help the civillians first", int32_t(0x00000000), int32_t(0x24CF2806)},
    {"38-n140.aud",
     "once they're safe, we can concentrate on cabals harvesters",
     int32_t(0x00000000),
     int32_t(0x0D3B94E5)},
    {"38-n142.aud",
     "gdi is sending us additional funding for aiding the civillians",
     int32_t(0x00000000),
     int32_t(0x40F335EE)},
    {"38-n144.aud", "forget the civillians, there dead", int32_t(0x00000000), int32_t(0x96AAD6F3)},
    {"38-n146.aud", "this should be easy enough", int32_t(0x00000000), int32_t(0xDB6277F8)},
    {"38-n148.aud", "lets get those harvesters", int32_t(0x00000000), int32_t(0xE1681688)},
    {"38-n150.aud",
     "gdi is uploading the final pieces of the code now, stand by",
     int32_t(0x00000000),
     int32_t(0xAB4C9F51)},
    {"38-n152.aud", "fire storm coming down", int32_t(0x00000000), int32_t(0xE6843E5A)},
    {"38-n154.aud", "fire storm is offline", int32_t(0x00000000), int32_t(0x30DDDD47)},
    {"38-n156.aud", "code fragment retrieved", int32_t(0x00000000), int32_t(0x7D157C4C)},
    {"39-n000.aud", "i am free, now its paback time, hassan", int32_t(0x00000000), int32_t(0xF4506FA8)},
    {"3minr.aud", "3 minutes left", int32_t(0xE3A791B5), int32_t(0x00000000)},
    {"3objmet1.aud", "3rd objective met", int32_t(0xD0070895), int32_t(0x00000000)},
    {"3point.fnt", "3 point", int32_t(0xB19A3DB7), int32_t(0x00000000)},
    {"3pres.shp", "", int32_t(0x00000000), int32_t(0xF4955982)},
    {"3tnk.hva", "-", int32_t(0x00000000), int32_t(0x70D5CBB6)},
    {"3tnk.shp", "unit: heavy tank", int32_t(0xE6E4FB94), int32_t(0x00000000)},
    {"3tnk.vxl", "heavy tank", int32_t(0x00000000), int32_t(0x865F14FF)},
    {"3tnkbarl.hva", "-", int32_t(0x00000000), int32_t(0x8A6E0EBC)},
    {"3tnkbarl.vxl", "heavy tank barrel", int32_t(0x00000000), int32_t(0x7CE4D1F5)},
    {"3tnkicon.shp", "icon: heavy tank", int32_t(0x1A202A8D), int32_t(0x00000000)},
    {"3tnktur.hva", "-", int32_t(0x00000000), int32_t(0xD57D286F)},
    {"3tnktur.vxl", "heavy tank turret", int32_t(0x00000000), int32_t(0xDA8B5B84)},
    {"3tweak10.ini", "", int32_t(0x00000000), int32_t(0x8CA82DC7)},
    {"3tweak10.map", "-", int32_t(0x00000000), int32_t(0x68523114)},
    {"4.aud", "", int32_t(0xAA825CAC), int32_t(0x00000000)},
    {"40-n000.aud", "we have been touched by the spirit hand of kane", int32_t(0x00000000), int32_t(0xFB85B8A2)},
    {"40.aud", "", int32_t(0x825CA4BD), int32_t(0x00000000)},
    {"40103emnky1.aud", "", int32_t(0x17659E46), int32_t(0x00000000)},
    {"4025108e.csv", "", int32_t(0xB58C6461), int32_t(0x00000000)},
    {"4025108e.lsv", "", int32_t(0xB58C6D61), int32_t(0x00000000)},
    {"4025108e.vqa", "", int32_t(0xA08A7761), int32_t(0x00000000)},
    {"4025108e_e.vqa", "", int32_t(0x6ACF0E76), int32_t(0x00000000)},
    {"4025108e_e.vqt", "", int32_t(0x6ACF2176), int32_t(0x00000000)},
    {"4025108e_h.pcx", "", int32_t(0x5ECF2B68), int32_t(0x00000000)},
    {"4025108e_h.vqa", "", int32_t(0x6ACF1476), int32_t(0x00000000)},
    {"4025108e_l.pcx", "", int32_t(0x5ECF3368), int32_t(0x00000000)},
    {"4025108e_l.vqa", "", int32_t(0x6ACF1C76), int32_t(0x00000000)},
    {"40minr.aud", "40 minutes left", int32_t(0xA791A9C2), int32_t(0x00000000)},
    {"41-n000.aud", "stand and identify yourself in the name of kane", int32_t(0x00000000), int32_t(0x3A0B6762)},
    {"41-n002.aud", "sound the alarm", int32_t(0x00000000), int32_t(0x77C3C669)},
    {"41-n004.aud", "base command, this is post tk421, we have got", int32_t(0x00000000), int32_t(0xA19A2574)},
    {"41-n006.aud",
     "we just got word from general hassan, hes moving up north to cairo",
     int32_t(0x00000000),
     int32_t(0xEC52847F)},
    {"411440103e.aud", "", int32_t(0xE4AB192D), int32_t(0x00000000)},
    {"41450203e.aud", "", int32_t(0x20E4AF31), int32_t(0x00000000)},
    {"42-i000.aud", "toxin soldier", int32_t(0x00000000), int32_t(0xC7886CAA)},
    {"42-i002.aud", "yes", int32_t(0x00000000), int32_t(0x8A40CDA1)},
    {"42-i004.aud", "im all ears", int32_t(0x00000000), int32_t(0x5C192EBC)},
    {"42-i006.aud", "of course", int32_t(0x00000000), int32_t(0x11D18FB7)},
    {"42-i008.aud", "i think i can be pursuaded", int32_t(0x00000000), int32_t(0x2BDBEEC7)},
    {"42-i010.aud", "on it", int32_t(0x00000000), int32_t(0x61FF671E)},
    {"42-i012.aud", "knockout", int32_t(0x00000000), int32_t(0x2C37C615)},
    {"42-i266.aud", "-", int32_t(0x00000000), int32_t(0x3024BDF0)},
    {"43-n000.aud", "i have the codes", int32_t(0x00000000), int32_t(0x6267DEA3)},
    {"44-n000.aud", "we are here & waiting for your arrival", int32_t(0x00000000), int32_t(0x4B5CCB20)},
    {"47-n000.aud", "dont shoot, i can tell you gdis evac locations", int32_t(0x00000000), int32_t(0xD2BEAD21)},
    {"4e.aud", "", int32_t(0x825CCEBD), int32_t(0x00000000)},
    {"4minr.aud", "4 minutes left", int32_t(0xE3A791B9), int32_t(0x00000000)},
    {"4pres.shp", "", int32_t(0x00000000), int32_t(0x800DB00D)},
    {"4tnk.hva", "-", int32_t(0x00000000), int32_t(0x7A10C2AF)},
    {"4tnk.shp", "unit: mammoth tank", int32_t(0xE6E4FB96), int32_t(0x00000000)},
    {"4tnk.vxl", "mammoth tank", int32_t(0x00000000), int32_t(0x8C9A1DE6)},
    {"4tnkbarl.hva", "-", int32_t(0x00000000), int32_t(0xFEF6E733)},
    {"4tnkbarl.vxl", "mammoth tank barrel", int32_t(0x00000000), int32_t(0x087C387A)},
    {"4tnkicon.shp", "icon: mammoth tank", int32_t(0x1A202A91), int32_t(0x00000000)},
    {"4tnktur.hva", "-", int32_t(0x00000000), int32_t(0xA1E5C1E0)},
    {"4tnktur.vxl", "mammoth tank turret", int32_t(0x00000000), int32_t(0xAE13B20B)},
    {"5010007e.aud", "", int32_t(0x8F886263), int32_t(0x00000000)},
    {"5010107e.aud", "", int32_t(0x8F886265), int32_t(0x00000000)},
    {"5010207e.aud", "", int32_t(0x8F886267), int32_t(0x00000000)},
    {"5010307e.aud", "", int32_t(0x8F886269), int32_t(0x00000000)},
    {"5010407e.aud", "", int32_t(0x8F88626B), int32_t(0x00000000)},
    {"5010507e.aud", "", int32_t(0x8F88626D), int32_t(0x00000000)},
    {"5010607e.aud", "", int32_t(0x8F88626F), int32_t(0x00000000)},
    {"5010707e.aud", "", int32_t(0x8F886271), int32_t(0x00000000)},
    {"5010807e.aud", "", int32_t(0x8F886273), int32_t(0x00000000)},
    {"5010907e.aud", "", int32_t(0x8F886275), int32_t(0x00000000)},
    {"5011007e.aud", "", int32_t(0x93886263), int32_t(0x00000000)},
    {"5011107e.aud", "", int32_t(0x93886265), int32_t(0x00000000)},
    {"5011207e.aud", "", int32_t(0x93886267), int32_t(0x00000000)},
    {"5011307e.aud", "", int32_t(0x93886269), int32_t(0x00000000)},
    {"5011407e.aud", "", int32_t(0x9388626B), int32_t(0x00000000)},
    {"5011507e.aud", "", int32_t(0x9388626D), int32_t(0x00000000)},
    {"5011607e.aud", "", int32_t(0x9388626F), int32_t(0x00000000)},
    {"5011707e.aud", "", int32_t(0x93886271), int32_t(0x00000000)},
    {"5011807e.aud", "", int32_t(0x93886273), int32_t(0x00000000)},
    {"5011907e.aud", "", int32_t(0x93886275), int32_t(0x00000000)},
    {"5012007e.aud", "", int32_t(0x97886263), int32_t(0x00000000)},
    {"5012107e.aud", "", int32_t(0x97886265), int32_t(0x00000000)},
    {"5012207e.aud", "", int32_t(0x97886267), int32_t(0x00000000)},
    {"5012307e.aud", "", int32_t(0x97886269), int32_t(0x00000000)},
    {"5012407e.aud", "", int32_t(0x9788626B), int32_t(0x00000000)},
    {"5012507e.aud", "", int32_t(0x9788626D), int32_t(0x00000000)},
    {"5012607e.aud", "", int32_t(0x9788626F), int32_t(0x00000000)},
    {"5012707e.aud", "", int32_t(0x97886271), int32_t(0x00000000)},
    {"50cal.shp", "50 calibre cannon shot", int32_t(0x95B31DBD), int32_t(0x7B67F207)},
    {"52-n000.aud", "welcome stranger", int32_t(0x00000000), int32_t(0x384C4D0C)},
    {"52-n002.aud", "can i offer you a cool beverage", int32_t(0x00000000), int32_t(0x7584EC07)},
    {"52-n004.aud", "what do you think you are doing", int32_t(0x00000000), int32_t(0xA3DD0F1A)},
    {"524eftwood5.aud", "", int32_t(0xC3ADC0A2), int32_t(0x00000000)},
    {"53-i000.aud", "what", int32_t(0x00000000), int32_t(0x9DA3FF05)},
    {"53-i002.aud", "ready to go", int32_t(0x00000000), int32_t(0xD06B5E0E)},
    {"53-i004.aud", "shall we go", int32_t(0x00000000), int32_t(0x0632BD13)},
    {"53-i006.aud", "yes", int32_t(0x00000000), int32_t(0x4BFA1C18)},
    {"53-i008.aud", "on my way", int32_t(0x00000000), int32_t(0x71F07D68)},
    {"53-i010.aud", "that seems logical", int32_t(0x00000000), int32_t(0x3BD4F4B1)},
    {"53-i012.aud", "oooh", int32_t(0x00000000), int32_t(0x761C55BA)},
    {"53-i102.aud", "-", int32_t(0x00000000), int32_t(0x1CC15E90)},
    {"53-i104.aud", "-", int32_t(0x00000000), int32_t(0xCA98BD8D)},
    {"53-i106.aud", "-", int32_t(0x00000000), int32_t(0x87501C86)},
    {"53-i108.aud", "on my way", int32_t(0x00000000), int32_t(0xBD5A7DF6)},
    {"53-i110.aud", "-", int32_t(0x00000000), int32_t(0xF77EF42F)},
    {"53-i112.aud", "-", int32_t(0x00000000), int32_t(0xBAB65524)},
    {"54-n000.aud", "no tascitus piece in here", int32_t(0x00000000), int32_t(0xD0F9874F)},
    {"54-n002.aud",
     "nothing in this one either, you sure were in the right place",
     int32_t(0x00000000),
     int32_t(0x9D312644)},
    {"54-n004.aud", "got it, lets get out of here", int32_t(0x00000000), int32_t(0x4B68C559)},
    {"54-n006.aud", "nothing in there", int32_t(0x00000000), int32_t(0x06A06452)},
    {"54-n008.aud", "the hieroglyphics on this temple read", int32_t(0x00000000), int32_t(0x3CAA0522)},
    {"54-n010.aud", "temple of time", int32_t(0x00000000), int32_t(0x768E8CFB)},
    {"54-n012.aud", "temple of thunder", int32_t(0x00000000), int32_t(0x3B462DF0)},
    {"54-n014.aud", "temple of the tascitus", int32_t(0x00000000), int32_t(0xED1FCEED)},
    {"54-n016.aud", "i got the tascitus", int32_t(0x00000000), int32_t(0xA0D76FE6)},
    {"54-n018.aud", "the blue tiberium is highly explosive, maybe", int32_t(0x00000000), int32_t(0x9ADD0E96)},
    {"54-n020.aud", "maybe we can blast a path through there", int32_t(0x00000000), int32_t(0x47669666)},
    {"54-n022.aud", "understood", int32_t(0x00000000), int32_t(0x0AAE376D)},
    {"54-n024.aud", "going in", int32_t(0x00000000), int32_t(0xDCF7D470)},
    {"54-n026.aud", "yes sir", int32_t(0x00000000), int32_t(0x913F757B)},
    {"54-n028.aud", "moving out", int32_t(0x00000000), int32_t(0xAB35140B)},
    {"54-n030.aud", "on my way", int32_t(0x00000000), int32_t(0xE1119DD2)},
    {"55-n000.aud", "help", int32_t(0x00000000), int32_t(0x1177588F)},
    {"55-n002.aud", "save us", int32_t(0x00000000), int32_t(0x5CBFF984)},
    {"55-n004.aud", "its coming right at us", int32_t(0x00000000), int32_t(0x8AE61A99)},
    {"55-n006.aud", "get us out, please", int32_t(0x00000000), int32_t(0xC72EBB92)},
    {"55-n008.aud", "its after us", int32_t(0x00000000), int32_t(0xFD24DAE2)},
    {"55-n010.aud", "look out", int32_t(0x00000000), int32_t(0xB700533B)},
    {"55-n012.aud", "what is gdi doing. nothing", int32_t(0x00000000), int32_t(0xFAC8F230)},
    {"55-n014.aud", "why are we in this god forsaken place", int32_t(0x00000000), int32_t(0x2C91112D)},
    {"55-n016.aud",
     "are we going to let those shiners take our food & water",
     int32_t(0x00000000),
     int32_t(0x6159B026)},
    {"55-n018.aud", "cant we all just get allong", int32_t(0x00000000), int32_t(0x5B53D156)},
    {"55-n020.aud", "riot troops, run", int32_t(0x00000000), int32_t(0x86E849A6)},
    {"55-n022.aud", "thanks for the warning, here is a reward for your help", int32_t(0x00000000), int32_t(0xCB20E8AD)},
    {"55-n024.aud", "here commander, please take these 2 disruptors", int32_t(0x00000000), int32_t(0x1D790BB0)},
    {"55-n026.aud", "please take this mcv", int32_t(0x00000000), int32_t(0x50B1AABB)},
    {"55-n028.aud", "ill never turn", int32_t(0x00000000), int32_t(0x6ABBCBCB)},
    {"55-n030.aud", "piece through power", int32_t(0x00000000), int32_t(0x209F4212)},
    {"55-n032.aud", "for the technology of piece", int32_t(0x00000000), int32_t(0x6D57E319)},
    {"55-n034.aud", "we got one", int32_t(0x00000000), int32_t(0xBB0E0004)},
    {"55-n036.aud", "fish is on the hook", int32_t(0x00000000), int32_t(0xF6C6A10F)},
    {"55-n038.aud", "here creature creature", int32_t(0x00000000), int32_t(0xCCCCC07F)},
    {"55-n040.aud", "we are under siege", int32_t(0x00000000), int32_t(0xE5387C9C)},
    {"55-n042.aud", "thanks for the help", int32_t(0x00000000), int32_t(0xA8F0DD97)},
    {"55-n044.aud", "we can shut that fencing down for you", int32_t(0x00000000), int32_t(0x7EA93E8A)},
    {"56-n000.aud", "lets show gdi were not going to take this", int32_t(0x00000000), int32_t(0x88953E8E)},
    {"56-n002.aud", "kill the shiners", int32_t(0x00000000), int32_t(0xC55D9F85)},
    {"56-n004.aud", "down with gdi", int32_t(0x00000000), int32_t(0x13047C98)},
    {"56-n006.aud", "thanks for the warning, take these units", int32_t(0x00000000), int32_t(0x5ECCDD93)},
    {"56-n008.aud", "take this for your troubles", int32_t(0x00000000), int32_t(0x64C6BCE3)},
    {"56-n010.aud", "help us", int32_t(0x00000000), int32_t(0x2EE2353A)},
    {"56-n012.aud", "save us", int32_t(0x00000000), int32_t(0x632A9431)},
    {"56-n014.aud", "there comming", int32_t(0x00000000), int32_t(0xB573772C)},
    {"56-n016.aud", "get us out", int32_t(0x00000000), int32_t(0xF8BBD627)},
    {"56-n018.aud", "dont leave us", int32_t(0x00000000), int32_t(0xC2B1B757)},
    {"56-n020.aud", "wait", int32_t(0x00000000), int32_t(0x1F0A2FA7)},
    {"57-n100.aud", "you picked the wrong place to surface, nod scum", int32_t(0x00000000), int32_t(0x85B1E1D0)},
    {"57-n102.aud", "gdi promised us piece & now tratos is dead", int32_t(0x00000000), int32_t(0xC87940DB)},
    {"57-n104.aud", "gdi lied to us", int32_t(0x00000000), int32_t(0x1E20A3C6)},
    {"57-n106.aud", "destroy them", int32_t(0x00000000), int32_t(0x53E802CD)},
    {"57-n108.aud", "show them this is our land", int32_t(0x00000000), int32_t(0x69E263BD)},
    {"57-n110.aud", "make them remember us", int32_t(0x00000000), int32_t(0x23C6EA64)},
    {"57-n112.aud", "they poisened our food & water", int32_t(0x00000000), int32_t(0x6E0E4B6F)},
    {"57-n114.aud", "they're trying to kill us", int32_t(0x00000000), int32_t(0xB857A872)},
    {"57-n116.aud", "take this harvester for your troubles", int32_t(0x00000000), int32_t(0xF59F0979)},
    {"57-n118.aud", "release the hounds", int32_t(0x00000000), int32_t(0xCF956809)},
    {"57-n120.aud", "halt & prepare for vehicle inspection", int32_t(0x00000000), int32_t(0x122EF0F9)},
    {"57-n122.aud", "ok, looks good, head on in", int32_t(0x00000000), int32_t(0x5FE651F2)},
    {"57-n124.aud", "its bugged, destroy it now", int32_t(0x00000000), int32_t(0x89BFB2EF)},
    {"5724e.aud", "", int32_t(0x7B4B39A3), int32_t(0x00000000)},
    {"58-n100.aud", "no civillian or mutant casualties", int32_t(0x00000000), int32_t(0x16491516)},
    {"58-n102.aud", "the riot should end quickly, but stay vigilent", int32_t(0x00000000), int32_t(0x5B81B41D)},
    {"58-n104.aud", "copy that valdes, transport is dusting off now", int32_t(0x00000000), int32_t(0x8DD85700)},
    {"58-n106.aud", "you get the juggernaut", int32_t(0x00000000), int32_t(0xC010F60B)},
    {"58-n108.aud", "get your people to the evac point", int32_t(0x00000000), int32_t(0xFA1A977B)},
    {"58-n110.aud", "get your poeple to the transport", int32_t(0x00000000), int32_t(0xB03E1EA2)},
    {"58-n112.aud", "valdez, we recommend you take out their leader", int32_t(0x00000000), int32_t(0xFDF6BFA9)},
    {"58-n114.aud", "protect doctor budro with your life, commander", int32_t(0x00000000), int32_t(0x2BAF5CB4)},
    {"58-n116.aud", "our base is under attack", int32_t(0x00000000), int32_t(0x6667FDBF)},
    {"58-n118.aud", "what in the world", int32_t(0x00000000), int32_t(0x5C6D9CCF)},
    {"58-n120.aud", "i should go warn the civillians in this area", int32_t(0x00000000), int32_t(0x81D6043F)},
    {"58-n122.aud", "cabal is one sick bastard", int32_t(0x00000000), int32_t(0xCC1EA534)},
    {"58-n124.aud", "cabal is taking prisoners, this cant be good", int32_t(0x00000000), int32_t(0x1A474629)},
    {"58-n126.aud", "cabal is conscripting humans", int32_t(0x00000000), int32_t(0x578FE722)},
    {"58-n128.aud", "cabal intends to turn you all into cyborgs", int32_t(0x00000000), int32_t(0x6D858652)},
    {"58-n130.aud", "cabal is harvesting biological components", int32_t(0x00000000), int32_t(0x27A10F8B)},
    {"58-n132.aud", "you must evacuate the city immediatly", int32_t(0x00000000), int32_t(0x6A69AE80)},
    {"58-n134.aud", "civillians to arms, defend your town", int32_t(0x00000000), int32_t(0xBC304D9D)},
    {"58-n136.aud", "this must be their base", int32_t(0x00000000), int32_t(0xF1F8EC96)},
    {"58-n138.aud", "what the", int32_t(0x00000000), int32_t(0xCBF28DE6)},
    {"58-n140.aud", "i must warn the citicens of tronhime", int32_t(0x00000000), int32_t(0xE2063105)},
    {"58-n142.aud", "people of tronhime, get out now", int32_t(0x00000000), int32_t(0xAFCE900E)},
    {"59-n100.aud", "we can ill afford to loose more civillians to cabal", int32_t(0x00000000), int32_t(0xD7C7CAD6)},
    {"59-n102.aud", "get in there & protect those civillians", int32_t(0x00000000), int32_t(0x9A0F6BDD)},
    {"59-n104.aud", "well done commander, reinforcements en route", int32_t(0x00000000), int32_t(0x4C5688C0)},
    {"5minr.aud", "5 minutes left", int32_t(0xE3A791BD), int32_t(0x00000000)},
    {"6.fnt", "6", int32_t(0x9C8C5CC0), int32_t(0x00000000)},
    {"60-0000e.aud", "", int32_t(0x8F6A6267), int32_t(0x00000000)},
    {"60-n100.aud", "system ready", int32_t(0x00000000), int32_t(0xDB1426A3)},
    {"60-n102.aud", "instructions", int32_t(0x00000000), int32_t(0x96DC87A8)},
    {"60-n104.aud", "awaiting navcom", int32_t(0x00000000), int32_t(0x408564B5)},
    {"60-n106.aud", "moving", int32_t(0x00000000), int32_t(0x0D4DC5BE)},
    {"60-n108.aud", "recieving course", int32_t(0x00000000), int32_t(0x3747A4CE)},
    {"60-n110.aud", "as ordered", int32_t(0x00000000), int32_t(0x7D632D17)},
    {"60-n112.aud", "exterminate", int32_t(0x00000000), int32_t(0x30AB8C1C)},
    {"60-n114.aud", "target locked", int32_t(0x00000000), int32_t(0xE6F26F01)},
    {"60-n116.aud", "weapons armed", int32_t(0x00000000), int32_t(0xAB3ACE0A)},
    {"61-n000.aud", "dare you defile sacred ground", int32_t(0x00000000), int32_t(0xD630F9FD)},
    {"61-n002.aud", "kill the mutant", int32_t(0x00000000), int32_t(0x9BF858F6)},
    {"61-n004.aud", "stop thief", int32_t(0x00000000), int32_t(0x4DA1BBEB)},
    {"61-n006.aud", "kill the heretics", int32_t(0x00000000), int32_t(0x00691AE0)},
    {"61-n008.aud", "do not let them escape", int32_t(0x00000000), int32_t(0x3A637B90)},
    {"61-n010.aud", "what, they killed the leader", int32_t(0x00000000), int32_t(0x7047F249)},
    {"61-n012.aud", "we join you in the hereafter", int32_t(0x00000000), int32_t(0x3D8F5342)},
    {"62-n000.aud", "welcome traveler", int32_t(0x00000000), int32_t(0x4FD29FFC)},
    {"62-n002.aud", "join us", int32_t(0x00000000), int32_t(0x021A3EF7)},
    {"62-n004.aud", "join me", int32_t(0x00000000), int32_t(0xD443DDEA)},
    {"62-n006.aud", "existance is futile", int32_t(0x00000000), int32_t(0x998B7CE1)},
    {"62-n008.aud", "im coming to join you", int32_t(0x00000000), int32_t(0xA3811D91)},
    {"62-n010.aud", "i am a messenger", int32_t(0x00000000), int32_t(0xE9A59448)},
    {"62-n012.aud", "come to me", int32_t(0x00000000), int32_t(0xA46D3543)},
    {"64-i965.aud", "-", int32_t(0x00000000), int32_t(0xEF5487D4)},
    {"6410024e.aud", "", int32_t(0x8F827667), int32_t(0x00000000)},
    {"6410124e.aud", "", int32_t(0x8F827669), int32_t(0x00000000)},
    {"6410224e.aud", "", int32_t(0x8F82766B), int32_t(0x00000000)},
    {"6410324e.aud", "", int32_t(0x8F82766D), int32_t(0x00000000)},
    {"6410424e.aud", "", int32_t(0x8F82766F), int32_t(0x00000000)},
    {"6410524e.aud", "", int32_t(0x8F827671), int32_t(0x00000000)},
    {"6410624e.aud", "", int32_t(0x8F827673), int32_t(0x00000000)},
    {"6410724e.aud", "", int32_t(0x8F827675), int32_t(0x00000000)},
    {"6410824e.aud", "", int32_t(0x8F827677), int32_t(0x00000000)},
    {"6410924e.aud", "", int32_t(0x8F827679), int32_t(0x00000000)},
    {"6411024e.aud", "", int32_t(0x93827667), int32_t(0x00000000)},
    {"6411124e.aud", "", int32_t(0x93827669), int32_t(0x00000000)},
    {"6411224e.aud", "", int32_t(0x9382766B), int32_t(0x00000000)},
    {"6411324e.aud", "", int32_t(0x9382766D), int32_t(0x00000000)},
    {"67-0870r.aud", "", int32_t(0xA96A8C77), int32_t(0x00000000)},
    {"67-1100r.aud", "", int32_t(0xAD6A7E69), int32_t(0x00000000)},
    {"67-n100.aud", "you talking to me", int32_t(0x00000000), int32_t(0xF22F3320)},
    {"67-n102.aud", "can i help you", int32_t(0x00000000), int32_t(0xBFE7922B)},
    {"67-n104.aud", "whatever", int32_t(0x00000000), int32_t(0x69BE7136)},
    {"67-n106.aud", "im going", int32_t(0x00000000), int32_t(0x2476D03D)},
    {"67-n108.aud", "out of my way", int32_t(0x00000000), int32_t(0x1E7CB14D)},
    {"67_0470r.aud", "", int32_t(0xAA328C6F), int32_t(0x00000000)},
    {"67_0480r.aud", "", int32_t(0xAA328E6F), int32_t(0x00000000)},
    {"67_0500r.aud", "", int32_t(0xAA327E71), int32_t(0x00000000)},
    {"67_0540r.aud", "", int32_t(0xAA328671), int32_t(0x00000000)},
    {"67_0560r.aud", "", int32_t(0xAA328A71), int32_t(0x00000000)},
    {"67_0870r.aud", "", int32_t(0xAA328C77), int32_t(0x00000000)},
    {"67_0880r.aud", "", int32_t(0xAA328E77), int32_t(0x00000000)},
    {"67_0900r.aud", "", int32_t(0xAA327E79), int32_t(0x00000000)},
    {"67_0940r.aud", "", int32_t(0xAA328679), int32_t(0x00000000)},
    {"67_0960r.aud", "", int32_t(0xAA328A79), int32_t(0x00000000)},
    {"67_1070r.aud", "", int32_t(0xAE328C67), int32_t(0x00000000)},
    {"67_1080r.aud", "", int32_t(0xAE328E67), int32_t(0x00000000)},
    {"67_1100r.aud", "", int32_t(0xAE327E69), int32_t(0x00000000)},
    {"67_1140r.aud", "", int32_t(0xAE328669), int32_t(0x00000000)},
    {"67_1160r.aud", "", int32_t(0xAE328A69), int32_t(0x00000000)},
    {"68-n100.aud", "yeah", int32_t(0x00000000), int32_t(0x61D7C7E6)},
    {"68-n102.aud", "huh", int32_t(0x00000000), int32_t(0x2C1F66ED)},
    {"68-n104.aud", "what", int32_t(0x00000000), int32_t(0xFA4685F0)},
    {"68-n106.aud", "shur", int32_t(0x00000000), int32_t(0xB78E24FB)},
    {"68-n108.aud", "alright", int32_t(0x00000000), int32_t(0x8D84458B)},
    {"68-n110.aud", "here i go", int32_t(0x00000000), int32_t(0xC7A0CC52)},
    {"69-n100.aud", "not me", int32_t(0x00000000), int32_t(0xA0591826)},
    {"69-n102.aud", "oooh", int32_t(0x00000000), int32_t(0xED91B92D)},
    {"69-n104.aud", "yeah", int32_t(0x00000000), int32_t(0x3BC85A30)},
    {"69-n106.aud", "do i gotta", int32_t(0x00000000), int32_t(0x7600FB3B)},
    {"69-n108.aud", "i gotta walk", int32_t(0x00000000), int32_t(0x4C0A9A4B)},
    {"69-n110.aud", "are you sure", int32_t(0x00000000), int32_t(0x062E1392)},
    {"6point.fnt", "6 point", int32_t(0xB19A3DC3), int32_t(0x574B127D)},
    {"6pres.shp", "", int32_t(0x00000000), int32_t(0x6C362E92)},
    {"70-n000.aud", "yes sir", int32_t(0x00000000), int32_t(0x8C1B6A52)},
    {"70-n002.aud", "need assistance", int32_t(0x00000000), int32_t(0xC1D3CB59)},
    {"70-n004.aud", "im your man", int32_t(0x00000000), int32_t(0x178A2844)},
    {"70-n006.aud", "be glad to", int32_t(0x00000000), int32_t(0x5A42894F)},
    {"70-n008.aud", "on the job", int32_t(0x00000000), int32_t(0x6048E83F)},
    {"70-n010.aud", "ok", int32_t(0x00000000), int32_t(0x2A6C61E6)},
    {"70-n012.aud", "looks like overtime", int32_t(0x00000000), int32_t(0x67A4C0ED)},
    {"70-n014.aud", "looks like overtime", int32_t(0x00000000), int32_t(0xB1FD23F0)},
    {"70-n016.aud", "take that", int32_t(0x00000000), int32_t(0xFC3582FB)},
    {"70-n018.aud", "hope i'm covered", int32_t(0x00000000), int32_t(0xC63FE38B)},
    {"71-n000.aud", "open fire, open fire", int32_t(0x00000000), int32_t(0x4D95B592)},
    {"71-n100.aud", "what, the civillians are shooting at us", int32_t(0x00000000), int32_t(0x813FB50C)},
    {"71-n102.aud", "so are the shiners, retreat to the factory", int32_t(0x00000000), int32_t(0xCCF71407)},
    {"71-n104.aud", "command station has been captured, defences offline", int32_t(0x00000000), int32_t(0x1AAEF71A)},
    {"71-n106.aud", "we need reinforcements now", int32_t(0x00000000), int32_t(0x57665611)},
    {"71-n108.aud", "what was that", int32_t(0x00000000), int32_t(0x6D6C3761)},
    {"71-n110.aud", "lets check that out", int32_t(0x00000000), int32_t(0x2748BEB8)},
    {"71-n112.aud", "did you hear something", int32_t(0x00000000), int32_t(0x6A801FB3)},
    {"71-n114.aud", "she ant going anywhere", int32_t(0x00000000), int32_t(0xBCD9FCAE)},
    {"71-n116.aud", "ill head back to base & get help", int32_t(0x00000000), int32_t(0xF1115DA5)},
    {"71-n118.aud", "shoot it", int32_t(0x00000000), int32_t(0xCB1B3CD5)},
    {"71-n120.aud", "lets get these civillians out of here now", int32_t(0x00000000), int32_t(0x16A0A425)},
    {"71-n122.aud", "were under attack", int32_t(0x00000000), int32_t(0x5B68052E)},
    {"71-n124.aud", "what the hell are those things", int32_t(0x00000000), int32_t(0x8D31E633)},
    {"71-n126.aud", "where are those things comming from", int32_t(0x00000000), int32_t(0xC0F94738)},
    {"71-n128.aud",
     "nod is uploading the final pieces of the code now, stand by",
     int32_t(0x00000000),
     int32_t(0xFAF32648)},
    {"71-n130.aud", "code recieved, firestorm wall coming down", int32_t(0x00000000), int32_t(0xB0D7AF91)},
    {"71-n132.aud", "firestorm is offline", int32_t(0x00000000), int32_t(0xFD1F0E9A)},
    {"71-n134.aud", "code fragment retrieved", int32_t(0x00000000), int32_t(0x2B46ED87)},
    {"71-n136.aud", "these laser posts are stronger than normal", int32_t(0x00000000), int32_t(0x668E4C8C)},
    {"7amb1.aud", "", int32_t(0xB3B76183), int32_t(0x00000000)},
    {"7amb10.aud", "", int32_t(0x8B91A994), int32_t(0x00000000)},
    {"7amb11.aud", "", int32_t(0x8B91AB94), int32_t(0x00000000)},
    {"7amb12.aud", "", int32_t(0x8B91AD94), int32_t(0x00000000)},
    {"7amb13.aud", "", int32_t(0x8B91AF94), int32_t(0x00000000)},
    {"7amb14.aud", "", int32_t(0x8B91B194), int32_t(0x00000000)},
    {"7amb2.aud", "", int32_t(0xB3B76185), int32_t(0x00000000)},
    {"7amb3.aud", "", int32_t(0xB3B76187), int32_t(0x00000000)},
    {"7amb4.aud", "", int32_t(0xB3B76189), int32_t(0x00000000)},
    {"7amb5.aud", "", int32_t(0xB3B7618B), int32_t(0x00000000)},
    {"7amb6.aud", "", int32_t(0xB3B7618D), int32_t(0x00000000)},
    {"7amb7.aud", "", int32_t(0xB3B7618F), int32_t(0x00000000)},
    {"7amb8.aud", "", int32_t(0xB3B76191), int32_t(0x00000000)},
    {"7amb9.aud", "", int32_t(0xB3B76193), int32_t(0x00000000)},
    {"7behind1.aud", "", int32_t(0xC7F2E69D), int32_t(0x00000000)},
    {"7behind2.aud", "", int32_t(0xC9F2E69D), int32_t(0x00000000)},
    {"7behind3.aud", "", int32_t(0xCBF2E69D), int32_t(0x00000000)},
    {"7coming1.aud", "", int32_t(0xDC20EA9D), int32_t(0x00000000)},
    {"7coming2.aud", "", int32_t(0xDE20EA9D), int32_t(0x00000000)},
    {"7e.aud", "", int32_t(0x825CCEC3), int32_t(0x00000000)},
    {"7glass1.aud", "", int32_t(0x61D818C4), int32_t(0x00000000)},
    {"7glass2.aud", "", int32_t(0x61DA18C4), int32_t(0x00000000)},
    {"7glass3.aud", "", int32_t(0x61DC18C4), int32_t(0x00000000)},
    {"7glass4.aud", "", int32_t(0x61DE18C4), int32_t(0x00000000)},
    {"7joinus1.aud", "", int32_t(0xCC3914A7), int32_t(0x00000000)},
    {"7joinus2.aud", "", int32_t(0xCE3914A7), int32_t(0x00000000)},
    {"7laff1.aud", "", int32_t(0x9B61D7BE), int32_t(0x00000000)},
    {"7laff2.aud", "", int32_t(0x9B61D9BE), int32_t(0x00000000)},
    {"7laff3.aud", "", int32_t(0x9B61DBBE), int32_t(0x00000000)},
    {"7laff4.aud", "", int32_t(0x9B61DDBE), int32_t(0x00000000)},
    {"7look1.aud", "", int32_t(0xBF99D7C8), int32_t(0x00000000)},
    {"7look2.aud", "", int32_t(0xBF99D9C8), int32_t(0x00000000)},
    {"7luth1.aud", "", int32_t(0xD3B1D7C2), int32_t(0x00000000)},
    {"7luth2.aud", "", int32_t(0xD3B1D9C2), int32_t(0x00000000)},
    {"7luth3.aud", "", int32_t(0xD3B1DBC2), int32_t(0x00000000)},
    {"7luth4.aud", "", int32_t(0xD3B1DDC2), int32_t(0x00000000)},
    {"7luth5.aud", "", int32_t(0xD3B1DFC2), int32_t(0x00000000)},
    {"7nogo1.aud", "", int32_t(0x9F99DFD0), int32_t(0x00000000)},
    {"7nogo2.aud", "", int32_t(0x9F99E1D0), int32_t(0x00000000)},
    {"7nogo3.aud", "", int32_t(0x9F99E3D0), int32_t(0x00000000)},
    {"7nogo4.aud", "", int32_t(0x9F99E5D0), int32_t(0x00000000)},
    {"7over1.aud", "", int32_t(0x97B5E3D6), int32_t(0x00000000)},
    {"7over2.aud", "", int32_t(0x97B5E5D6), int32_t(0x00000000)},
    {"7over3.aud", "", int32_t(0x97B5E7D6), int32_t(0x00000000)},
    {"7over4.aud", "", int32_t(0x97B5E9D6), int32_t(0x00000000)},
    {"7please1.aud", "", int32_t(0xBC11288D), int32_t(0x00000000)},
    {"7please2.aud", "", int32_t(0xBE11288D), int32_t(0x00000000)},
    {"7please3.aud", "", int32_t(0xC011288D), int32_t(0x00000000)},
    {"7urours1.aud", "", int32_t(0xE4453AB5), int32_t(0x00000000)},
    {"7urours2.aud", "", int32_t(0xE6453AB5), int32_t(0x00000000)},
    {"7yell1.aud", "", int32_t(0xB3720BCA), int32_t(0x00000000)},
    {"7yell2.aud", "", int32_t(0xB3720DCA), int32_t(0x00000000)},
    {"7yell3.aud", "", int32_t(0xB3720FCA), int32_t(0x00000000)},
    {"7yell4.aud", "", int32_t(0xB37211CA), int32_t(0x00000000)},
    {"8.fnt", "", int32_t(0x9C8C5CC4), int32_t(0x00000000)},
    {"80mx226m.aud", "c&c 80s mix", int32_t(0x3FF66673), int32_t(0x00000000)},
    {"86224e.aud", "", int32_t(0x4B25A79E), int32_t(0x00000000)},
    {"86604e.aud", "", int32_t(0x4335A79E), int32_t(0x00000000)},
    {"87v3barl.hva", "-", int32_t(0x00000000), int32_t(0x4DC8FA5A)},
    {"88424e.aud", "", int32_t(0x4B2DAF9E), int32_t(0x00000000)},
    {"8fat.fnt", "8 fat", int32_t(0xFCD0D29E), int32_t(0x00000000)},
    {"8point.fnt", "8 point", int32_t(0xB19A3DCB), int32_t(0xBE7AC163)},
    {"9150024e.aud", "", int32_t(0x8F926A73), int32_t(0x00000000)},
    {"9150124e.aud", "", int32_t(0x8F926A75), int32_t(0x00000000)},
    {"92-i269.aud", "-", int32_t(0x00000000), int32_t(0x5FDD0ECB)},
    {"9252524e.aud", "", int32_t(0x97926E7D), int32_t(0x00000000)},
    {"9252624e.aud", "", int32_t(0x97926E7F), int32_t(0x00000000)},
    {"9355024e.aud", "", int32_t(0xA3927273), int32_t(0x00000000)},
    {"9355124e.aud", "", int32_t(0xA3927275), int32_t(0x00000000)},
    {"9457524e.aud", "", int32_t(0xAB92767D), int32_t(0x00000000)},
    {"9457624e.aud", "", int32_t(0xAB92767F), int32_t(0x00000000)},
    {"9500mudwlk1.aud", "", int32_t(0x3B39EAD8), int32_t(0x00000000)},
    {"9520820e.aud", "", int32_t(0x8F7E7A83), int32_t(0x00000000)},
    {"9520920e.aud", "", int32_t(0x8F7E7A85), int32_t(0x00000000)},
    {"9810mudwlk4.aud", "", int32_t(0x3B4802D8), int32_t(0x00000000)},
    {"9825mudwlk6.aud", "", int32_t(0x635402D8), int32_t(0x00000000)},
    {"9843mudwlk3.aud", "", int32_t(0x535E02D8), int32_t(0x00000000)},
    {"984524e.aud", "", int32_t(0x319F9E8A), int32_t(0x00000000)},
    {"9860mudwlk7.aud", "", int32_t(0x3B7602D8), int32_t(0x00000000)},
    {"9888mudwlk2.aud", "", int32_t(0x7B7C02D8), int32_t(0x00000000)},
    {"99-0210e.aud", "", int32_t(0x8F6A8877), int32_t(0x00000000)},
    {"99-0220e.aud", "", int32_t(0x8F6A8A77), int32_t(0x00000000)},
    {"99-1820e.aud", "", int32_t(0x936A8A83), int32_t(0x00000000)},
    {"99-1890e.aud", "", int32_t(0x936A9883), int32_t(0x00000000)},
    {"99-1910e.aud", "", int32_t(0x936A8885), int32_t(0x00000000)},
    {"99-1920e.aud", "", int32_t(0x936A8A85), int32_t(0x00000000)},
    {"99-1970e.aud", "", int32_t(0x936A9485), int32_t(0x00000000)},
    {"99-1980e.aud", "", int32_t(0x936A9685), int32_t(0x00000000)},
    {"99-1990e.aud", "", int32_t(0x936A9885), int32_t(0x00000000)},
    {"99-2010e.aud", "", int32_t(0x976A8873), int32_t(0x00000000)},
    {"99-n454.aud", "you dare to attack me", int32_t(0x00000000), int32_t(0x5384E482)},
    {"99-n456.aud", "cybernetic intellegence will allways be superior", int32_t(0x00000000), int32_t(0x1E4C4589)},
    {"99-n458.aud", "by the way, missile launch detected", int32_t(0x00000000), int32_t(0x244624F9)},
    {"99-n460.aud", "cabal laugh", int32_t(0x00000000), int32_t(0xF9FDBC09)},
    {"99-n464.aud", "activating defence protocol, defender, now", int32_t(0x00000000), int32_t(0x626CFE1F)},
    {"99-n466.aud",
     "miscalculation in enemy ability, compensation initiated",
     int32_t(0x00000000),
     int32_t(0x2FA45F14)},
    {"9910mudwlk5.aud", "", int32_t(0x3B4A0AD8), int32_t(0x00000000)},
    {"9930050e.aud", "", int32_t(0x8F829073), int32_t(0x00000000)},
    {"9930050f.aud", "", int32_t(0x91829073), int32_t(0x00000000)},
    {"9930150e.aud", "", int32_t(0x8F829075), int32_t(0x00000000)},
    {"9930150f.aud", "", int32_t(0x91829075), int32_t(0x00000000)},
    {"9930250e.aud", "", int32_t(0x8F829077), int32_t(0x00000000)},
    {"9930250f.aud", "", int32_t(0x91829077), int32_t(0x00000000)},
    {"9930350e.aud", "", int32_t(0x8F829079), int32_t(0x00000000)},
    {"9930350f.aud", "", int32_t(0x91829079), int32_t(0x00000000)},
    {"9930450e.aud", "", int32_t(0x8F82907B), int32_t(0x00000000)},
    {"9930450f.aud", "", int32_t(0x9182907B), int32_t(0x00000000)},
    {"9930550e.aud", "", int32_t(0x8F82907D), int32_t(0x00000000)},
    {"9930550f.aud", "", int32_t(0x9182907D), int32_t(0x00000000)},
    {"9930650e.aud", "", int32_t(0x8F82907F), int32_t(0x00000000)},
    {"9930650f.aud", "", int32_t(0x9182907F), int32_t(0x00000000)},
    {"9930750e.aud", "", int32_t(0x8F829081), int32_t(0x00000000)},
    {"9930750f.aud", "", int32_t(0x91829081), int32_t(0x00000000)},
    {"9930950e.aud", "", int32_t(0x8F829085), int32_t(0x00000000)},
    {"9930950f.aud", "", int32_t(0x91829085), int32_t(0x00000000)},
    {"9931050e.aud", "", int32_t(0x93829073), int32_t(0x00000000)},
    {"9931050f.aud", "", int32_t(0x95829073), int32_t(0x00000000)},
    {"9931150e.aud", "", int32_t(0x93829075), int32_t(0x00000000)},
    {"9931150f.aud", "", int32_t(0x95829075), int32_t(0x00000000)},
    {"9931250e.aud", "", int32_t(0x93829077), int32_t(0x00000000)},
    {"9931250f.aud", "", int32_t(0x95829077), int32_t(0x00000000)},
    {"9931350e.aud", "", int32_t(0x93829079), int32_t(0x00000000)},
    {"9931350f.aud", "", int32_t(0x95829079), int32_t(0x00000000)},
    {"9931450e.aud", "", int32_t(0x9382907B), int32_t(0x00000000)},
    {"9931450f.aud", "", int32_t(0x9582907B), int32_t(0x00000000)},
    {"9931550e.aud", "", int32_t(0x9382907D), int32_t(0x00000000)},
    {"9931550f.aud", "", int32_t(0x9582907D), int32_t(0x00000000)},
    {"9931650e.aud", "", int32_t(0x9382907F), int32_t(0x00000000)},
    {"9931650f.aud", "", int32_t(0x9582907F), int32_t(0x00000000)},
    {"9931750e.aud", "", int32_t(0x93829081), int32_t(0x00000000)},
    {"9931750f.aud", "", int32_t(0x95829081), int32_t(0x00000000)},
    {"9931850e.aud", "", int32_t(0x93829083), int32_t(0x00000000)},
    {"9931850f.aud", "", int32_t(0x95829083), int32_t(0x00000000)},
    {"9931950e.aud", "", int32_t(0x93829085), int32_t(0x00000000)},
    {"9931950f.aud", "", int32_t(0x95829085), int32_t(0x00000000)},
    {"9932050e.aud", "", int32_t(0x97829073), int32_t(0x00000000)},
    {"9932050f.aud", "", int32_t(0x99829073), int32_t(0x00000000)},
    {"9932150e.aud", "", int32_t(0x97829075), int32_t(0x00000000)},
    {"9932150f.aud", "", int32_t(0x99829075), int32_t(0x00000000)},
    {"9932250e.aud", "", int32_t(0x97829077), int32_t(0x00000000)},
    {"9932250f.aud", "", int32_t(0x99829077), int32_t(0x00000000)},
    {"9932350e.aud", "", int32_t(0x97829079), int32_t(0x00000000)},
    {"9932350f.aud", "", int32_t(0x99829079), int32_t(0x00000000)},
    {"9932450e.aud", "", int32_t(0x9782907B), int32_t(0x00000000)},
    {"9932450f.aud", "", int32_t(0x9982907B), int32_t(0x00000000)},
    {"9932550e.aud", "", int32_t(0x9782907D), int32_t(0x00000000)},
    {"9932550f.aud", "", int32_t(0x9982907D), int32_t(0x00000000)},
    {"9932650e.aud", "", int32_t(0x9782907F), int32_t(0x00000000)},
    {"9932650f.aud", "", int32_t(0x9982907F), int32_t(0x00000000)},
    {"9940824e.aud", "", int32_t(0x8F8E8A83), int32_t(0x00000000)},
    {"9950024e.aud", "", int32_t(0x8F928A73), int32_t(0x00000000)},
    {"9950124e.aud", "", int32_t(0x8F928A75), int32_t(0x00000000)},
    {"9950224e.aud", "", int32_t(0x8F928A77), int32_t(0x00000000)},
    {"9950324e.aud", "", int32_t(0x8F928A79), int32_t(0x00000000)},
    {"9950424e.aud", "", int32_t(0x8F928A7B), int32_t(0x00000000)},
    {"9950524e.aud", "", int32_t(0x8F928A7D), int32_t(0x00000000)},
    {"9950624e.aud", "", int32_t(0x8F928A7F), int32_t(0x00000000)},
    {"9950724e.aud", "", int32_t(0x8F928A81), int32_t(0x00000000)},
    {"9950824e.aud", "", int32_t(0x8F928A83), int32_t(0x00000000)},
    {"9950924e.aud", "", int32_t(0x8F928A85), int32_t(0x00000000)},
    {"9951024e.aud", "", int32_t(0x93928A73), int32_t(0x00000000)},
    {"9951124e.aud", "", int32_t(0x93928A75), int32_t(0x00000000)},
    {"9951224e.aud", "", int32_t(0x93928A77), int32_t(0x00000000)},
    {"9951324e.aud", "", int32_t(0x93928A79), int32_t(0x00000000)},
    {"9951424e.aud", "", int32_t(0x93928A7B), int32_t(0x00000000)},
    {"9951524e.aud", "", int32_t(0x93928A7D), int32_t(0x00000000)},
    {"9951624e.aud", "", int32_t(0x93928A7F), int32_t(0x00000000)},
    {"9960024e.aud", "", int32_t(0x8F968A73), int32_t(0x00000000)},
    {"9960124e.aud", "", int32_t(0x8F968A75), int32_t(0x00000000)},
    {"9960224e.aud", "", int32_t(0x8F968A77), int32_t(0x00000000)},
    {"9960324e.aud", "", int32_t(0x8F968A79), int32_t(0x00000000)},
    {"9960424e.aud", "", int32_t(0x8F968A7B), int32_t(0x00000000)},
    {"9960524e.aud", "", int32_t(0x8F968A7D), int32_t(0x00000000)},
    {"9960624e.aud", "", int32_t(0x8F968A7F), int32_t(0x00000000)},
    {"9960724e.aud", "", int32_t(0x8F968A81), int32_t(0x00000000)},
    {"9960824e.aud", "", int32_t(0x8F968A83), int32_t(0x00000000)},
    {"9960924e.aud", "", int32_t(0x8F968A85), int32_t(0x00000000)},
    {"9970024e.aud", "", int32_t(0x8F9A8A73), int32_t(0x00000000)},
    {"9970124e.aud", "", int32_t(0x8F9A8A75), int32_t(0x00000000)},
    {"9970224e.aud", "", int32_t(0x8F9A8A77), int32_t(0x00000000)},
    {"9970324e.aud", "", int32_t(0x8F9A8A79), int32_t(0x00000000)},
    {"9970424e.aud", "", int32_t(0x8F9A8A7B), int32_t(0x00000000)},
    {"9970524e.aud", "", int32_t(0x8F9A8A7D), int32_t(0x00000000)},
    {"9970624e.aud", "", int32_t(0x8F9A8A7F), int32_t(0x00000000)},
    {"9980024e.aud", "", int32_t(0x8F9E8A73), int32_t(0x00000000)},
    {"9980124e.aud", "", int32_t(0x8F9E8A75), int32_t(0x00000000)},
    {"9980224e.aud", "", int32_t(0x8F9E8A77), int32_t(0x00000000)},
    {"9980324e.aud", "", int32_t(0x8F9E8A79), int32_t(0x00000000)},
    {"9980424e.aud", "", int32_t(0x8F9E8A7B), int32_t(0x00000000)},
    {"9980524e.aud", "", int32_t(0x8F9E8A7D), int32_t(0x00000000)},
    {"9980624e.aud", "", int32_t(0x8F9E8A7F), int32_t(0x00000000)},
    {"9980724e.aud", "", int32_t(0x8F9E8A81), int32_t(0x00000000)},
    {"9980824e.aud", "", int32_t(0x8F9E8A83), int32_t(0x00000000)},
    {"9980924e.aud", "", int32_t(0x8F9E8A85), int32_t(0x00000000)},
    {"9981024e.aud", "", int32_t(0x939E8A73), int32_t(0x00000000)},
    {"9981124e.aud", "", int32_t(0x939E8A75), int32_t(0x00000000)},
    {"9981224e.aud", "", int32_t(0x939E8A77), int32_t(0x00000000)},
    {"9981324e.aud", "", int32_t(0x939E8A79), int32_t(0x00000000)},
    {"9981424e.aud", "", int32_t(0x939E8A7B), int32_t(0x00000000)},
    {"9981624e.aud", "", int32_t(0x939E8A7F), int32_t(0x00000000)},
    {"9981724e.aud", "", int32_t(0x939E8A81), int32_t(0x00000000)},
    {"9981824e.aud", "", int32_t(0x939E8A83), int32_t(0x00000000)},
    {"9981924e.aud", "", int32_t(0x939E8A85), int32_t(0x00000000)},
    {"9982024e.aud", "", int32_t(0x979E8A73), int32_t(0x00000000)},
    {"9982124e.aud", "", int32_t(0x979E8A75), int32_t(0x00000000)},
    {"9982224e.aud", "", int32_t(0x979E8A77), int32_t(0x00000000)},
    {"9982324e.aud", "", int32_t(0x979E8A79), int32_t(0x00000000)},
    {"9982424e.aud", "", int32_t(0x979E8A7B), int32_t(0x00000000)},
    {"9982524e.aud", "", int32_t(0x979E8A7D), int32_t(0x00000000)},
    {"9982624e.aud", "", int32_t(0x979E8A7F), int32_t(0x00000000)},
    {"9982724e.aud", "", int32_t(0x979E8A81), int32_t(0x00000000)},
    {"9982824e.aud", "", int32_t(0x979E8A83), int32_t(0x00000000)},
    {"9982924e.aud", "", int32_t(0x979E8A85), int32_t(0x00000000)},
    {"9983024e.aud", "", int32_t(0x9B9E8A73), int32_t(0x00000000)},
    {"9983124e.aud", "", int32_t(0x9B9E8A75), int32_t(0x00000000)},
    {"9983224e.aud", "", int32_t(0x9B9E8A77), int32_t(0x00000000)},
    {"9983324e.aud", "", int32_t(0x9B9E8A79), int32_t(0x00000000)},
    {"9983424e.aud", "", int32_t(0x9B9E8A7B), int32_t(0x00000000)},
    {"9983524e.aud", "", int32_t(0x9B9E8A7D), int32_t(0x00000000)},
    {"9983624e.aud", "", int32_t(0x9B9E8A7F), int32_t(0x00000000)},
    {"9983724e.aud", "", int32_t(0x9B9E8A81), int32_t(0x00000000)},
    {"9983924e.aud", "", int32_t(0x9B9E8A85), int32_t(0x00000000)},
    {"9984024e.aud", "", int32_t(0x9F9E8A73), int32_t(0x00000000)},
    {"9984124e.aud", "", int32_t(0x9F9E8A75), int32_t(0x00000000)},
    {"9984224e.aud", "", int32_t(0x9F9E8A77), int32_t(0x00000000)},
    {"9984324e.aud", "", int32_t(0x9F9E8A79), int32_t(0x00000000)},
    {"9984424e.aud", "", int32_t(0x9F9E8A7B), int32_t(0x00000000)},
    {"9984524e.aud", "", int32_t(0x9F9E8A7D), int32_t(0x00000000)},
    {"9984624e.aud", "", int32_t(0x9F9E8A7F), int32_t(0x00000000)},
    {"9984724e.aud", "", int32_t(0x9F9E8A81), int32_t(0x00000000)},
    {"9984824e.aud", "", int32_t(0x9F9E8A83), int32_t(0x00000000)},
    {"9984924e.aud", "", int32_t(0x9F9E8A85), int32_t(0x00000000)},
    {"9985024e.aud", "", int32_t(0xA39E8A73), int32_t(0x00000000)},
    {"9985124e.aud", "", int32_t(0xA39E8A75), int32_t(0x00000000)},
    {"9985224e.aud", "", int32_t(0xA39E8A77), int32_t(0x00000000)},
    {"9985324e.aud", "", int32_t(0xA39E8A79), int32_t(0x00000000)},
    {"9985424e.aud", "", int32_t(0xA39E8A7B), int32_t(0x00000000)},
    {"9985524e.aud", "", int32_t(0xA39E8A7D), int32_t(0x00000000)},
    {"9985624e.aud", "", int32_t(0xA39E8A7F), int32_t(0x00000000)},
    {"9985724e.aud", "", int32_t(0xA39E8A81), int32_t(0x00000000)},
    {"9985824e.aud", "", int32_t(0xA39E8A83), int32_t(0x00000000)},
    {"9985924e.aud", "", int32_t(0xA39E8A85), int32_t(0x00000000)},
    {"9986024e.aud", "", int32_t(0xA79E8A73), int32_t(0x00000000)},
    {"9986124e.aud", "", int32_t(0xA79E8A75), int32_t(0x00000000)},
    {"9986224e.aud", "", int32_t(0xA79E8A77), int32_t(0x00000000)},
    {"9986324e.aud", "", int32_t(0xA79E8A79), int32_t(0x00000000)},
    {"9986424e.aud", "", int32_t(0xA79E8A7B), int32_t(0x00000000)},
    {"9986524e.aud", "", int32_t(0xA79E8A7D), int32_t(0x00000000)},
    {"9986624e.aud", "", int32_t(0xA79E8A7F), int32_t(0x00000000)},
    {"9986724e.aud", "", int32_t(0xA79E8A81), int32_t(0x00000000)},
    {"9986824e.aud", "", int32_t(0xA79E8A83), int32_t(0x00000000)},
    {"9986924e.aud", "", int32_t(0xA79E8A85), int32_t(0x00000000)},
    {"9987024e.aud", "", int32_t(0xAB9E8A73), int32_t(0x00000000)},
    {"9987124e.aud", "", int32_t(0xAB9E8A75), int32_t(0x00000000)},
    {"9987224e.aud", "", int32_t(0xAB9E8A77), int32_t(0x00000000)},
    {"9987324e.aud", "", int32_t(0xAB9E8A79), int32_t(0x00000000)},
    {"9987424e.aud", "", int32_t(0xAB9E8A7B), int32_t(0x00000000)},
    {"9987524e.aud", "", int32_t(0xAB9E8A7D), int32_t(0x00000000)},
    {"9987624e.aud", "", int32_t(0xAB9E8A7F), int32_t(0x00000000)},
    {"9987724e.aud", "", int32_t(0xAB9E8A81), int32_t(0x00000000)},
    {"9987824e.aud", "", int32_t(0xAB9E8A83), int32_t(0x00000000)},
    {"9987924e.aud", "", int32_t(0xAB9E8A85), int32_t(0x00000000)},
    {"9988024e.aud", "", int32_t(0xAF9E8A73), int32_t(0x00000000)},
    {"9988124e.aud", "", int32_t(0xAF9E8A75), int32_t(0x00000000)},
    {"9988224e.aud", "", int32_t(0xAF9E8A77), int32_t(0x00000000)},
    {"9988324e.aud", "", int32_t(0xAF9E8A79), int32_t(0x00000000)},
    {"9988424e.aud", "", int32_t(0xAF9E8A7B), int32_t(0x00000000)},
    {"9988524e.aud", "", int32_t(0xAF9E8A7D), int32_t(0x00000000)},
    {"9988624e.aud", "", int32_t(0xAF9E8A7F), int32_t(0x00000000)},
    {"9988724e.aud", "", int32_t(0xAF9E8A81), int32_t(0x00000000)},
    {"9988824e.aud", "", int32_t(0xAF9E8A83), int32_t(0x00000000)},
    {"9988924e.aud", "", int32_t(0xAF9E8A85), int32_t(0x00000000)},
    {"9989024e.aud", "", int32_t(0xB39E8A73), int32_t(0x00000000)},
    {"9989124e.aud", "", int32_t(0xB39E8A75), int32_t(0x00000000)},
    {"9989224e.aud", "", int32_t(0xB39E8A77), int32_t(0x00000000)},
    {"9989324e.aud", "", int32_t(0xB39E8A79), int32_t(0x00000000)},
    {"9989424e.aud", "", int32_t(0xB39E8A7B), int32_t(0x00000000)},
    {"9989524e.aud", "", int32_t(0xB39E8A7D), int32_t(0x00000000)},
    {"9989624e.aud", "", int32_t(0xB39E8A7F), int32_t(0x00000000)},
    {"9989724e.aud", "", int32_t(0xB39E8A81), int32_t(0x00000000)},
    {"9989824e.aud", "", int32_t(0xB39E8A83), int32_t(0x00000000)},
    {"9989924e.aud", "", int32_t(0xB39E8A85), int32_t(0x00000000)},
    {"9990024e.aud", "", int32_t(0x8FA28A73), int32_t(0x00000000)},
    {"9990124e.aud", "", int32_t(0x8FA28A75), int32_t(0x00000000)},
    {"9990224e.aud", "", int32_t(0x8FA28A77), int32_t(0x00000000)},
    {"9990324e.aud", "", int32_t(0x8FA28A79), int32_t(0x00000000)},
    {"9990424e.aud", "", int32_t(0x8FA28A7B), int32_t(0x00000000)},
    {"9990524e.aud", "", int32_t(0x8FA28A7D), int32_t(0x00000000)},
    {"9990624e.aud", "", int32_t(0x8FA28A7F), int32_t(0x00000000)},
    {"9990724e.aud", "", int32_t(0x8FA28A81), int32_t(0x00000000)},
    {"9990824e.aud", "", int32_t(0x8FA28A83), int32_t(0x00000000)},
    {"9990924e.aud", "", int32_t(0x8FA28A85), int32_t(0x00000000)},
    {"9991024e.aud", "", int32_t(0x93A28A73), int32_t(0x00000000)},
    {"9991124e.aud", "", int32_t(0x93A28A75), int32_t(0x00000000)},
    {"9991224e.aud", "", int32_t(0x93A28A77), int32_t(0x00000000)},
    {"9991324e.aud", "", int32_t(0x93A28A79), int32_t(0x00000000)},
    {"9991424e.aud", "", int32_t(0x93A28A7B), int32_t(0x00000000)},
    {"9991524e.aud", "", int32_t(0x93A28A7D), int32_t(0x00000000)},
    {"9991624e.aud", "", int32_t(0x93A28A7F), int32_t(0x00000000)},
    {"9991724e.aud", "", int32_t(0x93A28A81), int32_t(0x00000000)},
    {"9991824e.aud", "", int32_t(0x93A28A83), int32_t(0x00000000)},
    {"9991924e.aud", "", int32_t(0x93A28A85), int32_t(0x00000000)},
    {"9992024e.aud", "", int32_t(0x97A28A73), int32_t(0x00000000)},
    {"9992124e.aud", "", int32_t(0x97A28A75), int32_t(0x00000000)},
    {"9992224e.aud", "", int32_t(0x97A28A77), int32_t(0x00000000)},
    {"9992324e.aud", "", int32_t(0x97A28A79), int32_t(0x00000000)},
    {"9992424e.aud", "", int32_t(0x97A28A7B), int32_t(0x00000000)},
    {"9992524e.aud", "", int32_t(0x97A28A7D), int32_t(0x00000000)},
    {"9992624e.aud", "", int32_t(0x97A28A7F), int32_t(0x00000000)},
    {"9992724e.aud", "", int32_t(0x97A28A81), int32_t(0x00000000)},
    {"9992824e.aud", "", int32_t(0x97A28A83), int32_t(0x00000000)},
    {"9992924e.aud", "", int32_t(0x97A28A85), int32_t(0x00000000)},
    {"9993024e.aud", "", int32_t(0x9BA28A73), int32_t(0x00000000)},
    {"9993124e.aud", "", int32_t(0x9BA28A75), int32_t(0x00000000)},
    {"9993224e.aud", "", int32_t(0x9BA28A77), int32_t(0x00000000)},
    {"9993324e.aud", "", int32_t(0x9BA28A79), int32_t(0x00000000)},
    {"9993424e.aud", "", int32_t(0x9BA28A7B), int32_t(0x00000000)},
    {"9993524e.aud", "", int32_t(0x9BA28A7D), int32_t(0x00000000)},
    {"9993624e.aud", "", int32_t(0x9BA28A7F), int32_t(0x00000000)},
    {"9993724e.aud", "", int32_t(0x9BA28A81), int32_t(0x00000000)},
    {"a.aud", "", int32_t(0xAA825CC6), int32_t(0x00000000)},
    {"a00_f00e.bik", "", int32_t(0x00000000), int32_t(0x1DDF2928)},
    {"a01_f00e.bik", "", int32_t(0x00000000), int32_t(0xF21D4216)},
    {"a01_f04e.bik", "", int32_t(0x00000000), int32_t(0x698C0000)},
    {"a01_p01.wav", "", int32_t(0x00000000), int32_t(0xCC5B7930)},
    {"a01_p01e.bik", "", int32_t(0x00000000), int32_t(0x8395A91F)},
    {"a01_p02e.bik", "", int32_t(0x00000000), int32_t(0x0501DBB1)},
    {"a01_p03e.bik", "", int32_t(0x00000000), int32_t(0xCE5D0814)},
    {"a02_f00e.bik", "", int32_t(0x00000000), int32_t(0x192AF915)},
    {"a02_p01.wav", "", int32_t(0x00000000), int32_t(0x276CC233)},
    {"a02_p01e.bik", "", int32_t(0x00000000), int32_t(0x68A2121C)},
    {"a02_p02e.bik", "", int32_t(0x00000000), int32_t(0xEE3660B2)},
    {"a02_p03e.bik", "", int32_t(0x00000000), int32_t(0x256AB317)},
    {"a03_f00e.bik", "", int32_t(0x00000000), int32_t(0xF6E8922B)},
    {"a03_p01.wav", "", int32_t(0x00000000), int32_t(0xC8AEA90D)},
    {"a03_p01e.bik", "", int32_t(0x00000000), int32_t(0x87607922)},
    {"a03_p02e.bik", "", int32_t(0x00000000), int32_t(0x01F40B8C)},
    {"a03_p03e.bik", "", int32_t(0x00000000), int32_t(0xCAA8D829)},
    {"a03_p04e.bik", "", int32_t(0x00000000), int32_t(0xD7ADE891)},
    {"a04_f00e.bik", "", int32_t(0x00000000), int32_t(0x14348952)},
    {"a04_f02e.bik", "", int32_t(0x00000000), int32_t(0x59FC2859)},
    {"a04_f03e.bik", "", int32_t(0x00000000), int32_t(0x92A0FBFC)},
    {"a04_p01.wav", "", int32_t(0x00000000), int32_t(0x2A72B274)},
    {"a04_p01e.bik", "", int32_t(0x00000000), int32_t(0x65BC625B)},
    {"a04_p02e.bik", "", int32_t(0x00000000), int32_t(0xE32810F5)},
    {"a04_p03e.bik", "", int32_t(0x00000000), int32_t(0x2874C350)},
    {"a05_f00e.bik", "", int32_t(0x00000000), int32_t(0xFBF6E26C)},
    {"a05_p01.wav", "", int32_t(0x00000000), int32_t(0xC5B0D94A)},
    {"a05_p01e.bik", "", int32_t(0x00000000), int32_t(0x8A7E0965)},
    {"a05_p02.wav", "", int32_t(0x00000000), int32_t(0x4324ABE4)},
    {"a05_p02e.bik", "", int32_t(0x00000000), int32_t(0x0CEA7BCB)},
    {"a05_p03e.bik", "", int32_t(0x00000000), int32_t(0xC7B6A86E)},
    {"a06_f00e.bik", "", int32_t(0x00000000), int32_t(0x10C1596F)},
    {"a06_p01.wav", "", int32_t(0x00000000), int32_t(0x2E876249)},
    {"a06_p01e.bik", "", int32_t(0x00000000), int32_t(0x6149B266)},
    {"a06_p02e.bik", "", int32_t(0x00000000), int32_t(0xE7DDC0C8)},
    {"a06_p03e.bik", "", int32_t(0x00000000), int32_t(0x2C81136D)},
    {"a06_p04.wav", "", int32_t(0x00000000), int32_t(0x7E4AF3FA)},
    {"a06_p04e.bik", "", int32_t(0x00000000), int32_t(0x318423D5)},
    {"a07_f00e.bik", "", int32_t(0x00000000), int32_t(0xFF033251)},
    {"a07_p01.wav", "", int32_t(0x00000000), int32_t(0xC1450977)},
    {"a07_p01e.bik", "", int32_t(0x00000000), int32_t(0x8E8BD958)},
    {"a07_p02e.bik", "", int32_t(0x00000000), int32_t(0x081FABF6)},
    {"a08_f00e.bik", "", int32_t(0x00000000), int32_t(0x0E0869DC)},
    {"a08_p01e.bik", "", int32_t(0x00000000), int32_t(0x7F8082D5)},
    {"a08_p02e.bik", "", int32_t(0x00000000), int32_t(0xF914F07B)},
    {"a09_f00e.bik", "", int32_t(0x00000000), int32_t(0xE1CA02E2)},
    {"a09_p01e.bik", "", int32_t(0x00000000), int32_t(0x9042E9EB)},
    {"a10.shp", "a10 warthog", int32_t(0x5CB0AAD5), int32_t(0x00000000)},
    {"a10_f00e.bik", "", int32_t(0x00000000), int32_t(0xDC51F6E8)},
    {"a10_p01e.bik", "", int32_t(0x00000000), int32_t(0xADD91DE1)},
    {"a10_p02e.bik", "", int32_t(0x00000000), int32_t(0x2B4D6F4F)},
    {"a10icnh.des", "icon: a10 warthog", int32_t(0x81A4A6CF), int32_t(0x00000000)},
    {"a10icnh.tem", "icon: a10 warthog", int32_t(0x819EA6DF), int32_t(0x00000000)},
    {"a10icnh.win", "icon: a10 warthog", int32_t(0x819FAAE2), int32_t(0x00000000)},
    {"a10icon.shp", "icon: a10 warthog", int32_t(0x81ADABDE), int32_t(0x00000000)},
    {"a11_f00e.bik", "", int32_t(0x00000000), int32_t(0x33939DD6)},
    {"a11_p01e.bik", "", int32_t(0x00000000), int32_t(0x421B76DF)},
    {"a11_p02e.bik", "", int32_t(0x00000000), int32_t(0xC48F0471)},
    {"a11_p03e.bik", "", int32_t(0x00000000), int32_t(0x0FD3D7D4)},
    {"a12_f00e.bik", "", int32_t(0x00000000), int32_t(0xD8A426D5)},
    {"a12_p01e.bik", "", int32_t(0x00000000), int32_t(0xA92CCDDC)},
    {"a12_p02e.bik", "", int32_t(0x00000000), int32_t(0x2FB8BF72)},
    {"a13_f00e.bik", "", int32_t(0x00000000), int32_t(0x37664DEB)},
    {"a13_f01e.bik", "", int32_t(0x00000000), int32_t(0xFC3A9E4E)},
    {"a13_f02e.bik", "", int32_t(0x00000000), int32_t(0x7AAEECE0)},
    {"a_cam.csv", "", int32_t(0xAB93D9F5), int32_t(0x00000000)},
    {"a_cam.lsv", "", int32_t(0xABA5D9F5), int32_t(0x00000000)},
    {"a_cam.vqa", "", int32_t(0xA7B9D9E0), int32_t(0x00000000)},
    {"a_cam_e.vqa", "", int32_t(0x61D98CF5), int32_t(0x00000000)},
    {"a_cam_e.vqt", "", int32_t(0x61EC8CF5), int32_t(0x00000000)},
    {"a_cam_h.pcx", "", int32_t(0x61F67EEF), int32_t(0x00000000)},
    {"a_cam_h.vqa", "", int32_t(0x61DF8CF5), int32_t(0x00000000)},
    {"a_cam_l.pcx", "", int32_t(0x61FE7EEF), int32_t(0x00000000)},
    {"a_cam_l.vqa", "", int32_t(0x61E78CF5), int32_t(0x00000000)},
    {"aacanon3.aud", "solid turret", int32_t(0xAFFEE4CF), int32_t(0x00000000)},
    {"aagun.vqa", "a.a. gun shooting yak", int32_t(0xF7C961E2), int32_t(0x00000000)},
    {"aagun.vqp", "vqp: a.a. gun shooting yak", int32_t(0xF7C961F1), int32_t(0x00000000)},
    {"aappro1.aud", "allied forces apporaching", int32_t(0x9DE7F8EA), int32_t(0x00000000)},
    {"aarive1.aud", "allied reinforcements comming from east", int32_t(0x81EFE4F2), int32_t(0x00000000)},
    {"aarrive1.aud", "allied reinforcements have arrived", int32_t(0xF028F2C5), int32_t(0x00000000)},
    {"aarrivn1.aud", "allied reinforcements comming from north", int32_t(0xF03AF2C5), int32_t(0x00000000)},
    {"aarrivs1.aud", "allied reinforcements comming from south", int32_t(0xF044F2C5), int32_t(0x00000000)},
    {"aarrivw1.aud", "allied reinforcements comming from west", int32_t(0xF04CF2C5), int32_t(0x00000000)},
    {"aavail1.aud", "a-bomb available", int32_t(0x61FFF2D8), int32_t(0x00000000)},
    {"aban01.shp", "-", int32_t(0x00000000), int32_t(0x88FEF051)},
    {"aban02.shp", "-", int32_t(0x00000000), int32_t(0xB916EACC)},
    {"aban03.shp", "-", int32_t(0x00000000), int32_t(0x1F61E178)},
    {"aban04.shp", "-", int32_t(0x00000000), int32_t(0xDAC6DFF6)},
    {"aban05.shp", "-", int32_t(0x00000000), int32_t(0x7CB1D442)},
    {"aban06.shp", "-", int32_t(0x00000000), int32_t(0x4D59CEDF)},
    {"aban07.shp", "-", int32_t(0x00000000), int32_t(0xEB2EC56B)},
    {"aban08.shp", "-", int32_t(0x00000000), int32_t(0x1D66B582)},
    {"aban09.shp", "-", int32_t(0x00000000), int32_t(0xBB11BE36)},
    {"aban10.shp", "-", int32_t(0x00000000), int32_t(0xE223FB7B)},
    {"aban11.shp", "-", int32_t(0x00000000), int32_t(0x4454F0CF)},
    {"aban12.shp", "-", int32_t(0x00000000), int32_t(0x75BCEA52)},
    {"aban13.shp", "-", int32_t(0x00000000), int32_t(0xD3CBE1E6)},
    {"aban14.shp", "-", int32_t(0x00000000), int32_t(0x166CDF68)},
    {"aban15.shp", "-", int32_t(0x00000000), int32_t(0xB01BD4DC)},
    {"aban16.shp", "-", int32_t(0x00000000), int32_t(0x81F3CE41)},
    {"aban17.shp", "-", int32_t(0x00000000), int32_t(0x2784C5F5)},
    {"aban18.shp", "-", int32_t(0x00000000), int32_t(0xD1CCB51C)},
    {"abldgin1.aud", "building", int32_t(0xB822DCC1), int32_t(0x00000000)},
    {"access.ini", "", int32_t(0x00000000), int32_t(0x783276D0)},
    {"access.map", "-", int32_t(0x00000000), int32_t(0x56994528)},
    {"accom1.aud", "mission accomplished", int32_t(0xBF69B3F4), int32_t(0x00000000)},
    {"acdsplt3.aud", "", int32_t(0xF80EE6D3), int32_t(0x00000000)},
    {"acid3.aud", "", int32_t(0xBBA769AF), int32_t(0x00000000)},
    {"acidspew.aud", "", int32_t(0x0404EED9), int32_t(0x00000000)},
    {"ackno.r00", "soviet #1 achnoledged", int32_t(0x99D169D3), int32_t(0x00000000)},
    {"ackno.r01", "soviet #2 achnoledged", int32_t(0x99D169D4), int32_t(0x00000000)},
    {"ackno.r02", "soviet #3 achnoledged", int32_t(0x99D169D5), int32_t(0x00000000)},
    {"ackno.r03", "soviet #4 achnoledged", int32_t(0x99D169D6), int32_t(0x00000000)},
    {"ackno.v00", "c&c #1 achnoledged", int32_t(0x99D969D3), int32_t(0x00000000)},
    {"ackno.v01", "c&c #2 achnoledged", int32_t(0x99D969D4), int32_t(0x00000000)},
    {"ackno.v02", "c&c #3 achnoledged", int32_t(0x99D969D5), int32_t(0x00000000)},
    {"ackno.v03", "c&c #4 achnoledged", int32_t(0x99D969D6), int32_t(0x00000000)},
    {"acmtbg.shp", "", int32_t(0x00000000), int32_t(0x0B6F740C)},
    {"acmtbg2.shp", "", int32_t(0x00000000), int32_t(0x8297170A)},
    {"acmtmd.shp", "", int32_t(0x00000000), int32_t(0xE3A77C3D)},
    {"acmtmd2.shp", "", int32_t(0x00000000), int32_t(0x6A5F1F3B)},
    {"acmtsm.shp", "", int32_t(0x00000000), int32_t(0x1F0E1AF7)},
    {"acmtsm2.shp", "", int32_t(0x00000000), int32_t(0x96F679F1)},
    {"acrate.shp", "", int32_t(0xABA5E7F5), int32_t(0x00000000)},
    {"acrdt.shp", "", int32_t(0x00000000), int32_t(0x164EF979)},
    {"acrdt2.shp", "", int32_t(0x00000000), int32_t(0x758E2B38)},
    {"acrop.vqp", "", int32_t(0xDFF569F5), int32_t(0x00000000)},
    {"actions.csv", "", int32_t(0x824DFCE6), int32_t(0x00000000)},
    {"actors.tre", "", int32_t(0xE5ADF8FB), int32_t(0x00000000)},
    {"actors.trf", "", int32_t(0xE5ADF9FB), int32_t(0x00000000)},
    {"actors.trg", "", int32_t(0xE5ADFAFB), int32_t(0x00000000)},
    {"actors.tri", "", int32_t(0xE5ADFCFB), int32_t(0x00000000)},
    {"actors.trs", "", int32_t(0xE5AE06FB), int32_t(0x00000000)},
    {"addon.shp", "-", int32_t(0x00000000), int32_t(0x7AEBAE6B)},
    {"adog.shp", "", int32_t(0x00000000), int32_t(0x5950AC8D)},
    {"adogicon.shp", "", int32_t(0x00000000), int32_t(0x44E051D0)},
    {"adogp.shp", "", int32_t(0x00000000), int32_t(0x50E2D49D)},
    {"adoguico.shp", "", int32_t(0x00000000), int32_t(0x8126C331)},
    {"aegis.hva", "", int32_t(0x00000000), int32_t(0xA3FB7F7B)},
    {"aegis.vxl", "", int32_t(0x00000000), int32_t(0x1C6278DC)},
    {"aengicon.shp", "", int32_t(0x00000000), int32_t(0x6AACE52E)},
    {"aenguico.shp", "", int32_t(0x00000000), int32_t(0xAF6A77CF)},
    {"afallen1.aud", "allied forces have fallen", int32_t(0xD7F6E4CB), int32_t(0x00000000)},
    {"affirm1.r00", "soviet #1 affirmative", int32_t(0x81ABE3FB), int32_t(0x00000000)},
    {"affirm1.r01", "soviet #2 affirmative", int32_t(0x81ACE3FB), int32_t(0x00000000)},
    {"affirm1.r02", "soviet #3 affirmative", int32_t(0x81ADE3FB), int32_t(0x00000000)},
    {"affirm1.r03", "soviet #4 affirmative", int32_t(0x81AEE3FB), int32_t(0x00000000)},
    {"affirm1.v00", "c&c #1 affirmative", int32_t(0x81ABE3FF), int32_t(0x00000000)},
    {"affirm1.v01", "c&c #2 affirmative", int32_t(0x81ACE3FF), int32_t(0x00000000)},
    {"affirm1.v02", "c&c #3 affirmative", int32_t(0x81ADE3FF), int32_t(0x00000000)},
    {"affirm1.v03", "c&c #4 affirmative", int32_t(0x81AEE3FF), int32_t(0x00000000)},
    {"afld.shp", "airfield", int32_t(0xD8E0DFB0), int32_t(0x00000000)},
    {"afldicnh.des", "icon: airfield", int32_t(0xF512E3C5), int32_t(0x00000000)},
    {"afldicnh.tem", "icon: airfield", int32_t(0xEF12F3C5), int32_t(0x00000000)},
    {"afldicnh.win", "icon: airfield", int32_t(0xF016F6C5), int32_t(0x00000000)},
    {"afldicon.shp", "icon: airfield", int32_t(0xFE17F2C5), int32_t(0x00000000)},
    {"afldmake.shp", "make: airfield", int32_t(0xEC0FEECD), int32_t(0x00000000)},
    {"africa.wsa", "anim: african mission selection", int32_t(0xD3A5DCDE), int32_t(0x00000000)},
    {"aftmath.pkt", "", int32_t(0x92360CD7), int32_t(0x00000000)},
    {"aftr_hi.pcx", "pict: iron curtain destroyed", int32_t(0xA63BED13), int32_t(0x00000000)},
    {"aftr_lo.cps", "pict: iron curtain destroyed", int32_t(0xA6430206), int32_t(0x00000000)},
    {"aftrmath.ini", "inif: aftermath game settings", int32_t(0x2347E4CD), int32_t(0x00000000)},
    {"aftrmath.vqa", "iron curtain destroyed", int32_t(0x1B4AF1CD), int32_t(0x00000000)},
    {"aftrmath.vqp", "vqp: iron curtain destroyed", int32_t(0x2A4AF1CD), int32_t(0x00000000)},
    {"agapgen.shp", "", int32_t(0x00000000), int32_t(0xD60107FD)},
    {"aghq.vqp", "", int32_t(0xF2E1E4B0), int32_t(0x00000000)},
    {"aghqnt.vqp", "", int32_t(0xF17E15F2), int32_t(0x00000000)},
    {"agisicon.shp", "", int32_t(0x00000000), int32_t(0x213054EB)},
    {"agktbg.shp", "", int32_t(0x00000000), int32_t(0xB6A877C9)},
    {"agktbg2.shp", "", int32_t(0x00000000), int32_t(0x3F5014CF)},
    {"agktmd.shp", "", int32_t(0x00000000), int32_t(0x5E607FF8)},
    {"agktmd2.shp", "", int32_t(0x00000000), int32_t(0xD7981CFE)},
    {"agktsm.shp", "", int32_t(0x00000000), int32_t(0xA2C91932)},
    {"agktsm2.shp", "", int32_t(0x00000000), int32_t(0x2B317A34)},
    {"agun.shp", "bldg: aa gun", int32_t(0xECF2E1B0), int32_t(0x00000000)},
    {"agunicon.shp", "icon: aa gun", int32_t(0x263BF6C5), int32_t(0x00000000)},
    {"agunmake.shp", "make: aa gun", int32_t(0x1433F2CD), int32_t(0x00000000)},
    {"ahrvicon.shp", "", int32_t(0x00000000), int32_t(0x27119F7D)},
    {"ahrvuico.shp", "", int32_t(0x00000000), int32_t(0xE2D70D9C)},
    {"ai.ini", "ts ai settings", int32_t(0x00000000), int32_t(0x9E11E49A)},
    {"aifs.ini", "fs ai settings", int32_t(0x00000000), int32_t(0xA9688427)},
    {"aimd.ini", "", int32_t(0x00000000), int32_t(0x116F3F76)},
    {"airfield.vqa", "yak squadren", int32_t(0xE33305C5), int32_t(0x00000000)},
    {"airfield.vqp", "vqp: yak squadren", int32_t(0xF23305C5), int32_t(0x00000000)},
    {"airredy1.aud", "airstrike ready", int32_t(0xF050EEBD), int32_t(0x00000000)},
    {"airstrik.aud", "air strike", int32_t(0x28310ADB), int32_t(0x00000000)},
    {"airstrk.vqa", "guys spotting enemy base for planes", int32_t(0xAA211B03), int32_t(0x00000000)},
    {"airstrk.vqp", "guys spotting enemy base for planes", int32_t(0xAA301B03), int32_t(0x00000000)},
    {"akira.vqa", "nod base being ion cannoned", int32_t(0xEBD189C8), int32_t(0x00000000)},
    {"akira.vqp", "nod base being ion cannoned", int32_t(0xEBD189D7), int32_t(0x00000000)},
    {"alaunch1.aud", "a-bomb launch detected", int32_t(0xFBEAF8CF), int32_t(0x00000000)},
    {"albr55w.tff", "", int32_t(0xA5FDE1C3), int32_t(0x00000000)},
    {"ali-tran.wsa", "anim: allies score screen", int32_t(0x92FB2CDB), int32_t(0x00000000)},
    {"alias.vqa", "", int32_t(0xA7D18DEC), int32_t(0x00000000)},
    {"alibackh.pcx", "pict: allies score screen picture", int32_t(0xF1FF07B5), int32_t(0x00000000)},
    {"alipaper.cps", "pict: allies logo", int32_t(0x390014B5), int32_t(0x00000000)},
    {"alipaper.pcx", "pict: allies logo", int32_t(0x3DF321B5), int32_t(0x00000000)},
    {"all.inf", "inf: filenames and descriptions", int32_t(0x5CDEE6CB), int32_t(0x00000000)},
    {"all.shp", "", int32_t(0x00000000), int32_t(0x815629BF)},
    {"all01t.map", "", int32_t(0x00000000), int32_t(0xD937F5B1)},
    {"all01umd.map", "", int32_t(0x00000000), int32_t(0x3A6F0AC2)},
    {"all02s.map", "", int32_t(0x00000000), int32_t(0x921FCCDC)},
    {"all02umd.map", "", int32_t(0x00000000), int32_t(0xB4E00D21)},
    {"all03u.map", "", int32_t(0x00000000), int32_t(0x3D65F978)},
    {"all03umd.map", "", int32_t(0x00000000), int32_t(0x784A0DBF)},
    {"all04dmd.map", "", int32_t(0x00000000), int32_t(0xB32693DC)},
    {"all04u.map", "", int32_t(0x00000000), int32_t(0x37A0F061)},
    {"all05s.map", "", int32_t(0x00000000), int32_t(0x98DAC5C5)},
    {"all05umd.map", "", int32_t(0x00000000), int32_t(0xBE250438)},
    {"all06u.map", "", int32_t(0x00000000), int32_t(0x7585F71C)},
    {"all06umd.map", "", int32_t(0x00000000), int32_t(0x30AA03DB)},
    {"all07smd.map", "", int32_t(0x00000000), int32_t(0x9FD0367F)},
    {"all07t.map", "", int32_t(0x00000000), int32_t(0x1F58FC36)},
    {"all08u.map", "", int32_t(0x00000000), int32_t(0x600FE52E)},
    {"all09t.map", "", int32_t(0x00000000), int32_t(0x0AD2EE04)},
    {"all10s.map", "", int32_t(0x00000000), int32_t(0xC741DFE2)},
    {"all11t.map", "", int32_t(0x00000000), int32_t(0xCE4CE1F2)},
    {"all12s.map", "", int32_t(0x00000000), int32_t(0x8564D89F)},
    {"alliedlogo.shp", "", int32_t(0x00000000), int32_t(0x52286836)},
    {"alliedmcv.bmp", "", int32_t(0x00000000), int32_t(0x05DAFC4D)},
    {"alliedtanksrussia.bmp", "", int32_t(0x00000000), int32_t(0x51864A7B)},
    {"allies.mix", "allies.mix", int32_t(0xBF8E2FD8), int32_t(0x00000000)},
    {"ally1.vqa", "get einstien", int32_t(0x07DD8DA7), int32_t(0x00000000)},
    {"ally1.vqp", "vqp: get einstien", int32_t(0x07DD8DB6), int32_t(0x00000000)},
    {"ally10.vqa", "stop nukes", int32_t(0x118DD2B7), int32_t(0x00000000)},
    {"ally10.vqp", "vqp: stop nukes", int32_t(0x118DE1B7), int32_t(0x00000000)},
    {"ally10b.vqa", "deactivate launch terminals", int32_t(0xC1F6E2BD), int32_t(0x00000000)},
    {"ally10b.vqp", "vqp: deactivate launch terminals", int32_t(0xC205E2BD), int32_t(0x00000000)},
    {"ally11.vqa", "clear the river", int32_t(0x118DD4B7), int32_t(0x00000000)},
    {"ally11.vqp", "vqp: clear the river", int32_t(0x118DE3B7), int32_t(0x00000000)},
    {"ally12.vqa", "infiltrate tech centers", int32_t(0x118DD6B7), int32_t(0x00000000)},
    {"ally12.vqp", "vqp: infiltrate tech centers", int32_t(0x118DE5B7), int32_t(0x00000000)},
    {"ally14.vqa", "final assult on moscow", int32_t(0x118DDAB7), int32_t(0x00000000)},
    {"ally14.vqp", "vqp: final assult on moscow", int32_t(0x118DE9B7), int32_t(0x00000000)},
    {"ally2.vqa", "clear the way for the convoy", int32_t(0x07DD8DA9), int32_t(0x00000000)},
    {"ally2.vqp", "vqp: clear the way for the convoy", int32_t(0x07DD8DB8), int32_t(0x00000000)},
    {"ally4.vqa", "close the mountain pass", int32_t(0x07DD8DAD), int32_t(0x00000000)},
    {"ally4.vqp", "vqp: close the mountain pass", int32_t(0x07DD8DBC), int32_t(0x00000000)},
    {"ally5.vqa", "rescue tanya", int32_t(0x07DD8DAF), int32_t(0x00000000)},
    {"ally5.vqp", "vqp: rescue tanya", int32_t(0x07DD8DBE), int32_t(0x00000000)},
    {"ally6.vqa", "find the iron curtain", int32_t(0x07DD8DB1), int32_t(0x00000000)},
    {"ally6.vqp", "vqp: find the iron curtain", int32_t(0x07DD8DC0), int32_t(0x00000000)},
    {"ally8.vqa", "protect the tech centre", int32_t(0x07DD8DB5), int32_t(0x00000000)},
    {"ally8.vqp", "vqp: protect the tech centre", int32_t(0x07DD8DC4), int32_t(0x00000000)},
    {"ally9.vqa", "rescue kosygin", int32_t(0x07DD8DB7), int32_t(0x00000000)},
    {"ally9.vqp", "vqp: rescue kosygin", int32_t(0x07DD8DC6), int32_t(0x00000000)},
    {"allyend.vqa", "stalin is dead", int32_t(0xC1FB1EE5), int32_t(0x00000000)},
    {"allyend.vqp", "vqp: stalin is dead", int32_t(0xC20A1EE5), int32_t(0x00000000)},
    {"allymorf.vqa", "allied logo", int32_t(0x332725CD), int32_t(0x00000000)},
    {"allymorf.vqp", "vqp: allied logo", int32_t(0x422725CD), int32_t(0x00000000)},
    {"aloadlg.pcx", "", int32_t(0x00000000), int32_t(0xBA733FC7)},
    {"aloadmd.pcx", "", int32_t(0x00000000), int32_t(0x9A9046DD)},
    {"aloadsm.pcx", "", int32_t(0x00000000), int32_t(0x8A7EF086)},
    {"alogo.pal", "", int32_t(0x00000000), int32_t(0x2C87EFB5)},
    {"alphatst.shp", "-", int32_t(0x00000000), int32_t(0xD8E75117)},
    {"aly1-lo.cps", "pict: allies first briefing", int32_t(0x225719A2), int32_t(0x00000000)},
    {"aly1.pcx", "pict: allies first briefing", int32_t(0xBAF5E8B0), int32_t(0x00000000)},
    {"amanimation_s.bik", "", int32_t(0x00000000), int32_t(0x954FD886)},
    {"amazon01.map", "", int32_t(0x00000000), int32_t(0x9DDF6FBE)},
    {"ambloop2.aud", "", int32_t(0xD9FF14D1), int32_t(0x00000000)},
    {"ambttn.shp", "", int32_t(0x00000000), int32_t(0x875E79F8)},
    {"ambu.hva", "", int32_t(0x00000000), int32_t(0xC4F46DDE)},
    {"ambu.vxl", "", int32_t(0x00000000), int32_t(0x327EB297)},
    {"ambylop1.aud", "", int32_t(0x0BFF14CB), int32_t(0x00000000)},
    {"ambylop2.aud", "", int32_t(0x0DFF14CB), int32_t(0x00000000)},
    {"ambylop3.aud", "", int32_t(0x0FFF14CB), int32_t(0x00000000)},
    {"ambylop4.aud", "", int32_t(0x11FF14CB), int32_t(0x00000000)},
    {"ambylop5.aud", "", int32_t(0x13FF14CB), int32_t(0x00000000)},
    {"amer_clikmap_tempb.pcx", "", int32_t(0x00000000), int32_t(0x6E594793)},
    {"amerclick1.pcx", "-", int32_t(0x00000000), int32_t(0xA130E2CA)},
    {"america_worlddom_b.pcx", "", int32_t(0x00000000), int32_t(0x89E1C5F0)},
    {"ammo01.shp", "-", int32_t(0x00000000), int32_t(0x1641F05A)},
    {"amterr00.shp", "", int32_t(0x00000000), int32_t(0x92FB6671)},
    {"amterr01.shp", "", int32_t(0x00000000), int32_t(0xAF9B4FC1)},
    {"amterr02.shp", "", int32_t(0x00000000), int32_t(0xE83B3511)},
    {"amterr03.shp", "", int32_t(0x00000000), int32_t(0xD55B1CA1)},
    {"amterr04.shp", "", int32_t(0x00000000), int32_t(0x677BC0B1)},
    {"amterr05.shp", "", int32_t(0x00000000), int32_t(0x5A1BE901)},
    {"amterr06.shp", "", int32_t(0x00000000), int32_t(0x1DBB93D1)},
    {"amterr07.shp", "", int32_t(0x00000000), int32_t(0x20DBBA61)},
    {"amterr08.shp", "", int32_t(0x00000000), int32_t(0xA28B2DB0)},
    {"amterr09.shp", "", int32_t(0x00000000), int32_t(0x9FEB0400)},
    {"amterr10.shp", "", int32_t(0x00000000), int32_t(0x59A7B5D4)},
    {"amterr11.shp", "", int32_t(0x00000000), int32_t(0x64C79C64)},
    {"amterr12.shp", "", int32_t(0x00000000), int32_t(0x2367E6B4)},
    {"amterr13.shp", "", int32_t(0x00000000), int32_t(0x1E07CF04)},
    {"amterr14.shp", "", int32_t(0x00000000), int32_t(0xAC271314)},
    {"amterr15.shp", "", int32_t(0x00000000), int32_t(0x91473AA4)},
    {"amterr16.shp", "", int32_t(0x00000000), int32_t(0xD6E74074)},
    {"amterr17.shp", "", int32_t(0x00000000), int32_t(0xEB8769C4)},
    {"amterr18.shp", "", int32_t(0x00000000), int32_t(0x69D7FE15)},
    {"amterr19.shp", "", int32_t(0x00000000), int32_t(0x54B7D7A5)},
    {"amterr20.shp", "", int32_t(0x00000000), int32_t(0xDF33C77A)},
    {"amterr21.shp", "", int32_t(0x00000000), int32_t(0xE253EECA)},
    {"amterr22.shp", "", int32_t(0x00000000), int32_t(0xA5F3941A)},
    {"amterr23.shp", "", int32_t(0x00000000), int32_t(0x9893BDAA)},
    {"amterr24.shp", "", int32_t(0x00000000), int32_t(0x2AB361BA)},
    {"amterr25.shp", "", int32_t(0x00000000), int32_t(0x17D3480A)},
    {"amterr26.shp", "", int32_t(0x00000000), int32_t(0x507332DA)},
    {"amterr27.shp", "", int32_t(0x00000000), int32_t(0x6D131B6A)},
    {"amterr28.shp", "", int32_t(0x00000000), int32_t(0xEF438CBB)},
    {"amterr29.shp", "", int32_t(0x00000000), int32_t(0xD223A50B)},
    {"ancient.flc", "", int32_t(0x81F921D5), int32_t(0x00000000)},
    {"and3.aud", "", int32_t(0xAADDDDB0), int32_t(0x00000000)},
    {"anim.pal", "animations palette", int32_t(0x00000000), int32_t(0xA64C5120)},
    {"anim0001.wsa", "anim: welcome to the eva install program", int32_t(0xD8D8F093), int32_t(0x00000000)},
    {"anim0002.wsa", "anim: mouth moving", int32_t(0xDAD8F093), int32_t(0x00000000)},
    {"anim0006.wsa", "anim: animated window bits", int32_t(0xE2D8F093), int32_t(0x00000000)},
    {"anim01.wsa", "anim: welcome to the eva install program covert ops", int32_t(0xE381DCB8), int32_t(0x00000000)},
    {"animal1.aud", "", int32_t(0x91CC26C8), int32_t(0x00000000)},
    {"animal2.aud", "", int32_t(0x91CE26C8), int32_t(0x00000000)},
    {"anmagic.aud", "", int32_t(0x620020D4), int32_t(0x00000000)},
    {"anstone4.aud", "", int32_t(0xFE2D16D1), int32_t(0x00000000)},
    {"ant1.shp", "unit: ant #1", int32_t(0xB2F0EFB0), int32_t(0x00000000)},
    {"ant2.shp", "unit: ant #2", int32_t(0xB4F0EFB0), int32_t(0x00000000)},
    {"ant3.shp", "unit: ant #3", int32_t(0xB6F0EFB0), int32_t(0x00000000)},
    {"antbite.aud", "ant bite", int32_t(0x662036D8), int32_t(0x00000000)},
    {"antdie.aud", "ant die", int32_t(0x93AE07EC), int32_t(0x00000000)},
    {"antdie.shp", "misc: ant death", int32_t(0xB7AE13DF), int32_t(0x00000000)},
    {"antend.vqa", "queen ant dying in fire", int32_t(0xC1AE02F2), int32_t(0x00000000)},
    {"antend.vqp", "vqp: queen ant dying in fire", int32_t(0xC1AE11F2), int32_t(0x00000000)},
    {"antintro.vqa", "it came from red alert", int32_t(0x054737CF), int32_t(0x00000000)},
    {"antintro.vqp", "vqp: it came from red alert", int32_t(0x144737CF), int32_t(0x00000000)},
    {"ants.vqa", "", int32_t(0xE7F9F2B0), int32_t(0x00000000)},
    {"anvil1.aud", "", int32_t(0xA7B5DFF2), int32_t(0x00000000)},
    {"anvil2.aud", "", int32_t(0xA7B5E1F2), int32_t(0x00000000)},
    {"anvil3.aud", "", int32_t(0xA7B5E3F2), int32_t(0x00000000)},
    {"aoi.aud", "act on instinct", int32_t(0x5CD6F3C3), int32_t(0x00000000)},
    {"aoi.var", "act on instinct sfx", int32_t(0x5CE4DFD8), int32_t(0x00000000)},
    {"apache.hva", "-", int32_t(0x00000000), int32_t(0xA8A4660A)},
    {"apache.vqa", "", int32_t(0xB9620CE6), int32_t(0x00000000)},
    {"apache.vqp", "", int32_t(0xB9621BE6), int32_t(0x00000000)},
    {"apache.vxl", "harpy", int32_t(0x00000000), int32_t(0x78CB868E)},
    {"apachebarl.hva", "-", int32_t(0x00000000), int32_t(0x129E2A26)},
    {"apachetur.hva", "-", int32_t(0x00000000), int32_t(0x31852B7B)},
    {"apain1.aud", "", int32_t(0xA761E7F6), int32_t(0x00000000)},
    {"apain2.aud", "", int32_t(0xA761E9F6), int32_t(0x00000000)},
    {"apain3.aud", "", int32_t(0xA761EBF6), int32_t(0x00000000)},
    {"apain4.aud", "", int32_t(0xA761EDF6), int32_t(0x00000000)},
    {"apain5.aud", "", int32_t(0xA761EFF6), int32_t(0x00000000)},
    {"apain6.aud", "", int32_t(0xA761F1F6), int32_t(0x00000000)},
    {"apain7.aud", "", int32_t(0xA761F3F6), int32_t(0x00000000)},
    {"aparicon.shp", "", int32_t(0x00000000), int32_t(0xA251D114)},
    {"apc.hva", "-", int32_t(0x00000000), int32_t(0x12071024)},
    {"apc.shp", "apc", int32_t(0x5CD6E8D5), int32_t(0x00000000)},
    {"apc.vxl", "amphibious apc", int32_t(0x00000000), int32_t(0x1DF163CF)},
    {"apc_hi.pcx", "pict: apc running away", int32_t(0x1D6A2BD7), int32_t(0x00000000)},
    {"apc_lo.cps", "pict: apc running away", int32_t(0x036A32EC), int32_t(0x00000000)},
    {"apcescpe.vqa", "apc running away", int32_t(0xE0FF1DD9), int32_t(0x00000000)},
    {"apcescpe.vqp", "vqp: apc running away", int32_t(0xEFFF1DD9), int32_t(0x00000000)},
    {"apchicon.shp", "icon: harpy", int32_t(0x00000000), int32_t(0x9F4AC9C6)},
    {"apcicnh.des", "icon: apc", int32_t(0x81F122CF), int32_t(0x00000000)},
    {"apcicnh.tem", "icon: apc", int32_t(0x81EB22DF), int32_t(0x00000000)},
    {"apcicnh.win", "icon: apc", int32_t(0x81EC26E2), int32_t(0x00000000)},
    {"apcicon.shp", "icon: apc", int32_t(0x81FA27DE), int32_t(0x7560A316)},
    {"apcw.hva", "-", int32_t(0x00000000), int32_t(0x73611015)},
    {"apcw.vxl", "amphibious apc in water", int32_t(0x00000000), int32_t(0x85EBCF5C)},
    {"apeatk1.aud", "", int32_t(0x61BC2CEE), int32_t(0x00000000)},
    {"apedie1.aud", "", int32_t(0x6DBC20D8), int32_t(0x00000000)},
    {"apehurt1.aud", "", int32_t(0xC81326DD), int32_t(0x00000000)},
    {"apehurt2.aud", "", int32_t(0xCA1326DD), int32_t(0x00000000)},
    {"apeloit1.aud", "", int32_t(0xD81314D1), int32_t(0x00000000)},
    {"apeloit2.aud", "", int32_t(0xDA1314D1), int32_t(0x00000000)},
    {"aphi0049.pcx", "pict: helicopters", int32_t(0xEFCCF193), int32_t(0x00000000)},
    {"aplo0049.cps", "pict: helicpoters", int32_t(0x02E9E493), int32_t(0x00000000)},
    {"apmuzzle.shp", "", int32_t(0x00000000), int32_t(0x2D3AF039)},
    {"apocexp.shp", "", int32_t(0x00000000), int32_t(0xA7B8012A)},
    {"appear1.aud", "???", int32_t(0x71E83AC8), int32_t(0x00000000)},
    {"appr.vqa", "", int32_t(0xE5F1F6B0), int32_t(0x00000000)},
    {"approach.aud", "approach", int32_t(0x00000000), int32_t(0x395BD9C8)},
    {"aprep1.aud", "a-bomb preping", int32_t(0x97A5E7FA), int32_t(0x00000000)},
    {"aprtamb5.aud", "", int32_t(0x00231CB5), int32_t(0x00000000)},
    {"aprtfan1.aud", "", int32_t(0xF83B04BF), int32_t(0x00000000)},
    {"apwr.shp", "bldg: advanced powerplant", int32_t(0xF4F6F3B0), int32_t(0x00000000)},
    {"apwricon.shp", "icon: advanced powerplant", int32_t(0x36441AC5), int32_t(0x88E120BB)},
    {"apwrmake.shp", "make: advaced powerplant", int32_t(0x243C16CD), int32_t(0x00000000)},
    {"ar01-min.set", "", int32_t(0xB599368D), int32_t(0x00000000)},
    {"ar01.vqa", "", int32_t(0xA3B1FAB0), int32_t(0x00000000)},
    {"ar01_0.vqa", "", int32_t(0x711DEB14), int32_t(0x00000000)},
    {"ar01_1.vqa", "", int32_t(0x711DED14), int32_t(0x00000000)},
    {"ar01_2.vqa", "", int32_t(0x711DEF14), int32_t(0x00000000)},
    {"ar01_3.vqa", "", int32_t(0x711DF114), int32_t(0x00000000)},
    {"ar02-min.set", "", int32_t(0xB999368D), int32_t(0x00000000)},
    {"ar02.vqa", "", int32_t(0xA5B1FAB0), int32_t(0x00000000)},
    {"ar02_0.vqa", "", int32_t(0x751DEB14), int32_t(0x00000000)},
    {"ar02_1.vqa", "", int32_t(0x751DED14), int32_t(0x00000000)},
    {"ar02_2.vqa", "", int32_t(0x751DEF14), int32_t(0x00000000)},
    {"ar02_3.vqa", "", int32_t(0x751DF114), int32_t(0x00000000)},
    {"arabloop.aud", "", int32_t(0xEDF928CB), int32_t(0x00000000)},
    {"araziod.aud", "arazoid", int32_t(0xC5D23CD8), int32_t(0x00000000)},
    {"arbi.pcx", "", int32_t(0x00000000), int32_t(0xB1994766)},
    {"arbi.shp", "", int32_t(0x00000000), int32_t(0x5EF0A8C6)},
    {"arcbed1.aud", "", int32_t(0x65B426D0), int32_t(0x00000000)},
    {"arco.shp", "arcology", int32_t(0xEECEF7B0), int32_t(0x00000000)},
    {"arcoicon.shp", "icon: arcology", int32_t(0x29F422C5), int32_t(0x00000000)},
    {"ardrt.shp", "", int32_t(0x00000000), int32_t(0x8C5C2826)},
    {"ardrt2.shp", "", int32_t(0x00000000), int32_t(0xEF9CFA67)},
    {"aready1.aud", "a-bomb ready", int32_t(0x61BC50CE), int32_t(0x00000000)},
    {"arena33forever.map", "", int32_t(0x00000000), int32_t(0x8F47A888)},
    {"arenaapr.csv", "", int32_t(0x34090EB5), int32_t(0x00000000)},
    {"arenaapr.lsv", "", int32_t(0x340917B5), int32_t(0x00000000)},
    {"arenaapr.vqa", "", int32_t(0x1F0721B5), int32_t(0x00000000)},
    {"arenaapr_e.vqa", "", int32_t(0x67C8631D), int32_t(0x00000000)},
    {"arenaapr_e.vqt", "", int32_t(0x67C8761D), int32_t(0x00000000)},
    {"arenaapr_h.pcx", "", int32_t(0x5BC8800F), int32_t(0x00000000)},
    {"arenaapr_h.vqa", "", int32_t(0x67C8691D), int32_t(0x00000000)},
    {"arenaapr_l.pcx", "", int32_t(0x5BC8880F), int32_t(0x00000000)},
    {"arenaapr_l.vqa", "", int32_t(0x67C8711D), int32_t(0x00000000)},
    {"arenbat1.aud", "", int32_t(0xE0130CB7), int32_t(0x00000000)},
    {"arial.ttf", "", int32_t(0xADCDA5E3), int32_t(0x00000000)},
    {"arivruns.ini", "", int32_t(0x00000000), int32_t(0xE17554D2)},
    {"arivruns.map", "-", int32_t(0x00000000), int32_t(0x058F4801)},
    {"ariz01.des", "", int32_t(0x00000000), int32_t(0x98AE36B8)},
    {"ariz01.tem", "", int32_t(0x00000000), int32_t(0xEEF62F40)},
    {"arkdfly1.aud", "", int32_t(0xB83522BF), int32_t(0x00000000)},
    {"arkdnce1.aud", "", int32_t(0xB80D10CF), int32_t(0x00000000)},
    {"armor.shp", "crat: unit armor upgrade", int32_t(0xCDDBA5F9), int32_t(0xEBA9AF4D)},
    {"armord.shp", "", int32_t(0xE39221F1), int32_t(0x00000000)},
    {"armorup1.aud", "unit armour upgraded", int32_t(0xE42B34D7), int32_t(0x00000000)},
    {"arnd.shp", "", int32_t(0x00000000), int32_t(0xD1A2AC0C)},
    {"aroachb1.aud", "", int32_t(0xAC171AB9), int32_t(0x00000000)},
    {"arro0001.int", "red stripe on green", int32_t(0xF3F7F293), int32_t(0x00000000)},
    {"arro0002.int", "red stripe on green", int32_t(0xF5F7F293), int32_t(0x00000000)},
    {"arro0003.int", "red stripe on green", int32_t(0xF7F7F293), int32_t(0x00000000)},
    {"arro0004.int", "red stripe on green", int32_t(0xF9F7F293), int32_t(0x00000000)},
    {"arro0005.int", "red stripe on green", int32_t(0xFBF7F293), int32_t(0x00000000)},
    {"arro0006.int", "red stripe on green", int32_t(0xFDF7F293), int32_t(0x00000000)},
    {"arro0007.int", "red stripe on green", int32_t(0xFFF7F293), int32_t(0x00000000)},
    {"arro0008.int", "red stripe on green", int32_t(0x01F7F293), int32_t(0x00000000)},
    {"arro0009.int", "red stripe on green", int32_t(0x03F7F293), int32_t(0x00000000)},
    {"arro0010.int", "red stripe on green", int32_t(0xF1F9F293), int32_t(0x00000000)},
    {"arro0011.int", "red stripe on green", int32_t(0xF3F9F293), int32_t(0x00000000)},
    {"arro0012.int", "red stripe on green", int32_t(0xF5F9F293), int32_t(0x00000000)},
    {"arro0013.int", "red stripe on green", int32_t(0xF7F9F293), int32_t(0x00000000)},
    {"arro0014.int", "red stripe on green", int32_t(0xF9F9F293), int32_t(0x00000000)},
    {"arro0015.int", "red stripe on green", int32_t(0xFBF9F293), int32_t(0x00000000)},
    {"arrow.shp", "-", int32_t(0x00000000), int32_t(0x75EC7B4C)},
    {"arrow4.aud", "", int32_t(0xBFA5F608), int32_t(0x00000000)},
    {"arrow7.aud", "", int32_t(0xBFA5FC08), int32_t(0x00000000)},
    {"arrow8.aud", "", int32_t(0xBFA5FE08), int32_t(0x00000000)},
    {"arrow_dd.pcx", "-", int32_t(0x00000000), int32_t(0x6D7A2579)},
    {"arrow_du.pcx", "-", int32_t(0x00000000), int32_t(0x30FA9B4B)},
    {"arrow_ud.pcx", "-", int32_t(0x00000000), int32_t(0xA5F0F447)},
    {"arrow_uu.pcx", "-", int32_t(0x00000000), int32_t(0xF8704A75)},
    {"arrowby1.aud", "", int32_t(0xE4510EE1), int32_t(0x00000000)},
    {"arrowby2.aud", "", int32_t(0xE6510EE1), int32_t(0x00000000)},
    {"arrowby3.aud", "", int32_t(0xE8510EE1), int32_t(0x00000000)},
    {"arrowby4.aud", "", int32_t(0xEA510EE1), int32_t(0x00000000)},
    {"arrowby5.aud", "", int32_t(0xEC510EE1), int32_t(0x00000000)},
    {"arrwdest.shp", "", int32_t(0x00000000), int32_t(0xDAA27A59)},
    {"arrwe.shp", "", int32_t(0x00000000), int32_t(0x5C6AAD73)},
    {"arrwn.shp", "", int32_t(0x00000000), int32_t(0x0100B125)},
    {"arrwne.shp", "", int32_t(0x00000000), int32_t(0x4B0F8DC1)},
    {"arrwnw.shp", "", int32_t(0x00000000), int32_t(0xBB4E0026)},
    {"arrws.shp", "", int32_t(0x00000000), int32_t(0xE6BE95DF)},
    {"arrwse.shp", "", int32_t(0x00000000), int32_t(0xACB1A93B)},
    {"arrwsw.shp", "", int32_t(0x00000000), int32_t(0x5CF024DC)},
    {"arrww.shp", "", int32_t(0x00000000), int32_t(0x62F49B25)},
    {"art-exp1.shp", "explosion", int32_t(0x683A4CBD), int32_t(0x00000000)},
    {"art.ini", "ts graphic settings", int32_t(0x00000000), int32_t(0xF91B2C8B)},
    {"art2.hva", "-", int32_t(0x00000000), int32_t(0xABFFCB22)},
    {"art2.vxl", "deployable artillery", int32_t(0x00000000), int32_t(0x5D75146B)},
    {"art2barl.hva", "-", int32_t(0x00000000), int32_t(0xC626BF3B)},
    {"art2barl.vxl", "deployable artillery barrel", int32_t(0x00000000), int32_t(0x30AC6072)},
    {"art2tur.hva", "-", int32_t(0x00000000), int32_t(0x993599E8)},
    {"art2tur.vxl", "deployable artillery turret", int32_t(0x00000000), int32_t(0x96C3EA03)},
    {"artfs.ini", "fs graphic settings", int32_t(0x00000000), int32_t(0xAF6C7E3A)},
    {"artmd.ini", "", int32_t(0x00000000), int32_t(0x5B47D8D5)},
    {"arty.hva", "-", int32_t(0x00000000), int32_t(0x451D8D7E)},
    {"arty.shp", "artillery", int32_t(0x02F0F7B0), int32_t(0x00000000)},
    {"arty.vxl", "artillery", int32_t(0x00000000), int32_t(0xB3975237)},
    {"artybarl.hva", "-", int32_t(0x00000000), int32_t(0x1810A042)},
    {"artybarl.vxl", "artillery", int32_t(0x00000000), int32_t(0xEE9A7F0B)},
    {"artyicnh.des", "icon: artillery", int32_t(0x493313C5), int32_t(0x00000000)},
    {"artyicnh.tem", "icon: artillery", int32_t(0x433323C5), int32_t(0x00000000)},
    {"artyicnh.win", "icon: artillery", int32_t(0x443726C5), int32_t(0x00000000)},
    {"artyicon.shp", "icon: artillery", int32_t(0x523822C4), int32_t(0xB9EFBCA4)},
    {"asanimation_s.bik", "", int32_t(0x00000000), int32_t(0x1270F51A)},
    {"asaticon.shp", "", int32_t(0x00000000), int32_t(0x48A9CE9F)},
    {"ascent_e.vqa", "", int32_t(0xE11D4BCF), int32_t(0x00000000)},
    {"ascore.pal", "", int32_t(0x00000000), int32_t(0x28A9AB30)},
    {"ascramd.shp", "", int32_t(0x00000000), int32_t(0xB6362C89)},
    {"ascrasm.shp", "", int32_t(0x00000000), int32_t(0xA6D89AD2)},
    {"ascrbkmd.shp", "", int32_t(0x00000000), int32_t(0x56BB8CB3)},
    {"ascrbksm.shp", "", int32_t(0x00000000), int32_t(0x62778D29)},
    {"ascrtmd.shp", "", int32_t(0x00000000), int32_t(0x826D13C6)},
    {"ascrtsm.shp", "", int32_t(0x00000000), int32_t(0x9283A59D)},
    {"aselect1.aud", "allied forces selected", int32_t(0xD81314BD), int32_t(0x00000000)},
    {"asia_clikmap_tempb.pcx", "", int32_t(0x00000000), int32_t(0x5740D58C)},
    {"asia_worlddom_b.pcx", "", int32_t(0x00000000), int32_t(0xDBB4278A)},
    {"assess.vqa", "allied found iron curtain", int32_t(0xC1AA34FC), int32_t(0x00000000)},
    {"assess.vqp", "vqp: allied found iron curtain", int32_t(0xC1AA43FC), int32_t(0x00000000)},
    {"asterr00.shp", "", int32_t(0x00000000), int32_t(0x6E7B89BC)},
    {"asterr01.shp", "", int32_t(0x00000000), int32_t(0x531BA00C)},
    {"asterr02.shp", "", int32_t(0x00000000), int32_t(0x14BBDADC)},
    {"asterr03.shp", "", int32_t(0x00000000), int32_t(0x29DBF36C)},
    {"asterr04.shp", "", int32_t(0x00000000), int32_t(0x9BFB2F7C)},
    {"asterr05.shp", "", int32_t(0x00000000), int32_t(0xA69B06CC)},
    {"asterr06.shp", "", int32_t(0x00000000), int32_t(0xE13B7C1C)},
    {"asterr07.shp", "", int32_t(0x00000000), int32_t(0xDC5B55AC)},
    {"asterr08.shp", "", int32_t(0x00000000), int32_t(0x5E0BC27D)},
    {"asterr09.shp", "", int32_t(0x00000000), int32_t(0x636BEBCD)},
    {"asterr10.shp", "", int32_t(0x00000000), int32_t(0xA5275A19)},
    {"asterr11.shp", "", int32_t(0x00000000), int32_t(0x984773A9)},
    {"asterr12.shp", "", int32_t(0x00000000), int32_t(0xDFE70979)},
    {"asterr13.shp", "", int32_t(0x00000000), int32_t(0xE28720C9)},
    {"asterr14.shp", "", int32_t(0x00000000), int32_t(0x50A7FCD9)},
    {"asterr15.shp", "", int32_t(0x00000000), int32_t(0x6DC7D569)},
    {"asterr16.shp", "", int32_t(0x00000000), int32_t(0x2A67AFB9)},
    {"asterr17.shp", "", int32_t(0x00000000), int32_t(0x17078609)},
    {"asterr18.shp", "", int32_t(0x00000000), int32_t(0x955711D8)},
    {"asterr19.shp", "", int32_t(0x00000000), int32_t(0xA8373868)},
    {"asterr20.shp", "", int32_t(0x00000000), int32_t(0x23B328B7)},
    {"asterr21.shp", "", int32_t(0x00000000), int32_t(0x1ED30107)},
    {"asterr22.shp", "", int32_t(0x00000000), int32_t(0x59737BD7)},
    {"asterr23.shp", "", int32_t(0x00000000), int32_t(0x64135267)},
    {"asterr24.shp", "", int32_t(0x00000000), int32_t(0xD6338E77)},
    {"asterr25.shp", "", int32_t(0x00000000), int32_t(0xEB53A7C7)},
    {"asterr26.shp", "", int32_t(0x00000000), int32_t(0xACF3DD17)},
    {"asterr27.shp", "", int32_t(0x00000000), int32_t(0x9193F4A7)},
    {"asterr28.shp", "", int32_t(0x00000000), int32_t(0x13C36376)},
    {"asterr29.shp", "", int32_t(0x00000000), int32_t(0x2EA34AC6)},
    {"asw.hva", "", int32_t(0x00000000), int32_t(0xBBA84A34)},
    {"asw.vxl", "", int32_t(0x00000000), int32_t(0xB45E39DF)},
    {"atarget.shp", "", int32_t(0x00000000), int32_t(0x6DAEAC4C)},
    {"atek.shp", "bldg: allied techcenter", int32_t(0xE6D2FBB0), int32_t(0x00000000)},
    {"atekicon.shp", "icon: techcenter", int32_t(0x19FC2AC5), int32_t(0x00000000)},
    {"atekmake.shp", "make: allied tech center", int32_t(0x07F426CD), int32_t(0x00000000)},
    {"atlnch1.aud", "a-bomb launch detcted", int32_t(0x95D836CC), int32_t(0x00000000)},
    {"atomdoor.shp", "nuke firing smoke", int32_t(0x2A2442BB), int32_t(0x00000000)},
    {"atomicdn.shp", "nuke landing", int32_t(0x220E2AC5), int32_t(0x00000000)},
    {"atomicnh.des", "icon: nuclear strike", int32_t(0x191F1BC5), int32_t(0x00000000)},
    {"atomicnh.tem", "icon: nuclear strike", int32_t(0x131F2BC5), int32_t(0x00000000)},
    {"atomicnh.win", "icon: nuclear strike", int32_t(0x14232EC5), int32_t(0x00000000)},
    {"atomicon.shp", "icon: nuclear strike", int32_t(0x22242AC5), int32_t(0x00000000)},
    {"atomicup.shp", "nuke launching", int32_t(0x26302AC5), int32_t(0x00000000)},
    {"atomsfx.shp", "nuclear blast", int32_t(0x923E25FE), int32_t(0x00000000)},
    {"atprep1.aud", "a-bomb preping", int32_t(0xA5E846D0), int32_t(0x00000000)},
    {"attract2.cps", "pict: coming attractions", int32_t(0x014A1AB5), int32_t(0x00000000)},
    {"atwr.shp", "advanced guard tower", int32_t(0xF4F6FBB0), int32_t(0x00000000)},
    {"atwricnh.des", "icon: advanced guard tower", int32_t(0x2D3F1BC5), int32_t(0x00000000)},
    {"atwricnh.tem", "icon: advanced guard tower", int32_t(0x273F2BC5), int32_t(0x00000000)},
    {"atwricnh.win", "icon: advanced guard tower", int32_t(0x28432EC5), int32_t(0x00000000)},
    {"atwricon.shp", "icon: advanced guard tower", int32_t(0x36442AC5), int32_t(0x00000000)},
    {"atwrmake.shp", "make: advanced guard tower", int32_t(0x243C26CD), int32_t(0x00000000)},
    {"aud.aud", "", int32_t(0x5CCCFFC3), int32_t(0x00000000)},
    {"auddirtwlk3.aud", "", int32_t(0xDC1EDF08), int32_t(0x00000000)},
    {"audio.bag", "", int32_t(0x00000000), int32_t(0x2427114C)},
    {"audio.idx", "", int32_t(0x00000000), int32_t(0xCE282A5D)},
    {"audio.mix", "", int32_t(0x00000000), int32_t(0xAD29ACFA)},
    {"audiomd.mix", "", int32_t(0x00000000), int32_t(0xFE9DF3BE)},
    {"audlaff1.aud", "", int32_t(0xD7F322B5), int32_t(0x00000000)},
    {"audlaff2.aud", "", int32_t(0xD9F322B5), int32_t(0x00000000)},
    {"audlaff3.aud", "", int32_t(0xDBF322B5), int32_t(0x00000000)},
    {"audlaff4.aud", "", int32_t(0xDDF322B5), int32_t(0x00000000)},
    {"audlaff5.aud", "", int32_t(0xDFF322B5), int32_t(0x00000000)},
    {"audlaff6.aud", "", int32_t(0xE1F322B5), int32_t(0x00000000)},
    {"audlaff7.aud", "", int32_t(0xE3F322B5), int32_t(0x00000000)},
    {"audlaff8.aud", "", int32_t(0xE5F322B5), int32_t(0x00000000)},
    {"audlaff9.aud", "", int32_t(0xE7F322B5), int32_t(0x00000000)},
    {"audmrblwlk2.aud", "", int32_t(0x23FC9F2B), int32_t(0x00000000)},
    {"audpickup2.aud", "", int32_t(0x59AC6023), int32_t(0x00000000)},
    {"audstonwlk4.aud", "", int32_t(0x5408D333), int32_t(0x00000000)},
    {"aunitl1.aud", "airborne unit lost", int32_t(0x81E042EE), int32_t(0x00000000)},
    {"austintx.map", "", int32_t(0x00000000), int32_t(0xA35B9180)},
    {"autologinquery.pal", "", int32_t(0x00000000), int32_t(0x54EF6ADE)},
    {"autologinquery.shp", "", int32_t(0x00000000), int32_t(0x02A7BD34)},
    {"automap.shp", "", int32_t(0x9A421FF2), int32_t(0x00000000)},
    {"automap.trr", "", int32_t(0x9A4429F3), int32_t(0x00000000)},
    {"autosave.tre", "", int32_t(0x0D502BD9), int32_t(0x00000000)},
    {"autosave.trf", "", int32_t(0x0E502BD9), int32_t(0x00000000)},
    {"autosave.trg", "", int32_t(0x0F502BD9), int32_t(0x00000000)},
    {"autosave.tri", "", int32_t(0x11502BD9), int32_t(0x00000000)},
    {"autosave.trs", "", int32_t(0x1B502BD9), int32_t(0x00000000)},
    {"averted.vqa", "meltdown averted", int32_t(0xA5DF3503), int32_t(0x00000000)},
    {"averted.vqp", "vqp: meltdown averted", int32_t(0xA5EE3503), int32_t(0x00000000)},
    {"await.aud", "afterlife", int32_t(0xCF87B9F1), int32_t(0x00000000)},
    {"await1.r00", "soviet #1 waiting orders", int32_t(0xC961EFDD), int32_t(0x00000000)},
    {"await1.r01", "soviet #2 waiting orders", int32_t(0xC961F0DD), int32_t(0x00000000)},
    {"await1.r02", "soviet #3 waiting orders", int32_t(0xC961F1DD), int32_t(0x00000000)},
    {"await1.r03", "soviet #4 waiting orders", int32_t(0xC961F2DD), int32_t(0x00000000)},
    {"await1.v00", "c&c #1 waiting orders", int32_t(0xD161EFDD), int32_t(0x00000000)},
    {"await1.v01", "c&c #2 waiting orders", int32_t(0xD161F0DD), int32_t(0x00000000)},
    {"await1.v02", "c&c #3 waiting orders", int32_t(0xD161F1DD), int32_t(0x00000000)},
    {"await1.v03", "c&c #4 waiting orders", int32_t(0xD161F2DD), int32_t(0x00000000)},
    {"await_r.aud", "afterlife", int32_t(0x81EE70EE), int32_t(0x00000000)},
    {"away01_e.vqa", "", int32_t(0x31151593), int32_t(0x00000000)},
    {"away02_e.vqa", "", int32_t(0x31151793), int32_t(0x00000000)},
    {"axewood1.aud", "", int32_t(0x03F340D1), int32_t(0x00000000)},
    {"axewood2.aud", "", int32_t(0x05F340D1), int32_t(0x00000000)},
    {"axewood3.aud", "", int32_t(0x07F340D1), int32_t(0x00000000)},
    {"axewood4.aud", "", int32_t(0x09F340D1), int32_t(0x00000000)},
    {"axle.hva", "-", int32_t(0x00000000), int32_t(0xABF82845)},
    {"axle.vxl", "-", int32_t(0x00000000), int32_t(0x5D72F70C)},
    {"ayaricon.shp", "", int32_t(0x00000000), int32_t(0xD91CEF91)},
    {"b01nc-h.pcx", "-", int32_t(0x00000000), int32_t(0xD8BEAB64)},
    {"b01nc.pcx", "-", int32_t(0x00000000), int32_t(0x2D627BCE)},
    {"b02lm-g.pcx", "-", int32_t(0x00000000), int32_t(0xF9A39806)},
    {"b02lm-h.pcx", "-", int32_t(0x00000000), int32_t(0x08F52AD3)},
    {"b02lm.pcx", "-", int32_t(0x00000000), int32_t(0xFD29FA79)},
    {"b03l-h.pcx", "-", int32_t(0x00000000), int32_t(0x124A7053)},
    {"b03l.pcx", "-", int32_t(0x00000000), int32_t(0x2BA14C5D)},
    {"b04i-h.pcx", "-", int32_t(0x00000000), int32_t(0xBA012E65)},
    {"b04i.pcx", "-", int32_t(0x00000000), int32_t(0xFE44F395)},
    {"b05sm-h.pcx", "-", int32_t(0x00000000), int32_t(0x9950BC0A)},
    {"b05sm.pcx", "-", int32_t(0x00000000), int32_t(0x6C8C6CA0)},
    {"b06s-h.pcx", "-", int32_t(0x00000000), int32_t(0x871A36B7)},
    {"b06s.pcx", "-", int32_t(0x00000000), int32_t(0x99DCDDBD)},
    {"b07wdt-h.pcx", "-", int32_t(0x00000000), int32_t(0x28B2268C)},
    {"b07wdt.pcx", "-", int32_t(0x00000000), int32_t(0x5AEE41AF)},
    {"b08o-h.pcx", "-", int32_t(0x00000000), int32_t(0xD327B761)},
    {"b08o.pcx", "-", int32_t(0x00000000), int32_t(0x06C6C64E)},
    {"b09b-h.pcx", "-", int32_t(0x00000000), int32_t(0xCDAA3B08)},
    {"b09b.pcx", "-", int32_t(0x00000000), int32_t(0x350AD15A)},
    {"b1.des", "rock", int32_t(0x885CB5C9), int32_t(0x00000000)},
    {"b1.sno", "rocks", int32_t(0xA65CB1D2), int32_t(0x00000000)},
    {"b1.tem", "rock", int32_t(0xA85CAFC9), int32_t(0x00000000)},
    {"b1.win", "rock", int32_t(0xAE5CB0CD), int32_t(0x00000000)},
    {"b10e-h.pcx", "-", int32_t(0x00000000), int32_t(0x9450A2CB)},
    {"b10e.pcx", "-", int32_t(0x00000000), int32_t(0x06525736)},
    {"b12e-h.pcx", "-", int32_t(0x00000000), int32_t(0x90A572F6)},
    {"b12e.pcx", "-", int32_t(0x00000000), int32_t(0x4B9AF63D)},
    {"b2.des", "rocks", int32_t(0x885CB7C9), int32_t(0x00000000)},
    {"b2.sno", "rocks", int32_t(0xA65CB3D2), int32_t(0x00000000)},
    {"b2.tem", "rocks", int32_t(0xA85CB1C9), int32_t(0x00000000)},
    {"b2.win", "rocks", int32_t(0xAE5CB2CD), int32_t(0x00000000)},
    {"b3.sno", "rocks", int32_t(0xA65CB5D2), int32_t(0x00000000)},
    {"b3.tem", "large rocks", int32_t(0xA85CB3C9), int32_t(0x00000000)},
    {"b3.win", "large rocks", int32_t(0xAE5CB4CD), int32_t(0x00000000)},
    {"b4.des", "small rocks", int32_t(0x885CBBC9), int32_t(0x00000000)},
    {"b5.des", "small rocks", int32_t(0x885CBDC9), int32_t(0x00000000)},
    {"b6.des", "small rocks", int32_t(0x885CBFC9), int32_t(0x00000000)},
    {"b_b1.flc", "", int32_t(0xA5D104B2), int32_t(0x00000000)},
    {"b_b2.flc", "", int32_t(0xA7D104B2), int32_t(0x00000000)},
    {"b_cam.csv", "", int32_t(0xAB93D9F9), int32_t(0x00000000)},
    {"b_cam.lsv", "", int32_t(0xABA5D9F9), int32_t(0x00000000)},
    {"b_cam.vqa", "", int32_t(0xA7B9D9E4), int32_t(0x00000000)},
    {"b_cam_e.vqa", "", int32_t(0x61D98CF9), int32_t(0x00000000)},
    {"b_cam_e.vqt", "", int32_t(0x61EC8CF9), int32_t(0x00000000)},
    {"b_cam_h.pcx", "", int32_t(0x61F67EF3), int32_t(0x00000000)},
    {"b_cam_h.vqa", "", int32_t(0x61DF8CF9), int32_t(0x00000000)},
    {"b_cam_l.pcx", "", int32_t(0x61FE7EF3), int32_t(0x00000000)},
    {"b_cam_l.vqa", "", int32_t(0x61E78CF9), int32_t(0x00000000)},
    {"bab1atk1.aud", "", int32_t(0x6BF4EEB9), int32_t(0x00000000)},
    {"bab1atk2.aud", "", int32_t(0x6DF4EEB9), int32_t(0x00000000)},
    {"bab1deth.aud", "", int32_t(0x9A06D0BF), int32_t(0x00000000)},
    {"bab1hit1.aud", "", int32_t(0x6C06D8C7), int32_t(0x00000000)},
    {"bab1hit2.aud", "", int32_t(0x6E06D8C7), int32_t(0x00000000)},
    {"bab1htsh.aud", "", int32_t(0x9A04EEC7), int32_t(0x00000000)},
    {"bab1kilb.aud", "", int32_t(0x8DF6D8CD), int32_t(0x00000000)},
    {"bab2atk1.aud", "", int32_t(0x6FF4EEB9), int32_t(0x00000000)},
    {"bab2atk2.aud", "", int32_t(0x71F4EEB9), int32_t(0x00000000)},
    {"bab2deth.aud", "", int32_t(0x9E06D0BF), int32_t(0x00000000)},
    {"bab2hit1.aud", "", int32_t(0x7006D8C7), int32_t(0x00000000)},
    {"bab2hit2.aud", "", int32_t(0x7206D8C7), int32_t(0x00000000)},
    {"bab2htsh.aud", "", int32_t(0x9E04EEC7), int32_t(0x00000000)},
    {"bab2kilb.aud", "", int32_t(0x91F6D8CD), int32_t(0x00000000)},
    {"bab3atk1.aud", "", int32_t(0x73F4EEB9), int32_t(0x00000000)},
    {"bab3atk2.aud", "", int32_t(0x75F4EEB9), int32_t(0x00000000)},
    {"bab3deth.aud", "", int32_t(0xA206D0BF), int32_t(0x00000000)},
    {"bab3hit1.aud", "", int32_t(0x7406D8C7), int32_t(0x00000000)},
    {"bab3hit2.aud", "", int32_t(0x7606D8C7), int32_t(0x00000000)},
    {"bab3htsh.aud", "", int32_t(0xA204EEC7), int32_t(0x00000000)},
    {"bab3kilb.aud", "", int32_t(0x95F6D8CD), int32_t(0x00000000)},
    {"bab4atk1.aud", "", int32_t(0x77F4EEB9), int32_t(0x00000000)},
    {"bab4atk2.aud", "", int32_t(0x79F4EEB9), int32_t(0x00000000)},
    {"bab4deth.aud", "", int32_t(0xA606D0BF), int32_t(0x00000000)},
    {"bab4hit1.aud", "", int32_t(0x7806D8C7), int32_t(0x00000000)},
    {"bab4hit2.aud", "", int32_t(0x7A06D8C7), int32_t(0x00000000)},
    {"bab4htsh.aud", "", int32_t(0xA604EEC7), int32_t(0x00000000)},
    {"bab4kilb.aud", "", int32_t(0x99F6D8CD), int32_t(0x00000000)},
    {"babycry2.aud", "", int32_t(0x0E10EABD), int32_t(0x00000000)},
    {"back.aud", "", int32_t(0xDADBC3B2), int32_t(0x00000000)},
    {"back.bmp", "", int32_t(0xE6D3C4B2), int32_t(0x00000000)},
    {"back.pal", "", int32_t(0xE2C7D2B2), int32_t(0x00000000)},
    {"back.shp", "", int32_t(0xE6CED5B2), int32_t(0x00000000)},
    {"backstab.aud", "backstab", int32_t(0xF5E4EEDD), int32_t(0x00000000)},
    {"backtile.pcx", "", int32_t(0x0FE8E7DF), int32_t(0x00000000)},
    {"backtile_h.pcx", "", int32_t(0x0FA81863), int32_t(0x00000000)},
    {"backtile_l.pcx", "", int32_t(0x0FA82063), int32_t(0x00000000)},
    {"badfall1.aud", "", int32_t(0xBFFEDEB9), int32_t(0x00000000)},
    {"badfile.aud", "", int32_t(0x75DFF2DC), int32_t(0x00000000)},
    {"badger.aud", "", int32_t(0x9F6DEDE8), int32_t(0x00000000)},
    {"badr.shp", "unit: badger bomber", int32_t(0xF4D0D5B2), int32_t(0x00000000)},
    {"badricon.shp", "icon: badger", int32_t(0x35F7DEC9), int32_t(0x00000000)},
    {"bagclose.aud", "", int32_t(0xDC18E4CF), int32_t(0x00000000)},
    {"bagopen.aud", "", int32_t(0x99FDE4EA), int32_t(0x00000000)},
    {"bagopen1.aud", "", int32_t(0xE40ED0D7), int32_t(0x00000000)},
    {"ball.shp", "", int32_t(0xE8E0D5B2), int32_t(0x00000000)},
    {"ballrm1.aud", "", int32_t(0x8DD7F4EE), int32_t(0x00000000)},
    {"ballrm2.aud", "", int32_t(0x8DD9F4EE), int32_t(0x00000000)},
    {"ban.shp", "", int32_t(0x5CECCAD7), int32_t(0x00000000)},
    {"ban1atk1.aud", "", int32_t(0x6C24EEB9), int32_t(0x00000000)},
    {"ban1atk2.aud", "", int32_t(0x6E24EEB9), int32_t(0x00000000)},
    {"ban1deth.aud", "", int32_t(0x9A36D0BF), int32_t(0x00000000)},
    {"ban1hit1.aud", "", int32_t(0x6C36D8C7), int32_t(0x00000000)},
    {"ban1hit2.aud", "", int32_t(0x6E36D8C7), int32_t(0x00000000)},
    {"ban1htsh.aud", "", int32_t(0x9A34EEC7), int32_t(0x00000000)},
    {"ban1kilb.aud", "", int32_t(0x8E26D8CD), int32_t(0x00000000)},
    {"bana.hva", "", int32_t(0x00000000), int32_t(0x6F79F170)},
    {"bana.vxl", "", int32_t(0x00000000), int32_t(0x99F32E39)},
    {"bang1.aud", "", int32_t(0xC7BB61AF), int32_t(0x00000000)},
    {"bang2.aud", "", int32_t(0xC7BB61B1), int32_t(0x00000000)},
    {"bang3.aud", "", int32_t(0xC7BB61B3), int32_t(0x00000000)},
    {"bang4.aud", "", int32_t(0xC7BB61B5), int32_t(0x00000000)},
    {"bang5.aud", "", int32_t(0xC7BB61B7), int32_t(0x00000000)},
    {"bang6.aud", "", int32_t(0xC7BB61B9), int32_t(0x00000000)},
    {"bangdoor.aud", "", int32_t(0x062CE4BF), int32_t(0x00000000)},
    {"banish1.aud", "", int32_t(0x81DFEAF0), int32_t(0x00000000)},
    {"banner.vqa", "gdi banner unfolding", int32_t(0xE595EAE4), int32_t(0x00000000)},
    {"banner.vqp", "gdi banner unfolding", int32_t(0xE595F9E4), int32_t(0x00000000)},
    {"banr_nod.vqa", "nod banner unfolding", int32_t(0x1328F7F5), int32_t(0x00000000)},
    {"banr_nod.vqp", "nod banner unfolding", int32_t(0x2228F7F5), int32_t(0x00000000)},
    {"bar-main.vqa", "", int32_t(0x932CDDD1), int32_t(0x00000000)},
    {"bar3bhr.shp", "misc: allies score bar win", int32_t(0x2A3DDDE0), int32_t(0x00000000)},
    {"bar3blu.shp", "misc: allies score bar dos", int32_t(0x2A43E5E0), int32_t(0x00000000)},
    {"bar3red.shp", "nod score bar", int32_t(0x2A21D800), int32_t(0x00000000)},
    {"bar3rhr.shp", "misc: soviet score bar win", int32_t(0x2A3DDE00), int32_t(0x00000000)},
    {"bar3ylw.shp", "gdi score bar", int32_t(0x2A47E60E), int32_t(0x00000000)},
    {"bar_ll.pcx", "-", int32_t(0x00000000), int32_t(0x6E8068AC)},
    {"bar_lr.pcx", "-", int32_t(0x00000000), int32_t(0x59618F3F)},
    {"bar_ul.pcx", "-", int32_t(0x00000000), int32_t(0x0D7442AC)},
    {"bar_ur.pcx", "-", int32_t(0x00000000), int32_t(0x3A95A53F)},
    {"baracd01.ubn", "", int32_t(0x00000000), int32_t(0x329F1FA7)},
    {"baracd02.ubn", "", int32_t(0x00000000), int32_t(0x753F6577)},
    {"baracd03.ubn", "", int32_t(0x00000000), int32_t(0x485F4CC7)},
    {"baracd04.ubn", "", int32_t(0x00000000), int32_t(0xFA7F90D7)},
    {"baramb1.aud", "", int32_t(0x61EFDEE4), int32_t(0x00000000)},
    {"baramb2.aud", "", int32_t(0x61F1DEE4), int32_t(0x00000000)},
    {"barb.shp", "razor wire", int32_t(0xD4ECD5B2), int32_t(0xF24F1AFC)},
    {"barbicnh.des", "icon: razor wire", int32_t(0xED2ACFC9), int32_t(0x00000000)},
    {"barbicnh.tem", "icon: razor wire", int32_t(0xE72ADFC9), int32_t(0x00000000)},
    {"barbicnh.win", "icon: razor wire", int32_t(0xE82EE2C9), int32_t(0x00000000)},
    {"barbicon.shp", "icon: razor wire", int32_t(0xF62FDEC9), int32_t(0x00000000)},
    {"bargraph.aud", "-", int32_t(0x00000000), int32_t(0xA1E393FF)},
    {"barl.shp", "misc: barrel", int32_t(0xE8ECD5B2), int32_t(0x00000000)},
    {"barr.shp", "bldg: soviet barracks", int32_t(0xF4ECD5B2), int32_t(0x00000000)},
    {"barrel1.aud", "", int32_t(0xA5EFF2D4), int32_t(0x00000000)},
    {"barrel2.aud", "", int32_t(0xA5F1F2D4), int32_t(0x00000000)},
    {"barrel3.aud", "", int32_t(0xA5F3F2D4), int32_t(0x00000000)},
    {"barrel4.aud", "", int32_t(0xA5F5F2D4), int32_t(0x00000000)},
    {"barrel5.aud", "", int32_t(0xA5F7F2D4), int32_t(0x00000000)},
    {"barrel6.aud", "", int32_t(0xA5F9F2D4), int32_t(0x00000000)},
    {"barrel7.aud", "", int32_t(0xA5FBF2D4), int32_t(0x00000000)},
    {"barricon.shp", "icon: barracks", int32_t(0x362FDEC9), int32_t(0x00000000)},
    {"barrmake.shp", "make: barracks", int32_t(0x2427DAD1), int32_t(0x00000000)},
    {"bars3.aud", "???", int32_t(0xF7CB61B3), int32_t(0x00000000)},
    {"barsfx1.aud", "", int32_t(0xA9F00AD6), int32_t(0x00000000)},
    {"barsfx2.aud", "", int32_t(0xA9F20AD6), int32_t(0x00000000)},
    {"barsfx3.aud", "", int32_t(0xA9F40AD6), int32_t(0x00000000)},
    {"barsfx4.aud", "", int32_t(0xA9F60AD6), int32_t(0x00000000)},
    {"barsfx5.aud", "", int32_t(0xA9F80AD6), int32_t(0x00000000)},
    {"barsfx6.aud", "", int32_t(0xA9FA0AD6), int32_t(0x00000000)},
    {"barsfx7.aud", "", int32_t(0xA9FC0AD6), int32_t(0x00000000)},
    {"barslid1.aud", "", int32_t(0xF426D8CF), int32_t(0x00000000)},
    {"baseatk1.aud", "base under atack", int32_t(0xBC38EEB9), int32_t(0x00000000)},
    {"baseb01.ubn", "", int32_t(0x00000000), int32_t(0x7C5FE28C)},
    {"baseb01.urb", "", int32_t(0x00000000), int32_t(0xCCCC0EF0)},
    {"basepal.pal", "", int32_t(0x7231C8F9), int32_t(0x00000000)},
    {"bastion.flc", "", int32_t(0xAE2CEFE1), int32_t(0x00000000)},
    {"batl226m.aud", "", int32_t(0x1012AA9B), int32_t(0x00000000)},
    {"batlcon1.aud", "battle controll terminated", int32_t(0xD842E4BD), int32_t(0x00000000)},
    {"batricon.shp", "icon: battery", int32_t(0x00000000), int32_t(0x7B305243)},
    {"bats1.aud", "", int32_t(0xF7D361AF), int32_t(0x00000000)},
    {"batscat2.aud", "", int32_t(0xF64EC8BD), int32_t(0x00000000)},
    {"battle.ini", "ts campaign settings", int32_t(0x00000000), int32_t(0x889C5B31)},
    {"battle.vqa", "destroyed vechicles", int32_t(0xFDADD0F2), int32_t(0x00000000)},
    {"battle.vqp", "vqp: destroyed vechicles", int32_t(0xFDADDFF2), int32_t(0x00000000)},
    {"battlefs.ini", "fs campaign settings", int32_t(0x00000000), int32_t(0xBFE53B8C)},
    {"battlemd.ini", "", int32_t(0x00000000), int32_t(0x07E280DD)},
    {"bazook1.aud", "bazooka", int32_t(0x9A0FF0E8), int32_t(0x00000000)},
    {"bazook1.juv", "bazooka", int32_t(0x9A21F0F1), int32_t(0x00000000)},
    {"bb01-min.set", "", int32_t(0xB598F691), int32_t(0x00000000)},
    {"bb01.vqa", "", int32_t(0xA3B1DAB2), int32_t(0x00000000)},
    {"bb01_0.vqa", "", int32_t(0x711DAB18), int32_t(0x00000000)},
    {"bb01_1.vqa", "", int32_t(0x711DAD18), int32_t(0x00000000)},
    {"bb01_2.vqa", "", int32_t(0x711DAF18), int32_t(0x00000000)},
    {"bb01_3.vqa", "", int32_t(0x711DB118), int32_t(0x00000000)},
    {"bb02-min.set", "", int32_t(0xB998F691), int32_t(0x00000000)},
    {"bb02.vqa", "", int32_t(0xA5B1DAB2), int32_t(0x00000000)},
    {"bb02_0.vqa", "", int32_t(0x751DAB18), int32_t(0x00000000)},
    {"bb02_1.vqa", "", int32_t(0x751DAD18), int32_t(0x00000000)},
    {"bb02_2.vqa", "", int32_t(0x751DAF18), int32_t(0x00000000)},
    {"bb02_3.vqa", "", int32_t(0x751DB118), int32_t(0x00000000)},
    {"bb03-min.set", "", int32_t(0xBD98F691), int32_t(0x00000000)},
    {"bb03.vqa", "", int32_t(0xA7B1DAB2), int32_t(0x00000000)},
    {"bb03_0.vqa", "", int32_t(0x791DAB18), int32_t(0x00000000)},
    {"bb03_1.vqa", "", int32_t(0x791DAD18), int32_t(0x00000000)},
    {"bb03_2.vqa", "", int32_t(0x791DAF18), int32_t(0x00000000)},
    {"bb03_3.vqa", "", int32_t(0x791DB118), int32_t(0x00000000)},
    {"bb04-min.set", "", int32_t(0xC198F691), int32_t(0x00000000)},
    {"bb04.vqa", "", int32_t(0xA9B1DAB2), int32_t(0x00000000)},
    {"bb04_0.vqa", "", int32_t(0x7D1DAB18), int32_t(0x00000000)},
    {"bb04_1.vqa", "", int32_t(0x7D1DAD18), int32_t(0x00000000)},
    {"bb04_2.vqa", "", int32_t(0x7D1DAF18), int32_t(0x00000000)},
    {"bb04_3.vqa", "", int32_t(0x7D1DB118), int32_t(0x00000000)},
    {"bb05-min.set", "", int32_t(0xC598F691), int32_t(0x00000000)},
    {"bb05.vqa", "", int32_t(0xABB1DAB2), int32_t(0x00000000)},
    {"bb05_0.vqa", "", int32_t(0x811DAB18), int32_t(0x00000000)},
    {"bb05_1.vqa", "", int32_t(0x811DAD18), int32_t(0x00000000)},
    {"bb05_2.vqa", "", int32_t(0x811DAF18), int32_t(0x00000000)},
    {"bb05_3.vqa", "", int32_t(0x811DB118), int32_t(0x00000000)},
    {"bb05over.vqa", "", int32_t(0xBA9D0BD5), int32_t(0x00000000)},
    {"bb06-min.set", "", int32_t(0xC998F691), int32_t(0x00000000)},
    {"bb06.vqa", "", int32_t(0xADB1DAB2), int32_t(0x00000000)},
    {"bb06_0.vqa", "", int32_t(0x851DAB18), int32_t(0x00000000)},
    {"bb06_1.vqa", "", int32_t(0x851DAD18), int32_t(0x00000000)},
    {"bb06_2.vqa", "", int32_t(0x851DAF18), int32_t(0x00000000)},
    {"bb06_3.vqa", "", int32_t(0x851DB118), int32_t(0x00000000)},
    {"bb06over.vqa", "", int32_t(0xBE9D0BD5), int32_t(0x00000000)},
    {"bb07-min.set", "", int32_t(0xCD98F691), int32_t(0x00000000)},
    {"bb07.vqa", "", int32_t(0xAFB1DAB2), int32_t(0x00000000)},
    {"bb07_0.vqa", "", int32_t(0x891DAB18), int32_t(0x00000000)},
    {"bb07_1.vqa", "", int32_t(0x891DAD18), int32_t(0x00000000)},
    {"bb07_2.vqa", "", int32_t(0x891DAF18), int32_t(0x00000000)},
    {"bb07_3.vqa", "", int32_t(0x891DB118), int32_t(0x00000000)},
    {"bb07over.vqa", "", int32_t(0xC29D0BD5), int32_t(0x00000000)},
    {"bb08-min.set", "", int32_t(0xD198F691), int32_t(0x00000000)},
    {"bb08.vqa", "", int32_t(0xB1B1DAB2), int32_t(0x00000000)},
    {"bb08_0.vqa", "", int32_t(0x8D1DAB18), int32_t(0x00000000)},
    {"bb08_1.vqa", "", int32_t(0x8D1DAD18), int32_t(0x00000000)},
    {"bb08_2.vqa", "", int32_t(0x8D1DAF18), int32_t(0x00000000)},
    {"bb08_3.vqa", "", int32_t(0x8D1DB118), int32_t(0x00000000)},
    {"bb08over.vqa", "", int32_t(0xC69D0BD5), int32_t(0x00000000)},
    {"bb09-min.set", "", int32_t(0xD598F691), int32_t(0x00000000)},
    {"bb09.vqa", "", int32_t(0xB3B1DAB2), int32_t(0x00000000)},
    {"bb09_0.vqa", "", int32_t(0x911DAB18), int32_t(0x00000000)},
    {"bb09_1.vqa", "", int32_t(0x911DAD18), int32_t(0x00000000)},
    {"bb09_2.vqa", "", int32_t(0x911DAF18), int32_t(0x00000000)},
    {"bb09_3.vqa", "", int32_t(0x911DB118), int32_t(0x00000000)},
    {"bb10-min.set", "", int32_t(0xB19CF691), int32_t(0x00000000)},
    {"bb10.vqa", "", int32_t(0xA1B3DAB2), int32_t(0x00000000)},
    {"bb10_0.vqa", "", int32_t(0x6D21AB18), int32_t(0x00000000)},
    {"bb10_1.vqa", "", int32_t(0x6D21AD18), int32_t(0x00000000)},
    {"bb10_2.vqa", "", int32_t(0x6D21AF18), int32_t(0x00000000)},
    {"bb10_3.vqa", "", int32_t(0x6D21B118), int32_t(0x00000000)},
    {"bb10ovr1.vqa", "", int32_t(0x64BB0BD5), int32_t(0x00000000)},
    {"bb10ovr2.vqa", "", int32_t(0x66BB0BD5), int32_t(0x00000000)},
    {"bb10ovr3.vqa", "", int32_t(0x68BB0BD5), int32_t(0x00000000)},
    {"bb10ovr4.vqa", "", int32_t(0x6ABB0BD5), int32_t(0x00000000)},
    {"bb10ovr5.vqa", "", int32_t(0x6CBB0BD5), int32_t(0x00000000)},
    {"bb11-min.set", "", int32_t(0xB59CF691), int32_t(0x00000000)},
    {"bb11.vqa", "", int32_t(0xA3B3DAB2), int32_t(0x00000000)},
    {"bb11_0.vqa", "", int32_t(0x7121AB18), int32_t(0x00000000)},
    {"bb11_1.vqa", "", int32_t(0x7121AD18), int32_t(0x00000000)},
    {"bb11_2.vqa", "", int32_t(0x7121AF18), int32_t(0x00000000)},
    {"bb11_3.vqa", "", int32_t(0x7121B118), int32_t(0x00000000)},
    {"bb12-min.set", "", int32_t(0xB99CF691), int32_t(0x00000000)},
    {"bb12.aud", "", int32_t(0xA8B7C5B2), int32_t(0x00000000)},
    {"bb12_0.vqa", "", int32_t(0x7521AB18), int32_t(0x00000000)},
    {"bb12_1.vqa", "", int32_t(0x7521AD18), int32_t(0x00000000)},
    {"bb12_2.vqa", "", int32_t(0x7521AF18), int32_t(0x00000000)},
    {"bb12over.vqa", "", int32_t(0xAEA10BD5), int32_t(0x00000000)},
    {"bb51-min.set", "", int32_t(0xB5ACF691), int32_t(0x00000000)},
    {"bb51.vqa", "", int32_t(0xA3BBDAB2), int32_t(0x00000000)},
    {"bb51_0.vqa", "", int32_t(0x7131AB18), int32_t(0x00000000)},
    {"bb51_1.vqa", "", int32_t(0x7131AD18), int32_t(0x00000000)},
    {"bb51_2.vqa", "", int32_t(0x7131AF18), int32_t(0x00000000)},
    {"bb51_3.vqa", "", int32_t(0x7131B118), int32_t(0x00000000)},
    {"bb_brth.csv", "", int32_t(0x666404F0), int32_t(0x00000000)},
    {"bb_brth.lsv", "", int32_t(0x666404F9), int32_t(0x00000000)},
    {"bb_brth.vqa", "", int32_t(0x664F0303), int32_t(0x00000000)},
    {"bb_brth_e.vqa", "", int32_t(0x32C7C025), int32_t(0x00000000)},
    {"bb_brth_e.vqt", "", int32_t(0x32C7C038), int32_t(0x00000000)},
    {"bb_brth_h.pcx", "", int32_t(0x16BBC042), int32_t(0x00000000)},
    {"bb_brth_h.vqa", "", int32_t(0x32C7C02B), int32_t(0x00000000)},
    {"bb_brth_l.pcx", "", int32_t(0x16BBC04A), int32_t(0x00000000)},
    {"bb_brth_l.vqa", "", int32_t(0x32C7C033), int32_t(0x00000000)},
    {"bbblelrg.shp", "", int32_t(0x00000000), int32_t(0xBFDF4A9C)},
    {"bbdrip1.aud", "", int32_t(0xA5B7FEDC), int32_t(0x00000000)},
    {"bbdrip2.aud", "", int32_t(0xA5B9FEDC), int32_t(0x00000000)},
    {"bbdrip3.aud", "", int32_t(0xA5BBFEDC), int32_t(0x00000000)},
    {"bbdrip4.aud", "", int32_t(0xA5BDFEDC), int32_t(0x00000000)},
    {"bbdrip5.aud", "", int32_t(0xA5BFFEDC), int32_t(0x00000000)},
    {"bbele2.aud", "", int32_t(0xB371B1E8), int32_t(0x00000000)},
    {"bbgrn1.aud", "", int32_t(0xCB79AFFA), int32_t(0x00000000)},
    {"bbgrn2.aud", "", int32_t(0xCB79B1FA), int32_t(0x00000000)},
    {"bbgrn3.aud", "", int32_t(0xCB79B3FA), int32_t(0x00000000)},
    {"bbmove1.aud", "", int32_t(0x99DBE8F6), int32_t(0x00000000)},
    {"bbmove2.aud", "", int32_t(0x99DDE8F6), int32_t(0x00000000)},
    {"bbmove3.aud", "", int32_t(0x99DFE8F6), int32_t(0x00000000)},
    {"bboard01.shp", "-", int32_t(0x00000000), int32_t(0xCD51EB10)},
    {"bboard02.shp", "-", int32_t(0x00000000), int32_t(0x8AF191C0)},
    {"bboard03.shp", "-", int32_t(0x00000000), int32_t(0xB791B870)},
    {"bboard04.shp", "-", int32_t(0x00000000), int32_t(0x05B16460)},
    {"bboard05.shp", "-", int32_t(0x00000000), int32_t(0x38D14DD0)},
    {"bboard06.shp", "-", int32_t(0x00000000), int32_t(0x7F713700)},
    {"bboard07.shp", "-", int32_t(0x00000000), int32_t(0x42111EB0)},
    {"bboard08.shp", "-", int32_t(0x00000000), int32_t(0xC0418961)},
    {"bboard09.shp", "-", int32_t(0x00000000), int32_t(0xFD21A0D1)},
    {"bboard10.shp", "-", int32_t(0x00000000), int32_t(0x3B6D1105)},
    {"bboard11.shp", "-", int32_t(0x00000000), int32_t(0x060D38B5)},
    {"bboard12.shp", "-", int32_t(0x00000000), int32_t(0x41AD4265)},
    {"bboard13.shp", "-", int32_t(0x00000000), int32_t(0x7CCD6BD5)},
    {"bboard14.shp", "-", int32_t(0x00000000), int32_t(0xCEEDB7C5)},
    {"bboard15.shp", "-", int32_t(0x00000000), int32_t(0xF38D9E75)},
    {"bboard16.shp", "-", int32_t(0x00000000), int32_t(0xB42DE4A5)},
    {"bbpceilfan1.aud", "", int32_t(0x905A28EA), int32_t(0x00000000)},
    {"bc-vs-sb.csv", "", int32_t(0x33AEAADD), int32_t(0x00000000)},
    {"bc-vs-sb.lsv", "", int32_t(0x33AEB3DD), int32_t(0x00000000)},
    {"bc-vs-sb.vqa", "", int32_t(0x1EACBDDD), int32_t(0x00000000)},
    {"bc-vs-sb_e.vqa", "", int32_t(0x67139B6D), int32_t(0x00000000)},
    {"bc-vs-sb_e.vqt", "", int32_t(0x6713AE6D), int32_t(0x00000000)},
    {"bc-vs-sb_h.pcx", "", int32_t(0x5B13B85F), int32_t(0x00000000)},
    {"bc-vs-sb_h.vqa", "", int32_t(0x6713A16D), int32_t(0x00000000)},
    {"bc-vs-sb_l.pcx", "", int32_t(0x5B13C05F), int32_t(0x00000000)},
    {"bc-vs-sb_l.vqa", "", int32_t(0x6713A96D), int32_t(0x00000000)},
    {"bcab.hva", "", int32_t(0x00000000), int32_t(0x4E10285C)},
    {"bcab.vxl", "", int32_t(0x00000000), int32_t(0xB89AF715)},
    {"bcanyon.vqa", "orca flying through canyon", int32_t(0x95E2FD11), int32_t(0x00000000)},
    {"bcanyon.vqp", "orca flying through canyon", int32_t(0x95F1FD11), int32_t(0x00000000)},
    {"bchm_apr.csv", "", int32_t(0x3014D2F5), int32_t(0x00000000)},
    {"bchm_apr.lsv", "", int32_t(0x3014DBF5), int32_t(0x00000000)},
    {"bchm_apr.vqa", "", int32_t(0x1B12E5F5), int32_t(0x00000000)},
    {"bchm_apr_e.vqa", "", int32_t(0x5FDFEB9D), int32_t(0x00000000)},
    {"bchm_apr_e.vqt", "", int32_t(0x5FDFFE9D), int32_t(0x00000000)},
    {"bchm_apr_h.pcx", "", int32_t(0x53E0088F), int32_t(0x00000000)},
    {"bchm_apr_h.vqa", "", int32_t(0x5FDFF19D), int32_t(0x00000000)},
    {"bchm_apr_l.pcx", "", int32_t(0x53E0108F), int32_t(0x00000000)},
    {"bchm_apr_l.vqa", "", int32_t(0x5FDFF99D), int32_t(0x00000000)},
    {"bct1.aud", "battle control terminated", int32_t(0xA6FDC7B2), int32_t(0x00000000)},
    {"bde_li24.pcx", "-", int32_t(0x00000000), int32_t(0x3463AB7B)},
    {"bde_li30.pcx", "-", int32_t(0x00000000), int32_t(0x0ABFDE1E)},
    {"bde_mi24.pcx", "-", int32_t(0x00000000), int32_t(0xF8C9ABE5)},
    {"bde_mi30.pcx", "-", int32_t(0x00000000), int32_t(0xC615DE80)},
    {"bde_ri24.pcx", "-", int32_t(0x00000000), int32_t(0x5D528862)},
    {"bde_ri30.pcx", "-", int32_t(0x00000000), int32_t(0x638EFD07)},
    {"beachead.vqa", "transport beach landing", int32_t(0xD6D8F5C7), int32_t(0x996E3A2B)},
    {"beachead.vqp", "vqp: transport beach landing", int32_t(0xE5D8F5C7), int32_t(0x00000000)},
    {"beacon.shp", "beacon", int32_t(0x00000000), int32_t(0x4844F38B)},
    {"beag.hva", "", int32_t(0x00000000), int32_t(0xE5209216)},
    {"beag.vxl", "", int32_t(0x00000000), int32_t(0x13AA4D5F)},
    {"beagicon.shp", "", int32_t(0x00000000), int32_t(0xEC396C53)},
    {"bear1.aud", "", int32_t(0xF38771AF), int32_t(0x00000000)},
    {"bear2.aud", "", int32_t(0xF38771B1), int32_t(0x00000000)},
    {"beating1.aud", "", int32_t(0xF7E8F2C9), int32_t(0x00000000)},
    {"bed2.aud", "???", int32_t(0xA8DDCBB2), int32_t(0x00000000)},
    {"beep1.aud", "", int32_t(0xEB9771AF), int32_t(0x00000000)},
    {"beep10.aud", "", int32_t(0xC371B9C0), int32_t(0x00000000)},
    {"beep10a.aud", "", int32_t(0x9DDBCAAC), int32_t(0x00000000)},
    {"beep15.aud", "", int32_t(0xC371C3C0), int32_t(0x00000000)},
    {"beep16.aud", "", int32_t(0xC371C5C0), int32_t(0x00000000)},
    {"beepneat.aud", "", int32_t(0x2DECE0D3), int32_t(0x00000000)},
    {"beepslct.aud", "map sound #2", int32_t(0x2DF0EEDD), int32_t(0x00000000)},
    {"beepy1.aud", "audf:", int32_t(0xC371BC10), int32_t(0x00000000)},
    {"beepy2.aud", "beep", int32_t(0xC371BE10), int32_t(0x00000000)},
    {"beepy3.aud", "beep", int32_t(0xC371C010), int32_t(0x00000000)},
    {"beepy6.aud", "beep", int32_t(0xC371C610), int32_t(0x00000000)},
    {"beetat1a.aud", "", int32_t(0x17CCFEB9), int32_t(0x00000000)},
    {"beetat1b.aud", "", int32_t(0x19CCFEB9), int32_t(0x00000000)},
    {"beetat2a.aud", "", int32_t(0x17CEFEB9), int32_t(0x00000000)},
    {"beetat2b.aud", "", int32_t(0x19CEFEB9), int32_t(0x00000000)},
    {"beetcln1.aud", "", int32_t(0xF806EEBD), int32_t(0x00000000)},
    {"beetcln2.aud", "", int32_t(0xFA06EEBD), int32_t(0x00000000)},
    {"beetdie1.aud", "", int32_t(0xF7F4E8BF), int32_t(0x00000000)},
    {"beetdie2.aud", "", int32_t(0xF9F4E8BF), int32_t(0x00000000)},
    {"beethit1.aud", "", int32_t(0xF812E8C7), int32_t(0x00000000)},
    {"beethit2.aud", "", int32_t(0xFA12E8C7), int32_t(0x00000000)},
    {"beetloi1.aud", "", int32_t(0xF7FCF4CF), int32_t(0x00000000)},
    {"beetloi2.aud", "", int32_t(0xF9FCF4CF), int32_t(0x00000000)},
    {"befeared.aud", "enemies to be feared", int32_t(0xE1F8FAB9), int32_t(0x00000000)},
    {"befeared.var", "enemies to be feared sfx", int32_t(0xEFE50FB9), int32_t(0x00000000)},
    {"behind.shp", "", int32_t(0x00000000), int32_t(0x49A50D0F)},
    {"belbatl1.aud", "", int32_t(0xB01EFEB9), int32_t(0x00000000)},
    {"beli.csv", "", int32_t(0xE8EBCDB2), int32_t(0x00000000)},
    {"beli.lsv", "", int32_t(0xE8EBD6B2), int32_t(0x00000000)},
    {"beli.vqa", "", int32_t(0xD3E9E0B2), int32_t(0x00000000)},
    {"beli_h.pcx", "", int32_t(0xC58DFE0A), int32_t(0x00000000)},
    {"beli_h.vqa", "", int32_t(0xD18DE718), int32_t(0x00000000)},
    {"beli_l.pcx", "", int32_t(0xC58E060A), int32_t(0x00000000)},
    {"belial.aud", "", int32_t(0xA78DF1E0), int32_t(0x00000000)},
    {"beliale.aud", "", int32_t(0x820002CC), int32_t(0x00000000)},
    {"bells1.aud", "", int32_t(0xB38DBC04), int32_t(0x00000000)},
    {"bells2.aud", "", int32_t(0xB38DBE04), int32_t(0x00000000)},
    {"bells3.aud", "", int32_t(0xB38DC004), int32_t(0x00000000)},
    {"bells4.aud", "", int32_t(0xB38DC204), int32_t(0x00000000)},
    {"bells5.aud", "", int32_t(0xB38DC404), int32_t(0x00000000)},
    {"belltone.aud", "", int32_t(0x0022F4DF), int32_t(0x00000000)},
    {"belly1.aud", "", int32_t(0xB38DBC10), int32_t(0x00000000)},
    {"belly2.aud", "", int32_t(0xB38DBE10), int32_t(0x00000000)},
    {"belly3.aud", "", int32_t(0xB38DC010), int32_t(0x00000000)},
    {"belly4.aud", "", int32_t(0xB38DC210), int32_t(0x00000000)},
    {"belly5.aud", "", int32_t(0xB38DC410), int32_t(0x00000000)},
    {"belwand1.aud", "", int32_t(0x040EF2B9), int32_t(0x00000000)},
    {"best01.shp", "-", int32_t(0x00000000), int32_t(0xCCEEAE18)},
    {"best02.shp", "-", int32_t(0x00000000), int32_t(0xFD06B485)},
    {"bestbox.aud", "-", int32_t(0x00000000), int32_t(0x7E1BA4DB)},
    {"bflaatta.mrf", "", int32_t(0x00000000), int32_t(0x3BA3E5E4)},
    {"bflaattb.mrf", "", int32_t(0x00000000), int32_t(0x7C039F34)},
    {"bfrt.hva", "", int32_t(0x00000000), int32_t(0x76CA15EC)},
    {"bfrt.vxl", "", int32_t(0x00000000), int32_t(0x8040CAA5)},
    {"bfrticon.shp", "", int32_t(0x00000000), int32_t(0x2C0F4E0D)},
    {"bfrtuico.shp", "", int32_t(0x00000000), int32_t(0xE9C9DCEC)},
    {"bggy.hva", "-", int32_t(0x00000000), int32_t(0x7B3649C1)},
    {"bggy.shp", "nod buggy", int32_t(0x02D6E1B2), int32_t(0x00000000)},
    {"bggy.vxl", "attack buggy", int32_t(0x00000000), int32_t(0x8DBC9688)},
    {"bggyicnh.des", "icon: nod buggy", int32_t(0x48FEE7C9), int32_t(0x00000000)},
    {"bggyicnh.tem", "icon: nod buggy", int32_t(0x42FEF7C9), int32_t(0x00000000)},
    {"bggyicnh.win", "icon: nod buggy", int32_t(0x4402FAC9), int32_t(0x00000000)},
    {"bggyicon.shp", "icon: nod buggy", int32_t(0x5203F6C8), int32_t(0xDD493C36)},
    {"bib1.des", "bib 1", int32_t(0xB5C9D6B2), int32_t(0x00000000)},
    {"bib1.sno", "misc: bib", int32_t(0xB1D2E5B2), int32_t(0x00000000)},
    {"bib1.tem", "bib 1", int32_t(0xAFC9E6B2), int32_t(0x00000000)},
    {"bib1.win", "bib 1", int32_t(0xB0CDE9B2), int32_t(0x00000000)},
    {"bib2.des", "bib 2", int32_t(0xB7C9D6B2), int32_t(0x00000000)},
    {"bib2.sno", "misc: bib", int32_t(0xB3D2E5B2), int32_t(0x00000000)},
    {"bib2.tem", "bib 2", int32_t(0xB1C9E6B2), int32_t(0x00000000)},
    {"bib2.win", "bib 2", int32_t(0xB2CDE9B2), int32_t(0x00000000)},
    {"bib3.des", "bib 3", int32_t(0xB9C9D6B2), int32_t(0x00000000)},
    {"bib3.sno", "misc: bib", int32_t(0xB5D2E5B2), int32_t(0x00000000)},
    {"bib3.tem", "bib 3", int32_t(0xB3C9E6B2), int32_t(0x00000000)},
    {"bib3.win", "bib 3", int32_t(0xB4CDE9B2), int32_t(0x00000000)},
    {"bigblue.des", "", int32_t(0x00000000), int32_t(0xC2893B56)},
    {"bigblue.lun", "", int32_t(0x00000000), int32_t(0xE477DCD5)},
    {"bigblue.sno", "-", int32_t(0x00000000), int32_t(0xE565E6CC)},
    {"bigblue.tem", "-", int32_t(0x00000000), int32_t(0x46D15316)},
    {"bigblue.ubn", "", int32_t(0x00000000), int32_t(0xD00F7135)},
    {"bigblue.urb", "", int32_t(0x00000000), int32_t(0x609C9D49)},
    {"bigblue3.tem", "-", int32_t(0x00000000), int32_t(0x9E7A6F05)},
    {"bigboom1.aud", "", int32_t(0xB00D04D5), int32_t(0x00000000)},
    {"bigboom2.aud", "", int32_t(0xB20D04D5), int32_t(0x00000000)},
    {"bigboom3.aud", "", int32_t(0xB40D04D5), int32_t(0x00000000)},
    {"bigboom4.aud", "", int32_t(0xB60D04D5), int32_t(0x00000000)},
    {"bigboom5.aud", "", int32_t(0xB80D04D5), int32_t(0x00000000)},
    {"bigcheck.shp", "", int32_t(0xF3EC02C7), int32_t(0x00000000)},
    {"bigf226m.aud", "bigfoot", int32_t(0xF7DECA9B), int32_t(0x00000000)},
    {"bigfan2.aud", "", int32_t(0x75C616CC), int32_t(0x00000000)},
    {"bigfan3.aud", "", int32_t(0x75C816CC), int32_t(0x00000000)},
    {"bigfont.shp", "-", int32_t(0x00000000), int32_t(0x5282DB05)},
    {"bigfoot1.aud", "", int32_t(0xC01B04D5), int32_t(0x00000000)},
    {"bigfoot2.aud", "", int32_t(0xC21B04D5), int32_t(0x00000000)},
    {"bigfoot2.wav", "", int32_t(0xD4071AD5), int32_t(0x00000000)},
    {"bigfoot3.aud", "", int32_t(0xC41B04D5), int32_t(0x00000000)},
    {"bigfoot3.wav", "", int32_t(0xD6071AD5), int32_t(0x00000000)},
    {"bigfoot4.aud", "", int32_t(0xC61B04D5), int32_t(0x00000000)},
    {"bigggun1.aud", "railgun", int32_t(0x00000000), int32_t(0xB0735ED1)},
    {"bighurt1.aud", "", int32_t(0xC81B0AE1), int32_t(0x00000000)},
    {"bighurt2.aud", "", int32_t(0xCA1B0AE1), int32_t(0x00000000)},
    {"bigpot3.aud", "", int32_t(0x9DC822E8), int32_t(0x00000000)},
    {"bigpot4.aud", "", int32_t(0x9DCA22E8), int32_t(0x00000000)},
    {"bigrock1.aud", "", int32_t(0xF008ECD5), int32_t(0x00000000)},
    {"bigslam9.aud", "", int32_t(0x040CE8CF), int32_t(0x00000000)},
    {"bike.hva", "-", int32_t(0x00000000), int32_t(0xF9DB8864)},
    {"bike.shp", "recon bike", int32_t(0xDADEE5B2), int32_t(0x00000000)},
    {"bike.vxl", "attack cycle", int32_t(0x00000000), int32_t(0x0F51572D)},
    {"bikeicnh.des", "icon: recon bike", int32_t(0xF90EEFC9), int32_t(0x00000000)},
    {"bikeicnh.tem", "icon: recon bike", int32_t(0xF30EFFC9), int32_t(0x00000000)},
    {"bikeicnh.win", "icon: recon bike", int32_t(0xF41302C9), int32_t(0x00000000)},
    {"bikeicon.shp", "icon: recon bike", int32_t(0x0213FEC9), int32_t(0x00000000)},
    {"bikemix4.aud", "", int32_t(0xC232F8D1), int32_t(0x00000000)},
    {"bimbag1.aud", "", int32_t(0x65DC08CC), int32_t(0x00000000)},
    {"bimbook1.aud", "", int32_t(0xB02104D5), int32_t(0x00000000)},
    {"bimcomp1.aud", "", int32_t(0xB42B00D5), int32_t(0x00000000)},
    {"bimspel1.aud", "", int32_t(0xF422F0D7), int32_t(0x00000000)},
    {"binoc.vqa", "guy viewing tanks through binoculars", int32_t(0xDFE581D0), int32_t(0x00000000)},
    {"binoc.vqp", "vqp: guy viewing tanks through binoculars", int32_t(0xDFE581DF), int32_t(0x00000000)},
    {"bio.shp", "bio-research lab", int32_t(0x5CEEDAD7), int32_t(0x00000000)},
    {"bioicon.shp", "icon: bio-research lab", int32_t(0x822A0BE2), int32_t(0x00000000)},
    {"biomake.shp", "make: bio-research lab", int32_t(0x921803DE), int32_t(0x00000000)},
    {"bird1.aud", "", int32_t(0xBBCB81AF), int32_t(0x00000000)},
    {"bird2.aud", "", int32_t(0xBBCB81B1), int32_t(0x00000000)},
    {"birdnest.aud", "", int32_t(0xFE44F0D3), int32_t(0x00000000)},
    {"bits_a.pcx", "-", int32_t(0x00000000), int32_t(0xAC8A5DB2)},
    {"bits_i.pcx", "-", int32_t(0x00000000), int32_t(0x9F6513D5)},
    {"bkgdlg.pcx", "", int32_t(0x00000000), int32_t(0x613AF2D2)},
    {"bkgdlg.shp", "", int32_t(0x00000000), int32_t(0x685A8733)},
    {"bkgdlgy.shp", "", int32_t(0x00000000), int32_t(0x83911BAC)},
    {"bkgdmd.pcx", "", int32_t(0x00000000), int32_t(0x9C78E8D1)},
    {"bkgdmd.shp", "", int32_t(0x00000000), int32_t(0x95189D30)},
    {"bkgdmdy.shp", "", int32_t(0x00000000), int32_t(0x7ED301AF)},
    {"bkgdsm.pcx", "", int32_t(0x00000000), int32_t(0x60D18E1B)},
    {"bkgdsm.shp", "", int32_t(0x00000000), int32_t(0x69B1FBFA)},
    {"bkgdsmy.shp", "", int32_t(0x00000000), int32_t(0x827A6765)},
    {"bkground.vqa", "background on the conflict", int32_t(0x130B2DD5), int32_t(0x00000000)},
    {"bkground.vqp", "background on the conflict", int32_t(0x220B2DD5), int32_t(0x00000000)},
    {"blackout.vqa", "blackout of nod base", int32_t(0xF70125CD), int32_t(0x00000000)},
    {"blackout.vqp", "blackout of nod base", int32_t(0x060125CD), int32_t(0x00000000)},
    {"bladapr1.aud", "", int32_t(0xB7FF12B9), int32_t(0x00000000)},
    {"bladapr2.aud", "", int32_t(0xB9FF12B9), int32_t(0x00000000)},
    {"bladbrk1.aud", "", int32_t(0xB7F116BB), int32_t(0x00000000)},
    {"blade.tre", "", int32_t(0xB5AD8DD8), int32_t(0x00000000)},
    {"blade.trf", "", int32_t(0xB5AD8DD9), int32_t(0x00000000)},
    {"blade.trg", "", int32_t(0xB5AD8DDA), int32_t(0x00000000)},
    {"blade.tri", "", int32_t(0xB5AD8DDC), int32_t(0x00000000)},
    {"blade.trs", "", int32_t(0xB5AD8DE6), int32_t(0x00000000)},
    {"bladtrp1.aud", "", int32_t(0xB7FB16DF), int32_t(0x00000000)},
    {"bladtur1.aud", "", int32_t(0xB7FF1CDF), int32_t(0x00000000)},
    {"bladwood.aud", "", int32_t(0xDDF910E5), int32_t(0x00000000)},
    {"blank01.des", "", int32_t(0x00000000), int32_t(0x1B0C31CB)},
    {"blank01.lun", "", int32_t(0x00000000), int32_t(0x3DF2D648)},
    {"blank01.sno", "-", int32_t(0x00000000), int32_t(0x3CE0EC51)},
    {"blank01.tem", "-", int32_t(0x00000000), int32_t(0x9F54598B)},
    {"blank01.ubn", "", int32_t(0x00000000), int32_t(0x098A7BA8)},
    {"blank01.urb", "", int32_t(0x00000000), int32_t(0xB91997D4)},
    {"blankscreen.bmp", "", int32_t(0x00000000), int32_t(0x8E3252A4)},
    {"blat01.tem", "-", int32_t(0x00000000), int32_t(0xBEFD891B)},
    {"blat01a.tem", "-", int32_t(0x00000000), int32_t(0xFAD51AD7)},
    {"blat02.tem", "-", int32_t(0x00000000), int32_t(0x8F159386)},
    {"blat02a.tem", "-", int32_t(0x00000000), int32_t(0xCB3D004A)},
    {"blat03.tem", "-", int32_t(0x00000000), int32_t(0x29629832)},
    {"blat03a.tem", "-", int32_t(0x00000000), int32_t(0x6D4A0BFE)},
    {"blat04.tem", "-", int32_t(0x00000000), int32_t(0xECC5A6BC)},
    {"blat04a.tem", "-", int32_t(0x00000000), int32_t(0xA8ED3570)},
    {"blat05.tem", "-", int32_t(0x00000000), int32_t(0x4AB2AD08)},
    {"blat05a.tem", "-", int32_t(0x00000000), int32_t(0x0E9A3EC4)},
    {"blat06.tem", "-", int32_t(0x00000000), int32_t(0x7B5AB795)},
    {"blat06a.tem", "-", int32_t(0x00000000), int32_t(0x3F722459)},
    {"blat07.tem", "-", int32_t(0x00000000), int32_t(0xDD2DBC21)},
    {"blat07a.tem", "-", int32_t(0x00000000), int32_t(0x99052FED)},
    {"blat08.tem", "-", int32_t(0x00000000), int32_t(0x2B65CCC8)},
    {"blat08a.tem", "-", int32_t(0x00000000), int32_t(0x6F4D5F04)},
    {"blat09.tem", "-", int32_t(0x00000000), int32_t(0x8D12C77C)},
    {"blat09a.tem", "-", int32_t(0x00000000), int32_t(0xC93A54B0)},
    {"blat10.tem", "-", int32_t(0x00000000), int32_t(0xD4208231)},
    {"blat10a.tem", "-", int32_t(0x00000000), int32_t(0x900811FD)},
    {"blat11.tem", "-", int32_t(0x00000000), int32_t(0x72578985)},
    {"blat11a.tem", "-", int32_t(0x00000000), int32_t(0x367F1A49)},
    {"blat12.tem", "-", int32_t(0x00000000), int32_t(0x43BF9318)},
    {"blat12a.tem", "-", int32_t(0x00000000), int32_t(0x079700D4)},
    {"blat13.tem", "-", int32_t(0x00000000), int32_t(0xE5C898AC)},
    {"blat13a.tem", "-", int32_t(0x00000000), int32_t(0xA1E00B60)},
    {"blat14.tem", "-", int32_t(0x00000000), int32_t(0x206FA622)},
    {"blat14a.tem", "-", int32_t(0x00000000), int32_t(0x644735EE)},
    {"blat15.tem", "-", int32_t(0x00000000), int32_t(0x8618AD96)},
    {"blat15a.tem", "-", int32_t(0x00000000), int32_t(0xC2303E5A)},
    {"blat16.tem", "-", int32_t(0x00000000), int32_t(0xB7F0B70B)},
    {"blat16a.tem", "-", int32_t(0x00000000), int32_t(0xF3D824C7)},
    {"bld01.des", "", int32_t(0x00000000), int32_t(0xAB0E49E3)},
    {"bld01.sno", "-", int32_t(0x00000000), int32_t(0x2AB4A3E4)},
    {"bld01.tem", "-", int32_t(0x00000000), int32_t(0x36506968)},
    {"bld02.des", "", int32_t(0x00000000), int32_t(0x25814E00)},
    {"bld02.sno", "-", int32_t(0x00000000), int32_t(0xA43BA407)},
    {"bld02.tem", "-", int32_t(0x00000000), int32_t(0xB8DF6E8B)},
    {"bld03.des", "", int32_t(0x00000000), int32_t(0xE92B4E9E)},
    {"bld03.sno", "-", int32_t(0x00000000), int32_t(0x6891A499)},
    {"bld03.tem", "-", int32_t(0x00000000), int32_t(0x74756E15)},
    {"bldfeud.map", "", int32_t(0x00000000), int32_t(0x803A0100)},
    {"bldg1.aud", "unable to comply building in progress", int32_t(0xC7938DAF), int32_t(0x00000000)},
    {"bldginf1.aud", "building infiltrated", int32_t(0xC3F30EC9), int32_t(0x00000000)},
    {"bldging1.aud", "building", int32_t(0xC3F50EC9), int32_t(0x00000000)},
    {"bldgprg1.aud", "building in progress", int32_t(0xC3F516D7), int32_t(0x00000000)},
    {"bldsplt.flc", "", int32_t(0xA9FD15EF), int32_t(0x00000000)},
    {"bldsplt1.flc", "", int32_t(0xF3060FD7), int32_t(0x00000000)},
    {"bldsplt2.flc", "", int32_t(0xF5060FD7), int32_t(0x00000000)},
    {"bldsplt3.flc", "", int32_t(0xF7060FD7), int32_t(0x00000000)},
    {"bleep1.aud", "generic beep", int32_t(0x00000000), int32_t(0x3639BB6E)},
    {"bleep11.aud", "audf:", int32_t(0x71BBE8EA), int32_t(0x00000000)},
    {"bleep12.aud", "map sound #4", int32_t(0x71BDE8EA), int32_t(0x00000000)},
    {"bleep13.aud", "map sound #5", int32_t(0x71BFE8EA), int32_t(0x00000000)},
    {"bleep17.aud", "audf:", int32_t(0x71C7E8EA), int32_t(0x00000000)},
    {"bleep2.aud", "bleep 2", int32_t(0x9771D9FE), int32_t(0x00000000)},
    {"bleep2.juv", "bleep 2", int32_t(0xA971EBFE), int32_t(0x00000000)},
    {"bleep5.aud", "alarm", int32_t(0x9771DFFE), int32_t(0x00000000)},
    {"bleep6.aud", "radar map alert", int32_t(0x9771E1FE), int32_t(0x00000000)},
    {"bleep9.aud", "radar map power on", int32_t(0x9771E7FE), int32_t(0x00000000)},
    {"blip.aud", "", int32_t(0xE4E7D9B2), int32_t(0x1ABD82F9)},
    {"blizaxe1.aud", "", int32_t(0x100522B9), int32_t(0x00000000)},
    {"blizwnd1.aud", "", int32_t(0x10030EE5), int32_t(0x00000000)},
    {"blood1.aud", "", int32_t(0xBF99D7E6), int32_t(0x00000000)},
    {"blowitup.wav", "", int32_t(0x00000000), int32_t(0xC5313CEA)},
    {"blowout1.aud", "", int32_t(0x043B1CD5), int32_t(0x00000000)},
    {"blue01.tem", "-", int32_t(0x00000000), int32_t(0x2B03FEBB)},
    {"blue01a.tem", "-", int32_t(0x00000000), int32_t(0x6F2B6D77)},
    {"blue01b.tem", "-", int32_t(0x00000000), int32_t(0xE9BF1FD9)},
    {"blue01c.tem", "-", int32_t(0x00000000), int32_t(0x22E3CC7C)},
    {"blue01d.tem", "-", int32_t(0x00000000), int32_t(0x3FE6FCC4)},
    {"blue01e.tem", "-", int32_t(0x00000000), int32_t(0xF4BA2F61)},
    {"blue01f.tem", "-", int32_t(0x00000000), int32_t(0x722E5DCF)},
    {"blue01g.tem", "-", int32_t(0x00000000), int32_t(0xB9728E6A)},
    {"bmap.vqa", "dagger falls on map of europe & europe turns red", int32_t(0xE1D3F0B2), int32_t(0x00000000)},
    {"bmap.vqp", "vqp: dagger falls on map of europe & europe turns red", int32_t(0xF0D3F0B2), int32_t(0x00000000)},
    {"bnhi0020.pcx", "pict: guy viewing tanks through binoculars", int32_t(0xDDC8E997), int32_t(0x00000000)},
    {"bnkricon.shp", "", int32_t(0x00000000), int32_t(0x3E6D7CE0)},
    {"bnlo0020.cps", "pict: guy viewing tanks through binoculars", int32_t(0xF0E5DC97), int32_t(0x00000000)},
    {"boaratk1.aud", "", int32_t(0xEFF126B9), int32_t(0x00000000)},
    {"boaratk2.aud", "", int32_t(0xF1F126B9), int32_t(0x00000000)},
    {"boarcmb1.aud", "", int32_t(0xEFDF18BD), int32_t(0x00000000)},
    {"boarcmb2.aud", "", int32_t(0xF1DF18BD), int32_t(0x00000000)},
    {"boardie1.aud", "", int32_t(0xEFE510BF), int32_t(0x00000000)},
    {"boardie2.aud", "", int32_t(0xF1E510BF), int32_t(0x00000000)},
    {"boargore.aud", "", int32_t(0x17FF1CC5), int32_t(0x00000000)},
    {"boarhit1.aud", "", int32_t(0xF00310C7), int32_t(0x00000000)},
    {"boarhit2.aud", "", int32_t(0xF20310C7), int32_t(0x00000000)},
    {"boarloi1.aud", "", int32_t(0xEFED1CCF), int32_t(0x00000000)},
    {"boarloi2.aud", "", int32_t(0xF1ED1CCF), int32_t(0x00000000)},
    {"boarloi3.aud", "", int32_t(0xF3ED1CCF), int32_t(0x00000000)},
    {"boarrun1.aud", "", int32_t(0xEFF728DB), int32_t(0x00000000)},
    {"boarrun2.aud", "", int32_t(0xF1F728DB), int32_t(0x00000000)},
    {"boarstn1.aud", "", int32_t(0xEFF726DD), int32_t(0x00000000)},
    {"boarstn2.aud", "", int32_t(0xF1F726DD), int32_t(0x00000000)},
    {"boarwlk1.aud", "", int32_t(0xEFF116E5), int32_t(0x00000000)},
    {"boarwlk2.aud", "", int32_t(0xF1F116E5), int32_t(0x00000000)},
    {"boat.shp", "gunboat", int32_t(0xF8CAF1B2), int32_t(0x00000000)},
    {"boaticnh.des", "icon: gunboat", int32_t(0x34E707C9), int32_t(0x00000000)},
    {"boaticnh.tem", "icon: gunboat", int32_t(0x2EE717C9), int32_t(0x00000000)},
    {"boaticnh.win", "icon: gunboat", int32_t(0x2FEB1AC9), int32_t(0x00000000)},
    {"boaticon.shp", "icon: gunboat", int32_t(0x3DEC16C9), int32_t(0x00000000)},
    {"bodybags.vqa", "dead bodies in body bags", int32_t(0x4CF115BA), int32_t(0x00000000)},
    {"bodybags.vqp", "dead bodies in body bags", int32_t(0x5BF115BA), int32_t(0x00000000)},
    {"bog.aud", "bog", int32_t(0x5CD2F3C5), int32_t(0x00000000)},
    {"boilpot2.aud", "", int32_t(0xDA231CD7), int32_t(0x00000000)},
    {"bolticon.shp", "", int32_t(0x00000000), int32_t(0x6E25C1D3)},
    {"bomb.shp", "grenade", int32_t(0xD4E2F1B2), int32_t(0x50F0D1EF)},
    {"bomb1.aud", "bomb", int32_t(0xB3B799AF), int32_t(0x00000000)},
    {"bomb1.juv", "bomb", int32_t(0xB3C999C1), int32_t(0x00000000)},
    {"bombaway.vqa", "planes airstriking base", int32_t(0xFD0941B9), int32_t(0x00000000)},
    {"bombaway.vqp", "planes airstriking base", int32_t(0x0C0941B9), int32_t(0x00000000)},
    {"bombcurs.shp", "", int32_t(0x00000000), int32_t(0xECCB665C)},
    {"bombfail.aud", "", int32_t(0xE61D00C3), int32_t(0x00000000)},
    {"bombflee.vqa", "running away from bombers", int32_t(0xD5112BC3), int32_t(0x00000000)},
    {"bombflee.vqp", "running away from bombers", int32_t(0xE4112BC3), int32_t(0x00000000)},
    {"bombicnh.des", "icon: air strike", int32_t(0xED1707C9), int32_t(0x00000000)},
    {"bombicnh.tem", "icon: air strike", int32_t(0xE71717C9), int32_t(0x00000000)},
    {"bombicnh.win", "icon: air strike", int32_t(0xE81B1AC9), int32_t(0x00000000)},
    {"bombicon.shp", "icon: air strike", int32_t(0xF61C16C9), int32_t(0x00000000)},
    {"bombit1.aud", "commando present for ya", int32_t(0x65DC3ADC), int32_t(0x00000000)},
    {"bomblet.shp", "bomblet", int32_t(0x662E0FF4), int32_t(0x00000000)},
    {"bombrun.vqa", "badger blows up powerplant", int32_t(0x66133903), int32_t(0x00000000)},
    {"bombrun.vqp", "vqp: badger blows up powerplant", int32_t(0x66223903), int32_t(0x00000000)},
    {"bones1.aud", "", int32_t(0x9795E404), int32_t(0x00000000)},
    {"bones2.aud", "", int32_t(0x9795E604), int32_t(0x00000000)},
    {"bones3.aud", "", int32_t(0x9795E804), int32_t(0x00000000)},
    {"bones4.aud", "", int32_t(0x9795EA04), int32_t(0x00000000)},
    {"bones5.aud", "", int32_t(0x9795EC04), int32_t(0x00000000)},
    {"bones6.aud", "", int32_t(0x9795EE04), int32_t(0x00000000)},
    {"boneup1.aud", "", int32_t(0x71E032F4), int32_t(0x00000000)},
    {"bonfire1.aud", "", int32_t(0xC01922C9), int32_t(0x00000000)},
    {"bonus1.aud", "", int32_t(0xD795E404), int32_t(0x00000000)},
    {"bonus2.aud", "", int32_t(0xD795E604), int32_t(0x00000000)},
    {"bookhi.cps", "", int32_t(0xB39A22E9), int32_t(0x00000000)},
    {"booklow.cps", "", int32_t(0x8A3F2BE4), int32_t(0x00000000)},
    {"booloop2.aud", "", int32_t(0xDA331CD5), int32_t(0x00000000)},
    {"boop.aud", "stub sound used for all unsigned sound trigers", int32_t(0x00000000), int32_t(0xFD0C7B79)},
    {"borderb.shp", "", int32_t(0x6E1E29E6), int32_t(0x00000000)},
    {"borderh.shp", "", int32_t(0x6E2A29E6), int32_t(0x00000000)},
    {"borderh0.shp", "", int32_t(0xC22234C1), int32_t(0x00000000)},
    {"borderh1.shp", "", int32_t(0xC42234C1), int32_t(0x00000000)},
    {"borderh2.shp", "", int32_t(0xC62234C1), int32_t(0x00000000)},
    {"borderl.shp", "", int32_t(0x6E3229E6), int32_t(0x00000000)},
    {"borderm.shp", "", int32_t(0x6E3429E6), int32_t(0x00000000)},
    {"borders.pal", "", int32_t(0x6E3C22E3), int32_t(0x00000000)},
    {"borders.shp", "", int32_t(0x6E4029E6), int32_t(0x00000000)},
    {"bordert.shp", "", int32_t(0x6E4229E6), int32_t(0x00000000)},
    {"borderxl.shp", "", int32_t(0xFA4234C1), int32_t(0x00000000)},
    {"borderxs.shp", "", int32_t(0x084234C1), int32_t(0x00000000)},
    {"boris.shp", "", int32_t(0x00000000), int32_t(0x90405700)},
    {"bosnia.wsa", "anim: zoom on bosnia", int32_t(0xE7AA00EE), int32_t(0x00000000)},
    {"bottl03.flc", "", int32_t(0xADFAE9E7), int32_t(0x00000000)},
    {"bouldr1.aud", "", int32_t(0x8DFC36D2), int32_t(0x00000000)},
    {"bouldr2.aud", "", int32_t(0x8DFE36D2), int32_t(0x00000000)},
    {"bouldr3.aud", "", int32_t(0x8E0036D2), int32_t(0x00000000)},
    {"bouldr4.aud", "", int32_t(0x8E0236D2), int32_t(0x00000000)},
    {"bouldr5.aud", "", int32_t(0x8E0436D2), int32_t(0x00000000)},
    {"bouldr6.aud", "", int32_t(0x8E0636D2), int32_t(0x00000000)},
    {"bow1.aud", "", int32_t(0xA703DFB2), int32_t(0x00000000)},
    {"bow2.aud", "", int32_t(0xA903DFB2), int32_t(0x00000000)},
    {"bowhit1.aud", "", int32_t(0x7E043ADC), int32_t(0x00000000)},
    {"bowrels1.aud", "", int32_t(0xF05916C1), int32_t(0x00000000)},
    {"boxes01.int", "boxes #1", int32_t(0x7217EBF8), int32_t(0x00000000)},
    {"boxes02.int", "boxes #2", int32_t(0x7219EBF8), int32_t(0x00000000)},
    {"boxes03.int", "boxes #3", int32_t(0x721BEBF8), int32_t(0x00000000)},
    {"boxes04.int", "boxes #4", int32_t(0x721DEBF8), int32_t(0x00000000)},
    {"boxes05.int", "boxes #6", int32_t(0x721FEBF8), int32_t(0x00000000)},
    {"boxes06.int", "boxes #7", int32_t(0x7221EBF8), int32_t(0x00000000)},
    {"boxes07.int", "boxes #8", int32_t(0x7223EBF8), int32_t(0x00000000)},
    {"boxes08.int", "boxes #9", int32_t(0x7225EBF8), int32_t(0x00000000)},
    {"boxes09.int", "boxes #10", int32_t(0x7227EBF8), int32_t(0x00000000)},
    {"bpln.hva", "", int32_t(0x00000000), int32_t(0x614850D0)},
    {"bpln.vxl", "", int32_t(0x00000000), int32_t(0x97C28F99)},
    {"bplnicon.shp", "", int32_t(0x00000000), int32_t(0x6AC53931)},
    {"br003_1a.aud", "", int32_t(0x8779489D), int32_t(0x00000000)},
    {"br010_4a.aud", "", int32_t(0x8B7F4897), int32_t(0x00000000)},
    {"br011_2a.aud", "", int32_t(0x8B7B4899), int32_t(0x00000000)},
    {"br012_3b.aud", "", int32_t(0x8D7D489B), int32_t(0x00000000)},
    {"br013_3d.aud", "", int32_t(0x917D489D), int32_t(0x00000000)},
    {"br014_5a.aud", "", int32_t(0x8B81489F), int32_t(0x00000000)},
    {"br015_3c.aud", "", int32_t(0x8F7D48A1), int32_t(0x00000000)},
    {"br016_2b.aud", "", int32_t(0x8D7B48A3), int32_t(0x00000000)},
    {"br017_2a.aud", "", int32_t(0x8B7B48A5), int32_t(0x00000000)},
    {"br018_1p.aud", "", int32_t(0xA97948A7), int32_t(0x00000000)},
    {"br018_3e.aud", "", int32_t(0x937D48A7), int32_t(0x00000000)},
    {"br024_4b.aud", "", int32_t(0x917F489F), int32_t(0x00000000)},
    {"br025_5a.aud", "", int32_t(0x8F8148A1), int32_t(0x00000000)},
    {"br026_2a.aud", "", int32_t(0x8F7B48A3), int32_t(0x00000000)},
    {"br027_1p.aud", "", int32_t(0xAD7948A5), int32_t(0x00000000)},
    {"br027_3p.aud", "", int32_t(0xAD7D48A5), int32_t(0x00000000)},
    {"br028_2a.aud", "", int32_t(0x8F7B48A7), int32_t(0x00000000)},
    {"br029_3a.aud", "", int32_t(0x8F7D48A9), int32_t(0x00000000)},
    {"br030_3a.aud", "", int32_t(0x937D4897), int32_t(0x00000000)},
    {"br031_1p.aud", "", int32_t(0xB1794899), int32_t(0x00000000)},
    {"br032_7b.aud", "", int32_t(0x9585489B), int32_t(0x00000000)},
    {"br033_4b.aud", "", int32_t(0x957F489D), int32_t(0x00000000)},
    {"br034_1a.aud", "", int32_t(0x9379489F), int32_t(0x00000000)},
    {"br035_7b.aud", "", int32_t(0x958548A1), int32_t(0x00000000)},
    {"br1.des", "bush 1", int32_t(0x5CB5E9C8), int32_t(0x00000000)},
    {"br10.des", "purple squares", int32_t(0xB3A7E8B2), int32_t(0x00000000)},
    {"br1a.sno", "bridge", int32_t(0xD1B0F7B2), int32_t(0x00000000)},
    {"br1a.tem", "bridge", int32_t(0xCFA7F8B2), int32_t(0x00000000)},
    {"br1b.sno", "bridge", int32_t(0xD3B0F7B2), int32_t(0x00000000)},
    {"br1b.tem", "bridge", int32_t(0xD1A7F8B2), int32_t(0x00000000)},
    {"br1c.sno", "bridge", int32_t(0xD5B0F7B2), int32_t(0x00000000)},
    {"br1c.tem", "bridge", int32_t(0xD3A7F8B2), int32_t(0x00000000)},
    {"br1x.sno", "bridge segment", int32_t(0xFFB0F7B2), int32_t(0x00000000)},
    {"br1x.tem", "bridge segment", int32_t(0xFDA7F8B2), int32_t(0x00000000)},
    {"br2.des", "bush 2", int32_t(0x5CB7E9C8), int32_t(0x00000000)},
    {"br2a.sno", "bridge", int32_t(0xD1B2F7B2), int32_t(0x00000000)},
    {"br2a.tem", "bridge", int32_t(0xCFA9F8B2), int32_t(0x00000000)},
    {"br2b.sno", "bridge", int32_t(0xD3B2F7B2), int32_t(0x00000000)},
    {"br2b.tem", "bridge", int32_t(0xD1A9F8B2), int32_t(0x00000000)},
    {"br2c.sno", "bridge", int32_t(0xD5B2F7B2), int32_t(0x00000000)},
    {"br2c.tem", "bridge", int32_t(0xD3A9F8B2), int32_t(0x00000000)},
    {"br2x.sno", "bridge segment", int32_t(0xFFB2F7B2), int32_t(0x00000000)},
    {"br2x.tem", "bridge segment", int32_t(0xFDA9F8B2), int32_t(0x00000000)},
    {"br3.des", "cactus 1", int32_t(0x5CB9E9C8), int32_t(0x00000000)},
    {"br3a.sno", "bridge", int32_t(0xD1B4F7B2), int32_t(0x00000000)},
    {"br3a.tem", "bridge", int32_t(0xCFABF8B2), int32_t(0x00000000)},
    {"br3b.sno", "bridge", int32_t(0xD3B4F7B2), int32_t(0x00000000)},
    {"br3b.tem", "bridge", int32_t(0xD1ABF8B2), int32_t(0x00000000)},
    {"br3c.sno", "bridge", int32_t(0xD5B4F7B2), int32_t(0x00000000)},
    {"br3c.tem", "bridge", int32_t(0xD3ABF8B2), int32_t(0x00000000)},
    {"br3d.sno", "bridge", int32_t(0xD7B4F7B2), int32_t(0x00000000)},
    {"br3d.tem", "bridge", int32_t(0xD5ABF8B2), int32_t(0x00000000)},
    {"br3e.sno", "bridge", int32_t(0xD9B4F7B2), int32_t(0x00000000)},
    {"br3e.tem", "bridge", int32_t(0xD7ABF8B2), int32_t(0x00000000)},
    {"br3f.sno", "bridge", int32_t(0xDBB4F7B2), int32_t(0x00000000)},
    {"br3f.tem", "bridge", int32_t(0xD9ABF8B2), int32_t(0x00000000)},
    {"br4.des", "cactus 2", int32_t(0x5CBBE9C8), int32_t(0x00000000)},
    {"br5.des", "purple square", int32_t(0x5CBDE9C8), int32_t(0x00000000)},
    {"br6.des", "bushes 1", int32_t(0x5CBFE9C8), int32_t(0x00000000)},
    {"br7.des", "bushes 2", int32_t(0x5CC1E9C8), int32_t(0x00000000)},
    {"br8.des", "bushes 3", int32_t(0x5CC3E9C8), int32_t(0x00000000)},
    {"br9.des", "bushes 4", int32_t(0x5CC5E9C8), int32_t(0x00000000)},
    {"br_blues.aud", "", int32_t(0xF45D34CF), int32_t(0x00000000)},
    {"brainfre.wav", "", int32_t(0x00000000), int32_t(0x0CFBD6C3)},
    {"brainfry.aud", "", int32_t(0x1BFF16D3), int32_t(0x00000000)},
    {"brbed3.aud", "", int32_t(0x9765F3E6), int32_t(0x00000000)},
    {"brbed5.aud", "", int32_t(0x9765F7E6), int32_t(0x00000000)},
    {"brbed5x.aud", "", int32_t(0x71FE08D2), int32_t(0x00000000)},
    {"brckicon.shp", "", int32_t(0x00000000), int32_t(0x89359E32)},
    {"brdglok1.aud", "", int32_t(0xC3FD28CF), int32_t(0x00000000)},
    {"brdgtilt.vqa", "a bridge", int32_t(0x06FB31DF), int32_t(0x00000000)},
    {"brdgtilt.vqp", "vqp: a bridge", int32_t(0x15FB31DF), int32_t(0x00000000)},
    {"brdgtrn1.aud", "", int32_t(0xC4032EDF), int32_t(0x00000000)},
    {"breakr01.ubn", "", int32_t(0x00000000), int32_t(0x171295BD)},
    {"breakr01.urb", "", int32_t(0x00000000), int32_t(0x5466CBC7)},
    {"breakr02.ubn", "", int32_t(0x00000000), int32_t(0x50B2EF6D)},
    {"breakr02.urb", "", int32_t(0x00000000), int32_t(0x13C6B117)},
    {"breakr03.ubn", "", int32_t(0x00000000), int32_t(0x6DD2C6DD)},
    {"breakr03.urb", "", int32_t(0x00000000), int32_t(0x2EA698A7)},
    {"bridgb.des", "", int32_t(0x00000000), int32_t(0xF0272F94)},
    {"bridgb.lun", "", int32_t(0x00000000), int32_t(0x9907138D)},
    {"bridgb.sno", "", int32_t(0x00000000), int32_t(0x7708609B)},
    {"bridgb.tem", "", int32_t(0x00000000), int32_t(0x867F366C)},
    {"bridgb.ubn", "", int32_t(0x00000000), int32_t(0xBAEA0C9F)},
    {"bridgb.urb", "", int32_t(0x00000000), int32_t(0xFE5EB200)},
    {"bridge.des", "", int32_t(0x00000000), int32_t(0x3580111A)},
    {"bridge.lun", "", int32_t(0x00000000), int32_t(0x5CA02D03)},
    {"bridge.sno", "-", int32_t(0x00000000), int32_t(0xB2AF5E15)},
    {"bridge.tem", "-", int32_t(0x00000000), int32_t(0x43D808E2)},
    {"bridge.ubn", "", int32_t(0x00000000), int32_t(0x7F4D3211)},
    {"bridge.urb", "", int32_t(0x00000000), int32_t(0x3BF98C8E)},
    {"bridge1.sno", "bridge", int32_t(0x6DD721EA), int32_t(0x00000000)},
    {"bridge1.tem", "bridge sw-ne", int32_t(0x6DD518EB), int32_t(0x00000000)},
    {"bridge1.win", "bridge sw-ne", int32_t(0x6DD61CEE), int32_t(0x00000000)},
    {"bridge1d.sno", "bridge", int32_t(0xE8D626C5), int32_t(0x00000000)},
    {"bridge1d.tem", "bridge sw-ne destroyed", int32_t(0xE6CD27C5), int32_t(0x00000000)},
    {"bridge1d.win", "bridge sw-ne destroyed", int32_t(0xE7D12AC5), int32_t(0x00000000)},
    {"bridge1h.sno", "bridge", int32_t(0xF0D626C5), int32_t(0x00000000)},
    {"bridge1h.tem", "bridge", int32_t(0xEECD27C5), int32_t(0x00000000)},
    {"bridge1x.sno", "bridge segment", int32_t(0x10D626C5), int32_t(0x00000000)},
    {"bridge1x.tem", "bridge sw-ne connector", int32_t(0x0ECD27C5), int32_t(0x00000000)},
    {"bridge2.sno", "bridge", int32_t(0x6DD921EA), int32_t(0x00000000)},
    {"bridge2.tem", "bridge nw-se", int32_t(0x6DD718EB), int32_t(0x00000000)},
    {"bridge2.win", "bridge nw-se", int32_t(0x6DD81CEE), int32_t(0x00000000)},
    {"bridge2d.sno", "bridge", int32_t(0xE8D826C5), int32_t(0x00000000)},
    {"bridge2d.tem", "bridge nw-se destroyed", int32_t(0xE6CF27C5), int32_t(0x00000000)},
    {"bridge2d.win", "bridge nw-se destroyed", int32_t(0xE7D32AC5), int32_t(0x00000000)},
    {"bridge2h.sno", "bridge", int32_t(0xF0D826C5), int32_t(0x00000000)},
    {"bridge2h.tem", "bridge", int32_t(0xEECF27C5), int32_t(0x00000000)},
    {"bridge2x.sno", "bridge segment", int32_t(0x10D826C5), int32_t(0x00000000)},
    {"bridge2x.tem", "bridge nw-se connector", int32_t(0x0ECF27C5), int32_t(0x00000000)},
    {"bridge3.aud", "", int32_t(0x6DD028D8), int32_t(0x00000000)},
    {"bridge3.des", "bridge sw-ne desert", int32_t(0x6DDF18DB), int32_t(0x00000000)},
    {"bridge3d.des", "bridge sw-ne destroyed desert", int32_t(0xECD117C5), int32_t(0x00000000)},
    {"bridge4.des", "bridge nw-se desert", int32_t(0x6DE118DB), int32_t(0x00000000)},
    {"bridge4d.des", "bridge nw-se destroyed desert", int32_t(0xECD317C5), int32_t(0x00000000)},
    {"bridgegap.map", "", int32_t(0x00000000), int32_t(0xA0246ED5)},
    {"briefing.aud", "???", int32_t(0xE8171CC3), int32_t(0x00000000)},
    {"brigbrk2.aud", "", int32_t(0xC6112EBB), int32_t(0x00000000)},
    {"brigbrk3.aud", "", int32_t(0xC8112EBB), int32_t(0x00000000)},
    {"brigbrk4.aud", "", int32_t(0xCA112EBB), int32_t(0x00000000)},
    {"brigbrk5.aud", "", int32_t(0xCC112EBB), int32_t(0x00000000)},
    {"brigbrk6.aud", "", int32_t(0xCE112EBB), int32_t(0x00000000)},
    {"brigbrk7.aud", "", int32_t(0xD0112EBB), int32_t(0x00000000)},
    {"brigbrk8.aud", "", int32_t(0xD2112EBB), int32_t(0x00000000)},
    {"brigbrk9.aud", "", int32_t(0xD4112EBB), int32_t(0x00000000)},
    {"briggenr.pcx", "", int32_t(0x00000000), int32_t(0x8F5C9C61)},
    {"brik.shp", "concrete wall", int32_t(0xE6DAF7B2), int32_t(0x00000000)},
    {"brikicnh.des", "icon: concrete wall", int32_t(0x110713C9), int32_t(0x00000000)},
    {"brikicnh.tem", "icon: concrete wall", int32_t(0x0B0723C9), int32_t(0x00000000)},
    {"brikicnh.win", "icon: concrete wall", int32_t(0x0C0B26C9), int32_t(0x00000000)},
    {"brikicon.shp", "icon: concrete wall", int32_t(0x1A0C22C9), int32_t(0x00000000)},
    {"brisicon.shp", "", int32_t(0x00000000), int32_t(0x890FEE92)},
    {"brisuico.shp", "", int32_t(0x00000000), int32_t(0x4CC97C73)},
    {"brkfngr1.aud", "", int32_t(0xC02718D3), int32_t(0x00000000)},
    {"brkrope1.aud", "", int32_t(0xF00D2AD5), int32_t(0x00000000)},
    {"brl3.shp", "misc: barrels", int32_t(0xB6E0F7B2), int32_t(0x00000000)},
    {"brlogo_e.vqa", "", int32_t(0x09413DC5), int32_t(0x00000000)},
    {"brrkicon.shp", "icon: gdi barracks", int32_t(0x00000000), int32_t(0x415974E4)},
    {"brrlexp1.shp", "", int32_t(0x00000000), int32_t(0x9E4C0306)},
    {"brrlexp2.shp", "", int32_t(0x00000000), int32_t(0xD9EC79D6)},
    {"brtarget.aud", "", int32_t(0xF23118DB), int32_t(0x00000000)},
    {"brutdie.shp", "", int32_t(0x00000000), int32_t(0x2E7F504E)},
    {"brute.shp", "", int32_t(0x00000000), int32_t(0xF0A5583F)},
    {"bruticon.shp", "", int32_t(0x00000000), int32_t(0xD0FCE23D)},
    {"brutuico.shp", "", int32_t(0x00000000), int32_t(0x153A70DC)},
    {"brw_btn.shp", "", int32_t(0xDA4A39E0), int32_t(0x00000000)},
    {"brw_in.shp", "", int32_t(0x23BA35E2), int32_t(0x00000000)},
    {"brw_out.shp", "", int32_t(0xDA563BFA), int32_t(0x00000000)},
    {"brw_spin.shp", "", int32_t(0x6A383CDC), int32_t(0x00000000)},
    {"brwflash.shp", "", int32_t(0x00000000), int32_t(0x721470FA)},
    {"brwind2.aud", "", int32_t(0x820626E6), int32_t(0x00000000)},
    {"brwsopen.shp", "", int32_t(0x00000000), int32_t(0x81AAF37B)},
    {"bst-die.csv", "", int32_t(0x123232D4), int32_t(0x00000000)},
    {"bst-die.lsv", "", int32_t(0x123232DD), int32_t(0x00000000)},
    {"bst-die.vqa", "", int32_t(0x121D30E7), int32_t(0x00000000)},
    {"bst-die_e.vqa", "", int32_t(0x8A641BEE), int32_t(0x00000000)},
    {"bst-die_e.vqt", "", int32_t(0x8A641C01), int32_t(0x00000000)},
    {"bst-die_h.pcx", "", int32_t(0x6E581C0B), int32_t(0x00000000)},
    {"bst-die_h.vqa", "", int32_t(0x8A641BF4), int32_t(0x00000000)},
    {"bst-die_l.pcx", "", int32_t(0x6E581C13), int32_t(0x00000000)},
    {"bst-die_l.vqa", "", int32_t(0x8A641BFC), int32_t(0x00000000)},
    {"bst_chkd.pcx", "-", int32_t(0x00000000), int32_t(0xD16A353B)},
    {"bst_chkg.pcx", "-", int32_t(0x00000000), int32_t(0x96CA4FEB)},
    {"bst_uchk.pcx", "-", int32_t(0x00000000), int32_t(0x6D7DBC12)},
    {"bst_uckg.pcx", "-", int32_t(0x00000000), int32_t(0x2E1923BD)},
    {"bsub.hva", "", int32_t(0x00000000), int32_t(0xB189F41F)},
    {"bsub.vxl", "", int32_t(0x00000000), int32_t(0x47032B56)},
    {"bsubicon.shp", "", int32_t(0x00000000), int32_t(0xCEA80606)},
    {"bsubmisl.hva", "", int32_t(0x00000000), int32_t(0x4EC4958E)},
    {"bsubmisl.vxl", "", int32_t(0x00000000), int32_t(0xB84E4AC7)},
    {"bsubuico.shp", "", int32_t(0x00000000), int32_t(0x0B6E94E7)},
    {"btexture.shp", "background textures", int32_t(0x3C024EDF), int32_t(0x00000000)},
    {"btib01.sno", "", int32_t(0x00000000), int32_t(0x97B2816D)},
    {"btib01.tem", "", int32_t(0x00000000), int32_t(0x66C5D79A)},
    {"btib01.urb", "", int32_t(0x00000000), int32_t(0x1EE453F6)},
    {"btib02.sno", "", int32_t(0x00000000), int32_t(0xA65A9BF0)},
    {"btib02.tem", "", int32_t(0x00000000), int32_t(0x572DCD07)},
    {"btib02.urb", "", int32_t(0x00000000), int32_t(0x2F0C496B)},
    {"btib03.sno", "", int32_t(0x00000000), int32_t(0x002D9044)},
    {"btib03.tem", "", int32_t(0x00000000), int32_t(0xF15AC6B3)},
    {"btib03.urb", "", int32_t(0x00000000), int32_t(0x897B42DF)},
    {"btires02.vqa", "", int32_t(0xEED74DC1), int32_t(0x00000000)},
    {"btmfir02.flc", "", int32_t(0xC0E23BC9), int32_t(0x00000000)},
    {"btn-dn.shp", "butt: down", int32_t(0x5B963DD9), int32_t(0x00000000)},
    {"btn-mins.shp", "", int32_t(0xAC1E36D1), int32_t(0xC811F6CD)},
    {"btn-pl.shp", "butt: play", int32_t(0x5B9639F1), int32_t(0x00000000)},
    {"btn-plh.shp", "butt: play", int32_t(0x121A31FC), int32_t(0x00000000)},
    {"btn-plus.shp", "", int32_t(0xAC2C3CD7), int32_t(0x14860FC8)},
    {"btn-st.shp", "butt: stop", int32_t(0x5B9649F7), int32_t(0x00000000)},
    {"btn-sth.shp", "butt: stop", int32_t(0x121A4202), int32_t(0x00000000)},
    {"btn-up.shp", "butt: up", int32_t(0x5B9641FB), int32_t(0x00000000)},
    {"btransbt.shp", "", int32_t(0x00000000), int32_t(0xC7173D13)},
    {"btransmd.shp", "", int32_t(0x00000000), int32_t(0x56A11844)},
    {"btranstp.shp", "", int32_t(0x00000000), int32_t(0xE7187A55)},
    {"bttnbkgd.shp", "", int32_t(0x00000000), int32_t(0x26034352)},
    {"bubbles1.aud", "", int32_t(0xB00520CF), int32_t(0x00000000)},
    {"bubbly1.aud", "", int32_t(0x65B05CE2), int32_t(0x00000000)},
    {"bubbly2.aud", "", int32_t(0x65B25CE2), int32_t(0x00000000)},
    {"bubbly3.aud", "", int32_t(0x65B45CE2), int32_t(0x00000000)},
    {"bubbly4.aud", "", int32_t(0x65B65CE2), int32_t(0x00000000)},
    {"bud_li24.pcx", "-", int32_t(0x00000000), int32_t(0xB4D9DB4E)},
    {"bud_li30.pcx", "-", int32_t(0x00000000), int32_t(0x8A05AE2B)},
    {"bud_mi24.pcx", "-", int32_t(0x00000000), int32_t(0x7873DBD0)},
    {"bud_mi30.pcx", "-", int32_t(0x00000000), int32_t(0x46AFAEB5)},
    {"bud_ri24.pcx", "-", int32_t(0x00000000), int32_t(0xDDE8F857)},
    {"bud_ri30.pcx", "-", int32_t(0x00000000), int32_t(0xE3348D32)},
    {"buddylist.pal", "", int32_t(0x00000000), int32_t(0x5DFFBD3D)},
    {"buddylist.shp", "", int32_t(0x00000000), int32_t(0x3EC244D7)},
    {"bue_li24.pcx", "-", int32_t(0x00000000), int32_t(0x5B1BB070)},
    {"bue_li30.pcx", "-", int32_t(0x00000000), int32_t(0x65C7C515)},
    {"bue_mi24.pcx", "-", int32_t(0x00000000), int32_t(0x97B1B0EE)},
    {"bue_mi30.pcx", "-", int32_t(0x00000000), int32_t(0xA96DC58B)},
    {"bue_ri24.pcx", "-", int32_t(0x00000000), int32_t(0x322A9369)},
    {"bue_ri30.pcx", "-", int32_t(0x00000000), int32_t(0x0CF6E60C)},
    {"build5.aud", "building being placed", int32_t(0xB38203E6), int32_t(0x00000000)},
    {"buildngz.sha", "", int32_t(0x00000000), int32_t(0x3A1C917D)},
    {"buildngz.shp", "-", int32_t(0x00000000), int32_t(0x50ACB18F)},
    {"bully.wav", "", int32_t(0x00000000), int32_t(0x32FA5E9B)},
    {"bumsnor1.aud", "", int32_t(0xF42F34D3), int32_t(0x00000000)},
    {"bumsnor2.aud", "", int32_t(0xF62F34D3), int32_t(0x00000000)},
    {"bumsnor3.aud", "", int32_t(0xF82F34D3), int32_t(0x00000000)},
    {"bupp1.img", "", int32_t(0xDBD3B1B2), int32_t(0x00000000)},
    {"bupp1.lmf", "", int32_t(0xDBD9B1B1), int32_t(0x00000000)},
    {"bupp1.lsv", "", int32_t(0xE7D9B1C1), int32_t(0x00000000)},
    {"bupp1.odf", "", int32_t(0xC9DFB1B1), int32_t(0x00000000)},
    {"bupp1.pcx", "", int32_t(0xC7E1B1C3), int32_t(0x00000000)},
    {"bupp1.ver", "", int32_t(0xCBEDB1BD), int32_t(0x00000000)},
    {"burdet1.vqa", "greg burdette reports 1", int32_t(0x6DED4EE9), int32_t(0x00000000)},
    {"burdet1.vqp", "greg burdette reports 1", int32_t(0x6DFC4EE9), int32_t(0x00000000)},
    {"burdet2.vqa", "greg burdette reports 2", int32_t(0x6DEF4EE9), int32_t(0x00000000)},
    {"burdet2.vqp", "greg burdette reports 2", int32_t(0x6DFE4EE9), int32_t(0x00000000)},
    {"burn-l.shp", "medium fire for trees", int32_t(0xDFA63DAB), int32_t(0xDE355C13)},
    {"burn-m.shp", "small fire for trees", int32_t(0xDFA63FAB), int32_t(0x784257A7)},
    {"burn-s.shp", "small fire for trees", int32_t(0xDFA64BAB), int32_t(0x4FA3B034)},
    {"burn.wav", "", int32_t(0x00000000), int32_t(0x9B86F980)},
    {"burnt01.des", "", int32_t(0x00000000), int32_t(0xA7B5D2E9)},
    {"burnt01.lun", "", int32_t(0x00000000), int32_t(0x814B356A)},
    {"burnt01.sno", "-", int32_t(0x00000000), int32_t(0x80590F73)},
    {"burnt01.tem", "-", int32_t(0x00000000), int32_t(0x23EDBAA9)},
    {"burnt01.ubn", "", int32_t(0x00000000), int32_t(0xB533988A)},
    {"burnt01.urb", "", int32_t(0x00000000), int32_t(0x05A074F6)},
    {"burnt02.des", "", int32_t(0x00000000), int32_t(0x2121A047)},
    {"burnt02.lun", "", int32_t(0x00000000), int32_t(0x07DF47C4)},
    {"burnt02.sno", "-", int32_t(0x00000000), int32_t(0x06CD7DDD)},
    {"burnt02.tem", "-", int32_t(0x00000000), int32_t(0xA579C807)},
    {"burnt02.ubn", "", int32_t(0x00000000), int32_t(0x33A7EA24)},
    {"burnt02.urb", "", int32_t(0x00000000), int32_t(0x83340658)},
    {"burnt03.des", "", int32_t(0x00000000), int32_t(0xEA7D73E2)},
    {"burnt03.lun", "", int32_t(0x00000000), int32_t(0xCC839461)},
    {"burnt03.sno", "-", int32_t(0x00000000), int32_t(0xCD91AE78)},
    {"burnt03.tem", "-", int32_t(0x00000000), int32_t(0x6E251BA2)},
    {"burnt03.ubn", "", int32_t(0x00000000), int32_t(0xF8FB3981)},
    {"burnt03.urb", "", int32_t(0x00000000), int32_t(0x4868D5FD)},
    {"burnt04.des", "", int32_t(0x00000000), int32_t(0xF778435A)},
    {"burnt04.lun", "", int32_t(0x00000000), int32_t(0xD186A4D9)},
    {"burnt04.sno", "-", int32_t(0x00000000), int32_t(0xD0949EC0)},
    {"burnt04.tem", "-", int32_t(0x00000000), int32_t(0x73202B1A)},
    {"burnt04.ubn", "", int32_t(0x00000000), int32_t(0xE5FE0939)},
    {"burnt04.urb", "", int32_t(0x00000000), int32_t(0x556DE545)},
    {"burnt05.des", "", int32_t(0x00000000), int32_t(0x3C2490FF)},
    {"burnt05.lun", "", int32_t(0x00000000), int32_t(0x1ADA777C)},
    {"burnt05.sno", "-", int32_t(0x00000000), int32_t(0x1BC84D65)},
    {"burnt05.tem", "-", int32_t(0x00000000), int32_t(0xB87CF8BF)},
    {"burnt05.ubn", "", int32_t(0x00000000), int32_t(0x2EA2DA9C)},
    {"burnt05.urb", "", int32_t(0x00000000), int32_t(0x9E3136E0)},
    {"burnt06.des", "", int32_t(0x00000000), int32_t(0xBAB0E251)},
    {"burnt06.lun", "", int32_t(0x00000000), int32_t(0x9C4E05D2)},
    {"burnt06.sno", "-", int32_t(0x00000000), int32_t(0x9D5C3FCB)},
    {"burnt06.tem", "-", int32_t(0x00000000), int32_t(0x3EE88A11)},
    {"burnt06.ubn", "", int32_t(0x00000000), int32_t(0xA836A832)},
    {"burnt06.urb", "", int32_t(0x00000000), int32_t(0x18A5444E)},
    {"burnt07.des", "", int32_t(0x00000000), int32_t(0x71EC31F4)},
    {"burnt07.lun", "", int32_t(0x00000000), int32_t(0x5712D677)},
    {"burnt07.sno", "-", int32_t(0x00000000), int32_t(0x5600EC6E)},
    {"burnt07.tem", "-", int32_t(0x00000000), int32_t(0xF5B459B4)},
    {"burnt07.ubn", "", int32_t(0x00000000), int32_t(0x636A7B97)},
    {"burnt07.urb", "", int32_t(0x00000000), int32_t(0xD3F997EB)},
    {"burnt08.des", "", int32_t(0x00000000), int32_t(0x80BA8321)},
    {"burnt08.lun", "", int32_t(0x00000000), int32_t(0xA64464A2)},
    {"burnt08.sno", "-", int32_t(0x00000000), int32_t(0xA7565EBB)},
    {"burnt08.tem", "-", int32_t(0x00000000), int32_t(0x04E2EB61)},
    {"burnt08.ubn", "", int32_t(0x00000000), int32_t(0x923CC942)},
    {"burnt08.urb", "", int32_t(0x00000000), int32_t(0x22AF253E)},
    {"burnt09.des", "", int32_t(0x00000000), int32_t(0x4BE65084)},
    {"burnt09.lun", "", int32_t(0x00000000), int32_t(0x6D18B707)},
    {"burnt09.sno", "-", int32_t(0x00000000), int32_t(0x6C0A8D1E)},
    {"burnt09.tem", "-", int32_t(0x00000000), int32_t(0xCFBE38C4)},
    {"burnt09.ubn", "", int32_t(0x00000000), int32_t(0x59601AE7)},
    {"burnt09.urb", "", int32_t(0x00000000), int32_t(0xE9F3F69B)},
    {"burnt10.des", "", int32_t(0x00000000), int32_t(0xCA9E0AF8)},
    {"burnt10.lun", "", int32_t(0x00000000), int32_t(0xEC60ED7B)},
    {"burnt10.sno", "-", int32_t(0x00000000), int32_t(0xED72D762)},
    {"burnt10.tem", "-", int32_t(0x00000000), int32_t(0x4EC662B8)},
    {"burnt10.ubn", "", int32_t(0x00000000), int32_t(0xD818409B)},
    {"burnt10.urb", "", int32_t(0x00000000), int32_t(0x688BACE7)},
    {"burnt11.des", "", int32_t(0x00000000), int32_t(0x01C2D95D)},
    {"burnt11.lun", "", int32_t(0x00000000), int32_t(0x273C3EDE)},
    {"burnt11.sno", "-", int32_t(0x00000000), int32_t(0x262E04C7)},
    {"burnt11.tem", "-", int32_t(0x00000000), int32_t(0x859AB11D)},
    {"burnt11.ubn", "", int32_t(0x00000000), int32_t(0x1344933E)},
    {"burnt11.urb", "", int32_t(0x00000000), int32_t(0xA3D77F42)},
    {"burnt12.des", "", int32_t(0x00000000), int32_t(0x8756ABF3)},
    {"burnt12.lun", "", int32_t(0x00000000), int32_t(0xA1A84C70)},
    {"burnt12.sno", "-", int32_t(0x00000000), int32_t(0xA0BA7669)},
    {"burnt12.tem", "-", int32_t(0x00000000), int32_t(0x030EC3B3)},
    {"burnt12.ubn", "", int32_t(0x00000000), int32_t(0x95D0E190)},
    {"burnt12.urb", "", int32_t(0x00000000), int32_t(0x25430DEC)},
    {"bus.hva", "-", int32_t(0x00000000), int32_t(0xCD663AFB)},
    {"bus.vxl", "school bus", int32_t(0x00000000), int32_t(0xC2904910)},
    {"butn4p.aud", "", int32_t(0xBBAE39C6), int32_t(0x00000000)},
    {"butn4r.aud", "", int32_t(0xBBAE3DC6), int32_t(0x00000000)},
    {"butn5p.aud", "", int32_t(0xBBAE39C8), int32_t(0x00000000)},
    {"butn5r.aud", "", int32_t(0xBBAE3DC8), int32_t(0x00000000)},
    {"butn6.aud", "", int32_t(0xE3D3B1B9), int32_t(0x00000000)},
    {"button.aud", "button", int32_t(0xD3AE35FC), int32_t(0x2FEE7E81)},
    {"button.juv", "button", int32_t(0xE5AE47FC), int32_t(0x00000000)},
    {"button.shp", "", int32_t(0xF7AE41EF), int32_t(0xEF945254)},
    {"button.wav", "", int32_t(0xFFAE47E8), int32_t(0x00000000)},
    {"button00.shp", "", int32_t(0x00000000), int32_t(0x0D2B157D)},
    {"button01.shp", "", int32_t(0x00000000), int32_t(0x304B3CCD)},
    {"button02.shp", "", int32_t(0x00000000), int32_t(0x77EB461D)},
    {"button03.shp", "", int32_t(0x00000000), int32_t(0x4A8B6FAD)},
    {"button04.shp", "", int32_t(0x00000000), int32_t(0xF8ABB3BD)},
    {"button05.shp", "", int32_t(0x00000000), int32_t(0xC5CB9A0D)},
    {"button06.shp", "", int32_t(0x00000000), int32_t(0x826BE0DD)},
    {"button07.shp", "", int32_t(0x00000000), int32_t(0xBF0BC96D)},
    {"button08.shp", "", int32_t(0x00000000), int32_t(0x3D5B5EBC)},
    {"button09.shp", "", int32_t(0x00000000), int32_t(0x003B770C)},
    {"button10.shp", "", int32_t(0x00000000), int32_t(0xC677C6D8)},
    {"button11.shp", "", int32_t(0x00000000), int32_t(0xFB17EF68)},
    {"buttonin.shp", "", int32_t(0x00000000), int32_t(0x67E417DA)},
    {"buttonmv.aud", "", int32_t(0x00000000), int32_t(0x56F146F0)},
    {"buttons.shp", "", int32_t(0xAE4839FA), int32_t(0x00000000)},
    {"buzzy1.aud", "alarm", int32_t(0xEBC5FC10), int32_t(0x00000000)},
    {"bwdt.pcx", "-", int32_t(0x00000000), int32_t(0x2307DF0C)},
    {"bwdth.pcx", "-", int32_t(0x00000000), int32_t(0x20696210)},
    {"c1.shp", "civilian #1", int32_t(0xA65CB2CE), int32_t(0x00000000)},
    {"c10.shp", "civilian #10", int32_t(0x5CB0AAD9), int32_t(0x00000000)},
    {"c1480103e.aud", "", int32_t(0x38E4ABA9), int32_t(0x00000000)},
    {"c17.shp", "antonov cargo plane", int32_t(0x5CBEAAD9), int32_t(0x00000000)},
    {"c17icon.shp", "icon: antonov cargo plane", int32_t(0x81C9ABE6), int32_t(0x00000000)},
    {"c1a01md.map", "", int32_t(0x00000000), int32_t(0x37926E43)},
    {"c1a02md.map", "", int32_t(0x00000000), int32_t(0xB91D69A0)},
    {"c1a03md.map", "", int32_t(0x00000000), int32_t(0x75B7693E)},
    {"c1m1c.map", "", int32_t(0x00000000), int32_t(0x7218E983)},
    {"c1m2a.map", "", int32_t(0x00000000), int32_t(0x09B0D23B)},
    {"c1m3b.map", "", int32_t(0x00000000), int32_t(0x9044C19B)},
    {"c1m4c.map", "", int32_t(0x00000000), int32_t(0x388FACCC)},
    {"c1m5c.map", "", int32_t(0x00000000), int32_t(0x2FF4B88F)},
    {"c2.shp", "civilian #2", int32_t(0xA65CB4CE), int32_t(0x00000000)},
    {"c221455203e.aud", "", int32_t(0xAF35228B), int32_t(0x00000000)},
    {"c2m1c.map", "", int32_t(0x00000000), int32_t(0xEBFA8F82)},
    {"c2m2b.map", "", int32_t(0x00000000), int32_t(0x1EDDB3D9)},
    {"c2m3c.map", "", int32_t(0x00000000), int32_t(0xC50CA704)},
    {"c2m4b.map", "", int32_t(0x00000000), int32_t(0x6DC7CA53)},
    {"c2m5a.map", "", int32_t(0x00000000), int32_t(0xF433D9F3)},
    {"c2s01md.map", "", int32_t(0x00000000), int32_t(0x8D2B5997)},
    {"c2s02md.map", "", int32_t(0x00000000), int32_t(0x03A45E74)},
    {"c2s03md.map", "", int32_t(0x00000000), int32_t(0xCF0E5EEA)},
    {"c3.shp", "civilian #3", int32_t(0xA65CB6CE), int32_t(0x00000000)},
    {"c3m1a.map", "", int32_t(0x00000000), int32_t(0x6851573F)},
    {"c3m2a.map", "", int32_t(0x00000000), int32_t(0x51DC6BFA)},
    {"c3m3c.map", "", int32_t(0x00000000), int32_t(0x048278C4)},
    {"c3m4c.map", "", int32_t(0x00000000), int32_t(0x60E3150D)},
    {"c3m5b.map", "", int32_t(0x00000000), int32_t(0xBB3201D0)},
    {"c3y01md.map", "", int32_t(0x00000000), int32_t(0x5B87169E)},
    {"c3y02md.map", "", int32_t(0x00000000), int32_t(0xD508117D)},
    {"c3y03md.map", "", int32_t(0x00000000), int32_t(0x19A211E3)},
    {"c4.shp", "civilian #4", int32_t(0xA65CB8CE), int32_t(0x00000000)},
    {"c4m1a.map", "", int32_t(0x00000000), int32_t(0x416A42BC)},
    {"c4m2c.map", "", int32_t(0x00000000), int32_t(0x3AC27904)},
    {"c4m3a.map", "", int32_t(0x00000000), int32_t(0x6F9C6A3A)},
    {"c4m4c.map", "", int32_t(0x00000000), int32_t(0x49D8008E)},
    {"c4m5c.map", "", int32_t(0x00000000), int32_t(0x5EA314CD)},
    {"c4w01md.map", "", int32_t(0x00000000), int32_t(0x6C7533AE)},
    {"c5.shp", "civilian #5", int32_t(0xA65CBACE), int32_t(0x00000000)},
    {"c5m1c.map", "", int32_t(0x00000000), int32_t(0xC2C19A01)},
    {"c5m2b.map", "", int32_t(0x00000000), int32_t(0x37E6A65A)},
    {"c5m3c.map", "", int32_t(0x00000000), int32_t(0xEC37B287)},
    {"c5m4a.map", "", int32_t(0x00000000), int32_t(0xCA73D833)},
    {"c5m5b.map", "", int32_t(0x00000000), int32_t(0x5387CB93)},
    {"c6.shp", "civilian #6", int32_t(0xA65CBCCE), int32_t(0x00000000)},
    {"c7.shp", "civilian #7", int32_t(0xA65CBECE), int32_t(0x00000000)},
    {"c8.shp", "civilian #8", int32_t(0xA65CC0CE), int32_t(0x00000000)},
    {"c9.shp", "civilian #9", int32_t(0xA65CC2CE), int32_t(0x00000000)},
    {"c_armgd1.aud", "", int32_t(0xEFE34CD5), int32_t(0x00000000)},
    {"c_armor1.aud", "", int32_t(0xEFFF5CD5), int32_t(0x00000000)},
    {"c_drk1.aud", "", int32_t(0xCB6E23F8), int32_t(0x00000000)},
    {"c_heal1.aud", "", int32_t(0x71C86AD0), int32_t(0x00000000)},
    {"c_hello1.aud", "", int32_t(0xBC1556D3), int32_t(0x00000000)},
    {"c_ion1.aud", "", int32_t(0xBF8223FE), int32_t(0x00000000)},
    {"c_kodiak.shp", "-", int32_t(0x00000000), int32_t(0x5AA02A3D)},
    {"c_loser1.aud", "", int32_t(0xE42B48E1), int32_t(0x00000000)},
    {"c_mapup1.aud", "", int32_t(0xAC2B68DB), int32_t(0x00000000)},
    {"c_megaa1.aud", "", int32_t(0xBC0D40C9), int32_t(0x00000000)},
    {"c_megarr.aud", "", int32_t(0xFE2F40C9), int32_t(0x00000000)},
    {"c_megas1.aud", "", int32_t(0xBC3140C9), int32_t(0x00000000)},
    {"c_megaw1.aud", "", int32_t(0xBC3940C9), int32_t(0x00000000)},
    {"c_mgarng.aud", "", int32_t(0xF02762BD), int32_t(0x00000000)},
    {"c_nap1.aud", "", int32_t(0x87962402), int32_t(0x00000000)},
    {"c_nap2.aud", "", int32_t(0x87962602), int32_t(0x00000000)},
    {"c_nap3.aud", "", int32_t(0x87962802), int32_t(0x00000000)},
    {"c_nuke1.aud", "", int32_t(0xB1E05CE4), int32_t(0x00000000)},
    {"c_radar1.aud", "", int32_t(0xAC4340C3), int32_t(0x00000000)},
    {"c_ran1.aud", "", int32_t(0x87A623FE), int32_t(0x00000000)},
    {"c_ran10.aud", "", int32_t(0x61EE34EA), int32_t(0x00000000)},
    {"c_ran11.aud", "", int32_t(0x61F034EA), int32_t(0x00000000)},
    {"c_ran2.aud", "", int32_t(0x87A625FE), int32_t(0x00000000)},
    {"c_ran3.aud", "", int32_t(0x87A627FE), int32_t(0x00000000)},
    {"c_ran4.aud", "", int32_t(0x87A629FE), int32_t(0x00000000)},
    {"c_ran5.aud", "", int32_t(0x87A62BFE), int32_t(0x00000000)},
    {"c_ran6.aud", "", int32_t(0x87A62DFE), int32_t(0x00000000)},
    {"c_ran7.aud", "", int32_t(0x87A62FFE), int32_t(0x00000000)},
    {"c_ran8.aud", "", int32_t(0x87A631FE), int32_t(0x00000000)},
    {"c_ran9.aud", "", int32_t(0x87A633FE), int32_t(0x00000000)},
    {"c_range1.aud", "", int32_t(0xAC294CD7), int32_t(0x00000000)},
    {"c_rapid1.aud", "", int32_t(0xAC2750DB), int32_t(0x00000000)},
    {"c_shadow.shp", "-", int32_t(0x00000000), int32_t(0xBC95F2BF)},
    {"c_sorry1.aud", "", int32_t(0xE45562DF), int32_t(0x00000000)},
    {"c_speed1.aud", "", int32_t(0xE82B48C5), int32_t(0x00000000)},
    {"c_stlall.aud", "", int32_t(0x2E3B40D3), int32_t(0x00000000)},
    {"c_stltha.aud", "", int32_t(0x183366D3), int32_t(0x00000000)},
    {"c_stlthd.aud", "", int32_t(0x1E3366D3), int32_t(0x00000000)},
    {"c_telep1.aud", "", int32_t(0xBC4748D3), int32_t(0x00000000)},
    {"c_unit1.aud", "", int32_t(0x95FC7AE0), int32_t(0x00000000)},
    {"c_weapn1.aud", "", int32_t(0xBC4F5EBD), int32_t(0x00000000)},
    {"ca.shp", "unit: cruiser", int32_t(0xA65CD2CE), int32_t(0x00000000)},
    {"ca0001.shp", "-", int32_t(0x00000000), int32_t(0xDCCDFE2E)},
    {"ca0002.shp", "-", int32_t(0x00000000), int32_t(0xED25E4B3)},
    {"ca0003.shp", "-", int32_t(0x00000000), int32_t(0x4B52EF07)},
    {"ca0004.shp", "-", int32_t(0x00000000), int32_t(0x8EF5D189)},
    {"ca0005.shp", "-", int32_t(0x00000000), int32_t(0x2882DA3D)},
    {"ca0006.shp", "-", int32_t(0x00000000), int32_t(0x196AC0A0)},
    {"ca0007.shp", "-", int32_t(0x00000000), int32_t(0xBF1DCB14)},
    {"ca0008.shp", "-", int32_t(0x00000000), int32_t(0x4955BBFD)},
    {"ca0009.shp", "-", int32_t(0x00000000), int32_t(0xEF22B049)},
    {"ca0010.shp", "-", int32_t(0x00000000), int32_t(0xB610F504)},
    {"ca0011.shp", "-", int32_t(0x00000000), int32_t(0x1067FEB0)},
    {"ca0012.shp", "-", int32_t(0x00000000), int32_t(0x218FE42D)},
    {"ca0013.shp", "-", int32_t(0x00000000), int32_t(0x87F8EF99)},
    {"ca0014.shp", "-", int32_t(0x00000000), int32_t(0x425FD117)},
    {"ca0015.shp", "-", int32_t(0x00000000), int32_t(0xE428DAA3)},
    {"ca0016.shp", "-", int32_t(0x00000000), int32_t(0xD5C0C03E)},
    {"ca0017.shp", "-", int32_t(0x00000000), int32_t(0x73B7CB8A)},
    {"ca0018.shp", "-", int32_t(0x00000000), int32_t(0x85FFBB63)},
    {"ca0019.shp", "-", int32_t(0x00000000), int32_t(0x2388B0D7)},
    {"ca0020.shp", "-", int32_t(0x00000000), int32_t(0x389FF2E7)},
    {"ca0021.shp", "-", int32_t(0x00000000), int32_t(0x9EE8F953)},
    {"caairp.shp", "", int32_t(0x00000000), int32_t(0x26498591)},
    {"caairp_a.shp", "", int32_t(0x00000000), int32_t(0xF9E6B648)},
    {"caairp_f.shp", "", int32_t(0x00000000), int32_t(0x4BC66A58)},
    {"caaray.shp", "-", int32_t(0x00000000), int32_t(0x6F702A26)},
    {"caaray_a.shp", "-", int32_t(0x00000000), int32_t(0xB0DF19FF)},
    {"caaray_b.shp", "-", int32_t(0x00000000), int32_t(0xF77F632F)},
    {"caaray_c.shp", "-", int32_t(0x00000000), int32_t(0xCA1F4A9F)},
    {"caaray_d.shp", "-", int32_t(0x00000000), int32_t(0x783F968F)},
    {"caarmr.shp", "-", int32_t(0x00000000), int32_t(0x3AD86B93)},
    {"caarmr_a.shp", "-", int32_t(0x00000000), int32_t(0xE577584A)},
    {"caarmy01.shp", "", int32_t(0x00000000), int32_t(0xE70051F0)},
    {"caarmy02.shp", "", int32_t(0x00000000), int32_t(0xA0A02B20)},
    {"caarmy03.shp", "", int32_t(0x00000000), int32_t(0x9DC00290)},
    {"caarmy04.shp", "", int32_t(0x00000000), int32_t(0x2FE0DE80)},
    {"cabarn02.shp", "", int32_t(0x00000000), int32_t(0xD9386F50)},
    {"cabarr01.shp", "", int32_t(0x00000000), int32_t(0x3EE6E33A)},
    {"cabarr02.shp", "", int32_t(0x00000000), int32_t(0x794699EA)},
    {"cabhut.shp", "-", int32_t(0x00000000), int32_t(0x248F07DB)},
    {"cabunk01.shp", "", int32_t(0x00000000), int32_t(0x16980D3E)},
    {"cabunk02.shp", "", int32_t(0x00000000), int32_t(0x513877EE)},
    {"cabunk03.shp", "", int32_t(0x00000000), int32_t(0x6C585E5E)},
    {"cabunk04.shp", "", int32_t(0x00000000), int32_t(0xDE78824E)},
    {"cache.mix", "-", int32_t(0x00000000), int32_t(0x3B5A96DE)},
    {"cachemd.mix", "", int32_t(0x00000000), int32_t(0x68EEC99A)},
    {"cachig01.shp", "", int32_t(0x00000000), int32_t(0x69B0A04B)},
    {"cachig02.shp", "", int32_t(0x00000000), int32_t(0x2E10DA9B)},
    {"cachig03.shp", "", int32_t(0x00000000), int32_t(0x1370F32B)},
    {"cachig05.shp", "", int32_t(0x00000000), int32_t(0x9C30068B)},
    {"cachig05d.shp", "", int32_t(0x00000000), int32_t(0xD76431BE)},
    {"cacity01.shp", "", int32_t(0x00000000), int32_t(0xAE947761)},
    {"cacity02.shp", "", int32_t(0x00000000), int32_t(0xE9340DB1)},
    {"cacity03.shp", "", int32_t(0x00000000), int32_t(0xD4542401)},
    {"cacity04.shp", "", int32_t(0x00000000), int32_t(0x6674F811)},
    {"cacolo01.shp", "", int32_t(0x00000000), int32_t(0x76DE8D81)},
    {"cacrsh01.shp", "-", int32_t(0x00000000), int32_t(0x4B6D35AE)},
    {"cacrsh02.shp", "-", int32_t(0x00000000), int32_t(0x0CCD4F7E)},
    {"cacrsh03.shp", "-", int32_t(0x00000000), int32_t(0x31AD66CE)},
    {"cacrsh04.shp", "-", int32_t(0x00000000), int32_t(0x838DBADE)},
    {"cacrsh05.shp", "-", int32_t(0x00000000), int32_t(0xBEED936E)},
    {"cacufgl.shp", "", int32_t(0x00000000), int32_t(0x8A1076EF)},
    {"cacufgl_a.shp", "", int32_t(0x00000000), int32_t(0x3B030823)},
    {"cadam.shp", "-", int32_t(0x00000000), int32_t(0xA1CA40C7)},
    {"cadam_a.shp", "-", int32_t(0x00000000), int32_t(0x2C25A3CA)},
    {"cadam_b.shp", "-", int32_t(0x00000000), int32_t(0xAAB1D164)},
    {"caeast01.shp", "", int32_t(0x00000000), int32_t(0x7340CDE7)},
    {"caeast01dm.shp", "", int32_t(0x00000000), int32_t(0x5D04F438)},
    {"caeast02.shp", "", int32_t(0x00000000), int32_t(0x34E0B737)},
    {"caegyp01.shp", "", int32_t(0x00000000), int32_t(0x65D58CB6)},
    {"caegyp02.shp", "", int32_t(0x00000000), int32_t(0x2275F666)},
    {"caegyp03.shp", "", int32_t(0x00000000), int32_t(0x1F15DFD6)},
    {"caeur04.shp", "", int32_t(0x00000000), int32_t(0xB1415870)},
    {"caeur1.shp", "", int32_t(0x00000000), int32_t(0x4897D3DF)},
    {"caeur2.shp", "", int32_t(0x00000000), int32_t(0x797FC942)},
    {"caeuro05.shp", "", int32_t(0x00000000), int32_t(0xDE9FB0F0)},
    {"cafarm01.shp", "", int32_t(0x00000000), int32_t(0xA69BAF67)},
    {"cafarm02.shp", "", int32_t(0x00000000), int32_t(0xE13BD5B7)},
    {"cafarm06.shp", "", int32_t(0x00000000), int32_t(0x14BB7377)},
    {"cafncb.shp", "", int32_t(0x00000000), int32_t(0xE0A44F73)},
    {"cafncp.shp", "", int32_t(0x00000000), int32_t(0x10E5C294)},
    {"cafncw.shp", "", int32_t(0x00000000), int32_t(0xD542FC1A)},
    {"cafrfgl.shp", "", int32_t(0x00000000), int32_t(0x0858D062)},
    {"cafrfgl_a.shp", "", int32_t(0x00000000), int32_t(0xC2D36016)},
    {"cafrma.shp", "", int32_t(0x00000000), int32_t(0x8E32F6B9)},
    {"cafrmb.shp", "", int32_t(0x00000000), int32_t(0xBFDAEC24)},
    {"cagard01.shp", "", int32_t(0x00000000), int32_t(0xDCC1818A)},
    {"cagard03.shp", "", int32_t(0x00000000), int32_t(0xA601D2EA)},
    {"cagas01.shp", "", int32_t(0x00000000), int32_t(0xD8FF0A1D)},
    {"cagefgl.shp", "", int32_t(0x00000000), int32_t(0x2F3B94E4)},
    {"cagefgl_a.shp", "", int32_t(0x00000000), int32_t(0x96A821E2)},
    {"cagrd1_a.shp", "", int32_t(0x00000000), int32_t(0x4D78655E)},
    {"cahead.hva", "", int32_t(0x00000000), int32_t(0x1DD0A141)},
    {"cahead.vxl", "", int32_t(0x00000000), int32_t(0xCDBF41C5)},
    {"caheaddm.hva", "", int32_t(0x00000000), int32_t(0x8001AC66)},
    {"caheaddm.vxl", "", int32_t(0x00000000), int32_t(0x768B732F)},
    {"cahosp.shp", "-", int32_t(0x00000000), int32_t(0x65ECD74F)},
    {"cahosp_a.shp", "-", int32_t(0x00000000), int32_t(0xBA43E496)},
    {"cahosp_f.shp", "", int32_t(0x00000000), int32_t(0x08633886)},
    {"cahse01.shp", "", int32_t(0x00000000), int32_t(0x111603CB)},
    {"cahse02.shp", "", int32_t(0x00000000), int32_t(0x97827165)},
    {"cahse03.shp", "", int32_t(0x00000000), int32_t(0x5CDEA2C0)},
    {"cahse04.shp", "", int32_t(0x00000000), int32_t(0x41DB9278)},
    {"cahse05.shp", "", int32_t(0x00000000), int32_t(0x8A8741DD)},
    {"cahse06.shp", "", int32_t(0x00000000), int32_t(0x0C133373)},
    {"cahse07.shp", "", int32_t(0x00000000), int32_t(0xC74FE0D6)},
    {"caicon.shp", "icon: cruiser", int32_t(0xB381F1F3), int32_t(0x00000000)},
    {"caind01.shp", "", int32_t(0x00000000), int32_t(0x6FF1CD4D)},
    {"cairfgl.shp", "", int32_t(0x00000000), int32_t(0xF9538BEF)},
    {"cairfgl_a.shp", "", int32_t(0x00000000), int32_t(0x9447D4E0)},
    {"cakrmw.shp", "", int32_t(0x00000000), int32_t(0x7FC2D4FD)},
    {"cala01.shp", "", int32_t(0x00000000), int32_t(0xD7604CAE)},
    {"cala02.shp", "", int32_t(0x00000000), int32_t(0xE6885633)},
    {"cala03.shp", "", int32_t(0x00000000), int32_t(0x40FF5D87)},
    {"cala04.shp", "", int32_t(0x00000000), int32_t(0x85586309)},
    {"cala05.shp", "", int32_t(0x00000000), int32_t(0x232F68BD)},
    {"cala07.shp", "", int32_t(0x00000000), int32_t(0xB4B07994)},
    {"cala08.shp", "", int32_t(0x00000000), int32_t(0x42F8097D)},
    {"cala09.shp", "", int32_t(0x00000000), int32_t(0xE48F02C9)},
    {"cala10.shp", "", int32_t(0x00000000), int32_t(0xBDBD4784)},
    {"cala10_a.shp", "", int32_t(0x00000000), int32_t(0x6212745D)},
    {"cala14.shp", "", int32_t(0x00000000), int32_t(0x49F26397)},
    {"cala15.shp", "", int32_t(0x00000000), int32_t(0xEF856823)},
    {"calab.shp", "", int32_t(0x00000000), int32_t(0x6B3D129F)},
    {"calbfgl.shp", "", int32_t(0x00000000), int32_t(0xB3BA02DA)},
    {"calbfgl_a.shp", "", int32_t(0x00000000), int32_t(0xA4E31C57)},
    {"calf1.aud", "", int32_t(0xC3B361B3), int32_t(0x00000000)},
    {"calit01e.shp", "", int32_t(0x00000000), int32_t(0x86BFB070)},
    {"calit01n.shp", "", int32_t(0x00000000), int32_t(0xF16F8161)},
    {"calit01s.shp", "", int32_t(0x00000000), int32_t(0x691FD252)},
    {"calit01w.shp", "", int32_t(0x00000000), int32_t(0x9C9F7492)},
    {"calit02l.shp", "", int32_t(0x00000000), int32_t(0x0D3BA0AF)},
    {"calit02r.shp", "", int32_t(0x00000000), int32_t(0xD2EB894C)},
    {"calit03e.shp", "", int32_t(0x00000000), int32_t(0xCB77117B)},
    {"calit03n.shp", "", int32_t(0x00000000), int32_t(0xBCA7206A)},
    {"calit03s.shp", "", int32_t(0x00000000), int32_t(0x24D77359)},
    {"calit03w.shp", "", int32_t(0x00000000), int32_t(0xD157D599)},
    {"calldog1.aud", "", int32_t(0xD814E4C3), int32_t(0x00000000)},
    {"callfam1.aud", "", int32_t(0xD820C8C7), int32_t(0x00000000)},
    {"callfam2.aud", "", int32_t(0xDA20C8C7), int32_t(0x00000000)},
    {"calnd6_a.shp", "", int32_t(0x00000000), int32_t(0x3ACB1142)},
    {"calond01.shp", "", int32_t(0x00000000), int32_t(0xC7F7858B)},
    {"calond02.shp", "", int32_t(0x00000000), int32_t(0x8057FF5B)},
    {"calond03.shp", "", int32_t(0x00000000), int32_t(0xBD37D6EB)},
    {"calond04.shp", "", int32_t(0x00000000), int32_t(0x0F170AFB)},
    {"calond05.shp", "", int32_t(0x00000000), int32_t(0x3277234B)},
    {"calond06.shp", "", int32_t(0x00000000), int32_t(0x75D7599B)},
    {"calunr01.shp", "", int32_t(0x00000000), int32_t(0xFA17E490)},
    {"calunr02.shp", "", int32_t(0x00000000), int32_t(0xBDB79E40)},
    {"camach.shp", "", int32_t(0x00000000), int32_t(0x638D241B)},
    {"camach_f.shp", "", int32_t(0x00000000), int32_t(0x0E02CBD2)},
    {"camcop1.aud", "", int32_t(0x69DBFAEC), int32_t(0x00000000)},
    {"cameo.mix", "", int32_t(0x00000000), int32_t(0x451C5DF2)},
    {"cameo.pal", "icons palette", int32_t(0x00000000), int32_t(0x212BC496)},
    {"cameomd.mix", "", int32_t(0x00000000), int32_t(0x16A802B6)},
    {"camera2.aud", "", int32_t(0x71DDDCF2), int32_t(0x00000000)},
    {"camex01.shp", "", int32_t(0x00000000), int32_t(0xCF5BD78E)},
    {"camex02.shp", "", int32_t(0x00000000), int32_t(0x49CFA520)},
    {"camex03.shp", "", int32_t(0x00000000), int32_t(0x82937685)},
    {"camex04.shp", "", int32_t(0x00000000), int32_t(0x9F96463D)},
    {"camex05.shp", "", int32_t(0x00000000), int32_t(0x54CA9598)},
    {"camiam01.shp", "", int32_t(0x00000000), int32_t(0x1797C040)},
    {"camiam02.shp", "", int32_t(0x00000000), int32_t(0x5037BA90)},
    {"camiam03.shp", "", int32_t(0x00000000), int32_t(0x6D579320)},
    {"camiam04.shp", "", int32_t(0x00000000), int32_t(0xDF774F30)},
    {"camiam05.shp", "", int32_t(0x00000000), int32_t(0xE2176680)},
    {"camiam06.shp", "", int32_t(0x00000000), int32_t(0xA5B71C50)},
    {"camiam07.shp", "", int32_t(0x00000000), int32_t(0x98D735E0)},
    {"camiam08.shp", "", int32_t(0x00000000), int32_t(0x1A87A231)},
    {"camicon.shp", "icon: spy plane", int32_t(0x8221EBE6), int32_t(0x00000000)},
    {"camisc01.shp", "", int32_t(0x00000000), int32_t(0x79368D4B)},
    {"camisc02.shp", "", int32_t(0x00000000), int32_t(0x3E96F79B)},
    {"camisc03.shp", "", int32_t(0x00000000), int32_t(0x03F6DE2B)},
    {"camisc04.shp", "", int32_t(0x00000000), int32_t(0xB1D6023B)},
    {"camisc05.shp", "", int32_t(0x00000000), int32_t(0x8CB62B8B)},
    {"camisc06.shp", "", int32_t(0x00000000), int32_t(0xCB16515B)},
    {"caml.shp", "", int32_t(0x00000000), int32_t(0x7355144D)},
    {"camoon01.shp", "", int32_t(0x00000000), int32_t(0x40EFB165)},
    {"camorr01.shp", "", int32_t(0x00000000), int32_t(0x072F6325)},
    {"camorr02.shp", "", int32_t(0x00000000), int32_t(0x408F19F5)},
    {"camorr03.shp", "", int32_t(0x00000000), int32_t(0x7DEF3045)},
    {"camorr05.shp", "", int32_t(0x00000000), int32_t(0xF2AFC5E5)},
    {"camorr06.shp", "", int32_t(0x00000000), int32_t(0xB50FBF35)},
    {"camov01.shp", "", int32_t(0x00000000), int32_t(0x4FFF4F22)},
    {"camov01_a.shp", "", int32_t(0x00000000), int32_t(0xA67639FB)},
    {"camov02.shp", "", int32_t(0x00000000), int32_t(0xC96B3D8C)},
    {"camov02_a.shp", "", int32_t(0x00000000), int32_t(0x4D4182F8)},
    {"campaign.pcx", "", int32_t(0x00000000), int32_t(0x6177B5BE)},
    {"camsc01.shp", "", int32_t(0x00000000), int32_t(0x3150C108)},
    {"camsc02.shp", "", int32_t(0x00000000), int32_t(0xB7C4B3A6)},
    {"camsc03.shp", "", int32_t(0x00000000), int32_t(0x7C986003)},
    {"camsc04.shp", "", int32_t(0x00000000), int32_t(0x619D50BB)},
    {"camsc05.shp", "", int32_t(0x00000000), int32_t(0xAAC1831E)},
    {"camsc06.shp", "", int32_t(0x00000000), int32_t(0x2C55F1B0)},
    {"camsc06a.shp", "", int32_t(0x00000000), int32_t(0xCE68BDEB)},
    {"camsc07.shp", "", int32_t(0x00000000), int32_t(0xE7092215)},
    {"camsc08.shp", "", int32_t(0x00000000), int32_t(0x165F90C0)},
    {"camsc09.shp", "", int32_t(0x00000000), int32_t(0xDD034365)},
    {"camsc10.shp", "", int32_t(0x00000000), int32_t(0x5C7B1919)},
    {"camsc11.shp", "", int32_t(0x00000000), int32_t(0x9727CABC)},
    {"camsc12.shp", "", int32_t(0x00000000), int32_t(0x11B3B812)},
    {"camsc13.shp", "", int32_t(0x00000000), int32_t(0xDAEF6BB7)},
    {"cancel1.aud", "canceled", int32_t(0x69DFF2D8), int32_t(0x00000000)},
    {"canceld1.aud", "audf:", int32_t(0xB416DEC5), int32_t(0x00000000)},
    {"cancld1.aud", "cancelled", int32_t(0x69DFE2E6), int32_t(0x00000000)},
    {"canewy01.shp", "", int32_t(0x00000000), int32_t(0x33D10826)},
    {"canewy05.shp", "", int32_t(0x00000000), int32_t(0xC651AEE6)},
    {"canewy06.shp", "", int32_t(0x00000000), int32_t(0x81F1D436)},
    {"canewy07.shp", "", int32_t(0x00000000), int32_t(0xBC91FD86)},
    {"canewy08.shp", "", int32_t(0x00000000), int32_t(0x3EC16A57)},
    {"canewy10.shp", "", int32_t(0x00000000), int32_t(0xC5EDF233)},
    {"canewy11.shp", "", int32_t(0x00000000), int32_t(0xF88DDB83)},
    {"canewy12.shp", "", int32_t(0x00000000), int32_t(0xBF2DA153)},
    {"canewy13.shp", "", int32_t(0x00000000), int32_t(0x824D88E3)},
    {"canewy14.shp", "", int32_t(0x00000000), int32_t(0x306D54F3)},
    {"canewy15.shp", "", int32_t(0x00000000), int32_t(0x0D0D7D43)},
    {"canewy16.shp", "", int32_t(0x00000000), int32_t(0x4AAD0793)},
    {"canewy17.shp", "", int32_t(0x00000000), int32_t(0x77CD2E23)},
    {"canewy18.shp", "", int32_t(0x00000000), int32_t(0xF59DB9F2)},
    {"canewy20.shp", "", int32_t(0x00000000), int32_t(0x4379809D)},
    {"canewy21.shp", "", int32_t(0x00000000), int32_t(0x7E19A92D)},
    {"canister.shp", "rpg projectile", int32_t(0x00000000), int32_t(0xB50505E7)},
    {"cankfgl.shp", "", int32_t(0x00000000), int32_t(0x1BEC64BC)},
    {"cankfgl_a.shp", "", int32_t(0x00000000), int32_t(0xC218D212)},
    {"cannon1.aud", "mammoth tank gun", int32_t(0x95DFF6EC), int32_t(0x00000000)},
    {"cannon2.aud", "light tank gun", int32_t(0x95E1F6EC), int32_t(0x00000000)},
    {"canwy05.shp", "", int32_t(0x00000000), int32_t(0xF16144F2)},
    {"canwy09.shp", "", int32_t(0x00000000), int32_t(0x86A38489)},
    {"canwy22.shp", "", int32_t(0x00000000), int32_t(0x7BFB6563)},
    {"canwy23.shp", "", int32_t(0x00000000), int32_t(0xB0A7B6C6)},
    {"canwy24.shp", "", int32_t(0x00000000), int32_t(0xADA2867E)},
    {"canwy25.shp", "", int32_t(0x00000000), int32_t(0x66FE55DB)},
    {"canwy26.shp", "", int32_t(0x00000000), int32_t(0xE06A2775)},
    {"caoild.shp", "", int32_t(0x00000000), int32_t(0xC2202EE6)},
    {"caoild_a.shp", "", int32_t(0x00000000), int32_t(0x1D8F1D3F)},
    {"caoild_f.shp", "", int32_t(0x00000000), int32_t(0xAFAFC12F)},
    {"caos.hva", "", int32_t(0x00000000), int32_t(0x72AFE6A9)},
    {"caos.vxl", "", int32_t(0x00000000), int32_t(0x842539E0)},
    {"caosicon.shp", "", int32_t(0x00000000), int32_t(0x28A07070)},
    {"caosuico.shp", "", int32_t(0x00000000), int32_t(0xED66E291)},
    {"caoutp.shp", "", int32_t(0x00000000), int32_t(0xB41B0DC0)},
    {"caoutp_a.shp", "", int32_t(0x00000000), int32_t(0x6BB43E19)},
    {"caoutp_b.shp", "", int32_t(0x00000000), int32_t(0x2C1444C9)},
    {"caoutp_c.shp", "", int32_t(0x00000000), int32_t(0x11746D79)},
    {"caoutp_d.shp", "", int32_t(0x00000000), int32_t(0xA354B169)},
    {"caoutp_f.shp", "", int32_t(0x00000000), int32_t(0xD994E209)},
    {"caoutpbb.shp", "", int32_t(0x00000000), int32_t(0x935C558C)},
    {"cap_trat.vqa", "-", int32_t(0x00000000), int32_t(0xD9074FD3)},
    {"capark01.shp", "", int32_t(0x00000000), int32_t(0xEFFB6BF2)},
    {"capark02.shp", "", int32_t(0x00000000), int32_t(0xA85B1122)},
    {"capark03.shp", "", int32_t(0x00000000), int32_t(0x953B3892)},
    {"capark04.shp", "", int32_t(0x00000000), int32_t(0x271BE482)},
    {"capark05.shp", "", int32_t(0x00000000), int32_t(0x1A7BCD32)},
    {"capark06.shp", "", int32_t(0x00000000), int32_t(0x5DDBB7E2)},
    {"capars02.shp", "", int32_t(0x00000000), int32_t(0xFC6AC38B)},
    {"capars04.shp", "", int32_t(0x00000000), int32_t(0x732A362B)},
    {"capars05.shp", "", int32_t(0x00000000), int32_t(0x4E4A1F9B)},
    {"capars06.shp", "", int32_t(0x00000000), int32_t(0x09EA654B)},
    {"capars07.shp", "", int32_t(0x00000000), int32_t(0x348A4CFB)},
    {"capars08.shp", "", int32_t(0x00000000), int32_t(0xB6DADB2A)},
    {"capars09.shp", "", int32_t(0x00000000), int32_t(0x8BBAF29A)},
    {"capars10.shp", "", int32_t(0x00000000), int32_t(0x4DF6434E)},
    {"capars12.shp", "", int32_t(0x00000000), int32_t(0x3736102E)},
    {"capars12d.shp", "", int32_t(0x00000000), int32_t(0xA224DAAD)},
    {"capars13.shp", "", int32_t(0x00000000), int32_t(0x0A56399E)},
    {"capars14.shp", "", int32_t(0x00000000), int32_t(0xB876E58E)},
    {"capofgl.shp", "", int32_t(0x00000000), int32_t(0x7F6784EB)},
    {"capofgl_a.shp", "", int32_t(0x00000000), int32_t(0xAF88D168)},
    {"capol01e.shp", "", int32_t(0x00000000), int32_t(0x67698202)},
    {"capol01n.shp", "", int32_t(0x00000000), int32_t(0x10B9B313)},
    {"capol01s.shp", "", int32_t(0x00000000), int32_t(0x88C9E020)},
    {"capol01w.shp", "", int32_t(0x00000000), int32_t(0x7D4946E0)},
    {"capowr.shp", "", int32_t(0x00000000), int32_t(0x42400980)},
    {"capowr_a.shp", "", int32_t(0x00000000), int32_t(0x9DEF3A59)},
    {"caprs03.shp", "", int32_t(0x00000000), int32_t(0xC5084F33)},
    {"capyr01.shp", "-", int32_t(0x00000000), int32_t(0xC63F707B)},
    {"capyr02.shp", "-", int32_t(0x00000000), int32_t(0x40AB02D5)},
    {"capyr03.shp", "-", int32_t(0x00000000), int32_t(0x8BF7D170)},
    {"car.hva", "-", int32_t(0x00000000), int32_t(0x5901511D)},
    {"car.vxl", "car", int32_t(0x00000000), int32_t(0x56F722F6)},
    {"carcrek1.aud", "", int32_t(0xB434D0DF), int32_t(0x00000000)},
    {"cardown3.aud", "", int32_t(0xBC3AF4D9), int32_t(0x00000000)},
    {"carexpl1.aud", "", int32_t(0xBC36E6EB), int32_t(0x00000000)},
    {"cargele2.aud", "", int32_t(0xC628DEC5), int32_t(0x00000000)},
    {"cargocar.hva", "-", int32_t(0x00000000), int32_t(0xFC2B289D)},
    {"cargocar.vxl", "train cargo car", int32_t(0x00000000), int32_t(0x0AA1F7D4)},
    {"carland1.aud", "", int32_t(0xD826E2BD), int32_t(0x00000000)},
    {"carr.shp", "unit: helicarrier", int32_t(0xF4ECD5B4), int32_t(0x00000000)},
    {"carricon.shp", "icon: helicarrier", int32_t(0x362FDECD), int32_t(0xED8B6E6B)},
    {"carrier.hva", "", int32_t(0x00000000), int32_t(0x9307EC6A)},
    {"carrier.vxl", "", int32_t(0x00000000), int32_t(0x9CF19F81)},
    {"carufgl.shp", "", int32_t(0x00000000), int32_t(0x427C9C39)},
    {"carufgl_a.shp", "", int32_t(0x00000000), int32_t(0xC0BED539)},
    {"carup3.aud", "", int32_t(0xD7A5B002), int32_t(0x00000000)},
    {"carup3b.aud", "", int32_t(0xB211C0EE), int32_t(0x00000000)},
    {"carus02a.shp", "", int32_t(0x00000000), int32_t(0x8CFD6D39)},
    {"carus02b.shp", "", int32_t(0x00000000), int32_t(0xCB5D17E9)},
    {"carus02c.shp", "", int32_t(0x00000000), int32_t(0xF63D3E59)},
    {"carus02d.shp", "", int32_t(0x00000000), int32_t(0x441DE249)},
    {"carus02e.shp", "", int32_t(0x00000000), int32_t(0x797DCBF9)},
    {"carus02f.shp", "", int32_t(0x00000000), int32_t(0x3EDDB129)},
    {"carus02g.shp", "", int32_t(0x00000000), int32_t(0x03BD9899)},
    {"carus03.shp", "", int32_t(0x00000000), int32_t(0xA59CF2C7)},
    {"carus04.shp", "", int32_t(0x00000000), int32_t(0xB899C27F)},
    {"carus05.shp", "", int32_t(0x00000000), int32_t(0x73C511DA)},
    {"carus06.shp", "", int32_t(0x00000000), int32_t(0xF5516374)},
    {"carus07.shp", "", int32_t(0x00000000), int32_t(0x3E0DB0D1)},
    {"carus08.shp", "", int32_t(0x00000000), int32_t(0xCF5B0204)},
    {"carus09.shp", "", int32_t(0x00000000), int32_t(0x0407D1A1)},
    {"carus10.shp", "", int32_t(0x00000000), int32_t(0x857F8BDD)},
    {"carus11.shp", "", int32_t(0x00000000), int32_t(0x4E235878)},
    {"caryland.shp", "-", int32_t(0x00000000), int32_t(0x314D24FF)},
    {"casanf01.shp", "", int32_t(0x00000000), int32_t(0x4E0F9555)},
    {"casanf02.shp", "", int32_t(0x00000000), int32_t(0x09AFEF85)},
    {"casanf03.shp", "", int32_t(0x00000000), int32_t(0x34CFC635)},
    {"casanf04.shp", "", int32_t(0x00000000), int32_t(0x86EF1A25)},
    {"casanf05.shp", "", int32_t(0x00000000), int32_t(0xBB8F3395)},
    {"casanf06.shp", "", int32_t(0x00000000), int32_t(0xFC2F4945)},
    {"casanf07.shp", "", int32_t(0x00000000), int32_t(0xC14F60F5)},
    {"casanf08.shp", "", int32_t(0x00000000), int32_t(0x431FF724)},
    {"casanf09.shp", "", int32_t(0x00000000), int32_t(0x7E7FDE94)},
    {"casanf10.shp", "", int32_t(0x00000000), int32_t(0xB8336F40)},
    {"casanf11.shp", "", int32_t(0x00000000), int32_t(0x855346F0)},
    {"casanf12.shp", "", int32_t(0x00000000), int32_t(0xC2F33C20)},
    {"casanf13.shp", "", int32_t(0x00000000), int32_t(0xFF931590)},
    {"casanf14.shp", "", int32_t(0x00000000), int32_t(0x4DB3C980)},
    {"casanf15.shp", "", int32_t(0x00000000), int32_t(0x70D3E030)},
    {"casanf16.shp", "", int32_t(0x00000000), int32_t(0x37739AE0)},
    {"casanf17.shp", "", int32_t(0x00000000), int32_t(0x0A13B350)},
    {"casanf18.shp", "", int32_t(0x00000000), int32_t(0x88432481)},
    {"caseat01.shp", "", int32_t(0x00000000), int32_t(0x3A825B12)},
    {"caseat02.shp", "", int32_t(0x00000000), int32_t(0x7D2221C2)},
    {"caseat02_a.shp", "", int32_t(0x00000000), int32_t(0x3C12E1DB)},
    {"caseycan.ini", "", int32_t(0x00000000), int32_t(0xAFD95356)},
    {"caseycan.map", "-", int32_t(0x00000000), int32_t(0x4B234F85)},
    {"cashdn1.aud", "credit out", int32_t(0x7DF3F6D6), int32_t(0x00000000)},
    {"cashturn.aud", "selling", int32_t(0x0246F0E3), int32_t(0x9D4B9E8E)},
    {"cashup1.aud", "credit in", int32_t(0x7DF3FAF8), int32_t(0x00000000)},
    {"cashy1.aud", "", int32_t(0xA3A9AC14), int32_t(0x00000000)},
    {"casin03e.shp", "", int32_t(0x00000000), int32_t(0xF0A9E6FD)},
    {"casin03s.shp", "", int32_t(0x00000000), int32_t(0x1F0984DF)},
    {"caskfgl.shp", "", int32_t(0x00000000), int32_t(0xC9BC6EE4)},
    {"caskfgl_a.shp", "", int32_t(0x00000000), int32_t(0x13509E25)},
    {"caslab.shp", "", int32_t(0x00000000), int32_t(0x4DF02A24)},
    {"caslab_f.shp", "", int32_t(0x00000000), int32_t(0x207FC5ED)},
    {"castl01.shp", "", int32_t(0x00000000), int32_t(0xB5760F36)},
    {"castl02.shp", "", int32_t(0x00000000), int32_t(0x33E27D98)},
    {"castl03.shp", "", int32_t(0x00000000), int32_t(0xF8BEAE3D)},
    {"castl05a.shp", "", int32_t(0x00000000), int32_t(0xCCDA017B)},
    {"castl05b.shp", "", int32_t(0x00000000), int32_t(0x8B7A7BAB)},
    {"castl05c.shp", "", int32_t(0x00000000), int32_t(0xB61A521B)},
    {"castl05d.shp", "", int32_t(0x00000000), int32_t(0x043A8E0B)},
    {"castl05e.shp", "", int32_t(0x00000000), int32_t(0x395AA7BB)},
    {"castl05f.shp", "", int32_t(0x00000000), int32_t(0x7EFADD6B)},
    {"castl05g.shp", "", int32_t(0x00000000), int32_t(0x439AF4DB)},
    {"castl05h.shp", "", int32_t(0x00000000), int32_t(0xC1CA630A)},
    {"castrt01.shp", "", int32_t(0x00000000), int32_t(0x730D3BE8)},
    {"castrt02.shp", "", int32_t(0x00000000), int32_t(0x34AD4138)},
    {"castrt03.shp", "", int32_t(0x00000000), int32_t(0x09CD6888)},
    {"castrt04.shp", "", int32_t(0x00000000), int32_t(0xBBEDB498)},
    {"castrt05.shp", "", int32_t(0x00000000), int32_t(0x868D9D28)},
    {"casu01.shp", "-", int32_t(0x00000000), int32_t(0xF0E985B6)},
    {"casu02.shp", "-", int32_t(0x00000000), int32_t(0xC1019F2B)},
    {"caswst01.shp", "", int32_t(0x00000000), int32_t(0x862A07B3)},
    {"casydn01.shp", "", int32_t(0x00000000), int32_t(0xFB382793)},
    {"casydn02.shp", "", int32_t(0x00000000), int32_t(0xBC985D43)},
    {"casydn03.shp", "", int32_t(0x00000000), int32_t(0x81F874F3)},
    {"catech01.shp", "", int32_t(0x00000000), int32_t(0x3A05B1AC)},
    {"catex02.shp", "", int32_t(0x00000000), int32_t(0x92740F02)},
    {"catexs01.shp", "", int32_t(0x00000000), int32_t(0x7E0D54E5)},
    {"catexs02.shp", "", int32_t(0x00000000), int32_t(0x39AD2E35)},
    {"catexs03.shp", "", int32_t(0x00000000), int32_t(0x04CD0785)},
    {"catexs04.shp", "", int32_t(0x00000000), int32_t(0xB6EDDB95)},
    {"catexs05.shp", "", int32_t(0x00000000), int32_t(0x8B8DF225)},
    {"catexs06.shp", "", int32_t(0x00000000), int32_t(0xCC2D88F5)},
    {"catexs07.shp", "", int32_t(0x00000000), int32_t(0xF14DA145)},
    {"catexs08.shp", "", int32_t(0x00000000), int32_t(0x731D3694)},
    {"cathosp.shp", "", int32_t(0x00000000), int32_t(0xEA27284E)},
    {"catime01.shp", "", int32_t(0x00000000), int32_t(0xA86C314A)},
    {"catime02.shp", "", int32_t(0x00000000), int32_t(0xEFCC4B9A)},
    {"catime_a.shp", "", int32_t(0x00000000), int32_t(0xA81C6C0A)},
    {"catr03dm.shp", "", int32_t(0x00000000), int32_t(0x9285CEAF)},
    {"catran01.shp", "", int32_t(0x00000000), int32_t(0xD351AC53)},
    {"catran02.shp", "", int32_t(0x00000000), int32_t(0x94F1D683)},
    {"catran03.shp", "", int32_t(0x00000000), int32_t(0xA991FF33)},
    {"cats01.shp", "", int32_t(0x00000000), int32_t(0x612FE745)},
    {"caukfgl.shp", "", int32_t(0x00000000), int32_t(0xC4A21EA3)},
    {"caukfgl_a.shp", "", int32_t(0x00000000), int32_t(0xEB92D593)},
    {"cauldron.aud", "", int32_t(0x1248EAC3), int32_t(0x00000000)},
    {"caurb01.shp", "", int32_t(0x00000000), int32_t(0xDEF814C9)},
    {"caurb02.shp", "", int32_t(0x00000000), int32_t(0x586C6667)},
    {"caurb03.shp", "", int32_t(0x00000000), int32_t(0x9330B5C2)},
    {"causfgl.shp", "", int32_t(0x00000000), int32_t(0xD3BAFECA)},
    {"causfgl_a.shp", "", int32_t(0x00000000), int32_t(0x0596A024)},
    {"cavega.shp", "-", int32_t(0x00000000), int32_t(0xF0FD4421)},
    {"cavein2.aud", "", int32_t(0x7201F6E0), int32_t(0x00000000)},
    {"cavein3.aud", "", int32_t(0x7203F6E0), int32_t(0x00000000)},
    {"cavein4.aud", "", int32_t(0x7205F6E0), int32_t(0x00000000)},
    {"cawa19_a.shp", "", int32_t(0x00000000), int32_t(0x28C44B91)},
    {"cawa2a.shp", "", int32_t(0x00000000), int32_t(0xA663E1E7)},
    {"cawa2b.shp", "", int32_t(0x00000000), int32_t(0x978BFB7A)},
    {"cawa2c.shp", "", int32_t(0x00000000), int32_t(0x31FCF0CE)},
    {"cawa2d.shp", "", int32_t(0x00000000), int32_t(0xF45BCE40)},
    {"cawash03.shp", "", int32_t(0x00000000), int32_t(0x8AA539E8)},
    {"cawash04.shp", "", int32_t(0x00000000), int32_t(0x3885E5F8)},
    {"cawash05.shp", "", int32_t(0x00000000), int32_t(0x05E5CC48)},
    {"cawash06.shp", "", int32_t(0x00000000), int32_t(0x4245B698)},
    {"cawash07.shp", "", int32_t(0x00000000), int32_t(0x7F259F28)},
    {"cawash08.shp", "", int32_t(0x00000000), int32_t(0xFD7508F9)},
    {"cawash09.shp", "", int32_t(0x00000000), int32_t(0xC0152149)},
    {"cawash10.shp", "", int32_t(0x00000000), int32_t(0x0659909D)},
    {"cawash11.shp", "", int32_t(0x00000000), int32_t(0x3B39B92D)},
    {"cawash13.shp", "", int32_t(0x00000000), int32_t(0x41F9EA4D)},
    {"cawash16.shp", "", int32_t(0x00000000), int32_t(0x8919653D)},
    {"cawash17.shp", "", int32_t(0x00000000), int32_t(0xB4794C8D)},
    {"cawash18.shp", "", int32_t(0x00000000), int32_t(0x3629DB5C)},
    {"cawash19.shp", "", int32_t(0x00000000), int32_t(0x0B49F2EC)},
    {"cawsh18a.shp", "", int32_t(0x00000000), int32_t(0x3FF3DA58)},
    {"cawt01.shp", "", int32_t(0x00000000), int32_t(0xEE79318F)},
    {"cback.pcx", "-", int32_t(0x00000000), int32_t(0xC46AA5E9)},
    {"cback.vqa", "-", int32_t(0x00000000), int32_t(0xDA699BDB)},
    {"cbalopn1.aud", "", int32_t(0xD7F6EAD9), int32_t(0x00000000)},
    {"cbalsfx1.aud", "", int32_t(0xD80AD6E1), int32_t(0x00000000)},
    {"cblc.hva", "", int32_t(0x00000000), int32_t(0xA5331918)},
    {"cblc.vxl", "", int32_t(0x00000000), int32_t(0x53B9C651)},
    {"cc.col", "pal: setup program palette", int32_t(0x865CD2D5), int32_t(0x00000000)},
    {"cc2tease.vqa", "c&c 2 teaser", int32_t(0x1CC0E5C5), int32_t(0x00000000)},
    {"cc2tease.vqp", "c&c 2 teaser", int32_t(0x2BC0E5C5), int32_t(0x00000000)},
    {"ccd_i.pcx", "-", int32_t(0x00000000), int32_t(0xEB1C0775)},
    {"ccdemo.vqa", "", int32_t(0xC16DECF8), int32_t(0x00000000)},
    {"cce_i.pcx", "-", int32_t(0x00000000), int32_t(0x04DE6C4B)},
    {"cce_il.pcx", "", int32_t(0x00000000), int32_t(0x20DB09F7)},
    {"cce_ir.pcx", "", int32_t(0x00000000), int32_t(0x173AEE64)},
    {"cceldata.txt", "inf: map tiles list", int32_t(0x0815E3C3), int32_t(0x00000000)},
    {"ccliff01.tem", "-", int32_t(0x00000000), int32_t(0x7B1C4B4D)},
    {"ccliff02.tem", "-", int32_t(0x00000000), int32_t(0x3CBC319D)},
    {"ccliff03.tem", "-", int32_t(0x00000000), int32_t(0x01DC182D)},
    {"ccliff04.tem", "-", int32_t(0x00000000), int32_t(0xB3FCC43D)},
    {"ccliff05.tem", "-", int32_t(0x00000000), int32_t(0x8E9CED8D)},
    {"ccliff06.tem", "-", int32_t(0x00000000), int32_t(0xC93C975D)},
    {"cclocal.inf", "inf: list for cclocal.mix", int32_t(0x9A0FDDDC), int32_t(0x00000000)},
    {"cclogo.vqp", "???", int32_t(0xE98DFBEC), int32_t(0x00000000)},
    {"ccm.col", "pal: setup program palette", int32_t(0x5CE6D5C9), int32_t(0x00000000)},
    {"ccomand.shp", "", int32_t(0x00000000), int32_t(0xAC56016E)},
    {"ccomicon.shp", "", int32_t(0x00000000), int32_t(0x14CE5052)},
    {"ccomuico.shp", "", int32_t(0x00000000), int32_t(0xD108C2B3)},
    {"ccshapes.shp", "curs: setup mouse cursors", int32_t(0x182000BD), int32_t(0x00000000)},
    {"ccthang.aud", "c&c thang", int32_t(0x7E23FED0), int32_t(0x00000000)},
    {"cd.tre", "", int32_t(0xA85CCDD8), int32_t(0x00000000)},
    {"cd.trf", "", int32_t(0xA85CCED8), int32_t(0x00000000)},
    {"cd.trg", "", int32_t(0xA85CCFD8), int32_t(0x00000000)},
    {"cd.tri", "", int32_t(0xA85CD1D8), int32_t(0x00000000)},
    {"cd.trs", "", int32_t(0xA85CDBD8), int32_t(0x00000000)},
    {"cdairp.shp", "", int32_t(0x00000000), int32_t(0x571E29D3)},
    {"cdairp_a.shp", "", int32_t(0x00000000), int32_t(0x88B11A0A)},
    {"cdairp_f.shp", "", int32_t(0x00000000), int32_t(0x3A91C61A)},
    {"cdarmy01.shp", "", int32_t(0x00000000), int32_t(0x9657FDB2)},
    {"cdarmy02.shp", "", int32_t(0x00000000), int32_t(0xD1F78762)},
    {"cdarmy03.shp", "", int32_t(0x00000000), int32_t(0xEC97AED2)},
    {"cdarmy04.shp", "", int32_t(0x00000000), int32_t(0x5EB772C2)},
    {"cdbarn02.shp", "", int32_t(0x00000000), int32_t(0xA86FC312)},
    {"cdbarr01.shp", "", int32_t(0x00000000), int32_t(0x4FB14F78)},
    {"cdbarr02.shp", "", int32_t(0x00000000), int32_t(0x081135A8)},
    {"cdbhut.shp", "", int32_t(0x00000000), int32_t(0x55D8AB99)},
    {"cdbunk01.shp", "", int32_t(0x00000000), int32_t(0x67CFA17C)},
    {"cdbunk02.shp", "", int32_t(0x00000000), int32_t(0x206FDBAC)},
    {"cdbunk03.shp", "", int32_t(0x00000000), int32_t(0x1D0FF21C)},
    {"cdbunk04.shp", "", int32_t(0x00000000), int32_t(0xAF2F2E0C)},
    {"cdcache.smf", "", int32_t(0x61DDEEE6), int32_t(0x00000000)},
    {"cdcache2.smf", "", int32_t(0xAFE4F4C1), int32_t(0x00000000)},
    {"cdchig01.shp", "", int32_t(0x00000000), int32_t(0x18E70C09)},
    {"cdchig02.shp", "", int32_t(0x00000000), int32_t(0x5F4776D9)},
    {"cdchig03.shp", "", int32_t(0x00000000), int32_t(0x62275F69)},
    {"cdchig05.shp", "", int32_t(0x00000000), int32_t(0xED67AAC9)},
    {"cdchig05d.shp", "", int32_t(0x00000000), int32_t(0xE4E38F35)},
    {"cdcity01.shp", "", int32_t(0x00000000), int32_t(0xDFC3DB23)},
    {"cdcity02.shp", "", int32_t(0x00000000), int32_t(0x9863A1F3)},
    {"cdcity03.shp", "", int32_t(0x00000000), int32_t(0xA5038843)},
    {"cdcity04.shp", "", int32_t(0x00000000), int32_t(0x17235453)},
    {"cdcolo01.shp", "", int32_t(0x00000000), int32_t(0x078921C3)},
    {"cdcufgl.shp", "", int32_t(0x00000000), int32_t(0xFB47DAAD)},
    {"cdcufgl_a.shp", "", int32_t(0x00000000), int32_t(0x0884B6A8)},
    {"cdeast01.shp", "", int32_t(0x00000000), int32_t(0x021761A5)},
    {"cdeast01dm.shp", "", int32_t(0x00000000), int32_t(0x6E834AB3)},
    {"cdest.hva", "", int32_t(0x00000000), int32_t(0xB9902FEF)},
    {"cdest.vxl", "", int32_t(0x00000000), int32_t(0x06092848)},
    {"cdestwo.hva", "", int32_t(0x00000000), int32_t(0x98EE76A2)},
    {"cdestwo.vxl", "", int32_t(0x00000000), int32_t(0x97180549)},
    {"cdeur04.shp", "", int32_t(0x00000000), int32_t(0xC016F432)},
    {"cdeur1.shp", "", int32_t(0x00000000), int32_t(0x39C07F9D)},
    {"cdeur2.shp", "", int32_t(0x00000000), int32_t(0x08286500)},
    {"cdeuro05.shp", "", int32_t(0x00000000), int32_t(0xAFC81CB2)},
    {"cdfarm01.shp", "", int32_t(0x00000000), int32_t(0xD7CC0325)},
    {"cdfarm02.shp", "", int32_t(0x00000000), int32_t(0x906C79F5)},
    {"cdfarm06.shp", "", int32_t(0x00000000), int32_t(0x65ECDF35)},
    {"cdfncb.shp", "", int32_t(0x00000000), int32_t(0x91F3E331)},
    {"cdfncp.shp", "", int32_t(0x00000000), int32_t(0x61B26ED6)},
    {"cdfncw.shp", "", int32_t(0x00000000), int32_t(0xA4155058)},
    {"cdframes.dat", "", int32_t(0x43E4EFBD), int32_t(0x00000000)},
    {"cdfrfgl.shp", "", int32_t(0x00000000), int32_t(0x790F7C20)},
    {"cdfrfgl_a.shp", "", int32_t(0x00000000), int32_t(0xF154DE9D)},
    {"cdfrma.shp", "", int32_t(0x00000000), int32_t(0xFF655AFB)},
    {"cdfrmb.shp", "", int32_t(0x00000000), int32_t(0xCE8D4066)},
    {"cdgard01.shp", "", int32_t(0x00000000), int32_t(0xAD962DC8)},
    {"cdgard03.shp", "", int32_t(0x00000000), int32_t(0xD7567EA8)},
    {"cdgas.shp", "", int32_t(0x00000000), int32_t(0x529B749F)},
    {"cdgas01.shp", "", int32_t(0x00000000), int32_t(0xA9A8A65F)},
    {"cdgefgl.shp", "", int32_t(0x00000000), int32_t(0x5E6C38A6)},
    {"cdgefgl_a.shp", "", int32_t(0x00000000), int32_t(0xA52F9F69)},
    {"cdgrd1_a.shp", "", int32_t(0x00000000), int32_t(0x3C2FC91C)},
    {"cdhosp.shp", "", int32_t(0x00000000), int32_t(0x14BB7B0D)},
    {"cdhosp_a.shp", "", int32_t(0x00000000), int32_t(0xCB1448D4)},
    {"cdhosp_f.shp", "", int32_t(0x00000000), int32_t(0x793494C4)},
    {"cdhse01.shp", "", int32_t(0x00000000), int32_t(0x6041AF89)},
    {"cdhse02.shp", "", int32_t(0x00000000), int32_t(0xE6D5DD27)},
    {"cdhse03.shp", "", int32_t(0x00000000), int32_t(0x2D890E82)},
    {"cdhse04.shp", "", int32_t(0x00000000), int32_t(0x308C3E3A)},
    {"cdhse05.shp", "", int32_t(0x00000000), int32_t(0xFBD0ED9F)},
    {"cdhse06.shp", "", int32_t(0x00000000), int32_t(0x7D449F31)},
    {"cdhse07.shp", "", int32_t(0x00000000), int32_t(0xB6184C94)},
    {"cdind01.shp", "", int32_t(0x00000000), int32_t(0x1EA6610F)},
    {"cdirfgl.shp", "", int32_t(0x00000000), int32_t(0x880427AD)},
    {"cdirfgl_a.shp", "", int32_t(0x00000000), int32_t(0xA7C06A6B)},
    {"cdkrmw.shp", "", int32_t(0x00000000), int32_t(0x0E9578BF)},
    {"cdlab.shp", "", int32_t(0x00000000), int32_t(0x1A6ABEDD)},
    {"cdlbfgl.shp", "", int32_t(0x00000000), int32_t(0xC2EDAE98)},
    {"cdlbfgl_a.shp", "", int32_t(0x00000000), int32_t(0x9764A2DC)},
    {"cdlit01e.shp", "", int32_t(0x00000000), int32_t(0xF7E81C32)},
    {"cdlit01n.shp", "", int32_t(0x00000000), int32_t(0x80382D23)},
    {"cdlit01s.shp", "", int32_t(0x00000000), int32_t(0x18487E10)},
    {"cdlit01w.shp", "", int32_t(0x00000000), int32_t(0xEDC8D8D0)},
    {"cdlit02l.shp", "", int32_t(0x00000000), int32_t(0x7C6C0CED)},
    {"cdlit02r.shp", "", int32_t(0x00000000), int32_t(0xA3BC250E)},
    {"cdlit03e.shp", "", int32_t(0x00000000), int32_t(0xBA20BD39)},
    {"cdlit03n.shp", "", int32_t(0x00000000), int32_t(0xCDF08C28)},
    {"cdlit03s.shp", "", int32_t(0x00000000), int32_t(0x5580DF1B)},
    {"cdlit03w.shp", "", int32_t(0x00000000), int32_t(0xA00079DB)},
    {"cdlond02.shp", "", int32_t(0x00000000), int32_t(0xF1005319)},
    {"cdmex01.shp", "", int32_t(0x00000000), int32_t(0xBE0C7BCC)},
    {"cdmex02.shp", "", int32_t(0x00000000), int32_t(0x38980962)},
    {"cdmex03.shp", "", int32_t(0x00000000), int32_t(0xF3C4DAC7)},
    {"cdmex04.shp", "", int32_t(0x00000000), int32_t(0xEEC1EA7F)},
    {"cdmex05.shp", "", int32_t(0x00000000), int32_t(0x259D39DA)},
    {"cdmiam01.shp", "", int32_t(0x00000000), int32_t(0x66C06C02)},
    {"cdmiam02.shp", "", int32_t(0x00000000), int32_t(0x216016D2)},
    {"cdmiam03.shp", "", int32_t(0x00000000), int32_t(0x1C003F62)},
    {"cdmiam04.shp", "", int32_t(0x00000000), int32_t(0xAE20E372)},
    {"cdmiam05.shp", "", int32_t(0x00000000), int32_t(0x9340CAC2)},
    {"cdmiam06.shp", "", int32_t(0x00000000), int32_t(0xD4E0B012)},
    {"cdmiam07.shp", "", int32_t(0x00000000), int32_t(0xE98099A2)},
    {"cdmiam08.shp", "", int32_t(0x00000000), int32_t(0x6BD00E73)},
    {"cdmisc01.shp", "", int32_t(0x00000000), int32_t(0x08612109)},
    {"cdmisc02.shp", "", int32_t(0x00000000), int32_t(0x4FC15BD9)},
    {"cdmisc03.shp", "", int32_t(0x00000000), int32_t(0x72A17269)},
    {"cdmisc04.shp", "", int32_t(0x00000000), int32_t(0xC081AE79)},
    {"cdmisc05.shp", "", int32_t(0x00000000), int32_t(0xFDE187C9)},
    {"cdmisc06.shp", "", int32_t(0x00000000), int32_t(0xBA41FD19)},
    {"cdmoon01.shp", "", int32_t(0x00000000), int32_t(0x31B81D27)},
    {"cdmov01.shp", "", int32_t(0x00000000), int32_t(0x3EA8E360)},
    {"cdmov01_a.shp", "", int32_t(0x00000000), int32_t(0x95F18770)},
    {"cdmov02.shp", "", int32_t(0x00000000), int32_t(0xB83C91CE)},
    {"cdmov02_a.shp", "", int32_t(0x00000000), int32_t(0x7EC63C73)},
    {"cdmsc01.shp", "", int32_t(0x00000000), int32_t(0x40076D4A)},
    {"cdmsc02.shp", "", int32_t(0x00000000), int32_t(0xC6931FE4)},
    {"cdmsc03.shp", "", int32_t(0x00000000), int32_t(0x0DCFCC41)},
    {"cdmsc04.shp", "", int32_t(0x00000000), int32_t(0x10CAFCF9)},
    {"cdmsc05.shp", "", int32_t(0x00000000), int32_t(0xDB962F5C)},
    {"cdmsc06.shp", "", int32_t(0x00000000), int32_t(0x5D025DF2)},
    {"cdmsc06a.shp", "", int32_t(0x00000000), int32_t(0xBF3F11A9)},
    {"cdmsc07.shp", "", int32_t(0x00000000), int32_t(0x965E8E57)},
    {"cdmsc08.shp", "", int32_t(0x00000000), int32_t(0x67083C82)},
    {"cdmsc09.shp", "", int32_t(0x00000000), int32_t(0xAC54EF27)},
    {"cdmsc10.shp", "", int32_t(0x00000000), int32_t(0x2D2CB55B)},
    {"cdmsc11.shp", "", int32_t(0x00000000), int32_t(0xE67066FE)},
    {"cdmsc12.shp", "", int32_t(0x00000000), int32_t(0x60E41450)},
    {"cdmsc13.shp", "", int32_t(0x00000000), int32_t(0xABB8C7F5)},
    {"cdnewy01.shp", "", int32_t(0x00000000), int32_t(0x4286A464)},
    {"cdnewy05.shp", "", int32_t(0x00000000), int32_t(0xB70602A4)},
    {"cdnewy06.shp", "", int32_t(0x00000000), int32_t(0xF0A67874)},
    {"cdnewy07.shp", "", int32_t(0x00000000), int32_t(0xCDC651C4)},
    {"cdnewy08.shp", "", int32_t(0x00000000), int32_t(0x4F96C615)},
    {"cdnewy10.shp", "", int32_t(0x00000000), int32_t(0xB4BA5E71)},
    {"cdnewy11.shp", "", int32_t(0x00000000), int32_t(0x89DA77C1)},
    {"cdnewy12.shp", "", int32_t(0x00000000), int32_t(0xCE7A0D11)},
    {"cdnewy13.shp", "", int32_t(0x00000000), int32_t(0xF31A24A1)},
    {"cdnewy14.shp", "", int32_t(0x00000000), int32_t(0x413AF8B1)},
    {"cdnewy15.shp", "", int32_t(0x00000000), int32_t(0x7C5AD101)},
    {"cdnewy16.shp", "", int32_t(0x00000000), int32_t(0x3BFAABD1)},
    {"cdnewy17.shp", "", int32_t(0x00000000), int32_t(0x069A8261)},
    {"cdnewy18.shp", "", int32_t(0x00000000), int32_t(0x84CA15B0)},
    {"cdnewy20.shp", "", int32_t(0x00000000), int32_t(0x322E2CDF)},
    {"cdnewy21.shp", "", int32_t(0x00000000), int32_t(0x0F4E056F)},
    {"cdnkfgl.shp", "", int32_t(0x00000000), int32_t(0x6ABBC8FE)},
    {"cdnkfgl_a.shp", "", int32_t(0x00000000), int32_t(0xF19F6C99)},
    {"cdnwy05.shp", "", int32_t(0x00000000), int32_t(0x8036E8B0)},
    {"cdnwy09.shp", "", int32_t(0x00000000), int32_t(0xF7F428CB)},
    {"cdnwy22.shp", "", int32_t(0x00000000), int32_t(0x0AACC921)},
    {"cdnwy23.shp", "", int32_t(0x00000000), int32_t(0xC1F01A84)},
    {"cdnwy24.shp", "", int32_t(0x00000000), int32_t(0xDCF52A3C)},
    {"cdnwy25.shp", "", int32_t(0x00000000), int32_t(0x17A9F999)},
    {"cdnwy26.shp", "", int32_t(0x00000000), int32_t(0x913D8B37)},
    {"cdoild.shp", "", int32_t(0x00000000), int32_t(0xB37782A4)},
    {"cdoild_a.shp", "", int32_t(0x00000000), int32_t(0x6CD8B17D)},
    {"cdoild_f.shp", "", int32_t(0x00000000), int32_t(0xDEF86D6D)},
    {"cdoutp.shp", "", int32_t(0x00000000), int32_t(0xC54CA182)},
    {"cdoutp_a.shp", "", int32_t(0x00000000), int32_t(0x1AE3925B)},
    {"cdoutp_b.shp", "", int32_t(0x00000000), int32_t(0x5D43E88B)},
    {"cdoutp_c.shp", "", int32_t(0x00000000), int32_t(0x6023C13B)},
    {"cdoutp_d.shp", "", int32_t(0x00000000), int32_t(0xD2031D2B)},
    {"cdoutp_f.shp", "", int32_t(0x00000000), int32_t(0xA8C34E4B)},
    {"cdoutpbb.shp", "", int32_t(0x00000000), int32_t(0xE20BF9CE)},
    {"cdpark01.shp", "", int32_t(0x00000000), int32_t(0x9EACC7B0)},
    {"cdpark02.shp", "", int32_t(0x00000000), int32_t(0xD90CBD60)},
    {"cdpark03.shp", "", int32_t(0x00000000), int32_t(0xE46C94D0)},
    {"cdpars02.shp", "", int32_t(0x00000000), int32_t(0x8D3D6FC9)},
    {"cdpars04.shp", "", int32_t(0x00000000), int32_t(0x027D9A69)},
    {"cdpars05.shp", "", int32_t(0x00000000), int32_t(0x3F1DB3D9)},
    {"cdpars06.shp", "", int32_t(0x00000000), int32_t(0x78BDC909)},
    {"cdpars07.shp", "", int32_t(0x00000000), int32_t(0x45DDE0B9)},
    {"cdpars08.shp", "", int32_t(0x00000000), int32_t(0xC78D7768)},
    {"cdpars09.shp", "", int32_t(0x00000000), int32_t(0xFAED5ED8)},
    {"cdpars10.shp", "", int32_t(0x00000000), int32_t(0x3CA1EF0C)},
    {"cdpars12.shp", "", int32_t(0x00000000), int32_t(0x4661BC6C)},
    {"cdpars12d.shp", "", int32_t(0x00000000), int32_t(0x91A36426)},
    {"cdpars13.shp", "", int32_t(0x00000000), int32_t(0x7B0195DC)},
    {"cdpars14.shp", "", int32_t(0x00000000), int32_t(0xC92149CC)},
    {"cdpol01e.shp", "", int32_t(0x00000000), int32_t(0x163E2E40)},
    {"cdpol01n.shp", "", int32_t(0x00000000), int32_t(0x61EE1F51)},
    {"cdpol01s.shp", "", int32_t(0x00000000), int32_t(0xF99E4C62)},
    {"cdpol01w.shp", "", int32_t(0x00000000), int32_t(0x0C1EEAA2)},
    {"cdprs03.shp", "", int32_t(0x00000000), int32_t(0xB45FE371)},
    {"cdrufgl.shp", "", int32_t(0x00000000), int32_t(0x332B307B)},
    {"cdrufgl_a.shp", "", int32_t(0x00000000), int32_t(0xF3396BB2)},
    {"cdrus02a.shp", "", int32_t(0x00000000), int32_t(0xFDAAC17B)},
    {"cdrus02b.shp", "", int32_t(0x00000000), int32_t(0xBA0ABBAB)},
    {"cdrus02c.shp", "", int32_t(0x00000000), int32_t(0x876A921B)},
    {"cdrus02d.shp", "", int32_t(0x00000000), int32_t(0x354A4E0B)},
    {"cdrus02e.shp", "", int32_t(0x00000000), int32_t(0x082A67BB)},
    {"cdrus02f.shp", "", int32_t(0x00000000), int32_t(0x4F8A1D6B)},
    {"cdrus02g.shp", "", int32_t(0x00000000), int32_t(0x72EA34DB)},
    {"cdrus03.shp", "", int32_t(0x00000000), int32_t(0xD4CB5E85)},
    {"cdrus04.shp", "", int32_t(0x00000000), int32_t(0xC9CE6E3D)},
    {"cdrus05.shp", "", int32_t(0x00000000), int32_t(0x0292BD98)},
    {"cdrus06.shp", "", int32_t(0x00000000), int32_t(0x8406CF36)},
    {"cdrus07.shp", "", int32_t(0x00000000), int32_t(0x4F5A1C93)},
    {"cdrus08.shp", "", int32_t(0x00000000), int32_t(0xBE0CAE46)},
    {"cdrus09.shp", "", int32_t(0x00000000), int32_t(0x75507DE3)},
    {"cdrus10.shp", "", int32_t(0x00000000), int32_t(0xF428279F)},
    {"cdrus11.shp", "", int32_t(0x00000000), int32_t(0x3F74F43A)},
    {"cdseat01.shp", "", int32_t(0x00000000), int32_t(0x4BD5F750)},
    {"cdsin03e.shp", "", int32_t(0x00000000), int32_t(0x81FE4ABF)},
    {"cdsin03s.shp", "", int32_t(0x00000000), int32_t(0x6E5E289D)},
    {"cdskfgl.shp", "", int32_t(0x00000000), int32_t(0xB8EBC2A6)},
    {"cdskfgl_a.shp", "", int32_t(0x00000000), int32_t(0x20D720AE)},
    {"cdstl01.shp", "", int32_t(0x00000000), int32_t(0xC421A374)},
    {"cdstl02.shp", "", int32_t(0x00000000), int32_t(0x42B5D1DA)},
    {"cdstl03.shp", "", int32_t(0x00000000), int32_t(0x89E9027F)},
    {"cdstl05a.shp", "", int32_t(0x00000000), int32_t(0xBD8DAD39)},
    {"cdstl05b.shp", "", int32_t(0x00000000), int32_t(0xFA2DD7E9)},
    {"cdstl05c.shp", "", int32_t(0x00000000), int32_t(0xC74DFE59)},
    {"cdstl05d.shp", "", int32_t(0x00000000), int32_t(0x756D2249)},
    {"cdstl05e.shp", "", int32_t(0x00000000), int32_t(0x480D0BF9)},
    {"cdstl05f.shp", "", int32_t(0x00000000), int32_t(0x0FAD7129)},
    {"cdstl05g.shp", "", int32_t(0x00000000), int32_t(0x32CD5899)},
    {"cdstl05h.shp", "", int32_t(0x00000000), int32_t(0xB09DCF48)},
    {"cdstrt01.shp", "", int32_t(0x00000000), int32_t(0x025A97AA)},
    {"cdstrt05.shp", "", int32_t(0x00000000), int32_t(0xF7DA316A)},
    {"cdswst01.shp", "", int32_t(0x00000000), int32_t(0xF77DABF1)},
    {"cdsydn01.shp", "", int32_t(0x00000000), int32_t(0x8A6F8BD1)},
    {"cdsydn02.shp", "", int32_t(0x00000000), int32_t(0xCDCFF101)},
    {"cdsydn03.shp", "", int32_t(0x00000000), int32_t(0xF0AFD8B1)},
    {"cdtech01.shp", "", int32_t(0x00000000), int32_t(0x4B521DEE)},
    {"cdtexs01.shp", "", int32_t(0x00000000), int32_t(0x0F5AF8A7)},
    {"cdtexs02.shp", "", int32_t(0x00000000), int32_t(0x48FA8277)},
    {"cdtexs03.shp", "", int32_t(0x00000000), int32_t(0x759AABC7)},
    {"cdtexs04.shp", "", int32_t(0x00000000), int32_t(0xC7BA77D7)},
    {"cdtexs05.shp", "", int32_t(0x00000000), int32_t(0xFADA5E67)},
    {"cdtexs06.shp", "", int32_t(0x00000000), int32_t(0xBD7A24B7)},
    {"cdtexs07.shp", "", int32_t(0x00000000), int32_t(0x801A0D07)},
    {"cdtexs08.shp", "", int32_t(0x00000000), int32_t(0x024A9AD6)},
    {"cdthosp.shp", "", int32_t(0x00000000), int32_t(0x9B70840C)},
    {"cdtran03.shp", "", int32_t(0x00000000), int32_t(0xD8C65371)},
    {"cdts01.shp", "", int32_t(0x00000000), int32_t(0x10784B07)},
    {"cdukfgl.shp", "", int32_t(0x00000000), int32_t(0xB5F5B2E1)},
    {"cdukfgl_a.shp", "", int32_t(0x00000000), int32_t(0xD8156B18)},
    {"cdurb01.shp", "", int32_t(0x00000000), int32_t(0xAFAFB88B)},
    {"cdurb02.shp", "", int32_t(0x00000000), int32_t(0x293BCA25)},
    {"cdusfgl.shp", "", int32_t(0x00000000), int32_t(0xA2ED5288)},
    {"cdusfgl_a.shp", "", int32_t(0x00000000), int32_t(0x36111EAF)},
    {"cdwa19_a.shp", "", int32_t(0x00000000), int32_t(0x5993E7D3)},
    {"cdwa2a.shp", "", int32_t(0x00000000), int32_t(0xD7344DA5)},
    {"cdwa2b.shp", "", int32_t(0x00000000), int32_t(0xE6DC5738)},
    {"cdwa2c.shp", "", int32_t(0x00000000), int32_t(0x40AB5C8C)},
    {"cdwa2d.shp", "", int32_t(0x00000000), int32_t(0x850C6202)},
    {"cdwash03.shp", "", int32_t(0x00000000), int32_t(0xFBF295AA)},
    {"cdwash04.shp", "", int32_t(0x00000000), int32_t(0x49D249BA)},
    {"cdwash05.shp", "", int32_t(0x00000000), int32_t(0x74B2600A)},
    {"cdwash06.shp", "", int32_t(0x00000000), int32_t(0x33121ADA)},
    {"cdwash07.shp", "", int32_t(0x00000000), int32_t(0x0E72336A)},
    {"cdwash08.shp", "", int32_t(0x00000000), int32_t(0x8C22A4BB)},
    {"cdwash09.shp", "", int32_t(0x00000000), int32_t(0xB1428D0B)},
    {"cdwash10.shp", "", int32_t(0x00000000), int32_t(0x770E3CDF)},
    {"cdwash11.shp", "", int32_t(0x00000000), int32_t(0x4A6E156F)},
    {"cdwash13.shp", "", int32_t(0x00000000), int32_t(0x30AE460F)},
    {"cdwash16.shp", "", int32_t(0x00000000), int32_t(0xF84EC97F)},
    {"cdwash17.shp", "", int32_t(0x00000000), int32_t(0xC52EE0CF)},
    {"cdwash18.shp", "", int32_t(0x00000000), int32_t(0x477E771E)},
    {"cdwash19.shp", "", int32_t(0x00000000), int32_t(0x7A1E5EAE)},
    {"cdwsh18a.shp", "", int32_t(0x00000000), int32_t(0x4EA4761A)},
    {"cdwt01.shp", "", int32_t(0x00000000), int32_t(0x9F2E9DCD)},
    {"ceawgam.pcx", "", int32_t(0x00000000), int32_t(0xA2D5D1D0)},
    {"ceilfan1.aud", "", int32_t(0xD816D8C7), int32_t(0x00000000)},
    {"cellsel.shp", "-", int32_t(0x00000000), int32_t(0x686584AC)},
    {"cem_apr.csv", "", int32_t(0xDA3008D2), int32_t(0x00000000)},
    {"cem_apr.lsv", "", int32_t(0xDA3008DB), int32_t(0x00000000)},
    {"cem_apr.vqa", "", int32_t(0xDA1B06E5), int32_t(0x00000000)},
    {"cem_apr_e.vqa", "", int32_t(0x1A5FC7E8), int32_t(0x00000000)},
    {"cem_apr_e.vqt", "", int32_t(0x1A5FC7FB), int32_t(0x00000000)},
    {"cem_apr_h.pcx", "", int32_t(0xFE53C804), int32_t(0x00000000)},
    {"cem_apr_h.vqa", "", int32_t(0x1A5FC7EE), int32_t(0x00000000)},
    {"cem_apr_l.pcx", "", int32_t(0xFE53C80C), int32_t(0x00000000)},
    {"cem_apr_l.vqa", "", int32_t(0x1A5FC7F6), int32_t(0x00000000)},
    {"cementl1.aud", "", int32_t(0xBC22FED7), int32_t(0x00000000)},
    {"cementl2.aud", "", int32_t(0xBE22FED7), int32_t(0x00000000)},
    {"cementl3.aud", "", int32_t(0xC022FED7), int32_t(0x00000000)},
    {"cementl4.aud", "", int32_t(0xC222FED7), int32_t(0x00000000)},
    {"cementl5.aud", "", int32_t(0xC422FED7), int32_t(0x00000000)},
    {"cementr1.aud", "", int32_t(0xBC2EFED7), int32_t(0x00000000)},
    {"cementr2.aud", "", int32_t(0xBE2EFED7), int32_t(0x00000000)},
    {"cementr3.aud", "", int32_t(0xC02EFED7), int32_t(0x00000000)},
    {"cementr4.aud", "", int32_t(0xC22EFED7), int32_t(0x00000000)},
    {"cementr5.aud", "", int32_t(0xC42EFED7), int32_t(0x00000000)},
    {"cemwetl1.aud", "", int32_t(0x0422FEC5), int32_t(0x00000000)},
    {"cemwetl2.aud", "", int32_t(0x0622FEC5), int32_t(0x00000000)},
    {"cemwetl3.aud", "", int32_t(0x0822FEC5), int32_t(0x00000000)},
    {"cemwetl4.aud", "", int32_t(0x0A22FEC5), int32_t(0x00000000)},
    {"cemwetl5.aud", "", int32_t(0x0C22FEC5), int32_t(0x00000000)},
    {"cemwetr1.aud", "", int32_t(0x042EFEC5), int32_t(0x00000000)},
    {"cemwetr2.aud", "", int32_t(0x062EFEC5), int32_t(0x00000000)},
    {"cemwetr3.aud", "", int32_t(0x082EFEC5), int32_t(0x00000000)},
    {"cemwetr4.aud", "", int32_t(0x0A2EFEC5), int32_t(0x00000000)},
    {"cemwetr5.aud", "", int32_t(0x0C2EFEC5), int32_t(0x00000000)},
    {"cemwndr1.aud", "", int32_t(0x042EDED7), int32_t(0x00000000)},
    {"center.wsa", "anim: mouth moving", int32_t(0xFF95FAEA), int32_t(0x00000000)},
    {"center1.wsa", "anim: center mouth moving", int32_t(0xADDD0CEE), int32_t(0x00000000)},
    {"center16.aud", "center", int32_t(0x01F0FAC5), int32_t(0x00000000)},
    {"ceva001.wav", "", int32_t(0x00000000), int32_t(0x28C73F4F)},
    {"ceva002.wav", "", int32_t(0x00000000), int32_t(0xAE534DE1)},
    {"ceva003.wav", "", int32_t(0x00000000), int32_t(0x650F9E44)},
    {"ceva004.wav", "", int32_t(0x00000000), int32_t(0x780AAEFC)},
    {"ceva005.wav", "", int32_t(0x00000000), int32_t(0xB3567D59)},
    {"ceva006.wav", "", int32_t(0x00000000), int32_t(0x35C20FF7)},
    {"ceva007.wav", "", int32_t(0x00000000), int32_t(0xFE9EDC52)},
    {"ceva008.wav", "", int32_t(0x00000000), int32_t(0x0FC86E87)},
    {"ceva009.wav", "", int32_t(0x00000000), int32_t(0xC494BD22)},
    {"ceva010.wav", "", int32_t(0x00000000), int32_t(0x45ECE75E)},
    {"ceva011.wav", "", int32_t(0x00000000), int32_t(0x8EB034FB)},
    {"ceva012.wav", "", int32_t(0x00000000), int32_t(0x08244655)},
    {"ceva013.wav", "", int32_t(0x00000000), int32_t(0xC37895F0)},
    {"ceva014.wav", "", int32_t(0x00000000), int32_t(0xDE7DA548)},
    {"ceva015.wav", "", int32_t(0x00000000), int32_t(0x152176ED)},
    {"ceva016.wav", "", int32_t(0x00000000), int32_t(0x93B50443)},
    {"ceva017.wav", "", int32_t(0x00000000), int32_t(0x58E9D7E6)},
    {"ceva018.wav", "", int32_t(0x00000000), int32_t(0xA9BF6533)},
    {"ceva019.wav", "", int32_t(0x00000000), int32_t(0x62E3B696)},
    {"ceva020.wav", "", int32_t(0x00000000), int32_t(0x7404FDC3)},
    {"ceva021.wav", "", int32_t(0x00000000), int32_t(0xBF582E66)},
    {"ceva022.wav", "", int32_t(0x00000000), int32_t(0x39CC5CC8)},
    {"ceva023.wav", "", int32_t(0x00000000), int32_t(0xF2908F6D)},
    {"ceva024.wav", "", int32_t(0x00000000), int32_t(0xEF95BFD5)},
    {"ceva025.wav", "", int32_t(0x00000000), int32_t(0x24C96C70)},
    {"ceva026.wav", "", int32_t(0x00000000), int32_t(0xA25D1EDE)},
    {"ceva027.wav", "", int32_t(0x00000000), int32_t(0x6901CD7B)},
    {"ceva028.wav", "", int32_t(0x00000000), int32_t(0x98577FAE)},
    {"ceva029.wav", "", int32_t(0x00000000), int32_t(0x530BAC0B)},
    {"ceva030.wav", "", int32_t(0x00000000), int32_t(0xD273F677)},
    {"ceva031.wav", "", int32_t(0x00000000), int32_t(0x192F25D2)},
    {"ceva032.wav", "", int32_t(0x00000000), int32_t(0x9FBB577C)},
    {"ceva033.wav", "", int32_t(0x00000000), int32_t(0x54E784D9)},
    {"ceva035.wav", "", int32_t(0x00000000), int32_t(0x82BE67C4)},
    {"ceva036.wav", "", int32_t(0x00000000), int32_t(0x042A156A)},
    {"ceva037.wav", "", int32_t(0x00000000), int32_t(0xCF76C6CF)},
    {"ceva038.wav", "", int32_t(0x00000000), int32_t(0x3E20741A)},
    {"ceva039.wav", "", int32_t(0x00000000), int32_t(0xF57CA7BF)},
    {"ceva040.wav", "", int32_t(0x00000000), int32_t(0x17D4C8F9)},
    {"ceva041.wav", "", int32_t(0x00000000), int32_t(0xDC881B5C)},
    {"ceva042.wav", "", int32_t(0x00000000), int32_t(0x5A1C69F2)},
    {"ceva043.wav", "", int32_t(0x00000000), int32_t(0x9140BA57)},
    {"ceva044.wav", "", int32_t(0x00000000), int32_t(0x8C458AEF)},
    {"ceva045.wav", "", int32_t(0x00000000), int32_t(0x4719594A)},
    {"ceva046.wav", "", int32_t(0x00000000), int32_t(0xC18D2BE4)},
    {"ceva047.wav", "", int32_t(0x00000000), int32_t(0x0AD1F841)},
    {"ceva048.wav", "", int32_t(0x00000000), int32_t(0xFB874A94)},
    {"ceva049.wav", "", int32_t(0x00000000), int32_t(0x30DB9931)},
    {"ceva050.wav", "", int32_t(0x00000000), int32_t(0xB1A3C34D)},
    {"ceva051.wav", "", int32_t(0x00000000), int32_t(0x7AFF10E8)},
    {"ceva052.wav", "", int32_t(0x00000000), int32_t(0xFC6B6246)},
    {"ceva053.wav", "", int32_t(0x00000000), int32_t(0x3737B1E3)},
    {"ceva054.wav", "", int32_t(0x00000000), int32_t(0x2A32815B)},
    {"ceva055.wav", "", int32_t(0x00000000), int32_t(0xE16E52FE)},
    {"ceva056.wav", "", int32_t(0x00000000), int32_t(0x67FA2050)},
    {"ceva057.wav", "", int32_t(0x00000000), int32_t(0xACA6F3F5)},
    {"ceva058.wav", "", int32_t(0x00000000), int32_t(0x5DF04120)},
    {"ceva059.wav", "", int32_t(0x00000000), int32_t(0x96AC9285)},
    {"ceva060.wav", "", int32_t(0x00000000), int32_t(0x804BD9D0)},
    {"ceva061.wav", "", int32_t(0x00000000), int32_t(0x4B170A75)},
    {"ceva062.wav", "", int32_t(0x00000000), int32_t(0xCD8378DB)},
    {"ceva063.wav", "", int32_t(0x00000000), int32_t(0x06DFAB7E)},
    {"ceva064.wav", "", int32_t(0x00000000), int32_t(0x1BDA9BC6)},
    {"ceva065.wav", "", int32_t(0x00000000), int32_t(0xD0864863)},
    {"ceva066.wav", "", int32_t(0x00000000), int32_t(0x56123ACD)},
    {"ceva067.wav", "", int32_t(0x00000000), int32_t(0x9D4EE968)},
    {"ceva068.wav", "", int32_t(0x00000000), int32_t(0x6C185BBD)},
    {"ceva069.wav", "", int32_t(0x00000000), int32_t(0xA7448818)},
    {"ceva070.wav", "", int32_t(0x00000000), int32_t(0x263CD264)},
    {"ceva071.wav", "", int32_t(0x00000000), int32_t(0xED6001C1)},
    {"ceva072.wav", "", int32_t(0x00000000), int32_t(0x6BF4736F)},
    {"ceva073.wav", "", int32_t(0x00000000), int32_t(0xA0A8A0CA)},
    {"ceva074.wav", "", int32_t(0x00000000), int32_t(0xBDAD9072)},
    {"ceva075.wav", "", int32_t(0x00000000), int32_t(0x76F143D7)},
    {"ceva076.wav", "", int32_t(0x00000000), int32_t(0xF0653179)},
    {"ceva077.wav", "", int32_t(0x00000000), int32_t(0x3B39E2DC)},
    {"ceva078.wav", "", int32_t(0x00000000), int32_t(0xCA6F5009)},
    {"ceva079.wav", "", int32_t(0x00000000), int32_t(0x013383AC)},
    {"ceva080.wav", "", int32_t(0x00000000), int32_t(0xD074A28D)},
    {"ceva081.wav", "", int32_t(0x00000000), int32_t(0x1B287128)},
    {"ceva082.wav", "", int32_t(0x00000000), int32_t(0x9DBC0386)},
    {"ceva083.wav", "", int32_t(0x00000000), int32_t(0x56E0D023)},
    {"ceva084.wav", "", int32_t(0x00000000), int32_t(0x4BE5E09B)},
    {"ceva085.wav", "", int32_t(0x00000000), int32_t(0x80B9333E)},
    {"ceva086.wav", "", int32_t(0x00000000), int32_t(0x062D4190)},
    {"ceva087.wav", "", int32_t(0x00000000), int32_t(0xCD719235)},
    {"ceva088.wav", "", int32_t(0x00000000), int32_t(0x3C2720E0)},
    {"ceva089.wav", "", int32_t(0x00000000), int32_t(0xF77BF345)},
    {"ceva090.wav", "", int32_t(0x00000000), int32_t(0x7603A939)},
    {"ceva091.wav", "", int32_t(0x00000000), int32_t(0xBD5F7A9C)},
    {"ceva092.wav", "", int32_t(0x00000000), int32_t(0x3BCB0832)},
    {"ceva093.wav", "", int32_t(0x00000000), int32_t(0xF097DB97)},
    {"ceva094.wav", "", int32_t(0x00000000), int32_t(0xED92EB2F)},
    {"ceva095.wav", "", int32_t(0x00000000), int32_t(0x26CE388A)},
    {"ceva096.wav", "", int32_t(0x00000000), int32_t(0xA05A4A24)},
    {"ceva097.wav", "", int32_t(0x00000000), int32_t(0x6B069981)},
    {"ceva098.wav", "", int32_t(0x00000000), int32_t(0x9A502B54)},
    {"ceva099.wav", "", int32_t(0x00000000), int32_t(0x510CF8F1)},
    {"ceva100.wav", "", int32_t(0x00000000), int32_t(0x2F31EC74)},
    {"ceva101.wav", "", int32_t(0x00000000), int32_t(0xE46D3FD1)},
    {"ceva102.wav", "", int32_t(0x00000000), int32_t(0x62F94D7F)},
    {"ceva103.wav", "", int32_t(0x00000000), int32_t(0xA9A59EDA)},
    {"ceva104.wav", "", int32_t(0x00000000), int32_t(0xB4A0AE62)},
    {"ceva105.wav", "", int32_t(0x00000000), int32_t(0x7FFC7DC7)},
    {"ceva106.wav", "", int32_t(0x00000000), int32_t(0xF9680F69)},
    {"ceva107.wav", "", int32_t(0x00000000), int32_t(0x3234DCCC)},
    {"ceva108.wav", "", int32_t(0x00000000), int32_t(0xC3626E19)},
    {"ceva109.wav", "", int32_t(0x00000000), int32_t(0x083EBDBC)},
    {"ceva120.wav", "", int32_t(0x00000000), int32_t(0xB8AEFD5D)},
    {"ceva121.wav", "", int32_t(0x00000000), int32_t(0x73F22EF8)},
    {"ceva122.wav", "", int32_t(0x00000000), int32_t(0xF5665C56)},
    {"ceva123.wav", "", int32_t(0x00000000), int32_t(0x3E3A8FF3)},
    {"ceva124.wav", "", int32_t(0x00000000), int32_t(0x233FBF4B)},
    {"ceva125.wav", "", int32_t(0x00000000), int32_t(0xE8636CEE)},
    {"ceva127.wav", "", int32_t(0x00000000), int32_t(0xA5ABCDE5)},
    {"ceva128.wav", "", int32_t(0x00000000), int32_t(0x54FD7F30)},
    {"ceva129.wav", "", int32_t(0x00000000), int32_t(0x9FA1AC95)},
    {"ceva130.wav", "", int32_t(0x00000000), int32_t(0x1ED9F6E9)},
    {"ceva131.wav", "", int32_t(0x00000000), int32_t(0xD585254C)},
    {"ceva132.wav", "", int32_t(0x00000000), int32_t(0x531157E2)},
    {"ceva133.wav", "", int32_t(0x00000000), int32_t(0x984D8447)},
    {"ceva134.wav", "", int32_t(0x00000000), int32_t(0x8548B4FF)},
    {"ceva135.wav", "", int32_t(0x00000000), int32_t(0x4E14675A)},
    {"ceva136.wav", "", int32_t(0x00000000), int32_t(0xC88015F4)},
    {"ceva137.wav", "", int32_t(0x00000000), int32_t(0x03DCC651)},
    {"ceva138.wav", "", int32_t(0x00000000), int32_t(0xF28A7484)},
    {"ceva139.wav", "", int32_t(0x00000000), int32_t(0x39D6A721)},
    {"ceva140.wav", "", int32_t(0x00000000), int32_t(0xDB7EC867)},
    {"ceva141.wav", "", int32_t(0x00000000), int32_t(0x10221BC2)},
    {"ceva142.wav", "", int32_t(0x00000000), int32_t(0x96B6696C)},
    {"ceva143.wav", "", int32_t(0x00000000), int32_t(0x5DEABAC9)},
    {"ceva150.wav", "", int32_t(0x00000000), int32_t(0x7D09C3D3)},
    {"ceva151.wav", "", int32_t(0x00000000), int32_t(0xB6551076)},
    {"ceva153.wav", "", int32_t(0x00000000), int32_t(0xFB9DB17D)},
    {"cevau06.wav", "", int32_t(0x00000000), int32_t(0xADC9A128)},
    {"cevau07.wav", "", int32_t(0x00000000), int32_t(0x6695728D)},
    {"cevau08.wav", "", int32_t(0x00000000), int32_t(0x97C3C058)},
    {"cevau13.wav", "", int32_t(0x00000000), int32_t(0x5B733B2F)},
    {"cevau15.wav", "", int32_t(0x00000000), int32_t(0x8D2AD832)},
    {"cevau19.wav", "", int32_t(0x00000000), int32_t(0xFAE81849)},
    {"cevau20.wav", "", int32_t(0x00000000), int32_t(0xEC0F531C)},
    {"cevau22.wav", "", int32_t(0x00000000), int32_t(0xA1C7F217)},
    {"cevau23.wav", "", int32_t(0x00000000), int32_t(0x6A9B21B2)},
    {"cevau24.wav", "", int32_t(0x00000000), int32_t(0x779E110A)},
    {"cevau25.wav", "", int32_t(0x00000000), int32_t(0xBCC2C2AF)},
    {"cevau26.wav", "", int32_t(0x00000000), int32_t(0x3A56B001)},
    {"cevau27.wav", "", int32_t(0x00000000), int32_t(0xF10A63A4)},
    {"cevau31.wav", "", int32_t(0x00000000), int32_t(0x81248B0D)},
    {"cevau36.wav", "", int32_t(0x00000000), int32_t(0x9C21BBB5)},
    {"cevau37.wav", "", int32_t(0x00000000), int32_t(0x577D6810)},
    {"cevau38.wav", "", int32_t(0x00000000), int32_t(0xA62BDAC5)},
    {"cevau39.wav", "", int32_t(0x00000000), int32_t(0x6D770960)},
    {"cevau40.wav", "", int32_t(0x00000000), int32_t(0x8FDF6626)},
    {"cevau41.wav", "", int32_t(0x00000000), int32_t(0x4483B583)},
    {"cevau42.wav", "", int32_t(0x00000000), int32_t(0xC217C72D)},
    {"cevau43.wav", "", int32_t(0x00000000), int32_t(0x094B1488)},
    {"cevau44.wav", "", int32_t(0x00000000), int32_t(0x144E2430)},
    {"cevau45.wav", "", int32_t(0x00000000), int32_t(0xDF12F795)},
    {"cevau46.wav", "", int32_t(0x00000000), int32_t(0x5986853B)},
    {"cevau47.wav", "", int32_t(0x00000000), int32_t(0x92DA569E)},
    {"cevau48.wav", "", int32_t(0x00000000), int32_t(0x638CE44B)},
    {"cevau49.wav", "", int32_t(0x00000000), int32_t(0xA8D037EE)},
    {"cevau50.wav", "", int32_t(0x00000000), int32_t(0x29A86D92)},
    {"cevau51.wav", "", int32_t(0x00000000), int32_t(0xE2F4BE37)},
    {"cevau52.wav", "", int32_t(0x00000000), int32_t(0x6460CC99)},
    {"cevau53.wav", "", int32_t(0x00000000), int32_t(0xAF3C1F3C)},
    {"cevau54.wav", "", int32_t(0x00000000), int32_t(0xB2392F84)},
    {"cevau55.wav", "", int32_t(0x00000000), int32_t(0x7965FC21)},
    {"cevau56.wav", "", int32_t(0x00000000), int32_t(0xFFF18E8F)},
    {"cevau57.wav", "", int32_t(0x00000000), int32_t(0x34AD5D2A)},
    {"cevau58.wav", "", int32_t(0x00000000), int32_t(0xC5FBEFFF)},
    {"cevau59.wav", "", int32_t(0x00000000), int32_t(0x0EA73C5A)},
    {"cevau60.wav", "", int32_t(0x00000000), int32_t(0x1840770F)},
    {"cevau61.wav", "", int32_t(0x00000000), int32_t(0xD31CA4AA)},
    {"cevau62.wav", "", int32_t(0x00000000), int32_t(0x5588D604)},
    {"cevau63.wav", "", int32_t(0x00000000), int32_t(0x9ED405A1)},
    {"cevau64.wav", "", int32_t(0x00000000), int32_t(0x83D13519)},
    {"cevau65.wav", "", int32_t(0x00000000), int32_t(0x488DE6BC)},
    {"cevau66.wav", "", int32_t(0x00000000), int32_t(0xCE199412)},
    {"cevau67.wav", "", int32_t(0x00000000), int32_t(0x054547B7)},
    {"cevau68.wav", "", int32_t(0x00000000), int32_t(0xF413F562)},
    {"cevau69.wav", "", int32_t(0x00000000), int32_t(0x3F4F26C7)},
    {"cevau70.wav", "", int32_t(0x00000000), int32_t(0xBE377CBB)},
    {"cevau71.wav", "", int32_t(0x00000000), int32_t(0x756BAF1E)},
    {"cevau72.wav", "", int32_t(0x00000000), int32_t(0xF3FFDDB0)},
    {"cevau73.wav", "", int32_t(0x00000000), int32_t(0x38A30E15)},
    {"cevau74.wav", "", int32_t(0x00000000), int32_t(0x25A63EAD)},
    {"cevau75.wav", "", int32_t(0x00000000), int32_t(0xEEFAED08)},
    {"cevau76.wav", "", int32_t(0x00000000), int32_t(0x686E9FA6)},
    {"cevau77.wav", "", int32_t(0x00000000), int32_t(0xA3324C03)},
    {"cevau78.wav", "", int32_t(0x00000000), int32_t(0x5264FED6)},
    {"cevau79.wav", "", int32_t(0x00000000), int32_t(0x99382D73)},
    {"cevau80.wav", "", int32_t(0x00000000), int32_t(0x487F0C52)},
    {"cevau81.wav", "", int32_t(0x00000000), int32_t(0x8323DFF7)},
    {"cevau82.wav", "", int32_t(0x00000000), int32_t(0x05B7AD59)},
    {"cevau83.wav", "", int32_t(0x00000000), int32_t(0xCEEB7EFC)},
    {"cevau85.wav", "", int32_t(0x00000000), int32_t(0x18B29DE1)},
    {"cevau86.wav", "", int32_t(0x00000000), int32_t(0x9E26EF4F)},
    {"cevau87.wav", "", int32_t(0x00000000), int32_t(0x557A3CEA)},
    {"cevau88.wav", "", int32_t(0x00000000), int32_t(0xA42C8E3F)},
    {"cevau89.wav", "", int32_t(0x00000000), int32_t(0x6F705D9A)},
    {"cevau90.wav", "", int32_t(0x00000000), int32_t(0xEE0807E6)},
    {"cevau91.wav", "", int32_t(0x00000000), int32_t(0x2554D443)},
    {"cevau92.wav", "", int32_t(0x00000000), int32_t(0xA3C0A6ED)},
    {"cevau93.wav", "", int32_t(0x00000000), int32_t(0x689C7548)},
    {"cevau94.wav", "", int32_t(0x00000000), int32_t(0x759945F0)},
    {"cfirstr.pcx", "-", int32_t(0x00000000), int32_t(0x5DE08E9C)},
    {"cfirstrh.pcx", "-", int32_t(0x00000000), int32_t(0x8B9D8511)},
    {"cgbarr01.shp", "", int32_t(0x00000000), int32_t(0xD6532979)},
    {"cgbarr02.shp", "", int32_t(0x00000000), int32_t(0x91F353A9)},
    {"cgbunk03.shp", "", int32_t(0x00000000), int32_t(0x84ED941D)},
    {"cgbunk04.shp", "", int32_t(0x00000000), int32_t(0x36CD480D)},
    {"cgch06dm.shp", "", int32_t(0x00000000), int32_t(0xD4947935)},
    {"cgchig04.shp", "", int32_t(0x00000000), int32_t(0x49E5E578)},
    {"cgchig04d.shp", "", int32_t(0x00000000), int32_t(0xE2E5F10F)},
    {"cgchig06.shp", "", int32_t(0x00000000), int32_t(0x3325B618)},
    {"cgeast02.shp", "", int32_t(0x00000000), int32_t(0xDC557D74)},
    {"cgegyp01.shp", "", int32_t(0x00000000), int32_t(0x8D6046F5)},
    {"cgegyp02.shp", "", int32_t(0x00000000), int32_t(0xCAC03C25)},
    {"cgegyp03.shp", "", int32_t(0x00000000), int32_t(0xF7A01595)},
    {"cgegyp04.shp", "", int32_t(0x00000000), int32_t(0x4580C985)},
    {"cgegyp05.shp", "", int32_t(0x00000000), int32_t(0x78E0E035)},
    {"cgegyp06.shp", "", int32_t(0x00000000), int32_t(0x3F409AE5)},
    {"cgla01.shp", "", int32_t(0x00000000), int32_t(0x3FD586ED)},
    {"cgla02.shp", "", int32_t(0x00000000), int32_t(0x0E3D9C70)},
    {"cgla03.shp", "", int32_t(0x00000000), int32_t(0xA84A97C4)},
    {"cgla04.shp", "", int32_t(0x00000000), int32_t(0x6DEDA94A)},
    {"cgla05.shp", "", int32_t(0x00000000), int32_t(0xCB9AA2FE)},
    {"cgla06.shp", "", int32_t(0x00000000), int32_t(0xFA72B863)},
    {"cgla07.shp", "", int32_t(0x00000000), int32_t(0x5C05B3D7)},
    {"cgla08.shp", "", int32_t(0x00000000), int32_t(0xAA4DC33E)},
    {"cgla09.shp", "", int32_t(0x00000000), int32_t(0x0C3AC88A)},
    {"cgla10.shp", "", int32_t(0x00000000), int32_t(0x55088DC7)},
    {"cgla10_a.shp", "", int32_t(0x00000000), int32_t(0x8AA7BE1E)},
    {"cgla11.shp", "", int32_t(0x00000000), int32_t(0xF37F8673)},
    {"cgla12.shp", "", int32_t(0x00000000), int32_t(0xC2979CEE)},
    {"cgla13.shp", "", int32_t(0x00000000), int32_t(0x64E0975A)},
    {"cglnd6_a.shp", "", int32_t(0x00000000), int32_t(0xD27EDB01)},
    {"cglond01.shp", "", int32_t(0x00000000), int32_t(0x2F424FC8)},
    {"cglond03.shp", "", int32_t(0x00000000), int32_t(0x55821CA8)},
    {"cglond04.shp", "", int32_t(0x00000000), int32_t(0xE7A2C0B8)},
    {"cglond06.shp", "", int32_t(0x00000000), int32_t(0x9D6293D8)},
    {"cgmach.shp", "", int32_t(0x00000000), int32_t(0x8B38EE58)},
    {"cgmach_f.shp", "", int32_t(0x00000000), int32_t(0xE6B70191)},
    {"cgmorr01.shp", "", int32_t(0x00000000), int32_t(0xEF9AA966)},
    {"cgmorr02.shp", "", int32_t(0x00000000), int32_t(0xA83AD3B6)},
    {"cgmorr03.shp", "", int32_t(0x00000000), int32_t(0x955AFA06)},
    {"cgmorr04.shp", "", int32_t(0x00000000), int32_t(0x277A2616)},
    {"cgmorr05.shp", "", int32_t(0x00000000), int32_t(0x1A1A0FA6)},
    {"cgmorr06.shp", "", int32_t(0x00000000), int32_t(0x5DBA7576)},
    {"cgmorr07.shp", "", int32_t(0x00000000), int32_t(0x60DA5CC6)},
    {"cgmorr08.shp", "", int32_t(0x00000000), int32_t(0xE28ACB17)},
    {"cgmorr09.shp", "", int32_t(0x00000000), int32_t(0xDFEAE2A7)},
    {"cgmorr10.shp", "", int32_t(0x00000000), int32_t(0x19A65373)},
    {"cgnewy04.shp", "", int32_t(0x00000000), int32_t(0x13844D15)},
    {"cgny04dm.shp", "", int32_t(0x00000000), int32_t(0x0D4EB59E)},
    {"cgpark04.shp", "", int32_t(0x00000000), int32_t(0xCFAE2EC1)},
    {"cgpark05.shp", "", int32_t(0x00000000), int32_t(0xF2CE0771)},
    {"cgpark06.shp", "", int32_t(0x00000000), int32_t(0xB56E7DA1)},
    {"cgpars01.shp", "", int32_t(0x00000000), int32_t(0x537F7318)},
    {"cgpars11.shp", "", int32_t(0x00000000), int32_t(0x9823A0BD)},
    {"cgpars11d.shp", "", int32_t(0x00000000), int32_t(0xB953329A)},
    {"cgpowr.shp", "", int32_t(0x00000000), int32_t(0xAAF5C3C3)},
    {"cgpowr_a.shp", "", int32_t(0x00000000), int32_t(0x755AF01A)},
    {"cgpr01dm.shp", "", int32_t(0x00000000), int32_t(0xE444B5BF)},
    {"cgpr11dm.shp", "", int32_t(0x00000000), int32_t(0x28EEB521)},
    {"cgrus01.shp", "", int32_t(0x00000000), int32_t(0x00E1998F)},
    {"cgrus01d.shp", "", int32_t(0x00000000), int32_t(0x2A3C5AA4)},
    {"cgsanf01.shp", "", int32_t(0x00000000), int32_t(0xA6BA5F16)},
    {"cgsanf02.shp", "", int32_t(0x00000000), int32_t(0xE11A25C6)},
    {"cgsanf03.shp", "", int32_t(0x00000000), int32_t(0xDC7A0C76)},
    {"cgsanf04.shp", "", int32_t(0x00000000), int32_t(0x6E5AD066)},
    {"cgsanf06.shp", "", int32_t(0x00000000), int32_t(0x149A8306)},
    {"cgsanf07.shp", "", int32_t(0x00000000), int32_t(0x29FAAAB6)},
    {"cgsanf08.shp", "", int32_t(0x00000000), int32_t(0xABAA3D67)},
    {"cgsanf09.shp", "", int32_t(0x00000000), int32_t(0x96CA14D7)},
    {"cgsanf10.shp", "", int32_t(0x00000000), int32_t(0x5086A503)},
    {"cgsanf11.shp", "", int32_t(0x00000000), int32_t(0x6DE68CB3)},
    {"cgsanf12.shp", "", int32_t(0x00000000), int32_t(0x2A46F663)},
    {"cgsanf13.shp", "", int32_t(0x00000000), int32_t(0x1726DFD3)},
    {"cgsanf14.shp", "", int32_t(0x00000000), int32_t(0xA50603C3)},
    {"cgsin03e.shp", "", int32_t(0x00000000), int32_t(0x181C2CBE)},
    {"cgsin03s.shp", "", int32_t(0x00000000), int32_t(0xF7BC4E9C)},
    {"cgslab.shp", "", int32_t(0x00000000), int32_t(0xA545E067)},
    {"cgslab_f.shp", "", int32_t(0x00000000), int32_t(0xC8CA0FAE)},
    {"cgstl04.shp", "", int32_t(0x00000000), int32_t(0x0D0E54C6)},
    {"cgstl04dm.shp", "", int32_t(0x00000000), int32_t(0x03579AA6)},
    {"cgsydn02.shp", "", int32_t(0x00000000), int32_t(0x542D9700)},
    {"cgtime01.shp", "", int32_t(0x00000000), int32_t(0x40D9FB09)},
    {"cgtime02.shp", "", int32_t(0x00000000), int32_t(0x077981D9)},
    {"cgtime_a.shp", "", int32_t(0x00000000), int32_t(0x40A9A649)},
    {"cgurb01.shp", "", int32_t(0x00000000), int32_t(0x364DDE8A)},
    {"cgurb02.shp", "", int32_t(0x00000000), int32_t(0xB0D9AC24)},
    {"cgwa14dm.shp", "", int32_t(0x00000000), int32_t(0x0D47FF4B)},
    {"cgwa15dm.shp", "", int32_t(0x00000000), int32_t(0xAB30F4FF)},
    {"cgwash01.shp", "", int32_t(0x00000000), int32_t(0x18D0A0CB)},
    {"cgwash14.shp", "", int32_t(0x00000000), int32_t(0x1B6CFC1E)},
    {"cgwash15.shp", "", int32_t(0x00000000), int32_t(0x260CD5AE)},
    {"cgws01dm.shp", "", int32_t(0x00000000), int32_t(0x11E3BA85)},
    {"cgwsh12.shp", "", int32_t(0x00000000), int32_t(0x94E07F26)},
    {"cgwsh12a.shp", "", int32_t(0x00000000), int32_t(0x76DD337D)},
    {"cgwsh12d.shp", "", int32_t(0x00000000), int32_t(0xBE3DBC0D)},
    {"chain1.aud", "", int32_t(0xA761C7FE), int32_t(0x00000000)},
    {"chain1z.aud", "", int32_t(0x81FDD8EA), int32_t(0x00000000)},
    {"chain2.aud", "", int32_t(0xA761C9FE), int32_t(0x00000000)},
    {"chain2z.aud", "", int32_t(0x81FDDAEA), int32_t(0x00000000)},
    {"chain3.aud", "", int32_t(0xA761CBFE), int32_t(0x00000000)},
    {"chain3z.aud", "", int32_t(0x81FDDCEA), int32_t(0x00000000)},
    {"chain4.aud", "", int32_t(0xA761CDFE), int32_t(0x00000000)},
    {"chainbrk.aud", "", int32_t(0xFFFEE6D7), int32_t(0x00000000)},
    {"chaingn1.aud", "buggy fires gun/apache fires guns", int32_t(0x00000000), int32_t(0xC08AF067)},
    {"chainlnk.aud", "", int32_t(0xFFF6FAD7), int32_t(0x00000000)},
    {"chambat1.aud", "", int32_t(0xDC02E4BF), int32_t(0x00000000)},
    {"chamicon.shp", "icon: mutant hijacker", int32_t(0x00000000), int32_t(0x2926E7A5)},
    {"chamspy.shp", "unit: chameleon spy", int32_t(0x00000000), int32_t(0x27897619)},
    {"chamwdr1.aud", "", int32_t(0xDBFEEAE9), int32_t(0x00000000)},
    {"chan.shp", "chan", int32_t(0xECCAE3B4), int32_t(0x00000000)},
    {"changlng.flc", "", int32_t(0x0AEDFFC9), int32_t(0x00000000)},
    {"changpov.aud", "", int32_t(0x29F902C9), int32_t(0x00000000)},
    {"chant1.aud", "", int32_t(0xBB61C80A), int32_t(0x00000000)},
    {"chant2.aud", "", int32_t(0xBB61CA0A), int32_t(0x00000000)},
    {"chant3.aud", "", int32_t(0xBB61CC0A), int32_t(0x00000000)},
    {"chant4.aud", "", int32_t(0xBB61CE0A), int32_t(0x00000000)},
    {"chant5.aud", "", int32_t(0xBB61D00A), int32_t(0x00000000)},
    {"chaos2.aud", "chaos2", int32_t(0xBF61CA08), int32_t(0x00000000)},
    {"charge2.aud", "", int32_t(0xA5AE00DC), int32_t(0x00000000)},
    {"charmtl7.aud", "", int32_t(0xFBF30AD5), int32_t(0x00000000)},
    {"charmtl8.aud", "", int32_t(0xFDF30AD5), int32_t(0x00000000)},
    {"charmtl9.aud", "", int32_t(0xFFF30AD5), int32_t(0x00000000)},
    {"checks.shp", "", int32_t(0x00000000), int32_t(0x93DDA16D)},
    {"chekhole.aud", "", int32_t(0xFC0300CB), int32_t(0x00000000)},
    {"chem-e.shp", "chem. spray e", int32_t(0xDB71FBAF), int32_t(0x00000000)},
    {"chem-n.shp", "chem. spray n", int32_t(0xDB720DAF), int32_t(0x00000000)},
    {"chem-ne.shp", "chem. spray ne", int32_t(0x91F005BA), int32_t(0x00000000)},
    {"chem-nw.shp", "chem. spray nw", int32_t(0x921405BA), int32_t(0x00000000)},
    {"chem-s.shp", "chem. spray s", int32_t(0xDB7217AF), int32_t(0x00000000)},
    {"chem-se.shp", "chem. spray se", int32_t(0x91F00FBA), int32_t(0x00000000)},
    {"chem-sw.shp", "chem. spray sw", int32_t(0x92140FBA), int32_t(0x00000000)},
    {"chem-w.shp", "chem. spray w", int32_t(0xDB721FAF), int32_t(0x00000000)},
    {"chemball.shp", "chem explosion", int32_t(0x1DF5F6BF), int32_t(0x00000000)},
    {"chemicon.shp", "icon: chemical missile", int32_t(0x00000000), int32_t(0x20CD47DF)},
    {"chemisle.shp", "crate: chemical missile", int32_t(0x00000000), int32_t(0xB65798AE)},
    {"chevby1.aud", "", int32_t(0xB5BC28D2), int32_t(0x00000000)},
    {"chicken1.aud", "", int32_t(0xB416ECD1), int32_t(0x00000000)},
    {"chig01.urb", "", int32_t(0x00000000), int32_t(0x6B3A0CDA)},
    {"chig02.urb", "", int32_t(0x00000000), int32_t(0x5AD21647)},
    {"chig03.urb", "", int32_t(0x00000000), int32_t(0xFCA51DF3)},
    {"chig04.urb", "", int32_t(0x00000000), int32_t(0x3902237D)},
    {"chig05.urb", "", int32_t(0x00000000), int32_t(0x9F7528C9)},
    {"chimes1.aud", "", int32_t(0x91CC1CD8), int32_t(0x00000000)},
    {"chipmnk1.aud", "", int32_t(0xE810FED5), int32_t(0x00000000)},
    {"chipmnk2.aud", "", int32_t(0xEA10FED5), int32_t(0x00000000)},
    {"chipmnk3.aud", "", int32_t(0xEC10FED5), int32_t(0x00000000)},
    {"chipmnk4.aud", "", int32_t(0xEE10FED5), int32_t(0x00000000)},
    {"chngdir.aud", "audf:", int32_t(0x7A2208D6), int32_t(0x00000000)},
    {"choice1.aud", "menu choice", int32_t(0x00000000), int32_t(0x091660B1)},
    {"choice1.pcx", "-", int32_t(0x00000000), int32_t(0x1F6FD2D4)},
    {"choose.wsa", "anim: side selection animation", int32_t(0xEB99ED06), int32_t(0x00000000)},
    {"chrg226m.aud", "charge", int32_t(0xFC0AC69F), int32_t(0x00000000)},
    {"chrochr1.aud", "chronosphere charging", int32_t(0xE442F2C1), int32_t(0x00000000)},
    {"chroicon.shp", "", int32_t(0x00000000), int32_t(0xCB49F5C8)},
    {"chronapr.vqp", "", int32_t(0x323AF9D7), int32_t(0x00000000)},
    {"chronbox.shp", "crat: chronosphere", int32_t(0x3E2FF8D7), int32_t(0x00000000)},
    {"chrondsp.vqp", "", int32_t(0x2E40FFD7), int32_t(0x00000000)},
    {"chrono1.aud", "", int32_t(0x99F014EA), int32_t(0x00000000)},
    {"chrono2.aud", "", int32_t(0x99F214EA), int32_t(0x00000000)},
    {"chronoar.shp", "", int32_t(0x00000000), int32_t(0x99368D56)},
    {"chronobm.shp", "", int32_t(0x00000000), int32_t(0xFD12FFAB)},
    {"chronodb.shp", "", int32_t(0x00000000), int32_t(0xA91B8B67)},
    {"chronofd.shp", "", int32_t(0x00000000), int32_t(0x6B93DFCC)},
    {"chronofs.shp", "", int32_t(0x00000000), int32_t(0xB953945E)},
    {"chronosb.shp", "", int32_t(0x00000000), int32_t(0xB7C8B944)},
    {"chronosk.shp", "", int32_t(0x00000000), int32_t(0xBAD8DB35)},
    {"chronotg.shp", "", int32_t(0x00000000), int32_t(0x622D068C)},
    {"chrordy1.aud", "chronosphere ready", int32_t(0xE450EADF), int32_t(0x00000000)},
    {"chrotnk1.aud", "chrono tank sound", int32_t(0xE434FEE3), int32_t(0x00000000)},
    {"chroyes1.aud", "chronosphere test successful", int32_t(0xE444ECED), int32_t(0x00000000)},
    {"chrpicon.shp", "", int32_t(0x00000000), int32_t(0xB8307868)},
    {"chute1.aud", "paratroops", int32_t(0xD3B1C7EC), int32_t(0x00000000)},
    {"circuit.aud", "", int32_t(0x00000000), int32_t(0xAAABF386)},
    {"circus1.aud", "", int32_t(0x69F020F8), int32_t(0x00000000)},
    {"citadel.csv", "", int32_t(0x624002D8), int32_t(0x00000000)},
    {"citadel.lsv", "", int32_t(0x624002E1), int32_t(0x00000000)},
    {"citadel.vqa", "", int32_t(0x622B00EB), int32_t(0x00000000)},
    {"citadel_e.vqa", "", int32_t(0x2A7FBBF5), int32_t(0x00000000)},
    {"citadel_e.vqt", "", int32_t(0x2A7FBC08), int32_t(0x00000000)},
    {"citadel_h.pcx", "", int32_t(0x0E73BC12), int32_t(0x00000000)},
    {"citadel_h.vqa", "", int32_t(0x2A7FBBFB), int32_t(0x00000000)},
    {"citadel_l.pcx", "", int32_t(0x0E73BC1A), int32_t(0x00000000)},
    {"citadel_l.vqa", "", int32_t(0x2A7FBC03), int32_t(0x00000000)},
    {"citwicon.shp", "", int32_t(0x00000000), int32_t(0x10C1BA26)},
    {"city01.shp", "-", int32_t(0x00000000), int32_t(0x4EC28C9E)},
    {"city02.shp", "-", int32_t(0x00000000), int32_t(0x7F2A9603)},
    {"city03.shp", "-", int32_t(0x00000000), int32_t(0xD95D9DB7)},
    {"city04.shp", "-", int32_t(0x00000000), int32_t(0x1CFAA339)},
    {"city05.shp", "-", int32_t(0x00000000), int32_t(0xBA8DA88D)},
    {"city06.shp", "-", int32_t(0x00000000), int32_t(0x8B65B210)},
    {"city07.shp", "-", int32_t(0x00000000), int32_t(0x2D12B9A4)},
    {"city08.shp", "-", int32_t(0x00000000), int32_t(0xDB5AC94D)},
    {"city09.shp", "-", int32_t(0x00000000), int32_t(0x7D2DC2F9)},
    {"city10.shp", "-", int32_t(0x00000000), int32_t(0x241F87B4)},
    {"city11.shp", "-", int32_t(0x00000000), int32_t(0x82688C00)},
    {"city12.shp", "-", int32_t(0x00000000), int32_t(0xB380969D)},
    {"city13.shp", "-", int32_t(0x00000000), int32_t(0x15F79D29)},
    {"city14.shp", "-", int32_t(0x00000000), int32_t(0xD050A3A7)},
    {"city15.shp", "-", int32_t(0x00000000), int32_t(0x7627A813)},
    {"city16.shp", "-", int32_t(0x00000000), int32_t(0x47CFB28E)},
    {"city17.shp", "-", int32_t(0x00000000), int32_t(0xE1B8B93A)},
    {"city18.shp", "-", int32_t(0x00000000), int32_t(0x17F0C9D3)},
    {"city19.shp", "-", int32_t(0x00000000), int32_t(0xB187C267)},
    {"city20.shp", "-", int32_t(0x00000000), int32_t(0xAA908057)},
    {"city21.shp", "-", int32_t(0x00000000), int32_t(0x0CE78BE3)},
    {"city22.shp", "-", int32_t(0x00000000), int32_t(0x3D0F917E)},
    {"cityscap.ini", "", int32_t(0x00000000), int32_t(0xF3222D24)},
    {"cityscap.map", "-", int32_t(0x00000000), int32_t(0x17D831F7)},
    {"citysno.pal", "", int32_t(0x00000000), int32_t(0xCFD13F21)},
    {"citytem.pal", "", int32_t(0x00000000), int32_t(0x8ADBC3C9)},
    {"cityurb.pal", "", int32_t(0x00000000), int32_t(0x155ED3C2)},
    {"citywan1.aud", "", int32_t(0x0C42E8E9), int32_t(0x00000000)},
    {"citywan2.aud", "", int32_t(0x0E42E8E9), int32_t(0x00000000)},
    {"civ01.des", "", int32_t(0x00000000), int32_t(0x62A7F81B)},
    {"civ01.sno", "-", int32_t(0x00000000), int32_t(0xE31D121C)},
    {"civ01.tem", "-", int32_t(0x00000000), int32_t(0xFFF9D890)},
    {"civ01a.des", "", int32_t(0x00000000), int32_t(0xC668EA42)},
    {"civ02.des", "", int32_t(0x00000000), int32_t(0xEC28FFF8)},
    {"civ02.sno", "-", int32_t(0x00000000), int32_t(0x6D9215FF)},
    {"civ02.tem", "-", int32_t(0x00000000), int32_t(0x7176DF73)},
    {"civ02a.des", "", int32_t(0x00000000), int32_t(0x48E7EDA1)},
    {"civ03.des", "", int32_t(0x00000000), int32_t(0x2082FF66)},
    {"civ03.sno", "-", int32_t(0x00000000), int32_t(0xA1381561)},
    {"civ03.tem", "-", int32_t(0x00000000), int32_t(0xBDDCDFED)},
    {"civ03a.des", "", int32_t(0x00000000), int32_t(0x844DED3F)},
    {"civ04.des", "", int32_t(0x00000000), int32_t(0x2A47F67F)},
    {"civ04.sno", "-", int32_t(0x00000000), int32_t(0xABFD1C78)},
    {"civ04.tem", "-", int32_t(0x00000000), int32_t(0xB719D6F4)},
    {"civ04a.des", "", int32_t(0x00000000), int32_t(0x8E88E426)},
    {"civ05.des", "", int32_t(0x00000000), int32_t(0xE6EDF6E1)},
    {"civ05.sno", "-", int32_t(0x00000000), int32_t(0x67571CE6)},
    {"civ05.tem", "-", int32_t(0x00000000), int32_t(0x7BB3D66A)},
    {"civ05a.des", "", int32_t(0x00000000), int32_t(0x4222E4B8)},
    {"civ06.des", "", int32_t(0x00000000), int32_t(0x6862F102)},
    {"civ06.sno", "-", int32_t(0x00000000), int32_t(0xE9D81B05)},
    {"civ06.tem", "-", int32_t(0x00000000), int32_t(0xF53CD189)},
    {"civ06a.des", "", int32_t(0x00000000), int32_t(0xCCADE35B)},
    {"civ07.des", "", int32_t(0x00000000), int32_t(0xA4C8F19C)},
    {"civ07.sno", "-", int32_t(0x00000000), int32_t(0x25721B9B)},
    {"civ07.tem", "-", int32_t(0x00000000), int32_t(0x3996D117)},
    {"civ07a.des", "", int32_t(0x00000000), int32_t(0x0007E3C5)},
    {"civ08.des", "", int32_t(0x00000000), int32_t(0x7DE8E330)},
    {"civ08.sno", "-", int32_t(0x00000000), int32_t(0xFC520937)},
    {"civ08.tem", "-", int32_t(0x00000000), int32_t(0xE0B6C3BB)},
    {"civ08a.des", "", int32_t(0x00000000), int32_t(0xD927F169)},
    {"civ1.shp", "unit: civilian", int32_t(0x00000000), int32_t(0x28E98C0C)},
    {"civ2.shp", "unit: civilian", int32_t(0x00000000), int32_t(0x6F49F6DC)},
    {"civ3.shp", "unit: civilian", int32_t(0x00000000), int32_t(0x5229DF6C)},
    {"civa.shp", "", int32_t(0x00000000), int32_t(0xD13B6CC3)},
    {"civan.shp", "", int32_t(0x00000000), int32_t(0xB6DDF7B4)},
    {"civb.shp", "", int32_t(0x00000000), int32_t(0x969B1613)},
    {"civbbp.shp", "", int32_t(0x00000000), int32_t(0xA71651B3)},
    {"civbf.shp", "", int32_t(0x00000000), int32_t(0x5CB5D0C4)},
    {"civbfm.shp", "", int32_t(0x00000000), int32_t(0x2555A247)},
    {"civbtm.shp", "", int32_t(0x00000000), int32_t(0x1BCB9411)},
    {"civc.shp", "", int32_t(0x00000000), int32_t(0xABFB3FA3)},
    {"civdead1.aud", "civilian dead", int32_t(0xB836E8C5), int32_t(0x00000000)},
    {"civp.hva", "", int32_t(0x00000000), int32_t(0x2239814D)},
    {"civp.vxl", "", int32_t(0x00000000), int32_t(0xD4B35E04)},
    {"civsf.shp", "", int32_t(0x00000000), int32_t(0xE70E86F6)},
    {"civsfm.shp", "", int32_t(0x00000000), int32_t(0x9EEEF475)},
    {"civstm.shp", "", int32_t(0x00000000), int32_t(0xA070C223)},
    {"ckeep.img", "", int32_t(0xAFA789F4), int32_t(0x00000000)},
    {"ckeep.lmf", "", int32_t(0xAFAD89F3), int32_t(0x00000000)},
    {"ckeep.lsv", "", int32_t(0xBBAD8A03), int32_t(0x00000000)},
    {"ckeep.odf", "", int32_t(0x9DB389F3), int32_t(0x00000000)},
    {"ckeep.pcx", "", int32_t(0x9BB58A05), int32_t(0x00000000)},
    {"ckeep.ver", "", int32_t(0x9FC189FF), int32_t(0x00000000)},
    {"clairp.shp", "", int32_t(0x00000000), int32_t(0xEDDDC896)},
    {"clairp_a.shp", "", int32_t(0x00000000), int32_t(0x3272FB4F)},
    {"clairp_f.shp", "", int32_t(0x00000000), int32_t(0x8052275F)},
    {"clank1.aud", "audf:", int32_t(0xBB61D7F8), int32_t(0x00000000)},
    {"clanky1.aud", "", int32_t(0x95AC38E4), int32_t(0x00000000)},
    {"clanky2.aud", "", int32_t(0x95AE38E4), int32_t(0x00000000)},
    {"clanky4.aud", "", int32_t(0x95B238E4), int32_t(0x00000000)},
    {"clanky5.aud", "", int32_t(0x95B438E4), int32_t(0x00000000)},
    {"clanky6.aud", "", int32_t(0x95B638E4), int32_t(0x00000000)},
    {"clarmy01.shp", "", int32_t(0x00000000), int32_t(0x2C941CF7)},
    {"clarmy02.shp", "", int32_t(0x00000000), int32_t(0x6B346627)},
    {"clarmy03.shp", "", int32_t(0x00000000), int32_t(0x56544F97)},
    {"clarmy04.shp", "", int32_t(0x00000000), int32_t(0xE4749387)},
    {"clat01.des", "", int32_t(0x00000000), int32_t(0x5300DC8C)},
    {"clat01.lun", "", int32_t(0x00000000), int32_t(0x3A20E095)},
    {"clat01.sno", "-", int32_t(0x00000000), int32_t(0xD42F9383)},
    {"clat01.tem", "-", int32_t(0x00000000), int32_t(0x2558C574)},
    {"clat01.ubn", "", int32_t(0x00000000), int32_t(0x19CDFF87)},
    {"clat01.urb", "", int32_t(0x00000000), int32_t(0x5D794118)},
    {"clat01a.des", "", int32_t(0x00000000), int32_t(0xE5283EF8)},
    {"clat01a.lun", "", int32_t(0x00000000), int32_t(0xC3D6D97B)},
    {"clat01a.sno", "-", int32_t(0x00000000), int32_t(0xC2C4E362)},
    {"clat01a.tem", "-", int32_t(0x00000000), int32_t(0x617056B8)},
    {"clat01a.ubn", "", int32_t(0x00000000), int32_t(0xF7AE749B)},
    {"clat01a.urb", "", int32_t(0x00000000), int32_t(0x473D98E7)},
    {"clat02.des", "", int32_t(0x00000000), int32_t(0x62E8C611)},
    {"clat02.lun", "", int32_t(0x00000000), int32_t(0x0BC8FA08)},
    {"clat02.sno", "-", int32_t(0x00000000), int32_t(0xE5C7891E)},
    {"clat02.tem", "-", int32_t(0x00000000), int32_t(0x14B0DFE9)},
    {"clat02.ubn", "", int32_t(0x00000000), int32_t(0x2825E51A)},
    {"clat02.urb", "", int32_t(0x00000000), int32_t(0x6C915B85)},
    {"clat02a.des", "", int32_t(0x00000000), int32_t(0xD4C02465)},
    {"clat02a.lun", "", int32_t(0x00000000), int32_t(0xF23EC3E6)},
    {"clat02a.sno", "-", int32_t(0x00000000), int32_t(0xF32CF9FF)},
    {"clat02a.tem", "-", int32_t(0x00000000), int32_t(0x50984C25)},
    {"clat02a.ubn", "", int32_t(0x00000000), int32_t(0xC6466E06)},
    {"clat02a.urb", "", int32_t(0x00000000), int32_t(0x76D5827A)},
    {"clat03.des", "", int32_t(0x00000000), int32_t(0xC49FCDA5)},
    {"clat03.lun", "", int32_t(0x00000000), int32_t(0xADBFF1BC)},
    {"clat03.sno", "-", int32_t(0x00000000), int32_t(0x43B082AA)},
    {"clat03.tem", "-", int32_t(0x00000000), int32_t(0xB2C7D45D)},
    {"clat03.ubn", "", int32_t(0x00000000), int32_t(0x8E52EEAE)},
    {"clat03.urb", "", int32_t(0x00000000), int32_t(0xCAE65031)},
    {"clat03a.des", "", int32_t(0x00000000), int32_t(0x72B72FD1)},
    {"clat03a.lun", "", int32_t(0x00000000), int32_t(0x5449C852)},
    {"clat03a.sno", "-", int32_t(0x00000000), int32_t(0x555BF24B)},
    {"clat03a.tem", "-", int32_t(0x00000000), int32_t(0xF6EF4791)},
    {"clat03a.ubn", "", int32_t(0x00000000), int32_t(0x603165B2)},
    {"clat03a.urb", "", int32_t(0x00000000), int32_t(0xD0A289CE)},
    {"clat04.des", "", int32_t(0x00000000), int32_t(0x0138F32B)},
    {"clat04.lun", "", int32_t(0x00000000), int32_t(0x6818CF32)},
    {"clat04.sno", "-", int32_t(0x00000000), int32_t(0x8617BC24)},
    {"clat04.tem", "-", int32_t(0x00000000), int32_t(0x7760EAD3)},
    {"clat04.ubn", "", int32_t(0x00000000), int32_t(0x4BF5D020)},
    {"clat04.urb", "", int32_t(0x00000000), int32_t(0x0F416EBF)},
    {"clat04a.des", "", int32_t(0x00000000), int32_t(0xB710115F)},
    {"clat04a.lun", "", int32_t(0x00000000), int32_t(0x91EEF6DC)},
    {"clat04a.sno", "-", int32_t(0x00000000), int32_t(0x90FCCCC5)},
    {"clat04a.tem", "-", int32_t(0x00000000), int32_t(0x3348791F)},
    {"clat04a.ubn", "", int32_t(0x00000000), int32_t(0xA5965B3C)},
    {"clat04a.urb", "", int32_t(0x00000000), int32_t(0x1505B740)},
    {"clat05.des", "", int32_t(0x00000000), int32_t(0xA74FF89F)},
    {"clat05.lun", "", int32_t(0x00000000), int32_t(0xCE6FC486)},
    {"clat05.sno", "-", int32_t(0x00000000), int32_t(0x2060B790)},
    {"clat05.tem", "-", int32_t(0x00000000), int32_t(0xD117E167)},
    {"clat05.ubn", "", int32_t(0x00000000), int32_t(0xED82DB94)},
    {"clat05.urb", "", int32_t(0x00000000), int32_t(0xA936650B)},
    {"clat05a.des", "", int32_t(0x00000000), int32_t(0x11671AEB)},
    {"clat05a.lun", "", int32_t(0x00000000), int32_t(0x3799FD68)},
    {"clat05a.sno", "-", int32_t(0x00000000), int32_t(0x368BC771)},
    {"clat05a.tem", "-", int32_t(0x00000000), int32_t(0x953F72AB)},
    {"clat05a.ubn", "", int32_t(0x00000000), int32_t(0x03E15088)},
    {"clat05a.urb", "", int32_t(0x00000000), int32_t(0xB372BCF4)},
    {"clat06.des", "", int32_t(0x00000000), int32_t(0x96A7E202)},
    {"clat06.lun", "", int32_t(0x00000000), int32_t(0xFF87DE1B)},
    {"clat06.sno", "-", int32_t(0x00000000), int32_t(0x1188AD0D)},
    {"clat06.tem", "-", int32_t(0x00000000), int32_t(0xE0FFFBFA)},
    {"clat06.ubn", "", int32_t(0x00000000), int32_t(0xDC6AC109)},
    {"clat06.urb", "", int32_t(0x00000000), int32_t(0x98DE7F96)},
    {"clat06a.des", "", int32_t(0x00000000), int32_t(0x208F0076)},
    {"clat06a.lun", "", int32_t(0x00000000), int32_t(0x0671E7F5)},
    {"clat06a.sno", "-", int32_t(0x00000000), int32_t(0x0763DDEC)},
    {"clat06a.tem", "-", int32_t(0x00000000), int32_t(0xA4D76836)},
    {"clat06a.ubn", "", int32_t(0x00000000), int32_t(0x32094A15)},
    {"clat06a.urb", "", int32_t(0x00000000), int32_t(0x829AA669)},
    {"clat07.des", "", int32_t(0x00000000), int32_t(0x30D0E9B6)},
    {"clat07.lun", "", int32_t(0x00000000), int32_t(0x59F0D5AF)},
    {"clat07.sno", "-", int32_t(0x00000000), int32_t(0xB7FFA6B9)},
    {"clat07.tem", "-", int32_t(0x00000000), int32_t(0x4688F04E)},
    {"clat07.ubn", "", int32_t(0x00000000), int32_t(0x7A1DCABD)},
    {"clat07.urb", "", int32_t(0x00000000), int32_t(0x3EA97422)},
    {"clat07a.des", "", int32_t(0x00000000), int32_t(0x86F80BC2)},
    {"clat07a.lun", "", int32_t(0x00000000), int32_t(0xA006EC41)},
    {"clat07a.sno", "-", int32_t(0x00000000), int32_t(0xA114D658)},
    {"clat07a.tem", "-", int32_t(0x00000000), int32_t(0x02A06382)},
    {"clat07a.ubn", "", int32_t(0x00000000), int32_t(0x947E41A1)},
    {"clat07a.urb", "", int32_t(0x00000000), int32_t(0x24EDADDD)},
    {"clat08.des", "", int32_t(0x00000000), int32_t(0xC698995F)},
    {"clat08.lun", "", int32_t(0x00000000), int32_t(0xAFB8A546)},
    {"clat08.sno", "-", int32_t(0x00000000), int32_t(0x41B7D650)},
    {"clat08.tem", "-", int32_t(0x00000000), int32_t(0xB0C080A7)},
    {"clat08.ubn", "", int32_t(0x00000000), int32_t(0x8C55BA54)},
    {"clat08.urb", "", int32_t(0x00000000), int32_t(0xC8E104CB)},
    {"clat08a.des", "", int32_t(0x00000000), int32_t(0x70B07B2B)},
    {"clat08a.lun", "", int32_t(0x00000000), int32_t(0x564E9CA8)},
    {"clat08a.sno", "-", int32_t(0x00000000), int32_t(0x575CA6B1)},
    {"clat08a.tem", "-", int32_t(0x00000000), int32_t(0xF4E8136B)},
    {"clat08a.ubn", "", int32_t(0x00000000), int32_t(0x62363148)},
    {"clat08a.urb", "", int32_t(0x00000000), int32_t(0xD2A5DD34)},
    {"clat09.des", "", int32_t(0x00000000), int32_t(0x60EF92EB)},
    {"clat09.lun", "", int32_t(0x00000000), int32_t(0x09CFAEF2)},
    {"clat09.sno", "-", int32_t(0x00000000), int32_t(0xE7C0DDE4)},
    {"clat09.tem", "-", int32_t(0x00000000), int32_t(0x16B78B13)},
    {"clat09.ubn", "", int32_t(0x00000000), int32_t(0x2A22B1E0)},
    {"clat09.urb", "", int32_t(0x00000000), int32_t(0x6E960F7F)},
    {"clat09a.des", "", int32_t(0x00000000), int32_t(0xD6C7709F)},
    {"clat09a.lun", "", int32_t(0x00000000), int32_t(0xF039971C)},
    {"clat09a.sno", "-", int32_t(0x00000000), int32_t(0xF12BAD05)},
    {"clat09a.tem", "-", int32_t(0x00000000), int32_t(0x529F18DF)},
    {"clat09a.ubn", "", int32_t(0x00000000), int32_t(0xC4413AFC)},
    {"clat09a.urb", "", int32_t(0x00000000), int32_t(0x74D2D680)},
    {"clat10.des", "", int32_t(0x00000000), int32_t(0x39DDD7A6)},
    {"clat10.lun", "", int32_t(0x00000000), int32_t(0x50FDEBBF)},
    {"clat10.sno", "-", int32_t(0x00000000), int32_t(0xBEF298A9)},
    {"clat10.tem", "-", int32_t(0x00000000), int32_t(0x4F85CE5E)},
    {"clat10.ubn", "", int32_t(0x00000000), int32_t(0x7310F4AD)},
    {"clat10.urb", "", int32_t(0x00000000), int32_t(0x37A44A32)},
    {"clat10a.des", "", int32_t(0x00000000), int32_t(0x8FF535D2)},
    {"clat10a.lun", "", int32_t(0x00000000), int32_t(0xA90BD251)},
    {"clat10a.sno", "-", int32_t(0x00000000), int32_t(0xA819E848)},
    {"clat10a.tem", "-", int32_t(0x00000000), int32_t(0x0BAD5D92)},
    {"clat10a.ubn", "", int32_t(0x00000000), int32_t(0x9D737FB1)},
    {"clat10a.urb", "", int32_t(0x00000000), int32_t(0x2DE093CD)},
    {"clat11.des", "", int32_t(0x00000000), int32_t(0x9FAADC12)},
    {"clat11.lun", "", int32_t(0x00000000), int32_t(0xF68AE00B)},
    {"clat11.sno", "-", int32_t(0x00000000), int32_t(0x1885931D)},
    {"clat11.tem", "-", int32_t(0x00000000), int32_t(0xE9F2C5EA)},
    {"clat11.ubn", "", int32_t(0x00000000), int32_t(0xD567FF19)},
    {"clat11.urb", "", int32_t(0x00000000), int32_t(0x91D34186)},
    {"clat11a.des", "", int32_t(0x00000000), int32_t(0x29823E66)},
    {"clat11a.lun", "", int32_t(0x00000000), int32_t(0x0F7CD9E5)},
    {"clat11a.sno", "-", int32_t(0x00000000), int32_t(0x0E6EE3FC)},
    {"clat11a.tem", "-", int32_t(0x00000000), int32_t(0xADDA5626)},
    {"clat11a.ubn", "", int32_t(0x00000000), int32_t(0x3B047405)},
    {"clat11a.urb", "", int32_t(0x00000000), int32_t(0x8B979879)},
    {"clat12.des", "", int32_t(0x00000000), int32_t(0xAE42C68F)},
    {"clat12.lun", "", int32_t(0x00000000), int32_t(0xC762FA96)},
    {"clat12.sno", "-", int32_t(0x00000000), int32_t(0x296D8980)},
    {"clat12.tem", "-", int32_t(0x00000000), int32_t(0xD81ADF77)},
    {"clat12.ubn", "", int32_t(0x00000000), int32_t(0xE48FE584)},
    {"clat12.urb", "", int32_t(0x00000000), int32_t(0xA03B5B1B)},
    {"clat12a.des", "", int32_t(0x00000000), int32_t(0x186A24FB)},
    {"clat12a.lun", "", int32_t(0x00000000), int32_t(0x3E94C378)},
    {"clat12a.sno", "-", int32_t(0x00000000), int32_t(0x3F86F961)},
    {"clat12a.tem", "-", int32_t(0x00000000), int32_t(0x9C324CBB)},
    {"clat12a.ubn", "", int32_t(0x00000000), int32_t(0x0AEC6E98)},
    {"clat12a.urb", "", int32_t(0x00000000), int32_t(0xBA7F82E4)},
    {"clat13.des", "", int32_t(0x00000000), int32_t(0x0835CD3B)},
    {"clat13.lun", "", int32_t(0x00000000), int32_t(0x6115F122)},
    {"clat13.sno", "-", int32_t(0x00000000), int32_t(0x8F1A8234)},
    {"clat13.tem", "-", int32_t(0x00000000), int32_t(0x7E6DD4C3)},
    {"clat13.ubn", "", int32_t(0x00000000), int32_t(0x42F8EE30)},
    {"clat13.urb", "", int32_t(0x00000000), int32_t(0x064C50AF)},
    {"clat13a.des", "", int32_t(0x00000000), int32_t(0xBE1D2F4F)},
    {"clat13a.lun", "", int32_t(0x00000000), int32_t(0x98E3C8CC)},
    {"clat13a.sno", "-", int32_t(0x00000000), int32_t(0x99F1F2D5)},
    {"clat13a.tem", "-", int32_t(0x00000000), int32_t(0x3A45470F)},
    {"clat13a.ubn", "", int32_t(0x00000000), int32_t(0xAC9B652C)},
    {"clat13a.urb", "", int32_t(0x00000000), int32_t(0x1C088950)},
    {"clat14.des", "", int32_t(0x00000000), int32_t(0xCD92F3B5)},
    {"clat14.lun", "", int32_t(0x00000000), int32_t(0xA4B2CFAC)},
    {"clat14.sno", "-", int32_t(0x00000000), int32_t(0x4ABDBCBA)},
    {"clat14.tem", "-", int32_t(0x00000000), int32_t(0xBBCAEA4D)},
    {"clat14.ubn", "", int32_t(0x00000000), int32_t(0x875FD0BE)},
    {"clat14.urb", "", int32_t(0x00000000), int32_t(0xC3EB6E21)},
    {"clat14a.des", "", int32_t(0x00000000), int32_t(0x7BBA11C1)},
    {"clat14a.lun", "", int32_t(0x00000000), int32_t(0x5D44F642)},
    {"clat14a.sno", "-", int32_t(0x00000000), int32_t(0x5C56CC5B)},
    {"clat14a.tem", "-", int32_t(0x00000000), int32_t(0xFFE27981)},
    {"clat14a.ubn", "", int32_t(0x00000000), int32_t(0x693C5BA2)},
    {"clat14a.urb", "", int32_t(0x00000000), int32_t(0xD9AFB7DE)},
    {"clat15.des", "", int32_t(0x00000000), int32_t(0x6BE5F801)},
    {"clat15.lun", "", int32_t(0x00000000), int32_t(0x02C5C418)},
    {"clat15.sno", "-", int32_t(0x00000000), int32_t(0xECCAB70E)},
    {"clat15.tem", "-", int32_t(0x00000000), int32_t(0x1DBDE1F9)},
    {"clat15.ubn", "", int32_t(0x00000000), int32_t(0x2128DB0A)},
    {"clat15.urb", "", int32_t(0x00000000), int32_t(0x659C6595)},
    {"clat15a.des", "", int32_t(0x00000000), int32_t(0xDDCD1A75)},
    {"clat15a.lun", "", int32_t(0x00000000), int32_t(0xFB33FDF6)},
    {"clat15a.sno", "-", int32_t(0x00000000), int32_t(0xFA21C7EF)},
    {"clat15a.tem", "-", int32_t(0x00000000), int32_t(0x59957235)},
    {"clat15a.ubn", "", int32_t(0x00000000), int32_t(0xCF4B5016)},
    {"clat15a.urb", "", int32_t(0x00000000), int32_t(0x7FD8BC6A)},
    {"clat16.des", "", int32_t(0x00000000), int32_t(0x5A0DE29C)},
    {"clat16.lun", "", int32_t(0x00000000), int32_t(0x332DDE85)},
    {"clat16.sno", "-", int32_t(0x00000000), int32_t(0xDD22AD93)},
    {"clat16.tem", "-", int32_t(0x00000000), int32_t(0x2C55FB64)},
    {"clat16.ubn", "", int32_t(0x00000000), int32_t(0x10C0C197)},
    {"clat16.urb", "", int32_t(0x00000000), int32_t(0x54747F08)},
    {"clat16a.des", "", int32_t(0x00000000), int32_t(0xEC2500E8)},
    {"clat16a.lun", "", int32_t(0x00000000), int32_t(0xCADBE76B)},
    {"clat16a.sno", "-", int32_t(0x00000000), int32_t(0xCBC9DD72)},
    {"clat16a.tem", "-", int32_t(0x00000000), int32_t(0x687D68A8)},
    {"clat16a.ubn", "", int32_t(0x00000000), int32_t(0xFEA34A8B)},
    {"clat16a.urb", "", int32_t(0x00000000), int32_t(0x4E30A6F7)},
    {"clawbat1.aud", "", int32_t(0x0402F4BF), int32_t(0x00000000)},
    {"clawwan1.aud", "", int32_t(0x03F6F4E9), int32_t(0x00000000)},
    {"clbarn02.shp", "", int32_t(0x00000000), int32_t(0x12AC2257)},
    {"clbhut.shp", "", int32_t(0x00000000), int32_t(0xEF1B4ADC)},
    {"clbunk01.shp", "", int32_t(0x00000000), int32_t(0xDD0C4039)},
    {"clbunk02.shp", "", int32_t(0x00000000), int32_t(0x9AAC3AE9)},
    {"clchig01.shp", "", int32_t(0x00000000), int32_t(0xA224ED4C)},
    {"clchig02.shp", "", int32_t(0x00000000), int32_t(0xE584979C)},
    {"clchig03.shp", "", int32_t(0x00000000), int32_t(0xD8E4BE2C)},
    {"clchig05.shp", "", int32_t(0x00000000), int32_t(0x57A44B8C)},
    {"clchig05d.shp", "", int32_t(0x00000000), int32_t(0x2B6A43B2)},
    {"clcity01.shp", "", int32_t(0x00000000), int32_t(0x65003A66)},
    {"clcity02.shp", "", int32_t(0x00000000), int32_t(0x22A040B6)},
    {"clcity03.shp", "", int32_t(0x00000000), int32_t(0x1FC06906)},
    {"clcity04.shp", "", int32_t(0x00000000), int32_t(0xADE0B516)},
    {"clckicon.shp", "icon: stealth generator", int32_t(0x00000000), int32_t(0xEE103D90)},
    {"clcolo01.shp", "", int32_t(0x00000000), int32_t(0xBD4AC086)},
    {"clcufgl.shp", "", int32_t(0x00000000), int32_t(0x41843BE8)},
    {"clcufgl_a.shp", "", int32_t(0x00000000), int32_t(0xC70D7A2F)},
    {"cldrngl1.shp", "-", int32_t(0x00000000), int32_t(0x0F33FA79)},
    {"cldrngl2.shp", "-", int32_t(0x00000000), int32_t(0x489380A9)},
    {"cldrngmd.shp", "-", int32_t(0x00000000), int32_t(0xF55D4663)},
    {"cldrngsm.shp", "-", int32_t(0x00000000), int32_t(0xC19147F9)},
    {"clear01.des", "", int32_t(0x00000000), int32_t(0x350F380F)},
    {"clear01.lun", "", int32_t(0x00000000), int32_t(0x13F1DF8C)},
    {"clear01.sno", "-", int32_t(0x00000000), int32_t(0x12E3E595)},
    {"clear01.tem", "-", int32_t(0x00000000), int32_t(0xB157504F)},
    {"clear01.ubn", "", int32_t(0x00000000), int32_t(0x2789726C)},
    {"clear01.urb", "", int32_t(0x00000000), int32_t(0x971A9E10)},
    {"clear01a.des", "", int32_t(0x00000000), int32_t(0x0CC741E0)},
    {"clear01a.lun", "", int32_t(0x00000000), int32_t(0x2B106ED0)},
    {"clear01a.sno", "-", int32_t(0x00000000), int32_t(0xE25B7191)},
    {"clear01a.tem", "-", int32_t(0x00000000), int32_t(0xEAEEDFF3)},
    {"clear01a.ubn", "", int32_t(0x00000000), int32_t(0x3D6472B9)},
    {"clear01a.urb", "", int32_t(0x00000000), int32_t(0x7E102CC3)},
    {"clear01b.des", "", int32_t(0x00000000), int32_t(0x4B673B30)},
    {"clear01b.lun", "", int32_t(0x00000000), int32_t(0x6CB01400)},
    {"clear01b.sno", "-", int32_t(0x00000000), int32_t(0xA5FB0B41)},
    {"clear01b.tem", "-", int32_t(0x00000000), int32_t(0xAD4EA523)},
    {"clear01b.ubn", "", int32_t(0x00000000), int32_t(0x7AC40869)},
    {"clear01b.urb", "", int32_t(0x00000000), int32_t(0x39B05613)},
    {"clear01c.des", "", int32_t(0x00000000), int32_t(0x76071280)},
    {"clear01c.lun", "", int32_t(0x00000000), int32_t(0x51D03DB0)},
    {"clear01c.sno", "-", int32_t(0x00000000), int32_t(0x989B22F1)},
    {"clear01c.tem", "-", int32_t(0x00000000), int32_t(0x902E8C93)},
    {"clear01c.ubn", "", int32_t(0x00000000), int32_t(0x47A421D9)},
    {"clear01c.urb", "", int32_t(0x00000000), int32_t(0x04D07FA3)},
    {"clear01d.des", "", int32_t(0x00000000), int32_t(0xC427CE90)},
    {"clear01d.lun", "", int32_t(0x00000000), int32_t(0xE3F0E1A0)},
    {"clear01d.sno", "-", int32_t(0x00000000), int32_t(0x2ABBFEE1)},
    {"clear01d.tem", "-", int32_t(0x00000000), int32_t(0x220E5083)},
    {"clear01d.ubn", "", int32_t(0x00000000), int32_t(0xF584FDC9)},
    {"clear01d.urb", "", int32_t(0x00000000), int32_t(0xB6F0A3B3)},
    {"clear01e.des", "", int32_t(0x00000000), int32_t(0xF947E720)},
    {"clear01e.lun", "", int32_t(0x00000000), int32_t(0xDE90C810)},
    {"clear01e.sno", "-", int32_t(0x00000000), int32_t(0x17DBD751)},
    {"clear01e.tem", "-", int32_t(0x00000000), int32_t(0x1F6E7933)},
    {"clear01e.ubn", "", int32_t(0x00000000), int32_t(0xC8E4D479)},
    {"clear01e.urb", "", int32_t(0x00000000), int32_t(0x8B908A03)},
    {"clear01f.des", "", int32_t(0x00000000), int32_t(0xBEE79DF0)},
    {"clear01f.lun", "", int32_t(0x00000000), int32_t(0x9930B2C0)},
    {"clear01f.sno", "-", int32_t(0x00000000), int32_t(0x507BAD81)},
    {"clear01f.tem", "-", int32_t(0x00000000), int32_t(0x58CE03E3)},
    {"clear01f.ubn", "", int32_t(0x00000000), int32_t(0x8F44AEA9)},
    {"clear01f.urb", "", int32_t(0x00000000), int32_t(0xCC30F0D3)},
    {"clear01g.des", "", int32_t(0x00000000), int32_t(0x8387B440)},
    {"clear01g.lun", "", int32_t(0x00000000), int32_t(0xA4509B70)},
    {"clear01g.sno", "-", int32_t(0x00000000), int32_t(0x6D1B8431)},
    {"clear01g.tem", "-", int32_t(0x00000000), int32_t(0x65AE2A53)},
    {"clear01g.ubn", "", int32_t(0x00000000), int32_t(0xB2248719)},
    {"clear01g.urb", "", int32_t(0x00000000), int32_t(0xF150D963)},
    {"clear1.des", "clear terrain", int32_t(0x8D71E6F6), int32_t(0x00000000)},
    {"clear1.int", "blank wall tile", int32_t(0x9771E7FF), int32_t(0x00000000)},
    {"clear1.sno", "clear terrain", int32_t(0xAB71E2FF), int32_t(0x00000000)},
    {"clear1.tem", "clear terrain", int32_t(0xAD71E0F6), int32_t(0x00000000)},
    {"clear1.win", "clear terrain", int32_t(0xB371E1FA), int32_t(0x00000000)},
    {"cleast01.shp", "", int32_t(0x00000000), int32_t(0xB8D480E0)},
    {"cleast01dm.shp", "", int32_t(0x00000000), int32_t(0xA10A8634)},
    {"cledoor1.aud", "", int32_t(0xB80F10D9), int32_t(0x00000000)},
    {"cledoor2.aud", "", int32_t(0xBA0F10D9), int32_t(0x00000000)},
    {"cleg.shp", "", int32_t(0x00000000), int32_t(0x8901C6F1)},
    {"clegicon.shp", "", int32_t(0x00000000), int32_t(0x053ABEC3)},
    {"cleguico.shp", "", int32_t(0x00000000), int32_t(0xC0FC2C22)},
    {"cleric.aud", "", int32_t(0xCB71FBF4), int32_t(0x00000000)},
    {"clerx01.ubn", "", int32_t(0x00000000), int32_t(0x23041010)},
    {"clerx01a.ubn", "", int32_t(0x00000000), int32_t(0x39E910C5)},
    {"clerx01b.ubn", "", int32_t(0x00000000), int32_t(0x7E496A15)},
    {"clerx01c.ubn", "", int32_t(0x00000000), int32_t(0x432943A5)},
    {"clerx01d.ubn", "", int32_t(0x00000000), int32_t(0xF1099FB5)},
    {"clerx01e.ubn", "", int32_t(0x00000000), int32_t(0xCC69B605)},
    {"clerx01f.ubn", "", int32_t(0x00000000), int32_t(0x8BC9CCD5)},
    {"clerx01g.ubn", "", int32_t(0x00000000), int32_t(0xB6A9E565)},
    {"cleur04.shp", "", int32_t(0x00000000), int32_t(0x7AD51577)},
    {"cleur1.shp", "", int32_t(0x00000000), int32_t(0x83039ED8)},
    {"cleur2.shp", "", int32_t(0x00000000), int32_t(0xB2EB8445)},
    {"cleuro05.shp", "", int32_t(0x00000000), int32_t(0x150BFDF7)},
    {"clfarm01.shp", "", int32_t(0x00000000), int32_t(0x6D0FE260)},
    {"clfarm02.shp", "", int32_t(0x00000000), int32_t(0x2AAF98B0)},
    {"clfarm06.shp", "", int32_t(0x00000000), int32_t(0xDF2F3E70)},
    {"clfncb.shp", "", int32_t(0x00000000), int32_t(0x2B300274)},
    {"clfncp.shp", "", int32_t(0x00000000), int32_t(0xDB718F93)},
    {"clfncw.shp", "", int32_t(0x00000000), int32_t(0x1ED6B11D)},
    {"clforstwk4.aud", "", int32_t(0x59E05C4D), int32_t(0x00000000)},
    {"clfrfgl.shp", "", int32_t(0x00000000), int32_t(0xC3CC9D65)},
    {"clfrfgl_a.shp", "", int32_t(0x00000000), int32_t(0x3EDD121A)},
    {"clfrma.shp", "", int32_t(0x00000000), int32_t(0x45A6BBBE)},
    {"clfrmb.shp", "", int32_t(0x00000000), int32_t(0x744EA123)},
    {"clgard01.shp", "", int32_t(0x00000000), int32_t(0x1755CC8D)},
    {"clgard03.shp", "", int32_t(0x00000000), int32_t(0x6D959FED)},
    {"clgas01.shp", "", int32_t(0x00000000), int32_t(0x136B471A)},
    {"clgefgl.shp", "", int32_t(0x00000000), int32_t(0xE4AFD9E3)},
    {"clgefgl_a.shp", "", int32_t(0x00000000), int32_t(0x6AA653EE)},
    {"clgrd1_a.shp", "", int32_t(0x00000000), int32_t(0x86EC2859)},
    {"clhosp.shp", "", int32_t(0x00000000), int32_t(0xAE789A48)},
    {"clhosp_a.shp", "", int32_t(0x00000000), int32_t(0x71D7A991)},
    {"clhosp_f.shp", "", int32_t(0x00000000), int32_t(0xC3F77581)},
    {"clhse01.shp", "", int32_t(0x00000000), int32_t(0xDA824ECC)},
    {"clhse02.shp", "", int32_t(0x00000000), int32_t(0x5C163C62)},
    {"clhse03.shp", "", int32_t(0x00000000), int32_t(0x974AEFC7)},
    {"clhse04.shp", "", int32_t(0x00000000), int32_t(0x8A4FDF7F)},
    {"clhse05.shp", "", int32_t(0x00000000), int32_t(0x41130CDA)},
    {"clhse06.shp", "", int32_t(0x00000000), int32_t(0xC7877E74)},
    {"clhse07.shp", "", int32_t(0x00000000), int32_t(0x0CDBADD1)},
    {"click_a.cps", "pict: african mouse hotspots", int32_t(0x69FB3FE6), int32_t(0x00000000)},
    {"click_e.cps", "pict: european mouse hotspots", int32_t(0x6A033FE6), int32_t(0x00000000)},
    {"click_eb.cps", "pict: bosnian mouse hotspots", int32_t(0xE50032D1), int32_t(0x00000000)},
    {"click_sa.cps", "pict: south african mouse hotspots", int32_t(0xE31C32D1), int32_t(0x00000000)},
    {"clicky1.aud", "generic click", int32_t(0x00000000), int32_t(0x526404E5)},
    {"clif01.des", "", int32_t(0x00000000), int32_t(0xC2E1F68F)},
    {"clif01.sno", "-", int32_t(0x00000000), int32_t(0x45CEB980)},
    {"clif01.tem", "-", int32_t(0x00000000), int32_t(0xB4B9EF77)},
    {"clif02.des", "", int32_t(0x00000000), int32_t(0xF309EC12)},
    {"clif02.sno", "-", int32_t(0x00000000), int32_t(0x7426A31D)},
    {"clif02.tem", "-", int32_t(0x00000000), int32_t(0x8551F5EA)},
    {"cliff01.des", "", int32_t(0x00000000), int32_t(0xB3A38A99)},
    {"cliff01.sno", "-", int32_t(0x00000000), int32_t(0x944F5703)},
    {"cliff01.tem", "-", int32_t(0x00000000), int32_t(0x37FBE2D9)},
    {"cliff01.ubn", "", int32_t(0x00000000), int32_t(0xA125C0FA)},
    {"cliff01.urb", "", int32_t(0x00000000), int32_t(0x11B62C86)},
    {"cliff02.des", "", int32_t(0x00000000), int32_t(0x3537F837)},
    {"cliff02.sno", "-", int32_t(0x00000000), int32_t(0x12DB25AD)},
    {"cliff02.tem", "-", int32_t(0x00000000), int32_t(0xB16F9077)},
    {"cliff02.ubn", "", int32_t(0x00000000), int32_t(0x27B1B254)},
    {"cliff02.urb", "", int32_t(0x00000000), int32_t(0x97225E28)},
    {"cliff03.des", "", int32_t(0x00000000), int32_t(0xFE6B2B92)},
    {"cliff03.sno", "-", int32_t(0x00000000), int32_t(0xD987F608)},
    {"cliff03.tem", "-", int32_t(0x00000000), int32_t(0x7A3343D2)},
    {"cliff03.ubn", "", int32_t(0x00000000), int32_t(0xECED61F1)},
    {"cliff03.urb", "", int32_t(0x00000000), int32_t(0x5C7E8D8D)},
    {"cliff04.des", "", int32_t(0x00000000), int32_t(0xE36E1B2A)},
    {"cliff04.sno", "-", int32_t(0x00000000), int32_t(0xC482C6B0)},
    {"cliff04.tem", "-", int32_t(0x00000000), int32_t(0x6736736A)},
    {"cliff04.ubn", "", int32_t(0x00000000), int32_t(0xF1E85149)},
    {"cliff04.urb", "", int32_t(0x00000000), int32_t(0x417BBD35)},
    {"cliff05.des", "", int32_t(0x00000000), int32_t(0x2832C88F)},
    {"cliff05.sno", "-", int32_t(0x00000000), int32_t(0x0FDE1515)},
    {"cliff05.tem", "-", int32_t(0x00000000), int32_t(0xAC6AA0CF)},
    {"cliff05.ubn", "", int32_t(0x00000000), int32_t(0x3AB482EC)},
    {"cliff05.urb", "", int32_t(0x00000000), int32_t(0x8A276E90)},
    {"cliff06.des", "", int32_t(0x00000000), int32_t(0xAEA6BA21)},
    {"cliff06.sno", "-", int32_t(0x00000000), int32_t(0x894A67BB)},
    {"cliff06.tem", "-", int32_t(0x00000000), int32_t(0x2AFED261)},
    {"cliff06.ubn", "", int32_t(0x00000000), int32_t(0xBC20F042)},
    {"cliff06.urb", "", int32_t(0x00000000), int32_t(0x0CB31C3E)},
    {"cliff07.des", "", int32_t(0x00000000), int32_t(0x65FA6984)},
    {"cliff07.sno", "-", int32_t(0x00000000), int32_t(0x4216B41E)},
    {"cliff07.tem", "-", int32_t(0x00000000), int32_t(0xE1A201C4)},
    {"cliff07.ubn", "", int32_t(0x00000000), int32_t(0x777C23E7)},
    {"cliff07.urb", "", int32_t(0x00000000), int32_t(0xC7EFCF9B)},
    {"cliff08.des", "", int32_t(0x00000000), int32_t(0x94ACDB51)},
    {"cliff08.sno", "-", int32_t(0x00000000), int32_t(0xB34006CB)},
    {"cliff08.tem", "-", int32_t(0x00000000), int32_t(0x10F4B311)},
    {"cliff08.ubn", "", int32_t(0x00000000), int32_t(0x862A9132)},
    {"cliff08.urb", "", int32_t(0x00000000), int32_t(0x36B97D4E)},
    {"cliff09.des", "", int32_t(0x00000000), int32_t(0x5FF008F4)},
    {"cliff09.sno", "-", int32_t(0x00000000), int32_t(0x781CD56E)},
    {"cliff09.tem", "-", int32_t(0x00000000), int32_t(0xDBA860B4)},
    {"cliff09.ubn", "", int32_t(0x00000000), int32_t(0x4D764297)},
    {"cliff09.urb", "", int32_t(0x00000000), int32_t(0xFDE5AEEB)},
    {"cliff10.des", "", int32_t(0x00000000), int32_t(0xDE885288)},
    {"cliff10.sno", "-", int32_t(0x00000000), int32_t(0xF9648F12)},
    {"cliff10.tem", "-", int32_t(0x00000000), int32_t(0x5AD03AC8)},
    {"cliff10.ubn", "", int32_t(0x00000000), int32_t(0xCC0E18EB)},
    {"cliff10.urb", "", int32_t(0x00000000), int32_t(0x7C9DF497)},
    {"cliff11.des", "", int32_t(0x00000000), int32_t(0x15D4812D)},
    {"cliff11.sno", "-", int32_t(0x00000000), int32_t(0x32385CB7)},
    {"cliff11.tem", "-", int32_t(0x00000000), int32_t(0x918CE96D)},
    {"cliff11.ubn", "", int32_t(0x00000000), int32_t(0x0752CB4E)},
    {"cliff11.urb", "", int32_t(0x00000000), int32_t(0xB7C12732)},
    {"cliff12.des", "", int32_t(0x00000000), int32_t(0x9340F383)},
    {"cliff12.sno", "-", int32_t(0x00000000), int32_t(0xB4AC2E19)},
    {"cliff12.tem", "-", int32_t(0x00000000), int32_t(0x17189BC3)},
    {"cliff12.ubn", "", int32_t(0x00000000), int32_t(0x81C6B9E0)},
    {"cliff12.urb", "", int32_t(0x00000000), int32_t(0x3155559C)},
    {"cliff13.des", "", int32_t(0x00000000), int32_t(0x581C2026)},
    {"cliff13.sno", "-", int32_t(0x00000000), int32_t(0x7FF0FDBC)},
    {"cliff13.tem", "-", int32_t(0x00000000), int32_t(0xDC444866)},
    {"cliff13.ubn", "", int32_t(0x00000000), int32_t(0x4A9A6A45)},
    {"cliff13.urb", "", int32_t(0x00000000), int32_t(0xFA098639)},
    {"cliff14.des", "", int32_t(0x00000000), int32_t(0x4519109E)},
    {"cliff14.sno", "-", int32_t(0x00000000), int32_t(0x62F5CD04)},
    {"cliff14.tem", "-", int32_t(0x00000000), int32_t(0xC14178DE)},
    {"cliff14.ubn", "", int32_t(0x00000000), int32_t(0x579F5AFD)},
    {"cliff14.urb", "", int32_t(0x00000000), int32_t(0xE70CB681)},
    {"cliff15.des", "", int32_t(0x00000000), int32_t(0x8E45C33B)},
    {"cliff15.sno", "-", int32_t(0x00000000), int32_t(0xA9A91EA1)},
    {"cliff15.tem", "-", int32_t(0x00000000), int32_t(0x0A1DAB7B)},
    {"cliff15.ubn", "", int32_t(0x00000000), int32_t(0x9CC38958)},
    {"cliff15.urb", "", int32_t(0x00000000), int32_t(0x2C506524)},
    {"cliff16.des", "", int32_t(0x00000000), int32_t(0x08D1B195)},
    {"cliff16.sno", "-", int32_t(0x00000000), int32_t(0x2F3D6C0F)},
    {"cliff16.tem", "-", int32_t(0x00000000), int32_t(0x8C89D9D5)},
    {"cliff16.ubn", "", int32_t(0x00000000), int32_t(0x1A57FBF6)},
    {"cliff16.urb", "", int32_t(0x00000000), int32_t(0xAAC4178A)},
    {"cliff17.des", "", int32_t(0x00000000), int32_t(0xC38D6230)},
    {"cliff17.sno", "-", int32_t(0x00000000), int32_t(0xE461BFAA)},
    {"cliff17.tem", "-", int32_t(0x00000000), int32_t(0x47D50A70)},
    {"cliff17.ubn", "", int32_t(0x00000000), int32_t(0xD10B2853)},
    {"cliff17.urb", "", int32_t(0x00000000), int32_t(0x6198C42F)},
    {"cliff18.des", "", int32_t(0x00000000), int32_t(0x32DBD0E5)},
    {"cliff18.sno", "-", int32_t(0x00000000), int32_t(0x15370D7F)},
    {"cliff18.tem", "-", int32_t(0x00000000), int32_t(0xB683B8A5)},
    {"cliff18.ubn", "", int32_t(0x00000000), int32_t(0x205D9A86)},
    {"cliff18.urb", "", int32_t(0x00000000), int32_t(0x90CE76FA)},
    {"cliff19.des", "", int32_t(0x00000000), int32_t(0xF9870340)},
    {"cliff19.sno", "-", int32_t(0x00000000), int32_t(0xDE6BDEDA)},
    {"cliff19.tem", "-", int32_t(0x00000000), int32_t(0x7DDF6B00)},
    {"cliff19.ubn", "", int32_t(0x00000000), int32_t(0xEB014923)},
    {"cliff19.urb", "", int32_t(0x00000000), int32_t(0x5B92A55F)},
    {"cliff20.des", "", int32_t(0x00000000), int32_t(0xEF604815)},
    {"cliff20.sno", "-", int32_t(0x00000000), int32_t(0xC88C958F)},
    {"cliff20.tem", "-", int32_t(0x00000000), int32_t(0x6B382055)},
    {"cliff20.ubn", "", int32_t(0x00000000), int32_t(0xFDE60276)},
    {"cliff20.urb", "", int32_t(0x00000000), int32_t(0x4D75EE0A)},
    {"cliff21.des", "", int32_t(0x00000000), int32_t(0x243C9BB0)},
    {"cliff21.sno", "-", int32_t(0x00000000), int32_t(0x03D0462A)},
    {"cliff21.tem", "-", int32_t(0x00000000), int32_t(0xA064F3F0)},
    {"cliff21.ubn", "", int32_t(0x00000000), int32_t(0x36BAD1D3)},
    {"cliff21.urb", "", int32_t(0x00000000), int32_t(0x86293DAF)},
    {"cliff22.des", "", int32_t(0x00000000), int32_t(0xA2A8E91E)},
    {"cliff22.sno", "-", int32_t(0x00000000), int32_t(0x85443484)},
    {"cliff22.tem", "-", int32_t(0x00000000), int32_t(0x26F0815E)},
    {"cliff22.ubn", "", int32_t(0x00000000), int32_t(0xB02EA37D)},
    {"cliff22.urb", "", int32_t(0x00000000), int32_t(0x00BD4F01)},
    {"cliff23.des", "", int32_t(0x00000000), int32_t(0x69F43ABB)},
    {"cliff23.sno", "-", int32_t(0x00000000), int32_t(0x4E18E721)},
    {"cliff23.tem", "-", int32_t(0x00000000), int32_t(0xEDAC52FB)},
    {"cliff23.ubn", "", int32_t(0x00000000), int32_t(0x7B7270D8)},
    {"cliff23.urb", "", int32_t(0x00000000), int32_t(0xCBE19CA4)},
    {"cliff24.des", "", int32_t(0x00000000), int32_t(0x74F10A03)},
    {"cliff24.sno", "-", int32_t(0x00000000), int32_t(0x531DD799)},
    {"cliff24.tem", "-", int32_t(0x00000000), int32_t(0xF0A96243)},
    {"cliff24.ubn", "", int32_t(0x00000000), int32_t(0x66774060)},
    {"cliff24.urb", "", int32_t(0x00000000), int32_t(0xD6E4AC1C)},
    {"cliff25.des", "", int32_t(0x00000000), int32_t(0xBFADD9A6)},
    {"cliff25.sno", "-", int32_t(0x00000000), int32_t(0x9841043C)},
    {"cliff25.tem", "-", int32_t(0x00000000), int32_t(0x3BF5B1E6)},
    {"cliff25.ubn", "", int32_t(0x00000000), int32_t(0xAD2B93C5)},
    {"cliff25.urb", "", int32_t(0x00000000), int32_t(0x1DB87FB9)},
    {"cliff26.des", "", int32_t(0x00000000), int32_t(0x3939AB08)},
    {"cliff26.sno", "-", int32_t(0x00000000), int32_t(0x1ED57692)},
    {"cliff26.tem", "-", int32_t(0x00000000), int32_t(0xBD61C348)},
    {"cliff26.ubn", "", int32_t(0x00000000), int32_t(0x2BBFE16B)},
    {"cliff26.urb", "", int32_t(0x00000000), int32_t(0x9B2C0D17)},
    {"cliff27.des", "", int32_t(0x00000000), int32_t(0xF26578AD)},
    {"cliff27.sno", "-", int32_t(0x00000000), int32_t(0xD589A537)},
    {"cliff27.tem", "-", int32_t(0x00000000), int32_t(0x763D10ED)},
    {"cliff27.ubn", "", int32_t(0x00000000), int32_t(0xE0E332CE)},
    {"cliff27.urb", "", int32_t(0x00000000), int32_t(0x5070DEB2)},
    {"cliff28.des", "", int32_t(0x00000000), int32_t(0x0333CA78)},
    {"cliff28.sno", "-", int32_t(0x00000000), int32_t(0x24DF17E2)},
    {"cliff28.tem", "-", int32_t(0x00000000), int32_t(0x876BA238)},
    {"cliff28.ubn", "", int32_t(0x00000000), int32_t(0x11B5801B)},
    {"cliff28.urb", "", int32_t(0x00000000), int32_t(0xA1266C67)},
    {"cliff29.des", "", int32_t(0x00000000), int32_t(0xC86F19DD)},
    {"cliff29.sno", "-", int32_t(0x00000000), int32_t(0xEF83C447)},
    {"cliff29.tem", "-", int32_t(0x00000000), int32_t(0x4C37719D)},
    {"cliff29.ubn", "", int32_t(0x00000000), int32_t(0xDAE953BE)},
    {"cliff29.urb", "", int32_t(0x00000000), int32_t(0x6A7ABFC2)},
    {"cliff30.des", "", int32_t(0x00000000), int32_t(0x491743A1)},
    {"cliff30.sno", "-", int32_t(0x00000000), int32_t(0x6EFB9E3B)},
    {"cliff30.tem", "-", int32_t(0x00000000), int32_t(0xCD4F2BE1)},
    {"cliff30.ubn", "", int32_t(0x00000000), int32_t(0x5B9109C2)},
    {"cliff30.urb", "", int32_t(0x00000000), int32_t(0xEB02E5BE)},
    {"cliff31.des", "", int32_t(0x00000000), int32_t(0x824B9004)},
    {"cliff31.sno", "-", int32_t(0x00000000), int32_t(0xA5A74D9E)},
    {"cliff31.tem", "-", int32_t(0x00000000), int32_t(0x0613F844)},
    {"cliff31.ubn", "", int32_t(0x00000000), int32_t(0x90CDDA67)},
    {"cliff31.urb", "", int32_t(0x00000000), int32_t(0x205E361B)},
    {"cliff32.des", "", int32_t(0x00000000), int32_t(0x04DFE2AA)},
    {"cliff32.sno", "-", int32_t(0x00000000), int32_t(0x23333F30)},
    {"cliff32.tem", "-", int32_t(0x00000000), int32_t(0x80878AEA)},
    {"cliff32.ubn", "", int32_t(0x00000000), int32_t(0x1659A8C9)},
    {"cliff32.urb", "", int32_t(0x00000000), int32_t(0xA6CA44B5)},
    {"cliff32a.tem", "-", int32_t(0x00000000), int32_t(0xDB3E0556)},
    {"cliff33.des", "", int32_t(0x00000000), int32_t(0xCF83310F)},
    {"cliff33.sno", "-", int32_t(0x00000000), int32_t(0xE86FEC95)},
    {"cliff33.tem", "-", int32_t(0x00000000), int32_t(0x4BDB594F)},
    {"cliff33.ubn", "", int32_t(0x00000000), int32_t(0xDD057B6C)},
    {"cliff33.urb", "", int32_t(0x00000000), int32_t(0x6D969710)},
    {"cliff33a.des", "", int32_t(0x00000000), int32_t(0xF64B48E0)},
    {"cliff33a.sno", "-", int32_t(0x00000000), int32_t(0x18D77891)},
    {"cliff33a.tem", "-", int32_t(0x00000000), int32_t(0x1062D6F3)},
    {"cliff33a.ubn", "", int32_t(0x00000000), int32_t(0xC7E87BB9)},
    {"cliff33a.urb", "", int32_t(0x00000000), int32_t(0x849C25C3)},
    {"cliff34.des", "", int32_t(0x00000000), int32_t(0xD28601B7)},
    {"cliff34.sno", "-", int32_t(0x00000000), int32_t(0xF56ADC2D)},
    {"cliff34.tem", "-", int32_t(0x00000000), int32_t(0x56DE69F7)},
    {"cliff34.ubn", "", int32_t(0x00000000), int32_t(0xC0004BD4)},
    {"cliff34.urb", "", int32_t(0x00000000), int32_t(0x7093A7A8)},
    {"cliff34a.des", "", int32_t(0x00000000), int32_t(0xEB4E7858)},
    {"cliff34a.sno", "-", int32_t(0x00000000), int32_t(0x05D24829)},
    {"cliff34a.tem", "-", int32_t(0x00000000), int32_t(0x0D67E64B)},
    {"cliff34a.ubn", "", int32_t(0x00000000), int32_t(0xDAED4B01)},
    {"cliff34a.urb", "", int32_t(0x00000000), int32_t(0x9999157B)},
    {"cliff35.des", "", int32_t(0x00000000), int32_t(0x19DAD212)},
    {"cliff35.sno", "-", int32_t(0x00000000), int32_t(0x3E360F88)},
    {"cliff35.tem", "-", int32_t(0x00000000), int32_t(0x9D82BA52)},
    {"cliff35.ubn", "", int32_t(0x00000000), int32_t(0x0B5C9871)},
    {"cliff35.urb", "", int32_t(0x00000000), int32_t(0xBBCF740D)},
    {"cliff36.des", "", int32_t(0x00000000), int32_t(0x9F4EA0BC)},
    {"cliff36.sno", "-", int32_t(0x00000000), int32_t(0xB8A27D26)},
    {"cliff36.tem", "-", int32_t(0x00000000), int32_t(0x1B16C8FC)},
    {"cliff36.ubn", "", int32_t(0x00000000), int32_t(0x8DC8EADF)},
    {"cliff36.urb", "", int32_t(0x00000000), int32_t(0x3D5B06A3)},
    {"cliff37.des", "", int32_t(0x00000000), int32_t(0x54127319)},
    {"cliff37.sno", "-", int32_t(0x00000000), int32_t(0x73FEAE83)},
    {"cliff37.tem", "-", int32_t(0x00000000), int32_t(0xD04A1B59)},
    {"cliff37.ubn", "", int32_t(0x00000000), int32_t(0x4694397A)},
    {"cliff37.urb", "", int32_t(0x00000000), int32_t(0xF607D506)},
    {"cliff38.des", "", int32_t(0x00000000), int32_t(0xA544C1CC)},
    {"cliff38.sno", "-", int32_t(0x00000000), int32_t(0x82A81C56)},
    {"cliff38.tem", "-", int32_t(0x00000000), int32_t(0x211CA98C)},
    {"cliff38.ubn", "", int32_t(0x00000000), int32_t(0xB7C28BAF)},
    {"cliff38.urb", "", int32_t(0x00000000), int32_t(0x075167D3)},
    {"cliff39.des", "", int32_t(0x00000000), int32_t(0x6E181269)},
    {"cliff39.sno", "-", int32_t(0x00000000), int32_t(0x49F4CFF3)},
    {"cliff39.tem", "-", int32_t(0x00000000), int32_t(0xEA407A29)},
    {"cliff39.ubn", "", int32_t(0x00000000), int32_t(0x7C9E580A)},
    {"cliff39.urb", "", int32_t(0x00000000), int32_t(0xCC0DB476)},
    {"cliff40.des", "", int32_t(0x00000000), int32_t(0x8CB07D2F)},
    {"cliff40.sno", "-", int32_t(0x00000000), int32_t(0xAB5CA0B5)},
    {"cliff40.tem", "-", int32_t(0x00000000), int32_t(0x08E8156F)},
    {"cliff40.ubn", "", int32_t(0x00000000), int32_t(0x9E36374C)},
    {"cliff40.urb", "", int32_t(0x00000000), int32_t(0x2EA5DB30)},
    {"cliff41.des", "", int32_t(0x00000000), int32_t(0x47ECAE8A)},
    {"cliff41.tem", "", int32_t(0x00000000), int32_t(0xC3B4C6CA)},
    {"cliff41.urb", "", int32_t(0x00000000), int32_t(0xE5F90895)},
    {"cliff42.des", "", int32_t(0x00000000), int32_t(0xC178DC24)},
    {"cliff42.tem", "", int32_t(0x00000000), int32_t(0x4520B464)},
    {"cliff42.urb", "", int32_t(0x00000000), int32_t(0x636D7A3B)},
    {"cliffa01.ubn", "", int32_t(0x00000000), int32_t(0xC35928DA)},
    {"cliffa01.urb", "", int32_t(0x00000000), int32_t(0x802D76A0)},
    {"cliffa02.ubn", "", int32_t(0x00000000), int32_t(0x84F9520A)},
    {"cliffa02.urb", "", int32_t(0x00000000), int32_t(0xC78D0C70)},
    {"cliffa03.ubn", "", int32_t(0x00000000), int32_t(0xB9997BBA)},
    {"cliffa03.urb", "", int32_t(0x00000000), int32_t(0xFAED25C0)},
    {"cliffa04.ubn", "", int32_t(0x00000000), int32_t(0x0BB9A7AA)},
    {"cliffa04.urb", "", int32_t(0x00000000), int32_t(0x48CDF9D0)},
    {"cliffa05.ubn", "", int32_t(0x00000000), int32_t(0x36D98E1A)},
    {"cliffa05.urb", "", int32_t(0x00000000), int32_t(0x75ADD060)},
    {"cliffa06.ubn", "", int32_t(0x00000000), int32_t(0x7179F4CA)},
    {"cliffa06.urb", "", int32_t(0x00000000), int32_t(0x320DAAB0)},
    {"cliffa07.ubn", "", int32_t(0x00000000), int32_t(0x4C19DD7A)},
    {"cliffa07.urb", "", int32_t(0x00000000), int32_t(0x0F6D8300)},
    {"cliffa08.ubn", "", int32_t(0x00000000), int32_t(0xCE494AAB)},
    {"cliffa08.urb", "", int32_t(0x00000000), int32_t(0x8D3D14D1)},
    {"cliffa09.ubn", "", int32_t(0x00000000), int32_t(0xF329631B)},
    {"cliffa09.urb", "", int32_t(0x00000000), int32_t(0xB05D3D61)},
    {"cliffa10.ubn", "", int32_t(0x00000000), int32_t(0x3565D2CF)},
    {"cliffa10.urb", "", int32_t(0x00000000), int32_t(0x76118CB5)},
    {"cliffa11.ubn", "", int32_t(0x00000000), int32_t(0x0805FB7F)},
    {"cliffa11.urb", "", int32_t(0x00000000), int32_t(0x4B71A505)},
    {"cliffa12.ubn", "", int32_t(0x00000000), int32_t(0x4FA581AF)},
    {"cliffa12.urb", "", int32_t(0x00000000), int32_t(0x0CD1DFD5)},
    {"cliffa13.ubn", "", int32_t(0x00000000), int32_t(0x72C5A81F)},
    {"cliffa13.urb", "", int32_t(0x00000000), int32_t(0x31B1F665)},
    {"cliffa14.ubn", "", int32_t(0x00000000), int32_t(0xC0E5740F)},
    {"cliffa14.urb", "", int32_t(0x00000000), int32_t(0x83912A75)},
    {"cliffc01.ubn", "", int32_t(0x00000000), int32_t(0x54C639F3)},
    {"cliffc01.urb", "", int32_t(0x00000000), int32_t(0x17B26789)},
    {"cliffc02.ubn", "", int32_t(0x00000000), int32_t(0x13664323)},
    {"cliffc02.urb", "", int32_t(0x00000000), int32_t(0x50121D59)},
    {"cliffc03.ubn", "", int32_t(0x00000000), int32_t(0x2E066A93)},
    {"cliffc03.urb", "", int32_t(0x00000000), int32_t(0x6D7234E9)},
    {"cliffc04.ubn", "", int32_t(0x00000000), int32_t(0x9C26B683)},
    {"cliffc04.urb", "", int32_t(0x00000000), int32_t(0xDF52E8F9)},
    {"cliffc05.ubn", "", int32_t(0x00000000), int32_t(0xA1469F33)},
    {"cliffc05.urb", "", int32_t(0x00000000), int32_t(0xE232C149)},
    {"cliffc06.ubn", "", int32_t(0x00000000), int32_t(0xE6E6E5E3)},
    {"cliffc06.urb", "", int32_t(0x00000000), int32_t(0xA592BB99)},
    {"cliffsin.ini", "", int32_t(0x00000000), int32_t(0x435A0E91)},
    {"cliffsin.map", "-", int32_t(0x00000000), int32_t(0xA7A01242)},
    {"cliffx01.ubn", "", int32_t(0x00000000), int32_t(0x311FF1C7)},
    {"cliffx02.ubn", "", int32_t(0x00000000), int32_t(0x76BF8B17)},
    {"cliffx03.ubn", "", int32_t(0x00000000), int32_t(0x4BDFA2A7)},
    {"cliffx04.ubn", "", int32_t(0x00000000), int32_t(0xF9FF7EB7)},
    {"cliffx05.ubn", "", int32_t(0x00000000), int32_t(0xC49F5707)},
    {"cliffx06.ubn", "", int32_t(0x00000000), int32_t(0x833F2DD7)},
    {"cliffx07.ubn", "", int32_t(0x00000000), int32_t(0xBE5F0467)},
    {"cliffx08.ubn", "", int32_t(0x00000000), int32_t(0x3C0F93B6)},
    {"cliffx09.ubn", "", int32_t(0x00000000), int32_t(0x016FBA06)},
    {"cliffx10.ubn", "", int32_t(0x00000000), int32_t(0xC7230BD2)},
    {"cliffx11.ubn", "", int32_t(0x00000000), int32_t(0xFA432262)},
    {"cliffx12.ubn", "", int32_t(0x00000000), int32_t(0xBDE358B2)},
    {"cliffx13.ubn", "", int32_t(0x00000000), int32_t(0x80837102)},
    {"cliffx14.ubn", "", int32_t(0x00000000), int32_t(0x32A3AD12)},
    {"cliffx15.ubn", "", int32_t(0x00000000), int32_t(0x0FC384A2)},
    {"cliffx16.ubn", "", int32_t(0x00000000), int32_t(0x4863FE72)},
    {"cliffx17.ubn", "", int32_t(0x00000000), int32_t(0x7503D7C2)},
    {"cliffx18.ubn", "", int32_t(0x00000000), int32_t(0xF7534013)},
    {"cliffx19.ubn", "", int32_t(0x00000000), int32_t(0xCA3369A3)},
    {"cliffx20.ubn", "", int32_t(0x00000000), int32_t(0x41B7797C)},
    {"cliffx21.ubn", "", int32_t(0x00000000), int32_t(0x7CD750CC)},
    {"cliffx22.ubn", "", int32_t(0x00000000), int32_t(0x3B772A1C)},
    {"cliffx23.ubn", "", int32_t(0x00000000), int32_t(0x061703AC)},
    {"cliffx24.ubn", "", int32_t(0x00000000), int32_t(0xB437DFBC)},
    {"cliffx25.ubn", "", int32_t(0x00000000), int32_t(0x8957F60C)},
    {"cliffx26.ubn", "", int32_t(0x00000000), int32_t(0xCEF78CDC)},
    {"cliffx27.ubn", "", int32_t(0x00000000), int32_t(0xF397A56C)},
    {"cliffx28.ubn", "", int32_t(0x00000000), int32_t(0x71C732BD)},
    {"cliffx29.ubn", "", int32_t(0x00000000), int32_t(0x4CA71B0D)},
    {"cliffx30.ubn", "", int32_t(0x00000000), int32_t(0x8AEBAAD9)},
    {"cliffx31.ubn", "", int32_t(0x00000000), int32_t(0xB78B8369)},
    {"cliffx32.ubn", "", int32_t(0x00000000), int32_t(0xF02BF9B9)},
    {"cliffx33.ubn", "", int32_t(0x00000000), int32_t(0xCD4BD009)},
    {"cliffx34.ubn", "", int32_t(0x00000000), int32_t(0x7F6B0C19)},
    {"cliffx35.ubn", "", int32_t(0x00000000), int32_t(0x420B25A9)},
    {"cliffx36.ubn", "", int32_t(0x00000000), int32_t(0x05AB5F79)},
    {"cliffx37.ubn", "", int32_t(0x00000000), int32_t(0x38CB76C9)},
    {"cliffx38.ubn", "", int32_t(0x00000000), int32_t(0xBA9BE118)},
    {"cliffx39.ubn", "", int32_t(0x00000000), int32_t(0x87FBC8A8)},
    {"cliffx40.ubn", "", int32_t(0x00000000), int32_t(0x97EE9A61)},
    {"cliffx41.ubn", "", int32_t(0x00000000), int32_t(0xAA8EB3D1)},
    {"cliffx42.ubn", "", int32_t(0x00000000), int32_t(0xED2EC901)},
    {"clifx01.sno", "", int32_t(0x00000000), int32_t(0xFD7E741A)},
    {"clifx02.sno", "", int32_t(0x00000000), int32_t(0x7BEA06B4)},
    {"clifx03.sno", "", int32_t(0x00000000), int32_t(0xB0B6D511)},
    {"clifx04.sno", "", int32_t(0x00000000), int32_t(0xADB3E5A9)},
    {"clifx05.sno", "", int32_t(0x00000000), int32_t(0x66EF360C)},
    {"clifx06.sno", "", int32_t(0x00000000), int32_t(0xE07B44A2)},
    {"clifx07.sno", "", int32_t(0x00000000), int32_t(0x2B279707)},
    {"clifx08.sno", "", int32_t(0x00000000), int32_t(0xDA7125D2)},
    {"clifx09.sno", "", int32_t(0x00000000), int32_t(0x112DF677)},
    {"clifx10.sno", "", int32_t(0x00000000), int32_t(0x9055AC0B)},
    {"clifx11.sno", "", int32_t(0x00000000), int32_t(0x5B097FAE)},
    {"clifx12.sno", "", int32_t(0x00000000), int32_t(0xDD9D0D00)},
    {"clifx13.sno", "", int32_t(0x00000000), int32_t(0x16C1DEA5)},
    {"clifx14.sno", "", int32_t(0x00000000), int32_t(0x0BC4EE1D)},
    {"clifx15.sno", "", int32_t(0x00000000), int32_t(0xC0983DB8)},
    {"clifx16.sno", "", int32_t(0x00000000), int32_t(0x460C4F16)},
    {"clifx17.sno", "", int32_t(0x00000000), int32_t(0x8D509CB3)},
    {"clifx18.sno", "", int32_t(0x00000000), int32_t(0x7C062E66)},
    {"clifx19.sno", "", int32_t(0x00000000), int32_t(0xB75AFDC3)},
    {"clifx20.sno", "", int32_t(0x00000000), int32_t(0xA1BDB696)},
    {"clifx21.sno", "", int32_t(0x00000000), int32_t(0x6AE16533)},
    {"clifx22.sno", "", int32_t(0x00000000), int32_t(0xEC75179D)},
    {"clifx23.sno", "", int32_t(0x00000000), int32_t(0x2729C438)},
    {"clifx24.sno", "", int32_t(0x00000000), int32_t(0x3A2CF480)},
    {"clifx25.sno", "", int32_t(0x00000000), int32_t(0xF1702725)},
    {"clifx26.sno", "", int32_t(0x00000000), int32_t(0x77E4558B)},
    {"clifx27.sno", "", int32_t(0x00000000), int32_t(0xBCB8862E)},
    {"clifx28.sno", "", int32_t(0x00000000), int32_t(0x4DEE34FB)},
    {"clifx29.sno", "", int32_t(0x00000000), int32_t(0x86B2E75E)},
    {"clifx30.sno", "", int32_t(0x00000000), int32_t(0x07CABD22)},
    {"clifx31.sno", "", int32_t(0x00000000), int32_t(0xCC966E87)},
    {"clifx32.sno", "", int32_t(0x00000000), int32_t(0x4A021C29)},
    {"clifx33.sno", "", int32_t(0x00000000), int32_t(0x815ECF8C)},
    {"clifx33a.sno", "", int32_t(0x00000000), int32_t(0x71E65B88)},
    {"clifx34.sno", "", int32_t(0x00000000), int32_t(0x9C5BFF34)},
    {"clifx34a.sno", "", int32_t(0x00000000), int32_t(0x6CE36B30)},
    {"clifx35.sno", "", int32_t(0x00000000), int32_t(0x57072C91)},
    {"clifx36.sno", "", int32_t(0x00000000), int32_t(0xD1935E3F)},
    {"clifx37.sno", "", int32_t(0x00000000), int32_t(0x1ACF8D9A)},
    {"clifx38.sno", "", int32_t(0x00000000), int32_t(0xEB993F4F)},
    {"clifx39.sno", "", int32_t(0x00000000), int32_t(0x20C5ECEA)},
    {"clifx40.sno", "", int32_t(0x00000000), int32_t(0xC26D83AC)},
    {"clifxl01.sno", "", int32_t(0x00000000), int32_t(0x1480692B)},
    {"clifxl02.sno", "", int32_t(0x00000000), int32_t(0x532013FB)},
    {"clifxl03.sno", "", int32_t(0x00000000), int32_t(0x6E403A4B)},
    {"clifxl03a.sno", "", int32_t(0x00000000), int32_t(0x4BB575A2)},
    {"clifxl04.sno", "", int32_t(0x00000000), int32_t(0xDC60E65B)},
    {"clifxl04a.sno", "", int32_t(0x00000000), int32_t(0x2FD4186B)},
    {"clind01.shp", "", int32_t(0x00000000), int32_t(0xA465804A)},
    {"clink1.aud", "", int32_t(0xBB81D7F8), int32_t(0x00000000)},
    {"clink2.aud", "", int32_t(0xBB81D9F8), int32_t(0x00000000)},
    {"clink3.aud", "", int32_t(0xBB81DBF8), int32_t(0x00000000)},
    {"clink4.aud", "", int32_t(0xBB81DDF8), int32_t(0x00000000)},
    {"clirfgl.shp", "", int32_t(0x00000000), int32_t(0x32C7C6E8)},
    {"clirfgl_a.shp", "", int32_t(0x00000000), int32_t(0x6849A6EC)},
    {"clkrmw.shp", "", int32_t(0x00000000), int32_t(0xB45699FA)},
    {"clktarg.aud", "", int32_t(0x00000000), int32_t(0xD08C5D8E)},
    {"clla01.shp", "", int32_t(0x00000000), int32_t(0x1CF401A9)},
    {"clla02.shp", "", int32_t(0x00000000), int32_t(0x2D1C1B34)},
    {"cllab.shp", "", int32_t(0x00000000), int32_t(0xA0A95F98)},
    {"cllbfgl.shp", "", int32_t(0x00000000), int32_t(0x782E4FDD)},
    {"cllbfgl_a.shp", "", int32_t(0x00000000), int32_t(0x58ED6E5B)},
    {"cllit01e.shp", "", int32_t(0x00000000), int32_t(0x4D2BFD77)},
    {"cllit01n.shp", "", int32_t(0x00000000), int32_t(0x3AFBCC66)},
    {"cllit01s.shp", "", int32_t(0x00000000), int32_t(0xA28B9F55)},
    {"cllit01w.shp", "", int32_t(0x00000000), int32_t(0x570B3995)},
    {"cllit02l.shp", "", int32_t(0x00000000), int32_t(0xC6AFEDA8)},
    {"cllit02r.shp", "", int32_t(0x00000000), int32_t(0x197FC44B)},
    {"cllit03e.shp", "", int32_t(0x00000000), int32_t(0x00E35C7C)},
    {"cllit03n.shp", "", int32_t(0x00000000), int32_t(0x77336D6D)},
    {"cllit03s.shp", "", int32_t(0x00000000), int32_t(0xEF433E5E)},
    {"cllit03w.shp", "", int32_t(0x00000000), int32_t(0x1AC3989E)},
    {"cllond02.shp", "", int32_t(0x00000000), int32_t(0x4BC3B25C)},
    {"cllunr01.shp", "", int32_t(0x00000000), int32_t(0x3183A997)},
    {"cllunr02.shp", "", int32_t(0x00000000), int32_t(0x7623D347)},
    {"clmex01.shp", "", int32_t(0x00000000), int32_t(0x04CF9A89)},
    {"clmex02.shp", "", int32_t(0x00000000), int32_t(0x825BE827)},
    {"clmex03.shp", "", int32_t(0x00000000), int32_t(0x49073B82)},
    {"clmex04.shp", "", int32_t(0x00000000), int32_t(0x54020B3A)},
    {"clmex05.shp", "", int32_t(0x00000000), int32_t(0x9F5ED89F)},
    {"clmiam01.shp", "", int32_t(0x00000000), int32_t(0xDC038D47)},
    {"clmiam02.shp", "", int32_t(0x00000000), int32_t(0x9BA3F797)},
    {"clmiam03.shp", "", int32_t(0x00000000), int32_t(0xA6C3DE27)},
    {"clmiam04.shp", "", int32_t(0x00000000), int32_t(0x14E30237)},
    {"clmiam05.shp", "", int32_t(0x00000000), int32_t(0x29832B87)},
    {"clmiam06.shp", "", int32_t(0x00000000), int32_t(0x6E235157)},
    {"clmiam07.shp", "", int32_t(0x00000000), int32_t(0x534378E7)},
    {"clmiam08.shp", "", int32_t(0x00000000), int32_t(0xD113EF36)},
    {"clmisc01.shp", "", int32_t(0x00000000), int32_t(0xB2A2C04C)},
    {"clmisc02.shp", "", int32_t(0x00000000), int32_t(0xF502BA9C)},
    {"clmisc03.shp", "", int32_t(0x00000000), int32_t(0xC862932C)},
    {"clmisc04.shp", "", int32_t(0x00000000), int32_t(0x7A424F3C)},
    {"clmisc05.shp", "", int32_t(0x00000000), int32_t(0x4722668C)},
    {"clmisc06.shp", "", int32_t(0x00000000), int32_t(0x00821C5C)},
    {"clmoon01.shp", "", int32_t(0x00000000), int32_t(0x8B7BFC62)},
    {"clmov01.shp", "", int32_t(0x00000000), int32_t(0x846B0225)},
    {"clmov01_a.shp", "", int32_t(0x00000000), int32_t(0x5A784BF7)},
    {"clmov02.shp", "", int32_t(0x00000000), int32_t(0x02FF708B)},
    {"clmov02_a.shp", "", int32_t(0x00000000), int32_t(0xB14FF0F4)},
    {"clmsc01.shp", "", int32_t(0x00000000), int32_t(0xFAC48C0F)},
    {"clmsc02.shp", "", int32_t(0x00000000), int32_t(0x7C50FEA1)},
    {"clmsc03.shp", "", int32_t(0x00000000), int32_t(0xB70C2D04)},
    {"clmsc04.shp", "", int32_t(0x00000000), int32_t(0xAA091DBC)},
    {"clmsc05.shp", "", int32_t(0x00000000), int32_t(0x6155CE19)},
    {"clmsc06.shp", "", int32_t(0x00000000), int32_t(0xE7C1BCB7)},
    {"clmsc06a.shp", "", int32_t(0x00000000), int32_t(0x05FCF0EC)},
    {"clmsc07.shp", "", int32_t(0x00000000), int32_t(0x2C9D6F12)},
    {"clmsc08.shp", "", int32_t(0x00000000), int32_t(0xDDCBDDC7)},
    {"clmsc09.shp", "", int32_t(0x00000000), int32_t(0x16970E62)},
    {"clmsc10.shp", "", int32_t(0x00000000), int32_t(0x97EF541E)},
    {"clmsc11.shp", "", int32_t(0x00000000), int32_t(0x5CB387BB)},
    {"clmsc12.shp", "", int32_t(0x00000000), int32_t(0xDA27F515)},
    {"clmsc13.shp", "", int32_t(0x00000000), int32_t(0x117B26B0)},
    {"clnewy01.shp", "", int32_t(0x00000000), int32_t(0xF8454521)},
    {"clnewy05.shp", "", int32_t(0x00000000), int32_t(0x0DC5E3E1)},
    {"clnewy06.shp", "", int32_t(0x00000000), int32_t(0x4A659931)},
    {"clnewy07.shp", "", int32_t(0x00000000), int32_t(0x7705B081)},
    {"clnewy08.shp", "", int32_t(0x00000000), int32_t(0xF5552750)},
    {"clnewy10.shp", "", int32_t(0x00000000), int32_t(0x0E79BF34)},
    {"clnewy11.shp", "", int32_t(0x00000000), int32_t(0x33199684)},
    {"clnewy12.shp", "", int32_t(0x00000000), int32_t(0x74B9EC54)},
    {"clnewy13.shp", "", int32_t(0x00000000), int32_t(0x49D9C5E4)},
    {"clnewy14.shp", "", int32_t(0x00000000), int32_t(0xFBF919F4)},
    {"clnewy15.shp", "", int32_t(0x00000000), int32_t(0xC6993044)},
    {"clnewy16.shp", "", int32_t(0x00000000), int32_t(0x81394A94)},
    {"clnewy17.shp", "", int32_t(0x00000000), int32_t(0xBC596324)},
    {"clnewy18.shp", "", int32_t(0x00000000), int32_t(0x3E09F4F5)},
    {"clnewy20.shp", "", int32_t(0x00000000), int32_t(0x88EDCD9A)},
    {"clnewy21.shp", "", int32_t(0x00000000), int32_t(0xB58DE42A)},
    {"clnkfgl.shp", "", int32_t(0x00000000), int32_t(0xD07829BB)},
    {"clnkfgl_a.shp", "", int32_t(0x00000000), int32_t(0x3E16A01E)},
    {"clnwy05.shp", "", int32_t(0x00000000), int32_t(0x3AF509F5)},
    {"clnwy09.shp", "", int32_t(0x00000000), int32_t(0x4D37C98E)},
    {"clnwy22.shp", "", int32_t(0x00000000), int32_t(0xB06F2864)},
    {"clnwy23.shp", "", int32_t(0x00000000), int32_t(0x7B33FBC1)},
    {"clnwy24.shp", "", int32_t(0x00000000), int32_t(0x6636CB79)},
    {"clnwy25.shp", "", int32_t(0x00000000), int32_t(0xAD6A18DC)},
    {"clnwy26.shp", "", int32_t(0x00000000), int32_t(0x2BFE6A72)},
    {"cloak.shp", "crate: stealth", int32_t(0x00000000), int32_t(0x54D1FFB0)},
    {"cloak5.aud", "cloaking sound", int32_t(0x00000000), int32_t(0x32CC3FAA)},
    {"clock.shp", "time dial", int32_t(0x9DE38DF3), int32_t(0x00000000)},
    {"clock1.aud", "???", int32_t(0x8F99D7F8), int32_t(0x00000000)},
    {"cloild.shp", "", int32_t(0x00000000), int32_t(0x09B463E1)},
    {"cloild_a.shp", "", int32_t(0x00000000), int32_t(0xD61B5038)},
    {"cloild_f.shp", "", int32_t(0x00000000), int32_t(0x643B8C28)},
    {"clonicon.shp", "", int32_t(0x00000000), int32_t(0xBEBB9851)},
    {"cloud1.aud", "", int32_t(0xD799D7EA), int32_t(0x00000000)},
    {"cloud1.shp", "poison gas cloud (large)", int32_t(0x00000000), int32_t(0x2EF536BD)},
    {"cloud1d.shp", "poison gas cloud disappearing", int32_t(0x00000000), int32_t(0x7A76BB67)},
    {"cloud2.shp", "poison gas cloud (small)", int32_t(0x00000000), int32_t(0x1F1D2C20)},
    {"cloud2d.shp", "poison gas cloud desappearing", int32_t(0x00000000), int32_t(0x4B9EA1FA)},
    {"cloudb1.aud", "", int32_t(0xB1E40AD6), int32_t(0x00000000)},
    {"clouds.cps", "pict: ???", int32_t(0xDB9A2AE5), int32_t(0x00000000)},
    {"cloutp.shp", "", int32_t(0x00000000), int32_t(0x7F8F40C7)},
    {"cloutp_a.shp", "", int32_t(0x00000000), int32_t(0xA020731E)},
    {"cloutp_b.shp", "", int32_t(0x00000000), int32_t(0xE78009CE)},
    {"cloutp_c.shp", "", int32_t(0x00000000), int32_t(0xDAE0207E)},
    {"cloutp_d.shp", "", int32_t(0x00000000), int32_t(0x68C0FC6E)},
    {"cloutp_f.shp", "", int32_t(0x00000000), int32_t(0x1200AF0E)},
    {"cloutpbb.shp", "", int32_t(0x00000000), int32_t(0x58C8188B)},
    {"clovdie1.aud", "", int32_t(0x001D04C3), int32_t(0x00000000)},
    {"clovdies.aud", "", int32_t(0x441D04C3), int32_t(0x00000000)},
    {"clpark01.shp", "", int32_t(0x00000000), int32_t(0x246F26F5)},
    {"clpark02.shp", "", int32_t(0x00000000), int32_t(0x63CF5C25)},
    {"clpark03.shp", "", int32_t(0x00000000), int32_t(0x5EAF7595)},
    {"clpars02.shp", "", int32_t(0x00000000), int32_t(0x37FE8E8C)},
    {"clpars04.shp", "", int32_t(0x00000000), int32_t(0xB8BE7B2C)},
    {"clpars05.shp", "", int32_t(0x00000000), int32_t(0x85DE529C)},
    {"clpars06.shp", "", int32_t(0x00000000), int32_t(0xC27E284C)},
    {"clpars07.shp", "", int32_t(0x00000000), int32_t(0xFF1E01FC)},
    {"clpars08.shp", "", int32_t(0x00000000), int32_t(0x7D4E962D)},
    {"clpars09.shp", "", int32_t(0x00000000), int32_t(0x402EBF9D)},
    {"clpars10.shp", "", int32_t(0x00000000), int32_t(0x86620E49)},
    {"clpars12.shp", "", int32_t(0x00000000), int32_t(0xFCA25D29)},
    {"clpars12d.shp", "", int32_t(0x00000000), int32_t(0x5E2AA8A1)},
    {"clpars13.shp", "", int32_t(0x00000000), int32_t(0xC1C27499)},
    {"clpars14.shp", "", int32_t(0x00000000), int32_t(0x73E2A889)},
    {"clpol01e.shp", "", int32_t(0x00000000), int32_t(0xACFDCF05)},
    {"clpol01n.shp", "", int32_t(0x00000000), int32_t(0xDB2DFE14)},
    {"clpol01s.shp", "", int32_t(0x00000000), int32_t(0x435DAD27)},
    {"clpol01w.shp", "", int32_t(0x00000000), int32_t(0xB6DD0BE7)},
    {"clprs03.shp", "", int32_t(0x00000000), int32_t(0x0E9C0234)},
    {"clrufgl.shp", "", int32_t(0x00000000), int32_t(0x89E8D13E)},
    {"clrufgl_a.shp", "", int32_t(0x00000000), int32_t(0x3CB0A735)},
    {"clrus02a.shp", "", int32_t(0x00000000), int32_t(0x4769203E)},
    {"clrus02b.shp", "", int32_t(0x00000000), int32_t(0x00C95AEE)},
    {"clrus02c.shp", "", int32_t(0x00000000), int32_t(0x3DA9735E)},
    {"clrus02d.shp", "", int32_t(0x00000000), int32_t(0x8F89AF4E)},
    {"clrus02e.shp", "", int32_t(0x00000000), int32_t(0xB2E986FE)},
    {"clrus02f.shp", "", int32_t(0x00000000), int32_t(0xF549FC2E)},
    {"clrus02g.shp", "", int32_t(0x00000000), int32_t(0xC829D59E)},
    {"clrus03.shp", "", int32_t(0x00000000), int32_t(0x6E08BFC0)},
    {"clrus04.shp", "", int32_t(0x00000000), int32_t(0x730D8F78)},
    {"clrus05.shp", "", int32_t(0x00000000), int32_t(0xB8515CDD)},
    {"clrus06.shp", "", int32_t(0x00000000), int32_t(0x3EC52E73)},
    {"clrus07.shp", "", int32_t(0x00000000), int32_t(0xF599FDD6)},
    {"clrus08.shp", "", int32_t(0x00000000), int32_t(0x04CF4F03)},
    {"clrus09.shp", "", int32_t(0x00000000), int32_t(0xCF939CA6)},
    {"clrus10.shp", "", int32_t(0x00000000), int32_t(0x4EEBC6DA)},
    {"clrus11.shp", "", int32_t(0x00000000), int32_t(0x85B7157F)},
    {"clsanf01.shp", "", int32_t(0x00000000), int32_t(0x859BD852)},
    {"clsanf02.shp", "", int32_t(0x00000000), int32_t(0xC23BA282)},
    {"clsanf03.shp", "", int32_t(0x00000000), int32_t(0xFF5B8B32)},
    {"clsanf04.shp", "", int32_t(0x00000000), int32_t(0x4D7B5722)},
    {"clsanf06.shp", "", int32_t(0x00000000), int32_t(0x37BB0442)},
    {"clsanf07.shp", "", int32_t(0x00000000), int32_t(0x0ADB2DF2)},
    {"clsanf08.shp", "", int32_t(0x00000000), int32_t(0x888BBA23)},
    {"clsanf09.shp", "", int32_t(0x00000000), int32_t(0xB5EB9393)},
    {"clsanf10.shp", "", int32_t(0x00000000), int32_t(0x73A72247)},
    {"clsanf11.shp", "", int32_t(0x00000000), int32_t(0x4EC70BF7)},
    {"clsanf12.shp", "", int32_t(0x00000000), int32_t(0x09677127)},
    {"clsanf13.shp", "", int32_t(0x00000000), int32_t(0x34075897)},
    {"clsanf14.shp", "", int32_t(0x00000000), int32_t(0x86278487)},
    {"clseat01.shp", "", int32_t(0x00000000), int32_t(0xF1161615)},
    {"clskfgl.shp", "", int32_t(0x00000000), int32_t(0x022823E3)},
    {"clskfgl_a.shp", "", int32_t(0x00000000), int32_t(0xEF5EEC29)},
    {"clstl01.shp", "", int32_t(0x00000000), int32_t(0x7EE24231)},
    {"clstl02.shp", "", int32_t(0x00000000), int32_t(0xF876309F)},
    {"clstl03.shp", "", int32_t(0x00000000), int32_t(0x332AE33A)},
    {"clstl05a.shp", "", int32_t(0x00000000), int32_t(0x074E4C7C)},
    {"clstl05b.shp", "", int32_t(0x00000000), int32_t(0x40EE36AC)},
    {"clstl05c.shp", "", int32_t(0x00000000), int32_t(0x7D8E1F1C)},
    {"clstl05d.shp", "", int32_t(0x00000000), int32_t(0xCFAEC30C)},
    {"clstl05e.shp", "", int32_t(0x00000000), int32_t(0xF2CEEABC)},
    {"clstl05f.shp", "", int32_t(0x00000000), int32_t(0xB56E906C)},
    {"clstl05g.shp", "", int32_t(0x00000000), int32_t(0x880EB9DC)},
    {"clstl05h.shp", "", int32_t(0x00000000), int32_t(0x0A5E2E0D)},
    {"clstrt01.shp", "", int32_t(0x00000000), int32_t(0xB89976EF)},
    {"clstrt05.shp", "", int32_t(0x00000000), int32_t(0x4D19D02F)},
    {"clswst01.shp", "", int32_t(0x00000000), int32_t(0x4DBE4AB4)},
    {"clsydn01.shp", "", int32_t(0x00000000), int32_t(0x30AC6A94)},
    {"clsydn02.shp", "", int32_t(0x00000000), int32_t(0x770C1044)},
    {"clsydn03.shp", "", int32_t(0x00000000), int32_t(0x4A6C39F4)},
    {"cltech01.shp", "", int32_t(0x00000000), int32_t(0xF191FCAB)},
    {"cltexs01.shp", "", int32_t(0x00000000), int32_t(0xB59919E2)},
    {"cltexs02.shp", "", int32_t(0x00000000), int32_t(0xF2396332)},
    {"cltexs03.shp", "", int32_t(0x00000000), int32_t(0xCF594A82)},
    {"cltexs04.shp", "", int32_t(0x00000000), int32_t(0x7D799692)},
    {"cltexs05.shp", "", int32_t(0x00000000), int32_t(0x4019BF22)},
    {"cltexs06.shp", "", int32_t(0x00000000), int32_t(0x07B9C5F2)},
    {"cltexs07.shp", "", int32_t(0x00000000), int32_t(0x3AD9EC42)},
    {"cltexs08.shp", "", int32_t(0x00000000), int32_t(0xB8897B93)},
    {"clthosp.shp", "", int32_t(0x00000000), int32_t(0x21B36549)},
    {"cltran03.shp", "", int32_t(0x00000000), int32_t(0x6205B234)},
    {"clts01.shp", "", int32_t(0x00000000), int32_t(0xAABBAA42)},
    {"clues.tre", "", int32_t(0xB9FD8DF8), int32_t(0x00000000)},
    {"clues.trf", "", int32_t(0xB9FD8DF9), int32_t(0x00000000)},
    {"clues.trg", "", int32_t(0xB9FD8DFA), int32_t(0x00000000)},
    {"clues.tri", "", int32_t(0xB9FD8DFC), int32_t(0x00000000)},
    {"clues.trs", "", int32_t(0xB9FD8E06), int32_t(0x00000000)},
    {"cluetype.tre", "", int32_t(0xE54837E3), int32_t(0x00000000)},
    {"cluetype.trf", "", int32_t(0xE64837E3), int32_t(0x00000000)},
    {"cluetype.trg", "", int32_t(0xE74837E3), int32_t(0x00000000)},
    {"cluetype.tri", "", int32_t(0xE94837E3), int32_t(0x00000000)},
    {"cluetype.trs", "", int32_t(0xF34837E3), int32_t(0x00000000)},
    {"clukfgl.shp", "", int32_t(0x00000000), int32_t(0x0F3653A4)},
    {"clukfgl_a.shp", "", int32_t(0x00000000), int32_t(0x179CA79F)},
    {"clusfgl.shp", "", int32_t(0x00000000), int32_t(0x182EB3CD)},
    {"clusfgl_a.shp", "", int32_t(0x00000000), int32_t(0xF998D228)},
    {"clwa19_a.shp", "", int32_t(0x00000000), int32_t(0xE3500696)},
    {"clwa2a.shp", "", int32_t(0x00000000), int32_t(0x6DF7ACE0)},
    {"clwa2b.shp", "", int32_t(0x00000000), int32_t(0x5C1FB67D)},
    {"clwa2c.shp", "", int32_t(0x00000000), int32_t(0xFA68BDC9)},
    {"clwa2d.shp", "", int32_t(0x00000000), int32_t(0x3FCF8347)},
    {"clwash03.shp", "", int32_t(0x00000000), int32_t(0x413174EF)},
    {"clwash04.shp", "", int32_t(0x00000000), int32_t(0xF311A8FF)},
    {"clwash05.shp", "", int32_t(0x00000000), int32_t(0xCE71814F)},
    {"clwash06.shp", "", int32_t(0x00000000), int32_t(0x89D1FB9F)},
    {"clwash07.shp", "", int32_t(0x00000000), int32_t(0xB4B1D22F)},
    {"clwash08.shp", "", int32_t(0x00000000), int32_t(0x36E145FE)},
    {"clwash09.shp", "", int32_t(0x00000000), int32_t(0x0B816C4E)},
    {"clwash10.shp", "", int32_t(0x00000000), int32_t(0xCDCDDD9A)},
    {"clwash11.shp", "", int32_t(0x00000000), int32_t(0xF0ADF42A)},
    {"clwash13.shp", "", int32_t(0x00000000), int32_t(0x8A6DA74A)},
    {"clwash16.shp", "", int32_t(0x00000000), int32_t(0x428D283A)},
    {"clwash17.shp", "", int32_t(0x00000000), int32_t(0x7FED018A)},
    {"clwash18.shp", "", int32_t(0x00000000), int32_t(0xFDBD965B)},
    {"clwash19.shp", "", int32_t(0x00000000), int32_t(0xC0DDBFEB)},
    {"clwsh18a.shp", "", int32_t(0x00000000), int32_t(0xF467975F)},
    {"clwt01.shp", "", int32_t(0x00000000), int32_t(0x25ED7C88)},
    {"cmdcntr1.aud", "command centre under attack", int32_t(0xB40B1ED7), int32_t(0x00000000)},
    {"cmin.hva", "", int32_t(0x00000000), int32_t(0xFB263CF3)},
    {"cmin.vxl", "", int32_t(0x00000000), int32_t(0x0DACE3BA)},
    {"cmon.hva", "", int32_t(0x00000000), int32_t(0x2D7FDFEE)},
    {"cmon.vxl", "", int32_t(0x00000000), int32_t(0xDBF500A7)},
    {"cmon1.aud", "commando cmon", int32_t(0xE3BF91B3), int32_t(0x00000000)},
    {"cmptalk2.aud", "", int32_t(0xFA2D0EBD), int32_t(0x00000000)},
    {"cmptalk3.aud", "", int32_t(0xFC2D0EBD), int32_t(0x00000000)},
    {"cmptalk4.aud", "", int32_t(0xFE2D0EBD), int32_t(0x00000000)},
    {"cmptalk5.aud", "", int32_t(0x002D0EBD), int32_t(0x00000000)},
    {"cmptlk1.aud", "???", int32_t(0xADE820E6), int32_t(0x00000000)},
    {"cmptlk2.aud", "???", int32_t(0xADEA20E6), int32_t(0x00000000)},
    {"cmptlk3.aud", "???", int32_t(0xADEC20E6), int32_t(0x00000000)},
    {"cnairp.shp", "", int32_t(0x00000000), int32_t(0xB5B17157)},
    {"cnairp_a.shp", "", int32_t(0x00000000), int32_t(0x6A1E428E)},
    {"cnairp_f.shp", "", int32_t(0x00000000), int32_t(0xD83E9E9E)},
    {"cnarmy01.shp", "", int32_t(0x00000000), int32_t(0x74F8A536)},
    {"cnarmy02.shp", "", int32_t(0x00000000), int32_t(0x3358DFE6)},
    {"cnarmy03.shp", "", int32_t(0x00000000), int32_t(0x0E38F656)},
    {"cnarmy04.shp", "", int32_t(0x00000000), int32_t(0xBC182A46)},
    {"cnbarn02.shp", "", int32_t(0x00000000), int32_t(0x4AC09B96)},
    {"cnbarr01.shp", "", int32_t(0x00000000), int32_t(0xAD1E17FC)},
    {"cnbarr02.shp", "", int32_t(0x00000000), int32_t(0xEABE6D2C)},
    {"cnbhut.shp", "", int32_t(0x00000000), int32_t(0xB777F31D)},
    {"cnbunk01.shp", "", int32_t(0x00000000), int32_t(0x8560F9F8)},
    {"cnbunk02.shp", "", int32_t(0x00000000), int32_t(0xC2C08328)},
    {"cnbunk03.shp", "", int32_t(0x00000000), int32_t(0xFFA0AA98)},
    {"cnbunk04.shp", "", int32_t(0x00000000), int32_t(0x4D807688)},
    {"cnchig01.shp", "", int32_t(0x00000000), int32_t(0xFA48548D)},
    {"cnchig02.shp", "", int32_t(0x00000000), int32_t(0xBDE82E5D)},
    {"cnchig03.shp", "", int32_t(0x00000000), int32_t(0x808807ED)},
    {"cnchig05.shp", "", int32_t(0x00000000), int32_t(0x0FC8F24D)},
    {"cnchig05d.shp", "", int32_t(0x00000000), int32_t(0x83ECF223)},
    {"cncity01.shp", "", int32_t(0x00000000), int32_t(0x3D6C83A7)},
    {"cncity02.shp", "", int32_t(0x00000000), int32_t(0x7ACCF977)},
    {"cncity03.shp", "", int32_t(0x00000000), int32_t(0x47ACD0C7)},
    {"cncity04.shp", "", int32_t(0x00000000), int32_t(0xF58C0CD7)},
    {"cncolo01.shp", "", int32_t(0x00000000), int32_t(0xE5267947)},
    {"cncufgl.shp", "", int32_t(0x00000000), int32_t(0x19E88229)},
    {"cncufgl_a.shp", "", int32_t(0x00000000), int32_t(0x6F8BCBBE)},
    {"cneast01.shp", "", int32_t(0x00000000), int32_t(0xE0B83921)},
    {"cneast01dm.shp", "", int32_t(0x00000000), int32_t(0x098C37A5)},
    {"cneast02.shp", "", int32_t(0x00000000), int32_t(0xA71843F1)},
    {"cneur04.shp", "", int32_t(0x00000000), int32_t(0x22B9ACB6)},
    {"cneur1.shp", "", int32_t(0x00000000), int32_t(0xDB6F2719)},
    {"cneur2.shp", "", int32_t(0x00000000), int32_t(0xEA873D84)},
    {"cneuro05.shp", "", int32_t(0x00000000), int32_t(0x4D674436)},
    {"cnfarm01.shp", "", int32_t(0x00000000), int32_t(0x35635BA1)},
    {"cnfarm02.shp", "", int32_t(0x00000000), int32_t(0x72C32171)},
    {"cnfarm06.shp", "", int32_t(0x00000000), int32_t(0x874387B1)},
    {"cnfncb.shp", "", int32_t(0x00000000), int32_t(0x735CBBB5)},
    {"cnfncp.shp", "", int32_t(0x00000000), int32_t(0x831D3652)},
    {"cnfncw.shp", "", int32_t(0x00000000), int32_t(0x46BA08DC)},
    {"cnfrfgl.shp", "", int32_t(0x00000000), int32_t(0x9BA024A4)},
    {"cnfrfgl_a.shp", "", int32_t(0x00000000), int32_t(0x965BA38B)},
    {"cnfrma.shp", "", int32_t(0x00000000), int32_t(0x1DCA027F)},
    {"cnfrmb.shp", "", int32_t(0x00000000), int32_t(0x2C2218E2)},
    {"cngard01.shp", "", int32_t(0x00000000), int32_t(0x4F39754C)},
    {"cngard03.shp", "", int32_t(0x00000000), int32_t(0x35F9262C)},
    {"cngas01.shp", "", int32_t(0x00000000), int32_t(0x4B07FEDB)},
    {"cngefgl.shp", "", int32_t(0x00000000), int32_t(0xBCC36022)},
    {"cngefgl_a.shp", "", int32_t(0x00000000), int32_t(0xC220E27F)},
    {"cngrd1_a.shp", "", int32_t(0x00000000), int32_t(0xDE809198)},
    {"cnhosp.shp", "", int32_t(0x00000000), int32_t(0xF6142389)},
    {"cnhosp_a.shp", "", int32_t(0x00000000), int32_t(0x29BB1050)},
    {"cnhosp_f.shp", "", int32_t(0x00000000), int32_t(0x9B9BCC40)},
    {"cnhse01.shp", "", int32_t(0x00000000), int32_t(0x82EEF70D)},
    {"cnhse02.shp", "", int32_t(0x00000000), int32_t(0x047A85A3)},
    {"cnhse03.shp", "", int32_t(0x00000000), int32_t(0xCF265606)},
    {"cnhse04.shp", "", int32_t(0x00000000), int32_t(0xD22366BE)},
    {"cnhse05.shp", "", int32_t(0x00000000), int32_t(0x197FB51B)},
    {"cnhse06.shp", "", int32_t(0x00000000), int32_t(0x9FEBC7B5)},
    {"cnhse07.shp", "", int32_t(0x00000000), int32_t(0x54B71410)},
    {"cnind01.shp", "", int32_t(0x00000000), int32_t(0xFC09398B)},
    {"cnirfgl.shp", "", int32_t(0x00000000), int32_t(0x6AAB7F29)},
    {"cnirfgl_a.shp", "", int32_t(0x00000000), int32_t(0xC0CF177D)},
    {"cnkrmw.shp", "", int32_t(0x00000000), int32_t(0xEC3A203B)},
    {"cnla01.shp", "", int32_t(0x00000000), int32_t(0x4498B868)},
    {"cnla02.shp", "", int32_t(0x00000000), int32_t(0x7570A2F5)},
    {"cnla03.shp", "", int32_t(0x00000000), int32_t(0xD307A941)},
    {"cnla04.shp", "", int32_t(0x00000000), int32_t(0x16A097CF)},
    {"cnla05.shp", "", int32_t(0x00000000), int32_t(0xB0D79C7B)},
    {"cnla09.shp", "", int32_t(0x00000000), int32_t(0x7777F60F)},
    {"cnla10.shp", "", int32_t(0x00000000), int32_t(0x2E45B342)},
    {"cnla11.shp", "", int32_t(0x00000000), int32_t(0x8832B8F6)},
    {"cnla12.shp", "", int32_t(0x00000000), int32_t(0xB9DAA26B)},
    {"cnla13.shp", "", int32_t(0x00000000), int32_t(0x1FADA9DF)},
    {"cnla14.shp", "", int32_t(0x00000000), int32_t(0xDA0A9751)},
    {"cnla15.shp", "", int32_t(0x00000000), int32_t(0x7C7D9CE5)},
    {"cnlab.shp", "", int32_t(0x00000000), int32_t(0xF8C5E659)},
    {"cnlbfgl.shp", "", int32_t(0x00000000), int32_t(0x2042F61C)},
    {"cnlbfgl_a.shp", "", int32_t(0x00000000), int32_t(0xF06BDFCA)},
    {"cnlit01e.shp", "", int32_t(0x00000000), int32_t(0x154744B6)},
    {"cnlit01n.shp", "", int32_t(0x00000000), int32_t(0x629775A7)},
    {"cnlit01s.shp", "", int32_t(0x00000000), int32_t(0xFAE72694)},
    {"cnlit01w.shp", "", int32_t(0x00000000), int32_t(0x0F678054)},
    {"cnlit02l.shp", "", int32_t(0x00000000), int32_t(0x9EC35469)},
    {"cnlit02r.shp", "", int32_t(0x00000000), int32_t(0x41137D8A)},
    {"cnlit03e.shp", "", int32_t(0x00000000), int32_t(0x588FE5BD)},
    {"cnlit03n.shp", "", int32_t(0x00000000), int32_t(0x2F5FD4AC)},
    {"cnlit03s.shp", "", int32_t(0x00000000), int32_t(0xB72F879F)},
    {"cnlit03w.shp", "", int32_t(0x00000000), int32_t(0x42AF215F)},
    {"cnlond01.shp", "", int32_t(0x00000000), int32_t(0x540F714D)},
    {"cnlond02.shp", "", int32_t(0x00000000), int32_t(0x13AF0B9D)},
    {"cnlond04.shp", "", int32_t(0x00000000), int32_t(0x9CEFFE3D)},
    {"cnlond05.shp", "", int32_t(0x00000000), int32_t(0xA18FD78D)},
    {"cnmex01.shp", "", int32_t(0x00000000), int32_t(0x5CA32348)},
    {"cnmex02.shp", "", int32_t(0x00000000), int32_t(0xDA3751E6)},
    {"cnmex03.shp", "", int32_t(0x00000000), int32_t(0x116B8243)},
    {"cnmex04.shp", "", int32_t(0x00000000), int32_t(0x0C6EB2FB)},
    {"cnmex05.shp", "", int32_t(0x00000000), int32_t(0xC732615E)},
    {"cnmiam01.shp", "", int32_t(0x00000000), int32_t(0x846F3486)},
    {"cnmiam02.shp", "", int32_t(0x00000000), int32_t(0xC3CF4E56)},
    {"cnmiam03.shp", "", int32_t(0x00000000), int32_t(0xFEAF67E6)},
    {"cnmiam04.shp", "", int32_t(0x00000000), int32_t(0x4C8FBBF6)},
    {"cnmiam05.shp", "", int32_t(0x00000000), int32_t(0x71EF9246)},
    {"cnmiam06.shp", "", int32_t(0x00000000), int32_t(0x364FE896)},
    {"cnmiam07.shp", "", int32_t(0x00000000), int32_t(0x0B2FC126)},
    {"cnmiam08.shp", "", int32_t(0x00000000), int32_t(0x897F56F7)},
    {"cnmisc01.shp", "", int32_t(0x00000000), int32_t(0xEACE798D)},
    {"cnmisc02.shp", "", int32_t(0x00000000), int32_t(0xAD6E035D)},
    {"cnmisc03.shp", "", int32_t(0x00000000), int32_t(0x900E2AED)},
    {"cnmisc04.shp", "", int32_t(0x00000000), int32_t(0x222EF6FD)},
    {"cnmisc05.shp", "", int32_t(0x00000000), int32_t(0x1F4EDF4D)},
    {"cnmisc06.shp", "", int32_t(0x00000000), int32_t(0x58EEA59D)},
    {"cnmoon01.shp", "", int32_t(0x00000000), int32_t(0xD31745A3)},
    {"cnmov01.shp", "", int32_t(0x00000000), int32_t(0xDC07BBE4)},
    {"cnmov01_a.shp", "", int32_t(0x00000000), int32_t(0xF2FEFA66)},
    {"cnmov02.shp", "", int32_t(0x00000000), int32_t(0x5A93C94A)},
    {"cnmov02_a.shp", "", int32_t(0x00000000), int32_t(0x19C94165)},
    {"cnmsc01.shp", "", int32_t(0x00000000), int32_t(0xA2A835CE)},
    {"cnmsc02.shp", "", int32_t(0x00000000), int32_t(0x243C4760)},
    {"cnmsc03.shp", "", int32_t(0x00000000), int32_t(0xEF6094C5)},
    {"cnmsc04.shp", "", int32_t(0x00000000), int32_t(0xF265A47D)},
    {"cnmsc05.shp", "", int32_t(0x00000000), int32_t(0x393977D8)},
    {"cnmsc06.shp", "", int32_t(0x00000000), int32_t(0xBFAD0576)},
    {"cnmsc06a.shp", "", int32_t(0x00000000), int32_t(0x5D90492D)},
    {"cnmsc07.shp", "", int32_t(0x00000000), int32_t(0x74F1D6D3)},
    {"cnmsc08.shp", "", int32_t(0x00000000), int32_t(0x85A76406)},
    {"cnmsc09.shp", "", int32_t(0x00000000), int32_t(0x4EFBB7A3)},
    {"cnmsc10.shp", "", int32_t(0x00000000), int32_t(0xCF83EDDF)},
    {"cnmsc11.shp", "", int32_t(0x00000000), int32_t(0x04DF3E7A)},
    {"cnmsc12.shp", "", int32_t(0x00000000), int32_t(0x824B4CD4)},
    {"cnmsc13.shp", "", int32_t(0x00000000), int32_t(0x49179F71)},
    {"cnnewy01.shp", "", int32_t(0x00000000), int32_t(0xA029FCE0)},
    {"cnnewy04.shp", "", int32_t(0x00000000), int32_t(0x68C97390)},
    {"cnnewy05.shp", "", int32_t(0x00000000), int32_t(0x55A95A20)},
    {"cnnewy06.shp", "", int32_t(0x00000000), int32_t(0x120920F0)},
    {"cnnewy07.shp", "", int32_t(0x00000000), int32_t(0x2F690940)},
    {"cnnewy08.shp", "", int32_t(0x00000000), int32_t(0xAD399E91)},
    {"cnnewy10.shp", "", int32_t(0x00000000), int32_t(0x561506F5)},
    {"cnnewy11.shp", "", int32_t(0x00000000), int32_t(0x6B752F45)},
    {"cnnewy12.shp", "", int32_t(0x00000000), int32_t(0x2CD55595)},
    {"cnnewy13.shp", "", int32_t(0x00000000), int32_t(0x11B57C25)},
    {"cnnewy14.shp", "", int32_t(0x00000000), int32_t(0xA395A035)},
    {"cnnewy15.shp", "", int32_t(0x00000000), int32_t(0x9EF58985)},
    {"cnnewy16.shp", "", int32_t(0x00000000), int32_t(0xD955F355)},
    {"cnnewy17.shp", "", int32_t(0x00000000), int32_t(0xE435DAE5)},
    {"cnnewy18.shp", "", int32_t(0x00000000), int32_t(0x66654D34)},
    {"cnnewy20.shp", "", int32_t(0x00000000), int32_t(0xD081745B)},
    {"cnnewy21.shp", "", int32_t(0x00000000), int32_t(0xEDE15DEB)},
    {"cnnkfgl.shp", "", int32_t(0x00000000), int32_t(0x8814907A)},
    {"cnnkfgl_a.shp", "", int32_t(0x00000000), int32_t(0x9690118F)},
    {"cnnwy05.shp", "", int32_t(0x00000000), int32_t(0x6299B034)},
    {"cnnwy09.shp", "", int32_t(0x00000000), int32_t(0x155B704F)},
    {"cnnwy22.shp", "", int32_t(0x00000000), int32_t(0xE80391A5)},
    {"cnnwy23.shp", "", int32_t(0x00000000), int32_t(0x235F4200)},
    {"cnnwy24.shp", "", int32_t(0x00000000), int32_t(0x3E5A72B8)},
    {"cnnwy25.shp", "", int32_t(0x00000000), int32_t(0xF506A11D)},
    {"cnnwy26.shp", "", int32_t(0x00000000), int32_t(0x7392D3B3)},
    {"cnny04dm.shp", "", int32_t(0x00000000), int32_t(0x76038B1B)},
    {"cnoild.shp", "", int32_t(0x00000000), int32_t(0x51D8DA20)},
    {"cnoild_a.shp", "", int32_t(0x00000000), int32_t(0x8E77E9F9)},
    {"cnoild_f.shp", "", int32_t(0x00000000), int32_t(0x3C5735E9)},
    {"cnoutp.shp", "", int32_t(0x00000000), int32_t(0x27E3F906)},
    {"cnoutp_a.shp", "", int32_t(0x00000000), int32_t(0xF84CCADF)},
    {"cnoutp_b.shp", "", int32_t(0x00000000), int32_t(0xBFECB00F)},
    {"cnoutp_c.shp", "", int32_t(0x00000000), int32_t(0x828C99BF)},
    {"cnoutp_d.shp", "", int32_t(0x00000000), int32_t(0x30AC45AF)},
    {"cnoutp_f.shp", "", int32_t(0x00000000), int32_t(0x4A6C16CF)},
    {"cnoutpbb.shp", "", int32_t(0x00000000), int32_t(0x00A4A14A)},
    {"cnpark03.shp", "", int32_t(0x00000000), int32_t(0x06C3CC54)},
    {"cnpars02.shp", "", int32_t(0x00000000), int32_t(0x6F92374D)},
    {"cnpars04.shp", "", int32_t(0x00000000), int32_t(0xE0D2C2ED)},
    {"cnpars05.shp", "", int32_t(0x00000000), int32_t(0xDDB2EB5D)},
    {"cnpars06.shp", "", int32_t(0x00000000), int32_t(0x9A12918D)},
    {"cnpars07.shp", "", int32_t(0x00000000), int32_t(0xA772B83D)},
    {"cnpars08.shp", "", int32_t(0x00000000), int32_t(0x25222FEC)},
    {"cnpars09.shp", "", int32_t(0x00000000), int32_t(0x1842065C)},
    {"cnpars10.shp", "", int32_t(0x00000000), int32_t(0xDE0EB788)},
    {"cnpars12.shp", "", int32_t(0x00000000), int32_t(0xA4CEE4E8)},
    {"cnpars12d.shp", "", int32_t(0x00000000), int32_t(0xF6AC1930)},
    {"cnpars13.shp", "", int32_t(0x00000000), int32_t(0x99AECD58)},
    {"cnpars14.shp", "", int32_t(0x00000000), int32_t(0x2B8E1148)},
    {"cnpol01e.shp", "", int32_t(0x00000000), int32_t(0xF49176C4)},
    {"cnpol01n.shp", "", int32_t(0x00000000), int32_t(0x834147D5)},
    {"cnpol01s.shp", "", int32_t(0x00000000), int32_t(0x1B3114E6)},
    {"cnpol01w.shp", "", int32_t(0x00000000), int32_t(0xEEB1B226)},
    {"cnpowr.shp", "", int32_t(0x00000000), int32_t(0xD1B8FD46)},
    {"cnprs03.shp", "", int32_t(0x00000000), int32_t(0x56F0BBF5)},
    {"cnrufgl.shp", "", int32_t(0x00000000), int32_t(0xD18468FF)},
    {"cnrufgl_a.shp", "", int32_t(0x00000000), int32_t(0x943616A4)},
    {"cnrus02a.shp", "", int32_t(0x00000000), int32_t(0x1F0599FF)},
    {"cnrus02b.shp", "", int32_t(0x00000000), int32_t(0x58A5E32F)},
    {"cnrus02c.shp", "", int32_t(0x00000000), int32_t(0x65C5CA9F)},
    {"cnrus02d.shp", "", int32_t(0x00000000), int32_t(0xD7E5168F)},
    {"cnrus02e.shp", "", int32_t(0x00000000), int32_t(0xEA853F3F)},
    {"cnrus02f.shp", "", int32_t(0x00000000), int32_t(0xAD2545EF)},
    {"cnrus02g.shp", "", int32_t(0x00000000), int32_t(0x90456C5F)},
    {"cnrus03.shp", "", int32_t(0x00000000), int32_t(0x36640601)},
    {"cnrus04.shp", "", int32_t(0x00000000), int32_t(0x2B6136B9)},
    {"cnrus05.shp", "", int32_t(0x00000000), int32_t(0xE03DE51C)},
    {"cnrus06.shp", "", int32_t(0x00000000), int32_t(0x66A997B2)},
    {"cnrus07.shp", "", int32_t(0x00000000), int32_t(0xADF54417)},
    {"cnrus08.shp", "", int32_t(0x00000000), int32_t(0x5CA3F6C2)},
    {"cnrus09.shp", "", int32_t(0x00000000), int32_t(0x97FF2567)},
    {"cnrus10.shp", "", int32_t(0x00000000), int32_t(0x16877F1B)},
    {"cnrus11.shp", "", int32_t(0x00000000), int32_t(0xDDDBACBE)},
    {"cnsanf01.shp", "", int32_t(0x00000000), int32_t(0xDDF76193)},
    {"cnsanf02.shp", "", int32_t(0x00000000), int32_t(0x9A571B43)},
    {"cnsanf03.shp", "", int32_t(0x00000000), int32_t(0xA73732F3)},
    {"cnsanf05.shp", "", int32_t(0x00000000), int32_t(0x2877C753)},
    {"cnsanf06.shp", "", int32_t(0x00000000), int32_t(0x6FD7BD83)},
    {"cnsanf07.shp", "", int32_t(0x00000000), int32_t(0x52B79433)},
    {"cnsanf08.shp", "", int32_t(0x00000000), int32_t(0xD0E703E2)},
    {"cnsanf09.shp", "", int32_t(0x00000000), int32_t(0xED872A52)},
    {"cnsanf15.shp", "", int32_t(0x00000000), int32_t(0xE32B14F6)},
    {"cnsanf16.shp", "", int32_t(0x00000000), int32_t(0xA48B6E26)},
    {"cnsanf17.shp", "", int32_t(0x00000000), int32_t(0x99EB4796)},
    {"cnsanf18.shp", "", int32_t(0x00000000), int32_t(0x1BBBD047)},
    {"cnseat01.shp", "", int32_t(0x00000000), int32_t(0xA97AAFD4)},
    {"cnseat02.shp", "", int32_t(0x00000000), int32_t(0xEEDAD504)},
    {"cnseat02_a.shp", "", int32_t(0x00000000), int32_t(0x689A2246)},
    {"cnsin03e.shp", "", int32_t(0x00000000), int32_t(0x6351123B)},
    {"cnsin03s.shp", "", int32_t(0x00000000), int32_t(0x8CF17019)},
    {"cnskfgl.shp", "", int32_t(0x00000000), int32_t(0x5A449A22)},
    {"cnskfgl_a.shp", "", int32_t(0x00000000), int32_t(0x47D85DB8)},
    {"cnsticon.shp", "", int32_t(0x00000000), int32_t(0xE2AB8819)},
    {"cnstl01.shp", "", int32_t(0x00000000), int32_t(0x268EFBF0)},
    {"cnstl02.shp", "", int32_t(0x00000000), int32_t(0xA01A895E)},
    {"cnstl03.shp", "", int32_t(0x00000000), int32_t(0x6B465AFB)},
    {"cnstl05a.shp", "", int32_t(0x00000000), int32_t(0x5F22F5BD)},
    {"cnstl05b.shp", "", int32_t(0x00000000), int32_t(0x18828F6D)},
    {"cnstl05c.shp", "", int32_t(0x00000000), int32_t(0x25E2A6DD)},
    {"cnstl05d.shp", "", int32_t(0x00000000), int32_t(0x97C27ACD)},
    {"cnstl05e.shp", "", int32_t(0x00000000), int32_t(0xAAA2537D)},
    {"cnstl05f.shp", "", int32_t(0x00000000), int32_t(0xED0229AD)},
    {"cnstl05g.shp", "", int32_t(0x00000000), int32_t(0xD062001D)},
    {"cnstl05h.shp", "", int32_t(0x00000000), int32_t(0x523297CC)},
    {"cnstrt01.shp", "", int32_t(0x00000000), int32_t(0xE0F5CF2E)},
    {"cnstrt05.shp", "", int32_t(0x00000000), int32_t(0x157569EE)},
    {"cnswst01.shp", "", int32_t(0x00000000), int32_t(0x15D2F375)},
    {"cnsydn01.shp", "", int32_t(0x00000000), int32_t(0x68C0D355)},
    {"cnsydn02.shp", "", int32_t(0x00000000), int32_t(0x2F60A985)},
    {"cnsydn03.shp", "", int32_t(0x00000000), int32_t(0x12008035)},
    {"cntech01.shp", "", int32_t(0x00000000), int32_t(0xA9FD456A)},
    {"cntexs01.shp", "", int32_t(0x00000000), int32_t(0xEDF5A023)},
    {"cntexs02.shp", "", int32_t(0x00000000), int32_t(0xAA55DAF3)},
    {"cntexs03.shp", "", int32_t(0x00000000), int32_t(0x9735F343)},
    {"cntexs04.shp", "", int32_t(0x00000000), int32_t(0x25152F53)},
    {"cntexs05.shp", "", int32_t(0x00000000), int32_t(0x187506E3)},
    {"cntexs06.shp", "", int32_t(0x00000000), int32_t(0x5FD57C33)},
    {"cntexs07.shp", "", int32_t(0x00000000), int32_t(0x62B55583)},
    {"cntexs08.shp", "", int32_t(0x00000000), int32_t(0xE0E5C252)},
    {"cnthosp.shp", "", int32_t(0x00000000), int32_t(0x79DFDC88)},
    {"cntlded1.aud", "control centre deactivated", int32_t(0xD82F04C3), int32_t(0x00000000)},
    {"cntr03dm.shp", "", int32_t(0x00000000), int32_t(0x017D3A69)},
    {"cntran01.shp", "", int32_t(0x00000000), int32_t(0x40A95895)},
    {"cntran02.shp", "", int32_t(0x00000000), int32_t(0x07092245)},
    {"cntran03.shp", "", int32_t(0x00000000), int32_t(0x3A690BF5)},
    {"cnts01.shp", "", int32_t(0x00000000), int32_t(0xF2D71383)},
    {"cnukfgl.shp", "", int32_t(0x00000000), int32_t(0x575AEA65)},
    {"cnukfgl_a.shp", "", int32_t(0x00000000), int32_t(0xBF1A160E)},
    {"cnurb01.shp", "", int32_t(0x00000000), int32_t(0x4D00E00F)},
    {"cnurb02.shp", "", int32_t(0x00000000), int32_t(0xCB9492A1)},
    {"cnusfgl.shp", "", int32_t(0x00000000), int32_t(0x40420A0C)},
    {"cnusfgl_a.shp", "", int32_t(0x00000000), int32_t(0x511E63B9)},
    {"cnwa19_a.shp", "", int32_t(0x00000000), int32_t(0xBB3CBF57)},
    {"cnwa2a.shp", "", int32_t(0x00000000), int32_t(0x359B1521)},
    {"cnwa2b.shp", "", int32_t(0x00000000), int32_t(0x04730FBC)},
    {"cnwa2c.shp", "", int32_t(0x00000000), int32_t(0xA2040408)},
    {"cnwa2d.shp", "", int32_t(0x00000000), int32_t(0x67A33A86)},
    {"cnwash01.shp", "", int32_t(0x00000000), int32_t(0x639D9E4E)},
    {"cnwash03.shp", "", int32_t(0x00000000), int32_t(0x195DCD2E)},
    {"cnwash04.shp", "", int32_t(0x00000000), int32_t(0xAB7D113E)},
    {"cnwash05.shp", "", int32_t(0x00000000), int32_t(0x961D388E)},
    {"cnwash06.shp", "", int32_t(0x00000000), int32_t(0xD1BD425E)},
    {"cnwash07.shp", "", int32_t(0x00000000), int32_t(0xECDD6BEE)},
    {"cnwash08.shp", "", int32_t(0x00000000), int32_t(0x6E8DFC3F)},
    {"cnwash09.shp", "", int32_t(0x00000000), int32_t(0x53EDD58F)},
    {"cnwash10.shp", "", int32_t(0x00000000), int32_t(0x95A1645B)},
    {"cnwash11.shp", "", int32_t(0x00000000), int32_t(0xA8C14DEB)},
    {"cnwash13.shp", "", int32_t(0x00000000), int32_t(0xD2011E8B)},
    {"cnwash14.shp", "", int32_t(0x00000000), int32_t(0x6021C29B)},
    {"cnwash15.shp", "", int32_t(0x00000000), int32_t(0x5D41EB2B)},
    {"cnwash16.shp", "", int32_t(0x00000000), int32_t(0x1AE191FB)},
    {"cnwash17.shp", "", int32_t(0x00000000), int32_t(0x2781B84B)},
    {"cnwash18.shp", "", int32_t(0x00000000), int32_t(0xA5D12F9A)},
    {"cnwash19.shp", "", int32_t(0x00000000), int32_t(0x98B1062A)},
    {"cnwsh12.shp", "", int32_t(0x00000000), int32_t(0xEFAD41A3)},
    {"cnwsh18a.shp", "", int32_t(0x00000000), int32_t(0xAC0B2E9E)},
    {"cnwt01.shp", "", int32_t(0x00000000), int32_t(0x7D81C549)},
    {"coinin1.aud", "", int32_t(0x95CC2EE0), int32_t(0x00000000)},
    {"coinin2.aud", "", int32_t(0x95CE2EE0), int32_t(0x00000000)},
    {"coinin3.aud", "", int32_t(0x95D02EE0), int32_t(0x00000000)},
    {"coinout1.aud", "", int32_t(0xE02328D9), int32_t(0x00000000)},
    {"coinout2.aud", "", int32_t(0xE22328D9), int32_t(0x00000000)},
    {"coinout3.aud", "", int32_t(0xE42328D9), int32_t(0x00000000)},
    {"coinout4.aud", "", int32_t(0xE62328D9), int32_t(0x00000000)},
    {"coinout5.aud", "", int32_t(0xE82328D9), int32_t(0x00000000)},
    {"coinout6.aud", "", int32_t(0xEA2328D9), int32_t(0x00000000)},
    {"coinout7.aud", "", int32_t(0xEC2328D9), int32_t(0x00000000)},
    {"colonel.pcx", "", int32_t(0x00000000), int32_t(0x82C00E10)},
    {"colony.aud", "", int32_t(0xBF8E33FE), int32_t(0x00000000)},
    {"comchief.pcx", "", int32_t(0x00000000), int32_t(0xC4BB11ED)},
    {"comcntr1.aud", "communications center", int32_t(0xB42F26D7), int32_t(0x00000000)},
    {"comcntr1.juv", "communications center", int32_t(0xC62F2FD7), int32_t(0x00000000)},
    {"comedy.aud", "", int32_t(0x979233EA), int32_t(0x00000000)},
    {"commup1.aud", "communications center goes online", int32_t(0x00000000), int32_t(0xF6067FC6)},
    {"comndof1.aud", "commando freed", int32_t(0xE0171CC3), int32_t(0x00000000)},
    {"comndor1.aud", "commando rescued", int32_t(0xE02F1CC3), int32_t(0x00000000)},
    {"compas.shp", "", int32_t(0xE79233D7), int32_t(0x00000000)},
    {"compass.shp", "-", int32_t(0x00000000), int32_t(0xE7EC299F)},
    {"compbed1.aud", "", int32_t(0xE81308BF), int32_t(0x00000000)},
    {"compdwn4.aud", "", int32_t(0xEE272CC3), int32_t(0x00000000)},
    {"compon1.aud", "", int32_t(0x9DDC2EEC), int32_t(0x00000000)},
    {"compy1.aud", "", int32_t(0xC391E414), int32_t(0x00000000)},
    {"compy11.aud", "", int32_t(0x9DDBF500), int32_t(0x00000000)},
    {"compy12.aud", "", int32_t(0x9DDDF500), int32_t(0x00000000)},
    {"compy13.aud", "", int32_t(0x9DDFF500), int32_t(0x00000000)},
    {"compy14.aud", "", int32_t(0x9DE1F500), int32_t(0x00000000)},
    {"compy15.aud", "", int32_t(0x9DE3F500), int32_t(0x00000000)},
    {"compy16.aud", "", int32_t(0x9DE5F500), int32_t(0x00000000)},
    {"compy17.aud", "", int32_t(0x9DE7F500), int32_t(0x00000000)},
    {"compy18.aud", "", int32_t(0x9DE9F500), int32_t(0x00000000)},
    {"compy19.aud", "", int32_t(0x9DEBF500), int32_t(0x00000000)},
    {"compy2.aud", "", int32_t(0xC391E614), int32_t(0x00000000)},
    {"compy20.aud", "", int32_t(0x9DD9F700), int32_t(0x00000000)},
    {"compy21.aud", "", int32_t(0x9DDBF700), int32_t(0x00000000)},
    {"compy22.aud", "", int32_t(0x9DDDF700), int32_t(0x00000000)},
    {"compy24.aud", "", int32_t(0x9DE1F700), int32_t(0x00000000)},
    {"compy25.aud", "", int32_t(0x9DE3F700), int32_t(0x00000000)},
    {"compy26.aud", "", int32_t(0x9DE5F700), int32_t(0x00000000)},
    {"compy27.aud", "", int32_t(0x9DE7F700), int32_t(0x00000000)},
    {"compy28.aud", "", int32_t(0x9DE9F700), int32_t(0x00000000)},
    {"compy29.aud", "", int32_t(0x9DEBF700), int32_t(0x00000000)},
    {"compy3.aud", "", int32_t(0xC391E814), int32_t(0x00000000)},
    {"compy30.aud", "", int32_t(0x9DD9F900), int32_t(0x00000000)},
    {"compy31.aud", "", int32_t(0x9DDBF900), int32_t(0x00000000)},
    {"compy4.aud", "", int32_t(0xC391EA14), int32_t(0x00000000)},
    {"compy5.aud", "", int32_t(0xC391EC14), int32_t(0x00000000)},
    {"compy6.aud", "", int32_t(0xC391EE14), int32_t(0x00000000)},
    {"compy7.aud", "", int32_t(0xC391F014), int32_t(0x00000000)},
    {"compy8.aud", "", int32_t(0xC391F214), int32_t(0x00000000)},
    {"compy9.aud", "", int32_t(0xC391F414), int32_t(0x00000000)},
    {"cona.hva", "", int32_t(0x00000000), int32_t(0xF3EC8AB3)},
    {"cona.vxl", "", int32_t(0x00000000), int32_t(0x056655FA)},
    {"conc.shp", "concrete tiles", int32_t(0xD6E4F1B4), int32_t(0x00000000)},
    {"conqmd.mix", "", int32_t(0x00000000), int32_t(0xBA5EA181)},
    {"conquer.eng", "english ingame strings", int32_t(0xA22515FC), int32_t(0x00000000)},
    {"conquer.inf", "inf: list for conquer.mix", int32_t(0xA2241600), int32_t(0x00000000)},
    {"conquer.mix", "conquer.mix", int32_t(0xA2361104), int32_t(0x55DE03CC)},
    {"cons.shp", "", int32_t(0x00000000), int32_t(0x474E1DED)},
    {"conscmp1.aud", "construction complete", int32_t(0xF42F18C1), int32_t(0x00000000)},
    {"constru1.aud", "construction complete", int32_t(0xF43922E3), int32_t(0x00000000)},
    {"constru2.aud", "build sounds", int32_t(0xF63922E3), int32_t(0x00000000)},
    {"constru2.juv", "build sounds", int32_t(0x08392BE3), int32_t(0x00000000)},
    {"consyard.vqa", "construction yard unfolding", int32_t(0x172F15ED), int32_t(0x00000000)},
    {"consyard.vqp", "construction yard unfolding", int32_t(0x262F15ED), int32_t(0x00000000)},
    {"convlst1.aud", "convoy unit lost", int32_t(0x003724D3), int32_t(0x00000000)},
    {"convyap1.aud", "convoy approaching", int32_t(0x002F00ED), int32_t(0x00000000)},
    {"coolswng.aud", "", int32_t(0x042F2CE1), int32_t(0x00000000)},
    {"coopcamp.ini", "", int32_t(0x00000000), int32_t(0xF49CCB5A)},
    {"coopcampmd.ini", "", int32_t(0x00000000), int32_t(0xEFBFE4FE)},
    {"cooperat.pcx", "", int32_t(0x00000000), int32_t(0x2A6EE475)},
    {"cop.hva", "", int32_t(0x00000000), int32_t(0x44F68B4B)},
    {"cop.vxl", "", int32_t(0x00000000), int32_t(0x4B00F8A0)},
    {"core.shp", "-", int32_t(0x00000000), int32_t(0xDCFABD2F)},
    {"core_a.shp", "-", int32_t(0x00000000), int32_t(0x043EE5C3)},
    {"core_b.shp", "-", int32_t(0x00000000), int32_t(0x35D6FF5E)},
    {"core_c.shp", "-", int32_t(0x00000000), int32_t(0x93A1F4EA)},
    {"corefir1.aud", "core defender fire", int32_t(0x00000000), int32_t(0x34D28E13)},
    {"coremk.shp", "-", int32_t(0x00000000), int32_t(0x9ED08CDB)},
    {"coreup1.aud", "core defender up", int32_t(0x00000000), int32_t(0x9B7B07BB)},
    {"corporal.pcx", "", int32_t(0x00000000), int32_t(0x396E2EA6)},
    {"corpse1.aud", "", int32_t(0x9DF01CF4), int32_t(0x00000000)},
    {"corpse1.sno", "misc: soldier death #1", int32_t(0x9DFB1606), int32_t(0x00000000)},
    {"corpse1.tem", "misc: soldier death #1", int32_t(0x9DF90D07), int32_t(0x00000000)},
    {"corpse2.sno", "misc: soldier death #2", int32_t(0x9DFD1606), int32_t(0x00000000)},
    {"corpse2.tem", "misc: soldier death #2", int32_t(0x9DFB0D07), int32_t(0x00000000)},
    {"corpse3.sno", "misc: soldier death #3", int32_t(0x9DFF1606), int32_t(0x00000000)},
    {"corpse3.tem", "misc: soldier death #3", int32_t(0x9DFD0D07), int32_t(0x00000000)},
    {"couch1.vqa", "", int32_t(0xB9B1E0EE), int32_t(0x00000000)},
    {"countdwn.vqa", "meltedown imminent", int32_t(0x17551BE3), int32_t(0x00000000)},
    {"countdwn.vqp", "vqp: meltedown imminent", int32_t(0x26551BE3), int32_t(0x00000000)},
    {"counter1.aud", "counter", int32_t(0xE04F08E3), int32_t(0x00000000)},
    {"country1.aud", "country sound 1", int32_t(0xE05D22E3), int32_t(0x00000000)},
    {"country4.aud", "country sound 2", int32_t(0xE65D22E3), int32_t(0x00000000)},
    {"countrya.shp", "map of each african country", int32_t(0x0C5034E3), int32_t(0x00000000)},
    {"countrye.shp", "map of each european country", int32_t(0x145034E3), int32_t(0x00000000)},
    {"coup.vqa", "-", int32_t(0x00000000), int32_t(0x9E84DE64)},
    {"cow.shp", "", int32_t(0x00000000), int32_t(0x9B8AC607)},
    {"cow1.aud", "", int32_t(0xA703DFB4), int32_t(0x00000000)},
    {"cow2.aud", "", int32_t(0xA903DFB4), int32_t(0x00000000)},
    {"cplane.hva", "", int32_t(0x00000000), int32_t(0x59F85224)},
    {"cplane.vxl", "", int32_t(0x00000000), int32_t(0x8997B2A0)},
    {"cr1.des", "crater 1", int32_t(0x5CB5E9CA), int32_t(0x00000000)},
    {"cr1.sno", "misc: crater", int32_t(0x5CB1F2D9), int32_t(0x00000000)},
    {"cr1.tem", "crater 1", int32_t(0x5CAFE9DA), int32_t(0x00000000)},
    {"cr1.win", "crater 1", int32_t(0x5CB0EDDD), int32_t(0x00000000)},
    {"cr2.des", "crater 2", int32_t(0x5CB7E9CA), int32_t(0x00000000)},
    {"cr2.sno", "misc: crater", int32_t(0x5CB3F2D9), int32_t(0x00000000)},
    {"cr2.tem", "crater 2", int32_t(0x5CB1E9DA), int32_t(0x00000000)},
    {"cr2.win", "crater 2", int32_t(0x5CB2EDDD), int32_t(0x00000000)},
    {"cr3.des", "crater 3", int32_t(0x5CB9E9CA), int32_t(0x00000000)},
    {"cr3.sno", "misc: crater", int32_t(0x5CB5F2D9), int32_t(0x00000000)},
    {"cr3.tem", "crater 3", int32_t(0x5CB3E9DA), int32_t(0x00000000)},
    {"cr3.win", "crater 3", int32_t(0x5CB4EDDD), int32_t(0x00000000)},
    {"cr4.des", "crater 4", int32_t(0x5CBBE9CA), int32_t(0x00000000)},
    {"cr4.sno", "misc: crater", int32_t(0x5CB7F2D9), int32_t(0x00000000)},
    {"cr4.tem", "crater 4", int32_t(0x5CB5E9DA), int32_t(0x00000000)},
    {"cr4.win", "crater 4", int32_t(0x5CB6EDDD), int32_t(0x00000000)},
    {"cr5.des", "crater 5", int32_t(0x5CBDE9CA), int32_t(0x00000000)},
    {"cr5.sno", "misc: crater", int32_t(0x5CB9F2D9), int32_t(0x00000000)},
    {"cr5.tem", "crater 5", int32_t(0x5CB7E9DA), int32_t(0x00000000)},
    {"cr5.win", "crater 5", int32_t(0x5CB8EDDD), int32_t(0x00000000)},
    {"cr6.des", "crater 6", int32_t(0x5CBFE9CA), int32_t(0x00000000)},
    {"cr6.sno", "misc: crater", int32_t(0x5CBBF2D9), int32_t(0x00000000)},
    {"cr6.tem", "crater 6", int32_t(0x5CB9E9DA), int32_t(0x00000000)},
    {"cr6.win", "crater 6", int32_t(0x5CBAEDDD), int32_t(0x00000000)},
    {"crakwal1.aud", "", int32_t(0xD3F30CE9), int32_t(0x00000000)},
    {"crakwal2.aud", "", int32_t(0xD5F30CE9), int32_t(0x00000000)},
    {"crarmor.aud", "", int32_t(0xA5EE3CE8), int32_t(0x00000000)},
    {"crash01.tem", "-", int32_t(0x00000000), int32_t(0x2B7158EC)},
    {"crash02.tem", "-", int32_t(0x00000000), int32_t(0xADE52A42)},
    {"crash03.tem", "-", int32_t(0x00000000), int32_t(0x66B9F9E7)},
    {"crash04.tem", "-", int32_t(0x00000000), int32_t(0x7BBCC95F)},
    {"crash05.tem", "-", int32_t(0x00000000), int32_t(0xB0E01AFA)},
    {"crash06.tem", "-", int32_t(0x00000000), int32_t(0x36746854)},
    {"crash07.tem", "-", int32_t(0x00000000), int32_t(0xFD28BBF1)},
    {"crat01.shp", "-", int32_t(0x00000000), int32_t(0xF3DD62EA)},
    {"crat02.shp", "-", int32_t(0x00000000), int32_t(0xC2357877)},
    {"crat03.shp", "-", int32_t(0x00000000), int32_t(0x644273C3)},
    {"crat04.shp", "-", int32_t(0x00000000), int32_t(0xA1E54D4D)},
    {"crat0a.shp", "-", int32_t(0x00000000), int32_t(0x1FB5B2C1)},
    {"crat0b.shp", "-", int32_t(0x00000000), int32_t(0x2E5DA85C)},
    {"crat0c.shp", "-", int32_t(0x00000000), int32_t(0x882AA3E8)},
    {"crate.des", "", int32_t(0x00000000), int32_t(0x03976EC7)},
    {"crate.lun", "", int32_t(0x00000000), int32_t(0xB13DF4AF)},
    {"crate.sno", "-", int32_t(0x00000000), int32_t(0x822D84C0)},
    {"crate.tem", "-", int32_t(0x00000000), int32_t(0x9EC94E4C)},
    {"crate.ubn", "", int32_t(0x00000000), int32_t(0x4724EC6E)},
    {"crate.urb", "", int32_t(0x00000000), int32_t(0xC811C773)},
    {"crate4.aud", "", int32_t(0xD361F5EC), int32_t(0x00000000)},
    {"crate4.juv", "", int32_t(0xE56207EC), int32_t(0x00000000)},
    {"crater01.des", "", int32_t(0x00000000), int32_t(0x47225FFD)},
    {"crater01.lun", "", int32_t(0x00000000), int32_t(0x60F570CD)},
    {"crater01.sno", "-", int32_t(0x00000000), int32_t(0xA9BE6F8C)},
    {"crater01.tem", "-", int32_t(0x00000000), int32_t(0xA10BC1EE)},
    {"crater01.ubn", "", int32_t(0x00000000), int32_t(0x76816CA4)},
    {"crater01.urb", "", int32_t(0x00000000), int32_t(0x35F532DE)},
    {"crater02.des", "", int32_t(0x00000000), int32_t(0x0082252D)},
    {"crater02.lun", "", int32_t(0x00000000), int32_t(0x27550A1D)},
    {"crater02.sno", "-", int32_t(0x00000000), int32_t(0xEE1E155C)},
    {"crater02.tem", "-", int32_t(0x00000000), int32_t(0xE6ABBB3E)},
    {"crater02.ubn", "", int32_t(0x00000000), int32_t(0x31211674)},
    {"crater02.urb", "", int32_t(0x00000000), int32_t(0x7255480E)},
    {"crater03.des", "", int32_t(0x00000000), int32_t(0x3DE20C9D)},
    {"crater03.lun", "", int32_t(0x00000000), int32_t(0x1A3523AD)},
    {"crater03.sno", "-", int32_t(0x00000000), int32_t(0xD37E3CEC)},
    {"crater03.tem", "-", int32_t(0x00000000), int32_t(0xDBCB928E)},
    {"crater03.ubn", "", int32_t(0x00000000), int32_t(0x0C413FC4)},
    {"crater03.urb", "", int32_t(0x00000000), int32_t(0x4F3561BE)},
    {"crater04.des", "", int32_t(0x00000000), int32_t(0x8FC2D08D)},
    {"crater04.lun", "", int32_t(0x00000000), int32_t(0xA815FFBD)},
    {"crater04.sno", "-", int32_t(0x00000000), int32_t(0x615EE0FC)},
    {"crater04.tem", "-", int32_t(0x00000000), int32_t(0x69EB4E9E)},
    {"crater04.ubn", "", int32_t(0x00000000), int32_t(0xBE61E3D4)},
    {"crater04.urb", "", int32_t(0x00000000), int32_t(0xFD15BDAE)},
    {"crater05.des", "", int32_t(0x00000000), int32_t(0xB2A2F93D)},
    {"crater05.lun", "", int32_t(0x00000000), int32_t(0x9575D60D)},
    {"crater05.sno", "-", int32_t(0x00000000), int32_t(0x5C3EC94C)},
    {"crater05.tem", "-", int32_t(0x00000000), int32_t(0x548B672E)},
    {"crater05.ubn", "", int32_t(0x00000000), int32_t(0x8301CA64)},
    {"crater05.urb", "", int32_t(0x00000000), int32_t(0xC075941E)},
    {"crater06.des", "", int32_t(0x00000000), int32_t(0xF50283ED)},
    {"crater06.lun", "", int32_t(0x00000000), int32_t(0xD2D5ACDD)},
    {"crater06.sno", "-", int32_t(0x00000000), int32_t(0x1B9EB39C)},
    {"crater06.tem", "-", int32_t(0x00000000), int32_t(0x132B1DFE)},
    {"crater06.ubn", "", int32_t(0x00000000), int32_t(0xC4A1B0B4)},
    {"crater06.urb", "", int32_t(0x00000000), int32_t(0x87D5EECE)},
    {"crater07.des", "", int32_t(0x00000000), int32_t(0xC862AA5D)},
    {"crater07.lun", "", int32_t(0x00000000), int32_t(0xEFB5856D)},
    {"crater07.sno", "-", int32_t(0x00000000), int32_t(0x26FE9A2C)},
    {"crater07.tem", "-", int32_t(0x00000000), int32_t(0x2E4B344E)},
    {"crater07.ubn", "", int32_t(0x00000000), int32_t(0xF9C19904)},
    {"crater07.urb", "", int32_t(0x00000000), int32_t(0xBAB5C77E)},
    {"crater08.des", "", int32_t(0x00000000), int32_t(0x4A323D8C)},
    {"crater08.lun", "", int32_t(0x00000000), int32_t(0x6DE512BC)},
    {"crater08.sno", "-", int32_t(0x00000000), int32_t(0xA4AE0DFD)},
    {"crater08.tem", "-", int32_t(0x00000000), int32_t(0xAC1BA39F)},
    {"crater08.ubn", "", int32_t(0x00000000), int32_t(0x7B910ED5)},
    {"crater08.urb", "", int32_t(0x00000000), int32_t(0x38E550AF)},
    {"crater09.des", "", int32_t(0x00000000), int32_t(0x7752143C)},
    {"crater09.lun", "", int32_t(0x00000000), int32_t(0x50853B0C)},
    {"crater09.sno", "-", int32_t(0x00000000), int32_t(0x99CE244D)},
    {"crater09.tem", "-", int32_t(0x00000000), int32_t(0x917B8A2F)},
    {"crater09.ubn", "", int32_t(0x00000000), int32_t(0x46F12765)},
    {"crater09.urb", "", int32_t(0x00000000), int32_t(0x0585791F)},
    {"crater10.des", "", int32_t(0x00000000), int32_t(0xB11EA5E8)},
    {"crater10.lun", "", int32_t(0x00000000), int32_t(0x96C98AD8)},
    {"crater10.sno", "-", int32_t(0x00000000), int32_t(0x5F829599)},
    {"crater10.tem", "-", int32_t(0x00000000), int32_t(0x57373BFB)},
    {"crater10.ubn", "", int32_t(0x00000000), int32_t(0x80BD96B1)},
    {"crater10.urb", "", int32_t(0x00000000), int32_t(0xC3C9C8CB)},
    {"crater11.des", "", int32_t(0x00000000), int32_t(0x8C7E8C58)},
    {"crater11.lun", "", int32_t(0x00000000), int32_t(0xABA9A368)},
    {"crater11.sno", "-", int32_t(0x00000000), int32_t(0x62E2BC29)},
    {"crater11.tem", "-", int32_t(0x00000000), int32_t(0x6A57124B)},
    {"crater11.ubn", "", int32_t(0x00000000), int32_t(0xBDDDBF01)},
    {"crater11.urb", "", int32_t(0x00000000), int32_t(0xFEA9E17B)},
    {"crater12.des", "", int32_t(0x00000000), int32_t(0xCBDEF688)},
    {"crater12.lun", "", int32_t(0x00000000), int32_t(0xEC09D9B8)},
    {"crater12.sno", "-", int32_t(0x00000000), int32_t(0x2542C6F9)},
    {"crater12.tem", "-", int32_t(0x00000000), int32_t(0x2DF7689B)},
    {"crater12.ubn", "", int32_t(0x00000000), int32_t(0xFA7DC5D1)},
    {"crater12.urb", "", int32_t(0x00000000), int32_t(0xB9099BAB)},
    {"crazy.csv", "", int32_t(0x0F8BA614), int32_t(0x00000000)},
    {"crazy.lsv", "", int32_t(0x0F9DA614), int32_t(0x00000000)},
    {"crazy.vqa", "", int32_t(0x0BB1A5FF), int32_t(0x00000000)},
    {"crazy_e.vqa", "", int32_t(0xC5D15915), int32_t(0x00000000)},
    {"crazy_e.vqt", "", int32_t(0xC5E45915), int32_t(0x00000000)},
    {"crazy_h.pcx", "", int32_t(0xC5EE4B0F), int32_t(0x00000000)},
    {"crazy_h.vqa", "", int32_t(0xC5D75915), int32_t(0x00000000)},
    {"crazy_l.pcx", "", int32_t(0xC5F64B0F), int32_t(0x00000000)},
    {"crazy_l.vqa", "", int32_t(0xC5DF5915), int32_t(0x00000000)},
    {"creak1.aud", "", int32_t(0x8771EFF8), int32_t(0x00000000)},
    {"creak2.aud", "", int32_t(0x8771F1F8), int32_t(0x00000000)},
    {"creak3.aud", "", int32_t(0x8771F3F8), int32_t(0x00000000)},
    {"creak4.aud", "", int32_t(0x8771F5F8), int32_t(0x00000000)},
    {"creaky1.aud", "", int32_t(0x61BC50E4), int32_t(0x00000000)},
    {"creaky2.aud", "", int32_t(0x61BE50E4), int32_t(0x00000000)},
    {"creaky3.aud", "", int32_t(0x61C050E4), int32_t(0x00000000)},
    {"creaky4.aud", "", int32_t(0x61C250E4), int32_t(0x00000000)},
    {"creaky6.aud", "", int32_t(0x61C650E4), int32_t(0x00000000)},
    {"creaky7.aud", "", int32_t(0x61C850E4), int32_t(0x00000000)},
    {"creaky8.aud", "", int32_t(0x61CA50E4), int32_t(0x00000000)},
    {"creaky9.aud", "", int32_t(0x61CC50E4), int32_t(0x00000000)},
    {"creddwn1.aud", "credit negative", int32_t(0x00000000), int32_t(0x8269AB03)},
    {"credit1.aud", "credits stolen", int32_t(0x6DBC46E0), int32_t(0x00000000)},
    {"credit1.cps", "", int32_t(0x6DCB41E2), int32_t(0x00000000)},
    {"credit1.pcx", "", int32_t(0x6DD034EF), int32_t(0x00000000)},
    {"credit2.cps", "", int32_t(0x6DCD41E2), int32_t(0x00000000)},
    {"credit2.pcx", "", int32_t(0x6DD234EF), int32_t(0x00000000)},
    {"credit3.cps", "", int32_t(0x6DCF41E2), int32_t(0x00000000)},
    {"credit3.pcx", "", int32_t(0x6DD434EF), int32_t(0x00000000)},
    {"credit4.cps", "", int32_t(0x6DD141E2), int32_t(0x00000000)},
    {"credit4.pcx", "", int32_t(0x6DD634EF), int32_t(0x00000000)},
    {"credit5.cps", "", int32_t(0x6DD341E2), int32_t(0x00000000)},
    {"credit5.pcx", "", int32_t(0x6DD834EF), int32_t(0x00000000)},
    {"credit6.cps", "", int32_t(0x6DD541E2), int32_t(0x00000000)},
    {"credit6.pcx", "", int32_t(0x6DDA34EF), int32_t(0x00000000)},
    {"credit7.cps", "", int32_t(0x6DD741E2), int32_t(0x00000000)},
    {"credit7.pcx", "", int32_t(0x6DDC34EF), int32_t(0x00000000)},
    {"credit8.cps", "", int32_t(0x6DD941E2), int32_t(0x00000000)},
    {"credit8.pcx", "", int32_t(0x6DDE34EF), int32_t(0x00000000)},
    {"credit9.cps", "", int32_t(0x6DDB41E2), int32_t(0x00000000)},
    {"credit9.pcx", "", int32_t(0x6DE034EF), int32_t(0x00000000)},
    {"credits.aud", "end credits", int32_t(0x6E0046E0), int32_t(0x00000000)},
    {"credits.eng", "misc: credits", int32_t(0x6E033FE4), int32_t(0x00000000)},
    {"credits.shp", "", int32_t(0x00000000), int32_t(0x7637D6E1)},
    {"credits.tre", "", int32_t(0x6E0143F3), int32_t(0x00000000)},
    {"credits.trf", "", int32_t(0x6E0243F3), int32_t(0x00000000)},
    {"credits.trg", "", int32_t(0x6E0343F3), int32_t(0x00000000)},
    {"credits.tri", "", int32_t(0x6E0543F3), int32_t(0x00000000)},
    {"credits.trr", "", int32_t(0x6E0E43F3), int32_t(0x00000000)},
    {"credits.trs", "", int32_t(0x6E0F43F3), int32_t(0x00000000)},
    {"credits.txt", "game credits", int32_t(0x6E1049F3), int32_t(0x93AA882C)},
    {"credits.xmi", "", int32_t(0x6E053EF7), int32_t(0x00000000)},
    {"creditsmd.txt", "", int32_t(0x00000000), int32_t(0x373A7BC1)},
    {"creds.shp", "score screen coins", int32_t(0xA1BBA603), int32_t(0x00000000)},
    {"credsa.shp", "misc: allies credits dos", int32_t(0xB7721BFB), int32_t(0x00000000)},
    {"credsahr.shp", "misc: allies credits win", int32_t(0x05EE1EE1), int32_t(0x00000000)},
    {"credsu.shp", "misc: soviet credits dos", int32_t(0xB77243FB), int32_t(0x00000000)},
    {"credsuhr.shp", "misc: soviet credits win", int32_t(0x05EE46E1), int32_t(0x00000000)},
    {"credup1.aud", "credit positive", int32_t(0x00000000), int32_t(0x2C1000A5)},
    {"creeping.aud", "", int32_t(0xE8071CDB), int32_t(0x00000000)},
    {"crep226m.aud", "creep", int32_t(0x1FD6EE9F), int32_t(0x00000000)},
    {"crevas01.lun", "", int32_t(0x00000000), int32_t(0x65D5FD7F)},
    {"crevas01.sno", "", int32_t(0x00000000), int32_t(0xAC9EE23E)},
    {"crevas02.lun", "", int32_t(0x00000000), int32_t(0x227587AF)},
    {"crevas02.sno", "", int32_t(0x00000000), int32_t(0xEB3E98EE)},
    {"crevas03.lun", "", int32_t(0x00000000), int32_t(0x1F15AE1F)},
    {"crevas03.sno", "", int32_t(0x00000000), int32_t(0xD65EB15E)},
    {"crevas04.lun", "", int32_t(0x00000000), int32_t(0xAD35720F)},
    {"crevas04.sno", "", int32_t(0x00000000), int32_t(0x647E6D4E)},
    {"crevas05.lun", "", int32_t(0x00000000), int32_t(0x90555BBF)},
    {"crevas05.sno", "", int32_t(0x00000000), int32_t(0x591E44FE)},
    {"crevas06.lun", "", int32_t(0x00000000), int32_t(0xD7F5216F)},
    {"crevas06.sno", "", int32_t(0x00000000), int32_t(0x1EBE3E2E)},
    {"crheal.aud", "", int32_t(0x977E25E4), int32_t(0x00000000)},
    {"cricket1.aud", "", int32_t(0xB42314D1), int32_t(0x00000000)},
    {"cricket2.aud", "", int32_t(0xB62314D1), int32_t(0x00000000)},
    {"cricket3.aud", "", int32_t(0xB82314D1), int32_t(0x00000000)},
    {"cricket4.aud", "", int32_t(0xBA2314D1), int32_t(0x00000000)},
    {"crimes.tre", "", int32_t(0xDD8234E9), int32_t(0x00000000)},
    {"crimes.trf", "", int32_t(0xDD8235E9), int32_t(0x00000000)},
    {"crimes.trg", "", int32_t(0xDD8236E9), int32_t(0x00000000)},
    {"crimes.tri", "", int32_t(0xDD8238E9), int32_t(0x00000000)},
    {"crimes.trs", "", int32_t(0xDD8242E9), int32_t(0x00000000)},
    {"crivexp.shp", "", int32_t(0x00000000), int32_t(0xF8A6510D)},
    {"crivexp2.shp", "", int32_t(0x00000000), int32_t(0xA4E98749)},
    {"crmble2.aud", "wall crumbling", int32_t(0x65DE28E6), int32_t(0x9C5BD21C)},
    {"cronfail.vqa", "chronosphere test failed", int32_t(0x132121C7), int32_t(0x00000000)},
    {"cronfail.vqp", "vqp: chronosphere test failed", int32_t(0x222121C7), int32_t(0x00000000)},
    {"crontest.vqa", "chronosphere test ok", int32_t(0x233529E3), int32_t(0x00000000)},
    {"crontest.vqp", "vqp: chronosphere test ok", int32_t(0x323529E3), int32_t(0x00000000)},
    {"crosbow9.aud", "", int32_t(0x044128BF), int32_t(0x00000000)},
    {"croslock.aud", "", int32_t(0x281928D3), int32_t(0x00000000)},
    {"crosslt1.aud", "", int32_t(0xF43B22E1), int32_t(0x00000000)},
    {"crowdmad.aud", "", int32_t(0x2A1524C3), int32_t(0x00000000)},
    {"crowdsad.aud", "", int32_t(0x2A1530C3), int32_t(0x00000000)},
    {"crrange.aud", "", int32_t(0x62182CEA), int32_t(0x00000000)},
    {"crreload.aud", "", int32_t(0xE22128D3), int32_t(0x00000000)},
    {"crryicon.shp", "icon: orca transport", int32_t(0x00000000), int32_t(0x58CA527C)},
    {"crshnvox.aud", "", int32_t(0x164136D7), int32_t(0x00000000)},
    {"crshroud.aud", "", int32_t(0xEE4D28DF), int32_t(0x00000000)},
    {"crspeed.aud", "", int32_t(0x9E1A28D8), int32_t(0x00000000)},
    {"crtport.aud", "", int32_t(0x9E3E42EC), int32_t(0x00000000)},
    {"crtr01.lun", "", int32_t(0x00000000), int32_t(0x743D3C7E)},
    {"crtr02.lun", "", int32_t(0x00000000), int32_t(0x45D526E3)},
    {"crtr03.lun", "", int32_t(0x00000000), int32_t(0xE3A22D57)},
    {"crtr04.lun", "", int32_t(0x00000000), int32_t(0x260513D9)},
    {"crtr05.lun", "", int32_t(0x00000000), int32_t(0x8072186D)},
    {"crtr06.lun", "", int32_t(0x00000000), int32_t(0xB19A02F0)},
    {"crtr07.lun", "", int32_t(0x00000000), int32_t(0x17ED0944)},
    {"crtr08.lun", "", int32_t(0x00000000), int32_t(0xE1A579AD)},
    {"cruise.hva", "", int32_t(0x00000000), int32_t(0x8649C725)},
    {"cruise.vxl", "", int32_t(0x00000000), int32_t(0x562627A1)},
    {"crumble.aud", "wall crumbling", int32_t(0x922436D2), int32_t(0x00000000)},
    {"crumble.juv", "wall crumbling", int32_t(0x923636DB), int32_t(0x00000000)},
    {"crunclk.aud", "", int32_t(0x963036D4), int32_t(0x00000000)},
    {"crunshrd.aud", "", int32_t(0x064F1AE1), int32_t(0x00000000)},
    {"crus226m.aud", "crush", int32_t(0x2C16EE9F), int32_t(0x00000000)},
    {"crweapon.aud", "", int32_t(0xF6512ABD), int32_t(0x00000000)},
    {"crychrg1.aud", "", int32_t(0xB4492ECB), int32_t(0x00000000)},
    {"crychrg2.aud", "", int32_t(0xB6492ECB), int32_t(0x00000000)},
    {"cryexpl1.aud", "", int32_t(0xBC532AEB), int32_t(0x00000000)},
    {"cryloop1.aud", "", int32_t(0xD85B28D9), int32_t(0x00000000)},
    {"crys01.tem", "-", int32_t(0x00000000), int32_t(0x89C0866C)},
    {"crys01a.tem", "-", int32_t(0x00000000), int32_t(0xCDE815A0)},
    {"crys01b.tem", "-", int32_t(0x00000000), int32_t(0x4B7C670E)},
    {"crys01c.tem", "-", int32_t(0x00000000), int32_t(0x8020B4AB)},
    {"crys01d.tem", "-", int32_t(0x00000000), int32_t(0x9D258413)},
    {"crys01e.tem", "-", int32_t(0x00000000), int32_t(0x567957B6)},
    {"crys01f.tem", "-", int32_t(0x00000000), int32_t(0xD0ED2518)},
    {"crys01g.tem", "-", int32_t(0x00000000), int32_t(0x1BB1F6BD)},
    {"crysdie1.aud", "", int32_t(0xF4451CC3), int32_t(0x00000000)},
    {"crystal1.des", "", int32_t(0x00000000), int32_t(0x8DFD8974)},
    {"crystal1.lun", "", int32_t(0x00000000), int32_t(0xAA2AA644)},
    {"crystal1.sno", "-", int32_t(0x00000000), int32_t(0x6361B905)},
    {"crystal1.tem", "-", int32_t(0x00000000), int32_t(0x6BD41767)},
    {"crystal1.ubn", "", int32_t(0x00000000), int32_t(0xBC5EBA2D)},
    {"crystal1.urb", "", int32_t(0x00000000), int32_t(0xFF2AE457)},
    {"crystal2.des", "", int32_t(0x00000000), int32_t(0xCA5DF3A4)},
    {"crystal2.lun", "", int32_t(0x00000000), int32_t(0xED8ADC94)},
    {"crystal2.sno", "-", int32_t(0x00000000), int32_t(0x24C1C3D5)},
    {"crystal2.tem", "-", int32_t(0x00000000), int32_t(0x2C746DB7)},
    {"crystal2.ubn", "", int32_t(0x00000000), int32_t(0xFBFEC0FD)},
    {"crystal2.urb", "", int32_t(0x00000000), int32_t(0xB88A9E87)},
    {"crystal3.des", "", int32_t(0x00000000), int32_t(0xF73DDA14)},
    {"crystal3.lun", "", int32_t(0x00000000), int32_t(0xD0EAF524)},
    {"crystal3.sno", "-", int32_t(0x00000000), int32_t(0x19A1EA65)},
    {"crystal3.tem", "-", int32_t(0x00000000), int32_t(0x11144407)},
    {"crystal3.ubn", "", int32_t(0x00000000), int32_t(0xC69EE94D)},
    {"crystal3.urb", "", int32_t(0x00000000), int32_t(0x85EAB737)},
    {"crystal4.des", "", int32_t(0x00000000), int32_t(0x451D0604)},
    {"crystal4.lun", "", int32_t(0x00000000), int32_t(0x62CA2934)},
    {"crystal4.sno", "-", int32_t(0x00000000), int32_t(0xAB813675)},
    {"crystal4.tem", "-", int32_t(0x00000000), int32_t(0xA3349817)},
    {"crystal4.ubn", "", int32_t(0x00000000), int32_t(0x74BE355D)},
    {"crystal4.urb", "", int32_t(0x00000000), int32_t(0x37CA6B27)},
    {"crzyexpl.aud", "", int32_t(0x425F3AC5), int32_t(0x00000000)},
    {"cshapes.shp", "???", int32_t(0x62182000), int32_t(0x00000000)},
    {"csof001.wav", "", int32_t(0x00000000), int32_t(0xD15EF62C)},
    {"csof002.wav", "", int32_t(0x00000000), int32_t(0x57CA8482)},
    {"csof003.wav", "", int32_t(0x00000000), int32_t(0x9C965727)},
    {"csof004.wav", "", int32_t(0x00000000), int32_t(0x8193679F)},
    {"csof005.wav", "", int32_t(0x00000000), int32_t(0x4ACFB43A)},
    {"csof006.wav", "", int32_t(0x00000000), int32_t(0xCC5BC694)},
    {"csof007.wav", "", int32_t(0x00000000), int32_t(0x07071531)},
    {"csof008.wav", "", int32_t(0x00000000), int32_t(0xF651A7E4)},
    {"csof009.wav", "", int32_t(0x00000000), int32_t(0x3D0D7441)},
    {"csof010.wav", "", int32_t(0x00000000), int32_t(0xBC752E3D)},
    {"csof011.wav", "", int32_t(0x00000000), int32_t(0x7729FD98)},
    {"csof012.wav", "", int32_t(0x00000000), int32_t(0xF1BD8F36)},
    {"csof013.wav", "", int32_t(0x00000000), int32_t(0x3AE15C93)},
    {"csof014.wav", "", int32_t(0x00000000), int32_t(0x27E46C2B)},
    {"csof015.wav", "", int32_t(0x00000000), int32_t(0xECB8BF8E)},
    {"csof016.wav", "", int32_t(0x00000000), int32_t(0x6A2CCD20)},
    {"csof017.wav", "", int32_t(0x00000000), int32_t(0xA1701E85)},
    {"csof018.wav", "", int32_t(0x00000000), int32_t(0x5026AC50)},
    {"csof019.wav", "", int32_t(0x00000000), int32_t(0x9B7A7FF5)},
    {"csof020.wav", "", int32_t(0x00000000), int32_t(0x8D9D34A0)},
    {"csof021.wav", "", int32_t(0x00000000), int32_t(0x46C1E705)},
    {"csof022.wav", "", int32_t(0x00000000), int32_t(0xC05595AB)},
    {"csof023.wav", "", int32_t(0x00000000), int32_t(0x0B09460E)},
    {"csof024.wav", "", int32_t(0x00000000), int32_t(0x160C76B6)},
    {"csof025.wav", "", int32_t(0x00000000), int32_t(0xDD50A513)},
    {"csof026.wav", "", int32_t(0x00000000), int32_t(0x5BC4D7BD)},
    {"csof027.wav", "", int32_t(0x00000000), int32_t(0x90980418)},
    {"csof028.wav", "", int32_t(0x00000000), int32_t(0x61CEB6CD)},
    {"csof029.wav", "", int32_t(0x00000000), int32_t(0xAA926568)},
    {"csof030.wav", "", int32_t(0x00000000), int32_t(0x2BEA3F14)},
    {"csof031.wav", "", int32_t(0x00000000), int32_t(0xE0B6ECB1)},
    {"csof032.wav", "", int32_t(0x00000000), int32_t(0x66229E1F)},
    {"csof033.wav", "", int32_t(0x00000000), int32_t(0xAD7E4DBA)},
    {"csof035.wav", "", int32_t(0x00000000), int32_t(0x7B27AEA7)},
    {"csof036.wav", "", int32_t(0x00000000), int32_t(0xFDB3DC09)},
    {"csof037.wav", "", int32_t(0x00000000), int32_t(0x36EF0FAC)},
    {"csof038.wav", "", int32_t(0x00000000), int32_t(0xC7B9BD79)},
    {"csof039.wav", "", int32_t(0x00000000), int32_t(0x0CE56EDC)},
    {"csof040.wav", "", int32_t(0x00000000), int32_t(0xEE4D019A)},
    {"csof041.wav", "", int32_t(0x00000000), int32_t(0x2511D23F)},
    {"csof042.wav", "", int32_t(0x00000000), int32_t(0xA385A091)},
    {"csof043.wav", "", int32_t(0x00000000), int32_t(0x68D97334)},
    {"csof044.wav", "", int32_t(0x00000000), int32_t(0x75DC438C)},
    {"csof045.wav", "", int32_t(0x00000000), int32_t(0xBE809029)},
    {"csof046.wav", "", int32_t(0x00000000), int32_t(0x3814E287)},
    {"csof047.wav", "", int32_t(0x00000000), int32_t(0xF3483122)},
    {"csof048.wav", "", int32_t(0x00000000), int32_t(0x021E83F7)},
    {"csof049.wav", "", int32_t(0x00000000), int32_t(0xC9425052)},
    {"csof050.wav", "", int32_t(0x00000000), int32_t(0x483A0A2E)},
    {"csof051.wav", "", int32_t(0x00000000), int32_t(0x8366D98B)},
    {"csof052.wav", "", int32_t(0x00000000), int32_t(0x05F2AB25)},
    {"csof053.wav", "", int32_t(0x00000000), int32_t(0xCEAE7880)},
    {"csof054.wav", "", int32_t(0x00000000), int32_t(0xD3AB4838)},
    {"csof055.wav", "", int32_t(0x00000000), int32_t(0x18F79B9D)},
    {"csof056.wav", "", int32_t(0x00000000), int32_t(0x9E63E933)},
    {"csof057.wav", "", int32_t(0x00000000), int32_t(0x553F3A96)},
    {"csof058.wav", "", int32_t(0x00000000), int32_t(0xA4698843)},
    {"csof059.wav", "", int32_t(0x00000000), int32_t(0x6F355BE6)},
    {"csof060.wav", "", int32_t(0x00000000), int32_t(0x79D210B3)},
    {"csof061.wav", "", int32_t(0x00000000), int32_t(0xB28EC316)},
    {"csof062.wav", "", int32_t(0x00000000), int32_t(0x341AB1B8)},
    {"csof063.wav", "", int32_t(0x00000000), int32_t(0xFF46621D)},
    {"csof064.wav", "", int32_t(0x00000000), int32_t(0xE24352A5)},
    {"csof065.wav", "", int32_t(0x00000000), int32_t(0x291F8100)},
    {"csof066.wav", "", int32_t(0x00000000), int32_t(0xAF8BF3AE)},
    {"csof067.wav", "", int32_t(0x00000000), int32_t(0x64D7200B)},
    {"csof068.wav", "", int32_t(0x00000000), int32_t(0x958192DE)},
    {"csof069.wav", "", int32_t(0x00000000), int32_t(0x5EDD417B)},
    {"csof070.wav", "", int32_t(0x00000000), int32_t(0xDFA51B07)},
    {"csof071.wav", "", int32_t(0x00000000), int32_t(0x14F9C8A2)},
    {"csof072.wav", "", int32_t(0x00000000), int32_t(0x926DBA0C)},
    {"csof073.wav", "", int32_t(0x00000000), int32_t(0x593169A9)},
    {"csof074.wav", "", int32_t(0x00000000), int32_t(0x44345911)},
    {"csof075.wav", "", int32_t(0x00000000), int32_t(0x8F688AB4)},
    {"csof076.wav", "", int32_t(0x00000000), int32_t(0x09FCF81A)},
    {"csof077.wav", "", int32_t(0x00000000), int32_t(0xC2A02BBF)},
    {"csof078.wav", "", int32_t(0x00000000), int32_t(0x33F6996A)},
    {"csof079.wav", "", int32_t(0x00000000), int32_t(0xF8AA4ACF)},
    {"csof080.wav", "", int32_t(0x00000000), int32_t(0x29ED6BEE)},
    {"csof081.wav", "", int32_t(0x00000000), int32_t(0xE2B1B84B)},
    {"csof082.wav", "", int32_t(0x00000000), int32_t(0x6425CAE5)},
    {"csof083.wav", "", int32_t(0x00000000), int32_t(0xAF791940)},
    {"csof084.wav", "", int32_t(0x00000000), int32_t(0xB27C29F8)},
    {"csof085.wav", "", int32_t(0x00000000), int32_t(0x7920FA5D)},
    {"csof086.wav", "", int32_t(0x00000000), int32_t(0xFFB488F3)},
    {"csof087.wav", "", int32_t(0x00000000), int32_t(0x34E85B56)},
    {"csof088.wav", "", int32_t(0x00000000), int32_t(0xC5BEE983)},
    {"csof089.wav", "", int32_t(0x00000000), int32_t(0x0EE23A26)},
    {"csof090.wav", "", int32_t(0x00000000), int32_t(0x8F9A605A)},
    {"csof091.wav", "", int32_t(0x00000000), int32_t(0x44C6B3FF)},
    {"csof092.wav", "", int32_t(0x00000000), int32_t(0xC252C151)},
    {"csof093.wav", "", int32_t(0x00000000), int32_t(0x090E12F4)},
    {"csof094.wav", "", int32_t(0x00000000), int32_t(0x140B224C)},
    {"csof095.wav", "", int32_t(0x00000000), int32_t(0xDF57F1E9)},
    {"csof096.wav", "", int32_t(0x00000000), int32_t(0x59C38347)},
    {"csof097.wav", "", int32_t(0x00000000), int32_t(0x929F50E2)},
    {"csof098.wav", "", int32_t(0x00000000), int32_t(0x63C9E237)},
    {"csof099.wav", "", int32_t(0x00000000), int32_t(0xA8953192)},
    {"csof100.wav", "", int32_t(0x00000000), int32_t(0xD6A82517)},
    {"csof101.wav", "", int32_t(0x00000000), int32_t(0x1DF4F6B2)},
    {"csof102.wav", "", int32_t(0x00000000), int32_t(0x9B60841C)},
    {"csof103.wav", "", int32_t(0x00000000), int32_t(0x503C57B9)},
    {"csof104.wav", "", int32_t(0x00000000), int32_t(0x4D396701)},
    {"csof105.wav", "", int32_t(0x00000000), int32_t(0x8665B4A4)},
    {"csof106.wav", "", int32_t(0x00000000), int32_t(0x00F1C60A)},
    {"csof107.wav", "", int32_t(0x00000000), int32_t(0xCBAD15AF)},
    {"csof108.wav", "", int32_t(0x00000000), int32_t(0x3AFBA77A)},
    {"csof109.wav", "", int32_t(0x00000000), int32_t(0xF1A774DF)},
    {"csof120.wav", "", int32_t(0x00000000), int32_t(0x4137343E)},
    {"csof121.wav", "", int32_t(0x00000000), int32_t(0x8A6BE79B)},
    {"csof122.wav", "", int32_t(0x00000000), int32_t(0x0CFF9535)},
    {"csof123.wav", "", int32_t(0x00000000), int32_t(0xC7A34690)},
    {"csof124.wav", "", int32_t(0x00000000), int32_t(0xDAA67628)},
    {"csof125.wav", "", int32_t(0x00000000), int32_t(0x11FAA58D)},
    {"csof127.wav", "", int32_t(0x00000000), int32_t(0x5C320486)},
    {"csof128.wav", "", int32_t(0x00000000), int32_t(0xAD64B653)},
    {"csof129.wav", "", int32_t(0x00000000), int32_t(0x663865F6)},
    {"csof130.wav", "", int32_t(0x00000000), int32_t(0xE7403F8A)},
    {"csof131.wav", "", int32_t(0x00000000), int32_t(0x2C1CEC2F)},
    {"csof132.wav", "", int32_t(0x00000000), int32_t(0xAA889E81)},
    {"csof133.wav", "", int32_t(0x00000000), int32_t(0x61D44D24)},
    {"csof134.wav", "", int32_t(0x00000000), int32_t(0x7CD17D9C)},
    {"csof135.wav", "", int32_t(0x00000000), int32_t(0xB78DAE39)},
    {"csof136.wav", "", int32_t(0x00000000), int32_t(0x3119DC97)},
    {"csof137.wav", "", int32_t(0x00000000), int32_t(0xFA450F32)},
    {"csof138.wav", "", int32_t(0x00000000), int32_t(0x0B13BDE7)},
    {"csof139.wav", "", int32_t(0x00000000), int32_t(0xC04F6E42)},
    {"csof140.wav", "", int32_t(0x00000000), int32_t(0x22E70104)},
    {"csof141.wav", "", int32_t(0x00000000), int32_t(0xE9BBD2A1)},
    {"csof142.wav", "", int32_t(0x00000000), int32_t(0x6F2FA00F)},
    {"csof143.wav", "", int32_t(0x00000000), int32_t(0xA47373AA)},
    {"csof150.wav", "", int32_t(0x00000000), int32_t(0x84900AB0)},
    {"csof151.wav", "", int32_t(0x00000000), int32_t(0x4FCCD915)},
    {"csof153.wav", "", int32_t(0x00000000), int32_t(0x0204781E)},
    {"csofu04.wav", "", int32_t(0x00000000), int32_t(0x1998C940)},
    {"csofu06.wav", "", int32_t(0x00000000), int32_t(0x5450684B)},
    {"csofu07.wav", "", int32_t(0x00000000), int32_t(0x9F0CBBEE)},
    {"csofu08.wav", "", int32_t(0x00000000), int32_t(0x6E5A093B)},
    {"csofu09.wav", "", int32_t(0x00000000), int32_t(0xA506DA9E)},
    {"csofu10.wav", "", int32_t(0x00000000), int32_t(0x247E80E2)},
    {"csofu11.wav", "", int32_t(0x00000000), int32_t(0xEF225347)},
    {"csofu15.wav", "", int32_t(0x00000000), int32_t(0x74B31151)},
    {"csofu16.wav", "", int32_t(0x00000000), int32_t(0xF22763FF)},
    {"csofu18.wav", "", int32_t(0x00000000), int32_t(0xC82D028F)},
    {"csofu19.wav", "", int32_t(0x00000000), int32_t(0x0371D12A)},
    {"csofu20.wav", "", int32_t(0x00000000), int32_t(0x15969A7F)},
    {"csofu21.wav", "", int32_t(0x00000000), int32_t(0xDECA49DA)},
    {"csofu25.wav", "", int32_t(0x00000000), int32_t(0x455B0BCC)},
    {"csofu26.wav", "", int32_t(0x00000000), int32_t(0xC3CF7962)},
    {"csofu27.wav", "", int32_t(0x00000000), int32_t(0x0893AAC7)},
    {"csofu30.wav", "", int32_t(0x00000000), int32_t(0xB3E191CB)},
    {"csofu31.wav", "", int32_t(0x00000000), int32_t(0x78BD426E)},
    {"csofu33.wav", "", int32_t(0x00000000), int32_t(0x3575E365)},
    {"csofu39.wav", "", int32_t(0x00000000), int32_t(0x94EEC003)},
    {"csofu40.wav", "", int32_t(0x00000000), int32_t(0x7646AF45)},
    {"csofu41.wav", "", int32_t(0x00000000), int32_t(0xBD1A7CE0)},
    {"csofu42.wav", "", int32_t(0x00000000), int32_t(0x3B8E0E4E)},
    {"csofu43.wav", "", int32_t(0x00000000), int32_t(0xF0D2DDEB)},
    {"csofu44.wav", "", int32_t(0x00000000), int32_t(0xEDD7ED53)},
    {"csofu45.wav", "", int32_t(0x00000000), int32_t(0x268B3EF6)},
    {"csofu46.wav", "", int32_t(0x00000000), int32_t(0xA01F4C58)},
    {"csofu47.wav", "", int32_t(0x00000000), int32_t(0x6B439FFD)},
    {"csofu48.wav", "", int32_t(0x00000000), int32_t(0x9A152D28)},
    {"csofu49.wav", "", int32_t(0x00000000), int32_t(0x5149FE8D)},
    {"csofu50.wav", "", int32_t(0x00000000), int32_t(0xD031A4F1)},
    {"csofu51.wav", "", int32_t(0x00000000), int32_t(0x1B6D7754)},
    {"csofu52.wav", "", int32_t(0x00000000), int32_t(0x9DF905FA)},
    {"csofu53.wav", "", int32_t(0x00000000), int32_t(0x56A5D65F)},
    {"csofu54.wav", "", int32_t(0x00000000), int32_t(0x4BA0E6E7)},
    {"csofu55.wav", "", int32_t(0x00000000), int32_t(0x80FC3542)},
    {"csofu56.wav", "", int32_t(0x00000000), int32_t(0x066847EC)},
    {"csofu57.wav", "", int32_t(0x00000000), int32_t(0xCD349449)},
    {"csofu58.wav", "", int32_t(0x00000000), int32_t(0x3C62269C)},
    {"csofu59.wav", "", int32_t(0x00000000), int32_t(0xF73EF539)},
    {"csofu60.wav", "", int32_t(0x00000000), int32_t(0xE1D9BE6C)},
    {"csofu61.wav", "", int32_t(0x00000000), int32_t(0x2A856DC9)},
    {"csofu62.wav", "", int32_t(0x00000000), int32_t(0xAC111F67)},
    {"csofu63.wav", "", int32_t(0x00000000), int32_t(0x674DCCC2)},
    {"csofu64.wav", "", int32_t(0x00000000), int32_t(0x7A48FC7A)},
    {"csofu65.wav", "", int32_t(0x00000000), int32_t(0xB1142FDF)},
    {"csofu66.wav", "", int32_t(0x00000000), int32_t(0x37805D71)},
    {"csofu67.wav", "", int32_t(0x00000000), int32_t(0xFCDC8ED4)},
    {"csofu68.wav", "", int32_t(0x00000000), int32_t(0x0D8A3C01)},
    {"csofu69.wav", "", int32_t(0x00000000), int32_t(0xC6D6EFA4)},
    {"csofu70.wav", "", int32_t(0x00000000), int32_t(0x47AEB5D8)},
    {"csofu71.wav", "", int32_t(0x00000000), int32_t(0x8CF2667D)},
    {"csofu72.wav", "", int32_t(0x00000000), int32_t(0x0A6614D3)},
    {"csofu73.wav", "", int32_t(0x00000000), int32_t(0xC13AC776)},
    {"csofu74.wav", "", int32_t(0x00000000), int32_t(0xDC3FF7CE)},
    {"csofu75.wav", "", int32_t(0x00000000), int32_t(0x1763246B)},
    {"csofu76.wav", "", int32_t(0x00000000), int32_t(0x91F756C5)},
    {"csofu77.wav", "", int32_t(0x00000000), int32_t(0x5AAB8560)},
    {"csofu78.wav", "", int32_t(0x00000000), int32_t(0xABFD37B5)},
    {"csofu79.wav", "", int32_t(0x00000000), int32_t(0x60A1E410)},
    {"csofu80.wav", "", int32_t(0x00000000), int32_t(0xB1E6C531)},
    {"csofu81.wav", "", int32_t(0x00000000), int32_t(0x7ABA1694)},
    {"csofu82.wav", "", int32_t(0x00000000), int32_t(0xFC2E643A)},
    {"csofu83.wav", "", int32_t(0x00000000), int32_t(0x3772B79F)},
    {"csofu85.wav", "", int32_t(0x00000000), int32_t(0xE12B5482)},
    {"csofu86.wav", "", int32_t(0x00000000), int32_t(0x67BF262C)},
    {"csofu87.wav", "", int32_t(0x00000000), int32_t(0xACE3F589)},
    {"csofu88.wav", "", int32_t(0x00000000), int32_t(0x5DB5475C)},
    {"csofu89.wav", "", int32_t(0x00000000), int32_t(0x96E994F9)},
    {"csofu90.wav", "", int32_t(0x00000000), int32_t(0x1791CE85)},
    {"csofu91.wav", "", int32_t(0x00000000), int32_t(0xDCCD1D20)},
    {"csofu92.wav", "", int32_t(0x00000000), int32_t(0x5A596F8E)},
    {"csofu93.wav", "", int32_t(0x00000000), int32_t(0x9105BC2B)},
    {"csofu94.wav", "", int32_t(0x00000000), int32_t(0x8C008C93)},
    {"csphicon.shp", "", int32_t(0x00000000), int32_t(0x260A0BB3)},
    {"cstrike.pkt", "inif: counterstrike multiplayer map file names", int32_t(0xA6302EEF), int32_t(0x00000000)},
    {"ct0001.shp", "-", int32_t(0x00000000), int32_t(0x036C96A7)},
    {"ct0002.shp", "-", int32_t(0x00000000), int32_t(0x32848C3A)},
    {"ct0003.shp", "-", int32_t(0x00000000), int32_t(0x94F3878E)},
    {"ct0004.shp", "-", int32_t(0x00000000), int32_t(0x5154B900)},
    {"ct0005.shp", "-", int32_t(0x00000000), int32_t(0xF723B2B4)},
    {"ct0006.shp", "-", int32_t(0x00000000), int32_t(0xC6CBA829)},
    {"ct0007.shp", "-", int32_t(0x00000000), int32_t(0x60BCA39D)},
    {"ct0008.shp", "-", int32_t(0x00000000), int32_t(0x96F4D374)},
    {"ct0009.shp", "-", int32_t(0x00000000), int32_t(0x3083D8C0)},
    {"ct0010.shp", "-", int32_t(0x00000000), int32_t(0x69B19D8D)},
    {"ct0011.shp", "-", int32_t(0x00000000), int32_t(0xCFC69639)},
    {"ct0012.shp", "-", int32_t(0x00000000), int32_t(0xFE2E8CA4)},
    {"ct0013.shp", "-", int32_t(0x00000000), int32_t(0x58598710)},
    {"ct0014.shp", "-", int32_t(0x00000000), int32_t(0x9DFEB99E)},
    {"ct0015.shp", "-", int32_t(0x00000000), int32_t(0x3B89B22A)},
    {"ct0016.shp", "-", int32_t(0x00000000), int32_t(0x0A61A8B7)},
    {"ct0017.shp", "-", int32_t(0x00000000), int32_t(0xAC16A303)},
    {"ct0018.shp", "-", int32_t(0x00000000), int32_t(0x5A5ED3EA)},
    {"ct0019.shp", "-", int32_t(0x00000000), int32_t(0xFC29D85E)},
    {"ct0020.shp", "-", int32_t(0x00000000), int32_t(0xE73E9A6E)},
    {"ct0021.shp", "-", int32_t(0x00000000), int32_t(0x414991DA)},
    {"ct01-min.set", "", int32_t(0xB5993E95), int32_t(0x00000000)},
    {"ct01.vqa", "", int32_t(0xA3B1FEB4), int32_t(0x00000000)},
    {"ct01_0.vqa", "", int32_t(0x711DF31C), int32_t(0x00000000)},
    {"ct01_1.vqa", "", int32_t(0x711DF51C), int32_t(0x00000000)},
    {"ct01_2.vqa", "", int32_t(0x711DF71C), int32_t(0x00000000)},
    {"ct01_3.vqa", "", int32_t(0x711DF91C), int32_t(0x00000000)},
    {"ct01spnr.vqa", "", int32_t(0xAAAF47E1), int32_t(0x00000000)},
    {"ct01vo1a.aud", "", int32_t(0x8B7930E7), int32_t(0x00000000)},
    {"ct02-min.set", "", int32_t(0xB9993E95), int32_t(0x00000000)},
    {"ct02.vqa", "", int32_t(0xA5B1FEB4), int32_t(0x00000000)},
    {"ct02_0.vqa", "", int32_t(0x751DF31C), int32_t(0x00000000)},
    {"ct02_1.vqa", "", int32_t(0x751DF51C), int32_t(0x00000000)},
    {"ct02_2.vqa", "", int32_t(0x751DF71C), int32_t(0x00000000)},
    {"ct02_3.vqa", "", int32_t(0x751DF91C), int32_t(0x00000000)},
    {"ct02over.vqa", "", int32_t(0xAE9D53D9), int32_t(0x00000000)},
    {"ct03-min.set", "", int32_t(0xBD993E95), int32_t(0x00000000)},
    {"ct03.vqa", "", int32_t(0xA7B1FEB4), int32_t(0x00000000)},
    {"ct03_0.vqa", "", int32_t(0x791DF31C), int32_t(0x00000000)},
    {"ct03_1.vqa", "", int32_t(0x791DF51C), int32_t(0x00000000)},
    {"ct03_2.vqa", "", int32_t(0x791DF71C), int32_t(0x00000000)},
    {"ct03_3.vqa", "", int32_t(0x791DF91C), int32_t(0x00000000)},
    {"ct04-min.set", "", int32_t(0xC1993E95), int32_t(0x00000000)},
    {"ct04.vqa", "", int32_t(0xA9B1FEB4), int32_t(0x00000000)},
    {"ct04_0.vqa", "", int32_t(0x7D1DF31C), int32_t(0x00000000)},
    {"ct04_1.vqa", "", int32_t(0x7D1DF51C), int32_t(0x00000000)},
    {"ct04_2.vqa", "", int32_t(0x7D1DF71C), int32_t(0x00000000)},
    {"ct04_3.vqa", "", int32_t(0x7D1DF91C), int32_t(0x00000000)},
    {"ct05-min.set", "", int32_t(0xC5993E95), int32_t(0x00000000)},
    {"ct05.vqa", "", int32_t(0xABB1FEB4), int32_t(0x00000000)},
    {"ct05_0.vqa", "", int32_t(0x811DF31C), int32_t(0x00000000)},
    {"ct05_1.vqa", "", int32_t(0x811DF51C), int32_t(0x00000000)},
    {"ct05_2.vqa", "", int32_t(0x811DF71C), int32_t(0x00000000)},
    {"ct05_3.vqa", "", int32_t(0x811DF91C), int32_t(0x00000000)},
    {"ct05over.vqa", "", int32_t(0xBA9D53D9), int32_t(0x00000000)},
    {"ct06-min.set", "", int32_t(0xC9993E95), int32_t(0x00000000)},
    {"ct06.vqa", "", int32_t(0xADB1FEB4), int32_t(0x00000000)},
    {"ct06_0.vqa", "", int32_t(0x851DF31C), int32_t(0x00000000)},
    {"ct06_1.vqa", "", int32_t(0x851DF51C), int32_t(0x00000000)},
    {"ct06_2.vqa", "", int32_t(0x851DF71C), int32_t(0x00000000)},
    {"ct06_3.vqa", "", int32_t(0x851DF91C), int32_t(0x00000000)},
    {"ct07-min.set", "", int32_t(0xCD993E95), int32_t(0x00000000)},
    {"ct07.vqa", "", int32_t(0xAFB1FEB4), int32_t(0x00000000)},
    {"ct07_0.vqa", "", int32_t(0x891DF31C), int32_t(0x00000000)},
    {"ct07_1.vqa", "", int32_t(0x891DF51C), int32_t(0x00000000)},
    {"ct07_2.vqa", "", int32_t(0x891DF71C), int32_t(0x00000000)},
    {"ct07_3.vqa", "", int32_t(0x891DF91C), int32_t(0x00000000)},
    {"ct08-min.set", "", int32_t(0xD1993E95), int32_t(0x00000000)},
    {"ct08.vqa", "", int32_t(0xB1B1FEB4), int32_t(0x00000000)},
    {"ct08_0.vqa", "", int32_t(0x8D1DF31C), int32_t(0x00000000)},
    {"ct08_1.vqa", "", int32_t(0x8D1DF51C), int32_t(0x00000000)},
    {"ct08_2.vqa", "", int32_t(0x8D1DF71C), int32_t(0x00000000)},
    {"ct08_3.vqa", "", int32_t(0x8D1DF91C), int32_t(0x00000000)},
    {"ct09-min.set", "", int32_t(0xD5993E95), int32_t(0x00000000)},
    {"ct09.vqa", "", int32_t(0xB3B1FEB4), int32_t(0x00000000)},
    {"ct09_0.vqa", "", int32_t(0x911DF31C), int32_t(0x00000000)},
    {"ct09_1.vqa", "", int32_t(0x911DF51C), int32_t(0x00000000)},
    {"ct09_2.vqa", "", int32_t(0x911DF71C), int32_t(0x00000000)},
    {"ct09_3.vqa", "", int32_t(0x911DF91C), int32_t(0x00000000)},
    {"ct10-min.set", "", int32_t(0xB19D3E95), int32_t(0x00000000)},
    {"ct10.vqa", "", int32_t(0xA1B3FEB4), int32_t(0x00000000)},
    {"ct10_0.vqa", "", int32_t(0x6D21F31C), int32_t(0x00000000)},
    {"ct10_1.vqa", "", int32_t(0x6D21F51C), int32_t(0x00000000)},
    {"ct10_2.vqa", "", int32_t(0x6D21F71C), int32_t(0x00000000)},
    {"ct10_3.vqa", "", int32_t(0x6D21F91C), int32_t(0x00000000)},
    {"ct11-min.set", "", int32_t(0xB59D3E95), int32_t(0x00000000)},
    {"ct11.vqa", "", int32_t(0xA3B3FEB4), int32_t(0x00000000)},
    {"ct11_0.vqa", "", int32_t(0x7121F31C), int32_t(0x00000000)},
    {"ct11_1.vqa", "", int32_t(0x7121F51C), int32_t(0x00000000)},
    {"ct11_2.vqa", "", int32_t(0x7121F71C), int32_t(0x00000000)},
    {"ct11_3.vqa", "", int32_t(0x7121F91C), int32_t(0x00000000)},
    {"ct12-min.set", "", int32_t(0xB99D3E95), int32_t(0x00000000)},
    {"ct12.vqa", "", int32_t(0xA5B3FEB4), int32_t(0x00000000)},
    {"ct12_0.vqa", "", int32_t(0x7521F31C), int32_t(0x00000000)},
    {"ct12_1.vqa", "", int32_t(0x7521F51C), int32_t(0x00000000)},
    {"ct12_2.vqa", "", int32_t(0x7521F71C), int32_t(0x00000000)},
    {"ct12_3.vqa", "", int32_t(0x7521F91C), int32_t(0x00000000)},
    {"ct51-min.set", "", int32_t(0xB5AD3E95), int32_t(0x00000000)},
    {"ct51.vqa", "", int32_t(0xA3BBFEB4), int32_t(0x00000000)},
    {"ct51_0.vqa", "", int32_t(0x7131F31C), int32_t(0x00000000)},
    {"ct51_1.vqa", "", int32_t(0x7131F51C), int32_t(0x00000000)},
    {"ct51_2.vqa", "", int32_t(0x7131F71C), int32_t(0x00000000)},
    {"ct51_3.vqa", "", int32_t(0x7131F91C), int32_t(0x00000000)},
    {"ctairp.shp", "", int32_t(0x00000000), int32_t(0xF9E8ED18)},
    {"ctairp_a.shp", "", int32_t(0x00000000), int32_t(0x2647DEC1)},
    {"ctairp_f.shp", "", int32_t(0x00000000), int32_t(0x946702D1)},
    {"ctambl1.aud", "", int32_t(0x91AC3ED2), int32_t(0x00000000)},
    {"ctambr1.aud", "", int32_t(0x91AC4AD2), int32_t(0x00000000)},
    {"ctaray.shp", "-", int32_t(0x00000000), int32_t(0xB0D142AF)},
    {"ctaray_a.shp", "-", int32_t(0x00000000), int32_t(0x6F7E7176)},
    {"ctaray_b.shp", "-", int32_t(0x00000000), int32_t(0x28DE0BA6)},
    {"ctaray_c.shp", "-", int32_t(0x00000000), int32_t(0x15BE2216)},
    {"ctaray_d.shp", "-", int32_t(0x00000000), int32_t(0xA79EFE06)},
    {"ctarmr.shp", "-", int32_t(0x00000000), int32_t(0xE579031A)},
    {"ctarmr_a.shp", "-", int32_t(0x00000000), int32_t(0x3AD630C3)},
    {"ctarmy01.shp", "", int32_t(0x00000000), int32_t(0x38A13979)},
    {"ctarmy02.shp", "", int32_t(0x00000000), int32_t(0x7F0143A9)},
    {"ctarmy03.shp", "", int32_t(0x00000000), int32_t(0x42616A19)},
    {"ctarmy04.shp", "", int32_t(0x00000000), int32_t(0xF041B609)},
    {"ctbarn02.shp", "", int32_t(0x00000000), int32_t(0x069907D9)},
    {"ctbarr01.shp", "", int32_t(0x00000000), int32_t(0xE1478BB3)},
    {"ctbarr02.shp", "", int32_t(0x00000000), int32_t(0xA6E7F163)},
    {"ctbhut.shp", "-", int32_t(0x00000000), int32_t(0xFB2E6F52)},
    {"ctbunk01.shp", "", int32_t(0x00000000), int32_t(0xC93965B7)},
    {"ctbunk02.shp", "", int32_t(0x00000000), int32_t(0x8E991F67)},
    {"ctbunk03.shp", "", int32_t(0x00000000), int32_t(0xB3F936D7)},
    {"ctbunk04.shp", "", int32_t(0x00000000), int32_t(0x01D9EAC7)},
    {"ctchig01.shp", "", int32_t(0x00000000), int32_t(0xB611C8C2)},
    {"ctchig02.shp", "", int32_t(0x00000000), int32_t(0xF1B1B212)},
    {"ctchig03.shp", "", int32_t(0x00000000), int32_t(0xCCD19BA2)},
    {"ctchig05.shp", "", int32_t(0x00000000), int32_t(0x43916E02)},
    {"ctchig05d.shp", "", int32_t(0x00000000), int32_t(0xA081107A)},
    {"ctcity01.shp", "", int32_t(0x00000000), int32_t(0x71351FE8)},
    {"ctcity02.shp", "", int32_t(0x00000000), int32_t(0x36956538)},
    {"ctcity03.shp", "", int32_t(0x00000000), int32_t(0x0BF54C88)},
    {"ctcity04.shp", "", int32_t(0x00000000), int32_t(0xB9D59098)},
    {"ctcolo01.shp", "", int32_t(0x00000000), int32_t(0xA97FE508)},
    {"ctcrsh01.shp", "-", int32_t(0x00000000), int32_t(0x94CC5D27)},
    {"ctcrsh02.shp", "-", int32_t(0x00000000), int32_t(0xD36C27F7)},
    {"ctcrsh03.shp", "-", int32_t(0x00000000), int32_t(0xEE0C0E47)},
    {"ctcrsh04.shp", "-", int32_t(0x00000000), int32_t(0x5C2CD257)},
    {"ctcrsh05.shp", "-", int32_t(0x00000000), int32_t(0x614CFBE7)},
    {"ctcufgl.shp", "", int32_t(0x00000000), int32_t(0x55B11E66)},
    {"ctcufgl_a.shp", "", int32_t(0x00000000), int32_t(0x4CE629E7)},
    {"ctdam.shp", "-", int32_t(0x00000000), int32_t(0x7E6B284E)},
    {"ctdam_a.shp", "-", int32_t(0x00000000), int32_t(0xF384CB43)},
    {"ctdam_b.shp", "-", int32_t(0x00000000), int32_t(0x7510B9ED)},
    {"ctdrone1.aud", "", int32_t(0xEFF12ED9), int32_t(0x00000000)},
    {"cteast01.shp", "", int32_t(0x00000000), int32_t(0xACE1A56E)},
    {"cteast01dm.shp", "", int32_t(0x00000000), int32_t(0x2AE1D5FC)},
    {"ctech.shp", "-", int32_t(0x00000000), int32_t(0xF7BF6592)},
    {"cteur04.shp", "", int32_t(0x00000000), int32_t(0x6EE030F9)},
    {"cteur1.shp", "", int32_t(0x00000000), int32_t(0x9736BB56)},
    {"cteur2.shp", "", int32_t(0x00000000), int32_t(0xA6DEA1CB)},
    {"cteuro05.shp", "", int32_t(0x00000000), int32_t(0x013ED879)},
    {"ctfarm01.shp", "", int32_t(0x00000000), int32_t(0x793AC7EE)},
    {"ctfarm02.shp", "", int32_t(0x00000000), int32_t(0x3E9ABD3E)},
    {"ctfarm06.shp", "", int32_t(0x00000000), int32_t(0xCB1A1BFE)},
    {"ctfncb.shp", "", int32_t(0x00000000), int32_t(0x3F0527FA)},
    {"ctfncp.shp", "", int32_t(0x00000000), int32_t(0xCF44AA1D)},
    {"ctfncw.shp", "", int32_t(0x00000000), int32_t(0x0AE39493)},
    {"ctfrfgl.shp", "", int32_t(0x00000000), int32_t(0xD7F9B8EB)},
    {"ctfrfgl_a.shp", "", int32_t(0x00000000), int32_t(0xB53641D2)},
    {"ctfrma.shp", "", int32_t(0x00000000), int32_t(0x51939E30)},
    {"ctfrmb.shp", "", int32_t(0x00000000), int32_t(0x607B84AD)},
    {"ctgard01.shp", "", int32_t(0x00000000), int32_t(0x0360E903)},
    {"ctgard03.shp", "", int32_t(0x00000000), int32_t(0x79A0BA63)},
    {"ctgas01.shp", "", int32_t(0x00000000), int32_t(0x075E6294)},
    {"ctgefgl.shp", "", int32_t(0x00000000), int32_t(0xF09AFC6D)},
    {"ctgefgl_a.shp", "", int32_t(0x00000000), int32_t(0xE14D0026)},
    {"ctgrd1_a.shp", "", int32_t(0x00000000), int32_t(0x92D90DD7)},
    {"cthang.aud", "c&c thang", int32_t(0x877E23FE), int32_t(0x00000000)},
    {"cthosp.shp", "-", int32_t(0x00000000), int32_t(0xBA4DBFC6)},
    {"cthosp_a.shp", "-", int32_t(0x00000000), int32_t(0x65E28C1F)},
    {"cthosp_f.shp", "", int32_t(0x00000000), int32_t(0xD7C2500F)},
    {"cthse01.shp", "", int32_t(0x00000000), int32_t(0xCEB76B42)},
    {"cthse02.shp", "", int32_t(0x00000000), int32_t(0x482319EC)},
    {"cthse03.shp", "", int32_t(0x00000000), int32_t(0x837FCA49)},
    {"cthse04.shp", "", int32_t(0x00000000), int32_t(0x9E7AFAF1)},
    {"cthse05.shp", "", int32_t(0x00000000), int32_t(0x55262954)},
    {"cthse06.shp", "", int32_t(0x00000000), int32_t(0xD3B25BFA)},
    {"cthse07.shp", "", int32_t(0x00000000), int32_t(0x18EE885F)},
    {"ctibsun.pcx", "-", int32_t(0x00000000), int32_t(0xD5D978B3)},
    {"ctibsunh.pcx", "-", int32_t(0x00000000), int32_t(0x03A4733E)},
    {"ctind01.shp", "", int32_t(0x00000000), int32_t(0xB050A5C4)},
    {"ctirfgl.shp", "", int32_t(0x00000000), int32_t(0x26F2E366)},
    {"ctirfgl_a.shp", "", int32_t(0x00000000), int32_t(0xE3A2F524)},
    {"ctkrmw.shp", "", int32_t(0x00000000), int32_t(0xA063BC74)},
    {"ctla14.shp", "", int32_t(0x00000000), int32_t(0x96530B1E)},
    {"ctla15.shp", "", int32_t(0x00000000), int32_t(0x302400AA)},
    {"ctlab.shp", "", int32_t(0x00000000), int32_t(0xB49C7A16)},
    {"ctlbfgl.shp", "", int32_t(0x00000000), int32_t(0x6C1B6A53)},
    {"ctlbfgl_a.shp", "", int32_t(0x00000000), int32_t(0xD3063D93)},
    {"ctlit01e.shp", "", int32_t(0x00000000), int32_t(0x591ED8F9)},
    {"ctlit01n.shp", "", int32_t(0x00000000), int32_t(0x2ECEE9E8)},
    {"ctlit01s.shp", "", int32_t(0x00000000), int32_t(0xB6BEBADB)},
    {"ctlit01w.shp", "", int32_t(0x00000000), int32_t(0x433E1C1B)},
    {"ctlit02l.shp", "", int32_t(0x00000000), int32_t(0xD29AC826)},
    {"ctlit02r.shp", "", int32_t(0x00000000), int32_t(0x0D4AE1C5)},
    {"ctlit03e.shp", "", int32_t(0x00000000), int32_t(0x14D679F2)},
    {"ctlit03n.shp", "", int32_t(0x00000000), int32_t(0x630648E3)},
    {"ctlit03s.shp", "", int32_t(0x00000000), int32_t(0xFB761BD0)},
    {"ctlit03w.shp", "", int32_t(0x00000000), int32_t(0x0EF6BD10)},
    {"ctlond02.shp", "", int32_t(0x00000000), int32_t(0x5FF697D2)},
    {"ctlond06.shp", "", int32_t(0x00000000), int32_t(0xAA763112)},
    {"ctmex01.shp", "", int32_t(0x00000000), int32_t(0x10FABF07)},
    {"ctmex02.shp", "", int32_t(0x00000000), int32_t(0x966ECDA9)},
    {"ctmex03.shp", "", int32_t(0x00000000), int32_t(0x5D321E0C)},
    {"ctmex04.shp", "", int32_t(0x00000000), int32_t(0x40372EB4)},
    {"ctmex05.shp", "", int32_t(0x00000000), int32_t(0x8B6BFD11)},
    {"ctmiam01.shp", "", int32_t(0x00000000), int32_t(0xC836A8C9)},
    {"ctmiam02.shp", "", int32_t(0x00000000), int32_t(0x8F96D219)},
    {"ctmiam03.shp", "", int32_t(0x00000000), int32_t(0xB2F6FBA9)},
    {"ctmiam04.shp", "", int32_t(0x00000000), int32_t(0x00D627B9)},
    {"ctmiam05.shp", "", int32_t(0x00000000), int32_t(0x3DB60E09)},
    {"ctmiam06.shp", "", int32_t(0x00000000), int32_t(0x7A1674D9)},
    {"ctmiam07.shp", "", int32_t(0x00000000), int32_t(0x47765D69)},
    {"ctmiam08.shp", "", int32_t(0x00000000), int32_t(0xC526CAB8)},
    {"ctmisc01.shp", "", int32_t(0x00000000), int32_t(0xA697E5C2)},
    {"ctmisc02.shp", "", int32_t(0x00000000), int32_t(0xE1379F12)},
    {"ctmisc03.shp", "", int32_t(0x00000000), int32_t(0xDC57B6A2)},
    {"ctmisc04.shp", "", int32_t(0x00000000), int32_t(0x6E776AB2)},
    {"ctmisc05.shp", "", int32_t(0x00000000), int32_t(0x53174302)},
    {"ctmisc06.shp", "", int32_t(0x00000000), int32_t(0x14B739D2)},
    {"ctmoon01.shp", "", int32_t(0x00000000), int32_t(0x9F4ED9EC)},
    {"ctmov01.shp", "", int32_t(0x00000000), int32_t(0x905E27AB)},
    {"ctmov01_a.shp", "", int32_t(0x00000000), int32_t(0xD193183F)},
    {"ctmov02.shp", "", int32_t(0x00000000), int32_t(0x16CA5505)},
    {"ctmov02_a.shp", "", int32_t(0x00000000), int32_t(0x3AA4A33C)},
    {"ctmsc01.shp", "", int32_t(0x00000000), int32_t(0xEEF1A981)},
    {"ctmsc02.shp", "", int32_t(0x00000000), int32_t(0x6865DB2F)},
    {"ctmsc03.shp", "", int32_t(0x00000000), int32_t(0xA339088A)},
    {"ctmsc04.shp", "", int32_t(0x00000000), int32_t(0xBE3C3832)},
    {"ctmsc05.shp", "", int32_t(0x00000000), int32_t(0x7560EB97)},
    {"ctmsc06.shp", "", int32_t(0x00000000), int32_t(0xF3F49939)},
    {"ctmsc06a.shp", "", int32_t(0x00000000), int32_t(0x11C9D562)},
    {"ctmsc07.shp", "", int32_t(0x00000000), int32_t(0x38A84A9C)},
    {"ctmsc08.shp", "", int32_t(0x00000000), int32_t(0xC9FEF849)},
    {"ctmsc09.shp", "", int32_t(0x00000000), int32_t(0x02A22BEC)},
    {"ctmsc10.shp", "", int32_t(0x00000000), int32_t(0x83DA7190)},
    {"ctmsc11.shp", "", int32_t(0x00000000), int32_t(0x4886A235)},
    {"ctmsc12.shp", "", int32_t(0x00000000), int32_t(0xCE12D09B)},
    {"ctmsc13.shp", "", int32_t(0x00000000), int32_t(0x054E033E)},
    {"ctnewy01.shp", "", int32_t(0x00000000), int32_t(0xEC7060AF)},
    {"ctnewy05.shp", "", int32_t(0x00000000), int32_t(0x19F0C66F)},
    {"ctnewy06.shp", "", int32_t(0x00000000), int32_t(0x5E50BCBF)},
    {"ctnewy07.shp", "", int32_t(0x00000000), int32_t(0x6330950F)},
    {"ctnewy08.shp", "", int32_t(0x00000000), int32_t(0xE16002DE)},
    {"ctnewy10.shp", "", int32_t(0x00000000), int32_t(0x1A4C9ABA)},
    {"ctnewy11.shp", "", int32_t(0x00000000), int32_t(0x272CB30A)},
    {"ctnewy12.shp", "", int32_t(0x00000000), int32_t(0x608CC9DA)},
    {"ctnewy13.shp", "", int32_t(0x00000000), int32_t(0x5DECE06A)},
    {"ctnewy14.shp", "", int32_t(0x00000000), int32_t(0xEFCC3C7A)},
    {"ctnewy15.shp", "", int32_t(0x00000000), int32_t(0xD2AC15CA)},
    {"ctnewy16.shp", "", int32_t(0x00000000), int32_t(0x950C6F1A)},
    {"ctnewy17.shp", "", int32_t(0x00000000), int32_t(0xA86C46AA)},
    {"ctnewy18.shp", "", int32_t(0x00000000), int32_t(0x2A3CD17B)},
    {"ctnewy20.shp", "", int32_t(0x00000000), int32_t(0x9CD8E814)},
    {"ctnewy21.shp", "", int32_t(0x00000000), int32_t(0xA1B8C1A4)},
    {"ctnk.shp", "unit: chrono tank", int32_t(0xE6E4FBB4), int32_t(0x00000000)},
    {"ctnkfgl.shp", "", int32_t(0x00000000), int32_t(0xC44D0C35)},
    {"ctnkfgl_a.shp", "", int32_t(0x00000000), int32_t(0xB5FDF3D6)},
    {"ctnkicon.shp", "icon: chrono tank", int32_t(0x1A202ACD), int32_t(0x00000000)},
    {"ctnwy05.shp", "", int32_t(0x00000000), int32_t(0x2EC02C7B)},
    {"ctnwy09.shp", "", int32_t(0x00000000), int32_t(0x5902EC00)},
    {"ctnwy22.shp", "", int32_t(0x00000000), int32_t(0xA45A0DEA)},
    {"ctnwy23.shp", "", int32_t(0x00000000), int32_t(0x6F06DE4F)},
    {"ctnwy24.shp", "", int32_t(0x00000000), int32_t(0x7203EEF7)},
    {"ctnwy25.shp", "", int32_t(0x00000000), int32_t(0xB95F3D52)},
    {"ctnwy26.shp", "", int32_t(0x00000000), int32_t(0x3FCB4FFC)},
    {"ctoild.shp", "", int32_t(0x00000000), int32_t(0x1D81466F)},
    {"ctoild_a.shp", "", int32_t(0x00000000), int32_t(0xC22E75B6)},
    {"ctoild_f.shp", "", int32_t(0x00000000), int32_t(0x700EA9A6)},
    {"ctoutp.shp", "", int32_t(0x00000000), int32_t(0x6BBA6549)},
    {"ctoutp_a.shp", "", int32_t(0x00000000), int32_t(0xB4155690)},
    {"ctoutp_b.shp", "", int32_t(0x00000000), int32_t(0xF3B52C40)},
    {"ctoutp_c.shp", "", int32_t(0x00000000), int32_t(0xCED505F0)},
    {"ctoutp_d.shp", "", int32_t(0x00000000), int32_t(0x7CF5D9E0)},
    {"ctoutp_f.shp", "", int32_t(0x00000000), int32_t(0x06358A80)},
    {"ctoutpbb.shp", "", int32_t(0x00000000), int32_t(0x4CFD3D05)},
    {"ctpark01.shp", "", int32_t(0x00000000), int32_t(0x305A037B)},
    {"ctpark02.shp", "", int32_t(0x00000000), int32_t(0x77FA79AB)},
    {"ctpark03.shp", "", int32_t(0x00000000), int32_t(0x4A9A501B)},
    {"ctpars02.shp", "", int32_t(0x00000000), int32_t(0x23CBAB02)},
    {"ctpars04.shp", "", int32_t(0x00000000), int32_t(0xAC8B5EA2)},
    {"ctpars05.shp", "", int32_t(0x00000000), int32_t(0x91EB7712)},
    {"ctpars06.shp", "", int32_t(0x00000000), int32_t(0xD64B0DC2)},
    {"ctpars07.shp", "", int32_t(0x00000000), int32_t(0xEB2B2472)},
    {"ctpars08.shp", "", int32_t(0x00000000), int32_t(0x697BB3A3)},
    {"ctpars09.shp", "", int32_t(0x00000000), int32_t(0x541B9A13)},
    {"ctpars10.shp", "", int32_t(0x00000000), int32_t(0x92572BC7)},
    {"ctpars12.shp", "", int32_t(0x00000000), int32_t(0xE89778A7)},
    {"ctpars12d.shp", "", int32_t(0x00000000), int32_t(0xD5C1FB69)},
    {"ctpars13.shp", "", int32_t(0x00000000), int32_t(0xD5F75117)},
    {"ctpars14.shp", "", int32_t(0x00000000), int32_t(0x67D78D07)},
    {"ctpol01e.shp", "", int32_t(0x00000000), int32_t(0xB8C8EA8B)},
    {"ctpol01n.shp", "", int32_t(0x00000000), int32_t(0xCF18DB9A)},
    {"ctpol01s.shp", "", int32_t(0x00000000), int32_t(0x576888A9)},
    {"ctpol01w.shp", "", int32_t(0x00000000), int32_t(0xA2E82E69)},
    {"ctprs03.shp", "", int32_t(0x00000000), int32_t(0x1AA927BA)},
    {"ctpyr01.shp", "-", int32_t(0x00000000), int32_t(0x199E18F2)},
    {"ctpyr02.shp", "-", int32_t(0x00000000), int32_t(0x9F0A6A5C)},
    {"ctpyr03.shp", "-", int32_t(0x00000000), int32_t(0x5456B9F9)},
    {"ctr_btn.shp", "", int32_t(0xDA3641E4), int32_t(0x00000000)},
    {"ctr_in.shp", "", int32_t(0x23A63DE6), int32_t(0x00000000)},
    {"ctr_out.shp", "", int32_t(0xDA4243FE), int32_t(0x00000000)},
    {"ctr_spin.shp", "", int32_t(0x6A2444E0), int32_t(0x00000000)},
    {"ctrain1.aud", "", int32_t(0x61F042E0), int32_t(0x00000000)},
    {"ctroofl1.aud", "", int32_t(0xE4371ED9), int32_t(0x00000000)},
    {"ctroofr1.aud", "", int32_t(0xE4431ED9), int32_t(0x00000000)},
    {"ctrufgl.shp", "", int32_t(0x00000000), int32_t(0x9DDDF4B0)},
    {"ctrufgl_a.shp", "", int32_t(0x00000000), int32_t(0xB75BF4FD)},
    {"ctrunoff.aud", "", int32_t(0x262B30D7), int32_t(0x00000000)},
    {"ctrus02a.shp", "", int32_t(0x00000000), int32_t(0x535C05B0)},
    {"ctrus02b.shp", "", int32_t(0x00000000), int32_t(0x14FC7F60)},
    {"ctrus02c.shp", "", int32_t(0x00000000), int32_t(0x299C56D0)},
    {"ctrus02d.shp", "", int32_t(0x00000000), int32_t(0x9BBC8AC0)},
    {"ctrus02e.shp", "", int32_t(0x00000000), int32_t(0xA6DCA370)},
    {"ctrus02f.shp", "", int32_t(0x00000000), int32_t(0xE17CD9A0)},
    {"ctrus02g.shp", "", int32_t(0x00000000), int32_t(0xDC1CF010)},
    {"ctrus03.shp", "", int32_t(0x00000000), int32_t(0x7A3D9A4E)},
    {"ctrus04.shp", "", int32_t(0x00000000), int32_t(0x6738AAF6)},
    {"ctrus05.shp", "", int32_t(0x00000000), int32_t(0xAC647953)},
    {"ctrus06.shp", "", int32_t(0x00000000), int32_t(0x2AF00BFD)},
    {"ctrus07.shp", "", int32_t(0x00000000), int32_t(0xE1ACD858)},
    {"ctrus08.shp", "", int32_t(0x00000000), int32_t(0x10FA6A8D)},
    {"ctrus09.shp", "", int32_t(0x00000000), int32_t(0xDBA6B928)},
    {"ctrus10.shp", "", int32_t(0x00000000), int32_t(0x5ADEE354)},
    {"ctrus11.shp", "", int32_t(0x00000000), int32_t(0x918230F1)},
    {"ctsanf01.shp", "", int32_t(0x00000000), int32_t(0x91AEFDDC)},
    {"ctsanf02.shp", "", int32_t(0x00000000), int32_t(0xD60E870C)},
    {"ctsanf03.shp", "", int32_t(0x00000000), int32_t(0xEB6EAEBC)},
    {"ctsanf04.shp", "", int32_t(0x00000000), int32_t(0x594E72AC)},
    {"ctsanf05.shp", "", int32_t(0x00000000), int32_t(0x642E5B1C)},
    {"ctsanf06.shp", "", int32_t(0x00000000), int32_t(0x238E21CC)},
    {"ctsanf07.shp", "", int32_t(0x00000000), int32_t(0x1EEE087C)},
    {"ctsanf08.shp", "", int32_t(0x00000000), int32_t(0x9CBE9FAD)},
    {"ctsanf09.shp", "", int32_t(0x00000000), int32_t(0xA1DEB61D)},
    {"ctsanf10.shp", "", int32_t(0x00000000), int32_t(0x679207C9)},
    {"ctsanf11.shp", "", int32_t(0x00000000), int32_t(0x5AF22E79)},
    {"ctsanf12.shp", "", int32_t(0x00000000), int32_t(0x1D5254A9)},
    {"ctsanf13.shp", "", int32_t(0x00000000), int32_t(0x20327D19)},
    {"ctsanf14.shp", "", int32_t(0x00000000), int32_t(0x9212A109)},
    {"ctsanf15.shp", "", int32_t(0x00000000), int32_t(0xAF7288B9)},
    {"ctsanf16.shp", "", int32_t(0x00000000), int32_t(0xE8D2F269)},
    {"ctsanf17.shp", "", int32_t(0x00000000), int32_t(0xD5B2DBD9)},
    {"ctsanf18.shp", "", int32_t(0x00000000), int32_t(0x57E24C08)},
    {"ctseat01.shp", "", int32_t(0x00000000), int32_t(0xE523339B)},
    {"ctseat02.shp", "", int32_t(0x00000000), int32_t(0xA283494B)},
    {"ctseat02_a.shp", "", int32_t(0x00000000), int32_t(0x4BF7C01F)},
    {"ctsin03e.shp", "", int32_t(0x00000000), int32_t(0x2F088E74)},
    {"ctsin03s.shp", "", int32_t(0x00000000), int32_t(0xC0A8EC56)},
    {"ctskfgl.shp", "", int32_t(0x00000000), int32_t(0x161D066D)},
    {"ctskfgl_a.shp", "", int32_t(0x00000000), int32_t(0x64B5BFE1)},
    {"ctstl01.shp", "", int32_t(0x00000000), int32_t(0x6AD767BF)},
    {"ctstl02.shp", "", int32_t(0x00000000), int32_t(0xEC431511)},
    {"ctstl03.shp", "", int32_t(0x00000000), int32_t(0x271FC6B4)},
    {"ctstl05a.shp", "", int32_t(0x00000000), int32_t(0x137B69F2)},
    {"ctstl05b.shp", "", int32_t(0x00000000), int32_t(0x54DB1322)},
    {"ctstl05c.shp", "", int32_t(0x00000000), int32_t(0x69BB3A92)},
    {"ctstl05d.shp", "", int32_t(0x00000000), int32_t(0xDB9BE682)},
    {"ctstl05e.shp", "", int32_t(0x00000000), int32_t(0xE6FBCF32)},
    {"ctstl05f.shp", "", int32_t(0x00000000), int32_t(0xA15BB5E2)},
    {"ctstl05g.shp", "", int32_t(0x00000000), int32_t(0x9C3B9C52)},
    {"ctstl05h.shp", "", int32_t(0x00000000), int32_t(0x1E6B0B83)},
    {"ctstrt01.shp", "", int32_t(0x00000000), int32_t(0xACAC5361)},
    {"ctstrt05.shp", "", int32_t(0x00000000), int32_t(0x592CF5A1)},
    {"ctswst01.shp", "", int32_t(0x00000000), int32_t(0x598B6F3A)},
    {"ctsydn01.shp", "", int32_t(0x00000000), int32_t(0x24994F1A)},
    {"ctsydn02.shp", "", int32_t(0x00000000), int32_t(0x633935CA)},
    {"ctsydn03.shp", "", int32_t(0x00000000), int32_t(0x5E591C7A)},
    {"cttech01.shp", "", int32_t(0x00000000), int32_t(0xE5A4D925)},
    {"cttexs01.shp", "", int32_t(0x00000000), int32_t(0xA1AC3C6C)},
    {"cttexs02.shp", "", int32_t(0x00000000), int32_t(0xE60C46BC)},
    {"cttexs03.shp", "", int32_t(0x00000000), int32_t(0xDB6C6F0C)},
    {"cttexs04.shp", "", int32_t(0x00000000), int32_t(0x694CB31C)},
    {"cttexs05.shp", "", int32_t(0x00000000), int32_t(0x542C9AAC)},
    {"cttexs06.shp", "", int32_t(0x00000000), int32_t(0x138CE07C)},
    {"cttexs07.shp", "", int32_t(0x00000000), int32_t(0x2EECC9CC)},
    {"cttexs08.shp", "", int32_t(0x00000000), int32_t(0xACBC5E1D)},
    {"ctthosp.shp", "", int32_t(0x00000000), int32_t(0x358640C7)},
    {"cttr03dm.shp", "", int32_t(0x00000000), int32_t(0x4D24A626)},
    {"cttran01.shp", "", int32_t(0x00000000), int32_t(0x0CF0C4DA)},
    {"cttran02.shp", "", int32_t(0x00000000), int32_t(0x4B50BE0A)},
    {"cttran03.shp", "", int32_t(0x00000000), int32_t(0x763097BA)},
    {"ctts01.shp", "", int32_t(0x00000000), int32_t(0xBE8E8FCC)},
    {"ctukfgl.shp", "", int32_t(0x00000000), int32_t(0x1B03762A)},
    {"ctukfgl_a.shp", "", int32_t(0x00000000), int32_t(0x9C77F457)},
    {"cturb01.shp", "", int32_t(0x00000000), int32_t(0x01597C40)},
    {"cturb02.shp", "", int32_t(0x00000000), int32_t(0x87CD0EEE)},
    {"cturb03.shp", "", int32_t(0x00000000), int32_t(0x4C91DD4B)},
    {"ctusfgl.shp", "", int32_t(0x00000000), int32_t(0x0C1B9643)},
    {"ctusfgl_a.shp", "", int32_t(0x00000000), int32_t(0x727381E0)},
    {"ctvega.shp", "-", int32_t(0x00000000), int32_t(0x2F5C2CA8)},
    {"ctwa19_a.shp", "", int32_t(0x00000000), int32_t(0xF7652318)},
    {"ctwa2a.shp", "", int32_t(0x00000000), int32_t(0x79C2896E)},
    {"ctwa2b.shp", "", int32_t(0x00000000), int32_t(0x482A93F3)},
    {"ctwa2c.shp", "", int32_t(0x00000000), int32_t(0xEE5D9847)},
    {"ctwa2d.shp", "", int32_t(0x00000000), int32_t(0x2BFAA6C9)},
    {"ctwash03.shp", "", int32_t(0x00000000), int32_t(0x55045161)},
    {"ctwash04.shp", "", int32_t(0x00000000), int32_t(0xE7248D71)},
    {"ctwash05.shp", "", int32_t(0x00000000), int32_t(0xDA44A4C1)},
    {"ctwash06.shp", "", int32_t(0x00000000), int32_t(0x9DE4DE11)},
    {"ctwash07.shp", "", int32_t(0x00000000), int32_t(0xA084F7A1)},
    {"ctwash08.shp", "", int32_t(0x00000000), int32_t(0x22D46070)},
    {"ctwash09.shp", "", int32_t(0x00000000), int32_t(0x1FB449C0)},
    {"ctwash10.shp", "", int32_t(0x00000000), int32_t(0xD9F8F814)},
    {"ctwash11.shp", "", int32_t(0x00000000), int32_t(0xE498D1A4)},
    {"ctwash13.shp", "", int32_t(0x00000000), int32_t(0x9E5882C4)},
    {"ctwash16.shp", "", int32_t(0x00000000), int32_t(0x56B80DB4)},
    {"ctwash17.shp", "", int32_t(0x00000000), int32_t(0x6BD82404)},
    {"ctwash18.shp", "", int32_t(0x00000000), int32_t(0xE988B3D5)},
    {"ctwash19.shp", "", int32_t(0x00000000), int32_t(0xD4E89A65)},
    {"ctwsh18a.shp", "", int32_t(0x00000000), int32_t(0xE052B2D1)},
    {"ctwt01.shp", "", int32_t(0x00000000), int32_t(0x31D85906)},
    {"cuairp.shp", "", int32_t(0x00000000), int32_t(0x386632D8)},
    {"cuairp_a.shp", "", int32_t(0x00000000), int32_t(0xE7C90101)},
    {"cuairp_f.shp", "", int32_t(0x00000000), int32_t(0x55E9DD11)},
    {"cuarmy01.shp", "", int32_t(0x00000000), int32_t(0xF92FE6B9)},
    {"cuarmy02.shp", "", int32_t(0x00000000), int32_t(0xBE8F9C69)},
    {"cuarmy03.shp", "", int32_t(0x00000000), int32_t(0x83EFB5D9)},
    {"cuarmy04.shp", "", int32_t(0x00000000), int32_t(0x31CF69C9)},
    {"cubarn02.shp", "", int32_t(0x00000000), int32_t(0xC717D819)},
    {"cubarr01.shp", "", int32_t(0x00000000), int32_t(0x20C95473)},
    {"cubarr02.shp", "", int32_t(0x00000000), int32_t(0x67692EA3)},
    {"cubhut.shp", "", int32_t(0x00000000), int32_t(0x3AA0B092)},
    {"cubunk01.shp", "", int32_t(0x00000000), int32_t(0x08B7BA77)},
    {"cubunk02.shp", "", int32_t(0x00000000), int32_t(0x4F17C0A7)},
    {"cubunk03.shp", "", int32_t(0x00000000), int32_t(0x7277E917)},
    {"cubunk04.shp", "", int32_t(0x00000000), int32_t(0xC0573507)},
    {"cuchig01.shp", "", int32_t(0x00000000), int32_t(0x779F1702)},
    {"cuchig02.shp", "", int32_t(0x00000000), int32_t(0x303F6DD2)},
    {"cuchig03.shp", "", int32_t(0x00000000), int32_t(0x0D5F4462)},
    {"cuchig05.shp", "", int32_t(0x00000000), int32_t(0x821FB1C2)},
    {"cuchig05d.shp", "", int32_t(0x00000000), int32_t(0x197ACB92)},
    {"cucity01.shp", "", int32_t(0x00000000), int32_t(0xB0BBC028)},
    {"cucity02.shp", "", int32_t(0x00000000), int32_t(0xF71BBAF8)},
    {"cucity03.shp", "", int32_t(0x00000000), int32_t(0xCA7B9348)},
    {"cucity04.shp", "", int32_t(0x00000000), int32_t(0x785B4F58)},
    {"cucolo01.shp", "", int32_t(0x00000000), int32_t(0x68F13AC8)},
    {"cucufgl.shp", "", int32_t(0x00000000), int32_t(0x943FC1A6)},
    {"cucufgl_a.shp", "", int32_t(0x00000000), int32_t(0xF51DF20F)},
    {"cud_i.pcx", "-", int32_t(0x00000000), int32_t(0xAD5F09FD)},
    {"cue_i.pcx", "-", int32_t(0x00000000), int32_t(0x429D62C3)},
    {"cueast01.shp", "", int32_t(0x00000000), int32_t(0x6D6F7AAE)},
    {"cueast01dm.shp", "", int32_t(0x00000000), int32_t(0x931A0E14)},
    {"cueast02.shp", "", int32_t(0x00000000), int32_t(0x2ACF007E)},
    {"cueur04.shp", "", int32_t(0x00000000), int32_t(0xAF6EEF39)},
    {"cueur1.shp", "", int32_t(0x00000000), int32_t(0x56B86496)},
    {"cueur2.shp", "", int32_t(0x00000000), int32_t(0x67507E0B)},
    {"cueuro05.shp", "", int32_t(0x00000000), int32_t(0xC0B007B9)},
    {"cufarm01.shp", "", int32_t(0x00000000), int32_t(0xB8B4182E)},
    {"cufarm02.shp", "", int32_t(0x00000000), int32_t(0xFF1462FE)},
    {"cufarm06.shp", "", int32_t(0x00000000), int32_t(0x0A94C43E)},
    {"cufncb.shp", "", int32_t(0x00000000), int32_t(0xFE8BF83A)},
    {"cufncp.shp", "", int32_t(0x00000000), int32_t(0x0ECA75DD)},
    {"cufncw.shp", "", int32_t(0x00000000), int32_t(0xCB6D4B53)},
    {"cufrfgl.shp", "", int32_t(0x00000000), int32_t(0x1677672B)},
    {"cufrfgl_a.shp", "", int32_t(0x00000000), int32_t(0x0CCD9A3A)},
    {"cufrma.shp", "", int32_t(0x00000000), int32_t(0x901D41F0)},
    {"cufrmb.shp", "", int32_t(0x00000000), int32_t(0xA1F55B6D)},
    {"cugard01.shp", "", int32_t(0x00000000), int32_t(0xC2EE36C3)},
    {"cugard03.shp", "", int32_t(0x00000000), int32_t(0xB82E65A3)},
    {"cugas01.shp", "", int32_t(0x00000000), int32_t(0xC6D0BD54)},
    {"cugefgl.shp", "", int32_t(0x00000000), int32_t(0x311423AD)},
    {"cugefgl_a.shp", "", int32_t(0x00000000), int32_t(0x58B6DBCE)},
    {"cugrd1_a.shp", "", int32_t(0x00000000), int32_t(0x5357D217)},
    {"cuhosp.shp", "", int32_t(0x00000000), int32_t(0x7BC36006)},
    {"cuhosp_a.shp", "", int32_t(0x00000000), int32_t(0xA46C53DF)},
    {"cuhosp_f.shp", "", int32_t(0x00000000), int32_t(0x164C8FCF)},
    {"cuhse01.shp", "", int32_t(0x00000000), int32_t(0x0F39B482)},
    {"cuhse02.shp", "", int32_t(0x00000000), int32_t(0x89ADC62C)},
    {"cuhse03.shp", "", int32_t(0x00000000), int32_t(0x42F11589)},
    {"cuhse04.shp", "", int32_t(0x00000000), int32_t(0x5FF42531)},
    {"cuhse05.shp", "", int32_t(0x00000000), int32_t(0x94A8F694)},
    {"cuhse06.shp", "", int32_t(0x00000000), int32_t(0x123C843A)},
    {"cuhse07.shp", "", int32_t(0x00000000), int32_t(0xD960579F)},
    {"cuind01.shp", "", int32_t(0x00000000), int32_t(0x71DE7A04)},
    {"cuirfgl.shp", "", int32_t(0x00000000), int32_t(0xE77C3CA6)},
    {"cuirfgl_a.shp", "", int32_t(0x00000000), int32_t(0x5A592ECC)},
    {"cukrmw.shp", "", int32_t(0x00000000), int32_t(0x61ED63B4)},
    {"cula01.shp", "", int32_t(0x00000000), int32_t(0xC94FFBE7)},
    {"cula02.shp", "", int32_t(0x00000000), int32_t(0xF8A7E17A)},
    {"cula03.shp", "", int32_t(0x00000000), int32_t(0x5ED0EACE)},
    {"cula04.shp", "", int32_t(0x00000000), int32_t(0x9B77D440)},
    {"cula05.shp", "", int32_t(0x00000000), int32_t(0x3D00DFF4)},
    {"cula07.shp", "", int32_t(0x00000000), int32_t(0xAA9FCEDD)},
    {"cula09.shp", "", int32_t(0x00000000), int32_t(0xFAA0B580)},
    {"cula11.shp", "", int32_t(0x00000000), int32_t(0x05E5FB79)},
    {"cula12.shp", "", int32_t(0x00000000), int32_t(0x340DE1E4)},
    {"cula13.shp", "", int32_t(0x00000000), int32_t(0x927AEA50)},
    {"cula14.shp", "", int32_t(0x00000000), int32_t(0x57DDD4DE)},
    {"cula15.shp", "", int32_t(0x00000000), int32_t(0xF1AADF6A)},
    {"culab.shp", "", int32_t(0x00000000), int32_t(0x7512A5D6)},
    {"culbfgl.shp", "", int32_t(0x00000000), int32_t(0xAD95B593)},
    {"culbfgl_a.shp", "", int32_t(0x00000000), int32_t(0x6AFDE67B)},
    {"culit01e.shp", "", int32_t(0x00000000), int32_t(0x98900739)},
    {"culit01n.shp", "", int32_t(0x00000000), int32_t(0xEF403628)},
    {"culit01s.shp", "", int32_t(0x00000000), int32_t(0x7730651B)},
    {"culit01w.shp", "", int32_t(0x00000000), int32_t(0x82B0C3DB)},
    {"culit02l.shp", "", int32_t(0x00000000), int32_t(0x131417E6)},
    {"culit02r.shp", "", int32_t(0x00000000), int32_t(0xCCC43E05)},
    {"culit03e.shp", "", int32_t(0x00000000), int32_t(0xD558A632)},
    {"culit03n.shp", "", int32_t(0x00000000), int32_t(0xA2889723)},
    {"culit03s.shp", "", int32_t(0x00000000), int32_t(0x3AF8C410)},
    {"culit03w.shp", "", int32_t(0x00000000), int32_t(0xCF7862D0)},
    {"cumex01.shp", "", int32_t(0x00000000), int32_t(0xD17460C7)},
    {"cumex02.shp", "", int32_t(0x00000000), int32_t(0x57E01269)},
    {"cumex03.shp", "", int32_t(0x00000000), int32_t(0x9CBCC1CC)},
    {"cumex04.shp", "", int32_t(0x00000000), int32_t(0x81B9F174)},
    {"cumex05.shp", "", int32_t(0x00000000), int32_t(0x4AE522D1)},
    {"cumiam01.shp", "", int32_t(0x00000000), int32_t(0x09B87709)},
    {"cumiam02.shp", "", int32_t(0x00000000), int32_t(0x4E180DD9)},
    {"cumiam03.shp", "", int32_t(0x00000000), int32_t(0x73782469)},
    {"cumiam04.shp", "", int32_t(0x00000000), int32_t(0xC158F879)},
    {"cumiam05.shp", "", int32_t(0x00000000), int32_t(0xFC38D1C9)},
    {"cumiam06.shp", "", int32_t(0x00000000), int32_t(0xBB98AB19)},
    {"cumiam07.shp", "", int32_t(0x00000000), int32_t(0x86F882A9)},
    {"cumiam08.shp", "", int32_t(0x00000000), int32_t(0x04A81578)},
    {"cumisc01.shp", "", int32_t(0x00000000), int32_t(0x67193A02)},
    {"cumisc02.shp", "", int32_t(0x00000000), int32_t(0x20B940D2)},
    {"cumisc03.shp", "", int32_t(0x00000000), int32_t(0x1DD96962)},
    {"cumisc04.shp", "", int32_t(0x00000000), int32_t(0xAFF9B572)},
    {"cumisc05.shp", "", int32_t(0x00000000), int32_t(0x92999CC2)},
    {"cumisc06.shp", "", int32_t(0x00000000), int32_t(0xD539E612)},
    {"cumoon01.shp", "", int32_t(0x00000000), int32_t(0x5EC0062C)},
    {"cumorr05.shp", "", int32_t(0x00000000), int32_t(0xEC8072AC)},
    {"cumov01.shp", "", int32_t(0x00000000), int32_t(0x51D0F86B)},
    {"cumov01_a.shp", "", int32_t(0x00000000), int32_t(0x6868C3D7)},
    {"cumov02.shp", "", int32_t(0x00000000), int32_t(0xD7448AC5)},
    {"cumov02_a.shp", "", int32_t(0x00000000), int32_t(0x835F78D4)},
    {"cumsc01.shp", "", int32_t(0x00000000), int32_t(0x2F7F7641)},
    {"cumsc02.shp", "", int32_t(0x00000000), int32_t(0xA9EB04EF)},
    {"cumsc03.shp", "", int32_t(0x00000000), int32_t(0x62B7D74A)},
    {"cumsc04.shp", "", int32_t(0x00000000), int32_t(0x7FB2E7F2)},
    {"cumsc05.shp", "", int32_t(0x00000000), int32_t(0xB4EE3457)},
    {"cumsc06.shp", "", int32_t(0x00000000), int32_t(0x327A46F9)},
    {"cumsc06a.shp", "", int32_t(0x00000000), int32_t(0xD0470AA2)},
    {"cumsc07.shp", "", int32_t(0x00000000), int32_t(0xF926955C)},
    {"cumsc08.shp", "", int32_t(0x00000000), int32_t(0x08702789)},
    {"cumsc09.shp", "", int32_t(0x00000000), int32_t(0xC32CF42C)},
    {"cumsc10.shp", "", int32_t(0x00000000), int32_t(0x4254AE50)},
    {"cumsc11.shp", "", int32_t(0x00000000), int32_t(0x89087DF5)},
    {"cumsc12.shp", "", int32_t(0x00000000), int32_t(0x0F9C0F5B)},
    {"cumsc13.shp", "", int32_t(0x00000000), int32_t(0xC4C0DCFE)},
    {"cunewy01.shp", "", int32_t(0x00000000), int32_t(0x2DFEBF6F)},
    {"cunewy05.shp", "", int32_t(0x00000000), int32_t(0xD87E19AF)},
    {"cunewy06.shp", "", int32_t(0x00000000), int32_t(0x9FDE637F)},
    {"cunewy07.shp", "", int32_t(0x00000000), int32_t(0xA2BE4ACF)},
    {"cunewy08.shp", "", int32_t(0x00000000), int32_t(0x20EEDD1E)},
    {"cunewy10.shp", "", int32_t(0x00000000), int32_t(0xDBC2457A)},
    {"cunewy11.shp", "", int32_t(0x00000000), int32_t(0xE6A26CCA)},
    {"cunewy12.shp", "", int32_t(0x00000000), int32_t(0xA102161A)},
    {"cunewy13.shp", "", int32_t(0x00000000), int32_t(0x9C623FAA)},
    {"cunewy14.shp", "", int32_t(0x00000000), int32_t(0x2E42E3BA)},
    {"cunewy15.shp", "", int32_t(0x00000000), int32_t(0x1322CA0A)},
    {"cunewy16.shp", "", int32_t(0x00000000), int32_t(0x5482B0DA)},
    {"cunewy17.shp", "", int32_t(0x00000000), int32_t(0x69E2996A)},
    {"cunewy18.shp", "", int32_t(0x00000000), int32_t(0xEBB20EBB)},
    {"cunewy20.shp", "", int32_t(0x00000000), int32_t(0x5D5637D4)},
    {"cunewy21.shp", "", int32_t(0x00000000), int32_t(0x60361E64)},
    {"cunkfgl.shp", "", int32_t(0x00000000), int32_t(0x05C3D3F5)},
    {"cunkfgl_a.shp", "", int32_t(0x00000000), int32_t(0x0C06283E)},
    {"cunwy05.shp", "", int32_t(0x00000000), int32_t(0xEF4EF3BB)},
    {"cunwy09.shp", "", int32_t(0x00000000), int32_t(0x988C33C0)},
    {"cunwy22.shp", "", int32_t(0x00000000), int32_t(0x65D4D22A)},
    {"cunwy23.shp", "", int32_t(0x00000000), int32_t(0xAE88018F)},
    {"cunwy24.shp", "", int32_t(0x00000000), int32_t(0xB38D3137)},
    {"cunwy25.shp", "", int32_t(0x00000000), int32_t(0x78D1E292)},
    {"cunwy26.shp", "", int32_t(0x00000000), int32_t(0xFE45903C)},
    {"cuoild.shp", "", int32_t(0x00000000), int32_t(0xDC0F99AF)},
    {"cuoild_a.shp", "", int32_t(0x00000000), int32_t(0x03A0AA76)},
    {"cuoild_f.shp", "", int32_t(0x00000000), int32_t(0xB1807666)},
    {"cuoutp.shp", "", int32_t(0x00000000), int32_t(0xAA34BA89)},
    {"cuoutp_a.shp", "", int32_t(0x00000000), int32_t(0x759B8950)},
    {"cuoutp_b.shp", "", int32_t(0x00000000), int32_t(0x323BF380)},
    {"cuoutp_c.shp", "", int32_t(0x00000000), int32_t(0x0F5BDA30)},
    {"cuoutp_d.shp", "", int32_t(0x00000000), int32_t(0xBD7B0620)},
    {"cuoutp_f.shp", "", int32_t(0x00000000), int32_t(0xC7BB5540)},
    {"cuoutpbb.shp", "", int32_t(0x00000000), int32_t(0x8D73E2C5)},
    {"cupark01.shp", "", int32_t(0x00000000), int32_t(0xF1D4DCBB)},
    {"cupark02.shp", "", int32_t(0x00000000), int32_t(0xB674A66B)},
    {"cupark03.shp", "", int32_t(0x00000000), int32_t(0x8B148FDB)},
    {"cupars02.shp", "", int32_t(0x00000000), int32_t(0xE24574C2)},
    {"cupars04.shp", "", int32_t(0x00000000), int32_t(0x6D058162)},
    {"cupars05.shp", "", int32_t(0x00000000), int32_t(0x5065A8D2)},
    {"cupars06.shp", "", int32_t(0x00000000), int32_t(0x17C5D202)},
    {"cupars07.shp", "", int32_t(0x00000000), int32_t(0x2AA5FBB2)},
    {"cupars08.shp", "", int32_t(0x00000000), int32_t(0xA8F56C63)},
    {"cupars09.shp", "", int32_t(0x00000000), int32_t(0x959545D3)},
    {"cupars10.shp", "", int32_t(0x00000000), int32_t(0x53D9F407)},
    {"cupars12.shp", "", int32_t(0x00000000), int32_t(0x2919A767)},
    {"cupars12d.shp", "", int32_t(0x00000000), int32_t(0x6C3A2081)},
    {"cupars13.shp", "", int32_t(0x00000000), int32_t(0x14798ED7)},
    {"cupars14.shp", "", int32_t(0x00000000), int32_t(0xA65952C7)},
    {"cupol01e.shp", "", int32_t(0x00000000), int32_t(0x7946354B)},
    {"cupol01n.shp", "", int32_t(0x00000000), int32_t(0x0E96045A)},
    {"cupol01s.shp", "", int32_t(0x00000000), int32_t(0x96E65769)},
    {"cupol01w.shp", "", int32_t(0x00000000), int32_t(0x6366F1A9)},
    {"cupowr.shp", "", int32_t(0x00000000), int32_t(0x5C6FBEC9)},
    {"cuprs03.shp", "", int32_t(0x00000000), int32_t(0xDB27F87A)},
    {"curr01.shp", "-", int32_t(0x00000000), int32_t(0x65653408)},
    {"curse.csv", "", int32_t(0xF3CFB1ED), int32_t(0x00000000)},
    {"curse.lsv", "", int32_t(0xF3E1B1ED), int32_t(0x00000000)},
    {"curse.vqa", "", int32_t(0xEFF5B1D8), int32_t(0x00000000)},
    {"curse_e.vqa", "", int32_t(0xAA1564ED), int32_t(0x00000000)},
    {"curse_e.vqt", "", int32_t(0xAA2864ED), int32_t(0x00000000)},
    {"curse_h.pcx", "", int32_t(0xAA3256E7), int32_t(0x00000000)},
    {"curse_h.vqa", "", int32_t(0xAA1B64ED), int32_t(0x00000000)},
    {"curse_l.pcx", "", int32_t(0xAA3A56E7), int32_t(0x00000000)},
    {"curse_l.vqa", "", int32_t(0xAA2364ED), int32_t(0x00000000)},
    {"cursor.bmp", "", int32_t(0xD1A649F8), int32_t(0xA7044F80)},
    {"curtain1.aud", "", int32_t(0xF83B28BD), int32_t(0x00000000)},
    {"curtcurs.shp", "", int32_t(0x00000000), int32_t(0x324857E2)},
    {"curufgl.shp", "", int32_t(0x00000000), int32_t(0x5C532B70)},
    {"curufgl_a.shp", "", int32_t(0x00000000), int32_t(0x0EA02F15)},
    {"curus02a.shp", "", int32_t(0x00000000), int32_t(0x92D2DA70)},
    {"curus02b.shp", "", int32_t(0x00000000), int32_t(0xD572A0A0)},
    {"curus02c.shp", "", int32_t(0x00000000), int32_t(0xE8128910)},
    {"curus02d.shp", "", int32_t(0x00000000), int32_t(0x5A325500)},
    {"curus02e.shp", "", int32_t(0x00000000), int32_t(0x67527CB0)},
    {"curus02f.shp", "", int32_t(0x00000000), int32_t(0x20F20660)},
    {"curus02g.shp", "", int32_t(0x00000000), int32_t(0x1D922FD0)},
    {"curus03.shp", "", int32_t(0x00000000), int32_t(0xBBB3458E)},
    {"curus04.shp", "", int32_t(0x00000000), int32_t(0xA6B67536)},
    {"curus05.shp", "", int32_t(0x00000000), int32_t(0x6DEAA693)},
    {"curus06.shp", "", int32_t(0x00000000), int32_t(0xEB7ED43D)},
    {"curus07.shp", "", int32_t(0x00000000), int32_t(0x20220798)},
    {"curus08.shp", "", int32_t(0x00000000), int32_t(0xD174B54D)},
    {"curus09.shp", "", int32_t(0x00000000), int32_t(0x1A2866E8)},
    {"curus10.shp", "", int32_t(0x00000000), int32_t(0x9B503C94)},
    {"curus11.shp", "", int32_t(0x00000000), int32_t(0x500CEF31)},
    {"cusanf01.shp", "", int32_t(0x00000000), int32_t(0x5020221C)},
    {"cusanf02.shp", "", int32_t(0x00000000), int32_t(0x178058CC)},
    {"cusanf03.shp", "", int32_t(0x00000000), int32_t(0x2AE0717C)},
    {"cusanf04.shp", "", int32_t(0x00000000), int32_t(0x98C0AD6C)},
    {"cusanf05.shp", "", int32_t(0x00000000), int32_t(0xA5A084DC)},
    {"cusanf06.shp", "", int32_t(0x00000000), int32_t(0xE200FE0C)},
    {"cusanf07.shp", "", int32_t(0x00000000), int32_t(0xDF60D7BC)},
    {"cusanf08.shp", "", int32_t(0x00000000), int32_t(0x5D30406D)},
    {"cusanf09.shp", "", int32_t(0x00000000), int32_t(0x605069DD)},
    {"cusanf10.shp", "", int32_t(0x00000000), int32_t(0xA61CD809)},
    {"cusanf11.shp", "", int32_t(0x00000000), int32_t(0x9B7CF1B9)},
    {"cusanf12.shp", "", int32_t(0x00000000), int32_t(0xDCDC8B69)},
    {"cusanf13.shp", "", int32_t(0x00000000), int32_t(0xE1BCA2D9)},
    {"cusanf14.shp", "", int32_t(0x00000000), int32_t(0x539C7EC9)},
    {"cusanf15.shp", "", int32_t(0x00000000), int32_t(0x6EFC5779)},
    {"cusanf16.shp", "", int32_t(0x00000000), int32_t(0x295C2DA9)},
    {"cusanf17.shp", "", int32_t(0x00000000), int32_t(0x143C0419)},
    {"cusanf18.shp", "", int32_t(0x00000000), int32_t(0x966C93C8)},
    {"cuseat01.shp", "", int32_t(0x00000000), int32_t(0x24ADEC5B)},
    {"cusin03e.shp", "", int32_t(0x00000000), int32_t(0xEE8651B4)},
    {"cusin03s.shp", "", int32_t(0x00000000), int32_t(0x01263396)},
    {"cuskfgl.shp", "", int32_t(0x00000000), int32_t(0xD793D9AD)},
    {"cuskfgl_a.shp", "", int32_t(0x00000000), int32_t(0xDD4E6409)},
    {"custl01.shp", "", int32_t(0x00000000), int32_t(0xAB59B87F)},
    {"custl02.shp", "", int32_t(0x00000000), int32_t(0x2DCDCAD1)},
    {"custl03.shp", "", int32_t(0x00000000), int32_t(0xE6911974)},
    {"custl05a.shp", "", int32_t(0x00000000), int32_t(0xD2F5B632)},
    {"custl05b.shp", "", int32_t(0x00000000), int32_t(0x9555CCE2)},
    {"custl05c.shp", "", int32_t(0x00000000), int32_t(0xA835E552)},
    {"custl05d.shp", "", int32_t(0x00000000), int32_t(0x1A153942)},
    {"custl05e.shp", "", int32_t(0x00000000), int32_t(0x277510F2)},
    {"custl05f.shp", "", int32_t(0x00000000), int32_t(0x60D56A22)},
    {"custl05g.shp", "", int32_t(0x00000000), int32_t(0x5DB54392)},
    {"custl05h.shp", "", int32_t(0x00000000), int32_t(0xDFE5D443)},
    {"custrt01.shp", "", int32_t(0x00000000), int32_t(0x6D228CA1)},
    {"custrt05.shp", "", int32_t(0x00000000), int32_t(0x98A22A61)},
    {"cuswst01.shp", "", int32_t(0x00000000), int32_t(0x9805B0FA)},
    {"cusydn01.shp", "", int32_t(0x00000000), int32_t(0xE51790DA)},
    {"cusydn02.shp", "", int32_t(0x00000000), int32_t(0xA2B7EA0A)},
    {"cusydn03.shp", "", int32_t(0x00000000), int32_t(0x9FD7C3BA)},
    {"cutech01.shp", "", int32_t(0x00000000), int32_t(0x242A06E5)},
    {"cutexs01.shp", "", int32_t(0x00000000), int32_t(0x6022E3AC)},
    {"cutexs02.shp", "", int32_t(0x00000000), int32_t(0x2782997C)},
    {"cutexs03.shp", "", int32_t(0x00000000), int32_t(0x1AE2B0CC)},
    {"cutexs04.shp", "", int32_t(0x00000000), int32_t(0xA8C26CDC)},
    {"cutexs05.shp", "", int32_t(0x00000000), int32_t(0x95A2456C)},
    {"cutexs06.shp", "", int32_t(0x00000000), int32_t(0xD2023FBC)},
    {"cutexs07.shp", "", int32_t(0x00000000), int32_t(0xEF62160C)},
    {"cutexs08.shp", "", int32_t(0x00000000), int32_t(0x6D3281DD)},
    {"cuthosp.shp", "", int32_t(0x00000000), int32_t(0xF4089F07)},
    {"cutr03dm.shp", "", int32_t(0x00000000), int32_t(0x8CAA79E6)},
    {"cuts01.shp", "", int32_t(0x00000000), int32_t(0x7F00500C)},
    {"cuttin.aud", "", int32_t(0xD3AE35F4), int32_t(0x00000000)},
    {"cuukfgl.shp", "", int32_t(0x00000000), int32_t(0xDA8DA9EA)},
    {"cuukfgl_a.shp", "", int32_t(0x00000000), int32_t(0x258C2FBF)},
    {"cuurb01.shp", "", int32_t(0x00000000), int32_t(0xC0D7A380)},
    {"cuurb02.shp", "", int32_t(0x00000000), int32_t(0x4643D12E)},
    {"cuurb03.shp", "", int32_t(0x00000000), int32_t(0x8D1F028B)},
    {"cuusfgl.shp", "", int32_t(0x00000000), int32_t(0xCD954983)},
    {"cuusfgl_a.shp", "", int32_t(0x00000000), int32_t(0xCB885A08)},
    {"cuwa19_a.shp", "", int32_t(0x00000000), int32_t(0x36EBFCD8)},
    {"cuwa2a.shp", "", int32_t(0x00000000), int32_t(0xB84C56AE)},
    {"cuwa2b.shp", "", int32_t(0x00000000), int32_t(0x89A44C33)},
    {"cuwa2c.shp", "", int32_t(0x00000000), int32_t(0x2FD34787)},
    {"cuwa2d.shp", "", int32_t(0x00000000), int32_t(0xEA747909)},
    {"cuwash03.shp", "", int32_t(0x00000000), int32_t(0x948A8EA1)},
    {"cuwash04.shp", "", int32_t(0x00000000), int32_t(0x26AA52B1)},
    {"cuwash05.shp", "", int32_t(0x00000000), int32_t(0x1BCA7B01)},
    {"cuwash06.shp", "", int32_t(0x00000000), int32_t(0x5C6A01D1)},
    {"cuwash07.shp", "", int32_t(0x00000000), int32_t(0x610A2861)},
    {"cuwash08.shp", "", int32_t(0x00000000), int32_t(0xE35ABFB0)},
    {"cuwash09.shp", "", int32_t(0x00000000), int32_t(0xDE3A9600)},
    {"cuwash10.shp", "", int32_t(0x00000000), int32_t(0x187627D4)},
    {"cuwash11.shp", "", int32_t(0x00000000), int32_t(0x25160E64)},
    {"cuwash13.shp", "", int32_t(0x00000000), int32_t(0x5FD65D04)},
    {"cuwash16.shp", "", int32_t(0x00000000), int32_t(0x9736D274)},
    {"cuwash17.shp", "", int32_t(0x00000000), int32_t(0xAA56FBC4)},
    {"cuwash18.shp", "", int32_t(0x00000000), int32_t(0x28066C15)},
    {"cuwash19.shp", "", int32_t(0x00000000), int32_t(0x156645A5)},
    {"cuwsh18a.shp", "", int32_t(0x00000000), int32_t(0x21DC6D11)},
    {"cuwt01.shp", "", int32_t(0x00000000), int32_t(0xF05686C6)},
    {"cybcicon.shp", "icon: cyborg commando", int32_t(0x00000000), int32_t(0x65AB9C3F)},
    {"cybiicon.shp", "icon: cyborg", int32_t(0x00000000), int32_t(0xF08516A1)},
    {"cyborg.shp", "-", int32_t(0x00000000), int32_t(0x0828C0D6)},
    {"cyc2.shp", "unit: cyborg commando", int32_t(0x00000000), int32_t(0x5B8CF93A)},
    {"cycl.shp", "chain link fence", int32_t(0xE8CF05B4), int32_t(0x1D6EA794)},
    {"cyclicnh.des", "icon: chain link fence", int32_t(0x14EF2FCD), int32_t(0x00000000)},
    {"cyclicnh.tem", "icon: chain link fence", int32_t(0x0EEF3FCD), int32_t(0x00000000)},
    {"cyclicnh.win", "icon: chain link fence", int32_t(0x0FF342CD), int32_t(0x00000000)},
    {"cyclicon.shp", "icon: chain link fence", int32_t(0x1DF43ECD), int32_t(0x55D038D0)},
    {"cygun1.aud", "cyborg fires gun", int32_t(0x00000000), int32_t(0xB3392EDD)},
    {"cylat01.tem", "-", int32_t(0x00000000), int32_t(0x548C1A8B)},
    {"cylat01a.tem", "-", int32_t(0x00000000), int32_t(0x0F359537)},
    {"cylat02.tem", "-", int32_t(0x00000000), int32_t(0xD2186825)},
    {"cylat02a.tem", "-", int32_t(0x00000000), int32_t(0x89A1E799)},
    {"cylat03.tem", "-", int32_t(0x00000000), int32_t(0x1944BB80)},
    {"cylat03a.tem", "-", int32_t(0x00000000), int32_t(0x42FD343C)},
    {"cylat04.tem", "-", int32_t(0x00000000), int32_t(0x04418B38)},
    {"cylat04a.tem", "-", int32_t(0x00000000), int32_t(0x5FF80484)},
    {"cylat05.tem", "-", int32_t(0x00000000), int32_t(0xCF1D589D)},
    {"cylat05a.tem", "-", int32_t(0x00000000), int32_t(0x94A4D721)},
    {"cylat06.tem", "-", int32_t(0x00000000), int32_t(0x49892A33)},
    {"cylat06a.tem", "-", int32_t(0x00000000), int32_t(0x1230A58F)},
    {"cylat07.tem", "-", int32_t(0x00000000), int32_t(0x82D5F996)},
    {"cylat07a.tem", "-", int32_t(0x00000000), int32_t(0xD96C762A)},
    {"cylat08.tem", "-", int32_t(0x00000000), int32_t(0x73834B43)},
    {"cylat08a.tem", "-", int32_t(0x00000000), int32_t(0x283AC4FF)},
    {"cylat09.tem", "-", int32_t(0x00000000), int32_t(0xB8DF98E6)},
    {"cylat09a.tem", "-", int32_t(0x00000000), int32_t(0xE366175A)},
    {"cylat10.tem", "-", int32_t(0x00000000), int32_t(0x39A7C29A)},
    {"cylat10a.tem", "-", int32_t(0x00000000), int32_t(0x621E4D26)},
    {"cylat11.tem", "-", int32_t(0x00000000), int32_t(0xF2FB113F)},
    {"cylat11a.tem", "-", int32_t(0x00000000), int32_t(0xA9429E83)},
    {"cylat12.tem", "-", int32_t(0x00000000), int32_t(0x746F6391)},
    {"cylat12a.tem", "-", int32_t(0x00000000), int32_t(0x2FD6EC2D)},
    {"cylat13.tem", "-", int32_t(0x00000000), int32_t(0xBF33B034)},
    {"cylat13a.tem", "-", int32_t(0x00000000), int32_t(0xE48A3F88)},
    {"cylat14.tem", "-", int32_t(0x00000000), int32_t(0xA236808C)},
    {"cylat14a.tem", "-", int32_t(0x00000000), int32_t(0xF98F0F30)},
    {"cylat15.tem", "-", int32_t(0x00000000), int32_t(0x696A5329)},
    {"cylat15a.tem", "-", int32_t(0x00000000), int32_t(0x32D3DC95)},
    {"cylat16.tem", "-", int32_t(0x00000000), int32_t(0xEFFE2187)},
    {"cylat16a.tem", "-", int32_t(0x00000000), int32_t(0xB447AE3B)},
    {"cyur001.wav", "", int32_t(0x00000000), int32_t(0xF251ACF4)},
    {"cyur002.wav", "", int32_t(0x00000000), int32_t(0x74C5DE5A)},
    {"cyur003.wav", "", int32_t(0x00000000), int32_t(0xBF990DFF)},
    {"cyur004.wav", "", int32_t(0x00000000), int32_t(0xA29C3D47)},
    {"cyur005.wav", "", int32_t(0x00000000), int32_t(0x69C0EEE2)},
    {"cyur006.wav", "", int32_t(0x00000000), int32_t(0xEF549C4C)},
    {"cyur007.wav", "", int32_t(0x00000000), int32_t(0x24084FE9)},
    {"cyur008.wav", "", int32_t(0x00000000), int32_t(0xD55EFD3C)},
    {"cyur009.wav", "", int32_t(0x00000000), int32_t(0x1E022E99)},
    {"cyur010.wav", "", int32_t(0x00000000), int32_t(0x9F7A74E5)},
    {"cyur011.wav", "", int32_t(0x00000000), int32_t(0x5426A740)},
    {"cyur012.wav", "", int32_t(0x00000000), int32_t(0xD2B2D5EE)},
    {"cyur013.wav", "", int32_t(0x00000000), int32_t(0x19EE064B)},
    {"cyur014.wav", "", int32_t(0x00000000), int32_t(0x04EB36F3)},
    {"cyur015.wav", "", int32_t(0x00000000), int32_t(0xCFB7E556)},
    {"cyur016.wav", "", int32_t(0x00000000), int32_t(0x492397F8)},
    {"cyur017.wav", "", int32_t(0x00000000), int32_t(0x827F445D)},
    {"cyur018.wav", "", int32_t(0x00000000), int32_t(0x7329F688)},
    {"cyur019.wav", "", int32_t(0x00000000), int32_t(0xB875252D)},
    {"cyur020.wav", "", int32_t(0x00000000), int32_t(0xAE926E78)},
    {"cyur021.wav", "", int32_t(0x00000000), int32_t(0x65CEBDDD)},
    {"cyur022.wav", "", int32_t(0x00000000), int32_t(0xE35ACF73)},
    {"cyur023.wav", "", int32_t(0x00000000), int32_t(0x28061CD6)},
    {"cyur024.wav", "", int32_t(0x00000000), int32_t(0x35032C6E)},
    {"cyur025.wav", "", int32_t(0x00000000), int32_t(0xFE5FFFCB)},
    {"cyur026.wav", "", int32_t(0x00000000), int32_t(0x78CB8D65)},
    {"cyur027.wav", "", int32_t(0x00000000), int32_t(0xB3975EC0)},
    {"cyur028.wav", "", int32_t(0x00000000), int32_t(0x42C1EC15)},
    {"cyur029.wav", "", int32_t(0x00000000), int32_t(0x899D3FB0)},
    {"cyur030.wav", "", int32_t(0x00000000), int32_t(0x08E565CC)},
    {"cyur031.wav", "", int32_t(0x00000000), int32_t(0xC3B9B669)},
    {"cyur032.wav", "", int32_t(0x00000000), int32_t(0x452DC4C7)},
    {"cyur033.wav", "", int32_t(0x00000000), int32_t(0x8E711762)},
    {"cyur035.wav", "", int32_t(0x00000000), int32_t(0x5828F47F)},
    {"cyur036.wav", "", int32_t(0x00000000), int32_t(0xDEBC86D1)},
    {"cyur037.wav", "", int32_t(0x00000000), int32_t(0x15E05574)},
    {"cyur038.wav", "", int32_t(0x00000000), int32_t(0xE4B6E7A1)},
    {"cyur039.wav", "", int32_t(0x00000000), int32_t(0x2FEA3404)},
    {"cyur040.wav", "", int32_t(0x00000000), int32_t(0xCD425B42)},
    {"cyur041.wav", "", int32_t(0x00000000), int32_t(0x061E88E7)},
    {"cyur042.wav", "", int32_t(0x00000000), int32_t(0x808AFA49)},
    {"cyur043.wav", "", int32_t(0x00000000), int32_t(0x4BD629EC)},
    {"cyur044.wav", "", int32_t(0x00000000), int32_t(0x56D31954)},
    {"cyur045.wav", "", int32_t(0x00000000), int32_t(0x9D8FCAF1)},
    {"cyur046.wav", "", int32_t(0x00000000), int32_t(0x1B1BB85F)},
    {"cyur047.wav", "", int32_t(0x00000000), int32_t(0xD0476BFA)},
    {"cyur048.wav", "", int32_t(0x00000000), int32_t(0x2111D92F)},
    {"cyur049.wav", "", int32_t(0x00000000), int32_t(0xEA4D0A8A)},
    {"cyur050.wav", "", int32_t(0x00000000), int32_t(0x6B3550F6)},
    {"cyur051.wav", "", int32_t(0x00000000), int32_t(0xA0698353)},
    {"cyur052.wav", "", int32_t(0x00000000), int32_t(0x26FDF1FD)},
    {"cyur053.wav", "", int32_t(0x00000000), int32_t(0xEDA12258)},
    {"cyur054.wav", "", int32_t(0x00000000), int32_t(0xF0A412E0)},
    {"cyur055.wav", "", int32_t(0x00000000), int32_t(0x3BF8C145)},
    {"cyur056.wav", "", int32_t(0x00000000), int32_t(0xBD6CB3EB)},
    {"cyur057.wav", "", int32_t(0x00000000), int32_t(0x7630604E)},
    {"cyur058.wav", "", int32_t(0x00000000), int32_t(0x8766D29B)},
    {"cyur059.wav", "", int32_t(0x00000000), int32_t(0x4C3A013E)},
    {"cyur060.wav", "", int32_t(0x00000000), int32_t(0x5ADD4A6B)},
    {"cyur061.wav", "", int32_t(0x00000000), int32_t(0x918199CE)},
    {"cyur062.wav", "", int32_t(0x00000000), int32_t(0x1715EB60)},
    {"cyur063.wav", "", int32_t(0x00000000), int32_t(0xDC4938C5)},
    {"cyur064.wav", "", int32_t(0x00000000), int32_t(0xC14C087D)},
    {"cyur065.wav", "", int32_t(0x00000000), int32_t(0x0A10DBD8)},
    {"cyur066.wav", "", int32_t(0x00000000), int32_t(0x8C84A976)},
    {"cyur067.wav", "", int32_t(0x00000000), int32_t(0x47D87AD3)},
    {"cyur068.wav", "", int32_t(0x00000000), int32_t(0xB68EC806)},
    {"cyur069.wav", "", int32_t(0x00000000), int32_t(0x7DD21BA3)},
    {"cyur070.wav", "", int32_t(0x00000000), int32_t(0xFCAA41DF)},
    {"cyur071.wav", "", int32_t(0x00000000), int32_t(0x37F6927A)},
    {"cyur072.wav", "", int32_t(0x00000000), int32_t(0xB162E0D4)},
    {"cyur073.wav", "", int32_t(0x00000000), int32_t(0x7A3E3371)},
    {"cyur074.wav", "", int32_t(0x00000000), int32_t(0x673B03C9)},
    {"cyur075.wav", "", int32_t(0x00000000), int32_t(0xAC67D06C)},
    {"cyur076.wav", "", int32_t(0x00000000), int32_t(0x2AF3A2C2)},
    {"cyur077.wav", "", int32_t(0x00000000), int32_t(0xE1AF7167)},
    {"cyur078.wav", "", int32_t(0x00000000), int32_t(0x10F9C3B2)},
    {"cyur079.wav", "", int32_t(0x00000000), int32_t(0xDBA51017)},
    {"cyur080.wav", "", int32_t(0x00000000), int32_t(0x0AE23136)},
    {"cyur081.wav", "", int32_t(0x00000000), int32_t(0xC1BEE293)},
    {"cyur082.wav", "", int32_t(0x00000000), int32_t(0x472A903D)},
    {"cyur083.wav", "", int32_t(0x00000000), int32_t(0x8C764398)},
    {"cyur084.wav", "", int32_t(0x00000000), int32_t(0x91737320)},
    {"cyur085.wav", "", int32_t(0x00000000), int32_t(0x5A2FA085)},
    {"cyur086.wav", "", int32_t(0x00000000), int32_t(0xDCBBD22B)},
    {"cyur087.wav", "", int32_t(0x00000000), int32_t(0x17E7018E)},
    {"cyur088.wav", "", int32_t(0x00000000), int32_t(0xE6B1B35B)},
    {"cyur089.wav", "", int32_t(0x00000000), int32_t(0x2DED60FE)},
    {"cyur090.wav", "", int32_t(0x00000000), int32_t(0xAC953A82)},
    {"cyur091.wav", "", int32_t(0x00000000), int32_t(0x67C9E927)},
    {"cyur092.wav", "", int32_t(0x00000000), int32_t(0xE15D9B89)},
    {"cyur093.wav", "", int32_t(0x00000000), int32_t(0x2A01482C)},
    {"cyur094.wav", "", int32_t(0x00000000), int32_t(0x37047894)},
    {"cyur095.wav", "", int32_t(0x00000000), int32_t(0xFC58AB31)},
    {"cyur096.wav", "", int32_t(0x00000000), int32_t(0x7ACCD99F)},
    {"cyur097.wav", "", int32_t(0x00000000), int32_t(0xB1900A3A)},
    {"cyur098.wav", "", int32_t(0x00000000), int32_t(0x40C6B8EF)},
    {"cyur099.wav", "", int32_t(0x00000000), int32_t(0x8B9A6B4A)},
    {"cyur100.wav", "", int32_t(0x00000000), int32_t(0xF5A77FCF)},
    {"cyur101.wav", "", int32_t(0x00000000), int32_t(0x3EFBAC6A)},
    {"cyur102.wav", "", int32_t(0x00000000), int32_t(0xB86FDEC4)},
    {"cyur103.wav", "", int32_t(0x00000000), int32_t(0x73330D61)},
    {"cyur104.wav", "", int32_t(0x00000000), int32_t(0x6E363DD9)},
    {"cyur105.wav", "", int32_t(0x00000000), int32_t(0xA56AEE7C)},
    {"cyur106.wav", "", int32_t(0x00000000), int32_t(0x23FE9CD2)},
    {"cyur107.wav", "", int32_t(0x00000000), int32_t(0xE8A24F77)},
    {"cyur108.wav", "", int32_t(0x00000000), int32_t(0x19F4FDA2)},
    {"cyur109.wav", "", int32_t(0x00000000), int32_t(0xD2A82E07)},
    {"cyur120.wav", "", int32_t(0x00000000), int32_t(0x62386EE6)},
    {"cyur121.wav", "", int32_t(0x00000000), int32_t(0xA964BD43)},
    {"cyur122.wav", "", int32_t(0x00000000), int32_t(0x2FF0CFED)},
    {"cyur123.wav", "", int32_t(0x00000000), int32_t(0xE4AC1C48)},
    {"cyur124.wav", "", int32_t(0x00000000), int32_t(0xF9A92CF0)},
    {"cyur125.wav", "", int32_t(0x00000000), int32_t(0x32F5FF55)},
    {"cyur127.wav", "", int32_t(0x00000000), int32_t(0x7F3D5E5E)},
    {"cyur128.wav", "", int32_t(0x00000000), int32_t(0x8E6BEC8B)},
    {"cyur129.wav", "", int32_t(0x00000000), int32_t(0x45373F2E)},
    {"cyur130.wav", "", int32_t(0x00000000), int32_t(0xC44F6552)},
    {"cyur131.wav", "", int32_t(0x00000000), int32_t(0x0F13B6F7)},
    {"cyur132.wav", "", int32_t(0x00000000), int32_t(0x8987C459)},
    {"cyur133.wav", "", int32_t(0x00000000), int32_t(0x42DB17FC)},
    {"cyur134.wav", "", int32_t(0x00000000), int32_t(0x5FDE2744)},
    {"cyur135.wav", "", int32_t(0x00000000), int32_t(0x9482F4E1)},
    {"cyur136.wav", "", int32_t(0x00000000), int32_t(0x1216864F)},
    {"cyur137.wav", "", int32_t(0x00000000), int32_t(0xD94A55EA)},
    {"cyur138.wav", "", int32_t(0x00000000), int32_t(0x281CE73F)},
    {"cyur139.wav", "", int32_t(0x00000000), int32_t(0xE340349A)},
    {"cyur140.wav", "", int32_t(0x00000000), int32_t(0x01E85BDC)},
    {"cyur141.wav", "", int32_t(0x00000000), int32_t(0xCAB48879)},
    {"cyur142.wav", "", int32_t(0x00000000), int32_t(0x4C20FAD7)},
    {"cyur143.wav", "", int32_t(0x00000000), int32_t(0x877C2972)},
    {"cyur151.wav", "", int32_t(0x00000000), int32_t(0x6CC383CD)},
    {"cyur152.wav", "", int32_t(0x00000000), int32_t(0xEA57F163)},
    {"cyur153.wav", "", int32_t(0x00000000), int32_t(0x210B22C6)},
    {"d.shp", "-", int32_t(0x00000000), int32_t(0xAEF1515B)},
    {"d01.des", "road bottom end", int32_t(0x5CB5A5CC), int32_t(0x00000000)},
    {"d01.sno", "road", int32_t(0x5CB1AEDB), int32_t(0x00000000)},
    {"d01.tem", "road bottom end", int32_t(0x5CAFA5DC), int32_t(0x00000000)},
    {"d01.win", "road bottom end", int32_t(0x5CB0A9DF), int32_t(0x00000000)},
    {"d02.des", "road left end", int32_t(0x5CB7A5CC), int32_t(0x00000000)},
    {"d02.sno", "road", int32_t(0x5CB3AEDB), int32_t(0x00000000)},
    {"d02.tem", "road left end", int32_t(0x5CB1A5DC), int32_t(0x00000000)},
    {"d02.win", "road left end", int32_t(0x5CB2A9DF), int32_t(0x00000000)},
    {"d03.des", "road top end", int32_t(0x5CB9A5CC), int32_t(0x00000000)},
    {"d03.sno", "road", int32_t(0x5CB5AEDB), int32_t(0x00000000)},
    {"d03.tem", "road top end", int32_t(0x5CB3A5DC), int32_t(0x00000000)},
    {"d03.win", "road top end", int32_t(0x5CB4A9DF), int32_t(0x00000000)},
    {"d04.des", "road right end", int32_t(0x5CBBA5CC), int32_t(0x00000000)},
    {"d04.sno", "road", int32_t(0x5CB7AEDB), int32_t(0x00000000)},
    {"d04.tem", "road right end", int32_t(0x5CB5A5DC), int32_t(0x00000000)},
    {"d04.win", "road right end", int32_t(0x5CB6A9DF), int32_t(0x00000000)},
    {"d05.des", "road s-n 1", int32_t(0x5CBDA5CC), int32_t(0x00000000)},
    {"d05.sno", "road", int32_t(0x5CB9AEDB), int32_t(0x00000000)},
    {"d05.tem", "road s-n 1", int32_t(0x5CB7A5DC), int32_t(0x00000000)},
    {"d05.win", "road s-n 1", int32_t(0x5CB8A9DF), int32_t(0x00000000)},
    {"d06.des", "road s-n 2", int32_t(0x5CBFA5CC), int32_t(0x00000000)},
    {"d06.sno", "road", int32_t(0x5CBBAEDB), int32_t(0x00000000)},
    {"d06.tem", "road s-n 2", int32_t(0x5CB9A5DC), int32_t(0x00000000)},
    {"d06.win", "road s-n 2", int32_t(0x5CBAA9DF), int32_t(0x00000000)},
    {"d07.des", "road s-n 3", int32_t(0x5CC1A5CC), int32_t(0x00000000)},
    {"d07.sno", "road", int32_t(0x5CBDAEDB), int32_t(0x00000000)},
    {"d07.tem", "road s-n 3", int32_t(0x5CBBA5DC), int32_t(0x00000000)},
    {"d07.win", "road s-n 3", int32_t(0x5CBCA9DF), int32_t(0x00000000)},
    {"d08.des", "road s-n 4", int32_t(0x5CC3A5CC), int32_t(0x00000000)},
    {"d08.sno", "road", int32_t(0x5CBFAEDB), int32_t(0x00000000)},
    {"d08.tem", "road s-n 4", int32_t(0x5CBDA5DC), int32_t(0x00000000)},
    {"d08.win", "road s-n 4", int32_t(0x5CBEA9DF), int32_t(0x00000000)},
    {"d09.des", "road w-e 1", int32_t(0x5CC5A5CC), int32_t(0x00000000)},
    {"d09.sno", "road", int32_t(0x5CC1AEDB), int32_t(0x00000000)},
    {"d09.tem", "road w-e 1", int32_t(0x5CBFA5DC), int32_t(0x00000000)},
    {"d09.win", "road w-e 1", int32_t(0x5CC0A9DF), int32_t(0x00000000)},
    {"d10.des", "road w-e 2", int32_t(0x5CB3A7CC), int32_t(0x00000000)},
    {"d10.sno", "road", int32_t(0x5CAFB0DB), int32_t(0x00000000)},
    {"d10.tem", "road w-e 2", int32_t(0x5CADA7DC), int32_t(0x00000000)},
    {"d10.win", "road w-e 2", int32_t(0x5CAEABDF), int32_t(0x00000000)},
    {"d11.des", "road w-e 3", int32_t(0x5CB5A7CC), int32_t(0x00000000)},
    {"d11.sno", "road", int32_t(0x5CB1B0DB), int32_t(0x00000000)},
    {"d11.tem", "road w-e 3", int32_t(0x5CAFA7DC), int32_t(0x00000000)},
    {"d11.win", "road w-e 3", int32_t(0x5CB0ABDF), int32_t(0x00000000)},
    {"d12.des", "road w-e 4", int32_t(0x5CB7A7CC), int32_t(0x00000000)},
    {"d12.sno", "road", int32_t(0x5CB3B0DB), int32_t(0x00000000)},
    {"d12.tem", "road w-e 4", int32_t(0x5CB1A7DC), int32_t(0x00000000)},
    {"d12.win", "road w-e 4", int32_t(0x5CB2ABDF), int32_t(0x00000000)},
    {"d13.des", "road wu-ed", int32_t(0x5CB9A7CC), int32_t(0x00000000)},
    {"d13.sno", "road", int32_t(0x5CB5B0DB), int32_t(0x00000000)},
    {"d13.tem", "road wu-ed", int32_t(0x5CB3A7DC), int32_t(0x00000000)},
    {"d13.win", "road wu-ed", int32_t(0x5CB4ABDF), int32_t(0x00000000)},
    {"d14.des", "road t n--w+e", int32_t(0x5CBBA7CC), int32_t(0x00000000)},
    {"d14.sno", "road", int32_t(0x5CB7B0DB), int32_t(0x00000000)},
    {"d14.tem", "road t n--w+e", int32_t(0x5CB5A7DC), int32_t(0x00000000)},
    {"d14.win", "road t n--w+e", int32_t(0x5CB6ABDF), int32_t(0x00000000)},
    {"d15.des", "road y s--n+e 1", int32_t(0x5CBDA7CC), int32_t(0x00000000)},
    {"d15.sno", "road", int32_t(0x5CB9B0DB), int32_t(0x00000000)},
    {"d15.tem", "road y s--n+e 1", int32_t(0x5CB7A7DC), int32_t(0x00000000)},
    {"d15.win", "road y s--n+e 1", int32_t(0x5CB8ABDF), int32_t(0x00000000)},
    {"d16.des", "road y s--n+e 2", int32_t(0x5CBFA7CC), int32_t(0x00000000)},
    {"d16.sno", "road", int32_t(0x5CBBB0DB), int32_t(0x00000000)},
    {"d16.tem", "road y s--n+e 2", int32_t(0x5CB9A7DC), int32_t(0x00000000)},
    {"d16.win", "road y s--n+e", int32_t(0x5CBAABDF), int32_t(0x00000000)},
    {"d17.des", "road t s--w+e", int32_t(0x5CC1A7CC), int32_t(0x00000000)},
    {"d17.sno", "road", int32_t(0x5CBDB0DB), int32_t(0x00000000)},
    {"d17.tem", "road t s--w+e", int32_t(0x5CBBA7DC), int32_t(0x00000000)},
    {"d17.win", "road t s--w+e", int32_t(0x5CBCABDF), int32_t(0x00000000)},
    {"d18.des", "road t w--n+s", int32_t(0x5CC3A7CC), int32_t(0x00000000)},
    {"d18.sno", "road", int32_t(0x5CBFB0DB), int32_t(0x00000000)},
    {"d18.tem", "road t w--n+s", int32_t(0x5CBDA7DC), int32_t(0x00000000)},
    {"d18.win", "road t w--n+s", int32_t(0x5CBEABDF), int32_t(0x00000000)},
    {"d19.des", "road + w-n-e-s", int32_t(0x5CC5A7CC), int32_t(0x00000000)},
    {"d19.sno", "road", int32_t(0x5CC1B0DB), int32_t(0x00000000)},
    {"d19.tem", "road + w-n-e-s", int32_t(0x5CBFA7DC), int32_t(0x00000000)},
    {"d19.win", "road + w-n-e-s", int32_t(0x5CC0ABDF), int32_t(0x00000000)},
    {"d20.des", "road corner n-e", int32_t(0x5CB3A9CC), int32_t(0x00000000)},
    {"d20.sno", "road", int32_t(0x5CAFB2DB), int32_t(0x00000000)},
    {"d20.tem", "road corner n-e", int32_t(0x5CADA9DC), int32_t(0x00000000)},
    {"d20.win", "road corner n-e", int32_t(0x5CAEADDF), int32_t(0x00000000)},
    {"d21.des", "road corner s-e", int32_t(0x5CB5A9CC), int32_t(0x00000000)},
    {"d21.sno", "road", int32_t(0x5CB1B2DB), int32_t(0x00000000)},
    {"d21.tem", "road corner s-e", int32_t(0x5CAFA9DC), int32_t(0x00000000)},
    {"d21.win", "road corner s-e", int32_t(0x5CB0ADDF), int32_t(0x00000000)},
    {"d22.des", "road corner w-s", int32_t(0x5CB7A9CC), int32_t(0x00000000)},
    {"d22.sno", "road", int32_t(0x5CB3B2DB), int32_t(0x00000000)},
    {"d22.tem", "road corner w-s", int32_t(0x5CB1A9DC), int32_t(0x00000000)},
    {"d22.win", "road corner w-s", int32_t(0x5CB2ADDF), int32_t(0x00000000)},
    {"d23.des", "road corner w-n", int32_t(0x5CB9A9CC), int32_t(0x00000000)},
    {"d23.sno", "road", int32_t(0x5CB5B2DB), int32_t(0x00000000)},
    {"d23.tem", "road corner w-n", int32_t(0x5CB3A9DC), int32_t(0x00000000)},
    {"d23.win", "road corner w-n", int32_t(0x5CB4ADDF), int32_t(0x00000000)},
    {"d24.des", "road diagonal nw-se 1", int32_t(0x5CBBA9CC), int32_t(0x00000000)},
    {"d24.sno", "road", int32_t(0x5CB7B2DB), int32_t(0x00000000)},
    {"d24.tem", "road diagonal nw-se 1", int32_t(0x5CB5A9DC), int32_t(0x00000000)},
    {"d24.win", "road diagonal nw-se 1", int32_t(0x5CB6ADDF), int32_t(0x00000000)},
    {"d25.des", "road diagonal nw-se 2", int32_t(0x5CBDA9CC), int32_t(0x00000000)},
    {"d25.sno", "road", int32_t(0x5CB9B2DB), int32_t(0x00000000)},
    {"d25.tem", "road diagonal nw-se 2", int32_t(0x5CB7A9DC), int32_t(0x00000000)},
    {"d25.win", "road diagonal nw-se 2", int32_t(0x5CB8ADDF), int32_t(0x00000000)},
    {"d26.des", "road diagonal nw-se connector 1", int32_t(0x5CBFA9CC), int32_t(0x00000000)},
    {"d26.sno", "road", int32_t(0x5CBBB2DB), int32_t(0x00000000)},
    {"d26.tem", "road diagonal nw-se connector 1", int32_t(0x5CB9A9DC), int32_t(0x00000000)},
    {"d26.win", "road diagonal nw-se connector 1", int32_t(0x5CBAADDF), int32_t(0x00000000)},
    {"d27.des", "road diagonal nw-se connector 2", int32_t(0x5CC1A9CC), int32_t(0x00000000)},
    {"d27.sno", "road", int32_t(0x5CBDB2DB), int32_t(0x00000000)},
    {"d27.tem", "road diagonal nw-se connector 2", int32_t(0x5CBBA9DC), int32_t(0x00000000)},
    {"d27.win", "road diagonal nw-se connector 2", int32_t(0x5CBCADDF), int32_t(0x00000000)},
    {"d28.des", "road corner w-se connector", int32_t(0x5CC3A9CC), int32_t(0x00000000)},
    {"d28.sno", "road", int32_t(0x5CBFB2DB), int32_t(0x00000000)},
    {"d28.tem", "road corner w-se connector", int32_t(0x5CBDA9DC), int32_t(0x00000000)},
    {"d28.win", "road corner w-se connector", int32_t(0x5CBEADDF), int32_t(0x00000000)},
    {"d29.des", "road corner n-se connector", int32_t(0x5CC5A9CC), int32_t(0x00000000)},
    {"d29.sno", "road", int32_t(0x5CC1B2DB), int32_t(0x00000000)},
    {"d29.tem", "road corner n-se connector", int32_t(0x5CBFA9DC), int32_t(0x00000000)},
    {"d29.win", "road corner n-se connector", int32_t(0x5CC0ADDF), int32_t(0x00000000)},
    {"d30.des", "road y se--n+w connector", int32_t(0x5CB3ABCC), int32_t(0x00000000)},
    {"d30.sno", "road", int32_t(0x5CAFB4DB), int32_t(0x00000000)},
    {"d30.tem", "road y se--n+w connector", int32_t(0x5CADABDC), int32_t(0x00000000)},
    {"d30.win", "road y se--n+w connector", int32_t(0x5CAEAFDF), int32_t(0x00000000)},
    {"d31.des", "road corner e-nw connector", int32_t(0x5CB5ABCC), int32_t(0x00000000)},
    {"d31.sno", "road", int32_t(0x5CB1B4DB), int32_t(0x00000000)},
    {"d31.tem", "road corner e-nw connector", int32_t(0x5CAFABDC), int32_t(0x00000000)},
    {"d31.win", "road corner e-nw connector", int32_t(0x5CB0AFDF), int32_t(0x00000000)},
    {"d32.des", "road corner s-nw connector", int32_t(0x5CB7ABCC), int32_t(0x00000000)},
    {"d32.sno", "road", int32_t(0x5CB3B4DB), int32_t(0x00000000)},
    {"d32.tem", "road corner s-nw connector", int32_t(0x5CB1ABDC), int32_t(0x00000000)},
    {"d32.win", "road corner s-nw connector", int32_t(0x5CB2AFDF), int32_t(0x00000000)},
    {"d33.des", "road y nw--s+e connector", int32_t(0x5CB9ABCC), int32_t(0x00000000)},
    {"d33.sno", "road", int32_t(0x5CB5B4DB), int32_t(0x00000000)},
    {"d33.tem", "road y nw--s+e connector", int32_t(0x5CB3ABDC), int32_t(0x00000000)},
    {"d33.win", "road y nw--s+e connector", int32_t(0x5CB4AFDF), int32_t(0x00000000)},
    {"d34.des", "road diagonal sw-ne 1", int32_t(0x5CBBABCC), int32_t(0x00000000)},
    {"d34.sno", "road", int32_t(0x5CB7B4DB), int32_t(0x00000000)},
    {"d34.tem", "road diagonal sw-ne 1", int32_t(0x5CB5ABDC), int32_t(0x00000000)},
    {"d34.win", "road diagonal sw-ne 1", int32_t(0x5CB6AFDF), int32_t(0x00000000)},
    {"d35.des", "road diagonal sw-ne 2", int32_t(0x5CBDABCC), int32_t(0x00000000)},
    {"d35.sno", "road", int32_t(0x5CB9B4DB), int32_t(0x00000000)},
    {"d35.tem", "road diagonal sw-ne 2", int32_t(0x5CB7ABDC), int32_t(0x00000000)},
    {"d35.win", "road diagonal sw-ne 2", int32_t(0x5CB8AFDF), int32_t(0x00000000)},
    {"d36.des", "road diagonal sw-ne connector 1", int32_t(0x5CBFABCC), int32_t(0x00000000)},
    {"d36.sno", "road", int32_t(0x5CBBB4DB), int32_t(0x00000000)},
    {"d36.tem", "road diagonal sw-ne connector 1", int32_t(0x5CB9ABDC), int32_t(0x00000000)},
    {"d36.win", "road diagonal sw-ne connector 1", int32_t(0x5CBAAFDF), int32_t(0x00000000)},
    {"d37.des", "road diagonal sw-ne connector 2", int32_t(0x5CC1ABCC), int32_t(0x00000000)},
    {"d37.sno", "road", int32_t(0x5CBDB4DB), int32_t(0x00000000)},
    {"d37.tem", "road diagonal sw-ne connector 2", int32_t(0x5CBBABDC), int32_t(0x00000000)},
    {"d37.win", "road diagonal sw-ne connector 2", int32_t(0x5CBCAFDF), int32_t(0x00000000)},
    {"d38.des", "road corner e-sw connector", int32_t(0x5CC3ABCC), int32_t(0x00000000)},
    {"d38.sno", "road", int32_t(0x5CBFB4DB), int32_t(0x00000000)},
    {"d38.tem", "road corner e-sw connector", int32_t(0x5CBDABDC), int32_t(0x00000000)},
    {"d38.win", "road corner e-sw connector", int32_t(0x5CBEAFDF), int32_t(0x00000000)},
    {"d39.des", "road corner n-sw connector", int32_t(0x5CC5ABCC), int32_t(0x00000000)},
    {"d39.sno", "road", int32_t(0x5CC1B4DB), int32_t(0x00000000)},
    {"d39.tem", "road corner n-sw connector", int32_t(0x5CBFABDC), int32_t(0x00000000)},
    {"d39.win", "road corner n-sw connector", int32_t(0x5CC0AFDF), int32_t(0x00000000)},
    {"d40.des", "road y sw--n+e connector", int32_t(0x5CB3ADCC), int32_t(0x00000000)},
    {"d40.sno", "road", int32_t(0x5CAFB6DB), int32_t(0x00000000)},
    {"d40.tem", "road y sw--n+e connector", int32_t(0x5CADADDC), int32_t(0x00000000)},
    {"d40.win", "road y sw--n+e connector", int32_t(0x5CAEB1DF), int32_t(0x00000000)},
    {"d41.des", "road corner w-ne connector", int32_t(0x5CB5ADCC), int32_t(0x00000000)},
    {"d41.sno", "road", int32_t(0x5CB1B6DB), int32_t(0x00000000)},
    {"d41.tem", "road corner w-ne connector", int32_t(0x5CAFADDC), int32_t(0x00000000)},
    {"d41.win", "road corner w-ne connector", int32_t(0x5CB0B1DF), int32_t(0x00000000)},
    {"d42.des", "road corner s-ne connector", int32_t(0x5CB7ADCC), int32_t(0x00000000)},
    {"d42.sno", "road", int32_t(0x5CB3B6DB), int32_t(0x00000000)},
    {"d42.tem", "road corner s-ne connector", int32_t(0x5CB1ADDC), int32_t(0x00000000)},
    {"d42.win", "road corner s-ne connector", int32_t(0x5CB2B1DF), int32_t(0x00000000)},
    {"d43.des", "road y ne--w+s connector", int32_t(0x5CB9ADCC), int32_t(0x00000000)},
    {"d43.sno", "road", int32_t(0x5CB5B6DB), int32_t(0x00000000)},
    {"d43.tem", "road y ne--w+s connector", int32_t(0x5CB3ADDC), int32_t(0x00000000)},
    {"d43.win", "road y ne--w+s connector", int32_t(0x5CB4B1DF), int32_t(0x00000000)},
    {"d44.sno", "road", int32_t(0x5CB7B6DB), int32_t(0x00000000)},
    {"d44.tem", "road", int32_t(0x5CB5ADDC), int32_t(0x00000000)},
    {"d45.sno", "road", int32_t(0x5CB9B6DB), int32_t(0x00000000)},
    {"d45.tem", "road", int32_t(0x5CB7ADDC), int32_t(0x00000000)},
    {"da01vh43.aud", "", int32_t(0x6F7ED6EB), int32_t(0x00000000)},
    {"da01vh44.aud", "", int32_t(0x717ED6EB), int32_t(0x00000000)},
    {"da01vh51.aud", "", int32_t(0x6B80D6EB), int32_t(0x00000000)},
    {"da01vh52.aud", "", int32_t(0x6D80D6EB), int32_t(0x00000000)},
    {"da15a100.aud", "", int32_t(0x797AA8C1), int32_t(0x00000000)},
    {"da15a101.aud", "", int32_t(0x7B7AA8C1), int32_t(0x00000000)},
    {"da15a106.aud", "", int32_t(0x857AA8C1), int32_t(0x00000000)},
    {"da15a108.aud", "", int32_t(0x897AA8C1), int32_t(0x00000000)},
    {"da15a110.aud", "", int32_t(0x797CA8C1), int32_t(0x00000000)},
    {"da15a301.aud", "", int32_t(0x7B7AACC1), int32_t(0x00000000)},
    {"da15a302.aud", "", int32_t(0x7D7AACC1), int32_t(0x00000000)},
    {"da15a304.aud", "", int32_t(0x817AACC1), int32_t(0x00000000)},
    {"da15a308.aud", "", int32_t(0x897AACC1), int32_t(0x00000000)},
    {"da15a312.aud", "", int32_t(0x7D7CACC1), int32_t(0x00000000)},
    {"da15a314.aud", "", int32_t(0x817CACC1), int32_t(0x00000000)},
    {"da15a322.aud", "", int32_t(0x7D7EACC1), int32_t(0x00000000)},
    {"da15a325.aud", "", int32_t(0x837EACC1), int32_t(0x00000000)},
    {"da15a326.aud", "", int32_t(0x857EACC1), int32_t(0x00000000)},
    {"da15b500.aud", "", int32_t(0x797AB0C3), int32_t(0x00000000)},
    {"da15b510.aud", "", int32_t(0x797CB0C3), int32_t(0x00000000)},
    {"da15b512.aud", "", int32_t(0x7D7CB0C3), int32_t(0x00000000)},
    {"da15b520.aud", "", int32_t(0x797EB0C3), int32_t(0x00000000)},
    {"da15b522.aud", "", int32_t(0x7D7EB0C3), int32_t(0x00000000)},
    {"da15b530.aud", "", int32_t(0x7980B0C3), int32_t(0x00000000)},
    {"da15b532.aud", "", int32_t(0x7D80B0C3), int32_t(0x00000000)},
    {"da15b540.aud", "", int32_t(0x7982B0C3), int32_t(0x00000000)},
    {"da15b542.aud", "", int32_t(0x7D82B0C3), int32_t(0x00000000)},
    {"da15eg00.aud", "", int32_t(0x797AD4C9), int32_t(0x00000000)},
    {"da15eg10.aud", "", int32_t(0x797CD4C9), int32_t(0x00000000)},
    {"da15eg20.aud", "", int32_t(0x797ED4C9), int32_t(0x00000000)},
    {"da15eg30.aud", "", int32_t(0x7980D4C9), int32_t(0x00000000)},
    {"da15eg40.aud", "", int32_t(0x7982D4C9), int32_t(0x00000000)},
    {"da15eg42.aud", "", int32_t(0x7D82D4C9), int32_t(0x00000000)},
    {"da15et00.aud", "", int32_t(0x797AEEC9), int32_t(0x00000000)},
    {"da15et10.aud", "", int32_t(0x797CEEC9), int32_t(0x00000000)},
    {"da15et20.aud", "", int32_t(0x797EEEC9), int32_t(0x00000000)},
    {"da15et30.aud", "", int32_t(0x7980EEC9), int32_t(0x00000000)},
    {"da15et40.aud", "", int32_t(0x7982EEC9), int32_t(0x00000000)},
    {"da15qh00.aud", "", int32_t(0x797AD6E1), int32_t(0x00000000)},
    {"da15qp01.aud", "", int32_t(0x7B7AE6E1), int32_t(0x00000000)},
    {"da15qp03.aud", "", int32_t(0x7F7AE6E1), int32_t(0x00000000)},
    {"da15qp05.aud", "", int32_t(0x837AE6E1), int32_t(0x00000000)},
    {"da15qp07.aud", "", int32_t(0x877AE6E1), int32_t(0x00000000)},
    {"da15qp09.aud", "", int32_t(0x8B7AE6E1), int32_t(0x00000000)},
    {"da15qp11.aud", "", int32_t(0x7B7CE6E1), int32_t(0x00000000)},
    {"da15qp13.aud", "", int32_t(0x7F7CE6E1), int32_t(0x00000000)},
    {"da15qp14.aud", "", int32_t(0x817CE6E1), int32_t(0x00000000)},
    {"da15t900.aud", "", int32_t(0x797AB8E7), int32_t(0x00000000)},
    {"da15t902.aud", "", int32_t(0x7D7AB8E7), int32_t(0x00000000)},
    {"da15t904.aud", "", int32_t(0x817AB8E7), int32_t(0x00000000)},
    {"da15t906.aud", "", int32_t(0x857AB8E7), int32_t(0x00000000)},
    {"da15t908.aud", "", int32_t(0x897AB8E7), int32_t(0x00000000)},
    {"da15t910.aud", "", int32_t(0x797CB8E7), int32_t(0x00000000)},
    {"da15t912.aud", "", int32_t(0x7D7CB8E7), int32_t(0x00000000)},
    {"da15t914.aud", "", int32_t(0x817CB8E7), int32_t(0x00000000)},
    {"da15t916.aud", "", int32_t(0x857CB8E7), int32_t(0x00000000)},
    {"da15va00.aud", "", int32_t(0x797AC8EB), int32_t(0x00000000)},
    {"da15va01.aud", "", int32_t(0x7B7AC8EB), int32_t(0x00000000)},
    {"da15va02.aud", "", int32_t(0x7D7AC8EB), int32_t(0x00000000)},
    {"da15va03.aud", "", int32_t(0x7F7AC8EB), int32_t(0x00000000)},
    {"da15va04.aud", "", int32_t(0x817AC8EB), int32_t(0x00000000)},
    {"da15va05.aud", "", int32_t(0x837AC8EB), int32_t(0x00000000)},
    {"da15va06.aud", "", int32_t(0x857AC8EB), int32_t(0x00000000)},
    {"da15va07.aud", "", int32_t(0x877AC8EB), int32_t(0x00000000)},
    {"da15va08.aud", "", int32_t(0x897AC8EB), int32_t(0x00000000)},
    {"da15va09.aud", "", int32_t(0x8B7AC8EB), int32_t(0x00000000)},
    {"da15va10.aud", "", int32_t(0x797CC8EB), int32_t(0x00000000)},
    {"da15va11.aud", "", int32_t(0x7B7CC8EB), int32_t(0x00000000)},
    {"da15va12.aud", "", int32_t(0x7D7CC8EB), int32_t(0x00000000)},
    {"da15va13.aud", "", int32_t(0x7F7CC8EB), int32_t(0x00000000)},
    {"da15va14.aud", "", int32_t(0x817CC8EB), int32_t(0x00000000)},
    {"da15va15.aud", "", int32_t(0x837CC8EB), int32_t(0x00000000)},
    {"da15va16.aud", "", int32_t(0x857CC8EB), int32_t(0x00000000)},
    {"da15va17.aud", "", int32_t(0x877CC8EB), int32_t(0x00000000)},
    {"da15va18.aud", "", int32_t(0x897CC8EB), int32_t(0x00000000)},
    {"da15va19.aud", "", int32_t(0x8B7CC8EB), int32_t(0x00000000)},
    {"da15va20.aud", "", int32_t(0x797EC8EB), int32_t(0x00000000)},
    {"da15va21.aud", "", int32_t(0x7B7EC8EB), int32_t(0x00000000)},
    {"da15va22.aud", "", int32_t(0x7D7EC8EB), int32_t(0x00000000)},
    {"da15va23.aud", "", int32_t(0x7F7EC8EB), int32_t(0x00000000)},
    {"da15va24.aud", "", int32_t(0x817EC8EB), int32_t(0x00000000)},
    {"da15va25.aud", "", int32_t(0x837EC8EB), int32_t(0x00000000)},
    {"da15va26.aud", "", int32_t(0x857EC8EB), int32_t(0x00000000)},
    {"da15va27.aud", "", int32_t(0x877EC8EB), int32_t(0x00000000)},
    {"da15va28.aud", "", int32_t(0x897EC8EB), int32_t(0x00000000)},
    {"da15va29.aud", "", int32_t(0x8B7EC8EB), int32_t(0x00000000)},
    {"da15va30.aud", "", int32_t(0x7980C8EB), int32_t(0x00000000)},
    {"da15va31.aud", "", int32_t(0x7B80C8EB), int32_t(0x00000000)},
    {"da15va32.aud", "", int32_t(0x7D80C8EB), int32_t(0x00000000)},
    {"da15va33.aud", "", int32_t(0x7F80C8EB), int32_t(0x00000000)},
    {"da15va34.aud", "", int32_t(0x8180C8EB), int32_t(0x00000000)},
    {"da15va35.aud", "", int32_t(0x8380C8EB), int32_t(0x00000000)},
    {"da15va36.aud", "", int32_t(0x8580C8EB), int32_t(0x00000000)},
    {"da15va37.aud", "", int32_t(0x8780C8EB), int32_t(0x00000000)},
    {"da15va38.aud", "", int32_t(0x8980C8EB), int32_t(0x00000000)},
    {"da15va39.aud", "", int32_t(0x8B80C8EB), int32_t(0x00000000)},
    {"da15va40.aud", "", int32_t(0x7982C8EB), int32_t(0x00000000)},
    {"da15va41.aud", "", int32_t(0x7B82C8EB), int32_t(0x00000000)},
    {"da15va42.aud", "", int32_t(0x7D82C8EB), int32_t(0x00000000)},
    {"da15va43.aud", "", int32_t(0x7F82C8EB), int32_t(0x00000000)},
    {"da15va44.aud", "", int32_t(0x8182C8EB), int32_t(0x00000000)},
    {"da15va45.aud", "", int32_t(0x8382C8EB), int32_t(0x00000000)},
    {"da15va46.aud", "", int32_t(0x8582C8EB), int32_t(0x00000000)},
    {"da15va47.aud", "", int32_t(0x8782C8EB), int32_t(0x00000000)},
    {"da15va48.aud", "", int32_t(0x8982C8EB), int32_t(0x00000000)},
    {"da15va49.aud", "", int32_t(0x8B82C8EB), int32_t(0x00000000)},
    {"da15va50.aud", "", int32_t(0x7984C8EB), int32_t(0x00000000)},
    {"da15va51.aud", "", int32_t(0x7B84C8EB), int32_t(0x00000000)},
    {"da15va52.aud", "", int32_t(0x7D84C8EB), int32_t(0x00000000)},
    {"da15va53.aud", "", int32_t(0x7F84C8EB), int32_t(0x00000000)},
    {"da15va54.aud", "", int32_t(0x8184C8EB), int32_t(0x00000000)},
    {"da15va55.aud", "", int32_t(0x8384C8EB), int32_t(0x00000000)},
    {"da15va56.aud", "", int32_t(0x8584C8EB), int32_t(0x00000000)},
    {"da15va57.aud", "", int32_t(0x8784C8EB), int32_t(0x00000000)},
    {"da15va58.aud", "", int32_t(0x8984C8EB), int32_t(0x00000000)},
    {"da15va59.aud", "", int32_t(0x8B84C8EB), int32_t(0x00000000)},
    {"da15va60.aud", "", int32_t(0x7986C8EB), int32_t(0x00000000)},
    {"da15va61.aud", "", int32_t(0x7B86C8EB), int32_t(0x00000000)},
    {"da15va62.aud", "", int32_t(0x7D86C8EB), int32_t(0x00000000)},
    {"da15va63.aud", "", int32_t(0x7F86C8EB), int32_t(0x00000000)},
    {"da15va64.aud", "", int32_t(0x8186C8EB), int32_t(0x00000000)},
    {"da15va65.aud", "", int32_t(0x8386C8EB), int32_t(0x00000000)},
    {"da15va66.aud", "", int32_t(0x8586C8EB), int32_t(0x00000000)},
    {"da15va67.aud", "", int32_t(0x8786C8EB), int32_t(0x00000000)},
    {"da15va68.aud", "", int32_t(0x8986C8EB), int32_t(0x00000000)},
    {"da15va69.aud", "", int32_t(0x8B86C8EB), int32_t(0x00000000)},
    {"da15va70.aud", "", int32_t(0x7988C8EB), int32_t(0x00000000)},
    {"da15va71.aud", "", int32_t(0x7B88C8EB), int32_t(0x00000000)},
    {"da15va72.aud", "", int32_t(0x7D88C8EB), int32_t(0x00000000)},
    {"da15vb00.aud", "", int32_t(0x797ACAEB), int32_t(0x00000000)},
    {"da15vb01.aud", "", int32_t(0x7B7ACAEB), int32_t(0x00000000)},
    {"da15vb02.aud", "", int32_t(0x7D7ACAEB), int32_t(0x00000000)},
    {"da15vb03.aud", "", int32_t(0x7F7ACAEB), int32_t(0x00000000)},
    {"da15vb04.aud", "", int32_t(0x817ACAEB), int32_t(0x00000000)},
    {"da15vb05.aud", "", int32_t(0x837ACAEB), int32_t(0x00000000)},
    {"da15vb06.aud", "", int32_t(0x857ACAEB), int32_t(0x00000000)},
    {"da15vb07.aud", "", int32_t(0x877ACAEB), int32_t(0x00000000)},
    {"da15vb08.aud", "", int32_t(0x897ACAEB), int32_t(0x00000000)},
    {"da15vb09.aud", "", int32_t(0x8B7ACAEB), int32_t(0x00000000)},
    {"da15vb10.aud", "", int32_t(0x797CCAEB), int32_t(0x00000000)},
    {"da15vj00.aud", "", int32_t(0x797ADAEB), int32_t(0x00000000)},
    {"da15vk00.aud", "", int32_t(0x797ADCEB), int32_t(0x00000000)},
    {"da15vl00.aud", "", int32_t(0x797ADEEB), int32_t(0x00000000)},
    {"da15vm00.aud", "", int32_t(0x797AE0EB), int32_t(0x00000000)},
    {"da15ya00.aud", "", int32_t(0x797AC8F1), int32_t(0x00000000)},
    {"da15ya01.aud", "", int32_t(0x7B7AC8F1), int32_t(0x00000000)},
    {"da15ya03.aud", "", int32_t(0x7F7AC8F1), int32_t(0x00000000)},
    {"da15ya04.aud", "", int32_t(0x817AC8F1), int32_t(0x00000000)},
    {"da15ya05.aud", "", int32_t(0x837AC8F1), int32_t(0x00000000)},
    {"da15ya06.aud", "", int32_t(0x857AC8F1), int32_t(0x00000000)},
    {"da15ya07.aud", "", int32_t(0x877AC8F1), int32_t(0x00000000)},
    {"da15ya08.aud", "", int32_t(0x897AC8F1), int32_t(0x00000000)},
    {"da15ya09.aud", "", int32_t(0x8B7AC8F1), int32_t(0x00000000)},
    {"da15ya10.aud", "", int32_t(0x797CC8F1), int32_t(0x00000000)},
    {"da15ya11.aud", "", int32_t(0x7B7CC8F1), int32_t(0x00000000)},
    {"da15ya12.aud", "", int32_t(0x7D7CC8F1), int32_t(0x00000000)},
    {"da15ya13.aud", "", int32_t(0x7F7CC8F1), int32_t(0x00000000)},
    {"da15ya14.aud", "", int32_t(0x817CC8F1), int32_t(0x00000000)},
    {"da15ya15.aud", "", int32_t(0x837CC8F1), int32_t(0x00000000)},
    {"da15ya16.aud", "", int32_t(0x857CC8F1), int32_t(0x00000000)},
    {"da15ya17.aud", "", int32_t(0x877CC8F1), int32_t(0x00000000)},
    {"da15ya18.aud", "", int32_t(0x897CC8F1), int32_t(0x00000000)},
    {"da15ya19.aud", "", int32_t(0x8B7CC8F1), int32_t(0x00000000)},
    {"da15ya20.aud", "", int32_t(0x797EC8F1), int32_t(0x00000000)},
    {"da15ya21.aud", "", int32_t(0x7B7EC8F1), int32_t(0x00000000)},
    {"da15ya22.aud", "", int32_t(0x7D7EC8F1), int32_t(0x00000000)},
    {"da15ya23.aud", "", int32_t(0x7F7EC8F1), int32_t(0x00000000)},
    {"da15ya24.aud", "", int32_t(0x817EC8F1), int32_t(0x00000000)},
    {"da15ya25.aud", "", int32_t(0x837EC8F1), int32_t(0x00000000)},
    {"da15ya26.aud", "", int32_t(0x857EC8F1), int32_t(0x00000000)},
    {"da15ya27.aud", "", int32_t(0x877EC8F1), int32_t(0x00000000)},
    {"da15ya28.aud", "", int32_t(0x897EC8F1), int32_t(0x00000000)},
    {"da15ya29.aud", "", int32_t(0x8B7EC8F1), int32_t(0x00000000)},
    {"da15ya30.aud", "", int32_t(0x7980C8F1), int32_t(0x00000000)},
    {"da15ya31.aud", "", int32_t(0x7B80C8F1), int32_t(0x00000000)},
    {"da15ya32.aud", "", int32_t(0x7D80C8F1), int32_t(0x00000000)},
    {"da15ya33.aud", "", int32_t(0x7F80C8F1), int32_t(0x00000000)},
    {"da15ya34.aud", "", int32_t(0x8180C8F1), int32_t(0x00000000)},
    {"da15ya35.aud", "", int32_t(0x8380C8F1), int32_t(0x00000000)},
    {"da15ya36.aud", "", int32_t(0x8580C8F1), int32_t(0x00000000)},
    {"da15ya37.aud", "", int32_t(0x8780C8F1), int32_t(0x00000000)},
    {"da15ya38.aud", "", int32_t(0x8980C8F1), int32_t(0x00000000)},
    {"da15ya39.aud", "", int32_t(0x8B80C8F1), int32_t(0x00000000)},
    {"da15ya40.aud", "", int32_t(0x7982C8F1), int32_t(0x00000000)},
    {"da15ya41.aud", "", int32_t(0x7B82C8F1), int32_t(0x00000000)},
    {"da15ya43.aud", "", int32_t(0x7F82C8F1), int32_t(0x00000000)},
    {"da15ya44.aud", "", int32_t(0x8182C8F1), int32_t(0x00000000)},
    {"da15ya45.aud", "", int32_t(0x8382C8F1), int32_t(0x00000000)},
    {"da15ya46.aud", "", int32_t(0x8582C8F1), int32_t(0x00000000)},
    {"da15ya47.aud", "", int32_t(0x8782C8F1), int32_t(0x00000000)},
    {"da15ya48.aud", "", int32_t(0x8982C8F1), int32_t(0x00000000)},
    {"da15ya49.aud", "", int32_t(0x8B82C8F1), int32_t(0x00000000)},
    {"da15ya50.aud", "", int32_t(0x7984C8F1), int32_t(0x00000000)},
    {"da15ya51.aud", "", int32_t(0x7B84C8F1), int32_t(0x00000000)},
    {"da15ya52.aud", "", int32_t(0x7D84C8F1), int32_t(0x00000000)},
    {"da15ya53.aud", "", int32_t(0x7F84C8F1), int32_t(0x00000000)},
    {"da15ya54.aud", "", int32_t(0x8184C8F1), int32_t(0x00000000)},
    {"da15ya55.aud", "", int32_t(0x8384C8F1), int32_t(0x00000000)},
    {"da15ya56.aud", "", int32_t(0x8584C8F1), int32_t(0x00000000)},
    {"da15ya57.aud", "", int32_t(0x8784C8F1), int32_t(0x00000000)},
    {"da15ya58.aud", "", int32_t(0x8984C8F1), int32_t(0x00000000)},
    {"da15ya59.aud", "", int32_t(0x8B84C8F1), int32_t(0x00000000)},
    {"da15ya60.aud", "", int32_t(0x7986C8F1), int32_t(0x00000000)},
    {"da15ya61.aud", "", int32_t(0x7B86C8F1), int32_t(0x00000000)},
    {"da15ya62.aud", "", int32_t(0x7D86C8F1), int32_t(0x00000000)},
    {"da15ya63.aud", "", int32_t(0x7F86C8F1), int32_t(0x00000000)},
    {"da15ya64.aud", "", int32_t(0x8186C8F1), int32_t(0x00000000)},
    {"da15ya65.aud", "", int32_t(0x8386C8F1), int32_t(0x00000000)},
    {"da15ya66.aud", "", int32_t(0x8586C8F1), int32_t(0x00000000)},
    {"da15ya67.aud", "", int32_t(0x8786C8F1), int32_t(0x00000000)},
    {"da15ya68.aud", "", int32_t(0x8986C8F1), int32_t(0x00000000)},
    {"da15ya69.aud", "", int32_t(0x8B86C8F1), int32_t(0x00000000)},
    {"da15ya70.aud", "", int32_t(0x7988C8F1), int32_t(0x00000000)},
    {"da15ya71.aud", "", int32_t(0x7B88C8F1), int32_t(0x00000000)},
    {"da15ya72.aud", "", int32_t(0x7D88C8F1), int32_t(0x00000000)},
    {"da15ya73.aud", "", int32_t(0x7F88C8F1), int32_t(0x00000000)},
    {"da15ya74.aud", "", int32_t(0x8188C8F1), int32_t(0x00000000)},
    {"da15ya75.aud", "", int32_t(0x8388C8F1), int32_t(0x00000000)},
    {"da15ya76.aud", "", int32_t(0x8588C8F1), int32_t(0x00000000)},
    {"da15ya77.aud", "", int32_t(0x8788C8F1), int32_t(0x00000000)},
    {"da15ya78.aud", "", int32_t(0x8988C8F1), int32_t(0x00000000)},
    {"da15ya79.aud", "", int32_t(0x8B88C8F1), int32_t(0x00000000)},
    {"da15ya80.aud", "", int32_t(0x798AC8F1), int32_t(0x00000000)},
    {"da15ya81.aud", "", int32_t(0x7B8AC8F1), int32_t(0x00000000)},
    {"da15ya82.aud", "", int32_t(0x7D8AC8F1), int32_t(0x00000000)},
    {"da15ya83.aud", "", int32_t(0x7F8AC8F1), int32_t(0x00000000)},
    {"da15ya84.aud", "", int32_t(0x818AC8F1), int32_t(0x00000000)},
    {"da15ya85.aud", "", int32_t(0x838AC8F1), int32_t(0x00000000)},
    {"da15ya86.aud", "", int32_t(0x858AC8F1), int32_t(0x00000000)},
    {"da15ya87.aud", "", int32_t(0x878AC8F1), int32_t(0x00000000)},
    {"da15ya88.aud", "", int32_t(0x898AC8F1), int32_t(0x00000000)},
    {"da15ya89.aud", "", int32_t(0x8B8AC8F1), int32_t(0x00000000)},
    {"da15ya90.aud", "", int32_t(0x798CC8F1), int32_t(0x00000000)},
    {"da15ya91.aud", "", int32_t(0x7B8CC8F1), int32_t(0x00000000)},
    {"da15ya92.aud", "", int32_t(0x7D8CC8F1), int32_t(0x00000000)},
    {"da15ya93.aud", "", int32_t(0x7F8CC8F1), int32_t(0x00000000)},
    {"da15ya94.aud", "", int32_t(0x818CC8F1), int32_t(0x00000000)},
    {"da15ya95.aud", "", int32_t(0x838CC8F1), int32_t(0x00000000)},
    {"da15ya96.aud", "", int32_t(0x858CC8F1), int32_t(0x00000000)},
    {"da15ya97.aud", "", int32_t(0x878CC8F1), int32_t(0x00000000)},
    {"da15ya98.aud", "", int32_t(0x898CC8F1), int32_t(0x00000000)},
    {"da15ya99.aud", "", int32_t(0x8B8CC8F1), int32_t(0x00000000)},
    {"da15yaa0.aud", "", int32_t(0x799CC8F1), int32_t(0x00000000)},
    {"da15yaa1.aud", "", int32_t(0x7B9CC8F1), int32_t(0x00000000)},
    {"da15yaa2.aud", "", int32_t(0x7D9CC8F1), int32_t(0x00000000)},
    {"da15yaa3.aud", "", int32_t(0x7F9CC8F1), int32_t(0x00000000)},
    {"da15yaa4.aud", "", int32_t(0x819CC8F1), int32_t(0x00000000)},
    {"da15yaa5.aud", "", int32_t(0x839CC8F1), int32_t(0x00000000)},
    {"da15yaa6.aud", "", int32_t(0x859CC8F1), int32_t(0x00000000)},
    {"da15yaa7.aud", "", int32_t(0x879CC8F1), int32_t(0x00000000)},
    {"da15yaa8.aud", "", int32_t(0x899CC8F1), int32_t(0x00000000)},
    {"da15yaa9.aud", "", int32_t(0x8B9CC8F1), int32_t(0x00000000)},
    {"da15yab0.aud", "", int32_t(0x799EC8F1), int32_t(0x00000000)},
    {"da15yab1.aud", "", int32_t(0x7B9EC8F1), int32_t(0x00000000)},
    {"da15yab2.aud", "", int32_t(0x7D9EC8F1), int32_t(0x00000000)},
    {"da15yab3.aud", "", int32_t(0x7F9EC8F1), int32_t(0x00000000)},
    {"da15yab4.aud", "", int32_t(0x819EC8F1), int32_t(0x00000000)},
    {"da15yab5.aud", "", int32_t(0x839EC8F1), int32_t(0x00000000)},
    {"da15yab6.aud", "", int32_t(0x859EC8F1), int32_t(0x00000000)},
    {"da15yab7.aud", "", int32_t(0x879EC8F1), int32_t(0x00000000)},
    {"da15yab8.aud", "", int32_t(0x899EC8F1), int32_t(0x00000000)},
    {"da15yab9.aud", "", int32_t(0x8B9EC8F1), int32_t(0x00000000)},
    {"da15yac0.aud", "", int32_t(0x79A0C8F1), int32_t(0x00000000)},
    {"da15yac1.aud", "", int32_t(0x7BA0C8F1), int32_t(0x00000000)},
    {"da15yac2.aud", "", int32_t(0x7DA0C8F1), int32_t(0x00000000)},
    {"da15yac3.aud", "", int32_t(0x7FA0C8F1), int32_t(0x00000000)},
    {"da15yac4.aud", "", int32_t(0x81A0C8F1), int32_t(0x00000000)},
    {"da15yac5.aud", "", int32_t(0x83A0C8F1), int32_t(0x00000000)},
    {"da15yac6.aud", "", int32_t(0x85A0C8F1), int32_t(0x00000000)},
    {"da15yac7.aud", "", int32_t(0x87A0C8F1), int32_t(0x00000000)},
    {"da15yac8.aud", "", int32_t(0x89A0C8F1), int32_t(0x00000000)},
    {"da15yac9.aud", "", int32_t(0x8BA0C8F1), int32_t(0x00000000)},
    {"da15yad0.aud", "", int32_t(0x79A2C8F1), int32_t(0x00000000)},
    {"da15yad1.aud", "", int32_t(0x7BA2C8F1), int32_t(0x00000000)},
    {"da15yad2.aud", "", int32_t(0x7DA2C8F1), int32_t(0x00000000)},
    {"da15yad3.aud", "", int32_t(0x7FA2C8F1), int32_t(0x00000000)},
    {"da15yad4.aud", "", int32_t(0x81A2C8F1), int32_t(0x00000000)},
    {"da15yad5.aud", "", int32_t(0x83A2C8F1), int32_t(0x00000000)},
    {"da15yad6.aud", "", int32_t(0x85A2C8F1), int32_t(0x00000000)},
    {"da15yad7.aud", "", int32_t(0x87A2C8F1), int32_t(0x00000000)},
    {"da15yad8.aud", "", int32_t(0x89A2C8F1), int32_t(0x00000000)},
    {"da15yad9.aud", "", int32_t(0x8BA2C8F1), int32_t(0x00000000)},
    {"da15yae0.aud", "", int32_t(0x79A4C8F1), int32_t(0x00000000)},
    {"da15yae1.aud", "", int32_t(0x7BA4C8F1), int32_t(0x00000000)},
    {"da15yc00.aud", "", int32_t(0x797ACCF1), int32_t(0x00000000)},
    {"da15yc01.aud", "", int32_t(0x7B7ACCF1), int32_t(0x00000000)},
    {"da15yc02.aud", "", int32_t(0x7D7ACCF1), int32_t(0x00000000)},
    {"da15yc03.aud", "", int32_t(0x7F7ACCF1), int32_t(0x00000000)},
    {"da15yc04.aud", "", int32_t(0x817ACCF1), int32_t(0x00000000)},
    {"da15yc05.aud", "", int32_t(0x837ACCF1), int32_t(0x00000000)},
    {"da15yc06.aud", "", int32_t(0x857ACCF1), int32_t(0x00000000)},
    {"da15yc07.aud", "", int32_t(0x877ACCF1), int32_t(0x00000000)},
    {"da15yc08.aud", "", int32_t(0x897ACCF1), int32_t(0x00000000)},
    {"da15yc09.aud", "", int32_t(0x8B7ACCF1), int32_t(0x00000000)},
    {"da15yc10.aud", "", int32_t(0x797CCCF1), int32_t(0x00000000)},
    {"da15yc11.aud", "", int32_t(0x7B7CCCF1), int32_t(0x00000000)},
    {"da15yc12.aud", "", int32_t(0x7D7CCCF1), int32_t(0x00000000)},
    {"da15yc13.aud", "", int32_t(0x7F7CCCF1), int32_t(0x00000000)},
    {"da15yc14.aud", "", int32_t(0x817CCCF1), int32_t(0x00000000)},
    {"da15yc15.aud", "", int32_t(0x837CCCF1), int32_t(0x00000000)},
    {"da15yc16.aud", "", int32_t(0x857CCCF1), int32_t(0x00000000)},
    {"da15yc17.aud", "", int32_t(0x877CCCF1), int32_t(0x00000000)},
    {"da15yc18.aud", "", int32_t(0x897CCCF1), int32_t(0x00000000)},
    {"da15yc19.aud", "", int32_t(0x8B7CCCF1), int32_t(0x00000000)},
    {"da15yc20.aud", "", int32_t(0x797ECCF1), int32_t(0x00000000)},
    {"da15yc21.aud", "", int32_t(0x7B7ECCF1), int32_t(0x00000000)},
    {"da15yc22.aud", "", int32_t(0x7D7ECCF1), int32_t(0x00000000)},
    {"da15yc23.aud", "", int32_t(0x7F7ECCF1), int32_t(0x00000000)},
    {"da15yc24.aud", "", int32_t(0x817ECCF1), int32_t(0x00000000)},
    {"da15yc25.aud", "", int32_t(0x837ECCF1), int32_t(0x00000000)},
    {"da15yc26.aud", "", int32_t(0x857ECCF1), int32_t(0x00000000)},
    {"da15yc27.aud", "", int32_t(0x877ECCF1), int32_t(0x00000000)},
    {"da15yc28.aud", "", int32_t(0x897ECCF1), int32_t(0x00000000)},
    {"da15yc29.aud", "", int32_t(0x8B7ECCF1), int32_t(0x00000000)},
    {"da15yc30.aud", "", int32_t(0x7980CCF1), int32_t(0x00000000)},
    {"da15yc31.aud", "", int32_t(0x7B80CCF1), int32_t(0x00000000)},
    {"da15yc32.aud", "", int32_t(0x7D80CCF1), int32_t(0x00000000)},
    {"da15yc33.aud", "", int32_t(0x7F80CCF1), int32_t(0x00000000)},
    {"da15yc34.aud", "", int32_t(0x8180CCF1), int32_t(0x00000000)},
    {"da15yc35.aud", "", int32_t(0x8380CCF1), int32_t(0x00000000)},
    {"da15yc36.aud", "", int32_t(0x8580CCF1), int32_t(0x00000000)},
    {"da15yc37.aud", "", int32_t(0x8780CCF1), int32_t(0x00000000)},
    {"da15yc38.aud", "", int32_t(0x8980CCF1), int32_t(0x00000000)},
    {"da15yc39.aud", "", int32_t(0x8B80CCF1), int32_t(0x00000000)},
    {"da15yc40.aud", "", int32_t(0x7982CCF1), int32_t(0x00000000)},
    {"da15yc41.aud", "", int32_t(0x7B82CCF1), int32_t(0x00000000)},
    {"da15yc42.aud", "", int32_t(0x7D82CCF1), int32_t(0x00000000)},
    {"da15yg00.aud", "", int32_t(0x797AD4F1), int32_t(0x00000000)},
    {"da15yg10.aud", "", int32_t(0x797CD4F1), int32_t(0x00000000)},
    {"da15yg20.aud", "", int32_t(0x797ED4F1), int32_t(0x00000000)},
    {"da15yg30.aud", "", int32_t(0x7980D4F1), int32_t(0x00000000)},
    {"da15yg40.aud", "", int32_t(0x7982D4F1), int32_t(0x00000000)},
    {"da15ym00.aud", "", int32_t(0x797AE0F1), int32_t(0x00000000)},
    {"da15ym10.aud", "", int32_t(0x797CE0F1), int32_t(0x00000000)},
    {"da15ym12.aud", "", int32_t(0x7D7CE0F1), int32_t(0x00000000)},
    {"da15ym30.aud", "", int32_t(0x7980E0F1), int32_t(0x00000000)},
    {"da15ym40.aud", "", int32_t(0x7982E0F1), int32_t(0x00000000)},
    {"da15yn00.aud", "", int32_t(0x797AE2F1), int32_t(0x00000000)},
    {"da15yn10.aud", "", int32_t(0x797CE2F1), int32_t(0x00000000)},
    {"da15yn20.aud", "", int32_t(0x797EE2F1), int32_t(0x00000000)},
    {"da15yn22.aud", "", int32_t(0x7D7EE2F1), int32_t(0x00000000)},
    {"da15yn30.aud", "", int32_t(0x7980E2F1), int32_t(0x00000000)},
    {"da15yn40.aud", "", int32_t(0x7982E2F1), int32_t(0x00000000)},
    {"da15yo00.aud", "", int32_t(0x797AE4F1), int32_t(0x00000000)},
    {"da15yo10.aud", "", int32_t(0x797CE4F1), int32_t(0x00000000)},
    {"da15yo20.aud", "", int32_t(0x797EE4F1), int32_t(0x00000000)},
    {"da15yo30.aud", "", int32_t(0x7980E4F1), int32_t(0x00000000)},
    {"da15yo32.aud", "", int32_t(0x7D80E4F1), int32_t(0x00000000)},
    {"da15yo40.aud", "", int32_t(0x7982E4F1), int32_t(0x00000000)},
    {"da15yp00.aud", "", int32_t(0x797AE6F1), int32_t(0x00000000)},
    {"da15yp10.aud", "", int32_t(0x797CE6F1), int32_t(0x00000000)},
    {"da15yp20.aud", "", int32_t(0x797EE6F1), int32_t(0x00000000)},
    {"da15yp30.aud", "", int32_t(0x7980E6F1), int32_t(0x00000000)},
    {"da15yp40.aud", "", int32_t(0x7982E6F1), int32_t(0x00000000)},
    {"da15yq00.aud", "", int32_t(0x797AE8F1), int32_t(0x00000000)},
    {"da15yq10.aud", "", int32_t(0x797CE8F1), int32_t(0x00000000)},
    {"da15yq20.aud", "", int32_t(0x797EE8F1), int32_t(0x00000000)},
    {"da15yq30.aud", "", int32_t(0x7980E8F1), int32_t(0x00000000)},
    {"da15yq32.aud", "", int32_t(0x7D80E8F1), int32_t(0x00000000)},
    {"da15yq40.aud", "", int32_t(0x7982E8F1), int32_t(0x00000000)},
    {"da15ys00.aud", "", int32_t(0x797AECF1), int32_t(0x00000000)},
    {"da15yu00.aud", "", int32_t(0x797AF0F1), int32_t(0x00000000)},
    {"da15zg00.aud", "", int32_t(0x797AD4F3), int32_t(0x00000000)},
    {"da15zg10.aud", "", int32_t(0x797CD4F3), int32_t(0x00000000)},
    {"da15zg20.aud", "", int32_t(0x797ED4F3), int32_t(0x00000000)},
    {"da15zg30.aud", "", int32_t(0x7980D4F3), int32_t(0x00000000)},
    {"da15zg40.aud", "", int32_t(0x7982D4F3), int32_t(0x00000000)},
    {"da15zh00.aud", "", int32_t(0x797AD6F3), int32_t(0x00000000)},
    {"da15zh10.aud", "", int32_t(0x797CD6F3), int32_t(0x00000000)},
    {"da15zh20.aud", "", int32_t(0x797ED6F3), int32_t(0x00000000)},
    {"da15zh30.aud", "", int32_t(0x7980D6F3), int32_t(0x00000000)},
    {"da15zh32.aud", "", int32_t(0x7D80D6F3), int32_t(0x00000000)},
    {"da15zh40.aud", "", int32_t(0x7982D6F3), int32_t(0x00000000)},
    {"da15zh42.aud", "", int32_t(0x7D82D6F3), int32_t(0x00000000)},
    {"da15zi00.aud", "", int32_t(0x797AD8F3), int32_t(0x00000000)},
    {"da15zi10.aud", "", int32_t(0x797CD8F3), int32_t(0x00000000)},
    {"da15zi20.aud", "", int32_t(0x797ED8F3), int32_t(0x00000000)},
    {"da15zi30.aud", "", int32_t(0x7980D8F3), int32_t(0x00000000)},
    {"da15zi40.aud", "", int32_t(0x7982D8F3), int32_t(0x00000000)},
    {"da15zj00.aud", "", int32_t(0x797ADAF3), int32_t(0x00000000)},
    {"da15zj10.aud", "", int32_t(0x797CDAF3), int32_t(0x00000000)},
    {"da15zj20.aud", "", int32_t(0x797EDAF3), int32_t(0x00000000)},
    {"da15zj30.aud", "", int32_t(0x7980DAF3), int32_t(0x00000000)},
    {"da15zj40.aud", "", int32_t(0x7982DAF3), int32_t(0x00000000)},
    {"da15zk00.aud", "", int32_t(0x797ADCF3), int32_t(0x00000000)},
    {"da19t901.aud", "", int32_t(0x8B7AB8E7), int32_t(0x00000000)},
    {"da19t903.aud", "", int32_t(0x8F7AB8E7), int32_t(0x00000000)},
    {"da19t905.aud", "", int32_t(0x937AB8E7), int32_t(0x00000000)},
    {"da19t907.aud", "", int32_t(0x977AB8E7), int32_t(0x00000000)},
    {"da19t909.aud", "", int32_t(0x9B7AB8E7), int32_t(0x00000000)},
    {"da19t911.aud", "", int32_t(0x8B7CB8E7), int32_t(0x00000000)},
    {"da19t913.aud", "", int32_t(0x8F7CB8E7), int32_t(0x00000000)},
    {"da19t915.aud", "", int32_t(0x937CB8E7), int32_t(0x00000000)},
    {"da19t917.aud", "", int32_t(0x977CB8E7), int32_t(0x00000000)},
    {"da20a104.aud", "", int32_t(0x6D7EA8C1), int32_t(0x00000000)},
    {"da20a107.aud", "", int32_t(0x737EA8C1), int32_t(0x00000000)},
    {"da20a109.aud", "", int32_t(0x777EA8C1), int32_t(0x00000000)},
    {"da20a116.aud", "", int32_t(0x7180A8C1), int32_t(0x00000000)},
    {"da21a300.aud", "", int32_t(0x697EACC1), int32_t(0x00000000)},
    {"da21a303.aud", "", int32_t(0x6F7EACC1), int32_t(0x00000000)},
    {"da21a305.aud", "", int32_t(0x737EACC1), int32_t(0x00000000)},
    {"da21a306.aud", "", int32_t(0x757EACC1), int32_t(0x00000000)},
    {"da21a307.aud", "", int32_t(0x777EACC1), int32_t(0x00000000)},
    {"da21a309.aud", "", int32_t(0x7B7EACC1), int32_t(0x00000000)},
    {"da21a310.aud", "", int32_t(0x6980ACC1), int32_t(0x00000000)},
    {"da21a311.aud", "", int32_t(0x6B80ACC1), int32_t(0x00000000)},
    {"da21a313.aud", "", int32_t(0x6F80ACC1), int32_t(0x00000000)},
    {"da21a315.aud", "", int32_t(0x7380ACC1), int32_t(0x00000000)},
    {"da21a316.aud", "", int32_t(0x7580ACC1), int32_t(0x00000000)},
    {"da21a317.aud", "", int32_t(0x7780ACC1), int32_t(0x00000000)},
    {"da21a318.aud", "", int32_t(0x7980ACC1), int32_t(0x00000000)},
    {"da21a319.aud", "", int32_t(0x7B80ACC1), int32_t(0x00000000)},
    {"da21a320.aud", "", int32_t(0x6982ACC1), int32_t(0x00000000)},
    {"da21a324.aud", "", int32_t(0x7182ACC1), int32_t(0x00000000)},
    {"da21qp15.aud", "", int32_t(0x7380E6E1), int32_t(0x00000000)},
    {"da21qp16.aud", "", int32_t(0x7580E6E1), int32_t(0x00000000)},
    {"da21qp17.aud", "", int32_t(0x7780E6E1), int32_t(0x00000000)},
    {"da21qp18.aud", "", int32_t(0x7980E6E1), int32_t(0x00000000)},
    {"da21u901.aud", "", int32_t(0x6B7EB8E9), int32_t(0x00000000)},
    {"da22a000.aud", "", int32_t(0x6D7EA6C1), int32_t(0x00000000)},
    {"da22a001.aud", "", int32_t(0x6F7EA6C1), int32_t(0x00000000)},
    {"da22a004.aud", "", int32_t(0x757EA6C1), int32_t(0x00000000)},
    {"da24a102.aud", "", int32_t(0x797EA8C1), int32_t(0x00000000)},
    {"da24a111.aud", "", int32_t(0x7780A8C1), int32_t(0x00000000)},
    {"da24a112.aud", "", int32_t(0x7980A8C1), int32_t(0x00000000)},
    {"da24a113.aud", "", int32_t(0x7B80A8C1), int32_t(0x00000000)},
    {"da24a114.aud", "", int32_t(0x7D80A8C1), int32_t(0x00000000)},
    {"da26eg11.aud", "", int32_t(0x7F80D4C9), int32_t(0x00000000)},
    {"da26et11.aud", "", int32_t(0x7F80EEC9), int32_t(0x00000000)},
    {"da26qh10.aud", "", int32_t(0x7D80D6E1), int32_t(0x00000000)},
    {"da26vc00.aud", "", int32_t(0x7D7ECCEB), int32_t(0x00000000)},
    {"da26vc01.aud", "", int32_t(0x7F7ECCEB), int32_t(0x00000000)},
    {"da26vc02.aud", "", int32_t(0x817ECCEB), int32_t(0x00000000)},
    {"da26vc03.aud", "", int32_t(0x837ECCEB), int32_t(0x00000000)},
    {"da26vc04.aud", "", int32_t(0x857ECCEB), int32_t(0x00000000)},
    {"da26vc05.aud", "", int32_t(0x877ECCEB), int32_t(0x00000000)},
    {"da26vc06.aud", "", int32_t(0x897ECCEB), int32_t(0x00000000)},
    {"da26vc07.aud", "", int32_t(0x8B7ECCEB), int32_t(0x00000000)},
    {"da26vc08.aud", "", int32_t(0x8D7ECCEB), int32_t(0x00000000)},
    {"da26vc09.aud", "", int32_t(0x8F7ECCEB), int32_t(0x00000000)},
    {"da26vc10.aud", "", int32_t(0x7D80CCEB), int32_t(0x00000000)},
    {"da26vc11.aud", "", int32_t(0x7F80CCEB), int32_t(0x00000000)},
    {"da26vc12.aud", "", int32_t(0x8180CCEB), int32_t(0x00000000)},
    {"da26vc13.aud", "", int32_t(0x8380CCEB), int32_t(0x00000000)},
    {"da26vc14.aud", "", int32_t(0x8580CCEB), int32_t(0x00000000)},
    {"da26vc15.aud", "", int32_t(0x8780CCEB), int32_t(0x00000000)},
    {"da26vc16.aud", "", int32_t(0x8980CCEB), int32_t(0x00000000)},
    {"da26vc17.aud", "", int32_t(0x8B80CCEB), int32_t(0x00000000)},
    {"da26vc18.aud", "", int32_t(0x8D80CCEB), int32_t(0x00000000)},
    {"da26vc19.aud", "", int32_t(0x8F80CCEB), int32_t(0x00000000)},
    {"da26vc20.aud", "", int32_t(0x7D82CCEB), int32_t(0x00000000)},
    {"da26vc21.aud", "", int32_t(0x7F82CCEB), int32_t(0x00000000)},
    {"da26vc22.aud", "", int32_t(0x8182CCEB), int32_t(0x00000000)},
    {"da26vc23.aud", "", int32_t(0x8382CCEB), int32_t(0x00000000)},
    {"da26vc24.aud", "", int32_t(0x8582CCEB), int32_t(0x00000000)},
    {"da26vc25.aud", "", int32_t(0x8782CCEB), int32_t(0x00000000)},
    {"da26vc26.aud", "", int32_t(0x8982CCEB), int32_t(0x00000000)},
    {"da26vc27.aud", "", int32_t(0x8B82CCEB), int32_t(0x00000000)},
    {"da26vc28.aud", "", int32_t(0x8D82CCEB), int32_t(0x00000000)},
    {"da26vc29.aud", "", int32_t(0x8F82CCEB), int32_t(0x00000000)},
    {"da26vc30.aud", "", int32_t(0x7D84CCEB), int32_t(0x00000000)},
    {"da26vc31.aud", "", int32_t(0x7F84CCEB), int32_t(0x00000000)},
    {"da26vc32.aud", "", int32_t(0x8184CCEB), int32_t(0x00000000)},
    {"da26vc33.aud", "", int32_t(0x8384CCEB), int32_t(0x00000000)},
    {"da26vc34.aud", "", int32_t(0x8584CCEB), int32_t(0x00000000)},
    {"da26vc35.aud", "", int32_t(0x8784CCEB), int32_t(0x00000000)},
    {"da26vc36.aud", "", int32_t(0x8984CCEB), int32_t(0x00000000)},
    {"da26vc37.aud", "", int32_t(0x8B84CCEB), int32_t(0x00000000)},
    {"da26vc38.aud", "", int32_t(0x8D84CCEB), int32_t(0x00000000)},
    {"da26vc39.aud", "", int32_t(0x8F84CCEB), int32_t(0x00000000)},
    {"da26vc40.aud", "", int32_t(0x7D86CCEB), int32_t(0x00000000)},
    {"da26vc41.aud", "", int32_t(0x7F86CCEB), int32_t(0x00000000)},
    {"da26vc42.aud", "", int32_t(0x8186CCEB), int32_t(0x00000000)},
    {"da26vc43.aud", "", int32_t(0x8386CCEB), int32_t(0x00000000)},
    {"da26vc44.aud", "", int32_t(0x8586CCEB), int32_t(0x00000000)},
    {"da26vc45.aud", "", int32_t(0x8786CCEB), int32_t(0x00000000)},
    {"da26vc46.aud", "", int32_t(0x8986CCEB), int32_t(0x00000000)},
    {"da26vc47.aud", "", int32_t(0x8B86CCEB), int32_t(0x00000000)},
    {"da26vc48.aud", "", int32_t(0x8D86CCEB), int32_t(0x00000000)},
    {"da26vc49.aud", "", int32_t(0x8F86CCEB), int32_t(0x00000000)},
    {"da26vc50.aud", "", int32_t(0x7D88CCEB), int32_t(0x00000000)},
    {"da26vj10.aud", "", int32_t(0x7D80DAEB), int32_t(0x00000000)},
    {"da26vk10.aud", "", int32_t(0x7D80DCEB), int32_t(0x00000000)},
    {"da26vl10.aud", "", int32_t(0x7D80DEEB), int32_t(0x00000000)},
    {"da26vm10.aud", "", int32_t(0x7D80E0EB), int32_t(0x00000000)},
    {"da26yg11.aud", "", int32_t(0x7F80D4F1), int32_t(0x00000000)},
    {"da26yg12.aud", "", int32_t(0x8180D4F1), int32_t(0x00000000)},
    {"da26ym11.aud", "", int32_t(0x7F80E0F1), int32_t(0x00000000)},
    {"da26yn11.aud", "", int32_t(0x7F80E2F1), int32_t(0x00000000)},
    {"da26yo11.aud", "", int32_t(0x7F80E4F1), int32_t(0x00000000)},
    {"da26yp11.aud", "", int32_t(0x7F80E6F1), int32_t(0x00000000)},
    {"da26yq11.aud", "", int32_t(0x7F80E8F1), int32_t(0x00000000)},
    {"da26yu10.aud", "", int32_t(0x7D80F0F1), int32_t(0x00000000)},
    {"da26yu11.aud", "", int32_t(0x7F80F0F1), int32_t(0x00000000)},
    {"da26yu12.aud", "", int32_t(0x8180F0F1), int32_t(0x00000000)},
    {"da26yu13.aud", "", int32_t(0x8380F0F1), int32_t(0x00000000)},
    {"da26yu14.aud", "", int32_t(0x8580F0F1), int32_t(0x00000000)},
    {"da26yu15.aud", "", int32_t(0x8780F0F1), int32_t(0x00000000)},
    {"da26yu16.aud", "", int32_t(0x8980F0F1), int32_t(0x00000000)},
    {"da26zg11.aud", "", int32_t(0x7F80D4F3), int32_t(0x00000000)},
    {"da26zh11.aud", "", int32_t(0x7F80D6F3), int32_t(0x00000000)},
    {"da26zi11.aud", "", int32_t(0x7F80D8F3), int32_t(0x00000000)},
    {"da26zj11.aud", "", int32_t(0x7F80DAF3), int32_t(0x00000000)},
    {"da26zk10.aud", "", int32_t(0x7D80DCF3), int32_t(0x00000000)},
    {"da26zk11.aud", "", int32_t(0x7F80DCF3), int32_t(0x00000000)},
    {"da26zk12.aud", "", int32_t(0x8180DCF3), int32_t(0x00000000)},
    {"da26zk13.aud", "", int32_t(0x8380DCF3), int32_t(0x00000000)},
    {"da26zk14.aud", "", int32_t(0x8580DCF3), int32_t(0x00000000)},
    {"da26zk15.aud", "", int32_t(0x8780DCF3), int32_t(0x00000000)},
    {"da26zk16.aud", "", int32_t(0x8980DCF3), int32_t(0x00000000)},
    {"da26zk17.aud", "", int32_t(0x8B80DCF3), int32_t(0x00000000)},
    {"da26zk18.aud", "", int32_t(0x8D80DCF3), int32_t(0x00000000)},
    {"da26zk19.aud", "", int32_t(0x8F80DCF3), int32_t(0x00000000)},
    {"da27eg21.aud", "", int32_t(0x8382D4C9), int32_t(0x00000000)},
    {"da27et21.aud", "", int32_t(0x8382EEC9), int32_t(0x00000000)},
    {"da27qh20.aud", "", int32_t(0x8182D6E1), int32_t(0x00000000)},
    {"da27vd00.aud", "", int32_t(0x817ECEEB), int32_t(0x00000000)},
    {"da27vd01.aud", "", int32_t(0x837ECEEB), int32_t(0x00000000)},
    {"da27vd02.aud", "", int32_t(0x857ECEEB), int32_t(0x00000000)},
    {"da27vd03.aud", "", int32_t(0x877ECEEB), int32_t(0x00000000)},
    {"da27vd04.aud", "", int32_t(0x897ECEEB), int32_t(0x00000000)},
    {"da27vd05.aud", "", int32_t(0x8B7ECEEB), int32_t(0x00000000)},
    {"da27vd06.aud", "", int32_t(0x8D7ECEEB), int32_t(0x00000000)},
    {"da27vd07.aud", "", int32_t(0x8F7ECEEB), int32_t(0x00000000)},
    {"da27vd08.aud", "", int32_t(0x917ECEEB), int32_t(0x00000000)},
    {"da27vd09.aud", "", int32_t(0x937ECEEB), int32_t(0x00000000)},
    {"da27vd10.aud", "", int32_t(0x8180CEEB), int32_t(0x00000000)},
    {"da27vd11.aud", "", int32_t(0x8380CEEB), int32_t(0x00000000)},
    {"da27vd12.aud", "", int32_t(0x8580CEEB), int32_t(0x00000000)},
    {"da27vd13.aud", "", int32_t(0x8780CEEB), int32_t(0x00000000)},
    {"da27vd14.aud", "", int32_t(0x8980CEEB), int32_t(0x00000000)},
    {"da27vd15.aud", "", int32_t(0x8B80CEEB), int32_t(0x00000000)},
    {"da27vd16.aud", "", int32_t(0x8D80CEEB), int32_t(0x00000000)},
    {"da27vd17.aud", "", int32_t(0x8F80CEEB), int32_t(0x00000000)},
    {"da27vd18.aud", "", int32_t(0x9180CEEB), int32_t(0x00000000)},
    {"da27vd19.aud", "", int32_t(0x9380CEEB), int32_t(0x00000000)},
    {"da27vd20.aud", "", int32_t(0x8182CEEB), int32_t(0x00000000)},
    {"da27vd21.aud", "", int32_t(0x8382CEEB), int32_t(0x00000000)},
    {"da27vd22.aud", "", int32_t(0x8582CEEB), int32_t(0x00000000)},
    {"da27vd23.aud", "", int32_t(0x8782CEEB), int32_t(0x00000000)},
    {"da27vd24.aud", "", int32_t(0x8982CEEB), int32_t(0x00000000)},
    {"da27vd25.aud", "", int32_t(0x8B82CEEB), int32_t(0x00000000)},
    {"da27vd26.aud", "", int32_t(0x8D82CEEB), int32_t(0x00000000)},
    {"da27vd27.aud", "", int32_t(0x8F82CEEB), int32_t(0x00000000)},
    {"da27vd28.aud", "", int32_t(0x9182CEEB), int32_t(0x00000000)},
    {"da27vd29.aud", "", int32_t(0x9382CEEB), int32_t(0x00000000)},
    {"da27vd30.aud", "", int32_t(0x8184CEEB), int32_t(0x00000000)},
    {"da27vd31.aud", "", int32_t(0x8384CEEB), int32_t(0x00000000)},
    {"da27vd32.aud", "", int32_t(0x8584CEEB), int32_t(0x00000000)},
    {"da27vd33.aud", "", int32_t(0x8784CEEB), int32_t(0x00000000)},
    {"da27vd34.aud", "", int32_t(0x8984CEEB), int32_t(0x00000000)},
    {"da27vd35.aud", "", int32_t(0x8B84CEEB), int32_t(0x00000000)},
    {"da27vd36.aud", "", int32_t(0x8D84CEEB), int32_t(0x00000000)},
    {"da27vd37.aud", "", int32_t(0x8F84CEEB), int32_t(0x00000000)},
    {"da27vd38.aud", "", int32_t(0x9184CEEB), int32_t(0x00000000)},
    {"da27vd39.aud", "", int32_t(0x9384CEEB), int32_t(0x00000000)},
    {"da27vd40.aud", "", int32_t(0x8186CEEB), int32_t(0x00000000)},
    {"da27vd41.aud", "", int32_t(0x8386CEEB), int32_t(0x00000000)},
    {"da27vd42.aud", "", int32_t(0x8586CEEB), int32_t(0x00000000)},
    {"da27vd43.aud", "", int32_t(0x8786CEEB), int32_t(0x00000000)},
    {"da27vd44.aud", "", int32_t(0x8986CEEB), int32_t(0x00000000)},
    {"da27vd45.aud", "", int32_t(0x8B86CEEB), int32_t(0x00000000)},
    {"da27vd46.aud", "", int32_t(0x8D86CEEB), int32_t(0x00000000)},
    {"da27vd47.aud", "", int32_t(0x8F86CEEB), int32_t(0x00000000)},
    {"da27vd48.aud", "", int32_t(0x9186CEEB), int32_t(0x00000000)},
    {"da27vd49.aud", "", int32_t(0x9386CEEB), int32_t(0x00000000)},
    {"da27vd50.aud", "", int32_t(0x8188CEEB), int32_t(0x00000000)},
    {"da27yg21.aud", "", int32_t(0x8382D4F1), int32_t(0x00000000)},
    {"da27ym20.aud", "", int32_t(0x8182E0F1), int32_t(0x00000000)},
    {"da27yn21.aud", "", int32_t(0x8382E2F1), int32_t(0x00000000)},
    {"da27yo21.aud", "", int32_t(0x8382E4F1), int32_t(0x00000000)},
    {"da27yp21.aud", "", int32_t(0x8382E6F1), int32_t(0x00000000)},
    {"da27yq21.aud", "", int32_t(0x8382E8F1), int32_t(0x00000000)},
    {"da27yu20.aud", "", int32_t(0x8182F0F1), int32_t(0x00000000)},
    {"da27yu21.aud", "", int32_t(0x8382F0F1), int32_t(0x00000000)},
    {"da27yu22.aud", "", int32_t(0x8582F0F1), int32_t(0x00000000)},
    {"da27yu23.aud", "", int32_t(0x8782F0F1), int32_t(0x00000000)},
    {"da27yu24.aud", "", int32_t(0x8982F0F1), int32_t(0x00000000)},
    {"da27yu25.aud", "", int32_t(0x8B82F0F1), int32_t(0x00000000)},
    {"da27yu26.aud", "", int32_t(0x8D82F0F1), int32_t(0x00000000)},
    {"da27yu27.aud", "", int32_t(0x8F82F0F1), int32_t(0x00000000)},
    {"da27yu28.aud", "", int32_t(0x9182F0F1), int32_t(0x00000000)},
    {"da27yu29.aud", "", int32_t(0x9382F0F1), int32_t(0x00000000)},
    {"da27zg21.aud", "", int32_t(0x8382D4F3), int32_t(0x00000000)},
    {"da27zh21.aud", "", int32_t(0x8382D6F3), int32_t(0x00000000)},
    {"da27zi21.aud", "", int32_t(0x8382D8F3), int32_t(0x00000000)},
    {"da27zj21.aud", "", int32_t(0x8382DAF3), int32_t(0x00000000)},
    {"da27zk20.aud", "", int32_t(0x8182DCF3), int32_t(0x00000000)},
    {"da27zk21.aud", "", int32_t(0x8382DCF3), int32_t(0x00000000)},
    {"da27zk22.aud", "", int32_t(0x8582DCF3), int32_t(0x00000000)},
    {"da27zk23.aud", "", int32_t(0x8782DCF3), int32_t(0x00000000)},
    {"da27zk24.aud", "", int32_t(0x8982DCF3), int32_t(0x00000000)},
    {"da27zk25.aud", "", int32_t(0x8B82DCF3), int32_t(0x00000000)},
    {"da27zk26.aud", "", int32_t(0x8D82DCF3), int32_t(0x00000000)},
    {"da27zk27.aud", "", int32_t(0x8F82DCF3), int32_t(0x00000000)},
    {"da27zk28.aud", "", int32_t(0x9182DCF3), int32_t(0x00000000)},
    {"da27zk29.aud", "", int32_t(0x9382DCF3), int32_t(0x00000000)},
    {"da28b531.aud", "", int32_t(0x8784B0C3), int32_t(0x00000000)},
    {"da28ef31.aud", "", int32_t(0x8784D2C9), int32_t(0x00000000)},
    {"da28et31.aud", "", int32_t(0x8784EEC9), int32_t(0x00000000)},
    {"da28qh30.aud", "", int32_t(0x8584D6E1), int32_t(0x00000000)},
    {"da28ve00.aud", "", int32_t(0x857ED0EB), int32_t(0x00000000)},
    {"da28ve01.aud", "", int32_t(0x877ED0EB), int32_t(0x00000000)},
    {"da28ve02.aud", "", int32_t(0x897ED0EB), int32_t(0x00000000)},
    {"da28ve03.aud", "", int32_t(0x8B7ED0EB), int32_t(0x00000000)},
    {"da28ve04.aud", "", int32_t(0x8D7ED0EB), int32_t(0x00000000)},
    {"da28ve05.aud", "", int32_t(0x8F7ED0EB), int32_t(0x00000000)},
    {"da28ve06.aud", "", int32_t(0x917ED0EB), int32_t(0x00000000)},
    {"da28ve07.aud", "", int32_t(0x937ED0EB), int32_t(0x00000000)},
    {"da28ve08.aud", "", int32_t(0x957ED0EB), int32_t(0x00000000)},
    {"da28ve09.aud", "", int32_t(0x977ED0EB), int32_t(0x00000000)},
    {"da28ve10.aud", "", int32_t(0x8580D0EB), int32_t(0x00000000)},
    {"da28ve11.aud", "", int32_t(0x8780D0EB), int32_t(0x00000000)},
    {"da28ve12.aud", "", int32_t(0x8980D0EB), int32_t(0x00000000)},
    {"da28ve13.aud", "", int32_t(0x8B80D0EB), int32_t(0x00000000)},
    {"da28ve14.aud", "", int32_t(0x8D80D0EB), int32_t(0x00000000)},
    {"da28ve15.aud", "", int32_t(0x8F80D0EB), int32_t(0x00000000)},
    {"da28ve16.aud", "", int32_t(0x9180D0EB), int32_t(0x00000000)},
    {"da28ve17.aud", "", int32_t(0x9380D0EB), int32_t(0x00000000)},
    {"da28ve18.aud", "", int32_t(0x9580D0EB), int32_t(0x00000000)},
    {"da28ve19.aud", "", int32_t(0x9780D0EB), int32_t(0x00000000)},
    {"da28ve20.aud", "", int32_t(0x8582D0EB), int32_t(0x00000000)},
    {"da28ve21.aud", "", int32_t(0x8782D0EB), int32_t(0x00000000)},
    {"da28ve22.aud", "", int32_t(0x8982D0EB), int32_t(0x00000000)},
    {"da28ve23.aud", "", int32_t(0x8B82D0EB), int32_t(0x00000000)},
    {"da28ve24.aud", "", int32_t(0x8D82D0EB), int32_t(0x00000000)},
    {"da28ve25.aud", "", int32_t(0x8F82D0EB), int32_t(0x00000000)},
    {"da28ve26.aud", "", int32_t(0x9182D0EB), int32_t(0x00000000)},
    {"da28ve27.aud", "", int32_t(0x9382D0EB), int32_t(0x00000000)},
    {"da28ve28.aud", "", int32_t(0x9582D0EB), int32_t(0x00000000)},
    {"da28ve29.aud", "", int32_t(0x9782D0EB), int32_t(0x00000000)},
    {"da28ve30.aud", "", int32_t(0x8584D0EB), int32_t(0x00000000)},
    {"da28ve31.aud", "", int32_t(0x8784D0EB), int32_t(0x00000000)},
    {"da28ve32.aud", "", int32_t(0x8984D0EB), int32_t(0x00000000)},
    {"da28ve33.aud", "", int32_t(0x8B84D0EB), int32_t(0x00000000)},
    {"da28ve34.aud", "", int32_t(0x8D84D0EB), int32_t(0x00000000)},
    {"da28ve35.aud", "", int32_t(0x8F84D0EB), int32_t(0x00000000)},
    {"da28ve36.aud", "", int32_t(0x9184D0EB), int32_t(0x00000000)},
    {"da28ve37.aud", "", int32_t(0x9384D0EB), int32_t(0x00000000)},
    {"da28ve38.aud", "", int32_t(0x9584D0EB), int32_t(0x00000000)},
    {"da28ve39.aud", "", int32_t(0x9784D0EB), int32_t(0x00000000)},
    {"da28ve40.aud", "", int32_t(0x8586D0EB), int32_t(0x00000000)},
    {"da28ve41.aud", "", int32_t(0x8786D0EB), int32_t(0x00000000)},
    {"da28ve42.aud", "", int32_t(0x8986D0EB), int32_t(0x00000000)},
    {"da28ve43.aud", "", int32_t(0x8B86D0EB), int32_t(0x00000000)},
    {"da28ve44.aud", "", int32_t(0x8D86D0EB), int32_t(0x00000000)},
    {"da28ve45.aud", "", int32_t(0x8F86D0EB), int32_t(0x00000000)},
    {"da28ve46.aud", "", int32_t(0x9186D0EB), int32_t(0x00000000)},
    {"da28ve47.aud", "", int32_t(0x9386D0EB), int32_t(0x00000000)},
    {"da28ve48.aud", "", int32_t(0x9586D0EB), int32_t(0x00000000)},
    {"da28ve49.aud", "", int32_t(0x9786D0EB), int32_t(0x00000000)},
    {"da28ve50.aud", "", int32_t(0x8588D0EB), int32_t(0x00000000)},
    {"da28yg31.aud", "", int32_t(0x8784D4F1), int32_t(0x00000000)},
    {"da28ym31.aud", "", int32_t(0x8784E0F1), int32_t(0x00000000)},
    {"da28yn31.aud", "", int32_t(0x8784E2F1), int32_t(0x00000000)},
    {"da28yo31.aud", "", int32_t(0x8784E4F1), int32_t(0x00000000)},
    {"da28yo33.aud", "", int32_t(0x8B84E4F1), int32_t(0x00000000)},
    {"da28yp31.aud", "", int32_t(0x8784E6F1), int32_t(0x00000000)},
    {"da28yq31.aud", "", int32_t(0x8784E8F1), int32_t(0x00000000)},
    {"da28yu30.aud", "", int32_t(0x8584F0F1), int32_t(0x00000000)},
    {"da28yu31.aud", "", int32_t(0x8784F0F1), int32_t(0x00000000)},
    {"da28yu32.aud", "", int32_t(0x8984F0F1), int32_t(0x00000000)},
    {"da28yu33.aud", "", int32_t(0x8B84F0F1), int32_t(0x00000000)},
    {"da28yu34.aud", "", int32_t(0x8D84F0F1), int32_t(0x00000000)},
    {"da28yu35.aud", "", int32_t(0x8F84F0F1), int32_t(0x00000000)},
    {"da28yu36.aud", "", int32_t(0x9184F0F1), int32_t(0x00000000)},
    {"da28yu37.aud", "", int32_t(0x9384F0F1), int32_t(0x00000000)},
    {"da28yu38.aud", "", int32_t(0x9584F0F1), int32_t(0x00000000)},
    {"da28yu39.aud", "", int32_t(0x9784F0F1), int32_t(0x00000000)},
    {"da28zg31.aud", "", int32_t(0x8784D4F3), int32_t(0x00000000)},
    {"da28zh31.aud", "", int32_t(0x8784D6F3), int32_t(0x00000000)},
    {"da28zh33.aud", "", int32_t(0x8B84D6F3), int32_t(0x00000000)},
    {"da28zi31.aud", "", int32_t(0x8784D8F3), int32_t(0x00000000)},
    {"da28zj31.aud", "", int32_t(0x8784DAF3), int32_t(0x00000000)},
    {"da28zk30.aud", "", int32_t(0x8584DCF3), int32_t(0x00000000)},
    {"da28zk31.aud", "", int32_t(0x8784DCF3), int32_t(0x00000000)},
    {"da28zk32.aud", "", int32_t(0x8984DCF3), int32_t(0x00000000)},
    {"da28zk33.aud", "", int32_t(0x8B84DCF3), int32_t(0x00000000)},
    {"da28zk34.aud", "", int32_t(0x8D84DCF3), int32_t(0x00000000)},
    {"da28zk35.aud", "", int32_t(0x8F84DCF3), int32_t(0x00000000)},
    {"da28zk36.aud", "", int32_t(0x9184DCF3), int32_t(0x00000000)},
    {"da28zk37.aud", "", int32_t(0x9384DCF3), int32_t(0x00000000)},
    {"da28zk38.aud", "", int32_t(0x9584DCF3), int32_t(0x00000000)},
    {"da28zk39.aud", "", int32_t(0x9784DCF3), int32_t(0x00000000)},
    {"da29b541.aud", "", int32_t(0x8B86B0C3), int32_t(0x00000000)},
    {"da29eg41.aud", "", int32_t(0x8B86D4C9), int32_t(0x00000000)},
    {"da29eg43.aud", "", int32_t(0x8F86D4C9), int32_t(0x00000000)},
    {"da29et41.aud", "", int32_t(0x8B86EEC9), int32_t(0x00000000)},
    {"da29qh40.aud", "", int32_t(0x8986D6E1), int32_t(0x00000000)},
    {"da29vf00.aud", "", int32_t(0x897ED2EB), int32_t(0x00000000)},
    {"da29vf01.aud", "", int32_t(0x8B7ED2EB), int32_t(0x00000000)},
    {"da29vf03.aud", "", int32_t(0x8F7ED2EB), int32_t(0x00000000)},
    {"da29vf04.aud", "", int32_t(0x917ED2EB), int32_t(0x00000000)},
    {"da29vf05.aud", "", int32_t(0x937ED2EB), int32_t(0x00000000)},
    {"da29vf06.aud", "", int32_t(0x957ED2EB), int32_t(0x00000000)},
    {"da29vf07.aud", "", int32_t(0x977ED2EB), int32_t(0x00000000)},
    {"da29vf08.aud", "", int32_t(0x997ED2EB), int32_t(0x00000000)},
    {"da29vf09.aud", "", int32_t(0x9B7ED2EB), int32_t(0x00000000)},
    {"da29vf10.aud", "", int32_t(0x8980D2EB), int32_t(0x00000000)},
    {"da29vf11.aud", "", int32_t(0x8B80D2EB), int32_t(0x00000000)},
    {"da29vf12.aud", "", int32_t(0x8D80D2EB), int32_t(0x00000000)},
    {"da29vf13.aud", "", int32_t(0x8F80D2EB), int32_t(0x00000000)},
    {"da29vf14.aud", "", int32_t(0x9180D2EB), int32_t(0x00000000)},
    {"da29vf15.aud", "", int32_t(0x9380D2EB), int32_t(0x00000000)},
    {"da29vf16.aud", "", int32_t(0x9580D2EB), int32_t(0x00000000)},
    {"da29vf17.aud", "", int32_t(0x9780D2EB), int32_t(0x00000000)},
    {"da29vf18.aud", "", int32_t(0x9980D2EB), int32_t(0x00000000)},
    {"da29vf19.aud", "", int32_t(0x9B80D2EB), int32_t(0x00000000)},
    {"da29vf20.aud", "", int32_t(0x8982D2EB), int32_t(0x00000000)},
    {"da29vf21.aud", "", int32_t(0x8B82D2EB), int32_t(0x00000000)},
    {"da29vf22.aud", "", int32_t(0x8D82D2EB), int32_t(0x00000000)},
    {"da29vf23.aud", "", int32_t(0x8F82D2EB), int32_t(0x00000000)},
    {"da29vf24.aud", "", int32_t(0x9182D2EB), int32_t(0x00000000)},
    {"da29vf25.aud", "", int32_t(0x9382D2EB), int32_t(0x00000000)},
    {"da29vf26.aud", "", int32_t(0x9582D2EB), int32_t(0x00000000)},
    {"da29vf27.aud", "", int32_t(0x9782D2EB), int32_t(0x00000000)},
    {"da29vf28.aud", "", int32_t(0x9982D2EB), int32_t(0x00000000)},
    {"da29vf29.aud", "", int32_t(0x9B82D2EB), int32_t(0x00000000)},
    {"da29vf30.aud", "", int32_t(0x8984D2EB), int32_t(0x00000000)},
    {"da29vf31.aud", "", int32_t(0x8B84D2EB), int32_t(0x00000000)},
    {"da29vf32.aud", "", int32_t(0x8D84D2EB), int32_t(0x00000000)},
    {"da29vf33.aud", "", int32_t(0x8F84D2EB), int32_t(0x00000000)},
    {"da29vf34.aud", "", int32_t(0x9184D2EB), int32_t(0x00000000)},
    {"da29vf35.aud", "", int32_t(0x9384D2EB), int32_t(0x00000000)},
    {"da29vf36.aud", "", int32_t(0x9584D2EB), int32_t(0x00000000)},
    {"da29vf37.aud", "", int32_t(0x9784D2EB), int32_t(0x00000000)},
    {"da29vf38.aud", "", int32_t(0x9984D2EB), int32_t(0x00000000)},
    {"da29vf39.aud", "", int32_t(0x9B84D2EB), int32_t(0x00000000)},
    {"da29vf40.aud", "", int32_t(0x8986D2EB), int32_t(0x00000000)},
    {"da29vf41.aud", "", int32_t(0x8B86D2EB), int32_t(0x00000000)},
    {"da29vf42.aud", "", int32_t(0x8D86D2EB), int32_t(0x00000000)},
    {"da29vf43.aud", "", int32_t(0x8F86D2EB), int32_t(0x00000000)},
    {"da29vf44.aud", "", int32_t(0x9186D2EB), int32_t(0x00000000)},
    {"da29vf45.aud", "", int32_t(0x9386D2EB), int32_t(0x00000000)},
    {"da29vf46.aud", "", int32_t(0x9586D2EB), int32_t(0x00000000)},
    {"da29vf47.aud", "", int32_t(0x9786D2EB), int32_t(0x00000000)},
    {"da29vf48.aud", "", int32_t(0x9986D2EB), int32_t(0x00000000)},
    {"da29vf49.aud", "", int32_t(0x9B86D2EB), int32_t(0x00000000)},
    {"da29vf50.aud", "", int32_t(0x8988D2EB), int32_t(0x00000000)},
    {"da29ym41.aud", "", int32_t(0x8B86E0F1), int32_t(0x00000000)},
    {"da29yn41.aud", "", int32_t(0x8B86E2F1), int32_t(0x00000000)},
    {"da29yo41.aud", "", int32_t(0x8B86E4F1), int32_t(0x00000000)},
    {"da29yp41.aud", "", int32_t(0x8B86E6F1), int32_t(0x00000000)},
    {"da29yq41.aud", "", int32_t(0x8B86E8F1), int32_t(0x00000000)},
    {"da29yu40.aud", "", int32_t(0x8986F0F1), int32_t(0x00000000)},
    {"da29yu41.aud", "", int32_t(0x8B86F0F1), int32_t(0x00000000)},
    {"da29yu42.aud", "", int32_t(0x8D86F0F1), int32_t(0x00000000)},
    {"da29yu43.aud", "", int32_t(0x8F86F0F1), int32_t(0x00000000)},
    {"da29yu44.aud", "", int32_t(0x9186F0F1), int32_t(0x00000000)},
    {"da29yu45.aud", "", int32_t(0x9386F0F1), int32_t(0x00000000)},
    {"da29yu46.aud", "", int32_t(0x9586F0F1), int32_t(0x00000000)},
    {"da29yu47.aud", "", int32_t(0x9786F0F1), int32_t(0x00000000)},
    {"da29zg41.aud", "", int32_t(0x8B86D4F3), int32_t(0x00000000)},
    {"da29zh41.aud", "", int32_t(0x8B86D6F3), int32_t(0x00000000)},
    {"da29zi41.aud", "", int32_t(0x8B86D8F3), int32_t(0x00000000)},
    {"da29zj41.aud", "", int32_t(0x8B86DAF3), int32_t(0x00000000)},
    {"da29zk40.aud", "", int32_t(0x8986DCF3), int32_t(0x00000000)},
    {"da29zk41.aud", "", int32_t(0x8B86DCF3), int32_t(0x00000000)},
    {"da29zk42.aud", "", int32_t(0x8D86DCF3), int32_t(0x00000000)},
    {"da29zk43.aud", "", int32_t(0x8F86DCF3), int32_t(0x00000000)},
    {"da29zk44.aud", "", int32_t(0x9186DCF3), int32_t(0x00000000)},
    {"da29zk45.aud", "", int32_t(0x9386DCF3), int32_t(0x00000000)},
    {"da29zk46.aud", "", int32_t(0x9586DCF3), int32_t(0x00000000)},
    {"da29zk47.aud", "", int32_t(0x9786DCF3), int32_t(0x00000000)},
    {"da29zk48.aud", "", int32_t(0x9986DCF3), int32_t(0x00000000)},
    {"da29zk49.aud", "", int32_t(0x9B86DCF3), int32_t(0x00000000)},
    {"da37xy00.aud", "", int32_t(0x8182F8EF), int32_t(0x00000000)},
    {"da37xy01.aud", "", int32_t(0x8382F8EF), int32_t(0x00000000)},
    {"da37xy02.aud", "", int32_t(0x8582F8EF), int32_t(0x00000000)},
    {"da37xy03.aud", "", int32_t(0x8782F8EF), int32_t(0x00000000)},
    {"da37xy04.aud", "", int32_t(0x8982F8EF), int32_t(0x00000000)},
    {"da37xy05.aud", "", int32_t(0x8B82F8EF), int32_t(0x00000000)},
    {"da37xy06.aud", "", int32_t(0x8D82F8EF), int32_t(0x00000000)},
    {"da37xy07.aud", "", int32_t(0x8F82F8EF), int32_t(0x00000000)},
    {"da37xy08.aud", "", int32_t(0x9182F8EF), int32_t(0x00000000)},
    {"da37xy09.aud", "", int32_t(0x9382F8EF), int32_t(0x00000000)},
    {"da37xy10.aud", "", int32_t(0x8184F8EF), int32_t(0x00000000)},
    {"da37xy11.aud", "", int32_t(0x8384F8EF), int32_t(0x00000000)},
    {"da37xy12.aud", "", int32_t(0x8584F8EF), int32_t(0x00000000)},
    {"da37xy13.aud", "", int32_t(0x8784F8EF), int32_t(0x00000000)},
    {"da37xy14.aud", "", int32_t(0x8984F8EF), int32_t(0x00000000)},
    {"da37xy15.aud", "", int32_t(0x8B84F8EF), int32_t(0x00000000)},
    {"da37xy16.aud", "", int32_t(0x8D84F8EF), int32_t(0x00000000)},
    {"da37xy17.aud", "", int32_t(0x8F84F8EF), int32_t(0x00000000)},
    {"da37xy18.aud", "", int32_t(0x9184F8EF), int32_t(0x00000000)},
    {"da37xy19.aud", "", int32_t(0x9384F8EF), int32_t(0x00000000)},
    {"da37xy20.aud", "", int32_t(0x8186F8EF), int32_t(0x00000000)},
    {"da37xy21.aud", "", int32_t(0x8386F8EF), int32_t(0x00000000)},
    {"da37xy22.aud", "", int32_t(0x8586F8EF), int32_t(0x00000000)},
    {"da37xy23.aud", "", int32_t(0x8786F8EF), int32_t(0x00000000)},
    {"da37xy24.aud", "", int32_t(0x8986F8EF), int32_t(0x00000000)},
    {"da37xy25.aud", "", int32_t(0x8B86F8EF), int32_t(0x00000000)},
    {"da37xy26.aud", "", int32_t(0x8D86F8EF), int32_t(0x00000000)},
    {"da37xy27.aud", "", int32_t(0x8F86F8EF), int32_t(0x00000000)},
    {"da37xy28.aud", "", int32_t(0x9186F8EF), int32_t(0x00000000)},
    {"da37xy29.aud", "", int32_t(0x9386F8EF), int32_t(0x00000000)},
    {"da37xy30.aud", "", int32_t(0x8188F8EF), int32_t(0x00000000)},
    {"da37xy31.aud", "", int32_t(0x8388F8EF), int32_t(0x00000000)},
    {"da37xy32.aud", "", int32_t(0x8588F8EF), int32_t(0x00000000)},
    {"da37xy33.aud", "", int32_t(0x8788F8EF), int32_t(0x00000000)},
    {"da37xy34.aud", "", int32_t(0x8988F8EF), int32_t(0x00000000)},
    {"da37xy35.aud", "", int32_t(0x8B88F8EF), int32_t(0x00000000)},
    {"da37xy36.aud", "", int32_t(0x8D88F8EF), int32_t(0x00000000)},
    {"da37xy37.aud", "", int32_t(0x8F88F8EF), int32_t(0x00000000)},
    {"da37yd22.aud", "", int32_t(0x8586CEF1), int32_t(0x00000000)},
    {"da37yd23.aud", "", int32_t(0x8786CEF1), int32_t(0x00000000)},
    {"da37yd24.aud", "", int32_t(0x8986CEF1), int32_t(0x00000000)},
    {"da37yd25.aud", "", int32_t(0x8B86CEF1), int32_t(0x00000000)},
    {"da37yd26.aud", "", int32_t(0x8D86CEF1), int32_t(0x00000000)},
    {"da37yd27.aud", "", int32_t(0x8F86CEF1), int32_t(0x00000000)},
    {"da37yd28.aud", "", int32_t(0x9186CEF1), int32_t(0x00000000)},
    {"da37yd29.aud", "", int32_t(0x9386CEF1), int32_t(0x00000000)},
    {"da45vg00.aud", "", int32_t(0x7986D4EB), int32_t(0x00000000)},
    {"da45vg05.aud", "", int32_t(0x8386D4EB), int32_t(0x00000000)},
    {"da56yd00.aud", "", int32_t(0x7D8ACEF1), int32_t(0x00000000)},
    {"da56yd01.aud", "", int32_t(0x7F8ACEF1), int32_t(0x00000000)},
    {"da56yd02.aud", "", int32_t(0x818ACEF1), int32_t(0x00000000)},
    {"da56yd03.aud", "", int32_t(0x838ACEF1), int32_t(0x00000000)},
    {"da56yd10.aud", "", int32_t(0x7D8CCEF1), int32_t(0x00000000)},
    {"da56yd11.aud", "", int32_t(0x7F8CCEF1), int32_t(0x00000000)},
    {"da56yd12.aud", "", int32_t(0x818CCEF1), int32_t(0x00000000)},
    {"da56yd13.aud", "", int32_t(0x838CCEF1), int32_t(0x00000000)},
    {"da56yd14.aud", "", int32_t(0x858CCEF1), int32_t(0x00000000)},
    {"da57yd04.aud", "", int32_t(0x898ACEF1), int32_t(0x00000000)},
    {"da57yd05.aud", "", int32_t(0x8B8ACEF1), int32_t(0x00000000)},
    {"da57yd06.aud", "", int32_t(0x8D8ACEF1), int32_t(0x00000000)},
    {"da59yd07.aud", "", int32_t(0x978ACEF1), int32_t(0x00000000)},
    {"da59yd08.aud", "", int32_t(0x998ACEF1), int32_t(0x00000000)},
    {"da59yd09.aud", "", int32_t(0x9B8ACEF1), int32_t(0x00000000)},
    {"da59yd15.aud", "", int32_t(0x938CCEF1), int32_t(0x00000000)},
    {"da59yd16.aud", "", int32_t(0x958CCEF1), int32_t(0x00000000)},
    {"da59yd17.aud", "", int32_t(0x978CCEF1), int32_t(0x00000000)},
    {"da59yd18.aud", "", int32_t(0x998CCEF1), int32_t(0x00000000)},
    {"da59yd19.aud", "", int32_t(0x9B8CCEF1), int32_t(0x00000000)},
    {"da59yd20.aud", "", int32_t(0x898ECEF1), int32_t(0x00000000)},
    {"da59yd21.aud", "", int32_t(0x8B8ECEF1), int32_t(0x00000000)},
    {"da59yd30.aud", "", int32_t(0x8990CEF1), int32_t(0x00000000)},
    {"da59yd31.aud", "", int32_t(0x8B90CEF1), int32_t(0x00000000)},
    {"da59yd32.aud", "", int32_t(0x8D90CEF1), int32_t(0x00000000)},
    {"da59yd33.aud", "", int32_t(0x8F90CEF1), int32_t(0x00000000)},
    {"da59yd34.aud", "", int32_t(0x9190CEF1), int32_t(0x00000000)},
    {"da60a321.aud", "", int32_t(0x6792ACC1), int32_t(0x00000000)},
    {"da60a323.aud", "", int32_t(0x6B92ACC1), int32_t(0x00000000)},
    {"da65vh28.aud", "", int32_t(0x8992D6EB), int32_t(0x00000000)},
    {"da65vh29.aud", "", int32_t(0x8B92D6EB), int32_t(0x00000000)},
    {"da71a002.aud", "", int32_t(0x6D92A6C1), int32_t(0x00000000)},
    {"da73u900.aud", "", int32_t(0x7192B8E9), int32_t(0x00000000)},
    {"da73ua00.aud", "", int32_t(0x7192C8E9), int32_t(0x00000000)},
    {"da73ua01.aud", "", int32_t(0x7392C8E9), int32_t(0x00000000)},
    {"da73ua02.aud", "", int32_t(0x7592C8E9), int32_t(0x00000000)},
    {"da73yb00.aud", "", int32_t(0x7192CAF1), int32_t(0x00000000)},
    {"da73yb01.aud", "", int32_t(0x7392CAF1), int32_t(0x00000000)},
    {"da73yb02.aud", "", int32_t(0x7592CAF1), int32_t(0x00000000)},
    {"da73yb03.aud", "", int32_t(0x7792CAF1), int32_t(0x00000000)},
    {"da73yb04.aud", "", int32_t(0x7992CAF1), int32_t(0x00000000)},
    {"da73yb05.aud", "", int32_t(0x7B92CAF1), int32_t(0x00000000)},
    {"da73yb06.aud", "", int32_t(0x7D92CAF1), int32_t(0x00000000)},
    {"da82a103.aud", "", int32_t(0x7396A8C1), int32_t(0x00000000)},
    {"da82a105.aud", "", int32_t(0x7796A8C1), int32_t(0x00000000)},
    {"da82a115.aud", "", int32_t(0x7798A8C1), int32_t(0x00000000)},
    {"da84vh14.aud", "", int32_t(0x7D98D6EB), int32_t(0x00000000)},
    {"da84vh15.aud", "", int32_t(0x7F98D6EB), int32_t(0x00000000)},
    {"daa6vh00.aud", "", int32_t(0x7DBAD6EB), int32_t(0x00000000)},
    {"daa6vh01.aud", "", int32_t(0x7FBAD6EB), int32_t(0x00000000)},
    {"dac4yj00.aud", "", int32_t(0x75C2DAF1), int32_t(0x00000000)},
    {"dac4yj01.aud", "", int32_t(0x77C2DAF1), int32_t(0x00000000)},
    {"dac4yj02.aud", "", int32_t(0x79C2DAF1), int32_t(0x00000000)},
    {"dac4yj03.aud", "", int32_t(0x7BC2DAF1), int32_t(0x00000000)},
    {"dac4yj04.aud", "", int32_t(0x7DC2DAF1), int32_t(0x00000000)},
    {"dac4yj05.aud", "", int32_t(0x7FC2DAF1), int32_t(0x00000000)},
    {"dac4yj06.aud", "", int32_t(0x81C2DAF1), int32_t(0x00000000)},
    {"dac4yj07.aud", "", int32_t(0x83C2DAF1), int32_t(0x00000000)},
    {"dac4yj08.aud", "", int32_t(0x85C2DAF1), int32_t(0x00000000)},
    {"dac4yj09.aud", "", int32_t(0x87C2DAF1), int32_t(0x00000000)},
    {"dac4yj10.aud", "", int32_t(0x75C4DAF1), int32_t(0x00000000)},
    {"dac4yj11.aud", "", int32_t(0x77C4DAF1), int32_t(0x00000000)},
    {"dac4yj12.aud", "", int32_t(0x79C4DAF1), int32_t(0x00000000)},
    {"dac4yj13.aud", "", int32_t(0x7BC4DAF1), int32_t(0x00000000)},
    {"daglite1.aud", "", int32_t(0xD7FCEED1), int32_t(0x00000000)},
    {"dam_sh.flc", "", int32_t(0x0991D902), int32_t(0x00000000)},
    {"dambreak.vqa", "-", int32_t(0x00000000), int32_t(0xA4E6A2B6)},
    {"dark_a.pal", "pal: ???", int32_t(0xCDA5D410), int32_t(0x00000000)},
    {"dark_b.pal", "pal: ???", int32_t(0xCDA5D610), int32_t(0x00000000)},
    {"dark_e.pal", "pal: ???", int32_t(0xCDA5DC10), int32_t(0x00000000)},
    {"dark_sa.pal", "pal: ???", int32_t(0x8A17ED1F), int32_t(0x00000000)},
    {"darken.shp", "-", int32_t(0x00000000), int32_t(0xF121A1D2)},
    {"dashatk1.aud", "", int32_t(0xC838EEC1), int32_t(0x00000000)},
    {"dashatk2.aud", "", int32_t(0xCA38EEC1), int32_t(0x00000000)},
    {"dashdeth.aud", "", int32_t(0xF64AD0C7), int32_t(0x00000000)},
    {"dashhit1.aud", "", int32_t(0xC84AD8CF), int32_t(0x00000000)},
    {"dashhit2.aud", "", int32_t(0xCA4AD8CF), int32_t(0x00000000)},
    {"dashhtsh.aud", "", int32_t(0xF648EECF), int32_t(0x00000000)},
    {"dashkilb.aud", "", int32_t(0xEA3AD8D5), int32_t(0x00000000)},
    {"dataload.aud", "", int32_t(0xD228E4D7), int32_t(0x00000000)},
    {"day.ini", "-", int32_t(0x00000000), int32_t(0x5B53B762)},
    {"dbak6440.pcx", "-", int32_t(0x00000000), int32_t(0x58DA0EB1)},
    {"dbltrbl.map", "", int32_t(0x00000000), int32_t(0x94C4BDFA)},
    {"dbri-wm1.shp", "", int32_t(0x00000000), int32_t(0xDF1EFDC0)},
    {"dbri-wm2.shp", "", int32_t(0x00000000), int32_t(0x98BE8710)},
    {"dbri-wm3.shp", "", int32_t(0x00000000), int32_t(0xA5DEAEA0)},
    {"dbris10lg.shp", "-", int32_t(0x00000000), int32_t(0x3FFC486D)},
    {"dbris10sm.shp", "-", int32_t(0x00000000), int32_t(0xDD45D905)},
    {"dbris1lg.shp", "-", int32_t(0x00000000), int32_t(0x336CC177)},
    {"dbris1sm.shp", "-", int32_t(0x00000000), int32_t(0x8B5C6998)},
    {"dbris2lg.shp", "-", int32_t(0x00000000), int32_t(0x0284DBEA)},
    {"dbris2sm.shp", "-", int32_t(0x00000000), int32_t(0xBAB47305)},
    {"dbris3lg.shp", "-", int32_t(0x00000000), int32_t(0xA4F3D05E)},
    {"dbris3sm.shp", "-", int32_t(0x00000000), int32_t(0x1CC378B1)},
    {"dbris4lg.shp", "-", int32_t(0x00000000), int32_t(0x6154EED0)},
    {"dbris4sm.shp", "-", int32_t(0x00000000), int32_t(0xD964463F)},
    {"dbris5lg.shp", "-", int32_t(0x00000000), int32_t(0xC723E564)},
    {"dbris5sm.shp", "-", int32_t(0x00000000), int32_t(0x7F134D8B)},
    {"dbris6lg.shp", "-", int32_t(0x00000000), int32_t(0xF6CBFFF9)},
    {"dbris6sm.shp", "-", int32_t(0x00000000), int32_t(0x4EFB5716)},
    {"dbris7lg.shp", "-", int32_t(0x00000000), int32_t(0x50BCF44D)},
    {"dbris7sm.shp", "-", int32_t(0x00000000), int32_t(0xE88C5CA2)},
    {"dbris8lg.shp", "-", int32_t(0x00000000), int32_t(0xA6F484A4)},
    {"dbris8sm.shp", "-", int32_t(0x00000000), int32_t(0x1EC42C4B)},
    {"dbris9lg.shp", "-", int32_t(0x00000000), int32_t(0x00838F10)},
    {"dbris9sm.shp", "-", int32_t(0x00000000), int32_t(0xB8B327FF)},
    {"dbrs10lg.shp", "", int32_t(0x00000000), int32_t(0x3E3BA5EA)},
    {"dbrs10sm.shp", "", int32_t(0x00000000), int32_t(0x860B0D05)},
    {"dchi0040.pcx", "pict: allied destroyers", int32_t(0xDDCCBD9F), int32_t(0x00000000)},
    {"dcliff01.des", "", int32_t(0x00000000), int32_t(0xE9AD3CD1)},
    {"dcliff01.sno", "-", int32_t(0x00000000), int32_t(0x07310CA0)},
    {"dcliff01.tem", "-", int32_t(0x00000000), int32_t(0x0F84A2C2)},
    {"dcliff01.ubn", "", int32_t(0x00000000), int32_t(0xD80E0F88)},
    {"dcliff01.urb", "", int32_t(0x00000000), int32_t(0x9B7A51F2)},
    {"dcliff02.des", "", int32_t(0x00000000), int32_t(0xAE0D4601)},
    {"dcliff02.sno", "-", int32_t(0x00000000), int32_t(0x40917670)},
    {"dcliff02.tem", "-", int32_t(0x00000000), int32_t(0x4824D812)},
    {"dcliff02.ubn", "", int32_t(0x00000000), int32_t(0x9FAE7558)},
    {"dcliff02.urb", "", int32_t(0x00000000), int32_t(0xDCDA2B22)},
    {"dclo0040.cps", "pict: allied destroyers", int32_t(0xF0E9B09F), int32_t(0x00000000)},
    {"dclock.mrf", "???", int32_t(0xD78DE9E9), int32_t(0x00000000)},
    {"dd-bkgnd.shp", "misc: backgrounds", int32_t(0xE199F2D5), int32_t(0x00000000)},
    {"dd-botm.shp", "misc: bottom edge", int32_t(0x65A00202), int32_t(0x00000000)},
    {"dd-crnr.shp", "misc: corners", int32_t(0x69A9F608), int32_t(0x00000000)},
    {"dd-edge.shp", "misc: left/right edges", int32_t(0x718FE7EC), int32_t(0x00000000)},
    {"dd-left.shp", "misc: left edge", int32_t(0x8DADE5EE), int32_t(0x00000000)},
    {"dd-right.shp", "misc: right edge", int32_t(0x418DF2D1), int32_t(0x00000000)},
    {"dd-top.shp", "misc: top edge", int32_t(0xF71201F7), int32_t(0x00000000)},
    {"dd.shp", "unit: destroyer", int32_t(0xA65CD8D0), int32_t(0x00000000)},
    {"dd15cr00.aud", "", int32_t(0x797AF6C5), int32_t(0x00000000)},
    {"dd15cr10.aud", "", int32_t(0x797CF6C5), int32_t(0x00000000)},
    {"dd15cr20.aud", "", int32_t(0x797EF6C5), int32_t(0x00000000)},
    {"dd15cr30.aud", "", int32_t(0x7980F6C5), int32_t(0x00000000)},
    {"dd15cr40.aud", "", int32_t(0x7982F6C5), int32_t(0x00000000)},
    {"dd15d200.aud", "", int32_t(0x797AB6C7), int32_t(0x00000000)},
    {"dd15d210.aud", "", int32_t(0x797CB6C7), int32_t(0x00000000)},
    {"dd15d220.aud", "", int32_t(0x797EB6C7), int32_t(0x00000000)},
    {"dd15d222.aud", "", int32_t(0x7D7EB6C7), int32_t(0x00000000)},
    {"dd15d230.aud", "", int32_t(0x7980B6C7), int32_t(0x00000000)},
    {"dd15d240.aud", "", int32_t(0x7982B6C7), int32_t(0x00000000)},
    {"dd26cr11.aud", "", int32_t(0x7F80F6C5), int32_t(0x00000000)},
    {"dd26d211.aud", "", int32_t(0x7F80B6C7), int32_t(0x00000000)},
    {"dd27cr21.aud", "", int32_t(0x8382F6C5), int32_t(0x00000000)},
    {"dd27d221.aud", "", int32_t(0x8382B6C7), int32_t(0x00000000)},
    {"dd28cr31.aud", "", int32_t(0x8784F6C5), int32_t(0x00000000)},
    {"dd28d231.aud", "", int32_t(0x8784B6C7), int32_t(0x00000000)},
    {"dd29cr41.aud", "", int32_t(0x8B86F6C5), int32_t(0x00000000)},
    {"dd29d241.aud", "", int32_t(0x8B86B6C7), int32_t(0x00000000)},
    {"ddb1ca47.aud", "", int32_t(0x77C6D4C5), int32_t(0x00000000)},
    {"ddb1ca48.aud", "", int32_t(0x79C6D4C5), int32_t(0x00000000)},
    {"ddb1ca49.aud", "", int32_t(0x7BC6D4C5), int32_t(0x00000000)},
    {"ddb1ca50.aud", "", int32_t(0x69C8D4C5), int32_t(0x00000000)},
    {"ddb1ca51.aud", "", int32_t(0x6BC8D4C5), int32_t(0x00000000)},
    {"ddb1ca52.aud", "", int32_t(0x6DC8D4C5), int32_t(0x00000000)},
    {"ddb1ca53.aud", "", int32_t(0x6FC8D4C5), int32_t(0x00000000)},
    {"ddbx.hva", "", int32_t(0x00000000), int32_t(0xE11CE2D8)},
    {"ddbx.vxl", "", int32_t(0x00000000), int32_t(0x17963D91)},
    {"ddicon.shp", "icon: destroyer", int32_t(0xB381FDF7), int32_t(0x00000000)},
    {"death_a.shp", "-", int32_t(0x00000000), int32_t(0xA0FAFBD9)},
    {"death_b.shp", "-", int32_t(0x00000000), int32_t(0x266E8977)},
    {"death_c.shp", "-", int32_t(0x00000000), int32_t(0xED325AD2)},
    {"death_d.shp", "-", int32_t(0x00000000), int32_t(0xF0376A6A)},
    {"death_e.shp", "-", int32_t(0x00000000), int32_t(0x3B6BB9CF)},
    {"death_f.shp", "-", int32_t(0x00000000), int32_t(0xBDFFCB61)},
    {"deathvalleygirl.map", "", int32_t(0x00000000), int32_t(0xB3EE5676)},
    {"deathvalleygirlmw.map", "", int32_t(0x00000000), int32_t(0xE6BB91DD)},
    {"debris1.aud", "", int32_t(0xA5B010E4), int32_t(0x00000000)},
    {"debris2.aud", "", int32_t(0xA5B210E4), int32_t(0x00000000)},
    {"debris3.aud", "", int32_t(0xA5B410E4), int32_t(0x00000000)},
    {"debris4.aud", "", int32_t(0xA5B610E4), int32_t(0x00000000)},
    {"debris5.aud", "", int32_t(0xA5B810E4), int32_t(0x00000000)},
    {"debris6.aud", "", int32_t(0xA5BA10E4), int32_t(0x00000000)},
    {"debug.eng", "misc: debugging strings", int32_t(0xF19371E6), int32_t(0x00000000)},
    {"deceiver.wav", "", int32_t(0x00000000), int32_t(0x27C26D24)},
    {"decomp2.aud", "", int32_t(0x99B60AEC), int32_t(0x00000000)},
    {"decurse.flc", "", int32_t(0xB1DB07FB), int32_t(0x00000000)},
    {"dedgirl1.aud", "dead girl 1", int32_t(0x00000000), int32_t(0x23865F42)},
    {"dedgirl2.aud", "dead girl 2", int32_t(0x00000000), int32_t(0x64262592)},
    {"dedgirl3.aud", "dead girl 3", int32_t(0x00000000), int32_t(0x59460C22)},
    {"dedgirl4.aud", "dead girl 4", int32_t(0x00000000), int32_t(0xEB66D032)},
    {"dedman1.aud", "man die #1", int32_t(0x91B806D4), int32_t(0x53343D45)},
    {"dedman10.aud", "man die #9", int32_t(0xD9C8F2C1), int32_t(0x00000000)},
    {"dedman2.aud", "man die #2", int32_t(0x91BA06D4), int32_t(0xD5A04FEB)},
    {"dedman3.aud", "man die #3", int32_t(0x91BC06D4), int32_t(0x1EFC9C4E)},
    {"dedman4.aud", "man die #4", int32_t(0x91BE06D4), int32_t(0x03F9ACF6)},
    {"dedman5.aud", "man die #5", int32_t(0x91C006D4), int32_t(0xC8A57F53)},
    {"dedman6.aud", "man die #6", int32_t(0x91C206D4), int32_t(0x4E310DFD)},
    {"dedman7.aud", "man die #7", int32_t(0x91C406D4), int32_t(0x00000000)},
    {"dedman8.aud", "man die #8", int32_t(0x91C606D4), int32_t(0x00000000)},
    {"defd.shp", "-", int32_t(0x00000000), int32_t(0xD7688245)},
    {"defd_exp.shp", "-", int32_t(0x00000000), int32_t(0xC052F859)},
    {"defdmk.shp", "-", int32_t(0x00000000), int32_t(0x31D90801)},
    {"defend.wav", "", int32_t(0x00000000), int32_t(0xABBC4614)},
    {"defender.shp", "-", int32_t(0x00000000), int32_t(0x04C7943E)},
    {"defense.aud", "defense", int32_t(0x00000000), int32_t(0xA383EF15)},
    {"dekclap1.aud", "", int32_t(0xB422D8D7), int32_t(0x00000000)},
    {"dekglas1.aud", "", int32_t(0xC428D8D7), int32_t(0x00000000)},
    {"dektra_e.vqa", "", int32_t(0x1D3CEDE3), int32_t(0x00000000)},
    {"delphi.shp", "delphi", int32_t(0xE78DF7E9), int32_t(0x00000000)},
    {"demopic.cps", "pict: buy c&c now", int32_t(0x9A0EF7F4), int32_t(0x00000000)},
    {"demopic.pcx", "pict: buy red alert now", int32_t(0x9A13EB01), int32_t(0x00000000)},
    {"demtexp.shp", "", int32_t(0x00000000), int32_t(0x2CEEE136)},
    {"dense_r.aud", "dense", int32_t(0xAA2228DC), int32_t(0x00000000)},
    {"deploy1.aud", "cannot deploy here", int32_t(0x8DE81CF0), int32_t(0x00000000)},
    {"depthchg.aud", "", int32_t(0x2426DCCF), int32_t(0x00000000)},
    {"des.mix", "", int32_t(0x00000000), int32_t(0xD77312D5)},
    {"des0101.des", "", int32_t(0x00000000), int32_t(0xA9D66E64)},
    {"des0101.tem", "-", int32_t(0x00000000), int32_t(0x2D8E0624)},
    {"des0102.des", "", int32_t(0x00000000), int32_t(0x2F421CCA)},
    {"des0102.tem", "-", int32_t(0x00000000), int32_t(0xAB1A748A)},
    {"des0103.des", "", int32_t(0x00000000), int32_t(0xE41ECF6F)},
    {"des0103.tem", "-", int32_t(0x00000000), int32_t(0x6046A72F)},
    {"des0104.des", "", int32_t(0x00000000), int32_t(0xF91BFFD7)},
    {"des0104.tem", "-", int32_t(0x00000000), int32_t(0x7D439797)},
    {"des0105.des", "", int32_t(0x00000000), int32_t(0x32472C72)},
    {"des0105.tem", "-", int32_t(0x00000000), int32_t(0xB61F4432)},
    {"des0106.des", "", int32_t(0x00000000), int32_t(0xB4D35EDC)},
    {"des0106.tem", "-", int32_t(0x00000000), int32_t(0x308B369C)},
    {"des0107.des", "", int32_t(0x00000000), int32_t(0x7F8F8D79)},
    {"des0107.tem", "-", int32_t(0x00000000), int32_t(0xFBD7E539)},
    {"des0108.des", "", int32_t(0x00000000), int32_t(0x8ED93FAC)},
    {"des0108.tem", "-", int32_t(0x00000000), int32_t(0x0A8157EC)},
    {"des0109.des", "", int32_t(0x00000000), int32_t(0x4585EC09)},
    {"des0109.tem", "-", int32_t(0x00000000), int32_t(0xC1DD8449)},
    {"des0110.des", "", int32_t(0x00000000), int32_t(0xC4FDB675)},
    {"des0110.tem", "-", int32_t(0x00000000), int32_t(0x40A5DE35)},
    {"des0111.des", "", int32_t(0x00000000), int32_t(0x0FA165D0)},
    {"des0111.tem", "-", int32_t(0x00000000), int32_t(0x8BF90D90)},
    {"des0112.des", "", int32_t(0x00000000), int32_t(0x8935177E)},
    {"des0112.tem", "-", int32_t(0x00000000), int32_t(0x0D6D7F3E)},
    {"des0113.des", "", int32_t(0x00000000), int32_t(0x4269C4DB)},
    {"des0113.tem", "-", int32_t(0x00000000), int32_t(0xC631AC9B)},
    {"des0114.des", "", int32_t(0x00000000), int32_t(0x5F6CF463)},
    {"des0114.tem", "-", int32_t(0x00000000), int32_t(0xDB349C23)},
    {"des0115.des", "", int32_t(0x00000000), int32_t(0x943027C6)},
    {"des0115.tem", "-", int32_t(0x00000000), int32_t(0x10684F86)},
    {"des0116.des", "", int32_t(0x00000000), int32_t(0x12A45568)},
    {"des0116.tem", "-", int32_t(0x00000000), int32_t(0x96FC3D28)},
    {"des0117.des", "", int32_t(0x00000000), int32_t(0xD9F886CD)},
    {"des0117.tem", "-", int32_t(0x00000000), int32_t(0x5DA0EE8D)},
    {"des0118.des", "", int32_t(0x00000000), int32_t(0x28AE3418)},
    {"des0118.tem", "-", int32_t(0x00000000), int32_t(0xACF65C58)},
    {"des0119.des", "", int32_t(0x00000000), int32_t(0xE3F2E7BD)},
    {"des0119.tem", "-", int32_t(0x00000000), int32_t(0x67AA8FFD)},
    {"des0120.des", "", int32_t(0x00000000), int32_t(0xF515ACE8)},
    {"des0120.tem", "-", int32_t(0x00000000), int32_t(0x714DC4A8)},
    {"des0121.des", "", int32_t(0x00000000), int32_t(0x3E497F4D)},
    {"des0121.tem", "-", int32_t(0x00000000), int32_t(0xBA11170D)},
    {"des0122.des", "", int32_t(0x00000000), int32_t(0xB8DD0DE3)},
    {"des0122.tem", "-", int32_t(0x00000000), int32_t(0x3C8565A3)},
    {"des0123.des", "", int32_t(0x00000000), int32_t(0x7381DE46)},
    {"des0123.tem", "-", int32_t(0x00000000), int32_t(0xF7D9B606)},
    {"des0124.des", "", int32_t(0x00000000), int32_t(0x6E84EEFE)},
    {"des0124.tem", "-", int32_t(0x00000000), int32_t(0xEADC86BE)},
    {"des0125.des", "", int32_t(0x00000000), int32_t(0xA5D83D5B)},
    {"des0125.tem", "-", int32_t(0x00000000), int32_t(0x2180551B)},
    {"des0126.des", "", int32_t(0x00000000), int32_t(0x234C4FF5)},
    {"des0126.tem", "-", int32_t(0x00000000), int32_t(0xA71427B5)},
    {"des0127.des", "", int32_t(0x00000000), int32_t(0xE8109C50)},
    {"des0127.tem", "-", int32_t(0x00000000), int32_t(0x6C48F410)},
    {"des0128.des", "", int32_t(0x00000000), int32_t(0x19462E85)},
    {"des0128.tem", "-", int32_t(0x00000000), int32_t(0x9D1E46C5)},
    {"des0129.des", "", int32_t(0x00000000), int32_t(0xD21AFD20)},
    {"des0129.tem", "-", int32_t(0x00000000), int32_t(0x56429560)},
    {"des0130.des", "", int32_t(0x00000000), int32_t(0x5362A75C)},
    {"des0130.tem", "-", int32_t(0x00000000), int32_t(0xD73ACF1C)},
    {"des0131.des", "", int32_t(0x00000000), int32_t(0x983E74F9)},
    {"des0131.tem", "-", int32_t(0x00000000), int32_t(0x1C661CB9)},
    {"des0132.des", "", int32_t(0x00000000), int32_t(0x1EAA0657)},
    {"des0132.tem", "-", int32_t(0x00000000), int32_t(0x9AF26E17)},
    {"des0133.des", "", int32_t(0x00000000), int32_t(0xD5F6D5F2)},
    {"des0133.tem", "-", int32_t(0x00000000), int32_t(0x51AEBDB2)},
    {"des0134.des", "", int32_t(0x00000000), int32_t(0xC8F3E54A)},
    {"des0134.tem", "-", int32_t(0x00000000), int32_t(0x4CAB8D0A)},
    {"des0135.des", "", int32_t(0x00000000), int32_t(0x03AF36EF)},
    {"des0135.tem", "-", int32_t(0x00000000), int32_t(0x87F75EAF)},
    {"des0136.des", "", int32_t(0x00000000), int32_t(0x853B4441)},
    {"des0136.tem", "-", int32_t(0x00000000), int32_t(0x01632C01)},
    {"des0137.des", "", int32_t(0x00000000), int32_t(0x4E6797E4)},
    {"des0137.tem", "-", int32_t(0x00000000), int32_t(0xCA3FFFA4)},
    {"des0138.des", "", int32_t(0x00000000), int32_t(0xBF312531)},
    {"des0138.tem", "-", int32_t(0x00000000), int32_t(0x3B694D71)},
    {"des0139.des", "", int32_t(0x00000000), int32_t(0x746DF694)},
    {"des0139.tem", "-", int32_t(0x00000000), int32_t(0xF0359ED4)},
    {"des0140.des", "", int32_t(0x00000000), int32_t(0x96C599D2)},
    {"des0140.tem", "-", int32_t(0x00000000), int32_t(0x129DF192)},
    {"des0141.des", "", int32_t(0x00000000), int32_t(0x5D994A77)},
    {"des0141.tem", "-", int32_t(0x00000000), int32_t(0xD9C12237)},
    {"des0142.des", "", int32_t(0x00000000), int32_t(0xDB0D38D9)},
    {"des0142.tem", "-", int32_t(0x00000000), int32_t(0x5F555099)},
    {"des0143.des", "", int32_t(0x00000000), int32_t(0x1051EB7C)},
    {"des0143.tem", "-", int32_t(0x00000000), int32_t(0x9409833C)},
    {"des0144.des", "", int32_t(0x00000000), int32_t(0x0D54DBC4)},
    {"des0144.tem", "-", int32_t(0x00000000), int32_t(0x890CB384)},
    {"des0145.des", "", int32_t(0x00000000), int32_t(0xC6080861)},
    {"des0145.tem", "-", int32_t(0x00000000), int32_t(0x42506021)},
    {"des0146.des", "", int32_t(0x00000000), int32_t(0x409C7ACF)},
    {"des0146.tem", "-", int32_t(0x00000000), int32_t(0xC4C4128F)},
    {"des0147.des", "", int32_t(0x00000000), int32_t(0x8BC0A96A)},
    {"des0147.tem", "-", int32_t(0x00000000), int32_t(0x0F98C12A)},
    {"des0148.des", "", int32_t(0x00000000), int32_t(0x7A961BBF)},
    {"des0148.tem", "-", int32_t(0x00000000), int32_t(0xFECE73FF)},
    {"des0201.des", "", int32_t(0x00000000), int32_t(0x27596987)},
    {"des0201.tem", "-", int32_t(0x00000000), int32_t(0xA30101C7)},
    {"des0202.des", "", int32_t(0x00000000), int32_t(0xA1CD1B29)},
    {"des0202.tem", "-", int32_t(0x00000000), int32_t(0x25957369)},
    {"des0203.des", "", int32_t(0x00000000), int32_t(0x6A91C88C)},
    {"des0203.tem", "-", int32_t(0x00000000), int32_t(0xEEC9A0CC)},
    {"des0204.des", "", int32_t(0x00000000), int32_t(0x7794F834)},
    {"des0204.tem", "-", int32_t(0x00000000), int32_t(0xF3CC9074)},
    {"des0205.des", "", int32_t(0x00000000), int32_t(0xBCC82B91)},
    {"des0205.tem", "-", int32_t(0x00000000), int32_t(0x389043D1)},
    {"des0206.des", "", int32_t(0x00000000), int32_t(0x3A5C593F)},
    {"des0206.tem", "-", int32_t(0x00000000), int32_t(0xBE04317F)},
    {"des0207.des", "", int32_t(0x00000000), int32_t(0xF1008A9A)},
    {"des0207.tem", "-", int32_t(0x00000000), int32_t(0x7558E2DA)},
    {"des0208.des", "", int32_t(0x00000000), int32_t(0x0056384F)},
    {"des0208.tem", "-", int32_t(0x00000000), int32_t(0x840E500F)},
    {"des0209.des", "", int32_t(0x00000000), int32_t(0xCB0AEBEA)},
    {"des0209.tem", "-", int32_t(0x00000000), int32_t(0x4F5283AA)},
    {"des0210.des", "", int32_t(0x00000000), int32_t(0x4A72B196)},
    {"des0210.tem", "-", int32_t(0x00000000), int32_t(0xCE2AD9D6)},
    {"des0211.des", "", int32_t(0x00000000), int32_t(0x812E6233)},
    {"des0211.tem", "-", int32_t(0x00000000), int32_t(0x05760A73)},
    {"des0212.des", "", int32_t(0x00000000), int32_t(0x07BA109D)},
    {"des0212.tem", "-", int32_t(0x00000000), int32_t(0x83E278DD)},
    {"des0213.des", "", int32_t(0x00000000), int32_t(0xCCE6C338)},
    {"des0213.tem", "-", int32_t(0x00000000), int32_t(0x48BEAB78)},
    {"des0214.des", "", int32_t(0x00000000), int32_t(0xD1E3F380)},
    {"des0214.tem", "-", int32_t(0x00000000), int32_t(0x55BB9BC0)},
    {"des0215.des", "", int32_t(0x00000000), int32_t(0x1ABF2025)},
    {"des0215.tem", "-", int32_t(0x00000000), int32_t(0x9EE74865)},
    {"des0216.des", "", int32_t(0x00000000), int32_t(0x9C2B528B)},
    {"des0216.tem", "-", int32_t(0x00000000), int32_t(0x18733ACB)},
    {"des0217.des", "", int32_t(0x00000000), int32_t(0x5777812E)},
    {"des0217.tem", "-", int32_t(0x00000000), int32_t(0xD32FE96E)},
    {"des0218.des", "", int32_t(0x00000000), int32_t(0xA62133FB)},
    {"des0218.tem", "-", int32_t(0x00000000), int32_t(0x22795BBB)},
    {"des0219.des", "", int32_t(0x00000000), int32_t(0x6D7DE05E)},
    {"des0219.tem", "-", int32_t(0x00000000), int32_t(0xE925881E)},
    {"des0220.des", "", int32_t(0x00000000), int32_t(0x7B9AAB0B)},
    {"des0220.tem", "-", int32_t(0x00000000), int32_t(0xFFC2C34B)},
    {"des0221.des", "", int32_t(0x00000000), int32_t(0xB0C678AE)},
    {"des0221.tem", "-", int32_t(0x00000000), int32_t(0x349E10EE)},
    {"des0222.des", "", int32_t(0x00000000), int32_t(0x36520A00)},
    {"des0222.tem", "-", int32_t(0x00000000), int32_t(0xB20A6240)},
    {"des0223.des", "", int32_t(0x00000000), int32_t(0xFD0ED9A5)},
    {"des0223.tem", "-", int32_t(0x00000000), int32_t(0x7956B1E5)},
    {"des0224.des", "", int32_t(0x00000000), int32_t(0xE00BE91D)},
    {"des0224.tem", "-", int32_t(0x00000000), int32_t(0x6453815D)},
    {"des0225.des", "", int32_t(0x00000000), int32_t(0x2B573AB8)},
    {"des0225.tem", "-", int32_t(0x00000000), int32_t(0xAF0F52F8)},
    {"des0226.des", "", int32_t(0x00000000), int32_t(0xADC34816)},
    {"des0226.tem", "-", int32_t(0x00000000), int32_t(0x299B2056)},
    {"des0227.des", "", int32_t(0x00000000), int32_t(0x669F9BB3)},
    {"des0227.tem", "-", int32_t(0x00000000), int32_t(0xE2C7F3F3)},
    {"des0228.des", "", int32_t(0x00000000), int32_t(0x97C92966)},
    {"des0228.tem", "-", int32_t(0x00000000), int32_t(0x13914126)},
    {"des0229.des", "", int32_t(0x00000000), int32_t(0x5C95FAC3)},
    {"des0229.tem", "-", int32_t(0x00000000), int32_t(0xD8CD9283)},
    {"des0230.des", "", int32_t(0x00000000), int32_t(0xDDEDA0BF)},
    {"des0230.tem", "-", int32_t(0x00000000), int32_t(0x59B5C8FF)},
    {"des0231.des", "", int32_t(0x00000000), int32_t(0x16B1731A)},
    {"des0231.tem", "-", int32_t(0x00000000), int32_t(0x92E91B5A)},
    {"des0232.des", "", int32_t(0x00000000), int32_t(0x902501B4)},
    {"des0232.tem", "-", int32_t(0x00000000), int32_t(0x147D69F4)},
    {"des0233.des", "", int32_t(0x00000000), int32_t(0x5B79D211)},
    {"des0233.tem", "-", int32_t(0x00000000), int32_t(0xDF21BA51)},
    {"des0234.des", "", int32_t(0x00000000), int32_t(0x467CE2A9)},
    {"des0234.tem", "-", int32_t(0x00000000), int32_t(0xC2248AE9)},
    {"des0235.des", "", int32_t(0x00000000), int32_t(0x8D20310C)},
    {"des0235.tem", "-", int32_t(0x00000000), int32_t(0x0978594C)},
    {"des0236.des", "", int32_t(0x00000000), int32_t(0x0BB443A2)},
    {"des0236.tem", "-", int32_t(0x00000000), int32_t(0x8FEC2BE2)},
    {"des0237.des", "", int32_t(0x00000000), int32_t(0xC0E89007)},
    {"des0237.tem", "-", int32_t(0x00000000), int32_t(0x44B0F847)},
    {"des0238.des", "", int32_t(0x00000000), int32_t(0x31BE22D2)},
    {"des0238.tem", "-", int32_t(0x00000000), int32_t(0xB5E64A92)},
    {"des0239.des", "", int32_t(0x00000000), int32_t(0xFAE2F177)},
    {"des0239.tem", "-", int32_t(0x00000000), int32_t(0x7EBA9937)},
    {"des0240.des", "", int32_t(0x00000000), int32_t(0x184A9E31)},
    {"des0240.tem", "-", int32_t(0x00000000), int32_t(0x9C12F671)},
    {"des0241.des", "", int32_t(0x00000000), int32_t(0xD3164D94)},
    {"des0241.tem", "-", int32_t(0x00000000), int32_t(0x574E25D4)},
    {"des0242.des", "", int32_t(0x00000000), int32_t(0x55823F3A)},
    {"des0242.tem", "-", int32_t(0x00000000), int32_t(0xD1DA577A)},
    {"des0243.des", "", int32_t(0x00000000), int32_t(0x9EDEEC9F)},
    {"des0243.tem", "-", int32_t(0x00000000), int32_t(0x1A8684DF)},
    {"des0244.des", "", int32_t(0x00000000), int32_t(0x83DBDC27)},
    {"des0244.tem", "-", int32_t(0x00000000), int32_t(0x0783B467)},
    {"des0245.des", "", int32_t(0x00000000), int32_t(0x48870F82)},
    {"des0245.tem", "-", int32_t(0x00000000), int32_t(0xCCDF67C2)},
    {"des0246.des", "", int32_t(0x00000000), int32_t(0xCE137D2C)},
    {"des0246.tem", "-", int32_t(0x00000000), int32_t(0x4A4B156C)},
    {"des0247.des", "", int32_t(0x00000000), int32_t(0x054FAE89)},
    {"des0247.tem", "-", int32_t(0x00000000), int32_t(0x8117C6C9)},
    {"des0248.des", "", int32_t(0x00000000), int32_t(0xF4191C5C)},
    {"des0248.tem", "-", int32_t(0x00000000), int32_t(0x7041741C)},
    {"deseicnh.inf", "inf: list for deseicnh.mix", int32_t(0xEC37E4D1), int32_t(0x00000000)},
    {"desert.inf", "inf: list for desert.mix", int32_t(0xA7AA0403), int32_t(0x00000000)},
    {"desert.mix", "", int32_t(0x00000000), int32_t(0xCD50B6E6)},
    {"desert.pal", "pal: desert", int32_t(0xB5AA09F6), int32_t(0x85604EA4)},
    {"desertmd.ini", "", int32_t(0x00000000), int32_t(0xA9F9AF97)},
    {"desflees.vqa", "guys running away from tanks in the desert", int32_t(0x0128F5D7), int32_t(0x00000000)},
    {"desflees.vqp", "guys running away from tanks in the desert", int32_t(0x1028F5D7), int32_t(0x00000000)},
    {"deskbell.aud", "", int32_t(0x0A3AE0C3), int32_t(0x00000000)},
    {"deskill.vqa", "guy killing another guy in the desert", int32_t(0x8A26FEF9), int32_t(0x00000000)},
    {"deskill.vqp", "guy killing another guy in the desert", int32_t(0x8A35FEF9), int32_t(0x00000000)},
    {"deso.shp", "", int32_t(0x00000000), int32_t(0xF3A3207C)},
    {"desoicon.shp", "", int32_t(0x00000000), int32_t(0x9B873A7E)},
    {"desolar.ini", "", int32_t(0x00000000), int32_t(0x3BF48DAD)},
    {"desolar.map", "-", int32_t(0x00000000), int32_t(0x24CAF4DF)},
    {"desolat.vqa", "deserted village", int32_t(0x9A36E8FF), int32_t(0x00000000)},
    {"desolat.vqp", "deserted village", int32_t(0x9A45E8FF), int32_t(0x00000000)},
    {"desouico.shp", "", int32_t(0x00000000), int32_t(0x5E41A89F)},
    {"dessweep.vqa", "tanks moving into a desert town", int32_t(0x2F28F5ED), int32_t(0x00000000)},
    {"dessweep.vqp", "tanks moving into a desert town", int32_t(0x3E28F5ED), int32_t(0x00000000)},
    {"dest.hva", "", int32_t(0x00000000), int32_t(0x4A11D553)},
    {"dest.vxl", "", int32_t(0x00000000), int32_t(0xBC9B0A1A)},
    {"desticon.shp", "", int32_t(0x00000000), int32_t(0xB512E6D2)},
    {"destroy.wav", "", int32_t(0x00000000), int32_t(0x30689089)},
    {"destroyr.vqa", "allied destroyers", int32_t(0x375109E3), int32_t(0x00000000)},
    {"destroyr.vqp", "vqp: allied destroyers", int32_t(0x465109E3), int32_t(0x00000000)},
    {"destwo.hva", "", int32_t(0x00000000), int32_t(0x05B77B37)},
    {"destwo.vxl", "", int32_t(0x00000000), int32_t(0xD5D89BB3)},
    {"deswnd1.aud", "", int32_t(0xB9F3F2EE), int32_t(0x00000000)},
    {"detnicon.shp", "icon: hunter-seeker", int32_t(0x00000000), int32_t(0x6E203544)},
    {"devent.trr", "", int32_t(0xBDB60FFF), int32_t(0x00000000)},
    {"deviator.shp", "crat: air strike", int32_t(0x1A4010C1), int32_t(0x00000000)},
    {"device.bmp", "", int32_t(0x00000000), int32_t(0xB8B9BD5E)},
    {"dgreen.mrf", "???", int32_t(0xAFA5FFED), int32_t(0x00000000)},
    {"dgreen1.shp", "-", int32_t(0x00000000), int32_t(0xDE3AA1AB)},
    {"dgreen2.shp", "-", int32_t(0x00000000), int32_t(0x58AED305)},
    {"dgreen3.shp", "-", int32_t(0x00000000), int32_t(0x93F200A0)},
    {"dgreen4.shp", "-", int32_t(0x00000000), int32_t(0x8EF73018)},
    {"dhal226m.aud", "", int32_t(0x0FC6C6A3), int32_t(0x00000000)},
    {"dhallp1.aud", "", int32_t(0x8DAC16EA), int32_t(0x00000000)},
    {"dialog.pal", "", int32_t(0x00000000), int32_t(0xB10A9944)},
    {"dialog.shp", "", int32_t(0xD76203F7), int32_t(0x00000000)},
    {"dialogn.pal", "", int32_t(0x00000000), int32_t(0xE949292E)},
    {"dialogy.pal", "", int32_t(0x00000000), int32_t(0xF79A1B0D)},
    {"dialout3.aud", "", int32_t(0xDC0310DD), int32_t(0x00000000)},
    {"dib_acp2.bmp", "", int32_t(0x31F6EDC1), int32_t(0x00000000)},
    {"dib_acpt.bmp", "", int32_t(0x75F6EDC0), int32_t(0x00000000)},
    {"dib_own.bmp", "", int32_t(0xD9F620F1), int32_t(0x00000000)},
    {"dib_sqel.bmp", "", int32_t(0x65E109E4), int32_t(0x00000000)},
    {"dib_user.bmp", "", int32_t(0x71E10DE8), int32_t(0x00000000)},
    {"die.aud", "die", int32_t(0x5CCEE7C9), int32_t(0x00000000)},
    {"die1.aud", "", int32_t(0xA6DFD3B6), int32_t(0x00000000)},
    {"dieyell1.aud", "", int32_t(0x0C02FEC9), int32_t(0x00000000)},
    {"dieyell2.aud", "", int32_t(0x0E02FEC9), int32_t(0x00000000)},
    {"dieyel~1.aud", "", int32_t(0x0C66FEC9), int32_t(0x00000000)},
    {"dig.shp", "digging animation", int32_t(0x00000000), int32_t(0xF149F8BF)},
    {"dino.vqa", "dino movie", int32_t(0xDFEDE8B6), int32_t(0x00000000)},
    {"dino.vqp", "dino movie", int32_t(0xEEEDE8B6), int32_t(0x00000000)},
    {"dinoatk1.aud", "dino attack", int32_t(0xE4250EC1), int32_t(0x00000000)},
    {"dinodie1.aud", "dino die", int32_t(0xE418F8C7), int32_t(0x00000000)},
    {"dinohrt1.aud", "", int32_t(0xE4370ACF), int32_t(0x00000000)},
    {"dinomout.aud", "dino move out", int32_t(0x2A3904D9), int32_t(0x00000000)},
    {"dinoyes.aud", "dino yes", int32_t(0x9A240504), int32_t(0x00000000)},
    {"diplobtn.shp", "", int32_t(0x00000000), int32_t(0x4A2EDF14)},
    {"dirtexpl.shp", "dirt explosion", int32_t(0x00000000), int32_t(0xEAFC217E)},
    {"dirtwlk1.aud", "", int32_t(0xF834FEED), int32_t(0x00000000)},
    {"dirtwlk2.aud", "", int32_t(0xFA34FEED), int32_t(0x00000000)},
    {"dirtwlk3.aud", "", int32_t(0xFC34FEED), int32_t(0x00000000)},
    {"dirtwlk4.aud", "", int32_t(0xFE34FEED), int32_t(0x00000000)},
    {"dirtwlk5.aud", "", int32_t(0x0034FEED), int32_t(0x00000000)},
    {"dirtwlk6.aud", "", int32_t(0x0234FEED), int32_t(0x00000000)},
    {"dirtwlk7.aud", "", int32_t(0x0434FEED), int32_t(0x00000000)},
    {"disa.vqa", "", int32_t(0xC3F7E8B6), int32_t(0x00000000)},
    {"discon.shp", "", int32_t(0xB3AA11F7), int32_t(0x00000000)},
    {"discus.shp", "disk thrower's disk", int32_t(0x00000000), int32_t(0x654A4594)},
    {"dish1.aud", "", int32_t(0xCBCF81B7), int32_t(0x00000000)},
    {"dish2.aud", "", int32_t(0xCBCF81B9), int32_t(0x00000000)},
    {"dish3.aud", "", int32_t(0xCBCF81BB), int32_t(0x00000000)},
    {"dish4.aud", "", int32_t(0xCBCF81BD), int32_t(0x00000000)},
    {"dish5.aud", "", int32_t(0xCBCF81BF), int32_t(0x00000000)},
    {"disk.hva", "", int32_t(0x00000000), int32_t(0x6F01BF74)},
    {"disk.vxl", "", int32_t(0x00000000), int32_t(0x998B603D)},
    {"diskdest.vqa", "-", int32_t(0x00000000), int32_t(0x9D9BDF9C)},
    {"diskicon.shp", "", int32_t(0x00000000), int32_t(0xCC71F9B5)},
    {"diskray.shp", "", int32_t(0x00000000), int32_t(0xCFDDFFED)},
    {"disktur.hva", "", int32_t(0x00000000), int32_t(0x329DC380)},
    {"disktur.vxl", "", int32_t(0x00000000), int32_t(0x3D6BB06B)},
    {"diskuico.shp", "", int32_t(0x00000000), int32_t(0x09B76B54)},
    {"djbi.pcx", "", int32_t(0x00000000), int32_t(0xAD489BAB)},
    {"djbi.shp", "", int32_t(0x00000000), int32_t(0x4221740B)},
    {"djugg.shp", "-", int32_t(0x00000000), int32_t(0xDCC5A198)},
    {"djugg_a.shp", "-", int32_t(0x00000000), int32_t(0x512A4295)},
    {"djuggbar.hva", "-", int32_t(0x00000000), int32_t(0x3CDC4D2E)},
    {"djuggbar.vxl", "deployed juggernaut barrel", int32_t(0x00000000), int32_t(0xCA569267)},
    {"djuggmk.shp", "-", int32_t(0x00000000), int32_t(0x00F0EC14)},
    {"dkodnce1.aud", "", int32_t(0xB81CF4DB), int32_t(0x00000000)},
    {"dkstorm1.aud", "", int32_t(0xF83D12DD), int32_t(0x00000000)},
    {"dl15sr02.aud", "", int32_t(0x7D7B16E5), int32_t(0x00000000)},
    {"dl15sr04.aud", "", int32_t(0x817B16E5), int32_t(0x00000000)},
    {"dlat01.des", "", int32_t(0x00000000), int32_t(0x27983503)},
    {"dlat01.lun", "", int32_t(0x00000000), int32_t(0x4EB8091A)},
    {"dlat01.sno", "", int32_t(0x00000000), int32_t(0xA0B77A0C)},
    {"dlat01.tem", "-", int32_t(0x00000000), int32_t(0x51C02CFB)},
    {"dlat01.ubn", "", int32_t(0x00000000), int32_t(0x6D551608)},
    {"dlat01.urb", "", int32_t(0x00000000), int32_t(0x29E1A897)},
    {"dlat01a.des", "", int32_t(0x00000000), int32_t(0x91B0D777)},
    {"dlat01a.lun", "", int32_t(0x00000000), int32_t(0xB74E30F4)},
    {"dlat01a.sno", "", int32_t(0x00000000), int32_t(0xB65C0AED)},
    {"dlat01a.tem", "-", int32_t(0x00000000), int32_t(0x15E8BF37)},
    {"dlat01a.ubn", "", int32_t(0x00000000), int32_t(0x83369D14)},
    {"dlat01a.urb", "", int32_t(0x00000000), int32_t(0x33A57168)},
    {"dlat02.des", "", int32_t(0x00000000), int32_t(0x16702F9E)},
    {"dlat02.lun", "", int32_t(0x00000000), int32_t(0x7F501387)},
    {"dlat02.sno", "", int32_t(0x00000000), int32_t(0x915F6091)},
    {"dlat02.tem", "-", int32_t(0x00000000), int32_t(0x60283666)},
    {"dlat02.ubn", "", int32_t(0x00000000), int32_t(0x5CBD0C95)},
    {"dlat02.urb", "", int32_t(0x00000000), int32_t(0x1809B20A)},
    {"dlat02a.des", "", int32_t(0x00000000), int32_t(0xA058CDEA)},
    {"dlat02a.lun", "", int32_t(0x00000000), int32_t(0x86A62A69)},
    {"dlat02a.sno", "", int32_t(0x00000000), int32_t(0x87B41070)},
    {"dlat02a.tem", "-", int32_t(0x00000000), int32_t(0x2400A5AA)},
    {"dlat02a.ubn", "", int32_t(0x00000000), int32_t(0xB2DE8789)},
    {"dlat02a.urb", "", int32_t(0x00000000), int32_t(0x024D6BF5)},
    {"dlat03.des", "", int32_t(0x00000000), int32_t(0xB007242A)},
    {"dlat03.lun", "", int32_t(0x00000000), int32_t(0xD9271833)},
    {"dlat03.sno", "", int32_t(0x00000000), int32_t(0x37286B25)},
    {"dlat03.tem", "-", int32_t(0x00000000), int32_t(0xC65F3DD2)},
    {"dlat03.ubn", "", int32_t(0x00000000), int32_t(0xFACA0721)},
    {"dlat03.urb", "", int32_t(0x00000000), int32_t(0xBE7EB9BE)},
    {"dlat03a.des", "", int32_t(0x00000000), int32_t(0x062FC65E)},
    {"dlat03a.lun", "", int32_t(0x00000000), int32_t(0x20D121DD)},
    {"dlat03a.sno", "", int32_t(0x00000000), int32_t(0x21C31BC4)},
    {"dlat03a.tem", "-", int32_t(0x00000000), int32_t(0x8277AE1E)},
    {"dlat03a.ubn", "", int32_t(0x00000000), int32_t(0x14A98C3D)},
    {"dlat03a.urb", "", int32_t(0x00000000), int32_t(0xA43A6041)},
    {"dlat04.des", "", int32_t(0x00000000), int32_t(0x75A01AA4)},
    {"dlat04.lun", "", int32_t(0x00000000), int32_t(0x1C8026BD)},
    {"dlat04.sno", "", int32_t(0x00000000), int32_t(0xF28F55AB)},
    {"dlat04.tem", "-", int32_t(0x00000000), int32_t(0x03F8035C)},
    {"dlat04.ubn", "", int32_t(0x00000000), int32_t(0x3F6D39AF)},
    {"dlat04.urb", "", int32_t(0x00000000), int32_t(0x7BD98730)},
    {"dlat04a.des", "", int32_t(0x00000000), int32_t(0xC388F8D0)},
    {"dlat04a.lun", "", int32_t(0x00000000), int32_t(0xE5761F53)},
    {"dlat04a.sno", "", int32_t(0x00000000), int32_t(0xE464254A)},
    {"dlat04a.tem", "-", int32_t(0x00000000), int32_t(0x47D09090)},
    {"dlat04a.ubn", "", int32_t(0x00000000), int32_t(0xD10EB2B3)},
    {"dlat04a.urb", "", int32_t(0x00000000), int32_t(0x619D5ECF)},
    {"dlat05.des", "", int32_t(0x00000000), int32_t(0xD3D71110)},
    {"dlat05.lun", "", int32_t(0x00000000), int32_t(0xBAF72D09)},
    {"dlat05.sno", "", int32_t(0x00000000), int32_t(0x54F85E1F)},
    {"dlat05.tem", "-", int32_t(0x00000000), int32_t(0xA58F08E8)},
    {"dlat05.ubn", "", int32_t(0x00000000), int32_t(0x991A321B)},
    {"dlat05.urb", "", int32_t(0x00000000), int32_t(0xDDAE8C84)},
    {"dlat05a.des", "", int32_t(0x00000000), int32_t(0x65FFF364)},
    {"dlat05a.lun", "", int32_t(0x00000000), int32_t(0x430114E7)},
    {"dlat05a.sno", "", int32_t(0x00000000), int32_t(0x42132EFE)},
    {"dlat05a.tem", "-", int32_t(0x00000000), int32_t(0xE1A79B24)},
    {"dlat05a.ubn", "", int32_t(0x00000000), int32_t(0x7779B907)},
    {"dlat05a.urb", "", int32_t(0x00000000), int32_t(0xC7EA557B)},
    {"dlat06.des", "", int32_t(0x00000000), int32_t(0xE23F0B8D)},
    {"dlat06.lun", "", int32_t(0x00000000), int32_t(0x8B1F3794)},
    {"dlat06.sno", "", int32_t(0x00000000), int32_t(0x65104482)},
    {"dlat06.tem", "-", int32_t(0x00000000), int32_t(0x94671275)},
    {"dlat06.ubn", "", int32_t(0x00000000), int32_t(0xA8F22886)},
    {"dlat06.urb", "", int32_t(0x00000000), int32_t(0xEC469619)},
    {"dlat06a.des", "", int32_t(0x00000000), int32_t(0x5417E9F9)},
    {"dlat06a.lun", "", int32_t(0x00000000), int32_t(0x72E90E7A)},
    {"dlat06a.sno", "", int32_t(0x00000000), int32_t(0x73FB3463)},
    {"dlat06a.tem", "-", int32_t(0x00000000), int32_t(0xD04F81B9)},
    {"dlat06a.ubn", "", int32_t(0x00000000), int32_t(0x4691A39A)},
    {"dlat06a.urb", "", int32_t(0x00000000), int32_t(0xF6024FE6)},
    {"dlat07.des", "", int32_t(0x00000000), int32_t(0x44480039)},
    {"dlat07.lun", "", int32_t(0x00000000), int32_t(0x2D683C20)},
    {"dlat07.sno", "", int32_t(0x00000000), int32_t(0xC3674F36)},
    {"dlat07.tem", "-", int32_t(0x00000000), int32_t(0x321019C1)},
    {"dlat07.ubn", "", int32_t(0x00000000), int32_t(0x0E852332)},
    {"dlat07.urb", "", int32_t(0x00000000), int32_t(0x4A319DAD)},
    {"dlat07a.des", "", int32_t(0x00000000), int32_t(0xF260E24D)},
    {"dlat07a.lun", "", int32_t(0x00000000), int32_t(0xD49E05CE)},
    {"dlat07a.sno", "", int32_t(0x00000000), int32_t(0xD58C3FD7)},
    {"dlat07a.tem", "-", int32_t(0x00000000), int32_t(0x76388A0D)},
    {"dlat07a.ubn", "", int32_t(0x00000000), int32_t(0xE0E6A82E)},
    {"dlat07a.urb", "", int32_t(0x00000000), int32_t(0x50754452)},
    {"dlat08.des", "", int32_t(0x00000000), int32_t(0xB20070D0)},
    {"dlat08.lun", "", int32_t(0x00000000), int32_t(0xDB204CC9)},
    {"dlat08.sno", "", int32_t(0x00000000), int32_t(0x352F3FDF)},
    {"dlat08.tem", "-", int32_t(0x00000000), int32_t(0xC4586928)},
    {"dlat08.ubn", "", int32_t(0x00000000), int32_t(0xF8CD53DB)},
    {"dlat08.urb", "", int32_t(0x00000000), int32_t(0xBC79ED44)},
    {"dlat08a.des", "", int32_t(0x00000000), int32_t(0x042892A4)},
    {"dlat08a.lun", "", int32_t(0x00000000), int32_t(0x22D67527)},
    {"dlat08a.sno", "", int32_t(0x00000000), int32_t(0x23C44F3E)},
    {"dlat08a.tem", "-", int32_t(0x00000000), int32_t(0x8070FAE4)},
    {"dlat08a.ubn", "", int32_t(0x00000000), int32_t(0x16AED8C7)},
    {"dlat08a.urb", "", int32_t(0x00000000), int32_t(0xA63D34BB)},
    {"dlat09.des", "", int32_t(0x00000000), int32_t(0x14777B64)},
    {"dlat09.lun", "", int32_t(0x00000000), int32_t(0x7D57477D)},
    {"dlat09.sno", "", int32_t(0x00000000), int32_t(0x9358346B)},
    {"dlat09.tem", "-", int32_t(0x00000000), int32_t(0x622F629C)},
    {"dlat09.ubn", "", int32_t(0x00000000), int32_t(0x5EBA586F)},
    {"dlat09.urb", "", int32_t(0x00000000), int32_t(0x1A0EE6F0)},
    {"dlat09a.des", "", int32_t(0x00000000), int32_t(0xA25F9910)},
    {"dlat09a.lun", "", int32_t(0x00000000), int32_t(0x84A17E93)},
    {"dlat09a.sno", "", int32_t(0x00000000), int32_t(0x85B3448A)},
    {"dlat09a.tem", "-", int32_t(0x00000000), int32_t(0x2607F150)},
    {"dlat09a.ubn", "", int32_t(0x00000000), int32_t(0xB0D9D373)},
    {"dlat09a.urb", "", int32_t(0x00000000), int32_t(0x004A3F0F)},
    {"dlat10.des", "", int32_t(0x00000000), int32_t(0x4D453E29)},
    {"dlat10.lun", "", int32_t(0x00000000), int32_t(0x24650230)},
    {"dlat10.sno", "", int32_t(0x00000000), int32_t(0xCA6A7126)},
    {"dlat10.tem", "-", int32_t(0x00000000), int32_t(0x3B1D27D1)},
    {"dlat10.ubn", "", int32_t(0x00000000), int32_t(0x07881D22)},
    {"dlat10.urb", "", int32_t(0x00000000), int32_t(0x433CA3BD)},
    {"dlat10a.des", "", int32_t(0x00000000), int32_t(0xFB6DDC5D)},
    {"dlat10a.lun", "", int32_t(0x00000000), int32_t(0xDD933BDE)},
    {"dlat10a.sno", "", int32_t(0x00000000), int32_t(0xDC8101C7)},
    {"dlat10a.tem", "-", int32_t(0x00000000), int32_t(0x7F35B41D)},
    {"dlat10a.ubn", "", int32_t(0x00000000), int32_t(0xE9EB963E)},
    {"dlat10a.urb", "", int32_t(0x00000000), int32_t(0x59787A42)},
    {"dlat11.des", "", int32_t(0x00000000), int32_t(0xEB32359D)},
    {"dlat11.lun", "", int32_t(0x00000000), int32_t(0x82120984)},
    {"dlat11.sno", "", int32_t(0x00000000), int32_t(0x6C1D7A92)},
    {"dlat11.tem", "-", int32_t(0x00000000), int32_t(0x9D6A2C65)},
    {"dlat11.ubn", "", int32_t(0x00000000), int32_t(0xA1FF1696)},
    {"dlat11.urb", "", int32_t(0x00000000), int32_t(0xE54BA809)},
    {"dlat11a.des", "", int32_t(0x00000000), int32_t(0x5D1AD7E9)},
    {"dlat11a.lun", "", int32_t(0x00000000), int32_t(0x7BE4306A)},
    {"dlat11a.sno", "", int32_t(0x00000000), int32_t(0x7AF60A73)},
    {"dlat11a.tem", "-", int32_t(0x00000000), int32_t(0xD942BFA9)},
    {"dlat11a.ubn", "", int32_t(0x00000000), int32_t(0x4F9C9D8A)},
    {"dlat11a.urb", "", int32_t(0x00000000), int32_t(0xFF0F71F6)},
    {"dlat12.des", "", int32_t(0x00000000), int32_t(0xDADA2F00)},
    {"dlat12.lun", "", int32_t(0x00000000), int32_t(0xB3FA1319)},
    {"dlat12.sno", "", int32_t(0x00000000), int32_t(0x5DF5600F)},
    {"dlat12.tem", "-", int32_t(0x00000000), int32_t(0xAC8236F8)},
    {"dlat12.ubn", "", int32_t(0x00000000), int32_t(0x90170C0B)},
    {"dlat12.urb", "", int32_t(0x00000000), int32_t(0xD4A3B294)},
    {"dlat12a.des", "", int32_t(0x00000000), int32_t(0x6CF2CD74)},
    {"dlat12a.lun", "", int32_t(0x00000000), int32_t(0x4A0C2AF7)},
    {"dlat12a.sno", "", int32_t(0x00000000), int32_t(0x4B1E10EE)},
    {"dlat12a.tem", "-", int32_t(0x00000000), int32_t(0xE8AAA534)},
    {"dlat12a.ubn", "", int32_t(0x00000000), int32_t(0x7E748717)},
    {"dlat12a.urb", "", int32_t(0x00000000), int32_t(0xCEE76B6B)},
    {"dlat13.des", "", int32_t(0x00000000), int32_t(0x7CAD24B4)},
    {"dlat13.lun", "", int32_t(0x00000000), int32_t(0x158D18AD)},
    {"dlat13.sno", "", int32_t(0x00000000), int32_t(0xFB826BBB)},
    {"dlat13.tem", "-", int32_t(0x00000000), int32_t(0x0AF53D4C)},
    {"dlat13.ubn", "", int32_t(0x00000000), int32_t(0x366007BF)},
    {"dlat13.urb", "", int32_t(0x00000000), int32_t(0x72D4B920)},
    {"dlat13a.des", "", int32_t(0x00000000), int32_t(0xCA85C6C0)},
    {"dlat13a.lun", "", int32_t(0x00000000), int32_t(0xEC7B2143)},
    {"dlat13a.sno", "", int32_t(0x00000000), int32_t(0xED691B5A)},
    {"dlat13a.tem", "-", int32_t(0x00000000), int32_t(0x4EDDAE80)},
    {"dlat13a.ubn", "", int32_t(0x00000000), int32_t(0xD8038CA3)},
    {"dlat13a.urb", "", int32_t(0x00000000), int32_t(0x689060DF)},
    {"dlat14.des", "", int32_t(0x00000000), int32_t(0xB90A1A3A)},
    {"dlat14.lun", "", int32_t(0x00000000), int32_t(0xD02A2623)},
    {"dlat14.sno", "", int32_t(0x00000000), int32_t(0x3E255535)},
    {"dlat14.tem", "-", int32_t(0x00000000), int32_t(0xCF5203C2)},
    {"dlat14.ubn", "", int32_t(0x00000000), int32_t(0xF3C73931)},
    {"dlat14.urb", "", int32_t(0x00000000), int32_t(0xB77387AE)},
    {"dlat14a.des", "", int32_t(0x00000000), int32_t(0x0F22F84E)},
    {"dlat14a.lun", "", int32_t(0x00000000), int32_t(0x29DC1FCD)},
    {"dlat14a.sno", "", int32_t(0x00000000), int32_t(0x28CE25D4)},
    {"dlat14a.tem", "-", int32_t(0x00000000), int32_t(0x8B7A900E)},
    {"dlat14a.ubn", "", int32_t(0x00000000), int32_t(0x1DA4B22D)},
    {"dlat14a.urb", "", int32_t(0x00000000), int32_t(0xAD375E51)},
    {"dlat15.des", "", int32_t(0x00000000), int32_t(0x1F7D118E)},
    {"dlat15.lun", "", int32_t(0x00000000), int32_t(0x765D2D97)},
    {"dlat15.sno", "", int32_t(0x00000000), int32_t(0x98525E81)},
    {"dlat15.tem", "-", int32_t(0x00000000), int32_t(0x69250876)},
    {"dlat15.ubn", "", int32_t(0x00000000), int32_t(0x55B03285)},
    {"dlat15.urb", "", int32_t(0x00000000), int32_t(0x11048C1A)},
    {"dlat15a.des", "", int32_t(0x00000000), int32_t(0xA955F3FA)},
    {"dlat15a.lun", "", int32_t(0x00000000), int32_t(0x8FAB1479)},
    {"dlat15a.sno", "", int32_t(0x00000000), int32_t(0x8EB92E60)},
    {"dlat15a.tem", "-", int32_t(0x00000000), int32_t(0x2D0D9BBA)},
    {"dlat15a.ubn", "", int32_t(0x00000000), int32_t(0xBBD3B999)},
    {"dlat15a.urb", "", int32_t(0x00000000), int32_t(0x0B4055E5)},
    {"dlat16.des", "", int32_t(0x00000000), int32_t(0x2E950B13)},
    {"dlat16.lun", "", int32_t(0x00000000), int32_t(0x47B5370A)},
    {"dlat16.sno", "", int32_t(0x00000000), int32_t(0xA9BA441C)},
    {"dlat16.tem", "-", int32_t(0x00000000), int32_t(0x58CD12EB)},
    {"dlat16.ubn", "", int32_t(0x00000000), int32_t(0x64582818)},
    {"dlat16.urb", "", int32_t(0x00000000), int32_t(0x20EC9687)},
    {"dlat16a.des", "", int32_t(0x00000000), int32_t(0x98BDE967)},
    {"dlat16a.lun", "", int32_t(0x00000000), int32_t(0xBE430EE4)},
    {"dlat16a.sno", "", int32_t(0x00000000), int32_t(0xBF5134FD)},
    {"dlat16a.tem", "-", int32_t(0x00000000), int32_t(0x1CE58127)},
    {"dlat16a.ubn", "", int32_t(0x00000000), int32_t(0x8A3BA304)},
    {"dlat16a.urb", "", int32_t(0x00000000), int32_t(0x3AA84F78)},
    {"dlgmenu.tre", "", int32_t(0x920D1FEF), int32_t(0x00000000)},
    {"dlgmenu.trf", "", int32_t(0x920E1FEF), int32_t(0x00000000)},
    {"dlgmenu.trg", "", int32_t(0x920F1FEF), int32_t(0x00000000)},
    {"dlgmenu.tri", "", int32_t(0x92111FEF), int32_t(0x00000000)},
    {"dlgmenu.trs", "", int32_t(0x921B1FEF), int32_t(0x00000000)},
    {"dlgsysa.pcx", "-", int32_t(0x00000000), int32_t(0x13404914)},
    {"dlgsysi.pcx", "-", int32_t(0x00000000), int32_t(0xFF13CB79)},
    {"dlight.mrf", "???", int32_t(0xB7821FF3), int32_t(0x00000000)},
    {"dlimp_a.shp", "-", int32_t(0x00000000), int32_t(0x675D5B1C)},
    {"dlimpet.shp", "-", int32_t(0x00000000), int32_t(0xF7E80BB4)},
    {"dlimpmk.shp", "-", int32_t(0x00000000), int32_t(0x3687F59D)},
    {"dlow1.img", "", int32_t(0xF7CF8DBA), int32_t(0x00000000)},
    {"dlow1.lmf", "", int32_t(0xF7D58DB9), int32_t(0x00000000)},
    {"dlow1.lsv", "", int32_t(0x03D58DC8), int32_t(0x00000000)},
    {"dlow1.odf", "", int32_t(0xE5DB8DB9), int32_t(0x00000000)},
    {"dlow1.pcx", "", int32_t(0xE3DD8DCB), int32_t(0x00000000)},
    {"dlow1.ver", "", int32_t(0xE7E98DC5), int32_t(0x00000000)},
    {"dlph.shp", "", int32_t(0x00000000), int32_t(0x528FCB11)},
    {"dlphicon.shp", "", int32_t(0x00000000), int32_t(0x6F9CD231)},
    {"dlphuico.shp", "", int32_t(0x00000000), int32_t(0xAA5A40D0)},
    {"dmachine.aud", "-", int32_t(0x00000000), int32_t(0xCA690BE1)},
    {"dmisl.hva", "", int32_t(0x00000000), int32_t(0x032732F5)},
    {"dmisl.vxl", "", int32_t(0x00000000), int32_t(0xBCBE3552)},
    {"dmouse.mrf", "???", int32_t(0xEF9A0609), int32_t(0x00000000)},
    {"dmusic.mix", "", int32_t(0xE7B213EC), int32_t(0x00000000)},
    {"dnarrow.pcx", "-", int32_t(0x00000000), int32_t(0x79D29FBB)},
    {"dnarrowp.pcx", "-", int32_t(0x00000000), int32_t(0xFF3F4875)},
    {"dnarrowr.pcx", "-", int32_t(0x00000000), int32_t(0x85FF1B15)},
    {"dnoa.shp", "", int32_t(0x00000000), int32_t(0x3A800807)},
    {"dnob.shp", "", int32_t(0x00000000), int32_t(0x7D2072D7)},
    {"dog.shp", "unit: attack dog", int32_t(0x5CDEE6DB), int32_t(0x9299CD85)},
    {"dogbark1.aud", "", int32_t(0xB00922C1), int32_t(0x00000000)},
    {"dogbark3.aud", "", int32_t(0xB40922C1), int32_t(0x00000000)},
    {"dogbite1.aud", "", int32_t(0xAFFD26D1), int32_t(0x00000000)},
    {"dogbullt.shp", "unit: attack dog jumping", int32_t(0x01FE28E9), int32_t(0x00000000)},
    {"dogcry1.aud", "", int32_t(0x69C444F6), int32_t(0x00000000)},
    {"dogcry2.aud", "", int32_t(0x69C644F6), int32_t(0x00000000)},
    {"dogexpl1.aud", "", int32_t(0xBC0B1EEF), int32_t(0x00000000)},
    {"dogfar1.aud", "", int32_t(0x75C436D4), int32_t(0x00000000)},
    {"dogfar2.aud", "", int32_t(0x75C636D4), int32_t(0x00000000)},
    {"dogg5p.aud", "dog angry", int32_t(0x9F7A21D0), int32_t(0x00000000)},
    {"doggie.shp", "-", int32_t(0x00000000), int32_t(0xD14C72D9)},
    {"doggun1.aud", "", int32_t(0x79C42EFC), int32_t(0x00000000)},
    {"doggun2.aud", "", int32_t(0x79C62EFC), int32_t(0x00000000)},
    {"doggy1.aud", "", int32_t(0x9F79E418), int32_t(0x00000000)},
    {"doggy2.aud", "", int32_t(0x9F79E618), int32_t(0x00000000)},
    {"doggy3.aud", "", int32_t(0x9F79E818), int32_t(0x00000000)},
    {"doggy4.aud", "", int32_t(0x9F79EA18), int32_t(0x00000000)},
    {"doghurt1.aud", "", int32_t(0xC81B22E9), int32_t(0x00000000)},
    {"dogicon.shp", "icon: attack dog", int32_t(0x820A23EA), int32_t(0xD9264471)},
    {"dogmad1.aud", "", int32_t(0x91C41AD4), int32_t(0x00000000)},
    {"dogneed1.aud", "", int32_t(0xDFFB08C9), int32_t(0x00000000)},
    {"dogneed2.aud", "", int32_t(0xE1FB08C9), int32_t(0x00000000)},
    {"dogp.shp", "", int32_t(0x00000000), int32_t(0x2D243FEC)},
    {"dogtail1.aud", "", int32_t(0xF80B10C1), int32_t(0x00000000)},
    {"dogtail2.aud", "", int32_t(0xFA0B10C1), int32_t(0x00000000)},
    {"dogtoy1.aud", "", int32_t(0xADC444F0), int32_t(0x00000000)},
    {"dogtoy2.aud", "", int32_t(0xADC644F0), int32_t(0x00000000)},
    {"dogtoy3.aud", "", int32_t(0xADC844F0), int32_t(0x00000000)},
    {"doguico.shp", "", int32_t(0x00000000), int32_t(0x0EEE500D)},
    {"dogw3px.aud", "dog angry #2", int32_t(0xBA1232B8), int32_t(0x00000000)},
    {"dogw5.aud", "dog suffering", int32_t(0x079F99BE), int32_t(0x00000000)},
    {"dogw6.aud", "dog die", int32_t(0x079F99C0), int32_t(0x00000000)},
    {"dogw7.aud", "dog wouf #2", int32_t(0x079F99C2), int32_t(0x00000000)},
    {"dogy1.aud", "dog wouf", int32_t(0x0F9F99B6), int32_t(0x00000000)},
    {"dollar.shp", "crat: money", int32_t(0xD78E31DB), int32_t(0x00000000)},
    {"doly.hva", "", int32_t(0x00000000), int32_t(0xE471FEE2)},
    {"doly.vxl", "", int32_t(0x00000000), int32_t(0x12FB21AB)},
    {"dome.shp", "bldg: radar dome", int32_t(0xDAE2F1B6), int32_t(0x00000000)},
    {"domeicon.shp", "icon: radar dome", int32_t(0x021C16D1), int32_t(0x00000000)},
    {"domemake.shp", "make: radar dome", int32_t(0xF01412D9), int32_t(0x00000000)},
    {"domficon.shp", "icon: radar dome fake", int32_t(0x061C16D1), int32_t(0x00000000)},
    {"donkey1.aud", "", int32_t(0x89E044DC), int32_t(0x00000000)},
    {"door.csv", "", int32_t(0xFAF1E1B6), int32_t(0x00000000)},
    {"door.lsv", "", int32_t(0xFAF1EAB6), int32_t(0x00000000)},
    {"door.vqa", "", int32_t(0xE5EFF4B6), int32_t(0x00000000)},
    {"door1ac.aud", "", int32_t(0xA60814B4), int32_t(0x00000000)},
    {"door1ao.aud", "", int32_t(0xA62014B4), int32_t(0x00000000)},
    {"door1bc.aud", "", int32_t(0xA60816B4), int32_t(0x00000000)},
    {"door1bo.aud", "", int32_t(0xA62016B4), int32_t(0x00000000)},
    {"door1cc.aud", "", int32_t(0xA60818B4), int32_t(0x00000000)},
    {"door1co.aud", "", int32_t(0xA62018B4), int32_t(0x00000000)},
    {"door_e.vqa", "", int32_t(0xF59A0920), int32_t(0x00000000)},
    {"door_e.vqt", "", int32_t(0xF59A1C20), int32_t(0x00000000)},
    {"door_h.pcx", "", int32_t(0xE99A2612), int32_t(0x00000000)},
    {"door_h.vqa", "", int32_t(0xF59A0F20), int32_t(0x00000000)},
    {"door_l.pcx", "", int32_t(0xE99A2E12), int32_t(0x00000000)},
    {"door_l.vqa", "", int32_t(0xF59A1720), int32_t(0x00000000)},
    {"doorjam1.aud", "", int32_t(0xF02D00D3), int32_t(0x00000000)},
    {"doorlock.aud", "", int32_t(0x24191CD7), int32_t(0x00000000)},
    {"doorlok1.aud", "", int32_t(0xF0291CD7), int32_t(0x00000000)},
    {"doornok1.aud", "", int32_t(0xF0291CDB), int32_t(0x00000000)},
    {"doornok2.aud", "", int32_t(0xF2291CDB), int32_t(0x00000000)},
    {"doornok3.aud", "", int32_t(0xF4291CDB), int32_t(0x00000000)},
    {"doornok4.aud", "", int32_t(0xF6291CDB), int32_t(0x00000000)},
    {"doornok5.aud", "", int32_t(0xF8291CDB), int32_t(0x00000000)},
    {"doorwc1.aud", "", int32_t(0xA5E41900), int32_t(0x00000000)},
    {"doorwc2.aud", "", int32_t(0xA5E61900), int32_t(0x00000000)},
    {"doorwo1.aud", "", int32_t(0xA5E43100), int32_t(0x00000000)},
    {"doorwo2.aud", "", int32_t(0xA5E63100), int32_t(0x00000000)},
    {"doorws1.aud", "", int32_t(0xA5E43900), int32_t(0x00000000)},
    {"doorws2.aud", "", int32_t(0xA5E63900), int32_t(0x00000000)},
    {"dorslid1.aud", "", int32_t(0xF42710D7), int32_t(0x00000000)},
    {"dorslid2.aud", "", int32_t(0xF62710D7), int32_t(0x00000000)},
    {"double.vqa", "2 construction yards", int32_t(0xB5B208FA), int32_t(0x00000000)},
    {"double.vqp", "vqp: 2 construction yards", int32_t(0xB5B217FA), int32_t(0x00000000)},
    {"doubletrouble.map", "", int32_t(0x00000000), int32_t(0x7EEAC5AF)},
    {"downbtn.shp", "", int32_t(0x00000000), int32_t(0x339A60FA)},
    {"downbtn2.shp", "", int32_t(0x00000000), int32_t(0x6FD5B6BE)},
    {"downtown.map", "", int32_t(0x00000000), int32_t(0x6F592D88)},
    {"dpod.hva", "-", int32_t(0x00000000), int32_t(0x6B033358)},
    {"dpod.vxl", "droppod", int32_t(0x00000000), int32_t(0x9D89EC11)},
    {"dpodbarl.hva", "-", int32_t(0x00000000), int32_t(0x5A1EB1AA)},
    {"dpodtur.hva", "-", int32_t(0x00000000), int32_t(0x050D9779)},
    {"dpthchrg.vqa", "boat blows up sub", int32_t(0xF14727C5), int32_t(0x00000000)},
    {"dpthchrg.vqp", "vqp: boat blows up sub", int32_t(0x004727C5), int32_t(0x00000000)},
    {"dr01-min.set", "", int32_t(0xB5993699), int32_t(0x00000000)},
    {"dr01.vqa", "", int32_t(0xA3B1FAB6), int32_t(0x00000000)},
    {"dr01_0.vqa", "", int32_t(0x711DEB20), int32_t(0x00000000)},
    {"dr01_1.vqa", "", int32_t(0x711DED20), int32_t(0x00000000)},
    {"dr01_2.vqa", "", int32_t(0x711DEF20), int32_t(0x00000000)},
    {"dr01_3.vqa", "", int32_t(0x711DF120), int32_t(0x00000000)},
    {"dr02-min.set", "", int32_t(0xB9993699), int32_t(0x00000000)},
    {"dr02.vqa", "", int32_t(0xA5B1FAB6), int32_t(0x00000000)},
    {"dr02_0.vqa", "", int32_t(0x751DEB20), int32_t(0x00000000)},
    {"dr02_1.vqa", "", int32_t(0x751DED20), int32_t(0x00000000)},
    {"dr02_2.vqa", "", int32_t(0x751DEF20), int32_t(0x00000000)},
    {"dr02_3.vqa", "", int32_t(0x751DF120), int32_t(0x00000000)},
    {"dr03-min.set", "", int32_t(0xBD993699), int32_t(0x00000000)},
    {"dr03.vqa", "", int32_t(0xA7B1FAB6), int32_t(0x00000000)},
    {"dr03_0.vqa", "", int32_t(0x791DEB20), int32_t(0x00000000)},
    {"dr03_1.vqa", "", int32_t(0x791DED20), int32_t(0x00000000)},
    {"dr03_2.vqa", "", int32_t(0x791DEF20), int32_t(0x00000000)},
    {"dr03_3.vqa", "", int32_t(0x791DF120), int32_t(0x00000000)},
    {"dr04-min.set", "", int32_t(0xC1993699), int32_t(0x00000000)},
    {"dr04.vqa", "", int32_t(0xA9B1FAB6), int32_t(0x00000000)},
    {"dr04_0.vqa", "", int32_t(0x7D1DEB20), int32_t(0x00000000)},
    {"dr04_1.vqa", "", int32_t(0x7D1DED20), int32_t(0x00000000)},
    {"dr04_2.vqa", "", int32_t(0x7D1DEF20), int32_t(0x00000000)},
    {"dr04_3.vqa", "", int32_t(0x7D1DF120), int32_t(0x00000000)},
    {"dr04over.vqa", "", int32_t(0xB69D4BDD), int32_t(0x00000000)},
    {"dr05-min.set", "", int32_t(0xC5993699), int32_t(0x00000000)},
    {"dr05.vqa", "", int32_t(0xABB1FAB6), int32_t(0x00000000)},
    {"dr05_0.vqa", "", int32_t(0x811DEB20), int32_t(0x00000000)},
    {"dr05_1.vqa", "", int32_t(0x811DED20), int32_t(0x00000000)},
    {"dr05_2.vqa", "", int32_t(0x811DEF20), int32_t(0x00000000)},
    {"dr05_3.vqa", "", int32_t(0x811DF120), int32_t(0x00000000)},
    {"dr05over.vqa", "", int32_t(0xBA9D4BDD), int32_t(0x00000000)},
    {"dr06-min.set", "", int32_t(0xC9993699), int32_t(0x00000000)},
    {"dr06.vqa", "", int32_t(0xADB1FAB6), int32_t(0x00000000)},
    {"dr06_0.vqa", "", int32_t(0x851DEB20), int32_t(0x00000000)},
    {"dr06_1.vqa", "", int32_t(0x851DED20), int32_t(0x00000000)},
    {"dr06_2.vqa", "", int32_t(0x851DEF20), int32_t(0x00000000)},
    {"dr06_3.vqa", "", int32_t(0x851DF120), int32_t(0x00000000)},
    {"dr06over.vqa", "", int32_t(0xBE9D4BDD), int32_t(0x00000000)},
    {"dr06ovr2.vqa", "", int32_t(0x7EB74BDD), int32_t(0x00000000)},
    {"dracdag1.aud", "", int32_t(0xB3E90CC7), int32_t(0x00000000)},
    {"dragon.shp", "missile", int32_t(0xC36235F7), int32_t(0x7D58D62F)},
    {"dragon5.csv", "", int32_t(0x79C638F2), int32_t(0x00000000)},
    {"dragon5.lsv", "", int32_t(0x79C638FB), int32_t(0x00000000)},
    {"dragon5.vqa", "", int32_t(0x79B13705), int32_t(0x00000000)},
    {"dragon5_e.vqa", "", int32_t(0x598C2829), int32_t(0x00000000)},
    {"dragon5_e.vqt", "", int32_t(0x598C283C), int32_t(0x00000000)},
    {"dragon5_h.pcx", "", int32_t(0x3D802846), int32_t(0x00000000)},
    {"dragon5_h.vqa", "", int32_t(0x598C282F), int32_t(0x00000000)},
    {"dragon5_l.pcx", "", int32_t(0x3D80284E), int32_t(0x00000000)},
    {"dragon5_l.vqa", "", int32_t(0x598C2837), int32_t(0x00000000)},
    {"dragon7.csv", "", int32_t(0x79CA38F2), int32_t(0x00000000)},
    {"dragon7.lsv", "", int32_t(0x79CA38FB), int32_t(0x00000000)},
    {"dragon7.vqa", "", int32_t(0x79B53705), int32_t(0x00000000)},
    {"dragon7_e.vqa", "", int32_t(0x59942829), int32_t(0x00000000)},
    {"dragon7_e.vqt", "", int32_t(0x5994283C), int32_t(0x00000000)},
    {"dragon7_h.pcx", "", int32_t(0x3D882846), int32_t(0x00000000)},
    {"dragon7_h.vqa", "", int32_t(0x5994282F), int32_t(0x00000000)},
    {"dragon7_l.pcx", "", int32_t(0x3D88284E), int32_t(0x00000000)},
    {"dragon7_l.vqa", "", int32_t(0x59942837), int32_t(0x00000000)},
    {"dragon8.csv", "", int32_t(0x79CC38F2), int32_t(0x00000000)},
    {"dragon8.lsv", "", int32_t(0x79CC38FB), int32_t(0x00000000)},
    {"dragon8.vqa", "", int32_t(0x79B73705), int32_t(0x00000000)},
    {"dragon8_e.vqa", "", int32_t(0x59982829), int32_t(0x00000000)},
    {"dragon8_e.vqt", "", int32_t(0x5998283C), int32_t(0x00000000)},
    {"dragon8_h.pcx", "", int32_t(0x3D8C2846), int32_t(0x00000000)},
    {"dragon8_h.vqa", "", int32_t(0x5998282F), int32_t(0x00000000)},
    {"dragon8_l.pcx", "", int32_t(0x3D8C284E), int32_t(0x00000000)},
    {"dragon8_l.vqa", "", int32_t(0x59982837), int32_t(0x00000000)},
    {"dragont1.aud", "", int32_t(0xC40326DD), int32_t(0x00000000)},
    {"dragont2.aud", "", int32_t(0xC60326DD), int32_t(0x00000000)},
    {"dragont3.aud", "", int32_t(0xC80326DD), int32_t(0x00000000)},
    {"dragont4.aud", "", int32_t(0xCA0326DD), int32_t(0x00000000)},
    {"dragont5.aud", "", int32_t(0xCC0326DD), int32_t(0x00000000)},
    {"drahall1.aud", "", int32_t(0xC7F322C1), int32_t(0x00000000)},
    {"drain1x.aud", "", int32_t(0x81FA00EE), int32_t(0x00000000)},
    {"drakat1a.aud", "", int32_t(0xF3BD32C1), int32_t(0x00000000)},
    {"drakat1b.aud", "", int32_t(0xF5BD32C1), int32_t(0x00000000)},
    {"drakatk2.aud", "", int32_t(0xD5F132C1), int32_t(0x00000000)},
    {"drakblo1.aud", "", int32_t(0xD3F922C3), int32_t(0x00000000)},
    {"drakblo2.aud", "", int32_t(0xD5F922C3), int32_t(0x00000000)},
    {"drakdie1.aud", "", int32_t(0xD3E51CC7), int32_t(0x00000000)},
    {"drakdie2.aud", "", int32_t(0xD5E51CC7), int32_t(0x00000000)},
    {"drakdie3.aud", "", int32_t(0xD7E51CC7), int32_t(0x00000000)},
    {"drakloi1.aud", "", int32_t(0xD3ED28D7), int32_t(0x00000000)},
    {"drakloi2.aud", "", int32_t(0xD5ED28D7), int32_t(0x00000000)},
    {"drakloi3.aud", "", int32_t(0xD7ED28D7), int32_t(0x00000000)},
    {"drakrun1.aud", "", int32_t(0xD3F734E3), int32_t(0x00000000)},
    {"drakrun2.aud", "", int32_t(0xD5F734E3), int32_t(0x00000000)},
    {"drakrun3.aud", "", int32_t(0xD7F734E3), int32_t(0x00000000)},
    {"drakrun4.aud", "", int32_t(0xD9F734E3), int32_t(0x00000000)},
    {"drakstn1.aud", "", int32_t(0xD3F732E5), int32_t(0x00000000)},
    {"drakstn2.aud", "", int32_t(0xD5F732E5), int32_t(0x00000000)},
    {"drakwlk1.aud", "", int32_t(0xD3F122ED), int32_t(0x00000000)},
    {"drakwlk2.aud", "", int32_t(0xD5F122ED), int32_t(0x00000000)},
    {"drakwlk3.aud", "", int32_t(0xD7F122ED), int32_t(0x00000000)},
    {"drakwlk4.aud", "", int32_t(0xD9F122ED), int32_t(0x00000000)},
    {"drakwlk5.aud", "", int32_t(0xDBF122ED), int32_t(0x00000000)},
    {"drakwlk6.aud", "", int32_t(0xDDF122ED), int32_t(0x00000000)},
    {"drakwlk7.aud", "", int32_t(0xDFF122ED), int32_t(0x00000000)},
    {"dramb4.aud", "", int32_t(0xB761F5EA), int32_t(0x00000000)},
    {"dramb5.aud", "", int32_t(0xB761F7EA), int32_t(0x00000000)},
    {"drawbrid.ini", "", int32_t(0x00000000), int32_t(0x0BA303FA)},
    {"drawbrid.map", "-", int32_t(0x00000000), int32_t(0xEF591F29)},
    {"drawer1.aud", "", int32_t(0xB9AC42DC), int32_t(0x00000000)},
    {"dreadnaught.bmp", "", int32_t(0x00000000), int32_t(0xBCB30A5D)},
    {"dreadnought.bmp", "", int32_t(0x00000000), int32_t(0xA27A3AEE)},
    {"dred.hva", "", int32_t(0x00000000), int32_t(0x5D070117)},
    {"dred.mrf", "???", int32_t(0xCEDCF1B6), int32_t(0x00000000)},
    {"dred.vxl", "", int32_t(0x00000000), int32_t(0xAB8DDE5E)},
    {"dredicon.shp", "", int32_t(0x00000000), int32_t(0xB4AF8444)},
    {"dredmiss.shp", "", int32_t(0x00000000), int32_t(0x78F14423)},
    {"dredwo.hva", "", int32_t(0x00000000), int32_t(0x040A19A1)},
    {"dredwo.vxl", "", int32_t(0x00000000), int32_t(0xD465F925)},
    {"drgbrth1.aud", "", int32_t(0xB00332E3), int32_t(0x00000000)},
    {"drgbrth2.aud", "", int32_t(0xB20332E3), int32_t(0x00000000)},
    {"drgbrth3.aud", "", int32_t(0xB40332E3), int32_t(0x00000000)},
    {"drgbrth4.aud", "", int32_t(0xB60332E3), int32_t(0x00000000)},
    {"drgbrth5.aud", "", int32_t(0xB80332E3), int32_t(0x00000000)},
    {"drgbrth6.aud", "", int32_t(0xBA0332E3), int32_t(0x00000000)},
    {"drgbrth7.aud", "", int32_t(0xBC0332E3), int32_t(0x00000000)},
    {"drgbrth8.aud", "", int32_t(0xBE0332E3), int32_t(0x00000000)},
    {"drgfoot1.aud", "", int32_t(0xC01B28DD), int32_t(0x00000000)},
    {"drgfoot2.aud", "", int32_t(0xC21B28DD), int32_t(0x00000000)},
    {"drgnflgt.csv", "", int32_t(0x37FF24CB), int32_t(0x00000000)},
    {"drgnflgt.lsv", "", int32_t(0x37FF2DCB), int32_t(0x00000000)},
    {"drgnflgt.vqa", "", int32_t(0x22FD37CB), int32_t(0x00000000)},
    {"drgnflgt_e.vqa", "", int32_t(0x6FB48F49), int32_t(0x00000000)},
    {"drgnflgt_e.vqt", "", int32_t(0x6FB4A249), int32_t(0x00000000)},
    {"drgnflgt_h.pcx", "", int32_t(0x63B4AC3B), int32_t(0x00000000)},
    {"drgnflgt_h.vqa", "", int32_t(0x6FB49549), int32_t(0x00000000)},
    {"drgnflgt_l.pcx", "", int32_t(0x63B4B43B), int32_t(0x00000000)},
    {"drgnflgt_l.vqa", "", int32_t(0x6FB49D49), int32_t(0x00000000)},
    {"drgstir1.aud", "", int32_t(0xF4171CE7), int32_t(0x00000000)},
    {"drgstir2.aud", "", int32_t(0xF6171CE7), int32_t(0x00000000)},
    {"drgstir3.aud", "", int32_t(0xF8171CE7), int32_t(0x00000000)},
    {"drgstir4.aud", "", int32_t(0xFA171CE7), int32_t(0x00000000)},
    {"dril226m.aud", "drill", int32_t(0x0FE6EEA3), int32_t(0x00000000)},
    {"drill.aud", "", int32_t(0xDBA7A5ED), int32_t(0x00000000)},
    {"drill7.aud", "audf:", int32_t(0xB381FBFE), int32_t(0x00000000)},
    {"drill9.aud", "audf:", int32_t(0xB381FFFE), int32_t(0x00000000)},
    {"drilmov3.aud", "audf:", int32_t(0xDC2728D9), int32_t(0x00000000)},
    {"drilmov4.aud", "audf:", int32_t(0xDE2728D9), int32_t(0x00000000)},
    {"drip2.aud", "", int32_t(0xEBA7A5B9), int32_t(0x00000000)},
    {"drip3.aud", "", int32_t(0xEBA7A5BB), int32_t(0x00000000)},
    {"drip4.aud", "", int32_t(0xEBA7A5BD), int32_t(0x00000000)},
    {"drip5.aud", "", int32_t(0xEBA7A5BF), int32_t(0x00000000)},
    {"dripc1.aud", "", int32_t(0xC381EFEC), int32_t(0x00000000)},
    {"dripc2.aud", "", int32_t(0xC381F1EC), int32_t(0x00000000)},
    {"dripc3.aud", "", int32_t(0xC381F3EC), int32_t(0x00000000)},
    {"dripc4.aud", "", int32_t(0xC381F5EC), int32_t(0x00000000)},
    {"dripc5.aud", "", int32_t(0xC381F7EC), int32_t(0x00000000)},
    {"dripc6.aud", "", int32_t(0xC381F9EC), int32_t(0x00000000)},
    {"dripc7.aud", "", int32_t(0xC381FBEC), int32_t(0x00000000)},
    {"dripcav1.aud", "", int32_t(0xE8270CC5), int32_t(0x00000000)},
    {"dripcav2.aud", "", int32_t(0xEA270CC5), int32_t(0x00000000)},
    {"dripcav3.aud", "", int32_t(0xEC270CC5), int32_t(0x00000000)},
    {"dripcav4.aud", "", int32_t(0xEE270CC5), int32_t(0x00000000)},
    {"dripcav5.aud", "", int32_t(0xF0270CC5), int32_t(0x00000000)},
    {"dripcav6.aud", "", int32_t(0xF2270CC5), int32_t(0x00000000)},
    {"dripcav7.aud", "", int32_t(0xF4270CC5), int32_t(0x00000000)},
    {"dripcav8.aud", "", int32_t(0xF6270CC5), int32_t(0x00000000)},
    {"dripps1.aud", "", int32_t(0x9DCC44F2), int32_t(0x00000000)},
    {"drippy1.aud", "", int32_t(0x9DCC50F2), int32_t(0x00000000)},
    {"drippy10.aud", "", int32_t(0xE5DD3CDF), int32_t(0x00000000)},
    {"drippy2.aud", "", int32_t(0x9DCE50F2), int32_t(0x00000000)},
    {"drippy4.aud", "", int32_t(0x9DD250F2), int32_t(0x00000000)},
    {"drippy6.aud", "", int32_t(0x9DD650F2), int32_t(0x00000000)},
    {"drippy7.aud", "", int32_t(0x9DD850F2), int32_t(0x00000000)},
    {"drkness2.aud", "", int32_t(0xE22930C9), int32_t(0x00000000)},
    {"drmrmapr.csv", "", int32_t(0x44290ED9), int32_t(0x00000000)},
    {"drmrmapr.lsv", "", int32_t(0x442917D9), int32_t(0x00000000)},
    {"drmrmapr.vqa", "", int32_t(0x2F2721D9), int32_t(0x00000000)},
    {"drmrmapr_e.vqa", "", int32_t(0x88086365), int32_t(0x00000000)},
    {"drmrmapr_e.vqt", "", int32_t(0x88087665), int32_t(0x00000000)},
    {"drmrmapr_h.pcx", "", int32_t(0x7C088057), int32_t(0x00000000)},
    {"drmrmapr_h.vqa", "", int32_t(0x88086965), int32_t(0x00000000)},
    {"drmrmapr_l.pcx", "", int32_t(0x7C088857), int32_t(0x00000000)},
    {"drmrmapr_l.vqa", "", int32_t(0x88087165), int32_t(0x00000000)},
    {"drnmnstr.flc", "", int32_t(0x1D2E35DB), int32_t(0x00000000)},
    {"droadc01.des", "", int32_t(0x00000000), int32_t(0xC627161B)},
    {"droadc01.sno", "-", int32_t(0x00000000), int32_t(0x28BB266A)},
    {"droadc01.tem", "-", int32_t(0x00000000), int32_t(0x200E8808)},
    {"droadc01.ubn", "", int32_t(0x00000000), int32_t(0xF7842542)},
    {"droadc01.urb", "", int32_t(0x00000000), int32_t(0xB4F07B38)},
    {"droadc02.des", "", int32_t(0x00000000), int32_t(0x81876CCB)},
    {"droadc02.sno", "-", int32_t(0x00000000), int32_t(0x6F1B5CBA)},
    {"droadc02.tem", "-", int32_t(0x00000000), int32_t(0x67AEF2D8)},
    {"droadc02.ubn", "", int32_t(0x00000000), int32_t(0xB0245F92)},
    {"droadc02.urb", "", int32_t(0x00000000), int32_t(0xF35001E8)},
    {"droadc03.des", "", int32_t(0x00000000), int32_t(0xBCE7457B)},
    {"droadc03.sno", "-", int32_t(0x00000000), int32_t(0x527B750A)},
    {"droadc03.tem", "-", int32_t(0x00000000), int32_t(0x5ACEDB68)},
    {"droadc03.ubn", "", int32_t(0x00000000), int32_t(0x8D447622)},
    {"droadc03.urb", "", int32_t(0x00000000), int32_t(0xCE302858)},
    {"droadc04.des", "", int32_t(0x00000000), int32_t(0x0EC7996B)},
    {"droadc04.sno", "-", int32_t(0x00000000), int32_t(0xE05BA91A)},
    {"droadc04.tem", "-", int32_t(0x00000000), int32_t(0xE8EE0778)},
    {"droadc04.ubn", "", int32_t(0x00000000), int32_t(0x3F64AA32)},
    {"droadc04.urb", "", int32_t(0x00000000), int32_t(0x7C10F448)},
    {"droadc05.des", "", int32_t(0x00000000), int32_t(0x33A7B0DB)},
    {"droadc05.sno", "-", int32_t(0x00000000), int32_t(0xDD3B80AA)},
    {"droadc05.tem", "-", int32_t(0x00000000), int32_t(0xD58E2EC8)},
    {"droadc05.ubn", "", int32_t(0x00000000), int32_t(0x02048382)},
    {"droadc05.urb", "", int32_t(0x00000000), int32_t(0x4170DDF8)},
    {"droadc06.des", "", int32_t(0x00000000), int32_t(0x7407CA0B)},
    {"droadc06.sno", "-", int32_t(0x00000000), int32_t(0x9A9BFA7A)},
    {"droadc06.tem", "-", int32_t(0x00000000), int32_t(0x922E5418)},
    {"droadc06.ubn", "", int32_t(0x00000000), int32_t(0x45A4F952)},
    {"droadc06.urb", "", int32_t(0x00000000), int32_t(0x06D0A728)},
    {"droadc07.des", "", int32_t(0x00000000), int32_t(0x4967E3BB)},
    {"droadc07.sno", "-", int32_t(0x00000000), int32_t(0xA7FBD3CA)},
    {"droadc07.tem", "-", int32_t(0x00000000), int32_t(0xAF4E7DA8)},
    {"droadc07.ubn", "", int32_t(0x00000000), int32_t(0x78C4D0E2)},
    {"droadc07.urb", "", int32_t(0x00000000), int32_t(0x3BB08E98)},
    {"droadc08.des", "", int32_t(0x00000000), int32_t(0xCB37746A)},
    {"droadc08.sno", "-", int32_t(0x00000000), int32_t(0x25AB441B)},
    {"droadc08.tem", "-", int32_t(0x00000000), int32_t(0x2D1EEA79)},
    {"droadc08.ubn", "", int32_t(0x00000000), int32_t(0xFA944733)},
    {"droadc08.urb", "", int32_t(0x00000000), int32_t(0xB9E01949)},
    {"droadc09.des", "", int32_t(0x00000000), int32_t(0xF6575DDA)},
    {"droadc09.sno", "-", int32_t(0x00000000), int32_t(0x18CB6DAB)},
    {"droadc09.tem", "-", int32_t(0x00000000), int32_t(0x107EC3C9)},
    {"droadc09.ubn", "", int32_t(0x00000000), int32_t(0xC7F46E83)},
    {"droadc09.urb", "", int32_t(0x00000000), int32_t(0x848030F9)},
    {"droadc10.des", "", int32_t(0x00000000), int32_t(0x301BEC0E)},
    {"droadc10.sno", "-", int32_t(0x00000000), int32_t(0xDE87DC7F)},
    {"droadc10.tem", "-", int32_t(0x00000000), int32_t(0xD632721D)},
    {"droadc10.ubn", "", int32_t(0x00000000), int32_t(0x01B8DF57)},
    {"droadc10.urb", "", int32_t(0x00000000), int32_t(0x42CC812D)},
    {"droadc11.des", "", int32_t(0x00000000), int32_t(0x0D7BC5BE)},
    {"droadc11.sno", "-", int32_t(0x00000000), int32_t(0xE3E7F5CF)},
    {"droadc11.tem", "-", int32_t(0x00000000), int32_t(0xEB525BAD)},
    {"droadc11.ubn", "", int32_t(0x00000000), int32_t(0x3CD8F6E7)},
    {"droadc11.urb", "", int32_t(0x00000000), int32_t(0x7FACA89D)},
    {"droadc12.des", "", int32_t(0x00000000), int32_t(0x4ADBBF6E)},
    {"droadc12.sno", "-", int32_t(0x00000000), int32_t(0xA4478F1F)},
    {"droadc12.tem", "-", int32_t(0x00000000), int32_t(0xACF2217D)},
    {"droadc12.ubn", "", int32_t(0x00000000), int32_t(0x7B788C37)},
    {"droadc12.urb", "", int32_t(0x00000000), int32_t(0x380CD24D)},
    {"droadc13.des", "", int32_t(0x00000000), int32_t(0x77BB96DE)},
    {"droadc13.sno", "-", int32_t(0x00000000), int32_t(0x9927A6AF)},
    {"droadc13.tem", "-", int32_t(0x00000000), int32_t(0x919208CD)},
    {"droadc13.ubn", "", int32_t(0x00000000), int32_t(0x4618A587)},
    {"droadc13.urb", "", int32_t(0x00000000), int32_t(0x056CFBFD)},
    {"droadc14.des", "", int32_t(0x00000000), int32_t(0xC59B4ACE)},
    {"droadc14.sno", "-", int32_t(0x00000000), int32_t(0x2B077ABF)},
    {"droadc14.tem", "-", int32_t(0x00000000), int32_t(0x23B2D4DD)},
    {"droadc14.ubn", "", int32_t(0x00000000), int32_t(0xF4387997)},
    {"droadc14.urb", "", int32_t(0x00000000), int32_t(0xB74C27ED)},
    {"droadc15.des", "", int32_t(0x00000000), int32_t(0xF8FB637E)},
    {"droadc15.sno", "-", int32_t(0x00000000), int32_t(0x1667530F)},
    {"droadc15.tem", "-", int32_t(0x00000000), int32_t(0x1ED2FD6D)},
    {"droadc15.ubn", "", int32_t(0x00000000), int32_t(0xC9585027)},
    {"droadc15.urb", "", int32_t(0x00000000), int32_t(0x8A2C0E5D)},
    {"droadc16.des", "", int32_t(0x00000000), int32_t(0xBF5B19AE)},
    {"droadc16.sno", "-", int32_t(0x00000000), int32_t(0x51C729DF)},
    {"droadc16.tem", "-", int32_t(0x00000000), int32_t(0x597287BD)},
    {"droadc16.ubn", "", int32_t(0x00000000), int32_t(0x8EF82AF7)},
    {"droadc16.urb", "", int32_t(0x00000000), int32_t(0xCD8C748D)},
    {"droadc17.des", "", int32_t(0x00000000), int32_t(0x823B301E)},
    {"droadc17.sno", "-", int32_t(0x00000000), int32_t(0x6CA7006F)},
    {"droadc17.tem", "-", int32_t(0x00000000), int32_t(0x6412AE0D)},
    {"droadc17.ubn", "", int32_t(0x00000000), int32_t(0xB3980347)},
    {"droadc17.urb", "", int32_t(0x00000000), int32_t(0xF0EC5D3D)},
    {"droadc18.des", "", int32_t(0x00000000), int32_t(0x006BA7CF)},
    {"droadc18.sno", "-", int32_t(0x00000000), int32_t(0xEEF797BE)},
    {"droadc18.tem", "-", int32_t(0x00000000), int32_t(0xE64239DC)},
    {"droadc18.ubn", "", int32_t(0x00000000), int32_t(0x31C89496)},
    {"droadc18.urb", "", int32_t(0x00000000), int32_t(0x72BCCAEC)},
    {"droadc19.des", "", int32_t(0x00000000), int32_t(0x3D0B8E7F)},
    {"droadc19.sno", "-", int32_t(0x00000000), int32_t(0xD397BE0E)},
    {"droadc19.tem", "-", int32_t(0x00000000), int32_t(0xDB22106C)},
    {"droadc19.ubn", "", int32_t(0x00000000), int32_t(0x0CA8BD26)},
    {"droadc19.urb", "", int32_t(0x00000000), int32_t(0x4FDCE35C)},
    {"droadc20.des", "", int32_t(0x00000000), int32_t(0xB68F9EA0)},
    {"droadc20.sno", "-", int32_t(0x00000000), int32_t(0x5813AED1)},
    {"droadc20.tem", "-", int32_t(0x00000000), int32_t(0x50A600B3)},
    {"droadc20.ubn", "", int32_t(0x00000000), int32_t(0x872CADF9)},
    {"droadc20.urb", "", int32_t(0x00000000), int32_t(0xC458F383)},
    {"droadc21.des", "", int32_t(0x00000000), int32_t(0x8BEFB710)},
    {"droadc21.sno", "-", int32_t(0x00000000), int32_t(0x65738761)},
    {"droadc21.tem", "-", int32_t(0x00000000), int32_t(0x6DC62903)},
    {"droadc21.ubn", "", int32_t(0x00000000), int32_t(0xBA4C8449)},
    {"droadc21.urb", "", int32_t(0x00000000), int32_t(0xF938DA33)},
    {"droadc22.des", "", int32_t(0x00000000), int32_t(0xCC4FCDC0)},
    {"droadc22.sno", "-", int32_t(0x00000000), int32_t(0x22D3FDB1)},
    {"droadc22.tem", "-", int32_t(0x00000000), int32_t(0x2A6653D3)},
    {"droadc22.ubn", "", int32_t(0x00000000), int32_t(0xFDECFE99)},
    {"droadc22.urb", "", int32_t(0x00000000), int32_t(0xBE98A0E3)},
    {"droadc23.des", "", int32_t(0x00000000), int32_t(0xF12FE470)},
    {"droadc23.sno", "-", int32_t(0x00000000), int32_t(0x1FB3D401)},
    {"droadc23.tem", "-", int32_t(0x00000000), int32_t(0x17067A63)},
    {"droadc23.ubn", "", int32_t(0x00000000), int32_t(0xC08CD729)},
    {"droadc23.urb", "", int32_t(0x00000000), int32_t(0x83F88953)},
    {"droadc24.des", "", int32_t(0x00000000), int32_t(0x430F3860)},
    {"droadc24.sno", "-", int32_t(0x00000000), int32_t(0xAD930811)},
    {"droadc24.tem", "-", int32_t(0x00000000), int32_t(0xA526A673)},
    {"droadc24.ubn", "", int32_t(0x00000000), int32_t(0x72AC0B39)},
    {"droadc24.urb", "", int32_t(0x00000000), int32_t(0x31D85543)},
    {"droadj01.des", "", int32_t(0x00000000), int32_t(0x53BF53C8)},
    {"droadj01.sno", "-", int32_t(0x00000000), int32_t(0xBD2363B9)},
    {"droadj01.tem", "-", int32_t(0x00000000), int32_t(0xB596CDDB)},
    {"droadj01.ubn", "", int32_t(0x00000000), int32_t(0x621C6091)},
    {"droadj01.urb", "", int32_t(0x00000000), int32_t(0x21683EEB)},
    {"droadj02.des", "", int32_t(0x00000000), int32_t(0x141F2918)},
    {"droadj02.sno", "-", int32_t(0x00000000), int32_t(0xFA831969)},
    {"droadj02.tem", "-", int32_t(0x00000000), int32_t(0xF236B70B)},
    {"droadj02.ubn", "", int32_t(0x00000000), int32_t(0x25BC1A41)},
    {"droadj02.urb", "", int32_t(0x00000000), int32_t(0x66C8443B)},
    {"droadj03.des", "", int32_t(0x00000000), int32_t(0x297F00A8)},
    {"droadj03.sno", "-", int32_t(0x00000000), int32_t(0xC7E330D9)},
    {"droadj03.tem", "-", int32_t(0x00000000), int32_t(0xCF569EBB)},
    {"droadj03.ubn", "", int32_t(0x00000000), int32_t(0x18DC33F1)},
    {"droadj03.urb", "", int32_t(0x00000000), int32_t(0x5BA86D8B)},
    {"droadj04.des", "", int32_t(0x00000000), int32_t(0x9B5FDCB8)},
    {"droadj04.sno", "-", int32_t(0x00000000), int32_t(0x75C3ECC9)},
    {"droadj04.tem", "-", int32_t(0x00000000), int32_t(0x7D7642AB)},
    {"droadj04.ubn", "", int32_t(0x00000000), int32_t(0xAAFCEFE1)},
    {"droadj04.urb", "", int32_t(0x00000000), int32_t(0xE988B19B)},
    {"droadj05.des", "", int32_t(0x00000000), int32_t(0xA63FF508)},
    {"droadj05.sno", "-", int32_t(0x00000000), int32_t(0x48A3C579)},
    {"droadj05.tem", "-", int32_t(0x00000000), int32_t(0x40166B1B)},
    {"droadj05.ubn", "", int32_t(0x00000000), int32_t(0x979CC651)},
    {"droadj05.urb", "", int32_t(0x00000000), int32_t(0xD4E8982B)},
    {"droadj06.des", "", int32_t(0x00000000), int32_t(0xE19F8FD8)},
    {"droadj06.sno", "-", int32_t(0x00000000), int32_t(0x0F03BFA9)},
    {"droadj06.tem", "-", int32_t(0x00000000), int32_t(0x07B611CB)},
    {"droadj06.ubn", "", int32_t(0x00000000), int32_t(0xD03CBC81)},
    {"droadj06.urb", "", int32_t(0x00000000), int32_t(0x9348E2FB)},
    {"droadj07.des", "", int32_t(0x00000000), int32_t(0xDCFFA668)},
    {"droadj07.sno", "-", int32_t(0x00000000), int32_t(0x32639619)},
    {"droadj07.tem", "-", int32_t(0x00000000), int32_t(0x3AD6387B)},
    {"droadj07.ubn", "", int32_t(0x00000000), int32_t(0xED5C9531)},
    {"droadj07.urb", "", int32_t(0x00000000), int32_t(0xAE28CB4B)},
    {"droadj08.des", "", int32_t(0x00000000), int32_t(0x5EAF31B9)},
    {"droadj08.sno", "-", int32_t(0x00000000), int32_t(0xB03301C8)},
    {"droadj08.tem", "-", int32_t(0x00000000), int32_t(0xB886AFAA)},
    {"droadj08.ubn", "", int32_t(0x00000000), int32_t(0x6F0C02E0)},
    {"droadj08.urb", "", int32_t(0x00000000), int32_t(0x2C785C9A)},
    {"droadj09.des", "", int32_t(0x00000000), int32_t(0x63CF1809)},
    {"droadj09.sno", "-", int32_t(0x00000000), int32_t(0x8D532878)},
    {"droadj09.tem", "-", int32_t(0x00000000), int32_t(0x85E6861A)},
    {"droadj09.ubn", "", int32_t(0x00000000), int32_t(0x526C2B50)},
    {"droadj09.urb", "", int32_t(0x00000000), int32_t(0x1118752A)},
    {"droadj10.des", "", int32_t(0x00000000), int32_t(0xA583A9DD)},
    {"droadj10.sno", "-", int32_t(0x00000000), int32_t(0x4B1F99AC)},
    {"droadj10.tem", "-", int32_t(0x00000000), int32_t(0x43AA37CE)},
    {"droadj10.ubn", "", int32_t(0x00000000), int32_t(0x94209A84)},
    {"droadj10.urb", "", int32_t(0x00000000), int32_t(0xD754C4FE)},
    {"droadj11.des", "", int32_t(0x00000000), int32_t(0x98E3806D)},
    {"droadj11.sno", "-", int32_t(0x00000000), int32_t(0x767FB01C)},
    {"droadj11.tem", "-", int32_t(0x00000000), int32_t(0x7ECA1E7E)},
    {"droadj11.ubn", "", int32_t(0x00000000), int32_t(0xA940B334)},
    {"droadj11.urb", "", int32_t(0x00000000), int32_t(0xEA34ED4E)},
    {"droads01.des", "", int32_t(0x00000000), int32_t(0xA1F98AD5)},
    {"droads01.sno", "-", int32_t(0x00000000), int32_t(0x4F65BAA4)},
    {"droads01.tem", "-", int32_t(0x00000000), int32_t(0x47D014C6)},
    {"droads01.ubn", "", int32_t(0x00000000), int32_t(0x905AB98C)},
    {"droads01.urb", "", int32_t(0x00000000), int32_t(0xD32EE7F6)},
    {"droads02.des", "", int32_t(0x00000000), int32_t(0xE659F005)},
    {"droads02.sno", "-", int32_t(0x00000000), int32_t(0x08C5C074)},
    {"droads02.tem", "-", int32_t(0x00000000), int32_t(0x00706E16)},
    {"droads02.ubn", "", int32_t(0x00000000), int32_t(0xD7FAC35C)},
    {"droads02.urb", "", int32_t(0x00000000), int32_t(0x948E9D26)},
    {"droads03.des", "", int32_t(0x00000000), int32_t(0xDB39D9B5)},
    {"droads03.sno", "-", int32_t(0x00000000), int32_t(0x35A5E9C4)},
    {"droads03.tem", "-", int32_t(0x00000000), int32_t(0x3D1047A6)},
    {"droads03.ubn", "", int32_t(0x00000000), int32_t(0xEA9AEAEC)},
    {"droads03.urb", "", int32_t(0x00000000), int32_t(0xA9EEB496)},
    {"droads04.des", "", int32_t(0x00000000), int32_t(0x691905A5)},
    {"droads04.sno", "-", int32_t(0x00000000), int32_t(0x878535D4)},
    {"droads04.tem", "-", int32_t(0x00000000), int32_t(0x8F309BB6)},
    {"droads04.ubn", "", int32_t(0x00000000), int32_t(0x58BA36FC)},
    {"droads04.urb", "", int32_t(0x00000000), int32_t(0x1BCE6886)},
    {"droads05.des", "", int32_t(0x00000000), int32_t(0x54792C15)},
    {"droads05.sno", "-", int32_t(0x00000000), int32_t(0xBAE51C64)},
    {"droads05.tem", "-", int32_t(0x00000000), int32_t(0xB250B206)},
    {"droads05.ubn", "", int32_t(0x00000000), int32_t(0x65DA1F4C)},
    {"droads05.urb", "", int32_t(0x00000000), int32_t(0x26AE4136)},
    {"droads06.des", "", int32_t(0x00000000), int32_t(0x13D956C5)},
    {"droads06.sno", "-", int32_t(0x00000000), int32_t(0xFD4566B4)},
    {"droads06.tem", "-", int32_t(0x00000000), int32_t(0xF5F0C8D6)},
    {"droads06.ubn", "", int32_t(0x00000000), int32_t(0x227A659C)},
    {"droads06.urb", "", int32_t(0x00000000), int32_t(0x610E3BE6)},
    {"droads07.des", "", int32_t(0x00000000), int32_t(0x2EB97F75)},
    {"droads07.sno", "-", int32_t(0x00000000), int32_t(0xC0254F04)},
    {"droads07.tem", "-", int32_t(0x00000000), int32_t(0xC890E166)},
    {"droads07.ubn", "", int32_t(0x00000000), int32_t(0x1F1A4C2C)},
    {"droads07.urb", "", int32_t(0x00000000), int32_t(0x5C6E1256)},
    {"droads08.des", "", int32_t(0x00000000), int32_t(0xACE9E8A4)},
    {"droads08.sno", "-", int32_t(0x00000000), int32_t(0x4275D8D5)},
    {"droads08.tem", "-", int32_t(0x00000000), int32_t(0x4AC076B7)},
    {"droads08.ubn", "", int32_t(0x00000000), int32_t(0x9D4ADBFD)},
    {"droads08.urb", "", int32_t(0x00000000), int32_t(0xDE3E8587)},
    {"droads09.des", "", int32_t(0x00000000), int32_t(0x9189C114)},
    {"droads09.sno", "-", int32_t(0x00000000), int32_t(0x7F15F165)},
    {"droads09.tem", "-", int32_t(0x00000000), int32_t(0x77A05F07)},
    {"droads09.ubn", "", int32_t(0x00000000), int32_t(0xA02AF24D)},
    {"droads09.urb", "", int32_t(0x00000000), int32_t(0xE35EAC37)},
    {"droads10.des", "", int32_t(0x00000000), int32_t(0x57C570C0)},
    {"droads10.sno", "-", int32_t(0x00000000), int32_t(0xB95940B1)},
    {"droads10.tem", "-", int32_t(0x00000000), int32_t(0xB1ECEED3)},
    {"droads10.ubn", "", int32_t(0x00000000), int32_t(0x66664399)},
    {"droads10.urb", "", int32_t(0x00000000), int32_t(0x25121DE3)},
    {"droads11.des", "", int32_t(0x00000000), int32_t(0x6AA55970)},
    {"droads11.sno", "-", int32_t(0x00000000), int32_t(0x84396901)},
    {"droads11.tem", "-", int32_t(0x00000000), int32_t(0x8C8CC763)},
    {"droads11.ubn", "", int32_t(0x00000000), int32_t(0x5B066A29)},
    {"droads11.urb", "", int32_t(0x00000000), int32_t(0x18723453)},
    {"droads12.des", "", int32_t(0x00000000), int32_t(0x2D0523A0)},
    {"droads12.sno", "-", int32_t(0x00000000), int32_t(0xC39913D1)},
    {"droads12.tem", "-", int32_t(0x00000000), int32_t(0xCB2CBDB3)},
    {"droads12.ubn", "", int32_t(0x00000000), int32_t(0x1CA610F9)},
    {"droads12.urb", "", int32_t(0x00000000), int32_t(0x5FD24E83)},
    {"droads13.des", "", int32_t(0x00000000), int32_t(0x10650A10)},
    {"droads13.sno", "-", int32_t(0x00000000), int32_t(0xFEF93A61)},
    {"droads13.tem", "-", int32_t(0x00000000), int32_t(0xF64C9403)},
    {"droads13.ubn", "", int32_t(0x00000000), int32_t(0x21C63949)},
    {"droads13.urb", "", int32_t(0x00000000), int32_t(0x62B26733)},
    {"droads14.des", "", int32_t(0x00000000), int32_t(0xA245D600)},
    {"droads14.sno", "-", int32_t(0x00000000), int32_t(0x4CD9E671)},
    {"droads14.tem", "-", int32_t(0x00000000), int32_t(0x446C4813)},
    {"droads14.ubn", "", int32_t(0x00000000), int32_t(0x93E6E559)},
    {"droads14.urb", "", int32_t(0x00000000), int32_t(0xD092BB23)},
    {"droads15.des", "", int32_t(0x00000000), int32_t(0x9F25FFB0)},
    {"droads15.sno", "-", int32_t(0x00000000), int32_t(0x71B9CFC1)},
    {"droads15.tem", "-", int32_t(0x00000000), int32_t(0x790C61A3)},
    {"droads15.ubn", "", int32_t(0x00000000), int32_t(0xAE86CCE9)},
    {"droads15.urb", "", int32_t(0x00000000), int32_t(0xEDF29293)},
    {"droads16.des", "", int32_t(0x00000000), int32_t(0xD8858560)},
    {"droads16.sno", "-", int32_t(0x00000000), int32_t(0x3619B511)},
    {"droads16.tem", "-", int32_t(0x00000000), int32_t(0x3EAC1B73)},
    {"droads16.ubn", "", int32_t(0x00000000), int32_t(0xE926B639)},
    {"droads16.urb", "", int32_t(0x00000000), int32_t(0xAA52E843)},
    {"droads17.des", "", int32_t(0x00000000), int32_t(0xE5E5ACD0)},
    {"droads17.sno", "-", int32_t(0x00000000), int32_t(0x0B799CA1)},
    {"droads17.tem", "-", int32_t(0x00000000), int32_t(0x03CC32C3)},
    {"droads17.ubn", "", int32_t(0x00000000), int32_t(0xD4469F89)},
    {"droads17.urb", "", int32_t(0x00000000), int32_t(0x9732C1F3)},
    {"droads18.des", "", int32_t(0x00000000), int32_t(0x67B53B01)},
    {"droads18.sno", "-", int32_t(0x00000000), int32_t(0x89290B70)},
    {"droads18.tem", "-", int32_t(0x00000000), int32_t(0x819CA512)},
    {"droads18.ubn", "", int32_t(0x00000000), int32_t(0x56160858)},
    {"droads18.urb", "", int32_t(0x00000000), int32_t(0x15625622)},
    {"droads19.des", "", int32_t(0x00000000), int32_t(0x5AD512B1)},
    {"droads19.sno", "-", int32_t(0x00000000), int32_t(0xB44922C0)},
    {"droads19.tem", "-", int32_t(0x00000000), int32_t(0xBCFC8CA2)},
    {"droads19.ubn", "", int32_t(0x00000000), int32_t(0x6B7621E8)},
    {"droads19.urb", "", int32_t(0x00000000), int32_t(0x28027F92)},
    {"droads20.des", "", int32_t(0x00000000), int32_t(0xD151026E)},
    {"droads20.sno", "-", int32_t(0x00000000), int32_t(0x3FCD321F)},
    {"droads20.tem", "-", int32_t(0x00000000), int32_t(0x37789C7D)},
    {"droads20.ubn", "", int32_t(0x00000000), int32_t(0xE0F23137)},
    {"droads20.urb", "", int32_t(0x00000000), int32_t(0xA3866F4D)},
    {"droads21.des", "", int32_t(0x00000000), int32_t(0xEC312BDE)},
    {"droads21.sno", "-", int32_t(0x00000000), int32_t(0x02AD1BAF)},
    {"droads21.tem", "-", int32_t(0x00000000), int32_t(0x0A18B5CD)},
    {"droads21.ubn", "", int32_t(0x00000000), int32_t(0xDD921887)},
    {"droads21.urb", "", int32_t(0x00000000), int32_t(0x9EE646FD)},
    {"droads22.des", "", int32_t(0x00000000), int32_t(0xAB91510E)},
    {"droads22.sno", "-", int32_t(0x00000000), int32_t(0x450D617F)},
    {"droads22.tem", "-", int32_t(0x00000000), int32_t(0x4DB8CF1D)},
    {"droads22.ubn", "", int32_t(0x00000000), int32_t(0x9A326257)},
    {"droads22.urb", "", int32_t(0x00000000), int32_t(0xD9463C2D)},
    {"droads23.des", "", int32_t(0x00000000), int32_t(0x96F178BE)},
    {"droads23.sno", "-", int32_t(0x00000000), int32_t(0x786D48CF)},
    {"droads23.tem", "-", int32_t(0x00000000), int32_t(0x70D8E6AD)},
    {"droads23.ubn", "", int32_t(0x00000000), int32_t(0xA7524BE7)},
    {"droads23.urb", "", int32_t(0x00000000), int32_t(0xE426159D)},
    {"droads24.des", "", int32_t(0x00000000), int32_t(0x24D1A4AE)},
    {"droads24.sno", "-", int32_t(0x00000000), int32_t(0xCA4D94DF)},
    {"droads24.tem", "-", int32_t(0x00000000), int32_t(0xC2F83ABD)},
    {"droads24.ubn", "", int32_t(0x00000000), int32_t(0x157297F7)},
    {"droads24.urb", "", int32_t(0x00000000), int32_t(0x5606C98D)},
    {"droads25.des", "", int32_t(0x00000000), int32_t(0x19B18D1E)},
    {"droads25.sno", "-", int32_t(0x00000000), int32_t(0xF72DBD6F)},
    {"droads25.tem", "-", int32_t(0x00000000), int32_t(0xFF98130D)},
    {"droads25.ubn", "", int32_t(0x00000000), int32_t(0x2812BE47)},
    {"droads25.urb", "", int32_t(0x00000000), int32_t(0x6B66E03D)},
    {"droads26.des", "", int32_t(0x00000000), int32_t(0x5E11F7CE)},
    {"droads26.sno", "-", int32_t(0x00000000), int32_t(0xB08DC7BF)},
    {"droads26.tem", "-", int32_t(0x00000000), int32_t(0xB83869DD)},
    {"droads26.ubn", "", int32_t(0x00000000), int32_t(0x6FB2C497)},
    {"droads26.urb", "", int32_t(0x00000000), int32_t(0x2CC69AED)},
    {"droads27.des", "", int32_t(0x00000000), int32_t(0x6371DE7E)},
    {"droads27.sno", "-", int32_t(0x00000000), int32_t(0x8DEDEE0F)},
    {"droads27.tem", "-", int32_t(0x00000000), int32_t(0x8558406D)},
    {"droads27.ubn", "", int32_t(0x00000000), int32_t(0x52D2ED27)},
    {"droads27.urb", "", int32_t(0x00000000), int32_t(0x11A6B35D)},
    {"droads28.des", "", int32_t(0x00000000), int32_t(0xE12149AF)},
    {"droads28.sno", "-", int32_t(0x00000000), int32_t(0x0FBD79DE)},
    {"droads28.tem", "-", int32_t(0x00000000), int32_t(0x0708D7BC)},
    {"droads28.ubn", "", int32_t(0x00000000), int32_t(0xD0827AF6)},
    {"droads28.urb", "", int32_t(0x00000000), int32_t(0x93F6248C)},
    {"droads29.des", "", int32_t(0x00000000), int32_t(0xDC41601F)},
    {"droads29.sno", "-", int32_t(0x00000000), int32_t(0x32DD506E)},
    {"droads29.tem", "-", int32_t(0x00000000), int32_t(0x3A68FE0C)},
    {"droads29.ubn", "", int32_t(0x00000000), int32_t(0xEDE25346)},
    {"droads29.urb", "", int32_t(0x00000000), int32_t(0xAE960D3C)},
    {"droads30.des", "", int32_t(0x00000000), int32_t(0x1A0DD1CB)},
    {"droads30.sno", "-", int32_t(0x00000000), int32_t(0xF491E1BA)},
    {"droads30.tem", "-", int32_t(0x00000000), int32_t(0xFC244FD8)},
    {"droads30.ubn", "", int32_t(0x00000000), int32_t(0x2BAEE292)},
    {"droads30.urb", "", int32_t(0x00000000), int32_t(0x68DABCE8)},
    {"droads31.des", "", int32_t(0x00000000), int32_t(0x276DF87B)},
    {"droads31.sno", "-", int32_t(0x00000000), int32_t(0xC9F1C80A)},
    {"droads31.tem", "-", int32_t(0x00000000), int32_t(0xC1446668)},
    {"droads31.ubn", "", int32_t(0x00000000), int32_t(0x16CECB22)},
    {"droads31.urb", "", int32_t(0x00000000), int32_t(0x55BA9558)},
    {"droads32.des", "", int32_t(0x00000000), int32_t(0x60CD82AB)},
    {"droads32.sno", "-", int32_t(0x00000000), int32_t(0x8E51B2DA)},
    {"droads32.tem", "-", int32_t(0x00000000), int32_t(0x86E41CB8)},
    {"droads32.ubn", "", int32_t(0x00000000), int32_t(0x516EB1F2)},
    {"droads32.urb", "", int32_t(0x00000000), int32_t(0x121AEF88)},
    {"droads33.des", "", int32_t(0x00000000), int32_t(0x5DADAB1B)},
    {"droads33.sno", "-", int32_t(0x00000000), int32_t(0xB3319B6A)},
    {"droads33.tem", "-", int32_t(0x00000000), int32_t(0xBB843508)},
    {"droads33.ubn", "", int32_t(0x00000000), int32_t(0x6C0E9842)},
    {"droads33.urb", "", int32_t(0x00000000), int32_t(0x2F7AC638)},
    {"droads34.des", "", int32_t(0x00000000), int32_t(0xEF8D770B)},
    {"droads34.sno", "-", int32_t(0x00000000), int32_t(0x0111477A)},
    {"droads34.tem", "-", int32_t(0x00000000), int32_t(0x09A4E918)},
    {"droads34.ubn", "", int32_t(0x00000000), int32_t(0xDE2E4452)},
    {"droads34.urb", "", int32_t(0x00000000), int32_t(0x9D5A1A28)},
    {"droads35.des", "", int32_t(0x00000000), int32_t(0xD2ED5EBB)},
    {"droads35.sno", "-", int32_t(0x00000000), int32_t(0x3C716ECA)},
    {"droads35.tem", "-", int32_t(0x00000000), int32_t(0x34C4C0A8)},
    {"droads35.ubn", "", int32_t(0x00000000), int32_t(0xE34E6DE2)},
    {"droads35.urb", "", int32_t(0x00000000), int32_t(0xA03A3398)},
    {"droads36.des", "", int32_t(0x00000000), int32_t(0x954D246B)},
    {"droads36.sno", "-", int32_t(0x00000000), int32_t(0x7BD1141A)},
    {"droads36.tem", "-", int32_t(0x00000000), int32_t(0x7364BA78)},
    {"droads36.ubn", "", int32_t(0x00000000), int32_t(0xA4EE1732)},
    {"droads36.urb", "", int32_t(0x00000000), int32_t(0xE79A4948)},
    {"droads37.des", "", int32_t(0x00000000), int32_t(0xA82D0DDB)},
    {"droads37.sno", "-", int32_t(0x00000000), int32_t(0x46B13DAA)},
    {"droads37.tem", "-", int32_t(0x00000000), int32_t(0x4E0493C8)},
    {"droads37.ubn", "", int32_t(0x00000000), int32_t(0x998E3E82)},
    {"droads37.urb", "", int32_t(0x00000000), int32_t(0xDAFA60F8)},
    {"droads38.des", "", int32_t(0x00000000), int32_t(0x2A7D9A0A)},
    {"droads38.sno", "-", int32_t(0x00000000), int32_t(0xC4E1AA7B)},
    {"droads38.tem", "-", int32_t(0x00000000), int32_t(0xCC540419)},
    {"droads38.ubn", "", int32_t(0x00000000), int32_t(0x1BDEA953)},
    {"droads38.urb", "", int32_t(0x00000000), int32_t(0x58AAF729)},
    {"droads39.des", "", int32_t(0x00000000), int32_t(0x171DB3BA)},
    {"droads39.sno", "-", int32_t(0x00000000), int32_t(0xF98183CB)},
    {"droads39.tem", "-", int32_t(0x00000000), int32_t(0xF1342DA9)},
    {"droads39.ubn", "", int32_t(0x00000000), int32_t(0x26BE80E3)},
    {"droads39.urb", "", int32_t(0x00000000), int32_t(0x65CADE99)},
    {"droads40.des", "", int32_t(0x00000000), int32_t(0x0708E173)},
    {"droads40.sno", "-", int32_t(0x00000000), int32_t(0xE994D102)},
    {"droads40.tem", "-", int32_t(0x00000000), int32_t(0xE1217F60)},
    {"droads40.ubn", "", int32_t(0x00000000), int32_t(0x36ABD22A)},
    {"droads40.urb", "", int32_t(0x00000000), int32_t(0x75DF8C50)},
    {"droads41.des", "", int32_t(0x00000000), int32_t(0x3A68C8C3)},
    {"droads41.sno", "-", int32_t(0x00000000), int32_t(0xD4F4F8B2)},
    {"droads41.tem", "-", int32_t(0x00000000), int32_t(0xDC4156D0)},
    {"droads41.ubn", "", int32_t(0x00000000), int32_t(0x0BCBFB9A)},
    {"droads41.urb", "", int32_t(0x00000000), int32_t(0x48BFA5E0)},
    {"droads42.des", "", int32_t(0x00000000), int32_t(0x7DC8B213)},
    {"droads42.sno", "-", int32_t(0x00000000), int32_t(0x93548262)},
    {"droads42.tem", "-", int32_t(0x00000000), int32_t(0x9BE12C00)},
    {"droads42.ubn", "", int32_t(0x00000000), int32_t(0x4C6B814A)},
    {"droads42.urb", "", int32_t(0x00000000), int32_t(0x0F1FDF30)},
    {"droads43.des", "", int32_t(0x00000000), int32_t(0x40A89BA3)},
    {"droads43.sno", "-", int32_t(0x00000000), int32_t(0xAE34ABD2)},
    {"droads43.tem", "-", int32_t(0x00000000), int32_t(0xA68105B0)},
    {"droads43.ubn", "", int32_t(0x00000000), int32_t(0x710BA8FA)},
    {"droads43.urb", "", int32_t(0x00000000), int32_t(0x327FF680)},
    {"droads44.des", "", int32_t(0x00000000), int32_t(0xF28847B3)},
    {"droads44.sno", "-", int32_t(0x00000000), int32_t(0x1C1477C2)},
    {"droads44.tem", "-", int32_t(0x00000000), int32_t(0x14A1D9A0)},
    {"droads44.ubn", "", int32_t(0x00000000), int32_t(0xC32B74EA)},
    {"droads44.urb", "", int32_t(0x00000000), int32_t(0x805F2A90)},
    {"droads45.des", "", int32_t(0x00000000), int32_t(0xCFE86E03)},
    {"droads45.sno", "-", int32_t(0x00000000), int32_t(0x21745E72)},
    {"droads45.tem", "-", int32_t(0x00000000), int32_t(0x29C1F010)},
    {"droads45.ubn", "", int32_t(0x00000000), int32_t(0xFE4B5D5A)},
    {"droads45.urb", "", int32_t(0x00000000), int32_t(0xBD3F0320)},
    {"droads46.des", "", int32_t(0x00000000), int32_t(0x884814D3)},
    {"droads46.sno", "-", int32_t(0x00000000), int32_t(0x66D424A2)},
    {"droads46.tem", "-", int32_t(0x00000000), int32_t(0x6E618AC0)},
    {"droads46.ubn", "", int32_t(0x00000000), int32_t(0xB9EB278A)},
    {"droads46.urb", "", int32_t(0x00000000), int32_t(0xFA9F79F0)},
    {"droads47.des", "", int32_t(0x00000000), int32_t(0xB5283D63)},
    {"droads47.sno", "-", int32_t(0x00000000), int32_t(0x5BB40D12)},
    {"droads47.tem", "-", int32_t(0x00000000), int32_t(0x5301A370)},
    {"droads47.ubn", "", int32_t(0x00000000), int32_t(0x848B0E3A)},
    {"droads47.urb", "", int32_t(0x00000000), int32_t(0xC7FF5040)},
    {"droads48.des", "", int32_t(0x00000000), int32_t(0x3778AAB2)},
    {"droads48.sno", "-", int32_t(0x00000000), int32_t(0xD9E49AC3)},
    {"droads48.tem", "-", int32_t(0x00000000), int32_t(0xD15134A1)},
    {"droads48.ubn", "", int32_t(0x00000000), int32_t(0x06DB99EB)},
    {"droads48.urb", "", int32_t(0x00000000), int32_t(0x45AFC791)},
    {"droads49.des", "", int32_t(0x00000000), int32_t(0x0A188302)},
    {"droads49.sno", "-", int32_t(0x00000000), int32_t(0xE484B373)},
    {"droads49.tem", "-", int32_t(0x00000000), int32_t(0xEC311D11)},
    {"droads49.ubn", "", int32_t(0x00000000), int32_t(0x3BBBB05B)},
    {"droads49.urb", "", int32_t(0x00000000), int32_t(0x78CFEE21)},
    {"droads50.des", "", int32_t(0x00000000), int32_t(0xCC5432D6)},
    {"droads50.sno", "-", int32_t(0x00000000), int32_t(0x22C802A7)},
    {"droads50.tem", "-", int32_t(0x00000000), int32_t(0x2A7DACC5)},
    {"droads50.ubn", "", int32_t(0x00000000), int32_t(0xFDF7018F)},
    {"droads50.urb", "", int32_t(0x00000000), int32_t(0xBE835FF5)},
    {"droads51.des", "", int32_t(0x00000000), int32_t(0xF1341B66)},
    {"droads51.sno", "-", int32_t(0x00000000), int32_t(0x1FA82B17)},
    {"droads51.tem", "-", int32_t(0x00000000), int32_t(0x171D8575)},
    {"droads51.ubn", "", int32_t(0x00000000), int32_t(0xC097283F)},
    {"droads51.urb", "", int32_t(0x00000000), int32_t(0x83E37645)},
    {"droads52.des", "", int32_t(0x00000000), int32_t(0xB69461B6)},
    {"droads52.sno", "-", int32_t(0x00000000), int32_t(0x580851C7)},
    {"droads52.tem", "-", int32_t(0x00000000), int32_t(0x50BDFFA5)},
    {"droads52.ubn", "", int32_t(0x00000000), int32_t(0x873752EF)},
    {"droads52.urb", "", int32_t(0x00000000), int32_t(0xC4430C95)},
    {"droads53.des", "", int32_t(0x00000000), int32_t(0x8BF44806)},
    {"droads53.sno", "-", int32_t(0x00000000), int32_t(0x65687877)},
    {"droads53.tem", "-", int32_t(0x00000000), int32_t(0x6DDDD615)},
    {"droads53.ubn", "", int32_t(0x00000000), int32_t(0xBA577B5F)},
    {"droads53.urb", "", int32_t(0x00000000), int32_t(0xF9232525)},
    {"droads54.des", "", int32_t(0x00000000), int32_t(0x39D49416)},
    {"droads54.sno", "-", int32_t(0x00000000), int32_t(0xD748A467)},
    {"droads54.tem", "-", int32_t(0x00000000), int32_t(0xDFFD0A05)},
    {"droads54.ubn", "", int32_t(0x00000000), int32_t(0x0877A74F)},
    {"droads54.urb", "", int32_t(0x00000000), int32_t(0x4B03F935)},
    {"droads55.des", "", int32_t(0x00000000), int32_t(0x04B4BDA6)},
    {"droads55.sno", "-", int32_t(0x00000000), int32_t(0xEA288DD7)},
    {"droads55.tem", "-", int32_t(0x00000000), int32_t(0xE29D23B5)},
    {"droads55.ubn", "", int32_t(0x00000000), int32_t(0x35178EFF)},
    {"droads55.urb", "", int32_t(0x00000000), int32_t(0x7663D085)},
    {"droads56.des", "", int32_t(0x00000000), int32_t(0x4314C776)},
    {"droads56.sno", "-", int32_t(0x00000000), int32_t(0xAD88F707)},
    {"droads56.tem", "-", int32_t(0x00000000), int32_t(0xA53D5965)},
    {"droads56.ubn", "", int32_t(0x00000000), int32_t(0x72B7F42F)},
    {"droads56.urb", "", int32_t(0x00000000), int32_t(0x31C3AA55)},
    {"droads57.des", "", int32_t(0x00000000), int32_t(0x7E74EEC6)},
    {"droads57.sno", "-", int32_t(0x00000000), int32_t(0x90E8DEB7)},
    {"droads57.tem", "-", int32_t(0x00000000), int32_t(0x985D70D5)},
    {"droads57.ubn", "", int32_t(0x00000000), int32_t(0x4FD7DD9F)},
    {"droads57.urb", "", int32_t(0x00000000), int32_t(0x0CA383E5)},
    {"droads58.des", "", int32_t(0x00000000), int32_t(0xFC247917)},
    {"droads58.sno", "-", int32_t(0x00000000), int32_t(0x12B84966)},
    {"droads58.tem", "-", int32_t(0x00000000), int32_t(0x1A0DE704)},
    {"droads58.ubn", "", int32_t(0x00000000), int32_t(0xCD874A4E)},
    {"droads58.urb", "", int32_t(0x00000000), int32_t(0x8EF31434)},
    {"droads59.des", "", int32_t(0x00000000), int32_t(0xC14450A7)},
    {"droads59.sno", "-", int32_t(0x00000000), int32_t(0x2FD860D6)},
    {"droads59.tem", "-", int32_t(0x00000000), int32_t(0x276DCEB4)},
    {"droads59.ubn", "", int32_t(0x00000000), int32_t(0xF0E763FE)},
    {"droads59.urb", "", int32_t(0x00000000), int32_t(0xB3933D84)},
    {"droads60.des", "", int32_t(0x00000000), int32_t(0x4AC04078)},
    {"droads60.sno", "-", int32_t(0x00000000), int32_t(0xA45C7009)},
    {"droads60.tem", "-", int32_t(0x00000000), int32_t(0xACE9DE6B)},
    {"droads60.ubn", "", int32_t(0x00000000), int32_t(0x7B637321)},
    {"droads60.urb", "", int32_t(0x00000000), int32_t(0x38172D5B)},
    {"droads61.des", "", int32_t(0x00000000), int32_t(0x77A069C8)},
    {"droads61.sno", "-", int32_t(0x00000000), int32_t(0x993C59B9)},
    {"droads61.tem", "-", int32_t(0x00000000), int32_t(0x9189F7DB)},
    {"droads61.ubn", "", int32_t(0x00000000), int32_t(0x46035A91)},
    {"droads61.urb", "", int32_t(0x00000000), int32_t(0x057704EB)},
    {"droads62.des", "", int32_t(0x00000000), int32_t(0x30001318)},
    {"droads62.sno", "-", int32_t(0x00000000), int32_t(0xDE9C2369)},
    {"droads62.tem", "-", int32_t(0x00000000), int32_t(0xD6298D0B)},
    {"droads62.ubn", "", int32_t(0x00000000), int32_t(0x01A32041)},
    {"droads62.urb", "", int32_t(0x00000000), int32_t(0x42D77E3B)},
    {"droads63.des", "", int32_t(0x00000000), int32_t(0x0D603AA8)},
    {"droads63.sno", "-", int32_t(0x00000000), int32_t(0xE3FC0AD9)},
    {"droads63.tem", "-", int32_t(0x00000000), int32_t(0xEB49A4BB)},
    {"droads63.ubn", "", int32_t(0x00000000), int32_t(0x3CC309F1)},
    {"droads63.urb", "", int32_t(0x00000000), int32_t(0x7FB7578B)},
    {"droads64.des", "", int32_t(0x00000000), int32_t(0xBF40E6B8)},
    {"droads64.sno", "-", int32_t(0x00000000), int32_t(0x51DCD6C9)},
    {"droads64.tem", "-", int32_t(0x00000000), int32_t(0x596978AB)},
    {"droads64.ubn", "", int32_t(0x00000000), int32_t(0x8EE3D5E1)},
    {"droads64.urb", "", int32_t(0x00000000), int32_t(0xCD978B9B)},
    {"droads65.des", "", int32_t(0x00000000), int32_t(0x8220CF08)},
    {"droads65.sno", "-", int32_t(0x00000000), int32_t(0x6CBCFF79)},
    {"droads65.tem", "-", int32_t(0x00000000), int32_t(0x6409511B)},
    {"droads65.ubn", "", int32_t(0x00000000), int32_t(0xB383FC51)},
    {"droads65.urb", "", int32_t(0x00000000), int32_t(0xF0F7A22B)},
    {"droads66.des", "", int32_t(0x00000000), int32_t(0xC580B5D8)},
    {"droads66.sno", "-", int32_t(0x00000000), int32_t(0x2B1C85A9)},
    {"droads66.tem", "-", int32_t(0x00000000), int32_t(0x23A92BCB)},
    {"droads66.ubn", "", int32_t(0x00000000), int32_t(0xF4238681)},
    {"droads66.urb", "", int32_t(0x00000000), int32_t(0xB757D8FB)},
    {"drok.wav", "", int32_t(0x00000000), int32_t(0xEFE650BC)},
    {"dron.shp", "", int32_t(0x00000000), int32_t(0x18AE696C)},
    {"dron226m.aud", "drone", int32_t(0x17FEEEA3), int32_t(0x00000000)},
    {"dronicon.shp", "", int32_t(0x00000000), int32_t(0x36A39E13)},
    {"dronp.shp", "", int32_t(0x00000000), int32_t(0x22A11B5E)},
    {"drop0001.shp", "-", int32_t(0x00000000), int32_t(0xBDC88FF7)},
    {"drop0002.shp", "-", int32_t(0x00000000), int32_t(0xFA68F527)},
    {"drop0003.shp", "-", int32_t(0x00000000), int32_t(0xC708DC97)},
    {"dropbutton.shp", "", int32_t(0x00000000), int32_t(0xBA0D44C6)},
    {"dropdown.shp", "-", int32_t(0x00000000), int32_t(0xE181F8A3)},
    {"dropdwn1.aud", "dropship lands", int32_t(0x00000000), int32_t(0x10FFC138)},
    {"dropexp.shp", "-", int32_t(0x00000000), int32_t(0xF23AB14F)},
    {"dropglas.aud", "", int32_t(0x2C1522CD), int32_t(0x00000000)},
    {"dropland.shp", "-", int32_t(0x00000000), int32_t(0x0C32D3B9)},
    {"droppod.shp", "unit: droppod (dropping from right)", int32_t(0x00000000), int32_t(0xFC5F6CCD)},
    {"droppod2.shp", "unit: droppod (dropping from left)", int32_t(0x00000000), int32_t(0xA010BA89)},
    {"droppody.shp", "-", int32_t(0x00000000), int32_t(0x4EF2FCD5)},
    {"droppody2.shp", "-", int32_t(0x00000000), int32_t(0xBFCB210A)},
    {"dropship.pal", "dropship palette", int32_t(0x00000000), int32_t(0x73D1ED48)},
    {"dropup.shp", "-", int32_t(0x00000000), int32_t(0x71AA0354)},
    {"dropup1.aud", "dropship takes off", int32_t(0x00000000), int32_t(0xBE866A9E)},
    {"drown.flc", "", int32_t(0xF5C9A5F0), int32_t(0x00000000)},
    {"drown1.aud", "", int32_t(0xDF99F002), int32_t(0x00000000)},
    {"drown2.aud", "", int32_t(0xDF99F202), int32_t(0x00000000)},
    {"drown3.aud", "", int32_t(0xDF99F402), int32_t(0x00000000)},
    {"drownsnd.flc", "", int32_t(0x292635DB), int32_t(0x00000000)},
    {"drrain1.aud", "", int32_t(0x61F03AE4), int32_t(0x00000000)},
    {"drslpe01.des", "", int32_t(0x00000000), int32_t(0x91DB9AC1)},
    {"drslpe01.sno", "-", int32_t(0x00000000), int32_t(0x7F47AAB0)},
    {"drslpe01.tem", "-", int32_t(0x00000000), int32_t(0x77F204D2)},
    {"drslpe01.ubn", "", int32_t(0x00000000), int32_t(0xA078A998)},
    {"drslpe01.urb", "", int32_t(0x00000000), int32_t(0xE30CF7E2)},
    {"drslpe02.des", "", int32_t(0x00000000), int32_t(0xD67BE011)},
    {"drslpe02.sno", "-", int32_t(0x00000000), int32_t(0x38E7D060)},
    {"drslpe02.tem", "-", int32_t(0x00000000), int32_t(0x30527E02)},
    {"drslpe02.ubn", "", int32_t(0x00000000), int32_t(0xE7D8D348)},
    {"drslpe02.urb", "", int32_t(0x00000000), int32_t(0xA4AC8D32)},
    {"drslpe03.des", "", int32_t(0x00000000), int32_t(0xEB1BC9A1)},
    {"drslpe03.sno", "-", int32_t(0x00000000), int32_t(0x0587F9D0)},
    {"drslpe03.tem", "-", int32_t(0x00000000), int32_t(0x0D3257B2)},
    {"drslpe03.ubn", "", int32_t(0x00000000), int32_t(0xDAB8FAF8)},
    {"drslpe03.urb", "", int32_t(0x00000000), int32_t(0x99CCA482)},
    {"drslpe04.des", "", int32_t(0x00000000), int32_t(0x593B15B1)},
    {"drslpe04.sno", "-", int32_t(0x00000000), int32_t(0xB7A725C0)},
    {"drslpe04.tem", "-", int32_t(0x00000000), int32_t(0xBF128BA2)},
    {"drslpe04.ubn", "", int32_t(0x00000000), int32_t(0x689826E8)},
    {"drslpe04.urb", "", int32_t(0x00000000), int32_t(0x2BEC7892)},
    {"drslpe05.des", "", int32_t(0x00000000), int32_t(0x645B3C01)},
    {"drslpe05.sno", "-", int32_t(0x00000000), int32_t(0x8AC70C70)},
    {"drslpe05.tem", "-", int32_t(0x00000000), int32_t(0x8272A212)},
    {"drslpe05.ubn", "", int32_t(0x00000000), int32_t(0x55F80F58)},
    {"drslpe05.urb", "", int32_t(0x00000000), int32_t(0x168C5122)},
    {"drslpe06.des", "", int32_t(0x00000000), int32_t(0x23FB46D1)},
    {"drslpe06.sno", "-", int32_t(0x00000000), int32_t(0xCD6776A0)},
    {"drslpe06.tem", "-", int32_t(0x00000000), int32_t(0xC5D2D8C2)},
    {"drslpe06.ubn", "", int32_t(0x00000000), int32_t(0x12587588)},
    {"drslpe06.urb", "", int32_t(0x00000000), int32_t(0x512C2BF2)},
    {"drslpe07.des", "", int32_t(0x00000000), int32_t(0x1E9B6F61)},
    {"drslpe07.sno", "-", int32_t(0x00000000), int32_t(0xF0075F10)},
    {"drslpe07.tem", "-", int32_t(0x00000000), int32_t(0xF8B2F172)},
    {"drslpe07.ubn", "", int32_t(0x00000000), int32_t(0x2F385C38)},
    {"drslpe07.urb", "", int32_t(0x00000000), int32_t(0x6C4C0242)},
    {"drslpe08.des", "", int32_t(0x00000000), int32_t(0x9CCBF8B0)},
    {"drslpe08.sno", "-", int32_t(0x00000000), int32_t(0x7257C8C1)},
    {"drslpe08.tem", "-", int32_t(0x00000000), int32_t(0x7AE266A3)},
    {"drslpe08.ubn", "", int32_t(0x00000000), int32_t(0xAD68CBE9)},
    {"drslpe08.urb", "", int32_t(0x00000000), int32_t(0xEE1C9593)},
    {"drugout.aud", "", int32_t(0x7A4248F0), int32_t(0x00000000)},
    {"drum.bnk", "", int32_t(0xE5F8E6B6), int32_t(0x00000000)},
    {"drum01.shp", "oil container", int32_t(0x00000000), int32_t(0xA9635EDD)},
    {"drum02.shp", "oil container", int32_t(0x00000000), int32_t(0x988B4440)},
    {"dryheat.map", "", int32_t(0x00000000), int32_t(0x195220A1)},
    {"dryheatmw.map", "", int32_t(0x00000000), int32_t(0x7337AF5D)},
    {"dsaping1.aud", "deployable sensor array ping", int32_t(0x00000000), int32_t(0x81F4B34F)},
    {"dscent_e.vqa", "", int32_t(0xE11D4BDB), int32_t(0x00000000)},
    {"dshade.mrf", "???", int32_t(0x9F7E1DEB), int32_t(0x00000000)},
    {"dshadow.mrf", "???", int32_t(0x62163DE6), int32_t(0x00000000)},
    {"dshp.hva", "-", int32_t(0x00000000), int32_t(0xD28E283F)},
    {"dshp.vxl", "dropship", int32_t(0x00000000), int32_t(0x2404F776)},
    {"dshpbarl.hva", "-", int32_t(0x00000000), int32_t(0xD00CDFAF)},
    {"dshptur.hva", "-", int32_t(0x00000000), int32_t(0x8F1FF97C)},
    {"dtrans.mrf", "???", int32_t(0x9FA63DFF), int32_t(0x00000000)},
    {"dtrk.shp", "unit: demo truck", int32_t(0xE6ECFBB6), int32_t(0x00000000)},
    {"dtrkicon.shp", "icon: demo truck", int32_t(0x1A302AD1), int32_t(0x00000000)},
    {"dtunn01.des", "", int32_t(0x00000000), int32_t(0x86A19E53)},
    {"dtunn01.sno", "-", int32_t(0x00000000), int32_t(0xA14D43C9)},
    {"dtunn01.tem", "-", int32_t(0x00000000), int32_t(0x02F9F613)},
    {"dtunn01.ubn", "", int32_t(0x00000000), int32_t(0x9427D430)},
    {"dtunn01.urb", "", int32_t(0x00000000), int32_t(0x24B4384C)},
    {"dtunn02.des", "", int32_t(0x00000000), int32_t(0x0035ECFD)},
    {"dtunn02.sno", "-", int32_t(0x00000000), int32_t(0x27D93167)},
    {"dtunn02.tem", "-", int32_t(0x00000000), int32_t(0x846D84BD)},
    {"dtunn02.ubn", "", int32_t(0x00000000), int32_t(0x12B3A69E)},
    {"dtunn02.urb", "", int32_t(0x00000000), int32_t(0xA2204AE2)},
    {"dtunn03.des", "", int32_t(0x00000000), int32_t(0xCB693F58)},
    {"dtunn03.sno", "-", int32_t(0x00000000), int32_t(0xEC85E2C2)},
    {"dtunn03.tem", "-", int32_t(0x00000000), int32_t(0x4F315718)},
    {"dtunn03.ubn", "", int32_t(0x00000000), int32_t(0xD9EF753B)},
    {"dtunn03.urb", "", int32_t(0x00000000), int32_t(0x697C9947)},
    {"dtunn04.des", "", int32_t(0x00000000), int32_t(0xD66C0FE0)},
    {"dtunn04.sno", "-", int32_t(0x00000000), int32_t(0xF180D27A)},
    {"dtunn04.tem", "-", int32_t(0x00000000), int32_t(0x523467A0)},
    {"dtunn04.ubn", "", int32_t(0x00000000), int32_t(0xC4EA4583)},
    {"dtunn04.urb", "", int32_t(0x00000000), int32_t(0x7479A9FF)},
    {"dtunnt01.des", "", int32_t(0x00000000), int32_t(0xF21EBC20)},
    {"dtunnt01.sno", "-", int32_t(0x00000000), int32_t(0x1C828C51)},
    {"dtunnt01.tem", "-", int32_t(0x00000000), int32_t(0x14372233)},
    {"dtunnt02.des", "", int32_t(0x00000000), int32_t(0xB5BEC6F0)},
    {"dtunnt02.sno", "-", int32_t(0x00000000), int32_t(0x5B22F681)},
    {"dtunnt02.tem", "-", int32_t(0x00000000), int32_t(0x539758E3)},
    {"dtunnt03.des", "", int32_t(0x00000000), int32_t(0x88DEEF40)},
    {"dtunnt03.sno", "-", int32_t(0x00000000), int32_t(0x6642DF31)},
    {"dtunnt03.tem", "-", int32_t(0x00000000), int32_t(0x6EF77153)},
    {"dtunnt04.des", "", int32_t(0x00000000), int32_t(0x3AFE3350)},
    {"dtunnt04.sno", "-", int32_t(0x00000000), int32_t(0xD4620321)},
    {"dtunnt04.tem", "-", int32_t(0x00000000), int32_t(0xDCD7AD43)},
    {"dud.vqa", "dud missile in london", int32_t(0x5CC9FBDE), int32_t(0x00000000)},
    {"dud.vqp", "vqp: dud missile in london", int32_t(0x5CD8FBDE), int32_t(0x00000000)},
    {"duel.ini", "", int32_t(0x00000000), int32_t(0x25D20E04)},
    {"duel.map", "-", int32_t(0x00000000), int32_t(0xC12812D7)},
    {"dummy.wav", "", int32_t(0x00000000), int32_t(0x257E8406)},
    {"dunepatr.map", "", int32_t(0x00000000), int32_t(0x8D1FF8B2)},
    {"dunits.mrf", "???", int32_t(0xBF96420B), int32_t(0x00000000)},
    {"durasmoke.shp", "", int32_t(0x00000000), int32_t(0x6FA27FC0)},
    {"dusk.ini", "-", int32_t(0x00000000), int32_t(0x427D3392)},
    {"duskhour.aud", "dusk hour", int32_t(0x00000000), int32_t(0x9EDE5152)},
    {"dwhite.mrf", "???", int32_t(0xBF7E2E0B), int32_t(0x00000000)},
    {"dyellow.mrf", "???", int32_t(0x8E0A55F6), int32_t(0x00000000)},
    {"e-bwtocl.wsa", "anim: spinning earth", int32_t(0x36E2AAEB), int32_t(0x00000000)},
    {"e-esper.vqa", "", int32_t(0xA9FA910B), int32_t(0x00000000)},
    {"e.aud", "", int32_t(0xAA825CCE), int32_t(0x00000000)},
    {"e01sc01.mix", "-", int32_t(0x00000000), int32_t(0x74694C5E)},
    {"e01sc02.mix", "-", int32_t(0x00000000), int32_t(0xF2FD3EF0)},
    {"e01vox01.mix", "-", int32_t(0x00000000), int32_t(0x791E9677)},
    {"e01vox02.mix", "-", int32_t(0x00000000), int32_t(0x3EBEECA7)},
    {"e029e.csv", "", int32_t(0x8B4F1DF5), int32_t(0x00000000)},
    {"e029e.lsv", "", int32_t(0x8B611DF5), int32_t(0x00000000)},
    {"e029e.vqa", "", int32_t(0x87751DE0), int32_t(0x00000000)},
    {"e029e_e.vqa", "", int32_t(0x4194D0F5), int32_t(0x00000000)},
    {"e029e_e.vqt", "", int32_t(0x41A7D0F5), int32_t(0x00000000)},
    {"e029e_h.pcx", "", int32_t(0x41B1C2EF), int32_t(0x00000000)},
    {"e029e_h.vqa", "", int32_t(0x419AD0F5), int32_t(0x00000000)},
    {"e029e_l.pcx", "", int32_t(0x41B9C2EF), int32_t(0x00000000)},
    {"e029e_l.vqa", "", int32_t(0x41A2D0F5), int32_t(0x00000000)},
    {"e030e.csv", "", int32_t(0x67531DF5), int32_t(0x00000000)},
    {"e030e.lsv", "", int32_t(0x67651DF5), int32_t(0x00000000)},
    {"e030e.vqa", "", int32_t(0x63791DE0), int32_t(0x00000000)},
    {"e030e_e.vqa", "", int32_t(0x1D98D0F5), int32_t(0x00000000)},
    {"e030e_e.vqt", "", int32_t(0x1DABD0F5), int32_t(0x00000000)},
    {"e030e_h.pcx", "", int32_t(0x1DB5C2EF), int32_t(0x00000000)},
    {"e030e_h.vqa", "", int32_t(0x1D9ED0F5), int32_t(0x00000000)},
    {"e030e_l.pcx", "", int32_t(0x1DBDC2EF), int32_t(0x00000000)},
    {"e030e_l.vqa", "", int32_t(0x1DA6D0F5), int32_t(0x00000000)},
    {"e031e.csv", "", int32_t(0x6B531DF5), int32_t(0x00000000)},
    {"e031e.lsv", "", int32_t(0x6B651DF5), int32_t(0x00000000)},
    {"e031e.vqa", "", int32_t(0x67791DE0), int32_t(0x00000000)},
    {"e031e_e.vqa", "", int32_t(0x2198D0F5), int32_t(0x00000000)},
    {"e031e_e.vqt", "", int32_t(0x21ABD0F5), int32_t(0x00000000)},
    {"e031e_h.pcx", "", int32_t(0x21B5C2EF), int32_t(0x00000000)},
    {"e031e_h.vqa", "", int32_t(0x219ED0F5), int32_t(0x00000000)},
    {"e031e_l.pcx", "", int32_t(0x21BDC2EF), int32_t(0x00000000)},
    {"e031e_l.vqa", "", int32_t(0x21A6D0F5), int32_t(0x00000000)},
    {"e032e.csv", "", int32_t(0x6F531DF5), int32_t(0x00000000)},
    {"e032e.lsv", "", int32_t(0x6F651DF5), int32_t(0x00000000)},
    {"e032e.vqa", "", int32_t(0x6B791DE0), int32_t(0x00000000)},
    {"e032e_e.vqa", "", int32_t(0x2598D0F5), int32_t(0x00000000)},
    {"e032e_e.vqt", "", int32_t(0x25ABD0F5), int32_t(0x00000000)},
    {"e032e_h.pcx", "", int32_t(0x25B5C2EF), int32_t(0x00000000)},
    {"e032e_h.vqa", "", int32_t(0x259ED0F5), int32_t(0x00000000)},
    {"e032e_l.pcx", "", int32_t(0x25BDC2EF), int32_t(0x00000000)},
    {"e032e_l.vqa", "", int32_t(0x25A6D0F5), int32_t(0x00000000)},
    {"e033e.csv", "", int32_t(0x73531DF5), int32_t(0x00000000)},
    {"e033e.lsv", "", int32_t(0x73651DF5), int32_t(0x00000000)},
    {"e033e.vqa", "", int32_t(0x6F791DE0), int32_t(0x00000000)},
    {"e033e_e.vqa", "", int32_t(0x2998D0F5), int32_t(0x00000000)},
    {"e033e_e.vqt", "", int32_t(0x29ABD0F5), int32_t(0x00000000)},
    {"e033e_h.pcx", "", int32_t(0x29B5C2EF), int32_t(0x00000000)},
    {"e033e_h.vqa", "", int32_t(0x299ED0F5), int32_t(0x00000000)},
    {"e033e_l.pcx", "", int32_t(0x29BDC2EF), int32_t(0x00000000)},
    {"e033e_l.vqa", "", int32_t(0x29A6D0F5), int32_t(0x00000000)},
    {"e068e.csv", "", int32_t(0x875F1DF5), int32_t(0x00000000)},
    {"e068e.lsv", "", int32_t(0x87711DF5), int32_t(0x00000000)},
    {"e068e.vqa", "", int32_t(0x83851DE0), int32_t(0x00000000)},
    {"e068e_e.vqa", "", int32_t(0x3DA4D0F5), int32_t(0x00000000)},
    {"e068e_e.vqt", "", int32_t(0x3DB7D0F5), int32_t(0x00000000)},
    {"e068e_h.pcx", "", int32_t(0x3DC1C2EF), int32_t(0x00000000)},
    {"e068e_h.vqa", "", int32_t(0x3DAAD0F5), int32_t(0x00000000)},
    {"e068e_l.pcx", "", int32_t(0x3DC9C2EF), int32_t(0x00000000)},
    {"e068e_l.vqa", "", int32_t(0x3DB2D0F5), int32_t(0x00000000)},
    {"e069e.csv", "", int32_t(0x8B5F1DF5), int32_t(0x00000000)},
    {"e069e.lsv", "", int32_t(0x8B711DF5), int32_t(0x00000000)},
    {"e069e.vqa", "", int32_t(0x87851DE0), int32_t(0x00000000)},
    {"e069e_e.vqa", "", int32_t(0x41A4D0F5), int32_t(0x00000000)},
    {"e069e_e.vqt", "", int32_t(0x41B7D0F5), int32_t(0x00000000)},
    {"e069e_h.pcx", "", int32_t(0x41C1C2EF), int32_t(0x00000000)},
    {"e069e_h.vqa", "", int32_t(0x41AAD0F5), int32_t(0x00000000)},
    {"e069e_l.pcx", "", int32_t(0x41C9C2EF), int32_t(0x00000000)},
    {"e069e_l.vqa", "", int32_t(0x41B2D0F5), int32_t(0x00000000)},
    {"e1.shp", "minigunner", int32_t(0xA65CB2D2), int32_t(0x30739919)},
    {"e125e.csv", "", int32_t(0x7B4F21F5), int32_t(0x00000000)},
    {"e125e.lsv", "", int32_t(0x7B6121F5), int32_t(0x00000000)},
    {"e125e.vqa", "", int32_t(0x777521E0), int32_t(0x00000000)},
    {"e125e_e.vqa", "", int32_t(0x3194D4F5), int32_t(0x00000000)},
    {"e125e_e.vqt", "", int32_t(0x31A7D4F5), int32_t(0x00000000)},
    {"e125e_h.pcx", "", int32_t(0x31B1C6EF), int32_t(0x00000000)},
    {"e125e_h.vqa", "", int32_t(0x319AD4F5), int32_t(0x00000000)},
    {"e125e_l.pcx", "", int32_t(0x31B9C6EF), int32_t(0x00000000)},
    {"e125e_l.vqa", "", int32_t(0x31A2D4F5), int32_t(0x00000000)},
    {"e198e.csv", "", int32_t(0x876B21F5), int32_t(0x00000000)},
    {"e198e.lsv", "", int32_t(0x877D21F5), int32_t(0x00000000)},
    {"e198e.vqa", "", int32_t(0x839121E0), int32_t(0x00000000)},
    {"e198e_e.vqa", "", int32_t(0x3DB0D4F5), int32_t(0x00000000)},
    {"e198e_e.vqt", "", int32_t(0x3DC3D4F5), int32_t(0x00000000)},
    {"e198e_h.pcx", "", int32_t(0x3DCDC6EF), int32_t(0x00000000)},
    {"e198e_h.vqa", "", int32_t(0x3DB6D4F5), int32_t(0x00000000)},
    {"e198e_l.pcx", "", int32_t(0x3DD5C6EF), int32_t(0x00000000)},
    {"e198e_l.vqa", "", int32_t(0x3DBED4F5), int32_t(0x00000000)},
    {"e1icnh.des", "icon: minigunner", int32_t(0x9581A8F6), int32_t(0x00000000)},
    {"e1icnh.tem", "icon: minigunner", int32_t(0xB581A2F6), int32_t(0x00000000)},
    {"e1icnh.win", "icon: minigunner", int32_t(0xBB81A3FA), int32_t(0x00000000)},
    {"e1icon.shp", "icon: minigunner", int32_t(0xB381B1FB), int32_t(0x61F07B81)},
    {"e1rot.shp", "minigunner death", int32_t(0xCDEF220D), int32_t(0x00000000)},
    {"e1uico.shp", "", int32_t(0x00000000), int32_t(0x38948E82)},
    {"e2.shp", "grenadier", int32_t(0xA65CB4D2), int32_t(0x019B8384)},
    {"e232e.csv", "", int32_t(0x6F5325F5), int32_t(0x00000000)},
    {"e232e.lsv", "", int32_t(0x6F6525F5), int32_t(0x00000000)},
    {"e232e.vqa", "", int32_t(0x6B7925E0), int32_t(0x00000000)},
    {"e232e_e.vqa", "", int32_t(0x2598D8F5), int32_t(0x00000000)},
    {"e232e_e.vqt", "", int32_t(0x25ABD8F5), int32_t(0x00000000)},
    {"e232e_h.pcx", "", int32_t(0x25B5CAEF), int32_t(0x00000000)},
    {"e232e_h.vqa", "", int32_t(0x259ED8F5), int32_t(0x00000000)},
    {"e232e_l.pcx", "", int32_t(0x25BDCAEF), int32_t(0x00000000)},
    {"e232e_l.vqa", "", int32_t(0x25A6D8F5), int32_t(0x00000000)},
    {"e233e.csv", "", int32_t(0x735325F5), int32_t(0x00000000)},
    {"e233e.lsv", "", int32_t(0x736525F5), int32_t(0x00000000)},
    {"e233e.vqa", "", int32_t(0x6F7925E0), int32_t(0x00000000)},
    {"e233e_e.vqa", "", int32_t(0x2998D8F5), int32_t(0x00000000)},
    {"e233e_e.vqt", "", int32_t(0x29ABD8F5), int32_t(0x00000000)},
    {"e233e_h.pcx", "", int32_t(0x29B5CAEF), int32_t(0x00000000)},
    {"e233e_h.vqa", "", int32_t(0x299ED8F5), int32_t(0x00000000)},
    {"e233e_l.pcx", "", int32_t(0x29BDCAEF), int32_t(0x00000000)},
    {"e233e_l.vqa", "", int32_t(0x29A6D8F5), int32_t(0x00000000)},
    {"e242e.csv", "", int32_t(0x6F5725F5), int32_t(0x00000000)},
    {"e242e.lsv", "", int32_t(0x6F6925F5), int32_t(0x00000000)},
    {"e242e.vqa", "", int32_t(0x6B7D25E0), int32_t(0x00000000)},
    {"e242e_e.vqa", "", int32_t(0x259CD8F5), int32_t(0x00000000)},
    {"e242e_e.vqt", "", int32_t(0x25AFD8F5), int32_t(0x00000000)},
    {"e242e_h.pcx", "", int32_t(0x25B9CAEF), int32_t(0x00000000)},
    {"e242e_h.vqa", "", int32_t(0x25A2D8F5), int32_t(0x00000000)},
    {"e242e_l.pcx", "", int32_t(0x25C1CAEF), int32_t(0x00000000)},
    {"e242e_l.vqa", "", int32_t(0x25AAD8F5), int32_t(0x00000000)},
    {"e243e.csv", "", int32_t(0x735725F5), int32_t(0x00000000)},
    {"e243e.lsv", "", int32_t(0x736925F5), int32_t(0x00000000)},
    {"e243e.vqa", "", int32_t(0x6F7D25E0), int32_t(0x00000000)},
    {"e243e_e.vqa", "", int32_t(0x299CD8F5), int32_t(0x00000000)},
    {"e243e_e.vqt", "", int32_t(0x29AFD8F5), int32_t(0x00000000)},
    {"e243e_h.pcx", "", int32_t(0x29B9CAEF), int32_t(0x00000000)},
    {"e243e_h.vqa", "", int32_t(0x29A2D8F5), int32_t(0x00000000)},
    {"e243e_l.pcx", "", int32_t(0x29C1CAEF), int32_t(0x00000000)},
    {"e243e_l.vqa", "", int32_t(0x29AAD8F5), int32_t(0x00000000)},
    {"e244e.csv", "", int32_t(0x775725F5), int32_t(0x00000000)},
    {"e244e.lsv", "", int32_t(0x776925F5), int32_t(0x00000000)},
    {"e244e.vqa", "", int32_t(0x737D25E0), int32_t(0x00000000)},
    {"e244e_e.vqa", "", int32_t(0x2D9CD8F5), int32_t(0x00000000)},
    {"e244e_e.vqt", "", int32_t(0x2DAFD8F5), int32_t(0x00000000)},
    {"e244e_h.pcx", "", int32_t(0x2DB9CAEF), int32_t(0x00000000)},
    {"e244e_h.vqa", "", int32_t(0x2DA2D8F5), int32_t(0x00000000)},
    {"e244e_l.pcx", "", int32_t(0x2DC1CAEF), int32_t(0x00000000)},
    {"e244e_l.vqa", "", int32_t(0x2DAAD8F5), int32_t(0x00000000)},
    {"e2icnh.des", "icon: grenadier", int32_t(0x9581ACF6), int32_t(0x00000000)},
    {"e2icnh.tem", "icon: grenadier", int32_t(0xB581A6F6), int32_t(0x00000000)},
    {"e2icnh.win", "icon: grenadier", int32_t(0xBB81A7FA), int32_t(0x00000000)},
    {"e2icon.shp", "icon: grenadier", int32_t(0xB381B5FB), int32_t(0xF8121D80)},
    {"e2rot.shp", "grenadier death", int32_t(0xCDEF260D), int32_t(0x00000000)},
    {"e2uico.shp", "", int32_t(0x00000000), int32_t(0xA176E883)},
    {"e3.shp", "rocket soldier", int32_t(0xA65CB6D2), int32_t(0xA7EC8830)},
    {"e31.map", "", int32_t(0x00000000), int32_t(0x179782BB)},
    {"e32.map", "", int32_t(0x00000000), int32_t(0x9103F015)},
    {"e3icnh.des", "icon: rocket soldier", int32_t(0x9581B0F6), int32_t(0x00000000)},
    {"e3icnh.tem", "icon: rocket soldier", int32_t(0xB581AAF6), int32_t(0x00000000)},
    {"e3icnh.win", "icon: rocket soldier", int32_t(0xBB81ABFA), int32_t(0x00000000)},
    {"e3icon.shp", "icon: rocket soldier", int32_t(0xB381B9FB), int32_t(0x00000000)},
    {"e3rot.shp", "rocket soldier death", int32_t(0xCDEF2A0D), int32_t(0x00000000)},
    {"e4.shp", "flamer", int32_t(0xA65CB8D2), int32_t(0x624BB6BE)},
    {"e4icnh.des", "icon: flamer", int32_t(0x9581B4F6), int32_t(0x00000000)},
    {"e4icnh.tem", "icon: flamer", int32_t(0xB581AEF6), int32_t(0x00000000)},
    {"e4icnh.win", "icon: flamer", int32_t(0xBB81AFFA), int32_t(0x00000000)},
    {"e4icon.shp", "icon: flamer", int32_t(0xB381BDFB), int32_t(0x10A7D7C3)},
    {"e4rot.shp", "flamer death", int32_t(0xCDEF2E0D), int32_t(0x00000000)},
    {"e5.shp", "chem warrior", int32_t(0xA65CBAD2), int32_t(0xC43CBD0A)},
    {"e5icnh.des", "icon: chem warrior", int32_t(0x9581B8F6), int32_t(0x00000000)},
    {"e5icnh.tem", "icon: chem warrior", int32_t(0xB581B2F6), int32_t(0x00000000)},
    {"e5icnh.win", "icon: chem warrior", int32_t(0xBB81B3FA), int32_t(0x00000000)},
    {"e5icon.shp", "icon: chem warrior", int32_t(0xB381C1FB), int32_t(0x00000000)},
    {"e6.shp", "engineer", int32_t(0xA65CBCD2), int32_t(0x00000000)},
    {"e6icnh.des", "icon: engineer", int32_t(0x9581BCF6), int32_t(0x00000000)},
    {"e6icnh.tem", "icon: engineer", int32_t(0xB581B6F6), int32_t(0x00000000)},
    {"e6icnh.win", "icon: engineer", int32_t(0xBB81B7FA), int32_t(0x00000000)},
    {"e6icon.shp", "icon: engineer", int32_t(0xB381C5FB), int32_t(0x00000000)},
    {"e7.shp", "unit: tanya", int32_t(0xA65CBED2), int32_t(0x00000000)},
    {"e7icon.shp", "icon: tanya", int32_t(0xB381C9FB), int32_t(0x00000000)},
    {"e_03.flc", "", int32_t(0xA9AD04B8), int32_t(0x00000000)},
    {"e_armgd1.aud", "", int32_t(0xEFE34CDD), int32_t(0x00000000)},
    {"e_armor1.aud", "", int32_t(0xEFFF5CDD), int32_t(0x00000000)},
    {"e_compas.shp", "", int32_t(0x33D870DD), int32_t(0x00000000)},
    {"e_drag.flc", "", int32_t(0xD56E4EE3), int32_t(0x00000000)},
    {"e_drk1.aud", "", int32_t(0xCB6E2400), int32_t(0x00000000)},
    {"e_enhn.shp", "-", int32_t(0x00000000), int32_t(0x82E4C87F)},
    {"e_heal1.aud", "", int32_t(0x71C86AD8), int32_t(0x00000000)},
    {"e_hello1.aud", "", int32_t(0xBC1556DB), int32_t(0x00000000)},
    {"e_int.shp", "", int32_t(0xC9CBDA0D), int32_t(0x00000000)},
    {"e_ion1.aud", "", int32_t(0xBF822406), int32_t(0x00000000)},
    {"e_jrn.shp", "", int32_t(0xD9CFDA01), int32_t(0x00000000)},
    {"e_loser1.aud", "", int32_t(0xE42B48E9), int32_t(0x00000000)},
    {"e_mapup1.aud", "", int32_t(0xAC2B68E3), int32_t(0x00000000)},
    {"e_megaa1.aud", "", int32_t(0xBC0D40D1), int32_t(0x00000000)},
    {"e_megarr.aud", "", int32_t(0xFE2F40D1), int32_t(0x00000000)},
    {"e_megas1.aud", "", int32_t(0xBC3140D1), int32_t(0x00000000)},
    {"e_megaw1.aud", "", int32_t(0xBC3940D1), int32_t(0x00000000)},
    {"e_mgarng.aud", "", int32_t(0xF02762C5), int32_t(0x00000000)},
    {"e_nuke1.aud", "", int32_t(0xB1E05CEC), int32_t(0x00000000)},
    {"e_option.trr", "", int32_t(0x302E63EB), int32_t(0x00000000)},
    {"e_radar1.aud", "", int32_t(0xAC4340CB), int32_t(0x00000000)},
    {"e_range1.aud", "", int32_t(0xAC294CDF), int32_t(0x00000000)},
    {"e_rapid1.aud", "", int32_t(0xAC2750E3), int32_t(0x00000000)},
    {"e_sorry1.aud", "", int32_t(0xE45562E7), int32_t(0x00000000)},
    {"e_speed1.aud", "", int32_t(0xE82B48CD), int32_t(0x00000000)},
    {"e_stlall.aud", "", int32_t(0x2E3B40DB), int32_t(0x00000000)},
    {"e_stltha.aud", "", int32_t(0x183366DB), int32_t(0x00000000)},
    {"e_stlthd.aud", "", int32_t(0x1E3366DB), int32_t(0x00000000)},
    {"e_telep1.aud", "", int32_t(0xBC4748DB), int32_t(0x00000000)},
    {"e_unit1.aud", "", int32_t(0x95FC7AE8), int32_t(0x00000000)},
    {"e_weapn1.aud", "", int32_t(0xBC4F5EC5), int32_t(0x00000000)},
    {"ea_wwlogo.bik", "", int32_t(0x00000000), int32_t(0x48113C24)},
    {"eaffirm1.aud", "engineer: affirmative!", int32_t(0xC008EAD5), int32_t(0x00000000)},
    {"eagle01.lun", "", int32_t(0x00000000), int32_t(0xB49C3833)},
    {"eaglehun.wav", "", int32_t(0x00000000), int32_t(0x6F7ECE2C)},
    {"earshi.kfr", "", int32_t(0xE3A5E9EB), int32_t(0x00000000)},
    {"earslow.kfr", "", int32_t(0xAA49E9F8), int32_t(0x00000000)},
    {"earth.shp", "crat: reveal map", int32_t(0xE1EF61F5), int32_t(0x00000000)},
    {"earth_a.wsa", "anim: zoom on africa", int32_t(0xAE0D16FC), int32_t(0x00000000)},
    {"earth_e.wsa", "anim: zoom on europe", int32_t(0xAE1516FC), int32_t(0x00000000)},
    {"eastvsbest.map", "", int32_t(0x00000000), int32_t(0x889A65C2)},
    {"eb1.map", "", int32_t(0x00000000), int32_t(0x5D885924)},
    {"eb2.map", "", int32_t(0x00000000), int32_t(0xDB1C2B8A)},
    {"eb3.map", "", int32_t(0x00000000), int32_t(0x1040F82F)},
    {"eb4.map", "", int32_t(0x00000000), int32_t(0x0D45C897)},
    {"eb5.map", "", int32_t(0x00000000), int32_t(0xC6191B32)},
    {"ebtn-dn.shp", "butt: down", int32_t(0x963DD9C2), int32_t(0xE689F448)},
    {"ebtn-up.shp", "butt: up", int32_t(0x9641FBC2), int32_t(0x1EFC00D9)},
    {"ecache01.mix", "-", int32_t(0x00000000), int32_t(0x020CD434)},
    {"ed_sizes.shp", "misc: map sizes", int32_t(0x445018D5), int32_t(0x00000000)},
    {"edbtn_c.shp", "butt: temperate default terrain", int32_t(0xADE01804), int32_t(0x00000000)},
    {"edbtn_cg.shp", "butt: temperate gems", int32_t(0x2FD822DF), int32_t(0x00000000)},
    {"edbtn_cm.shp", "butt: temperate ore", int32_t(0x3BD822DF), int32_t(0x00000000)},
    {"edbtn_cw.shp", "butt: temperate water", int32_t(0x4FD822DF), int32_t(0x00000000)},
    {"edbtn_ff.shp", "butt: forward", int32_t(0x2DDE22DF), int32_t(0x00000000)},
    {"edbtn_lt.shp", "butt: left arrow", int32_t(0x49EA22DF), int32_t(0x00000000)},
    {"edbtn_mx.shp", "butt: view all tiles", int32_t(0x51EC22DE), int32_t(0x00000000)},
    {"edbtn_rr.shp", "butt: backward", int32_t(0x45F622DF), int32_t(0x00000000)},
    {"edbtn_rt.shp", "butt: right arrow", int32_t(0x49F622DF), int32_t(0x00000000)},
    {"edbtn_s.shp", "butt: snow default terrain", int32_t(0xAE001804), int32_t(0x00000000)},
    {"edbtn_sg.shp", "butt: snow gems", int32_t(0x2FF822DF), int32_t(0x00000000)},
    {"edbtn_sm.shp", "butt: snow ore", int32_t(0x3BF822DF), int32_t(0x00000000)},
    {"edbtn_sp.shp", "butt: flags", int32_t(0x41F822DF), int32_t(0x00000000)},
    {"edbtn_sw.shp", "butt: snow water", int32_t(0x4FF822DF), int32_t(0x00000000)},
    {"edhi.mix", "edhi.mix", int32_t(0xEAD9D5B8), int32_t(0x00000000)},
    {"editfnt.fnt", "fnt:", int32_t(0xAE21FBE7), int32_t(0x691820F9)},
    {"editor.eng", "misc: english editor strings", int32_t(0xDB81FD01), int32_t(0x00000000)},
    {"editor.fre", "misc: french editor strings", int32_t(0xDD81FB05), int32_t(0x00000000)},
    {"editor.ger", "misc: german editor strings", int32_t(0xDF8207F8), int32_t(0x00000000)},
    {"editor.mix", "rmix: editor.mix", int32_t(0xEB820DFC), int32_t(0x00000000)},
    {"edits.shp", "", int32_t(0xE1CB6E0B), int32_t(0x00000000)},
    {"edlo.mix", "edlo.mix", int32_t(0xF6E1D5B8), int32_t(0x00000000)},
    {"edmouse.shp", "curs: editor mouse cursors", int32_t(0x9A100012), int32_t(0x00000000)},
    {"edoor1.aud", "", int32_t(0xBF99B80E), int32_t(0x00000000)},
    {"edoor2.aud", "", int32_t(0xBF99BA0E), int32_t(0x00000000)},
    {"edoor3.aud", "", int32_t(0xBF99BC0E), int32_t(0x00000000)},
    {"edoor4.aud", "", int32_t(0xBF99BE0E), int32_t(0x00000000)},
    {"edoor5.aud", "", int32_t(0xBF99C00E), int32_t(0x00000000)},
    {"edoor6c.aud", "", int32_t(0x9A07D2FA), int32_t(0x00000000)},
    {"edoor6o.aud", "", int32_t(0x9A1FD2FA), int32_t(0x00000000)},
    {"edtitle.cps", "pict: red alert map editor title screen", int32_t(0x822EFA00), int32_t(0x00000000)},
    {"edtitlef.cps", "pict: red alert map editor title screen french", int32_t(0x052BECEB), int32_t(0x00000000)},
    {"edtitleg.cps", "pict: red alert map editor title screen german", int32_t(0x072BECEB), int32_t(0x00000000)},
    {"eeback.pcx", "", int32_t(0x00000000), int32_t(0xF5EAC688)},
    {"eebackh.pcx", "", int32_t(0x00000000), int32_t(0x09F234CF)},
    {"eegr01.shp", "", int32_t(0x00000000), int32_t(0xE5291F8F)},
    {"eegr02.shp", "", int32_t(0x00000000), int32_t(0xD4C10512)},
    {"eegr03.shp", "", int32_t(0x00000000), int32_t(0x72B60EA6)},
    {"eegr04.shp", "", int32_t(0x00000000), int32_t(0xB7113028)},
    {"eegr05.shp", "", int32_t(0x00000000), int32_t(0x11663B9C)},
    {"eegr06.shp", "", int32_t(0x00000000), int32_t(0x208E2101)},
    {"eegr07.shp", "", int32_t(0x00000000), int32_t(0x86F92AB5)},
    {"eegr08.shp", "", int32_t(0x00000000), int32_t(0x70B15A5C)},
    {"eegr09.shp", "", int32_t(0x00000000), int32_t(0xD6C651E8)},
    {"eegr10.shp", "", int32_t(0x00000000), int32_t(0x8FF414A5)},
    {"eegr11.shp", "", int32_t(0x00000000), int32_t(0x29831F11)},
    {"eegr12.shp", "", int32_t(0x00000000), int32_t(0x186B058C)},
    {"eegr13.shp", "", int32_t(0x00000000), int32_t(0xBE1C0E38)},
    {"eegr14.shp", "", int32_t(0x00000000), int32_t(0x7BBB30B6)},
    {"eegr15.shp", "", int32_t(0x00000000), int32_t(0xDDCC3B02)},
    {"eegr16.shp", "", int32_t(0x00000000), int32_t(0xEC24219F)},
    {"eegr17.shp", "", int32_t(0x00000000), int32_t(0x4A532A2B)},
    {"eegr18.shp", "", int32_t(0x00000000), int32_t(0xBC1B5AC2)},
    {"eegr19.shp", "", int32_t(0x00000000), int32_t(0x1A6C5176)},
    {"eegr20.shp", "", int32_t(0x00000000), int32_t(0x017B1346)},
    {"eegr21.shp", "", int32_t(0x00000000), int32_t(0xA70C18F2)},
    {"eegr22.shp", "", int32_t(0x00000000), int32_t(0x96E4026F)},
    {"eegr23.shp", "", int32_t(0x00000000), int32_t(0x309309DB)},
    {"eegr24.shp", "", int32_t(0x00000000), int32_t(0xF5343755)},
    {"eegr25.shp", "", int32_t(0x00000000), int32_t(0x53433CE1)},
    {"eegr26.shp", "", int32_t(0x00000000), int32_t(0x62AB267C)},
    {"eegr27.shp", "", int32_t(0x00000000), int32_t(0xC4DC2DC8)},
    {"eegr28.shp", "", int32_t(0x00000000), int32_t(0x32945D21)},
    {"eegr29.shp", "", int32_t(0x00000000), int32_t(0x94E35695)},
    {"eegr30.shp", "", int32_t(0x00000000), int32_t(0xCDD113D8)},
    {"eengin1.aud", "engineer: engineering", int32_t(0x79E006E8), int32_t(0x00000000)},
    {"eenr01.shp", "", int32_t(0x00000000), int32_t(0x193C3445)},
    {"eenr02.shp", "", int32_t(0x00000000), int32_t(0x28D42ED8)},
    {"eenr03.shp", "", int32_t(0x00000000), int32_t(0x8EA3256C)},
    {"eenr04.shp", "", int32_t(0x00000000), int32_t(0x4B041BE2)},
    {"eenr05.shp", "", int32_t(0x00000000), int32_t(0xED731056)},
    {"eenr06.shp", "", int32_t(0x00000000), int32_t(0xDC9B0ACB)},
    {"eenr07.shp", "", int32_t(0x00000000), int32_t(0x7AEC017F)},
    {"eenr08.shp", "", int32_t(0x00000000), int32_t(0x8CA47196)},
    {"eenr09.shp", "", int32_t(0x00000000), int32_t(0x2AD37A22)},
    {"eenr10.shp", "", int32_t(0x00000000), int32_t(0x73E13F6F)},
    {"eenr11.shp", "", int32_t(0x00000000), int32_t(0xD59634DB)},
    {"eenr12.shp", "", int32_t(0x00000000), int32_t(0xE47E2E46)},
    {"eenr13.shp", "", int32_t(0x00000000), int32_t(0x420925F2)},
    {"eenr14.shp", "", int32_t(0x00000000), int32_t(0x87AE1B7C)},
    {"eenr15.shp", "", int32_t(0x00000000), int32_t(0x21D910C8)},
    {"eenr16.shp", "", int32_t(0x00000000), int32_t(0x10310A55)},
    {"eenr17.shp", "", int32_t(0x00000000), int32_t(0xB64601E1)},
    {"eenr18.shp", "", int32_t(0x00000000), int32_t(0x400E7108)},
    {"eenr19.shp", "", int32_t(0x00000000), int32_t(0xE6797ABC)},
    {"eenr20.shp", "", int32_t(0x00000000), int32_t(0xFD6E388C)},
    {"eenr21.shp", "", int32_t(0x00000000), int32_t(0x5B193338)},
    {"eenr22.shp", "", int32_t(0x00000000), int32_t(0x6AF129A5)},
    {"eenr23.shp", "", int32_t(0x00000000), int32_t(0xCC862211)},
    {"eenr24.shp", "", int32_t(0x00000000), int32_t(0x09211C9F)},
    {"eenr25.shp", "", int32_t(0x00000000), int32_t(0xAF56172B)},
    {"eenr26.shp", "", int32_t(0x00000000), int32_t(0x9EBE0DB6)},
    {"eenr27.shp", "", int32_t(0x00000000), int32_t(0x38C90602)},
    {"eenr28.shp", "", int32_t(0x00000000), int32_t(0xCE8176EB)},
    {"eenr29.shp", "", int32_t(0x00000000), int32_t(0x68F67D5F)},
    {"eenr30.shp", "", int32_t(0x00000000), int32_t(0x31C43812)},
    {"eerie1.aud", "", int32_t(0xA7A5BBF4), int32_t(0x00000000)},
    {"eerie2.aud", "", int32_t(0xA7A5BDF4), int32_t(0x00000000)},
    {"eerie3.aud", "", int32_t(0xA7A5BFF4), int32_t(0x00000000)},
    {"eerie4.aud", "", int32_t(0xA7A5C1F4), int32_t(0x00000000)},
    {"eerie5.aud", "", int32_t(0xA7A5C3F4), int32_t(0x00000000)},
    {"effector.csv", "", int32_t(0x100B04C9), int32_t(0x00000000)},
    {"efficien.aud", "-", int32_t(0x00000000), int32_t(0x45628CA9)},
    {"efic01.shp", "-", int32_t(0x00000000), int32_t(0xD9B91F0F)},
    {"efnt.fnt", "", int32_t(0x00000000), int32_t(0xED438FAD)},
    {"egopal.pal", "pal: ???", int32_t(0xE19A01D8), int32_t(0x00000000)},
    {"einah1.aud", "einstein: ah!", int32_t(0x8795CBFA), int32_t(0x00000000)},
    {"einit1.aud", "???", int32_t(0xA795CC12), int32_t(0x00000000)},
    {"einok1.aud", "einstein: incredible", int32_t(0xBF95CC00), int32_t(0x00000000)},
    {"eins.shp", "", int32_t(0x00000000), int32_t(0xE2F12150)},
    {"einstein.bmp", "", int32_t(0x00000000), int32_t(0xA0389034)},
    {"einstein.shp", "unit: einstein", int32_t(0x3A1402EB), int32_t(0x00000000)},
    {"einyes1.aud", "einstein: yes", int32_t(0xC1E020E0), int32_t(0x00000000)},
    {"elcad.shp", "-", int32_t(0x00000000), int32_t(0x78F0A872)},
    {"eldoorc1.aud", "", int32_t(0xE3ED16E1), int32_t(0x00000000)},
    {"eldooro2.aud", "", int32_t(0xE60516E1), int32_t(0x00000000)},
    {"eleamb3.aud", "", int32_t(0x61C00AF0), int32_t(0x00000000)},
    {"elebad1.aud", "", int32_t(0x65BC0ED8), int32_t(0x00000000)},
    {"elebutn1.aud", "", int32_t(0xB0071AED), int32_t(0x00000000)},
    {"elecbp1.aud", "", int32_t(0x69BC26DA), int32_t(0x00000000)},
    {"eleclab1.aud", "", int32_t(0xB3EEF4DB), int32_t(0x00000000)},
    {"electdog.shp", "misc: attack dog electro death", int32_t(0xEBFC0CEB), int32_t(0x00000000)},
    {"electro.shp", "infantry being electricuted", int32_t(0x00000000), int32_t(0xF1912225)},
    {"electro.sno", "misc: soldier electro death", int32_t(0x6A032410), int32_t(0x00000000)},
    {"electro.tem", "misc: soldier electro death", int32_t(0x6A011B11), int32_t(0x00000000)},
    {"electro1.aud", "", int32_t(0xB40916EB), int32_t(0x106A41CE)},
    {"eledown1.aud", "", int32_t(0xB80720E1), int32_t(0x00000000)},
    {"element1.aud", "", int32_t(0xDC130ECD), int32_t(0x00000000)},
    {"element2.aud", "", int32_t(0xDE130ECD), int32_t(0x00000000)},
    {"element3.aud", "", int32_t(0xE0130ECD), int32_t(0x00000000)},
    {"element4.aud", "", int32_t(0xE2130ECD), int32_t(0x00000000)},
    {"element5.aud", "", int32_t(0xE4130ECD), int32_t(0x00000000)},
    {"element6.aud", "", int32_t(0xE6130ECD), int32_t(0x00000000)},
    {"eleup1.aud", "", int32_t(0xD771D80A), int32_t(0x00000000)},
    {"elevat1.aud", "", int32_t(0xB5BC2ED8), int32_t(0x00000000)},
    {"elevat2.aud", "", int32_t(0xB5BE2ED8), int32_t(0x00000000)},
    {"elevat3.aud", "", int32_t(0xB5C02ED8), int32_t(0x00000000)},
    {"elevator.csv", "", int32_t(0x54071CC5), int32_t(0x00000000)},
    {"elevator.lsv", "", int32_t(0x540725C5), int32_t(0x00000000)},
    {"elevator.shp", "", int32_t(0x4DFC2CC5), int32_t(0x00000000)},
    {"elevator.vqa", "inside soviet elevator", int32_t(0x3F052FC5), int32_t(0x00000000)},
    {"elevator.vqp", "vqp: inside soviet elevator", int32_t(0x4E052FC5), int32_t(0x00000000)},
    {"elevator_e.vqa", "", int32_t(0xA7C47F3D), int32_t(0x00000000)},
    {"elevator_e.vqt", "", int32_t(0xA7C4923D), int32_t(0x00000000)},
    {"elevator_h.pcx", "", int32_t(0x9BC49C2F), int32_t(0x00000000)},
    {"elevator_h.vqa", "", int32_t(0xA7C4853D), int32_t(0x00000000)},
    {"elevator_l.pcx", "", int32_t(0x9BC4A42F), int32_t(0x00000000)},
    {"elevator_l.vqa", "", int32_t(0xA7C48D3D), int32_t(0x00000000)},
    {"elevfar1.aud", "", int32_t(0x000EF4CF), int32_t(0x00000000)},
    {"elevfar2.aud", "", int32_t(0x020EF4CF), int32_t(0x00000000)},
    {"elevfar3.aud", "", int32_t(0x040EF4CF), int32_t(0x00000000)},
    {"elevfar4.aud", "", int32_t(0x060EF4CF), int32_t(0x00000000)},
    {"elevnull.aud", "", int32_t(0x36031CDF), int32_t(0x00000000)},
    {"elspark1.aud", "", int32_t(0xE83916C5), int32_t(0x00000000)},
    {"elspark2.aud", "", int32_t(0xEA3916C5), int32_t(0x00000000)},
    {"elusive.aud", "-", int32_t(0x00000000), int32_t(0x08D5BA51)},
    {"ember1.aud", "", int32_t(0x9765DC0E), int32_t(0x00000000)},
    {"emblem.aud", "emblem", int32_t(0x00000000), int32_t(0xD2C3A513)},
    {"emote.shp", "", int32_t(0x00000000), int32_t(0x89BF909C)},
    {"emovout1.aud", "engineer: moving out!", int32_t(0x003B20E1), int32_t(0x00000000)},
    {"emp_fx01.shp", "emp effect displayed on units", int32_t(0x00000000), int32_t(0xC0197CB4)},
    {"empicon.shp", "-", int32_t(0x00000000), int32_t(0xDF9D2B4E)},
    {"emprtrlr.bik", "", int32_t(0x00000000), int32_t(0x87500336)},
    {"empulse.shp", "crat: hide map", int32_t(0xB21C2400), int32_t(0x00000000)},
    {"empulse.vqa", "-", int32_t(0x00000000), int32_t(0xF100C523)},
    {"end01a_e.vqa", "", int32_t(0x8D2111A5), int32_t(0x00000000)},
    {"end01a_f.vqa", "", int32_t(0x8F2111A5), int32_t(0x00000000)},
    {"end01a_g.vqa", "", int32_t(0x912111A5), int32_t(0x00000000)},
    {"end01a_i.vqa", "", int32_t(0x952111A5), int32_t(0x00000000)},
    {"end01a_s.vqa", "", int32_t(0xA92111A5), int32_t(0x00000000)},
    {"end01b_e.vqa", "", int32_t(0x8D2113A5), int32_t(0x00000000)},
    {"end01b_f.vqa", "", int32_t(0x8F2113A5), int32_t(0x00000000)},
    {"end01b_g.vqa", "", int32_t(0x912113A5), int32_t(0x00000000)},
    {"end01b_i.vqa", "", int32_t(0x952113A5), int32_t(0x00000000)},
    {"end01b_s.vqa", "", int32_t(0xA92113A5), int32_t(0x00000000)},
    {"end01c_e.vqa", "", int32_t(0x8D2115A5), int32_t(0x00000000)},
    {"end01c_f.vqa", "", int32_t(0x8F2115A5), int32_t(0x00000000)},
    {"end01c_g.vqa", "", int32_t(0x912115A5), int32_t(0x00000000)},
    {"end01c_i.vqa", "", int32_t(0x952115A5), int32_t(0x00000000)},
    {"end01c_s.vqa", "", int32_t(0xA92115A5), int32_t(0x00000000)},
    {"end01d_e.vqa", "", int32_t(0x8D2117A5), int32_t(0x00000000)},
    {"end01d_f.vqa", "", int32_t(0x8F2117A5), int32_t(0x00000000)},
    {"end01d_g.vqa", "", int32_t(0x912117A5), int32_t(0x00000000)},
    {"end01d_i.vqa", "", int32_t(0x952117A5), int32_t(0x00000000)},
    {"end01d_s.vqa", "", int32_t(0xA92117A5), int32_t(0x00000000)},
    {"end01e_e.vqa", "", int32_t(0x8D2119A5), int32_t(0x00000000)},
    {"end01e_f.vqa", "", int32_t(0x8F2119A5), int32_t(0x00000000)},
    {"end01e_g.vqa", "", int32_t(0x912119A5), int32_t(0x00000000)},
    {"end01e_i.vqa", "", int32_t(0x952119A5), int32_t(0x00000000)},
    {"end01e_s.vqa", "", int32_t(0xA92119A5), int32_t(0x00000000)},
    {"end01f_e.vqa", "", int32_t(0x8D211BA5), int32_t(0x00000000)},
    {"end01f_f.vqa", "", int32_t(0x8F211BA5), int32_t(0x00000000)},
    {"end01f_g.vqa", "", int32_t(0x91211BA5), int32_t(0x00000000)},
    {"end01f_i.vqa", "", int32_t(0x95211BA5), int32_t(0x00000000)},
    {"end01f_s.vqa", "", int32_t(0xA9211BA5), int32_t(0x00000000)},
    {"end02_e.vqa", "", int32_t(0x1DDD48CF), int32_t(0x00000000)},
    {"end02_f.vqa", "", int32_t(0x1DDF48CF), int32_t(0x00000000)},
    {"end02_g.vqa", "", int32_t(0x1DE148CF), int32_t(0x00000000)},
    {"end02_i.vqa", "", int32_t(0x1DE548CF), int32_t(0x00000000)},
    {"end02_s.vqa", "", int32_t(0x1DF948CF), int32_t(0x00000000)},
    {"end03_e.vqa", "", int32_t(0x1DDD48D1), int32_t(0x00000000)},
    {"end03_f.vqa", "", int32_t(0x1DDF48D1), int32_t(0x00000000)},
    {"end03_g.vqa", "", int32_t(0x1DE148D1), int32_t(0x00000000)},
    {"end03_i.vqa", "", int32_t(0x1DE548D1), int32_t(0x00000000)},
    {"end03_s.vqa", "", int32_t(0x1DF948D1), int32_t(0x00000000)},
    {"end04a_e.vqa", "", int32_t(0x8D2111AB), int32_t(0x00000000)},
    {"end04a_f.vqa", "", int32_t(0x8F2111AB), int32_t(0x00000000)},
    {"end04a_g.vqa", "", int32_t(0x912111AB), int32_t(0x00000000)},
    {"end04a_i.vqa", "", int32_t(0x952111AB), int32_t(0x00000000)},
    {"end04a_s.vqa", "", int32_t(0xA92111AB), int32_t(0x00000000)},
    {"end04b_e.vqa", "", int32_t(0x8D2113AB), int32_t(0x00000000)},
    {"end04b_f.vqa", "", int32_t(0x8F2113AB), int32_t(0x00000000)},
    {"end04b_g.vqa", "", int32_t(0x912113AB), int32_t(0x00000000)},
    {"end04b_i.vqa", "", int32_t(0x952113AB), int32_t(0x00000000)},
    {"end04b_s.vqa", "", int32_t(0xA92113AB), int32_t(0x00000000)},
    {"end04c_e.vqa", "", int32_t(0x8D2115AB), int32_t(0x00000000)},
    {"end04c_f.vqa", "", int32_t(0x8F2115AB), int32_t(0x00000000)},
    {"end04c_g.vqa", "", int32_t(0x912115AB), int32_t(0x00000000)},
    {"end04c_i.vqa", "", int32_t(0x952115AB), int32_t(0x00000000)},
    {"end04c_s.vqa", "", int32_t(0xA92115AB), int32_t(0x00000000)},
    {"end04d_e.vqa", "", int32_t(0x8D2117AB), int32_t(0x00000000)},
    {"end04d_f.vqa", "", int32_t(0x8F2117AB), int32_t(0x00000000)},
    {"end04d_g.vqa", "", int32_t(0x912117AB), int32_t(0x00000000)},
    {"end04d_i.vqa", "", int32_t(0x952117AB), int32_t(0x00000000)},
    {"end04d_s.vqa", "", int32_t(0xA92117AB), int32_t(0x00000000)},
    {"end05_e.vqa", "", int32_t(0x1DDD48D5), int32_t(0x00000000)},
    {"end05_f.vqa", "", int32_t(0x1DDF48D5), int32_t(0x00000000)},
    {"end05_g.vqa", "", int32_t(0x1DE148D5), int32_t(0x00000000)},
    {"end05_i.vqa", "", int32_t(0x1DE548D5), int32_t(0x00000000)},
    {"end05_s.vqa", "", int32_t(0x1DF948D5), int32_t(0x00000000)},
    {"end06_e.vqa", "", int32_t(0x1DDD48D7), int32_t(0x00000000)},
    {"end06_f.vqa", "", int32_t(0x1DDF48D7), int32_t(0x00000000)},
    {"end06_g.vqa", "", int32_t(0x1DE148D7), int32_t(0x00000000)},
    {"end06_i.vqa", "", int32_t(0x1DE548D7), int32_t(0x00000000)},
    {"end06_s.vqa", "", int32_t(0x1DF948D7), int32_t(0x00000000)},
    {"end07_e.vqa", "", int32_t(0x1DDD48D9), int32_t(0x00000000)},
    {"end07_f.vqa", "", int32_t(0x1DDF48D9), int32_t(0x00000000)},
    {"end07_g.vqa", "", int32_t(0x1DE148D9), int32_t(0x00000000)},
    {"end07_i.vqa", "", int32_t(0x1DE548D9), int32_t(0x00000000)},
    {"end07_s.vqa", "", int32_t(0x1DF948D9), int32_t(0x00000000)},
    {"endcred.tre", "", int32_t(0x69DF160D), int32_t(0x00000000)},
    {"endcred.trf", "", int32_t(0x69E0160D), int32_t(0x00000000)},
    {"endcred.trg", "", int32_t(0x69E1160D), int32_t(0x00000000)},
    {"endcred.tri", "", int32_t(0x69E3160D), int32_t(0x00000000)},
    {"endcred.trs", "", int32_t(0x69ED160D), int32_t(0x00000000)},
    {"enemya.aud", "enemy planes approaching", int32_t(0xB772001C), int32_t(0x00000000)},
    {"energy1.aud", "", int32_t(0xA5BC40E4), int32_t(0x00000000)},
    {"energy2.aud", "", int32_t(0xA5BE40E4), int32_t(0x00000000)},
    {"eng_edhi.pcx", "pict: red alert map editor title screen", int32_t(0x67F111CC), int32_t(0x00000000)},
    {"engineer.shp", "unit: engineer", int32_t(0x00000000), int32_t(0x13C2CC8B)},
    {"english.lng", "", int32_t(0x8DF52DF3), int32_t(0x00000000)},
    {"english.vqa", "red alert intro sequence", int32_t(0x8DEF30FD), int32_t(0x00000000)},
    {"english.vqp", "vqp: red alert intro sequence", int32_t(0x8DFE30FD), int32_t(0x00000000)},
    {"engnicon.shp", "-", int32_t(0x00000000), int32_t(0x1A3DC484)},
    {"enmyapp1.aud", "enemy approaching", int32_t(0x0C2B1AC5), int32_t(0x00000000)},
    {"enmyunit.aud", "enemy units approching", int32_t(0x521D16EC), int32_t(0x00000000)},
    {"ergylop1.aud", "", int32_t(0x0C1328DB), int32_t(0x00000000)},
    {"errormsg.tre", "", int32_t(0x114237E7), int32_t(0x00000000)},
    {"errormsg.trf", "", int32_t(0x124237E7), int32_t(0x00000000)},
    {"errormsg.trg", "", int32_t(0x134237E7), int32_t(0x00000000)},
    {"errormsg.tri", "", int32_t(0x154237E7), int32_t(0x00000000)},
    {"errormsg.trs", "", int32_t(0x1F4237E7), int32_t(0x00000000)},
    {"espbuttn.shp", "", int32_t(0xF63248ED), int32_t(0x00000000)},
    {"esper.vqa", "", int32_t(0xB7EDA9FA), int32_t(0x00000000)},
    {"esploop1.aud", "", int32_t(0xD8372CE1), int32_t(0x00000000)},
    {"esploop2.aud", "", int32_t(0xDA372CE1), int32_t(0x00000000)},
    {"esploop3.aud", "", int32_t(0xDC372CE1), int32_t(0x00000000)},
    {"espthumb.shp", "", int32_t(0x26244AD3), int32_t(0x00000000)},
    {"estaff1.aud", "", int32_t(0x61F82EE2), int32_t(0x00000000)},
    {"estrucx.aud", "enemy structure destroyed", int32_t(0xA6462900), int32_t(0x00000000)},
    {"etabs.shp", "misc: option bar", int32_t(0x99ABAE0B), int32_t(0x00000000)},
    {"ethanks.aud", "thanks", int32_t(0x620C3CF2), int32_t(0x00000000)},
    {"euanimation_s.bik", "", int32_t(0x00000000), int32_t(0xC1411550)},
    {"euro01.urb", "", int32_t(0x00000000), int32_t(0x85F3F8F1)},
    {"euro02.urb", "", int32_t(0x00000000), int32_t(0xB41BE26C)},
    {"euro03.urb", "", int32_t(0x00000000), int32_t(0x126CE9D8)},
    {"euro04.urb", "", int32_t(0x00000000), int32_t(0xD7CBD756)},
    {"euro05.urb", "", int32_t(0x00000000), int32_t(0x71BCDCE2)},
    {"euro_clikmap_tempb.pcx", "", int32_t(0x00000000), int32_t(0x298FF418)},
    {"euroc.hva", "", int32_t(0x00000000), int32_t(0xC02D82C2)},
    {"euroc.vxl", "", int32_t(0x00000000), int32_t(0x7FB48565)},
    {"euroclick1.pcx", "-", int32_t(0x00000000), int32_t(0x0EBEAD8D)},
    {"europe.wsa", "anim: european mission selection", int32_t(0xEBA62108), int32_t(0x00000000)},
    {"europe_worlddom_b.pcx", "", int32_t(0x00000000), int32_t(0x761BCB30)},
    {"euterr00.shp", "", int32_t(0x00000000), int32_t(0x85C87880)},
    {"euterr01.shp", "", int32_t(0x00000000), int32_t(0xB8A85130)},
    {"euterr02.shp", "", int32_t(0x00000000), int32_t(0xFF082BE0)},
    {"euterr03.shp", "", int32_t(0x00000000), int32_t(0xC2680250)},
    {"euterr04.shp", "", int32_t(0x00000000), int32_t(0x7048DE40)},
    {"euterr05.shp", "", int32_t(0x00000000), int32_t(0x4D28F7F0)},
    {"euterr06.shp", "", int32_t(0x00000000), int32_t(0x0A888D20)},
    {"euterr07.shp", "", int32_t(0x00000000), int32_t(0x37E8A490)},
    {"euterr08.shp", "", int32_t(0x00000000), int32_t(0xB5B83341)},
    {"euterr09.shp", "", int32_t(0x00000000), int32_t(0x88D81AF1)},
    {"euterr10.shp", "", int32_t(0x00000000), int32_t(0x4E94AB25)},
    {"euterr11.shp", "", int32_t(0x00000000), int32_t(0x73F48295)},
    {"euterr12.shp", "", int32_t(0x00000000), int32_t(0x3454F845)},
    {"euterr13.shp", "", int32_t(0x00000000), int32_t(0x0934D1F5)},
    {"euterr14.shp", "", int32_t(0x00000000), int32_t(0xBB140DE5)},
    {"euterr15.shp", "", int32_t(0x00000000), int32_t(0x86742455)},
    {"euterr16.shp", "", int32_t(0x00000000), int32_t(0xC1D45E85)},
    {"euterr17.shp", "", int32_t(0x00000000), int32_t(0xFCB47735)},
    {"euterr18.shp", "", int32_t(0x00000000), int32_t(0x7EE4E0E4)},
    {"euterr19.shp", "", int32_t(0x00000000), int32_t(0x4384C954)},
    {"euterr20.shp", "", int32_t(0x00000000), int32_t(0xC800D98B)},
    {"euterr21.shp", "", int32_t(0x00000000), int32_t(0xF560F03B)},
    {"euterr22.shp", "", int32_t(0x00000000), int32_t(0xB2C08AEB)},
    {"euterr23.shp", "", int32_t(0x00000000), int32_t(0x8FA0A35B)},
    {"euterr24.shp", "", int32_t(0x00000000), int32_t(0x3D807F4B)},
    {"euterr25.shp", "", int32_t(0x00000000), int32_t(0x00E056FB)},
    {"euterr26.shp", "", int32_t(0x00000000), int32_t(0x47402C2B)},
    {"euterr27.shp", "", int32_t(0x00000000), int32_t(0x7A20059B)},
    {"euterr28.shp", "", int32_t(0x00000000), int32_t(0xF870924A)},
    {"euterr29.shp", "", int32_t(0x00000000), int32_t(0xC510BBFA)},
    {"eva.ini", "", int32_t(0x00000000), int32_t(0xDA05954A)},
    {"eva.vqa", "-", int32_t(0x00000000), int32_t(0x0DDCBCC6)},
    {"eva.wsa", "anim: eva logo", int32_t(0x5CC3FFE1), int32_t(0x00000000)},
    {"eva1.aud", "eva 1", int32_t(0xA6D7EDB8), int32_t(0x00000000)},
    {"eva10.aud", "eva 10", int32_t(0x6F87B5B9), int32_t(0x00000000)},
    {"eva11.aud", "eva 11", int32_t(0x6F87B5BB), int32_t(0x00000000)},
    {"eva12.aud", "eva 12", int32_t(0x6F87B5BD), int32_t(0x00000000)},
    {"eva13.aud", "eva 13", int32_t(0x6F87B5BF), int32_t(0x00000000)},
    {"eva14.aud", "eva 14", int32_t(0x6F87B5C1), int32_t(0x00000000)},
    {"eva15.aud", "eva 15", int32_t(0x6F87B5C3), int32_t(0x00000000)},
    {"eva16.aud", "eva 16", int32_t(0x6F87B5C5), int32_t(0x00000000)},
    {"eva17.aud", "eva 17", int32_t(0x6F87B5C7), int32_t(0x00000000)},
    {"eva2.aud", "eva 2", int32_t(0xA8D7EDB8), int32_t(0x00000000)},
    {"eva3.aud", "eva 3", int32_t(0xAAD7EDB8), int32_t(0x00000000)},
    {"eva4.aud", "eva 4", int32_t(0xACD7EDB8), int32_t(0x00000000)},
    {"eva5.aud", "eva 5", int32_t(0xAED7EDB8), int32_t(0x00000000)},
    {"eva6.aud", "eva 6", int32_t(0xB0D7EDB8), int32_t(0x00000000)},
    {"eva7.aud", "eva 7", int32_t(0xB2D7EDB8), int32_t(0x00000000)},
    {"eva8.aud", "eva 8", int32_t(0xB4D7EDB8), int32_t(0x00000000)},
    {"eva9.aud", "eva 9", int32_t(0xB6D7EDB8), int32_t(0x00000000)},
    {"evamd.ini", "", int32_t(0x00000000), int32_t(0x291FDA84)},
    {"ewod1.img", "", int32_t(0xABCFB9BE), int32_t(0x00000000)},
    {"ewod1.lmf", "", int32_t(0xABD5B9BD), int32_t(0x00000000)},
    {"ewod1.lsv", "", int32_t(0xB7D5B9CD), int32_t(0x00000000)},
    {"ewod1.odf", "", int32_t(0x99DBB9BD), int32_t(0x00000000)},
    {"ewod1.pcx", "", int32_t(0x97DDB9CF), int32_t(0x00000000)},
    {"ewod1.ver", "", int32_t(0x9BE9B9C9), int32_t(0x00000000)},
    {"examb1.aud", "", int32_t(0xB76207EE), int32_t(0x00000000)},
    {"examb2.aud", "", int32_t(0xB76209EE), int32_t(0x00000000)},
    {"exatak2.aud", "", int32_t(0xADAE4CD8), int32_t(0x00000000)},
    {"exdie1.aud", "", int32_t(0xA76E07F4), int32_t(0x00000000)},
    {"execute.vqa", "spy being shot", int32_t(0x69E15B15), int32_t(0x00000000)},
    {"execute.vqp", "vqp: spy being shot", int32_t(0x69F05B15), int32_t(0x00000000)},
    {"exists1.aud", "audf:", int32_t(0xA9CC5CFE), int32_t(0x00000000)},
    {"exit.cps", "pict: ???", int32_t(0xFBE2F3B8), int32_t(0x00000000)},
    {"exit.wsa", "anim: installation complete", int32_t(0xE9E607B8), int32_t(0x00000000)},
    {"exitopen.shp", "", int32_t(0x00000000), int32_t(0x4A9B9EE2)},
    {"exlghrt1.aud", "", int32_t(0xC42F46D3), int32_t(0x00000000)},
    {"exnest1.aud", "", int32_t(0x71E05EFC), int32_t(0x00000000)},
    {"exp.shp", "", int32_t(0x5CF0F8DD), int32_t(0x00000000)},
    {"expand.dat", "empty file", int32_t(0x8D9E3DF2), int32_t(0x00000000)},
    {"expdirt1.aud", "dirt explosion", int32_t(0x00000000), int32_t(0x250C0740)},
    {"expel1.aud", "", int32_t(0x979E0802), int32_t(0x00000000)},
    {"experm~1.aud", "", int32_t(0xBC933CE7), int32_t(0x00000000)},
    {"experm~2.aud", "", int32_t(0xBE933CE7), int32_t(0x00000000)},
    {"experm~3.aud", "", int32_t(0xC0933CE7), int32_t(0x00000000)},
    {"experm~4.aud", "", int32_t(0xC2933CE7), int32_t(0x00000000)},
    {"expfire1.aud", "", int32_t(0xC02146D5), int32_t(0x00000000)},
    {"explode1.aud", "", int32_t(0xD8212AE1), int32_t(0x00000000)},
    {"explode2.aud", "", int32_t(0xDA212AE1), int32_t(0x00000000)},
    {"explolb.shp", "", int32_t(0x00000000), int32_t(0x5B2EC921)},
    {"explolrg.shp", "big explosion", int32_t(0x00000000), int32_t(0x35857241)},
    {"explomed.shp", "medium explosion", int32_t(0x00000000), int32_t(0xCA813106)},
    {"explosml.shp", "small explosion", int32_t(0x00000000), int32_t(0x21431F39)},
    {"expnew01.aud", "big building explosion with glass", int32_t(0x00000000), int32_t(0x26D0FA7A)},
    {"expnew02.aud", "big building explosion with glass", int32_t(0x00000000), int32_t(0x617080AA)},
    {"expnew03.aud", "big building explosion with glass", int32_t(0x00000000), int32_t(0x5C10A91A)},
    {"expnew04.aud", "big building explosion with glass", int32_t(0x00000000), int32_t(0xEE30750A)},
    {"expnew05.aud", "medium explosion for vehicle or structure", int32_t(0x00000000), int32_t(0xD3505CBA)},
    {"expnew06.aud", "medium explosion good for all & land destruction", int32_t(0x00000000), int32_t(0x94F0266A)},
    {"expnew07.aud", "medium explosion with glass", int32_t(0x00000000), int32_t(0xA9900FDA)},
    {"expnew08.aud", "lg/md explosion with glass", int32_t(0x00000000), int32_t(0x2BC0980B)},
    {"expnew09.aud", "medium explosion general", int32_t(0x00000000), int32_t(0x16A0B1BB)},
    {"expnew10.aud", "medium explosion general and vehicle", int32_t(0x00000000), int32_t(0xD0EC006F)},
    {"expnew11.aud", "medium explosion with glass", int32_t(0x00000000), int32_t(0xED8C29DF)},
    {"expnew12.aud", "small explosion general", int32_t(0x00000000), int32_t(0xAA2C530F)},
    {"expnew13.aud", "small explosion general", int32_t(0x00000000), int32_t(0x974C7ABF)},
    {"expnew14.aud", "small explosion general", int32_t(0x00000000), int32_t(0x256CA6AF)},
    {"expnew15.aud", "small explosion general", int32_t(0x00000000), int32_t(0x180C8F1F)},
    {"expnew16.aud", "explosion", int32_t(0x00000000), int32_t(0x5FACF5CF)},
    {"expnew17.aud", "explosion", int32_t(0x00000000), int32_t(0x62CCDC7F)},
    {"expnew18.aud", "explosion", int32_t(0x00000000), int32_t(0xE09C4BAE)},
    {"expnew19.aud", "explosion", int32_t(0x00000000), int32_t(0xDDFC621E)},
    {"exsmhrt1.aud", "", int32_t(0xDC4B46D3), int32_t(0x00000000)},
    {"extendb.shp", "", int32_t(0x00000000), int32_t(0x012391F9)},
    {"extndl01.shp", "", int32_t(0x00000000), int32_t(0x7C5C5DD5)},
    {"extndl02.shp", "", int32_t(0x00000000), int32_t(0x3BFC2705)},
    {"exwlk1.aud", "", int32_t(0xB3BA0800), int32_t(0x00000000)},
    {"exwlk2.aud", "", int32_t(0xB3BA0A00), int32_t(0x00000000)},
    {"exwlk3.aud", "", int32_t(0xB3BA0C00), int32_t(0x00000000)},
    {"eye.shp", "advanced comm. center", int32_t(0x5CDAFADD), int32_t(0x00000000)},
    {"eyeicnh.des", "icon: advanced comm. center", int32_t(0x81F946DF), int32_t(0x00000000)},
    {"eyeicnh.tem", "icon: advanced comm. center", int32_t(0x81F346EF), int32_t(0x00000000)},
    {"eyeicnh.win", "icon: advanced comm. center", int32_t(0x81F44AF2), int32_t(0x00000000)},
    {"eyeicon.shp", "icon: advanced comm. center", int32_t(0x82024BEE), int32_t(0x00000000)},
    {"eyemake.shp", "make: advanced comm. center", int32_t(0x91F043EA), int32_t(0x00000000)},
    {"eyemaxh.wsa", "", int32_t(0x91E768EE), int32_t(0x00000000)},
    {"eyemaxhp.wsa", "", int32_t(0x16F96CC5), int32_t(0x00000000)},
    {"eyeminh.wsa", "", int32_t(0x91E754FE), int32_t(0x00000000)},
    {"eyeminhp.wsa", "", int32_t(0x16F958D5), int32_t(0x00000000)},
    {"eyenorm.wsa", "", int32_t(0x95F15D0A), int32_t(0x00000000)},
    {"eyenormp.wsa", "", int32_t(0x1B0360E1), int32_t(0x00000000)},
    {"eyessir1.aud", "engineer: yes sir!", int32_t(0xF40F38E9), int32_t(0x00000000)},
    {"f01.sno", "crossing", int32_t(0x5CB1AEDF), int32_t(0x00000000)},
    {"f01.tem", "bridge", int32_t(0x5CAFA5E0), int32_t(0x00000000)},
    {"f02.sno", "crossing", int32_t(0x5CB3AEDF), int32_t(0x00000000)},
    {"f02.tem", "bridge", int32_t(0x5CB1A5E0), int32_t(0x00000000)},
    {"f03.sno", "crossing", int32_t(0x5CB5AEDF), int32_t(0x00000000)},
    {"f03.tem", "bridge", int32_t(0x5CB3A5E0), int32_t(0x00000000)},
    {"f04.sno", "crossing", int32_t(0x5CB7AEDF), int32_t(0x00000000)},
    {"f04.tem", "bridge", int32_t(0x5CB5A5E0), int32_t(0x00000000)},
    {"f05.sno", "crossing", int32_t(0x5CB9AEDF), int32_t(0x00000000)},
    {"f05.tem", "bridge", int32_t(0x5CB7A5E0), int32_t(0x00000000)},
    {"f06.sno", "crossing", int32_t(0x5CBBAEDF), int32_t(0x00000000)},
    {"f06.tem", "bridge", int32_t(0x5CB9A5E0), int32_t(0x00000000)},
    {"f_compas.shp", "", int32_t(0x33D870E1), int32_t(0x00000000)},
    {"f_int.shp", "", int32_t(0xC9CBDA11), int32_t(0x00000000)},
    {"f_jrn.shp", "", int32_t(0xD9CFDA05), int32_t(0x00000000)},
    {"f_option.trr", "", int32_t(0x302E63EF), int32_t(0x00000000)},
    {"fac1226m.aud", "face to the enemy 1", int32_t(0xA3CEAAAB), int32_t(0x00000000)},
    {"fac2226m.aud", "face to the enemy 2", int32_t(0xA7CEAAAB), int32_t(0x00000000)},
    {"facbld1.aud", "factory goes online", int32_t(0x00000000), int32_t(0x0DC64E6F)},
    {"facedown.map", "", int32_t(0x00000000), int32_t(0x01BF1675)},
    {"facficon.shp", "icon: construction yard fake", int32_t(0x05F3DED9), int32_t(0x00000000)},
    {"fact.shp", "construction yard", int32_t(0xF8CED5BA), int32_t(0x00000000)},
    {"factamb2.aud", "", int32_t(0xF9E6E0C9), int32_t(0x00000000)},
    {"facticon.shp", "icon: construction yard", int32_t(0x3DF3DED9), int32_t(0xCE5E8A27)},
    {"factmake.shp", "make: mcv => construction yard", int32_t(0x2BEBDAE1), int32_t(0x00000000)},
    {"fade.vqa", "", int32_t(0xCBD9D8BA), int32_t(0x00000000)},
    {"fail1.aud", "mission failed", int32_t(0xDBA761BF), int32_t(0x00000000)},
    {"faildmgc.flc", "", int32_t(0xFAFFE5CF), int32_t(0x00000000)},
    {"failspl1.aud", "", int32_t(0xD812E6ED), int32_t(0x00000000)},
    {"falc.hva", "", int32_t(0x00000000), int32_t(0xDC3B0DE1)},
    {"falc.vxl", "", int32_t(0x00000000), int32_t(0x2AB1D2A8)},
    {"falcicon.shp", "", int32_t(0x00000000), int32_t(0xF7F4FE12)},
    {"falls1.des", "waterfall east-west", int32_t(0xB98DBB04), int32_t(0x00000000)},
    {"falls1.sno", "waterfall", int32_t(0xD78DB70D), int32_t(0x00000000)},
    {"falls1.tem", "waterfall east-west", int32_t(0xD98DB504), int32_t(0x00000000)},
    {"falls1.win", "waterfall east-west", int32_t(0xDF8DB608), int32_t(0x00000000)},
    {"falls1a.sno", "waterfall", int32_t(0x8E02B612), int32_t(0x00000000)},
    {"falls1a.tem", "waterfall", int32_t(0x8E00AD13), int32_t(0x00000000)},
    {"falls2.des", "waterfall north-south", int32_t(0xB98DBD04), int32_t(0x00000000)},
    {"falls2.sno", "waterfall", int32_t(0xD78DB90D), int32_t(0x00000000)},
    {"falls2.tem", "waterfall north-south", int32_t(0xD98DB704), int32_t(0x00000000)},
    {"falls2.win", "waterfall north-south", int32_t(0xDF8DB808), int32_t(0x00000000)},
    {"falls2a.sno", "waterfall", int32_t(0x8E02B812), int32_t(0x00000000)},
    {"falls2a.tem", "waterfall", int32_t(0x8E00AF13), int32_t(0x00000000)},
    {"fampowr1.aud", "", int32_t(0xE82EF4E5), int32_t(0x00000000)},
    {"famshld1.aud", "", int32_t(0xF412DED7), int32_t(0x00000000)},
    {"fangatk1.aud", "", int32_t(0xC424EEC9), int32_t(0x00000000)},
    {"fangatk2.aud", "", int32_t(0xC624EEC9), int32_t(0x00000000)},
    {"fangatk3.aud", "", int32_t(0xC824EEC9), int32_t(0x00000000)},
    {"fangdie1.aud", "", int32_t(0xC418D8CF), int32_t(0x00000000)},
    {"fangdie2.aud", "", int32_t(0xC618D8CF), int32_t(0x00000000)},
    {"fanghit1.aud", "", int32_t(0xC436D8D7), int32_t(0x00000000)},
    {"fanghit2.aud", "", int32_t(0xC636D8D7), int32_t(0x00000000)},
    {"fanghit3.aud", "", int32_t(0xC836D8D7), int32_t(0x00000000)},
    {"fanghit4.aud", "", int32_t(0xCA36D8D7), int32_t(0x00000000)},
    {"fanghit5.aud", "", int32_t(0xCC36D8D7), int32_t(0x00000000)},
    {"fanghit6.aud", "", int32_t(0xCE36D8D7), int32_t(0x00000000)},
    {"fangloi1.aud", "", int32_t(0xC420E4DF), int32_t(0x00000000)},
    {"fangloi2.aud", "", int32_t(0xC620E4DF), int32_t(0x00000000)},
    {"fangothr.aud", "", int32_t(0x061EEEE5), int32_t(0x00000000)},
    {"fangrun1.aud", "", int32_t(0xC42AF0EB), int32_t(0x00000000)},
    {"fangrun2.aud", "", int32_t(0xC62AF0EB), int32_t(0x00000000)},
    {"fangwlk1.aud", "", int32_t(0xC424DEF5), int32_t(0x00000000)},
    {"fangwlk2.aud", "", int32_t(0xC624DEF5), int32_t(0x00000000)},
    {"farm01.des", "", int32_t(0x00000000), int32_t(0xCCCD285A)},
    {"farm01.tem", "", int32_t(0x00000000), int32_t(0xBA9531A2)},
    {"farm02.des", "", int32_t(0x00000000), int32_t(0xFD2532C7)},
    {"farm02.tem", "", int32_t(0x00000000), int32_t(0x8B7D2B3F)},
    {"farm03.des", "", int32_t(0x00000000), int32_t(0x5B523973)},
    {"farm03.tem", "", int32_t(0x00000000), int32_t(0x2D0A208B)},
    {"farm04.des", "", int32_t(0x00000000), int32_t(0x9EF507FD)},
    {"farm04.tem", "", int32_t(0x00000000), int32_t(0xE8AD1E05)},
    {"farm05.des", "", int32_t(0x00000000), int32_t(0x38820C49)},
    {"farm05.tem", "", int32_t(0x00000000), int32_t(0x4EDA15B1)},
    {"farm06.des", "", int32_t(0x00000000), int32_t(0x096A16D4)},
    {"farm06.tem", "", int32_t(0x00000000), int32_t(0x7F320F2C)},
    {"farm07.des", "", int32_t(0x00000000), int32_t(0xAF1D1D60)},
    {"farm07.tem", "", int32_t(0x00000000), int32_t(0xD9450498)},
    {"farm08.des", "", int32_t(0x00000000), int32_t(0x59556D89)},
    {"farm08.tem", "", int32_t(0x00000000), int32_t(0x2F0D7471)},
    {"fb1.shp", "misc: fireballs", int32_t(0x5CB2CCDF), int32_t(0x00000000)},
    {"fb2.shp", "misc: fireballs", int32_t(0x5CB4CCDF), int32_t(0x00000000)},
    {"fball1.shp", "large explosion", int32_t(0xD761BBF9), int32_t(0x00000000)},
    {"fcom.shp", "bldg: forward command post", int32_t(0xEAE6D9BA), int32_t(0x00000000)},
    {"fel1104a.aud", "", int32_t(0x8BEEB6A9), int32_t(0x00000000)},
    {"fel1104b.aud", "", int32_t(0x8DEEB6A9), int32_t(0x00000000)},
    {"fel1106a.aud", "", int32_t(0x8BF2B6A9), int32_t(0x00000000)},
    {"fel1106b.aud", "", int32_t(0x8DF2B6A9), int32_t(0x00000000)},
    {"feleatk1.aud", "", int32_t(0xBC1CFEC9), int32_t(0x00000000)},
    {"feleatk2.aud", "", int32_t(0xBE1CFEC9), int32_t(0x00000000)},
    {"feleatk3.aud", "", int32_t(0xC01CFEC9), int32_t(0x00000000)},
    {"feledie1.aud", "", int32_t(0xBC10E8CF), int32_t(0x00000000)},
    {"feledie2.aud", "", int32_t(0xBE10E8CF), int32_t(0x00000000)},
    {"felehit1.aud", "", int32_t(0xBC2EE8D7), int32_t(0x00000000)},
    {"felehit2.aud", "", int32_t(0xBE2EE8D7), int32_t(0x00000000)},
    {"feleloi1.aud", "", int32_t(0xBC18F4DF), int32_t(0x00000000)},
    {"feleloi2.aud", "", int32_t(0xBE18F4DF), int32_t(0x00000000)},
    {"feleloi3.aud", "", int32_t(0xC018F4DF), int32_t(0x00000000)},
    {"felewlk1.aud", "", int32_t(0xBC1CEEF5), int32_t(0x00000000)},
    {"felewlk2.aud", "", int32_t(0xBE1CEEF5), int32_t(0x00000000)},
    {"femcry1.aud", "", int32_t(0x69DC1CFE), int32_t(0x00000000)},
    {"femcry2.aud", "", int32_t(0x69DE1CFE), int32_t(0x00000000)},
    {"femcry3.aud", "", int32_t(0x69E01CFE), int32_t(0x00000000)},
    {"femdie1.aud", "", int32_t(0x6DDBF4EC), int32_t(0x00000000)},
    {"femfear1.aud", "", int32_t(0xC02ED8D1), int32_t(0x00000000)},
    {"femhurt1.aud", "", int32_t(0xC832FAF1), int32_t(0x00000000)},
    {"femhurt2.aud", "", int32_t(0xCA32FAF1), int32_t(0x00000000)},
    {"femorg1.aud", "", int32_t(0x99DBF8FE), int32_t(0x00000000)},
    {"femorg2.aud", "", int32_t(0x99DDF8FE), int32_t(0x00000000)},
    {"femorg3.aud", "", int32_t(0x99DFF8FE), int32_t(0x00000000)},
    {"femorg4.aud", "", int32_t(0x99E1F8FE), int32_t(0x00000000)},
    {"fempain1.aud", "", int32_t(0xE826E8C9), int32_t(0x00000000)},
    {"fenc.shp", "misc: barbed wire", int32_t(0xD6E4DDBA), int32_t(0xCB3EDB45)},
    {"fence01.des", "", int32_t(0x00000000), int32_t(0x76899AD9)},
    {"fence01.lun", "", int32_t(0x00000000), int32_t(0x50777D5A)},
    {"fence01.sno", "", int32_t(0x00000000), int32_t(0x51654743)},
    {"fence01.tem", "", int32_t(0x00000000), int32_t(0xF2D1F299)},
    {"fence01.ubn", "", int32_t(0x00000000), int32_t(0x640FD0BA)},
    {"fence01.urb", "", int32_t(0x00000000), int32_t(0xD49C3CC6)},
    {"fence02.des", "", int32_t(0x00000000), int32_t(0xF01DE877)},
    {"fence02.lun", "", int32_t(0x00000000), int32_t(0xD6E30FF4)},
    {"fence02.sno", "", int32_t(0x00000000), int32_t(0xD7F135ED)},
    {"fence02.tem", "", int32_t(0x00000000), int32_t(0x74458037)},
    {"fence02.ubn", "", int32_t(0x00000000), int32_t(0xE29BA214)},
    {"fence02.urb", "", int32_t(0x00000000), int32_t(0x52084E68)},
    {"fence03.des", "", int32_t(0x00000000), int32_t(0x3B413BD2)},
    {"fence03.lun", "", int32_t(0x00000000), int32_t(0x1DBFDC51)},
    {"fence03.sno", "", int32_t(0x00000000), int32_t(0x1CADE648)},
    {"fence03.tem", "", int32_t(0x00000000), int32_t(0xBF195392)},
    {"fence03.ubn", "", int32_t(0x00000000), int32_t(0x29C771B1)},
    {"fence03.urb", "", int32_t(0x00000000), int32_t(0x99549DCD)},
    {"fence04.des", "", int32_t(0x00000000), int32_t(0x26440B6A)},
    {"fence04.lun", "", int32_t(0x00000000), int32_t(0x00BAECE9)},
    {"fence04.sno", "", int32_t(0x00000000), int32_t(0x01A8D6F0)},
    {"fence04.tem", "", int32_t(0x00000000), int32_t(0xA21C632A)},
    {"fence04.ubn", "", int32_t(0x00000000), int32_t(0x34C24109)},
    {"fence04.urb", "", int32_t(0x00000000), int32_t(0x8451AD75)},
    {"fence05.des", "", int32_t(0x00000000), int32_t(0xED18D8CF)},
    {"fence05.lun", "", int32_t(0x00000000), int32_t(0xCBE63F4C)},
    {"fence05.sno", "", int32_t(0x00000000), int32_t(0xCAF40555)},
    {"fence05.tem", "", int32_t(0x00000000), int32_t(0x6940B08F)},
    {"fence05.ubn", "", int32_t(0x00000000), int32_t(0xFF9E92AC)},
    {"fence05.urb", "", int32_t(0x00000000), int32_t(0x4F0D7ED0)},
    {"fence06.des", "", int32_t(0x00000000), int32_t(0x6B8CAA61)},
    {"fence06.lun", "", int32_t(0x00000000), int32_t(0x4D724DE2)},
    {"fence06.sno", "", int32_t(0x00000000), int32_t(0x4C6077FB)},
    {"fence06.tem", "", int32_t(0x00000000), int32_t(0xEFD4C221)},
    {"fence06.ubn", "", int32_t(0x00000000), int32_t(0x790AE002)},
    {"fence06.urb", "", int32_t(0x00000000), int32_t(0xC9990C7E)},
    {"fence07.des", "", int32_t(0x00000000), int32_t(0xA0D079C4)},
    {"fence07.lun", "", int32_t(0x00000000), int32_t(0x862E9E47)},
    {"fence07.sno", "", int32_t(0x00000000), int32_t(0x873CA45E)},
    {"fence07.tem", "", int32_t(0x00000000), int32_t(0x24881184)},
    {"fence07.ubn", "", int32_t(0x00000000), int32_t(0xB25633A7)},
    {"fence07.urb", "", int32_t(0x00000000), int32_t(0x02C5DFDB)},
    {"fence08.des", "", int32_t(0x00000000), int32_t(0x5186CB11)},
    {"fence08.lun", "", int32_t(0x00000000), int32_t(0x77782C92)},
    {"fence08.sno", "", int32_t(0x00000000), int32_t(0x766A168B)},
    {"fence08.tem", "", int32_t(0x00000000), int32_t(0xD5DEA351)},
    {"fence08.ubn", "", int32_t(0x00000000), int32_t(0x43008172)},
    {"fence08.urb", "", int32_t(0x00000000), int32_t(0xF3936D0E)},
    {"fence09.des", "", int32_t(0x00000000), int32_t(0x9ADA18B4)},
    {"fence09.lun", "", int32_t(0x00000000), int32_t(0xBC24FF37)},
    {"fence09.sno", "", int32_t(0x00000000), int32_t(0xBD36C52E)},
    {"fence09.tem", "", int32_t(0x00000000), int32_t(0x1E8270F4)},
    {"fence09.ubn", "", int32_t(0x00000000), int32_t(0x885C52D7)},
    {"fence09.urb", "", int32_t(0x00000000), int32_t(0x38CFBEAB)},
    {"fence10.des", "", int32_t(0x00000000), int32_t(0x1BA242C8)},
    {"fence10.lun", "", int32_t(0x00000000), int32_t(0x3D5CA54B)},
    {"fence10.sno", "", int32_t(0x00000000), int32_t(0x3C4E9F52)},
    {"fence10.tem", "", int32_t(0x00000000), int32_t(0x9FFA2A88)},
    {"fence10.ubn", "", int32_t(0x00000000), int32_t(0x092408AB)},
    {"fence10.urb", "", int32_t(0x00000000), int32_t(0xB9B7E4D7)},
    {"fence11.des", "", int32_t(0x00000000), int32_t(0xD0FE916D)},
    {"fence11.lun", "", int32_t(0x00000000), int32_t(0xF60076EE)},
    {"fence11.sno", "", int32_t(0x00000000), int32_t(0xF7124CF7)},
    {"fence11.tem", "", int32_t(0x00000000), int32_t(0x54A6F92D)},
    {"fence11.ubn", "", int32_t(0x00000000), int32_t(0xC278DB0E)},
    {"fence11.urb", "", int32_t(0x00000000), int32_t(0x72EB3772)},
    {"fence12.des", "", int32_t(0x00000000), int32_t(0x566AE3C3)},
    {"fence12.lun", "", int32_t(0x00000000), int32_t(0x70940440)},
    {"fence12.sno", "", int32_t(0x00000000), int32_t(0x71863E59)},
    {"fence12.tem", "", int32_t(0x00000000), int32_t(0xD2328B83)},
    {"fence12.ubn", "", int32_t(0x00000000), int32_t(0x44ECA9A0)},
    {"fence12.urb", "", int32_t(0x00000000), int32_t(0xF47F45DC)},
    {"fence13.des", "", int32_t(0x00000000), int32_t(0x9D363066)},
    {"fence13.lun", "", int32_t(0x00000000), int32_t(0xBBC8D7E5)},
    {"fence13.sno", "", int32_t(0x00000000), int32_t(0xBADAEDFC)},
    {"fence13.tem", "", int32_t(0x00000000), int32_t(0x196E5826)},
    {"fence13.ubn", "", int32_t(0x00000000), int32_t(0x8FB07A05)},
    {"fence13.urb", "", int32_t(0x00000000), int32_t(0x3F239679)},
    {"fence14.des", "", int32_t(0x00000000), int32_t(0x803300DE)},
    {"fence14.lun", "", int32_t(0x00000000), int32_t(0xA6CDE75D)},
    {"fence14.sno", "", int32_t(0x00000000), int32_t(0xA7DFDD44)},
    {"fence14.tem", "", int32_t(0x00000000), int32_t(0x046B689E)},
    {"fence14.ubn", "", int32_t(0x00000000), int32_t(0x92B54ABD)},
    {"fence14.urb", "", int32_t(0x00000000), int32_t(0x2226A6C1)},
    {"fence15.des", "", int32_t(0x00000000), int32_t(0x4B6FD37B)},
    {"fence15.lun", "", int32_t(0x00000000), int32_t(0x6D9134F8)},
    {"fence15.sno", "", int32_t(0x00000000), int32_t(0x6C830EE1)},
    {"fence15.tem", "", int32_t(0x00000000), int32_t(0xCF37BB3B)},
    {"fence15.ubn", "", int32_t(0x00000000), int32_t(0x59E99918)},
    {"fence15.urb", "", int32_t(0x00000000), int32_t(0xE97A7564)},
    {"fence16.des", "", int32_t(0x00000000), int32_t(0xCDFBA1D5)},
    {"fence16.lun", "", int32_t(0x00000000), int32_t(0xEB054656)},
    {"fence16.sno", "", int32_t(0x00000000), int32_t(0xEA177C4F)},
    {"fence16.tem", "", int32_t(0x00000000), int32_t(0x49A3C995)},
    {"fence16.ubn", "", int32_t(0x00000000), int32_t(0xDF7DEBB6)},
    {"fence16.urb", "", int32_t(0x00000000), int32_t(0x6FEE07CA)},
    {"fence17.des", "", int32_t(0x00000000), int32_t(0x06A77270)},
    {"fence17.lun", "", int32_t(0x00000000), int32_t(0x205995F3)},
    {"fence17.sno", "", int32_t(0x00000000), int32_t(0x214BAFEA)},
    {"fence17.tem", "", int32_t(0x00000000), int32_t(0x82FF1A30)},
    {"fence17.ubn", "", int32_t(0x00000000), int32_t(0x14213813)},
    {"fence17.urb", "", int32_t(0x00000000), int32_t(0xA4B2D46F)},
    {"fence18.des", "", int32_t(0x00000000), int32_t(0xF7F1C0A5)},
    {"fence18.lun", "", int32_t(0x00000000), int32_t(0xD10F2726)},
    {"fence18.sno", "", int32_t(0x00000000), int32_t(0xD01D1D3F)},
    {"fence18.tem", "", int32_t(0x00000000), int32_t(0x73A9A8E5)},
    {"fence18.ubn", "", int32_t(0x00000000), int32_t(0xE5778AC6)},
    {"fence18.urb", "", int32_t(0x00000000), int32_t(0x55E466BA)},
    {"fence19.des", "", int32_t(0x00000000), int32_t(0x3CAD1300)},
    {"fence19.lun", "", int32_t(0x00000000), int32_t(0x1A53F483)},
    {"fence19.sno", "", int32_t(0x00000000), int32_t(0x1B41CE9A)},
    {"fence19.tem", "", int32_t(0x00000000), int32_t(0xB8F57B40)},
    {"fence19.ubn", "", int32_t(0x00000000), int32_t(0x2E2B5963)},
    {"fence19.urb", "", int32_t(0x00000000), int32_t(0x9EB8B51F)},
    {"fence20.des", "", int32_t(0x00000000), int32_t(0x2A4A5855)},
    {"fence20.lun", "", int32_t(0x00000000), int32_t(0x0CB4BFD6)},
    {"fence20.sno", "", int32_t(0x00000000), int32_t(0x0DA685CF)},
    {"fence20.tem", "", int32_t(0x00000000), int32_t(0xAE123015)},
    {"fence20.ubn", "", int32_t(0x00000000), int32_t(0x38CC1236)},
    {"fence20.urb", "", int32_t(0x00000000), int32_t(0x885FFE4A)},
    {"fence21.des", "", int32_t(0x00000000), int32_t(0xE1168BF0)},
    {"fence21.lun", "", int32_t(0x00000000), int32_t(0xC7E86C73)},
    {"fence21.sno", "", int32_t(0x00000000), int32_t(0xC6FA566A)},
    {"fence21.tem", "", int32_t(0x00000000), int32_t(0x654EE3B0)},
    {"fence21.ubn", "", int32_t(0x00000000), int32_t(0xF390C193)},
    {"fence21.urb", "", int32_t(0x00000000), int32_t(0x43032DEF)},
    {"fence22.des", "", int32_t(0x00000000), int32_t(0x6782F95E)},
    {"fence22.lun", "", int32_t(0x00000000), int32_t(0x417C1EDD)},
    {"fence22.sno", "", int32_t(0x00000000), int32_t(0x406E24C4)},
    {"fence22.tem", "", int32_t(0x00000000), int32_t(0xE3DA911E)},
    {"fence22.ubn", "", int32_t(0x00000000), int32_t(0x7504B33D)},
    {"fence22.urb", "", int32_t(0x00000000), int32_t(0xC5975F41)},
    {"fencicon.shp", "icon: barbed wire", int32_t(0xFA1FEED9), int32_t(0x00000000)},
    {"ffon1.aud", "", int32_t(0xE3BF75BF), int32_t(0x00000000)},
    {"field1.aud", "", int32_t(0xB371CBF6), int32_t(0x00000000)},
    {"fiend1.aud", "tiberium fiend", int32_t(0x00000000), int32_t(0x3ECC8D5F)},
    {"fiend2.aud", "tiberium fiend", int32_t(0x00000000), int32_t(0x0F2497C2)},
    {"fight.map", "", int32_t(0x00000000), int32_t(0x9306F050)},
    {"fight1.aud", "", int32_t(0xA379CC16), int32_t(0x00000000)},
    {"fight2.aud", "", int32_t(0xA379CE16), int32_t(0x00000000)},
    {"fight3.aud", "", int32_t(0xA379D016), int32_t(0x00000000)},
    {"fighter.aud", "", int32_t(0x7E060502), int32_t(0x00000000)},
    {"file.wws", "", int32_t(0xDDEFE9BA), int32_t(0x00000000)},
    {"file1.vqa", "", int32_t(0xB7DD81BC), int32_t(0x00000000)},
    {"file2.vqa", "", int32_t(0xB7DD81BE), int32_t(0x00000000)},
    {"file3.vqa", "", int32_t(0xB7DD81C0), int32_t(0x00000000)},
    {"file4.vqa", "", int32_t(0xB7DD81C2), int32_t(0x00000000)},
    {"file5.vqa", "", int32_t(0xB7DD81C4), int32_t(0x00000000)},
    {"file6.vqa", "", int32_t(0xB7DD81C6), int32_t(0x00000000)},
    {"file7.vqa", "", int32_t(0xB7DD81C8), int32_t(0x00000000)},
    {"file8.vqa", "", int32_t(0xB7DD81CA), int32_t(0x00000000)},
    {"file9.vqa", "", int32_t(0xB7DD81CC), int32_t(0x00000000)},
    {"findpage.shp", "", int32_t(0xEC0FFAE7), int32_t(0x00000000)},
    {"finish1.aud", "", int32_t(0x81E00B00), int32_t(0x00000000)},
    {"fire01.shp", "", int32_t(0x00000000), int32_t(0x918B3AAC)},
    {"fire02.shp", "", int32_t(0x00000000), int32_t(0xA0632031)},
    {"fire03.shp", "", int32_t(0x00000000), int32_t(0x06142B85)},
    {"fire1.shp", "large fire", int32_t(0xA5EF81CB), int32_t(0x0F09F2EE)},
    {"fire2.shp", "medium fire", int32_t(0xA5EF81CD), int32_t(0x8186F50D)},
    {"fire3.shp", "small fire", int32_t(0xA5EF81CF), int32_t(0x4D2CF593)},
    {"fire4.shp", "very small fire", int32_t(0xA5EF81D1), int32_t(0x47E9FC8A)},
    {"fireamb1.aud", "", int32_t(0xBC2300C9), int32_t(0x00000000)},
    {"firebd1.aud", "", int32_t(0x71F002DE), int32_t(0x00000000)},
    {"firebl1.aud", "", int32_t(0x71F012DE), int32_t(0x00000000)},
    {"firebl2.aud", "", int32_t(0x71F212DE), int32_t(0x00000000)},
    {"firebl3.aud", "flame sound #1", int32_t(0x71F412DE), int32_t(0x00000000)},
    {"firebl4.aud", "", int32_t(0x71F612DE), int32_t(0x00000000)},
    {"firebl5.aud", "", int32_t(0x71F812DE), int32_t(0x00000000)},
    {"firebl6.aud", "", int32_t(0x71FA12DE), int32_t(0x00000000)},
    {"firecrac.aud", "", int32_t(0xE0210ACD), int32_t(0x00000000)},
    {"firepo1.aud", "unit firepower upgraded", int32_t(0x71F018FA), int32_t(0x00000000)},
    {"firepowr.shp", "crate: firepower upgrade", int32_t(0x00000000), int32_t(0xE98B6D87)},
    {"firespew.aud", "", int32_t(0x082906ED), int32_t(0x00000000)},
    {"firestrm.ini", "fs main settings", int32_t(0x00000000), int32_t(0x93201A50)},
    {"firetrap.aud", "", int32_t(0xFA210AEF), int32_t(0x00000000)},
    {"firetrt1.aud", "flame sound #2", int32_t(0xBC470AEF), int32_t(0x00000000)},
    {"fireweb1.aud", "web firing sound", int32_t(0x00000000), int32_t(0x30A36A1A)},
    {"firflsh1.aud", "", int32_t(0xC02F0CDF), int32_t(0x00000000)},
    {"firicn.flc", "", int32_t(0xB1A604EB), int32_t(0x00000000)},
    {"firpass1.aud", "", int32_t(0xE8450CC9), int32_t(0x00000000)},
    {"firpass2.aud", "", int32_t(0xEA450CC9), int32_t(0x00000000)},
    {"firpass3.aud", "", int32_t(0xEC450CC9), int32_t(0x00000000)},
    {"firstrm1.aud", "firestorm defense burning", int32_t(0x00000000), int32_t(0x32D94697)},
    {"fishdeth.csv", "", int32_t(0x0848F2CF), int32_t(0x00000000)},
    {"fishdeth.lsv", "", int32_t(0x0848FBCF), int32_t(0x00000000)},
    {"fishdeth.vqa", "", int32_t(0xF34705CF), int32_t(0x00000000)},
    {"fishdeth_e.vqa", "", int32_t(0x10482B51), int32_t(0x00000000)},
    {"fishdeth_e.vqt", "", int32_t(0x10483E51), int32_t(0x00000000)},
    {"fishdeth_h.pcx", "", int32_t(0x04484843), int32_t(0x00000000)},
    {"fishdeth_h.vqa", "", int32_t(0x10483151), int32_t(0x00000000)},
    {"fishdeth_l.pcx", "", int32_t(0x04485043), int32_t(0x00000000)},
    {"fishdeth_l.vqa", "", int32_t(0x10483951), int32_t(0x00000000)},
    {"fisheye1.aud", "", int32_t(0xC82D18D1), int32_t(0x00000000)},
    {"fist226m.aud", "fist", int32_t(0x300ECAAB), int32_t(0x00000000)},
    {"fix.shp", "service depot", int32_t(0x5D00DADF), int32_t(0x00000000)},
    {"fixicnh.des", "icon: service depot", int32_t(0x824506E3), int32_t(0x00000000)},
    {"fixicnh.tem", "icon: service depot", int32_t(0x823F06F3), int32_t(0x00000000)},
    {"fixicnh.win", "icon: service depot", int32_t(0x82400AF6), int32_t(0x00000000)},
    {"fixicon.shp", "icon: service depot", int32_t(0x824E0BF2), int32_t(0x0B0DCAC8)},
    {"fixit1.aud", "wrench sound", int32_t(0xA7BDCC16), int32_t(0x00000000)},
    {"fixmake.shp", "make: service depot", int32_t(0x923C03EE), int32_t(0x00000000)},
    {"flag.vqa", "flag being raised", int32_t(0xCFD3EEBA), int32_t(0x00000000)},
    {"flag.vqp", "flag being raised", int32_t(0xDED3EEBA), int32_t(0x00000000)},
    {"flagfly.shp", "flag", int32_t(0x7A0811F8), int32_t(0x0EF831E0)},
    {"flaglop1.aud", "", int32_t(0xC3FB10DF), int32_t(0x00000000)},
    {"flair.img", "", int32_t(0xBF978E04), int32_t(0x00000000)},
    {"flair.lmf", "", int32_t(0xBF9D8E03), int32_t(0x00000000)},
    {"flair.lsv", "", int32_t(0xCB9D8E13), int32_t(0x00000000)},
    {"flair.odf", "", int32_t(0xADA38E03), int32_t(0x00000000)},
    {"flair.pcx", "", int32_t(0xABA58E15), int32_t(0x00000000)},
    {"flair.ver", "", int32_t(0xAFB18E0F), int32_t(0x00000000)},
    {"flak.hva", "", int32_t(0x00000000), int32_t(0x3102343E)},
    {"flak.shp", "misc: small explosion", int32_t(0xE6CAEBBA), int32_t(0x9F806782)},
    {"flak.vxl", "", int32_t(0x00000000), int32_t(0xC788EB77)},
    {"flakicon.shp", "", int32_t(0x00000000), int32_t(0x72469ABD)},
    {"flakt.shp", "", int32_t(0x00000000), int32_t(0xE20E110A)},
    {"flaktur.hva", "", int32_t(0x00000000), int32_t(0x8CAAA088)},
    {"flaktur.vxl", "", int32_t(0x00000000), int32_t(0x835CD363)},
    {"flame-e.shp", "single flame e", int32_t(0x91DFD3F6), int32_t(0x00000000)},
    {"flame-n.shp", "single flame n", int32_t(0x91F1D3F6), int32_t(0x00000000)},
    {"flame-ne.shp", "single flame ne", int32_t(0x0FE9DED1), int32_t(0x00000000)},
    {"flame-nw.shp", "single flame nw", int32_t(0x33E9DED1), int32_t(0x00000000)},
    {"flame-s.shp", "single flame s", int32_t(0x91FBD3F6), int32_t(0x00000000)},
    {"flame-se.shp", "single flame se", int32_t(0x0FF3DED1), int32_t(0x00000000)},
    {"flame-sw.shp", "single flame sw", int32_t(0x33F3DED1), int32_t(0x00000000)},
    {"flame-w.shp", "single flame w", int32_t(0x9203D3F6), int32_t(0x00000000)},
    {"flameall.shp", "devil's tongue flame stream", int32_t(0x00000000), int32_t(0x3D38C69F)},
    {"flameguy.shp", "infantry caught on fire", int32_t(0x00000000), int32_t(0xD231B804)},
    {"flamer2.aud", "flame sound", int32_t(0x91AE2AE4), int32_t(0x00000000)},
    {"flamer2.juv", "flame sound", int32_t(0x91C02AED), int32_t(0x00000000)},
    {"flamthro.shp", "-", int32_t(0x00000000), int32_t(0x66CDABC2)},
    {"flamtnk1.aud", "flame tank fire", int32_t(0x00000000), int32_t(0x9D325C7A)},
    {"flapsout.aud", "", int32_t(0x00000000), int32_t(0x04016027)},
    {"flare.flc", "", int32_t(0xE1918DE6), int32_t(0x00000000)},
    {"flare.vqa", "flare man", int32_t(0xEBB18DE4), int32_t(0x00000000)},
    {"flare.vqp", "vqp: flare man", int32_t(0xEBB18DF3), int32_t(0x00000000)},
    {"flare1.aud", "signal flare detected", int32_t(0xCB61D7F8), int32_t(0x00000000)},
    {"flaree1.aud", "signal flare detected to the east", int32_t(0xA5AC10E4), int32_t(0x00000000)},
    {"flaren1.aud", "signal flare detected to the north", int32_t(0xA5AC22E4), int32_t(0x00000000)},
    {"flares1.aud", "signal flare detected to the south", int32_t(0xA5AC2CE4), int32_t(0x00000000)},
    {"flarew1.aud", "signal flare detected to the west", int32_t(0xA5AC34E4), int32_t(0x00000000)},
    {"flata.hva", "", int32_t(0x00000000), int32_t(0xC2214B46)},
    {"flata.vxl", "", int32_t(0x00000000), int32_t(0x7DB84CE1)},
    {"flesh1.aud", "", int32_t(0xCF71D7FE), int32_t(0x00000000)},
    {"flesh2.aud", "", int32_t(0xCF71D9FE), int32_t(0x00000000)},
    {"flgrysmk.shp", "", int32_t(0x00000000), int32_t(0xE1769D4E)},
    {"flies1.aud", "", int32_t(0x9781D814), int32_t(0x00000000)},
    {"flkticon.shp", "", int32_t(0x00000000), int32_t(0x161D87D4)},
    {"flktuico.shp", "", int32_t(0x00000000), int32_t(0xD3DB1535)},
    {"flmspt.shp", "oil pump explosion", int32_t(0xF3922A01), int32_t(0x00000000)},
    {"float.ini", "", int32_t(0x00000000), int32_t(0x969E66B7)},
    {"float.map", "-", int32_t(0x00000000), int32_t(0x5D25AABD)},
    {"float_v2.aud", "floating", int32_t(0xAE3F30EF), int32_t(0x00000000)},
    {"floater.shp", "-", int32_t(0x00000000), int32_t(0xA2EAFB9F)},
    {"floatk1.aud", "tiberium floater attack", int32_t(0x00000000), int32_t(0xBCF58554)},
    {"floatmov.aud", "tiberium floater move", int32_t(0x00000000), int32_t(0xE4A46C0B)},
    {"flood.csv", "", int32_t(0xE3C38DF7), int32_t(0x00000000)},
    {"flood.lsv", "", int32_t(0xE3D58DF7), int32_t(0x00000000)},
    {"flood.vqa", "", int32_t(0xDFE98DE2), int32_t(0x00000000)},
    {"flood_e.vqa", "", int32_t(0x9A0940F7), int32_t(0x00000000)},
    {"flood_e.vqt", "", int32_t(0x9A1C40F7), int32_t(0x00000000)},
    {"flood_h.pcx", "", int32_t(0x9A2632F1), int32_t(0x00000000)},
    {"flood_h.vqa", "", int32_t(0x9A0F40F7), int32_t(0x00000000)},
    {"flood_l.pcx", "", int32_t(0x9A2E32F1), int32_t(0x00000000)},
    {"flood_l.vqa", "", int32_t(0x9A1740F7), int32_t(0x00000000)},
    {"floorup1.aud", "", int32_t(0xE4331CEB), int32_t(0x00000000)},
    {"floorup2.aud", "", int32_t(0xE6331CEB), int32_t(0x00000000)},
    {"flor0001.int", "green floor", int32_t(0xFFEBDAA7), int32_t(0x00000000)},
    {"flor0002.int", "green floor", int32_t(0x01EBDAA7), int32_t(0x00000000)},
    {"flor0003.int", "green floor", int32_t(0x03EBDAA7), int32_t(0x00000000)},
    {"flor0004.int", "green floor", int32_t(0x05EBDAA7), int32_t(0x00000000)},
    {"flor0005.int", "green floor", int32_t(0x07EBDAA7), int32_t(0x00000000)},
    {"flor0006.int", "green floor", int32_t(0x09EBDAA7), int32_t(0x00000000)},
    {"flor0007.int", "green floor", int32_t(0x0BEBDAA7), int32_t(0x00000000)},
    {"florbuzz.aud", "", int32_t(0x42471CCB), int32_t(0x00000000)},
    {"flotmov2.aud", "tiberium floater move", int32_t(0x00000000), int32_t(0xBEF3D2C2)},
    {"flotmov3.aud", "tiberium floater move", int32_t(0x00000000), int32_t(0x8393FB72)},
    {"flotmov4.aud", "tiberium floater move", int32_t(0x00000000), int32_t(0x31B32762)},
    {"flow01.des", "", int32_t(0x00000000), int32_t(0xECE7A7EA)},
    {"flow01.sno", "-", int32_t(0x00000000), int32_t(0x6BC8E8E5)},
    {"flow01.tem", "-", int32_t(0x00000000), int32_t(0x9ABFBE12)},
    {"fluid.vqa", "", int32_t(0xC8018DE2), int32_t(0x00000000)},
    {"flurry.aud", "flurry", int32_t(0x00000000), int32_t(0x204C2BBE)},
    {"flute2.aud", "", int32_t(0xD3B1D9F8), int32_t(0x00000000)},
    {"flytru_e.vqa", "", int32_t(0x1D7531EB), int32_t(0x00000000)},
    {"flyy.vqa", "apache shooting apc", int32_t(0xF403EEBA), int32_t(0x00000000)},
    {"flyy.vqp", "apache shooting apc", int32_t(0x0303EEBA), int32_t(0x00000000)},
    {"focus.shp", "", int32_t(0xE5B39A0F), int32_t(0x11DE37CC)},
    {"fog.shp", "-", int32_t(0x00000000), int32_t(0xD0BCCAF8)},
    {"fogger1a.aud", "fogger", int32_t(0xE3D522D1), int32_t(0x00000000)},
    {"fona01.tem", "-", int32_t(0x00000000), int32_t(0x334588D6)},
    {"fona02.tem", "-", int32_t(0x00000000), int32_t(0x02AD924B)},
    {"fona03.tem", "-", int32_t(0x00000000), int32_t(0xA4DA99FF)},
    {"fona04.tem", "-", int32_t(0x00000000), int32_t(0x617DA771)},
    {"fona05.tem", "-", int32_t(0x00000000), int32_t(0xC70AACC5)},
    {"fona06.tem", "-", int32_t(0x00000000), int32_t(0xF6E2B658)},
    {"fona07.tem", "-", int32_t(0x00000000), int32_t(0x5095BDEC)},
    {"fona08.tem", "-", int32_t(0x00000000), int32_t(0xA6DDCD05)},
    {"fona09.tem", "-", int32_t(0x00000000), int32_t(0x00AAC6B1)},
    {"fona10.tem", "-", int32_t(0x00000000), int32_t(0x599883FC)},
    {"fona11.tem", "-", int32_t(0x00000000), int32_t(0xFFEF8848)},
    {"fona12.tem", "-", int32_t(0x00000000), int32_t(0xCE0792D5)},
    {"fona13.tem", "-", int32_t(0x00000000), int32_t(0x68709961)},
    {"fona14.tem", "-", int32_t(0x00000000), int32_t(0xADD7A7EF)},
    {"fona15.tem", "-", int32_t(0x00000000), int32_t(0x0BA0AC5B)},
    {"font.pal", "", int32_t(0xF4DDEEBA), int32_t(0x7A0B96C6)},
    {"font6.fnt", "font 6", int32_t(0xEDC599D9), int32_t(0x00000000)},
    {"font_ned.fnt", "", int32_t(0x2E122005), int32_t(0x00000000)},
    {"forcicon.shp", "", int32_t(0x00000000), int32_t(0x9CE5644F)},
    {"forcshld.shp", "", int32_t(0x00000000), int32_t(0xBFBD7759)},
    {"ford1.des", "fjord w-e", int32_t(0x9BD199CE), int32_t(0x00000000)},
    {"ford1.sno", "fjord", int32_t(0xADEF99CA), int32_t(0x00000000)},
    {"ford1.tem", "fjord w-e", int32_t(0x9BF199C8), int32_t(0x00000000)},
    {"ford1.win", "fjord w-e", int32_t(0xA3F799C9), int32_t(0x00000000)},
    {"ford2.des", "fjord n-s", int32_t(0x9BD199D0), int32_t(0x00000000)},
    {"ford2.sno", "fjord", int32_t(0xADEF99CC), int32_t(0x00000000)},
    {"ford2.tem", "fjord n-s", int32_t(0x9BF199CA), int32_t(0x00000000)},
    {"ford2.win", "fjord n-s", int32_t(0xA3F799CB), int32_t(0x00000000)},
    {"fore-junk-02.vqa", "", int32_t(0x099953AB), int32_t(0x00000000)},
    {"forestfr.ini", "", int32_t(0x00000000), int32_t(0x016290CD)},
    {"forestfr.map", "-", int32_t(0x00000000), int32_t(0xE5988C1E)},
    {"forestkl.vqa", "guy killing another guy in the forest", int32_t(0xEF313BED), int32_t(0x00000000)},
    {"forestkl.vqp", "guy killing another guy in the forest", int32_t(0xFE313BED), int32_t(0x00000000)},
    {"forstwk1.aud", "", int32_t(0xF4352CEF), int32_t(0x00000000)},
    {"forstwk2.aud", "", int32_t(0xF6352CEF), int32_t(0x00000000)},
    {"forstwk3.aud", "", int32_t(0xF8352CEF), int32_t(0x00000000)},
    {"forstwk4.aud", "", int32_t(0xFA352CEF), int32_t(0x00000000)},
    {"forstwk5.aud", "", int32_t(0xFC352CEF), int32_t(0x00000000)},
    {"forstwk6.aud", "", int32_t(0xFE352CEF), int32_t(0x00000000)},
    {"forstwk7.aud", "", int32_t(0x00352CEF), int32_t(0x00000000)},
    {"forticon.shp", "", int32_t(0x00000000), int32_t(0x54444BF7)},
    {"fortific.wav", "", int32_t(0x00000000), int32_t(0x171DF55C)},
    {"fortress.hva", "", int32_t(0x00000000), int32_t(0x54A391DF)},
    {"fortress.vxl", "", int32_t(0x00000000), int32_t(0xA2294E96)},
    {"fortune1.aud", "", int32_t(0xF8291AF1), int32_t(0x00000000)},
    {"fountain.aud", "", int32_t(0x1A3D00EF), int32_t(0x00000000)},
    {"fourcorners.map", "", int32_t(0x00000000), int32_t(0x76EDF97A)},
    {"fourcornersmw.map", "", int32_t(0x00000000), int32_t(0xBE6A51C4)},
    {"fpain1.aud", "", int32_t(0xA761E80A), int32_t(0x00000000)},
    {"fpain2.aud", "", int32_t(0xA761EA0A), int32_t(0x00000000)},
    {"fpain3.aud", "", int32_t(0xA761EC0A), int32_t(0x00000000)},
    {"fpain4.aud", "", int32_t(0xA761EE0A), int32_t(0x00000000)},
    {"fpls.shp", "circles for flag", int32_t(0xF6E0F3BA), int32_t(0x00000000)},
    {"fpower.shp", "crat: unit firepower upgrade", int32_t(0x039A35EA), int32_t(0x00000000)},
    {"frag1.shp", "medium explosion", int32_t(0xADABA5CB), int32_t(0x00000000)},
    {"frag3.shp", "medium explosion", int32_t(0xADABA5CF), int32_t(0x00000000)},
    {"frai.pcx", "", int32_t(0x00000000), int32_t(0x3DC83CD1)},
    {"frai.shp", "", int32_t(0x00000000), int32_t(0xD2A1D371)},
    {"fre_edhi.pcx", "pict: red alert map editor title screen french", int32_t(0x67E921D0), int32_t(0x00000000)},
    {"french.lng", "", int32_t(0xD17220ED), int32_t(0x00000000)},
    {"frhi0166.pcx", "pict: frozen soldier", int32_t(0xE9D0FBA7), int32_t(0x00000000)},
    {"frlo0166.cps", "pict: frozen soldier", int32_t(0xFCEDEEA7), int32_t(0x00000000)},
    {"frozen.vqa", "frozen soldier", int32_t(0x159A26F3), int32_t(0x00000000)},
    {"frozen.vqp", "vqp: frozen soldier", int32_t(0x159A35F3), int32_t(0x00000000)},
    {"frstbite.map", "", int32_t(0x00000000), int32_t(0xFE451C67)},
    {"frstrun1.aud", "", int32_t(0xF83F34EB), int32_t(0x00000000)},
    {"frstrun2.aud", "", int32_t(0xFA3F34EB), int32_t(0x00000000)},
    {"frstrun3.aud", "", int32_t(0xFC3F34EB), int32_t(0x00000000)},
    {"frstrun4.aud", "", int32_t(0xFE3F34EB), int32_t(0x00000000)},
    {"frstrun5.aud", "", int32_t(0x003F34EB), int32_t(0x00000000)},
    {"fs_sb01.vqa", "-", int32_t(0x00000000), int32_t(0xC768D184)},
    {"fs_title.vqa", "-", int32_t(0x00000000), int32_t(0xA1103CB5)},
    {"fsair.shp", "firestorm animation (with aerial proj/units)", int32_t(0x00000000), int32_t(0x37990006)},
    {"fsalg.pal", "", int32_t(0x00000000), int32_t(0x2A6883EC)},
    {"fsalg.shp", "", int32_t(0x00000000), int32_t(0x49557A06)},
    {"fsasm.shp", "", int32_t(0x00000000), int32_t(0xABECEB6E)},
    {"fsbclg.shp", "", int32_t(0x00000000), int32_t(0xFD213F4F)},
    {"fsbcsm.shp", "", int32_t(0x00000000), int32_t(0xFCCA4386)},
    {"fsbkgdlg.pal", "", int32_t(0x00000000), int32_t(0x3853748F)},
    {"fsbkgdlg.shp", "", int32_t(0x00000000), int32_t(0xFFD62DD0)},
    {"fsbkgdsm.shp", "", int32_t(0x00000000), int32_t(0x47E6853F)},
    {"fsdicon.shp", "icon: firestrom generator", int32_t(0x00000000), int32_t(0x7AC637E1)},
    {"fsgdi01.ini", "", int32_t(0x00000000), int32_t(0xB1030AFA)},
    {"fsgdi01.map", "-", int32_t(0x00000000), int32_t(0xAE3D7388)},
    {"fsgdi02.ini", "", int32_t(0x00000000), int32_t(0x37977854)},
    {"fsgdi02.map", "-", int32_t(0x00000000), int32_t(0x28A90126)},
    {"fsgdi03.ini", "", int32_t(0x00000000), int32_t(0xFCCBABF1)},
    {"fsgdi03.map", "-", int32_t(0x00000000), int32_t(0xE3F5D283)},
    {"fsgdi04.ini", "", int32_t(0x00000000), int32_t(0xE1CE9B49)},
    {"fsgdi04.map", "-", int32_t(0x00000000), int32_t(0xFEF0E23B)},
    {"fsgdi05.ini", "", int32_t(0x00000000), int32_t(0x2A9248EC)},
    {"fsgdi05.map", "-", int32_t(0x00000000), int32_t(0x35AC319E)},
    {"fsgdi06.ini", "", int32_t(0x00000000), int32_t(0xAC063A42)},
    {"fsgdi06.map", "-", int32_t(0x00000000), int32_t(0xB3384330)},
    {"fsgdi07.ini", "", int32_t(0x00000000), int32_t(0x675AE9E7)},
    {"fsgdi07.map", "-", int32_t(0x00000000), int32_t(0x78649095)},
    {"fsgdi08.ini", "", int32_t(0x00000000), int32_t(0x960C5B32)},
    {"fsgdi08.map", "-", int32_t(0x00000000), int32_t(0x89322240)},
    {"fsgdi09.ini", "", int32_t(0x00000000), int32_t(0x5D508897)},
    {"fsgdi09.map", "-", int32_t(0x00000000), int32_t(0x426EF1E5)},
    {"fsgdifnl.vqa", "-", int32_t(0x00000000), int32_t(0x8930F145)},
    {"fsgdiint.vqa", "-", int32_t(0x00000000), int32_t(0x2FE85DEF)},
    {"fsgdim01.vqa", "-", int32_t(0x00000000), int32_t(0xBB5DED70)},
    {"fsgdim02.vqa", "-", int32_t(0x00000000), int32_t(0xFCFD97A0)},
    {"fsgdim03.vqa", "-", int32_t(0x00000000), int32_t(0xC19DBE10)},
    {"fsgdim04.vqa", "-", int32_t(0x00000000), int32_t(0x73BD6200)},
    {"fsgdim05.vqa", "-", int32_t(0x00000000), int32_t(0x4EDD4BB0)},
    {"fsgdim06.vqa", "-", int32_t(0x00000000), int32_t(0x097D3160)},
    {"fsgdim07.vqa", "-", int32_t(0x00000000), int32_t(0x341D18D0)},
    {"fsgdim08.vqa", "-", int32_t(0x00000000), int32_t(0xB64D8F01)},
    {"fsgdim09.vqa", "-", int32_t(0x00000000), int32_t(0x8B2DA6B1)},
    {"fsgrnd.shp", "firestorm animation (with ground proj/units)", int32_t(0x00000000), int32_t(0xD37EBFD9)},
    {"fsgrysmk.shp", "", int32_t(0x00000000), int32_t(0xDC78AD43)},
    {"fsidle.shp", "firestorm animation (blue idle anim)", int32_t(0x00000000), int32_t(0xF63FB858)},
    {"fsmap.aud", "firestorm map screen", int32_t(0x00000000), int32_t(0xE93976AE)},
    {"fsmenu.aud", "firestorm main menu", int32_t(0x00000000), int32_t(0x0D2EBB07)},
    {"fsnod01.ini", "", int32_t(0x00000000), int32_t(0x5446AA3C)},
    {"fsnod01.map", "-", int32_t(0x00000000), int32_t(0x4B78D34E)},
    {"fsnod02.ini", "", int32_t(0x00000000), int32_t(0xD2D2D892)},
    {"fsnod02.map", "-", int32_t(0x00000000), int32_t(0xCDECA1E0)},
    {"fsnod03.ini", "", int32_t(0x00000000), int32_t(0x198E0B37)},
    {"fsnod03.map", "-", int32_t(0x00000000), int32_t(0x06B07245)},
    {"fsnod04.ini", "", int32_t(0x00000000), int32_t(0x048B3B8F)},
    {"fsnod04.map", "-", int32_t(0x00000000), int32_t(0x1BB542FD)},
    {"fsnod05.ini", "", int32_t(0x00000000), int32_t(0xCFD7E82A)},
    {"fsnod05.map", "-", int32_t(0x00000000), int32_t(0xD0E99158)},
    {"fsnod06.ini", "", int32_t(0x00000000), int32_t(0x49439A84)},
    {"fsnod06.map", "-", int32_t(0x00000000), int32_t(0x567DE3F6)},
    {"fsnod07.ini", "", int32_t(0x00000000), int32_t(0x821F4921)},
    {"fsnod07.map", "-", int32_t(0x00000000), int32_t(0x9D213053)},
    {"fsnod08.ini", "", int32_t(0x00000000), int32_t(0x7349FBF4)},
    {"fsnod08.map", "-", int32_t(0x00000000), int32_t(0x6C778286)},
    {"fsnod09.ini", "", int32_t(0x00000000), int32_t(0xB8152851)},
    {"fsnod09.map", "-", int32_t(0x00000000), int32_t(0xA72B5123)},
    {"fsnodfnl.vqa", "-", int32_t(0x00000000), int32_t(0x6C755183)},
    {"fsnodm01.vqa", "-", int32_t(0x00000000), int32_t(0x5E184DB6)},
    {"fsnodm02.vqa", "-", int32_t(0x00000000), int32_t(0x19B83766)},
    {"fsnodm03.vqa", "-", int32_t(0x00000000), int32_t(0x24D81ED6)},
    {"fsnodm04.vqa", "-", int32_t(0x00000000), int32_t(0x96F8C2C6)},
    {"fsnodm05.vqa", "-", int32_t(0x00000000), int32_t(0xAB98EB76)},
    {"fsnodm06.vqa", "-", int32_t(0x00000000), int32_t(0xEC3891A6)},
    {"fsnodm07.vqa", "-", int32_t(0x00000000), int32_t(0xD158B816)},
    {"fsnodm08.vqa", "-", int32_t(0x00000000), int32_t(0x53082FC7)},
    {"fsnodm09.vqa", "-", int32_t(0x00000000), int32_t(0x6E680677)},
    {"fspicon.shp", "icon: firestorm wall section", int32_t(0x00000000), int32_t(0x54831673)},
    {"fsscrn.pal", "", int32_t(0x00000000), int32_t(0x9FAC64B9)},
    {"fsslg.pal", "", int32_t(0x00000000), int32_t(0x0933D239)},
    {"fsslg.shp", "", int32_t(0x00000000), int32_t(0x6A0E2BD3)},
    {"fsssm.shp", "", int32_t(0x00000000), int32_t(0x88B7BABB)},
    {"fstback.pcx", "-", int32_t(0x00000000), int32_t(0xDC4C1E69)},
    {"fstback.vqa", "-", int32_t(0x00000000), int32_t(0x7D859FB3)},
    {"fstdicon.shp", "icon: firestorm defence", int32_t(0x00000000), int32_t(0x51762FCD)},
    {"ftnk.hva", "-", int32_t(0x00000000), int32_t(0x94655442)},
    {"ftnk.shp", "flame tank", int32_t(0xE6E4FBBA), int32_t(0x00000000)},
    {"ftnk.vxl", "flame tank", int32_t(0x00000000), int32_t(0x62EF8B0B)},
    {"ftnkicnh.des", "icon: flame tank", int32_t(0x111B1BD9), int32_t(0x00000000)},
    {"ftnkicnh.tem", "icon: flame tank", int32_t(0x0B1B2BD9), int32_t(0x00000000)},
    {"ftnkicnh.win", "icon: flame tank", int32_t(0x0C1F2ED9), int32_t(0x00000000)},
    {"ftnkicon.shp", "icon: flame tank", int32_t(0x1A202AD9), int32_t(0x00000000)},
    {"ftrk.hva", "", int32_t(0x00000000), int32_t(0xE07196A2)},
    {"ftrk.vxl", "", int32_t(0x00000000), int32_t(0x16FB49EB)},
    {"ftrplat1.aud", "", int32_t(0xE84714DF), int32_t(0x00000000)},
    {"ftrplat2.aud", "", int32_t(0xEA4714DF), int32_t(0x00000000)},
    {"ftur.shp", "bldg: flame tower", int32_t(0xF4F2FBBA), int32_t(0x00000000)},
    {"fturicon.shp", "icon: flame tower", int32_t(0x363C2AD9), int32_t(0x00000000)},
    {"fturmake.shp", "make: flame tower", int32_t(0x243426E1), int32_t(0x00000000)},
    {"ftwood1.aud", "", int32_t(0x9A042EF8), int32_t(0x00000000)},
    {"ftwood2.aud", "", int32_t(0x9A062EF8), int32_t(0x00000000)},
    {"ftwood3.aud", "", int32_t(0x9A082EF8), int32_t(0x00000000)},
    {"ftwood5.aud", "", int32_t(0x9A0C2EF8), int32_t(0x00000000)},
    {"ftwood6.aud", "", int32_t(0x9A0E2EF8), int32_t(0x00000000)},
    {"fullfnt3.pal", "-", int32_t(0x00000000), int32_t(0x21437A9F)},
    {"fullfnt3.shp", "-", int32_t(0x00000000), int32_t(0xE6C623C0)},
    {"fv.hva", "", int32_t(0x00000000), int32_t(0xB0F09E8A)},
    {"fv.vxl", "", int32_t(0x00000000), int32_t(0x609F7E0E)},
    {"fvicon.shp", "", int32_t(0x00000000), int32_t(0x6F812ACA)},
    {"fvtur.hva", "", int32_t(0x00000000), int32_t(0xAAB0BF2E)},
    {"fvtur.vxl", "", int32_t(0x00000000), int32_t(0x1529B889)},
    {"fvtur1.hva", "", int32_t(0x00000000), int32_t(0xDF88ED4A)},
    {"fvtur1.vxl", "", int32_t(0x00000000), int32_t(0x0FE70DCE)},
    {"fvtur10.hva", "", int32_t(0x00000000), int32_t(0x99DC20A8)},
    {"fvtur10.vxl", "", int32_t(0x00000000), int32_t(0x962A5343)},
    {"fvtur11.hva", "", int32_t(0x00000000), int32_t(0x5280F30D)},
    {"fvtur11.vxl", "", int32_t(0x00000000), int32_t(0x5D7680E6)},
    {"fvtur12.hva", "", int32_t(0x00000000), int32_t(0xD41481A3)},
    {"fvtur12.vxl", "", int32_t(0x00000000), int32_t(0xDBE2F248)},
    {"fvtur13.hva", "", int32_t(0x00000000), int32_t(0x1F485206)},
    {"fvtur13.vxl", "", int32_t(0x00000000), int32_t(0x10BE21ED)},
    {"fvtur14.hva", "", int32_t(0x00000000), int32_t(0x024D62BE)},
    {"fvtur14.vxl", "", int32_t(0x00000000), int32_t(0x0DBB1155)},
    {"fvtur2.hva", "", int32_t(0x00000000), int32_t(0xEE60F7D7)},
    {"fvtur2.vxl", "", int32_t(0x00000000), int32_t(0x3E0F1753)},
    {"fvtur3.hva", "", int32_t(0x00000000), int32_t(0x4817FC63)},
    {"fvtur3.vxl", "", int32_t(0x00000000), int32_t(0x98781CE7)},
    {"fvtur4.hva", "", int32_t(0x00000000), int32_t(0x8DB0C2ED)},
    {"fvtur4.vxl", "", int32_t(0x00000000), int32_t(0x5DDF2269)},
    {"fvtur5.hva", "", int32_t(0x00000000), int32_t(0x2BC7C959)},
    {"fvtur5.vxl", "", int32_t(0x00000000), int32_t(0xFBA829DD)},
    {"fvtur6.hva", "", int32_t(0x00000000), int32_t(0x1A2FD3C4)},
    {"fvtur6.vxl", "", int32_t(0x00000000), int32_t(0xCA403340)},
    {"fvtur7.hva", "", int32_t(0x00000000), int32_t(0xBC58D870)},
    {"fvtur7.vxl", "", int32_t(0x00000000), int32_t(0x6C3738F4)},
    {"fvtur8.hva", "", int32_t(0x00000000), int32_t(0x4A10A899)},
    {"fvtur8.vxl", "", int32_t(0x00000000), int32_t(0x9A7F481D)},
    {"fvtur9.hva", "", int32_t(0x00000000), int32_t(0xEC67A32D)},
    {"fvtur9.vxl", "", int32_t(0x00000000), int32_t(0x3C0843A9)},
    {"fvuico.shp", "", int32_t(0x00000000), int32_t(0x36E5DFC9)},
    {"fwp.aud", "fight win prevail", int32_t(0x5CE503CD), int32_t(0x00000000)},
    {"fyell1.aud", "", int32_t(0xB3720C06), int32_t(0x00000000)},
    {"fyell2.aud", "", int32_t(0xB3720E06), int32_t(0x00000000)},
    {"fyell3.aud", "", int32_t(0xB3721006), int32_t(0x00000000)},
    {"fyell4.aud", "", int32_t(0xB3721206), int32_t(0x00000000)},
    {"g_canyon.ini", "", int32_t(0x00000000), int32_t(0xA5C7CDC2)},
    {"g_canyon.map", "-", int32_t(0x00000000), int32_t(0x413DD111)},
    {"g_knoll.ini", "", int32_t(0x00000000), int32_t(0xF5B51385)},
    {"g_knoll.map", "-", int32_t(0x00000000), int32_t(0xEA8B6AF7)},
    {"gaairc.shp", "", int32_t(0x00000000), int32_t(0x737938BD)},
    {"gaairc_a.shp", "", int32_t(0x00000000), int32_t(0xACD60B64)},
    {"gaairc_b.shp", "", int32_t(0x00000000), int32_t(0xEB7671B4)},
    {"gaairc_c.shp", "", int32_t(0x00000000), int32_t(0xD6165804)},
    {"gaaircbb.shp", "", int32_t(0x00000000), int32_t(0x543E60F1)},
    {"gaaircmk.shp", "", int32_t(0x00000000), int32_t(0xA878B055)},
    {"gaarty.shp", "-", int32_t(0x00000000), int32_t(0x582D2E16)},
    {"gaartymk.shp", "-", int32_t(0x00000000), int32_t(0x832CA6FE)},
    {"gacnst.shp", "-", int32_t(0x00000000), int32_t(0x7D3E2797)},
    {"gacnst_a.shp", "-", int32_t(0x00000000), int32_t(0xA291144E)},
    {"gacnst_b.shp", "-", int32_t(0x00000000), int32_t(0xE5316E9E)},
    {"gacnst_c.shp", "-", int32_t(0x00000000), int32_t(0xD851472E)},
    {"gacnst_d.shp", "-", int32_t(0x00000000), int32_t(0x6A719B3E)},
    {"gacnstdm.shp", "", int32_t(0x00000000), int32_t(0x0E700B17)},
    {"gacnstmk.shp", "-", int32_t(0x00000000), int32_t(0xA63FAF7F)},
    {"gacsph.shp", "", int32_t(0x00000000), int32_t(0x0E4073E8)},
    {"gacsph_a.shp", "", int32_t(0x00000000), int32_t(0xD1EF4031)},
    {"gacsph_e.shp", "", int32_t(0x00000000), int32_t(0x246FE6F1)},
    {"gacsph_f.shp", "", int32_t(0x00000000), int32_t(0x63CF9C21)},
    {"gacsph_g.shp", "", int32_t(0x00000000), int32_t(0x5EAFB591)},
    {"gacsph_h.shp", "", int32_t(0x00000000), int32_t(0xDCFF2240)},
    {"gacsphdm.shp", "", int32_t(0x00000000), int32_t(0x7D0E5F68)},
    {"gacsphmk.shp", "", int32_t(0x00000000), int32_t(0xD541FB00)},
    {"gactwr.shp", "-", int32_t(0x00000000), int32_t(0xA34AD4B8)},
    {"gactwr_a.shp", "-", int32_t(0x00000000), int32_t(0x7CE5E761)},
    {"gactwr_b.shp", "-", int32_t(0x00000000), int32_t(0x3B459DB1)},
    {"gactwr_c.shp", "-", int32_t(0x00000000), int32_t(0x0625B401)},
    {"gactwr_d.shp", "-", int32_t(0x00000000), int32_t(0xB4056811)},
    {"gactwrmk.shp", "-", int32_t(0x00000000), int32_t(0x784B5C50)},
    {"gadept.shp", "-", int32_t(0x00000000), int32_t(0x9338A5D0)},
    {"gadept_a.shp", "-", int32_t(0x00000000), int32_t(0x4C979609)},
    {"gadept_b.shp", "-", int32_t(0x00000000), int32_t(0x0B37ECD9)},
    {"gadept_c.shp", "-", int32_t(0x00000000), int32_t(0x3657C569)},
    {"gadept_d.shp", "-", int32_t(0x00000000), int32_t(0x84771979)},
    {"gadeptbb.shp", "-", int32_t(0x00000000), int32_t(0xB47FFD9C)},
    {"gadeptmk.shp", "-", int32_t(0x00000000), int32_t(0x48392D38)},
    {"gadpsa.shp", "-", int32_t(0x00000000), int32_t(0xCE061664)},
    {"gadpsa_a.shp", "-", int32_t(0x00000000), int32_t(0x11A925BD)},
    {"gadpsamk.shp", "-", int32_t(0x00000000), int32_t(0x15079E8C)},
    {"gadrop.shp", "-", int32_t(0x00000000), int32_t(0x0A4D8DFC)},
    {"gadrop_a.shp", "-", int32_t(0x00000000), int32_t(0xD5E2BE25)},
    {"gadrop_b.shp", "-", int32_t(0x00000000), int32_t(0x9242C4F5)},
    {"gadropmk.shp", "-", int32_t(0x00000000), int32_t(0xD14C0514)},
    {"gafdsf.shp", "-", int32_t(0x00000000), int32_t(0xFE78EBAA)},
    {"gafire.shp", "-", int32_t(0x00000000), int32_t(0xF27516FE)},
    {"gafire_a.shp", "-", int32_t(0x00000000), int32_t(0x2DDA2527)},
    {"gafire_b.shp", "-", int32_t(0x00000000), int32_t(0x6A7A5FF7)},
    {"gafire_c.shp", "-", int32_t(0x00000000), int32_t(0x571A7647)},
    {"gafiremk.shp", "-", int32_t(0x00000000), int32_t(0x29749E16)},
    {"gafsdf.shp", "-", int32_t(0x00000000), int32_t(0x40A7FC20)},
    {"gafsdf_a.shp", "-", int32_t(0x00000000), int32_t(0x9F08CFF9)},
    {"gafwll.shp", "", int32_t(0x00000000), int32_t(0x6ADEE9D7)},
    {"gagap.shp", "", int32_t(0x00000000), int32_t(0xAE45E441)},
    {"gagapmk.shp", "", int32_t(0x00000000), int32_t(0x7270A9CD)},
    {"gagate_a.shp", "-", int32_t(0x00000000), int32_t(0xBFAFE586)},
    {"gagate_b.shp", "-", int32_t(0x00000000), int32_t(0xF80F9F56)},
    {"gagateza.shp", "-", int32_t(0x00000000), int32_t(0xEF627435)},
    {"gagatezb.shp", "-", int32_t(0x00000000), int32_t(0xA8C20EE5)},
    {"gagcan.shp", "", int32_t(0x00000000), int32_t(0x78AA956C)},
    {"gagcanmk.shp", "", int32_t(0x00000000), int32_t(0xA3AB1D84)},
    {"gagreen.shp", "-", int32_t(0x00000000), int32_t(0xB04437E2)},
    {"gahpad.shp", "-", int32_t(0x00000000), int32_t(0xB89CEF1B)},
    {"gahpad_a.shp", "-", int32_t(0x00000000), int32_t(0x6733DCC2)},
    {"gahpadbb.shp", "-", int32_t(0x00000000), int32_t(0x9FDBB757)},
    {"gahpadmk.shp", "-", int32_t(0x00000000), int32_t(0x639D67F3)},
    {"gaicbm.shp", "-", int32_t(0x00000000), int32_t(0xD904B8A1)},
    {"gaicbm_a.shp", "-", int32_t(0x00000000), int32_t(0x06AB8B78)},
    {"gaicbmmk.shp", "-", int32_t(0x00000000), int32_t(0x02053049)},
    {"gakodk.shp", "-", int32_t(0x00000000), int32_t(0x9E7AA735)},
    {"gakodk_a.shp", "-", int32_t(0x00000000), int32_t(0x41D594EC)},
    {"gakodk_b.shp", "-", int32_t(0x00000000), int32_t(0x0675EE3C)},
    {"gakodk_c.shp", "-", int32_t(0x00000000), int32_t(0x3B15C78C)},
    {"galite.shp", "-", int32_t(0x00000000), int32_t(0x23388FB0)},
    {"game.fnt", "", int32_t(0x00000000), int32_t(0xB1D57AC2)},
    {"gamefrm1.aud", "game forming", int32_t(0x00000000), int32_t(0x245E3C75)},
    {"gameinfo.dat", "", int32_t(0x0802E5DD), int32_t(0x00000000)},
    {"gameover.vqa", "tanks going onto plane tank store being locked up", int32_t(0xFB1107E9), int32_t(0x00000000)},
    {"gameover.vqp", "tanks going onto plane tank store being locked up", int32_t(0x0A1107E9), int32_t(0x00000000)},
    {"gaoldcc1.shp", "ruined old c&c construction yard", int32_t(0x00000000), int32_t(0xCF9A641B)},
    {"gaoldcc2.shp", "ruined old c&c temple", int32_t(0x00000000), int32_t(0x883A1ECB)},
    {"gaoldcc3.shp", "ruined old c&c weapons factory", int32_t(0x00000000), int32_t(0xB55A377B)},
    {"gaoldcc4.shp", "ruined old c&c refinery", int32_t(0x00000000), int32_t(0x077AEB6B)},
    {"gaoldcc5.shp", "ruined old c&c advanced power", int32_t(0x00000000), int32_t(0x3A1AC2DB)},
    {"gaoldcc6.shp", "ruined old c&c silos", int32_t(0x00000000), int32_t(0x7DBAB80B)},
    {"gaorep.shp", "", int32_t(0x00000000), int32_t(0x636D6AC3)},
    {"gaorep_a.shp", "", int32_t(0x00000000), int32_t(0xBCC2591A)},
    {"gaorepmk.shp", "", int32_t(0x00000000), int32_t(0xB86CE22B)},
    {"gap.shp", "bldg: gap generator", int32_t(0x5CF0CAE1), int32_t(0x52FA8318)},
    {"gap.sno", "-", int32_t(0x00000000), int32_t(0x9B2DF134)},
    {"gapave.shp", "-", int32_t(0x00000000), int32_t(0xE7574BB3)},
    {"gapicon.shp", "icon: gap generator", int32_t(0x822DEBF6), int32_t(0x39BC2716)},
    {"gapile.shp", "-", int32_t(0x00000000), int32_t(0xB1F4C448)},
    {"gapile_a.shp", "-", int32_t(0x00000000), int32_t(0x6E5BF791)},
    {"gapile_b.shp", "-", int32_t(0x00000000), int32_t(0x29FB8D41)},
    {"gapile_c.shp", "-", int32_t(0x00000000), int32_t(0x149BA4F1)},
    {"gapiledm.shp", "", int32_t(0x00000000), int32_t(0xC2BAE8C8)},
    {"gapilemk.shp", "-", int32_t(0x00000000), int32_t(0x6AF54CA0)},
    {"gapill.shp", "", int32_t(0x00000000), int32_t(0x246C819B)},
    {"gapillmk.shp", "", int32_t(0x00000000), int32_t(0xFF6D0973)},
    {"gaplug.shp", "-", int32_t(0x00000000), int32_t(0x0F08BA2E)},
    {"gaplug_a.shp", "-", int32_t(0x00000000), int32_t(0xD0A789F7)},
    {"gaplug_b.shp", "-", int32_t(0x00000000), int32_t(0x9707F327)},
    {"gaplug_c.shp", "-", int32_t(0x00000000), int32_t(0xAA67DA97)},
    {"gaplug_d.shp", "-", int32_t(0x00000000), int32_t(0x18470687)},
    {"gaplug_e.shp", "-", int32_t(0x00000000), int32_t(0x25272F37)},
    {"gaplug_f.shp", "-", int32_t(0x00000000), int32_t(0x628755E7)},
    {"gaplugmk.shp", "-", int32_t(0x00000000), int32_t(0xD40932C6)},
    {"gapmake.shp", "make: gap generator", int32_t(0x921BE3F2), int32_t(0xB8FDA5B7)},
    {"gapmake.sno", "-", int32_t(0x00000000), int32_t(0x712AD79B)},
    {"gapowr.shp", "-", int32_t(0x00000000), int32_t(0x414632FF)},
    {"gapowr_a.shp", "-", int32_t(0x00000000), int32_t(0x9EE90126)},
    {"gapowr_b.shp", "-", int32_t(0x00000000), int32_t(0xD9497BF6)},
    {"gapowrmk.shp", "-", int32_t(0x00000000), int32_t(0x9A47BA17)},
    {"gapris.shp", "", int32_t(0x00000000), int32_t(0xD38FBF74)},
    {"gapris_a.shp", "", int32_t(0x00000000), int32_t(0x0C208CAD)},
    {"gapris_b.shp", "", int32_t(0x00000000), int32_t(0x4B80F67D)},
    {"gaprisdm.shp", "", int32_t(0x00000000), int32_t(0xA0C193F4)},
    {"gaprismk.shp", "", int32_t(0x00000000), int32_t(0x088E379C)},
    {"garadr.shp", "-", int32_t(0x00000000), int32_t(0x7F450F98)},
    {"garadr_a.shp", "-", int32_t(0x00000000), int32_t(0xA0EA3C41)},
    {"garadrmk.shp", "-", int32_t(0x00000000), int32_t(0xA4448770)},
    {"garbage.aud", "", int32_t(0x6617E8E0), int32_t(0x00000000)},
    {"garbage4.aud", "", int32_t(0xB628D4CD), int32_t(0x00000000)},
    {"garden1.aud", "", int32_t(0x6DEFF6E8), int32_t(0x00000000)},
    {"garefn.shp", "", int32_t(0x00000000), int32_t(0xC0F2AF53)},
    {"garefnbb.shp", "", int32_t(0x00000000), int32_t(0xE7B5F71F)},
    {"garefnl1.shp", "", int32_t(0x00000000), int32_t(0x63CD0C70)},
    {"garefnl2.shp", "", int32_t(0x00000000), int32_t(0x246D76A0)},
    {"garefnl3.shp", "", int32_t(0x00000000), int32_t(0x190D5F10)},
    {"garefnmk.shp", "", int32_t(0x00000000), int32_t(0x1BF327BB)},
    {"garefnor.shp", "", int32_t(0x00000000), int32_t(0x3BCB7343)},
    {"gargle1.aud", "", int32_t(0x79EFE4F6), int32_t(0x00000000)},
    {"gargmov1.aud", "", int32_t(0xC44AE4E5), int32_t(0x00000000)},
    {"garobo.shp", "", int32_t(0x00000000), int32_t(0x77E12083)},
    {"garobo_a.shp", "", int32_t(0x00000000), int32_t(0xA84E135A)},
    {"garobomk.shp", "", int32_t(0x00000000), int32_t(0xACE0A86B)},
    {"gasand.shp", "-", int32_t(0x00000000), int32_t(0x0549D19A)},
    {"gasilo.shp", "-", int32_t(0x00000000), int32_t(0xFEB32005)},
    {"gasilo_a.shp", "-", int32_t(0x00000000), int32_t(0x211C13DC)},
    {"gasilo_b.shp", "-", int32_t(0x00000000), int32_t(0x66BC690C)},
    {"gasilomk.shp", "-", int32_t(0x00000000), int32_t(0x25B2A8ED)},
    {"gaslrgmk.shp", "veinhole creating gas animation", int32_t(0x00000000), int32_t(0x35FB80DC)},
    {"gaspot.shp", "-", int32_t(0x00000000), int32_t(0x15861BF8)},
    {"gaspot_a.shp", "-", int32_t(0x00000000), int32_t(0xCA292821)},
    {"gaspotmk.shp", "-", int32_t(0x00000000), int32_t(0xCE879310)},
    {"gaspst.shp", "", int32_t(0x00000000), int32_t(0x3E923F9C)},
    {"gaspst_a.shp", "", int32_t(0x00000000), int32_t(0xE13D0C45)},
    {"gaspstmk.shp", "", int32_t(0x00000000), int32_t(0xE593B774)},
    {"gassy1.aud", "", int32_t(0xCFA9AC24), int32_t(0x00000000)},
    {"gastank.hva", "-", int32_t(0x00000000), int32_t(0xF9E2D9BD)},
    {"gastank.vxl", "debris", int32_t(0x00000000), int32_t(0xF614AA56)},
    {"gat2icon.shp", "icon: gdi gate", int32_t(0x00000000), int32_t(0xBFF0A4F7)},
    {"gatec1.aud", "", int32_t(0x97ADABF8), int32_t(0x00000000)},
    {"gatech.shp", "-", int32_t(0x00000000), int32_t(0xE6DCE44A)},
    {"gatech_a.shp", "-", int32_t(0x00000000), int32_t(0x3973D793)},
    {"gatechmk.shp", "-", int32_t(0x00000000), int32_t(0x3DDD6CA2)},
    {"gatedwn1.aud", "", int32_t(0xBC42F4D3), int32_t(0x696CCC23)},
    {"gateicon.shp", "icon: gdi gate", int32_t(0x00000000), int32_t(0x2B320AEB)},
    {"gateo1.aud", "", int32_t(0x97ADAC10), int32_t(0x00000000)},
    {"gateup1.aud", "gate going up", int32_t(0x00000000), int32_t(0xC7156785)},
    {"gatick.shp", "-", int32_t(0x00000000), int32_t(0x31000DC3)},
    {"gatickmk.shp", "-", int32_t(0x00000000), int32_t(0xEA01852B)},
    {"gauge.aud", "", int32_t(0xC7D761EB), int32_t(0xF73EC012)},
    {"gauge.shp", "", int32_t(0xADFB61F7), int32_t(0x00000000)},
    {"gaugeend.aud", "", int32_t(0xEA46D0D5), int32_t(0xA5816D5D)},
    {"gauges.cps", "pict:", int32_t(0xA3B1FEF7), int32_t(0x00000000)},
    {"gaunt1.aud", "", int32_t(0xBBB1AC1A), int32_t(0x00000000)},
    {"gawall.shp", "-", int32_t(0x00000000), int32_t(0x7D6838FA)},
    {"gaweap.shp", "-", int32_t(0x00000000), int32_t(0x1BFF8A9D)},
    {"gaweap_1.shp", "-", int32_t(0x00000000), int32_t(0x3D82598B)},
    {"gaweap_2.shp", "-", int32_t(0x00000000), int32_t(0x7A22235B)},
    {"gaweap_3.shp", "", int32_t(0x00000000), int32_t(0x47420AEB)},
    {"gaweap_4.shp", "", int32_t(0x00000000), int32_t(0xF562D6FB)},
    {"gaweap_a.shp", "-", int32_t(0x00000000), int32_t(0xC450B944)},
    {"gaweap_b.shp", "-", int32_t(0x00000000), int32_t(0x83F0C394)},
    {"gaweap_c.shp", "-", int32_t(0x00000000), int32_t(0xBE90EA24)},
    {"gaweap_d.shp", "-", int32_t(0x00000000), int32_t(0x0CB03634)},
    {"gaweapbb.shp", "-", int32_t(0x00000000), int32_t(0x3CB8D2D1)},
    {"gaweapmk.shp", "-", int32_t(0x00000000), int32_t(0xC0FE0275)},
    {"gaweth.shp", "", int32_t(0x00000000), int32_t(0x7B95677B)},
    {"gaweth_e.shp", "", int32_t(0x00000000), int32_t(0x51BAF262)},
    {"gaweth_f.shp", "", int32_t(0x00000000), int32_t(0x161A88B2)},
    {"gaweth_g.shp", "", int32_t(0x00000000), int32_t(0x2B7AA102)},
    {"gaweth_h.shp", "", int32_t(0x00000000), int32_t(0xA92A36D3)},
    {"gawethmk.shp", "", int32_t(0x00000000), int32_t(0xA094EF93)},
    {"gayard.shp", "", int32_t(0x00000000), int32_t(0x397F6537)},
    {"gayard_a.shp", "", int32_t(0x00000000), int32_t(0xE6D056EE)},
    {"gayard_c.shp", "", int32_t(0x00000000), int32_t(0x9C10058E)},
    {"gayard_d.shp", "", int32_t(0x00000000), int32_t(0x2E30D99E)},
    {"gayard_s.shp", "", int32_t(0x00000000), int32_t(0xFCF0920C)},
    {"gayardmk.shp", "", int32_t(0x00000000), int32_t(0xE27EEDDF)},
    {"gb51445403e.aud", "", int32_t(0xB74D9EAB), int32_t(0x00000000)},
    {"gbayicon.shp", "icon: dropship bay", int32_t(0x00000000), int32_t(0x39A39723)},
    {"gbfix01.ubn", "", int32_t(0x00000000), int32_t(0xB7D667C6)},
    {"gbfix01.urb", "", int32_t(0x00000000), int32_t(0x07458BBA)},
    {"gbfix02.ubn", "", int32_t(0x00000000), int32_t(0x31421568)},
    {"gbfix02.urb", "", int32_t(0x00000000), int32_t(0x81D1F914)},
    {"gbfix03.ubn", "", int32_t(0x00000000), int32_t(0xFA1EC6CD)},
    {"gbfix03.urb", "", int32_t(0x00000000), int32_t(0x4A8D2AB1)},
    {"gbfix04.ubn", "", int32_t(0x00000000), int32_t(0xE71BF675)},
    {"gbfix04.urb", "", int32_t(0x00000000), int32_t(0x57881A09)},
    {"gbfix05.ubn", "", int32_t(0x00000000), int32_t(0x2C4725D0)},
    {"gbfix05.urb", "", int32_t(0x00000000), int32_t(0x9CD4C9AC)},
    {"gbfix06.ubn", "", int32_t(0x00000000), int32_t(0xAAD3577E)},
    {"gbfix06.urb", "", int32_t(0x00000000), int32_t(0x1A40BB02)},
    {"gbfix07.ubn", "", int32_t(0x00000000), int32_t(0x618F84DB)},
    {"gbfix07.urb", "", int32_t(0x00000000), int32_t(0xD11C68A7)},
    {"gbfix08.ubn", "", int32_t(0x00000000), int32_t(0x90D9360E)},
    {"gbfix08.urb", "", int32_t(0x00000000), int32_t(0x204ADA72)},
    {"gbri.pcx", "", int32_t(0x00000000), int32_t(0x13FED0B4)},
    {"gbri.shp", "", int32_t(0x00000000), int32_t(0xFC973F14)},
    {"gbshard1.aud", "", int32_t(0xC82AEECD), int32_t(0x00000000)},
    {"gcanicon.shp", "", int32_t(0x00000000), int32_t(0x308C675B)},
    {"gclock2.shp", "-", int32_t(0x00000000), int32_t(0xA7F76F92)},
    {"gclockb1.aud", "", int32_t(0xE40AE4D1), int32_t(0x00000000)},
    {"gclockb2.aud", "", int32_t(0xE60AE4D1), int32_t(0x00000000)},
    {"gclockc1.aud", "", int32_t(0xE40CE4D1), int32_t(0x00000000)},
    {"gclockc2.aud", "", int32_t(0xE60CE4D1), int32_t(0x00000000)},
    {"gclockt1.aud", "", int32_t(0xE42EE4D1), int32_t(0x00000000)},
    {"gclockt2.aud", "", int32_t(0xE62EE4D1), int32_t(0x00000000)},
    {"gclockw1.aud", "", int32_t(0xE434E4D1), int32_t(0x00000000)},
    {"gclockw2.aud", "", int32_t(0xE634E4D1), int32_t(0x00000000)},
    {"gcmuzzle.shp", "", int32_t(0x00000000), int32_t(0xF513F713)},
    {"gdaircmk.shp", "", int32_t(0x00000000), int32_t(0xD92F1C17)},
    {"gdansk.vqp", "", int32_t(0xE561F814), int32_t(0x00000000)},
    {"gdcnstmk.shp", "", int32_t(0x00000000), int32_t(0xD768033D)},
    {"gdcommmk.shp", "", int32_t(0x00000000), int32_t(0x5B64ED7A)},
    {"gdcsphmk.shp", "", int32_t(0x00000000), int32_t(0xA4165742)},
    {"gddeptmk.shp", "", int32_t(0x00000000), int32_t(0x396E817A)},
    {"gdgapmk.shp", "", int32_t(0x00000000), int32_t(0x0327058F)},
    {"gdgate_a.shp", "", int32_t(0x00000000), int32_t(0xCEF849C4)},
    {"gdgcanmk.shp", "", int32_t(0x00000000), int32_t(0xD2FCB1C6)},
    {"gdgiicon.shp", "", int32_t(0x00000000), int32_t(0x70C86F56)},
    {"gdgiuico.shp", "", int32_t(0x00000000), int32_t(0xB50EFDB7)},
    {"gdi-01.aud", "-", int32_t(0x00000000), int32_t(0x39354EB2)},
    {"gdi-02.aud", "-", int32_t(0x00000000), int32_t(0x08DD542F)},
    {"gdi-03a.aud", "-", int32_t(0x00000000), int32_t(0xAADE1745)},
    {"gdi-03b.aud", "-", int32_t(0x00000000), int32_t(0x2C4A65EB)},
    {"gdi-04.aud", "-", int32_t(0x00000000), int32_t(0x6B0D6115)},
    {"gdi-05a.aud", "-", int32_t(0x00000000), int32_t(0xC90E227F)},
    {"gdi-05b.aud", "-", int32_t(0x00000000), int32_t(0x4F9A50D1)},
    {"gdi-06a.aud", "-", int32_t(0x00000000), int32_t(0xF8E638E2)},
    {"gdi-06b.aud", "-", int32_t(0x00000000), int32_t(0x7E724A4C)},
    {"gdi-07.aud", "-", int32_t(0x00000000), int32_t(0x5AE57B88)},
    {"gdi-08.aud", "-", int32_t(0x00000000), int32_t(0xACAD0B61)},
    {"gdi-09a.aud", "-", int32_t(0x00000000), int32_t(0x0EAE480B)},
    {"gdi-09b.aud", "-", int32_t(0x00000000), int32_t(0x883A3AA5)},
    {"gdi-09c.aud", "-", int32_t(0x00000000), int32_t(0x4366E900)},
    {"gdi-09d.aud", "-", int32_t(0x00000000), int32_t(0x5E63D9B8)},
    {"gdi-10a.aud", "-", int32_t(0x00000000), int32_t(0x579C0D46)},
    {"gdi-10b.aud", "-", int32_t(0x00000000), int32_t(0xD1087FE8)},
    {"gdi-11.aud", "-", int32_t(0x00000000), int32_t(0xF59F4E2C)},
    {"gdi-12.aud", "-", int32_t(0x00000000), int32_t(0xC47754B1)},
    {"gdi01_sb.vqa", "-", int32_t(0x00000000), int32_t(0xAB553214)},
    {"gdi02_sb.vqa", "-", int32_t(0x00000000), int32_t(0x25DA35F7)},
    {"gdi03_sb.vqa", "-", int32_t(0x00000000), int32_t(0xE9703569)},
    {"gdi1.vqa", "capture the beachead", int32_t(0xA3E3DEBC), int32_t(0x00000000)},
    {"gdi1.vqp", "capture the beachead", int32_t(0xB2E3DEBC), int32_t(0x00000000)},
    {"gdi10.vqa", "play with the orcas", int32_t(0x67D16DBE), int32_t(0x00000000)},
    {"gdi10.vqp", "play with the orcas", int32_t(0x67D16DCD), int32_t(0x00000000)},
    {"gdi10a.ini", "", int32_t(0x00000000), int32_t(0xAA7CEE1C)},
    {"gdi10a.map", "-", int32_t(0x00000000), int32_t(0x84D7DDE4)},
    {"gdi10b.ini", "", int32_t(0x00000000), int32_t(0x9B94F481)},
    {"gdi10b.map", "-", int32_t(0x00000000), int32_t(0xB53FC779)},
    {"gdi11.vqa", "find delphi", int32_t(0x67D16DC0), int32_t(0x00000000)},
    {"gdi11.vqp", "find delphi", int32_t(0x67D16DCF), int32_t(0x00000000)},
    {"gdi11a.ini", "", int32_t(0x00000000), int32_t(0x66D6EE82)},
    {"gdi11a.map", "-", int32_t(0x00000000), int32_t(0x487DDD7A)},
    {"gdi12.vqa", "get mobius", int32_t(0x67D16DC2), int32_t(0x00000000)},
    {"gdi12.vqp", "get mobius", int32_t(0x67D16DD1), int32_t(0x00000000)},
    {"gdi12a.ini", "", int32_t(0x00000000), int32_t(0xE859E961)},
    {"gdi12a.map", "-", int32_t(0x00000000), int32_t(0xC6F2DA99)},
    {"gdi13.vqa", "destroy bio lab", int32_t(0x67D16DC4), int32_t(0x00000000)},
    {"gdi13.vqp", "destroy bio lab", int32_t(0x67D16DD3), int32_t(0x00000000)},
    {"gdi14.vqa", "destroy nod forces", int32_t(0x67D16DC6), int32_t(0x00000000)},
    {"gdi14.vqp", "destroy nod forces", int32_t(0x67D16DD5), int32_t(0x00000000)},
    {"gdi15.vqa", "destroy nod base", int32_t(0x67D16DC8), int32_t(0x00000000)},
    {"gdi15.vqp", "destroy nod base", int32_t(0x67D16DD7), int32_t(0x00000000)},
    {"gdi1a.ini", "", int32_t(0x00000000), int32_t(0x7E1E4740)},
    {"gdi1a.map", "-", int32_t(0x00000000), int32_t(0xB5A58B4A)},
    {"gdi2.vqa", "destroy nod refinery", int32_t(0xA5E3DEBC), int32_t(0x00000000)},
    {"gdi2.vqp", "destroy nod refinery", int32_t(0xB4E3DEBC), int32_t(0x00000000)},
    {"gdi2a.ini", "", int32_t(0x00000000), int32_t(0x47937B85)},
    {"gdi2a.map", "-", int32_t(0x00000000), int32_t(0x8C28B78F)},
    {"gdi3.vqa", "destroy sam sites", int32_t(0xA7E3DEBC), int32_t(0x00000000)},
    {"gdi3.vqp", "destroy sam sites", int32_t(0xB6E3DEBC), int32_t(0x00000000)},
    {"gdi3a.ini", "", int32_t(0x00000000), int32_t(0x50E86FC6)},
    {"gdi3a.map", "-", int32_t(0x00000000), int32_t(0x9B53A3CC)},
    {"gdi3b.ini", "", int32_t(0x00000000), int32_t(0xDE676825)},
    {"gdi3b.map", "-", int32_t(0x00000000), int32_t(0x15DCA42F)},
    {"gdi3lose.vqa", "apache blowing up tank", int32_t(0x991D05E3), int32_t(0x00000000)},
    {"gdi3lose.vqp", "apache blowing up tank", int32_t(0xA81D05E3), int32_t(0x00000000)},
    {"gdi4a.ini", "", int32_t(0x00000000), int32_t(0x3489020F)},
    {"gdi4a.map", "-", int32_t(0x00000000), int32_t(0xFF32CE05)},
    {"gdi4a.vqa", "capture the village", int32_t(0x73D16DE0), int32_t(0x00000000)},
    {"gdi4a.vqp", "capture the village", int32_t(0x73D16DEF), int32_t(0x00000000)},
    {"gdi4b.vqa", "recapture the convoy", int32_t(0x73D16DE2), int32_t(0x00000000)},
    {"gdi4b.vqp", "recapture the convoy", int32_t(0x73D16DF1), int32_t(0x00000000)},
    {"gdi5.vqa", "repair gdi base", int32_t(0xABE3DEBC), int32_t(0x00000000)},
    {"gdi5.vqp", "repair gdi base", int32_t(0xBAE3DEBC), int32_t(0x00000000)},
    {"gdi5a.ini", "", int32_t(0x00000000), int32_t(0x23F2164C)},
    {"gdi5a.map", "-", int32_t(0x00000000), int32_t(0xE849DA46)},
    {"gdi5b.ini", "", int32_t(0x00000000), int32_t(0xAD7D11AF)},
    {"gdi5b.map", "-", int32_t(0x00000000), int32_t(0x66C6DDA5)},
    {"gdi5c.ini", "", int32_t(0x00000000), int32_t(0x61D71131)},
    {"gdi5c.map", "-", int32_t(0x00000000), int32_t(0xAA6CDD3B)},
    {"gdi6.vqa", "destroy nod base", int32_t(0xADE3DEBC), int32_t(0x00000000)},
    {"gdi6.vqp", "destroy nod base", int32_t(0xBCE3DEBC), int32_t(0x00000000)},
    {"gdi6a.ini", "", int32_t(0x00000000), int32_t(0x1A7F2A89)},
    {"gdi6a.map", "-", int32_t(0x00000000), int32_t(0xD1C4E683)},
    {"gdi6b.ini", "", int32_t(0x00000000), int32_t(0x94F02D6A)},
    {"gdi6b.map", "-", int32_t(0x00000000), int32_t(0x5F4BE160)},
    {"gdi7.vqa", "finish nod base", int32_t(0xAFE3DEBC), int32_t(0x00000000)},
    {"gdi7.vqp", "finish nod base", int32_t(0xBEE3DEBC), int32_t(0x00000000)},
    {"gdi7a.ini", "", int32_t(0x00000000), int32_t(0x0D043ECA)},
    {"gdi7a.map", "-", int32_t(0x00000000), int32_t(0xC6BFF2C0)},
    {"gdi8a.ini", "", int32_t(0x00000000), int32_t(0xD2BDF11B)},
    {"gdi8a.map", "-", int32_t(0x00000000), int32_t(0x19063D11)},
    {"gdi8a.vqa", "repair gdi equipment", int32_t(0x83D16DE0), int32_t(0x00000000)},
    {"gdi8a.vqp", "repair gdi equipment", int32_t(0x83D16DEF), int32_t(0x00000000)},
    {"gdi8b.vqa", "protect mobieus", int32_t(0x83D16DE2), int32_t(0x00000000)},
    {"gdi8b.vqp", "protect mobieus", int32_t(0x83D16DF1), int32_t(0x00000000)},
    {"gdi9.vqa", "destroy bunkers", int32_t(0xB3E3DEBC), int32_t(0x00000000)},
    {"gdi9.vqp", "destroy bunkers", int32_t(0xC2E3DEBC), int32_t(0x00000000)},
    {"gdi9a.ini", "", int32_t(0x00000000), int32_t(0xC5C6E558)},
    {"gdi9a.map", "-", int32_t(0x00000000), int32_t(0x0E7D2952)},
    {"gdi9b.ini", "", int32_t(0x00000000), int32_t(0x4B49E2BB)},
    {"gdi9b.map", "-", int32_t(0x00000000), int32_t(0x80F22EB1)},
    {"gdi9c.ini", "", int32_t(0x00000000), int32_t(0x87E3E225)},
    {"gdi9c.map", "-", int32_t(0x00000000), int32_t(0x4C582E2F)},
    {"gdi9d.ini", "", int32_t(0x00000000), int32_t(0x8D26EB3C)},
    {"gdi9d.map", "-", int32_t(0x00000000), int32_t(0x469D2736)},
    {"gdi_finl.vqa", "-", int32_t(0x00000000), int32_t(0x8A6CE238)},
    {"gdi_flag.vqa", "-", int32_t(0x00000000), int32_t(0x5ED24E5B)},
    {"gdi_logo.vqa", "-", int32_t(0x00000000), int32_t(0x18D3E0D2)},
    {"gdi_m02.vqa", "-", int32_t(0x00000000), int32_t(0x48302E1A)},
    {"gdi_m03.vqa", "-", int32_t(0x00000000), int32_t(0x836CFDBF)},
    {"gdi_m04.vqa", "-", int32_t(0x00000000), int32_t(0x9E69CD07)},
    {"gdi_m05.vqa", "-", int32_t(0x00000000), int32_t(0x55351EA2)},
    {"gdi_m06.vqa", "-", int32_t(0x00000000), int32_t(0xD3A16C0C)},
    {"gdi_m07.vqa", "-", int32_t(0x00000000), int32_t(0x18FDBFA9)},
    {"gdi_m08.vqa", "-", int32_t(0x00000000), int32_t(0xE9AB0D7C)},
    {"gdi_m09a.vqa", "-", int32_t(0x00000000), int32_t(0x4041925E)},
    {"gdi_m09b.vqa", "-", int32_t(0x00000000), int32_t(0x07E1E88E)},
    {"gdi_m09c.vqa", "-", int32_t(0x00000000), int32_t(0x3A81C13E)},
    {"gdi_m10a.vqa", "-", int32_t(0x00000000), int32_t(0xC139C822)},
    {"gdi_m11.vqa", "-", int32_t(0x00000000), int32_t(0x68D35700)},
    {"gdi_m12a.vqa", "-", int32_t(0x00000000), int32_t(0x8CF16929)},
    {"gdi_slct.aud", "g. d. i. selected", int32_t(0x6A00EAF0), int32_t(0x00000000)},
    {"gdiamerica.pal", "", int32_t(0x00000000), int32_t(0x1F52B3F7)},
    {"gdiamerica.pcx", "", int32_t(0x00000000), int32_t(0x407A11FC)},
    {"gdiamerica.vqa", "", int32_t(0x00000000), int32_t(0xD56492FF)},
    {"gdic.pcx", "-", int32_t(0x00000000), int32_t(0x538F0F77)},
    {"gdicapt1.aud", "gdi building captured", int32_t(0xB422F2CD), int32_t(0x00000000)},
    {"gdich.pcx", "-", int32_t(0x00000000), int32_t(0xB28113C2)},
    {"gdiclk01.pcx", "-", int32_t(0x00000000), int32_t(0xEEBFB2D2)},
    {"gdiclk02.pcx", "-", int32_t(0x00000000), int32_t(0xA91FC802)},
    {"gdiclk03.pcx", "-", int32_t(0x00000000), int32_t(0x947FE1B2)},
    {"gdiclk04.pcx", "-", int32_t(0x00000000), int32_t(0x265F3DA2)},
    {"gdiclk05.pcx", "-", int32_t(0x00000000), int32_t(0x1B3F1412)},
    {"gdiclose.aud", "", int32_t(0xDC20F0E3), int32_t(0x8DBF8DE5)},
    {"gdidead1.aud", "gdi unit destroyed", int32_t(0xB802D4D5), int32_t(0x00000000)},
    {"gdiend1.vqa", "gdi end no ion cannon", int32_t(0x71C8EB0F), int32_t(0x00000000)},
    {"gdiend1.vqp", "gdi end no ion cannon", int32_t(0x71D7EB0F), int32_t(0x00000000)},
    {"gdiend2.vqa", "gdi end with ion cannon", int32_t(0x71CAEB0F), int32_t(0x00000000)},
    {"gdiend2.vqp", "gdi end with ion cannon", int32_t(0x71D9EB0F), int32_t(0x00000000)},
    {"gdieurope.pal", "", int32_t(0x00000000), int32_t(0xCD5B5229)},
    {"gdieurope.pcx", "", int32_t(0x00000000), int32_t(0x5C94C2A9)},
    {"gdieurope.vqa", "", int32_t(0x00000000), int32_t(0x4297FC9B)},
    {"gdifina.vqa", "missiles shoot temple", int32_t(0x75E8FF05), int32_t(0x00000000)},
    {"gdifina.vqp", "missiles shoot temple", int32_t(0x75F7FF05), int32_t(0x00000000)},
    {"gdifinb.vqa", "temple is ion cannoned", int32_t(0x75EAFF05), int32_t(0x00000000)},
    {"gdifinb.vqp", "temple is ion cannoned", int32_t(0x75F9FF05), int32_t(0x00000000)},
    {"gdigen.inf", "inf: list for gdi general.mix", int32_t(0xAF81F3F5), int32_t(0x00000000)},
    {"gdii.pcx", "-", int32_t(0x00000000), int32_t(0x193F17D6)},
    {"gdilogo.pal", "", int32_t(0x00000000), int32_t(0x8DC82588)},
    {"gdilogo.shp", "", int32_t(0x00000000), int32_t(0x76DBECB4)},
    {"gdilose.vqa", "gdi logo being turned into nod logo", int32_t(0x8DF10911), int32_t(0x00000000)},
    {"gdilose.vqp", "gdi logo being turned into nod logo", int32_t(0x8E000911), int32_t(0x00000000)},
    {"gdim09cw.vqa", "-", int32_t(0x00000000), int32_t(0x25A375BE)},
    {"gdim09d1.vqa", "-", int32_t(0x00000000), int32_t(0x2ED4C7EB)},
    {"gdimap01.pcx", "-", int32_t(0x00000000), int32_t(0xD8A1B4A5)},
    {"gdimap01.vqa", "-", int32_t(0x00000000), int32_t(0xC0B31004)},
    {"gdimap02.pcx", "-", int32_t(0x00000000), int32_t(0x9F01CE75)},
    {"gdimap02.vqa", "-", int32_t(0x00000000), int32_t(0x87136AD4)},
    {"gdimap03.pcx", "-", int32_t(0x00000000), int32_t(0xA261E7C5)},
    {"gdimap03.vqa", "-", int32_t(0x00000000), int32_t(0xBA734364)},
    {"gdimap04.pcx", "-", int32_t(0x00000000), int32_t(0x10413BD5)},
    {"gdimap04.vqa", "-", int32_t(0x00000000), int32_t(0x08539F74)},
    {"gdimap05.pcx", "-", int32_t(0x00000000), int32_t(0x2D211265)},
    {"gdimap05.vqa", "-", int32_t(0x00000000), int32_t(0x3533B6C4)},
    {"gdimov.inf", "inf: list for gdi movies.mix", int32_t(0xC7820409), int32_t(0x00000000)},
    {"gdiopen.aud", "", int32_t(0x9A05F0FE), int32_t(0x764E4918)},
    {"gditarget.pal", "-", int32_t(0x00000000), int32_t(0xEE458D8A)},
    {"gditarget2.shp", "-", int32_t(0x00000000), int32_t(0xEEB8A621)},
    {"gdnarrowp.pcx", "", int32_t(0x00000000), int32_t(0xDD42B9F6)},
    {"gdnarrowr.pcx", "", int32_t(0x00000000), int32_t(0x9F67BE8B)},
    {"gdorepmk.shp", "", int32_t(0x00000000), int32_t(0xC93B4E69)},
    {"gdpilemk.shp", "", int32_t(0x00000000), int32_t(0x1BA2E0E2)},
    {"gdpillmk.shp", "", int32_t(0x00000000), int32_t(0x8E3AA531)},
    {"gdpowrmk.shp", "", int32_t(0x00000000), int32_t(0xEB101655)},
    {"gdprismk.shp", "", int32_t(0x00000000), int32_t(0x79D99BDE)},
    {"gdrefnmk.shp", "", int32_t(0x00000000), int32_t(0x6AA48BF9)},
    {"gdsand.shp", "", int32_t(0x00000000), int32_t(0x741E7DD8)},
    {"gdspstmk.shp", "", int32_t(0x00000000), int32_t(0x94C41B36)},
    {"gdtechmk.shp", "", int32_t(0x00000000), int32_t(0x4C8AC0E0)},
    {"gdwall.shp", "", int32_t(0x00000000), int32_t(0x0C3F94B8)},
    {"gdweapmk.shp", "", int32_t(0x00000000), int32_t(0xB1A9AE37)},
    {"gdwethmk.shp", "", int32_t(0x00000000), int32_t(0xD1C343D1)},
    {"gdyardmk.shp", "", int32_t(0x00000000), int32_t(0x9329419D)},
    {"gears.aud", "audf:", int32_t(0xF3877207), int32_t(0x00000000)},
    {"gem01.des", "", int32_t(0x00000000), int32_t(0xB4F52BBC)},
    {"gem01.lun", "", int32_t(0x00000000), int32_t(0x065FB1D4)},
    {"gem01.sno", "misc: gemstones #1", int32_t(0x5DDB71CE), int32_t(0x354FC1BB)},
    {"gem01.tem", "misc: gemstones #1", int32_t(0x4BDD71CC), int32_t(0x29AB0B37)},
    {"gem01.ubn", "", int32_t(0x00000000), int32_t(0xF046A915)},
    {"gem01.urb", "", int32_t(0x00000000), int32_t(0x7F738208)},
    {"gem02.des", "", int32_t(0x00000000), int32_t(0x3A7A2C5F)},
    {"gem02.lun", "", int32_t(0x00000000), int32_t(0x88D0B637)},
    {"gem02.sno", "misc: gemstones #2", int32_t(0x5DDB71D0), int32_t(0xBBC0C658)},
    {"gem02.tem", "misc: gemstones #2", int32_t(0x4BDD71CE), int32_t(0xA7240CD4)},
    {"gem02.ubn", "", int32_t(0x00000000), int32_t(0x7EC9AEF6)},
    {"gem02.urb", "", int32_t(0x00000000), int32_t(0xF1FC85EB)},
    {"gem03.des", "", int32_t(0x00000000), int32_t(0xF6D02CC1)},
    {"gem03.lun", "", int32_t(0x00000000), int32_t(0x447AB6A9)},
    {"gem03.sno", "misc: gemstones #3", int32_t(0x5DDB71D2), int32_t(0x776AC6C6)},
    {"gem03.tem", "misc: gemstones #3", int32_t(0x4BDD71D0), int32_t(0x6B8E0C4A)},
    {"gem03.ubn", "", int32_t(0x00000000), int32_t(0xB263AE68)},
    {"gem03.urb", "", int32_t(0x00000000), int32_t(0x3D568575)},
    {"gem04.des", "", int32_t(0x00000000), int32_t(0xFC1525D8)},
    {"gem04.lun", "", int32_t(0x00000000), int32_t(0x4EBFBFB0)},
    {"gem04.sno", "misc: gemstones #4", int32_t(0x5DDB71D4), int32_t(0x7DAFCFDF)},
    {"gem04.tem", "misc: gemstones #4", int32_t(0x4BDD71D2), int32_t(0x614B0553)},
    {"gem04.ubn", "", int32_t(0x00000000), int32_t(0xB8A6A771)},
    {"gem04.urb", "", int32_t(0x00000000), int32_t(0x37938C6C)},
    {"gem05.des", "", int32_t(0x00000000), int32_t(0x30BF2546)},
    {"gem05.lun", "", int32_t(0x00000000), int32_t(0x8215BF2E)},
    {"gem05.sno", "", int32_t(0x00000000), int32_t(0xB105CF41)},
    {"gem05.tem", "", int32_t(0x00000000), int32_t(0xADE105CD)},
    {"gem05.ubn", "", int32_t(0x00000000), int32_t(0x740CA7EF)},
    {"gem05.urb", "", int32_t(0x00000000), int32_t(0xFB398CF2)},
    {"gem06.des", "", int32_t(0x00000000), int32_t(0xBE3022A5)},
    {"gem06.lun", "", int32_t(0x00000000), int32_t(0x0C9AB8CD)},
    {"gem06.sno", "", int32_t(0x00000000), int32_t(0x3F8AC8A2)},
    {"gem06.tem", "", int32_t(0x00000000), int32_t(0x236E022E)},
    {"gem06.ubn", "", int32_t(0x00000000), int32_t(0xFA83A00C)},
    {"gem06.urb", "", int32_t(0x00000000), int32_t(0x75B68B11)},
    {"gem07.des", "", int32_t(0x00000000), int32_t(0x729A223B)},
    {"gem07.lun", "", int32_t(0x00000000), int32_t(0xC030B853)},
    {"gem07.sno", "", int32_t(0x00000000), int32_t(0xF320C83C)},
    {"gem07.tem", "", int32_t(0x00000000), int32_t(0xEFC402B0)},
    {"gem07.ubn", "", int32_t(0x00000000), int32_t(0x3629A092)},
    {"gem07.urb", "", int32_t(0x00000000), int32_t(0xB91C8B8F)},
    {"gem08.des", "", int32_t(0x00000000), int32_t(0xABBA3097)},
    {"gem08.lun", "", int32_t(0x00000000), int32_t(0x1910AAFF)},
    {"gem08.sno", "", int32_t(0x00000000), int32_t(0x2A00DA90)},
    {"gem08.tem", "", int32_t(0x00000000), int32_t(0x36E4101C)},
    {"gem08.ubn", "", int32_t(0x00000000), int32_t(0xEF09B23E)},
    {"gem08.urb", "", int32_t(0x00000000), int32_t(0x603C9923)},
    {"gem09.des", "", int32_t(0x00000000), int32_t(0x67103009)},
    {"gem09.lun", "", int32_t(0x00000000), int32_t(0xD5BAAA61)},
    {"gem09.sno", "", int32_t(0x00000000), int32_t(0xE6AADA0E)},
    {"gem09.tem", "", int32_t(0x00000000), int32_t(0xFA4E1082)},
    {"gem09.ubn", "", int32_t(0x00000000), int32_t(0x23A3B2A0)},
    {"gem09.urb", "", int32_t(0x00000000), int32_t(0xAC9699BD)},
    {"gem10.des", "", int32_t(0x00000000), int32_t(0x6F243F61)},
    {"gem10.lun", "", int32_t(0x00000000), int32_t(0xDD8EA509)},
    {"gem10.sno", "", int32_t(0x00000000), int32_t(0xEE9ED566)},
    {"gem10.tem", "", int32_t(0x00000000), int32_t(0xF27A1FEA)},
    {"gem10.ubn", "", int32_t(0x00000000), int32_t(0x2B97BDC8)},
    {"gem10.urb", "", int32_t(0x00000000), int32_t(0xA4A296D5)},
    {"gem11.des", "", int32_t(0x00000000), int32_t(0xA38E3FFF)},
    {"gem11.lun", "", int32_t(0x00000000), int32_t(0x1124A597)},
    {"gem11.sno", "", int32_t(0x00000000), int32_t(0x2234D5F8)},
    {"gem11.tem", "", int32_t(0x00000000), int32_t(0x3ED01F74)},
    {"gem11.ubn", "", int32_t(0x00000000), int32_t(0xE73DBD56)},
    {"gem11.urb", "", int32_t(0x00000000), int32_t(0x6808964B)},
    {"gem12.des", "", int32_t(0x00000000), int32_t(0x2D01381C)},
    {"gem12.lun", "", int32_t(0x00000000), int32_t(0x9FABA274)},
    {"gem12.sno", "", int32_t(0x00000000), int32_t(0xACBBD21B)},
    {"gem12.tem", "", int32_t(0x00000000), int32_t(0xB05F1897)},
    {"gem12.ubn", "", int32_t(0x00000000), int32_t(0x69B2BAB5)},
    {"gem12.urb", "", int32_t(0x00000000), int32_t(0xE68791A8)},
    {"gems01.des", "", int32_t(0x00000000), int32_t(0x55165431)},
    {"gems02.des", "", int32_t(0x00000000), int32_t(0x64FE4EAC)},
    {"gems03.des", "", int32_t(0x00000000), int32_t(0xC2894518)},
    {"gems04.des", "", int32_t(0x00000000), int32_t(0x072E7B96)},
    {"gems05.des", "", int32_t(0x00000000), int32_t(0xA1597022)},
    {"gems06.des", "", int32_t(0x00000000), int32_t(0x90B16ABF)},
    {"gems07.des", "", int32_t(0x00000000), int32_t(0x36C6610B)},
    {"gems08.des", "", int32_t(0x00000000), int32_t(0xC08E11E2)},
    {"gems09.des", "", int32_t(0x00000000), int32_t(0x66F91A56)},
    {"gems10.des", "", int32_t(0x00000000), int32_t(0x3FCB5F1B)},
    {"gems11.des", "", int32_t(0x00000000), int32_t(0x99BC54AF)},
    {"gems12.des", "", int32_t(0x00000000), int32_t(0xA8544E32)},
    {"gemtowr1.aud", "", int32_t(0xF82F04E9), int32_t(0x00000000)},
    {"gemtowr2.aud", "", int32_t(0xFA2F04E9), int32_t(0x00000000)},
    {"gemtowr3.aud", "", int32_t(0xFC2F04E9), int32_t(0x00000000)},
    {"gemtowr4.aud", "", int32_t(0xFE2F04E9), int32_t(0x00000000)},
    {"genbutts.shp", "", int32_t(0x002A10F5), int32_t(0x00000000)},
    {"gendeath.shp", "", int32_t(0x00000000), int32_t(0x9A7D7F95)},
    {"general.mix", "general.mix", int32_t(0x7229E10E), int32_t(0x00000000)},
    {"general.pcx", "", int32_t(0x00000000), int32_t(0x2DE9373F)},
    {"generic.mix", "", int32_t(0x00000000), int32_t(0x40B4C119)},
    {"generic.vqa", "kane ordering nod to look for dinos", int32_t(0x7200F917), int32_t(0x00000000)},
    {"generic.vqp", "kane ordering nod to look for dinos", int32_t(0x720FF917), int32_t(0x00000000)},
    {"genermd.mix", "", int32_t(0x00000000), int32_t(0xA9FED5B2)},
    {"gennodl1.vqa", "-", int32_t(0x00000000), int32_t(0x20978F2D)},
    {"genwin01.vqa", "-", int32_t(0x00000000), int32_t(0x3E0BE074)},
    {"ger_edhi.pcx", "pict: red alert map editor title screen german", int32_t(0x681CEDD4), int32_t(0x00000000)},
    {"gerchair.aud", "", int32_t(0xF630D8DB), int32_t(0x00000000)},
    {"geri.pcx", "", int32_t(0x00000000), int32_t(0xD659EE3A)},
    {"geri.shp", "", int32_t(0x00000000), int32_t(0x3930019A)},
    {"getbuttn.aud", "", int32_t(0xEA4EFEF5), int32_t(0x00000000)},
    {"getbuttn.wav", "", int32_t(0xFC3B14F5), int32_t(0x00000000)},
    {"getitem1.aud", "", int32_t(0xCC40E0F3), int32_t(0x00000000)},
    {"gflr0001.int", "grey floor", int32_t(0xFFDFC2AB), int32_t(0x00000000)},
    {"gflr0002.int", "grey floor", int32_t(0x01DFC2AB), int32_t(0x00000000)},
    {"gflr0003.int", "grey floor", int32_t(0x03DFC2AB), int32_t(0x00000000)},
    {"gflr0004.int", "grey floor", int32_t(0x05DFC2AB), int32_t(0x00000000)},
    {"gflr0005.int", "grey floor", int32_t(0x07DFC2AB), int32_t(0x00000000)},
    {"ggairc.shp", "", int32_t(0x00000000), int32_t(0x9BCCF2FE)},
    {"ggairc_a.shp", "", int32_t(0x00000000), int32_t(0x4463C127)},
    {"ggairc_b.shp", "", int32_t(0x00000000), int32_t(0x03C3BBF7)},
    {"ggairc_c.shp", "", int32_t(0x00000000), int32_t(0x3EA39247)},
    {"ggaircbb.shp", "", int32_t(0x00000000), int32_t(0xBC8BAAB2)},
    {"ggcnst.shp", "", int32_t(0x00000000), int32_t(0x958BEDD4)},
    {"ggcnst_a.shp", "", int32_t(0x00000000), int32_t(0x4A24DE0D)},
    {"ggcnst_b.shp", "", int32_t(0x00000000), int32_t(0x0D84A4DD)},
    {"ggcnst_c.shp", "", int32_t(0x00000000), int32_t(0x30E48D6D)},
    {"ggcnst_d.shp", "", int32_t(0x00000000), int32_t(0x82C4517D)},
    {"ggcnstdm.shp", "", int32_t(0x00000000), int32_t(0xE6C5C154)},
    {"ggcsph.shp", "", int32_t(0x00000000), int32_t(0xE6F5B9AB)},
    {"ggcsph_a.shp", "", int32_t(0x00000000), int32_t(0x395A8A72)},
    {"ggcsph_e.shp", "", int32_t(0x00000000), int32_t(0xCCDA2CB2)},
    {"ggcsph_f.shp", "", int32_t(0x00000000), int32_t(0x8B7A5662)},
    {"ggcsph_g.shp", "", int32_t(0x00000000), int32_t(0xB61A7FD2)},
    {"ggcsph_h.shp", "", int32_t(0x00000000), int32_t(0x344AE803)},
    {"ggcsphdm.shp", "", int32_t(0x00000000), int32_t(0x95BB952B)},
    {"ggdept.shp", "", int32_t(0x00000000), int32_t(0x7B8D6F93)},
    {"ggdept_a.shp", "", int32_t(0x00000000), int32_t(0xA4225C4A)},
    {"ggdept_b.shp", "", int32_t(0x00000000), int32_t(0xE382269A)},
    {"ggdept_c.shp", "", int32_t(0x00000000), int32_t(0xDEE20F2A)},
    {"ggdept_d.shp", "", int32_t(0x00000000), int32_t(0x6CC2D33A)},
    {"ggdeptbb.shp", "", int32_t(0x00000000), int32_t(0x5CCA37DF)},
    {"ggfwll.shp", "", int32_t(0x00000000), int32_t(0x826B2394)},
    {"gggap.shp", "", int32_t(0x00000000), int32_t(0x46F02E02)},
    {"gggate_b.shp", "", int32_t(0x00000000), int32_t(0x10BA5515)},
    {"gggateza.shp", "", int32_t(0x00000000), int32_t(0x07D7BE76)},
    {"gggatezb.shp", "", int32_t(0x00000000), int32_t(0x4077C4A6)},
    {"gggcan.shp", "", int32_t(0x00000000), int32_t(0x901F5F2F)},
    {"gghunt.shp", "unit: hunter seeker", int32_t(0x00000000), int32_t(0xA440EE75)},
    {"ggi.shp", "", int32_t(0x00000000), int32_t(0x15F3E571)},
    {"gglite.shp", "", int32_t(0x00000000), int32_t(0xCB8D45F3)},
    {"ggorep.shp", "", int32_t(0x00000000), int32_t(0x8BD8A080)},
    {"ggorep_a.shp", "", int32_t(0x00000000), int32_t(0x54779359)},
    {"ggpile.shp", "", int32_t(0x00000000), int32_t(0x59410E0B)},
    {"ggpile_a.shp", "", int32_t(0x00000000), int32_t(0x86EE3DD2)},
    {"ggpile_b.shp", "", int32_t(0x00000000), int32_t(0xC14E4702)},
    {"ggpile_c.shp", "", int32_t(0x00000000), int32_t(0xFC2E6EB2)},
    {"ggpiledm.shp", "", int32_t(0x00000000), int32_t(0x2A0F228B)},
    {"ggpill.shp", "", int32_t(0x00000000), int32_t(0xCCD94BD8)},
    {"ggpowr.shp", "", int32_t(0x00000000), int32_t(0xA9F3F8BC)},
    {"ggpowr_a.shp", "", int32_t(0x00000000), int32_t(0x765CCB65)},
    {"ggpowr_b.shp", "", int32_t(0x00000000), int32_t(0x31FCB1B5)},
    {"ggpris.shp", "", int32_t(0x00000000), int32_t(0x3B3A7537)},
    {"ggpris_a.shp", "", int32_t(0x00000000), int32_t(0xE49546EE)},
    {"ggpris_b.shp", "", int32_t(0x00000000), int32_t(0xA3353C3E)},
    {"ggprisdm.shp", "", int32_t(0x00000000), int32_t(0x487459B7)},
    {"ggrefn.shp", "", int32_t(0x00000000), int32_t(0x28476510)},
    {"ggrefnbb.shp", "", int32_t(0x00000000), int32_t(0x0F003D5C)},
    {"ggrefnl1.shp", "", int32_t(0x00000000), int32_t(0x8B78C633)},
    {"ggrefnl2.shp", "", int32_t(0x00000000), int32_t(0xCCD8BCE3)},
    {"ggrefnl3.shp", "", int32_t(0x00000000), int32_t(0xF1B89553)},
    {"ggrefnor.shp", "", int32_t(0x00000000), int32_t(0xD37EB900)},
    {"ggrobo.shp", "", int32_t(0x00000000), int32_t(0x9F54EAC0)},
    {"ggrobo_a.shp", "", int32_t(0x00000000), int32_t(0x40FBD919)},
    {"ggrobomk.shp", "", int32_t(0x00000000), int32_t(0x44556228)},
    {"ggspot.shp", "", int32_t(0x00000000), int32_t(0xFD33D1BB)},
    {"ggspot_a.shp", "", int32_t(0x00000000), int32_t(0x229CE262)},
    {"ggspotmk.shp", "", int32_t(0x00000000), int32_t(0x26325953)},
    {"ggspst.shp", "", int32_t(0x00000000), int32_t(0xD627F5DF)},
    {"ggspst_a.shp", "", int32_t(0x00000000), int32_t(0x0988C606)},
    {"ggtech.shp", "", int32_t(0x00000000), int32_t(0x0E692E09)},
    {"ggtech_a.shp", "", int32_t(0x00000000), int32_t(0xD1C61DD0)},
    {"ggunicon.shp", "", int32_t(0x00000000), int32_t(0xAE10354B)},
    {"ggweap.shp", "", int32_t(0x00000000), int32_t(0xF34A40DE)},
    {"ggweap_1.shp", "", int32_t(0x00000000), int32_t(0xD53793C8)},
    {"ggweap_2.shp", "", int32_t(0x00000000), int32_t(0x9297E918)},
    {"ggweap_3.shp", "", int32_t(0x00000000), int32_t(0xAFF7C0A8)},
    {"ggweap_4.shp", "", int32_t(0x00000000), int32_t(0x1DD71CB8)},
    {"ggweap_a.shp", "", int32_t(0x00000000), int32_t(0x2CE57307)},
    {"ggweap_b.shp", "", int32_t(0x00000000), int32_t(0x6B4509D7)},
    {"ggweapbb.shp", "", int32_t(0x00000000), int32_t(0xD40D1892)},
    {"ggweth.shp", "", int32_t(0x00000000), int32_t(0x9320AD38)},
    {"ggweth_e.shp", "", int32_t(0x00000000), int32_t(0xB90F3821)},
    {"ggweth_f.shp", "", int32_t(0x00000000), int32_t(0xFEAF42F1)},
    {"ggweth_g.shp", "", int32_t(0x00000000), int32_t(0xC3CF6B41)},
    {"ggweth_h.shp", "", int32_t(0x00000000), int32_t(0x419FFC90)},
    {"ggyard.shp", "", int32_t(0x00000000), int32_t(0xD1CAAF74)},
    {"ggyard_a.shp", "", int32_t(0x00000000), int32_t(0x0E659CAD)},
    {"ggyard_c.shp", "", int32_t(0x00000000), int32_t(0x74A5CFCD)},
    {"ggyard_d.shp", "", int32_t(0x00000000), int32_t(0xC68513DD)},
    {"ggyard_s.shp", "", int32_t(0x00000000), int32_t(0x1445584F)},
    {"ghost.shp", "unit: ghost stalker", int32_t(0x00000000), int32_t(0xC0A3FE3D)},
    {"gi.shp", "", int32_t(0x00000000), int32_t(0xADD10028)},
    {"giicon.shp", "", int32_t(0x00000000), int32_t(0xC92A56A8)},
    {"girlokay.aud", "girl ok", int32_t(0x2820FCE9), int32_t(0x00000000)},
    {"girlyeah.aud", "girl ya?", int32_t(0x0620F0FD), int32_t(0x00000000)},
    {"giuico.shp", "", int32_t(0x00000000), int32_t(0x904EA3AB)},
    {"gla_apr.csv", "", int32_t(0xDA0024E2), int32_t(0x00000000)},
    {"gla_apr.lsv", "", int32_t(0xDA0024EB), int32_t(0x00000000)},
    {"gla_apr.vqa", "", int32_t(0xD9EB22F5), int32_t(0x00000000)},
    {"gla_apr_e.vqa", "", int32_t(0x1A000008), int32_t(0x00000000)},
    {"gla_apr_e.vqt", "", int32_t(0x1A00001B), int32_t(0x00000000)},
    {"gla_apr_h.pcx", "", int32_t(0xFDF40024), int32_t(0x00000000)},
    {"gla_apr_h.vqa", "", int32_t(0x1A00000E), int32_t(0x00000000)},
    {"gla_apr_l.pcx", "", int32_t(0xFDF4002C), int32_t(0x00000000)},
    {"gla_apr_l.vqa", "", int32_t(0x1A000016), int32_t(0x00000000)},
    {"glad226m.aud", "", int32_t(0xEFC6D6AF), int32_t(0x00000000)},
    {"gladwan1.aud", "", int32_t(0xB7F6F4F9), int32_t(0x00000000)},
    {"glaircmk.shp", "", int32_t(0x00000000), int32_t(0x63ECFD52)},
    {"glass4.aud", "", int32_t(0xCF61DE18), int32_t(0x00000000)},
    {"glassy1.aud", "", int32_t(0xA9AC3904), int32_t(0x00000000)},
    {"glassy2.aud", "", int32_t(0xA9AE3904), int32_t(0x00000000)},
    {"glassy3.aud", "", int32_t(0xA9B03904), int32_t(0x00000000)},
    {"glassy4.aud", "", int32_t(0xA9B23904), int32_t(0x00000000)},
    {"glat01.des", "", int32_t(0x00000000), int32_t(0x5006E7F3)},
    {"glat01.lun", "", int32_t(0x00000000), int32_t(0x3926DBEA)},
    {"glat01.sno", "-", int32_t(0x00000000), int32_t(0xD729A8FC)},
    {"glat01.tem", "-", int32_t(0x00000000), int32_t(0x265EFE0B)},
    {"glat01.ubn", "", int32_t(0x00000000), int32_t(0x1ACBC4F8)},
    {"glat01.urb", "", int32_t(0x00000000), int32_t(0x5E7F7A67)},
    {"glat01a.des", "", int32_t(0x00000000), int32_t(0xE62E0587)},
    {"glat01a.lun", "", int32_t(0x00000000), int32_t(0xC0D0E204)},
    {"glat01a.sno", "-", int32_t(0x00000000), int32_t(0xC1C2D81D)},
    {"glat01a.tem", "-", int32_t(0x00000000), int32_t(0x62766DC7)},
    {"glat01a.ubn", "", int32_t(0x00000000), int32_t(0xF4A84FE4)},
    {"glat01a.urb", "", int32_t(0x00000000), int32_t(0x443BA398)},
    {"glat02.des", "", int32_t(0x00000000), int32_t(0x61EEFD6E)},
    {"glat02.lun", "", int32_t(0x00000000), int32_t(0x08CEC177)},
    {"glat02.sno", "-", int32_t(0x00000000), int32_t(0xE6C1B261)},
    {"glat02.tem", "-", int32_t(0x00000000), int32_t(0x17B6E496)},
    {"glat02.ubn", "", int32_t(0x00000000), int32_t(0x2B23DE65)},
    {"glat02.urb", "", int32_t(0x00000000), int32_t(0x6F9760FA)},
    {"glat02a.des", "", int32_t(0x00000000), int32_t(0xD7C61F1A)},
    {"glat02a.lun", "", int32_t(0x00000000), int32_t(0xF138F899)},
    {"glat02a.sno", "-", int32_t(0x00000000), int32_t(0xF02AC280)},
    {"glat02a.tem", "-", int32_t(0x00000000), int32_t(0x539E775A)},
    {"glat02a.ubn", "", int32_t(0x00000000), int32_t(0xC5405579)},
    {"glat02a.urb", "", int32_t(0x00000000), int32_t(0x75D3B905)},
    {"glat03.des", "", int32_t(0x00000000), int32_t(0xC799F6DA)},
    {"glat03.lun", "", int32_t(0x00000000), int32_t(0xAEB9CAC3)},
    {"glat03.sno", "-", int32_t(0x00000000), int32_t(0x40B6B9D5)},
    {"glat03.tem", "-", int32_t(0x00000000), int32_t(0xB1C1EF22)},
    {"glat03.ubn", "", int32_t(0x00000000), int32_t(0x8D54D5D1)},
    {"glat03.urb", "", int32_t(0x00000000), int32_t(0xC9E06B4E)},
    {"glat03a.des", "", int32_t(0x00000000), int32_t(0x71B114AE)},
    {"glat03a.lun", "", int32_t(0x00000000), int32_t(0x574FF32D)},
    {"glat03a.sno", "-", int32_t(0x00000000), int32_t(0x565DC934)},
    {"glat03a.tem", "-", int32_t(0x00000000), int32_t(0xF5E97CEE)},
    {"glat03a.ubn", "", int32_t(0x00000000), int32_t(0x63375ECD)},
    {"glat03a.urb", "", int32_t(0x00000000), int32_t(0xD3A4B2B1)},
    {"glat04.des", "", int32_t(0x00000000), int32_t(0x023EC854)},
    {"glat04.lun", "", int32_t(0x00000000), int32_t(0x6B1EF44D)},
    {"glat04.sno", "-", int32_t(0x00000000), int32_t(0x8511875B)},
    {"glat04.tem", "-", int32_t(0x00000000), int32_t(0x7466D1AC)},
    {"glat04.ubn", "", int32_t(0x00000000), int32_t(0x48F3EB5F)},
    {"glat04.urb", "", int32_t(0x00000000), int32_t(0x0C4755C0)},
    {"glat04a.des", "", int32_t(0x00000000), int32_t(0xB4162A20)},
    {"glat04a.lun", "", int32_t(0x00000000), int32_t(0x92E8CDA3)},
    {"glat04a.sno", "-", int32_t(0x00000000), int32_t(0x93FAF7BA)},
    {"glat04a.tem", "-", int32_t(0x00000000), int32_t(0x304E4260)},
    {"glat04a.ubn", "", int32_t(0x00000000), int32_t(0xA6906043)},
    {"glat04a.urb", "", int32_t(0x00000000), int32_t(0x16038C3F)},
    {"glat05.des", "", int32_t(0x00000000), int32_t(0xA449C3E0)},
    {"glat05.lun", "", int32_t(0x00000000), int32_t(0xCD69FFF9)},
    {"glat05.sno", "-", int32_t(0x00000000), int32_t(0x23668CEF)},
    {"glat05.tem", "-", int32_t(0x00000000), int32_t(0xD211DA18)},
    {"glat05.ubn", "", int32_t(0x00000000), int32_t(0xEE84E0EB)},
    {"glat05.urb", "", int32_t(0x00000000), int32_t(0xAA305E74)},
    {"glat05a.des", "", int32_t(0x00000000), int32_t(0x12612194)},
    {"glat05a.lun", "", int32_t(0x00000000), int32_t(0x349FC617)},
    {"glat05a.sno", "-", int32_t(0x00000000), int32_t(0x358DFC0E)},
    {"glat05a.tem", "-", int32_t(0x00000000), int32_t(0x963949D4)},
    {"glat05a.ubn", "", int32_t(0x00000000), int32_t(0x00E76BF7)},
    {"glat05a.urb", "", int32_t(0x00000000), int32_t(0xB074878B)},
    {"glat06.des", "", int32_t(0x00000000), int32_t(0x95A1D97D)},
    {"glat06.lun", "", int32_t(0x00000000), int32_t(0xFC81E564)},
    {"glat06.sno", "-", int32_t(0x00000000), int32_t(0x128E9672)},
    {"glat06.tem", "-", int32_t(0x00000000), int32_t(0xE3F9C085)},
    {"glat06.ubn", "", int32_t(0x00000000), int32_t(0xDF6CFA76)},
    {"glat06.urb", "", int32_t(0x00000000), int32_t(0x9BD844E9)},
    {"glat06a.des", "", int32_t(0x00000000), int32_t(0x23893B09)},
    {"glat06a.lun", "", int32_t(0x00000000), int32_t(0x0577DC8A)},
    {"glat06a.sno", "-", int32_t(0x00000000), int32_t(0x0465E693)},
    {"glat06a.tem", "-", int32_t(0x00000000), int32_t(0xA7D15349)},
    {"glat06a.ubn", "", int32_t(0x00000000), int32_t(0x310F716A)},
    {"glat06a.urb", "", int32_t(0x00000000), int32_t(0x819C9D16)},
    {"glat07.des", "", int32_t(0x00000000), int32_t(0x33D6D2C9)},
    {"glat07.lun", "", int32_t(0x00000000), int32_t(0x5AF6EED0)},
    {"glat07.sno", "-", int32_t(0x00000000), int32_t(0xB4F99DC6)},
    {"glat07.tem", "-", int32_t(0x00000000), int32_t(0x458ECB31)},
    {"glat07.ubn", "", int32_t(0x00000000), int32_t(0x791BF1C2)},
    {"glat07.urb", "", int32_t(0x00000000), int32_t(0x3DAF4F5D)},
    {"glat07a.des", "", int32_t(0x00000000), int32_t(0x85FE30BD)},
    {"glat07a.lun", "", int32_t(0x00000000), int32_t(0xA300D73E)},
    {"glat07a.sno", "-", int32_t(0x00000000), int32_t(0xA212ED27)},
    {"glat07a.tem", "-", int32_t(0x00000000), int32_t(0x01A658FD)},
    {"glat07a.ubn", "", int32_t(0x00000000), int32_t(0x97787ADE)},
    {"glat07a.urb", "", int32_t(0x00000000), int32_t(0x27EB96A2)},
    {"glat08.des", "", int32_t(0x00000000), int32_t(0xC59EA220)},
    {"glat08.lun", "", int32_t(0x00000000), int32_t(0xACBE9E39)},
    {"glat08.sno", "-", int32_t(0x00000000), int32_t(0x42B1ED2F)},
    {"glat08.tem", "-", int32_t(0x00000000), int32_t(0xB3C6BBD8)},
    {"glat08.ubn", "", int32_t(0x00000000), int32_t(0x8F53812B)},
    {"glat08.urb", "", int32_t(0x00000000), int32_t(0xCBE73FB4)},
    {"glat08a.des", "", int32_t(0x00000000), int32_t(0x73B64054)},
    {"glat08a.lun", "", int32_t(0x00000000), int32_t(0x5548A7D7)},
    {"glat08a.sno", "-", int32_t(0x00000000), int32_t(0x545A9DCE)},
    {"glat08a.tem", "-", int32_t(0x00000000), int32_t(0xF7EE2814)},
    {"glat08a.ubn", "", int32_t(0x00000000), int32_t(0x61300A37)},
    {"glat08a.urb", "", int32_t(0x00000000), int32_t(0xD1A3E64B)},
    {"glat09.des", "", int32_t(0x00000000), int32_t(0x63E9A994)},
    {"glat09.lun", "", int32_t(0x00000000), int32_t(0x0AC9958D)},
    {"glat09.sno", "-", int32_t(0x00000000), int32_t(0xE4C6E69B)},
    {"glat09.tem", "-", int32_t(0x00000000), int32_t(0x15B1B06C)},
    {"glat09.ubn", "", int32_t(0x00000000), int32_t(0x29248A9F)},
    {"glat09.urb", "", int32_t(0x00000000), int32_t(0x6D903400)},
    {"glat09a.des", "", int32_t(0x00000000), int32_t(0xD5C14BE0)},
    {"glat09a.lun", "", int32_t(0x00000000), int32_t(0xF33FAC63)},
    {"glat09a.sno", "-", int32_t(0x00000000), int32_t(0xF22D967A)},
    {"glat09a.tem", "-", int32_t(0x00000000), int32_t(0x519923A0)},
    {"glat09a.ubn", "", int32_t(0x00000000), int32_t(0xC7470183)},
    {"glat09a.urb", "", int32_t(0x00000000), int32_t(0x77D4EDFF)},
    {"glat10.des", "", int32_t(0x00000000), int32_t(0x3ADBECD9)},
    {"glat10.lun", "", int32_t(0x00000000), int32_t(0x53FBD0C0)},
    {"glat10.sno", "-", int32_t(0x00000000), int32_t(0xBDF4A3D6)},
    {"glat10.tem", "-", int32_t(0x00000000), int32_t(0x4C83F521)},
    {"glat10.ubn", "", int32_t(0x00000000), int32_t(0x7016CFD2)},
    {"glat10.urb", "", int32_t(0x00000000), int32_t(0x34A2714D)},
    {"glat10a.des", "", int32_t(0x00000000), int32_t(0x8CF30EAD)},
    {"glat10a.lun", "", int32_t(0x00000000), int32_t(0xAA0DE92E)},
    {"glat10a.sno", "-", int32_t(0x00000000), int32_t(0xAB1FD337)},
    {"glat10a.tem", "-", int32_t(0x00000000), int32_t(0x08AB66ED)},
    {"glat10a.ubn", "", int32_t(0x00000000), int32_t(0x9E7544CE)},
    {"glat10a.urb", "", int32_t(0x00000000), int32_t(0x2EE6A8B2)},
    {"glat11.des", "", int32_t(0x00000000), int32_t(0x9CACE76D)},
    {"glat11.lun", "", int32_t(0x00000000), int32_t(0xF58CDB74)},
    {"glat11.sno", "-", int32_t(0x00000000), int32_t(0x1B83A862)},
    {"glat11.tem", "-", int32_t(0x00000000), int32_t(0xEAF4FE95)},
    {"glat11.ubn", "", int32_t(0x00000000), int32_t(0xD661C466)},
    {"glat11.urb", "", int32_t(0x00000000), int32_t(0x92D57AF9)},
    {"glat11a.des", "", int32_t(0x00000000), int32_t(0x2A840519)},
    {"glat11a.lun", "", int32_t(0x00000000), int32_t(0x0C7AE29A)},
    {"glat11a.sno", "-", int32_t(0x00000000), int32_t(0x0D68D883)},
    {"glat11a.tem", "-", int32_t(0x00000000), int32_t(0xAEDC6D59)},
    {"glat11a.ubn", "", int32_t(0x00000000), int32_t(0x38024F7A)},
    {"glat11a.urb", "", int32_t(0x00000000), int32_t(0x8891A306)},
    {"glat12.des", "", int32_t(0x00000000), int32_t(0xAD44FDF0)},
    {"glat12.lun", "", int32_t(0x00000000), int32_t(0xC464C1E9)},
    {"glat12.sno", "-", int32_t(0x00000000), int32_t(0x2A6BB2FF)},
    {"glat12.tem", "-", int32_t(0x00000000), int32_t(0xDB1CE408)},
    {"glat12.ubn", "", int32_t(0x00000000), int32_t(0xE789DEFB)},
    {"glat12.urb", "", int32_t(0x00000000), int32_t(0xA33D6064)},
    {"glat12a.des", "", int32_t(0x00000000), int32_t(0x1B6C1F84)},
    {"glat12a.lun", "", int32_t(0x00000000), int32_t(0x3D92F807)},
    {"glat12a.sno", "-", int32_t(0x00000000), int32_t(0x3C80C21E)},
    {"glat12a.tem", "-", int32_t(0x00000000), int32_t(0x9F3477C4)},
    {"glat12a.ubn", "", int32_t(0x00000000), int32_t(0x09EA55E7)},
    {"glat12a.urb", "", int32_t(0x00000000), int32_t(0xB979B99B)},
    {"glat13.des", "", int32_t(0x00000000), int32_t(0x0B33F644)},
    {"glat13.lun", "", int32_t(0x00000000), int32_t(0x6213CA5D)},
    {"glat13.sno", "-", int32_t(0x00000000), int32_t(0x8C1CB94B)},
    {"glat13.tem", "-", int32_t(0x00000000), int32_t(0x7D6BEFBC)},
    {"glat13.ubn", "", int32_t(0x00000000), int32_t(0x41FED54F)},
    {"glat13.urb", "", int32_t(0x00000000), int32_t(0x054A6BD0)},
    {"glat13a.des", "", int32_t(0x00000000), int32_t(0xBD1B1430)},
    {"glat13a.lun", "", int32_t(0x00000000), int32_t(0x9BE5F3B3)},
    {"glat13a.sno", "-", int32_t(0x00000000), int32_t(0x9AF7C9AA)},
    {"glat13a.tem", "-", int32_t(0x00000000), int32_t(0x39437C70)},
    {"glat13a.ubn", "", int32_t(0x00000000), int32_t(0xAF9D5E53)},
    {"glat13a.urb", "", int32_t(0x00000000), int32_t(0x1F0EB22F)},
    {"glat14.des", "", int32_t(0x00000000), int32_t(0xCE94C8CA)},
    {"glat14.lun", "", int32_t(0x00000000), int32_t(0xA7B4F4D3)},
    {"glat14.sno", "-", int32_t(0x00000000), int32_t(0x49BB87C5)},
    {"glat14.tem", "-", int32_t(0x00000000), int32_t(0xB8CCD132)},
    {"glat14.ubn", "", int32_t(0x00000000), int32_t(0x8459EBC1)},
    {"glat14.urb", "", int32_t(0x00000000), int32_t(0xC0ED555E)},
    {"glat14a.des", "", int32_t(0x00000000), int32_t(0x78BC2ABE)},
    {"glat14a.lun", "", int32_t(0x00000000), int32_t(0x5E42CD3D)},
    {"glat14a.sno", "-", int32_t(0x00000000), int32_t(0x5F50F724)},
    {"glat14a.tem", "-", int32_t(0x00000000), int32_t(0xFCE442FE)},
    {"glat14a.ubn", "", int32_t(0x00000000), int32_t(0x6A3A60DD)},
    {"glat14a.urb", "", int32_t(0x00000000), int32_t(0xDAA98CA1)},
    {"glat15.des", "", int32_t(0x00000000), int32_t(0x68E3C37E)},
    {"glat15.lun", "", int32_t(0x00000000), int32_t(0x01C3FF67)},
    {"glat15.sno", "-", int32_t(0x00000000), int32_t(0xEFCC8C71)},
    {"glat15.tem", "-", int32_t(0x00000000), int32_t(0x1EBBDA86)},
    {"glat15.ubn", "", int32_t(0x00000000), int32_t(0x222EE075)},
    {"glat15.urb", "", int32_t(0x00000000), int32_t(0x669A5EEA)},
    {"glat15a.des", "", int32_t(0x00000000), int32_t(0xDECB210A)},
    {"glat15a.lun", "", int32_t(0x00000000), int32_t(0xF835C689)},
    {"glat15a.sno", "-", int32_t(0x00000000), int32_t(0xF927FC90)},
    {"glat15a.tem", "-", int32_t(0x00000000), int32_t(0x5A93494A)},
    {"glat15a.ubn", "", int32_t(0x00000000), int32_t(0xCC4D6B69)},
    {"glat15a.urb", "", int32_t(0x00000000), int32_t(0x7CDE8715)},
    {"glat16.des", "", int32_t(0x00000000), int32_t(0x590BD9E3)},
    {"glat16.lun", "", int32_t(0x00000000), int32_t(0x302BE5FA)},
    {"glat16.sno", "-", int32_t(0x00000000), int32_t(0xDE2496EC)},
    {"glat16.tem", "-", int32_t(0x00000000), int32_t(0x2F53C01B)},
    {"glat16.ubn", "", int32_t(0x00000000), int32_t(0x13C6FAE8)},
    {"glat16.urb", "", int32_t(0x00000000), int32_t(0x57724477)},
    {"glat16a.des", "", int32_t(0x00000000), int32_t(0xEF233B97)},
    {"glat16a.lun", "", int32_t(0x00000000), int32_t(0xC9DDDC14)},
    {"glat16a.sno", "-", int32_t(0x00000000), int32_t(0xC8CFE60D)},
    {"glat16a.tem", "-", int32_t(0x00000000), int32_t(0x6B7B53D7)},
    {"glat16a.ubn", "", int32_t(0x00000000), int32_t(0xFDA571F4)},
    {"glat16a.urb", "", int32_t(0x00000000), int32_t(0x4D369D88)},
    {"glcnstmk.shp", "", int32_t(0x00000000), int32_t(0x6DABE278)},
    {"glcommmk.shp", "", int32_t(0x00000000), int32_t(0xE1A70C3F)},
    {"glcsphmk.shp", "", int32_t(0x00000000), int32_t(0x1ED5B607)},
    {"gldeptmk.shp", "", int32_t(0x00000000), int32_t(0x83AD603F)},
    {"glgapmk.shp", "", int32_t(0x00000000), int32_t(0xB9E4E4CA)},
    {"glgate_a.shp", "", int32_t(0x00000000), int32_t(0x743BA881)},
    {"glgcanmk.shp", "", int32_t(0x00000000), int32_t(0x683F5083)},
    {"glnch4.aud", "rpg launch", int32_t(0x00000000), int32_t(0xD8064B3A)},
    {"global.img", "", int32_t(0x9B9A10EC), int32_t(0x00000000)},
    {"global.odf", "", int32_t(0xA79A0FE3), int32_t(0x00000000)},
    {"global.tex", "", int32_t(0xB19A21E4), int32_t(0x00000000)},
    {"global.ver", "", int32_t(0xB59A1BE4), int32_t(0x00000000)},
    {"global\\ai\\2hl1\\actions.csv", "", int32_t(0x10E636E8), int32_t(0x00000000)},
    {"global\\ai\\2hl1\\effector.csv", "", int32_t(0xD773F3EF), int32_t(0x00000000)},
    {"global\\ai\\2hl1\\goals.csv", "", int32_t(0xBB9DBA42), int32_t(0x00000000)},
    {"global\\ai\\2hl1\\spells.csv", "", int32_t(0xB51B5B29), int32_t(0x00000000)},
    {"global\\ai\\2hl1\\stat.csv", "", int32_t(0x4BB0CA61), int32_t(0x00000000)},
    {"global\\ai\\a_human\\actions.csv", "", int32_t(0x7588764D), int32_t(0x00000000)},
    {"global\\ai\\a_human\\effector.csv", "", int32_t(0x854F040A), int32_t(0x00000000)},
    {"global\\ai\\a_human\\goals.csv", "", int32_t(0x57F765C5), int32_t(0x00000000)},
    {"global\\ai\\a_human\\spells.csv", "", int32_t(0xFC1655B8), int32_t(0x00000000)},
    {"global\\ai\\a_human\\stat.csv", "", int32_t(0x958778D7), int32_t(0x00000000)},
    {"global\\ai\\aksalar\\actions.csv", "", int32_t(0xF5773726), int32_t(0x00000000)},
    {"global\\ai\\aksalar\\effector.csv", "", int32_t(0x053DC4E4), int32_t(0x00000000)},
    {"global\\ai\\aksalar\\goals.csv", "", int32_t(0x17EEC632), int32_t(0x00000000)},
    {"global\\ai\\aksalar\\spells.csv", "", int32_t(0xBC0DB625), int32_t(0x00000000)},
    {"global\\ai\\aksalar\\stat.csv", "", int32_t(0x557ED942), int32_t(0x00000000)},
    {"global\\ai\\anyar\\actions.csv", "", int32_t(0x08526635), int32_t(0x00000000)},
    {"global\\ai\\anyar\\effector.csv", "", int32_t(0x960F6E18), int32_t(0x00000000)},
    {"global\\ai\\anyar\\goals.csv", "", int32_t(0x5D900368), int32_t(0x00000000)},
    {"global\\ai\\anyar\\spells.csv", "", int32_t(0x3D76A787), int32_t(0x00000000)},
    {"global\\ai\\anyar\\stat.csv", "", int32_t(0x41D8207C), int32_t(0x00000000)},
    {"global\\ai\\ape\\actions.csv", "", int32_t(0xBD40C301), int32_t(0x00000000)},
    {"global\\ai\\ape\\effector.csv", "", int32_t(0xCD0750BE), int32_t(0x00000000)},
    {"global\\ai\\ape\\goals.csv", "", int32_t(0x7BD38C1D), int32_t(0x00000000)},
    {"global\\ai\\ape\\spells.csv", "", int32_t(0x1FF27C10), int32_t(0x00000000)},
    {"global\\ai\\ape\\stat.csv", "", int32_t(0xB9639F2D), int32_t(0x00000000)},
    {"global\\ai\\b_human\\actions.csv", "", int32_t(0x75A8764D), int32_t(0x00000000)},
    {"global\\ai\\b_human\\effector.csv", "", int32_t(0x856F040A), int32_t(0x00000000)},
    {"global\\ai\\b_human\\goals.csv", "", int32_t(0x580765C5), int32_t(0x00000000)},
    {"global\\ai\\b_human\\spells.csv", "", int32_t(0xFC2655B8), int32_t(0x00000000)},
    {"global\\ai\\b_human\\stat.csv", "", int32_t(0x959778D7), int32_t(0x00000000)},
    {"global\\ai\\bacatta\\actions.csv", "", int32_t(0xE617359E), int32_t(0x00000000)},
    {"global\\ai\\bacatta\\effector.csv", "", int32_t(0xF5DDC35B), int32_t(0x00000000)},
    {"global\\ai\\bacatta\\goals.csv", "", int32_t(0x103EC56E), int32_t(0x00000000)},
    {"global\\ai\\bacatta\\spells.csv", "", int32_t(0xB45DB561), int32_t(0x00000000)},
    {"global\\ai\\bacatta\\stat.csv", "", int32_t(0x4DCED87E), int32_t(0x00000000)},
    {"global\\ai\\bacl12\\actions.csv", "", int32_t(0xB309A7D6), int32_t(0x00000000)},
    {"global\\ai\\bacl12\\effector.csv", "", int32_t(0xE023163A), int32_t(0x00000000)},
    {"global\\ai\\bacl12\\goals.csv", "", int32_t(0xF0A6DB02), int32_t(0x00000000)},
    {"global\\ai\\bacl12\\spells.csv", "", int32_t(0xD74AF9F2), int32_t(0x00000000)},
    {"global\\ai\\bacl12\\stat.csv", "", int32_t(0x10E46B14), int32_t(0x00000000)},
    {"global\\ai\\bacl16\\actions.csv", "", int32_t(0xD309A7D6), int32_t(0x00000000)},
    {"global\\ai\\bacl16\\effector.csv", "", int32_t(0x2023163B), int32_t(0x00000000)},
    {"global\\ai\\bacl16\\goals.csv", "", int32_t(0x10A6DB01), int32_t(0x00000000)},
    {"global\\ai\\bacl16\\spells.csv", "", int32_t(0xF74AF9F2), int32_t(0x00000000)},
    {"global\\ai\\bacl16\\stat.csv", "", int32_t(0x30E46B14), int32_t(0x00000000)},
    {"global\\ai\\bacl4\\actions.csv", "", int32_t(0x3772BD8A), int32_t(0x00000000)},
    {"global\\ai\\bacl4\\effector.csv", "", int32_t(0xC52FC56D), int32_t(0x00000000)},
    {"global\\ai\\bacl4\\goals.csv", "", int32_t(0x8CB05ABD), int32_t(0x00000000)},
    {"global\\ai\\bacl4\\spells.csv", "", int32_t(0x6C96FEDC), int32_t(0x00000000)},
    {"global\\ai\\bacl4\\stat.csv", "", int32_t(0xD9684C26), int32_t(0x00000000)},
    {"global\\ai\\bacl8\\actions.csv", "", int32_t(0x3792BD8A), int32_t(0x00000000)},
    {"global\\ai\\bacl8\\effector.csv", "", int32_t(0xC54FC56D), int32_t(0x00000000)},
    {"global\\ai\\bacl8\\goals.csv", "", int32_t(0x8CD05ABD), int32_t(0x00000000)},
    {"global\\ai\\bacl8\\spells.csv", "", int32_t(0x6CB6FEDC), int32_t(0x00000000)},
    {"global\\ai\\bacl8\\stat.csv", "", int32_t(0xD9784C26), int32_t(0x00000000)},
    {"global\\ai\\belial\\actions.csv", "", int32_t(0xC389901D), int32_t(0x00000000)},
    {"global\\ai\\belial\\effector.csv", "", int32_t(0x0122E6C9), int32_t(0x00000000)},
    {"global\\ai\\belial\\goals.csv", "", int32_t(0x0126C348), int32_t(0x00000000)},
    {"global\\ai\\belial\\spells.csv", "", int32_t(0xE7CAE237), int32_t(0x00000000)},
    {"global\\ai\\belial\\stat.csv", "", int32_t(0x2164535B), int32_t(0x00000000)},
    {"global\\ai\\belstat\\actions.csv", "", int32_t(0x361856C4), int32_t(0x00000000)},
    {"global\\ai\\belstat\\effector.csv", "", int32_t(0x45DEE481), int32_t(0x00000000)},
    {"global\\ai\\belstat\\goals.csv", "", int32_t(0xB83F5601), int32_t(0x00000000)},
    {"global\\ai\\belstat\\spells.csv", "", int32_t(0x5C5E45F5), int32_t(0x00000000)},
    {"global\\ai\\belstat\\stat.csv", "", int32_t(0xF5CF6911), int32_t(0x00000000)},
    {"global\\ai\\chip\\actions.csv", "", int32_t(0x11F72ED0), int32_t(0x00000000)},
    {"global\\ai\\chip\\effector.csv", "", int32_t(0xD884EBD7), int32_t(0x00000000)},
    {"global\\ai\\chip\\goals.csv", "", int32_t(0xBC263636), int32_t(0x00000000)},
    {"global\\ai\\chip\\spells.csv", "", int32_t(0xB62C5311), int32_t(0x00000000)},
    {"global\\ai\\chip\\stat.csv", "", int32_t(0x4C394655), int32_t(0x00000000)},
    {"global\\ai\\coid\\actions.csv", "", int32_t(0x81F6CED0), int32_t(0x00000000)},
    {"global\\ai\\coid\\effector.csv", "", int32_t(0x48848BD8), int32_t(0x00000000)},
    {"global\\ai\\coid\\goals.csv", "", int32_t(0xF4260636), int32_t(0x00000000)},
    {"global\\ai\\coid\\spells.csv", "", int32_t(0x262BF30C), int32_t(0x00000000)},
    {"global\\ai\\coid\\stat.csv", "", int32_t(0x84391653), int32_t(0x00000000)},
    {"global\\ai\\cone\\actions.csv", "", int32_t(0x81F6D6F8), int32_t(0x00000000)},
    {"global\\ai\\cone\\effector.csv", "", int32_t(0x48849400), int32_t(0x00000000)},
    {"global\\ai\\cone\\goals.csv", "", int32_t(0xF4260A4A), int32_t(0x00000000)},
    {"global\\ai\\cone\\spells.csv", "", int32_t(0x262BFB34), int32_t(0x00000000)},
    {"global\\ai\\cone\\stat.csv", "", int32_t(0x84391A67), int32_t(0x00000000)},
    {"global\\ai\\conex\\actions.csv", "", int32_t(0x18A285DD), int32_t(0x00000000)},
    {"global\\ai\\conex\\effector.csv", "", int32_t(0xA65F8DC0), int32_t(0x00000000)},
    {"global\\ai\\conex\\goals.csv", "", int32_t(0x6DE02310), int32_t(0x00000000)},
    {"global\\ai\\conex\\spells.csv", "", int32_t(0x4DC6C72F), int32_t(0x00000000)},
    {"global\\ai\\conex\\stat.csv", "", int32_t(0x4A003050), int32_t(0x00000000)},
    {"global\\ai\\daniel\\actions.csv", "", int32_t(0x83C9902D), int32_t(0x00000000)},
    {"global\\ai\\daniel\\effector.csv", "", int32_t(0x81A2E6E6), int32_t(0x00000000)},
    {"global\\ai\\daniel\\goals.csv", "", int32_t(0xC166C357), int32_t(0x00000000)},
    {"global\\ai\\daniel\\spells.csv", "", int32_t(0xA80AE247), int32_t(0x00000000)},
    {"global\\ai\\daniel\\stat.csv", "", int32_t(0xE1A4536A), int32_t(0x00000000)},
    {"global\\ai\\dawn\\actions.csv", "", int32_t(0xA2071F3F), int32_t(0x00000000)},
    {"global\\ai\\dawn\\effector.csv", "", int32_t(0x6894DC47), int32_t(0x00000000)},
    {"global\\ai\\dawn\\goals.csv", "", int32_t(0x842E2E6E), int32_t(0x00000000)},
    {"global\\ai\\dawn\\spells.csv", "", int32_t(0x463C4381), int32_t(0x00000000)},
    {"global\\ai\\dawn\\stat.csv", "", int32_t(0x14413E8D), int32_t(0x00000000)},
    {"global\\ai\\dawnl12\\actions.csv", "", int32_t(0xB5D80668), int32_t(0x00000000)},
    {"global\\ai\\dawnl12\\effector.csv", "", int32_t(0xC59E9425), int32_t(0x00000000)},
    {"global\\ai\\dawnl12\\goals.csv", "", int32_t(0xF81F2DD4), int32_t(0x00000000)},
    {"global\\ai\\dawnl12\\spells.csv", "", int32_t(0x9C3E1DC6), int32_t(0x00000000)},
    {"global\\ai\\dawnl12\\stat.csv", "", int32_t(0x35AF40E3), int32_t(0x00000000)},
    {"global\\ai\\dawnl19\\actions.csv", "", int32_t(0xB5D806A0), int32_t(0x00000000)},
    {"global\\ai\\dawnl19\\effector.csv", "", int32_t(0xC59E945D), int32_t(0x00000000)},
    {"global\\ai\\dawnl19\\goals.csv", "", int32_t(0xF81F2DF0), int32_t(0x00000000)},
    {"global\\ai\\dawnl19\\spells.csv", "", int32_t(0x9C3E1DE2), int32_t(0x00000000)},
    {"global\\ai\\dawnl19\\stat.csv", "", int32_t(0x35AF40FF), int32_t(0x00000000)},
    {"global\\ai\\dawnl4\\actions.csv", "", int32_t(0xC401B876), int32_t(0x00000000)},
    {"global\\ai\\dawnl4\\effector.csv", "", int32_t(0x0213377B), int32_t(0x00000000)},
    {"global\\ai\\dawnl4\\goals.csv", "", int32_t(0x019EEBA1), int32_t(0x00000000)},
    {"global\\ai\\dawnl4\\spells.csv", "", int32_t(0xE8430A92), int32_t(0x00000000)},
    {"global\\ai\\dawnl4\\stat.csv", "", int32_t(0x21DC7BB4), int32_t(0x00000000)},
    {"global\\ai\\dawnl8\\actions.csv", "", int32_t(0xE401B876), int32_t(0x00000000)},
    {"global\\ai\\dawnl8\\effector.csv", "", int32_t(0x4213377B), int32_t(0x00000000)},
    {"global\\ai\\dawnl8\\goals.csv", "", int32_t(0x219EEBA1), int32_t(0x00000000)},
    {"global\\ai\\dawnl8\\spells.csv", "", int32_t(0x08430A91), int32_t(0x00000000)},
    {"global\\ai\\dawnl8\\stat.csv", "", int32_t(0x41DC7BB4), int32_t(0x00000000)},
    {"global\\ai\\dino\\actions.csv", "", int32_t(0x220726F8), int32_t(0x00000000)},
    {"global\\ai\\dino\\effector.csv", "", int32_t(0xE894E3FF), int32_t(0x00000000)},
    {"global\\ai\\dino\\goals.csv", "", int32_t(0xC42E324A), int32_t(0x00000000)},
    {"global\\ai\\dino\\spells.csv", "", int32_t(0xC63C4B39), int32_t(0x00000000)},
    {"global\\ai\\dino\\stat.csv", "", int32_t(0x54414269), int32_t(0x00000000)},
    {"global\\ai\\dracoid\\actions.csv", "", int32_t(0x5607558E), int32_t(0x00000000)},
    {"global\\ai\\dracoid\\effector.csv", "", int32_t(0x65CDE34B), int32_t(0x00000000)},
    {"global\\ai\\dracoid\\goals.csv", "", int32_t(0xC836D566), int32_t(0x00000000)},
    {"global\\ai\\dracoid\\spells.csv", "", int32_t(0x6C55C558), int32_t(0x00000000)},
    {"global\\ai\\dracoid\\stat.csv", "", int32_t(0x05C6E875), int32_t(0x00000000)},
    {"global\\ai\\drar_p\\actions.csv", "", int32_t(0xB499D7C0), int32_t(0x00000000)},
    {"global\\ai\\drar_p\\effector.csv", "", int32_t(0xE343760E), int32_t(0x00000000)},
    {"global\\ai\\drar_p\\goals.csv", "", int32_t(0xF2370AEC), int32_t(0x00000000)},
    {"global\\ai\\drar_p\\spells.csv", "", int32_t(0xD8DB29DC), int32_t(0x00000000)},
    {"global\\ai\\drar_p\\stat.csv", "", int32_t(0x12749AFE), int32_t(0x00000000)},
    {"global\\ai\\drar_ph\\actions.csv", "", int32_t(0xC70845AC), int32_t(0x00000000)},
    {"global\\ai\\drar_ph\\effector.csv", "", int32_t(0xD6CED369), int32_t(0x00000000)},
    {"global\\ai\\drar_ph\\goals.csv", "", int32_t(0x00B74D75), int32_t(0x00000000)},
    {"global\\ai\\drar_ph\\spells.csv", "", int32_t(0xA4D63D68), int32_t(0x00000000)},
    {"global\\ai\\drar_ph\\stat.csv", "", int32_t(0x3E476085), int32_t(0x00000000)},
    {"global\\ai\\draracle\\actions.csv", "", int32_t(0xC9BE5986), int32_t(0x00000000)},
    {"global\\ai\\draracle\\effector.csv", "", int32_t(0x904C168E), int32_t(0x00000000)},
    {"global\\ai\\draracle\\goals.csv", "", int32_t(0x1809CB91), int32_t(0x00000000)},
    {"global\\ai\\draracle\\spells.csv", "", int32_t(0x6DF37DC6), int32_t(0x00000000)},
    {"global\\ai\\draracle\\stat.csv", "", int32_t(0xA81CDBB0), int32_t(0x00000000)},
    {"global\\ai\\exec\\actions.csv", "", int32_t(0x1216C6AB), int32_t(0x00000000)},
    {"global\\ai\\exec\\effector.csv", "", int32_t(0xD8A483B4), int32_t(0x00000000)},
    {"global\\ai\\exec\\goals.csv", "", int32_t(0x3C360224), int32_t(0x00000000)},
    {"global\\ai\\exec\\spells.csv", "", int32_t(0xB64BEAEE), int32_t(0x00000000)},
    {"global\\ai\\exec\\stat.csv", "", int32_t(0xCC491243), int32_t(0x00000000)},
    {"global\\ai\\eye\\actions.csv", "", int32_t(0x4D80C2FC), int32_t(0x00000000)},
    {"global\\ai\\eye\\effector.csv", "", int32_t(0x5D4750B9), int32_t(0x00000000)},
    {"global\\ai\\eye\\goals.csv", "", int32_t(0xC3F38C1D), int32_t(0x00000000)},
    {"global\\ai\\eye\\spells.csv", "", int32_t(0x68127C11), int32_t(0x00000000)},
    {"global\\ai\\eye\\stat.csv", "", int32_t(0x01839F2E), int32_t(0x00000000)},
    {"global\\ai\\fire\\actions.csv", "", int32_t(0x2226D718), int32_t(0x00000000)},
    {"global\\ai\\fire\\effector.csv", "", int32_t(0xE8B4941F), int32_t(0x00000000)},
    {"global\\ai\\fire\\goals.csv", "", int32_t(0xC43E0A5A), int32_t(0x00000000)},
    {"global\\ai\\fire\\spells.csv", "", int32_t(0xC65BFB59), int32_t(0x00000000)},
    {"global\\ai\\fire\\stat.csv", "", int32_t(0x54511A79), int32_t(0x00000000)},
    {"global\\ai\\fireu\\actions.csv", "", int32_t(0xB8BA85FE), int32_t(0x00000000)},
    {"global\\ai\\fireu\\effector.csv", "", int32_t(0x46778DE1), int32_t(0x00000000)},
    {"global\\ai\\fireu\\goals.csv", "", int32_t(0x0DF82330), int32_t(0x00000000)},
    {"global\\ai\\fireu\\spells.csv", "", int32_t(0xEDDEC750), int32_t(0x00000000)},
    {"global\\ai\\fireu\\stat.csv", "", int32_t(0x1A0C3060), int32_t(0x00000000)},
    {"global\\ai\\ftig_cub\\actions.csv", "", int32_t(0x0BDD9245), int32_t(0x00000000)},
    {"global\\ai\\ftig_cub\\effector.csv", "", int32_t(0xD26B4F4E), int32_t(0x00000000)},
    {"global\\ai\\ftig_cub\\goals.csv", "", int32_t(0x391967F1), int32_t(0x00000000)},
    {"global\\ai\\ftig_cub\\spells.csv", "", int32_t(0xB012B684), int32_t(0x00000000)},
    {"global\\ai\\ftig_cub\\stat.csv", "", int32_t(0xC92C7810), int32_t(0x00000000)},
    {"global\\ai\\ftig_fem\\actions.csv", "", int32_t(0x3BDDE9C5), int32_t(0x00000000)},
    {"global\\ai\\ftig_fem\\effector.csv", "", int32_t(0x026BA6CD), int32_t(0x00000000)},
    {"global\\ai\\ftig_fem\\goals.csv", "", int32_t(0x511993B1), int32_t(0x00000000)},
    {"global\\ai\\ftig_fem\\spells.csv", "", int32_t(0xE0130E04), int32_t(0x00000000)},
    {"global\\ai\\ftig_fem\\stat.csv", "", int32_t(0xE12CA3D0), int32_t(0x00000000)},
    {"global\\ai\\ftig_mal\\actions.csv", "", int32_t(0xABDDE1A3), int32_t(0x00000000)},
    {"global\\ai\\ftig_mal\\effector.csv", "", int32_t(0x726B9EAB), int32_t(0x00000000)},
    {"global\\ai\\ftig_mal\\goals.csv", "", int32_t(0x89198FA0), int32_t(0x00000000)},
    {"global\\ai\\ftig_mal\\spells.csv", "", int32_t(0x501305E5), int32_t(0x00000000)},
    {"global\\ai\\ftig_mal\\stat.csv", "", int32_t(0x192C9FBF), int32_t(0x00000000)},
    {"global\\ai\\ftig_rog\\actions.csv", "", int32_t(0xFBDDBA13), int32_t(0x00000000)},
    {"global\\ai\\ftig_rog\\effector.csv", "", int32_t(0xC26B771B), int32_t(0x00000000)},
    {"global\\ai\\ftig_rog\\goals.csv", "", int32_t(0xB1197BD8), int32_t(0x00000000)},
    {"global\\ai\\ftig_rog\\spells.csv", "", int32_t(0xA012DE55), int32_t(0x00000000)},
    {"global\\ai\\ftig_rog\\stat.csv", "", int32_t(0x412C8BF7), int32_t(0x00000000)},
    {"global\\ai\\ggcapt\\actions.csv", "", int32_t(0x24514FD5), int32_t(0x00000000)},
    {"global\\ai\\ggcapt\\effector.csv", "", int32_t(0xC2B26639), int32_t(0x00000000)},
    {"global\\ai\\ggcapt\\goals.csv", "", int32_t(0x61EE8300), int32_t(0x00000000)},
    {"global\\ai\\ggcapt\\spells.csv", "", int32_t(0x4892A1F0), int32_t(0x00000000)},
    {"global\\ai\\ggcapt\\stat.csv", "", int32_t(0x822C1313), int32_t(0x00000000)},
    {"global\\ai\\gguard\\actions.csv", "", int32_t(0xA4615065), int32_t(0x00000000)},
    {"global\\ai\\gguard\\effector.csv", "", int32_t(0xC2D26758), int32_t(0x00000000)},
    {"global\\ai\\gguard\\goals.csv", "", int32_t(0xE1FE838F), int32_t(0x00000000)},
    {"global\\ai\\gguard\\spells.csv", "", int32_t(0xC8A2A27F), int32_t(0x00000000)},
    {"global\\ai\\gguard\\stat.csv", "", int32_t(0x023C13A3), int32_t(0x00000000)},
    {"global\\ai\\globalai.csv", "", int32_t(0x794B2157), int32_t(0x00000000)},
    {"global\\ai\\guard\\actions.csv", "", int32_t(0x7842ED77), int32_t(0x00000000)},
    {"global\\ai\\guard\\effector.csv", "", int32_t(0x05FFF55A), int32_t(0x00000000)},
    {"global\\ai\\guard\\goals.csv", "", int32_t(0xCD808AAA), int32_t(0x00000000)},
    {"global\\ai\\guard\\spells.csv", "", int32_t(0xAD672EC9), int32_t(0x00000000)},
    {"global\\ai\\guard\\stat.csv", "", int32_t(0x79D0641D), int32_t(0x00000000)},
    {"global\\ai\\hatom\\actions.csv", "", int32_t(0x389AD612), int32_t(0x00000000)},
    {"global\\ai\\hatom\\effector.csv", "", int32_t(0xC657DDF5), int32_t(0x00000000)},
    {"global\\ai\\hatom\\goals.csv", "", int32_t(0x8DD87345), int32_t(0x00000000)},
    {"global\\ai\\hatom\\spells.csv", "", int32_t(0x6DBF1764), int32_t(0x00000000)},
    {"global\\ai\\hatom\\stat.csv", "", int32_t(0xD9FC586A), int32_t(0x00000000)},
    {"global\\ai\\hivegrd\\actions.csv", "", int32_t(0xC60776E7), int32_t(0x00000000)},
    {"global\\ai\\hivegrd\\effector.csv", "", int32_t(0xD5CE04A4), int32_t(0x00000000)},
    {"global\\ai\\hivegrd\\goals.csv", "", int32_t(0x8036E612), int32_t(0x00000000)},
    {"global\\ai\\hivegrd\\spells.csv", "", int32_t(0x2455D605), int32_t(0x00000000)},
    {"global\\ai\\hivegrd\\stat.csv", "", int32_t(0xBDC6F922), int32_t(0x00000000)},
    {"global\\ai\\hivew\\actions.csv", "", int32_t(0xB8EA861E), int32_t(0x00000000)},
    {"global\\ai\\hivew\\effector.csv", "", int32_t(0x46A78E01), int32_t(0x00000000)},
    {"global\\ai\\hivew\\goals.csv", "", int32_t(0x0E282350), int32_t(0x00000000)},
    {"global\\ai\\hivew\\spells.csv", "", int32_t(0xEE0EC770), int32_t(0x00000000)},
    {"global\\ai\\hivew\\stat.csv", "", int32_t(0x1A243070), int32_t(0x00000000)},
    {"global\\ai\\hl1\\actions.csv", "", int32_t(0x7DB0C261), int32_t(0x00000000)},
    {"global\\ai\\hl1\\effector.csv", "", int32_t(0x8D77501E), int32_t(0x00000000)},
    {"global\\ai\\hl1\\goals.csv", "", int32_t(0x5C0B8BCF), int32_t(0x00000000)},
    {"global\\ai\\hl1\\spells.csv", "", int32_t(0x002A7BC0), int32_t(0x00000000)},
    {"global\\ai\\hl1\\stat.csv", "", int32_t(0x999B9EDD), int32_t(0x00000000)},
    {"global\\ai\\hl2\\actions.csv", "", int32_t(0x7DB0C269), int32_t(0x00000000)},
    {"global\\ai\\hl2\\effector.csv", "", int32_t(0x8D775026), int32_t(0x00000000)},
    {"global\\ai\\hl2\\goals.csv", "", int32_t(0x5C0B8BD3), int32_t(0x00000000)},
    {"global\\ai\\hl2\\spells.csv", "", int32_t(0x002A7BC4), int32_t(0x00000000)},
    {"global\\ai\\hl2\\stat.csv", "", int32_t(0x999B9EE1), int32_t(0x00000000)},
    {"global\\ai\\hl3\\actions.csv", "", int32_t(0x7DB0C271), int32_t(0x00000000)},
    {"global\\ai\\hl3\\effector.csv", "", int32_t(0x8D77502E), int32_t(0x00000000)},
    {"global\\ai\\hl3\\goals.csv", "", int32_t(0x5C0B8BD7), int32_t(0x00000000)},
    {"global\\ai\\hl3\\spells.csv", "", int32_t(0x002A7BC8), int32_t(0x00000000)},
    {"global\\ai\\hl3\\stat.csv", "", int32_t(0x999B9EE5), int32_t(0x00000000)},
    {"global\\ai\\huline\\actions.csv", "", int32_t(0x8C519018), int32_t(0x00000000)},
    {"global\\ai\\huline\\effector.csv", "", int32_t(0x92B2E6C0), int32_t(0x00000000)},
    {"global\\ai\\huline\\goals.csv", "", int32_t(0xC9EEC344), int32_t(0x00000000)},
    {"global\\ai\\huline\\spells.csv", "", int32_t(0xB092E234), int32_t(0x00000000)},
    {"global\\ai\\huline\\stat.csv", "", int32_t(0xEA2C5357), int32_t(0x00000000)},
    {"global\\ai\\human\\actions.csv", "", int32_t(0x78A265D7), int32_t(0x00000000)},
    {"global\\ai\\human\\effector.csv", "", int32_t(0x065F6DBA), int32_t(0x00000000)},
    {"global\\ai\\human\\goals.csv", "", int32_t(0xCDE0030A), int32_t(0x00000000)},
    {"global\\ai\\human\\spells.csv", "", int32_t(0xADC6A729), int32_t(0x00000000)},
    {"global\\ai\\human\\stat.csv", "", int32_t(0x7A00204D), int32_t(0x00000000)},
    {"global\\ai\\imp\\actions.csv", "", int32_t(0x8DC0C359), int32_t(0x00000000)},
    {"global\\ai\\imp\\effector.csv", "", int32_t(0x9D875116), int32_t(0x00000000)},
    {"global\\ai\\imp\\goals.csv", "", int32_t(0x64138C49), int32_t(0x00000000)},
    {"global\\ai\\imp\\spells.csv", "", int32_t(0x08327C3C), int32_t(0x00000000)},
    {"global\\ai\\imp\\stat.csv", "", int32_t(0xA1A39F59), int32_t(0x00000000)},
    {"global\\ai\\imp_bel\\actions.csv", "", int32_t(0x75D916C7), int32_t(0x00000000)},
    {"global\\ai\\imp_bel\\effector.csv", "", int32_t(0x859FA484), int32_t(0x00000000)},
    {"global\\ai\\imp_bel\\goals.csv", "", int32_t(0x581FB602), int32_t(0x00000000)},
    {"global\\ai\\imp_bel\\spells.csv", "", int32_t(0xFC3EA5F5), int32_t(0x00000000)},
    {"global\\ai\\imp_bel\\stat.csv", "", int32_t(0x95AFC912), int32_t(0x00000000)},
    {"global\\ai\\jagen\\actions.csv", "", int32_t(0x38C285AA), int32_t(0x00000000)},
    {"global\\ai\\jagen\\effector.csv", "", int32_t(0xC67F8D8D), int32_t(0x00000000)},
    {"global\\ai\\jagen\\goals.csv", "", int32_t(0x8E0022DD), int32_t(0x00000000)},
    {"global\\ai\\jagen\\spells.csv", "", int32_t(0x6DE6C6FC), int32_t(0x00000000)},
    {"global\\ai\\jagen\\stat.csv", "", int32_t(0xDA103036), int32_t(0x00000000)},
    {"global\\ai\\kadan\\actions.csv", "", int32_t(0x38D26592), int32_t(0x00000000)},
    {"global\\ai\\kadan\\effector.csv", "", int32_t(0xC68F6D75), int32_t(0x00000000)},
    {"global\\ai\\kadan\\goals.csv", "", int32_t(0x8E1002C5), int32_t(0x00000000)},
    {"global\\ai\\kadan\\spells.csv", "", int32_t(0x6DF6A6E4), int32_t(0x00000000)},
    {"global\\ai\\kadan\\stat.csv", "", int32_t(0xDA18202A), int32_t(0x00000000)},
    {"global\\ai\\kaf\\actions.csv", "", int32_t(0xCDE0C308), int32_t(0x00000000)},
    {"global\\ai\\kaf\\effector.csv", "", int32_t(0xDDA750C5), int32_t(0x00000000)},
    {"global\\ai\\kaf\\goals.csv", "", int32_t(0x04238C23), int32_t(0x00000000)},
    {"global\\ai\\kaf\\spells.csv", "", int32_t(0xA8427C16), int32_t(0x00000000)},
    {"global\\ai\\kaf\\stat.csv", "", int32_t(0x41B39F33), int32_t(0x00000000)},
    {"global\\ai\\kara\\actions.csv", "", int32_t(0xA276B717), int32_t(0x00000000)},
    {"global\\ai\\kara\\effector.csv", "", int32_t(0x6904741F), int32_t(0x00000000)},
    {"global\\ai\\kara\\goals.csv", "", int32_t(0x8465FA5A), int32_t(0x00000000)},
    {"global\\ai\\kara\\spells.csv", "", int32_t(0x46ABDB59), int32_t(0x00000000)},
    {"global\\ai\\kara\\stat.csv", "", int32_t(0x14790A79), int32_t(0x00000000)},
    {"global\\ai\\kelsrick\\actions.csv", "", int32_t(0x8BAE99ED), int32_t(0x00000000)},
    {"global\\ai\\kelsrick\\effector.csv", "", int32_t(0x523C56F3), int32_t(0x00000000)},
    {"global\\ai\\kelsrick\\goals.csv", "", int32_t(0x7901EBC5), int32_t(0x00000000)},
    {"global\\ai\\kelsrick\\spells.csv", "", int32_t(0x2FE3BE2F), int32_t(0x00000000)},
    {"global\\ai\\kelsrick\\stat.csv", "", int32_t(0x0914FBE4), int32_t(0x00000000)},
    {"global\\ai\\kenneth\\actions.csv", "", int32_t(0x66480687), int32_t(0x00000000)},
    {"global\\ai\\kenneth\\effector.csv", "", int32_t(0x760E9444), int32_t(0x00000000)},
    {"global\\ai\\kenneth\\goals.csv", "", int32_t(0x50572DE2), int32_t(0x00000000)},
    {"global\\ai\\kenneth\\spells.csv", "", int32_t(0xF4761DD5), int32_t(0x00000000)},
    {"global\\ai\\kenneth\\stat.csv", "", int32_t(0x8DE740F2), int32_t(0x00000000)},
    {"global\\ai\\kityara\\actions.csv", "", int32_t(0xC608B6AF), int32_t(0x00000000)},
    {"global\\ai\\kityara\\effector.csv", "", int32_t(0xD5CF446C), int32_t(0x00000000)},
    {"global\\ai\\kityara\\goals.csv", "", int32_t(0x803785F6), int32_t(0x00000000)},
    {"global\\ai\\kityara\\spells.csv", "", int32_t(0x245675E9), int32_t(0x00000000)},
    {"global\\ai\\kityara\\stat.csv", "", int32_t(0xBDC79906), int32_t(0x00000000)},
    {"global\\ai\\l4ww\\actions.csv", "", int32_t(0xD2876742), int32_t(0x00000000)},
    {"global\\ai\\l4ww\\effector.csv", "", int32_t(0x9915244A), int32_t(0x00000000)},
    {"global\\ai\\l4ww\\goals.csv", "", int32_t(0x1C6E526F), int32_t(0x00000000)},
    {"global\\ai\\l4ww\\spells.csv", "", int32_t(0x76BC8B82), int32_t(0x00000000)},
    {"global\\ai\\l4ww\\stat.csv", "", int32_t(0xAC81628E), int32_t(0x00000000)},
    {"global\\ai\\lamp_qn\\actions.csv", "", int32_t(0xB80826A6), int32_t(0x00000000)},
    {"global\\ai\\lamp_qn\\effector.csv", "", int32_t(0xC7CEB463), int32_t(0x00000000)},
    {"global\\ai\\lamp_qn\\goals.csv", "", int32_t(0xF9373DF1), int32_t(0x00000000)},
    {"global\\ai\\lamp_qn\\spells.csv", "", int32_t(0x9D562DE5), int32_t(0x00000000)},
    {"global\\ai\\lamp_qn\\stat.csv", "", int32_t(0x36C75102), int32_t(0x00000000)},
    {"global\\ai\\lamplt\\actions.csv", "", int32_t(0xC481C825), int32_t(0x00000000)},
    {"global\\ai\\lamplt\\effector.csv", "", int32_t(0x031356D9), int32_t(0x00000000)},
    {"global\\ai\\lamplt\\goals.csv", "", int32_t(0x021EFB50), int32_t(0x00000000)},
    {"global\\ai\\lamplt\\spells.csv", "", int32_t(0xE8C31A3F), int32_t(0x00000000)},
    {"global\\ai\\lamplt\\stat.csv", "", int32_t(0x225C8B63), int32_t(0x00000000)},
    {"global\\ai\\larkhon\\actions.csv", "", int32_t(0x9697D6F4), int32_t(0x00000000)},
    {"global\\ai\\larkhon\\effector.csv", "", int32_t(0xA65E64B3), int32_t(0x00000000)},
    {"global\\ai\\larkhon\\goals.csv", "", int32_t(0xE87F1619), int32_t(0x00000000)},
    {"global\\ai\\larkhon\\spells.csv", "", int32_t(0x8C9E060D), int32_t(0x00000000)},
    {"global\\ai\\larkhon\\stat.csv", "", int32_t(0x260F292A), int32_t(0x00000000)},
    {"global\\ai\\ls1\\actions.csv", "", int32_t(0xEDF0C25D), int32_t(0x00000000)},
    {"global\\ai\\ls1\\effector.csv", "", int32_t(0xFDB7501A), int32_t(0x00000000)},
    {"global\\ai\\ls1\\goals.csv", "", int32_t(0x942B8BCD), int32_t(0x00000000)},
    {"global\\ai\\ls1\\spells.csv", "", int32_t(0x384A7BC0), int32_t(0x00000000)},
    {"global\\ai\\ls1\\stat.csv", "", int32_t(0xD1BB9EDD), int32_t(0x00000000)},
    {"global\\ai\\luther\\actions.csv", "", int32_t(0xF4498858), int32_t(0x00000000)},
    {"global\\ai\\luther\\effector.csv", "", int32_t(0x62A2D73F), int32_t(0x00000000)},
    {"global\\ai\\luther\\goals.csv", "", int32_t(0x31E6BB83), int32_t(0x00000000)},
    {"global\\ai\\luther\\spells.csv", "", int32_t(0x188ADA73), int32_t(0x00000000)},
    {"global\\ai\\luther\\stat.csv", "", int32_t(0x52244B96), int32_t(0x00000000)},
    {"global\\ai\\malex\\actions.csv", "", int32_t(0x394285D2), int32_t(0x00000000)},
    {"global\\ai\\malex\\effector.csv", "", int32_t(0xC6FF8DB5), int32_t(0x00000000)},
    {"global\\ai\\malex\\goals.csv", "", int32_t(0x8E802305), int32_t(0x00000000)},
    {"global\\ai\\malex\\spells.csv", "", int32_t(0x6E66C724), int32_t(0x00000000)},
    {"global\\ai\\malex\\stat.csv", "", int32_t(0xDA50304A), int32_t(0x00000000)},
    {"global\\ai\\man\\actions.csv", "", int32_t(0xCE00C348), int32_t(0x00000000)},
    {"global\\ai\\man\\effector.csv", "", int32_t(0xDDC75105), int32_t(0x00000000)},
    {"global\\ai\\man\\goals.csv", "", int32_t(0x04338C43), int32_t(0x00000000)},
    {"global\\ai\\man\\spells.csv", "", int32_t(0xA8527C36), int32_t(0x00000000)},
    {"global\\ai\\man\\stat.csv", "", int32_t(0x41C39F53), int32_t(0x00000000)},
    {"global\\ai\\mauri\\actions.csv", "", int32_t(0x38CAEE1A), int32_t(0x00000000)},
    {"global\\ai\\mauri\\effector.csv", "", int32_t(0xC687F5FD), int32_t(0x00000000)},
    {"global\\ai\\mauri\\goals.csv", "", int32_t(0x8E088B4D), int32_t(0x00000000)},
    {"global\\ai\\mauri\\spells.csv", "", int32_t(0x6DEF2F6C), int32_t(0x00000000)},
    {"global\\ai\\mauri\\stat.csv", "", int32_t(0xDA14646E), int32_t(0x00000000)},
    {"global\\ai\\melik\\actions.csv", "", int32_t(0x78DAA5D2), int32_t(0x00000000)},
    {"global\\ai\\melik\\effector.csv", "", int32_t(0x0697ADB5), int32_t(0x00000000)},
    {"global\\ai\\melik\\goals.csv", "", int32_t(0xCE184305), int32_t(0x00000000)},
    {"global\\ai\\melik\\spells.csv", "", int32_t(0xADFEE724), int32_t(0x00000000)},
    {"global\\ai\\melik\\stat.csv", "", int32_t(0xFA1C404A), int32_t(0x00000000)},
    {"global\\ai\\moss\\actions.csv", "", int32_t(0x82974720), int32_t(0x00000000)},
    {"global\\ai\\moss\\effector.csv", "", int32_t(0x49250428), int32_t(0x00000000)},
    {"global\\ai\\moss\\goals.csv", "", int32_t(0xF476425E), int32_t(0x00000000)},
    {"global\\ai\\moss\\spells.csv", "", int32_t(0x26CC6B5C), int32_t(0x00000000)},
    {"global\\ai\\moss\\stat.csv", "", int32_t(0x8489527B), int32_t(0x00000000)},
    {"global\\ai\\mug\\actions.csv", "", int32_t(0x0E00C30C), int32_t(0x00000000)},
    {"global\\ai\\mug\\effector.csv", "", int32_t(0x1DC750C9), int32_t(0x00000000)},
    {"global\\ai\\mug\\goals.csv", "", int32_t(0xA4338C25), int32_t(0x00000000)},
    {"global\\ai\\mug\\spells.csv", "", int32_t(0x48527C18), int32_t(0x00000000)},
    {"global\\ai\\mug\\stat.csv", "", int32_t(0xE1C39F35), int32_t(0x00000000)},
    {"global\\ai\\oid\\actions.csv", "", int32_t(0x4E20C2F9), int32_t(0x00000000)},
    {"global\\ai\\oid\\effector.csv", "", int32_t(0x5DE750B6), int32_t(0x00000000)},
    {"global\\ai\\oid\\goals.csv", "", int32_t(0x44438C1B), int32_t(0x00000000)},
    {"global\\ai\\oid\\spells.csv", "", int32_t(0xE8627C0E), int32_t(0x00000000)},
    {"global\\ai\\oid\\stat.csv", "", int32_t(0x81D39F2B), int32_t(0x00000000)},
    {"global\\ai\\p2p\\actions.csv", "", int32_t(0xDE30C35B), int32_t(0x00000000)},
    {"global\\ai\\p2p\\effector.csv", "", int32_t(0xEDF75118), int32_t(0x00000000)},
    {"global\\ai\\p2p\\goals.csv", "", int32_t(0x8C4B8C4C), int32_t(0x00000000)},
    {"global\\ai\\p2p\\spells.csv", "", int32_t(0x306A7C3F), int32_t(0x00000000)},
    {"global\\ai\\p2p\\stat.csv", "", int32_t(0xC9DB9F5C), int32_t(0x00000000)},
    {"global\\ai\\pdracoid\\actions.csv", "", int32_t(0xCB5D427D), int32_t(0x00000000)},
    {"global\\ai\\pdracoid\\effector.csv", "", int32_t(0x91EAFF85), int32_t(0x00000000)},
    {"global\\ai\\pdracoid\\goals.csv", "", int32_t(0x98D9400D), int32_t(0x00000000)},
    {"global\\ai\\pdracoid\\spells.csv", "", int32_t(0x6F9266BF), int32_t(0x00000000)},
    {"global\\ai\\pdracoid\\stat.csv", "", int32_t(0x28EC502C), int32_t(0x00000000)},
    {"global\\ai\\pole\\actions.csv", "", int32_t(0x82C6D6E8), int32_t(0x00000000)},
    {"global\\ai\\pole\\effector.csv", "", int32_t(0x495493F0), int32_t(0x00000000)},
    {"global\\ai\\pole\\goals.csv", "", int32_t(0xF48E0A42), int32_t(0x00000000)},
    {"global\\ai\\pole\\spells.csv", "", int32_t(0x26FBFB24), int32_t(0x00000000)},
    {"global\\ai\\pole\\stat.csv", "", int32_t(0x84A11A5F), int32_t(0x00000000)},
    {"global\\ai\\poles\\actions.csv", "", int32_t(0x194A85CD), int32_t(0x00000000)},
    {"global\\ai\\poles\\effector.csv", "", int32_t(0xA7078DB0), int32_t(0x00000000)},
    {"global\\ai\\poles\\goals.csv", "", int32_t(0x6E882300), int32_t(0x00000000)},
    {"global\\ai\\poles\\spells.csv", "", int32_t(0x4E6EC71F), int32_t(0x00000000)},
    {"global\\ai\\poles\\stat.csv", "", int32_t(0x4A543048), int32_t(0x00000000)},
    {"global\\ai\\postx\\actions.csv", "", int32_t(0x1972FE05), int32_t(0x00000000)},
    {"global\\ai\\postx\\effector.csv", "", int32_t(0xA73005E8), int32_t(0x00000000)},
    {"global\\ai\\postx\\goals.csv", "", int32_t(0x6EB09B38), int32_t(0x00000000)},
    {"global\\ai\\postx\\spells.csv", "", int32_t(0x4E973F57), int32_t(0x00000000)},
    {"global\\ai\\postx\\stat.csv", "", int32_t(0x4A686C64), int32_t(0x00000000)},
    {"global\\ai\\priest\\actions.csv", "", int32_t(0xD4F97000), int32_t(0x00000000)},
    {"global\\ai\\priest\\effector.csv", "", int32_t(0x2402A68F), int32_t(0x00000000)},
    {"global\\ai\\priest\\goals.csv", "", int32_t(0x1296A32B), int32_t(0x00000000)},
    {"global\\ai\\priest\\spells.csv", "", int32_t(0xF93AC21C), int32_t(0x00000000)},
    {"global\\ai\\priest\\stat.csv", "", int32_t(0x32D4333E), int32_t(0x00000000)},
    {"global\\ai\\prollel\\actions.csv", "", int32_t(0x1757E6AE), int32_t(0x00000000)},
    {"global\\ai\\prollel\\effector.csv", "", int32_t(0x271E746B), int32_t(0x00000000)},
    {"global\\ai\\prollel\\goals.csv", "", int32_t(0xA8DF1DF6), int32_t(0x00000000)},
    {"global\\ai\\prollel\\spells.csv", "", int32_t(0x4CFE0DE9), int32_t(0x00000000)},
    {"global\\ai\\prollel\\stat.csv", "", int32_t(0xE66F3106), int32_t(0x00000000)},
    {"global\\ai\\rashar\\actions.csv", "", int32_t(0xB4898855), int32_t(0x00000000)},
    {"global\\ai\\rashar\\effector.csv", "", int32_t(0xE322D738), int32_t(0x00000000)},
    {"global\\ai\\rashar\\goals.csv", "", int32_t(0xF226BB7F), int32_t(0x00000000)},
    {"global\\ai\\rashar\\spells.csv", "", int32_t(0xD8CADA6F), int32_t(0x00000000)},
    {"global\\ai\\rashar\\stat.csv", "", int32_t(0x12644B93), int32_t(0x00000000)},
    {"global\\ai\\rat\\actions.csv", "", int32_t(0xCE50C378), int32_t(0x00000000)},
    {"global\\ai\\rat\\effector.csv", "", int32_t(0xDE175135), int32_t(0x00000000)},
    {"global\\ai\\rat\\goals.csv", "", int32_t(0x045B8C5B), int32_t(0x00000000)},
    {"global\\ai\\rat\\spells.csv", "", int32_t(0xA87A7C4E), int32_t(0x00000000)},
    {"global\\ai\\rat\\stat.csv", "", int32_t(0x41EB9F6B), int32_t(0x00000000)},
    {"global\\ai\\rg\\actions.csv", "", int32_t(0xE83E1676), int32_t(0x00000000)},
    {"global\\ai\\rg\\effector.csv", "", int32_t(0x4A8BF37B), int32_t(0x00000000)},
    {"global\\ai\\rg\\goals.csv", "", int32_t(0x25DB49A1), int32_t(0x00000000)},
    {"global\\ai\\rg\\spells.csv", "", int32_t(0x0C7F6891), int32_t(0x00000000)},
    {"global\\ai\\rg\\stat.csv", "", int32_t(0x4618D9B4), int32_t(0x00000000)},
    {"global\\ai\\rix\\actions.csv", "", int32_t(0x4E50C399), int32_t(0x00000000)},
    {"global\\ai\\rix\\effector.csv", "", int32_t(0x5E175156), int32_t(0x00000000)},
    {"global\\ai\\rix\\goals.csv", "", int32_t(0x445B8C6B), int32_t(0x00000000)},
    {"global\\ai\\rix\\spells.csv", "", int32_t(0xE87A7C5E), int32_t(0x00000000)},
    {"global\\ai\\rix\\stat.csv", "", int32_t(0x81EB9F7B), int32_t(0x00000000)},
    {"global\\ai\\roach\\actions.csv", "", int32_t(0x19127575), int32_t(0x00000000)},
    {"global\\ai\\roach\\effector.csv", "", int32_t(0xA6CF7D58), int32_t(0x00000000)},
    {"global\\ai\\roach\\goals.csv", "", int32_t(0x6E5012A8), int32_t(0x00000000)},
    {"global\\ai\\roach\\spells.csv", "", int32_t(0x4E36B6C7), int32_t(0x00000000)},
    {"global\\ai\\roach\\stat.csv", "", int32_t(0x4A38281C), int32_t(0x00000000)},
    {"global\\ai\\ruloi\\actions.csv", "", int32_t(0x791AD5CF), int32_t(0x00000000)},
    {"global\\ai\\ruloi\\effector.csv", "", int32_t(0x06D7DDB2), int32_t(0x00000000)},
    {"global\\ai\\ruloi\\goals.csv", "", int32_t(0xCE587302), int32_t(0x00000000)},
    {"global\\ai\\ruloi\\spells.csv", "", int32_t(0xAE3F1721), int32_t(0x00000000)},
    {"global\\ai\\ruloi\\stat.csv", "", int32_t(0x7A3C5849), int32_t(0x00000000)},
    {"global\\ai\\scotia\\actions.csv", "", int32_t(0x4CD9E834), int32_t(0x00000000)},
    {"global\\ai\\scotia\\effector.csv", "", int32_t(0x13C396F6), int32_t(0x00000000)},
    {"global\\ai\\scotia\\goals.csv", "", int32_t(0x8A771B5F), int32_t(0x00000000)},
    {"global\\ai\\scotia\\spells.csv", "", int32_t(0x711B3A4F), int32_t(0x00000000)},
    {"global\\ai\\scotia\\stat.csv", "", int32_t(0xAAB4AB72), int32_t(0x00000000)},
    {"global\\ai\\sewer\\actions.csv", "", int32_t(0x7972862A), int32_t(0x00000000)},
    {"global\\ai\\sewer\\effector.csv", "", int32_t(0x072F8E0D), int32_t(0x00000000)},
    {"global\\ai\\sewer\\goals.csv", "", int32_t(0xCEB0235D), int32_t(0x00000000)},
    {"global\\ai\\sewer\\spells.csv", "", int32_t(0xAE96C77C), int32_t(0x00000000)},
    {"global\\ai\\sewer\\stat.csv", "", int32_t(0xFA683076), int32_t(0x00000000)},
    {"global\\ai\\shade\\actions.csv", "", int32_t(0xA90A7D76), int32_t(0x00000000)},
    {"global\\ai\\shade\\effector.csv", "", int32_t(0x36C78559), int32_t(0x00000000)},
    {"global\\ai\\shade\\goals.csv", "", int32_t(0xFE481AA9), int32_t(0x00000000)},
    {"global\\ai\\shade\\spells.csv", "", int32_t(0xDE2EBEC8), int32_t(0x00000000)},
    {"global\\ai\\shade\\stat.csv", "", int32_t(0x12342C1C), int32_t(0x00000000)},
    {"global\\ai\\shalla\\actions.csv", "", int32_t(0x9CF1A7C5), int32_t(0x00000000)},
    {"global\\ai\\shalla\\effector.csv", "", int32_t(0xB3F31618), int32_t(0x00000000)},
    {"global\\ai\\shalla\\goals.csv", "", int32_t(0xDA8EDAEF), int32_t(0x00000000)},
    {"global\\ai\\shalla\\spells.csv", "", int32_t(0xC132F9DF), int32_t(0x00000000)},
    {"global\\ai\\shalla\\stat.csv", "", int32_t(0xFACC6B02), int32_t(0x00000000)},
    {"global\\ai\\shaman\\actions.csv", "", int32_t(0x0499AFC5), int32_t(0x00000000)},
    {"global\\ai\\shaman\\effector.csv", "", int32_t(0x83432619), int32_t(0x00000000)},
    {"global\\ai\\shaman\\goals.csv", "", int32_t(0x4236E2F0), int32_t(0x00000000)},
    {"global\\ai\\shaman\\spells.csv", "", int32_t(0x28DB01E0), int32_t(0x00000000)},
    {"global\\ai\\shaman\\stat.csv", "", int32_t(0x62747303), int32_t(0x00000000)},
    {"global\\ai\\skel\\actions.csv", "", int32_t(0x42F70EB0), int32_t(0x00000000)},
    {"global\\ai\\skel\\effector.csv", "", int32_t(0x0984CBB8), int32_t(0x00000000)},
    {"global\\ai\\skel\\goals.csv", "", int32_t(0xD4A62626), int32_t(0x00000000)},
    {"global\\ai\\skel\\spells.csv", "", int32_t(0xE72C32ED), int32_t(0x00000000)},
    {"global\\ai\\skel\\stat.csv", "", int32_t(0x64B93643), int32_t(0x00000000)},
    {"global\\ai\\slime1\\actions.csv", "", int32_t(0x5CB9B005), int32_t(0x00000000)},
    {"global\\ai\\slime1\\effector.csv", "", int32_t(0x33832696), int32_t(0x00000000)},
    {"global\\ai\\slime1\\goals.csv", "", int32_t(0x9A56E32F), int32_t(0x00000000)},
    {"global\\ai\\slime1\\spells.csv", "", int32_t(0x80FB021F), int32_t(0x00000000)},
    {"global\\ai\\slime1\\stat.csv", "", int32_t(0xBA947342), int32_t(0x00000000)},
    {"global\\ai\\slime2\\actions.csv", "", int32_t(0x64B9B005), int32_t(0x00000000)},
    {"global\\ai\\slime2\\effector.csv", "", int32_t(0x43832696), int32_t(0x00000000)},
    {"global\\ai\\slime2\\goals.csv", "", int32_t(0xA256E32F), int32_t(0x00000000)},
    {"global\\ai\\slime2\\spells.csv", "", int32_t(0x88FB021F), int32_t(0x00000000)},
    {"global\\ai\\slime2\\stat.csv", "", int32_t(0xC2947342), int32_t(0x00000000)},
    {"global\\ai\\spare\\actions.csv", "", int32_t(0x290AED75), int32_t(0x00000000)},
    {"global\\ai\\spare\\effector.csv", "", int32_t(0xB6C7F558), int32_t(0x00000000)},
    {"global\\ai\\spare\\goals.csv", "", int32_t(0x7E488AA8), int32_t(0x00000000)},
    {"global\\ai\\spare\\spells.csv", "", int32_t(0x5E2F2EC7), int32_t(0x00000000)},
    {"global\\ai\\spare\\stat.csv", "", int32_t(0x5234641C), int32_t(0x00000000)},
    {"global\\ai\\spider\\actions.csv", "", int32_t(0xA4B96800), int32_t(0x00000000)},
    {"global\\ai\\spider\\effector.csv", "", int32_t(0xC382968E), int32_t(0x00000000)},
    {"global\\ai\\spider\\goals.csv", "", int32_t(0xE2569B2C), int32_t(0x00000000)},
    {"global\\ai\\spider\\spells.csv", "", int32_t(0xC8FABA1C), int32_t(0x00000000)},
    {"global\\ai\\spider\\stat.csv", "", int32_t(0x02942B3E), int32_t(0x00000000)},
    {"global\\ai\\ssar\\actions.csv", "", int32_t(0xC2F73E90), int32_t(0x00000000)},
    {"global\\ai\\ssar\\effector.csv", "", int32_t(0x8984FB94), int32_t(0x00000000)},
    {"global\\ai\\ssar\\goals.csv", "", int32_t(0x14A63E14), int32_t(0x00000000)},
    {"global\\ai\\ssar\\spells.csv", "", int32_t(0x672C62CC), int32_t(0x00000000)},
    {"global\\ai\\ssar\\stat.csv", "", int32_t(0xA4B94E33), int32_t(0x00000000)},
    {"global\\ai\\ssar_p\\actions.csv", "", int32_t(0xC589D7C0), int32_t(0x00000000)},
    {"global\\ai\\ssar_p\\effector.csv", "", int32_t(0x0523760F), int32_t(0x00000000)},
    {"global\\ai\\ssar_p\\goals.csv", "", int32_t(0x03270AEB), int32_t(0x00000000)},
    {"global\\ai\\ssar_p\\spells.csv", "", int32_t(0xE9CB29DC), int32_t(0x00000000)},
    {"global\\ai\\ssar_p\\stat.csv", "", int32_t(0x23649AFE), int32_t(0x00000000)},
    {"global\\ai\\stiger\\actions.csv", "", int32_t(0xE4B98000), int32_t(0x00000000)},
    {"global\\ai\\stiger\\effector.csv", "", int32_t(0x4382C68F), int32_t(0x00000000)},
    {"global\\ai\\stiger\\goals.csv", "", int32_t(0x2256B32B), int32_t(0x00000000)},
    {"global\\ai\\stiger\\spells.csv", "", int32_t(0x08FAD21B), int32_t(0x00000000)},
    {"global\\ai\\stiger\\stat.csv", "", int32_t(0x4294433E), int32_t(0x00000000)},
    {"global\\ai\\stsquid\\actions.csv", "", int32_t(0x984836AE), int32_t(0x00000000)},
    {"global\\ai\\stsquid\\effector.csv", "", int32_t(0xA80EC469), int32_t(0x00000000)},
    {"global\\ai\\stsquid\\goals.csv", "", int32_t(0xE95745F6), int32_t(0x00000000)},
    {"global\\ai\\stsquid\\spells.csv", "", int32_t(0x8D7635E8), int32_t(0x00000000)},
    {"global\\ai\\stsquid\\stat.csv", "", int32_t(0x26E75905), int32_t(0x00000000)},
    {"global\\ai\\swarmer\\actions.csv", "", int32_t(0xB7C845FC), int32_t(0x00000000)},
    {"global\\ai\\swarmer\\effector.csv", "", int32_t(0xC78ED3B9), int32_t(0x00000000)},
    {"global\\ai\\swarmer\\goals.csv", "", int32_t(0xF9174D9E), int32_t(0x00000000)},
    {"global\\ai\\swarmer\\spells.csv", "", int32_t(0x9D363D90), int32_t(0x00000000)},
    {"global\\ai\\swarmer\\stat.csv", "", int32_t(0x36A760AD), int32_t(0x00000000)},
    {"global\\ai\\tig_cub\\actions.csv", "", int32_t(0xF74915E7), int32_t(0x00000000)},
    {"global\\ai\\tig_cub\\effector.csv", "", int32_t(0x070FA3A3), int32_t(0x00000000)},
    {"global\\ai\\tig_cub\\goals.csv", "", int32_t(0x98D7B592), int32_t(0x00000000)},
    {"global\\ai\\tig_cub\\spells.csv", "", int32_t(0x3CF6A585), int32_t(0x00000000)},
    {"global\\ai\\tig_cub\\stat.csv", "", int32_t(0xD667C8A2), int32_t(0x00000000)},
    {"global\\ai\\tig_fe\\actions.csv", "", int32_t(0xCCD23FF5), int32_t(0x00000000)},
    {"global\\ai\\tig_fe\\effector.csv", "", int32_t(0x13B44679), int32_t(0x00000000)},
    {"global\\ai\\tig_fe\\goals.csv", "", int32_t(0x0A6F7320), int32_t(0x00000000)},
    {"global\\ai\\tig_fe\\spells.csv", "", int32_t(0xF113920F), int32_t(0x00000000)},
    {"global\\ai\\tig_fe\\stat.csv", "", int32_t(0x2AAD0333), int32_t(0x00000000)},
    {"global\\ai\\tig_mal\\actions.csv", "", int32_t(0xB7E91636), int32_t(0x00000000)},
    {"global\\ai\\tig_mal\\effector.csv", "", int32_t(0xC7AFA3F3), int32_t(0x00000000)},
    {"global\\ai\\tig_mal\\goals.csv", "", int32_t(0xF927B5B9), int32_t(0x00000000)},
    {"global\\ai\\tig_mal\\spells.csv", "", int32_t(0x9D46A5AD), int32_t(0x00000000)},
    {"global\\ai\\tig_mal\\stat.csv", "", int32_t(0x36B7C8CA), int32_t(0x00000000)},
    {"global\\ai\\tig_rog\\actions.csv", "", int32_t(0x9839160F), int32_t(0x00000000)},
    {"global\\ai\\tig_rog\\effector.csv", "", int32_t(0xA7FFA3CC), int32_t(0x00000000)},
    {"global\\ai\\tig_rog\\goals.csv", "", int32_t(0x694FB5A6), int32_t(0x00000000)},
    {"global\\ai\\tig_rog\\spells.csv", "", int32_t(0x0D6EA599), int32_t(0x00000000)},
    {"global\\ai\\tig_rog\\stat.csv", "", int32_t(0xA6DFC8B6), int32_t(0x00000000)},
    {"global\\ai\\tree\\actions.csv", "", int32_t(0xB306D6B0), int32_t(0x00000000)},
    {"global\\ai\\tree\\effector.csv", "", int32_t(0x799493B4), int32_t(0x00000000)},
    {"global\\ai\\tree\\goals.csv", "", int32_t(0x0CAE0A24), int32_t(0x00000000)},
    {"global\\ai\\tree\\spells.csv", "", int32_t(0x573BFAEC), int32_t(0x00000000)},
    {"global\\ai\\tree\\stat.csv", "", int32_t(0x9CC11A43), int32_t(0x00000000)},
    {"global\\ai\\treex\\actions.csv", "", int32_t(0x49B28595), int32_t(0x00000000)},
    {"global\\ai\\treex\\effector.csv", "", int32_t(0xD76F8D78), int32_t(0x00000000)},
    {"global\\ai\\treex\\goals.csv", "", int32_t(0x9EF022C8), int32_t(0x00000000)},
    {"global\\ai\\treex\\spells.csv", "", int32_t(0x7ED6C6E7), int32_t(0x00000000)},
    {"global\\ai\\treex\\stat.csv", "", int32_t(0x6288302D), int32_t(0x00000000)},
    {"global\\ai\\villager\\actions.csv", "", int32_t(0xEBFE61FD), int32_t(0x00000000)},
    {"global\\ai\\villager\\effector.csv", "", int32_t(0xB28C1F05), int32_t(0x00000000)},
    {"global\\ai\\villager\\goals.csv", "", int32_t(0xA929CFCD), int32_t(0x00000000)},
    {"global\\ai\\villager\\spells.csv", "", int32_t(0x9033863F), int32_t(0x00000000)},
    {"global\\ai\\villager\\stat.csv", "", int32_t(0x393CDFEC), int32_t(0x00000000)},
    {"global\\ai\\visc\\actions.csv", "", int32_t(0x2326C720), int32_t(0x00000000)},
    {"global\\ai\\visc\\effector.csv", "", int32_t(0xE9B48427), int32_t(0x00000000)},
    {"global\\ai\\visc\\goals.csv", "", int32_t(0xC4BE025E), int32_t(0x00000000)},
    {"global\\ai\\visc\\spells.csv", "", int32_t(0xC75BEB61), int32_t(0x00000000)},
    {"global\\ai\\visc\\stat.csv", "", int32_t(0x54D1127D), int32_t(0x00000000)},
    {"global\\ai\\wild2\\actions.csv", "", int32_t(0xB8B27DCE), int32_t(0x00000000)},
    {"global\\ai\\wild2\\effector.csv", "", int32_t(0x466F85B1), int32_t(0x00000000)},
    {"global\\ai\\wild2\\goals.csv", "", int32_t(0x0DF01B00), int32_t(0x00000000)},
    {"global\\ai\\wild2\\spells.csv", "", int32_t(0xEDD6BF20), int32_t(0x00000000)},
    {"global\\ai\\wild2\\stat.csv", "", int32_t(0x1A082C48), int32_t(0x00000000)},
    {"global\\ai\\wild\\actions.csv", "", int32_t(0x2336CEE8), int32_t(0x00000000)},
    {"global\\ai\\wild\\effector.csv", "", int32_t(0xE9C48BEF), int32_t(0x00000000)},
    {"global\\ai\\wild\\goals.csv", "", int32_t(0xC4C60642), int32_t(0x00000000)},
    {"global\\ai\\wild\\spells.csv", "", int32_t(0xC76BF329), int32_t(0x00000000)},
    {"global\\ai\\wild\\stat.csv", "", int32_t(0x54D91661), int32_t(0x00000000)},
    {"global\\ai\\worm\\actions.csv", "", int32_t(0x83371718), int32_t(0x00000000)},
    {"global\\ai\\worm\\effector.csv", "", int32_t(0x49C4D420), int32_t(0x00000000)},
    {"global\\ai\\worm\\goals.csv", "", int32_t(0xF4C62A5A), int32_t(0x00000000)},
    {"global\\ai\\worm\\spells.csv", "", int32_t(0x276C3B54), int32_t(0x00000000)},
    {"global\\ai\\worm\\stat.csv", "", int32_t(0x84D93A77), int32_t(0x00000000)},
    {"global\\global.img", "", int32_t(0xFF72C08E), int32_t(0x00000000)},
    {"global\\global.odf", "", int32_t(0xED7EC08D), int32_t(0x00000000)},
    {"global\\global.tex", "", int32_t(0xEF88C09F), int32_t(0x00000000)},
    {"global\\global.ver", "", int32_t(0xEF8CC099), int32_t(0x00000000)},
    {"global\\sounds.efx", "", int32_t(0x5D9AD8B8), int32_t(0x00000000)},
    {"global\\sounds.ver", "", int32_t(0x5BBCD8B2), int32_t(0x00000000)},
    {"global\\spell.odf", "", int32_t(0x3EC86D0D), int32_t(0x00000000)},
    {"global\\spell.tex", "", int32_t(0x50C9720D), int32_t(0x00000000)},
    {"global\\spell.ver", "", int32_t(0x4AC9740D), int32_t(0x00000000)},
    {"globalai.csv", "", int32_t(0xF2130CCD), int32_t(0x00000000)},
    {"globe.shp", "-", int32_t(0x00000000), int32_t(0x7BD0EA38)},
    {"gloom.aud", "gloom", int32_t(0xE7BF8DFB), int32_t(0x641B2599)},
    {"gloop1.aud", "", int32_t(0xBF99D812), int32_t(0x00000000)},
    {"gloop10.aud", "", int32_t(0x99E1E8FE), int32_t(0x00000000)},
    {"gloop11.aud", "", int32_t(0x99E3E8FE), int32_t(0x00000000)},
    {"gloop2.aud", "", int32_t(0xBF99DA12), int32_t(0x00000000)},
    {"gloop3.aud", "", int32_t(0xBF99DC12), int32_t(0x00000000)},
    {"gloop4.aud", "", int32_t(0xBF99DE12), int32_t(0x00000000)},
    {"gloop5.aud", "", int32_t(0xBF99E012), int32_t(0x00000000)},
    {"gloop6.aud", "", int32_t(0xBF99E212), int32_t(0x00000000)},
    {"gloop7.aud", "", int32_t(0xBF99E412), int32_t(0x00000000)},
    {"gloop8.aud", "", int32_t(0xBF99E612), int32_t(0x00000000)},
    {"gloop9.aud", "", int32_t(0xBF99E812), int32_t(0x00000000)},
    {"glorepmk.shp", "", int32_t(0x00000000), int32_t(0x73F8AF2C)},
    {"glowpot.lbm", "", int32_t(0xBA331209), int32_t(0x00000000)},
    {"glpilemk.shp", "", int32_t(0x00000000), int32_t(0xA16101A7)},
    {"glpillmk.shp", "", int32_t(0x00000000), int32_t(0x34F94474)},
    {"glpowrmk.shp", "", int32_t(0x00000000), int32_t(0x51D3F710)},
    {"glprismk.shp", "", int32_t(0x00000000), int32_t(0xC31A7A9B)},
    {"glrefnmk.shp", "", int32_t(0x00000000), int32_t(0xD0676ABC)},
    {"gls.pal", "", int32_t(0x00000000), int32_t(0x4EAA594A)},
    {"glsand.shp", "", int32_t(0x00000000), int32_t(0xCEDD9C9D)},
    {"glsl.shp", "", int32_t(0x00000000), int32_t(0xAF14189C)},
    {"glslmd.shp", "", int32_t(0x00000000), int32_t(0xB11D7C29)},
    {"glsmd.pal", "", int32_t(0x00000000), int32_t(0x366CBDFB)},
    {"glspstmk.shp", "", int32_t(0x00000000), int32_t(0x2E07FA73)},
    {"glss.shp", "", int32_t(0x00000000), int32_t(0x4DA418CF)},
    {"gltechmk.shp", "", int32_t(0x00000000), int32_t(0xF64921A5)},
    {"glugwine.aud", "", int32_t(0xEC4704F9), int32_t(0x00000000)},
    {"glwall.shp", "", int32_t(0x00000000), int32_t(0xB6FC75FD)},
    {"glweapmk.shp", "", int32_t(0x00000000), int32_t(0x0B6A4F72)},
    {"glwethmk.shp", "", int32_t(0x00000000), int32_t(0x6B00A294)},
    {"glyardmk.shp", "", int32_t(0x00000000), int32_t(0x29EAA0D8)},
    {"gmenu.mix", "-", int32_t(0x00000000), int32_t(0x30F90780)},
    {"gnaircmk.shp", "", int32_t(0x00000000), int32_t(0x3B804493)},
    {"gncnstmk.shp", "", int32_t(0x00000000), int32_t(0x35C75BB9)},
    {"gncommmk.shp", "", int32_t(0x00000000), int32_t(0xB9CBB5FE)},
    {"gncsphmk.shp", "", int32_t(0x00000000), int32_t(0x46B90FC6)},
    {"gndeptmk.shp", "", int32_t(0x00000000), int32_t(0xDBC1D9FE)},
    {"gngapmk.shp", "", int32_t(0x00000000), int32_t(0xE1885D0B)},
    {"gngate_a.shp", "", int32_t(0x00000000), int32_t(0x2C571140)},
    {"gngcanmk.shp", "", int32_t(0x00000000), int32_t(0x3053E942)},
    {"gnorepmk.shp", "", int32_t(0x00000000), int32_t(0x2B9416ED)},
    {"gnpilemk.shp", "", int32_t(0x00000000), int32_t(0xF90DB866)},
    {"gnpillmk.shp", "", int32_t(0x00000000), int32_t(0x6C95FDB5)},
    {"gnpowrmk.shp", "", int32_t(0x00000000), int32_t(0x09BF4ED1)},
    {"gnprismk.shp", "", int32_t(0x00000000), int32_t(0x9B76C35A)},
    {"gnrefnmk.shp", "", int32_t(0x00000000), int32_t(0x880BD37D)},
    {"gnrl.shp", "unit: cosygin", int32_t(0xE8ECEFBC), int32_t(0x00000000)},
    {"gnsand.shp", "", int32_t(0x00000000), int32_t(0x96B1255C)},
    {"gnspstmk.shp", "", int32_t(0x00000000), int32_t(0x766B43B2)},
    {"gntechmk.shp", "", int32_t(0x00000000), int32_t(0xAE259864)},
    {"gnwall.shp", "", int32_t(0x00000000), int32_t(0xEE90CC3C)},
    {"gnweapmk.shp", "", int32_t(0x00000000), int32_t(0x5306F6B3)},
    {"gnwethmk.shp", "", int32_t(0x00000000), int32_t(0x336C1B55)},
    {"gnyardmk.shp", "", int32_t(0x00000000), int32_t(0x71861919)},
    {"goals.csv", "", int32_t(0xD78B9A19), int32_t(0x00000000)},
    {"goat01.aud", "", int32_t(0xD361E3D2), int32_t(0x00000000)},
    {"goat1.aud", "", int32_t(0xFB8799C3), int32_t(0x00000000)},
    {"godmode.flc", "", int32_t(0x91DF1201), int32_t(0x00000000)},
    {"gold01.sno", "misc: ore #1", int32_t(0xB78DEECB), int32_t(0x17F5073C)},
    {"gold01.tem", "misc: ore #1", int32_t(0xB98DECC2), int32_t(0xE68251CB)},
    {"gold01.urb", "", int32_t(0x00000000), int32_t(0x9EA3D5A7)},
    {"gold02.sno", "misc: ore #2", int32_t(0xB78DF0CB), int32_t(0x261D1DA1)},
    {"gold02.tem", "misc: ore #2", int32_t(0xB98DEEC2), int32_t(0xD76A4B56)},
    {"gold02.urb", "", int32_t(0x00000000), int32_t(0xAF4BCF3A)},
    {"gold03.sno", "misc: ore #3", int32_t(0xB78DF2CB), int32_t(0x806A1615)},
    {"gold03.tem", "misc: ore #3", int32_t(0xB98DF0C2), int32_t(0x711D40E2)},
    {"gold03.urb", "", int32_t(0x00000000), int32_t(0x093CC48E)},
    {"gold04.sno", "misc: ore #4", int32_t(0xB78DF4CB), int32_t(0x45CD289B)},
    {"gold04.tem", "misc: ore #4", int32_t(0xB98DF2C2), int32_t(0xB4BA7E6C)},
    {"gold04.urb", "", int32_t(0x00000000), int32_t(0xCC9BFA00)},
    {"gong2.aud", "", int32_t(0xC7BB99C5), int32_t(0x00000000)},
    {"goo01.flc", "", int32_t(0x59C999C2), int32_t(0x00000000)},
    {"goo02.flc", "", int32_t(0x59C999C4), int32_t(0x00000000)},
    {"goop1.aud", "", int32_t(0xEBBF99C3), int32_t(0x00000000)},
    {"goop2.aud", "", int32_t(0xEBBF99C5), int32_t(0x00000000)},
    {"goop3.aud", "", int32_t(0xEBBF99C7), int32_t(0x00000000)},
    {"goop4.aud", "", int32_t(0xEBBF99C9), int32_t(0x00000000)},
    {"gorep.shp", "", int32_t(0x00000000), int32_t(0x6058D4E7)},
    {"gostgun1.aud", "ghost talker", int32_t(0x00000000), int32_t(0x7B6DBCA4)},
    {"gosticon.shp", "icon: ghost stalker", int32_t(0x00000000), int32_t(0x20236CA6)},
    {"gothic1.aud", "", int32_t(0x7DF818F0), int32_t(0x00000000)},
    {"gothic2.aud", "", int32_t(0x7DFA18F0), int32_t(0x00000000)},
    {"gothic3.aud", "", int32_t(0x7DFC18F0), int32_t(0x00000000)},
    {"gotit1.aud", "commando you got it", int32_t(0xA7ADE41A), int32_t(0x00000000)},
    {"gotshot1.aud", "", int32_t(0xF44F1CDB), int32_t(0x00000000)},
    {"gpsbox.shp", "crat: gps", int32_t(0xAFAA4203), int32_t(0x00000000)},
    {"gpslnch.vqa", "", int32_t(0x8E1F190F), int32_t(0x00000000)},
    {"gpssicon.shp", "icon: gps satellite", int32_t(0x3A341ADD), int32_t(0x00000000)},
    {"grad12fn.fnt", "grad 12 font", int32_t(0x01DFF3AD), int32_t(0x00000000)},
    {"grad6fnt.fnt", "grad 6 font", int32_t(0x0DF01BB7), int32_t(0x474404D7)},
    {"granite1.aud", "", int32_t(0xDFE532DD), int32_t(0x00000000)},
    {"grdfoot1.aud", "", int32_t(0xC00F28E9), int32_t(0x00000000)},
    {"grdfoot2.aud", "", int32_t(0xC20F28E9), int32_t(0x00000000)},
    {"grdhurt3.aud", "", int32_t(0xCC0F2EF5), int32_t(0x00000000)},
    {"grdhurt4.aud", "", int32_t(0xCE0F2EF5), int32_t(0x00000000)},
    {"green01.des", "", int32_t(0x00000000), int32_t(0xBC7199D5)},
    {"green01.lun", "", int32_t(0x00000000), int32_t(0x9A8F7E56)},
    {"green01.sno", "", int32_t(0x00000000), int32_t(0x9B9D444F)},
    {"green01.tem", "-", int32_t(0x00000000), int32_t(0x3829F195)},
    {"green01.ubn", "", int32_t(0x00000000), int32_t(0xAEF7D3B6)},
    {"green01.urb", "", int32_t(0x00000000), int32_t(0x1E643FCA)},
    {"green01a.des", "", int32_t(0x00000000), int32_t(0x85B9E03A)},
    {"green01a.lun", "", int32_t(0x00000000), int32_t(0xA26ECF0A)},
    {"green01a.sno", "", int32_t(0x00000000), int32_t(0x6B25D04B)},
    {"green01a.tem", "-", int32_t(0x00000000), int32_t(0x63907E29)},
    {"green01a.ubn", "", int32_t(0x00000000), int32_t(0xB41AD363)},
    {"green01a.urb", "", int32_t(0x00000000), int32_t(0xF76E8D19)},
    {"green01b.des", "", int32_t(0x00000000), int32_t(0xC2199AEA)},
    {"green01b.lun", "", int32_t(0x00000000), int32_t(0xE5CEB5DA)},
    {"green01b.sno", "", int32_t(0x00000000), int32_t(0x2C85AA9B)},
    {"green01b.tem", "-", int32_t(0x00000000), int32_t(0x243004F9)},
    {"green01b.ubn", "", int32_t(0x00000000), int32_t(0xF3BAA9B3)},
    {"green01b.urb", "", int32_t(0x00000000), int32_t(0xB0CEF7C9)},
    {"green01c.des", "", int32_t(0x00000000), int32_t(0xFF79B35A)},
    {"green01c.lun", "", int32_t(0x00000000), int32_t(0xD8AE9C6A)},
    {"green01c.sno", "", int32_t(0x00000000), int32_t(0x11E5832B)},
    {"green01c.tem", "-", int32_t(0x00000000), int32_t(0x19502D49)},
    {"green01c.ubn", "", int32_t(0x00000000), int32_t(0xCEDA8003)},
    {"green01c.urb", "", int32_t(0x00000000), int32_t(0x8DAEDE79)},
    {"green01d.des", "", int32_t(0x00000000), int32_t(0x4D596F4A)},
    {"green01d.lun", "", int32_t(0x00000000), int32_t(0x6A8E407A)},
    {"green01d.sno", "", int32_t(0x00000000), int32_t(0xA3C55F3B)},
    {"green01d.tem", "-", int32_t(0x00000000), int32_t(0xAB70F159)},
    {"green01d.ubn", "", int32_t(0x00000000), int32_t(0x7CFA5C13)},
    {"green01d.urb", "", int32_t(0x00000000), int32_t(0x3F8E0269)},
    {"green01e.des", "", int32_t(0x00000000), int32_t(0x703946FA)},
    {"green01e.lun", "", int32_t(0x00000000), int32_t(0x57EE69CA)},
    {"green01e.sno", "", int32_t(0x00000000), int32_t(0x9EA5768B)},
    {"green01e.tem", "-", int32_t(0x00000000), int32_t(0x9610D8E9)},
    {"green01e.ubn", "", int32_t(0x00000000), int32_t(0x419A75A3)},
    {"green01e.urb", "", int32_t(0x00000000), int32_t(0x02EE2BD9)},
    {"green01f.des", "", int32_t(0x00000000), int32_t(0x37993C2A)},
    {"green01f.lun", "", int32_t(0x00000000), int32_t(0x104E131A)},
    {"green01f.sno", "", int32_t(0x00000000), int32_t(0xD9050C5B)},
    {"green01f.tem", "-", int32_t(0x00000000), int32_t(0xD1B0A239)},
    {"green01f.ubn", "", int32_t(0x00000000), int32_t(0x063A0F73)},
    {"green01f.urb", "", int32_t(0x00000000), int32_t(0x454E5109)},
    {"green01g.des", "", int32_t(0x00000000), int32_t(0x0AF9159A)},
    {"green01g.lun", "", int32_t(0x00000000), int32_t(0x2D2E3AAA)},
    {"green01g.sno", "", int32_t(0x00000000), int32_t(0xE46525EB)},
    {"green01g.tem", "-", int32_t(0x00000000), int32_t(0xECD08B89)},
    {"green01g.ubn", "", int32_t(0x00000000), int32_t(0x3B5A26C3)},
    {"green01g.urb", "", int32_t(0x00000000), int32_t(0x782E78B9)},
    {"grenade1.aud", "tanya dart", int32_t(0xDFF512CD), int32_t(0x00000000)},
    {"grey01.sno", "-", int32_t(0x00000000), int32_t(0xD30D001C)},
    {"grey01a.sno", "-", int32_t(0x00000000), int32_t(0xC5E670FD)},
    {"grey01b.sno", "-", int32_t(0x00000000), int32_t(0x43720253)},
    {"grey01c.sno", "-", int32_t(0x00000000), int32_t(0x882ED1F6)},
    {"grey01d.sno", "-", int32_t(0x00000000), int32_t(0x952BE14E)},
    {"grey01e.sno", "-", int32_t(0x00000000), int32_t(0x5E7732EB)},
    {"grey01f.sno", "-", int32_t(0x00000000), int32_t(0xD8E34045)},
    {"grey01g.sno", "-", int32_t(0x00000000), int32_t(0x13BF93E0)},
    {"greyerth.wsa", "anim: spinning earth", int32_t(0x371144D5), int32_t(0x00000000)},
    {"grfix01.ubn", "", int32_t(0x00000000), int32_t(0x1920A30D)},
    {"grfix01.urb", "", int32_t(0x00000000), int32_t(0xA9B34F71)},
    {"grfix02.ubn", "", int32_t(0x00000000), int32_t(0x9FB4D1A3)},
    {"grfix02.urb", "", int32_t(0x00000000), int32_t(0x2F273DDF)},
    {"grfix03.ubn", "", int32_t(0x00000000), int32_t(0x54E80206)},
    {"grfix03.urb", "", int32_t(0x00000000), int32_t(0xE47BEE7A)},
    {"grfix04.ubn", "", int32_t(0x00000000), int32_t(0x49ED32BE)},
    {"grfix04.urb", "", int32_t(0x00000000), int32_t(0xF97EDEC2)},
    {"grfix05.ubn", "", int32_t(0x00000000), int32_t(0x82B1E11B)},
    {"grfix05.urb", "", int32_t(0x00000000), int32_t(0x32220D67)},
    {"grfix06.ubn", "", int32_t(0x00000000), int32_t(0x042593B5)},
    {"grfix06.urb", "", int32_t(0x00000000), int32_t(0xB4B67FC9)},
    {"grfix07.ubn", "", int32_t(0x00000000), int32_t(0xCF794010)},
    {"grfix07.urb", "", int32_t(0x00000000), int32_t(0x7FEAAC6C)},
    {"grfix08.ubn", "", int32_t(0x00000000), int32_t(0x3E2FF2C5)},
    {"grfix08.urb", "", int32_t(0x00000000), int32_t(0x8EBC1EB9)},
    {"grfxtxt.pal", "", int32_t(0x00000000), int32_t(0x12FA50F2)},
    {"grfxtxt.shp", "", int32_t(0x00000000), int32_t(0xE9E999CE)},
    {"grinder.wav", "", int32_t(0x00000000), int32_t(0xBD3ADDDE)},
    {"grndicon.shp", "", int32_t(0x00000000), int32_t(0x3BD1AD43)},
    {"grndwire.aud", "ground wire", int32_t(0xE0331CF9), int32_t(0x00000000)},
    {"groundze.map", "", int32_t(0x00000000), int32_t(0x437B30D2)},
    {"groundzemw.map", "", int32_t(0x00000000), int32_t(0x2A8D7381)},
    {"growold1.aud", "", int32_t(0x041B22E9), int32_t(0x00000000)},
    {"grulo.img", "", int32_t(0xCBE7A602), int32_t(0x00000000)},
    {"grulo.lmf", "", int32_t(0xCBEDA601), int32_t(0x00000000)},
    {"grulo.lsv", "", int32_t(0xD7EDA611), int32_t(0x00000000)},
    {"grulo.odf", "", int32_t(0xB9F3A601), int32_t(0x00000000)},
    {"grulo.pcx", "", int32_t(0xB7F5A613), int32_t(0x00000000)},
    {"grulo.ver", "", int32_t(0xBC01A60D), int32_t(0x00000000)},
    {"grunt1m1.aud", "", int32_t(0xE044ECF3), int32_t(0x00000000)},
    {"grunt1m2.aud", "", int32_t(0xE244ECF3), int32_t(0x00000000)},
    {"grunt1m3.aud", "", int32_t(0xE444ECF3), int32_t(0x00000000)},
    {"grunt2m1.aud", "", int32_t(0xE044EEF3), int32_t(0x00000000)},
    {"grunt2m2.aud", "", int32_t(0xE244EEF3), int32_t(0x00000000)},
    {"grunt2m3.aud", "", int32_t(0xE444EEF3), int32_t(0x00000000)},
    {"grvestne.vqa", "tanya adams r.i.p.", int32_t(0xE14747F1), int32_t(0x00000000)},
    {"grvestne.vqp", "vqp: tanya adams r.i.p.", int32_t(0xF04747F1), int32_t(0x00000000)},
    {"grvlwlk1.aud", "", int32_t(0xD84522F9), int32_t(0x00000000)},
    {"grvlwlk2.aud", "", int32_t(0xDA4522F9), int32_t(0x00000000)},
    {"grvlwlk3.aud", "", int32_t(0xDC4522F9), int32_t(0x00000000)},
    {"grvlwlk4.aud", "", int32_t(0xDE4522F9), int32_t(0x00000000)},
    {"grvlwlk5.aud", "", int32_t(0xE04522F9), int32_t(0x00000000)},
    {"grvlwlk6.aud", "", int32_t(0xE24522F9), int32_t(0x00000000)},
    {"grvlwlk7.aud", "", int32_t(0xE44522F9), int32_t(0x00000000)},
    {"gsbgripb.pcx", "", int32_t(0x00000000), int32_t(0x84566E14)},
    {"gsbgripm.pcx", "", int32_t(0x00000000), int32_t(0x0606F9C5)},
    {"gsbgript.pcx", "", int32_t(0x00000000), int32_t(0x6BF60C36)},
    {"gstr0001.int", "grey floor with yellow stripes", int32_t(0xFFFFF6AB), int32_t(0x00000000)},
    {"gstr0002.int", "grey floor with yellow stripes", int32_t(0x01FFF6AB), int32_t(0x00000000)},
    {"gstr0003.int", "grey floor with yellow stripes", int32_t(0x03FFF6AB), int32_t(0x00000000)},
    {"gstr0004.int", "grey floor with yellow stripes", int32_t(0x05FFF6AB), int32_t(0x00000000)},
    {"gstr0005.int", "grey floor with yellow stripes", int32_t(0x07FFF6AB), int32_t(0x00000000)},
    {"gstr0006.int", "grey floor with yellow stripes", int32_t(0x09FFF6AB), int32_t(0x00000000)},
    {"gstr0007.int", "grey floor with yellow stripes", int32_t(0x0BFFF6AB), int32_t(0x00000000)},
    {"gstr0008.int", "grey floor with yellow stripes", int32_t(0x0DFFF6AB), int32_t(0x00000000)},
    {"gstr0009.int", "grey floor with yellow stripes", int32_t(0x0FFFF6AB), int32_t(0x00000000)},
    {"gstr0010.int", "grey floor with yellow stripes", int32_t(0xFE01F6AB), int32_t(0x00000000)},
    {"gstr0011.int", "grey floor with yellow stripes", int32_t(0x0001F6AB), int32_t(0x00000000)},
    {"gstruc1.aud", "gdi structure destroyed", int32_t(0xA5F82908), int32_t(0x00000000)},
    {"gsweep.aud", "-", int32_t(0x00000000), int32_t(0xA955D5B8)},
    {"gt18.pcx", "", int32_t(0x00000000), int32_t(0x5D22CDCB)},
    {"gtaircmk.shp", "", int32_t(0x00000000), int32_t(0x77D9D8DC)},
    {"gtarty.shp", "-", int32_t(0x00000000), int32_t(0x878C469F)},
    {"gtartymk.shp", "-", int32_t(0x00000000), int32_t(0x5C8DCE77)},
    {"gtcnst.shp", "-", int32_t(0x00000000), int32_t(0xA29F4F1E)},
    {"gtcnst_a.shp", "-", int32_t(0x00000000), int32_t(0x7D307CC7)},
    {"gtcnst_b.shp", "-", int32_t(0x00000000), int32_t(0x3A900617)},
    {"gtcnst_c.shp", "-", int32_t(0x00000000), int32_t(0x07F02FA7)},
    {"gtcnst_d.shp", "-", int32_t(0x00000000), int32_t(0xB5D0F3B7)},
    {"gtcnstmk.shp", "-", int32_t(0x00000000), int32_t(0x799EC7F6)},
    {"gtcommmk.shp", "-", int32_t(0x00000000), int32_t(0xF59229B1)},
    {"gtcsphmk.shp", "", int32_t(0x00000000), int32_t(0x0AE09389)},
    {"gtctwr.shp", "-", int32_t(0x00000000), int32_t(0x7CEBBC31)},
    {"gtctwr_a.shp", "-", int32_t(0x00000000), int32_t(0xA3448FE8)},
    {"gtctwr_b.shp", "-", int32_t(0x00000000), int32_t(0xE4E4F538)},
    {"gtctwr_c.shp", "-", int32_t(0x00000000), int32_t(0xD984DC88)},
    {"gtctwr_d.shp", "-", int32_t(0x00000000), int32_t(0x6BA40098)},
    {"gtctwrmk.shp", "-", int32_t(0x00000000), int32_t(0xA7EA34D9)},
    {"gtdept.shp", "-", int32_t(0x00000000), int32_t(0x4C99CD59)},
    {"gtdept_a.shp", "-", int32_t(0x00000000), int32_t(0x9336FE80)},
    {"gtdept_b.shp", "-", int32_t(0x00000000), int32_t(0xD4968450)},
    {"gtdept_c.shp", "-", int32_t(0x00000000), int32_t(0xE9F6ADE0)},
    {"gtdept_d.shp", "-", int32_t(0x00000000), int32_t(0x5BD671F0)},
    {"gtdeptbb.shp", "-", int32_t(0x00000000), int32_t(0x6BDE9515)},
    {"gtdeptmk.shp", "-", int32_t(0x00000000), int32_t(0x979845B1)},
    {"gtdpsa.shp", "-", int32_t(0x00000000), int32_t(0x11A77EED)},
    {"gtdpsa_a.shp", "-", int32_t(0x00000000), int32_t(0xCE084D34)},
    {"gtdpsamk.shp", "-", int32_t(0x00000000), int32_t(0xCAA6F605)},
    {"gtdrop.shp", "-", int32_t(0x00000000), int32_t(0xD5ECE575)},
    {"gtdrop_a.shp", "-", int32_t(0x00000000), int32_t(0x0A43D6AC)},
    {"gtdrop_b.shp", "-", int32_t(0x00000000), int32_t(0x4DE3AC7C)},
    {"gtdropmk.shp", "-", int32_t(0x00000000), int32_t(0x0EED6D9D)},
    {"gtfire.shp", "-", int32_t(0x00000000), int32_t(0x2DD47E77)},
    {"gtfire_a.shp", "-", int32_t(0x00000000), int32_t(0xF27B4DAE)},
    {"gtfire_b.shp", "-", int32_t(0x00000000), int32_t(0xB5DB377E)},
    {"gtfire_c.shp", "-", int32_t(0x00000000), int32_t(0x88BB1ECE)},
    {"gtfiremk.shp", "-", int32_t(0x00000000), int32_t(0xF6D5F69F)},
    {"gtfsdf.shp", "-", int32_t(0x00000000), int32_t(0x9F0694A9)},
    {"gtfsdf_a.shp", "-", int32_t(0x00000000), int32_t(0x40A9A770)},
    {"gtgapmk.shp", "", int32_t(0x00000000), int32_t(0xADD1C144)},
    {"gtgate_a.shp", "-", int32_t(0x00000000), int32_t(0x600E8D0F)},
    {"gtgate_b.shp", "-", int32_t(0x00000000), int32_t(0x27AEF7DF)},
    {"gtgateza.shp", "-", int32_t(0x00000000), int32_t(0x30C31CBC)},
    {"gtgatezb.shp", "-", int32_t(0x00000000), int32_t(0x7763666C)},
    {"gtgcanbarl.hva", "", int32_t(0x00000000), int32_t(0x8D39D0C2)},
    {"gtgcanbarl.vxl", "", int32_t(0x00000000), int32_t(0x5D563046)},
    {"gtgcanmk.shp", "", int32_t(0x00000000), int32_t(0x7C0A750D)},
    {"gtgcantur.hva", "", int32_t(0x00000000), int32_t(0xAE22D19F)},
    {"gtgcantur.vxl", "", int32_t(0x00000000), int32_t(0x11BBD638)},
    {"gtgreen.shp", "-", int32_t(0x00000000), int32_t(0x6FE55F6B)},
    {"gthpad.shp", "-", int32_t(0x00000000), int32_t(0x673D8792)},
    {"gthpad_a.shp", "-", int32_t(0x00000000), int32_t(0xB892B44B)},
    {"gthpadbb.shp", "-", int32_t(0x00000000), int32_t(0x407ADFDE)},
    {"gthpadmk.shp", "-", int32_t(0x00000000), int32_t(0xBC3C0F7A)},
    {"gticbm.shp", "-", int32_t(0x00000000), int32_t(0x06A5D028)},
    {"gticbm_a.shp", "-", int32_t(0x00000000), int32_t(0xD90AE3F1)},
    {"gticbmmk.shp", "-", int32_t(0x00000000), int32_t(0xDDA458C0)},
    {"gtkodk.shp", "-", int32_t(0x00000000), int32_t(0x41DBCFBC)},
    {"gtkodk_a.shp", "-", int32_t(0x00000000), int32_t(0x9E74FC65)},
    {"gtkodk_b.shp", "-", int32_t(0x00000000), int32_t(0xD9D486B5)},
    {"gtkodk_c.shp", "-", int32_t(0x00000000), int32_t(0xE4B4AF05)},
    {"gtlite.shp", "-", int32_t(0x00000000), int32_t(0xFC99E739)},
    {"gtncicon.shp", "", int32_t(0x00000000), int32_t(0xB7050AC9)},
    {"gtnk.hva", "", int32_t(0x00000000), int32_t(0x58CF54DC)},
    {"gtnk.vxl", "", int32_t(0x00000000), int32_t(0xAE458B95)},
    {"gtnkbarl.hva", "", int32_t(0x00000000), int32_t(0xAD22B437)},
    {"gtnkbarl.vxl", "", int32_t(0x00000000), int32_t(0x5BA86B7E)},
    {"gtnkicon.shp", "", int32_t(0x00000000), int32_t(0x0CDDA8D1)},
    {"gtnktur.hva", "", int32_t(0x00000000), int32_t(0xF23192E4)},
    {"gtnktur.vxl", "", int32_t(0x00000000), int32_t(0xFDC7E10F)},
    {"gtnkuico.shp", "", int32_t(0x00000000), int32_t(0xC91B3A30)},
    {"gtoldcc1.shp", "ruined old c&c construction yard", int32_t(0x00000000), int32_t(0x103B0C92)},
    {"gtoldcc2.shp", "ruined old c&c temple", int32_t(0x00000000), int32_t(0x579B7642)},
    {"gtoldcc3.shp", "ruined old c&c weapons factory", int32_t(0x00000000), int32_t(0x6AFB5FF2)},
    {"gtoldcc4.shp", "ruined old c&c refinery", int32_t(0x00000000), int32_t(0xD8DB83E2)},
    {"gtoldcc5.shp", "ruined old c&c advanced power", int32_t(0x00000000), int32_t(0xE5BBAA52)},
    {"gtoldcc6.shp", "ruined old c&c silos", int32_t(0x00000000), int32_t(0xA21BD082)},
    {"gtorepmk.shp", "", int32_t(0x00000000), int32_t(0x67CD8AA2)},
    {"gtpave.shp", "-", int32_t(0x00000000), int32_t(0x38F6233A)},
    {"gtpile.shp", "-", int32_t(0x00000000), int32_t(0x6E55ACC1)},
    {"gtpile_a.shp", "-", int32_t(0x00000000), int32_t(0xB1FA9F18)},
    {"gtpile_b.shp", "-", int32_t(0x00000000), int32_t(0xF65AE5C8)},
    {"gtpile_c.shp", "-", int32_t(0x00000000), int32_t(0xCB3ACC78)},
    {"gtpilemk.shp", "-", int32_t(0x00000000), int32_t(0xB5542429)},
    {"gtpillmk.shp", "", int32_t(0x00000000), int32_t(0x20CC61FA)},
    {"gtplug.shp", "-", int32_t(0x00000000), int32_t(0xD0A9D2A7)},
    {"gtplug_a.shp", "-", int32_t(0x00000000), int32_t(0x0F06E17E)},
    {"gtplug_b.shp", "-", int32_t(0x00000000), int32_t(0x48A69BAE)},
    {"gtplug_c.shp", "-", int32_t(0x00000000), int32_t(0x75C6B21E)},
    {"gtplug_d.shp", "-", int32_t(0x00000000), int32_t(0xC7E66E0E)},
    {"gtplug_e.shp", "-", int32_t(0x00000000), int32_t(0xFA8647BE)},
    {"gtplug_f.shp", "-", int32_t(0x00000000), int32_t(0xBD263D6E)},
    {"gtplugmk.shp", "-", int32_t(0x00000000), int32_t(0x0BA85A4F)},
    {"gtpowexp.shp", "", int32_t(0x00000000), int32_t(0xA3B44565)},
    {"gtpowr.shp", "-", int32_t(0x00000000), int32_t(0x9EE75A76)},
    {"gtpowr_a.shp", "-", int32_t(0x00000000), int32_t(0x414869AF)},
    {"gtpowr_b.shp", "-", int32_t(0x00000000), int32_t(0x06E8137F)},
    {"gtpowrmk.shp", "-", int32_t(0x00000000), int32_t(0x45E6D29E)},
    {"gtprismk.shp", "", int32_t(0x00000000), int32_t(0xD72F5F15)},
    {"gtradr.shp", "-", int32_t(0x00000000), int32_t(0xA0E46711)},
    {"gtradr_a.shp", "-", int32_t(0x00000000), int32_t(0x7F4B54C8)},
    {"gtradrmk.shp", "-", int32_t(0x00000000), int32_t(0x7BE5EFF9)},
    {"gtrefnmk.shp", "", int32_t(0x00000000), int32_t(0xC4524F32)},
    {"gtsand.shp", "-", int32_t(0x00000000), int32_t(0xDAE8B913)},
    {"gtsilo.shp", "-", int32_t(0x00000000), int32_t(0x2112488C)},
    {"gtsilo_a.shp", "-", int32_t(0x00000000), int32_t(0xFEBD7B55)},
    {"gtsilo_b.shp", "-", int32_t(0x00000000), int32_t(0xB91D0185)},
    {"gtsilomk.shp", "-", int32_t(0x00000000), int32_t(0xFA13C064)},
    {"gtslrgmk.shp", "-", int32_t(0x00000000), int32_t(0xEA5AE855)},
    {"gtspot.shp", "-", int32_t(0x00000000), int32_t(0xCA277371)},
    {"gtspot_a.shp", "-", int32_t(0x00000000), int32_t(0x158840A8)},
    {"gtspotmk.shp", "-", int32_t(0x00000000), int32_t(0x1126FB99)},
    {"gtspstmk.shp", "", int32_t(0x00000000), int32_t(0x3A32DFFD)},
    {"gtt2icon.shp", "-", int32_t(0x00000000), int32_t(0x6051CC7E)},
    {"gttech.shp", "-", int32_t(0x00000000), int32_t(0x397D8CC3)},
    {"gttech_a.shp", "-", int32_t(0x00000000), int32_t(0xE6D2BF1A)},
    {"gttechmk.shp", "-", int32_t(0x00000000), int32_t(0xE27C042B)},
    {"gtteicon.shp", "-", int32_t(0x00000000), int32_t(0xF4936262)},
    {"gttick.shp", "-", int32_t(0x00000000), int32_t(0xEEA1654A)},
    {"gttickmk.shp", "-", int32_t(0x00000000), int32_t(0x35A0EDA2)},
    {"gtwall.shp", "-", int32_t(0x00000000), int32_t(0xA2C95073)},
    {"gtweap.shp", "-", int32_t(0x00000000), int32_t(0xC45EE214)},
    {"gtweap_1.shp", "-", int32_t(0x00000000), int32_t(0xE2233102)},
    {"gtweap_2.shp", "-", int32_t(0x00000000), int32_t(0xA5834BD2)},
    {"gtweap_a.shp", "-", int32_t(0x00000000), int32_t(0x1BF1D1CD)},
    {"gtweap_b.shp", "-", int32_t(0x00000000), int32_t(0x5C51AB1D)},
    {"gtweap_c.shp", "-", int32_t(0x00000000), int32_t(0x613182AD)},
    {"gtweap_d.shp", "-", int32_t(0x00000000), int32_t(0xD3115EBD)},
    {"gtweapbb.shp", "-", int32_t(0x00000000), int32_t(0xE319BA58)},
    {"gtweapmk.shp", "-", int32_t(0x00000000), int32_t(0x1F5F6AFC)},
    {"gtwethmk.shp", "", int32_t(0x00000000), int32_t(0x7F35871A)},
    {"gtwr.shp", "guard tower", int32_t(0xF4F6FBBC), int32_t(0x00000000)},
    {"gtwricnh.des", "icon: guard tower", int32_t(0x2D3F1BDD), int32_t(0x00000000)},
    {"gtwricnh.tem", "icon: guard tower", int32_t(0x273F2BDD), int32_t(0x00000000)},
    {"gtwricnh.win", "icon: guard tower", int32_t(0x28432EDD), int32_t(0x00000000)},
    {"gtwricon.shp", "icon: guard tower", int32_t(0x36442ADD), int32_t(0x00000000)},
    {"gtwrmake.shp", "make: guard tower", int32_t(0x243C26E5), int32_t(0x00000000)},
    {"gtyardmk.shp", "", int32_t(0x00000000), int32_t(0x3DDF8556)},
    {"guaircmk.shp", "", int32_t(0x00000000), int32_t(0xB657071C)},
    {"gucnstmk.shp", "", int32_t(0x00000000), int32_t(0xB8101836)},
    {"gucommmk.shp", "", int32_t(0x00000000), int32_t(0x341CF671)},
    {"gucsphmk.shp", "", int32_t(0x00000000), int32_t(0xCB6E4C49)},
    {"gudeptmk.shp", "", int32_t(0x00000000), int32_t(0x56169A71)},
    {"gugapmk.shp", "", int32_t(0x00000000), int32_t(0x6C5F1E84)},
    {"gugate_a.shp", "", int32_t(0x00000000), int32_t(0xA18052CF)},
    {"gugcanmk.shp", "", int32_t(0x00000000), int32_t(0xBD84AACD)},
    {"gulp1.aud", "", int32_t(0xEBB3B1C3), int32_t(0x00000000)},
    {"gun.shp", "turret", int32_t(0x5CECF2E1), int32_t(0x00000000)},
    {"gun11.aud", "minigunner shot", int32_t(0x6FBBB1C3), int32_t(0x00000000)},
    {"gun13.aud", "pillbox shot", int32_t(0x6FBBB1C7), int32_t(0x00000000)},
    {"gun18.aud", "gunshot", int32_t(0x6FBBB1D1), int32_t(0x82B3335A)},
    {"gun18.juv", "gunshot", int32_t(0x6FCDB1E3), int32_t(0x00000000)},
    {"gun19.aud", "gunshot", int32_t(0x6FBBB1D3), int32_t(0x00000000)},
    {"gun19.juv", "gunshot", int32_t(0x6FCDB1E5), int32_t(0x00000000)},
    {"gun20.aud", "gunshot", int32_t(0x73BBB1C1), int32_t(0x00000000)},
    {"gun20.juv", "gunshot", int32_t(0x73CDB1D3), int32_t(0x00000000)},
    {"gun27.aud", "pistol 1", int32_t(0x73BBB1CF), int32_t(0x00000000)},
    {"gun5.aud", "pistol 2", int32_t(0xAEF1EBBC), int32_t(0x00000000)},
    {"gun5.juv", "pistol 2", int32_t(0xC0F1F4BC), int32_t(0x00000000)},
    {"gun8.aud", "gunshot", int32_t(0xB4F1EBBC), int32_t(0x00000000)},
    {"gun8.juv", "gunshot", int32_t(0xC6F1F4BC), int32_t(0x00000000)},
    {"gunaim1.aud", "", int32_t(0x61E044F0), int32_t(0x00000000)},
    {"gunboat.vqa", "gunboat blowing up turret", int32_t(0x66232911), int32_t(0x00000000)},
    {"gunboat.vqp", "gunboat blowing up turret", int32_t(0x66322911), int32_t(0x00000000)},
    {"gunclip1.aud", "gun clip", int32_t(0xB42F28E3), int32_t(0x00000000)},
    {"gunclip1.juv", "gun clip", int32_t(0xC62F31E3), int32_t(0x00000000)},
    {"gunfire.shp", "gunfire", int32_t(0x76144202), int32_t(0x3C43FFD0)},
    {"gunfires.shp", "", int32_t(0x00000000), int32_t(0xC45E7769)},
    {"gunfirey.shp", "", int32_t(0x00000000), int32_t(0x8EEE6FC8)},
    {"gunh1a.aud", "", int32_t(0xA3961BD4), int32_t(0x00000000)},
    {"gunh1ar.aud", "", int32_t(0x7E222CC0), int32_t(0x00000000)},
    {"gunh1b.aud", "", int32_t(0xA3961DD4), int32_t(0x00000000)},
    {"gunh1br.aud", "", int32_t(0x7E222EC0), int32_t(0x00000000)},
    {"gunh1c.aud", "", int32_t(0xA3961FD4), int32_t(0x00000000)},
    {"gunh1cr.aud", "", int32_t(0x7E2230C0), int32_t(0x00000000)},
    {"gunh2a.aud", "", int32_t(0xA3961BD6), int32_t(0x00000000)},
    {"gunh2ar.aud", "", int32_t(0x7E222CC2), int32_t(0x00000000)},
    {"gunh2b.aud", "", int32_t(0xA3961DD6), int32_t(0x00000000)},
    {"gunh2br.aud", "", int32_t(0x7E222EC2), int32_t(0x00000000)},
    {"gunh2c.aud", "", int32_t(0xA3961FD6), int32_t(0x00000000)},
    {"gunh2cr.aud", "", int32_t(0x7E2230C2), int32_t(0x00000000)},
    {"gunh3a.aud", "", int32_t(0xA3961BD8), int32_t(0x00000000)},
    {"gunh3ar.aud", "", int32_t(0x7E222CC4), int32_t(0x00000000)},
    {"gunh3b.aud", "", int32_t(0xA3961DD8), int32_t(0x00000000)},
    {"gunh3br.aud", "", int32_t(0x7E222EC4), int32_t(0x00000000)},
    {"gunh3c.aud", "", int32_t(0xA3961FD8), int32_t(0x00000000)},
    {"gunh3cr.aud", "", int32_t(0x7E2230C4), int32_t(0x00000000)},
    {"gunicnh.des", "icon: turret", int32_t(0x821D36E7), int32_t(0x00000000)},
    {"gunicnh.tem", "icon: turret", int32_t(0x821736F7), int32_t(0x00000000)},
    {"gunicnh.win", "icon: turret", int32_t(0x82183AFA), int32_t(0x00000000)},
    {"gunicon.shp", "icon: turret", int32_t(0x82263BF6), int32_t(0x00000000)},
    {"gunm1a.aud", "", int32_t(0xB7961BD4), int32_t(0x00000000)},
    {"gunm1ar.aud", "", int32_t(0x92222CC0), int32_t(0x00000000)},
    {"gunm1b.aud", "", int32_t(0xB7961DD4), int32_t(0x00000000)},
    {"gunm1br.aud", "", int32_t(0x92222EC0), int32_t(0x00000000)},
    {"gunm1c.aud", "", int32_t(0xB7961FD4), int32_t(0x00000000)},
    {"gunm1cr.aud", "", int32_t(0x922230C0), int32_t(0x00000000)},
    {"gunm2a.aud", "", int32_t(0xB7961BD6), int32_t(0x00000000)},
    {"gunm2ar.aud", "", int32_t(0x92222CC2), int32_t(0x00000000)},
    {"gunm2b.aud", "", int32_t(0xB7961DD6), int32_t(0x00000000)},
    {"gunm2br.aud", "", int32_t(0x92222EC2), int32_t(0x00000000)},
    {"gunm2c.aud", "", int32_t(0xB7961FD6), int32_t(0x00000000)},
    {"gunm2cr.aud", "", int32_t(0x922230C2), int32_t(0x00000000)},
    {"gunm3a.aud", "", int32_t(0xB7961BD8), int32_t(0x00000000)},
    {"gunm3ar.aud", "", int32_t(0x92222CC4), int32_t(0x00000000)},
    {"gunm3b.aud", "", int32_t(0xB7961DD8), int32_t(0x00000000)},
    {"gunm3br.aud", "", int32_t(0x92222EC4), int32_t(0x00000000)},
    {"gunm3c.aud", "", int32_t(0xB7961FD8), int32_t(0x00000000)},
    {"gunm3cr.aud", "", int32_t(0x922230C4), int32_t(0x00000000)},
    {"gunmake.shp", "make: turret", int32_t(0x921433F2), int32_t(0x00000000)},
    {"gunmiss1.aud", "", int32_t(0xDC353CDD), int32_t(0x00000000)},
    {"gunmiss2.aud", "", int32_t(0xDE353CDD), int32_t(0x00000000)},
    {"gunmiss3.aud", "", int32_t(0xE0353CDD), int32_t(0x00000000)},
    {"gunmiss4.aud", "", int32_t(0xE2353CDD), int32_t(0x00000000)},
    {"gunrack1.aud", "", int32_t(0xF0251CCD), int32_t(0x00000000)},
    {"guoremk.shp", "", int32_t(0x00000000), int32_t(0xDE9E1F8B)},
    {"guorepmk.shp", "", int32_t(0x00000000), int32_t(0xA6435562)},
    {"guparrowp.pcx", "", int32_t(0x00000000), int32_t(0x8DF294BD)},
    {"guparrowr.pcx", "", int32_t(0x00000000), int32_t(0xCFD793C0)},
    {"gupilemk.shp", "", int32_t(0x00000000), int32_t(0x74DAFBE9)},
    {"gupillmk.shp", "", int32_t(0x00000000), int32_t(0xE142BE3A)},
    {"gupowrmk.shp", "", int32_t(0x00000000), int32_t(0x84680D5E)},
    {"guprismk.shp", "", int32_t(0x00000000), int32_t(0x16A180D5)},
    {"gurefnmk.shp", "", int32_t(0x00000000), int32_t(0x05DC90F2)},
    {"gurgle1.aud", "", int32_t(0x79F034F6), int32_t(0x00000000)},
    {"gurgle2.aud", "", int32_t(0x79F234F6), int32_t(0x00000000)},
    {"gurgle3.aud", "", int32_t(0x79F434F6), int32_t(0x00000000)},
    {"gurgle4.aud", "", int32_t(0x79F634F6), int32_t(0x00000000)},
    {"gusand.shp", "", int32_t(0x00000000), int32_t(0x1B6666D3)},
    {"guspstmk.shp", "", int32_t(0x00000000), int32_t(0xFBBC003D)},
    {"gutechmk.shp", "", int32_t(0x00000000), int32_t(0x23F2DBEB)},
    {"guwall.shp", "", int32_t(0x00000000), int32_t(0x63478FB3)},
    {"guweapmk.shp", "", int32_t(0x00000000), int32_t(0xDED1B53C)},
    {"guwethmk.shp", "", int32_t(0x00000000), int32_t(0xBEBB58DA)},
    {"guyardmk.shp", "", int32_t(0x00000000), int32_t(0xFC515A96)},
    {"guyokay1.aud", "guy ok", int32_t(0xE46D18E1), int32_t(0x00000000)},
    {"guyyeah1.aud", "guy ya?", int32_t(0x0C4B18D5), int32_t(0x00000000)},
    {"gwepicon.shp", "", int32_t(0x00000000), int32_t(0x434AE98B)},
    {"h18tur.hva", "-", int32_t(0x00000000), int32_t(0x236D1233)},
    {"h1bite1.aud", "", int32_t(0x81AFA50A), int32_t(0x00000000)},
    {"h1die1.aud", "", int32_t(0xA76D6C00), int32_t(0x00000000)},
    {"h1hurt1.aud", "", int32_t(0xB1C7C306), int32_t(0x00000000)},
    {"h1hurt2.aud", "", int32_t(0xB1C9C306), int32_t(0x00000000)},
    {"h1loitr1.aud", "", int32_t(0xE42AAEE1), int32_t(0x00000000)},
    {"h20pipe1.aud", "", int32_t(0xE7A0AAE1), int32_t(0x00000000)},
    {"h20pipe2.aud", "", int32_t(0xE9A0AAE1), int32_t(0x00000000)},
    {"h2atk1.aud", "", int32_t(0xD361700C), int32_t(0x00000000)},
    {"h2die1.aud", "", int32_t(0xA76D7000), int32_t(0x00000000)},
    {"h2hurt1.aud", "", int32_t(0xB1C7C706), int32_t(0x00000000)},
    {"h2hurt2.aud", "", int32_t(0xB1C9C706), int32_t(0x00000000)},
    {"h2loitr1.aud", "", int32_t(0xE42AB2E1), int32_t(0x00000000)},
    {"h2loitr2.aud", "", int32_t(0xE62AB2E1), int32_t(0x00000000)},
    {"h2o_exp1.shp", "misc: big shot into water", int32_t(0x3025CCD9), int32_t(0x63B209B3)},
    {"h2o_exp2.shp", "misc: medium shot into water", int32_t(0x3225CCD9), int32_t(0x24127363)},
    {"h2o_exp3.shp", "misc: small shot into water", int32_t(0x3425CCD9), int32_t(0x19725AD3)},
    {"h2obomb2.aud", "water explosion", int32_t(0xB216A4ED), int32_t(0x00000000)},
    {"h2ofal1w.aud", "", int32_t(0x0BF4A2D1), int32_t(0x00000000)},
    {"h2ofall1.aud", "", int32_t(0xC02AA2D1), int32_t(0x00000000)},
    {"h2ofall2.aud", "", int32_t(0xC22AA2D1), int32_t(0x00000000)},
    {"h2ofall3.aud", "", int32_t(0xC42AA2D1), int32_t(0x00000000)},
    {"h2ofallb.aud", "", int32_t(0xE22AA2D1), int32_t(0x00000000)},
    {"h2ofallf.aud", "", int32_t(0xEA2AA2D1), int32_t(0x00000000)},
    {"h2oin1.aud", "", int32_t(0xA7997012), int32_t(0x00000000)},
    {"h2oin2.aud", "", int32_t(0xA7997212), int32_t(0x00000000)},
    {"h2oin3.aud", "", int32_t(0xA7997412), int32_t(0x00000000)},
    {"h2oloop1.aud", "", int32_t(0xD832A8ED), int32_t(0x00000000)},
    {"h2oout1.aud", "", int32_t(0x99E3C70C), int32_t(0x00000000)},
    {"h3atk1.aud", "", int32_t(0xD361740C), int32_t(0x00000000)},
    {"h3atk2.aud", "", int32_t(0xD361760C), int32_t(0x00000000)},
    {"h3die1.aud", "", int32_t(0xA76D7400), int32_t(0x00000000)},
    {"h3hurt1.aud", "", int32_t(0xB1C7CB06), int32_t(0x00000000)},
    {"h3hurt2.aud", "", int32_t(0xB1C9CB06), int32_t(0x00000000)},
    {"h3loit1.aud", "", int32_t(0x99D7CAF4), int32_t(0x00000000)},
    {"h3loit2.aud", "", int32_t(0x99D9CAF4), int32_t(0x00000000)},
    {"hacker.aud", "-", int32_t(0x00000000), int32_t(0x5C43DCEA)},
    {"halbast1.aud", "", int32_t(0xB02EECD1), int32_t(0x00000000)},
    {"hand.shp", "hand of nod", int32_t(0xD8E4D5BE), int32_t(0x00000000)},
    {"handicnh.des", "icon: hand of nod", int32_t(0xF51ACFE1), int32_t(0x00000000)},
    {"handicnh.tem", "icon: hand of nod", int32_t(0xEF1ADFE1), int32_t(0x00000000)},
    {"handicnh.win", "icon: hand of nod", int32_t(0xF01EE2E1), int32_t(0x00000000)},
    {"handicon.shp", "icon: hand of nod", int32_t(0xFE1FDEE1), int32_t(0x7E5190F8)},
    {"handmake.shp", "make: hand of nod", int32_t(0xEC17DAE9), int32_t(0x00000000)},
    {"harv.hva", "-", int32_t(0x00000000), int32_t(0x586D64CA)},
    {"harv.shp", "harvester", int32_t(0xFCECD5BE), int32_t(0x00000000)},
    {"harv.vxl", "harvester", int32_t(0x00000000), int32_t(0xAEE7BB83)},
    {"harvestr.shp", "-", int32_t(0x00000000), int32_t(0x3D859A33)},
    {"harvicnh.des", "icon: harvester", int32_t(0x3D2ACFE1), int32_t(0x00000000)},
    {"harvicnh.tem", "icon: harvester", int32_t(0x372ADFE1), int32_t(0x00000000)},
    {"harvicnh.win", "icon: harvester", int32_t(0x382EE2E1), int32_t(0x00000000)},
    {"harvicon.shp", "icon: harvester", int32_t(0x462FDEE1), int32_t(0xC1F59B69)},
    {"harvtur.hva", "", int32_t(0x00000000), int32_t(0x3F19A15C)},
    {"harvtur.vxl", "", int32_t(0x00000000), int32_t(0x30EFD2B7)},
    {"harvuico.shp", "", int32_t(0x00000000), int32_t(0x04330988)},
    {"haunt1.aud", "", int32_t(0xBBB1AC1E), int32_t(0x00000000)},
    {"haunt2.aud", "", int32_t(0xBBB1AE1E), int32_t(0x00000000)},
    {"hbosnia.wsa", "anim: zoom on bosnia", int32_t(0xAA00EF14), int32_t(0x00000000)},
    {"hbox.sno", "bldg: camo. pillbox", int32_t(0xFFECD7BE), int32_t(0x1C2D28BC)},
    {"hbox.tem", "bldg: camo. pillbox", int32_t(0xFDE3D8BE), int32_t(0x149886DE)},
    {"hbox.urb", "", int32_t(0x00000000), int32_t(0x806675EE)},
    {"hboxicon.shp", "icon: camo pillbox", int32_t(0x4E23E2E1), int32_t(0x00000000)},
    {"hboxmake.sno", "make: camo. pillbox", int32_t(0x3B21DEE9), int32_t(0x6643EA05)},
    {"hboxmake.tem", "make: camo. pillbox", int32_t(0x3918DFE9), int32_t(0x6EF64467)},
    {"hboxmake.urb", "", int32_t(0x00000000), int32_t(0xFA08B757)},
    {"hbtn-dn.shp", "butt: down", int32_t(0x963DD9CE), int32_t(0x00000000)},
    {"hbtn-dn2.shp", "butt: down", int32_t(0xEE35E4A9), int32_t(0x00000000)},
    {"hbtn-up.shp", "butt: up", int32_t(0x9641FBCE), int32_t(0x00000000)},
    {"hbtn-up2.shp", "butt: up", int32_t(0xEE3A06A9), int32_t(0x00000000)},
    {"hc01-min.set", "", int32_t(0xB598FAA9), int32_t(0x00000000)},
    {"hc01.vqa", "", int32_t(0xA3B1DCBE), int32_t(0x00000000)},
    {"hc01_0.vqa", "", int32_t(0x711DAF30), int32_t(0x00000000)},
    {"hc01_1.vqa", "", int32_t(0x711DB130), int32_t(0x00000000)},
    {"hc01_2.vqa", "", int32_t(0x711DB330), int32_t(0x00000000)},
    {"hc01_3.vqa", "", int32_t(0x711DB530), int32_t(0x00000000)},
    {"hc01ar11.img", "", int32_t(0x6E70FAD1), int32_t(0x00000000)},
    {"hc01ar12.img", "", int32_t(0x7070FAD1), int32_t(0x00000000)},
    {"hc01esp1.vqa", "", int32_t(0x68B309D9), int32_t(0x00000000)},
    {"hc01esp2.vqa", "", int32_t(0x6AB309D9), int32_t(0x00000000)},
    {"hc01esp3.vqa", "", int32_t(0x6CB309D9), int32_t(0x00000000)},
    {"hc01vo1a.aud", "", int32_t(0x8B78ECFB), int32_t(0x00000000)},
    {"hc02-min.set", "", int32_t(0xB998FAA9), int32_t(0x00000000)},
    {"hc02.vqa", "", int32_t(0xA5B1DCBE), int32_t(0x00000000)},
    {"hc02_0.vqa", "", int32_t(0x751DAF30), int32_t(0x00000000)},
    {"hc02_1.vqa", "", int32_t(0x751DB130), int32_t(0x00000000)},
    {"hc02_2.vqa", "", int32_t(0x751DB330), int32_t(0x00000000)},
    {"hc02_3.vqa", "", int32_t(0x751DB530), int32_t(0x00000000)},
    {"hc02cb1.img", "", int32_t(0x256ADEF0), int32_t(0x00000000)},
    {"hc02cb2.img", "", int32_t(0x256CDEF0), int32_t(0x00000000)},
    {"hc02esp2.vqa", "", int32_t(0x6EB309D9), int32_t(0x00000000)},
    {"hc02esp3.vqa", "", int32_t(0x70B309D9), int32_t(0x00000000)},
    {"hc02esp4.vqa", "", int32_t(0x72B309D9), int32_t(0x00000000)},
    {"hc02esp5.vqa", "", int32_t(0x74B309D9), int32_t(0x00000000)},
    {"hc03-min.set", "", int32_t(0xBD98FAA9), int32_t(0x00000000)},
    {"hc03.vqa", "", int32_t(0xA7B1DCBE), int32_t(0x00000000)},
    {"hc03_0.vqa", "", int32_t(0x791DAF30), int32_t(0x00000000)},
    {"hc03_1.vqa", "", int32_t(0x791DB130), int32_t(0x00000000)},
    {"hc03_2.vqa", "", int32_t(0x791DB330), int32_t(0x00000000)},
    {"hc03_3.vqa", "", int32_t(0x791DB530), int32_t(0x00000000)},
    {"hc04-min.set", "", int32_t(0xC198FAA9), int32_t(0x00000000)},
    {"hc04.vqa", "", int32_t(0xA9B1DCBE), int32_t(0x00000000)},
    {"hc04_0.vqa", "", int32_t(0x7D1DAF30), int32_t(0x00000000)},
    {"hc04_1.vqa", "", int32_t(0x7D1DB130), int32_t(0x00000000)},
    {"hc04_2.vqa", "", int32_t(0x7D1DB330), int32_t(0x00000000)},
    {"hc04_3.vqa", "", int32_t(0x7D1DB530), int32_t(0x00000000)},
    {"hcanm1.aud", "", int32_t(0xBB61B410), int32_t(0x00000000)},
    {"hcanm2.aud", "", int32_t(0xBB61B610), int32_t(0x00000000)},
    {"hcanm3.aud", "", int32_t(0xBB61B810), int32_t(0x00000000)},
    {"hcanm4.aud", "", int32_t(0xBB61BA10), int32_t(0x00000000)},
    {"hcanm5.aud", "", int32_t(0xBB61BC10), int32_t(0x00000000)},
    {"hcanm6.aud", "", int32_t(0xBB61BE10), int32_t(0x00000000)},
    {"hcanm7.aud", "", int32_t(0xBB61C010), int32_t(0x00000000)},
    {"hcanm8.aud", "", int32_t(0xBB61C210), int32_t(0x00000000)},
    {"hcbell1.aud", "", int32_t(0x71AFFAFA), int32_t(0x00000000)},
    {"hclock.shp", "time dial", int32_t(0xE38DF3EF), int32_t(0x00000000)},
    {"hcloop1.aud", "", int32_t(0x99D80300), int32_t(0x00000000)},
    {"hcrate.shp", "", int32_t(0xABA5E811), int32_t(0x00000000)},
    {"hcsing1.aud", "", int32_t(0x81F3F0FE), int32_t(0x00000000)},
    {"hdline01.bmp", "", int32_t(0xD7DEDDEB), int32_t(0x72CCC2FB)},
    {"hdline02.bmp", "", int32_t(0xD9DEDDEB), int32_t(0x356CB82B)},
    {"hdline03.bmp", "", int32_t(0xDBDEDDEB), int32_t(0x080C919B)},
    {"hdline04.bmp", "", int32_t(0xDDDEDDEB), int32_t(0xBA2C4D8B)},
    {"hdline05.bmp", "", int32_t(0xDFDEDDEB), int32_t(0x874C643B)},
    {"hdline06.bmp", "", int32_t(0xE1DEDDEB), int32_t(0xC0EC1EEB)},
    {"hdline07.bmp", "", int32_t(0x00000000), int32_t(0xFD8C375B)},
    {"hdline08.bmp", "", int32_t(0xE5DEDDEB), int32_t(0x7FDCA08A)},
    {"hdline09.bmp", "", int32_t(0xE7DEDDEB), int32_t(0x42BC893A)},
    {"hdline10.bmp", "", int32_t(0xD5E0DDEB), int32_t(0x84F038EE)},
    {"hdstn01.des", "", int32_t(0x00000000), int32_t(0x19ADAFB1)},
    {"hdstn01.lun", "", int32_t(0x00000000), int32_t(0x3F534832)},
    {"hdstn01.sno", "", int32_t(0x00000000), int32_t(0x3E41722B)},
    {"hdstn01.tem", "", int32_t(0x00000000), int32_t(0x9DF5C7F1)},
    {"hdstn01.ubn", "", int32_t(0x00000000), int32_t(0x0B2BE5D2)},
    {"hdstn01.urb", "", int32_t(0x00000000), int32_t(0xBBB809AE)},
    {"headhit2.aud", "", int32_t(0xBA02E8DF), int32_t(0x00000000)},
    {"headon1.aud", "", int32_t(0x6DAC0700), int32_t(0x00000000)},
    {"heal.flc", "", int32_t(0xDBCED0BE), int32_t(0x00000000)},
    {"heal1.aud", "", int32_t(0xDB8771C7), int32_t(0x00000000)},
    {"heal2.aud", "medic heal sound", int32_t(0xDB8771C9), int32_t(0x00000000)},
    {"healall.shp", "crate: heal everything", int32_t(0x00000000), int32_t(0x470FD897)},
    {"healer1.aud", "healing units", int32_t(0x00000000), int32_t(0x83585783)},
    {"heallev1.aud", "", int32_t(0xD806E0E7), int32_t(0x00000000)},
    {"healone.shp", "crate: heal unit", int32_t(0x00000000), int32_t(0xE2158A44)},
    {"healthd.shp", "", int32_t(0x8DDDEE1C), int32_t(0x00000000)},
    {"heart.var", "heartbreak sfx", int32_t(0xCBB1721B), int32_t(0x00000000)},
    {"heart1a.aud", "", int32_t(0xA5CBCD0A), int32_t(0x00000000)},
    {"heart1b.aud", "", int32_t(0xA5CDCD0A), int32_t(0x00000000)},
    {"heart1c.aud", "", int32_t(0xA5CFCD0A), int32_t(0x00000000)},
    {"hearth_a.wsa", "anim: zoom on africa", int32_t(0x0D16FCF7), int32_t(0x00000000)},
    {"hearth_e.wsa", "anim: zoom on europe", int32_t(0x1516FCF7), int32_t(0x00000000)},
    {"heavyg.aud", "demolition", int32_t(0xDB61E828), int32_t(0x00000000)},
    {"heavytank.bmp", "", int32_t(0x00000000), int32_t(0x2177A1DD)},
    {"heli.hva", "-", int32_t(0x00000000), int32_t(0x774E2361)},
    {"heli.shp", "apache helicopter", int32_t(0xE2E0DDBE), int32_t(0x00000000)},
    {"heli.vxl", "longbow", int32_t(0x00000000), int32_t(0x81C4FC28)},
    {"helidown.aud", "", int32_t(0x0634F4D7), int32_t(0x00000000)},
    {"helidown.juv", "", int32_t(0x1834FDD7), int32_t(0x00000000)},
    {"heliicnh.des", "icon: apache helicopter", int32_t(0x0912DFE1), int32_t(0x00000000)},
    {"heliicnh.tem", "icon: apache helicopter", int32_t(0x0312EFE1), int32_t(0x00000000)},
    {"heliicnh.win", "icon: apache helicopter", int32_t(0x0416F2E1), int32_t(0x00000000)},
    {"heliicon.shp", "icon: apache helicopter", int32_t(0x1217EEE1), int32_t(0x3B32D410)},
    {"heliup1.aud", "", int32_t(0x81D80B0C), int32_t(0x00000000)},
    {"heliup1.juv", "", int32_t(0x81EA0B15), int32_t(0x00000000)},
    {"hell226m.aud", "hell march", int32_t(0x0FF2BAB3), int32_t(0x00000000)},
    {"hellnvox.aud", "", int32_t(0x262502EB), int32_t(0x00000000)},
    {"hellvaly.vqa", "valley filled with tiberium", int32_t(0x251AEDFB), int32_t(0x00000000)},
    {"hellvaly.vqp", "valley filled with tiberium", int32_t(0x341AEDFB), int32_t(0x00000000)},
    {"help.fnt", "fnt:", int32_t(0xF4E6D0BE), int32_t(0x00000000)},
    {"help.shp", "", int32_t(0xF0E0DDBE), int32_t(0x00000000)},
    {"help.tre", "", int32_t(0xE5EADEBE), int32_t(0x00000000)},
    {"help.trf", "", int32_t(0xE6EADEBE), int32_t(0x00000000)},
    {"help.trg", "", int32_t(0xE7EADEBE), int32_t(0x00000000)},
    {"help.tri", "", int32_t(0xE9EADEBE), int32_t(0x00000000)},
    {"help.trr", "", int32_t(0xF2EADEBE), int32_t(0x00000000)},
    {"help.trs", "", int32_t(0xF3EADEBE), int32_t(0x00000000)},
    {"help_h.pcx", "", int32_t(0xE18DFE22), int32_t(0x00000000)},
    {"help_l.pcx", "", int32_t(0xE18E0622), int32_t(0x00000000)},
    {"helptext.trr", "", int32_t(0x3C33F3F7), int32_t(0x00000000)},
    {"heroism.aud", "heroism", int32_t(0x00000000), int32_t(0xFB7482EC)},
    {"hextreme.ini", "", int32_t(0x00000000), int32_t(0x1361F119)},
    {"hextreme.map", "-", int32_t(0x00000000), int32_t(0xF79BEDCA)},
    {"hf01-min.set", "", int32_t(0xB59906A9), int32_t(0x00000000)},
    {"hf01.vqa", "", int32_t(0xA3B1E2BE), int32_t(0x00000000)},
    {"hf01_0.vqa", "", int32_t(0x711DBB30), int32_t(0x00000000)},
    {"hf01_1.vqa", "", int32_t(0x711DBD30), int32_t(0x00000000)},
    {"hf01_2.vqa", "", int32_t(0x711DBF30), int32_t(0x00000000)},
    {"hf01_3.vqa", "", int32_t(0x711DC130), int32_t(0x00000000)},
    {"hf02-min.set", "", int32_t(0xB99906A9), int32_t(0x00000000)},
    {"hf02.vqa", "", int32_t(0xA5B1E2BE), int32_t(0x00000000)},
    {"hf02_0.vqa", "", int32_t(0x751DBB30), int32_t(0x00000000)},
    {"hf02_1.vqa", "", int32_t(0x751DBD30), int32_t(0x00000000)},
    {"hf02_2.vqa", "", int32_t(0x751DBF30), int32_t(0x00000000)},
    {"hf02_3.vqa", "", int32_t(0x751DC130), int32_t(0x00000000)},
    {"hf03-min.set", "", int32_t(0xBD9906A9), int32_t(0x00000000)},
    {"hf03.vqa", "", int32_t(0xA7B1E2BE), int32_t(0x00000000)},
    {"hf03_0.vqa", "", int32_t(0x791DBB30), int32_t(0x00000000)},
    {"hf03_1.vqa", "", int32_t(0x791DBD30), int32_t(0x00000000)},
    {"hf03_2.vqa", "", int32_t(0x791DBF30), int32_t(0x00000000)},
    {"hf03_3.vqa", "", int32_t(0x791DC130), int32_t(0x00000000)},
    {"hf04-min.set", "", int32_t(0xC19906A9), int32_t(0x00000000)},
    {"hf04.vqa", "", int32_t(0xA9B1E2BE), int32_t(0x00000000)},
    {"hf04_0.vqa", "", int32_t(0x7D1DBB30), int32_t(0x00000000)},
    {"hf04_1.vqa", "", int32_t(0x7D1DBD30), int32_t(0x00000000)},
    {"hf04_2.vqa", "", int32_t(0x7D1DBF30), int32_t(0x00000000)},
    {"hf04_3.vqa", "", int32_t(0x7D1DC130), int32_t(0x00000000)},
    {"hf05-min.set", "", int32_t(0xC59906A9), int32_t(0x00000000)},
    {"hf05.vqa", "", int32_t(0xABB1E2BE), int32_t(0x00000000)},
    {"hf05_0.vqa", "", int32_t(0x811DBB30), int32_t(0x00000000)},
    {"hf05_1.vqa", "", int32_t(0x811DBD30), int32_t(0x00000000)},
    {"hf05_2.vqa", "", int32_t(0x811DBF30), int32_t(0x00000000)},
    {"hf05_3.vqa", "", int32_t(0x811DC130), int32_t(0x00000000)},
    {"hf06-min.set", "", int32_t(0xC99906A9), int32_t(0x00000000)},
    {"hf06.vqa", "", int32_t(0xADB1E2BE), int32_t(0x00000000)},
    {"hf06_0.vqa", "", int32_t(0x851DBB30), int32_t(0x00000000)},
    {"hf06_1.vqa", "", int32_t(0x851DBD30), int32_t(0x00000000)},
    {"hf06_2.vqa", "", int32_t(0x851DBF30), int32_t(0x00000000)},
    {"hf06_3.vqa", "", int32_t(0x851DC130), int32_t(0x00000000)},
    {"hf07-min.set", "", int32_t(0xCD9906A9), int32_t(0x00000000)},
    {"hf07.vqa", "", int32_t(0xAFB1E2BE), int32_t(0x00000000)},
    {"hf07_0.vqa", "", int32_t(0x891DBB30), int32_t(0x00000000)},
    {"hf07_1.vqa", "", int32_t(0x891DBD30), int32_t(0x00000000)},
    {"hf07_2.vqa", "", int32_t(0x891DBF30), int32_t(0x00000000)},
    {"hf07_3.vqa", "", int32_t(0x891DC130), int32_t(0x00000000)},
    {"hfnt-d.fnt", "???", int32_t(0xDD95F5C9), int32_t(0x00000000)},
    {"hideseek.vqa", "-", int32_t(0x00000000), int32_t(0xD4600AF9)},
    {"hidvally.map", "", int32_t(0x00000000), int32_t(0xE705ECD0)},
    {"hill01.tem", "ant hill", int32_t(0xD98DD4C6), int32_t(0x00000000)},
    {"hillbtwn.map", "", int32_t(0x00000000), int32_t(0xAC53084B)},
    {"hind.hva", "-", int32_t(0x00000000), int32_t(0x05B62CAF)},
    {"hind.shp", "unit: hind", int32_t(0xD8E4E5BE), int32_t(0x00000000)},
    {"hind.vxl", "hind", int32_t(0x00000000), int32_t(0xF33CF3E6)},
    {"hindicon.shp", "icon: hind", int32_t(0xFE1FFEE1), int32_t(0xC49271BD)},
    {"hires.mix", "rmix: hires.mix", int32_t(0xA7E3821F), int32_t(0x00000000)},
    {"hisc1-hr.shp", "misc: score screen bits", int32_t(0x0225D2B1), int32_t(0x00000000)},
    {"hisc2-hr.shp", "misc: score screen bits", int32_t(0x0225D2B3), int32_t(0x00000000)},
    {"hiscore1.shp", "score screen corner piece", int32_t(0xC0201CED), int32_t(0x00000000)},
    {"hiscore2.shp", "score screen bar across top", int32_t(0xC2201CED), int32_t(0x00000000)},
    {"hit1norm.aud", "", int32_t(0xA44B04EB), int32_t(0x00000000)},
    {"hit2norm.aud", "", int32_t(0xA84B04EB), int32_t(0x00000000)},
    {"hit3liz.aud", "", int32_t(0x2A4A0CFA), int32_t(0x00000000)},
    {"hit3norm.aud", "", int32_t(0xAC4B04EB), int32_t(0x00000000)},
    {"hit4norm.aud", "", int32_t(0xB04B04EB), int32_t(0x00000000)},
    {"hit5beas.aud", "", int32_t(0xC028F0D3), int32_t(0x00000000)},
    {"hit5norm.aud", "", int32_t(0xB44B04EB), int32_t(0x00000000)},
    {"hitdoor1.aud", "", int32_t(0xB84B04ED), int32_t(0x00000000)},
    {"hittarg1.aud", "", int32_t(0xF8350AD1), int32_t(0x00000000)},
    {"hittarg2.aud", "", int32_t(0xFA350AD1), int32_t(0x00000000)},
    {"hittarg3.aud", "", int32_t(0xFC350AD1), int32_t(0x00000000)},
    {"hivamb1.aud", "", int32_t(0x61FFFEFC), int32_t(0x00000000)},
    {"hivamb2.aud", "", int32_t(0x6201FEFC), int32_t(0x00000000)},
    {"hivebat1.aud", "", int32_t(0xBC56E8D3), int32_t(0x00000000)},
    {"hivecav1.aud", "", int32_t(0xBC5AE8D5), int32_t(0x00000000)},
    {"hivedie1.aud", "", int32_t(0xBC38F8D7), int32_t(0x00000000)},
    {"hivedie2.aud", "", int32_t(0xBE38F8D7), int32_t(0x00000000)},
    {"hivemom1.aud", "", int32_t(0xBC4904E9), int32_t(0x00000000)},
    {"hivewlk1.aud", "", int32_t(0xBC44FEFD), int32_t(0x00000000)},
    {"hivewlk2.aud", "", int32_t(0xBE44FEFD), int32_t(0x00000000)},
    {"hivewlk3.aud", "", int32_t(0xC044FEFD), int32_t(0x00000000)},
    {"hlight.shp", "-", int32_t(0x00000000), int32_t(0x5E6EFE0E)},
    {"hm2.wav", "", int32_t(0x00000000), int32_t(0xDFAF5ECF)},
    {"hmap.shp", "butt: map", int32_t(0xF0CAEDBE), int32_t(0x00000000)},
    {"hmapf.shp", "", int32_t(0xD1AB91FD), int32_t(0x00000000)},
    {"hmapg.shp", "", int32_t(0xD1AB91FF), int32_t(0x00000000)},
    {"hmec.hva", "-", int32_t(0x00000000), int32_t(0x291E246F)},
    {"hmec.vxl", "mammoth mk 2", int32_t(0x00000000), int32_t(0xDF94FB26)},
    {"hmecicon.shp", "icon: mammoth mk 2", int32_t(0x00000000), int32_t(0xE8CA9401)},
    {"hole0000.lut", "", int32_t(0xC9E6E9AF), int32_t(0x00000000)},
    {"hole0001.lut", "", int32_t(0xCBE6E9AF), int32_t(0x00000000)},
    {"hole0002.lut", "", int32_t(0xCDE6E9AF), int32_t(0x00000000)},
    {"hole0003.lut", "", int32_t(0xCFE6E9AF), int32_t(0x00000000)},
    {"hole0004.lut", "", int32_t(0xD1E6E9AF), int32_t(0x00000000)},
    {"hole0005.lut", "", int32_t(0xD3E6E9AF), int32_t(0x00000000)},
    {"hole0006.lut", "", int32_t(0xD5E6E9AF), int32_t(0x00000000)},
    {"hole0007.lut", "", int32_t(0xD7E6E9AF), int32_t(0x00000000)},
    {"hole0008.lut", "", int32_t(0xD9E6E9AF), int32_t(0x00000000)},
    {"hole0009.lut", "", int32_t(0xDBE6E9AF), int32_t(0x00000000)},
    {"hole0010.lut", "", int32_t(0xC9E8E9AF), int32_t(0x00000000)},
    {"hole0011.lut", "", int32_t(0xCBE8E9AF), int32_t(0x00000000)},
    {"hole0012.lut", "", int32_t(0xCDE8E9AF), int32_t(0x00000000)},
    {"hole0013.lut", "", int32_t(0xCFE8E9AF), int32_t(0x00000000)},
    {"hole0014.lut", "", int32_t(0xD1E8E9AF), int32_t(0x00000000)},
    {"hole0015.lut", "", int32_t(0xD3E8E9AF), int32_t(0x00000000)},
    {"hole0016.lut", "", int32_t(0xD5E8E9AF), int32_t(0x00000000)},
    {"hole0017.lut", "", int32_t(0xD7E8E9AF), int32_t(0x00000000)},
    {"hole0018.lut", "", int32_t(0xD9E8E9AF), int32_t(0x00000000)},
    {"hole0019.lut", "", int32_t(0xDBE8E9AF), int32_t(0x00000000)},
    {"hole0020.lut", "", int32_t(0xC9EAE9AF), int32_t(0x00000000)},
    {"hole0021.lut", "", int32_t(0xCBEAE9AF), int32_t(0x00000000)},
    {"hole0022.lut", "", int32_t(0xCDEAE9AF), int32_t(0x00000000)},
    {"hole0023.lut", "", int32_t(0xCFEAE9AF), int32_t(0x00000000)},
    {"hole0024.lut", "", int32_t(0xD1EAE9AF), int32_t(0x00000000)},
    {"hole0025.lut", "", int32_t(0xD3EAE9AF), int32_t(0x00000000)},
    {"hole0026.lut", "", int32_t(0xD5EAE9AF), int32_t(0x00000000)},
    {"hole0027.lut", "", int32_t(0xD7EAE9AF), int32_t(0x00000000)},
    {"hole0028.lut", "", int32_t(0xD9EAE9AF), int32_t(0x00000000)},
    {"hole0029.lut", "", int32_t(0xDBEAE9AF), int32_t(0x00000000)},
    {"hole0030.lut", "", int32_t(0xC9ECE9AF), int32_t(0x00000000)},
    {"hole0031.lut", "", int32_t(0xCBECE9AF), int32_t(0x00000000)},
    {"hole0032.lut", "", int32_t(0xCDECE9AF), int32_t(0x00000000)},
    {"hole0033.lut", "", int32_t(0xCFECE9AF), int32_t(0x00000000)},
    {"hole0034.lut", "", int32_t(0xD1ECE9AF), int32_t(0x00000000)},
    {"hole0035.lut", "", int32_t(0xD3ECE9AF), int32_t(0x00000000)},
    {"hole0036.lut", "", int32_t(0xD5ECE9AF), int32_t(0x00000000)},
    {"hole0037.lut", "", int32_t(0xD7ECE9AF), int32_t(0x00000000)},
    {"hole0038.lut", "", int32_t(0xD9ECE9AF), int32_t(0x00000000)},
    {"hole0039.lut", "", int32_t(0xDBECE9AF), int32_t(0x00000000)},
    {"hole0040.lut", "", int32_t(0xC9EEE9AF), int32_t(0x00000000)},
    {"hole0041.lut", "", int32_t(0xCBEEE9AF), int32_t(0x00000000)},
    {"hole0042.lut", "", int32_t(0xCDEEE9AF), int32_t(0x00000000)},
    {"hole0043.lut", "", int32_t(0xCFEEE9AF), int32_t(0x00000000)},
    {"hole0044.lut", "", int32_t(0xD1EEE9AF), int32_t(0x00000000)},
    {"hole0045.lut", "", int32_t(0xD3EEE9AF), int32_t(0x00000000)},
    {"hole0046.lut", "", int32_t(0xD5EEE9AF), int32_t(0x00000000)},
    {"hole0047.lut", "", int32_t(0xD7EEE9AF), int32_t(0x00000000)},
    {"hologrm1.aud", "", int32_t(0xE42122DD), int32_t(0x00000000)},
    {"holster1.aud", "", int32_t(0xF42B08F7), int32_t(0x00000000)},
    {"hornet.hva", "", int32_t(0x00000000), int32_t(0x6F793381)},
    {"hornet.vxl", "", int32_t(0x00000000), int32_t(0xBF16D305)},
    {"horse1.aud", "", int32_t(0xCFA5E400), int32_t(0x00000000)},
    {"horse2.aud", "", int32_t(0xCFA5E600), int32_t(0x00000000)},
    {"horse3.aud", "", int32_t(0xCFA5E800), int32_t(0x00000000)},
    {"horv.hva", "-", int32_t(0x00000000), int32_t(0x08521F97)},
    {"horv.vxl", "harvester with back removed", int32_t(0x00000000), int32_t(0xFED8C0DE)},
    {"hosp.shp", "hospital", int32_t(0xF0EEF1BE), int32_t(0x00000000)},
    {"hospicon.shp", "icon: hospital", int32_t(0x2E3416E1), int32_t(0x00000000)},
    {"hospmake.shp", "make: hospital", int32_t(0x1C2C12E9), int32_t(0x00000000)},
    {"hotspot2.flc", "", int32_t(0xF54621EF), int32_t(0x00000000)},
    {"house01.des", "", int32_t(0x00000000), int32_t(0x0E99292D)},
    {"house01.sno", "-", int32_t(0x00000000), int32_t(0x2975F4B7)},
    {"house01.tem", "-", int32_t(0x00000000), int32_t(0x8AC1416D)},
    {"house01.urb", "", int32_t(0x00000000), int32_t(0xAC8C8F32)},
    {"house02.urb", "", int32_t(0x00000000), int32_t(0x2A18FD9C)},
    {"house03.urb", "", int32_t(0x00000000), int32_t(0xE1442E39)},
    {"house04.urb", "", int32_t(0x00000000), int32_t(0xFC411E81)},
    {"hovr.hva", "", int32_t(0x00000000), int32_t(0x6643FB41)},
    {"hovr.vxl", "", int32_t(0x00000000), int32_t(0x90C92408)},
    {"hovricon.shp", "icon: hover mlrs", int32_t(0x00000000), int32_t(0xC7844119)},
    {"hovrmis1.aud", "hovermlrs rocket fire", int32_t(0x00000000), int32_t(0x123C6A2C)},
    {"hp_bar.shp", "", int32_t(0xAFDA35EB), int32_t(0x00000000)},
    {"hpad.shp", "helipad", int32_t(0xD8CAF3BE), int32_t(0x00000000)},
    {"hpadicnh.des", "icon: helipad", int32_t(0xF4E70BE1), int32_t(0x00000000)},
    {"hpadicnh.tem", "icon: helipad", int32_t(0xEEE71BE1), int32_t(0x00000000)},
    {"hpadicnh.win", "icon: helipad", int32_t(0xEFEB1EE1), int32_t(0x00000000)},
    {"hpadicon.shp", "icon: helipad", int32_t(0xFDEC1AE1), int32_t(0x00000000)},
    {"hpadmake.shp", "make: helipad", int32_t(0xEBE416E9), int32_t(0x00000000)},
    {"hpips.shp", "building messages", int32_t(0xD1CB9E17), int32_t(0x00000000)},
    {"hpips_f.shp", "", int32_t(0x9E02481A), int32_t(0x00000000)},
    {"hpips_g.shp", "", int32_t(0x9E04481A), int32_t(0x00000000)},
    {"hpower.shp", "power requirement indicator", int32_t(0x039A35F2), int32_t(0x00000000)},
    {"hpsuck1.aud", "", int32_t(0xB1F42CE8), int32_t(0x00000000)},
    {"hpwrbar.shp", "powerbar", int32_t(0xA6520BF8), int32_t(0x00000000)},
    {"hq.shp", "comm. center", int32_t(0xA65CF2D8), int32_t(0x00000000)},
    {"hqicnh.des", "icon: comm. center", int32_t(0x95822902), int32_t(0x00000000)},
    {"hqicnh.tem", "icon: comm. center", int32_t(0xB5822302), int32_t(0x00000000)},
    {"hqicnh.win", "icon: comm. center", int32_t(0xBB822406), int32_t(0x00000000)},
    {"hqicon.shp", "icon: comm. center", int32_t(0xB3823207), int32_t(0x00000000)},
    {"hqmake.shp", "make: comm. center", int32_t(0xAB921FFF), int32_t(0x00000000)},
    {"hradar.gdi", "gdi radar and logo", int32_t(0x9F6236E7), int32_t(0x00000000)},
    {"hradar.jp", "jp radar and logo", int32_t(0xA561EDF3), int32_t(0x00000000)},
    {"hradar.nod", "nod radar and logo", int32_t(0xAD6231F2), int32_t(0x00000000)},
    {"hrddirt1.aud", "", int32_t(0xB80F2EE1), int32_t(0x00000000)},
    {"hrddirt2.aud", "", int32_t(0xBA0F2EE1), int32_t(0x00000000)},
    {"hrddirt3.aud", "", int32_t(0xBC0F2EE1), int32_t(0x00000000)},
    {"hrddirt4.aud", "", int32_t(0xBE0F2EE1), int32_t(0x00000000)},
    {"hrddirt5.aud", "", int32_t(0xC00F2EE1), int32_t(0x00000000)},
    {"hrddirt6.aud", "", int32_t(0xC20F2EE1), int32_t(0x00000000)},
    {"hrddirt7.aud", "", int32_t(0xC40F2EE1), int32_t(0x00000000)},
    {"hrepair.shp", "butt: repair", int32_t(0x9E0A23F6), int32_t(0x00000000)},
    {"hrepairf.shp", "", int32_t(0x1E022ED1), int32_t(0x00000000)},
    {"hrepairg.shp", "", int32_t(0x20022ED1), int32_t(0x00000000)},
    {"hroachd1.aud", "", int32_t(0xAC1B1AD5), int32_t(0x00000000)},
    {"hrtbeat1.aud", "", int32_t(0xB04F0CD9), int32_t(0x00000000)},
    {"hsafrica.wsa", "anim: zoom on south africa", int32_t(0xDCDF36F3), int32_t(0x00000000)},
    {"hsell.shp", "butt: sell", int32_t(0xC1BBAA09), int32_t(0x00000000)},
    {"hsellf.shp", "", int32_t(0xD7722A01), int32_t(0x00000000)},
    {"hsellg.shp", "", int32_t(0xD7722C01), int32_t(0x00000000)},
    {"hside1.shp", "sidebar 1", int32_t(0xB781FFF3), int32_t(0x00000000)},
    {"hside2.shp", "sidebar 2", int32_t(0xB78201F3), int32_t(0x00000000)},
    {"hsradar.shp", "", int32_t(0x623E17FC), int32_t(0x00000000)},
    {"hstrip.shp", "sidebar background", int32_t(0xEFAE3DFB), int32_t(0x00000000)},
    {"hstripdn.shp", "butt: scroll down", int32_t(0x362240E1), int32_t(0x00000000)},
    {"hstripup.shp", "butt: scroll up", int32_t(0x3A4440E1), int32_t(0x00000000)},
    {"htabs.shp", "tabs", int32_t(0x99ABAE17), int32_t(0x00000000)},
    {"htitle.pcx", "pict: title screen", int32_t(0xF18233FC), int32_t(0x00000000)},
    {"htk.hva", "", int32_t(0x00000000), int32_t(0x1554AD71)},
    {"htk.vxl", "", int32_t(0x00000000), int32_t(0x1AA2DE9A)},
    {"htkbarl.hva", "", int32_t(0x00000000), int32_t(0x020F12A0)},
    {"htkbarl.vxl", "", int32_t(0x00000000), int32_t(0x0DF9614B)},
    {"htkicon.shp", "", int32_t(0x00000000), int32_t(0x4BC7AAF1)},
    {"htktur.hva", "", int32_t(0x00000000), int32_t(0x1F9016D2)},
    {"htktur.vxl", "", int32_t(0x00000000), int32_t(0xCFFFF656)},
    {"htkuico.shp", "", int32_t(0x00000000), int32_t(0x9C0FBE8D)},
    {"htnk.hva", "", int32_t(0x00000000), int32_t(0x81EF4670)},
    {"htnk.shp", "mammoth tank", int32_t(0xE6E4FBBE), int32_t(0x00000000)},
    {"htnk.vxl", "", int32_t(0x00000000), int32_t(0x77659939)},
    {"htnkbarl.hva", "", int32_t(0x00000000), int32_t(0xDFB62B46)},
    {"htnkbarl.vxl", "", int32_t(0x00000000), int32_t(0x293CF40F)},
    {"htnkicnh.des", "icon: mammoth tank", int32_t(0x111B1BE1), int32_t(0x00000000)},
    {"htnkicnh.tem", "icon: mammoth tank", int32_t(0x0B1B2BE1), int32_t(0x00000000)},
    {"htnkicnh.win", "icon: mammoth tank", int32_t(0x0C1F2EE1), int32_t(0x00000000)},
    {"htnkicon.shp", "icon: mammoth tank", int32_t(0x1A202AE1), int32_t(0x7E4937A0)},
    {"htnktur.hva", "", int32_t(0x00000000), int32_t(0x80A50D95)},
    {"htnktur.vxl", "", int32_t(0x00000000), int32_t(0x8F537E7E)},
    {"htnkuico.shp", "", int32_t(0x00000000), int32_t(0xBB8FA541)},
    {"htrkpuff.shp", "", int32_t(0x00000000), int32_t(0x335ECF3B)},
    {"huge.fnt", "", int32_t(0x00000000), int32_t(0x5AFFF3D5)},
    {"hujung1.aud", "", int32_t(0xB1D038FE), int32_t(0x00000000)},
    {"human1.aud", "", int32_t(0x8791FC12), int32_t(0x00000000)},
    {"human10.aud", "", int32_t(0x61DA0CFE), int32_t(0x00000000)},
    {"human11.aud", "", int32_t(0x61DC0CFE), int32_t(0x00000000)},
    {"human2.aud", "", int32_t(0x8791FE12), int32_t(0x00000000)},
    {"human3.aud", "", int32_t(0x87920012), int32_t(0x00000000)},
    {"human4.aud", "", int32_t(0x87920212), int32_t(0x00000000)},
    {"human5.aud", "", int32_t(0x87920412), int32_t(0x00000000)},
    {"human6.aud", "", int32_t(0x87920612), int32_t(0x00000000)},
    {"human7.aud", "", int32_t(0x87920812), int32_t(0x00000000)},
    {"human8.aud", "", int32_t(0x87920A12), int32_t(0x00000000)},
    {"human9.aud", "", int32_t(0x87920C12), int32_t(0x00000000)},
    {"hummer1.aud", "", int32_t(0x91DC4EEC), int32_t(0x00000000)},
    {"hummer2.aud", "", int32_t(0x91DE4EEC), int32_t(0x00000000)},
    {"hummer3.aud", "", int32_t(0x91E04EEC), int32_t(0x00000000)},
    {"hummer4.aud", "", int32_t(0x91E24EEC), int32_t(0x00000000)},
    {"hunt1.aud", "", int32_t(0xFBBBB1C7), int32_t(0x00000000)},
    {"hunter2.aud", "hunter seeker droid", int32_t(0x00000000), int32_t(0x4D295A02)},
    {"hurt1m1.aud", "", int32_t(0xADF044C4), int32_t(0x00000000)},
    {"hurt1m2.aud", "", int32_t(0xADF244C4), int32_t(0x00000000)},
    {"hurt1m3.aud", "", int32_t(0xADF444C4), int32_t(0x00000000)},
    {"hut-fire.csv", "", int32_t(0x96492ADB), int32_t(0x00000000)},
    {"hut-fire.lsv", "", int32_t(0x964933DB), int32_t(0x00000000)},
    {"hut-fire.vqa", "", int32_t(0x81473DDB), int32_t(0x00000000)},
    {"hut-fire_e.vqa", "", int32_t(0x2C489B6A), int32_t(0x00000000)},
    {"hut-fire_e.vqt", "", int32_t(0x2C48AE6A), int32_t(0x00000000)},
    {"hut-fire_h.pcx", "", int32_t(0x2048B85C), int32_t(0x00000000)},
    {"hut-fire_h.vqa", "", int32_t(0x2C48A16A), int32_t(0x00000000)},
    {"hut-fire_l.pcx", "", int32_t(0x2048C05C), int32_t(0x00000000)},
    {"hut-fire_l.vqa", "", int32_t(0x2C48A96A), int32_t(0x00000000)},
    {"hutblow1.aud", "", int32_t(0xB05534E7), int32_t(0x00000000)},
    {"huvilag1.aud", "", int32_t(0xCC3D18E7), int32_t(0x00000000)},
    {"hv1-v-rl.csv", "", int32_t(0xA3BCF6FB), int32_t(0x00000000)},
    {"hv1-v-rl.lsv", "", int32_t(0xA3BCFFFB), int32_t(0x00000000)},
    {"hv1-v-rl.vqa", "", int32_t(0x8EBB09FB), int32_t(0x00000000)},
    {"hv1-v-rl_e.vqa", "", int32_t(0x473033AA), int32_t(0x00000000)},
    {"hv1-v-rl_e.vqt", "", int32_t(0x473046AA), int32_t(0x00000000)},
    {"hv1-v-rl_h.pcx", "", int32_t(0x3B30509C), int32_t(0x00000000)},
    {"hv1-v-rl_h.vqa", "", int32_t(0x473039AA), int32_t(0x00000000)},
    {"hv1-v-rl_l.pcx", "", int32_t(0x3B30589C), int32_t(0x00000000)},
    {"hv1-v-rl_l.vqa", "", int32_t(0x473041AA), int32_t(0x00000000)},
    {"hvr.hva", "-", int32_t(0x00000000), int32_t(0xA612EF0B)},
    {"hvr.vxl", "hover mlrs", int32_t(0x00000000), int32_t(0xA9E49CE0)},
    {"hvrbarl.hva", "-", int32_t(0x00000000), int32_t(0x81D80143)},
    {"hvrtur.hva", "-", int32_t(0x00000000), int32_t(0x9C470531)},
    {"hvrtur.vxl", "hover mlrs", int32_t(0x00000000), int32_t(0x4C28E5B5)},
    {"hvwm_apr.csv", "", int32_t(0x30511F0D), int32_t(0x00000000)},
    {"hvwm_apr.lsv", "", int32_t(0x3051280D), int32_t(0x00000000)},
    {"hvwm_apr.vqa", "", int32_t(0x1B4F320D), int32_t(0x00000000)},
    {"hvwm_apr_e.vqa", "", int32_t(0x605883CD), int32_t(0x00000000)},
    {"hvwm_apr_e.vqt", "", int32_t(0x605896CD), int32_t(0x00000000)},
    {"hvwm_apr_h.pcx", "", int32_t(0x5458A0BF), int32_t(0x00000000)},
    {"hvwm_apr_h.vqa", "", int32_t(0x605889CD), int32_t(0x00000000)},
    {"hvwm_apr_l.pcx", "", int32_t(0x5458A8BF), int32_t(0x00000000)},
    {"hvwm_apr_l.vqa", "", int32_t(0x605891CD), int32_t(0x00000000)},
    {"hvydoor1.aud", "heavy door", int32_t(0xB85F38ED), int32_t(0x00000000)},
    {"hvydoor1.juv", "heavy door", int32_t(0xCA5F41ED), int32_t(0x00000000)},
    {"hvygun10.aud", "heavy gun", int32_t(0xC21D36F9), int32_t(0x00000000)},
    {"hvygun10.juv", "heavy gun", int32_t(0xD41D3FF9), int32_t(0x00000000)},
    {"hw-brdge.csv", "", int32_t(0xE99728F3), int32_t(0x00000000)},
    {"hw-brdge.lsv", "", int32_t(0xE99731F3), int32_t(0x00000000)},
    {"hw-brdge.vqa", "", int32_t(0xD4953BF3), int32_t(0x00000000)},
    {"hw-brdge_e.vqa", "", int32_t(0xD2E4979A), int32_t(0x00000000)},
    {"hw-brdge_e.vqt", "", int32_t(0xD2E4AA9A), int32_t(0x00000000)},
    {"hw-brdge_h.pcx", "", int32_t(0xC6E4B48C), int32_t(0x00000000)},
    {"hw-brdge_h.vqa", "", int32_t(0xD2E49D9A), int32_t(0x00000000)},
    {"hw-brdge_l.pcx", "", int32_t(0xC6E4BC8C), int32_t(0x00000000)},
    {"hw-brdge_l.vqa", "", int32_t(0xD2E4A59A), int32_t(0x00000000)},
    {"hwhit.img", "", int32_t(0xBFB3BA10), int32_t(0x00000000)},
    {"hwhit.lmf", "", int32_t(0xBFB9BA0F), int32_t(0x00000000)},
    {"hwhit.lsv", "", int32_t(0xCBB9BA1F), int32_t(0x00000000)},
    {"hwhit.odf", "", int32_t(0xADBFBA0F), int32_t(0x00000000)},
    {"hwhit.pcx", "", int32_t(0xABC1BA21), int32_t(0x00000000)},
    {"hwhit.ver", "", int32_t(0xAFCDBA1B), int32_t(0x00000000)},
    {"hwtz.hva", "", int32_t(0x00000000), int32_t(0x4FCAC322)},
    {"hwtz.vxl", "", int32_t(0x00000000), int32_t(0xB9401C6B)},
    {"hyd.hva", "", int32_t(0x00000000), int32_t(0x85D57E64)},
    {"hyd.vxl", "", int32_t(0x00000000), int32_t(0x8A230D8F)},
    {"hydrod1.aud", "flame turret down", int32_t(0xA5B84300), int32_t(0x00000000)},
    {"hyena1.aud", "", int32_t(0xBB720BF8), int32_t(0x00000000)},
    {"hyena2.aud", "", int32_t(0xBB720DF8), int32_t(0x00000000)},
    {"hyte01.des", "", int32_t(0x00000000), int32_t(0x870F0C95)},
    {"hyte01.sno", "", int32_t(0x00000000), int32_t(0x0020439A)},
    {"hyte01.tem", "", int32_t(0x00000000), int32_t(0xF157156D)},
    {"hyte01.urb", "", int32_t(0x00000000), int32_t(0x89769101)},
    {"hyte02.des", "", int32_t(0x00000000), int32_t(0xB6E71608)},
    {"hyte02.sno", "", int32_t(0x00000000), int32_t(0x31C85907)},
    {"hyte02.tem", "", int32_t(0x00000000), int32_t(0xC0BF0FF0)},
    {"hyte02.urb", "", int32_t(0x00000000), int32_t(0xB89E8B9C)},
    {"hyte03.des", "", int32_t(0x00000000), int32_t(0x10901DBC)},
    {"hyte03.sno", "", int32_t(0x00000000), int32_t(0x97BF52B3)},
    {"hyte03.tem", "", int32_t(0x00000000), int32_t(0x66C80444)},
    {"hyte03.urb", "", int32_t(0x00000000), int32_t(0x1EE98028)},
    {"hyte04.des", "", int32_t(0x00000000), int32_t(0xD5372332)},
    {"hyte04.sno", "", int32_t(0x00000000), int32_t(0x52186C3D)},
    {"hyte04.tem", "", int32_t(0x00000000), int32_t(0xA36F3ACA)},
    {"hyte04.urb", "", int32_t(0x00000000), int32_t(0xDB4EBEA6)},
    {"hyte05.des", "", int32_t(0x00000000), int32_t(0x73402886)},
    {"hyte05.sno", "", int32_t(0x00000000), int32_t(0xF46F6789)},
    {"hyte05.tem", "", int32_t(0x00000000), int32_t(0x0518317E)},
    {"hyte05.urb", "", int32_t(0x00000000), int32_t(0x7D39B512)},
    {"hyte06.des", "", int32_t(0x00000000), int32_t(0x42A8321B)},
    {"hyte06.sno", "", int32_t(0x00000000), int32_t(0xC5877D14)},
    {"hyte06.tem", "", int32_t(0x00000000), int32_t(0x34F02BE3)},
    {"hyte06.urb", "", int32_t(0x00000000), int32_t(0x4CD1AF8F)},
    {"hyte07.des", "", int32_t(0x00000000), int32_t(0xE4DF39AF)},
    {"hyte07.sno", "", int32_t(0x00000000), int32_t(0x63F076A0)},
    {"hyte07.tem", "", int32_t(0x00000000), int32_t(0x92872057)},
    {"hyte07.urb", "", int32_t(0x00000000), int32_t(0xEAA6A43B)},
    {"hyte08.des", "", int32_t(0x00000000), int32_t(0x12974946)},
    {"hyte08.sno", "", int32_t(0x00000000), int32_t(0x95B80649)},
    {"hyte08.tem", "", int32_t(0x00000000), int32_t(0x64CF50BE)},
    {"hyte08.urb", "", int32_t(0x00000000), int32_t(0x1CEED4D2)},
    {"hyte09.des", "", int32_t(0x00000000), int32_t(0xB4E042F2)},
    {"hyte09.sno", "", int32_t(0x00000000), int32_t(0x33CF0DFD)},
    {"hyte09.tem", "", int32_t(0x00000000), int32_t(0xC2B85B0A)},
    {"hyte09.urb", "", int32_t(0x00000000), int32_t(0xBA99DF66)},
    {"hyte10.des", "", int32_t(0x00000000), int32_t(0xEDD207BF)},
    {"hyte10.sno", "", int32_t(0x00000000), int32_t(0x6AFD48B0)},
    {"hyte10.tem", "", int32_t(0x00000000), int32_t(0x9B8A1E47)},
    {"hyte10.urb", "", int32_t(0x00000000), int32_t(0xE3AB9A2B)},
    {"hyte11.des", "", int32_t(0x00000000), int32_t(0x4BA50C0B)},
    {"hyte11.sno", "", int32_t(0x00000000), int32_t(0xCC8A4304)},
    {"hyte11.tem", "", int32_t(0x00000000), int32_t(0x3DFD15F3)},
    {"hyte11.urb", "", int32_t(0x00000000), int32_t(0x45DC919F)},
    {"hyte12.des", "", int32_t(0x00000000), int32_t(0x7A4D1696)},
    {"hyte12.sno", "", int32_t(0x00000000), int32_t(0xFD625999)},
    {"hyte12.tem", "", int32_t(0x00000000), int32_t(0x0C150F6E)},
    {"hyte12.urb", "", int32_t(0x00000000), int32_t(0x74348B02)},
    {"hyte13.des", "", int32_t(0x00000000), int32_t(0xDC3A1D22)},
    {"hyte13.sno", "", int32_t(0x00000000), int32_t(0x5B15522D)},
    {"hyte13.tem", "", int32_t(0x00000000), int32_t(0xAA6204DA)},
    {"hyte13.urb", "", int32_t(0x00000000), int32_t(0xD24380B6)},
    {"hyte14.des", "", int32_t(0x00000000), int32_t(0x199D23AC)},
    {"hyte14.sno", "", int32_t(0x00000000), int32_t(0x9EB26CA3)},
    {"hyte14.tem", "", int32_t(0x00000000), int32_t(0x6FC53A54)},
    {"hyte14.urb", "", int32_t(0x00000000), int32_t(0x17E4BE38)},
    {"hyte15.des", "", int32_t(0x00000000), int32_t(0xBFEA2818)},
    {"hyte15.sno", "", int32_t(0x00000000), int32_t(0x38C56717)},
    {"hyte15.tem", "", int32_t(0x00000000), int32_t(0xC9B231E0)},
    {"hyte15.urb", "", int32_t(0x00000000), int32_t(0xB193B58C)},
    {"i.mix", "", int32_t(0x929A5CEA), int32_t(0x00000000)},
    {"i_am.aud", "i am", int32_t(0xDED7FFC0), int32_t(0x00000000)},
    {"icbm.hva", "-", int32_t(0x00000000), int32_t(0x17BED175)},
    {"icbm.vxl", "icbm", int32_t(0x00000000), int32_t(0xE1340E3C)},
    {"icbm1.aud", "big huge icbm rocket", int32_t(0x00000000), int32_t(0x3E2525A8)},
    {"icbmlnch.vqa", "-", int32_t(0x00000000), int32_t(0x2DC922FD)},
    {"ice01.sno", "misc: ice floe", int32_t(0x5DBB69D6), int32_t(0x00000000)},
    {"ice01.tem", "misc: ice floe", int32_t(0x4BBD69D4), int32_t(0x00000000)},
    {"ice0101.des", "", int32_t(0x00000000), int32_t(0xF57C5466)},
    {"ice0101.sno", "-", int32_t(0x00000000), int32_t(0xD29089FC)},
    {"ice0102.des", "", int32_t(0x00000000), int32_t(0x73E826C8)},
    {"ice0102.sno", "-", int32_t(0x00000000), int32_t(0x5404FB52)},
    {"ice0103.des", "", int32_t(0x00000000), int32_t(0xB8B4F56D)},
    {"ice0103.sno", "-", int32_t(0x00000000), int32_t(0x9F5828F7)},
    {"ice0104.des", "", int32_t(0x00000000), int32_t(0xA5B1C5D5)},
    {"ice0104.sno", "-", int32_t(0x00000000), int32_t(0x825D184F)},
    {"ice0105.des", "", int32_t(0x00000000), int32_t(0x6EED1670)},
    {"ice0105.sno", "-", int32_t(0x00000000), int32_t(0x4901CBEA)},
    {"ice0106.des", "", int32_t(0x00000000), int32_t(0xE87964DE)},
    {"ice0106.sno", "-", int32_t(0x00000000), int32_t(0xCF95B944)},
    {"ice0107.des", "", int32_t(0x00000000), int32_t(0x2325B77B)},
    {"ice0107.sno", "-", int32_t(0x00000000), int32_t(0x04C96AE1)},
    {"ice0108.des", "", int32_t(0x00000000), int32_t(0xD27305AE)},
    {"ice0108.sno", "-", int32_t(0x00000000), int32_t(0xF59FD834)},
    {"ice0109.des", "", int32_t(0x00000000), int32_t(0x192FD60B)},
    {"ice0109.sno", "-", int32_t(0x00000000), int32_t(0x3EC30B91)},
    {"ice0110.des", "", int32_t(0x00000000), int32_t(0x98578C77)},
    {"ice0110.sno", "-", int32_t(0x00000000), int32_t(0xBFBB51ED)},
    {"ice0111.des", "", int32_t(0x00000000), int32_t(0x530B5FD2)},
    {"ice0111.sno", "-", int32_t(0x00000000), int32_t(0x74E78248)},
    {"ice0112.des", "", int32_t(0x00000000), int32_t(0xD59F2D7C)},
    {"ice0112.sno", "-", int32_t(0x00000000), int32_t(0xF273F0E6)},
    {"ice0113.des", "", int32_t(0x00000000), int32_t(0x1EC3FED9)},
    {"ice0113.sno", "-", int32_t(0x00000000), int32_t(0x392F2343)},
    {"ice0114.des", "", int32_t(0x00000000), int32_t(0x03C6CE61)},
    {"ice0114.sno", "-", int32_t(0x00000000), int32_t(0x242A13FB)},
    {"ice0115.des", "", int32_t(0x00000000), int32_t(0xC89A1DC4)},
    {"ice0115.sno", "-", int32_t(0x00000000), int32_t(0xEF76C05E)},
    {"ice0116.des", "", int32_t(0x00000000), int32_t(0x4E0E6F6A)},
    {"ice0116.sno", "-", int32_t(0x00000000), int32_t(0x69E2B2F0)},
    {"ice0117.des", "", int32_t(0x00000000), int32_t(0x8552BCCF)},
    {"ice0117.sno", "-", int32_t(0x00000000), int32_t(0xA2BE6155)},
    {"ice0118.des", "", int32_t(0x00000000), int32_t(0x74040E1A)},
    {"ice0118.sno", "-", int32_t(0x00000000), int32_t(0x53E8D380)},
    {"ice0119.des", "", int32_t(0x00000000), int32_t(0xBF58DDBF)},
    {"ice0119.sno", "-", int32_t(0x00000000), int32_t(0x98B40025)},
    {"ice0120.des", "", int32_t(0x00000000), int32_t(0xA9BF96EA)},
    {"ice0120.sno", "-", int32_t(0x00000000), int32_t(0x8E534B70)},
    {"ice0121.des", "", int32_t(0x00000000), int32_t(0x62E3454F)},
    {"ice0121.sno", "-", int32_t(0x00000000), int32_t(0x450F98D5)},
    {"ice0122.des", "", int32_t(0x00000000), int32_t(0xE47737E1)},
    {"ice0122.sno", "-", int32_t(0x00000000), int32_t(0xC39BEA7B)},
    {"ice0123.des", "", int32_t(0x00000000), int32_t(0x2F2BE444)},
    {"ice0123.sno", "-", int32_t(0x00000000), int32_t(0x08C739DE)},
    {"ice0124.des", "", int32_t(0x00000000), int32_t(0x322ED4FC)},
    {"ice0124.sno", "-", int32_t(0x00000000), int32_t(0x15C20966)},
    {"ice0125.des", "", int32_t(0x00000000), int32_t(0xF9720759)},
    {"ice0125.sno", "-", int32_t(0x00000000), int32_t(0xDE9EDAC3)},
    {"ice0126.des", "", int32_t(0x00000000), int32_t(0x7FE675F7)},
    {"ice0126.sno", "-", int32_t(0x00000000), int32_t(0x580AA86D)},
    {"ice0127.des", "", int32_t(0x00000000), int32_t(0xB4BAA652)},
    {"ice0127.sno", "-", int32_t(0x00000000), int32_t(0x93567BC8)},
    {"ice0128.des", "", int32_t(0x00000000), int32_t(0x45EC1487)},
    {"ice0128.sno", "-", int32_t(0x00000000), int32_t(0x6200C91D)},
    {"ice0129.des", "", int32_t(0x00000000), int32_t(0x8EB0C722)},
    {"ice0129.sno", "-", int32_t(0x00000000), int32_t(0xA95C1AB8)},
    {"ice0130.des", "", int32_t(0x00000000), int32_t(0x0FC89D5E)},
    {"ice0130.sno", "-", int32_t(0x00000000), int32_t(0x282440C4)},
    {"ice0131.des", "", int32_t(0x00000000), int32_t(0xC4944EFB)},
    {"ice0131.sno", "-", int32_t(0x00000000), int32_t(0xE3789361)},
    {"ice0132.des", "", int32_t(0x00000000), int32_t(0x42003C55)},
    {"ice0132.sno", "-", int32_t(0x00000000), int32_t(0x65ECE1CF)},
    {"ice0133.des", "", int32_t(0x00000000), int32_t(0x895CEFF0)},
    {"ice0133.sno", "-", int32_t(0x00000000), int32_t(0xAEB0326A)},
    {"ice0134.des", "", int32_t(0x00000000), int32_t(0x9459DF48)},
    {"ice0134.sno", "-", int32_t(0x00000000), int32_t(0xB3B502D2)},
    {"ice0135.des", "", int32_t(0x00000000), int32_t(0x5F050CED)},
    {"ice0135.sno", "-", int32_t(0x00000000), int32_t(0x78E9D177)},
    {"ice0136.des", "", int32_t(0x00000000), int32_t(0xD9917E43)},
    {"ice0136.sno", "-", int32_t(0x00000000), int32_t(0xFE7DA3D9)},
    {"ice0137.des", "", int32_t(0x00000000), int32_t(0x12CDADE6)},
    {"ice0137.sno", "-", int32_t(0x00000000), int32_t(0x3521707C)},
    {"ice0138.des", "", int32_t(0x00000000), int32_t(0xE39B1F33)},
    {"ice0138.sno", "-", int32_t(0x00000000), int32_t(0xC477C2A9)},
    {"ice0139.des", "", int32_t(0x00000000), int32_t(0x28C7CC96)},
    {"ice0139.sno", "-", int32_t(0x00000000), int32_t(0x0F2B110C)},
    {"ice0140.des", "", int32_t(0x00000000), int32_t(0xCA6FA3D0)},
    {"ice0140.sno", "-", int32_t(0x00000000), int32_t(0xED837E4A)},
    {"ice0141.des", "", int32_t(0x00000000), int32_t(0x01337075)},
    {"ice0141.sno", "-", int32_t(0x00000000), int32_t(0x26DFADEF)},
    {"ice0142.des", "", int32_t(0x00000000), int32_t(0x87A702DB)},
    {"ice0142.sno", "-", int32_t(0x00000000), int32_t(0xA04BDF41)},
    {"ice0143.des", "", int32_t(0x00000000), int32_t(0x4CFBD17E)},
    {"ice0143.sno", "-", int32_t(0x00000000), int32_t(0x6B170CE4)},
    {"ice0144.des", "", int32_t(0x00000000), int32_t(0x51FEE1C6)},
    {"ice0144.sno", "-", int32_t(0x00000000), int32_t(0x76123C5C)},
    {"ice0145.des", "", int32_t(0x00000000), int32_t(0x9AA23263)},
    {"ice0145.sno", "-", int32_t(0x00000000), int32_t(0xBD4EEFF9)},
    {"ice0146.des", "", int32_t(0x00000000), int32_t(0x1C3640CD)},
    {"ice0146.sno", "-", int32_t(0x00000000), int32_t(0x3BDA9D57)},
    {"ice0147.des", "", int32_t(0x00000000), int32_t(0xD76A9368)},
    {"ice0147.sno", "-", int32_t(0x00000000), int32_t(0xF0864EF2)},
    {"ice0148.des", "", int32_t(0x00000000), int32_t(0x263C21BD)},
    {"ice0148.sno", "-", int32_t(0x00000000), int32_t(0x01D0FC27)},
    {"ice0149.des", "", int32_t(0x00000000), int32_t(0xED60F218)},
    {"ice0149.sno", "-", int32_t(0x00000000), int32_t(0xCA8C2F82)},
    {"ice0150.des", "", int32_t(0x00000000), int32_t(0x6C18A864)},
    {"ice0150.sno", "-", int32_t(0x00000000), int32_t(0x4BF475FE)},
    {"ice0151.des", "", int32_t(0x00000000), int32_t(0xA7447BC1)},
    {"ice0151.sno", "-", int32_t(0x00000000), int32_t(0x80A8A65B)},
    {"ice0152.des", "", int32_t(0x00000000), int32_t(0x21D0096F)},
    {"ice0152.sno", "-", int32_t(0x00000000), int32_t(0x063CD4F5)},
    {"ice0153.des", "", int32_t(0x00000000), int32_t(0xEA8CDACA)},
    {"ice0153.sno", "-", int32_t(0x00000000), int32_t(0xCD600750)},
    {"ice0154.des", "", int32_t(0x00000000), int32_t(0xF789EA72)},
    {"ice0154.sno", "-", int32_t(0x00000000), int32_t(0xD06537E8)},
    {"ice0155.des", "", int32_t(0x00000000), int32_t(0x3CD539D7)},
    {"ice0155.sno", "-", int32_t(0x00000000), int32_t(0x1B39E44D)},
    {"ice0156.des", "", int32_t(0x00000000), int32_t(0xBA414B79)},
    {"ice0156.sno", "-", int32_t(0x00000000), int32_t(0x9DAD96E3)},
    {"ice0157.des", "", int32_t(0x00000000), int32_t(0x711D98DC)},
    {"ice0157.sno", "-", int32_t(0x00000000), int32_t(0x56F14546)},
    {"ice0158.des", "", int32_t(0x00000000), int32_t(0x804B2A09)},
    {"ice0158.sno", "-", int32_t(0x00000000), int32_t(0xA7A7F793)},
    {"ice0159.des", "", int32_t(0x00000000), int32_t(0x4B17F9AC)},
    {"ice0159.sno", "-", int32_t(0x00000000), int32_t(0x6CFB2436)},
    {"ice0160.des", "", int32_t(0x00000000), int32_t(0x5DF0B2F9)},
    {"ice0160.sno", "-", int32_t(0x00000000), int32_t(0x7A1C6F63)},
    {"ice0161.des", "", int32_t(0x00000000), int32_t(0x96AC615C)},
    {"ice0161.sno", "-", int32_t(0x00000000), int32_t(0xB140BCC6)},
    {"ice0162.des", "", int32_t(0x00000000), int32_t(0x103813F2)},
    {"ice0162.sno", "-", int32_t(0x00000000), int32_t(0x37D4CE68)},
    {"ice0163.des", "", int32_t(0x00000000), int32_t(0xDB64C057)},
    {"ice0163.sno", "-", int32_t(0x00000000), int32_t(0xFC881DCD)},
    {"ice0164.des", "", int32_t(0x00000000), int32_t(0xC661F0EF)},
    {"ice0164.sno", "-", int32_t(0x00000000), int32_t(0xE18D2D75)},
    {"ice02.sno", "misc: ice floe", int32_t(0x5DBB69D8), int32_t(0x00000000)},
    {"ice02.tem", "misc: ice floe", int32_t(0x4BBD69D6), int32_t(0x00000000)},
    {"ice0201.des", "", int32_t(0x00000000), int32_t(0x7BF35385)},
    {"ice0201.sno", "-", int32_t(0x00000000), int32_t(0x5C1F8E1F)},
    {"ice0202.des", "", int32_t(0x00000000), int32_t(0xFD67212B)},
    {"ice0202.sno", "-", int32_t(0x00000000), int32_t(0xDA8BFCB1)},
    {"ice0203.des", "", int32_t(0x00000000), int32_t(0x363BF28E)},
    {"ice0203.sno", "-", int32_t(0x00000000), int32_t(0x11D72F14)},
    {"ice0204.des", "", int32_t(0x00000000), int32_t(0x2B3EC236)},
    {"ice0204.sno", "-", int32_t(0x00000000), int32_t(0x0CD21FAC)},
    {"ice0205.des", "", int32_t(0x00000000), int32_t(0xE0621193)},
    {"ice0205.sno", "-", int32_t(0x00000000), int32_t(0xC78ECC09)},
    {"ice0206.des", "", int32_t(0x00000000), int32_t(0x66F6633D)},
    {"ice0206.sno", "-", int32_t(0x00000000), int32_t(0x411ABEA7)},
    {"ice0207.des", "", int32_t(0x00000000), int32_t(0xADAAB098)},
    {"ice0207.sno", "-", int32_t(0x00000000), int32_t(0x8A466D02)},
    {"ice0208.des", "", int32_t(0x00000000), int32_t(0x5CFC024D)},
    {"ice0208.sno", "-", int32_t(0x00000000), int32_t(0x7B10DFD7)},
    {"ice0209.des", "", int32_t(0x00000000), int32_t(0x97A0D1E8)},
    {"ice0209.sno", "-", int32_t(0x00000000), int32_t(0xB04C0C72)},
    {"ice0210.des", "", int32_t(0x00000000), int32_t(0x16D88B94)},
    {"ice0210.sno", "-", int32_t(0x00000000), int32_t(0x3134560E)},
    {"ice0211.des", "", int32_t(0x00000000), int32_t(0xDD845831)},
    {"ice0211.sno", "-", int32_t(0x00000000), int32_t(0xFA6885AB)},
    {"ice0212.des", "", int32_t(0x00000000), int32_t(0x5B102A9F)},
    {"ice0212.sno", "-", int32_t(0x00000000), int32_t(0x7CFCF705)},
    {"ice0213.des", "", int32_t(0x00000000), int32_t(0x904CF93A)},
    {"ice0213.sno", "-", int32_t(0x00000000), int32_t(0xB7A024A0)},
    {"ice0214.des", "", int32_t(0x00000000), int32_t(0x8D49C982)},
    {"ice0214.sno", "-", int32_t(0x00000000), int32_t(0xAAA51418)},
    {"ice0215.des", "", int32_t(0x00000000), int32_t(0x46151A27)},
    {"ice0215.sno", "-", int32_t(0x00000000), int32_t(0x61F9C7BD)},
    {"ice0216.des", "", int32_t(0x00000000), int32_t(0xC0816889)},
    {"ice0216.sno", "-", int32_t(0x00000000), int32_t(0xE76DB513)},
    {"ice0217.des", "", int32_t(0x00000000), int32_t(0x0BDDBB2C)},
    {"ice0217.sno", "-", int32_t(0x00000000), int32_t(0x2C3166B6)},
    {"ice0218.des", "", int32_t(0x00000000), int32_t(0xFA8B09F9)},
    {"ice0218.sno", "-", int32_t(0x00000000), int32_t(0xDD67D463)},
    {"ice0219.des", "", int32_t(0x00000000), int32_t(0x31D7DA5C)},
    {"ice0219.sno", "-", int32_t(0x00000000), int32_t(0x163B07C6)},
    {"ice0220.des", "", int32_t(0x00000000), int32_t(0x27309109)},
    {"ice0220.sno", "-", int32_t(0x00000000), int32_t(0x00DC4C93)},
    {"ice0221.des", "", int32_t(0x00000000), int32_t(0xEC6C42AC)},
    {"ice0221.sno", "-", int32_t(0x00000000), int32_t(0xCB809F36)},
    {"ice0222.des", "", int32_t(0x00000000), int32_t(0x6AF83002)},
    {"ice0222.sno", "-", int32_t(0x00000000), int32_t(0x4D14ED98)},
    {"ice0223.des", "", int32_t(0x00000000), int32_t(0xA1A4E3A7)},
    {"ice0223.sno", "-", int32_t(0x00000000), int32_t(0x86483E3D)},
    {"ice0224.des", "", int32_t(0x00000000), int32_t(0xBCA1D31F)},
    {"ice0224.sno", "-", int32_t(0x00000000), int32_t(0x9B4D0E85)},
    {"ice0225.des", "", int32_t(0x00000000), int32_t(0x77FD00BA)},
    {"ice0225.sno", "-", int32_t(0x00000000), int32_t(0x5011DD20)},
    {"ice0226.des", "", int32_t(0x00000000), int32_t(0xF1697214)},
    {"ice0226.sno", "-", int32_t(0x00000000), int32_t(0xD685AF8E)},
    {"ice0227.des", "", int32_t(0x00000000), int32_t(0x3A35A1B1)},
    {"ice0227.sno", "-", int32_t(0x00000000), int32_t(0x1DD97C2B)},
    {"ice0228.des", "", int32_t(0x00000000), int32_t(0xCB631364)},
    {"ice0228.sno", "-", int32_t(0x00000000), int32_t(0xEC8FCEFE)},
    {"ice0229.des", "", int32_t(0x00000000), int32_t(0x003FC0C1)},
    {"ice0229.sno", "-", int32_t(0x00000000), int32_t(0x27D31D5B)},
    {"ice0230.des", "", int32_t(0x00000000), int32_t(0x81479ABD)},
    {"ice0230.sno", "-", int32_t(0x00000000), int32_t(0xA6AB4727)},
    {"ice0231.des", "", int32_t(0x00000000), int32_t(0x4A1B4918)},
    {"ice0231.sno", "-", int32_t(0x00000000), int32_t(0x6DF79482)},
    {"ice0232.des", "", int32_t(0x00000000), int32_t(0xCC8F3BB6)},
    {"ice0232.sno", "-", int32_t(0x00000000), int32_t(0xEB63E62C)},
    {"ice0233.des", "", int32_t(0x00000000), int32_t(0x07D3E813)},
    {"ice0233.sno", "-", int32_t(0x00000000), int32_t(0x203F3589)},
    {"ice0234.des", "", int32_t(0x00000000), int32_t(0x1AD6D8AB)},
    {"ice0234.sno", "-", int32_t(0x00000000), int32_t(0x3D3A0531)},
    {"ice0235.des", "", int32_t(0x00000000), int32_t(0xD18A0B0E)},
    {"ice0235.sno", "-", int32_t(0x00000000), int32_t(0xF666D694)},
    {"ice0236.des", "", int32_t(0x00000000), int32_t(0x571E79A0)},
    {"ice0236.sno", "-", int32_t(0x00000000), int32_t(0x70F2A43A)},
    {"ice0237.des", "", int32_t(0x00000000), int32_t(0x9C42AA05)},
    {"ice0237.sno", "-", int32_t(0x00000000), int32_t(0xBBAE779F)},
    {"ice0238.des", "", int32_t(0x00000000), int32_t(0x6D1418D0)},
    {"ice0238.sno", "-", int32_t(0x00000000), int32_t(0x4AF8C54A)},
    {"ice0239.des", "", int32_t(0x00000000), int32_t(0xA648CB75)},
    {"ice0239.sno", "-", int32_t(0x00000000), int32_t(0x81A416EF)},
    {"ice0240.des", "", int32_t(0x00000000), int32_t(0x44E0A433)},
    {"ice0240.sno", "-", int32_t(0x00000000), int32_t(0x630C79A9)},
    {"ice0241.des", "", int32_t(0x00000000), int32_t(0x8FBC7796)},
    {"ice0241.sno", "-", int32_t(0x00000000), int32_t(0xA850AA0C)},
    {"ice0242.des", "", int32_t(0x00000000), int32_t(0x09280538)},
    {"ice0242.sno", "-", int32_t(0x00000000), int32_t(0x2EC4D8A2)},
    {"ice0243.des", "", int32_t(0x00000000), int32_t(0xC274D69D)},
    {"ice0243.sno", "-", int32_t(0x00000000), int32_t(0xE5980B07)},
    {"ice0244.des", "", int32_t(0x00000000), int32_t(0xDF71E625)},
    {"ice0244.sno", "-", int32_t(0x00000000), int32_t(0xF89D3BBF)},
    {"ice0245.des", "", int32_t(0x00000000), int32_t(0x142D3580)},
    {"ice0245.sno", "-", int32_t(0x00000000), int32_t(0x33C1E81A)},
    {"ice0246.des", "", int32_t(0x00000000), int32_t(0x92B9472E)},
    {"ice0246.sno", "-", int32_t(0x00000000), int32_t(0xB5559AB4)},
    {"ice0247.des", "", int32_t(0x00000000), int32_t(0x59E5948B)},
    {"ice0247.sno", "-", int32_t(0x00000000), int32_t(0x7E094911)},
    {"ice0248.des", "", int32_t(0x00000000), int32_t(0xA8B3265E)},
    {"ice0248.sno", "-", int32_t(0x00000000), int32_t(0x8F5FFBC4)},
    {"ice0249.des", "", int32_t(0x00000000), int32_t(0x63EFF5FB)},
    {"ice0249.sno", "-", int32_t(0x00000000), int32_t(0x44032861)},
    {"ice0250.des", "", int32_t(0x00000000), int32_t(0xE297AF87)},
    {"ice0250.sno", "-", int32_t(0x00000000), int32_t(0xC57B721D)},
    {"ice0251.des", "", int32_t(0x00000000), int32_t(0x29CB7C22)},
    {"ice0251.sno", "-", int32_t(0x00000000), int32_t(0x0E27A1B8)},
    {"ice0252.des", "", int32_t(0x00000000), int32_t(0xAF5F0E8C)},
    {"ice0252.sno", "-", int32_t(0x00000000), int32_t(0x88B3D316)},
    {"ice0253.des", "", int32_t(0x00000000), int32_t(0x6403DD29)},
    {"ice0253.sno", "-", int32_t(0x00000000), int32_t(0x43EF00B3)},
    {"ice0254.des", "", int32_t(0x00000000), int32_t(0x7906ED91)},
    {"ice0254.sno", "-", int32_t(0x00000000), int32_t(0x5EEA300B)},
    {"ice0255.des", "", int32_t(0x00000000), int32_t(0xB25A3E34)},
    {"ice0255.sno", "-", int32_t(0x00000000), int32_t(0x95B6E3AE)},
    {"ice0256.des", "", int32_t(0x00000000), int32_t(0x34CE4C9A)},
    {"ice0256.sno", "-", int32_t(0x00000000), int32_t(0x13229100)},
    {"ice0257.des", "", int32_t(0x00000000), int32_t(0xFF929F3F)},
    {"ice0257.sno", "-", int32_t(0x00000000), int32_t(0xD87E42A5)},
    {"ice0258.des", "", int32_t(0x00000000), int32_t(0x0EC42DEA)},
    {"ice0258.sno", "-", int32_t(0x00000000), int32_t(0x2928F070)},
    {"ice0259.des", "", int32_t(0x00000000), int32_t(0xC598FE4F)},
    {"ice0259.sno", "-", int32_t(0x00000000), int32_t(0xE27423D5)},
    {"ice0260.des", "", int32_t(0x00000000), int32_t(0xD37FB51A)},
    {"ice0260.sno", "-", int32_t(0x00000000), int32_t(0xF4936880)},
    {"ice0261.des", "", int32_t(0x00000000), int32_t(0x182366BF)},
    {"ice0261.sno", "-", int32_t(0x00000000), int32_t(0x3FCFBB25)},
    {"ice0262.des", "", int32_t(0x00000000), int32_t(0x9EB71411)},
    {"ice0262.sno", "-", int32_t(0x00000000), int32_t(0xB95BC98B)},
    {"ice0263.des", "", int32_t(0x00000000), int32_t(0x55EBC7B4)},
    {"ice0263.sno", "-", int32_t(0x00000000), int32_t(0x72071A2E)},
    {"ice0264.des", "", int32_t(0x00000000), int32_t(0x48EEF70C)},
    {"ice0264.sno", "-", int32_t(0x00000000), int32_t(0x6F022A96)},
    {"ice03.sno", "misc: ice floe", int32_t(0x5DBB69DA), int32_t(0x00000000)},
    {"ice03.tem", "misc: ice floe", int32_t(0x4BBD69D8), int32_t(0x00000000)},
    {"ice0301.des", "", int32_t(0x00000000), int32_t(0xB759531B)},
    {"ice0301.sno", "-", int32_t(0x00000000), int32_t(0x90B58E81)},
    {"ice0302.des", "", int32_t(0x00000000), int32_t(0x31CD21B5)},
    {"ice0302.sno", "-", int32_t(0x00000000), int32_t(0x1621FC2F)},
    {"ice0303.des", "", int32_t(0x00000000), int32_t(0xFA91F210)},
    {"ice0303.sno", "-", int32_t(0x00000000), int32_t(0xDD7D2F8A)},
    {"ice0304.des", "", int32_t(0x00000000), int32_t(0xE794C2A8)},
    {"ice0304.sno", "-", int32_t(0x00000000), int32_t(0xC0781F32)},
    {"ice0305.des", "", int32_t(0x00000000), int32_t(0x2CC8110D)},
    {"ice0305.sno", "-", int32_t(0x00000000), int32_t(0x0B24CC97)},
    {"ice0306.des", "", int32_t(0x00000000), int32_t(0xAA5C63A3)},
    {"ice0306.sno", "-", int32_t(0x00000000), int32_t(0x8DB0BE39)},
    {"ice0307.des", "", int32_t(0x00000000), int32_t(0x6100B006)},
    {"ice0307.sno", "-", int32_t(0x00000000), int32_t(0x46EC6D9C)},
    {"ice0308.des", "", int32_t(0x00000000), int32_t(0x905602D3)},
    {"ice0308.sno", "-", int32_t(0x00000000), int32_t(0xB7BADF49)},
    {"ice0309.des", "", int32_t(0x00000000), int32_t(0x5B0AD176)},
    {"ice0309.sno", "-", int32_t(0x00000000), int32_t(0x7CE60CEC)},
    {"ice0310.des", "", int32_t(0x00000000), int32_t(0xDA728B0A)},
    {"ice0310.sno", "-", int32_t(0x00000000), int32_t(0xFD9E5690)},
    {"ice0311.des", "", int32_t(0x00000000), int32_t(0x112E58AF)},
    {"ice0311.sno", "-", int32_t(0x00000000), int32_t(0x36C28535)},
    {"ice0312.des", "", int32_t(0x00000000), int32_t(0x97BA2A01)},
    {"ice0312.sno", "-", int32_t(0x00000000), int32_t(0xB056F79B)},
    {"ice0313.des", "", int32_t(0x00000000), int32_t(0x5CE6F9A4)},
    {"ice0313.sno", "-", int32_t(0x00000000), int32_t(0x7B0A243E)},
    {"ice0314.des", "", int32_t(0x00000000), int32_t(0x41E3C91C)},
    {"ice0314.sno", "-", int32_t(0x00000000), int32_t(0x660F1486)},
    {"ice0315.des", "", int32_t(0x00000000), int32_t(0x8ABF1AB9)},
    {"ice0315.sno", "-", int32_t(0x00000000), int32_t(0xAD53C723)},
    {"ice0316.des", "", int32_t(0x00000000), int32_t(0x0C2B6817)},
    {"ice0316.sno", "-", int32_t(0x00000000), int32_t(0x2BC7B58D)},
    {"ice0317.des", "", int32_t(0x00000000), int32_t(0xC777BBB2)},
    {"ice0317.sno", "-", int32_t(0x00000000), int32_t(0xE09B6628)},
    {"ice0318.des", "", int32_t(0x00000000), int32_t(0x36210967)},
    {"ice0318.sno", "-", int32_t(0x00000000), int32_t(0x11CDD4FD)},
    {"ice0319.des", "", int32_t(0x00000000), int32_t(0xFD7DDAC2)},
    {"ice0319.sno", "-", int32_t(0x00000000), int32_t(0xDA910758)},
    {"ice0320.des", "", int32_t(0x00000000), int32_t(0xEB9A9197)},
    {"ice0320.sno", "-", int32_t(0x00000000), int32_t(0xCC764C0D)},
    {"ice0321.des", "", int32_t(0x00000000), int32_t(0x20C64232)},
    {"ice0321.sno", "-", int32_t(0x00000000), int32_t(0x072A9FA8)},
    {"ice0322.des", "", int32_t(0x00000000), int32_t(0xA652309C)},
    {"ice0322.sno", "-", int32_t(0x00000000), int32_t(0x81BEED06)},
    {"ice0323.des", "", int32_t(0x00000000), int32_t(0x6D0EE339)},
    {"ice0323.sno", "-", int32_t(0x00000000), int32_t(0x4AE23EA3)},
    {"ice0324.des", "", int32_t(0x00000000), int32_t(0x700BD381)},
    {"ice0324.sno", "-", int32_t(0x00000000), int32_t(0x57E70E1B)},
    {"ice0325.des", "", int32_t(0x00000000), int32_t(0xBB570024)},
    {"ice0325.sno", "-", int32_t(0x00000000), int32_t(0x9CBBDDBE)},
    {"ice0326.des", "", int32_t(0x00000000), int32_t(0x3DC3728A)},
    {"ice0326.sno", "-", int32_t(0x00000000), int32_t(0x1A2FAF10)},
    {"ice0327.des", "", int32_t(0x00000000), int32_t(0xF69FA12F)},
    {"ice0327.sno", "-", int32_t(0x00000000), int32_t(0xD1737CB5)},
    {"ice0328.des", "", int32_t(0x00000000), int32_t(0x07C913FA)},
    {"ice0328.sno", "-", int32_t(0x00000000), int32_t(0x2025CE60)},
    {"ice0329.des", "", int32_t(0x00000000), int32_t(0xCC95C05F)},
    {"ice0329.sno", "-", int32_t(0x00000000), int32_t(0xEB791DC5)},
    {"ice0330.des", "", int32_t(0x00000000), int32_t(0x4DED9A23)},
    {"ice0330.sno", "-", int32_t(0x00000000), int32_t(0x6A0147B9)},
    {"ice0331.des", "", int32_t(0x00000000), int32_t(0x86B14986)},
    {"ice0331.sno", "-", int32_t(0x00000000), int32_t(0xA15D941C)},
    {"ice0332.des", "", int32_t(0x00000000), int32_t(0x00253B28)},
    {"ice0332.sno", "-", int32_t(0x00000000), int32_t(0x27C9E6B2)},
    {"ice0333.des", "", int32_t(0x00000000), int32_t(0xCB79E88D)},
    {"ice0333.sno", "-", int32_t(0x00000000), int32_t(0xEC953517)},
    {"ice0334.des", "", int32_t(0x00000000), int32_t(0xD67CD835)},
    {"ice0334.sno", "-", int32_t(0x00000000), int32_t(0xF19005AF)},
    {"ice0335.des", "", int32_t(0x00000000), int32_t(0x1D200B90)},
    {"ice0335.sno", "-", int32_t(0x00000000), int32_t(0x3ACCD60A)},
    {"ice0336.des", "", int32_t(0x00000000), int32_t(0x9BB4793E)},
    {"ice0336.sno", "-", int32_t(0x00000000), int32_t(0xBC58A4A4)},
    {"ice0337.des", "", int32_t(0x00000000), int32_t(0x50E8AA9B)},
    {"ice0337.sno", "-", int32_t(0x00000000), int32_t(0x77047701)},
    {"ice0338.des", "", int32_t(0x00000000), int32_t(0xA1BE184E)},
    {"ice0338.sno", "-", int32_t(0x00000000), int32_t(0x8652C5D4)},
    {"ice0339.des", "", int32_t(0x00000000), int32_t(0x6AE2CBEB)},
    {"ice0339.sno", "-", int32_t(0x00000000), int32_t(0x4D0E1671)},
    {"ice0340.des", "", int32_t(0x00000000), int32_t(0x884AA4AD)},
    {"ice0340.sno", "-", int32_t(0x00000000), int32_t(0xAFA67937)},
    {"ice0341.des", "", int32_t(0x00000000), int32_t(0x43167708)},
    {"ice0341.sno", "-", int32_t(0x00000000), int32_t(0x64FAAA92)},
    {"ice0342.des", "", int32_t(0x00000000), int32_t(0xC58205A6)},
    {"ice0342.sno", "-", int32_t(0x00000000), int32_t(0xE26ED83C)},
    {"ice0343.des", "", int32_t(0x00000000), int32_t(0x0EDED603)},
    {"ice0343.sno", "-", int32_t(0x00000000), int32_t(0x29320B99)},
    {"ice0344.des", "", int32_t(0x00000000), int32_t(0x13DBE6BB)},
    {"ice0344.sno", "-", int32_t(0x00000000), int32_t(0x34373B21)},
    {"ice0345.des", "", int32_t(0x00000000), int32_t(0xD887351E)},
    {"ice0345.sno", "-", int32_t(0x00000000), int32_t(0xFF6BE884)},
    {"ice0346.des", "", int32_t(0x00000000), int32_t(0x5E1347B0)},
    {"ice0346.sno", "-", int32_t(0x00000000), int32_t(0x79FF9A2A)},
    {"ice0347.des", "", int32_t(0x00000000), int32_t(0x954F9415)},
    {"ice0347.sno", "-", int32_t(0x00000000), int32_t(0xB2A3498F)},
    {"ice0348.des", "", int32_t(0x00000000), int32_t(0x641926C0)},
    {"ice0348.sno", "-", int32_t(0x00000000), int32_t(0x43F5FB5A)},
    {"ice0349.des", "", int32_t(0x00000000), int32_t(0xAF45F565)},
    {"ice0349.sno", "-", int32_t(0x00000000), int32_t(0x88A928FF)},
    {"ice0350.des", "", int32_t(0x00000000), int32_t(0x2E3DAF19)},
    {"ice0350.sno", "-", int32_t(0x00000000), int32_t(0x09D17283)},
    {"ice0351.des", "", int32_t(0x00000000), int32_t(0xE5617CBC)},
    {"ice0351.sno", "-", int32_t(0x00000000), int32_t(0xC28DA126)},
    {"ice0352.des", "", int32_t(0x00000000), int32_t(0x63F50E12)},
    {"ice0352.sno", "-", int32_t(0x00000000), int32_t(0x4419D388)},
    {"ice0353.des", "", int32_t(0x00000000), int32_t(0xA8A9DDB7)},
    {"ice0353.sno", "-", int32_t(0x00000000), int32_t(0x8F45002D)},
    {"ice0354.des", "", int32_t(0x00000000), int32_t(0xB5ACED0F)},
    {"ice0354.sno", "-", int32_t(0x00000000), int32_t(0x92403095)},
    {"ice0355.des", "", int32_t(0x00000000), int32_t(0x7EF03EAA)},
    {"ice0355.sno", "-", int32_t(0x00000000), int32_t(0x591CE330)},
    {"ice0356.des", "", int32_t(0x00000000), int32_t(0xF8644C04)},
    {"ice0356.sno", "-", int32_t(0x00000000), int32_t(0xDF88919E)},
    {"ice0357.des", "", int32_t(0x00000000), int32_t(0x33389FA1)},
    {"ice0357.sno", "-", int32_t(0x00000000), int32_t(0x14D4423B)},
    {"ice0358.des", "", int32_t(0x00000000), int32_t(0xC26E2D74)},
    {"ice0358.sno", "-", int32_t(0x00000000), int32_t(0xE582F0EE)},
    {"ice0359.des", "", int32_t(0x00000000), int32_t(0x0932FED1)},
    {"ice0359.sno", "-", int32_t(0x00000000), int32_t(0x2EDE234B)},
    {"ice0360.des", "", int32_t(0x00000000), int32_t(0x1FD5B584)},
    {"ice0360.sno", "-", int32_t(0x00000000), int32_t(0x3839681E)},
    {"ice0361.des", "", int32_t(0x00000000), int32_t(0xD4896621)},
    {"ice0361.sno", "-", int32_t(0x00000000), int32_t(0xF365BBBB)},
    {"ice0362.des", "", int32_t(0x00000000), int32_t(0x521D148F)},
    {"ice0362.sno", "-", int32_t(0x00000000), int32_t(0x75F1C915)},
    {"ice0363.des", "", int32_t(0x00000000), int32_t(0x9941C72A)},
    {"ice0363.sno", "-", int32_t(0x00000000), int32_t(0xBEAD1AB0)},
    {"ice0364.des", "", int32_t(0x00000000), int32_t(0x8444F792)},
    {"ice0364.sno", "-", int32_t(0x00000000), int32_t(0xA3A82A08)},
    {"ice04.sno", "misc: ice floe", int32_t(0x5DBB69DC), int32_t(0x00000000)},
    {"ice04.tem", "misc: ice floe", int32_t(0x4BBD69DA), int32_t(0x00000000)},
    {"ice05.sno", "misc: ice floe", int32_t(0x5DBB69DE), int32_t(0x00000000)},
    {"ice05.tem", "misc: ice floe", int32_t(0x4BBD69DC), int32_t(0x00000000)},
    {"icecliff.ini", "", int32_t(0x00000000), int32_t(0xF97691AB)},
    {"icecliff.map", "-", int32_t(0x00000000), int32_t(0x1D8C8D78)},
    {"icecrak1.aud", "ice crack", int32_t(0x00000000), int32_t(0x8D50354B)},
    {"icecrak2.aud", "ice crack", int32_t(0x00000000), int32_t(0xCAF04F9B)},
    {"icecrak3.aud", "ice crack", int32_t(0x00000000), int32_t(0xF790662B)},
    {"icemust.ini", "", int32_t(0x00000000), int32_t(0x0C44DBD3)},
    {"icemust.map", "-", int32_t(0x00000000), int32_t(0x137AA2A1)},
    {"iceplod1.aud", "", int32_t(0xE7F2ECEB), int32_t(0x00000000)},
    {"iceskate.vqa", "-", int32_t(0x00000000), int32_t(0xB1D92F05)},
    {"icewalk1.aud", "", int32_t(0x0400E6D5), int32_t(0x00000000)},
    {"icewalk2.aud", "", int32_t(0x0600E6D5), int32_t(0x00000000)},
    {"icewalk3.aud", "", int32_t(0x0800E6D5), int32_t(0x00000000)},
    {"icewalk4.aud", "", int32_t(0x0A00E6D5), int32_t(0x00000000)},
    {"icewalk5.aud", "", int32_t(0x0C00E6D5), int32_t(0x00000000)},
    {"icewalk6.aud", "", int32_t(0x0E00E6D5), int32_t(0x00000000)},
    {"icewalk7.aud", "", int32_t(0x1000E6D5), int32_t(0x00000000)},
    {"ima.aud", "", int32_t(0x5CC6EFD3), int32_t(0x00000000)},
    {"imp1app1.aud", "", int32_t(0x6C3716D5), int32_t(0x00000000)},
    {"impappr2.aud", "", int32_t(0xAE3B16F3), int32_t(0x00000000)},
    {"impclaw1.aud", "", int32_t(0xB444F8EB), int32_t(0x00000000)},
    {"impicon.flc", "", int32_t(0x82211FF1), int32_t(0x00000000)},
    {"impswd1.aud", "", int32_t(0xA9E81314), int32_t(0x00000000)},
    {"in.vqa", "", int32_t(0xAC5CDDE3), int32_t(0x00000000)},
    {"in_cavtwig1.aud", "", int32_t(0xD4F2AF22), int32_t(0x00000000)},
    {"income1.aud", "incoming missile", int32_t(0x99B41900), int32_t(0x00000000)},
    {"ind.aud", "industrial", int32_t(0x5CCCF1D3), int32_t(0x00000000)},
    {"ind2.aud", "canyon chase", int32_t(0xA8DDDDC0), int32_t(0x00000000)},
    {"indeep.aud", "", int32_t(0x00000000), int32_t(0xE99FB581)},
    {"indeep.wav", "", int32_t(0x00000000), int32_t(0xDC3CB408)},
    {"index.dat", "", int32_t(0x97999629), int32_t(0x00000000)},
    {"indflut1.aud", "", int32_t(0xC00F24EB), int32_t(0x00000000)},
    {"indpicon.shp", "", int32_t(0x00000000), int32_t(0x9002ABE5)},
    {"industro.wav", "", int32_t(0x00000000), int32_t(0x2817EF5C)},
    {"indxplod.aud", "", int32_t(0x2E0512F3), int32_t(0x00000000)},
    {"infdie.shp", "-", int32_t(0x00000000), int32_t(0x5822FB0C)},
    {"inferno.vqa", "flame tank torching village", int32_t(0x71F9271F), int32_t(0x00000000)},
    {"inferno.vqp", "flame tank torching village", int32_t(0x7208271F), int32_t(0x00000000)},
    {"infgun3.aud", "infantry gun", int32_t(0x00000000), int32_t(0xCA587F96)},
    {"infiltra.aud", "-", int32_t(0x00000000), int32_t(0xB9016A3D)},
    {"infrared.aud", "infrared", int32_t(0x00000000), int32_t(0xB9722B29)},
    {"infshdw.shp", "", int32_t(0x00000000), int32_t(0x2B9F2271)},
    {"infxicon.shp", "icon: invulnerability", int32_t(0x4E0012E5), int32_t(0x00000000)},
    {"init.shp", "", int32_t(0x00000000), int32_t(0xDFDCE639)},
    {"initicon.shp", "", int32_t(0x00000000), int32_t(0x38107159)},
    {"inituico.shp", "", int32_t(0x00000000), int32_t(0xFDD6E3B8)},
    {"insd01_e.vqa", "", int32_t(0xDD5CF1B3), int32_t(0x00000000)},
    {"insd02_e.vqa", "", int32_t(0xDD5CF3B3), int32_t(0x00000000)},
    {"insites.vqa", "sam site shooting plane", int32_t(0x82351523), int32_t(0x00000000)},
    {"insites.vqp", "sam site shooting plane", int32_t(0x82441523), int32_t(0x00000000)},
    {"inst.vqa", "", int32_t(0xE9F7F2C0), int32_t(0x00000000)},
    {"inst00.bmp", "", int32_t(0xD5A9E9D2), int32_t(0x00000000)},
    {"inst01.bmp", "", int32_t(0xD5A9EBD2), int32_t(0x00000000)},
    {"inst01.cps", "pict:", int32_t(0xD7A9EED5), int32_t(0x00000000)},
    {"inst01.wsa", "anim:", int32_t(0xFFA9DCD8), int32_t(0x00000000)},
    {"inst01w.cps", "pict:", int32_t(0xAE4EEBC8), int32_t(0x00000000)},
    {"inst01w.wsa", "anim:", int32_t(0xAE3CEEDC), int32_t(0x00000000)},
    {"inst02.aud", "", int32_t(0x00000000), int32_t(0x6FCFBB1A)},
    {"inst02.bmp", "", int32_t(0xD5A9EDD2), int32_t(0x00000000)},
    {"inst02.cps", "pict:", int32_t(0xD7A9F0D5), int32_t(0x00000000)},
    {"inst02.wsa", "anim:", int32_t(0xFFA9DED8), int32_t(0x00000000)},
    {"inst03.aud", "", int32_t(0x00000000), int32_t(0xC9B8B0AE)},
    {"inst03.bmp", "", int32_t(0xD5A9EFD2), int32_t(0x00000000)},
    {"inst03.cps", "pict:", int32_t(0xD7A9F2D5), int32_t(0x00000000)},
    {"inst03.wsa", "anim:", int32_t(0xFFA9E0D8), int32_t(0x00000000)},
    {"inst04.aud", "", int32_t(0x00000000), int32_t(0x0C1F8E20)},
    {"inst04.bmp", "", int32_t(0xD5A9F1D2), int32_t(0x00000000)},
    {"inst04.cps", "pict:", int32_t(0xD7A9F4D5), int32_t(0x00000000)},
    {"inst04.wsa", "anim:", int32_t(0xFFA9E2D8), int32_t(0x00000000)},
    {"inst05.aud", "", int32_t(0x00000000), int32_t(0xAA688594)},
    {"inst05.bmp", "", int32_t(0xD5A9F3D2), int32_t(0x00000000)},
    {"inst05.cps", "pict:", int32_t(0xD7A9F6D5), int32_t(0x00000000)},
    {"inst05.wsa", "anim:", int32_t(0xFFA9E4D8), int32_t(0x00000000)},
    {"inst06.aud", "", int32_t(0x00000000), int32_t(0x9B809F09)},
    {"inst06.bmp", "", int32_t(0xD5A9F5D2), int32_t(0x00000000)},
    {"inst06.cps", "pict:", int32_t(0xD7A9F8D5), int32_t(0x00000000)},
    {"inst06.wsa", "anim:", int32_t(0xFFA9E6D8), int32_t(0x00000000)},
    {"inst07.aud", "", int32_t(0x00000000), int32_t(0x3DF794BD)},
    {"inst07.bmp", "", int32_t(0xD5A9F7D2), int32_t(0x00000000)},
    {"inst07.cps", "pict:", int32_t(0xD7A9FAD5), int32_t(0x00000000)},
    {"inst07.wsa", "anim:", int32_t(0xFFA9E8D8), int32_t(0x00000000)},
    {"inst08.aud", "", int32_t(0x00000000), int32_t(0xCBBFE454)},
    {"inst08.bmp", "", int32_t(0xD5A9F9D2), int32_t(0x00000000)},
    {"inst08.cps", "pict:", int32_t(0xD7A9FCD5), int32_t(0x00000000)},
    {"inst08.wsa", "anim:", int32_t(0xFFA9EAD8), int32_t(0x00000000)},
    {"inst09.aud", "", int32_t(0x00000000), int32_t(0x6DC8EFE0)},
    {"inst09.bmp", "", int32_t(0xD5A9FBD2), int32_t(0x00000000)},
    {"inst09.cps", "pict:", int32_t(0xD7A9FED5), int32_t(0x00000000)},
    {"inst09.wsa", "anim:", int32_t(0xFFA9ECD8), int32_t(0x00000000)},
    {"inst10.aud", "", int32_t(0x00000000), int32_t(0x34FAAAAD)},
    {"inst10.bmp", "", int32_t(0xD5A9E9D4), int32_t(0x00000000)},
    {"inst11.aud", "", int32_t(0x00000000), int32_t(0x928DA119)},
    {"inst12.aud", "", int32_t(0x00000000), int32_t(0xA365BB84)},
    {"inst13.aud", "", int32_t(0x00000000), int32_t(0x0512B030)},
    {"inst14.aud", "", int32_t(0x00000000), int32_t(0xC0B58EBE)},
    {"inst15.aud", "", int32_t(0x00000000), int32_t(0x66C2850A)},
    {"inst16.aud", "", int32_t(0x00000000), int32_t(0x572A9F97)},
    {"instal1.aud", "audf:", int32_t(0xADF426E8), int32_t(0x00000000)},
    {"install.aud", "", int32_t(0xAE2A26E8), int32_t(0x00000000)},
    {"install.cps", "pict:", int32_t(0xAE3921EA), int32_t(0x00000000)},
    {"install.wsa", "anim:", int32_t(0xAE2724FE), int32_t(0x00000000)},
    {"install2.cps", "pict:", int32_t(0x093614D5), int32_t(0x00000000)},
    {"int.shp", "", int32_t(0x5CF8E4E5), int32_t(0x00000000)},
    {"interior.mix", "interior.mix", int32_t(0x123918F7), int32_t(0x00000000)},
    {"interior.pal", "pal: interior", int32_t(0x06311BF7), int32_t(0x00000000)},
    {"intolop1.aud", "", int32_t(0xE44718EB), int32_t(0x00000000)},
    {"intrface.shp", "", int32_t(0x24200EDF), int32_t(0x00000000)},
    {"intrfacg.shp", "", int32_t(0x28200EDF), int32_t(0x00000000)},
    {"intrgt_e.vqa", "", int32_t(0x156137E1), int32_t(0x00000000)},
    {"intrgt_f.vqa", "", int32_t(0x176137E1), int32_t(0x00000000)},
    {"intrgt_g.vqa", "", int32_t(0x196137E1), int32_t(0x00000000)},
    {"intrgt_i.vqa", "", int32_t(0x1D6137E1), int32_t(0x00000000)},
    {"intrgt_s.vqa", "", int32_t(0x316137E1), int32_t(0x00000000)},
    {"intro.aud", "menu music", int32_t(0xF3D39607), int32_t(0x15A29702)},
    {"intro.vqa", "-", int32_t(0x00000000), int32_t(0xC432F319)},
    {"intro2.vqa", "c&c intro movie", int32_t(0xF5ADDF14), int32_t(0x00000000)},
    {"intro2.vqp", "c&c intro movie", int32_t(0xF5ADEE14), int32_t(0x00000000)},
    {"intro_e.vqa", "", int32_t(0xA61D4919), int32_t(0x00000000)},
    {"intro_f.vqa", "", int32_t(0xA61F4919), int32_t(0x00000000)},
    {"intro_g.vqa", "", int32_t(0xA6214919), int32_t(0x00000000)},
    {"intro_i.vqa", "", int32_t(0xA6254919), int32_t(0x00000000)},
    {"intro_s.vqa", "", int32_t(0xA6394919), int32_t(0x00000000)},
    {"invasion.map", "", int32_t(0x00000000), int32_t(0x8693EB9C)},
    {"inviso.shp", "-", int32_t(0x00000000), int32_t(0xC7C8EF1E)},
    {"inviso2.aud", "", int32_t(0x82022D0C), int32_t(0x00000000)},
    {"invul2.aud", "flame turret up", int32_t(0xD7B5E212), int32_t(0x00000000)},
    {"invulbox.shp", "crat: iron curtain", int32_t(0x564010EA), int32_t(0x00000000)},
    {"invun.shp", "crat: heal all units", int32_t(0xE5FF9611), int32_t(0x00000000)},
    {"ion.ini", "-", int32_t(0x00000000), int32_t(0x8EBAEBCD)},
    {"ion1.aud", "ion cannon", int32_t(0xA6F1DFC0), int32_t(0xCF68EA77)},
    {"ion1.juv", "ion cannon", int32_t(0xB8F1E8C0), int32_t(0x00000000)},
    {"ionbeam.shp", "ion cannon beam", int32_t(0x00000000), int32_t(0x290DF0FC)},
    {"ionchrg1.aud", "ion cannon charging", int32_t(0xB41D22E3), int32_t(0x00000000)},
    {"ioncicon.shp", "icon: ion cannon", int32_t(0x00000000), int32_t(0xD3E39A58)},
    {"ionicnh.des", "icon: ion cannon", int32_t(0x821D1EEF), int32_t(0x00000000)},
    {"ionicnh.tem", "icon: ion cannon", int32_t(0x82171EFF), int32_t(0x00000000)},
    {"ionicnh.win", "icon: ion cannon", int32_t(0x82182302), int32_t(0x00000000)},
    {"ionicon.shp", "icon: ion cannon", int32_t(0x822623FE), int32_t(0x00000000)},
    {"ionredy1.aud", "ion cannon ready", int32_t(0xF04106DD), int32_t(0x00000000)},
    {"ionsfx.shp", "ion cannon discharge", int32_t(0xF3963DF9), int32_t(0x00000000)},
    {"ionstorm.aud",
     "ion storm ambient (no music track but ion storm sound)",
     int32_t(0x00000000),
     int32_t(0x5DC1324D)},
    {"iontest.vqa", "ion cannon test", int32_t(0xAE233505), int32_t(0x00000000)},
    {"iontest.vqp", "ion cannon test", int32_t(0xAE323505), int32_t(0x00000000)},
    {"ircricon.shp", "", int32_t(0x00000000), int32_t(0xF8C4CE16)},
    {"iris.shp", "", int32_t(0x00000000), int32_t(0xCD82CC93)},
    {"irisclse.aud", "", int32_t(0x00000000), int32_t(0x66C51A33)},
    {"irisopen.aud", "", int32_t(0x00000000), int32_t(0x334B2951)},
    {"iron.shp", "bldg: iron curtain", int32_t(0xECE6F7C0), int32_t(0x00000000)},
    {"ironblst.shp", "", int32_t(0x00000000), int32_t(0x5D6ABE81)},
    {"ironchg1.aud", "iron curtain charging", int32_t(0xE0211AD9), int32_t(0x00000000)},
    {"ironcur1.aud", "", int32_t(0xE03734D9), int32_t(0x00000000)},
    {"ironcur2.aud", "", int32_t(0xE23734D9), int32_t(0x00000000)},
    {"ironcur9.aud", "iron curtain sound", int32_t(0xF03734D9), int32_t(0x00000000)},
    {"ironfist.aud", "", int32_t(0x26391CDF), int32_t(0x00000000)},
    {"ironfx.shp", "", int32_t(0x00000000), int32_t(0x4ADCE3F6)},
    {"ironicon.shp", "icon: iron curtain", int32_t(0x262422E5), int32_t(0xA80C9FFD)},
    {"ironmake.shp", "make: iron curtain", int32_t(0x141C1EED), int32_t(0x00000000)},
    {"ironrdy1.aud", "iron curtain ready", int32_t(0xE04512F7), int32_t(0x00000000)},
    {"irtgrvlwlk6.aud", "", int32_t(0xF484D76C), int32_t(0x00000000)},
    {"ishat.img", "", int32_t(0x9FB3AA14), int32_t(0x00000000)},
    {"ishat.lmf", "", int32_t(0x9FB9AA13), int32_t(0x00000000)},
    {"ishat.lsv", "", int32_t(0xABB9AA23), int32_t(0x00000000)},
    {"ishat.odf", "", int32_t(0x8DBFAA13), int32_t(0x00000000)},
    {"ishat.pcx", "", int32_t(0x8BC1AA25), int32_t(0x00000000)},
    {"ishat.ver", "", int32_t(0x8FCDAA1F), int32_t(0x00000000)},
    {"ishore01.des", "", int32_t(0x00000000), int32_t(0x6A1C0548)},
    {"ishore01.sno", "-", int32_t(0x00000000), int32_t(0x84803539)},
    {"ishore01.tem", "-", int32_t(0x00000000), int32_t(0x8C359B5B)},
    {"ishore02.des", "", int32_t(0x00000000), int32_t(0x2DBC7F98)},
    {"ishore02.sno", "-", int32_t(0x00000000), int32_t(0xC3204FE9)},
    {"ishore02.tem", "-", int32_t(0x00000000), int32_t(0xCB95E18B)},
    {"ishore03.des", "", int32_t(0x00000000), int32_t(0x10DC5628)},
    {"ishore03.sno", "-", int32_t(0x00000000), int32_t(0xFE406659)},
    {"ishore03.tem", "-", int32_t(0x00000000), int32_t(0xF6F5C83B)},
    {"ishore04.des", "", int32_t(0x00000000), int32_t(0xA2FC8A38)},
    {"ishore04.sno", "-", int32_t(0x00000000), int32_t(0x4C60BA49)},
    {"ishore04.tem", "-", int32_t(0x00000000), int32_t(0x44D5142B)},
    {"ishore05.des", "", int32_t(0x00000000), int32_t(0x9F9CA388)},
    {"ishore05.sno", "-", int32_t(0x00000000), int32_t(0x710093F9)},
    {"ishore05.tem", "-", int32_t(0x00000000), int32_t(0x79B53D9B)},
    {"ishore06.des", "", int32_t(0x00000000), int32_t(0xD83CD958)},
    {"ishore06.sno", "-", int32_t(0x00000000), int32_t(0x36A0E929)},
    {"ishore06.tem", "-", int32_t(0x00000000), int32_t(0x3E15474B)},
    {"ishore07.des", "", int32_t(0x00000000), int32_t(0xE55CF0E8)},
    {"ishore07.sno", "-", int32_t(0x00000000), int32_t(0x0BC0C099)},
    {"ishore07.tem", "-", int32_t(0x00000000), int32_t(0x03756EFB)},
    {"ishore08.des", "", int32_t(0x00000000), int32_t(0x670C6739)},
    {"ishore08.sno", "-", int32_t(0x00000000), int32_t(0x89905748)},
    {"ishore08.tem", "-", int32_t(0x00000000), int32_t(0x8125F92A)},
    {"ishore09.des", "", int32_t(0x00000000), int32_t(0x5A6C4E89)},
    {"ishore09.sno", "-", int32_t(0x00000000), int32_t(0xB4F07EF8)},
    {"ishore09.tem", "-", int32_t(0x00000000), int32_t(0xBC45D09A)},
    {"ishore10.des", "", int32_t(0x00000000), int32_t(0x9C20FF5D)},
    {"ishore10.sno", "-", int32_t(0x00000000), int32_t(0x72BCCF2C)},
    {"ishore10.tem", "-", int32_t(0x00000000), int32_t(0x7A09614E)},
    {"ishore11.des", "", int32_t(0x00000000), int32_t(0xA140D6ED)},
    {"ishore11.sno", "-", int32_t(0x00000000), int32_t(0x4FDCE69C)},
    {"ishore11.tem", "-", int32_t(0x00000000), int32_t(0x476948FE)},
    {"ishore12.des", "", int32_t(0x00000000), int32_t(0xE6E0AC3D)},
    {"ishore12.sno", "-", int32_t(0x00000000), int32_t(0x087C9C4C)},
    {"ishore12.tem", "-", int32_t(0x00000000), int32_t(0x00C9322E)},
    {"ishore13.des", "", int32_t(0x00000000), int32_t(0xDB80858D)},
    {"ishore13.sno", "-", int32_t(0x00000000), int32_t(0x351CB5FC)},
    {"ishore13.tem", "-", int32_t(0x00000000), int32_t(0x3DA91B9E)},
    {"ishore14.des", "", int32_t(0x00000000), int32_t(0x69A0599D)},
    {"ishore14.sno", "-", int32_t(0x00000000), int32_t(0x873C69EC)},
    {"ishore14.tem", "-", int32_t(0x00000000), int32_t(0x8F89C78E)},
    {"ishore15.des", "", int32_t(0x00000000), int32_t(0x54C0702D)},
    {"ishore15.sno", "-", int32_t(0x00000000), int32_t(0xBA5C405C)},
    {"ishore15.tem", "-", int32_t(0x00000000), int32_t(0xB2E9EE3E)},
    {"ishore16.des", "", int32_t(0x00000000), int32_t(0x13600AFD)},
    {"ishore16.sno", "-", int32_t(0x00000000), int32_t(0xFDFC3A8C)},
    {"ishore16.tem", "-", int32_t(0x00000000), int32_t(0xF54994EE)},
    {"ishore17.des", "", int32_t(0x00000000), int32_t(0x2E00234D)},
    {"ishore17.sno", "-", int32_t(0x00000000), int32_t(0xC09C133C)},
    {"ishore17.tem", "-", int32_t(0x00000000), int32_t(0xC829BD5E)},
    {"ishore18.des", "", int32_t(0x00000000), int32_t(0xAC50B49C)},
    {"ishore18.sno", "-", int32_t(0x00000000), int32_t(0x42CC84ED)},
    {"ishore18.tem", "-", int32_t(0x00000000), int32_t(0x4A792A8F)},
    {"ishore19.des", "", int32_t(0x00000000), int32_t(0x91309D2C)},
    {"ishore19.sno", "-", int32_t(0x00000000), int32_t(0x7FACAD5D)},
    {"ishore19.tem", "-", int32_t(0x00000000), int32_t(0x7719033F)},
    {"ishore20.des", "", int32_t(0x00000000), int32_t(0x1AB48DF3)},
    {"ishore20.sno", "-", int32_t(0x00000000), int32_t(0xF428BD82)},
    {"ishore20.tem", "-", int32_t(0x00000000), int32_t(0xFC9D13E0)},
    {"ishore21.des", "", int32_t(0x00000000), int32_t(0x27D4A443)},
    {"ishore21.sno", "-", int32_t(0x00000000), int32_t(0xC9489432)},
    {"ishore21.tem", "-", int32_t(0x00000000), int32_t(0xC1FD3A50)},
    {"ishore22.des", "", int32_t(0x00000000), int32_t(0x6074DE93)},
    {"ishore22.sno", "-", int32_t(0x00000000), int32_t(0x8EE8EEE2)},
    {"ishore22.tem", "-", int32_t(0x00000000), int32_t(0x865D4080)},
    {"ishore23.des", "", int32_t(0x00000000), int32_t(0x5D14F723)},
    {"ishore23.sno", "-", int32_t(0x00000000), int32_t(0xB388C752)},
    {"ishore23.tem", "-", int32_t(0x00000000), int32_t(0xBB3D6930)},
    {"ishore24.des", "", int32_t(0x00000000), int32_t(0xEF342B33)},
    {"ishore24.sno", "-", int32_t(0x00000000), int32_t(0x01A81B42)},
    {"ishore24.tem", "-", int32_t(0x00000000), int32_t(0x091DB520)},
    {"ishore25.des", "", int32_t(0x00000000), int32_t(0xD2540283)},
    {"ishore25.sno", "-", int32_t(0x00000000), int32_t(0x3CC832F2)},
    {"ishore25.tem", "-", int32_t(0x00000000), int32_t(0x347D9C90)},
    {"ishore26.des", "", int32_t(0x00000000), int32_t(0x95F47853)},
    {"ishore26.sno", "-", int32_t(0x00000000), int32_t(0x7B684822)},
    {"ishore26.tem", "-", int32_t(0x00000000), int32_t(0x73DDE640)},
    {"ishore27.des", "", int32_t(0x00000000), int32_t(0xA89451E3)},
    {"ishore27.sno", "-", int32_t(0x00000000), int32_t(0x46086192)},
    {"ishore27.tem", "-", int32_t(0x00000000), int32_t(0x4EBDCFF0)},
    {"ishore28.des", "", int32_t(0x00000000), int32_t(0x2AC4C632)},
    {"ishore28.sno", "-", int32_t(0x00000000), int32_t(0xC458F643)},
    {"ishore28.tem", "-", int32_t(0x00000000), int32_t(0xCCED5821)},
    {"ishore29.des", "", int32_t(0x00000000), int32_t(0x17A4EF82)},
    {"ishore29.sno", "-", int32_t(0x00000000), int32_t(0xF938DFF3)},
    {"ishore29.tem", "-", int32_t(0x00000000), int32_t(0xF18D7191)},
    {"ishore30.des", "", int32_t(0x00000000), int32_t(0xD1E85E56)},
    {"ishore30.sno", "-", int32_t(0x00000000), int32_t(0x3F746E27)},
    {"ishore30.tem", "-", int32_t(0x00000000), int32_t(0x37C1C045)},
    {"ishore31.des", "", int32_t(0x00000000), int32_t(0xEC8877E6)},
    {"ishore31.sno", "-", int32_t(0x00000000), int32_t(0x02144797)},
    {"ishore31.tem", "-", int32_t(0x00000000), int32_t(0x0AA1E9F5)},
    {"ishore32.des", "", int32_t(0x00000000), int32_t(0xAB280D36)},
    {"ishore32.sno", "-", int32_t(0x00000000), int32_t(0x45B43D47)},
    {"ishore32.tem", "-", int32_t(0x00000000), int32_t(0x4D019325)},
    {"ishore33.des", "", int32_t(0x00000000), int32_t(0x96482486)},
    {"ishore33.sno", "-", int32_t(0x00000000), int32_t(0x78D414F7)},
    {"ishore33.tem", "-", int32_t(0x00000000), int32_t(0x7061BA95)},
    {"ishore34.des", "", int32_t(0x00000000), int32_t(0x2468F896)},
    {"ishore34.sno", "-", int32_t(0x00000000), int32_t(0xCAF4C8E7)},
    {"ishore34.tem", "-", int32_t(0x00000000), int32_t(0xC2416685)},
    {"ishore35.des", "", int32_t(0x00000000), int32_t(0x1908D126)},
    {"ishore35.sno", "-", int32_t(0x00000000), int32_t(0xF794E157)},
    {"ishore35.tem", "-", int32_t(0x00000000), int32_t(0xFF214F35)},
    {"ishore36.des", "", int32_t(0x00000000), int32_t(0x5EA8ABF6)},
    {"ishore36.sno", "-", int32_t(0x00000000), int32_t(0xB0349B87)},
    {"ishore36.tem", "-", int32_t(0x00000000), int32_t(0xB88135E5)},
    {"ishore37.des", "", int32_t(0x00000000), int32_t(0x63C88246)},
    {"ishore37.sno", "-", int32_t(0x00000000), int32_t(0x8D54B237)},
    {"ishore37.tem", "-", int32_t(0x00000000), int32_t(0x85E11C55)},
    {"ishore38.des", "", int32_t(0x00000000), int32_t(0xE1981597)},
    {"ishore38.sno", "-", int32_t(0x00000000), int32_t(0x0F0425E6)},
    {"ishore38.tem", "-", int32_t(0x00000000), int32_t(0x07B18B84)},
    {"ishore39.des", "", int32_t(0x00000000), int32_t(0xDCF83C27)},
    {"ishore39.sno", "-", int32_t(0x00000000), int32_t(0x32640C56)},
    {"ishore39.tem", "-", int32_t(0x00000000), int32_t(0x3AD1A234)},
    {"ishore40.des", "", int32_t(0x00000000), int32_t(0xCCED6EEE)},
    {"ishore40.sno", "-", int32_t(0x00000000), int32_t(0x22715E9F)},
    {"ishore40.tem", "-", int32_t(0x00000000), int32_t(0x2AC4F0FD)},
    {"ishore41.des", "", int32_t(0x00000000), int32_t(0xF18D475E)},
    {"ishore41.sno", "-", int32_t(0x00000000), int32_t(0x1F11772F)},
    {"ishore41.tem", "-", int32_t(0x00000000), int32_t(0x17A4D94D)},
    {"ishore42.des", "", int32_t(0x00000000), int32_t(0xB62D3D8E)},
    {"ishore42.sno", "-", int32_t(0x00000000), int32_t(0x58B10DFF)},
    {"ishore42.tem", "-", int32_t(0x00000000), int32_t(0x5004A39D)},
    {"ishore43.des", "", int32_t(0x00000000), int32_t(0x8B4D143E)},
    {"ishore43.sno", "-", int32_t(0x00000000), int32_t(0x65D1244F)},
    {"ishore43.tem", "-", int32_t(0x00000000), int32_t(0x6D648A2D)},
    {"ishore44.des", "", int32_t(0x00000000), int32_t(0x396DC82E)},
    {"ishore44.sno", "-", int32_t(0x00000000), int32_t(0xD7F1F85F)},
    {"ishore44.tem", "-", int32_t(0x00000000), int32_t(0xDF44563D)},
    {"ishore45.des", "", int32_t(0x00000000), int32_t(0x040DE19E)},
    {"ishore45.sno", "-", int32_t(0x00000000), int32_t(0xEA91D1EF)},
    {"ishore45.tem", "-", int32_t(0x00000000), int32_t(0xE2247F8D)},
    {"ishore46.des", "", int32_t(0x00000000), int32_t(0x43AD9B4E)},
    {"ishore46.sno", "-", int32_t(0x00000000), int32_t(0xAD31AB3F)},
    {"ishore46.tem", "-", int32_t(0x00000000), int32_t(0xA584055D)},
    {"ishore47.des", "", int32_t(0x00000000), int32_t(0x7ECDB2FE)},
    {"ishore47.sno", "-", int32_t(0x00000000), int32_t(0x9051828F)},
    {"ishore47.tem", "-", int32_t(0x00000000), int32_t(0x98E42CED)},
    {"ishore48.des", "", int32_t(0x00000000), int32_t(0xFC9D252F)},
    {"ishore48.sno", "-", int32_t(0x00000000), int32_t(0x1201155E)},
    {"ishore48.tem", "-", int32_t(0x00000000), int32_t(0x1AB4BB3C)},
    {"isleofoades.map", "", int32_t(0x00000000), int32_t(0xE57DDF16)},
    {"isodes.mix", "", int32_t(0x00000000), int32_t(0x8C8CCA19)},
    {"isodes.pal", "", int32_t(0x00000000), int32_t(0xC4BC325B)},
    {"isodesmd.mix", "", int32_t(0x00000000), int32_t(0xCADDCD81)},
    {"isogen.mix", "", int32_t(0x00000000), int32_t(0xB3080BD2)},
    {"isogenmd.mix", "", int32_t(0x00000000), int32_t(0xF5590C4A)},
    {"isolun.mix", "", int32_t(0x00000000), int32_t(0x4DE6A424)},
    {"isolun.pal", "", int32_t(0x00000000), int32_t(0x05D65C66)},
    {"isolunmd.mix", "", int32_t(0x00000000), int32_t(0x0BB7A3BC)},
    {"isosno.pal", "snow theater palette", int32_t(0x00000000), int32_t(0xF109F70F)},
    {"isosnomd.mix", "", int32_t(0x00000000), int32_t(0xFF6808D5)},
    {"isosnow.mix", "-", int32_t(0x00000000), int32_t(0x0F5D1D99)},
    {"isotem.pal", "temperate theater paltette", int32_t(0x00000000), int32_t(0x5F9D97B9)},
    {"isotemmd.mix", "", int32_t(0x00000000), int32_t(0x51FC6863)},
    {"isotemp.mix", "-", int32_t(0x00000000), int32_t(0xBCCC4D97)},
    {"isoubn.mix", "", int32_t(0x00000000), int32_t(0x3BFB683C)},
    {"isoubn.pal", "", int32_t(0x00000000), int32_t(0x73CB907E)},
    {"isoubnmd.mix", "", int32_t(0x00000000), int32_t(0x7DAA6FA4)},
    {"isourb.mix", "", int32_t(0x00000000), int32_t(0x80E03363)},
    {"isourb.pal", "", int32_t(0x00000000), int32_t(0xC8D0CB21)},
    {"isourbmd.mix", "", int32_t(0x00000000), int32_t(0xC6B134FB)},
    {"item0014.pcx", "", int32_t(0xF5BB01B3), int32_t(0x00000000)},
    {"item0031.pcx", "", int32_t(0xEFBF01B3), int32_t(0x00000000)},
    {"itemjt.trr", "", int32_t(0xDD724C0B), int32_t(0x00000000)},
    {"ivan.shp", "", int32_t(0x00000000), int32_t(0x4DEE39DE)},
    {"ivanicon.shp", "", int32_t(0x00000000), int32_t(0x061CDCCC)},
    {"ivanuico.shp", "", int32_t(0x00000000), int32_t(0xC3DA4E2D)},
    {"ivncicon.shp", "", int32_t(0x00000000), int32_t(0x06586016)},
    {"ivncuico.shp", "", int32_t(0x00000000), int32_t(0xC39EF2F7)},
    {"j1.aud", "untamed land", int32_t(0x825CA6E9), int32_t(0x00000000)},
    {"j_compas.shp", "", int32_t(0x33D870F1), int32_t(0x00000000)},
    {"j_int.shp", "", int32_t(0xC9CBDA21), int32_t(0x00000000)},
    {"j_jrn.shp", "", int32_t(0xD9CFDA15), int32_t(0x00000000)},
    {"j_option.trr", "", int32_t(0x302E63FF), int32_t(0x00000000)},
    {"jaciatk1.aud", "", int32_t(0xCBF8EED9), int32_t(0x00000000)},
    {"jaciatk2.aud", "", int32_t(0xCDF8EED9), int32_t(0x00000000)},
    {"jacideth.aud", "", int32_t(0xFA0AD0DF), int32_t(0x00000000)},
    {"jacihit1.aud", "", int32_t(0xCC0AD8E7), int32_t(0x00000000)},
    {"jacihit2.aud", "", int32_t(0xCE0AD8E7), int32_t(0x00000000)},
    {"jacihtsh.aud", "", int32_t(0xFA08EEE7), int32_t(0x00000000)},
    {"jacikilb.aud", "", int32_t(0xEDFAD8ED), int32_t(0x00000000)},
    {"jadiatk1.aud", "", int32_t(0xCBFCEED9), int32_t(0x00000000)},
    {"jadiatk2.aud", "", int32_t(0xCDFCEED9), int32_t(0x00000000)},
    {"jadideth.aud", "", int32_t(0xFA0ED0DF), int32_t(0x00000000)},
    {"jadihit1.aud", "", int32_t(0xCC0ED8E7), int32_t(0x00000000)},
    {"jadihit2.aud", "", int32_t(0xCE0ED8E7), int32_t(0x00000000)},
    {"jadihtsh.aud", "", int32_t(0xFA0CEEE7), int32_t(0x00000000)},
    {"jadikilb.aud", "", int32_t(0xEDFED8ED), int32_t(0x00000000)},
    {"jakeatk1.aud", "", int32_t(0xBC18EED9), int32_t(0x00000000)},
    {"jakeatk2.aud", "", int32_t(0xBE18EED9), int32_t(0x00000000)},
    {"jakedeth.aud", "", int32_t(0xEA2AD0DF), int32_t(0x00000000)},
    {"jakehit1.aud", "", int32_t(0xBC2AD8E7), int32_t(0x00000000)},
    {"jakehit2.aud", "", int32_t(0xBE2AD8E7), int32_t(0x00000000)},
    {"jakehtsh.aud", "", int32_t(0xEA28EEE7), int32_t(0x00000000)},
    {"jakekilb.aud", "", int32_t(0xDE1AD8ED), int32_t(0x00000000)},
    {"jank.wav", "", int32_t(0x00000000), int32_t(0x67061778)},
    {"japanise.lng", "", int32_t(0xD735E3F3), int32_t(0x00000000)},
    {"japi.pcx", "", int32_t(0x00000000), int32_t(0xF4DB7EF3)},
    {"japi.shp", "", int32_t(0x00000000), int32_t(0x1BB29153)},
    {"jat201.des", "", int32_t(0x00000000), int32_t(0xEBC31998)},
    {"jat202.des", "", int32_t(0x00000000), int32_t(0xDA2B0305)},
    {"jat203.des", "", int32_t(0x00000000), int32_t(0x7C5C08B1)},
    {"jat204.des", "", int32_t(0x00000000), int32_t(0xB9FB363F)},
    {"jat205.des", "", int32_t(0x00000000), int32_t(0x1F8C3D8B)},
    {"jat206.des", "", int32_t(0x00000000), int32_t(0x2E642716)},
    {"jat207.des", "", int32_t(0x00000000), int32_t(0x88132CA2)},
    {"jat208.des", "", int32_t(0x00000000), int32_t(0x7E5B5C4B)},
    {"jat209.des", "", int32_t(0x00000000), int32_t(0xD82C57FF)},
    {"jat210.des", "", int32_t(0x00000000), int32_t(0x811E12B2)},
    {"jat211.des", "", int32_t(0x00000000), int32_t(0x27691906)},
    {"jat212.des", "", int32_t(0x00000000), int32_t(0x1681039B)},
    {"jat213.des", "", int32_t(0x00000000), int32_t(0xB0F6082F)},
    {"jat214.des", "", int32_t(0x00000000), int32_t(0x755136A1)},
    {"jat215.des", "", int32_t(0x00000000), int32_t(0xD3263D15)},
    {"jat216.des", "", int32_t(0x00000000), int32_t(0xE2CE2788)},
    {"jbird1.aud", "", int32_t(0xCB81B006), int32_t(0x00000000)},
    {"jbird10.aud", "", int32_t(0xA5C9C0F2), int32_t(0x00000000)},
    {"jbird11.aud", "", int32_t(0xA5CBC0F2), int32_t(0x00000000)},
    {"jbird2.aud", "", int32_t(0xCB81B206), int32_t(0x00000000)},
    {"jbird3.aud", "", int32_t(0xCB81B406), int32_t(0x00000000)},
    {"jbird4.aud", "", int32_t(0xCB81B606), int32_t(0x00000000)},
    {"jbird5.aud", "", int32_t(0xCB81B806), int32_t(0x00000000)},
    {"jbird6.aud", "", int32_t(0xCB81BA06), int32_t(0x00000000)},
    {"jbird7.aud", "", int32_t(0xCB81BC06), int32_t(0x00000000)},
    {"jbird8.aud", "", int32_t(0xCB81BE06), int32_t(0x00000000)},
    {"jbird9.aud", "", int32_t(0xCB81C006), int32_t(0x00000000)},
    {"jburn1.aud", "shok trop burn baby burn", int32_t(0xCBB1B01A), int32_t(0x00000000)},
    {"jchrge1.aud", "shok trop fully charged", int32_t(0xA5C7ECF8), int32_t(0x00000000)},
    {"jcrisp1.aud", "shok trop extra crispy", int32_t(0x81F00310), int32_t(0x00000000)},
    {"jdance1.aud", "shok trop lets dance", int32_t(0x95ABF0F0), int32_t(0x00000000)},
    {"jdi_v2.aud", "take em' out", int32_t(0xFF81BA2A), int32_t(0x00000000)},
    {"jeep.hva", "-", int32_t(0x00000000), int32_t(0x7F948027)},
    {"jeep.shp", "hummvee", int32_t(0xF0D2DDC2), int32_t(0x00000000)},
    {"jeep.vxl", "-", int32_t(0x00000000), int32_t(0x891E5F6E)},
    {"jeepicnh.des", "icon: hummvee", int32_t(0x24F6DFE9), int32_t(0x00000000)},
    {"jeepicnh.tem", "icon: hummvee", int32_t(0x1EF6EFE9), int32_t(0x00000000)},
    {"jeepicnh.win", "icon: hummvee", int32_t(0x1FFAF2E9), int32_t(0x00000000)},
    {"jeepicon.shp", "icon: hummvee", int32_t(0x2DFBEEE9), int32_t(0x00000000)},
    {"jeeptur.hva", "-", int32_t(0x00000000), int32_t(0xD593AF5A)},
    {"jeeptur.vxl", "-", int32_t(0x00000000), int32_t(0xDA65DCB1)},
    {"jestmov1.aud", "", int32_t(0xF84EF4F1), int32_t(0x00000000)},
    {"jestmus1.aud", "", int32_t(0xF84900F1), int32_t(0x00000000)},
    {"jjeticon.shp", "icon: jumpjet infantry", int32_t(0x00000000), int32_t(0xE56B30A5)},
    {"jjetuico.shp", "", int32_t(0x00000000), int32_t(0x20ADA244)},
    {"jjuice1.aud", "shok trop got juice", int32_t(0x81FC08F0), int32_t(0x00000000)},
    {"jjump1.aud", "shok trop need a jump", int32_t(0xB7B1D01E), int32_t(0x00000000)},
    {"jlight1.aud", "shok trop lights out", int32_t(0x79CC2EFA), int32_t(0x00000000)},
    {"josh.shp", "", int32_t(0x00000000), int32_t(0xF079B110)},
    {"journal1.aud", "", int32_t(0xF04300F3), int32_t(0x00000000)},
    {"journal2.aud", "", int32_t(0xF24300F3), int32_t(0x00000000)},
    {"jpower1.aud", "shok trop power on", int32_t(0xB9E43AF4), int32_t(0x00000000)},
    {"jshock1.aud", "shok trop shocking", int32_t(0x99C838F0), int32_t(0x00000000)},
    {"jugcrash.aud", "", int32_t(0xE21918FB), int32_t(0x00000000)},
    {"jugger.shp", "-", int32_t(0x00000000), int32_t(0x81F28A87)},
    {"jugger1.aud", "juggernaut firing sound", int32_t(0x00000000), int32_t(0x4EDEE34D)},
    {"juggicon.shp", "-", int32_t(0x00000000), int32_t(0x49DDAE21)},
    {"juggmove.aud", "", int32_t(0xEC1F34F1), int32_t(0x00000000)},
    {"jump1.aud", "", int32_t(0xEBB7B1CF), int32_t(0x00000000)},
    {"jumpjet.shp", "unit: jumpjet infantry", int32_t(0x00000000), int32_t(0x727D0A5B)},
    {"jumpjet1.aud", "jump jet fires gun", int32_t(0x00000000), int32_t(0x938669B0)},
    {"jundr.img", "", int32_t(0xABCBB214), int32_t(0x00000000)},
    {"jundr.lmf", "", int32_t(0xABD1B213), int32_t(0x00000000)},
    {"jundr.lsv", "", int32_t(0xB7D1B223), int32_t(0x00000000)},
    {"jundr.odf", "", int32_t(0x99D7B213), int32_t(0x00000000)},
    {"jundr.pcx", "", int32_t(0x97D9B225), int32_t(0x00000000)},
    {"jundr.ver", "", int32_t(0x9BE5B21F), int32_t(0x00000000)},
    {"jungle1.aud", "", int32_t(0x79E03502), int32_t(0x00000000)},
    {"jungle2.aud", "", int32_t(0x79E23502), int32_t(0x00000000)},
    {"jungle3.aud", "", int32_t(0x79E43502), int32_t(0x00000000)},
    {"jungle4.aud", "", int32_t(0x79E63502), int32_t(0x00000000)},
    {"justdoit.aud", "just do it!", int32_t(0x3E3534DF), int32_t(0x00000000)},
    {"justdoit.var", "", int32_t(0x4C2149DF), int32_t(0x00000000)},
    {"jyes1.aud", "shok trop yeesss", int32_t(0xF797C1CF), int32_t(0x00000000)},
    {"k_light1.shp", "-", int32_t(0x00000000), int32_t(0x05EB5921)},
    {"k_light2.shp", "-", int32_t(0x00000000), int32_t(0x424B23F1)},
    {"kaboom1.aud", "building half destroyed", int32_t(0x99AFF50C), int32_t(0x00000000)},
    {"kaboom12.aud", "explosion", int32_t(0xE5C0E0F9), int32_t(0x00000000)},
    {"kaboom15.aud", "explosion", int32_t(0xEBC0E0F9), int32_t(0x00000000)},
    {"kaboom22.aud", "building destroyed", int32_t(0xE5C2E0F9), int32_t(0x00000000)},
    {"kaboom25.aud", "wall hit", int32_t(0xEBC2E0F9), int32_t(0x00000000)},
    {"kaboom30.aud", "wall down", int32_t(0xE1C4E0F9), int32_t(0x00000000)},
    {"kane2.aud", "audf:", int32_t(0xBFBB61D5), int32_t(0x00000000)},
    {"kanefinl.aud", "kane's speech", int32_t(0xF22AD8E7), int32_t(0x00000000)},
    {"kanepre.vqa", "kane's intro to tiberium", int32_t(0x7204FB23), int32_t(0x00000000)},
    {"kanepre.vqp", "kane's intro to tiberium", int32_t(0x7213FB23), int32_t(0x00000000)},
    {"keepem1.aud", "commando keep em comming", int32_t(0x9DBC04F8), int32_t(0x00000000)},
    {"keeptrap.aud", "", int32_t(0x25ECFB03), int32_t(0x00000000)},
    {"kenn.shp", "bldg: kennel", int32_t(0xECE4DDC4), int32_t(0x00000000)},
    {"kennicon.shp", "icon: kennel", int32_t(0x261FEEED), int32_t(0x00000000)},
    {"kennmake.shp", "make: kennel", int32_t(0x1417EAF5), int32_t(0x00000000)},
    {"key.ini", "", int32_t(0x00000000), int32_t(0x763C81DD)},
    {"keyboard.ini", "ts keyboard settings", int32_t(0x00000000), int32_t(0x88F6EA3B)},
    {"keyboardmd.ini", "", int32_t(0x00000000), int32_t(0x930BE675)},
    {"keystrok.aud", "keystroke", int32_t(0x2858FB03), int32_t(0x00000000)},
    {"kia.tre", "", int32_t(0x5CC7E4EA), int32_t(0x00000000)},
    {"kia.trf", "", int32_t(0x5CC8E4EA), int32_t(0x00000000)},
    {"kia.trg", "", int32_t(0x5CC9E4EA), int32_t(0x00000000)},
    {"kia.tri", "", int32_t(0x5CCBE4EA), int32_t(0x00000000)},
    {"kia.trs", "", int32_t(0x5CD5E4EA), int32_t(0x00000000)},
    {"kia.vqa", "", int32_t(0x5CC3E3EC), int32_t(0x00000000)},
    {"kia6pt.fnt", "-", int32_t(0x00000000), int32_t(0x60F77787)},
    {"kia6pt.fon", "", int32_t(0x65621C1C), int32_t(0x00000000)},
    {"kia_clue.vqa", "", int32_t(0x490113E0), int32_t(0x00000000)},
    {"kia_crim.vqa", "", int32_t(0x58E91FE0), int32_t(0x00000000)},
    {"kia_ingm.vqa", "", int32_t(0x58E517EC), int32_t(0x00000000)},
    {"kia_susp.vqa", "", int32_t(0x5EFD2600), int32_t(0x00000000)},
    {"kiacred.tre", "", int32_t(0x69D30225), int32_t(0x00000000)},
    {"kiacred.trf", "", int32_t(0x69D40225), int32_t(0x00000000)},
    {"kiacred.trg", "", int32_t(0x69D50225), int32_t(0x00000000)},
    {"kiacred.tri", "", int32_t(0x69D70225), int32_t(0x00000000)},
    {"kiacred.trs", "", int32_t(0x69E10225), int32_t(0x00000000)},
    {"kiaopt.shp", "", int32_t(0xE3621E15), int32_t(0x00000000)},
    {"kiaover.vqa", "", int32_t(0x99EB012F), int32_t(0x00000000)},
    {"kick.shp", "", int32_t(0xE6CEE5C4), int32_t(0x00000000)},
    {"kick1.aud", "", int32_t(0xD78F81D3), int32_t(0x00000000)},
    {"kick2.aud", "", int32_t(0xD78F81D5), int32_t(0x00000000)},
    {"kickdoor.aud", "", int32_t(0x160104E3), int32_t(0x00000000)},
    {"kill_gdi.vqa", "-", int32_t(0x00000000), int32_t(0x6D26AA05)},
    {"killmech.vqa", "-", int32_t(0x00000000), int32_t(0xE4429472)},
    {"killvnt1.aud", "", int32_t(0xD82F0307), int32_t(0x00000000)},
    {"kirov.bmp", "", int32_t(0x00000000), int32_t(0xDECC8E72)},
    {"klax1.aud", "klaxon", int32_t(0x00000000), int32_t(0x4C86F3CC)},
    {"klaxon1.aud", "", int32_t(0xBDAC230C), int32_t(0x00000000)},
    {"kmachine.aud", "-", int32_t(0x00000000), int32_t(0xB8FD9490)},
    {"kngdoor1.aud", "", int32_t(0xB81718F9), int32_t(0x00000000)},
    {"knife1a.aud", "", int32_t(0x75EBF0F8), int32_t(0x00000000)},
    {"knife1b.aud", "", int32_t(0x75EDF0F8), int32_t(0x00000000)},
    {"knife2a.aud", "", int32_t(0x75EBF2F8), int32_t(0x00000000)},
    {"knife2b.aud", "", int32_t(0x75EDF2F8), int32_t(0x00000000)},
    {"kosyfre1.aud", "kosygin freed", int32_t(0x0C2D22E7), int32_t(0x00000000)},
    {"kosyres1.aud", "kosygin rescued", int32_t(0x0C4908FF), int32_t(0x00000000)},
    {"kp01-min.set", "", int32_t(0xB5992EB5), int32_t(0x00000000)},
    {"kp01.vqa", "", int32_t(0xA3B1F6C4), int32_t(0x00000000)},
    {"kp01_0.vqa", "", int32_t(0x711DE33C), int32_t(0x00000000)},
    {"kp01_1.vqa", "", int32_t(0x711DE53C), int32_t(0x00000000)},
    {"kp01_2.vqa", "", int32_t(0x711DE73C), int32_t(0x00000000)},
    {"kp01_3.vqa", "", int32_t(0x711DE93C), int32_t(0x00000000)},
    {"kp02-min.set", "", int32_t(0xB9992EB5), int32_t(0x00000000)},
    {"kp02.vqa", "", int32_t(0xA5B1F6C4), int32_t(0x00000000)},
    {"kp02_0.vqa", "", int32_t(0x751DE33C), int32_t(0x00000000)},
    {"kp02_1.vqa", "", int32_t(0x751DE53C), int32_t(0x00000000)},
    {"kp02_2.vqa", "", int32_t(0x751DE73C), int32_t(0x00000000)},
    {"kp02_3.vqa", "", int32_t(0x751DE93C), int32_t(0x00000000)},
    {"kp03-min.set", "", int32_t(0xBD992EB5), int32_t(0x00000000)},
    {"kp03.vqa", "", int32_t(0xA7B1F6C4), int32_t(0x00000000)},
    {"kp03_0.vqa", "", int32_t(0x791DE33C), int32_t(0x00000000)},
    {"kp03_1.vqa", "", int32_t(0x791DE53C), int32_t(0x00000000)},
    {"kp03_2.vqa", "", int32_t(0x791DE73C), int32_t(0x00000000)},
    {"kp03_3.vqa", "", int32_t(0x791DE93C), int32_t(0x00000000)},
    {"kp04-min.set", "", int32_t(0xC1992EB5), int32_t(0x00000000)},
    {"kp04.vqa", "", int32_t(0xA9B1F6C4), int32_t(0x00000000)},
    {"kp04_0.vqa", "", int32_t(0x7D1DE33C), int32_t(0x00000000)},
    {"kp04_1.vqa", "", int32_t(0x7D1DE53C), int32_t(0x00000000)},
    {"kp04_2.vqa", "", int32_t(0x7D1DE73C), int32_t(0x00000000)},
    {"kp04_3.vqa", "", int32_t(0x7D1DE93C), int32_t(0x00000000)},
    {"kp05-min.set", "", int32_t(0xC5992EB5), int32_t(0x00000000)},
    {"kp05.vqa", "", int32_t(0xABB1F6C4), int32_t(0x00000000)},
    {"kp05_0.vqa", "", int32_t(0x811DE33C), int32_t(0x00000000)},
    {"kp05_1.vqa", "", int32_t(0x811DE53C), int32_t(0x00000000)},
    {"kp05_2.vqa", "", int32_t(0x811DE73C), int32_t(0x00000000)},
    {"kp05_3.vqa", "", int32_t(0x811DE93C), int32_t(0x00000000)},
    {"kp06-min.set", "", int32_t(0xC9992EB5), int32_t(0x00000000)},
    {"kp06.img", "", int32_t(0xB3ADE9C4), int32_t(0x00000000)},
    {"kp06.vqa", "", int32_t(0xADB1F6C4), int32_t(0x00000000)},
    {"kp06_0.vqa", "", int32_t(0x851DE33C), int32_t(0x00000000)},
    {"kp06_1.vqa", "", int32_t(0x851DE53C), int32_t(0x00000000)},
    {"kp06_2.vqa", "", int32_t(0x851DE73C), int32_t(0x00000000)},
    {"kp06_3.vqa", "", int32_t(0x851DE93C), int32_t(0x00000000)},
    {"kp06esp1.vqa", "", int32_t(0x7CB33DE5), int32_t(0x00000000)},
    {"kp06esp2.vqa", "", int32_t(0x7EB33DE5), int32_t(0x00000000)},
    {"kp06esp3.vqa", "", int32_t(0x80B33DE5), int32_t(0x00000000)},
    {"kp06esp4.vqa", "", int32_t(0x82B33DE5), int32_t(0x00000000)},
    {"kp07-min.set", "", int32_t(0xCD992EB5), int32_t(0x00000000)},
    {"kp07.vqa", "", int32_t(0xAFB1F6C4), int32_t(0x00000000)},
    {"kp07_0.vqa", "", int32_t(0x891DE33C), int32_t(0x00000000)},
    {"kp07_1.vqa", "", int32_t(0x891DE53C), int32_t(0x00000000)},
    {"kp07_2.vqa", "", int32_t(0x891DE73C), int32_t(0x00000000)},
    {"kp07_3.vqa", "", int32_t(0x891DE93C), int32_t(0x00000000)},
    {"kpamb1.aud", "", int32_t(0xB761E806), int32_t(0x00000000)},
    {"ktchrain.aud", "", int32_t(0x01F514FF), int32_t(0x00000000)},
    {"ktstlexp.shp", "", int32_t(0x00000000), int32_t(0x42CD4236)},
    {"kung1.aud", "", int32_t(0xC7BBB1D3), int32_t(0x00000000)},
    {"kvolc.img", "", int32_t(0xCBCFB5FA), int32_t(0x00000000)},
    {"kvolc.lmf", "", int32_t(0xCBD5B5F9), int32_t(0x00000000)},
    {"kvolc.lsv", "", int32_t(0xD7D5B609), int32_t(0x00000000)},
    {"kvolc.odf", "", int32_t(0xB9DBB5F9), int32_t(0x00000000)},
    {"kvolc.pcx", "", int32_t(0xB7DDB60B), int32_t(0x00000000)},
    {"kvolc.ver", "", int32_t(0xBBE9B605), int32_t(0x00000000)},
    {"kyoto.aud", "", int32_t(0xFBBFC20F), int32_t(0x00000000)},
    {"l10_dc.img", "", int32_t(0x0F1D9305), int32_t(0x00000000)},
    {"l12_cm.img", "", int32_t(0x0F25A703), int32_t(0x00000000)},
    {"l13_rc.img", "", int32_t(0x0F299321), int32_t(0x00000000)},
    {"l14_ht.img", "", int32_t(0x0F2DB50D), int32_t(0x00000000)},
    {"l16_ca.img", "", int32_t(0x0F358F03), int32_t(0x00000000)},
    {"l17_hc.img", "", int32_t(0x0F39930D), int32_t(0x00000000)},
    {"l19_bc.img", "", int32_t(0x0F419301), int32_t(0x00000000)},
    {"l1_dc.img", "", int32_t(0xAC0F21FE), int32_t(0x00000000)},
    {"l20_bb.img", "", int32_t(0x0F1D9501), int32_t(0x00000000)},
    {"l3_dh.img", "", int32_t(0xAC0F2A08), int32_t(0x00000000)},
    {"l4_hj.img", "", int32_t(0xBC0F2E0C), int32_t(0x00000000)},
    {"l5_hc.img", "", int32_t(0xBC0F31FE), int32_t(0x00000000)},
    {"l7_dh.img", "", int32_t(0xAC0F3A08), int32_t(0x00000000)},
    {"l8_sj.img", "", int32_t(0xE80F3E0C), int32_t(0x00000000)},
    {"l9_dr.img", "", int32_t(0xAC0F421C), int32_t(0x00000000)},
    {"lab-lo.cps", "pict: time machine", int32_t(0x3B65F719), int32_t(0x00000000)},
    {"lab.pcx", "pict: time machine", int32_t(0x5CDCC5E8), int32_t(0x00000000)},
    {"labamb1.aud", "", int32_t(0x61AFDF0C), int32_t(0x00000000)},
    {"labamb2.aud", "", int32_t(0x61B1DF0C), int32_t(0x00000000)},
    {"labamb3.aud", "", int32_t(0x61B3DF0C), int32_t(0x00000000)},
    {"labbuzz1.aud", "", int32_t(0xB012FB09), int32_t(0x00000000)},
    {"labmisc1.aud", "", int32_t(0xDBE4ECF1), int32_t(0x00000000)},
    {"labmisc2.aud", "", int32_t(0xDDE4ECF1), int32_t(0x00000000)},
    {"labmisc3.aud", "", int32_t(0xDFE4ECF1), int32_t(0x00000000)},
    {"labmisc4.aud", "", int32_t(0xE1E4ECF1), int32_t(0x00000000)},
    {"labmisc5.aud", "", int32_t(0xE3E4ECF1), int32_t(0x00000000)},
    {"labmisc6.aud", "", int32_t(0xE5E4ECF1), int32_t(0x00000000)},
    {"labmisc7.aud", "", int32_t(0xE7E4ECF1), int32_t(0x00000000)},
    {"labmisc8.aud", "", int32_t(0xE9E4ECF1), int32_t(0x00000000)},
    {"labmisc9.aud", "", int32_t(0xEBE4ECF1), int32_t(0x00000000)},
    {"ladder.shp", "", int32_t(0xB76DFA03), int32_t(0x00000000)},
    {"land1.aud", "", int32_t(0xBBBB61D7), int32_t(0x00000000)},
    {"landicon.shp", "", int32_t(0x00000000), int32_t(0x7D57AB87)},
    {"landing.vqa", "hovercrafts landing", int32_t(0x6E08F319), int32_t(0x00000000)},
    {"landing.vqp", "hovercrafts landing", int32_t(0x6E17F319), int32_t(0x00000000)},
    {"lands-lo.cps", "pict: hitler vanishing", int32_t(0x0321A305), int32_t(0x00000000)},
    {"landsbrg.pcx", "pict: hitler vanishing", int32_t(0xF820DA05), int32_t(0x00000000)},
    {"langrule.ini", "", int32_t(0x00000000), int32_t(0xB3C17994)},
    {"language.eng", "", int32_t(0xEF15CD09), int32_t(0x00000000)},
    {"language.fre", "", int32_t(0xED19CE09), int32_t(0x00000000)},
    {"language.ger", "", int32_t(0xFA0CCF09), int32_t(0x00000000)},
    {"language.jap", "", int32_t(0xF808D209), int32_t(0x00000000)},
    {"lantern1.aud", "", int32_t(0xF82AEAE9), int32_t(0x00000000)},
    {"lar1.shp", "misc: ant egg", int32_t(0xB2ECD5C6), int32_t(0x00000000)},
    {"lar2.shp", "misc: ant eggs", int32_t(0xB4ECD5C6), int32_t(0x00000000)},
    {"larkbite.aud", "", int32_t(0xFC46D8E3), int32_t(0x00000000)},
    {"larkdam1.aud", "", int32_t(0xD438C8E7), int32_t(0x00000000)},
    {"larkdam2.aud", "", int32_t(0xD638C8E7), int32_t(0x00000000)},
    {"larkdie.aud", "", int32_t(0x8A17ECFA), int32_t(0x00000000)},
    {"larkltr1.aud", "", int32_t(0xD442EEF7), int32_t(0x00000000)},
    {"larkltr2.aud", "", int32_t(0xD642EEF7), int32_t(0x00000000)},
    {"larksnor.aud", "", int32_t(0x163CE305), int32_t(0x00000000)},
    {"larkvskn.csv", "", int32_t(0x2032EF0B), int32_t(0x00000000)},
    {"larkvskn.lsv", "", int32_t(0x2032F80B), int32_t(0x00000000)},
    {"larkvskn.vqa", "", int32_t(0x0B31020B), int32_t(0x00000000)},
    {"larkvskn_e.vqa", "", int32_t(0x401C23C9), int32_t(0x00000000)},
    {"larkvskn_e.vqt", "", int32_t(0x401C36C9), int32_t(0x00000000)},
    {"larkvskn_h.pcx", "", int32_t(0x341C40BB), int32_t(0x00000000)},
    {"larkvskn_h.vqa", "", int32_t(0x401C29C9), int32_t(0x00000000)},
    {"larkvskn_l.pcx", "", int32_t(0x341C48BB), int32_t(0x00000000)},
    {"larkvskn_l.vqa", "", int32_t(0x401C31C9), int32_t(0x00000000)},
    {"laser.hva", "-", int32_t(0x00000000), int32_t(0x8956DF0F)},
    {"laser.vxl", "laser turret turret", int32_t(0x00000000), int32_t(0x36CFD8A8)},
    {"lasricon.shp", "icon: laser fence post", int32_t(0x00000000), int32_t(0x70DD9A24)},
    {"lastfile.aud", "", int32_t(0x203AD8EB), int32_t(0x00000000)},
    {"lastscnb.pal", "pal: ???", int32_t(0x222ADC05), int32_t(0x00000000)},
    {"lastscng.pal", "pal: ???", int32_t(0x2C2ADC05), int32_t(0x00000000)},
    {"lastur1.aud", "laser turret", int32_t(0x00000000), int32_t(0x787F9FE9)},
    {"lat101.des", "", int32_t(0x00000000), int32_t(0x3D7380BD)},
    {"lat102.des", "", int32_t(0x00000000), int32_t(0x0C9B9A20)},
    {"lat103.des", "", int32_t(0x00000000), int32_t(0xAAEC9194)},
    {"lat104.des", "", int32_t(0x00000000), int32_t(0x6F4BAF1A)},
    {"lat105.des", "", int32_t(0x00000000), int32_t(0xC93CA4AE)},
    {"lat106.des", "", int32_t(0x00000000), int32_t(0xF8D4BE33)},
    {"lat107.des", "", int32_t(0x00000000), int32_t(0x5EA3B587)},
    {"lat108.des", "", int32_t(0x00000000), int32_t(0xA8EBC56E)},
    {"lat109.des", "", int32_t(0x00000000), int32_t(0x0E9CCEDA)},
    {"lat110.des", "", int32_t(0x00000000), int32_t(0x57AE8B97)},
    {"lat111.des", "", int32_t(0x00000000), int32_t(0xF1D98023)},
    {"lat112.des", "", int32_t(0x00000000), int32_t(0xC0319ABE)},
    {"lat113.des", "", int32_t(0x00000000), int32_t(0x6646910A)},
    {"lat114.des", "", int32_t(0x00000000), int32_t(0xA3E1AF84)},
    {"lat115.des", "", int32_t(0x00000000), int32_t(0x0596A430)},
    {"lat116.des", "", int32_t(0x00000000), int32_t(0x347EBEAD)},
    {"lat201.des", "", int32_t(0x00000000), int32_t(0x04FEBC78)},
    {"lat202.des", "", int32_t(0x00000000), int32_t(0x3516A6E5)},
    {"lat203.des", "", int32_t(0x00000000), int32_t(0x9361AD51)},
    {"lat204.des", "", int32_t(0x00000000), int32_t(0x56C693DF)},
    {"lat205.des", "", int32_t(0x00000000), int32_t(0xF0B1986B)},
    {"lat206.des", "", int32_t(0x00000000), int32_t(0xC15982F6)},
    {"lat207.des", "", int32_t(0x00000000), int32_t(0x672E8942)},
    {"lat208.des", "", int32_t(0x00000000), int32_t(0x9166F9AB)},
    {"lat209.des", "", int32_t(0x00000000), int32_t(0x3711F21F)},
    {"lat210.des", "", int32_t(0x00000000), int32_t(0x6E23B752)},
    {"lat211.des", "", int32_t(0x00000000), int32_t(0xC854BCE6)},
    {"lat212.des", "", int32_t(0x00000000), int32_t(0xF9BCA67B)},
    {"lat213.des", "", int32_t(0x00000000), int32_t(0x5FCBADCF)},
    {"lat214.des", "", int32_t(0x00000000), int32_t(0x9A6C9341)},
    {"lat215.des", "", int32_t(0x00000000), int32_t(0x3C1B98F5)},
    {"lat216.des", "", int32_t(0x00000000), int32_t(0x0DF38268)},
    {"latency.bmp", "", int32_t(0x7253D90F), int32_t(0x00000000)},
    {"lati.pcx", "", int32_t(0x00000000), int32_t(0xA9253562)},
    {"lati.shp", "", int32_t(0x00000000), int32_t(0x464CDAC2)},
    {"laugh1.aud", "commando laugh", int32_t(0x9FB1AC16), int32_t(0x00000000)},
    {"lava.flc", "", int32_t(0xC5F8C8C6), int32_t(0x00000000)},
    {"lavadrp1.aud", "", int32_t(0xAC4EEAE7), int32_t(0x00000000)},
    {"lavadrp2.aud", "", int32_t(0xAE4EEAE7), int32_t(0x00000000)},
    {"lavadrp3.aud", "", int32_t(0xB04EEAE7), int32_t(0x00000000)},
    {"lavadrp4.aud", "", int32_t(0xB24EEAE7), int32_t(0x00000000)},
    {"lavadrp5.aud", "", int32_t(0xB44EEAE7), int32_t(0x00000000)},
    {"lavadrp6.aud", "", int32_t(0xB64EEAE7), int32_t(0x00000000)},
    {"lavafal1.aud", "", int32_t(0xAC46C8EB), int32_t(0x00000000)},
    {"lavahard.aud", "", int32_t(0xD252C8EF), int32_t(0x00000000)},
    {"lazer7.aud", "", int32_t(0x97C5B82A), int32_t(0x00000000)},
    {"lcrf.hva", "", int32_t(0x00000000), int32_t(0x2B58EC9B)},
    {"lcrf.vxl", "", int32_t(0x00000000), int32_t(0xDDD233D2)},
    {"ldscrn.pal", "", int32_t(0x00000000), int32_t(0xF2565D90)},
    {"ldscrna.pal", "", int32_t(0x00000000), int32_t(0x5B435F2F)},
    {"ldscrns.pal", "", int32_t(0x00000000), int32_t(0x155DFCBF)},
    {"leave.shp", "", int32_t(0xE9AB720B), int32_t(0x00000000)},
    {"led.fnt", "led", int32_t(0x5CDCD8DE), int32_t(0x00000000)},
    {"lefal3.aud", "", int32_t(0x8775C01E), int32_t(0x00000000)},
    {"left1.wsa", "anim: left mouth moving", int32_t(0xF7C771D4), int32_t(0x00000000)},
    {"left16.aud", "left", int32_t(0xD375C5E8), int32_t(0x00000000)},
    {"leftbar.pcx", "-", int32_t(0x00000000), int32_t(0xB170D737)},
    {"lefty1.aud", "commando that was left handed", int32_t(0xD375BC38), int32_t(0x00000000)},
    {"leinatk1.aud", "", int32_t(0xE010FEE1), int32_t(0x00000000)},
    {"leinatk2.aud", "", int32_t(0xE210FEE1), int32_t(0x00000000)},
    {"leindeth.aud", "", int32_t(0x0E22E0E7), int32_t(0x00000000)},
    {"leinhit1.aud", "", int32_t(0xE022E8EF), int32_t(0x00000000)},
    {"leinhit2.aud", "", int32_t(0xE222E8EF), int32_t(0x00000000)},
    {"leinhtsh.aud", "", int32_t(0x0E20FEEF), int32_t(0x00000000)},
    {"leinkilb.aud", "", int32_t(0x0212E8F5), int32_t(0x00000000)},
    {"lendcap.shp", "", int32_t(0x00000000), int32_t(0x593CBE20)},
    {"lesrheal.flc", "", int32_t(0x251BE5EF), int32_t(0x00000000)},
    {"levels\\bupp1\\bupp1.ver", "", int32_t(0x48C21F4B), int32_t(0x00000000)},
    {"levels\\ckeep\\ckeep.ver", "", int32_t(0x244208E4), int32_t(0x00000000)},
    {"levels\\dlow1\\dlow1.ver", "", int32_t(0x64D61F11), int32_t(0x00000000)},
    {"levels\\ewod1\\ewod1.ver", "", int32_t(0x746A2343), int32_t(0x00000000)},
    {"levels\\flair\\flair.ver", "", int32_t(0x5465F8F4), int32_t(0x00000000)},
    {"levels\\grulo\\grulo.ver", "", int32_t(0x9C96972A), int32_t(0x00000000)},
    {"levels\\hwhit\\hwhit.ver", "", int32_t(0xA0923D4C), int32_t(0x00000000)},
    {"levels\\ishat\\ishat.ver", "", int32_t(0xB042411C), int32_t(0x00000000)},
    {"levels\\jundr\\jundr.ver", "", int32_t(0xC8627132), int32_t(0x00000000)},
    {"levels\\kvolc\\kvolc.ver", "", int32_t(0x64A65F4A), int32_t(0x00000000)},
    {"levels\\lupp2\\lupp2.ver", "", int32_t(0xF0C24949), int32_t(0x00000000)},
    {"levels\\mlow2\\mlow2.ver", "", int32_t(0xFCD6450F), int32_t(0x00000000)},
    {"levels\\nwod2\\nwod2.ver", "", int32_t(0x0C6A4942), int32_t(0x00000000)},
    {"levels\\olow3\\olow3.ver", "", int32_t(0x24D64F10), int32_t(0x00000000)},
    {"levels\\pwod3\\pwod3.ver", "", int32_t(0x346A5342), int32_t(0x00000000)},
    {"levels\\qwod0\\da15ya98.aud", "", int32_t(0x9EF29671), int32_t(0x00000000)},
    {"levels\\qwod0\\da15zk00.aud", "", int32_t(0x7B1A9A61), int32_t(0x00000000)},
    {"levels\\qwod0\\qwod0.lmf", "", int32_t(0x186A454A), int32_t(0x00000000)},
    {"levels\\qwod0\\qwod0.map", "", int32_t(0x1A6A4F3E), int32_t(0x00000000)},
    {"levels\\qwod0\\qwod0.odf", "", int32_t(0x1E6A4541), int32_t(0x00000000)},
    {"levels\\qwod0\\qwod0.ver", "", int32_t(0x2C6A5142), int32_t(0x00000000)},
    {"levels\\rvol0\\rvol0.ver", "", int32_t(0x3CA6554A), int32_t(0x00000000)},
    {"levels\\swod4\\swod4.ver", "", int32_t(0x6C6A6142), int32_t(0x00000000)},
    {"levup4.aud", "", int32_t(0xD7B5C226), int32_t(0x00000000)},
    {"lft_btn.shp", "", int32_t(0xDA3E0A08), int32_t(0x00000000)},
    {"lft_in.shp", "", int32_t(0x23AE060A), int32_t(0x00000000)},
    {"lft_out.shp", "", int32_t(0xDA4A0C22), int32_t(0x00000000)},
    {"lft_spin.shp", "", int32_t(0x6A2C0D04), int32_t(0x00000000)},
    {"lftire02.vqa", "", int32_t(0xCB02FA03), int32_t(0x00000000)},
    {"lgcal1.aud", "", int32_t(0x8769C41E), int32_t(0x00000000)},
    {"lgcal2.aud", "", int32_t(0x8769C61E), int32_t(0x00000000)},
    {"lgcal3.aud", "", int32_t(0x8769C81E), int32_t(0x00000000)},
    {"lgrysmk1.shp", "-", int32_t(0x00000000), int32_t(0xA8A8C632)},
    {"libbas01.ubn", "", int32_t(0x00000000), int32_t(0x9F1235EC)},
    {"libbas01.urb", "", int32_t(0x00000000), int32_t(0xDC666B96)},
    {"libdes.pal", "", int32_t(0x00000000), int32_t(0xE5B852B4)},
    {"liblun.pal", "", int32_t(0x00000000), int32_t(0x24D23C89)},
    {"library1.aud", "", int32_t(0xF0110AE1), int32_t(0x00000000)},
    {"libsno.pal", "", int32_t(0x00000000), int32_t(0xD00D97E0)},
    {"libtem.pal", "", int32_t(0x00000000), int32_t(0x7E99F756)},
    {"libubn.pal", "", int32_t(0x00000000), int32_t(0x52CFF091)},
    {"liburb.pal", "", int32_t(0x00000000), int32_t(0xE9D4ABCE)},
    {"lieutena.pcx", "", int32_t(0x00000000), int32_t(0xA6C45D13)},
    {"light.pal", "-", int32_t(0x00000000), int32_t(0x2EC0E041)},
    {"lighton.aud", "", int32_t(0x7DFE191A), int32_t(0x00000000)},
    {"lighton1.aud", "", int32_t(0xC80F0507), int32_t(0x00000000)},
    {"limo.hva", "", int32_t(0x00000000), int32_t(0x70B861EA)},
    {"limo.vxl", "", int32_t(0x00000000), int32_t(0x8632BEA3)},
    {"limpbom1.aud", "limpet drone attatch", int32_t(0x00000000), int32_t(0x8B1B8DF4)},
    {"limpc3.aud", "limpet drone move", int32_t(0x00000000), int32_t(0x3E74A419)},
    {"limpc4.aud", "limpet drone move", int32_t(0x00000000), int32_t(0xFBD39A97)},
    {"limped.shp", "-", int32_t(0x00000000), int32_t(0x11AE6FEE)},
    {"limpicon.shp", "-", int32_t(0x00000000), int32_t(0xDD8FE2BC)},
    {"limpq3.aud", "limpet drone move", int32_t(0x00000000), int32_t(0x00EA924F)},
    {"limpq4.aud", "limpet drone move", int32_t(0x00000000), int32_t(0xC54DACC1)},
    {"linefire.aud", "in the line of fire", int32_t(0xE432F8EB), int32_t(0x00000000)},
    {"linkup.aud", "-", int32_t(0x00000000), int32_t(0xFB5CAD62)},
    {"litehard.aud", "", int32_t(0xE24AE8EF), int32_t(0x00000000)},
    {"liteicon.shp", "icon: light", int32_t(0x00000000), int32_t(0xE0634FA0)},
    {"litenngd.shp", "", int32_t(0xEE2814FB), int32_t(0x00000000)},
    {"litning.shp", "misc: tesla zaps", int32_t(0x96300A16), int32_t(0x00000000)},
    {"littrch1.aud", "", int32_t(0xF836ED03), int32_t(0x00000000)},
    {"liz-die.csv", "", int32_t(0x124A0AFC), int32_t(0x00000000)},
    {"liz-die.lsv", "", int32_t(0x124A0B05), int32_t(0x00000000)},
    {"liz-die.vqa", "", int32_t(0x1235090F), int32_t(0x00000000)},
    {"liz-die_e.vqa", "", int32_t(0x8A93CC3E), int32_t(0x00000000)},
    {"liz-die_e.vqt", "", int32_t(0x8A93CC51), int32_t(0x00000000)},
    {"liz-die_h.pcx", "", int32_t(0x6E87CC5B), int32_t(0x00000000)},
    {"liz-die_h.vqa", "", int32_t(0x8A93CC44), int32_t(0x00000000)},
    {"liz-die_l.pcx", "", int32_t(0x6E87CC63), int32_t(0x00000000)},
    {"liz-die_l.vqa", "", int32_t(0x8A93CC4C), int32_t(0x00000000)},
    {"lk1.aud", "", int32_t(0x5CA6EBD9), int32_t(0x00000000)},
    {"lk1grvlwlk3.aud", "", int32_t(0xF3669F84), int32_t(0x00000000)},
    {"llbite1.aud", "", int32_t(0x81B0111A), int32_t(0x00000000)},
    {"lldam1.aud", "", int32_t(0x876DD820), int32_t(0x00000000)},
    {"lldie1.aud", "", int32_t(0xA76DD810), int32_t(0x00000000)},
    {"llloitr1.aud", "", int32_t(0xE42B1AF1), int32_t(0x00000000)},
    {"llloitr2.aud", "", int32_t(0xE62B1AF1), int32_t(0x00000000)},
    {"llshapes.shp", "", int32_t(0x182024E1), int32_t(0x00000000)},
    {"load.mix", "", int32_t(0x00000000), int32_t(0xBC80C10F)},
    {"load.pcx", "", int32_t(0x00000000), int32_t(0x529119A6)},
    {"load1.aud", "mission loaded", int32_t(0xBB8799D7), int32_t(0x00000000)},
    {"load400a.pcx", "-", int32_t(0x00000000), int32_t(0xA3B2529E)},
    {"load400b.pcx", "-", int32_t(0x00000000), int32_t(0xE412284E)},
    {"load400c.pcx", "-", int32_t(0x00000000), int32_t(0xD97201FE)},
    {"load400d.pcx", "-", int32_t(0x00000000), int32_t(0x6B52DDEE)},
    {"load480a.pcx", "-", int32_t(0x00000000), int32_t(0x905D1CF9)},
    {"load480b.pcx", "-", int32_t(0x00000000), int32_t(0xD7FD6629)},
    {"load480c.pcx", "-", int32_t(0x00000000), int32_t(0xEA9D4F99)},
    {"load480d.pcx", "-", int32_t(0x00000000), int32_t(0x58BD9389)},
    {"load600a.pcx", "-", int32_t(0x00000000), int32_t(0xE19755E3)},
    {"load600b.pcx", "-", int32_t(0x00000000), int32_t(0xA6372F33)},
    {"load600c.pcx", "-", int32_t(0x00000000), int32_t(0x9B570683)},
    {"load600d.pcx", "-", int32_t(0x00000000), int32_t(0x2977DA93)},
    {"loading.pcx", "-", int32_t(0x00000000), int32_t(0xE5FA292C)},
    {"loadmd.mix", "", int32_t(0x00000000), int32_t(0xDF966243)},
    {"loadout.shp", "-", int32_t(0x00000000), int32_t(0x153752AD)},
    {"lobrdb01.des", "", int32_t(0x00000000), int32_t(0x638D1799)},
    {"lobrdb01.lun", "", int32_t(0x00000000), int32_t(0x445A38A9)},
    {"lobrdb01.sno", "", int32_t(0x00000000), int32_t(0x8D1127E8)},
    {"lobrdb01.tem", "", int32_t(0x00000000), int32_t(0x85A4898A)},
    {"lobrdb01.ubn", "", int32_t(0x00000000), int32_t(0x522E24C0)},
    {"lobrdb01.urb", "", int32_t(0x00000000), int32_t(0x115A7ABA)},
    {"lobrdb02.des", "", int32_t(0x00000000), int32_t(0x242D6D49)},
    {"lobrdb02.lun", "", int32_t(0x00000000), int32_t(0x03FA4279)},
    {"lobrdb02.sno", "", int32_t(0x00000000), int32_t(0xCAB15D38)},
    {"lobrdb02.tem", "", int32_t(0x00000000), int32_t(0xC204F35A)},
    {"lobrdb02.ubn", "", int32_t(0x00000000), int32_t(0x158E5E10)},
    {"lobrdb02.urb", "", int32_t(0x00000000), int32_t(0x56FA006A)},
    {"lobrdb03.des", "", int32_t(0x00000000), int32_t(0x194D44F9)},
    {"lobrdb03.lun", "", int32_t(0x00000000), int32_t(0x3E9A6BC9)},
    {"lobrdb03.sno", "", int32_t(0x00000000), int32_t(0xF7D17488)},
    {"lobrdb03.tem", "", int32_t(0x00000000), int32_t(0xFF64DAEA)},
    {"lobrdb03.ubn", "", int32_t(0x00000000), int32_t(0x28EE77A0)},
    {"lobrdb03.urb", "", int32_t(0x00000000), int32_t(0x6B9A29DA)},
    {"lobrdb04.des", "", int32_t(0x00000000), int32_t(0xAB6D98E9)},
    {"lobrdb04.lun", "", int32_t(0x00000000), int32_t(0x8CBAB7D9)},
    {"lobrdb04.sno", "", int32_t(0x00000000), int32_t(0x45F1A898)},
    {"lobrdb04.tem", "", int32_t(0x00000000), int32_t(0x4D4406FA)},
    {"lobrdb04.ubn", "", int32_t(0x00000000), int32_t(0x9ACEABB0)},
    {"lobrdb04.urb", "", int32_t(0x00000000), int32_t(0xD9BAF5CA)},
    {"lobrdb05.des", "", int32_t(0x00000000), int32_t(0x960DB159)},
    {"lobrdb05.lun", "", int32_t(0x00000000), int32_t(0xB1DA9E69)},
    {"lobrdb05.sno", "", int32_t(0x00000000), int32_t(0x78918128)},
    {"lobrdb05.tem", "", int32_t(0x00000000), int32_t(0x70242F4A)},
    {"lobrdb05.ubn", "", int32_t(0x00000000), int32_t(0xA7AE8200)},
    {"lobrdb05.urb", "", int32_t(0x00000000), int32_t(0xE4DADC7A)},
    {"lobrdb06.des", "", int32_t(0x00000000), int32_t(0xD1ADCB89)},
    {"lobrdb06.lun", "", int32_t(0x00000000), int32_t(0xF67AE4B9)},
    {"lobrdb06.sno", "", int32_t(0x00000000), int32_t(0x3F31FBF8)},
    {"lobrdb06.tem", "", int32_t(0x00000000), int32_t(0x3784559A)},
    {"lobrdb06.ubn", "", int32_t(0x00000000), int32_t(0xE00EF8D0)},
    {"lobrdb06.urb", "", int32_t(0x00000000), int32_t(0xA37AA6AA)},
    {"lobrdb07.des", "", int32_t(0x00000000), int32_t(0xECCDE239)},
    {"lobrdb07.lun", "", int32_t(0x00000000), int32_t(0xCB1ACD09)},
    {"lobrdb07.sno", "", int32_t(0x00000000), int32_t(0x0251D248)},
    {"lobrdb07.tem", "", int32_t(0x00000000), int32_t(0x0AE47C2A)},
    {"lobrdb07.ubn", "", int32_t(0x00000000), int32_t(0xDD6ED160)},
    {"lobrdb07.urb", "", int32_t(0x00000000), int32_t(0x9E1A8F1A)},
    {"lobrdb08.des", "", int32_t(0x00000000), int32_t(0x6E9D75E8)},
    {"lobrdb08.lun", "", int32_t(0x00000000), int32_t(0x494A5AD8)},
    {"lobrdb08.sno", "", int32_t(0x00000000), int32_t(0x80014599)},
    {"lobrdb08.tem", "", int32_t(0x00000000), int32_t(0x88B4EBFB)},
    {"lobrdb08.ubn", "", int32_t(0x00000000), int32_t(0x5F3E46B1)},
    {"lobrdb08.urb", "", int32_t(0x00000000), int32_t(0x1C4A18CB)},
    {"lobrdb09.des", "", int32_t(0x00000000), int32_t(0x53FD5C58)},
    {"lobrdb09.lun", "", int32_t(0x00000000), int32_t(0x742A7368)},
    {"lobrdb09.sno", "", int32_t(0x00000000), int32_t(0xBD616C29)},
    {"lobrdb09.tem", "", int32_t(0x00000000), int32_t(0xB5D4C24B)},
    {"lobrdb09.ubn", "", int32_t(0x00000000), int32_t(0x625E6F01)},
    {"lobrdb09.urb", "", int32_t(0x00000000), int32_t(0x212A317B)},
    {"lobrdb10.des", "", int32_t(0x00000000), int32_t(0x95B1ED8C)},
    {"lobrdb10.lun", "", int32_t(0x00000000), int32_t(0xB266C2BC)},
    {"lobrdb10.sno", "", int32_t(0x00000000), int32_t(0x7B2DDDFD)},
    {"lobrdb10.tem", "", int32_t(0x00000000), int32_t(0x7398739F)},
    {"lobrdb10.ubn", "", int32_t(0x00000000), int32_t(0xA412DED5)},
    {"lobrdb10.urb", "", int32_t(0x00000000), int32_t(0xE76680AF)},
    {"lobrdb11.des", "", int32_t(0x00000000), int32_t(0xA8D1C43C)},
    {"lobrdb11.lun", "", int32_t(0x00000000), int32_t(0x8F06EB0C)},
    {"lobrdb11.sno", "", int32_t(0x00000000), int32_t(0x464DF44D)},
    {"lobrdb11.tem", "", int32_t(0x00000000), int32_t(0x4EF85A2F)},
    {"lobrdb11.ubn", "", int32_t(0x00000000), int32_t(0x9972F765)},
    {"lobrdb11.urb", "", int32_t(0x00000000), int32_t(0xDA06A91F)},
    {"lobrdb12.des", "", int32_t(0x00000000), int32_t(0xEF71BEEC)},
    {"lobrdb12.lun", "", int32_t(0x00000000), int32_t(0xC8A691DC)},
    {"lobrdb12.sno", "", int32_t(0x00000000), int32_t(0x01ED8E9D)},
    {"lobrdb12.tem", "", int32_t(0x00000000), int32_t(0x095820FF)},
    {"lobrdb12.ubn", "", int32_t(0x00000000), int32_t(0xDED28DB5)},
    {"lobrdb12.urb", "", int32_t(0x00000000), int32_t(0x9DA6D3CF)},
    {"lobrdb13.des", "", int32_t(0x00000000), int32_t(0xD211975C)},
    {"lobrdb13.lun", "", int32_t(0x00000000), int32_t(0xF5C6B86C)},
    {"lobrdb13.sno", "", int32_t(0x00000000), int32_t(0x3C8DA72D)},
    {"lobrdb13.tem", "", int32_t(0x00000000), int32_t(0x3438094F)},
    {"lobrdb13.ubn", "", int32_t(0x00000000), int32_t(0xE3B2A405)},
    {"lobrdb13.urb", "", int32_t(0x00000000), int32_t(0xA0C6FA7F)},
    {"lobrdb14.des", "", int32_t(0x00000000), int32_t(0x60314B4C)},
    {"lobrdb14.lun", "", int32_t(0x00000000), int32_t(0x47E6647C)},
    {"lobrdb14.sno", "", int32_t(0x00000000), int32_t(0x8EAD7B3D)},
    {"lobrdb14.tem", "", int32_t(0x00000000), int32_t(0x8618D55F)},
    {"lobrdb14.ubn", "", int32_t(0x00000000), int32_t(0x51927815)},
    {"lobrdb14.urb", "", int32_t(0x00000000), int32_t(0x12E6266F)},
    {"lobrdb15.des", "", int32_t(0x00000000), int32_t(0x5D5162FC)},
    {"lobrdb15.lun", "", int32_t(0x00000000), int32_t(0x7A864DCC)},
    {"lobrdb15.sno", "", int32_t(0x00000000), int32_t(0xB3CD528D)},
    {"lobrdb15.tem", "", int32_t(0x00000000), int32_t(0xBB78FCEF)},
    {"lobrdb15.ubn", "", int32_t(0x00000000), int32_t(0x6CF251A5)},
    {"lobrdb15.urb", "", int32_t(0x00000000), int32_t(0x2F860FDF)},
    {"lobrdb16.des", "", int32_t(0x00000000), int32_t(0x1AF1182C)},
    {"lobrdb16.lun", "", int32_t(0x00000000), int32_t(0x3D26371C)},
    {"lobrdb16.sno", "", int32_t(0x00000000), int32_t(0xF46D285D)},
    {"lobrdb16.tem", "", int32_t(0x00000000), int32_t(0xFCD8863F)},
    {"lobrdb16.ubn", "", int32_t(0x00000000), int32_t(0x2B522B75)},
    {"lobrdb16.urb", "", int32_t(0x00000000), int32_t(0x6826750F)},
    {"lobrdb17.des", "", int32_t(0x00000000), int32_t(0x2791319C)},
    {"lobrdb17.lun", "", int32_t(0x00000000), int32_t(0x00461EAC)},
    {"lobrdb17.sno", "", int32_t(0x00000000), int32_t(0xC90D01ED)},
    {"lobrdb17.tem", "", int32_t(0x00000000), int32_t(0xC1B8AF8F)},
    {"lobrdb17.ubn", "", int32_t(0x00000000), int32_t(0x163202C5)},
    {"lobrdb17.urb", "", int32_t(0x00000000), int32_t(0x55465CBF)},
    {"lobrdb18.des", "", int32_t(0x00000000), int32_t(0xA5C1A64D)},
    {"lobrdb18.lun", "", int32_t(0x00000000), int32_t(0x8216897D)},
    {"lobrdb18.sno", "", int32_t(0x00000000), int32_t(0x4B5D963C)},
    {"lobrdb18.tem", "", int32_t(0x00000000), int32_t(0x43E8385E)},
    {"lobrdb18.ubn", "", int32_t(0x00000000), int32_t(0x94629514)},
    {"lobrdb18.urb", "", int32_t(0x00000000), int32_t(0xD716CB6E)},
    {"lobrdb19.des", "", int32_t(0x00000000), int32_t(0x98A18FFD)},
    {"lobrdb19.lun", "", int32_t(0x00000000), int32_t(0xBF76A0CD)},
    {"lobrdb19.sno", "", int32_t(0x00000000), int32_t(0x763DBF8C)},
    {"lobrdb19.tem", "", int32_t(0x00000000), int32_t(0x7E8811EE)},
    {"lobrdb19.ubn", "", int32_t(0x00000000), int32_t(0xA902BCA4)},
    {"lobrdb19.urb", "", int32_t(0x00000000), int32_t(0xEA76E2DE)},
    {"lobrdb20.des", "", int32_t(0x00000000), int32_t(0x13259F22)},
    {"lobrdb20.lun", "", int32_t(0x00000000), int32_t(0x34F2B012)},
    {"lobrdb20.sno", "", int32_t(0x00000000), int32_t(0xFDB9AF53)},
    {"lobrdb20.tem", "", int32_t(0x00000000), int32_t(0xF50C0131)},
    {"lobrdb20.ubn", "", int32_t(0x00000000), int32_t(0x2286AC7B)},
    {"lobrdb20.urb", "", int32_t(0x00000000), int32_t(0x61F2F201)},
    {"lobrdb21.des", "", int32_t(0x00000000), int32_t(0x2E45B692)},
    {"lobrdb21.lun", "", int32_t(0x00000000), int32_t(0x099299A2)},
    {"lobrdb21.sno", "", int32_t(0x00000000), int32_t(0xC0D986E3)},
    {"lobrdb21.tem", "", int32_t(0x00000000), int32_t(0xC86C2881)},
    {"lobrdb21.ubn", "", int32_t(0x00000000), int32_t(0x1FE685CB)},
    {"lobrdb21.urb", "", int32_t(0x00000000), int32_t(0x5C92DBB1)},
    {"lobrdb22.des", "", int32_t(0x00000000), int32_t(0x69E5CC42)},
    {"lobrdb22.lun", "", int32_t(0x00000000), int32_t(0x4E32E372)},
    {"lobrdb22.sno", "", int32_t(0x00000000), int32_t(0x8779FC33)},
    {"lobrdb22.tem", "", int32_t(0x00000000), int32_t(0x8FCC5251)},
    {"lobrdb22.ubn", "", int32_t(0x00000000), int32_t(0x5846FF1B)},
    {"lobrdb22.urb", "", int32_t(0x00000000), int32_t(0x1B32A161)},
    {"lobrdb23.des", "", int32_t(0x00000000), int32_t(0x5485E5F2)},
    {"lobrdb23.lun", "", int32_t(0x00000000), int32_t(0x7352CAC2)},
    {"lobrdb23.sno", "", int32_t(0x00000000), int32_t(0xBA19D583)},
    {"lobrdb23.tem", "", int32_t(0x00000000), int32_t(0xB2AC7BE1)},
    {"lobrdb23.ubn", "", int32_t(0x00000000), int32_t(0x6526D6AB)},
    {"lobrdb23.urb", "", int32_t(0x00000000), int32_t(0x265288D1)},
    {"lobrdb24.des", "", int32_t(0x00000000), int32_t(0xE6A539E2)},
    {"lobrdb24.lun", "", int32_t(0x00000000), int32_t(0xC17216D2)},
    {"lobrdb24.sno", "", int32_t(0x00000000), int32_t(0x08390993)},
    {"lobrdb24.tem", "", int32_t(0x00000000), int32_t(0x008CA7F1)},
    {"lobrdb24.ubn", "", int32_t(0x00000000), int32_t(0xD7060ABB)},
    {"lobrdb24.urb", "", int32_t(0x00000000), int32_t(0x947254C1)},
    {"lobrdb25.des", "", int32_t(0x00000000), int32_t(0xDBC51052)},
    {"lobrdb25.lun", "", int32_t(0x00000000), int32_t(0xFC123F62)},
    {"lobrdb25.sno", "", int32_t(0x00000000), int32_t(0x35592023)},
    {"lobrdb25.tem", "", int32_t(0x00000000), int32_t(0x3DEC8E41)},
    {"lobrdb25.ubn", "", int32_t(0x00000000), int32_t(0xEA66230B)},
    {"lobrdb25.urb", "", int32_t(0x00000000), int32_t(0xA9127D71)},
    {"lobrdb26.des", "", int32_t(0x00000000), int32_t(0x9C656A82)},
    {"lobrdb26.lun", "", int32_t(0x00000000), int32_t(0xBBB245B2)},
    {"lobrdb26.sno", "", int32_t(0x00000000), int32_t(0x72F95AF3)},
    {"lobrdb26.tem", "", int32_t(0x00000000), int32_t(0x7A4CF491)},
    {"lobrdb26.ubn", "", int32_t(0x00000000), int32_t(0xADC659DB)},
    {"lobrdb26.urb", "", int32_t(0x00000000), int32_t(0xEEB207A1)},
    {"lobrdb27.des", "", int32_t(0x00000000), int32_t(0xA1054332)},
    {"lobrdb27.lun", "", int32_t(0x00000000), int32_t(0x86D26C02)},
    {"lobrdb27.sno", "", int32_t(0x00000000), int32_t(0x4F997343)},
    {"lobrdb27.tem", "", int32_t(0x00000000), int32_t(0x472CDD21)},
    {"lobrdb27.ubn", "", int32_t(0x00000000), int32_t(0x90A6706B)},
    {"lobrdb27.urb", "", int32_t(0x00000000), int32_t(0xD3D22E11)},
    {"lobrdb28.des", "", int32_t(0x00000000), int32_t(0x2355D4E3)},
    {"lobrdb28.lun", "", int32_t(0x00000000), int32_t(0x0482FBD3)},
    {"lobrdb28.sno", "", int32_t(0x00000000), int32_t(0xCDC9E492)},
    {"lobrdb28.tem", "", int32_t(0x00000000), int32_t(0xC57C4AF0)},
    {"lobrdb28.ubn", "", int32_t(0x00000000), int32_t(0x12F6E7BA)},
    {"lobrdb28.urb", "", int32_t(0x00000000), int32_t(0x5182B9C0)},
    {"lobrdg01.des", "", int32_t(0x00000000), int32_t(0x31B5383E)},
    {"lobrdg01.lun", "", int32_t(0x00000000), int32_t(0x1662170E)},
    {"lobrdg01.sno", "-", int32_t(0x00000000), int32_t(0xDF29084F)},
    {"lobrdg01.tem", "-", int32_t(0x00000000), int32_t(0xD79CA62D)},
    {"lobrdg01.ubn", "", int32_t(0x00000000), int32_t(0x00160B67)},
    {"lobrdg01.urb", "", int32_t(0x00000000), int32_t(0x4362551D)},
    {"lobrdg02.des", "", int32_t(0x00000000), int32_t(0x761542EE)},
    {"lobrdg02.lun", "", int32_t(0x00000000), int32_t(0x51C26DDE)},
    {"lobrdg02.sno", "-", int32_t(0x00000000), int32_t(0x9889729F)},
    {"lobrdg02.tem", "-", int32_t(0x00000000), int32_t(0x903CDCFD)},
    {"lobrdg02.ubn", "", int32_t(0x00000000), int32_t(0x47B671B7)},
    {"lobrdg02.urb", "", int32_t(0x00000000), int32_t(0x04C22FCD)},
    {"lobrdg03.des", "", int32_t(0x00000000), int32_t(0x4B756B5E)},
    {"lobrdg03.lun", "", int32_t(0x00000000), int32_t(0x6CA2446E)},
    {"lobrdg03.sno", "-", int32_t(0x00000000), int32_t(0xA5E95B2F)},
    {"lobrdg03.tem", "-", int32_t(0x00000000), int32_t(0xAD5CF54D)},
    {"lobrdg03.ubn", "", int32_t(0x00000000), int32_t(0x7AD65807)},
    {"lobrdg03.urb", "", int32_t(0x00000000), int32_t(0x39A2067D)},
    {"lobrdg04.des", "", int32_t(0x00000000), int32_t(0xF955B74E)},
    {"lobrdg04.lun", "", int32_t(0x00000000), int32_t(0xDE82987E)},
    {"lobrdg04.sno", "-", int32_t(0x00000000), int32_t(0x17C9873F)},
    {"lobrdg04.tem", "-", int32_t(0x00000000), int32_t(0x1F7C295D)},
    {"lobrdg04.ubn", "", int32_t(0x00000000), int32_t(0xC8F68417)},
    {"lobrdg04.urb", "", int32_t(0x00000000), int32_t(0x8B82DA6D)},
    {"lobrdg05.des", "", int32_t(0x00000000), int32_t(0xC4359EFE)},
    {"lobrdg05.lun", "", int32_t(0x00000000), int32_t(0xE3E2B1CE)},
    {"lobrdg05.sno", "-", int32_t(0x00000000), int32_t(0x2AA9AE8F)},
    {"lobrdg05.tem", "-", int32_t(0x00000000), int32_t(0x221C00ED)},
    {"lobrdg05.ubn", "", int32_t(0x00000000), int32_t(0xF596ADA7)},
    {"lobrdg05.urb", "", int32_t(0x00000000), int32_t(0xB6E2F3DD)},
    {"lobrdg06.des", "", int32_t(0x00000000), int32_t(0x8395E42E)},
    {"lobrdg06.lun", "", int32_t(0x00000000), int32_t(0xA442CB1E)},
    {"lobrdg06.sno", "-", int32_t(0x00000000), int32_t(0x6D09D45F)},
    {"lobrdg06.tem", "-", int32_t(0x00000000), int32_t(0x65BC7A3D)},
    {"lobrdg06.ubn", "", int32_t(0x00000000), int32_t(0xB236D777)},
    {"lobrdg06.urb", "", int32_t(0x00000000), int32_t(0xF142890D)},
    {"lobrdg07.des", "", int32_t(0x00000000), int32_t(0xBEF5CD9E)},
    {"lobrdg07.lun", "", int32_t(0x00000000), int32_t(0x9922E2AE)},
    {"lobrdg07.sno", "-", int32_t(0x00000000), int32_t(0x5069FDEF)},
    {"lobrdg07.tem", "-", int32_t(0x00000000), int32_t(0x58DC538D)},
    {"lobrdg07.ubn", "", int32_t(0x00000000), int32_t(0x8F56FEC7)},
    {"lobrdg07.urb", "", int32_t(0x00000000), int32_t(0xCC22A0BD)},
    {"lobrdg08.des", "", int32_t(0x00000000), int32_t(0x3CA55A4F)},
    {"lobrdg08.lun", "", int32_t(0x00000000), int32_t(0x1B72757F)},
    {"lobrdg08.sno", "-", int32_t(0x00000000), int32_t(0xD2396A3E)},
    {"lobrdg08.tem", "-", int32_t(0x00000000), int32_t(0xDA8CC45C)},
    {"lobrdg08.ubn", "", int32_t(0x00000000), int32_t(0x0D066916)},
    {"lobrdg08.urb", "", int32_t(0x00000000), int32_t(0x4E72376C)},
    {"lobrdg09.des", "", int32_t(0x00000000), int32_t(0x01C573FF)},
    {"lobrdg09.lun", "", int32_t(0x00000000), int32_t(0x26125CCF)},
    {"lobrdg09.sno", "-", int32_t(0x00000000), int32_t(0xEF59438E)},
    {"lobrdg09.tem", "-", int32_t(0x00000000), int32_t(0xE7ECEDEC)},
    {"lobrdg09.ubn", "", int32_t(0x00000000), int32_t(0x306640A6)},
    {"lobrdg09.urb", "", int32_t(0x00000000), int32_t(0x73121EDC)},
    {"lobrdg10.des", "", int32_t(0x00000000), int32_t(0xC789C22B)},
    {"lobrdg10.lun", "", int32_t(0x00000000), int32_t(0xE05EED1B)},
    {"lobrdg10.sno", "-", int32_t(0x00000000), int32_t(0x2915F25A)},
    {"lobrdg10.tem", "-", int32_t(0x00000000), int32_t(0x21A05C38)},
    {"lobrdg10.ubn", "", int32_t(0x00000000), int32_t(0xF62AF172)},
    {"lobrdg10.urb", "", int32_t(0x00000000), int32_t(0xB55EAF08)},
    {"lobrdg11.des", "", int32_t(0x00000000), int32_t(0xFAE9EB9B)},
    {"lobrdg11.lun", "", int32_t(0x00000000), int32_t(0xDD3EC4AB)},
    {"lobrdg11.sno", "-", int32_t(0x00000000), int32_t(0x1475DBEA)},
    {"lobrdg11.tem", "-", int32_t(0x00000000), int32_t(0x1CC07588)},
    {"lobrdg11.ubn", "", int32_t(0x00000000), int32_t(0xCB4AD8C2)},
    {"lobrdg11.urb", "", int32_t(0x00000000), int32_t(0x883E86B8)},
    {"lobrdg12.des", "", int32_t(0x00000000), int32_t(0xBD49914B)},
    {"lobrdg12.lun", "", int32_t(0x00000000), int32_t(0x9A9EBE7B)},
    {"lobrdg12.sno", "-", int32_t(0x00000000), int32_t(0x53D5A13A)},
    {"lobrdg12.tem", "-", int32_t(0x00000000), int32_t(0x5B600F58)},
    {"lobrdg12.ubn", "", int32_t(0x00000000), int32_t(0x8CEAA212)},
    {"lobrdg12.urb", "", int32_t(0x00000000), int32_t(0xCF9EFC68)},
    {"lobrdg13.des", "", int32_t(0x00000000), int32_t(0x8029B8FB)},
    {"lobrdg13.lun", "", int32_t(0x00000000), int32_t(0xA7FE97CB)},
    {"lobrdg13.sno", "-", int32_t(0x00000000), int32_t(0x6EB5888A)},
    {"lobrdg13.tem", "-", int32_t(0x00000000), int32_t(0x660026E8)},
    {"lobrdg13.ubn", "", int32_t(0x00000000), int32_t(0xB18A8BA2)},
    {"lobrdg13.urb", "", int32_t(0x00000000), int32_t(0xF2FED5D8)},
    {"lobrdg14.des", "", int32_t(0x00000000), int32_t(0x320964EB)},
    {"lobrdg14.lun", "", int32_t(0x00000000), int32_t(0x15DE4BDB)},
    {"lobrdg14.sno", "-", int32_t(0x00000000), int32_t(0xDC95549A)},
    {"lobrdg14.tem", "-", int32_t(0x00000000), int32_t(0xD420FAF8)},
    {"lobrdg14.ubn", "", int32_t(0x00000000), int32_t(0x03AA57B2)},
    {"lobrdg14.urb", "", int32_t(0x00000000), int32_t(0x40DE09C8)},
    {"lobrdg15.des", "", int32_t(0x00000000), int32_t(0x0F694D5B)},
    {"lobrdg15.lun", "", int32_t(0x00000000), int32_t(0x28BE626B)},
    {"lobrdg15.sno", "-", int32_t(0x00000000), int32_t(0xE1F57D2A)},
    {"lobrdg15.tem", "-", int32_t(0x00000000), int32_t(0xE940D348)},
    {"lobrdg15.ubn", "", int32_t(0x00000000), int32_t(0x3ECA7E02)},
    {"lobrdg15.urb", "", int32_t(0x00000000), int32_t(0x7DBE2078)},
    {"lobrdg16.des", "", int32_t(0x00000000), int32_t(0x48C9378B)},
    {"lobrdg16.lun", "", int32_t(0x00000000), int32_t(0x6F1E18BB)},
    {"lobrdg16.sno", "-", int32_t(0x00000000), int32_t(0xA65507FA)},
    {"lobrdg16.tem", "-", int32_t(0x00000000), int32_t(0xAEE0A998)},
    {"lobrdg16.ubn", "", int32_t(0x00000000), int32_t(0x796A04D2)},
    {"lobrdg16.urb", "", int32_t(0x00000000), int32_t(0x3A1E5AA8)},
    {"lobrdg17.des", "", int32_t(0x00000000), int32_t(0x75A91E3B)},
    {"lobrdg17.lun", "", int32_t(0x00000000), int32_t(0x527E310B)},
    {"lobrdg17.sno", "-", int32_t(0x00000000), int32_t(0x9B352E4A)},
    {"lobrdg17.tem", "-", int32_t(0x00000000), int32_t(0x93808028)},
    {"lobrdg17.ubn", "", int32_t(0x00000000), int32_t(0x440A2D62)},
    {"lobrdg17.urb", "", int32_t(0x00000000), int32_t(0x077E7318)},
    {"lobrdg18.des", "", int32_t(0x00000000), int32_t(0xF7F989EA)},
    {"lobrdg18.lun", "", int32_t(0x00000000), int32_t(0xD02EA6DA)},
    {"lobrdg18.sno", "-", int32_t(0x00000000), int32_t(0x1965B99B)},
    {"lobrdg18.tem", "-", int32_t(0x00000000), int32_t(0x11D017F9)},
    {"lobrdg18.ubn", "", int32_t(0x00000000), int32_t(0xC65ABAB3)},
    {"lobrdg18.urb", "", int32_t(0x00000000), int32_t(0x852EE4C9)},
    {"lobrdg19.des", "", int32_t(0x00000000), int32_t(0xCA99A05A)},
    {"lobrdg19.lun", "", int32_t(0x00000000), int32_t(0xED4E8F6A)},
    {"lobrdg19.sno", "-", int32_t(0x00000000), int32_t(0x2405902B)},
    {"lobrdg19.tem", "-", int32_t(0x00000000), int32_t(0x2CB03E49)},
    {"lobrdg19.ubn", "", int32_t(0x00000000), int32_t(0xFB3A9303)},
    {"lobrdg19.urb", "", int32_t(0x00000000), int32_t(0xB84ECD79)},
    {"lobrdg20.des", "", int32_t(0x00000000), int32_t(0x411DB085)},
    {"lobrdg20.lun", "", int32_t(0x00000000), int32_t(0x66CA9FB5)},
    {"lobrdg20.sno", "-", int32_t(0x00000000), int32_t(0xAF8180F4)},
    {"lobrdg20.tem", "-", int32_t(0x00000000), int32_t(0xA7342E96)},
    {"lobrdg20.ubn", "", int32_t(0x00000000), int32_t(0x70BE83DC)},
    {"lobrdg20.urb", "", int32_t(0x00000000), int32_t(0x33CADDA6)},
    {"lobrdg21.des", "", int32_t(0x00000000), int32_t(0x7C7D9935)},
    {"lobrdg21.lun", "", int32_t(0x00000000), int32_t(0x5BAAB605)},
    {"lobrdg21.sno", "-", int32_t(0x00000000), int32_t(0x92E1A944)},
    {"lobrdg21.tem", "-", int32_t(0x00000000), int32_t(0x9A540726)},
    {"lobrdg21.ubn", "", int32_t(0x00000000), int32_t(0x4DDEAA6C)},
    {"lobrdg21.urb", "", int32_t(0x00000000), int32_t(0x0EAAF416)},
    {"lobrdg22.des", "", int32_t(0x00000000), int32_t(0x3BDDE3E5)},
    {"lobrdg22.lun", "", int32_t(0x00000000), int32_t(0x1C0ACCD5)},
    {"lobrdg22.sno", "-", int32_t(0x00000000), int32_t(0xD541D394)},
    {"lobrdg22.tem", "-", int32_t(0x00000000), int32_t(0xDDF47DF6)},
    {"lobrdg22.ubn", "", int32_t(0x00000000), int32_t(0x0A7ED0BC)},
    {"lobrdg22.urb", "", int32_t(0x00000000), int32_t(0x490A8EC6)},
    {"lobrdg23.des", "", int32_t(0x00000000), int32_t(0x06BDCA55)},
    {"lobrdg23.lun", "", int32_t(0x00000000), int32_t(0x216AE565)},
    {"lobrdg23.sno", "-", int32_t(0x00000000), int32_t(0xE821FA24)},
    {"lobrdg23.tem", "-", int32_t(0x00000000), int32_t(0xE0945446)},
    {"lobrdg23.ubn", "", int32_t(0x00000000), int32_t(0x371EF90C)},
    {"lobrdg23.urb", "", int32_t(0x00000000), int32_t(0x746AA776)},
    {"lobrdg24.des", "", int32_t(0x00000000), int32_t(0xB49D1645)},
    {"lobrdg24.lun", "", int32_t(0x00000000), int32_t(0x934A3975)},
    {"lobrdg24.sno", "-", int32_t(0x00000000), int32_t(0x5A012634)},
    {"lobrdg24.tem", "-", int32_t(0x00000000), int32_t(0x52B48856)},
    {"lobrdg24.ubn", "", int32_t(0x00000000), int32_t(0x853E251C)},
    {"lobrdg24.urb", "", int32_t(0x00000000), int32_t(0xC64A7B66)},
    {"lobrdg25.des", "", int32_t(0x00000000), int32_t(0x89FD3FF5)},
    {"lobrdg25.lun", "", int32_t(0x00000000), int32_t(0xAE2A10C5)},
    {"lobrdg25.sno", "-", int32_t(0x00000000), int32_t(0x67610F84)},
    {"lobrdg25.tem", "-", int32_t(0x00000000), int32_t(0x6FD4A1E6)},
    {"lobrdg25.ubn", "", int32_t(0x00000000), int32_t(0xB85E0CAC)},
    {"lobrdg25.urb", "", int32_t(0x00000000), int32_t(0xFB2A52D6)},
    {"lobrdg26.des", "", int32_t(0x00000000), int32_t(0xCE5D4525)},
    {"lobrdg26.lun", "", int32_t(0x00000000), int32_t(0xE98A6A15)},
    {"lobrdg26.sno", "-", int32_t(0x00000000), int32_t(0x20C17554)},
    {"lobrdg26.tem", "-", int32_t(0x00000000), int32_t(0x2874DB36)},
    {"lobrdg26.ubn", "", int32_t(0x00000000), int32_t(0xFFFE767C)},
    {"lobrdg26.urb", "", int32_t(0x00000000), int32_t(0xBC8A2806)},
    {"lobrdg27.des", "", int32_t(0x00000000), int32_t(0xF33D6C95)},
    {"lobrdg27.lun", "", int32_t(0x00000000), int32_t(0xD4EA43A5)},
    {"lobrdg27.sno", "-", int32_t(0x00000000), int32_t(0x1DA15CE4)},
    {"lobrdg27.tem", "-", int32_t(0x00000000), int32_t(0x1514F286)},
    {"lobrdg27.ubn", "", int32_t(0x00000000), int32_t(0xC29E5FCC)},
    {"lobrdg27.urb", "", int32_t(0x00000000), int32_t(0x81EA01B6)},
    {"lobrdg28.des", "", int32_t(0x00000000), int32_t(0x716DFB44)},
    {"lobrdg28.lun", "", int32_t(0x00000000), int32_t(0x56BAD474)},
    {"lobrdg28.sno", "-", int32_t(0x00000000), int32_t(0x9FF1CB35)},
    {"lobrdg28.tem", "-", int32_t(0x00000000), int32_t(0x97446557)},
    {"lobrdg28.ubn", "", int32_t(0x00000000), int32_t(0x40CEC81D)},
    {"lobrdg28.urb", "", int32_t(0x00000000), int32_t(0x03BA9667)},
    {"lobrdgb1.des", "", int32_t(0x00000000), int32_t(0x775F94F4)},
    {"lobrdgb1.lun", "", int32_t(0x00000000), int32_t(0x5088BBC4)},
    {"lobrdgb1.sno", "", int32_t(0x00000000), int32_t(0x99C3A485)},
    {"lobrdgb1.tem", "", int32_t(0x00000000), int32_t(0x91760AE7)},
    {"lobrdgb1.ubn", "", int32_t(0x00000000), int32_t(0x46FCA7AD)},
    {"lobrdgb1.urb", "", int32_t(0x00000000), int32_t(0x0588F9D7)},
    {"lobrdgb2.des", "", int32_t(0x00000000), int32_t(0x30FFEE24)},
    {"lobrdgb2.lun", "", int32_t(0x00000000), int32_t(0x1728C114)},
    {"lobrdgb2.sno", "", int32_t(0x00000000), int32_t(0xDE63DE55)},
    {"lobrdgb2.tem", "", int32_t(0x00000000), int32_t(0xD6D67037)},
    {"lobrdgb2.ubn", "", int32_t(0x00000000), int32_t(0x015CDD7D)},
    {"lobrdgb2.urb", "", int32_t(0x00000000), int32_t(0x42288307)},
    {"lobrdgb3.des", "", int32_t(0x00000000), int32_t(0x0D9FC794)},
    {"lobrdgb3.lun", "", int32_t(0x00000000), int32_t(0x2A48E8A4)},
    {"lobrdgb3.sno", "", int32_t(0x00000000), int32_t(0xE303F7E5)},
    {"lobrdgb3.tem", "", int32_t(0x00000000), int32_t(0xEBB65987)},
    {"lobrdgb3.ubn", "", int32_t(0x00000000), int32_t(0x3C3CF4CD)},
    {"lobrdgb3.urb", "", int32_t(0x00000000), int32_t(0x7F48AAB7)},
    {"lobrdgb4.des", "", int32_t(0x00000000), int32_t(0xBFBF1B84)},
    {"lobrdgb4.lun", "", int32_t(0x00000000), int32_t(0x986834B4)},
    {"lobrdgb4.sno", "", int32_t(0x00000000), int32_t(0x51232BF5)},
    {"lobrdgb4.tem", "", int32_t(0x00000000), int32_t(0x59968597)},
    {"lobrdgb4.ubn", "", int32_t(0x00000000), int32_t(0x8E1C28DD)},
    {"lobrdgb4.urb", "", int32_t(0x00000000), int32_t(0xCD6876A7)},
    {"lobrdge1.des", "", int32_t(0x00000000), int32_t(0x6A5AA44C)},
    {"lobrdge1.lun", "", int32_t(0x00000000), int32_t(0x4D8D8B7C)},
    {"lobrdge1.sno", "-", int32_t(0x00000000), int32_t(0x84C6943D)},
    {"lobrdge1.tem", "-", int32_t(0x00000000), int32_t(0x8C733A5F)},
    {"lobrdge1.ubn", "", int32_t(0x00000000), int32_t(0x5BF99715)},
    {"lobrdge1.urb", "", int32_t(0x00000000), int32_t(0x188DC96F)},
    {"lobrdge2.des", "", int32_t(0x00000000), int32_t(0x2DFADE9C)},
    {"lobrdge2.lun", "", int32_t(0x00000000), int32_t(0x0A2DF1AC)},
    {"lobrdge2.sno", "-", int32_t(0x00000000), int32_t(0xC366EEED)},
    {"lobrdge2.tem", "-", int32_t(0x00000000), int32_t(0xCBD3408F)},
    {"lobrdge2.ubn", "", int32_t(0x00000000), int32_t(0x1C59EDC5)},
    {"lobrdge2.urb", "", int32_t(0x00000000), int32_t(0x5F2DB3BF)},
    {"lobrdge3.des", "", int32_t(0x00000000), int32_t(0x109AF72C)},
    {"lobrdge3.lun", "", int32_t(0x00000000), int32_t(0x374DD81C)},
    {"lobrdge3.sno", "-", int32_t(0x00000000), int32_t(0xFE06C75D)},
    {"lobrdge3.tem", "-", int32_t(0x00000000), int32_t(0xF6B3693F)},
    {"lobrdge3.ubn", "", int32_t(0x00000000), int32_t(0x2139C475)},
    {"lobrdge3.urb", "", int32_t(0x00000000), int32_t(0x624D9A0F)},
    {"lobrdge4.des", "", int32_t(0x00000000), int32_t(0xA2BA2B3C)},
    {"lobrdge4.lun", "", int32_t(0x00000000), int32_t(0x856D040C)},
    {"lobrdge4.sno", "-", int32_t(0x00000000), int32_t(0x4C261B4D)},
    {"lobrdge4.tem", "-", int32_t(0x00000000), int32_t(0x4493B52F)},
    {"lobrdge4.ubn", "", int32_t(0x00000000), int32_t(0x93191865)},
    {"lobrdge4.urb", "", int32_t(0x00000000), int32_t(0xD06D461F)},
    {"local mix database.dat", "mix database", int32_t(0x54C2D545), int32_t(0x366E051F)},
    {"local.inf", "inf: list for local.mix", int32_t(0xA19F9A0F), int32_t(0x00000000)},
    {"local.mix", "rmix: local.mix", int32_t(0x97A79A21), int32_t(0xA8548FD9)},
    {"localmd.mix", "", int32_t(0x00000000), int32_t(0xFBE0D09D)},
    {"loginscreen.pal", "", int32_t(0x00000000), int32_t(0xB7A2CFA5)},
    {"loginscreen.shp", "", int32_t(0x00000000), int32_t(0x4CB10699)},
    {"logo.pcx", "", int32_t(0x00000000), int32_t(0xF318CBAA)},
    {"logo.vqa", "westwood logo", int32_t(0xDFDFF4C6), int32_t(0x00000000)},
    {"logo.vqp", "westwood logo", int32_t(0xEEDFF4C6), int32_t(0x00000000)},
    {"logo01.shp", "-", int32_t(0x00000000), int32_t(0xC7A0D8BC)},
    {"logos.shp", "score screen gdi/nod logo", int32_t(0xCDC39A27), int32_t(0x00000000)},
    {"lokbrk1.aud", "", int32_t(0x65D42916), int32_t(0x00000000)},
    {"lol3.fnt", "", int32_t(0xBAE6E4C6), int32_t(0x00000000)},
    {"lolg.csv", "", int32_t(0xE4EBE1C6), int32_t(0x00000000)},
    {"lolg.lsv", "", int32_t(0xE4EBEAC6), int32_t(0x00000000)},
    {"lolg_h.pcx", "", int32_t(0xBD8E2632), int32_t(0x00000000)},
    {"lolg_h.vqa", "", int32_t(0xC98E0F40), int32_t(0x00000000)},
    {"lolg_l.pcx", "", int32_t(0xBD8E2E32), int32_t(0x00000000)},
    {"lonetrop.aud", "lone troop", int32_t(0x00000000), int32_t(0x3B89C1DE)},
    {"loop-1.cps", "pict:", int32_t(0xC799F2DB), int32_t(0x00000000)},
    {"loop-1.wsa", "anim:", int32_t(0xEF99E0DE), int32_t(0x00000000)},
    {"loop-1w.cps", "pict:", int32_t(0x9E3EEFCE), int32_t(0x00000000)},
    {"loop-1w.wsa", "anim:", int32_t(0x9E2CF2E2), int32_t(0x00000000)},
    {"loop-2.cps", "pict:", int32_t(0xC799F4DB), int32_t(0x00000000)},
    {"loop-2.wsa", "anim:", int32_t(0xEF99E2DE), int32_t(0x00000000)},
    {"loop-4.cps", "pict:", int32_t(0xC799F8DB), int32_t(0x00000000)},
    {"loop-4.wsa", "anim:", int32_t(0xEF99E6DE), int32_t(0x00000000)},
    {"loop7.aud", "", int32_t(0xEBBF99E3), int32_t(0x00000000)},
    {"loopie6m.aud", "satellite sounds", int32_t(0x1FFF08F1), int32_t(0x00000000)},
    {"lopower1.aud", "low power", int32_t(0xE43B090D), int32_t(0x00000000)},
    {"lores.mix", "rmix: lores.mix", int32_t(0xA7E39A2F), int32_t(0x00000000)},
    {"lovesong.aud", "", int32_t(0xE84B1D05), int32_t(0x00000000)},
    {"lowern1.aud", "", int32_t(0x72042F16), int32_t(0x00000000)},
    {"lowery1.aud", "", int32_t(0x72044516), int32_t(0x00000000)},
    {"lowhuml1.aud", "", int32_t(0xC84B1909), int32_t(0x00000000)},
    {"lowhuml2.aud", "", int32_t(0xCA4B1909), int32_t(0x00000000)},
    {"lpart1.aud", "", int32_t(0xCB61E82E), int32_t(0x00000000)},
    {"lpst.hva", "-", int32_t(0x00000000), int32_t(0xAC127D8F)},
    {"lpst.vxl", "deployable sensor array", int32_t(0x00000000), int32_t(0x5A98A2C6)},
    {"lpsticon.shp", "-", int32_t(0x00000000), int32_t(0x6CBFF8A5)},
    {"lqatk1.aud", "", int32_t(0xD361EC1C), int32_t(0x00000000)},
    {"lqdam1.aud", "", int32_t(0x876DEC20), int32_t(0x00000000)},
    {"lqdie1.aud", "", int32_t(0xA76DEC10), int32_t(0x00000000)},
    {"lqloitr1.aud", "", int32_t(0xE42B2EF1), int32_t(0x00000000)},
    {"lqloitr2.aud", "", int32_t(0xE62B2EF1), int32_t(0x00000000)},
    {"lredsmk1.shp", "-", int32_t(0x00000000), int32_t(0xEFF4910C)},
    {"lrotor.shp", "rotor shadows", int32_t(0xF79A3E17), int32_t(0x50AE186C)},
    {"lrtest1.aud", "", int32_t(0x71F84718), int32_t(0x00000000)},
    {"ls640a01.shp", "", int32_t(0x00000000), int32_t(0x3B8683AC)},
    {"ls640a02.shp", "", int32_t(0x00000000), int32_t(0x7C26F97C)},
    {"ls640a03.shp", "", int32_t(0x00000000), int32_t(0x4146D0CC)},
    {"ls640a04.shp", "", int32_t(0x00000000), int32_t(0xF3660CDC)},
    {"ls640a05.shp", "", int32_t(0x00000000), int32_t(0xCE06256C)},
    {"ls640a06.shp", "", int32_t(0x00000000), int32_t(0x89A65FBC)},
    {"ls640a07.shp", "", int32_t(0x00000000), int32_t(0xB4C6760C)},
    {"ls640a08.shp", "", int32_t(0x00000000), int32_t(0x3696E1DD)},
    {"ls640a09.shp", "", int32_t(0x00000000), int32_t(0x0BF6C86D)},
    {"ls640a10.shp", "", int32_t(0x00000000), int32_t(0xCDBA79B9)},
    {"ls640a11.shp", "", int32_t(0x00000000), int32_t(0xF0DA5009)},
    {"ls640a12.shp", "", int32_t(0x00000000), int32_t(0xB77A2AD9)},
    {"ls640b01.shp", "", int32_t(0x00000000), int32_t(0x0A6E9931)},
    {"ls640b02.shp", "", int32_t(0x00000000), int32_t(0x4DCEE3E1)},
    {"ls640cuba.shp", "", int32_t(0x00000000), int32_t(0x193EC7A6)},
    {"ls640france.shp", "", int32_t(0x00000000), int32_t(0xDC180955)},
    {"ls640germany.shp", "", int32_t(0x00000000), int32_t(0x8CD344A1)},
    {"ls640iraq.shp", "", int32_t(0x00000000), int32_t(0x5C7B89B5)},
    {"ls640korea.shp", "", int32_t(0x00000000), int32_t(0x05BB63BE)},
    {"ls640libya.shp", "", int32_t(0x00000000), int32_t(0xA64A606F)},
    {"ls640obs.shp", "", int32_t(0x00000000), int32_t(0xCEA17016)},
    {"ls640russia.shp", "", int32_t(0x00000000), int32_t(0x7A82F630)},
    {"ls640s01.shp", "", int32_t(0x00000000), int32_t(0xCBC70E4B)},
    {"ls640s02.shp", "", int32_t(0x00000000), int32_t(0x8C67749B)},
    {"ls640s03.shp", "", int32_t(0x00000000), int32_t(0xB1075D2B)},
    {"ls640s04.shp", "", int32_t(0x00000000), int32_t(0x0327813B)},
    {"ls640s05.shp", "", int32_t(0x00000000), int32_t(0x3E47A88B)},
    {"ls640s06.shp", "", int32_t(0x00000000), int32_t(0x79E7D25B)},
    {"ls640s07.shp", "", int32_t(0x00000000), int32_t(0x4487FBEB)},
    {"ls640s08.shp", "", int32_t(0x00000000), int32_t(0xC6D76C3A)},
    {"ls640s09.shp", "", int32_t(0x00000000), int32_t(0xFBB7458A)},
    {"ls640s10.shp", "", int32_t(0x00000000), int32_t(0x3DFBF45E)},
    {"ls640s11.shp", "", int32_t(0x00000000), int32_t(0x009BDDEE)},
    {"ls640s12.shp", "", int32_t(0x00000000), int32_t(0x473BA73E)},
    {"ls640ukingdom.shp", "", int32_t(0x00000000), int32_t(0x3F3C5D8C)},
    {"ls640ustates.shp", "", int32_t(0x00000000), int32_t(0x61DDFFCA)},
    {"ls800a01.pal", "", int32_t(0x00000000), int32_t(0xBF26BB4C)},
    {"ls800a01.shp", "", int32_t(0x00000000), int32_t(0x78A3E213)},
    {"ls800a02.pal", "", int32_t(0x00000000), int32_t(0xF886C19C)},
    {"ls800a02.shp", "", int32_t(0x00000000), int32_t(0x3F0398C3)},
    {"ls800a03.pal", "", int32_t(0x00000000), int32_t(0xC5E6E82C)},
    {"ls800a03.shp", "", int32_t(0x00000000), int32_t(0x0263B173)},
    {"ls800a04.pal", "", int32_t(0x00000000), int32_t(0x77C6343C)},
    {"ls800a04.shp", "", int32_t(0x00000000), int32_t(0xB0436D63)},
    {"ls800a05.pal", "", int32_t(0x00000000), int32_t(0x4AA61D8C)},
    {"ls800a05.shp", "", int32_t(0x00000000), int32_t(0x8D2344D3)},
    {"ls800a06.pal", "", int32_t(0x00000000), int32_t(0x0D06675C)},
    {"ls800a06.shp", "", int32_t(0x00000000), int32_t(0xCA833E03)},
    {"ls800a07.pal", "", int32_t(0x00000000), int32_t(0x30664EEC)},
    {"ls800a07.shp", "", int32_t(0x00000000), int32_t(0xF7E317B3)},
    {"ls800a08.shp", "", int32_t(0x00000000), int32_t(0x75B38062)},
    {"ls800a09.shp", "", int32_t(0x00000000), int32_t(0x48D3A9D2)},
    {"ls800a10.shp", "", int32_t(0x00000000), int32_t(0x8E9F1806)},
    {"ls800a11.shp", "", int32_t(0x00000000), int32_t(0xB3FF31B6)},
    {"ls800a12.shp", "", int32_t(0x00000000), int32_t(0xF45F4B66)},
    {"ls800b01.shp", "", int32_t(0x00000000), int32_t(0x494BF88E)},
    {"ls800b02.shp", "", int32_t(0x00000000), int32_t(0x0EEB825E)},
    {"ls800ca.pal", "", int32_t(0x00000000), int32_t(0xCFBE48F6)},
    {"ls800ca.shp", "", int32_t(0x00000000), int32_t(0x34AD81CA)},
    {"ls800cs.pal", "", int32_t(0x00000000), int32_t(0x81A0EB66)},
    {"ls800cs.shp", "", int32_t(0x00000000), int32_t(0x7AB3225A)},
    {"ls800cuba.shp", "", int32_t(0x00000000), int32_t(0x121CF8B0)},
    {"ls800cwa.pal", "", int32_t(0x00000000), int32_t(0xC49A7548)},
    {"ls800cwa.shp", "", int32_t(0x00000000), int32_t(0x031F2C17)},
    {"ls800cy.pal", "", int32_t(0x00000000), int32_t(0x203BC800)},
    {"ls800cy.shp", "", int32_t(0x00000000), int32_t(0xDB28013C)},
    {"ls800france.shp", "", int32_t(0x00000000), int32_t(0xD73A3643)},
    {"ls800germany.shp", "", int32_t(0x00000000), int32_t(0x87F17BB7)},
    {"ls800iraq.shp", "", int32_t(0x00000000), int32_t(0x5759B6A3)},
    {"ls800korea.shp", "", int32_t(0x00000000), int32_t(0x0E995CA8)},
    {"ls800libya.shp", "", int32_t(0x00000000), int32_t(0xAD685F79)},
    {"ls800obs.shp", "", int32_t(0x00000000), int32_t(0x8D8411A9)},
    {"ls800russia.shp", "", int32_t(0x00000000), int32_t(0x71A0C926)},
    {"ls800s01.pal", "", int32_t(0x00000000), int32_t(0x4F6736AB)},
    {"ls800s01.shp", "", int32_t(0x00000000), int32_t(0x88E26FF4)},
    {"ls800s02.pal", "", int32_t(0x00000000), int32_t(0x08C74C7B)},
    {"ls800s02.shp", "", int32_t(0x00000000), int32_t(0xCF421524)},
    {"ls800s03.pal", "", int32_t(0x00000000), int32_t(0x35A765CB)},
    {"ls800s03.shp", "", int32_t(0x00000000), int32_t(0xF2223C94)},
    {"ls800s04.pal", "", int32_t(0x00000000), int32_t(0x8787B9DB)},
    {"ls800s04.shp", "", int32_t(0x00000000), int32_t(0x4002E084)},
    {"ls800s05.pal", "", int32_t(0x00000000), int32_t(0xBAE7906B)},
    {"ls800s05.shp", "", int32_t(0x00000000), int32_t(0x7D62C934)},
    {"ls800s06.pal", "", int32_t(0x00000000), int32_t(0xFD47EABB)},
    {"ls800s06.shp", "", int32_t(0x00000000), int32_t(0x3AC2B3E4)},
    {"ls800s07.pal", "", int32_t(0x00000000), int32_t(0xC027C30B)},
    {"ls800s07.shp", "", int32_t(0x00000000), int32_t(0x07A29A54)},
    {"ls800s08.shp", "", int32_t(0x00000000), int32_t(0x85F20D85)},
    {"ls800s09.shp", "", int32_t(0x00000000), int32_t(0xB8922435)},
    {"ls800s10.shp", "", int32_t(0x00000000), int32_t(0x7EDE95E1)},
    {"ls800s11.shp", "", int32_t(0x00000000), int32_t(0x43BEBC51)},
    {"ls800s12.shp", "", int32_t(0x00000000), int32_t(0x041EC681)},
    {"ls800ukingdom.shp", "", int32_t(0x00000000), int32_t(0x551968CA)},
    {"ls800ustates.shp", "", int32_t(0x00000000), int32_t(0x6AFFC0DC)},
    {"ls800yuri.shp", "", int32_t(0x00000000), int32_t(0x21603D3B)},
    {"lspacer.shp", "", int32_t(0x00000000), int32_t(0xD508C1A4)},
    {"lst.shp", "hovercraft", int32_t(0x5CF8EEEB), int32_t(0x00000000)},
    {"lsticnh.des", "icon: hovercraft", int32_t(0x82352EFB), int32_t(0x00000000)},
    {"lsticnh.tem", "icon: hovercraft", int32_t(0x822F2F0B), int32_t(0x00000000)},
    {"lsticnh.win", "icon: hovercraft", int32_t(0x8230330E), int32_t(0x00000000)},
    {"lsticon.shp", "icon: hovercraft", int32_t(0x823E340A), int32_t(0x00000000)},
    {"lt_eur01.des", "", int32_t(0x00000000), int32_t(0x2364DC8D)},
    {"lt_eur01.lun", "", int32_t(0x00000000), int32_t(0x04B3F3BD)},
    {"lt_eur01.sno", "", int32_t(0x00000000), int32_t(0xCDF8ECFC)},
    {"lt_eur01.tem", "", int32_t(0x00000000), int32_t(0xC54D429E)},
    {"lt_eur01.ubn", "", int32_t(0x00000000), int32_t(0x12C7EFD4)},
    {"lt_eur01.urb", "", int32_t(0x00000000), int32_t(0x51B3B1AE)},
    {"lt_eur02.des", "", int32_t(0x00000000), int32_t(0x64C4A65D)},
    {"lt_eur02.lun", "", int32_t(0x00000000), int32_t(0x4313896D)},
    {"lt_eur02.sno", "", int32_t(0x00000000), int32_t(0x8A58962C)},
    {"lt_eur02.tem", "", int32_t(0x00000000), int32_t(0x82ED384E)},
    {"lt_eur02.ubn", "", int32_t(0x00000000), int32_t(0x55679504)},
    {"lt_eur02.urb", "", int32_t(0x00000000), int32_t(0x1613CB7E)},
    {"lt_gen01.des", "", int32_t(0x00000000), int32_t(0xD157339A)},
    {"lt_gen01.lun", "", int32_t(0x00000000), int32_t(0xF6801CAA)},
    {"lt_gen01.sno", "", int32_t(0x00000000), int32_t(0x3FCB03EB)},
    {"lt_gen01.tem", "", int32_t(0x00000000), int32_t(0x377EAD89)},
    {"lt_gen01.ubn", "", int32_t(0x00000000), int32_t(0xE0F400C3)},
    {"lt_gen01.urb", "", int32_t(0x00000000), int32_t(0xA3805EB9)},
    {"lt_gen02.des", "", int32_t(0x00000000), int32_t(0x96F7494A)},
    {"lt_gen02.lun", "", int32_t(0x00000000), int32_t(0xB120667A)},
    {"lt_gen02.sno", "", int32_t(0x00000000), int32_t(0x786B793B)},
    {"lt_gen02.tem", "", int32_t(0x00000000), int32_t(0x70DED759)},
    {"lt_gen02.ubn", "", int32_t(0x00000000), int32_t(0xA7547A13)},
    {"lt_gen02.urb", "", int32_t(0x00000000), int32_t(0xE4202469)},
    {"lt_gen03.des", "", int32_t(0x00000000), int32_t(0xAB9760FA)},
    {"lt_gen03.lun", "", int32_t(0x00000000), int32_t(0x8C404FCA)},
    {"lt_gen03.sno", "", int32_t(0x00000000), int32_t(0x450B508B)},
    {"lt_gen03.tem", "", int32_t(0x00000000), int32_t(0x4DBEFEE9)},
    {"lt_gen03.ubn", "", int32_t(0x00000000), int32_t(0x9A3453A3)},
    {"lt_gen03.urb", "", int32_t(0x00000000), int32_t(0xD9400DD9)},
    {"lt_gen04.des", "", int32_t(0x00000000), int32_t(0x19B7BCEA)},
    {"lt_gen04.lun", "", int32_t(0x00000000), int32_t(0x3E6093DA)},
    {"lt_gen04.sno", "", int32_t(0x00000000), int32_t(0xF72B8C9B)},
    {"lt_gen04.tem", "", int32_t(0x00000000), int32_t(0xFF9E22F9)},
    {"lt_gen04.ubn", "", int32_t(0x00000000), int32_t(0x28148FB3)},
    {"lt_gen04.urb", "", int32_t(0x00000000), int32_t(0x6B60D1C9)},
    {"lt_sgn01.des", "", int32_t(0x00000000), int32_t(0x625E279A)},
    {"lt_sgn01.lun", "", int32_t(0x00000000), int32_t(0x458908AA)},
    {"lt_sgn01.sno", "", int32_t(0x00000000), int32_t(0x8CC217EB)},
    {"lt_sgn01.tem", "", int32_t(0x00000000), int32_t(0x8477B989)},
    {"lt_sgn01.ubn", "", int32_t(0x00000000), int32_t(0x53FD14C3)},
    {"lt_sgn01.urb", "", int32_t(0x00000000), int32_t(0x10894AB9)},
    {"lt_sgn02.des", "", int32_t(0x00000000), int32_t(0x25FE5D4A)},
    {"lt_sgn02.lun", "", int32_t(0x00000000), int32_t(0x0229727A)},
    {"lt_sgn02.sno", "", int32_t(0x00000000), int32_t(0xCB626D3B)},
    {"lt_sgn02.tem", "", int32_t(0x00000000), int32_t(0xC3D7C359)},
    {"lt_sgn02.ubn", "", int32_t(0x00000000), int32_t(0x145D6E13)},
    {"lt_sgn02.urb", "", int32_t(0x00000000), int32_t(0x57293069)},
    {"lt_sgn03.des", "", int32_t(0x00000000), int32_t(0x189E74FA)},
    {"lt_sgn03.lun", "", int32_t(0x00000000), int32_t(0x3F495BCA)},
    {"lt_sgn03.sno", "", int32_t(0x00000000), int32_t(0xF602448B)},
    {"lt_sgn03.tem", "", int32_t(0x00000000), int32_t(0xFEB7EAE9)},
    {"lt_sgn03.ubn", "", int32_t(0x00000000), int32_t(0x293D47A3)},
    {"lt_sgn03.urb", "", int32_t(0x00000000), int32_t(0x6A4919D9)},
    {"lt_sgn04.des", "", int32_t(0x00000000), int32_t(0xAABEA8EA)},
    {"lt_sgn04.lun", "", int32_t(0x00000000), int32_t(0x8D6987DA)},
    {"lt_sgn04.sno", "", int32_t(0x00000000), int32_t(0x4422989B)},
    {"lt_sgn04.tem", "", int32_t(0x00000000), int32_t(0x4C9736F9)},
    {"lt_sgn04.ubn", "", int32_t(0x00000000), int32_t(0x9B1D9BB3)},
    {"lt_sgn04.urb", "", int32_t(0x00000000), int32_t(0xD869C5C9)},
    {"ltlman.flc", "", int32_t(0xC18E30FF), int32_t(0x00000000)},
    {"ltnk.hva", "", int32_t(0x00000000), int32_t(0x05A5488A)},
    {"ltnk.shp", "light tank", int32_t(0xE6E4FBC6), int32_t(0x00000000)},
    {"ltnk.vxl", "", int32_t(0x00000000), int32_t(0xF32F97C3)},
    {"ltnkbarl.hva", "", int32_t(0x00000000), int32_t(0xDCB01039)},
    {"ltnkbarl.vxl", "", int32_t(0x00000000), int32_t(0x2A3ACF70)},
    {"ltnkicnh.des", "icon: light tank", int32_t(0x111B1BF1), int32_t(0x00000000)},
    {"ltnkicnh.tem", "icon: light tank", int32_t(0x0B1B2BF1), int32_t(0x00000000)},
    {"ltnkicnh.win", "icon: light tank", int32_t(0x0C1F2EF1), int32_t(0x00000000)},
    {"ltnkicon.shp", "icon: light tank", int32_t(0x1A202AF1), int32_t(0x7D4F0CDF)},
    {"ltnktur.hva", "", int32_t(0x00000000), int32_t(0x83A336EA)},
    {"ltnktur.vxl", "", int32_t(0x00000000), int32_t(0x8C554501)},
    {"ltnkuico.shp", "", int32_t(0x00000000), int32_t(0xB8899E3E)},
    {"lun.mix", "", int32_t(0x00000000), int32_t(0xDC0084EB)},
    {"lunar.mix", "", int32_t(0x00000000), int32_t(0x78C2BB3F)},
    {"lunar.pal", "", int32_t(0x00000000), int32_t(0x1CF5225B)},
    {"lunarmd.ini", "", int32_t(0x00000000), int32_t(0xF28246B9)},
    {"lunr.shp", "", int32_t(0x00000000), int32_t(0x60A0E571)},
    {"lunricon.shp", "", int32_t(0x00000000), int32_t(0xBCA22735)},
    {"lunrk1.des", "", int32_t(0x00000000), int32_t(0x87041672)},
    {"lunrk1.lun", "", int32_t(0x00000000), int32_t(0xEE242A6B)},
    {"lunrk1.ubn", "", int32_t(0x00000000), int32_t(0xCDC93579)},
    {"lunrk2.des", "", int32_t(0x00000000), int32_t(0xB6EC0CEF)},
    {"lunrk2.lun", "", int32_t(0x00000000), int32_t(0xDFCC30F6)},
    {"lunrk2.shp", "", int32_t(0x00000000), int32_t(0xEAB15D44)},
    {"lunrk2.ubn", "", int32_t(0x00000000), int32_t(0xFC212FE4)},
    {"lunrk3.des", "", int32_t(0x00000000), int32_t(0x109B075B)},
    {"lunrk3.lun", "", int32_t(0x00000000), int32_t(0x79BB3B42)},
    {"lunrk3.ubn", "", int32_t(0x00000000), int32_t(0x5A562450)},
    {"lunrk4.des", "", int32_t(0x00000000), int32_t(0xD53C39D5)},
    {"lunrk4.lun", "", int32_t(0x00000000), int32_t(0xBC1C05CC)},
    {"lunrk4.ubn", "", int32_t(0x00000000), int32_t(0x9FF11ADE)},
    {"lunrk5.des", "", int32_t(0x00000000), int32_t(0x734B3261)},
    {"lunrk5.lun", "", int32_t(0x00000000), int32_t(0x1A6B0E78)},
    {"lunrk5.ubn", "", int32_t(0x00000000), int32_t(0x3986116A)},
    {"lunrk6.des", "", int32_t(0x00000000), int32_t(0x42A328FC)},
    {"lunrk6.lun", "", int32_t(0x00000000), int32_t(0x2B8314E5)},
    {"lunrk6.ubn", "", int32_t(0x00000000), int32_t(0x086E0BF7)},
    {"lunruico.shp", "", int32_t(0x00000000), int32_t(0x7964B5D4)},
    {"lupp2.img", "", int32_t(0xDBD3B1DC), int32_t(0x00000000)},
    {"lupp2.lmf", "", int32_t(0xDBD9B1DB), int32_t(0x00000000)},
    {"lupp2.lsv", "", int32_t(0xE7D9B1EB), int32_t(0x00000000)},
    {"lupp2.odf", "", int32_t(0xC9DFB1DB), int32_t(0x00000000)},
    {"lupp2.pcx", "", int32_t(0xC7E1B1ED), int32_t(0x00000000)},
    {"lupp2.ver", "", int32_t(0xCBEDB1E7), int32_t(0x00000000)},
    {"luth_inv.wsa", "", int32_t(0x0F413F1D), int32_t(0x00000000)},
    {"luth_lch.wsa", "", int32_t(0xF32B451D), int32_t(0x00000000)},
    {"luthrdie.csv", "", int32_t(0x02372103), int32_t(0x00000000)},
    {"luthrdie.lsv", "", int32_t(0x02372A03), int32_t(0x00000000)},
    {"luthrdie.vqa", "", int32_t(0xED353403), int32_t(0x00000000)},
    {"luthrdie_e.vqa", "", int32_t(0x042487B9), int32_t(0x00000000)},
    {"luthrdie_e.vqt", "", int32_t(0x04249AB9), int32_t(0x00000000)},
    {"luthrdie_h.pcx", "", int32_t(0xF824A4AC), int32_t(0x00000000)},
    {"luthrdie_h.vqa", "", int32_t(0x04248DB9), int32_t(0x00000000)},
    {"luthrdie_l.pcx", "", int32_t(0xF824ACAC), int32_t(0x00000000)},
    {"luthrdie_l.vqa", "", int32_t(0x042495B9), int32_t(0x00000000)},
    {"lvlshots\\l10_dc_h.pcx", "", int32_t(0x24078F4F), int32_t(0x00000000)},
    {"lvlshots\\l10_dc_l.pcx", "", int32_t(0x24078F57), int32_t(0x00000000)},
    {"lvlshots\\l12_cm_h.pcx", "", int32_t(0x342F8B4F), int32_t(0x00000000)},
    {"lvlshots\\l12_cm_l.pcx", "", int32_t(0x342F8B57), int32_t(0x00000000)},
    {"lvlshots\\l13_rc_h.pcx", "", int32_t(0x3C07C74F), int32_t(0x00000000)},
    {"lvlshots\\l13_rc_l.pcx", "", int32_t(0x3C07C757), int32_t(0x00000000)},
    {"lvlshots\\l14_ht_h.pcx", "", int32_t(0x444B9F4F), int32_t(0x00000000)},
    {"lvlshots\\l14_ht_l.pcx", "", int32_t(0x444B9F57), int32_t(0x00000000)},
    {"lvlshots\\l16_ca_h.pcx", "", int32_t(0x53FF8B4F), int32_t(0x00000000)},
    {"lvlshots\\l16_ca_l.pcx", "", int32_t(0x53FF8B57), int32_t(0x00000000)},
    {"lvlshots\\l17_hc_h.pcx", "", int32_t(0x5C079F4F), int32_t(0x00000000)},
    {"lvlshots\\l17_hc_l.pcx", "", int32_t(0x5C079F57), int32_t(0x00000000)},
    {"lvlshots\\l19_bc_h.pcx", "", int32_t(0x6C07874F), int32_t(0x00000000)},
    {"lvlshots\\l19_bc_l.pcx", "", int32_t(0x6C078757), int32_t(0x00000000)},
    {"lvlshots\\l1_dc_h.pcx", "", int32_t(0x352EE72B), int32_t(0x00000000)},
    {"lvlshots\\l1_dc_l.pcx", "", int32_t(0x3D2EE72B), int32_t(0x00000000)},
    {"lvlshots\\l20_bb_h.pcx", "", int32_t(0x240B874F), int32_t(0x00000000)},
    {"lvlshots\\l20_bb_l.pcx", "", int32_t(0x240B8757), int32_t(0x00000000)},
    {"lvlshots\\l3_dh_h.pcx", "", int32_t(0x3536F12B), int32_t(0x00000000)},
    {"lvlshots\\l3_dh_l.pcx", "", int32_t(0x3D36F12B), int32_t(0x00000000)},
    {"lvlshots\\l4_hj_h.pcx", "", int32_t(0x353AF533), int32_t(0x00000000)},
    {"lvlshots\\l4_hj_l.pcx", "", int32_t(0x3D3AF533), int32_t(0x00000000)},
    {"lvlshots\\l5_hc_h.pcx", "", int32_t(0x353EE733), int32_t(0x00000000)},
    {"lvlshots\\l5_hc_l.pcx", "", int32_t(0x3D3EE733), int32_t(0x00000000)},
    {"lvlshots\\l7_dh_h.pcx", "", int32_t(0x3546F12B), int32_t(0x00000000)},
    {"lvlshots\\l7_dh_l.pcx", "", int32_t(0x3D46F12B), int32_t(0x00000000)},
    {"lvlshots\\l8_sj_h.pcx", "", int32_t(0x354AF549), int32_t(0x00000000)},
    {"lvlshots\\l8_sj_l.pcx", "", int32_t(0x3D4AF549), int32_t(0x00000000)},
    {"lvlshots\\l9_dr_h.pcx", "", int32_t(0x354F052B), int32_t(0x00000000)},
    {"lvlshots\\l9_dr_l.pcx", "", int32_t(0x3D4F052B), int32_t(0x00000000)},
    {"lvlshots\\qwod0.pcx", "", int32_t(0xAD21DD40), int32_t(0x00000000)},
    {"lwal0001.int", "brown walls", int32_t(0xE7B406BF), int32_t(0x00000000)},
    {"lwal0002.int", "brown walls", int32_t(0xE9B406BF), int32_t(0x00000000)},
    {"lwal0003.int", "brown walls", int32_t(0xEBB406BF), int32_t(0x00000000)},
    {"lwal0004.int", "brown walls", int32_t(0xEDB406BF), int32_t(0x00000000)},
    {"lwal0005.int", "brown walls", int32_t(0xEFB406BF), int32_t(0x00000000)},
    {"lwal0006.int", "brown walls", int32_t(0xF1B406BF), int32_t(0x00000000)},
    {"lwal0007.int", "brown walls", int32_t(0xF3B406BF), int32_t(0x00000000)},
    {"lwal0008.int", "brown walls", int32_t(0xF5B406BF), int32_t(0x00000000)},
    {"lwal0009.int", "brown walls", int32_t(0xF7B406BF), int32_t(0x00000000)},
    {"lwal0010.int", "brown walls", int32_t(0xE5B606BF), int32_t(0x00000000)},
    {"lwal0011.int", "brown walls", int32_t(0xE7B606BF), int32_t(0x00000000)},
    {"lwal0012.int", "brown walls", int32_t(0xE9B606BF), int32_t(0x00000000)},
    {"lwal0013.int", "brown walls", int32_t(0xEBB606BF), int32_t(0x00000000)},
    {"lwal0014.int", "brown walls", int32_t(0xEDB606BF), int32_t(0x00000000)},
    {"lwal0015.int", "brown walls", int32_t(0xEFB606BF), int32_t(0x00000000)},
    {"lwal0016.int", "brown walls", int32_t(0xF1B606BF), int32_t(0x00000000)},
    {"lwal0017.int", "brown walls", int32_t(0xF3B606BF), int32_t(0x00000000)},
    {"lwal0018.int", "brown walls", int32_t(0xF5B606BF), int32_t(0x00000000)},
    {"lwal0019.int", "brown walls", int32_t(0xF7B606BF), int32_t(0x00000000)},
    {"lwal0020.int", "brown walls", int32_t(0xE5B806BF), int32_t(0x00000000)},
    {"lwal0021.int", "brown walls", int32_t(0xE7B806BF), int32_t(0x00000000)},
    {"lwal0022.int", "brown walls", int32_t(0xE9B806BF), int32_t(0x00000000)},
    {"lwal0023.int", "brown walls", int32_t(0xEBB806BF), int32_t(0x00000000)},
    {"lwal0024.int", "brown walls", int32_t(0xEDB806BF), int32_t(0x00000000)},
    {"lwal0025.int", "brown walls", int32_t(0xEFB806BF), int32_t(0x00000000)},
    {"lwal0026.int", "brown walls", int32_t(0xF1B806BF), int32_t(0x00000000)},
    {"lwal0027.int", "brown walls", int32_t(0xF3B806BF), int32_t(0x00000000)},
    {"lwscrnl.shp", "", int32_t(0x00000000), int32_t(0x2BDA2707)},
    {"lwscrns.shp", "", int32_t(0x00000000), int32_t(0xD95A9749)},
    {"lzrd_inv.wsa", "", int32_t(0xFF39531D), int32_t(0x00000000)},
    {"lzrd_lch.wsa", "", int32_t(0xE323591D), int32_t(0x00000000)},
    {"m113.hva", "-", int32_t(0x00000000), int32_t(0x23573F4C)},
    {"m113.vxl", "apc", int32_t(0x00000000), int32_t(0xD5DDE005)},
    {"m113tur.hva", "-", int32_t(0x00000000), int32_t(0x75BCFF27)},
    {"m113tur.vxl", "apc", int32_t(0x00000000), int32_t(0x7A4A8CCC)},
    {"m_armgd1.aud", "", int32_t(0xEFE34CFD), int32_t(0x00000000)},
    {"m_armor1.aud", "", int32_t(0xEFFF5CFD), int32_t(0x00000000)},
    {"m_drk1.aud", "", int32_t(0xCB6E2420), int32_t(0x00000000)},
    {"m_emp.hva", "-", int32_t(0x00000000), int32_t(0x3D3E2867)},
    {"m_emp.vxl", "mobile emp", int32_t(0x00000000), int32_t(0x82A72FC0)},
    {"m_heal1.aud", "", int32_t(0x71C86AF8), int32_t(0x00000000)},
    {"m_hello1.aud", "", int32_t(0xBC1556FB), int32_t(0x00000000)},
    {"m_hello2.aud", "", int32_t(0xBE1556FB), int32_t(0x00000000)},
    {"m_ion1.aud", "", int32_t(0xBF822426), int32_t(0x00000000)},
    {"m_loser1.aud", "", int32_t(0xE42B4909), int32_t(0x00000000)},
    {"m_mapup1.aud", "", int32_t(0xAC2B6903), int32_t(0x00000000)},
    {"m_megaa1.aud", "", int32_t(0xBC0D40F1), int32_t(0x00000000)},
    {"m_megarr.aud", "", int32_t(0xFE2F40F1), int32_t(0x00000000)},
    {"m_megas1.aud", "", int32_t(0xBC3140F1), int32_t(0x00000000)},
    {"m_megaw1.aud", "", int32_t(0xBC3940F1), int32_t(0x00000000)},
    {"m_mgarng.aud", "", int32_t(0xF02762E5), int32_t(0x00000000)},
    {"m_nuke1.aud", "", int32_t(0xB1E05D0C), int32_t(0x00000000)},
    {"m_radar1.aud", "", int32_t(0xAC4340EB), int32_t(0x00000000)},
    {"m_range1.aud", "", int32_t(0xAC294CFF), int32_t(0x00000000)},
    {"m_rapid1.aud", "", int32_t(0xAC275103), int32_t(0x00000000)},
    {"m_sorry1.aud", "", int32_t(0xE4556307), int32_t(0x00000000)},
    {"m_speed1.aud", "", int32_t(0xE82B48ED), int32_t(0x00000000)},
    {"m_stlall.aud", "", int32_t(0x2E3B40FB), int32_t(0x00000000)},
    {"m_stltha.aud", "", int32_t(0x183366FB), int32_t(0x00000000)},
    {"m_stlthd.aud", "", int32_t(0x1E3366FB), int32_t(0x00000000)},
    {"m_ubtel1.aud", "", int32_t(0xB043490B), int32_t(0x00000000)},
    {"m_unit1.aud", "", int32_t(0x95FC7B08), int32_t(0x00000000)},
    {"m_weapn1.aud", "", int32_t(0xBC4F5EE5), int32_t(0x00000000)},
    {"ma01-min.set", "", int32_t(0xB598F2BD), int32_t(0x00000000)},
    {"ma01.vqa", "", int32_t(0xA3B1D8C8), int32_t(0x00000000)},
    {"ma01_0.vqa", "", int32_t(0x711DA744), int32_t(0x00000000)},
    {"ma01_1.vqa", "", int32_t(0x711DA944), int32_t(0x00000000)},
    {"ma01_2.vqa", "", int32_t(0x711DAB44), int32_t(0x00000000)},
    {"ma01_3.vqa", "", int32_t(0x711DAD44), int32_t(0x00000000)},
    {"ma01spnr.vqa", "", int32_t(0xAAAEFC09), int32_t(0x00000000)},
    {"ma02-min.set", "", int32_t(0xB998F2BD), int32_t(0x00000000)},
    {"ma02.vqa", "", int32_t(0xA5B1D8C8), int32_t(0x00000000)},
    {"ma02_0.vqa", "", int32_t(0x751DA744), int32_t(0x00000000)},
    {"ma02_1.vqa", "", int32_t(0x751DA944), int32_t(0x00000000)},
    {"ma02_2.vqa", "", int32_t(0x751DAB44), int32_t(0x00000000)},
    {"ma02_3.vqa", "", int32_t(0x751DAD44), int32_t(0x00000000)},
    {"ma02over.vqa", "", int32_t(0xAE9D0801), int32_t(0x00000000)},
    {"ma04-min.set", "", int32_t(0xC198F2BD), int32_t(0x00000000)},
    {"ma04.vqa", "", int32_t(0xA9B1D8C8), int32_t(0x00000000)},
    {"ma04_0.vqa", "", int32_t(0x7D1DA744), int32_t(0x00000000)},
    {"ma04_1.vqa", "", int32_t(0x7D1DA944), int32_t(0x00000000)},
    {"ma04_2.vqa", "", int32_t(0x7D1DAB44), int32_t(0x00000000)},
    {"ma04_3.vqa", "", int32_t(0x7D1DAD44), int32_t(0x00000000)},
    {"ma04over.vqa", "", int32_t(0xB69D0801), int32_t(0x00000000)},
    {"ma04ovr2.vqa", "", int32_t(0x76B70801), int32_t(0x00000000)},
    {"ma04vo1a.aud", "", int32_t(0x9778E50F), int32_t(0x00000000)},
    {"ma05-min.set", "", int32_t(0xC598F2BD), int32_t(0x00000000)},
    {"ma05.vqa", "", int32_t(0xABB1D8C8), int32_t(0x00000000)},
    {"ma05_0.vqa", "", int32_t(0x811DA744), int32_t(0x00000000)},
    {"ma05_1.vqa", "", int32_t(0x811DA944), int32_t(0x00000000)},
    {"ma05_2.vqa", "", int32_t(0x811DAB44), int32_t(0x00000000)},
    {"ma05_3.vqa", "", int32_t(0x811DAD44), int32_t(0x00000000)},
    {"ma06-min.set", "", int32_t(0xC998F2BD), int32_t(0x00000000)},
    {"ma06.vqa", "", int32_t(0xADB1D8C8), int32_t(0x00000000)},
    {"ma06_0.vqa", "", int32_t(0x851DA744), int32_t(0x00000000)},
    {"ma06_1.vqa", "", int32_t(0x851DA944), int32_t(0x00000000)},
    {"ma06_2.vqa", "", int32_t(0x851DAB44), int32_t(0x00000000)},
    {"ma06_3.vqa", "", int32_t(0x851DAD44), int32_t(0x00000000)},
    {"ma06elev.vqa", "", int32_t(0xC69CF3ED), int32_t(0x00000000)},
    {"ma07-min.set", "", int32_t(0xCD98F2BD), int32_t(0x00000000)},
    {"ma07.vqa", "", int32_t(0xAFB1D8C8), int32_t(0x00000000)},
    {"ma07_0.vqa", "", int32_t(0x891DA744), int32_t(0x00000000)},
    {"ma07_1.vqa", "", int32_t(0x891DA944), int32_t(0x00000000)},
    {"ma07_2.vqa", "", int32_t(0x891DAB44), int32_t(0x00000000)},
    {"ma07_3.vqa", "", int32_t(0x891DAD44), int32_t(0x00000000)},
    {"ma08-min.set", "", int32_t(0xD198F2BD), int32_t(0x00000000)},
    {"ma1ev01.wav", "", int32_t(0x00000000), int32_t(0x097C78EA)},
    {"ma1ev02.wav", "", int32_t(0x00000000), int32_t(0x8FE80A44)},
    {"ma1ev03.wav", "", int32_t(0x00000000), int32_t(0x44B4D9E1)},
    {"ma1ev04.wav", "", int32_t(0x00000000), int32_t(0x59B1E959)},
    {"ma1ev05.wav", "", int32_t(0x00000000), int32_t(0x92ED3AFC)},
    {"ma1ev06.wav", "", int32_t(0x00000000), int32_t(0x14794852)},
    {"ma1ev07.wav", "", int32_t(0x00000000), int32_t(0xDF259BF7)},
    {"ma1ev08.wav", "", int32_t(0x00000000), int32_t(0x2E732922)},
    {"ma1ev09.wav", "", int32_t(0x00000000), int32_t(0xE52FFA87)},
    {"ma1ev10.wav", "", int32_t(0x00000000), int32_t(0x6457A0FB)},
    {"ma1ev11.wav", "", int32_t(0x00000000), int32_t(0xAF0B735E)},
    {"ma1ev12.wav", "", int32_t(0x00000000), int32_t(0x299F01F0)},
    {"ma2ta01.wav", "", int32_t(0x00000000), int32_t(0x2F8EADE9)},
    {"ma5ev01.wav", "", int32_t(0x00000000), int32_t(0x0097D890)},
    {"ma5ev02.wav", "", int32_t(0x00000000), int32_t(0x8603AA3E)},
    {"ma5ev03.wav", "", int32_t(0x00000000), int32_t(0x4D5F799B)},
    {"ma5ev04.wav", "", int32_t(0x00000000), int32_t(0x505A4923)},
    {"ma5ev05.wav", "", int32_t(0x00000000), int32_t(0x9B069A86)},
    {"ma5ev06.wav", "", int32_t(0x00000000), int32_t(0x1D92E828)},
    {"ma5i101.wav", "", int32_t(0x00000000), int32_t(0x3C8D8226)},
    {"ma5i201.wav", "", int32_t(0x00000000), int32_t(0xB20285C5)},
    {"ma5i301.wav", "", int32_t(0x00000000), int32_t(0x7EA8855B)},
    {"ma5i401.wav", "", int32_t(0x00000000), int32_t(0x746D8C42)},
    {"ma5i501.wav", "", int32_t(0x00000000), int32_t(0xB8C78CDC)},
    {"ma5ta01.wav", "", int32_t(0x00000000), int32_t(0xCD52B690)},
    {"ma5ta02.wav", "", int32_t(0x00000000), int32_t(0x4BC6C43E)},
    {"ma5ta03.wav", "", int32_t(0x00000000), int32_t(0x809A179B)},
    {"ma5ta04.wav", "", int32_t(0x00000000), int32_t(0x9D9F2723)},
    {"ma6ev01.wav", "", int32_t(0x00000000), int32_t(0xEBA06393)},
    {"ma6ev02.wav", "", int32_t(0x00000000), int32_t(0x6D34113D)},
    {"ma7ev01.wav", "", int32_t(0x00000000), int32_t(0x046208AD)},
    {"ma8ia01.wav", "", int32_t(0x00000000), int32_t(0x65239806)},
    {"ma8ia02.wav", "", int32_t(0x00000000), int32_t(0xE3B7EAA8)},
    {"ma8ta01.wav", "", int32_t(0x00000000), int32_t(0x38AC3D20)},
    {"ma9se01.wav", "", int32_t(0x00000000), int32_t(0x3745352D)},
    {"ma9se02.wav", "", int32_t(0x00000000), int32_t(0xB1D14783)},
    {"ma9se03.wav", "", int32_t(0x00000000), int32_t(0x7A8D9426)},
    {"maaei01.wav", "", int32_t(0x00000000), int32_t(0x5AAEDEF5)},
    {"maaei02.wav", "", int32_t(0x00000000), int32_t(0xDC3AAC5B)},
    {"maaei03.wav", "", int32_t(0x00000000), int32_t(0x17667FFE)},
    {"maaei04.wav", "", int32_t(0x00000000), int32_t(0x0A634F46)},
    {"maaev05.wav", "", int32_t(0x00000000), int32_t(0x64A4BF64)},
    {"maaev06.wav", "", int32_t(0x00000000), int32_t(0xE230CDCA)},
    {"macev01.wav", "", int32_t(0x00000000), int32_t(0xFBC02D4F)},
    {"macev02.wav", "", int32_t(0x00000000), int32_t(0x7D545FE1)},
    {"macev03.wav", "", int32_t(0x00000000), int32_t(0xB6088C44)},
    {"macev04.wav", "", int32_t(0x00000000), int32_t(0xAB0DBCFC)},
    {"macev05.wav", "", int32_t(0x00000000), int32_t(0x60516F59)},
    {"macev06.wav", "", int32_t(0x00000000), int32_t(0xE6C51DF7)},
    {"macev07.wav", "", int32_t(0x00000000), int32_t(0x2D99CE52)},
    {"macev08.wav", "", int32_t(0x00000000), int32_t(0xDCCF7C87)},
    {"macev09.wav", "", int32_t(0x00000000), int32_t(0x1793AF22)},
    {"macintro.vqa", "", int32_t(0x050303FF), int32_t(0x00000000)},
    {"macintro.vqp", "", int32_t(0x140303FF), int32_t(0x00000000)},
    {"macis01.wav", "", int32_t(0x00000000), int32_t(0x5514D03F)},
    {"macta01.wav", "", int32_t(0x00000000), int32_t(0x3605434F)},
    {"macve01.wav", "", int32_t(0x00000000), int32_t(0x9CB96533)},
    {"macve02.wav", "", int32_t(0x00000000), int32_t(0x1A2D179D)},
    {"macve03.wav", "", int32_t(0x00000000), int32_t(0xD171C438)},
    {"madchrg2.aud", "m.a.d. tank charging", int32_t(0xB5F4EAF3), int32_t(0x00000000)},
    {"madexplo.aud", "m.a.d. tank detonation", int32_t(0xF7FEE713), int32_t(0x00000000)},
    {"madrap.aud", "mad rap", int32_t(0x00000000), int32_t(0x358A5B7A)},
    {"maffirm1.aud", "medic: affirmative!", int32_t(0xC008EAF5), int32_t(0x00000000)},
    {"magchnk1.aud", "", int32_t(0xB408E2F3), int32_t(0x00000000)},
    {"magdrop1.aud", "", int32_t(0xB812E507), int32_t(0x00000000)},
    {"mage.aud", "", int32_t(0xCEE3C3C8), int32_t(0x00000000)},
    {"mageamb1.aud", "", int32_t(0xBBF6E0E5), int32_t(0x00000000)},
    {"magic!.aud", "", int32_t(0xA7798C10), int32_t(0x00000000)},
    {"magic1.aud", "", int32_t(0xA779AC10), int32_t(0x00000000)},
    {"magloop2.aud", "", int32_t(0xDA12E501), int32_t(0x00000000)},
    {"magloop3.aud", "", int32_t(0xDC12E501), int32_t(0x00000000)},
    {"magmove1.aud", "", int32_t(0xDBFCF301), int32_t(0x00000000)},
    {"magmove2.aud", "", int32_t(0xDDFCF301), int32_t(0x00000000)},
    {"mahi0107.pcx", "pict: assault on moscow", int32_t(0xEBC4B7C3), int32_t(0x00000000)},
    {"mainbase.vqa", "", int32_t(0x051CDDE7), int32_t(0x00000000)},
    {"mainbttn.pal", "", int32_t(0x00000000), int32_t(0xC087631E)},
    {"major.pcx", "", int32_t(0x00000000), int32_t(0xC9993215)},
    {"malehurt.aud", "", int32_t(0x022AF0F3), int32_t(0x00000000)},
    {"malo0107.cps", "pict: assult on moscow", int32_t(0xFEE1AAC3), int32_t(0x00000000)},
    {"mamasng1.aud", "", int32_t(0xAC18E309), int32_t(0x00000000)},
    {"manasuck.aud", "", int32_t(0xE014F109), int32_t(0x00000000)},
    {"manaup9.aud", "", int32_t(0x61EFFB20), int32_t(0x00000000)},
    {"mandie1.aud", "", int32_t(0x6DDFE508), int32_t(0x00000000)},
    {"manfear1.aud", "", int32_t(0xC032C8ED), int32_t(0x00000000)},
    {"manhatta.map", "", int32_t(0x00000000), int32_t(0x5D61FDB3)},
    {"manhole1.aud", "", int32_t(0xC818DF01), int32_t(0x00000000)},
    {"manpain1.aud", "", int32_t(0xE82AD8E5), int32_t(0x00000000)},
    {"map.aud", "map select music", int32_t(0x5CE4D7DB), int32_t(0x00000000)},
    {"map.fnt", "", int32_t(0x00000000), int32_t(0xC41C81CB)},
    {"map.pal", "pal: map", int32_t(0x5CECC3EA), int32_t(0x00000000)},
    {"map.shp", "butt: earth", int32_t(0x5CF0CAED), int32_t(0x00000000)},
    {"map1.aud", "map theme", int32_t(0xA6F5C3C8), int32_t(0x00000000)},
    {"map1.pal", "pal: ???", int32_t(0xAEE1D2C8), int32_t(0x00000000)},
    {"map_gry2.pal", "pal: ???", int32_t(0x2E34F9F1), int32_t(0x00000000)},
    {"map_loc2.pal", "pal: ???", int32_t(0x2E08F3FB), int32_t(0x00000000)},
    {"map_loc3.pal", "pal: ???", int32_t(0x3008F3FB), int32_t(0x00000000)},
    {"map_locl.pal", "pal: ???", int32_t(0x6208F3FA), int32_t(0x00000000)},
    {"map_prog.pal", "pal: ???", int32_t(0x5820FA02), int32_t(0x00000000)},
    {"maps.aud", "-", int32_t(0x00000000), int32_t(0xC133D816)},
    {"mapsel.ini", "ts map selection settings", int32_t(0x00000000), int32_t(0x1D55570B)},
    {"mapsel.pal", "map selection screen palette", int32_t(0x00000000), int32_t(0xBEB26DD4)},
    {"mapsel01.ini", "fs map selection settings", int32_t(0x00000000), int32_t(0x14A5FD47)},
    {"mapselmd.ini", "", int32_t(0x00000000), int32_t(0x922B8CE7)},
    {"mapwipe2.aud", "audf:", int32_t(0x0620E6F5), int32_t(0x00000000)},
    {"mapwipe5.aud", "audf:", int32_t(0x0C20E6F5), int32_t(0x00000000)},
    {"march.aud", "march to doom", int32_t(0xB7CB6209), int32_t(0x00000000)},
    {"march1.aud", "audf:", int32_t(0x8FA5AC1A), int32_t(0x00000000)},
    {"masasslt.vqa", "assault on moscow", int32_t(0xEF370209), int32_t(0x00000000)},
    {"masasslt.vqp", "vqp: assault on moscow", int32_t(0xFE370209), int32_t(0x00000000)},
    {"matt.shp", "-", int32_t(0x00000000), int32_t(0x1296896F)},
    {"mauratk1.aud", "", int32_t(0xF040EEE5), int32_t(0x00000000)},
    {"mauratk2.aud", "", int32_t(0xF240EEE5), int32_t(0x00000000)},
    {"maurdeth.aud", "", int32_t(0x1E52D0EB), int32_t(0x00000000)},
    {"maurhit1.aud", "", int32_t(0xF052D8F3), int32_t(0x00000000)},
    {"maurhit2.aud", "", int32_t(0xF252D8F3), int32_t(0x00000000)},
    {"maurhtsh.aud", "", int32_t(0x1E50EEF3), int32_t(0x00000000)},
    {"maurkilb.aud", "", int32_t(0x1242D8F9), int32_t(0x00000000)},
    {"maxhpdwn.aud", "", int32_t(0x0264CF03), int32_t(0x00000000)},
    {"maxhpup.aud", "", int32_t(0x7E460516), int32_t(0x00000000)},
    {"mboss1.aud", "mech: shore thing boss", int32_t(0xCF99B030), int32_t(0x00000000)},
    {"mcgun1.aud", "", int32_t(0xD779B426), int32_t(0x00000000)},
    {"mcgun2.aud", "", int32_t(0xD779B626), int32_t(0x00000000)},
    {"mclfx01.sno", "", int32_t(0x00000000), int32_t(0x619E9886)},
    {"mclfx02.sno", "", int32_t(0x00000000), int32_t(0xE70AEA28)},
    {"mclfx03.sno", "", int32_t(0x00000000), int32_t(0x2C56398D)},
    {"mclfx04.sno", "", int32_t(0x00000000), int32_t(0x31530935)},
    {"mclfx05.sno", "", int32_t(0x00000000), int32_t(0xFA0FDA90)},
    {"mclfx06.sno", "", int32_t(0x00000000), int32_t(0x7C9BA83E)},
    {"mclfx07.sno", "", int32_t(0x00000000), int32_t(0xB7C77B9B)},
    {"mclfx08.sno", "", int32_t(0x00000000), int32_t(0x4691C94E)},
    {"mclfx09.sno", "", int32_t(0x00000000), int32_t(0x8DCD1AEB)},
    {"mclfx10.sno", "", int32_t(0x00000000), int32_t(0x0CB54097)},
    {"mclfx11.sno", "", int32_t(0x00000000), int32_t(0xC7E99332)},
    {"mclfx12.sno", "", int32_t(0x00000000), int32_t(0x417DE19C)},
    {"mclfx13.sno", "", int32_t(0x00000000), int32_t(0x8A213239)},
    {"mclfx14.sno", "", int32_t(0x00000000), int32_t(0x97240281)},
    {"mclfx15.sno", "", int32_t(0x00000000), int32_t(0x5C78D124)},
    {"mclfx16.sno", "", int32_t(0x00000000), int32_t(0xDAECA38A)},
    {"mclfx17.sno", "", int32_t(0x00000000), int32_t(0x11B0702F)},
    {"mclfx18.sno", "", int32_t(0x00000000), int32_t(0xE0E6C2FA)},
    {"mclfx19.sno", "", int32_t(0x00000000), int32_t(0x2BBA115F)},
    {"mclfx20.sno", "", int32_t(0x00000000), int32_t(0x3D5D5A0A)},
    {"mclfx21.sno", "", int32_t(0x00000000), int32_t(0xF60189AF)},
    {"mclfx22.sno", "", int32_t(0x00000000), int32_t(0x7095FB01)},
    {"mclfx23.sno", "", int32_t(0x00000000), int32_t(0xBBC928A4)},
    {"mclfx24.sno", "", int32_t(0x00000000), int32_t(0xA6CC181C)},
    {"mclfx25.sno", "", int32_t(0x00000000), int32_t(0x6D90CBB9)},
    {"mclfx26.sno", "", int32_t(0x00000000), int32_t(0xEB04B917)},
    {"mclfx27.sno", "", int32_t(0x00000000), int32_t(0x20586AB2)},
    {"mclfx28.sno", "", int32_t(0x00000000), int32_t(0xD10ED867)},
    {"mclfx29.sno", "", int32_t(0x00000000), int32_t(0x1A520BC2)},
    {"mclfx30.sno", "", int32_t(0x00000000), int32_t(0x9B2A51BE)},
    {"mclfx31.sno", "", int32_t(0x00000000), int32_t(0x5076821B)},
    {"mclfx32.sno", "", int32_t(0x00000000), int32_t(0xD6E2F0B5)},
    {"mclfx33.sno", "", int32_t(0x00000000), int32_t(0x1DBE2310)},
    {"mclfx33a.sno", "", int32_t(0x00000000), int32_t(0xED06B714)},
    {"mclfx34.sno", "", int32_t(0x00000000), int32_t(0x00BB13A8)},
    {"mclfx34a.sno", "", int32_t(0x00000000), int32_t(0xF00387AC)},
    {"mclfx35.sno", "", int32_t(0x00000000), int32_t(0xCBE7C00D)},
    {"mclfx36.sno", "", int32_t(0x00000000), int32_t(0x4D73B2A3)},
    {"mclfx37.sno", "", int32_t(0x00000000), int32_t(0x862F6106)},
    {"mclfx38.sno", "", int32_t(0x00000000), int32_t(0x7779D3D3)},
    {"mclfx39.sno", "", int32_t(0x00000000), int32_t(0xBC250076)},
    {"mclfx40.sno", "", int32_t(0x00000000), int32_t(0x5E8D6F30)},
    {"mclif01.des", "", int32_t(0x00000000), int32_t(0xF0FAA9D4)},
    {"mclif01.sno", "", int32_t(0x00000000), int32_t(0xD716744E)},
    {"mclif01.tem", "", int32_t(0x00000000), int32_t(0x74A2C194)},
    {"mclif01.urb", "", int32_t(0x00000000), int32_t(0x52EF0FCB)},
    {"mclif02.des", "", int32_t(0x00000000), int32_t(0x766EDB7A)},
    {"mclif02.sno", "", int32_t(0x00000000), int32_t(0x518206E0)},
    {"mclif02.tem", "", int32_t(0x00000000), int32_t(0xF236B33A)},
    {"mclif02.urb", "", int32_t(0x00000000), int32_t(0xD47B7D65)},
    {"mclif03.des", "", int32_t(0x00000000), int32_t(0xBD3208DF)},
    {"mclif03.sno", "", int32_t(0x00000000), int32_t(0x9ADED545)},
    {"mclif03.tem", "", int32_t(0x00000000), int32_t(0x396A609F)},
    {"mclif03.urb", "", int32_t(0x00000000), int32_t(0x1F27AEC0)},
    {"mclif04.des", "", int32_t(0x00000000), int32_t(0xA0373867)},
    {"mclif04.sno", "", int32_t(0x00000000), int32_t(0x87DBE5FD)},
    {"mclif04.tem", "", int32_t(0x00000000), int32_t(0x246F5027)},
    {"mclif04.urb", "", int32_t(0x00000000), int32_t(0x02229E78)},
    {"mclif05.des", "", int32_t(0x00000000), int32_t(0x6B6BEBC2)},
    {"mclif05.sno", "", int32_t(0x00000000), int32_t(0x4C873658)},
    {"mclif05.tem", "", int32_t(0x00000000), int32_t(0xEF338382)},
    {"mclif05.urb", "", int32_t(0x00000000), int32_t(0xC97E4DDD)},
    {"mclif06.des", "", int32_t(0x00000000), int32_t(0xEDFF996C)},
    {"mclif06.sno", "", int32_t(0x00000000), int32_t(0xCA1344F6)},
    {"mclif06.tem", "", int32_t(0x00000000), int32_t(0x69A7F12C)},
    {"mclif06.urb", "", int32_t(0x00000000), int32_t(0x4FEA3F73)},
    {"mclif07.des", "", int32_t(0x00000000), int32_t(0x26A34AC9)},
    {"mclif07.sno", "", int32_t(0x00000000), int32_t(0x014F9753)},
    {"mclif07.tem", "", int32_t(0x00000000), int32_t(0xA2FB2289)},
    {"mclif07.urb", "", int32_t(0x00000000), int32_t(0x84B6ECD6)},
    {"mclif08.des", "", int32_t(0x00000000), int32_t(0xD7F5F81C)},
    {"mclif08.sno", "", int32_t(0x00000000), int32_t(0xF0192586)},
    {"mclif08.tem", "", int32_t(0x00000000), int32_t(0x53AD905C)},
    {"mclif08.urb", "", int32_t(0x00000000), int32_t(0x75E05E03)},
    {"mclif09.des", "", int32_t(0x00000000), int32_t(0x1CA92BB9)},
    {"mclif09.sno", "", int32_t(0x00000000), int32_t(0x3B45F623)},
    {"mclif09.tem", "", int32_t(0x00000000), int32_t(0x98F143F9)},
    {"mclif09.urb", "", int32_t(0x00000000), int32_t(0xBEBC8DA6)},
    {"mclif10.des", "", int32_t(0x00000000), int32_t(0x9DD171C5)},
    {"mclif10.sno", "", int32_t(0x00000000), int32_t(0xBA3DAC5F)},
    {"mclif10.tem", "", int32_t(0x00000000), int32_t(0x19891985)},
    {"mclif10.urb", "", int32_t(0x00000000), int32_t(0x3FC4D7DA)},
    {"mclif11.des", "", int32_t(0x00000000), int32_t(0x568DA260)},
    {"mclif11.sno", "", int32_t(0x00000000), int32_t(0x71617FFA)},
    {"mclif11.tem", "", int32_t(0x00000000), int32_t(0xD2D5CA20)},
    {"mclif11.urb", "", int32_t(0x00000000), int32_t(0xF498047F)},
    {"mclif12.des", "", int32_t(0x00000000), int32_t(0xD019D0CE)},
    {"mclif12.sno", "", int32_t(0x00000000), int32_t(0xF7F50D54)},
    {"mclif12.tem", "", int32_t(0x00000000), int32_t(0x5441B88E)},
    {"mclif12.urb", "", int32_t(0x00000000), int32_t(0x720C76D1)},
    {"mclif13.des", "", int32_t(0x00000000), int32_t(0x1B45036B)},
    {"mclif13.sno", "", int32_t(0x00000000), int32_t(0x3CA9DEF1)},
    {"mclif13.tem", "", int32_t(0x00000000), int32_t(0x9F1D6B2B)},
    {"mclif13.urb", "", int32_t(0x00000000), int32_t(0xB950A574)},
    {"mclif14.des", "", int32_t(0x00000000), int32_t(0x064033D3)},
    {"mclif14.sno", "", int32_t(0x00000000), int32_t(0x21ACEE49)},
    {"mclif14.tem", "", int32_t(0x00000000), int32_t(0x82185B93)},
    {"mclif14.urb", "", int32_t(0x00000000), int32_t(0xA45595CC)},
    {"mclif15.des", "", int32_t(0x00000000), int32_t(0xCD1CE076)},
    {"mclif15.sno", "", int32_t(0x00000000), int32_t(0xEAF03DEC)},
    {"mclif15.tem", "", int32_t(0x00000000), int32_t(0x49448836)},
    {"mclif15.urb", "", int32_t(0x00000000), int32_t(0x6F094669)},
    {"mclif16.des", "", int32_t(0x00000000), int32_t(0x4B8892D8)},
    {"mclif16.sno", "", int32_t(0x00000000), int32_t(0x6C644F42)},
    {"mclif16.tem", "", int32_t(0x00000000), int32_t(0xCFD0FA98)},
    {"mclif16.urb", "", int32_t(0x00000000), int32_t(0xE99D34C7)},
    {"mclif17.des", "", int32_t(0x00000000), int32_t(0x80D4417D)},
    {"mclif17.sno", "", int32_t(0x00000000), int32_t(0xA7389CE7)},
    {"mclif17.tem", "", int32_t(0x00000000), int32_t(0x048C293D)},
    {"mclif17.urb", "", int32_t(0x00000000), int32_t(0x22C1E762)},
    {"mclif18.des", "", int32_t(0x00000000), int32_t(0x7182F3A8)},
    {"mclif18.sno", "", int32_t(0x00000000), int32_t(0x566E2E32)},
    {"mclif18.tem", "", int32_t(0x00000000), int32_t(0xF5DA9BE8)},
    {"mclif18.urb", "", int32_t(0x00000000), int32_t(0xD39755B7)},
    {"mclif19.des", "", int32_t(0x00000000), int32_t(0xBADE200D)},
    {"mclif19.sno", "", int32_t(0x00000000), int32_t(0x9D32FD97)},
    {"mclif19.tem", "", int32_t(0x00000000), int32_t(0x3E86484D)},
    {"mclif19.urb", "", int32_t(0x00000000), int32_t(0x18CB8612)},
    {"mclif20.des", "", int32_t(0x00000000), int32_t(0xAC396B58)},
    {"mclif20.sno", "", int32_t(0x00000000), int32_t(0x8BD5B6C2)},
    {"mclif20.tem", "", int32_t(0x00000000), int32_t(0x28610318)},
    {"mclif20.urb", "", int32_t(0x00000000), int32_t(0x0E2CCD47)},
    {"mclif21.des", "", int32_t(0x00000000), int32_t(0x6765B8FD)},
    {"mclif21.sno", "", int32_t(0x00000000), int32_t(0x40896567)},
    {"mclif21.tem", "", int32_t(0x00000000), int32_t(0xE33DD0BD)},
    {"mclif21.urb", "", int32_t(0x00000000), int32_t(0xC5701EE2)},
    {"mclif22.des", "", int32_t(0x00000000), int32_t(0xE1F1CA53)},
    {"mclif22.sno", "", int32_t(0x00000000), int32_t(0xC61D17C9)},
    {"mclif22.tem", "", int32_t(0x00000000), int32_t(0x65A9A213)},
    {"mclif22.urb", "", int32_t(0x00000000), int32_t(0x43E46C4C)},
    {"mclif23.des", "", int32_t(0x00000000), int32_t(0x2AAD19F6)},
    {"mclif23.sno", "", int32_t(0x00000000), int32_t(0x0D41C46C)},
    {"mclif23.tem", "", int32_t(0x00000000), int32_t(0xAEF571B6)},
    {"mclif23.urb", "", int32_t(0x00000000), int32_t(0x88B8BFE9)},
    {"mclif24.des", "", int32_t(0x00000000), int32_t(0x37A8294E)},
    {"mclif24.sno", "", int32_t(0x00000000), int32_t(0x1044F4D4)},
    {"mclif24.tem", "", int32_t(0x00000000), int32_t(0xB3F0410E)},
    {"mclif24.urb", "", int32_t(0x00000000), int32_t(0x95BD8F51)},
    {"mclif25.des", "", int32_t(0x00000000), int32_t(0xFCF4FAEB)},
    {"mclif25.sno", "", int32_t(0x00000000), int32_t(0xDB182771)},
    {"mclif25.tem", "", int32_t(0x00000000), int32_t(0x78AC92AB)},
    {"mclif25.urb", "", int32_t(0x00000000), int32_t(0x5EE15CF4)},
    {"mclif26.des", "", int32_t(0x00000000), int32_t(0x7A608845)},
    {"mclif26.sno", "", int32_t(0x00000000), int32_t(0x5D8C55DF)},
    {"mclif26.tem", "", int32_t(0x00000000), int32_t(0xFE38E005)},
    {"mclif26.urb", "", int32_t(0x00000000), int32_t(0xD8752E5A)},
    {"mclif27.des", "", int32_t(0x00000000), int32_t(0xB13C5BE0)},
    {"mclif27.sno", "", int32_t(0x00000000), int32_t(0x96D0867A)},
    {"mclif27.tem", "", int32_t(0x00000000), int32_t(0x356433A0)},
    {"mclif27.urb", "", int32_t(0x00000000), int32_t(0x1329FDFF)},
    {"mclif28.des", "", int32_t(0x00000000), int32_t(0x406AE935)},
    {"mclif28.sno", "", int32_t(0x00000000), int32_t(0x678634AF)},
    {"mclif28.tem", "", int32_t(0x00000000), int32_t(0xC4328175)},
    {"mclif28.urb", "", int32_t(0x00000000), int32_t(0xE27F4F2A)},
    {"mclif29.des", "", int32_t(0x00000000), int32_t(0x8B363A90)},
    {"mclif29.sno", "", int32_t(0x00000000), int32_t(0xACDAE70A)},
    {"mclif29.tem", "", int32_t(0x00000000), int32_t(0x0F6E52D0)},
    {"mclif29.urb", "", int32_t(0x00000000), int32_t(0x29239C8F)},
    {"mclif30.des", "", int32_t(0x00000000), int32_t(0x0A4E60EC)},
    {"mclif30.sno", "", int32_t(0x00000000), int32_t(0x2DA2BD76)},
    {"mclif30.tem", "", int32_t(0x00000000), int32_t(0x8E1608AC)},
    {"mclif30.urb", "", int32_t(0x00000000), int32_t(0xA85BC6F3)},
    {"mclif31.des", "", int32_t(0x00000000), int32_t(0xC112B349)},
    {"mclif31.sno", "", int32_t(0x00000000), int32_t(0xE6FE6ED3)},
    {"mclif31.tem", "", int32_t(0x00000000), int32_t(0x454ADB09)},
    {"mclif31.urb", "", int32_t(0x00000000), int32_t(0x63071556)},
    {"mclif32.des", "", int32_t(0x00000000), int32_t(0x4786C1E7)},
    {"mclif32.sno", "", int32_t(0x00000000), int32_t(0x606A1C7D)},
    {"mclif32.tem", "", int32_t(0x00000000), int32_t(0xC3DEA9A7)},
    {"mclif32.urb", "", int32_t(0x00000000), int32_t(0xE59367F8)},
    {"mclif33.des", "", int32_t(0x00000000), int32_t(0x8CDA1242)},
    {"mclif33.sno", "", int32_t(0x00000000), int32_t(0xAB36CFD8)},
    {"mclif33.tem", "", int32_t(0x00000000), int32_t(0x08827A02)},
    {"mclif33.urb", "", int32_t(0x00000000), int32_t(0x2ECFB45D)},
    {"mclif33a.des", "", int32_t(0x00000000), int32_t(0xB5126BAD)},
    {"mclif33a.sno", "", int32_t(0x00000000), int32_t(0x5B8E5BDC)},
    {"mclif33a.tem", "", int32_t(0x00000000), int32_t(0x533BF5BE)},
    {"mclif33a.urb", "", int32_t(0x00000000), int32_t(0xC7C5068E)},
    {"mclif34.des", "", int32_t(0x00000000), int32_t(0x91DF22FA)},
    {"mclif34.sno", "", int32_t(0x00000000), int32_t(0xB633FF60)},
    {"mclif34.tem", "", int32_t(0x00000000), int32_t(0x15874ABA)},
    {"mclif34.urb", "", int32_t(0x00000000), int32_t(0x33CA84E5)},
    {"mclif34a.des", "", int32_t(0x00000000), int32_t(0xA8175B15)},
    {"mclif34a.sno", "", int32_t(0x00000000), int32_t(0x468B6B64)},
    {"mclif34a.tem", "", int32_t(0x00000000), int32_t(0x4E3EC506)},
    {"mclif34a.urb", "", int32_t(0x00000000), int32_t(0xDAC03636)},
    {"mclif35.des", "", int32_t(0x00000000), int32_t(0x5A83F15F)},
    {"mclif35.sno", "", int32_t(0x00000000), int32_t(0x7D6F2CC5)},
    {"mclif35.tem", "", int32_t(0x00000000), int32_t(0xDEDB991F)},
    {"mclif35.urb", "", int32_t(0x00000000), int32_t(0xF8965740)},
    {"mclif36.des", "", int32_t(0x00000000), int32_t(0xDC1783F1)},
    {"mclif36.sno", "", int32_t(0x00000000), int32_t(0xFBFB5E6B)},
    {"mclif36.tem", "", int32_t(0x00000000), int32_t(0x584FEBB1)},
    {"mclif36.urb", "", int32_t(0x00000000), int32_t(0x7E0225EE)},
    {"mclif37.des", "", int32_t(0x00000000), int32_t(0x174B5054)},
    {"mclif37.sno", "", int32_t(0x00000000), int32_t(0x30A78DCE)},
    {"mclif37.tem", "", int32_t(0x00000000), int32_t(0x93133814)},
    {"mclif37.urb", "", int32_t(0x00000000), int32_t(0xB55EF64B)},
    {"mclif38.des", "", int32_t(0x00000000), int32_t(0xE61DE281)},
    {"mclif38.sno", "", int32_t(0x00000000), int32_t(0xC1F13F1B)},
    {"mclif38.tem", "", int32_t(0x00000000), int32_t(0x62458AC1)},
    {"mclif38.urb", "", int32_t(0x00000000), int32_t(0x4408449E)},
    {"mclif39.des", "", int32_t(0x00000000), int32_t(0x2D413124)},
    {"mclif39.sno", "", int32_t(0x00000000), int32_t(0x0AADECBE)},
    {"mclif39.tem", "", int32_t(0x00000000), int32_t(0xA9195964)},
    {"mclif39.urb", "", int32_t(0x00000000), int32_t(0x8F54973B)},
    {"mclif40.des", "", int32_t(0x00000000), int32_t(0xCFE95E62)},
    {"mclif40.sno", "", int32_t(0x00000000), int32_t(0xE80583F8)},
    {"mclif40.tem", "", int32_t(0x00000000), int32_t(0x4BB13622)},
    {"mclif40.urb", "", int32_t(0x00000000), int32_t(0x6DFCF87D)},
    {"mclif41.des", "", int32_t(0x00000000), int32_t(0x04B58DC7)},
    {"mclif41.tem", "", int32_t(0x00000000), int32_t(0x80EDE587)},
    {"mclif41.urb", "", int32_t(0x00000000), int32_t(0xA6A02BD8)},
    {"mclif42.des", "", int32_t(0x00000000), int32_t(0x8221FF69)},
    {"mclif42.tem", "", int32_t(0x00000000), int32_t(0x06799729)},
    {"mclif42.urb", "", int32_t(0x00000000), int32_t(0x20345976)},
    {"mclifa01.urb", "", int32_t(0x00000000), int32_t(0xC37455ED)},
    {"mclifa02.urb", "", int32_t(0x00000000), int32_t(0x84D42F3D)},
    {"mclifa03.urb", "", int32_t(0x00000000), int32_t(0xB9B4068D)},
    {"mclifa04.urb", "", int32_t(0x00000000), int32_t(0x0B94DA9D)},
    {"mclifa05.urb", "", int32_t(0x00000000), int32_t(0x36F4F32D)},
    {"mclifa06.urb", "", int32_t(0x00000000), int32_t(0x715489FD)},
    {"mclifa07.urb", "", int32_t(0x00000000), int32_t(0x4C34A04D)},
    {"mclifa08.urb", "", int32_t(0x00000000), int32_t(0xCE64379C)},
    {"mclifa09.urb", "", int32_t(0x00000000), int32_t(0xF3041E2C)},
    {"mclifa10.urb", "", int32_t(0x00000000), int32_t(0x3548AFF8)},
    {"mclifa11.urb", "", int32_t(0x00000000), int32_t(0x08288648)},
    {"mclifa12.urb", "", int32_t(0x00000000), int32_t(0x4F88FC98)},
    {"mclifa13.urb", "", int32_t(0x00000000), int32_t(0x72E8D528)},
    {"mclifa14.urb", "", int32_t(0x00000000), int32_t(0xC0C80938)},
    {"mclifc01.urb", "", int32_t(0x00000000), int32_t(0x54EB44C4)},
    {"mclifc02.urb", "", int32_t(0x00000000), int32_t(0x134B3E14)},
    {"mclifc03.urb", "", int32_t(0x00000000), int32_t(0x2E2B17A4)},
    {"mclifc04.urb", "", int32_t(0x00000000), int32_t(0x9C0BCBB4)},
    {"mclifc05.urb", "", int32_t(0x00000000), int32_t(0xA16BE204)},
    {"mclifc06.urb", "", int32_t(0x00000000), int32_t(0xE6CB98D4)},
    {"mclifx01.ubn", "", int32_t(0x00000000), int32_t(0x7246D28A)},
    {"mclifx02.ubn", "", int32_t(0x00000000), int32_t(0x35E6A85A)},
    {"mclifx03.ubn", "", int32_t(0x00000000), int32_t(0x088681EA)},
    {"mclifx04.ubn", "", int32_t(0x00000000), int32_t(0xBAA65DFA)},
    {"mclifx05.ubn", "", int32_t(0x00000000), int32_t(0x87C6744A)},
    {"mclifx06.ubn", "", int32_t(0x00000000), int32_t(0xC0660E9A)},
    {"mclifx07.ubn", "", int32_t(0x00000000), int32_t(0xFD06272A)},
    {"mclifx08.ubn", "", int32_t(0x00000000), int32_t(0x7F56B0FB)},
    {"mclifx09.ubn", "", int32_t(0x00000000), int32_t(0x4236994B)},
    {"mclifx10.ubn", "", int32_t(0x00000000), int32_t(0x847A289F)},
    {"mclifx11.ubn", "", int32_t(0x00000000), int32_t(0xB91A012F)},
    {"mclifx12.ubn", "", int32_t(0x00000000), int32_t(0xFEBA7BFF)},
    {"mclifx13.ubn", "", int32_t(0x00000000), int32_t(0xC3DA524F)},
    {"mclifx14.ubn", "", int32_t(0x00000000), int32_t(0x71FA8E5F)},
    {"mclifx15.ubn", "", int32_t(0x00000000), int32_t(0x4C9AA7EF)},
    {"mclifx16.ubn", "", int32_t(0x00000000), int32_t(0x0B3ADD3F)},
    {"mclifx17.ubn", "", int32_t(0x00000000), int32_t(0x365AF48F)},
    {"mclifx18.ubn", "", int32_t(0x00000000), int32_t(0xB40A635E)},
    {"mclifx19.ubn", "", int32_t(0x00000000), int32_t(0x896A4AEE)},
    {"mclifx20.ubn", "", int32_t(0x00000000), int32_t(0x02EE5A31)},
    {"mclifx21.ubn", "", int32_t(0x00000000), int32_t(0x3F8E7381)},
    {"mclifx22.ubn", "", int32_t(0x00000000), int32_t(0x782E0951)},
    {"mclifx23.ubn", "", int32_t(0x00000000), int32_t(0x454E20E1)},
    {"mclifx24.ubn", "", int32_t(0x00000000), int32_t(0xF76EFCF1)},
    {"mclifx25.ubn", "", int32_t(0x00000000), int32_t(0xCA0ED541)},
    {"mclifx26.ubn", "", int32_t(0x00000000), int32_t(0x8DAEAF91)},
    {"mclifx27.ubn", "", int32_t(0x00000000), int32_t(0xB0CE8621)},
    {"mclifx28.ubn", "", int32_t(0x00000000), int32_t(0x329E11F0)},
    {"mclifx29.ubn", "", int32_t(0x00000000), int32_t(0x0FFE3840)},
    {"mclifx30.ubn", "", int32_t(0x00000000), int32_t(0xC9B28994)},
    {"mclifx31.ubn", "", int32_t(0x00000000), int32_t(0xF4D2A024)},
    {"mclifx32.ubn", "", int32_t(0x00000000), int32_t(0xB372DAF4)},
    {"mclifx33.ubn", "", int32_t(0x00000000), int32_t(0x8E12F344)},
    {"mclifx34.ubn", "", int32_t(0x00000000), int32_t(0x3C322F54)},
    {"mclifx35.ubn", "", int32_t(0x00000000), int32_t(0x015206E4)},
    {"mclifx36.ubn", "", int32_t(0x00000000), int32_t(0x46F27C34)},
    {"mclifx37.ubn", "", int32_t(0x00000000), int32_t(0x7B925584)},
    {"mclifx38.ubn", "", int32_t(0x00000000), int32_t(0xF9C2C255)},
    {"mclifx39.ubn", "", int32_t(0x00000000), int32_t(0xC4A2EBE5)},
    {"mclifx40.ubn", "", int32_t(0x00000000), int32_t(0xD4B7B92C)},
    {"mclifx41.ubn", "", int32_t(0x00000000), int32_t(0xE9D7909C)},
    {"mclifx42.ubn", "", int32_t(0x00000000), int32_t(0xAE77EA4C)},
    {"mcomnd1.aud", "commander", int32_t(0x91E3EB12), int32_t(0x00000000)},
    {"mcourse1.aud", "of course", int32_t(0xFC1CF507), int32_t(0x00000000)},
    {"mcredit1.vqa", "", int32_t(0xB942F5EB), int32_t(0x00000000)},
    {"mcredit2.vqa", "", int32_t(0xBB42F5EB), int32_t(0x00000000)},
    {"mcredits.vqa", "", int32_t(0xFD42F5EB), int32_t(0x00000000)},
    {"mcv.hva", "-", int32_t(0x00000000), int32_t(0x40851010)},
    {"mcv.shp", "mcv", int32_t(0x5CFCCEED), int32_t(0x00000000)},
    {"mcv.vqa", "mcv drives up", int32_t(0x5CEDD7F0), int32_t(0x00000000)},
    {"mcv.vqp", "vqp: mcv drives up", int32_t(0x5CFCD7F0), int32_t(0x00000000)},
    {"mcv.vxl", "mobile construction vechicle", int32_t(0x00000000), int32_t(0x4F7363FB)},
    {"mcv_land.vqa", "helicopter lands near mcv", int32_t(0x4746E5FA), int32_t(0x00000000)},
    {"mcv_land.vqp", "vqp: helicopter lands near mcv", int32_t(0x5646E5FA), int32_t(0x00000000)},
    {"mcvbrdge.vqa", "mcv crossing bridge", int32_t(0xD538EC07), int32_t(0x00000000)},
    {"mcvbrdge.vqp", "vqp: mcv crossing bridge", int32_t(0xE438EC07), int32_t(0x00000000)},
    {"mcvicnh.des", "icon: mcv", int32_t(0x823CEEFF), int32_t(0x00000000)},
    {"mcvicnh.tem", "icon: mcv", int32_t(0x8236EF0F), int32_t(0x00000000)},
    {"mcvicnh.win", "icon: mcv", int32_t(0x8237F312), int32_t(0x00000000)},
    {"mcvicon.shp", "icon: mcv", int32_t(0x8245F40E), int32_t(0x86F906F1)},
    {"mcvuico.shp", "", int32_t(0x00000000), int32_t(0x5131128D)},
    {"mdcal1.aud", "", int32_t(0x8769B822), int32_t(0x00000000)},
    {"mdcal2.aud", "", int32_t(0x8769BA22), int32_t(0x00000000)},
    {"mdrodc01.des", "", int32_t(0x00000000), int32_t(0x075FF3C8)},
    {"mdrodc01.sno", "", int32_t(0x00000000), int32_t(0xE9C3C3B9)},
    {"mdrodc01.tem", "", int32_t(0x00000000), int32_t(0xE1766DDB)},
    {"mdrodc01.urb", "", int32_t(0x00000000), int32_t(0x75889EEB)},
    {"mdrodc02.des", "", int32_t(0x00000000), int32_t(0x40FF8918)},
    {"mdrodc02.sno", "", int32_t(0x00000000), int32_t(0xAE63B969)},
    {"mdrodc02.tem", "", int32_t(0x00000000), int32_t(0xA6D6170B)},
    {"mdrodc02.urb", "", int32_t(0x00000000), int32_t(0x3228E43B)},
    {"mdrodc03.des", "", int32_t(0x00000000), int32_t(0x7D9FA0A8)},
    {"mdrodc03.sno", "", int32_t(0x00000000), int32_t(0x930390D9)},
    {"mdrodc03.tem", "", int32_t(0x00000000), int32_t(0x9BB63EBB)},
    {"mdrodc03.urb", "", int32_t(0x00000000), int32_t(0x0F48CD8B)},
    {"mdrodc04.des", "", int32_t(0x00000000), int32_t(0xCFBF7CB8)},
    {"mdrodc04.sno", "", int32_t(0x00000000), int32_t(0x21234CC9)},
    {"mdrodc04.tem", "", int32_t(0x00000000), int32_t(0x2996E2AB)},
    {"mdrodc04.urb", "", int32_t(0x00000000), int32_t(0xBD68119B)},
    {"mdrodc05.des", "", int32_t(0x00000000), int32_t(0xF2DF5508)},
    {"mdrodc05.sno", "", int32_t(0x00000000), int32_t(0x1C436579)},
    {"mdrodc05.tem", "", int32_t(0x00000000), int32_t(0x14F6CB1B)},
    {"mdrodc05.urb", "", int32_t(0x00000000), int32_t(0x8008382B)},
    {"mdrodc06.des", "", int32_t(0x00000000), int32_t(0xB57F2FD8)},
    {"mdrodc06.sno", "", int32_t(0x00000000), int32_t(0x5BE31FA9)},
    {"mdrodc06.tem", "", int32_t(0x00000000), int32_t(0x5356B1CB)},
    {"mdrodc06.urb", "", int32_t(0x00000000), int32_t(0xC7A842FB)},
    {"mdrodc07.des", "", int32_t(0x00000000), int32_t(0x881F0668)},
    {"mdrodc07.sno", "", int32_t(0x00000000), int32_t(0x66833619)},
    {"mdrodc07.tem", "", int32_t(0x00000000), int32_t(0x6E36987B)},
    {"mdrodc07.urb", "", int32_t(0x00000000), int32_t(0xFAC86B4B)},
    {"mdrodc08.des", "", int32_t(0x00000000), int32_t(0x0A4F91B9)},
    {"mdrodc08.sno", "", int32_t(0x00000000), int32_t(0xE4D3A1C8)},
    {"mdrodc08.tem", "", int32_t(0x00000000), int32_t(0xEC660FAA)},
    {"mdrodc08.urb", "", int32_t(0x00000000), int32_t(0x7898FC9A)},
    {"mdrodc09.des", "", int32_t(0x00000000), int32_t(0x372FB809)},
    {"mdrodc09.sno", "", int32_t(0x00000000), int32_t(0xD9B38878)},
    {"mdrodc09.tem", "", int32_t(0x00000000), int32_t(0xD106261A)},
    {"mdrodc09.urb", "", int32_t(0x00000000), int32_t(0x45F8D52A)},
    {"mdrodc10.des", "", int32_t(0x00000000), int32_t(0xF16309DD)},
    {"mdrodc10.sno", "", int32_t(0x00000000), int32_t(0x1FFF39AC)},
    {"mdrodc10.tem", "", int32_t(0x00000000), int32_t(0x174A97CE)},
    {"mdrodc10.urb", "", int32_t(0x00000000), int32_t(0x83B464FE)},
    {"mdrodc11.des", "", int32_t(0x00000000), int32_t(0xCC03206D)},
    {"mdrodc11.sno", "", int32_t(0x00000000), int32_t(0x229F101C)},
    {"mdrodc11.tem", "", int32_t(0x00000000), int32_t(0x2A2ABE7E)},
    {"mdrodc11.urb", "", int32_t(0x00000000), int32_t(0xBED44D4E)},
    {"mdrodc12.des", "", int32_t(0x00000000), int32_t(0x8BA35ABD)},
    {"mdrodc12.sno", "", int32_t(0x00000000), int32_t(0x653F6ACC)},
    {"mdrodc12.tem", "", int32_t(0x00000000), int32_t(0x6D8AC4AE)},
    {"mdrodc12.urb", "", int32_t(0x00000000), int32_t(0xF974379E)},
    {"mdrodc13.des", "", int32_t(0x00000000), int32_t(0xB6C3730D)},
    {"mdrodc13.sno", "", int32_t(0x00000000), int32_t(0x585F437C)},
    {"mdrodc13.tem", "", int32_t(0x00000000), int32_t(0x50EAED1E)},
    {"mdrodc13.urb", "", int32_t(0x00000000), int32_t(0xC4141E2E)},
    {"mdrodc14.des", "", int32_t(0x00000000), int32_t(0x04E3AF1D)},
    {"mdrodc14.sno", "", int32_t(0x00000000), int32_t(0xEA7F9F6C)},
    {"mdrodc14.tem", "", int32_t(0x00000000), int32_t(0xE2CA310E)},
    {"mdrodc14.urb", "", int32_t(0x00000000), int32_t(0x7634C23E)},
    {"mdrodc15.des", "", int32_t(0x00000000), int32_t(0x398386AD)},
    {"mdrodc15.sno", "", int32_t(0x00000000), int32_t(0xD71FB6DC)},
    {"mdrodc15.tem", "", int32_t(0x00000000), int32_t(0xDFAA18BE)},
    {"mdrodc15.urb", "", int32_t(0x00000000), int32_t(0x4B54EB8E)},
    {"mdrodc16.des", "", int32_t(0x00000000), int32_t(0x7E23FC7D)},
    {"mdrodc16.sno", "", int32_t(0x00000000), int32_t(0x90BFCC0C)},
    {"mdrodc16.tem", "", int32_t(0x00000000), int32_t(0x980A626E)},
    {"mdrodc16.urb", "", int32_t(0x00000000), int32_t(0x0CF4915E)},
    {"mdrodc17.des", "", int32_t(0x00000000), int32_t(0x4343D5CD)},
    {"mdrodc17.sno", "", int32_t(0x00000000), int32_t(0xADDFE5BC)},
    {"mdrodc17.tem", "", int32_t(0x00000000), int32_t(0xA56A4BDE)},
    {"mdrodc17.urb", "", int32_t(0x00000000), int32_t(0x3194B8EE)},
    {"mdrodc18.des", "", int32_t(0x00000000), int32_t(0xC113421C)},
    {"mdrodc18.sno", "", int32_t(0x00000000), int32_t(0x2F8F726D)},
    {"mdrodc18.tem", "", int32_t(0x00000000), int32_t(0x273ADC0F)},
    {"mdrodc18.urb", "", int32_t(0x00000000), int32_t(0xB3C42F3F)},
    {"mdrodc19.des", "", int32_t(0x00000000), int32_t(0xFC736BAC)},
    {"mdrodc19.sno", "", int32_t(0x00000000), int32_t(0x12EF5BDD)},
    {"mdrodc19.tem", "", int32_t(0x00000000), int32_t(0x1A5AF5BF)},
    {"mdrodc19.urb", "", int32_t(0x00000000), int32_t(0x8EA4068F)},
    {"mdrodc20.des", "", int32_t(0x00000000), int32_t(0x77F77B73)},
    {"mdrodc20.sno", "", int32_t(0x00000000), int32_t(0x996B4B02)},
    {"mdrodc20.tem", "", int32_t(0x00000000), int32_t(0x91DEE560)},
    {"mdrodc20.urb", "", int32_t(0x00000000), int32_t(0x05201650)},
    {"mdrodc21.des", "", int32_t(0x00000000), int32_t(0x4A9752C3)},
    {"mdrodc21.sno", "", int32_t(0x00000000), int32_t(0xA40B62B2)},
    {"mdrodc21.tem", "", int32_t(0x00000000), int32_t(0xACBECCD0)},
    {"mdrodc21.urb", "", int32_t(0x00000000), int32_t(0x38403FE0)},
    {"mdrodc22.des", "", int32_t(0x00000000), int32_t(0x0D372813)},
    {"mdrodc22.sno", "", int32_t(0x00000000), int32_t(0xE3AB1862)},
    {"mdrodc22.tem", "", int32_t(0x00000000), int32_t(0xEB1EB600)},
    {"mdrodc22.urb", "", int32_t(0x00000000), int32_t(0x7FE04530)},
    {"mdrodc23.des", "", int32_t(0x00000000), int32_t(0x305701A3)},
    {"mdrodc23.sno", "", int32_t(0x00000000), int32_t(0xDECB31D2)},
    {"mdrodc23.tem", "", int32_t(0x00000000), int32_t(0xD67E9FB0)},
    {"mdrodc23.urb", "", int32_t(0x00000000), int32_t(0x42806C80)},
    {"mdrodc24.des", "", int32_t(0x00000000), int32_t(0x8277DDB3)},
    {"mdrodc24.sno", "", int32_t(0x00000000), int32_t(0x6CEBEDC2)},
    {"mdrodc24.tem", "", int32_t(0x00000000), int32_t(0x645E43A0)},
    {"mdrodc24.urb", "", int32_t(0x00000000), int32_t(0xF0A0B090)},
    {"mdrodj01.des", "", int32_t(0x00000000), int32_t(0x92C7B61B)},
    {"mdrodj01.sno", "", int32_t(0x00000000), int32_t(0x7C5B866A)},
    {"mdrodj01.tem", "", int32_t(0x00000000), int32_t(0x74EE2808)},
    {"mdrodj01.urb", "", int32_t(0x00000000), int32_t(0xE010DB38)},
    {"mdrodj02.des", "", int32_t(0x00000000), int32_t(0xD567CCCB)},
    {"mdrodj02.sno", "", int32_t(0x00000000), int32_t(0x3BFBFCBA)},
    {"mdrodj02.tem", "", int32_t(0x00000000), int32_t(0x334E52D8)},
    {"mdrodj02.urb", "", int32_t(0x00000000), int32_t(0xA7B0A1E8)},
    {"mdrodj03.des", "", int32_t(0x00000000), int32_t(0xE807E57B)},
    {"mdrodj03.sno", "", int32_t(0x00000000), int32_t(0x069BD50A)},
    {"mdrodj03.tem", "", int32_t(0x00000000), int32_t(0x0E2E7B68)},
    {"mdrodj03.urb", "", int32_t(0x00000000), int32_t(0x9AD08858)},
    {"mdrodj04.des", "", int32_t(0x00000000), int32_t(0x5A27396B)},
    {"mdrodj04.sno", "", int32_t(0x00000000), int32_t(0xB4BB091A)},
    {"mdrodj04.tem", "", int32_t(0x00000000), int32_t(0xBC0EA778)},
    {"mdrodj04.urb", "", int32_t(0x00000000), int32_t(0x28F05448)},
    {"mdrodj05.des", "", int32_t(0x00000000), int32_t(0x674710DB)},
    {"mdrodj05.sno", "", int32_t(0x00000000), int32_t(0x89DB20AA)},
    {"mdrodj05.tem", "", int32_t(0x00000000), int32_t(0x816E8EC8)},
    {"mdrodj05.urb", "", int32_t(0x00000000), int32_t(0x15907DF8)},
    {"mdrodj06.des", "", int32_t(0x00000000), int32_t(0x20E76A0B)},
    {"mdrodj06.sno", "", int32_t(0x00000000), int32_t(0xCE7B5A7A)},
    {"mdrodj06.tem", "", int32_t(0x00000000), int32_t(0xC6CEF418)},
    {"mdrodj06.urb", "", int32_t(0x00000000), int32_t(0x52300728)},
    {"mdrodj07.des", "", int32_t(0x00000000), int32_t(0x1D8743BB)},
    {"mdrodj07.sno", "", int32_t(0x00000000), int32_t(0xF31B73CA)},
    {"mdrodj07.tem", "", int32_t(0x00000000), int32_t(0xFBAEDDA8)},
    {"mdrodj07.urb", "", int32_t(0x00000000), int32_t(0x6F502E98)},
    {"mdrodj08.des", "", int32_t(0x00000000), int32_t(0x9FD7D46A)},
    {"mdrodj08.sno", "", int32_t(0x00000000), int32_t(0x714BE41B)},
    {"mdrodj08.tem", "", int32_t(0x00000000), int32_t(0x79FE4A79)},
    {"mdrodj08.urb", "", int32_t(0x00000000), int32_t(0xED00B949)},
    {"mdrodj09.des", "", int32_t(0x00000000), int32_t(0xA2B7FDDA)},
    {"mdrodj09.sno", "", int32_t(0x00000000), int32_t(0x4C2BCDAB)},
    {"mdrodj09.tem", "", int32_t(0x00000000), int32_t(0x449E63C9)},
    {"mdrodj09.urb", "", int32_t(0x00000000), int32_t(0xD06090F9)},
    {"mdrodj10.des", "", int32_t(0x00000000), int32_t(0x64FB4C0E)},
    {"mdrodj10.sno", "", int32_t(0x00000000), int32_t(0x8A677C7F)},
    {"mdrodj10.tem", "", int32_t(0x00000000), int32_t(0x82D2D21D)},
    {"mdrodj10.urb", "", int32_t(0x00000000), int32_t(0x162C212D)},
    {"mdrodj11.des", "", int32_t(0x00000000), int32_t(0x599B65BE)},
    {"mdrodj11.sno", "", int32_t(0x00000000), int32_t(0xB70755CF)},
    {"mdrodj11.tem", "", int32_t(0x00000000), int32_t(0xBFB2FBAD)},
    {"mdrodj11.urb", "", int32_t(0x00000000), int32_t(0x2B4C089D)},
    {"mdrods01.des", "", int32_t(0x00000000), int32_t(0x60816F06)},
    {"mdrods01.sno", "", int32_t(0x00000000), int32_t(0x8E1D5F77)},
    {"mdrods01.tem", "", int32_t(0x00000000), int32_t(0x86A8F115)},
    {"mdrods01.urb", "", int32_t(0x00000000), int32_t(0x12560225)},
    {"mdrods02.des", "", int32_t(0x00000000), int32_t(0x272115D6)},
    {"mdrods02.sno", "", int32_t(0x00000000), int32_t(0xC9BD25A7)},
    {"mdrods02.tem", "", int32_t(0x00000000), int32_t(0xC1088BC5)},
    {"mdrods02.urb", "", int32_t(0x00000000), int32_t(0x55F678F5)},
    {"mdrods03.des", "", int32_t(0x00000000), int32_t(0x1A413C66)},
    {"mdrods03.sno", "", int32_t(0x00000000), int32_t(0xF4DD0C17)},
    {"mdrods03.tem", "", int32_t(0x00000000), int32_t(0xFC68A275)},
    {"mdrods03.urb", "", int32_t(0x00000000), int32_t(0x68965145)},
    {"mdrods04.des", "", int32_t(0x00000000), int32_t(0xA861E076)},
    {"mdrods04.sno", "", int32_t(0x00000000), int32_t(0x46FDD007)},
    {"mdrods04.tem", "", int32_t(0x00000000), int32_t(0x4E487E65)},
    {"mdrods04.urb", "", int32_t(0x00000000), int32_t(0xDAB68D55)},
    {"mdrods05.des", "", int32_t(0x00000000), int32_t(0x9501C9C6)},
    {"mdrods05.sno", "", int32_t(0x00000000), int32_t(0x7B9DF9B7)},
    {"mdrods05.tem", "", int32_t(0x00000000), int32_t(0x732857D5)},
    {"mdrods05.urb", "", int32_t(0x00000000), int32_t(0xE7D6A4E5)},
    {"mdrods06.des", "", int32_t(0x00000000), int32_t(0xD2A1B316)},
    {"mdrods06.sno", "", int32_t(0x00000000), int32_t(0x3C3D8367)},
    {"mdrods06.tem", "", int32_t(0x00000000), int32_t(0x34882D05)},
    {"mdrods06.urb", "", int32_t(0x00000000), int32_t(0xA076DE35)},
    {"mdrods07.des", "", int32_t(0x00000000), int32_t(0xEFC19AA6)},
    {"mdrods07.sno", "", int32_t(0x00000000), int32_t(0x015DAAD7)},
    {"mdrods07.tem", "", int32_t(0x00000000), int32_t(0x09E804B5)},
    {"mdrods07.urb", "", int32_t(0x00000000), int32_t(0x9D16F785)},
    {"mdrods08.des", "", int32_t(0x00000000), int32_t(0x6D910D77)},
    {"mdrods08.sno", "", int32_t(0x00000000), int32_t(0x830D3D06)},
    {"mdrods08.tem", "", int32_t(0x00000000), int32_t(0x8BB89364)},
    {"mdrods08.urb", "", int32_t(0x00000000), int32_t(0x1F466054)},
    {"mdrods09.des", "", int32_t(0x00000000), int32_t(0x50F124C7)},
    {"mdrods09.sno", "", int32_t(0x00000000), int32_t(0xBE6D14B6)},
    {"mdrods09.tem", "", int32_t(0x00000000), int32_t(0xB6D8BAD4)},
    {"mdrods09.urb", "", int32_t(0x00000000), int32_t(0x222649E4)},
    {"mdrods10.des", "", int32_t(0x00000000), int32_t(0x96BD9513)},
    {"mdrods10.sno", "", int32_t(0x00000000), int32_t(0x7821A562)},
    {"mdrods10.tem", "", int32_t(0x00000000), int32_t(0x70940B00)},
    {"mdrods10.urb", "", int32_t(0x00000000), int32_t(0xE46AF830)},
    {"mdrods11.des", "", int32_t(0x00000000), int32_t(0xABDDBCA3)},
    {"mdrods11.sno", "", int32_t(0x00000000), int32_t(0x45418CD2)},
    {"mdrods11.tem", "", int32_t(0x00000000), int32_t(0x4DF422B0)},
    {"mdrods11.urb", "", int32_t(0x00000000), int32_t(0xD90AD180)},
    {"mdrods12.des", "", int32_t(0x00000000), int32_t(0xEC7DC673)},
    {"mdrods12.sno", "", int32_t(0x00000000), int32_t(0x02E1F602)},
    {"mdrods12.tem", "", int32_t(0x00000000), int32_t(0x0A545860)},
    {"mdrods12.urb", "", int32_t(0x00000000), int32_t(0x9EAAAB50)},
    {"mdrods13.des", "", int32_t(0x00000000), int32_t(0xD11DEFC3)},
    {"mdrods13.sno", "", int32_t(0x00000000), int32_t(0x3F81DFB2)},
    {"mdrods13.tem", "", int32_t(0x00000000), int32_t(0x373471D0)},
    {"mdrods13.urb", "", int32_t(0x00000000), int32_t(0xA3CA82E0)},
    {"mdrods14.des", "", int32_t(0x00000000), int32_t(0x633D33D3)},
    {"mdrods14.sno", "", int32_t(0x00000000), int32_t(0x8DA103A2)},
    {"mdrods14.tem", "", int32_t(0x00000000), int32_t(0x8514ADC0)},
    {"mdrods14.urb", "", int32_t(0x00000000), int32_t(0x11EA5EF0)},
    {"mdrods15.des", "", int32_t(0x00000000), int32_t(0x5E5D1A63)},
    {"mdrods15.sno", "", int32_t(0x00000000), int32_t(0xB0C12A12)},
    {"mdrods15.tem", "", int32_t(0x00000000), int32_t(0xB8748470)},
    {"mdrods15.urb", "", int32_t(0x00000000), int32_t(0x2C8A7740)},
    {"mdrods16.des", "", int32_t(0x00000000), int32_t(0x19FD60B3)},
    {"mdrods16.sno", "", int32_t(0x00000000), int32_t(0xF76150C2)},
    {"mdrods16.tem", "", int32_t(0x00000000), int32_t(0xFFD4FEA0)},
    {"mdrods16.urb", "", int32_t(0x00000000), int32_t(0x6B2A0D90)},
    {"mdrods17.des", "", int32_t(0x00000000), int32_t(0x249D4903)},
    {"mdrods17.sno", "", int32_t(0x00000000), int32_t(0xCA017972)},
    {"mdrods17.tem", "", int32_t(0x00000000), int32_t(0xC2B4D710)},
    {"mdrods17.urb", "", int32_t(0x00000000), int32_t(0x564A2420)},
    {"mdrods18.des", "", int32_t(0x00000000), int32_t(0xA6CDDED2)},
    {"mdrods18.sno", "", int32_t(0x00000000), int32_t(0x4851EEA3)},
    {"mdrods18.tem", "", int32_t(0x00000000), int32_t(0x40E440C1)},
    {"mdrods18.urb", "", int32_t(0x00000000), int32_t(0xD41AB3F1)},
    {"mdrods19.des", "", int32_t(0x00000000), int32_t(0x9BADF762)},
    {"mdrods19.sno", "", int32_t(0x00000000), int32_t(0x7531C713)},
    {"mdrods19.tem", "", int32_t(0x00000000), int32_t(0x7D846971)},
    {"mdrods19.urb", "", int32_t(0x00000000), int32_t(0xE97A9A41)},
    {"mdrods20.des", "", int32_t(0x00000000), int32_t(0x1029E7BD)},
    {"mdrods20.sno", "", int32_t(0x00000000), int32_t(0xFEB5D7CC)},
    {"mdrods20.tem", "", int32_t(0x00000000), int32_t(0xF60079AE)},
    {"mdrods20.urb", "", int32_t(0x00000000), int32_t(0x62FE8A9E)},
    {"mdrods21.des", "", int32_t(0x00000000), int32_t(0x2D49CE0D)},
    {"mdrods21.sno", "", int32_t(0x00000000), int32_t(0xC3D5FE7C)},
    {"mdrods21.tem", "", int32_t(0x00000000), int32_t(0xCB60501E)},
    {"mdrods21.urb", "", int32_t(0x00000000), int32_t(0x5F9EA32E)},
    {"mdrods22.des", "", int32_t(0x00000000), int32_t(0x6AE9B4DD)},
    {"mdrods22.sno", "", int32_t(0x00000000), int32_t(0x847584AC)},
    {"mdrods22.tem", "", int32_t(0x00000000), int32_t(0x8CC02ACE)},
    {"mdrods22.urb", "", int32_t(0x00000000), int32_t(0x183ED9FE)},
    {"mdrods23.des", "", int32_t(0x00000000), int32_t(0x57899D6D)},
    {"mdrods23.sno", "", int32_t(0x00000000), int32_t(0xB915AD1C)},
    {"mdrods23.tem", "", int32_t(0x00000000), int32_t(0xB1A0037E)},
    {"mdrods23.urb", "", int32_t(0x00000000), int32_t(0x255EF04E)},
    {"mdrods24.des", "", int32_t(0x00000000), int32_t(0xE5A9417D)},
    {"mdrods24.sno", "", int32_t(0x00000000), int32_t(0x0B35710C)},
    {"mdrods24.tem", "", int32_t(0x00000000), int32_t(0x0380DF6E)},
    {"mdrods24.urb", "", int32_t(0x00000000), int32_t(0x977E2C5E)},
    {"mdrods25.des", "", int32_t(0x00000000), int32_t(0xD8C968CD)},
    {"mdrods25.sno", "", int32_t(0x00000000), int32_t(0x365558BC)},
    {"mdrods25.tem", "", int32_t(0x00000000), int32_t(0x3EE0F6DE)},
    {"mdrods25.urb", "", int32_t(0x00000000), int32_t(0xAA1E05EE)},
    {"mdrods26.des", "", int32_t(0x00000000), int32_t(0x9F69121D)},
    {"mdrods26.sno", "", int32_t(0x00000000), int32_t(0x71F5226C)},
    {"mdrods26.tem", "", int32_t(0x00000000), int32_t(0x79408C0E)},
    {"mdrods26.urb", "", int32_t(0x00000000), int32_t(0xEDBE7F3E)},
    {"mdrods27.des", "", int32_t(0x00000000), int32_t(0xA2093BAD)},
    {"mdrods27.sno", "", int32_t(0x00000000), int32_t(0x4C950BDC)},
    {"mdrods27.tem", "", int32_t(0x00000000), int32_t(0x4420A5BE)},
    {"mdrods27.urb", "", int32_t(0x00000000), int32_t(0xD0DE568E)},
    {"mdrods28.des", "", int32_t(0x00000000), int32_t(0x2059AC7C)},
    {"mdrods28.sno", "", int32_t(0x00000000), int32_t(0xCEC59C0D)},
    {"mdrods28.tem", "", int32_t(0x00000000), int32_t(0xC670326F)},
    {"mdrods28.urb", "", int32_t(0x00000000), int32_t(0x528EC15F)},
    {"mdrods29.des", "", int32_t(0x00000000), int32_t(0x1D3985CC)},
    {"mdrods29.sno", "", int32_t(0x00000000), int32_t(0xF3A5B5BD)},
    {"mdrods29.tem", "", int32_t(0x00000000), int32_t(0xFB101BDF)},
    {"mdrods29.urb", "", int32_t(0x00000000), int32_t(0x6FEEE8EF)},
    {"mdrods30.des", "", int32_t(0x00000000), int32_t(0xDB753418)},
    {"mdrods30.sno", "", int32_t(0x00000000), int32_t(0x35E90469)},
    {"mdrods30.tem", "", int32_t(0x00000000), int32_t(0x3D5CAA0B)},
    {"mdrods30.urb", "", int32_t(0x00000000), int32_t(0xA9A2593B)},
    {"mdrods31.des", "", int32_t(0x00000000), int32_t(0xE6151DA8)},
    {"mdrods31.sno", "", int32_t(0x00000000), int32_t(0x08892DD9)},
    {"mdrods31.tem", "", int32_t(0x00000000), int32_t(0x003C83BB)},
    {"mdrods31.urb", "", int32_t(0x00000000), int32_t(0x94C2708B)},
    {"mdrods32.des", "", int32_t(0x00000000), int32_t(0xA1B56778)},
    {"mdrods32.sno", "", int32_t(0x00000000), int32_t(0x4F295709)},
    {"mdrods32.tem", "", int32_t(0x00000000), int32_t(0x479CF96B)},
    {"mdrods32.urb", "", int32_t(0x00000000), int32_t(0xD3620A5B)},
    {"mdrods33.des", "", int32_t(0x00000000), int32_t(0x9CD54EC8)},
    {"mdrods33.sno", "", int32_t(0x00000000), int32_t(0x72497EB9)},
    {"mdrods33.tem", "", int32_t(0x00000000), int32_t(0x7AFCD0DB)},
    {"mdrods33.urb", "", int32_t(0x00000000), int32_t(0xEE0223EB)},
    {"mdrods34.des", "", int32_t(0x00000000), int32_t(0x2EF592D8)},
    {"mdrods34.sno", "", int32_t(0x00000000), int32_t(0xC069A2A9)},
    {"mdrods34.tem", "", int32_t(0x00000000), int32_t(0xC8DC0CCB)},
    {"mdrods34.urb", "", int32_t(0x00000000), int32_t(0x5C22FFFB)},
    {"mdrods35.des", "", int32_t(0x00000000), int32_t(0x1395BB68)},
    {"mdrods35.sno", "", int32_t(0x00000000), int32_t(0xFD098B19)},
    {"mdrods35.tem", "", int32_t(0x00000000), int32_t(0xF5BC257B)},
    {"mdrods35.urb", "", int32_t(0x00000000), int32_t(0x6142D64B)},
    {"mdrods36.des", "", int32_t(0x00000000), int32_t(0x5435C1B8)},
    {"mdrods36.sno", "", int32_t(0x00000000), int32_t(0xBAA9F1C9)},
    {"mdrods36.tem", "", int32_t(0x00000000), int32_t(0xB21C5FAB)},
    {"mdrods36.urb", "", int32_t(0x00000000), int32_t(0x26E2AC9B)},
    {"mdrods37.des", "", int32_t(0x00000000), int32_t(0x6955E808)},
    {"mdrods37.sno", "", int32_t(0x00000000), int32_t(0x87C9D879)},
    {"mdrods37.tem", "", int32_t(0x00000000), int32_t(0x8F7C761B)},
    {"mdrods37.urb", "", int32_t(0x00000000), int32_t(0x1B82852B)},
    {"mdrods38.des", "", int32_t(0x00000000), int32_t(0xEB057FD9)},
    {"mdrods38.sno", "", int32_t(0x00000000), int32_t(0x05994FA8)},
    {"mdrods38.tem", "", int32_t(0x00000000), int32_t(0x0D2CE1CA)},
    {"mdrods38.urb", "", int32_t(0x00000000), int32_t(0x99D212FA)},
    {"mdrods39.des", "", int32_t(0x00000000), int32_t(0xD6655669)},
    {"mdrods39.sno", "", int32_t(0x00000000), int32_t(0x38F96618)},
    {"mdrods39.tem", "", int32_t(0x00000000), int32_t(0x304CC87A)},
    {"mdrods39.urb", "", int32_t(0x00000000), int32_t(0xA4B23B4A)},
    {"mdrods40.des", "", int32_t(0x00000000), int32_t(0xC67004A0)},
    {"mdrods40.sno", "", int32_t(0x00000000), int32_t(0x28EC34D1)},
    {"mdrods40.tem", "", int32_t(0x00000000), int32_t(0x20599AB3)},
    {"mdrods40.urb", "", int32_t(0x00000000), int32_t(0xB4A76983)},
    {"mdrods41.des", "", int32_t(0x00000000), int32_t(0xFB102D10)},
    {"mdrods41.sno", "", int32_t(0x00000000), int32_t(0x158C1D61)},
    {"mdrods41.tem", "", int32_t(0x00000000), int32_t(0x1D39B303)},
    {"mdrods41.urb", "", int32_t(0x00000000), int32_t(0x89C74033)},
    {"mdrods42.des", "", int32_t(0x00000000), int32_t(0xBCB057C0)},
    {"mdrods42.sno", "", int32_t(0x00000000), int32_t(0x522C67B1)},
    {"mdrods42.tem", "", int32_t(0x00000000), int32_t(0x5A99C9D3)},
    {"mdrods42.urb", "", int32_t(0x00000000), int32_t(0xCE673AE3)},
    {"mdrods43.des", "", int32_t(0x00000000), int32_t(0x81D07E70)},
    {"mdrods43.sno", "", int32_t(0x00000000), int32_t(0x6F4C4E01)},
    {"mdrods43.tem", "", int32_t(0x00000000), int32_t(0x67F9E063)},
    {"mdrods43.urb", "", int32_t(0x00000000), int32_t(0xF3071353)},
    {"mdrods44.des", "", int32_t(0x00000000), int32_t(0x33F0A260)},
    {"mdrods44.sno", "", int32_t(0x00000000), int32_t(0xDD6C9211)},
    {"mdrods44.tem", "", int32_t(0x00000000), int32_t(0xD5D93C73)},
    {"mdrods44.urb", "", int32_t(0x00000000), int32_t(0x4127CF43)},
    {"mdrods45.des", "", int32_t(0x00000000), int32_t(0x0E908BD0)},
    {"mdrods45.sno", "", int32_t(0x00000000), int32_t(0xE00CBBA1)},
    {"mdrods45.tem", "", int32_t(0x00000000), int32_t(0xE8B915C3)},
    {"mdrods45.urb", "", int32_t(0x00000000), int32_t(0x7C47E6F3)},
    {"mdrods46.des", "", int32_t(0x00000000), int32_t(0x4930F100)},
    {"mdrods46.sno", "", int32_t(0x00000000), int32_t(0xA7ACC171)},
    {"mdrods46.tem", "", int32_t(0x00000000), int32_t(0xAF196F13)},
    {"mdrods46.urb", "", int32_t(0x00000000), int32_t(0x3BE79C23)},
    {"mdrods47.des", "", int32_t(0x00000000), int32_t(0x7450D8B0)},
    {"mdrods47.sno", "", int32_t(0x00000000), int32_t(0x9ACCE8C1)},
    {"mdrods47.tem", "", int32_t(0x00000000), int32_t(0x927946A3)},
    {"mdrods47.urb", "", int32_t(0x00000000), int32_t(0x0687B593)},
    {"mdrods48.des", "", int32_t(0x00000000), int32_t(0xF6004F61)},
    {"mdrods48.sno", "", int32_t(0x00000000), int32_t(0x189C7F10)},
    {"mdrods48.tem", "", int32_t(0x00000000), int32_t(0x1029D172)},
    {"mdrods48.urb", "", int32_t(0x00000000), int32_t(0x84D72242)},
    {"mdrods49.des", "", int32_t(0x00000000), int32_t(0xCB6066D1)},
    {"mdrods49.sno", "", int32_t(0x00000000), int32_t(0x25FC56A0)},
    {"mdrods49.tem", "", int32_t(0x00000000), int32_t(0x2D49F8C2)},
    {"mdrods49.urb", "", int32_t(0x00000000), int32_t(0xB9B70BF2)},
    {"mdrods50.des", "", int32_t(0x00000000), int32_t(0x0D2CD705)},
    {"mdrods50.sno", "", int32_t(0x00000000), int32_t(0xE3B0E774)},
    {"mdrods50.tem", "", int32_t(0x00000000), int32_t(0xEB054916)},
    {"mdrods50.urb", "", int32_t(0x00000000), int32_t(0x7FFBBA26)},
    {"mdrods51.des", "", int32_t(0x00000000), int32_t(0x304CFEB5)},
    {"mdrods51.sno", "", int32_t(0x00000000), int32_t(0xDED0CEC4)},
    {"mdrods51.tem", "", int32_t(0x00000000), int32_t(0xD66560A6)},
    {"mdrods51.urb", "", int32_t(0x00000000), int32_t(0x429B9396)},
    {"mdrods52.des", "", int32_t(0x00000000), int32_t(0x77EC8465)},
    {"mdrods52.sno", "", int32_t(0x00000000), int32_t(0x9970B414)},
    {"mdrods52.tem", "", int32_t(0x00000000), int32_t(0x91C51A76)},
    {"mdrods52.urb", "", int32_t(0x00000000), int32_t(0x053BE946)},
    {"mdrods53.des", "", int32_t(0x00000000), int32_t(0x4A8CADD5)},
    {"mdrods53.sno", "", int32_t(0x00000000), int32_t(0xA4109DA4)},
    {"mdrods53.tem", "", int32_t(0x00000000), int32_t(0xACA533C6)},
    {"mdrods53.urb", "", int32_t(0x00000000), int32_t(0x385BC0F6)},
    {"mdrods54.des", "", int32_t(0x00000000), int32_t(0xF8AC71C5)},
    {"mdrods54.sno", "", int32_t(0x00000000), int32_t(0x163041B4)},
    {"mdrods54.tem", "", int32_t(0x00000000), int32_t(0x1E85EFD6)},
    {"mdrods54.urb", "", int32_t(0x00000000), int32_t(0x8A7B1CE6)},
    {"mdrods55.des", "", int32_t(0x00000000), int32_t(0xC5CC5875)},
    {"mdrods55.sno", "", int32_t(0x00000000), int32_t(0x2B506804)},
    {"mdrods55.tem", "", int32_t(0x00000000), int32_t(0x23E5C666)},
    {"mdrods55.urb", "", int32_t(0x00000000), int32_t(0xB71B3556)},
    {"mdrods56.des", "", int32_t(0x00000000), int32_t(0x826C22A5)},
    {"mdrods56.sno", "", int32_t(0x00000000), int32_t(0x6CF012D4)},
    {"mdrods56.tem", "", int32_t(0x00000000), int32_t(0x6445BCB6)},
    {"mdrods56.urb", "", int32_t(0x00000000), int32_t(0xF0BB4F86)},
    {"mdrods57.des", "", int32_t(0x00000000), int32_t(0xBF0C0B15)},
    {"mdrods57.sno", "", int32_t(0x00000000), int32_t(0x51903B64)},
    {"mdrods57.tem", "", int32_t(0x00000000), int32_t(0x59259506)},
    {"mdrods57.urb", "", int32_t(0x00000000), int32_t(0xCDDB6636)},
    {"mdrods58.des", "", int32_t(0x00000000), int32_t(0x3D5C9CC4)},
    {"mdrods58.sno", "", int32_t(0x00000000), int32_t(0xD3C0ACB5)},
    {"mdrods58.tem", "", int32_t(0x00000000), int32_t(0xDB7502D7)},
    {"mdrods58.urb", "", int32_t(0x00000000), int32_t(0x4F8BF1E7)},
    {"mdrods59.des", "", int32_t(0x00000000), int32_t(0x003CB574)},
    {"mdrods59.sno", "", int32_t(0x00000000), int32_t(0xEEA08505)},
    {"mdrods59.tem", "", int32_t(0x00000000), int32_t(0xE6152B67)},
    {"mdrods59.urb", "", int32_t(0x00000000), int32_t(0x72EBD857)},
    {"mdrods60.des", "", int32_t(0x00000000), int32_t(0x8BB8A5AB)},
    {"mdrods60.sno", "", int32_t(0x00000000), int32_t(0x652495DA)},
    {"mdrods60.tem", "", int32_t(0x00000000), int32_t(0x6D913BB8)},
    {"mdrods60.urb", "", int32_t(0x00000000), int32_t(0xF96FC888)},
    {"mdrods61.des", "", int32_t(0x00000000), int32_t(0xB6D88C1B)},
    {"mdrods61.sno", "", int32_t(0x00000000), int32_t(0x5844BC6A)},
    {"mdrods61.tem", "", int32_t(0x00000000), int32_t(0x50F11208)},
    {"mdrods61.urb", "", int32_t(0x00000000), int32_t(0xC40FE138)},
    {"mdrods62.des", "", int32_t(0x00000000), int32_t(0xF178F6CB)},
    {"mdrods62.sno", "", int32_t(0x00000000), int32_t(0x1FE4C6BA)},
    {"mdrods62.tem", "", int32_t(0x00000000), int32_t(0x175168D8)},
    {"mdrods62.urb", "", int32_t(0x00000000), int32_t(0x83AF9BE8)},
    {"mdrods63.des", "", int32_t(0x00000000), int32_t(0xCC18DF7B)},
    {"mdrods63.sno", "", int32_t(0x00000000), int32_t(0x2284EF0A)},
    {"mdrods63.tem", "", int32_t(0x00000000), int32_t(0x2A314168)},
    {"mdrods63.urb", "", int32_t(0x00000000), int32_t(0xBECFB258)},
    {"mdrods64.des", "", int32_t(0x00000000), int32_t(0x7E38036B)},
    {"mdrods64.sno", "", int32_t(0x00000000), int32_t(0x90A4331A)},
    {"mdrods64.tem", "", int32_t(0x00000000), int32_t(0x98119D78)},
    {"mdrods64.urb", "", int32_t(0x00000000), int32_t(0x0CEF6E48)},
    {"mdrods65.des", "", int32_t(0x00000000), int32_t(0x43582ADB)},
    {"mdrods65.sno", "", int32_t(0x00000000), int32_t(0xADC41AAA)},
    {"mdrods65.tem", "", int32_t(0x00000000), int32_t(0xA571B4C8)},
    {"mdrods65.urb", "", int32_t(0x00000000), int32_t(0x318F47F8)},
    {"mdrods66.des", "", int32_t(0x00000000), int32_t(0x04F8500B)},
    {"mdrods66.sno", "", int32_t(0x00000000), int32_t(0xEA64607A)},
    {"mdrods66.tem", "", int32_t(0x00000000), int32_t(0xE2D1CE18)},
    {"mdrods66.urb", "", int32_t(0x00000000), int32_t(0x762F3D28)},
    {"mdrslp01.des", "", int32_t(0x00000000), int32_t(0xC878DF4B)},
    {"mdrslp01.sno", "", int32_t(0x00000000), int32_t(0x26E4EF3A)},
    {"mdrslp01.tem", "", int32_t(0x00000000), int32_t(0x2E514158)},
    {"mdrslp01.urb", "", int32_t(0x00000000), int32_t(0xBAAFB268)},
    {"mdrslp02.des", "", int32_t(0x00000000), int32_t(0x8FD8A59B)},
    {"mdrslp02.sno", "", int32_t(0x00000000), int32_t(0x614495EA)},
    {"mdrslp02.tem", "", int32_t(0x00000000), int32_t(0x69F13B88)},
    {"mdrslp02.urb", "", int32_t(0x00000000), int32_t(0xFD0FC8B8)},
    {"mdrslp03.des", "", int32_t(0x00000000), int32_t(0xB2B88C2B)},
    {"mdrslp03.sno", "", int32_t(0x00000000), int32_t(0x5C24BC5A)},
    {"mdrslp03.tem", "", int32_t(0x00000000), int32_t(0x54911238)},
    {"mdrslp03.urb", "", int32_t(0x00000000), int32_t(0xC06FE108)},
    {"mdrslp04.des", "", int32_t(0x00000000), int32_t(0x0098503B)},
    {"mdrslp04.sno", "", int32_t(0x00000000), int32_t(0xEE04604A)},
    {"mdrslp04.tem", "", int32_t(0x00000000), int32_t(0xE6B1CE28)},
    {"mdrslp04.urb", "", int32_t(0x00000000), int32_t(0x724F3D18)},
    {"mdrslp05.des", "", int32_t(0x00000000), int32_t(0x3DF8798B)},
    {"mdrslp05.sno", "", int32_t(0x00000000), int32_t(0xD36449FA)},
    {"mdrslp05.tem", "", int32_t(0x00000000), int32_t(0xDBD1E798)},
    {"mdrslp05.urb", "", int32_t(0x00000000), int32_t(0x4F2F14A8)},
    {"mdrslp06.des", "", int32_t(0x00000000), int32_t(0x7A58035B)},
    {"mdrslp06.sno", "", int32_t(0x00000000), int32_t(0x94C4332A)},
    {"mdrslp06.tem", "", int32_t(0x00000000), int32_t(0x9C719D48)},
    {"mdrslp06.urb", "", int32_t(0x00000000), int32_t(0x088F6E78)},
    {"mdrslp07.des", "", int32_t(0x00000000), int32_t(0x47382AEB)},
    {"mdrslp07.sno", "", int32_t(0x00000000), int32_t(0xA9A41A9A)},
    {"mdrslp07.tem", "", int32_t(0x00000000), int32_t(0xA111B4F8)},
    {"mdrslp07.urb", "", int32_t(0x00000000), int32_t(0x35EF47C8)},
    {"mdrslp08.des", "", int32_t(0x00000000), int32_t(0xC568BD3A)},
    {"mdrslp08.sno", "", int32_t(0x00000000), int32_t(0x2BF48D4B)},
    {"mdrslp08.tem", "", int32_t(0x00000000), int32_t(0x23412329)},
    {"mdrslp08.urb", "", int32_t(0x00000000), int32_t(0xB7BFD019)},
    {"mech.shp", "unit: mechanic", int32_t(0xE0CEDDC8), int32_t(0x00000000)},
    {"mechan1.aud", "", int32_t(0x7DB406F8), int32_t(0x00000000)},
    {"mechan1c.aud", "", int32_t(0xEBC4F2E5), int32_t(0x00000000)},
    {"mechatak.vqa", "-", int32_t(0x00000000), int32_t(0x31ECF03A)},
    {"mechicon.shp", "icon: mechanic", int32_t(0x0DF3EEF5), int32_t(0x00000000)},
    {"medi.shp", "unit: medic", int32_t(0xE2D0DDC8), int32_t(0x00000000)},
    {"medic.shp", "unit: medic", int32_t(0x00000000), int32_t(0x56705071)},
    {"mediicon.shp", "icon: medic", int32_t(0x11F7EEF5), int32_t(0xB046E3F4)},
    {"medusa.shp", "", int32_t(0x00000000), int32_t(0xDE7FC8C8)},
    {"megabst1.aud", "", int32_t(0xAC1AFCE7), int32_t(0x00000000)},
    {"mekatk2.vqa", "-", int32_t(0x00000000), int32_t(0x8EE5FEB4)},
    {"melodic.bnk", "", int32_t(0x9A02F5FF), int32_t(0x00000000)},
    {"mempfx.shp", "-", int32_t(0x00000000), int32_t(0xAEE0401F)},
    {"mempicon.shp", "-", int32_t(0x00000000), int32_t(0x4C303C14)},
    {"menu6.aud", "", int32_t(0xFFBB71E5), int32_t(0x00000000)},
    {"mercf1.aud", "mersonary freed", int32_t(0x8FA5BC16), int32_t(0x00000000)},
    {"mercr1.aud", "mersonary rescued", int32_t(0x8FA5BC2E), int32_t(0x00000000)},
    {"mercy98.aud", "", int32_t(0x69FDDD28), int32_t(0x00000000)},
    {"merge.flc", "", int32_t(0xB5D57202), int32_t(0x00000000)},
    {"message1.aud", "incomming message", int32_t(0x00000000), int32_t(0x4B7D152B)},
    {"metal12.fnt", "", int32_t(0x00000000), int32_t(0xCFD0D4EC)},
    {"metall1.aud", "", int32_t(0x61F8030E), int32_t(0x00000000)},
    {"metall2.aud", "", int32_t(0x61FA030E), int32_t(0x00000000)},
    {"metall3.aud", "", int32_t(0x61FC030E), int32_t(0x00000000)},
    {"metall4.aud", "", int32_t(0x61FE030E), int32_t(0x00000000)},
    {"metall5.aud", "", int32_t(0x6200030E), int32_t(0x00000000)},
    {"metalplt.shp", "misc: metal plate background", int32_t(0xFE3208FB), int32_t(0x00000000)},
    {"metalr1.aud", "", int32_t(0x61F80F0E), int32_t(0x00000000)},
    {"metalr2.aud", "", int32_t(0x61FA0F0E), int32_t(0x00000000)},
    {"metalr3.aud", "", int32_t(0x61FC0F0E), int32_t(0x00000000)},
    {"metalr4.aud", "", int32_t(0x61FE0F0E), int32_t(0x00000000)},
    {"metalr5.aud", "", int32_t(0x62000F0E), int32_t(0x00000000)},
    {"metdebri.shp", "-", int32_t(0x00000000), int32_t(0x9A1756E5)},
    {"meteor1.aud", "large meteor", int32_t(0x00000000), int32_t(0xE71FC0AC)},
    {"meteor2.aud", "small meteor", int32_t(0x00000000), int32_t(0x618BB202)},
    {"meter.aud", "", int32_t(0xBFD3721D), int32_t(0x00000000)},
    {"meter.flc", "", int32_t(0xADDD721C), int32_t(0x00000000)},
    {"meter000.pcx", "", int32_t(0xCDF4C607), int32_t(0x00000000)},
    {"meter001.pcx", "", int32_t(0xCFF4C607), int32_t(0x00000000)},
    {"methit1.aud", "meteor hits ground", int32_t(0x00000000), int32_t(0xB3EF1B46)},
    {"metlarge.shp", "large meteor", int32_t(0x00000000), int32_t(0x54B018E0)},
    {"metlhit1.aud", "", int32_t(0xD84EE8F3), int32_t(0x00000000)},
    {"metltral.shp", "-", int32_t(0x00000000), int32_t(0xBBA2A6C3)},
    {"metricon.shp", "icon: meteor shower", int32_t(0x00000000), int32_t(0xB97DBEB0)},
    {"metsmall.shp", "small meteor", int32_t(0x00000000), int32_t(0x418794EE)},
    {"metstral.shp", "-", int32_t(0x00000000), int32_t(0xC8DB2B63)},
    {"mex01.des", "", int32_t(0x00000000), int32_t(0x9F458971)},
    {"mex01.tem", "", int32_t(0x00000000), int32_t(0x021BA9FA)},
    {"mex02.des", "", int32_t(0x00000000), int32_t(0x11CA8E92)},
    {"mex02.tem", "", int32_t(0x00000000), int32_t(0x8C94AE19)},
    {"mex03.des", "", int32_t(0x00000000), int32_t(0xDD608E0C)},
    {"mex03.tem", "", int32_t(0x00000000), int32_t(0x403EAE87)},
    {"mex04.des", "", int32_t(0x00000000), int32_t(0xD7A58715)},
    {"mex04.tem", "", int32_t(0x00000000), int32_t(0x4AFBA79E)},
    {"mex05.des", "", int32_t(0x00000000), int32_t(0x1B0F878B)},
    {"mex05.tem", "", int32_t(0x00000000), int32_t(0x8651A700)},
    {"mforzen.vqa", "", int32_t(0xA61AF53F), int32_t(0x00000000)},
    {"mgg.shp", "unit: mobile gap generator", int32_t(0x5CDED6ED), int32_t(0x00000000)},
    {"mggicon.shp", "icon: mobile gap generator", int32_t(0x820A040E), int32_t(0x00000000)},
    {"mgun-e.shp", "machine gun fire (east)", int32_t(0x00000000), int32_t(0x2D7FE0C2)},
    {"mgun-n.shp", "machine gun fire (north)", int32_t(0x00000000), int32_t(0x2F78B438)},
    {"mgun-ne.shp", "machine gun fire (northeast)", int32_t(0x00000000), int32_t(0xB0A7EA47)},
    {"mgun-nw.shp", "machine gun fire (northwest)", int32_t(0x00000000), int32_t(0xFEB949D7)},
    {"mgun-s.shp", "machine gun fire (south)", int32_t(0x00000000), int32_t(0x29714936)},
    {"mgun-se.shp", "machine gun fire (southeast)", int32_t(0x00000000), int32_t(0xB6AE1749)},
    {"mgun-sw.shp", "machine gun fire (southwest)", int32_t(0x00000000), int32_t(0xF8B0B4D9)},
    {"mgun-w.shp", "machine gun fire (west)", int32_t(0x00000000), int32_t(0xDD3E6D25)},
    {"mgun.shp", "misc: gunboat gun", int32_t(0xECF2E1C8), int32_t(0x00000000)},
    {"mgun11.aud", "gunshot", int32_t(0xBBB1C3EC), int32_t(0x00000000)},
    {"mgun11.juv", "gunshot", int32_t(0xCDB1D5EC), int32_t(0x00000000)},
    {"mgun2.aud", "gunshot", int32_t(0xE3D779DD), int32_t(0x00000000)},
    {"mgun2.juv", "gunshot", int32_t(0xE3E979EF), int32_t(0x00000000)},
    {"mguninf1.aud", "rapid shoot", int32_t(0xE036FAF5), int32_t(0x00000000)},
    {"mhear1.aud", "mech: i hear ya", int32_t(0x8771C82E), int32_t(0x00000000)},
    {"mhello1.aud", "hello", int32_t(0x8DBC150E), int32_t(0x00000000)},
    {"mhijack.shp", "unit: mutant hijacker", int32_t(0x00000000), int32_t(0x9FB89BAF)},
    {"mhmmm1.aud", "hmmm", int32_t(0xB791C824), int32_t(0x00000000)},
    {"mhotdig1.aud", "mech: hot diggity", int32_t(0xF820F4EB), int32_t(0x00000000)},
    {"mhowdy1.aud", "mech: howdy", int32_t(0xB9E428FE), int32_t(0x00000000)},
    {"mhq.shp", "mobile hq", int32_t(0x5CF2D8ED), int32_t(0x00000000)},
    {"mhqicon.shp", "icon: mobile hq", int32_t(0x8232080E), int32_t(0x00000000)},
    {"mhuh1.aud", "mech: huh", int32_t(0xCBD77DDB), int32_t(0x00000000)},
    {"miami01.urb", "", int32_t(0x00000000), int32_t(0xC1729F5F)},
    {"miami02.urb", "", int32_t(0x00000000), int32_t(0x47E6EDF1)},
    {"miami03.urb", "", int32_t(0x00000000), int32_t(0x8CBA3E54)},
    {"miami04.urb", "", int32_t(0x00000000), int32_t(0x91BF0EEC)},
    {"miami05.urb", "", int32_t(0x00000000), int32_t(0x5AE3DD49)},
    {"miami06.urb", "", int32_t(0x00000000), int32_t(0xDC77AFE7)},
    {"mig.shp", "unit: mig", int32_t(0x5CDEDAED), int32_t(0x00000000)},
    {"mig.vqa", "mig blows up apc", int32_t(0x5CCFE3F0), int32_t(0x00000000)},
    {"mig.vqp", "vqp: mig blows up apc", int32_t(0x5CDEE3F0), int32_t(0x00000000)},
    {"mig_hi.pcx", "pict: mig blows up apc", int32_t(0x1D7A1007), int32_t(0x00000000)},
    {"mig_lo.cps", "pict: mig blows up apc", int32_t(0x037A171C), int32_t(0x00000000)},
    {"migicon.shp", "icon: mig attack plane", int32_t(0x820A0C0E), int32_t(0x00000000)},
    {"mind.hva", "", int32_t(0x00000000), int32_t(0x4D5622CB)},
    {"mind.vxl", "", int32_t(0x00000000), int32_t(0xBBDCFD82)},
    {"mindanim.shp", "", int32_t(0x00000000), int32_t(0x7FFAE515)},
    {"mindanimr.shp", "", int32_t(0x00000000), int32_t(0x939D7D7A)},
    {"mindicon.shp", "", int32_t(0x00000000), int32_t(0x5C3106AD)},
    {"minduico.shp", "", int32_t(0x00000000), int32_t(0x99F7944C)},
    {"mine.shp", "crat: mine", int32_t(0xDAE4E5C8), int32_t(0x00000000)},
    {"mine.sno", "misc: ore mine", int32_t(0xD9EAE5C8), int32_t(0x05E6F2B4)},
    {"mine.tem", "misc: ore mine", int32_t(0xD7E1E6C8), int32_t(0x0D535CD6)},
    {"mine.urb", "", int32_t(0x00000000), int32_t(0x99ADAFE6)},
    {"mine1.aud", "antiman mine", int32_t(0xBFBB81DB), int32_t(0x00000000)},
    {"mineblo1.aud", "antitank mine", int32_t(0xBC2CFEE7), int32_t(0x00000000)},
    {"minelay1.aud", "mine placed", int32_t(0xBC40E8FB), int32_t(0x00000000)},
    {"minigun.shp", "muzzle flash", int32_t(0x82261816), int32_t(0x00000000)},
    {"mininuke.shp", "", int32_t(0x00000000), int32_t(0x4FF43210)},
    {"minp.shp", "bldg: ap mine", int32_t(0xF0E4E5C8), int32_t(0x00000000)},
    {"minpmake.shp", "make: ap mine", int32_t(0x1C17FAFD), int32_t(0x00000000)},
    {"mintro01.vqa", "", int32_t(0xF4EB1A07), int32_t(0x00000000)},
    {"mintro02.vqa", "", int32_t(0xF6EB1A07), int32_t(0x00000000)},
    {"minv.shp", "bldg: at mine", int32_t(0xFCE4E5C8), int32_t(0x00000000)},
    {"minvmake.shp", "make: at mine", int32_t(0x3417FAFD), int32_t(0x00000000)},
    {"miragetank.bmp", "", int32_t(0x00000000), int32_t(0x119D6192)},
    {"mirror1.aud", "", int32_t(0xA5F01F14), int32_t(0x00000000)},
    {"misl.hva", "-", int32_t(0x00000000), int32_t(0xC26E784F)},
    {"misl.vxl", "-", int32_t(0x00000000), int32_t(0x34E4A706)},
    {"misl1.aud", "bike missile", int32_t(0x00000000), int32_t(0x009BB8C6)},
    {"mislchem.hva", "-", int32_t(0x00000000), int32_t(0xEEC7ECD5)},
    {"mislchem.vxl", "chemical missile", int32_t(0x00000000), int32_t(0x184D339C)},
    {"mislmlti.hva", "-", int32_t(0x00000000), int32_t(0x3208AD0A)},
    {"mislmlti.vxl", "multi missile", int32_t(0x00000000), int32_t(0xC4827243)},
    {"mislorca.hva", "-", int32_t(0x00000000), int32_t(0x696F3406)},
    {"mislorca.vxl", "-", int32_t(0x00000000), int32_t(0x9FE5EB4F)},
    {"mislsam.hva", "", int32_t(0x00000000), int32_t(0xA0819552)},
    {"mislsam.vxl", "", int32_t(0x00000000), int32_t(0xAF77E6B9)},
    {"misnlst1.aud", "your mission is a failure", int32_t(0xE04B0CFB), int32_t(0x00000000)},
    {"misnwon1.aud", "mission accomplished", int32_t(0xE03F0511), int32_t(0x00000000)},
    {"miss.shp", "tech center", int32_t(0xF6EEE5C8), int32_t(0x00000000)},
    {"missile.shp", "small rocket", int32_t(0xAA28061A), int32_t(0x717EAB48)},
    {"missile1.aud", "ground to air missile shot", int32_t(0xF42CFEF5), int32_t(0x00000000)},
    {"missile2.shp", "crat: nuclear strike", int32_t(0x022010F5), int32_t(0x00000000)},
    {"missile6.aud", "cruiser missile", int32_t(0xFE2CFEF5), int32_t(0x00000000)},
    {"missile7.aud", "air to air missile", int32_t(0x002CFEF5), int32_t(0x00000000)},
    {"missing.aud", "", int32_t(0xAA201708), int32_t(0x00000000)},
    {"mission.ini", "inif: mission briefings", int32_t(0xAA331210), int32_t(0x8A782347)},
    {"mission1.ini", "fs mission briefings", int32_t(0x00000000), int32_t(0x123EC462)},
    {"missionmd.ini", "", int32_t(0x00000000), int32_t(0xEB5CD6B4)},
    {"missions.mmx", "", int32_t(0x00000000), int32_t(0xB7583BA2)},
    {"missions.pkt", "inif: multiplayer map file names", int32_t(0x483513F5), int32_t(0xFC4AE02C)},
    {"missionsmd.pkt", "", int32_t(0x00000000), int32_t(0x480B82E4)},
    {"mists3.aud", "", int32_t(0xD3A9D030), int32_t(0x00000000)},
    {"mixfile.exe", "", int32_t(0x7631160C), int32_t(0x00000000)},
    {"mlaff1.aud", "mech: hill billy laugh", int32_t(0x9B61D816), int32_t(0x00000000)},
    {"mlevel1a.aud", "", int32_t(0x1FCD0AED), int32_t(0x00000000)},
    {"mlevel2a.aud", "", int32_t(0x1FCF0AED), int32_t(0x00000000)},
    {"mlevel3a.aud", "", int32_t(0x1FD10AED), int32_t(0x00000000)},
    {"mlevel3a.wav", "", int32_t(0x31BD20ED), int32_t(0x00000000)},
    {"mlevel4a.aud", "", int32_t(0x1FD30AED), int32_t(0x00000000)},
    {"mlevel5a.aud", "", int32_t(0x1FD50AED), int32_t(0x00000000)},
    {"mlevel5a.wav", "", int32_t(0x31C120ED), int32_t(0x00000000)},
    {"mlogo.vqa", "", int32_t(0xBFE98E14), int32_t(0x00000000)},
    {"mlow2.img", "", int32_t(0xF7CF8DE0), int32_t(0x00000000)},
    {"mlow2.lmf", "", int32_t(0xF7D58DDF), int32_t(0x00000000)},
    {"mlow2.lsv", "", int32_t(0x03D58DEE), int32_t(0x00000000)},
    {"mlow2.odf", "", int32_t(0xE5DB8DDF), int32_t(0x00000000)},
    {"mlow2.pcx", "", int32_t(0xE3DD8DF1), int32_t(0x00000000)},
    {"mlow2.ver", "", int32_t(0xE7E98DEB), int32_t(0x00000000)},
    {"mlrs.hva", "-", int32_t(0x00000000), int32_t(0xB9BA841E)},
    {"mlrs.shp", "ssm launcher", int32_t(0xF6ECEBC8), int32_t(0x00000000)},
    {"mlrs.vxl", "mlrs", int32_t(0x00000000), int32_t(0x4F305B57)},
    {"mlrsicnh.des", "icon: ssm launcher", int32_t(0x312AFBF5), int32_t(0x00000000)},
    {"mlrsicnh.tem", "icon: ssm launcher", int32_t(0x2B2B0BF5), int32_t(0x00000000)},
    {"mlrsicnh.win", "icon: ssm launcher", int32_t(0x2C2F0EF5), int32_t(0x00000000)},
    {"mlrsicon.shp", "icon: ssm launcher", int32_t(0x3A300AF5), int32_t(0x00000000)},
    {"mlrstur.hva", "-", int32_t(0x00000000), int32_t(0x26B9DE04)},
    {"mlrstur.vxl", "mlrs", int32_t(0x00000000), int32_t(0x294FADEF)},
    {"mltiicon.shp", "icon: multi-missile", int32_t(0x00000000), int32_t(0xECA55C99)},
    {"mltimisl.shp", "multi-missile projectile", int32_t(0x00000000), int32_t(0xC24B9CAD)},
    {"mltiplyr.wsa", "anim: multiplayer score screen", int32_t(0x0B572103), int32_t(0x00000000)},
    {"mmch.shp", "unit: titan", int32_t(0x00000000), int32_t(0x6EF5ABBB)},
    {"mmchbarl.hva", "-", int32_t(0x00000000), int32_t(0x5EDD116D)},
    {"mmchbarl.vxl", "titan turret", int32_t(0x00000000), int32_t(0xA857CE24)},
    {"mmchicon.shp", "icon: titan", int32_t(0x00000000), int32_t(0xFF220D8B)},
    {"mmchtur.hva", "-", int32_t(0x00000000), int32_t(0x01CE37BE)},
    {"mmdat.inf", "inf: list for mm.dat", int32_t(0xA1A39223), int32_t(0x00000000)},
    {"mmgdat.inf", "inf: list for mmgold.dat", int32_t(0xA37A2405), int32_t(0x00000000)},
    {"mmovout1.aud", "medic: moving out!", int32_t(0x003B2101), int32_t(0x00000000)},
    {"mmpb.shp", "", int32_t(0x00000000), int32_t(0xA107C32F)},
    {"mnbttn.shp", "", int32_t(0x00000000), int32_t(0x1BB65278)},
    {"mnky1.aud", "", int32_t(0x0FAF95DA), int32_t(0x00000000)},
    {"mnky2.aud", "", int32_t(0x0FAF95DC), int32_t(0x00000000)},
    {"mnky3.aud", "", int32_t(0x0FAF95DE), int32_t(0x00000000)},
    {"mnkydie1.aud", "", int32_t(0x0C0D0CEB), int32_t(0x00000000)},
    {"mnly.hva", "-", int32_t(0x00000000), int32_t(0x5D49EE7D)},
    {"mnly.shp", "unit: mine layer", int32_t(0x02E0EFC8), int32_t(0x00000000)},
    {"mnly.vxl", "mine layer", int32_t(0x00000000), int32_t(0xABC33134)},
    {"mnlyicon.shp", "icon: mine layer", int32_t(0x521812F4), int32_t(0x00000000)},
    {"mnscrnl.shp", "", int32_t(0x00000000), int32_t(0x65C49126)},
    {"mnscrnlcoopgamesetup.pal", "", int32_t(0x00000000), int32_t(0xD833DD7E)},
    {"mnscrnlcoopgamesetup.shp", "", int32_t(0x00000000), int32_t(0x1FB68421)},
    {"mnscrnlcustomizebattle.pal", "", int32_t(0x00000000), int32_t(0x78A45E31)},
    {"mnscrnlcustomizebattle.shp", "", int32_t(0x00000000), int32_t(0x2EEC89DB)},
    {"mnscrnlcustommatchlobby.pal", "", int32_t(0x00000000), int32_t(0xDE7A8223)},
    {"mnscrnlcustommatchlobby.shp", "", int32_t(0x00000000), int32_t(0x25694B1F)},
    {"mnscrnlmyinformation.pal", "", int32_t(0x00000000), int32_t(0xF0BF1BBC)},
    {"mnscrnlmyinformation.shp", "", int32_t(0x00000000), int32_t(0x373A42E3)},
    {"mnscrns.shp", "", int32_t(0x00000000), int32_t(0x97442168)},
    {"mobemp1.aud", "mobile emp", int32_t(0x00000000), int32_t(0xFABA7FD3)},
    {"mobil01.des", "", int32_t(0x00000000), int32_t(0x75E91768)},
    {"mobil01.tem", "", int32_t(0x00000000), int32_t(0xF1B17F28)},
    {"mobil02.des", "", int32_t(0x00000000), int32_t(0xF37D65C6)},
    {"mobil02.tem", "", int32_t(0x00000000), int32_t(0x77250D86)},
    {"mocash1.aud", "need more funds", int32_t(0x61B4231C), int32_t(0x00000000)},
    {"moebius.shp", "doctor mobieus", int32_t(0x660C301A), int32_t(0x00000000)},
    {"money.shp", "crate: money", int32_t(0x00000000), int32_t(0xA8B246CB)},
    {"monheal1.aud", "", int32_t(0xC82700ED), int32_t(0x00000000)},
    {"monheal2.aud", "", int32_t(0xCA2700ED), int32_t(0x00000000)},
    {"monkcym1.aud", "", int32_t(0xD42930E9), int32_t(0x00000000)},
    {"monkey1.aud", "", int32_t(0x89E04500), int32_t(0x00000000)},
    {"monkey2.aud", "", int32_t(0x89E24500), int32_t(0x00000000)},
    {"monocar.hva", "-", int32_t(0x00000000), int32_t(0x2DD2E8E9)},
    {"monocar.vxl", "train engine", int32_t(0x00000000), int32_t(0x22249B02)},
    {"monoeng.hva", "-", int32_t(0x00000000), int32_t(0x4EEE02AF)},
    {"monoeng.vxl", "train passenger car", int32_t(0x00000000), int32_t(0x41187144)},
    {"monpost1.aud", "", int32_t(0xE8372501), int32_t(0x00000000)},
    {"monster.trr", "", int32_t(0xAA301A31), int32_t(0x00000000)},
    {"montpass.vqa", "truck drives over sign", int32_t(0x39311603), int32_t(0x00000000)},
    {"montpass.vqp", "vqp: truck drives over sign", int32_t(0x48311603), int32_t(0x00000000)},
    {"monumentvalley.map", "", int32_t(0x00000000), int32_t(0x4C070F3E)},
    {"monumentvalleymw.map", "", int32_t(0x00000000), int32_t(0x2E6816AB)},
    {"monwand1.aud", "", int32_t(0x04171AE5), int32_t(0x00000000)},
    {"moonbed2.aud", "", int32_t(0xE21B08E7), int32_t(0x00000000)},
    {"moraji.aud", "", int32_t(0x87A6141E), int32_t(0x00000000)},
    {"morning.ini", "-", int32_t(0x00000000), int32_t(0x51F87D60)},
    {"morpat1a.aud", "", int32_t(0x080126E5), int32_t(0x00000000)},
    {"morpat1b.aud", "", int32_t(0x0A0126E5), int32_t(0x00000000)},
    {"morpat1c.aud", "", int32_t(0x0C0126E5), int32_t(0x00000000)},
    {"morpatk2.aud", "", int32_t(0xEA3526E5), int32_t(0x00000000)},
    {"morpdie1.aud", "", int32_t(0xE82910EB), int32_t(0x00000000)},
    {"morpdie2.aud", "", int32_t(0xEA2910EB), int32_t(0x00000000)},
    {"morph.flc", "", int32_t(0xD9D59A08), int32_t(0x00000000)},
    {"morph1.aud", "", int32_t(0xC3A5E41A), int32_t(0x00000000)},
    {"morphfld.flc", "", int32_t(0x0D2E0FF3), int32_t(0x00000000)},
    {"morphit1.aud", "", int32_t(0xE84710F3), int32_t(0x00000000)},
    {"morphit2.aud", "", int32_t(0xEA4710F3), int32_t(0x00000000)},
    {"morplik1.aud", "", int32_t(0xE83510FB), int32_t(0x00000000)},
    {"morplik2.aud", "", int32_t(0xEA3510FB), int32_t(0x00000000)},
    {"morploi1.aud", "", int32_t(0xE8311CFB), int32_t(0x00000000)},
    {"morploi2.aud", "", int32_t(0xEA311CFB), int32_t(0x00000000)},
    {"morpstn1.aud", "", int32_t(0xE83B2709), int32_t(0x00000000)},
    {"morpstn2.aud", "", int32_t(0xEA3B2709), int32_t(0x00000000)},
    {"morpwk1a.aud", "", int32_t(0x08011511), int32_t(0x00000000)},
    {"morpwk1b.aud", "", int32_t(0x0A011511), int32_t(0x00000000)},
    {"morpwk1c.aud", "", int32_t(0x0C011511), int32_t(0x00000000)},
    {"mortard.shp", "", int32_t(0xAE222A0A), int32_t(0x00000000)},
    {"motion1.aud", "", int32_t(0x81F82F14), int32_t(0x00000000)},
    {"motor1.aud", "audf:", int32_t(0xBFADE42E), int32_t(0x00000000)},
    {"motor2.aud", "audf:", int32_t(0xBFADE62E), int32_t(0x00000000)},
    {"motor3.aud", "audf:", int32_t(0xBFADE82E), int32_t(0x00000000)},
    {"motor4.aud", "audf:", int32_t(0xBFADEA2E), int32_t(0x00000000)},
    {"motor8.aud", "audf:", int32_t(0xBFADF22E), int32_t(0x00000000)},
    {"motorize.wav", "", int32_t(0x00000000), int32_t(0x989F25B8)},
    {"mountmoras.map", "", int32_t(0x00000000), int32_t(0xB6BDB430)},
    {"mouse.aud", "", int32_t(0xF7D79A03), int32_t(0x00000000)},
    {"mouse.sha", "", int32_t(0x00000000), int32_t(0x52FE1053)},
    {"mouse.shp", "curs: mouse cursors", int32_t(0xDDFB9A0F), int32_t(0x8332234B)},
    {"mouse3.shp", "", int32_t(0xF3B1F407), int32_t(0x00000000)},
    {"mouseh.shp", "", int32_t(0xF3B21E07), int32_t(0x00000000)},
    {"mousel.shp", "", int32_t(0xF3B22607), int32_t(0x00000000)},
    {"mouseoff.aud", "", int32_t(0x00000000), int32_t(0xDE0F3304)},
    {"mouseon.aud", "", int32_t(0x00000000), int32_t(0x5815963F)},
    {"mousepal.pal", "mouse cursors palette", int32_t(0x00000000), int32_t(0x25BD611A)},
    {"mouths.wsa", "anim: mouths moving", int32_t(0xFFB22518), int32_t(0x00000000)},
    {"move1.aud", "", int32_t(0xBFDB99DB), int32_t(0x00000000)},
    {"move2.aud", "", int32_t(0xBFDB99DD), int32_t(0x00000000)},
    {"move3.aud", "", int32_t(0xBFDB99DF), int32_t(0x00000000)},
    {"moveflsh.int", "movement circles", int32_t(0xFA4E1EEF), int32_t(0x00000000)},
    {"moveflsh.shp", "movement circles", int32_t(0xF64828EF), int32_t(0x00000000)},
    {"moveflsh.sno", "misc: movement circles", int32_t(0xF54E28EF), int32_t(0x00000000)},
    {"moveflsh.tem", "misc: movement circles", int32_t(0xF34529EF), int32_t(0x00000000)},
    {"movelite.shp", "", int32_t(0x00000000), int32_t(0x65D78BD2)},
    {"movies.mix", "", int32_t(0xBFB63C08), int32_t(0x00000000)},
    {"movies1.mix", "movies1.mix", int32_t(0x82142D0C), int32_t(0x00000000)},
    {"movies2.mix", "movies2.mix", int32_t(0x82162D0C), int32_t(0x00000000)},
    {"movingin.vqa", "troups moving in", int32_t(0x033D21FF), int32_t(0x00000000)},
    {"movingin.vqp", "vqp: troups moving in", int32_t(0x123D21FF), int32_t(0x00000000)},
    {"movout1.v00", "move out #1", int32_t(0x99EC1635), int32_t(0x00000000)},
    {"movout1.v01", "move out #2", int32_t(0x99ED1635), int32_t(0x00000000)},
    {"movout1.v02", "move out #3", int32_t(0x99EE1635), int32_t(0x00000000)},
    {"movout1.v03", "move out #4", int32_t(0x99EF1635), int32_t(0x00000000)},
    {"mp01du.map", "", int32_t(0x00000000), int32_t(0xC1180B29)},
    {"mp01t4.map", "", int32_t(0x00000000), int32_t(0x90627D53)},
    {"mp02t2.map", "", int32_t(0x00000000), int32_t(0xCA3F74AC)},
    {"mp03t4.map", "", int32_t(0x00000000), int32_t(0xBE9455D5)},
    {"mp04t8.map", "", int32_t(0x00000000), int32_t(0x1D555268)},
    {"mp05du.map", "", int32_t(0x00000000), int32_t(0x9CF45A25)},
    {"mp05mw.map", "", int32_t(0x00000000), int32_t(0x14245027)},
    {"mp05t4.map", "", int32_t(0x00000000), int32_t(0xCD8E2C5F)},
    {"mp06mw.map", "", int32_t(0x00000000), int32_t(0x2DA96CE2)},
    {"mp06t2.map", "", int32_t(0x00000000), int32_t(0x97D325A0)},
    {"mp07t4.map", "", int32_t(0x00000000), int32_t(0xE37804D9)},
    {"mp08mw.map", "", int32_t(0x00000000), int32_t(0xE56BB770)},
    {"mp08t2.map", "", int32_t(0x00000000), int32_t(0x5F11FE32)},
    {"mp09du.map", "", int32_t(0x00000000), int32_t(0x7AC0A931)},
    {"mp09t3.map", "", int32_t(0x00000000), int32_t(0xEE1DE1C5)},
    {"mp10s4.map", "", int32_t(0x00000000), int32_t(0x621E0B37)},
    {"mp11t2.map", "", int32_t(0x00000000), int32_t(0x1C702357)},
    {"mp12s4.map", "", int32_t(0x00000000), int32_t(0x4CE823B1)},
    {"mp13du.map", "", int32_t(0x00000000), int32_t(0x002C4891)},
    {"mp13mw.map", "", int32_t(0x00000000), int32_t(0x88FC4293)},
    {"mp13s4.map", "", int32_t(0x00000000), int32_t(0x5B9337F2)},
    {"mp13s4mw.map", "", int32_t(0x00000000), int32_t(0x39FC2E67)},
    {"mp14mw.map", "", int32_t(0x00000000), int32_t(0xEC9D2F5A)},
    {"mp14t2.map", "", int32_t(0x00000000), int32_t(0x56E76618)},
    {"mp15du.map", "", int32_t(0x00000000), int32_t(0x7336311B)},
    {"mp15mw.map", "", int32_t(0x00000000), int32_t(0xFBE63B19)},
    {"mp15s4.map", "", int32_t(0x00000000), int32_t(0x28894E78)},
    {"mp16mw.map", "", int32_t(0x00000000), int32_t(0xC26B07DC)},
    {"mp16s4.map", "", int32_t(0x00000000), int32_t(0x110472BD)},
    {"mp17du.map", "", int32_t(0x00000000), int32_t(0x5DC0199D)},
    {"mp17mw.map", "", int32_t(0x00000000), int32_t(0xD510139F)},
    {"mp17t6.map", "", int32_t(0x00000000), int32_t(0x9B257ECE)},
    {"mp18du.map", "", int32_t(0x00000000), int32_t(0x8279D64C)},
    {"mp18s3.map", "", int32_t(0x00000000), int32_t(0x1C6197A1)},
    {"mp19t4.map", "", int32_t(0x00000000), int32_t(0xC478B475)},
    {"mp20mw.map", "", int32_t(0x00000000), int32_t(0x5A46C555)},
    {"mp20t6.map", "", int32_t(0x00000000), int32_t(0x1473A804)},
    {"mp21s2.map", "", int32_t(0x00000000), int32_t(0xFD82914D)},
    {"mp22mw.map", "", int32_t(0x00000000), int32_t(0x74B0EDD3)},
    {"mp22s8.map", "", int32_t(0x00000000), int32_t(0x607FF2C6)},
    {"mp23mw.map", "", int32_t(0x00000000), int32_t(0x63CBF990)},
    {"mp23t4.map", "", int32_t(0x00000000), int32_t(0xBA6185E8)},
    {"mp24du.map", "", int32_t(0x00000000), int32_t(0x8F7A9E5B)},
    {"mp24t2.map", "", int32_t(0x00000000), int32_t(0xBDD0DD1B)},
    {"mp25du.map", "", int32_t(0x00000000), int32_t(0x98018A18)},
    {"mp25mw.map", "", int32_t(0x00000000), int32_t(0x10D1801A)},
    {"mp25t6.map", "", int32_t(0x00000000), int32_t(0x5EE4ED4B)},
    {"mp26s6.map", "", int32_t(0x00000000), int32_t(0x6DACD897)},
    {"mp27du.map", "", int32_t(0x00000000), int32_t(0xB6F7A29E)},
    {"mp27mw.map", "", int32_t(0x00000000), int32_t(0x3E27A89C)},
    {"mp27t8.map", "", int32_t(0x00000000), int32_t(0x202DBE90)},
    {"mp28du.map", "", int32_t(0x00000000), int32_t(0x694E6D4F)},
    {"mp28u4.map", "", int32_t(0x00000000), int32_t(0xF49E1BAB)},
    {"mp29mw.map", "", int32_t(0x00000000), int32_t(0xF6E5730E)},
    {"mp29u2.map", "", int32_t(0x00000000), int32_t(0x80353AD2)},
    {"mp29u4.map", "", int32_t(0x00000000), int32_t(0xE3E50FE8)},
    {"mp30mw.map", "", int32_t(0x00000000), int32_t(0xB584AE6B)},
    {"mp30s6.map", "", int32_t(0x00000000), int32_t(0xF174CA23)},
    {"mp30s8.map", "", int32_t(0x00000000), int32_t(0xA14BB17E)},
    {"mp31s2.map", "", int32_t(0x00000000), int32_t(0x1240FA73)},
    {"mp32du.map", "", int32_t(0x00000000), int32_t(0x13A28CEF)},
    {"mp32mw.map", "", int32_t(0x00000000), int32_t(0x9B7286ED)},
    {"mp32s8.map", "", int32_t(0x00000000), int32_t(0x8FBD99F8)},
    {"mp33u4.map", "", int32_t(0x00000000), int32_t(0x9909EE48)},
    {"mp34u4.map", "", int32_t(0x00000000), int32_t(0xFD688381)},
    {"mp3dec.asi", "", int32_t(0x932A1112), int32_t(0x00000000)},
    {"mpain1.aud", "", int32_t(0xA761E826), int32_t(0x00000000)},
    {"mpain2.aud", "", int32_t(0xA761EA26), int32_t(0x00000000)},
    {"mpain3.aud", "", int32_t(0xA761EC26), int32_t(0x00000000)},
    {"mpain4.aud", "", int32_t(0xA761EE26), int32_t(0x00000000)},
    {"mpain5.aud", "", int32_t(0xA761F026), int32_t(0x00000000)},
    {"mpain6.aud", "", int32_t(0xA761F226), int32_t(0x00000000)},
    {"mpain7.aud", "", int32_t(0xA761F426), int32_t(0x00000000)},
    {"mpascrn.pal", "", int32_t(0x00000000), int32_t(0xB06BC277)},
    {"mpascrnl.shp", "", int32_t(0x00000000), int32_t(0x51D583A1)},
    {"mpascrnlbar01.pcx", "", int32_t(0x00000000), int32_t(0x97071759)},
    {"mpascrnlbar02.pcx", "", int32_t(0x00000000), int32_t(0x198810BA)},
    {"mpascrnlbar03.pcx", "", int32_t(0x00000000), int32_t(0xD5221024)},
    {"mpascrnlbar04.pcx", "", int32_t(0x00000000), int32_t(0xDFE7193D)},
    {"mpascrnlbar05.pcx", "", int32_t(0x00000000), int32_t(0x134D19A3)},
    {"mpascrnlbar06.pcx", "", int32_t(0x00000000), int32_t(0x9DC21E40)},
    {"mpascrnlbar07.pcx", "", int32_t(0x00000000), int32_t(0x51681EDE)},
    {"mpascrnlbar08.pcx", "", int32_t(0x00000000), int32_t(0x88480C72)},
    {"mpascrnlbar09.pcx", "", int32_t(0x00000000), int32_t(0x44E20CEC)},
    {"mpascrnlbar10.pcx", "", int32_t(0x00000000), int32_t(0x4CD60384)},
    {"mpascrns.shp", "", int32_t(0x00000000), int32_t(0xB36583F2)},
    {"mpbattle.ini", "", int32_t(0x00000000), int32_t(0x4E22B5C7)},
    {"mpbattlemd.ini", "", int32_t(0x00000000), int32_t(0xAF084179)},
    {"mpcoop.ini", "", int32_t(0x00000000), int32_t(0xC5FE2DFC)},
    {"mpcoopmd.ini", "", int32_t(0x00000000), int32_t(0x4A80F610)},
    {"mpduel.ini", "", int32_t(0x00000000), int32_t(0x2F721418)},
    {"mpduelmd.ini", "", int32_t(0x00000000), int32_t(0xA00CCFF4)},
    {"mpfreeforall.ini", "", int32_t(0x00000000), int32_t(0x4651EB11)},
    {"mpfreeforallmd.ini", "", int32_t(0x00000000), int32_t(0xC0DC0681)},
    {"mplan3.aud", "a wonderfull plan", int32_t(0x878DEC26), int32_t(0x00000000)},
    {"mplayer.ini", "inif: aftermath multiplayer game settings", int32_t(0x621F1A30), int32_t(0x00000000)},
    {"mpls.pal", "", int32_t(0x00000000), int32_t(0x491F1BAC)},
    {"mplsc.pal", "", int32_t(0x00000000), int32_t(0xC0D54909)},
    {"mplsf.pal", "", int32_t(0x00000000), int32_t(0x8835476D)},
    {"mplsg.pal", "", int32_t(0x00000000), int32_t(0x449F47F3)},
    {"mplsi.pal", "", int32_t(0x00000000), int32_t(0x511555C1)},
    {"mplsk.pal", "", int32_t(0x00000000), int32_t(0x133052BC)},
    {"mplsl.pal", "", int32_t(0x00000000), int32_t(0x19F55BA5)},
    {"mplsobs.pal", "", int32_t(0x00000000), int32_t(0xCAACD103)},
    {"mplsr.pal", "", int32_t(0x00000000), int32_t(0x70C478BC)},
    {"mplsu.pal", "", int32_t(0x00000000), int32_t(0x7A0171A5)},
    {"mplsuk.pal", "", int32_t(0x00000000), int32_t(0x5544181C)},
    {"mpmeat.ini", "", int32_t(0x00000000), int32_t(0xAFDCA1F0)},
    {"mpmeatmd.ini", "", int32_t(0x00000000), int32_t(0x20A27A1C)},
    {"mpmodes.ini", "", int32_t(0x00000000), int32_t(0xAC6D82ED)},
    {"mpmodesmd.ini", "", int32_t(0x00000000), int32_t(0xF4887B6B)},
    {"mpmw.ini", "", int32_t(0x00000000), int32_t(0x93C61E76)},
    {"mpmwmd.ini", "", int32_t(0x00000000), int32_t(0x1D9B4286)},
    {"mpnaval.ini", "", int32_t(0x00000000), int32_t(0xB7C94077)},
    {"mpnavalmd.ini", "", int32_t(0x00000000), int32_t(0xF4508884)},
    {"mpscore.pcx", "-", int32_t(0x00000000), int32_t(0x2FB23764)},
    {"mpsiege.ini", "", int32_t(0x00000000), int32_t(0x68AABA0D)},
    {"mpsiegemd.ini", "", int32_t(0x00000000), int32_t(0x103DC95B)},
    {"mpsscrn.pal", "", int32_t(0x00000000), int32_t(0x933093A2)},
    {"mpsscrnl.shp", "", int32_t(0x00000000), int32_t(0x728ED274)},
    {"mpsscrnlbar01.pcx", "", int32_t(0x00000000), int32_t(0xBC7020C2)},
    {"mpsscrnlbar02.pcx", "", int32_t(0x00000000), int32_t(0x32FF2721)},
    {"mpsscrnlbar03.pcx", "", int32_t(0x00000000), int32_t(0xFE5527BF)},
    {"mpsscrnlbar04.pcx", "", int32_t(0x00000000), int32_t(0xF4902EA6)},
    {"mpsscrnlbar05.pcx", "", int32_t(0x00000000), int32_t(0x383A2E38)},
    {"mpsscrnlbar06.pcx", "", int32_t(0x00000000), int32_t(0xB6B529DB)},
    {"mpsscrnlbar07.pcx", "", int32_t(0x00000000), int32_t(0x7A1F2945)},
    {"mpsscrnlbar08.pcx", "", int32_t(0x00000000), int32_t(0xA33F3BE9)},
    {"mpsscrnlbar09.pcx", "", int32_t(0x00000000), int32_t(0x6F953B77)},
    {"mpsscrnlbar10.pcx", "", int32_t(0x00000000), int32_t(0x67A1341F)},
    {"mpsscrns.shp", "", int32_t(0x00000000), int32_t(0x903ED227)},
    {"mpteammd.ini", "", int32_t(0x00000000), int32_t(0x095F0923)},
    {"mpunholy.ini", "", int32_t(0x00000000), int32_t(0xBF347654)},
    {"mpunholymd.ini", "", int32_t(0x00000000), int32_t(0x45365077)},
    {"mpyls.pal", "", int32_t(0x00000000), int32_t(0x0E90BF2E)},
    {"mpyscrn.pal", "", int32_t(0x00000000), int32_t(0x8412036B)},
    {"mpyscrnl.shp", "", int32_t(0x00000000), int32_t(0x65AC42BD)},
    {"mpyscrnlbar01.pcx", "", int32_t(0x00000000), int32_t(0xAEF5E54D)},
    {"mpyscrnlbar02.pcx", "", int32_t(0x00000000), int32_t(0x207AE2AE)},
    {"mpyscrnlbar03.pcx", "", int32_t(0x00000000), int32_t(0xECD0E230)},
    {"mpyscrnlbar04.pcx", "", int32_t(0x00000000), int32_t(0xE615EB29)},
    {"mpyscrnlbar05.pcx", "", int32_t(0x00000000), int32_t(0x2ABFEBB7)},
    {"mpyscrnlbar06.pcx", "", int32_t(0x00000000), int32_t(0xA430EC54)},
    {"mpyscrnlbar07.pcx", "", int32_t(0x00000000), int32_t(0x689AECCA)},
    {"mpyscrnlbar08.pcx", "", int32_t(0x00000000), int32_t(0xB1BAFE66)},
    {"mpyscrnlbar09.pcx", "", int32_t(0x00000000), int32_t(0x7D10FEF8)},
    {"mpyscrnlbar10.pcx", "", int32_t(0x00000000), int32_t(0x7524F190)},
    {"mram01.des", "", int32_t(0x00000000), int32_t(0x46D21475)},
    {"mram01.sno", "", int32_t(0x00000000), int32_t(0xC1FD5B7A)},
    {"mram01.tem", "", int32_t(0x00000000), int32_t(0x308A0D8D)},
    {"mram01.urb", "", int32_t(0x00000000), int32_t(0x48AB89E1)},
    {"mram02.des", "", int32_t(0x00000000), int32_t(0x773A0EE8)},
    {"mram02.sno", "", int32_t(0x00000000), int32_t(0xF01541E7)},
    {"mram02.tem", "", int32_t(0x00000000), int32_t(0x01621710)},
    {"mram02.urb", "", int32_t(0x00000000), int32_t(0x7943937C)},
    {"mram03.des", "", int32_t(0x00000000), int32_t(0xD14D055C)},
    {"mram03.sno", "", int32_t(0x00000000), int32_t(0x56624A53)},
    {"mram03.tem", "", int32_t(0x00000000), int32_t(0xA7151CA4)},
    {"mram03.urb", "", int32_t(0x00000000), int32_t(0xDF3498C8)},
    {"mram04.des", "", int32_t(0x00000000), int32_t(0x14EA3BD2)},
    {"mram04.sno", "", int32_t(0x00000000), int32_t(0x93C574DD)},
    {"mram04.tem", "", int32_t(0x00000000), int32_t(0x62B2222A)},
    {"mram04.urb", "", int32_t(0x00000000), int32_t(0x1A93A646)},
    {"mram05.des", "", int32_t(0x00000000), int32_t(0xB29D3066)},
    {"mram05.sno", "", int32_t(0x00000000), int32_t(0x35B27F69)},
    {"mram05.tem", "", int32_t(0x00000000), int32_t(0xC4C5299E)},
    {"mram05.urb", "", int32_t(0x00000000), int32_t(0xBCE4ADF2)},
    {"mram06.des", "", int32_t(0x00000000), int32_t(0x83752AFB)},
    {"mram06.sno", "", int32_t(0x00000000), int32_t(0x045A65F4)},
    {"mram06.tem", "", int32_t(0x00000000), int32_t(0xF52D3303)},
    {"mram06.urb", "", int32_t(0x00000000), int32_t(0x8D0CB76F)},
    {"mram07.des", "", int32_t(0x00000000), int32_t(0x2502214F)},
    {"mram07.sno", "", int32_t(0x00000000), int32_t(0xA22D6E40)},
    {"mram07.tem", "", int32_t(0x00000000), int32_t(0x535A38B7)},
    {"mram07.urb", "", int32_t(0x00000000), int32_t(0x2B7BBCDB)},
    {"mram08.des", "", int32_t(0x00000000), int32_t(0xD34A51A6)},
    {"mram08.sno", "", int32_t(0x00000000), int32_t(0x54651EA9)},
    {"mram08.tem", "", int32_t(0x00000000), int32_t(0xA512485E)},
    {"mram08.urb", "", int32_t(0x00000000), int32_t(0xDD33CC32)},
    {"mram09.des", "", int32_t(0x00000000), int32_t(0x753D5A12)},
    {"mram09.sno", "", int32_t(0x00000000), int32_t(0xF212151D)},
    {"mram09.tem", "", int32_t(0x00000000), int32_t(0x036543EA)},
    {"mram09.urb", "", int32_t(0x00000000), int32_t(0x7B44C786)},
    {"mram10.des", "", int32_t(0x00000000), int32_t(0x2C0F1F5F)},
    {"mram10.sno", "", int32_t(0x00000000), int32_t(0xAB205050)},
    {"mram10.tem", "", int32_t(0x00000000), int32_t(0x5A5706A7)},
    {"mram10.urb", "", int32_t(0x00000000), int32_t(0x227682CB)},
    {"mramx01.ubn", "", int32_t(0x00000000), int32_t(0x4C270119)},
    {"mramx02.ubn", "", int32_t(0x00000000), int32_t(0xCAB373B7)},
    {"mramx03.ubn", "", int32_t(0x00000000), int32_t(0x01EFA012)},
    {"mramx04.ubn", "", int32_t(0x00000000), int32_t(0x1CEA90AA)},
    {"mramx05.ubn", "", int32_t(0x00000000), int32_t(0xD7B6430F)},
    {"mramx06.ubn", "", int32_t(0x00000000), int32_t(0x512231A1)},
    {"mramx07.ubn", "", int32_t(0x00000000), int32_t(0x9A7EE204)},
    {"mramx08.ubn", "", int32_t(0x00000000), int32_t(0x6B2850D1)},
    {"mramx09.ubn", "", int32_t(0x00000000), int32_t(0xA0748374)},
    {"mramx10.ubn", "", int32_t(0x00000000), int32_t(0x210CD908)},
    {"mrblwlk1.aud", "", int32_t(0xD7F52311), int32_t(0x00000000)},
    {"mrblwlk2.aud", "", int32_t(0xD9F52311), int32_t(0x00000000)},
    {"mrblwlk3.aud", "", int32_t(0xDBF52311), int32_t(0x00000000)},
    {"mrblwlk4.aud", "", int32_t(0xDDF52311), int32_t(0x00000000)},
    {"mrblwlk5.aud", "", int32_t(0xDFF52311), int32_t(0x00000000)},
    {"mrblwlk6.aud", "", int32_t(0xE1F52311), int32_t(0x00000000)},
    {"mrblwlk7.aud", "", int32_t(0xE3F52311), int32_t(0x00000000)},
    {"mrespon1.aud", "medic: medic reporting", int32_t(0xF4072903), int32_t(0x00000000)},
    {"mrise1.aud", "mech: rise n shine", int32_t(0xCF81F014), int32_t(0x00000000)},
    {"mrj.hva", "-", int32_t(0x00000000), int32_t(0xF538458A)},
    {"mrj.shp", "unit: radar jammer", int32_t(0x5CE4ECED), int32_t(0x00000000)},
    {"mrj.vxl", "mobile radar jammer", int32_t(0x00000000), int32_t(0xFACE3661)},
    {"mrj7.aud", "", int32_t(0xB2E9E5C8), int32_t(0x00000000)},
    {"mrjicon.shp", "icon: radar jammer", int32_t(0x8216300E), int32_t(0x00000000)},
    {"mrjtur.hva", "-", int32_t(0x00000000), int32_t(0x8044C0BF)},
    {"mrjtur.vxl", "mobile radar jammer turret", int32_t(0x00000000), int32_t(0x502B203B)},
    {"mrmfx01.des", "", int32_t(0x00000000), int32_t(0xC6C83529)},
    {"mrmfx01.sno", "", int32_t(0x00000000), int32_t(0xE124E8B3)},
    {"mrmfx01.tem", "", int32_t(0x00000000), int32_t(0x42905D69)},
    {"mrmfx01.urb", "", int32_t(0x00000000), int32_t(0x64DD9336)},
    {"mrmfx01a.des", "", int32_t(0x00000000), int32_t(0xFF004CC6)},
    {"mrmfx01a.sno", "", int32_t(0x00000000), int32_t(0x119C7CB7)},
    {"mrmfx01a.tem", "", int32_t(0x00000000), int32_t(0x1929D2D5)},
    {"mrmfx01a.urb", "", int32_t(0x00000000), int32_t(0x8DD721E5)},
    {"mrmfx01b.des", "", int32_t(0x00000000), int32_t(0xB8A03616)},
    {"mrmfx01b.sno", "", int32_t(0x00000000), int32_t(0x563C0667)},
    {"mrmfx01b.tem", "", int32_t(0x00000000), int32_t(0x5E89A805)},
    {"mrmfx01b.urb", "", int32_t(0x00000000), int32_t(0xCA775B35)},
    {"mrmfx01c.des", "", int32_t(0x00000000), int32_t(0x85C01FA6)},
    {"mrmfx01c.sno", "", int32_t(0x00000000), int32_t(0x6B5C2FD7)},
    {"mrmfx01c.tem", "", int32_t(0x00000000), int32_t(0x63E981B5)},
    {"mrmfx01c.urb", "", int32_t(0x00000000), int32_t(0xF7177285)},
    {"mrmfx02.des", "", int32_t(0x00000000), int32_t(0x405C4787)},
    {"mrmfx02.sno", "", int32_t(0x00000000), int32_t(0x67B09A1D)},
    {"mrmfx02.tem", "", int32_t(0x00000000), int32_t(0xC4042FC7)},
    {"mrmfx02.urb", "", int32_t(0x00000000), int32_t(0xE249E198)},
    {"mrmfx02a.des", "", int32_t(0x00000000), int32_t(0x79943E68)},
    {"mrmfx02a.sno", "", int32_t(0x00000000), int32_t(0x97080E19)},
    {"mrmfx02a.tem", "", int32_t(0x00000000), int32_t(0x9FBDA07B)},
    {"mrmfx02a.urb", "", int32_t(0x00000000), int32_t(0x0B43534B)},
    {"mrmfx02b.des", "", int32_t(0x00000000), int32_t(0x3E3444B8)},
    {"mrmfx02b.sno", "", int32_t(0x00000000), int32_t(0xD0A874C9)},
    {"mrmfx02b.tem", "", int32_t(0x00000000), int32_t(0xD81DDAAB)},
    {"mrmfx02b.urb", "", int32_t(0x00000000), int32_t(0x4CE3299B)},
    {"mrmfx02c.des", "", int32_t(0x00000000), int32_t(0x03546D08)},
    {"mrmfx02c.sno", "", int32_t(0x00000000), int32_t(0xEDC85D79)},
    {"mrmfx02c.tem", "", int32_t(0x00000000), int32_t(0xE57DF31B)},
    {"mrmfx02c.urb", "", int32_t(0x00000000), int32_t(0x7183002B)},
    {"mrmfx03.des", "", int32_t(0x00000000), int32_t(0x8B009422)},
    {"mrmfx03.sno", "", int32_t(0x00000000), int32_t(0xACEC49B8)},
    {"mrmfx03.tem", "", int32_t(0x00000000), int32_t(0x0F58FC62)},
    {"mrmfx03.urb", "", int32_t(0x00000000), int32_t(0x2915323D)},
    {"mrmfx03a.des", "", int32_t(0x00000000), int32_t(0xB2C8EDCD)},
    {"mrmfx03a.sno", "", int32_t(0x00000000), int32_t(0x5C54DDBC)},
    {"mrmfx03a.tem", "", int32_t(0x00000000), int32_t(0x54E173DE)},
    {"mrmfx03a.urb", "", int32_t(0x00000000), int32_t(0xC01F80EE)},
    {"mrmfx03b.des", "", int32_t(0x00000000), int32_t(0xF568971D)},
    {"mrmfx03b.sno", "", int32_t(0x00000000), int32_t(0x1BF4A76C)},
    {"mrmfx03b.tem", "", int32_t(0x00000000), int32_t(0x1341090E)},
    {"mrmfx03b.urb", "", int32_t(0x00000000), int32_t(0x87BFFA3E)},
    {"mrmfx03c.des", "", int32_t(0x00000000), int32_t(0xC808BEAD)},
    {"mrmfx03c.sno", "", int32_t(0x00000000), int32_t(0x26948EDC)},
    {"mrmfx03c.tem", "", int32_t(0x00000000), int32_t(0x2E2120BE)},
    {"mrmfx03c.urb", "", int32_t(0x00000000), int32_t(0xBADFD38E)},
    {"mrmfx04.des", "", int32_t(0x00000000), int32_t(0x9605A49A)},
    {"mrmfx04.sno", "", int32_t(0x00000000), int32_t(0xB1E97900)},
    {"mrmfx04.tem", "", int32_t(0x00000000), int32_t(0x125DCCDA)},
    {"mrmfx04.urb", "", int32_t(0x00000000), int32_t(0x34100285)},
    {"mrmfx04a.des", "", int32_t(0x00000000), int32_t(0xAFCDDD75)},
    {"mrmfx04a.sno", "", int32_t(0x00000000), int32_t(0x4151ED04)},
    {"mrmfx04a.tem", "", int32_t(0x00000000), int32_t(0x49E44366)},
    {"mrmfx04a.urb", "", int32_t(0x00000000), int32_t(0xDD1AB056)},
    {"mrmfx04b.des", "", int32_t(0x00000000), int32_t(0xE86DA7A5)},
    {"mrmfx04b.sno", "", int32_t(0x00000000), int32_t(0x06F197D4)},
    {"mrmfx04b.tem", "", int32_t(0x00000000), int32_t(0x0E4439B6)},
    {"mrmfx04b.urb", "", int32_t(0x00000000), int32_t(0x9ABACA86)},
    {"mrmfx04c.des", "", int32_t(0x00000000), int32_t(0xD50D8E15)},
    {"mrmfx04c.sno", "", int32_t(0x00000000), int32_t(0x3B91BE64)},
    {"mrmfx04c.tem", "", int32_t(0x00000000), int32_t(0x33241006)},
    {"mrmfx04c.urb", "", int32_t(0x00000000), int32_t(0xA7DAE336)},
    {"mrmfx05.des", "", int32_t(0x00000000), int32_t(0x5D59773F)},
    {"mrmfx05.sno", "", int32_t(0x00000000), int32_t(0x7AB5AAA5)},
    {"mrmfx05.tem", "", int32_t(0x00000000), int32_t(0xD9011F7F)},
    {"mrmfx05.urb", "", int32_t(0x00000000), int32_t(0xFF4CD120)},
    {"mrmfx05a.des", "", int32_t(0x00000000), int32_t(0x64910ED0)},
    {"mrmfx05a.sno", "", int32_t(0x00000000), int32_t(0x8A0D3EA1)},
    {"mrmfx05a.tem", "", int32_t(0x00000000), int32_t(0x82B890C3)},
    {"mrmfx05a.urb", "", int32_t(0x00000000), int32_t(0x164663F3)},
    {"mrmfx05b.des", "", int32_t(0x00000000), int32_t(0x23317400)},
    {"mrmfx05b.sno", "", int32_t(0x00000000), int32_t(0xCDAD4471)},
    {"mrmfx05b.tem", "", int32_t(0x00000000), int32_t(0xC518EA13)},
    {"mrmfx05b.urb", "", int32_t(0x00000000), int32_t(0x51E61923)},
    {"mrmfx05c.des", "", int32_t(0x00000000), int32_t(0x1E515DB0)},
    {"mrmfx05c.sno", "", int32_t(0x00000000), int32_t(0xF0CD6DC1)},
    {"mrmfx05c.tem", "", int32_t(0x00000000), int32_t(0xF878C3A3)},
    {"mrmfx05c.urb", "", int32_t(0x00000000), int32_t(0x6C863093)},
    {"mrmfx06.des", "", int32_t(0x00000000), int32_t(0xDBCD0591)},
    {"mrmfx06.sno", "", int32_t(0x00000000), int32_t(0xFC21D80B)},
    {"mrmfx06.tem", "", int32_t(0x00000000), int32_t(0x5F956DD1)},
    {"mrmfx06.urb", "", int32_t(0x00000000), int32_t(0x79D8A38E)},
    {"mrmfx06a.des", "", int32_t(0x00000000), int32_t(0xE2057C7E)},
    {"mrmfx06a.sno", "", int32_t(0x00000000), int32_t(0x0C994C0F)},
    {"mrmfx06a.tem", "", int32_t(0x00000000), int32_t(0x042CE26D)},
    {"mrmfx06a.urb", "", int32_t(0x00000000), int32_t(0x90D2115D)},
    {"mrmfx06b.des", "", int32_t(0x00000000), int32_t(0xA5A506AE)},
    {"mrmfx06b.sno", "", int32_t(0x00000000), int32_t(0x4B3936DF)},
    {"mrmfx06b.tem", "", int32_t(0x00000000), int32_t(0x438C98BD)},
    {"mrmfx06b.urb", "", int32_t(0x00000000), int32_t(0xD7726B8D)},
    {"mrmfx06c.des", "", int32_t(0x00000000), int32_t(0x98C52F1E)},
    {"mrmfx06c.sno", "", int32_t(0x00000000), int32_t(0x76591F6F)},
    {"mrmfx06c.tem", "", int32_t(0x00000000), int32_t(0x7EECB10D)},
    {"mrmfx06c.urb", "", int32_t(0x00000000), int32_t(0xEA12423D)},
    {"mrmfx07.des", "", int32_t(0x00000000), int32_t(0x1091D634)},
    {"mrmfx07.sno", "", int32_t(0x00000000), int32_t(0x377D0BAE)},
    {"mrmfx07.tem", "", int32_t(0x00000000), int32_t(0x94C9BE74)},
    {"mrmfx07.urb", "", int32_t(0x00000000), int32_t(0xB284702B)},
    {"mrmfx07a.des", "", int32_t(0x00000000), int32_t(0x2959AFDB)},
    {"mrmfx07a.sno", "", int32_t(0x00000000), int32_t(0xC7C59FAA)},
    {"mrmfx07a.tem", "", int32_t(0x00000000), int32_t(0xCF7031C8)},
    {"mrmfx07a.urb", "", int32_t(0x00000000), int32_t(0x5B8EC2F8)},
    {"mrmfx07b.des", "", int32_t(0x00000000), int32_t(0x6EF9D50B)},
    {"mrmfx07b.sno", "", int32_t(0x00000000), int32_t(0x8065E57A)},
    {"mrmfx07b.tem", "", int32_t(0x00000000), int32_t(0x88D04B18)},
    {"mrmfx07b.urb", "", int32_t(0x00000000), int32_t(0x1C2EB828)},
    {"mrmfx07c.des", "", int32_t(0x00000000), int32_t(0x5399FCBB)},
    {"mrmfx07c.sno", "", int32_t(0x00000000), int32_t(0xBD05CCCA)},
    {"mrmfx07c.tem", "", int32_t(0x00000000), int32_t(0xB5B062A8)},
    {"mrmfx07c.urb", "", int32_t(0x00000000), int32_t(0x214E9198)},
    {"mrmfx08.des", "", int32_t(0x00000000), int32_t(0xE1C764E1)},
    {"mrmfx08.sno", "", int32_t(0x00000000), int32_t(0xC62BB97B)},
    {"mrmfx08.tem", "", int32_t(0x00000000), int32_t(0x659F0CA1)},
    {"mrmfx08.urb", "", int32_t(0x00000000), int32_t(0x43D2C2FE)},
    {"mrmfx08a.des", "", int32_t(0x00000000), int32_t(0xD80F1D0E)},
    {"mrmfx08a.sno", "", int32_t(0x00000000), int32_t(0x36932D7F)},
    {"mrmfx08a.tem", "", int32_t(0x00000000), int32_t(0x3E26831D)},
    {"mrmfx08a.urb", "", int32_t(0x00000000), int32_t(0xAAD8702D)},
    {"mrmfx08b.des", "", int32_t(0x00000000), int32_t(0x9FAF67DE)},
    {"mrmfx08b.sno", "", int32_t(0x00000000), int32_t(0x713357AF)},
    {"mrmfx08b.tem", "", int32_t(0x00000000), int32_t(0x7986F9CD)},
    {"mrmfx08b.urb", "", int32_t(0x00000000), int32_t(0xED780AFD)},
    {"mrmfx08c.des", "", int32_t(0x00000000), int32_t(0xA2CF4E6E)},
    {"mrmfx08c.sno", "", int32_t(0x00000000), int32_t(0x4C537E1F)},
    {"mrmfx08c.tem", "", int32_t(0x00000000), int32_t(0x44E6D07D)},
    {"mrmfx08c.urb", "", int32_t(0x00000000), int32_t(0xD018234D)},
    {"mrmfx09.des", "", int32_t(0x00000000), int32_t(0x2A9BB744)},
    {"mrmfx09.sno", "", int32_t(0x00000000), int32_t(0x0D776ADE)},
    {"mrmfx09.tem", "", int32_t(0x00000000), int32_t(0xAEC3DF04)},
    {"mrmfx09.urb", "", int32_t(0x00000000), int32_t(0x888E115B)},
    {"mrmfx09a.des", "", int32_t(0x00000000), int32_t(0x1353CEAB)},
    {"mrmfx09a.sno", "", int32_t(0x00000000), int32_t(0xFDCFFEDA)},
    {"mrmfx09a.tem", "", int32_t(0x00000000), int32_t(0xF57A50B8)},
    {"mrmfx09a.urb", "", int32_t(0x00000000), int32_t(0x6184A388)},
    {"mrmfx09b.des", "", int32_t(0x00000000), int32_t(0x54F3B47B)},
    {"mrmfx09b.sno", "", int32_t(0x00000000), int32_t(0xBA6F840A)},
    {"mrmfx09b.tem", "", int32_t(0x00000000), int32_t(0xB2DA2A68)},
    {"mrmfx09b.urb", "", int32_t(0x00000000), int32_t(0x2624D958)},
    {"mrmfx09c.des", "", int32_t(0x00000000), int32_t(0x69939DCB)},
    {"mrmfx09c.sno", "", int32_t(0x00000000), int32_t(0x870FADBA)},
    {"mrmfx09c.tem", "", int32_t(0x00000000), int32_t(0x8FBA03D8)},
    {"mrmfx09c.urb", "", int32_t(0x00000000), int32_t(0x1B44F0E8)},
    {"mrmfx10.des", "", int32_t(0x00000000), int32_t(0xABE3ED38)},
    {"mrmfx10.sno", "", int32_t(0x00000000), int32_t(0x8C0F30A2)},
    {"mrmfx10.tem", "", int32_t(0x00000000), int32_t(0x2FBB8578)},
    {"mrmfx10.urb", "", int32_t(0x00000000), int32_t(0x09F64B27)},
    {"mrmfx10a.des", "", int32_t(0x00000000), int32_t(0x922B94D7)},
    {"mrmfx10a.sno", "", int32_t(0x00000000), int32_t(0x7CB7A4A6)},
    {"mrmfx10a.tem", "", int32_t(0x00000000), int32_t(0x74020AC4)},
    {"mrmfx10a.urb", "", int32_t(0x00000000), int32_t(0xE0FCF9F4)},
    {"mrmfx10b.des", "", int32_t(0x00000000), int32_t(0xD58BEE07)},
    {"mrmfx10b.sno", "", int32_t(0x00000000), int32_t(0x3B17DE76)},
    {"mrmfx10b.tem", "", int32_t(0x00000000), int32_t(0x33A27014)},
    {"mrmfx10b.urb", "", int32_t(0x00000000), int32_t(0xA75C8324)},
    {"mrmfx10c.des", "", int32_t(0x00000000), int32_t(0xE8EBC7B7)},
    {"mrmfx10c.sno", "", int32_t(0x00000000), int32_t(0x0677F7C6)},
    {"mrmfx10c.tem", "", int32_t(0x00000000), int32_t(0x0EC259A4)},
    {"mrmfx10c.urb", "", int32_t(0x00000000), int32_t(0x9A3CAA94)},
    {"mrmfx11.des", "", int32_t(0x00000000), int32_t(0x60BF3E9D)},
    {"mrmfx11.sno", "", int32_t(0x00000000), int32_t(0x4753E307)},
    {"mrmfx11.tem", "", int32_t(0x00000000), int32_t(0xE4E756DD)},
    {"mrmfx11.urb", "", int32_t(0x00000000), int32_t(0xC2AA9882)},
    {"mrmfx11a.des", "", int32_t(0x00000000), int32_t(0x59774772)},
    {"mrmfx11a.sno", "", int32_t(0x00000000), int32_t(0xB7EB7703)},
    {"mrmfx11a.tem", "", int32_t(0x00000000), int32_t(0xBF5ED961)},
    {"mrmfx11a.urb", "", int32_t(0x00000000), int32_t(0x2BA02A51)},
    {"mrmfx11b.des", "", int32_t(0x00000000), int32_t(0x1ED73DA2)},
    {"mrmfx11b.sno", "", int32_t(0x00000000), int32_t(0xF04B0DD3)},
    {"mrmfx11b.tem", "", int32_t(0x00000000), int32_t(0xF8FEA3B1)},
    {"mrmfx11b.urb", "", int32_t(0x00000000), int32_t(0x6C005081)},
    {"mrmfx11c.des", "", int32_t(0x00000000), int32_t(0x23B71412)},
    {"mrmfx11c.sno", "", int32_t(0x00000000), int32_t(0xCD2B2463)},
    {"mrmfx11c.tem", "", int32_t(0x00000000), int32_t(0xC59E8A01)},
    {"mrmfx11c.urb", "", int32_t(0x00000000), int32_t(0x51607931)},
    {"mrmfx12.des", "", int32_t(0x00000000), int32_t(0xE62B4C33)},
    {"mrmfx12.sno", "", int32_t(0x00000000), int32_t(0xC1C791A9)},
    {"mrmfx12.tem", "", int32_t(0x00000000), int32_t(0x62732473)},
    {"mrmfx12.urb", "", int32_t(0x00000000), int32_t(0x443EEA2C)},
    {"mrmfx12a.des", "", int32_t(0x00000000), int32_t(0xDFE335DC)},
    {"mrmfx12a.sno", "", int32_t(0x00000000), int32_t(0x317F05AD)},
    {"mrmfx12a.tem", "", int32_t(0x00000000), int32_t(0x39CAABCF)},
    {"mrmfx12a.urb", "", int32_t(0x00000000), int32_t(0xAD3458FF)},
    {"mrmfx12b.des", "", int32_t(0x00000000), int32_t(0x98434F0C)},
    {"mrmfx12b.sno", "", int32_t(0x00000000), int32_t(0x76DF7F7D)},
    {"mrmfx12b.tem", "", int32_t(0x00000000), int32_t(0x7E6AD11F)},
    {"mrmfx12b.urb", "", int32_t(0x00000000), int32_t(0xEA94222F)},
    {"mrmfx12c.des", "", int32_t(0x00000000), int32_t(0xA52366BC)},
    {"mrmfx12c.sno", "", int32_t(0x00000000), int32_t(0x4BBF56CD)},
    {"mrmfx12c.tem", "", int32_t(0x00000000), int32_t(0x430AF8AF)},
    {"mrmfx12c.urb", "", int32_t(0x00000000), int32_t(0xD7F40B9F)},
    {"mrmx01.sno", "", int32_t(0x00000000), int32_t(0x3D96BCCA)},
    {"mrmx02.sno", "", int32_t(0x00000000), int32_t(0x0C7EA657)},
    {"mrmx03.sno", "", int32_t(0x00000000), int32_t(0xAA09ADE3)},
    {"mrmx04.sno", "", int32_t(0x00000000), int32_t(0x6FAE936D)},
    {"mrmx05.sno", "", int32_t(0x00000000), int32_t(0xC9D998D9)},
    {"mrmx06.sno", "", int32_t(0x00000000), int32_t(0xF8318244)},
    {"mrmx07.sno", "", int32_t(0x00000000), int32_t(0x5E4689F0)},
    {"mrmx08.sno", "", int32_t(0x00000000), int32_t(0xA80EF919)},
    {"mrmx09.sno", "", int32_t(0x00000000), int32_t(0x0E79F2AD)},
    {"mrmx10.sno", "", int32_t(0x00000000), int32_t(0x574BB7E0)},
    {"ms1so01.wav", "", int32_t(0x00000000), int32_t(0x43C8141B)},
    {"ms1so02.wav", "", int32_t(0x00000000), int32_t(0xC55C66B5)},
    {"ms1so03.wav", "", int32_t(0x00000000), int32_t(0x0E00B510)},
    {"ms1so04.wav", "", int32_t(0x00000000), int32_t(0x130585A8)},
    {"ms1so05.wav", "", int32_t(0x00000000), int32_t(0xD859560D)},
    {"ms1so06.wav", "", int32_t(0x00000000), int32_t(0x5ECD24A3)},
    {"ms1so07.wav", "", int32_t(0x00000000), int32_t(0x9591F706)},
    {"ms1so09.wav", "", int32_t(0x00000000), int32_t(0xAF9B9676)},
    {"ms1so10.wav", "", int32_t(0x00000000), int32_t(0x2EE3CC0A)},
    {"ms1so11.wav", "", int32_t(0x00000000), int32_t(0xE5BF1FAF)},
    {"ms1so12.wav", "", int32_t(0x00000000), int32_t(0x632B6D01)},
    {"ms1so13.wav", "", int32_t(0x00000000), int32_t(0xA877BEA4)},
    {"ms3ca04.wav", "", int32_t(0x00000000), int32_t(0xAEBA05D6)},
    {"ms3ca05.wav", "", int32_t(0x00000000), int32_t(0x65E6D673)},
    {"ms3ca06.wav", "", int32_t(0x00000000), int32_t(0xE372A4DD)},
    {"ms3ca07.wav", "", int32_t(0x00000000), int32_t(0x282E7778)},
    {"ms3ia01.wav", "", int32_t(0x00000000), int32_t(0x6B591EFB)},
    {"ms3so01.wav", "", int32_t(0x00000000), int32_t(0x473DC426)},
    {"ms3so02.wav", "", int32_t(0x00000000), int32_t(0xC1A9B688)},
    {"ms3so03.wav", "", int32_t(0x00000000), int32_t(0x0AF5652D)},
    {"ms3so04.wav", "", int32_t(0x00000000), int32_t(0x17F05595)},
    {"ms4so01.wav", "", int32_t(0x00000000), int32_t(0xA5E1DF5F)},
    {"ms4so02.wav", "", int32_t(0x00000000), int32_t(0x2375ADF1)},
    {"ms4so03.wav", "", int32_t(0x00000000), int32_t(0xE8297E54)},
    {"ms5te01.wav", "", int32_t(0x00000000), int32_t(0xBF82C560)},
    {"ms7so01.wav", "", int32_t(0x00000000), int32_t(0x4ED6645C)},
    {"ms7so02.wav", "", int32_t(0x00000000), int32_t(0xC84216F2)},
    {"ms7so03.wav", "", int32_t(0x00000000), int32_t(0x031EC557)},
    {"ms8so01.wav", "", int32_t(0x00000000), int32_t(0xBFDD3FD1)},
    {"ms8so02.wav", "", int32_t(0x00000000), int32_t(0x39494D7F)},
    {"ms9pr01.wav", "", int32_t(0x00000000), int32_t(0x8E2C4CD0)},
    {"ms9pr02.wav", "", int32_t(0x00000000), int32_t(0x08B83E7E)},
    {"ms9pr03.wav", "", int32_t(0x00000000), int32_t(0xC3E4EDDB)},
    {"ms9pr04.wav", "", int32_t(0x00000000), int32_t(0xDEE1DD63)},
    {"ms9pr05.wav", "", int32_t(0x00000000), int32_t(0x15BD0EC6)},
    {"ms9se01.wav", "", int32_t(0x00000000), int32_t(0xC1DF4827)},
    {"ms9so01.wav", "", int32_t(0x00000000), int32_t(0x501F54EF)},
    {"ms9so02.wav", "", int32_t(0x00000000), int32_t(0xD68B2641)},
    {"ms9so03.wav", "", int32_t(0x00000000), int32_t(0x1DD7F5E4)},
    {"ms9so04.wav", "", int32_t(0x00000000), int32_t(0x00D2C55C)},
    {"ms9yu01.wav", "", int32_t(0x00000000), int32_t(0x284AF392)},
    {"msaa.wsa", "anim: map of europe", int32_t(0xC3D5FDC8), int32_t(0x00000000)},
    {"msab.wsa", "anim: map of europe", int32_t(0xC5D5FDC8), int32_t(0x00000000)},
    {"msac.wsa", "anim: map of europe", int32_t(0xC7D5FDC8), int32_t(0x00000000)},
    {"msad.wsa", "anim: map of europe", int32_t(0xC9D5FDC8), int32_t(0x00000000)},
    {"msae.wsa", "anim: map of europe", int32_t(0xCBD5FDC8), int32_t(0x00000000)},
    {"msaf.wsa", "anim: map of europe", int32_t(0xCDD5FDC8), int32_t(0x00000000)},
    {"msag.wsa", "anim: map of europe", int32_t(0xCFD5FDC8), int32_t(0x00000000)},
    {"msah.wsa", "anim: map of europe", int32_t(0xD1D5FDC8), int32_t(0x00000000)},
    {"msai.wsa", "anim: map of europe", int32_t(0xD3D5FDC8), int32_t(0x00000000)},
    {"msaj.wsa", "anim: map of europe", int32_t(0xD5D5FDC8), int32_t(0x00000000)},
    {"msak.wsa", "anim: map of europe", int32_t(0xD7D5FDC8), int32_t(0x00000000)},
    {"msal.wsa", "anim: map of europe", int32_t(0xD9D5FDC8), int32_t(0x00000000)},
    {"msam.shp", "rocket launcher", int32_t(0xEACAF9C8), int32_t(0x00000000)},
    {"msam.wsa", "anim: map of europe", int32_t(0xDBD5FDC8), int32_t(0x00000000)},
    {"msamicnh.des", "icon: rocket launcher", int32_t(0x18E717F5), int32_t(0x00000000)},
    {"msamicnh.tem", "icon: rocket launcher", int32_t(0x12E727F5), int32_t(0x00000000)},
    {"msamicnh.win", "icon: rocket launcher", int32_t(0x13EB2AF5), int32_t(0x00000000)},
    {"msamicon.shp", "icon: rocket launcher", int32_t(0x21EC26F5), int32_t(0x00000000)},
    {"msan.wsa", "anim: map of europe", int32_t(0xDDD5FDC8), int32_t(0x00000000)},
    {"msaso01.wav", "", int32_t(0x00000000), int32_t(0xB5819183)},
    {"msaso02.wav", "", int32_t(0x00000000), int32_t(0x3315E32D)},
    {"msaso03.wav", "", int32_t(0x00000000), int32_t(0xF8493088)},
    {"msaso04.wav", "", int32_t(0x00000000), int32_t(0xE54C0030)},
    {"msaso05.wav", "", int32_t(0x00000000), int32_t(0x2E10D395)},
    {"msayu01.wav", "", int32_t(0x00000000), int32_t(0xCDD436FE)},
    {"msbso01.wav", "", int32_t(0x00000000), int32_t(0x5EB62A80)},
    {"msbso02.wav", "", int32_t(0x00000000), int32_t(0xD822582E)},
    {"msbso05.wav", "", int32_t(0x00000000), int32_t(0xC5276896)},
    {"msbso06.wav", "", int32_t(0x00000000), int32_t(0x43B31A38)},
    {"msbyu01.wav", "", int32_t(0x00000000), int32_t(0x26E38DFD)},
    {"msbyu02.wav", "", int32_t(0x00000000), int32_t(0xA077FF53)},
    {"msbyu03.wav", "", int32_t(0x00000000), int32_t(0x6B2B2CF6)},
    {"msbyu04.wav", "", int32_t(0x00000000), int32_t(0x762E1C4E)},
    {"msbyu05.wav", "", int32_t(0x00000000), int32_t(0xBD72CFEB)},
    {"mscso03.wav", "", int32_t(0x00000000), int32_t(0xFCBCE0B5)},
    {"mscso04.wav", "", int32_t(0x00000000), int32_t(0xE1B9D00D)},
    {"msg.cps", "pict:", int32_t(0x5CE1F6DD), int32_t(0x00000000)},
    {"msg1.aud", "message", int32_t(0x00000000), int32_t(0xCC5343FF)},
    {"msgleft.shp", "", int32_t(0x8E162212), int32_t(0x00000000)},
    {"msgmid.shp", "", int32_t(0xDB7A260F), int32_t(0x00000000)},
    {"msgrt.shp", "", int32_t(0xD9C3AA2D), int32_t(0x00000000)},
    {"mshore01.des", "", int32_t(0x00000000), int32_t(0x691A3E37)},
    {"mshore01.sno", "", int32_t(0x00000000), int32_t(0x87860E46)},
    {"mshore01.tem", "", int32_t(0x00000000), int32_t(0x8F33A024)},
    {"mshore01.urb", "", int32_t(0x00000000), int32_t(0x1BCD5314)},
    {"mshore02.des", "", int32_t(0x00000000), int32_t(0x2EBA44E7)},
    {"mshore02.sno", "", int32_t(0x00000000), int32_t(0xC0267496)},
    {"mshore02.tem", "", int32_t(0x00000000), int32_t(0xC893DAF4)},
    {"mshore02.urb", "", int32_t(0x00000000), int32_t(0x5C6D29C4)},
    {"mshore03.des", "", int32_t(0x00000000), int32_t(0x13DA6D57)},
    {"mshore03.sno", "", int32_t(0x00000000), int32_t(0xFD465D26)},
    {"mshore03.tem", "", int32_t(0x00000000), int32_t(0xF5F3F344)},
    {"mshore03.urb", "", int32_t(0x00000000), int32_t(0x610D0074)},
    {"mshore04.des", "", int32_t(0x00000000), int32_t(0xA1FAB147)},
    {"mshore04.sno", "", int32_t(0x00000000), int32_t(0x4F668136)},
    {"mshore04.tem", "", int32_t(0x00000000), int32_t(0x47D32F54)},
    {"mshore04.urb", "", int32_t(0x00000000), int32_t(0xD32DDC64)},
    {"mshore05.des", "", int32_t(0x00000000), int32_t(0x9C9A98F7)},
    {"mshore05.sno", "", int32_t(0x00000000), int32_t(0x7206A886)},
    {"mshore05.tem", "", int32_t(0x00000000), int32_t(0x7AB306E4)},
    {"mshore05.urb", "", int32_t(0x00000000), int32_t(0xEE4DF5D4)},
    {"mshore06.des", "", int32_t(0x00000000), int32_t(0xDB3AE227)},
    {"mshore06.sno", "", int32_t(0x00000000), int32_t(0x35A6D256)},
    {"mshore06.tem", "", int32_t(0x00000000), int32_t(0x3D137C34)},
    {"mshore06.urb", "", int32_t(0x00000000), int32_t(0xA9ED8F04)},
    {"mshore07.des", "", int32_t(0x00000000), int32_t(0xE65ACB97)},
    {"mshore07.sno", "", int32_t(0x00000000), int32_t(0x08C6FBE6)},
    {"mshore07.tem", "", int32_t(0x00000000), int32_t(0x00735584)},
    {"mshore07.urb", "", int32_t(0x00000000), int32_t(0x948DA6B4)},
    {"mshore08.des", "", int32_t(0x00000000), int32_t(0x640A5C46)},
    {"mshore08.sno", "", int32_t(0x00000000), int32_t(0x8A966C37)},
    {"mshore08.tem", "", int32_t(0x00000000), int32_t(0x8223C255)},
    {"mshore08.urb", "", int32_t(0x00000000), int32_t(0x16DD3165)},
    {"mshore09.des", "", int32_t(0x00000000), int32_t(0x596A75F6)},
    {"mshore09.sno", "", int32_t(0x00000000), int32_t(0xB7F64587)},
    {"mshore09.tem", "", int32_t(0x00000000), int32_t(0xBF43EBE5)},
    {"mshore09.urb", "", int32_t(0x00000000), int32_t(0x2BBD18D5)},
    {"mshore10.des", "", int32_t(0x00000000), int32_t(0x9F26C422)},
    {"mshore10.sno", "", int32_t(0x00000000), int32_t(0x71BAF453)},
    {"mshore10.tem", "", int32_t(0x00000000), int32_t(0x790F5A31)},
    {"mshore10.urb", "", int32_t(0x00000000), int32_t(0xEDF1A901)},
    {"mshore11.des", "", int32_t(0x00000000), int32_t(0xA246ED92)},
    {"mshore11.sno", "", int32_t(0x00000000), int32_t(0x4CDADDE3)},
    {"mshore11.tem", "", int32_t(0x00000000), int32_t(0x446F7381)},
    {"mshore11.urb", "", int32_t(0x00000000), int32_t(0xD09180B1)},
    {"mshore12.des", "", int32_t(0x00000000), int32_t(0xE5E69742)},
    {"mshore12.sno", "", int32_t(0x00000000), int32_t(0x0B7AA733)},
    {"mshore12.tem", "", int32_t(0x00000000), int32_t(0x03CF0951)},
    {"mshore12.urb", "", int32_t(0x00000000), int32_t(0x9731FA61)},
    {"mshore13.des", "", int32_t(0x00000000), int32_t(0xD886BEF2)},
    {"mshore13.sno", "", int32_t(0x00000000), int32_t(0x361A8E83)},
    {"mshore13.tem", "", int32_t(0x00000000), int32_t(0x3EAF20E1)},
    {"mshore13.urb", "", int32_t(0x00000000), int32_t(0xAA51D3D1)},
    {"mshore14.des", "", int32_t(0x00000000), int32_t(0x6AA662E2)},
    {"mshore14.sno", "", int32_t(0x00000000), int32_t(0x843A5293)},
    {"mshore14.tem", "", int32_t(0x00000000), int32_t(0x8C8FFCF1)},
    {"mshore14.urb", "", int32_t(0x00000000), int32_t(0x18710FC1)},
    {"mshore15.des", "", int32_t(0x00000000), int32_t(0x57C64B52)},
    {"mshore15.sno", "", int32_t(0x00000000), int32_t(0xB95A7B23)},
    {"mshore15.tem", "", int32_t(0x00000000), int32_t(0xB1EFD541)},
    {"mshore15.urb", "", int32_t(0x00000000), int32_t(0x25112671)},
    {"mshore16.des", "", int32_t(0x00000000), int32_t(0x10663182)},
    {"mshore16.sno", "", int32_t(0x00000000), int32_t(0xFEFA01F3)},
    {"mshore16.tem", "", int32_t(0x00000000), int32_t(0xF64FAF91)},
    {"mshore16.urb", "", int32_t(0x00000000), int32_t(0x62B15CA1)},
    {"mshore17.des", "", int32_t(0x00000000), int32_t(0x2D061832)},
    {"mshore17.sno", "", int32_t(0x00000000), int32_t(0xC39A2843)},
    {"mshore17.tem", "", int32_t(0x00000000), int32_t(0xCB2F8621)},
    {"mshore17.urb", "", int32_t(0x00000000), int32_t(0x5FD17511)},
    {"mshore18.des", "", int32_t(0x00000000), int32_t(0xAF568FE3)},
    {"mshore18.sno", "", int32_t(0x00000000), int32_t(0x41CABF92)},
    {"mshore18.tem", "", int32_t(0x00000000), int32_t(0x497F11F0)},
    {"mshore18.urb", "", int32_t(0x00000000), int32_t(0xDD81E2C0)},
    {"mshore19.des", "", int32_t(0x00000000), int32_t(0x9236A653)},
    {"mshore19.sno", "", int32_t(0x00000000), int32_t(0x7CAA9622)},
    {"mshore19.tem", "", int32_t(0x00000000), int32_t(0x741F3840)},
    {"mshore19.urb", "", int32_t(0x00000000), int32_t(0xE0E1CB70)},
    {"mshore20.des", "", int32_t(0x00000000), int32_t(0x19B2B68C)},
    {"mshore20.sno", "", int32_t(0x00000000), int32_t(0xF72E86FD)},
    {"mshore20.tem", "", int32_t(0x00000000), int32_t(0xFF9B289F)},
    {"mshore20.urb", "", int32_t(0x00000000), int32_t(0x6B65DBAF)},
    {"mshore21.des", "", int32_t(0x00000000), int32_t(0x24D29F3C)},
    {"mshore21.sno", "", int32_t(0x00000000), int32_t(0xCA4EAF4D)},
    {"mshore21.tem", "", int32_t(0x00000000), int32_t(0xC2FB012F)},
    {"mshore21.urb", "", int32_t(0x00000000), int32_t(0x5605F21F)},
    {"mshore22.des", "", int32_t(0x00000000), int32_t(0x6372E5EC)},
    {"mshore22.sno", "", int32_t(0x00000000), int32_t(0x8DEED59D)},
    {"mshore22.tem", "", int32_t(0x00000000), int32_t(0x855B7BFF)},
    {"mshore22.urb", "", int32_t(0x00000000), int32_t(0x11A588CF)},
    {"mshore23.des", "", int32_t(0x00000000), int32_t(0x5E12CC5C)},
    {"mshore23.sno", "", int32_t(0x00000000), int32_t(0xB08EFC2D)},
    {"mshore23.tem", "", int32_t(0x00000000), int32_t(0xB83B524F)},
    {"mshore23.urb", "", int32_t(0x00000000), int32_t(0x2CC5A17F)},
    {"mshore24.des", "", int32_t(0x00000000), int32_t(0xEC32104C)},
    {"mshore24.sno", "", int32_t(0x00000000), int32_t(0x02AE203D)},
    {"mshore24.tem", "", int32_t(0x00000000), int32_t(0x0A1B8E5F)},
    {"mshore24.urb", "", int32_t(0x00000000), int32_t(0x9EE57D6F)},
    {"mshore25.des", "", int32_t(0x00000000), int32_t(0xD15239FC)},
    {"mshore25.sno", "", int32_t(0x00000000), int32_t(0x3FCE098D)},
    {"mshore25.tem", "", int32_t(0x00000000), int32_t(0x377BA7EF)},
    {"mshore25.urb", "", int32_t(0x00000000), int32_t(0xA38554DF)},
    {"mshore26.des", "", int32_t(0x00000000), int32_t(0x96F2432C)},
    {"mshore26.sno", "", int32_t(0x00000000), int32_t(0x786E735D)},
    {"mshore26.tem", "", int32_t(0x00000000), int32_t(0x70DBDD3F)},
    {"mshore26.urb", "", int32_t(0x00000000), int32_t(0xE4252E0F)},
    {"mshore27.des", "", int32_t(0x00000000), int32_t(0xAB926A9C)},
    {"mshore27.sno", "", int32_t(0x00000000), int32_t(0x450E5AED)},
    {"mshore27.tem", "", int32_t(0x00000000), int32_t(0x4DBBF48F)},
    {"mshore27.urb", "", int32_t(0x00000000), int32_t(0xD94507BF)},
    {"mshore28.des", "", int32_t(0x00000000), int32_t(0x29C2FD4D)},
    {"mshore28.sno", "", int32_t(0x00000000), int32_t(0xC75ECD3C)},
    {"mshore28.tem", "", int32_t(0x00000000), int32_t(0xCFEB635E)},
    {"mshore28.urb", "", int32_t(0x00000000), int32_t(0x5B15906E)},
    {"mshore29.des", "", int32_t(0x00000000), int32_t(0x14A2D4FD)},
    {"mshore29.sno", "", int32_t(0x00000000), int32_t(0xFA3EE48C)},
    {"mshore29.tem", "", int32_t(0x00000000), int32_t(0xF28B4AEE)},
    {"mshore29.urb", "", int32_t(0x00000000), int32_t(0x6675B9DE)},
    {"mshore30.des", "", int32_t(0x00000000), int32_t(0xD2EE6529)},
    {"mshore30.sno", "", int32_t(0x00000000), int32_t(0x3C725558)},
    {"mshore30.tem", "", int32_t(0x00000000), int32_t(0x34C7FB3A)},
    {"mshore30.urb", "", int32_t(0x00000000), int32_t(0xA039080A)},
    {"mshore31.des", "", int32_t(0x00000000), int32_t(0xEF8E4C99)},
    {"mshore31.sno", "", int32_t(0x00000000), int32_t(0x01127CE8)},
    {"mshore31.tem", "", int32_t(0x00000000), int32_t(0x09A7D28A)},
    {"mshore31.urb", "", int32_t(0x00000000), int32_t(0x9D5921BA)},
    {"mshore32.des", "", int32_t(0x00000000), int32_t(0xA82E3649)},
    {"mshore32.sno", "", int32_t(0x00000000), int32_t(0x46B20638)},
    {"mshore32.tem", "", int32_t(0x00000000), int32_t(0x4E07A85A)},
    {"mshore32.urb", "", int32_t(0x00000000), int32_t(0xDAF95B6A)},
    {"mshore33.des", "", int32_t(0x00000000), int32_t(0x954E1FF9)},
    {"mshore33.sno", "", int32_t(0x00000000), int32_t(0x7BD22F88)},
    {"mshore33.tem", "", int32_t(0x00000000), int32_t(0x736781EA)},
    {"mshore33.urb", "", int32_t(0x00000000), int32_t(0xE79972DA)},
    {"mshore34.des", "", int32_t(0x00000000), int32_t(0x276EC3E9)},
    {"mshore34.sno", "", int32_t(0x00000000), int32_t(0xC9F2F398)},
    {"mshore34.tem", "", int32_t(0x00000000), int32_t(0xC1475DFA)},
    {"mshore34.urb", "", int32_t(0x00000000), int32_t(0x55B9AECA)},
    {"mshore35.des", "", int32_t(0x00000000), int32_t(0x1A0EEA59)},
    {"mshore35.sno", "", int32_t(0x00000000), int32_t(0xF492DA28)},
    {"mshore35.tem", "", int32_t(0x00000000), int32_t(0xFC27744A)},
    {"mshore35.urb", "", int32_t(0x00000000), int32_t(0x68D9877A)},
    {"mshore36.des", "", int32_t(0x00000000), int32_t(0x5DAE9089)},
    {"mshore36.sno", "", int32_t(0x00000000), int32_t(0xB332A0F8)},
    {"mshore36.tem", "", int32_t(0x00000000), int32_t(0xBB870E9A)},
    {"mshore36.urb", "", int32_t(0x00000000), int32_t(0x2F79FDAA)},
    {"mshore37.des", "", int32_t(0x00000000), int32_t(0x60CEB939)},
    {"mshore37.sno", "", int32_t(0x00000000), int32_t(0x8E528948)},
    {"mshore37.tem", "", int32_t(0x00000000), int32_t(0x86E7272A)},
    {"mshore37.urb", "", int32_t(0x00000000), int32_t(0x1219D41A)},
    {"mshore38.des", "", int32_t(0x00000000), int32_t(0xE29E2EE8)},
    {"mshore38.sno", "", int32_t(0x00000000), int32_t(0x0C021E99)},
    {"mshore38.tem", "", int32_t(0x00000000), int32_t(0x04B7B0FB)},
    {"mshore38.urb", "", int32_t(0x00000000), int32_t(0x904943CB)},
    {"mshore39.des", "", int32_t(0x00000000), int32_t(0xDFFE0758)},
    {"mshore39.sno", "", int32_t(0x00000000), int32_t(0x31623729)},
    {"mshore39.tem", "", int32_t(0x00000000), int32_t(0x39D7994B)},
    {"mshore39.urb", "", int32_t(0x00000000), int32_t(0xAD296A7B)},
    {"mshore40.des", "", int32_t(0x00000000), int32_t(0xCFEB5591)},
    {"mshore40.sno", "", int32_t(0x00000000), int32_t(0x217765E0)},
    {"mshore40.tem", "", int32_t(0x00000000), int32_t(0x29C2CB82)},
    {"mshore40.urb", "", int32_t(0x00000000), int32_t(0xBD3C38B2)},
    {"mshore41.des", "", int32_t(0x00000000), int32_t(0xF28B7C21)},
    {"mshore41.sno", "", int32_t(0x00000000), int32_t(0x1C174C50)},
    {"mshore41.tem", "", int32_t(0x00000000), int32_t(0x14A2E232)},
    {"mshore41.urb", "", int32_t(0x00000000), int32_t(0x805C1102)},
    {"mshore42.des", "", int32_t(0x00000000), int32_t(0xB52B06F1)},
    {"mshore42.sno", "", int32_t(0x00000000), int32_t(0x5BB73680)},
    {"mshore42.tem", "", int32_t(0x00000000), int32_t(0x530298E2)},
    {"mshore42.urb", "", int32_t(0x00000000), int32_t(0xC7FC6BD2)},
    {"msizzle.vqa", "", int32_t(0xC5F1373F), int32_t(0x00000000)},
    {"mslo.sno", "bldg: missle silo", int32_t(0xEDE6F9C8), int32_t(0xC130889E)},
    {"mslo.tem", "bldg: missle silo", int32_t(0xEBDDFAC8), int32_t(0xC98526FC)},
    {"mslo.urb", "", int32_t(0x00000000), int32_t(0x5D7BD5CC)},
    {"msloicon.shp", "icon: missle silo", int32_t(0x2A1826F5), int32_t(0x00000000)},
    {"mslomake.sno", "make: missle silo", int32_t(0x171622FD), int32_t(0xB20E12A5)},
    {"mslomake.tem", "make: missle silo", int32_t(0x150D23FD), int32_t(0xBABBBCC7)},
    {"mslomake.urb", "", int32_t(0x00000000), int32_t(0x2E454FF7)},
    {"mslop01.des", "", int32_t(0x00000000), int32_t(0x97C22C39)},
    {"mslop01.lun", "", int32_t(0x00000000), int32_t(0xB13CCBBA)},
    {"mslop01.sno", "", int32_t(0x00000000), int32_t(0xB02EF1A3)},
    {"mslop01.tem", "", int32_t(0x00000000), int32_t(0x139A4479)},
    {"mslop01.urb", "", int32_t(0x00000000), int32_t(0x35D78A26)},
    {"mslop01a.des", "", int32_t(0x00000000), int32_t(0xAE0A55D6)},
    {"mslop01a.lun", "", int32_t(0x00000000), int32_t(0x89DD7AE6)},
    {"mslop01a.sno", "", int32_t(0x00000000), int32_t(0x409665A7)},
    {"mslop01a.tem", "", int32_t(0x00000000), int32_t(0x4823CBC5)},
    {"mslop01a.urb", "", int32_t(0x00000000), int32_t(0xDCDD38F5)},
    {"mslop01b.des", "", int32_t(0x00000000), int32_t(0xE9AA2F06)},
    {"mslop01b.lun", "", int32_t(0x00000000), int32_t(0xCE7D0036)},
    {"mslop01b.sno", "", int32_t(0x00000000), int32_t(0x07361F77)},
    {"mslop01b.tem", "", int32_t(0x00000000), int32_t(0x0F83B115)},
    {"mslop01b.urb", "", int32_t(0x00000000), int32_t(0x9B7D4225)},
    {"mslop01c.des", "", int32_t(0x00000000), int32_t(0xD4CA06B6)},
    {"mslop01c.lun", "", int32_t(0x00000000), int32_t(0xF31D2986)},
    {"mslop01c.sno", "", int32_t(0x00000000), int32_t(0x3A5636C7)},
    {"mslop01c.tem", "", int32_t(0x00000000), int32_t(0x32E398A5)},
    {"mslop01c.urb", "", int32_t(0x00000000), int32_t(0xA61D6B95)},
    {"mslop02.des", "", int32_t(0x00000000), int32_t(0x11565E97)},
    {"mslop02.lun", "", int32_t(0x00000000), int32_t(0x37A8B914)},
    {"mslop02.sno", "", int32_t(0x00000000), int32_t(0x36BA830D)},
    {"mslop02.tem", "", int32_t(0x00000000), int32_t(0x950E36D7)},
    {"mslop02.urb", "", int32_t(0x00000000), int32_t(0xB343F888)},
    {"mslop02a.des", "", int32_t(0x00000000), int32_t(0x289E2778)},
    {"mslop02a.lun", "", int32_t(0x00000000), int32_t(0x0F490848)},
    {"mslop02a.sno", "", int32_t(0x00000000), int32_t(0xC6021709)},
    {"mslop02a.tem", "", int32_t(0x00000000), int32_t(0xCEB7B96B)},
    {"mslop02a.urb", "", int32_t(0x00000000), int32_t(0x5A494A5B)},
    {"mslop02b.des", "", int32_t(0x00000000), int32_t(0x6F3E5DA8)},
    {"mslop02b.lun", "", int32_t(0x00000000), int32_t(0x48E97298)},
    {"mslop02b.sno", "", int32_t(0x00000000), int32_t(0x81A26DD9)},
    {"mslop02b.tem", "", int32_t(0x00000000), int32_t(0x8917C3BB)},
    {"mslop02b.urb", "", int32_t(0x00000000), int32_t(0x1DE9308B)},
    {"mslop02c.des", "", int32_t(0x00000000), int32_t(0x525E7418)},
    {"mslop02c.lun", "", int32_t(0x00000000), int32_t(0x75895B28)},
    {"mslop02c.sno", "", int32_t(0x00000000), int32_t(0xBCC24469)},
    {"mslop02c.tem", "", int32_t(0x00000000), int32_t(0xB477EA0B)},
    {"mslop02c.urb", "", int32_t(0x00000000), int32_t(0x2089193B)},
    {"mslop03.des", "", int32_t(0x00000000), int32_t(0xDA0A8D32)},
    {"mslop03.lun", "", int32_t(0x00000000), int32_t(0xFCF46AB1)},
    {"mslop03.sno", "", int32_t(0x00000000), int32_t(0xFDE650A8)},
    {"mslop03.tem", "", int32_t(0x00000000), int32_t(0x5E52E572)},
    {"mslop03.urb", "", int32_t(0x00000000), int32_t(0x781F2B2D)},
    {"mslop03a.des", "", int32_t(0x00000000), int32_t(0xE3C2F4DD)},
    {"mslop03a.lun", "", int32_t(0x00000000), int32_t(0xC415DBED)},
    {"mslop03a.sno", "", int32_t(0x00000000), int32_t(0x0D5EC4AC)},
    {"mslop03a.tem", "", int32_t(0x00000000), int32_t(0x05EB6ACE)},
    {"mslop03a.urb", "", int32_t(0x00000000), int32_t(0x911599FE)},
    {"mslop03b.des", "", int32_t(0x00000000), int32_t(0xA4628E0D)},
    {"mslop03b.lun", "", int32_t(0x00000000), int32_t(0x83B5A13D)},
    {"mslop03b.sno", "", int32_t(0x00000000), int32_t(0x4AFEBE7C)},
    {"mslop03b.tem", "", int32_t(0x00000000), int32_t(0x424B101E)},
    {"mslop03b.urb", "", int32_t(0x00000000), int32_t(0xD6B5E32E)},
    {"mslop03c.des", "", int32_t(0x00000000), int32_t(0x9902A7BD)},
    {"mslop03c.lun", "", int32_t(0x00000000), int32_t(0xBED5888D)},
    {"mslop03c.sno", "", int32_t(0x00000000), int32_t(0x779E97CC)},
    {"mslop03c.tem", "", int32_t(0x00000000), int32_t(0x7F2B39AE)},
    {"mslop03c.urb", "", int32_t(0x00000000), int32_t(0xEBD5CA9E)},
    {"mslop04.des", "", int32_t(0x00000000), int32_t(0xC70FBD8A)},
    {"mslop04.lun", "", int32_t(0x00000000), int32_t(0xE1F15A09)},
    {"mslop04.sno", "", int32_t(0x00000000), int32_t(0xE0E36010)},
    {"mslop04.tem", "", int32_t(0x00000000), int32_t(0x4357D5CA)},
    {"mslop04.urb", "", int32_t(0x00000000), int32_t(0x651A1B95)},
    {"mslop04a.des", "", int32_t(0x00000000), int32_t(0xFEC7C465)},
    {"mslop04a.lun", "", int32_t(0x00000000), int32_t(0xD910EB55)},
    {"mslop04a.sno", "", int32_t(0x00000000), int32_t(0x105BF414)},
    {"mslop04a.tem", "", int32_t(0x00000000), int32_t(0x18EE5A76)},
    {"mslop04a.urb", "", int32_t(0x00000000), int32_t(0x8C10A946)},
    {"mslop04b.des", "", int32_t(0x00000000), int32_t(0xB967BEB5)},
    {"mslop04b.lun", "", int32_t(0x00000000), int32_t(0x9EB09185)},
    {"mslop04b.sno", "", int32_t(0x00000000), int32_t(0x57FB8EC4)},
    {"mslop04b.tem", "", int32_t(0x00000000), int32_t(0x5F4E20A6)},
    {"mslop04b.urb", "", int32_t(0x00000000), int32_t(0xCBB0D396)},
    {"mslop04c.des", "", int32_t(0x00000000), int32_t(0x84079705)},
    {"mslop04c.lun", "", int32_t(0x00000000), int32_t(0xA3D0B835)},
    {"mslop04c.sno", "", int32_t(0x00000000), int32_t(0x6A9BA774)},
    {"mslop04c.tem", "", int32_t(0x00000000), int32_t(0x622E0916)},
    {"mslop04c.urb", "", int32_t(0x00000000), int32_t(0xF6D0FA26)},
    {"mslop05.des", "", int32_t(0x00000000), int32_t(0x0C536E2F)},
    {"mslop05.lun", "", int32_t(0x00000000), int32_t(0x2AAD89AC)},
    {"mslop05.sno", "", int32_t(0x00000000), int32_t(0x2BBFB3B5)},
    {"mslop05.tem", "", int32_t(0x00000000), int32_t(0x880B066F)},
    {"mslop05.urb", "", int32_t(0x00000000), int32_t(0xAE46C830)},
    {"mslop05a.des", "", int32_t(0x00000000), int32_t(0x359B17C0)},
    {"mslop05a.lun", "", int32_t(0x00000000), int32_t(0x124C38F0)},
    {"mslop05a.sno", "", int32_t(0x00000000), int32_t(0xDB0727B1)},
    {"mslop05a.tem", "", int32_t(0x00000000), int32_t(0xD3B289D3)},
    {"mslop05a.urb", "", int32_t(0x00000000), int32_t(0x474C7AE3)},
    {"mslop05b.des", "", int32_t(0x00000000), int32_t(0x723B6D10)},
    {"mslop05b.lun", "", int32_t(0x00000000), int32_t(0x55EC4220)},
    {"mslop05b.sno", "", int32_t(0x00000000), int32_t(0x9CA75D61)},
    {"mslop05b.tem", "", int32_t(0x00000000), int32_t(0x9412F303)},
    {"mslop05b.urb", "", int32_t(0x00000000), int32_t(0x00EC0033)},
    {"mslop05c.des", "", int32_t(0x00000000), int32_t(0x4F5B44A0)},
    {"mslop05c.lun", "", int32_t(0x00000000), int32_t(0x688C6B90)},
    {"mslop05c.sno", "", int32_t(0x00000000), int32_t(0xA1C774D1)},
    {"mslop05c.tem", "", int32_t(0x00000000), int32_t(0xA972DAB3)},
    {"mslop05c.urb", "", int32_t(0x00000000), int32_t(0x3D8C2983)},
    {"mslop06.des", "", int32_t(0x00000000), int32_t(0x8AC71C81)},
    {"mslop06.lun", "", int32_t(0x00000000), int32_t(0xAC39FB02)},
    {"mslop06.sno", "", int32_t(0x00000000), int32_t(0xAD2BC11B)},
    {"mslop06.tem", "", int32_t(0x00000000), int32_t(0x0E9F74C1)},
    {"mslop06.urb", "", int32_t(0x00000000), int32_t(0x28D2BA9E)},
    {"mslop06a.des", "", int32_t(0x00000000), int32_t(0xB30F656E)},
    {"mslop06a.lun", "", int32_t(0x00000000), int32_t(0x94D84A5E)},
    {"mslop06a.sno", "", int32_t(0x00000000), int32_t(0x5D93551F)},
    {"mslop06a.tem", "", int32_t(0x00000000), int32_t(0x5526FB7D)},
    {"mslop06a.urb", "", int32_t(0x00000000), int32_t(0xC1D8084D)},
    {"mslop06b.des", "", int32_t(0x00000000), int32_t(0xF4AF1FBE)},
    {"mslop06b.lun", "", int32_t(0x00000000), int32_t(0xD378308E)},
    {"mslop06b.sno", "", int32_t(0x00000000), int32_t(0x1A332FCF)},
    {"mslop06b.tem", "", int32_t(0x00000000), int32_t(0x128681AD)},
    {"mslop06b.urb", "", int32_t(0x00000000), int32_t(0x8678729D)},
    {"mslop06c.des", "", int32_t(0x00000000), int32_t(0xC9CF360E)},
    {"mslop06c.lun", "", int32_t(0x00000000), int32_t(0xEE18193E)},
    {"mslop06c.sno", "", int32_t(0x00000000), int32_t(0x2753067F)},
    {"mslop06c.tem", "", int32_t(0x00000000), int32_t(0x2FE6A81D)},
    {"mslop06c.urb", "", int32_t(0x00000000), int32_t(0xBB185B2D)},
    {"mslop07.des", "", int32_t(0x00000000), int32_t(0x419BCF24)},
    {"mslop07.lun", "", int32_t(0x00000000), int32_t(0x676528A7)},
    {"mslop07.sno", "", int32_t(0x00000000), int32_t(0x667712BE)},
    {"mslop07.tem", "", int32_t(0x00000000), int32_t(0xC5C3A764)},
    {"mslop07.urb", "", int32_t(0x00000000), int32_t(0xE38E693B)},
    {"mslop07a.des", "", int32_t(0x00000000), int32_t(0x7853B6CB)},
    {"mslop07a.lun", "", int32_t(0x00000000), int32_t(0x5F8499FB)},
    {"mslop07a.sno", "", int32_t(0x00000000), int32_t(0x96CF86BA)},
    {"mslop07a.tem", "", int32_t(0x00000000), int32_t(0x9E7A28D8)},
    {"mslop07a.urb", "", int32_t(0x00000000), int32_t(0x0A84DBE8)},
    {"mslop07b.des", "", int32_t(0x00000000), int32_t(0x3FF3CC1B)},
    {"mslop07b.lun", "", int32_t(0x00000000), int32_t(0x1824E32B)},
    {"mslop07b.sno", "", int32_t(0x00000000), int32_t(0xD16FFC6A)},
    {"mslop07b.tem", "", int32_t(0x00000000), int32_t(0xD9DA5208)},
    {"mslop07b.urb", "", int32_t(0x00000000), int32_t(0x4D24A138)},
    {"mslop07c.des", "", int32_t(0x00000000), int32_t(0x0293E5AB)},
    {"mslop07c.lun", "", int32_t(0x00000000), int32_t(0x2544CA9B)},
    {"mslop07c.sno", "", int32_t(0x00000000), int32_t(0xEC0FD5DA)},
    {"mslop07c.tem", "", int32_t(0x00000000), int32_t(0xE4BA7BB8)},
    {"mslop07c.urb", "", int32_t(0x00000000), int32_t(0x70448888)},
    {"mslop08.des", "", int32_t(0x00000000), int32_t(0xB0CD7DF1)},
    {"mslop08.lun", "", int32_t(0x00000000), int32_t(0x96339A72)},
    {"mslop08.sno", "", int32_t(0x00000000), int32_t(0x9721A06B)},
    {"mslop08.tem", "", int32_t(0x00000000), int32_t(0x349515B1)},
    {"mslop08.urb", "", int32_t(0x00000000), int32_t(0x12D8DBEE)},
    {"mslop08a.des", "", int32_t(0x00000000), int32_t(0x8905041E)},
    {"mslop08a.lun", "", int32_t(0x00000000), int32_t(0xAED22B2E)},
    {"mslop08a.sno", "", int32_t(0x00000000), int32_t(0x6799346F)},
    {"mslop08a.tem", "", int32_t(0x00000000), int32_t(0x6F2C9A0D)},
    {"mslop08a.urb", "", int32_t(0x00000000), int32_t(0xFBD2693D)},
    {"mslop08b.des", "", int32_t(0x00000000), int32_t(0xCEA57ECE)},
    {"mslop08b.lun", "", int32_t(0x00000000), int32_t(0xE97251FE)},
    {"mslop08b.sno", "", int32_t(0x00000000), int32_t(0x20394EBF)},
    {"mslop08b.tem", "", int32_t(0x00000000), int32_t(0x288CE0DD)},
    {"mslop08b.urb", "", int32_t(0x00000000), int32_t(0xBC7213ED)},
    {"mslop08c.des", "", int32_t(0x00000000), int32_t(0xF3C5577E)},
    {"mslop08c.lun", "", int32_t(0x00000000), int32_t(0xD412784E)},
    {"mslop08c.sno", "", int32_t(0x00000000), int32_t(0x1D59670F)},
    {"mslop08c.tem", "", int32_t(0x00000000), int32_t(0x15ECC96D)},
    {"mslop08c.urb", "", int32_t(0x00000000), int32_t(0x81123A5D)},
    {"mslop09.des", "", int32_t(0x00000000), int32_t(0x7B91AE54)},
    {"mslop09.lun", "", int32_t(0x00000000), int32_t(0x5D6F49D7)},
    {"mslop09.sno", "", int32_t(0x00000000), int32_t(0x5C7D73CE)},
    {"mslop09.tem", "", int32_t(0x00000000), int32_t(0xFFC9C614)},
    {"mslop09.urb", "", int32_t(0x00000000), int32_t(0xD984084B)},
    {"mslop09a.des", "", int32_t(0x00000000), int32_t(0x4259D7BB)},
    {"mslop09a.lun", "", int32_t(0x00000000), int32_t(0x658EF88B)},
    {"mslop09a.sno", "", int32_t(0x00000000), int32_t(0xACC5E7CA)},
    {"mslop09a.tem", "", int32_t(0x00000000), int32_t(0xA47049A8)},
    {"mslop09a.urb", "", int32_t(0x00000000), int32_t(0x308EBA98)},
    {"mslop09b.des", "", int32_t(0x00000000), int32_t(0x05F9AD6B)},
    {"mslop09b.lun", "", int32_t(0x00000000), int32_t(0x222E825B)},
    {"mslop09b.sno", "", int32_t(0x00000000), int32_t(0xEB659D1A)},
    {"mslop09b.tem", "", int32_t(0x00000000), int32_t(0xE3D03378)},
    {"mslop09b.urb", "", int32_t(0x00000000), int32_t(0x772EC048)},
    {"mslop09c.des", "", int32_t(0x00000000), int32_t(0x389984DB)},
    {"mslop09c.lun", "", int32_t(0x00000000), int32_t(0x1F4EABEB)},
    {"mslop09c.sno", "", int32_t(0x00000000), int32_t(0xD605B4AA)},
    {"mslop09c.tem", "", int32_t(0x00000000), int32_t(0xDEB01AC8)},
    {"mslop09c.urb", "", int32_t(0x00000000), int32_t(0x4A4EE9F8)},
    {"mslop10.des", "", int32_t(0x00000000), int32_t(0xFAE9F428)},
    {"mslop10.lun", "", int32_t(0x00000000), int32_t(0xDC1713AB)},
    {"mslop10.sno", "", int32_t(0x00000000), int32_t(0xDD0529B2)},
    {"mslop10.tem", "", int32_t(0x00000000), int32_t(0x7EB19C68)},
    {"mslop10.urb", "", int32_t(0x00000000), int32_t(0x58FC5237)},
    {"mslop10a.des", "", int32_t(0x00000000), int32_t(0xC3218DC7)},
    {"mslop10a.lun", "", int32_t(0x00000000), int32_t(0xE4F6A2F7)},
    {"mslop10a.sno", "", int32_t(0x00000000), int32_t(0x2DBDBDB6)},
    {"mslop10a.tem", "", int32_t(0x00000000), int32_t(0x250813D4)},
    {"mslop10a.urb", "", int32_t(0x00000000), int32_t(0xB1F6E0E4)},
    {"mslop10b.des", "", int32_t(0x00000000), int32_t(0x8481F717)},
    {"mslop10b.lun", "", int32_t(0x00000000), int32_t(0xA356D827)},
    {"mslop10b.sno", "", int32_t(0x00000000), int32_t(0x6A1DC766)},
    {"mslop10b.tem", "", int32_t(0x00000000), int32_t(0x62A86904)},
    {"mslop10b.urb", "", int32_t(0x00000000), int32_t(0xF6569A34)},
    {"mslop10c.des", "", int32_t(0x00000000), int32_t(0xB9E1DEA7)},
    {"mslop10c.lun", "", int32_t(0x00000000), int32_t(0x9E36F197)},
    {"mslop10c.sno", "", int32_t(0x00000000), int32_t(0x577DEED6)},
    {"mslop10c.tem", "", int32_t(0x00000000), int32_t(0x5FC840B4)},
    {"mslop10c.urb", "", int32_t(0x00000000), int32_t(0xCB36B384)},
    {"mslop11.des", "", int32_t(0x00000000), int32_t(0x31B5278D)},
    {"mslop11.lun", "", int32_t(0x00000000), int32_t(0x174BC00E)},
    {"mslop11.sno", "", int32_t(0x00000000), int32_t(0x1659FA17)},
    {"mslop11.tem", "", int32_t(0x00000000), int32_t(0xB5ED4FCD)},
    {"mslop11.urb", "", int32_t(0x00000000), int32_t(0x93A08192)},
    {"mslop11a.des", "", int32_t(0x00000000), int32_t(0x087D5E62)},
    {"mslop11a.lun", "", int32_t(0x00000000), int32_t(0x2FAA7152)},
    {"mslop11a.sno", "", int32_t(0x00000000), int32_t(0xE6E16E13)},
    {"mslop11a.tem", "", int32_t(0x00000000), int32_t(0xEE54C071)},
    {"mslop11a.urb", "", int32_t(0x00000000), int32_t(0x7AAA3341)},
    {"mslop11b.des", "", int32_t(0x00000000), int32_t(0x4FDD24B2)},
    {"mslop11b.lun", "", int32_t(0x00000000), int32_t(0x680A0B82)},
    {"mslop11b.sno", "", int32_t(0x00000000), int32_t(0xA14114C3)},
    {"mslop11b.tem", "", int32_t(0x00000000), int32_t(0xA9F4BAA1)},
    {"mslop11b.urb", "", int32_t(0x00000000), int32_t(0x3D0A4991)},
    {"mslop11c.des", "", int32_t(0x00000000), int32_t(0x72BD0D02)},
    {"mslop11c.lun", "", int32_t(0x00000000), int32_t(0x556A2232)},
    {"mslop11c.sno", "", int32_t(0x00000000), int32_t(0x9C213D73)},
    {"mslop11c.tem", "", int32_t(0x00000000), int32_t(0x94949311)},
    {"mslop11c.urb", "", int32_t(0x00000000), int32_t(0x006A6021)},
    {"mslop12.des", "", int32_t(0x00000000), int32_t(0xB7215523)},
    {"mslop12.lun", "", int32_t(0x00000000), int32_t(0x91DFB2A0)},
    {"mslop12.sno", "", int32_t(0x00000000), int32_t(0x90CD88B9)},
    {"mslop12.tem", "", int32_t(0x00000000), int32_t(0x33793D63)},
    {"mslop12.urb", "", int32_t(0x00000000), int32_t(0x1534F33C)},
    {"mslop12a.des", "", int32_t(0x00000000), int32_t(0x8EE92CCC)},
    {"mslop12a.lun", "", int32_t(0x00000000), int32_t(0xA93E03FC)},
    {"mslop12a.sno", "", int32_t(0x00000000), int32_t(0x60751CBD)},
    {"mslop12a.tem", "", int32_t(0x00000000), int32_t(0x68C0B2DF)},
    {"mslop12a.urb", "", int32_t(0x00000000), int32_t(0xFC3E41EF)},
    {"mslop12b.des", "", int32_t(0x00000000), int32_t(0xC949561C)},
    {"mslop12b.lun", "", int32_t(0x00000000), int32_t(0xEE9E792C)},
    {"mslop12b.sno", "", int32_t(0x00000000), int32_t(0x27D5666D)},
    {"mslop12b.tem", "", int32_t(0x00000000), int32_t(0x2F60C80F)},
    {"mslop12b.urb", "", int32_t(0x00000000), int32_t(0xBB9E3B3F)},
    {"mslop12c.des", "", int32_t(0x00000000), int32_t(0xF4297FAC)},
    {"mslop12c.lun", "", int32_t(0x00000000), int32_t(0xD3FE509C)},
    {"mslop12c.sno", "", int32_t(0x00000000), int32_t(0x1AB54FDD)},
    {"mslop12c.tem", "", int32_t(0x00000000), int32_t(0x1200E1BF)},
    {"mslop12c.urb", "", int32_t(0x00000000), int32_t(0x86FE128F)},
    {"mslop13.des", "", int32_t(0x00000000), int32_t(0x7C7D8686)},
    {"mslop13.lun", "", int32_t(0x00000000), int32_t(0x5A836105)},
    {"mslop13.sno", "", int32_t(0x00000000), int32_t(0x5B915B1C)},
    {"mslop13.tem", "", int32_t(0x00000000), int32_t(0xF825EEC6)},
    {"mslop13.urb", "", int32_t(0x00000000), int32_t(0xDE682099)},
    {"mslop13a.sno", "", int32_t(0x00000000), int32_t(0xAB29CF18)},
    {"mslop13a.tem", "", int32_t(0x00000000), int32_t(0xA39C617A)},
    {"mslop13a.urb", "", int32_t(0x00000000), int32_t(0x3762924A)},
    {"mslop13b.sno", "", int32_t(0x00000000), int32_t(0xEC89B5C8)},
    {"mslop13b.tem", "", int32_t(0x00000000), int32_t(0xE43C1BAA)},
    {"mslop13b.urb", "", int32_t(0x00000000), int32_t(0x70C2E89A)},
    {"mslop13c.sno", "", int32_t(0x00000000), int32_t(0xD1E99C78)},
    {"mslop13c.tem", "", int32_t(0x00000000), int32_t(0xD95C321A)},
    {"mslop13c.urb", "", int32_t(0x00000000), int32_t(0x4DA2C12A)},
    {"mslop14.des", "", int32_t(0x00000000), int32_t(0x6178B63E)},
    {"mslop14.lun", "", int32_t(0x00000000), int32_t(0x478651BD)},
    {"mslop14.sno", "", int32_t(0x00000000), int32_t(0x46946BA4)},
    {"mslop14.tem", "", int32_t(0x00000000), int32_t(0xE520DE7E)},
    {"mslop14.urb", "", int32_t(0x00000000), int32_t(0xC36D1021)},
    {"mslop14a.des", "", int32_t(0x00000000), int32_t(0x58B0CFD1)},
    {"mslop14a.lun", "", int32_t(0x00000000), int32_t(0x7F67E0E1)},
    {"mslop14a.sno", "", int32_t(0x00000000), int32_t(0xB62CFFA0)},
    {"mslop14a.tem", "", int32_t(0x00000000), int32_t(0xBE9951C2)},
    {"mslop14a.urb", "", int32_t(0x00000000), int32_t(0x2A67A2F2)},
    {"mslop14b.des", "", int32_t(0x00000000), int32_t(0x1F10B501)},
    {"mslop14b.lun", "", int32_t(0x00000000), int32_t(0x38C79A31)},
    {"mslop14b.sno", "", int32_t(0x00000000), int32_t(0xF18C8570)},
    {"mslop14b.tem", "", int32_t(0x00000000), int32_t(0xF9392B12)},
    {"mslop14b.urb", "", int32_t(0x00000000), int32_t(0x6DC7D822)},
    {"mslop14c.des", "", int32_t(0x00000000), int32_t(0x22709CB1)},
    {"mslop14c.lun", "", int32_t(0x00000000), int32_t(0x05A7B381)},
    {"mslop14c.sno", "", int32_t(0x00000000), int32_t(0xCCECACC0)},
    {"mslop14c.tem", "", int32_t(0x00000000), int32_t(0xC45902A2)},
    {"mslop14c.urb", "", int32_t(0x00000000), int32_t(0x50A7F192)},
    {"mslop15.des", "", int32_t(0x00000000), int32_t(0xAA24659B)},
    {"mslop15.lun", "", int32_t(0x00000000), int32_t(0x8CDA8218)},
    {"mslop15.sno", "", int32_t(0x00000000), int32_t(0x8DC8B801)},
    {"mslop15.tem", "", int32_t(0x00000000), int32_t(0x2E7C0DDB)},
    {"mslop15.urb", "", int32_t(0x00000000), int32_t(0x0831C384)},
    {"mslop15a.des", "", int32_t(0x00000000), int32_t(0x93EC1C74)},
    {"mslop15a.lun", "", int32_t(0x00000000), int32_t(0xB43B3344)},
    {"mslop15a.sno", "", int32_t(0x00000000), int32_t(0x7D702C05)},
    {"mslop15a.tem", "", int32_t(0x00000000), int32_t(0x75C58267)},
    {"mslop15a.urb", "", int32_t(0x00000000), int32_t(0xE13B7157)},
    {"mslop15b.des", "", int32_t(0x00000000), int32_t(0xD44C66A4)},
    {"mslop15b.lun", "", int32_t(0x00000000), int32_t(0xF39B4994)},
    {"mslop15b.sno", "", int32_t(0x00000000), int32_t(0x3AD056D5)},
    {"mslop15b.tem", "", int32_t(0x00000000), int32_t(0x3265F8B7)},
    {"mslop15b.urb", "", int32_t(0x00000000), int32_t(0xA69B0B87)},
    {"mslop15c.des", "", int32_t(0x00000000), int32_t(0xE92C4F14)},
    {"mslop15c.lun", "", int32_t(0x00000000), int32_t(0xCEFB6024)},
    {"mslop15c.sno", "", int32_t(0x00000000), int32_t(0x07B07F65)},
    {"mslop15c.tem", "", int32_t(0x00000000), int32_t(0x0F05D107)},
    {"mslop15c.urb", "", int32_t(0x00000000), int32_t(0x9BFB2237)},
    {"mslop16.des", "", int32_t(0x00000000), int32_t(0x2CB01735)},
    {"mslop16.lun", "", int32_t(0x00000000), int32_t(0x0A4EF0B6)},
    {"mslop16.sno", "", int32_t(0x00000000), int32_t(0x0B5CCAAF)},
    {"mslop16.tem", "", int32_t(0x00000000), int32_t(0xA8E87F75)},
    {"mslop16.urb", "", int32_t(0x00000000), int32_t(0x8EA5B12A)},
    {"mslop16a.des", "", int32_t(0x00000000), int32_t(0x15786EDA)},
    {"mslop16a.lun", "", int32_t(0x00000000), int32_t(0x32AF41EA)},
    {"mslop16a.sno", "", int32_t(0x00000000), int32_t(0xFBE45EAB)},
    {"mslop16a.tem", "", int32_t(0x00000000), int32_t(0xF351F0C9)},
    {"mslop16a.urb", "", int32_t(0x00000000), int32_t(0x67AF03F9)},
    {"mslop16b.des", "", int32_t(0x00000000), int32_t(0x52D8140A)},
    {"mslop16b.lun", "", int32_t(0x00000000), int32_t(0x750F3B3A)},
    {"mslop16b.sno", "", int32_t(0x00000000), int32_t(0xBC44247B)},
    {"mslop16b.tem", "", int32_t(0x00000000), int32_t(0xB4F18A19)},
    {"mslop16b.urb", "", int32_t(0x00000000), int32_t(0x200F7929)},
    {"mslop16c.des", "", int32_t(0x00000000), int32_t(0x6FB83DBA)},
    {"mslop16c.lun", "", int32_t(0x00000000), int32_t(0x486F128A)},
    {"mslop16c.sno", "", int32_t(0x00000000), int32_t(0x81240DCB)},
    {"mslop16c.tem", "", int32_t(0x00000000), int32_t(0x8991A3A9)},
    {"mslop16c.urb", "", int32_t(0x00000000), int32_t(0x1D6F5099)},
    {"mslop17.des", "", int32_t(0x00000000), int32_t(0xE7ECC490)},
    {"mslop17.lun", "", int32_t(0x00000000), int32_t(0xC1122313)},
    {"mslop17.sno", "", int32_t(0x00000000), int32_t(0xC000190A)},
    {"mslop17.tem", "", int32_t(0x00000000), int32_t(0x63B4ACD0)},
    {"mslop17.urb", "", int32_t(0x00000000), int32_t(0x45F9628F)},
    {"mslop17a.des", "", int32_t(0x00000000), int32_t(0xDE24BD7F)},
    {"mslop17a.lun", "", int32_t(0x00000000), int32_t(0xF9F3924F)},
    {"mslop17b.des", "", int32_t(0x00000000), int32_t(0x9984C7AF)},
    {"mslop17b.lun", "", int32_t(0x00000000), int32_t(0xBE53E89F)},
    {"mslop17c.des", "", int32_t(0x00000000), int32_t(0xA4E4EE1F)},
    {"mslop17c.lun", "", int32_t(0x00000000), int32_t(0x8333C12F)},
    {"mslop18.des", "", int32_t(0x00000000), int32_t(0x16BA7645)},
    {"mslop18.lun", "", int32_t(0x00000000), int32_t(0x304491C6)},
    {"mslop18.sno", "", int32_t(0x00000000), int32_t(0x3156ABDF)},
    {"mslop18.tem", "", int32_t(0x00000000), int32_t(0x92E21E05)},
    {"mslop18.urb", "", int32_t(0x00000000), int32_t(0xB4AFD05A)},
    {"mslop18a.des", "", int32_t(0x00000000), int32_t(0x2F720FAA)},
    {"mslop18a.lun", "", int32_t(0x00000000), int32_t(0x08A5209A)},
    {"mslop18b.des", "", int32_t(0x00000000), int32_t(0x68D2757A)},
    {"mslop18b.lun", "", int32_t(0x00000000), int32_t(0x4F055A4A)},
    {"mslop18c.des", "", int32_t(0x00000000), int32_t(0x55B25CCA)},
    {"mslop18c.lun", "", int32_t(0x00000000), int32_t(0x726573FA)},
    {"mslop19.des", "", int32_t(0x00000000), int32_t(0xDDE6A5E0)},
    {"mslop19.lun", "", int32_t(0x00000000), int32_t(0xFB184263)},
    {"mslop19.sno", "", int32_t(0x00000000), int32_t(0xFA0A787A)},
    {"mslop19.tem", "", int32_t(0x00000000), int32_t(0x59BECDA0)},
    {"mslop19.urb", "", int32_t(0x00000000), int32_t(0x7FF303FF)},
    {"mslop20.des", "", int32_t(0x00000000), int32_t(0xCB01EEB5)},
    {"mslop20.lun", "", int32_t(0x00000000), int32_t(0xEDFF0936)},
    {"mslop20.sno", "", int32_t(0x00000000), int32_t(0xECED332F)},
    {"mslop20.tem", "", int32_t(0x00000000), int32_t(0x4F5986F5)},
    {"mslop20.urb", "", int32_t(0x00000000), int32_t(0x691448AA)},
    {"mslpx01.ubn", "", int32_t(0x00000000), int32_t(0x25D8F04F)},
    {"mslpx01a.ubn", "", int32_t(0x00000000), int32_t(0x3F35F09A)},
    {"mslpx01b.ubn", "", int32_t(0x00000000), int32_t(0x78958A4A)},
    {"mslpx01c.ubn", "", int32_t(0x00000000), int32_t(0x45F5A3FA)},
    {"mslpx02.ubn", "", int32_t(0x00000000), int32_t(0xA34C82E1)},
    {"mslpx02a.ubn", "", int32_t(0x00000000), int32_t(0xB9A18234)},
    {"mslpx02b.ubn", "", int32_t(0x00000000), int32_t(0xFE01F8E4)},
    {"mslpx02c.ubn", "", int32_t(0x00000000), int32_t(0xC361D154)},
    {"mslpx03.ubn", "", int32_t(0x00000000), int32_t(0x68105144)},
    {"mslpx03a.ubn", "", int32_t(0x00000000), int32_t(0x72FD5191)},
    {"mslpx03b.ubn", "", int32_t(0x00000000), int32_t(0x355D2B41)},
    {"mslpx03c.ubn", "", int32_t(0x00000000), int32_t(0x083D02F1)},
    {"mslpx04.ubn", "", int32_t(0x00000000), int32_t(0x751561FC)},
    {"mslpx04a.ubn", "", int32_t(0x00000000), int32_t(0x6FF86129)},
    {"mslpx04b.ubn", "", int32_t(0x00000000), int32_t(0x28581BF9)},
    {"mslpx04c.ubn", "", int32_t(0x00000000), int32_t(0x15383249)},
    {"mslpx05.ubn", "", int32_t(0x00000000), int32_t(0xBE49B259)},
    {"mslpx05a.ubn", "", int32_t(0x00000000), int32_t(0xA4A4B28C)},
    {"mslpx05b.ubn", "", int32_t(0x00000000), int32_t(0xE304C85C)},
    {"mslpx05c.ubn", "", int32_t(0x00000000), int32_t(0xDE64E1EC)},
    {"mslpx06.ubn", "", int32_t(0x00000000), int32_t(0x38DDC0F7)},
    {"mslpx06a.ubn", "", int32_t(0x00000000), int32_t(0x2230C022)},
    {"mslpx06b.ubn", "", int32_t(0x00000000), int32_t(0x6590BAF2)},
    {"mslpx06c.ubn", "", int32_t(0x00000000), int32_t(0x58F09342)},
    {"mslpx07.ubn", "", int32_t(0x00000000), int32_t(0xF3811352)},
    {"mslpx07a.ubn", "", int32_t(0x00000000), int32_t(0xE96C1387)},
    {"mslpx07b.ubn", "", int32_t(0x00000000), int32_t(0xAECC6957)},
    {"mslpx07c.ubn", "", int32_t(0x00000000), int32_t(0x93AC40E7)},
    {"mslpx08.ubn", "", int32_t(0x00000000), int32_t(0x02D7A187)},
    {"mslpx08a.ubn", "", int32_t(0x00000000), int32_t(0x183AA152)},
    {"mslpx08b.ubn", "", int32_t(0x00000000), int32_t(0x5F9ADB82)},
    {"mslpx08c.ubn", "", int32_t(0x00000000), int32_t(0x62FAF232)},
    {"mslpx09.ubn", "", int32_t(0x00000000), int32_t(0xC98B7222)},
    {"mslpx09a.ubn", "", int32_t(0x00000000), int32_t(0xD36672F7)},
    {"mslpx09b.ubn", "", int32_t(0x00000000), int32_t(0x94C60827)},
    {"mslpx09c.ubn", "", int32_t(0x00000000), int32_t(0xA9A62197)},
    {"mslpx10.ubn", "", int32_t(0x00000000), int32_t(0x48F3285E)},
    {"mslpx10a.ubn", "", int32_t(0x00000000), int32_t(0x521E288B)},
    {"mslpx10b.ubn", "", int32_t(0x00000000), int32_t(0x15BE525B)},
    {"mslpx10c.ubn", "", int32_t(0x00000000), int32_t(0x28DE7BEB)},
    {"mslpx11.ubn", "", int32_t(0x00000000), int32_t(0x83AFFBFB)},
    {"mslpx11a.ubn", "", int32_t(0x00000000), int32_t(0x9942FB2E)},
    {"mslpx11b.ubn", "", int32_t(0x00000000), int32_t(0xDEE281FE)},
    {"mslpx11c.ubn", "", int32_t(0x00000000), int32_t(0xE382A84E)},
    {"mslpx12.ubn", "", int32_t(0x00000000), int32_t(0x053B8955)},
    {"mslpx12a.ubn", "", int32_t(0x00000000), int32_t(0x1FD68980)},
    {"mslpx12b.ubn", "", int32_t(0x00000000), int32_t(0x5876F350)},
    {"mslpx12c.ubn", "", int32_t(0x00000000), int32_t(0x6516DAE0)},
    {"mslpx13.ubn", "", int32_t(0x00000000), int32_t(0xCE675AF0)},
    {"mslpx14.ubn", "", int32_t(0x00000000), int32_t(0xD3626A48)},
    {"mslpx14a.ubn", "", int32_t(0x00000000), int32_t(0xC98F6A9D)},
    {"mslpx14b.ubn", "", int32_t(0x00000000), int32_t(0x8E2F104D)},
    {"mslpx14c.ubn", "", int32_t(0x00000000), int32_t(0xB34F39FD)},
    {"mslpx15.ubn", "", int32_t(0x00000000), int32_t(0x183EB9ED)},
    {"mslpx15a.ubn", "", int32_t(0x00000000), int32_t(0x02D3B938)},
    {"mslpx15b.ubn", "", int32_t(0x00000000), int32_t(0x4573C3E8)},
    {"mslpx15c.ubn", "", int32_t(0x00000000), int32_t(0x7813EA58)},
    {"mslpx16.ubn", "", int32_t(0x00000000), int32_t(0x9EAACB43)},
    {"mslpx16a.ubn", "", int32_t(0x00000000), int32_t(0x8447CB96)},
    {"mslpx16b.ubn", "", int32_t(0x00000000), int32_t(0xC3E7B146)},
    {"mslpx16c.ubn", "", int32_t(0x00000000), int32_t(0xFE8798F6)},
    {"mslpx17.ubn", "", int32_t(0x00000000), int32_t(0x55F618E6)},
    {"mslpx17a.ubn", "", int32_t(0x00000000), int32_t(0x4F1B1833)},
    {"mslpx17b.ubn", "", int32_t(0x00000000), int32_t(0x08BB62E3)},
    {"mslpx17c.ubn", "", int32_t(0x00000000), int32_t(0x35DB4B53)},
    {"mslpx18.ubn", "", int32_t(0x00000000), int32_t(0xA4A0AA33)},
    {"mslpx18a.ubn", "", int32_t(0x00000000), int32_t(0xBE4DAAE6)},
    {"mslpx18b.ubn", "", int32_t(0x00000000), int32_t(0xF9EDD036)},
    {"mslpx18c.ubn", "", int32_t(0x00000000), int32_t(0xC48DF986)},
    {"mslpx19.ubn", "", int32_t(0x00000000), int32_t(0x6FFC7996)},
    {"mslpx20.ubn", "", int32_t(0x00000000), int32_t(0x791B32C3)},
    {"msovrly.pal", "map selection overlay palette", int32_t(0x00000000), int32_t(0xE4F4358F)},
    {"mssa.wsa", "anim: map of europe", int32_t(0xC3F9FDC8), int32_t(0x00000000)},
    {"mssb.wsa", "anim: map of europe", int32_t(0xC5F9FDC8), int32_t(0x00000000)},
    {"mssc.wsa", "anim: map of europe", int32_t(0xC7F9FDC8), int32_t(0x00000000)},
    {"mssd.wsa", "anim: map of europe", int32_t(0xC9F9FDC8), int32_t(0x00000000)},
    {"msse.wsa", "anim: map of europe", int32_t(0xCBF9FDC8), int32_t(0x00000000)},
    {"mssf.wsa", "anim: map of europe", int32_t(0xCDF9FDC8), int32_t(0x00000000)},
    {"mssg.wsa", "anim: map of europe", int32_t(0xCFF9FDC8), int32_t(0x00000000)},
    {"mssh.wsa", "anim: map of europe", int32_t(0xD1F9FDC8), int32_t(0x00000000)},
    {"mssi.wsa", "anim: map of europe", int32_t(0xD3F9FDC8), int32_t(0x00000000)},
    {"mssj.wsa", "anim: map of europe", int32_t(0xD5F9FDC8), int32_t(0x00000000)},
    {"mssk.wsa", "anim: map of europe", int32_t(0xD7F9FDC8), int32_t(0x00000000)},
    {"mssl.wsa", "anim: map of europe", int32_t(0xD9F9FDC8), int32_t(0x00000000)},
    {"msslicon.shp", "icon: missile silo", int32_t(0x00000000), int32_t(0x79E032A2)},
    {"mssm.wsa", "anim: map of europe", int32_t(0xDBF9FDC8), int32_t(0x00000000)},
    {"mssn.wsa", "anim: map of europe", int32_t(0xDDF9FDC8), int32_t(0x00000000)},
    {"msticon.flc", "", int32_t(0x82313801), int32_t(0x00000000)},
    {"mstl.shp", "-", int32_t(0x00000000), int32_t(0xB247D8CB)},
    {"mstl_a.shp", "-", int32_t(0x00000000), int32_t(0xE85EA6CD)},
    {"mstlicon.shp", "-", int32_t(0x00000000), int32_t(0x9B3C29DB)},
    {"mstlmk.shp", "-", int32_t(0x00000000), int32_t(0x72B0CFD5)},
    {"msub.shp", "unit: missle sub", int32_t(0xD4F2F9C8), int32_t(0x00000000)},
    {"msubicon.shp", "icon: missle sub", int32_t(0xF63C26F5), int32_t(0x00000000)},
    {"mt1ds01.wav", "", int32_t(0x00000000), int32_t(0x89460A44)},
    {"mt1ds02.wav", "", int32_t(0x00000000), int32_t(0x0FD278EA)},
    {"mt1ds03.wav", "", int32_t(0x00000000), int32_t(0xC48EAB4F)},
    {"mt1ds04.wav", "", int32_t(0x00000000), int32_t(0xD98B9BF7)},
    {"mt1ds05.wav", "", int32_t(0x00000000), int32_t(0x12D74852)},
    {"mt1ds06.wav", "", int32_t(0x00000000), int32_t(0x94433AFC)},
    {"mt1ds07.wav", "", int32_t(0x00000000), int32_t(0x5F1FE959)},
    {"mt1ds08.wav", "", int32_t(0x00000000), int32_t(0xAE495B8C)},
    {"mt1ds09.wav", "", int32_t(0x00000000), int32_t(0x65158829)},
    {"mt1ds10.wav", "", int32_t(0x00000000), int32_t(0xE46DD255)},
    {"mt1ds11.wav", "", int32_t(0x00000000), int32_t(0x2F3101F0)},
    {"mt1ds12.wav", "", int32_t(0x00000000), int32_t(0xA9A5735E)},
    {"mt2ds01.wav", "", int32_t(0x00000000), int32_t(0x6271B147)},
    {"mt2ds02.wav", "", int32_t(0x00000000), int32_t(0xE4E5C3E9)},
    {"mt2ds03.wav", "", int32_t(0x00000000), int32_t(0x2FB9104C)},
    {"mt2ds04.wav", "", int32_t(0x00000000), int32_t(0x32BC20F4)},
    {"mt2ds05.wav", "", int32_t(0x00000000), int32_t(0xF9E0F351)},
    {"mt2ds06.wav", "", int32_t(0x00000000), int32_t(0x7F7481FF)},
    {"mt2ds07.wav", "", int32_t(0x00000000), int32_t(0xB428525A)},
    {"mt2ds08.wav", "", int32_t(0x00000000), int32_t(0x457EE08F)},
    {"mt2ds09.wav", "", int32_t(0x00000000), int32_t(0x8E22332A)},
    {"mt2ds10.wav", "", int32_t(0x00000000), int32_t(0x0F5A6956)},
    {"mt2ds11.wav", "", int32_t(0x00000000), int32_t(0xC406BAF3)},
    {"mt2ds12.wav", "", int32_t(0x00000000), int32_t(0x4292C85D)},
    {"mt2ds13.wav", "", int32_t(0x00000000), int32_t(0x89CE1BF8)},
    {"mt2ds14.wav", "", int32_t(0x00000000), int32_t(0x94CB2B40)},
    {"mt2ds15.wav", "", int32_t(0x00000000), int32_t(0x5F97F8E5)},
    {"mt2ds16.wav", "", int32_t(0x00000000), int32_t(0xD9038A4B)},
    {"mt2ds17.wav", "", int32_t(0x00000000), int32_t(0x125F59EE)},
    {"mt2ds18.wav", "", int32_t(0x00000000), int32_t(0xE309EB3B)},
    {"mt2ds19.wav", "", int32_t(0x00000000), int32_t(0x2855389E)},
    {"mt2ds20.wav", "", int32_t(0x00000000), int32_t(0x3EB273CB)},
    {"mt2ds21.wav", "", int32_t(0x00000000), int32_t(0xF5EEA06E)},
    {"mt2ds22.wav", "", int32_t(0x00000000), int32_t(0x737AD2C0)},
    {"mt2ds23.wav", "", int32_t(0x00000000), int32_t(0xB8260165)},
    {"mtfacthi.pcx", "pict: mammoth tank factory", int32_t(0xEFED49E9), int32_t(0x00000000)},
    {"mtfactlo.cps", "pict: mammoth tank factory", int32_t(0xF7023CE9), int32_t(0x00000000)},
    {"mthanks1.aud", "thanks", int32_t(0xAC1D28FF), int32_t(0x00000000)},
    {"mthmaxh.wsa", "", int32_t(0x91F3550E), int32_t(0x00000000)},
    {"mthmaxhp.wsa", "", int32_t(0x170558E5), int32_t(0x00000000)},
    {"mthminh.wsa", "", int32_t(0x91F3411E), int32_t(0x00000000)},
    {"mthminhp.wsa", "", int32_t(0x170544F5), int32_t(0x00000000)},
    {"mthnorm.wsa", "", int32_t(0x95FD492A), int32_t(0x00000000)},
    {"mthnormp.wsa", "", int32_t(0x1B0F4D01), int32_t(0x00000000)},
    {"mtiber1.aud", "mind the tiberium", int32_t(0x65CC4B00), int32_t(0x00000000)},
    {"mtimein1.aud", "mission timer initialised", int32_t(0xDC1724ED), int32_t(0x00000000)},
    {"mtlcrek2.aud", "", int32_t(0xB61D1D07), int32_t(0x00000000)},
    {"mtlcrek3.aud", "", int32_t(0xB81D1D07), int32_t(0x00000000)},
    {"mtlcrek4.aud", "", int32_t(0xBA1D1D07), int32_t(0x00000000)},
    {"mtlcrek5.aud", "", int32_t(0xBC1D1D07), int32_t(0x00000000)},
    {"mtldoor2.aud", "", int32_t(0xBA2B3101), int32_t(0x00000000)},
    {"mtlgrate.aud", "", int32_t(0xEC2F1507), int32_t(0x00000000)},
    {"mtlhit1.aud", "", int32_t(0x7DD84F08), int32_t(0x00000000)},
    {"mtlht1_i.aud", "", int32_t(0xF844F50B), int32_t(0x00000000)},
    {"mtlht2_i.aud", "", int32_t(0xF844F70B), int32_t(0x00000000)},
    {"mtlht3_i.aud", "", int32_t(0xF844F90B), int32_t(0x00000000)},
    {"mtlpage3.aud", "audf:", int32_t(0xEC1120E5), int32_t(0x00000000)},
    {"mtlratl1.aud", "", int32_t(0xF01F3AE5), int32_t(0x00000000)},
    {"mtlratl2.aud", "", int32_t(0xF21F3AE5), int32_t(0x00000000)},
    {"mtlratl3.aud", "", int32_t(0xF41F3AE5), int32_t(0x00000000)},
    {"mtlscrp2.aud", "", int32_t(0xF62736E9), int32_t(0x00000000)},
    {"mtlslam1.aud", "", int32_t(0xF42114FB), int32_t(0x00000000)},
    {"mtltrgt1.aud", "", int32_t(0xF82F2107), int32_t(0x00000000)},
    {"mtltrgt2.aud", "", int32_t(0xFA2F2107), int32_t(0x00000000)},
    {"mtnk.hva", "", int32_t(0x00000000), int32_t(0xC90F4814)},
    {"mtnk.shp", "medium tank", int32_t(0xE6E4FBC8), int32_t(0x00000000)},
    {"mtnk.vxl", "", int32_t(0x00000000), int32_t(0x3F85975D)},
    {"mtnkbarl.hva", "", int32_t(0x00000000), int32_t(0x47155C56)},
    {"mtnkbarl.vxl", "", int32_t(0x00000000), int32_t(0xB19F831F)},
    {"mtnkfact.vqa", "mammoth tank factory", int32_t(0x171129EF), int32_t(0x00000000)},
    {"mtnkfact.vqp", "vqp: mammoth tank factory", int32_t(0x261129EF), int32_t(0x00000000)},
    {"mtnkicnh.des", "icon: medium tank", int32_t(0x111B1BF5), int32_t(0x00000000)},
    {"mtnkicnh.tem", "icon: medium tank", int32_t(0x0B1B2BF5), int32_t(0x00000000)},
    {"mtnkicnh.win", "icon: medium tank", int32_t(0x0C1F2EF5), int32_t(0x00000000)},
    {"mtnkicon.shp", "icon: medium tank", int32_t(0x1A202AF5), int32_t(0xE6EA40B0)},
    {"mtnktur.hva", "", int32_t(0x00000000), int32_t(0x18067A85)},
    {"mtnktur.vxl", "", int32_t(0x00000000), int32_t(0x17F0096E)},
    {"mtnkuico.shp", "", int32_t(0x00000000), int32_t(0x232CD251)},
    {"mtrb.hva", "-", int32_t(0x00000000), int32_t(0xB00BE885)},
    {"mtrb.vxl", "metior", int32_t(0x00000000), int32_t(0x468137CC)},
    {"mtrs.hva", "-", int32_t(0x00000000), int32_t(0xED8B56B7)},
    {"mtrs.vxl", "metior", int32_t(0x00000000), int32_t(0x1B0189FE)},
    {"mtrt.hva", "-", int32_t(0x00000000), int32_t(0x5FAB8AA7)},
    {"mtrt.vxl", "metior", int32_t(0x00000000), int32_t(0xA92155EE)},
    {"mud1a.aud", "mud", int32_t(0x6F93B1FB), int32_t(0x00000000)},
    {"mudremx.aud", "", int32_t(0xA6064500), int32_t(0x00000000)},
    {"mudwlk1.aud", "", int32_t(0xB9B8410E), int32_t(0x00000000)},
    {"mudwlk2.aud", "", int32_t(0xB9BA410E), int32_t(0x00000000)},
    {"mudwlk3.aud", "", int32_t(0xB9BC410E), int32_t(0x00000000)},
    {"mudwlk4.aud", "", int32_t(0xB9BE410E), int32_t(0x00000000)},
    {"mudwlk5.aud", "", int32_t(0xB9C0410E), int32_t(0x00000000)},
    {"mudwlk6.aud", "", int32_t(0xB9C2410E), int32_t(0x00000000)},
    {"mudwlk7.aud", "", int32_t(0xB9C4410E), int32_t(0x00000000)},
    {"multi.pcx", "", int32_t(0x00000000), int32_t(0xD5EC04CA)},
    {"multi01.pkt", "-", int32_t(0x00000000), int32_t(0xA8B26BD3)},
    {"multiplayselection.pal", "", int32_t(0x00000000), int32_t(0x88D82BD9)},
    {"multiplayselection.shp", "", int32_t(0x00000000), int32_t(0xDE90FC33)},
    {"multscor.pal", "pal: ", int32_t(0x42112C09), int32_t(0x00000000)},
    {"mumy.shp", "", int32_t(0x00000000), int32_t(0x5D4EA650)},
    {"musbleed.aud", "", int32_t(0xD62D20FB), int32_t(0x00000000)},
    {"music\\anmagic.aud", "", int32_t(0xD6DF98EA), int32_t(0x00000000)},
    {"music\\anmagic.hmi", "", int32_t(0xC6ED98EF), int32_t(0x00000000)},
    {"music\\anmagic.xmi", "", int32_t(0xC70D98EF), int32_t(0x00000000)},
    {"music\\arenbat1.aud", "", int32_t(0xAEA616FD), int32_t(0x00000000)},
    {"music\\arenbat1.hmi", "", int32_t(0xBCA61BF5), int32_t(0x00000000)},
    {"music\\arenbat1.xmi", "", int32_t(0xDCA61BF5), int32_t(0x00000000)},
    {"music\\badfile.aud", "", int32_t(0x7AEFACCC), int32_t(0x00000000)},
    {"music\\badfile.hmi", "", int32_t(0x6AFDACD1), int32_t(0x00000000)},
    {"music\\badfile.xmi", "", int32_t(0x6B1DACD1), int32_t(0x00000000)},
    {"music\\belbatl1.aud", "", int32_t(0x92A9E709), int32_t(0x00000000)},
    {"music\\belbatl1.hmi", "", int32_t(0xA0A9EC01), int32_t(0x00000000)},
    {"music\\belbatl1.xmi", "", int32_t(0xC0A9EC01), int32_t(0x00000000)},
    {"music\\belwand1.aud", "", int32_t(0x7AAA3AFB), int32_t(0x00000000)},
    {"music\\belwand1.hmi", "", int32_t(0x88AA3FF3), int32_t(0x00000000)},
    {"music\\belwand1.xmi", "", int32_t(0xA8AA3FF3), int32_t(0x00000000)},
    {"music\\cemwndr1.aud", "", int32_t(0x52E63B1B), int32_t(0x00000000)},
    {"music\\cemwndr1.hmi", "", int32_t(0x60E64013), int32_t(0x00000000)},
    {"music\\cemwndr1.xmi", "", int32_t(0x80E64013), int32_t(0x00000000)},
    {"music\\chambat1.aud", "", int32_t(0x5EB612EF), int32_t(0x00000000)},
    {"music\\chambat1.hmi", "", int32_t(0x6CB617E7), int32_t(0x00000000)},
    {"music\\chambat1.xmi", "", int32_t(0x8CB617E7), int32_t(0x00000000)},
    {"music\\chamwdr1.aud", "", int32_t(0x6B0A12EB), int32_t(0x00000000)},
    {"music\\chamwdr1.hmi", "", int32_t(0x790A17E3), int32_t(0x00000000)},
    {"music\\chamwdr1.xmi", "", int32_t(0x990A17E3), int32_t(0x00000000)},
    {"music\\citywan1.aud", "", int32_t(0x670A432F), int32_t(0x00000000)},
    {"music\\citywan1.hmi", "", int32_t(0x750A4827), int32_t(0x00000000)},
    {"music\\citywan1.xmi", "", int32_t(0x950A4827), int32_t(0x00000000)},
    {"music\\citywan2.aud", "", int32_t(0x670A452F), int32_t(0x00000000)},
    {"music\\citywan2.hmi", "", int32_t(0x750A4A27), int32_t(0x00000000)},
    {"music\\citywan2.xmi", "", int32_t(0x950A4A27), int32_t(0x00000000)},
    {"music\\clawbat1.aud", "", int32_t(0x7EB63AEF), int32_t(0x00000000)},
    {"music\\clawbat1.hmi", "", int32_t(0x8CB63FE7), int32_t(0x00000000)},
    {"music\\clawbat1.xmi", "", int32_t(0xACB63FE7), int32_t(0x00000000)},
    {"music\\clawwan1.aud", "", int32_t(0x7F0A3AE3), int32_t(0x00000000)},
    {"music\\clawwan1.hmi", "", int32_t(0x8D0A3FDB), int32_t(0x00000000)},
    {"music\\clawwan1.xmi", "", int32_t(0xAD0A3FDB), int32_t(0x00000000)},
    {"music\\credits.aud", "", int32_t(0x22F7A4EB), int32_t(0x00000000)},
    {"music\\credits.hmi", "", int32_t(0x1305A4F0), int32_t(0x00000000)},
    {"music\\credits.xmi", "", int32_t(0x1325A4F0), int32_t(0x00000000)},
    {"music\\dhallp1.aud", "", int32_t(0xC30BC496), int32_t(0x00000000)},
    {"music\\dhallp1.hmi", "", int32_t(0xB319C49B), int32_t(0x00000000)},
    {"music\\dhallp1.xmi", "", int32_t(0xB339C49B), int32_t(0x00000000)},
    {"music\\drahall1.aud", "", int32_t(0xDAB9FEDD), int32_t(0x00000000)},
    {"music\\drahall1.hmi", "", int32_t(0xE8BA03D5), int32_t(0x00000000)},
    {"music\\drahall1.xmi", "", int32_t(0x08BA03D6), int32_t(0x00000000)},
    {"music\\drgstir4.aud", "", int32_t(0xCF063101), int32_t(0x00000000)},
    {"music\\gladwan1.aud", "", int32_t(0x7F29EEE3), int32_t(0x00000000)},
    {"music\\gladwan1.hmi", "", int32_t(0x8D29F3DB), int32_t(0x00000000)},
    {"music\\gladwan1.xmi", "", int32_t(0xAD29F3DB), int32_t(0x00000000)},
    {"music\\hivebat1.aud", "", int32_t(0x66DDF343), int32_t(0x00000000)},
    {"music\\hivebat1.hmi", "", int32_t(0x74DDF83B), int32_t(0x00000000)},
    {"music\\hivebat1.xmi", "", int32_t(0x94DDF83B), int32_t(0x00000000)},
    {"music\\hivecav1.aud", "", int32_t(0x66E1F347), int32_t(0x00000000)},
    {"music\\hivecav1.hmi", "", int32_t(0x74E1F83F), int32_t(0x00000000)},
    {"music\\hivecav1.xmi", "", int32_t(0x94E1F83F), int32_t(0x00000000)},
    {"music\\hujung1.aud", "", int32_t(0x0733E8BB), int32_t(0x00000000)},
    {"music\\hujung1.hmi", "", int32_t(0xF741E8BF), int32_t(0x00000000)},
    {"music\\hujung1.xmi", "", int32_t(0xF761E8BF), int32_t(0x00000000)},
    {"music\\hunt1.aud", "", int32_t(0xFC631954), int32_t(0x00000000)},
    {"music\\hunt1.hmi", "", int32_t(0xFC68115B), int32_t(0x00000000)},
    {"music\\hunt1.xmi", "", int32_t(0xFC68116B), int32_t(0x00000000)},
    {"music\\huvilag1.aud", "", int32_t(0xC7060327), int32_t(0x00000000)},
    {"music\\huvilag1.hmi", "", int32_t(0xD506081F), int32_t(0x00000000)},
    {"music\\huvilag1.xmi", "", int32_t(0xF506081F), int32_t(0x00000000)},
    {"music\\monpost1.aud", "", int32_t(0xDF3A1F21), int32_t(0x00000000)},
    {"music\\monpost1.hmi", "", int32_t(0xED3A2419), int32_t(0x00000000)},
    {"music\\monpost1.xmi", "", int32_t(0x0D3A241A), int32_t(0x00000000)},
    {"music\\monwand1.aud", "", int32_t(0xCB023B01), int32_t(0x00000000)},
    {"music\\monwand1.hmi", "", int32_t(0xD9023FF9), int32_t(0x00000000)},
    {"music\\monwand1.xmi", "", int32_t(0xF9023FF9), int32_t(0x00000000)},
    {"music\\rubat1.aud", "", int32_t(0x46E1DF28), int32_t(0x00000000)},
    {"music\\rubat1.hmi", "", int32_t(0x4BD9E628), int32_t(0x00000000)},
    {"music\\rubat1.xmi", "", int32_t(0x4BD9F628), int32_t(0x00000000)},
    {"music\\rupost1.aud", "", int32_t(0x3B97D0D3), int32_t(0x00000000)},
    {"music\\rupost1.hmi", "", int32_t(0x2BA5D0D8), int32_t(0x00000000)},
    {"music\\rupost1.xmi", "", int32_t(0x2BC5D0D8), int32_t(0x00000000)},
    {"music\\ruwandr1.aud", "", int32_t(0xD35DE341), int32_t(0x00000000)},
    {"music\\ruwandr1.hmi", "", int32_t(0xE15DE839), int32_t(0x00000000)},
    {"music\\ruwandr1.xmi", "", int32_t(0x015DE83A), int32_t(0x00000000)},
    {"music\\savage.aud", "", int32_t(0x1ECBDF51), int32_t(0x00000000)},
    {"music\\savage.hmi", "", int32_t(0x23C3E651), int32_t(0x00000000)},
    {"music\\savage.xmi", "", int32_t(0x23C3F651), int32_t(0x00000000)},
    {"music\\sedrgstir1.aud", "", int32_t(0xB3E753D2), int32_t(0x00000000)},
    {"music\\skelbat1.aud", "", int32_t(0x77360EFF), int32_t(0x00000000)},
    {"music\\skelbat1.hmi", "", int32_t(0x853613F7), int32_t(0x00000000)},
    {"music\\skelbat1.xmi", "", int32_t(0xA53613F7), int32_t(0x00000000)},
    {"music\\ssarbat1.aud", "", int32_t(0xB73626ED), int32_t(0x00000000)},
    {"music\\ssarbat1.hmi", "", int32_t(0xC5362BE5), int32_t(0x00000000)},
    {"music\\ssarbat1.xmi", "", int32_t(0xE5362BE5), int32_t(0x00000000)},
    {"music\\ssarcav1.aud", "", int32_t(0xB73A26F1), int32_t(0x00000000)},
    {"music\\ssarcav1.hmi", "", int32_t(0xC53A2BE9), int32_t(0x00000000)},
    {"music\\ssarcav1.xmi", "", int32_t(0xE53A2BE9), int32_t(0x00000000)},
    {"music\\ssarpit1.aud", "", int32_t(0xD76E26ED), int32_t(0x00000000)},
    {"music\\ssarpit1.hmi", "", int32_t(0xE56E2BE5), int32_t(0x00000000)},
    {"music\\ssarpit1.xmi", "", int32_t(0x056E2BE6), int32_t(0x00000000)},
    {"music\\temple1.aud", "", int32_t(0x7F8BD4C8), int32_t(0x00000000)},
    {"music\\temple1.hmi", "", int32_t(0x6F99D4CD), int32_t(0x00000000)},
    {"music\\temple1.xmi", "", int32_t(0x6FB9D4CD), int32_t(0x00000000)},
    {"music\\uewoods0.aud", "", int32_t(0x537A1945), int32_t(0x00000000)},
    {"music\\vicbatl1.aud", "", int32_t(0xB349E6E5), int32_t(0x00000000)},
    {"music\\vicbatl1.hmi", "", int32_t(0xC149EBDD), int32_t(0x00000000)},
    {"music\\vicbatl1.xmi", "", int32_t(0xE149EBDD), int32_t(0x00000000)},
    {"music\\wildbat1.aud", "", int32_t(0x6755EF1B), int32_t(0x00000000)},
    {"music\\wildbat1.hmi", "", int32_t(0x7555F413), int32_t(0x00000000)},
    {"music\\wildbat1.xmi", "", int32_t(0x9555F413), int32_t(0x00000000)},
    {"musvol8.aud", "", int32_t(0xB6024314), int32_t(0x00000000)},
    {"mut1atk1.aud", "", int32_t(0x6C3D3EE5), int32_t(0x00000000)},
    {"mut1atk2.aud", "", int32_t(0x6E3D3EE5), int32_t(0x00000000)},
    {"mut1die1.aud", "", int32_t(0x6C3128EB), int32_t(0x00000000)},
    {"mut1die2.aud", "", int32_t(0x6E3128EB), int32_t(0x00000000)},
    {"mut1hit1.aud", "", int32_t(0x6C4F28F3), int32_t(0x00000000)},
    {"mut1hit2.aud", "", int32_t(0x6E4F28F3), int32_t(0x00000000)},
    {"mut1loi1.aud", "", int32_t(0x6C3934FB), int32_t(0x00000000)},
    {"mut1loi2.aud", "", int32_t(0x6E3934FB), int32_t(0x00000000)},
    {"mut1pck1.aud", "", int32_t(0x6C3D1D03), int32_t(0x00000000)},
    {"mut1pck2.aud", "", int32_t(0x6E3D1D03), int32_t(0x00000000)},
    {"mut1run1.aud", "", int32_t(0x6C434107), int32_t(0x00000000)},
    {"mut1run2.aud", "", int32_t(0x6E434107), int32_t(0x00000000)},
    {"mut1stn1.aud", "", int32_t(0x6C433F09), int32_t(0x00000000)},
    {"mut1stn2.aud", "", int32_t(0x6E433F09), int32_t(0x00000000)},
    {"mut1wlk1.aud", "", int32_t(0x6C3D2F11), int32_t(0x00000000)},
    {"mut1wlk2.aud", "", int32_t(0x6E3D2F11), int32_t(0x00000000)},
    {"mut2atk1.aud", "", int32_t(0x703D3EE5), int32_t(0x00000000)},
    {"mut2atk2.aud", "", int32_t(0x723D3EE5), int32_t(0x00000000)},
    {"mut2die1.aud", "", int32_t(0x703128EB), int32_t(0x00000000)},
    {"mut2die2.aud", "", int32_t(0x723128EB), int32_t(0x00000000)},
    {"mut2hit1.aud", "", int32_t(0x704F28F3), int32_t(0x00000000)},
    {"mut2hit2.aud", "", int32_t(0x724F28F3), int32_t(0x00000000)},
    {"mut2hit3.aud", "", int32_t(0x744F28F3), int32_t(0x00000000)},
    {"mut2loi1.aud", "", int32_t(0x703934FB), int32_t(0x00000000)},
    {"mut2loi2.aud", "", int32_t(0x723934FB), int32_t(0x00000000)},
    {"mut2loi3.aud", "", int32_t(0x743934FB), int32_t(0x00000000)},
    {"mut2pck1.aud", "", int32_t(0x703D1D03), int32_t(0x00000000)},
    {"mut2pck2.aud", "", int32_t(0x723D1D03), int32_t(0x00000000)},
    {"mut2pck3.aud", "", int32_t(0x743D1D03), int32_t(0x00000000)},
    {"mut2run1.aud", "", int32_t(0x70434107), int32_t(0x00000000)},
    {"mut2run2.aud", "", int32_t(0x72434107), int32_t(0x00000000)},
    {"mut2stn1.aud", "", int32_t(0x70433F09), int32_t(0x00000000)},
    {"mut2stn2.aud", "", int32_t(0x72433F09), int32_t(0x00000000)},
    {"mut2wlk1.aud", "", int32_t(0x703D2F11), int32_t(0x00000000)},
    {"mut2wlk2.aud", "", int32_t(0x723D2F11), int32_t(0x00000000)},
    {"mutant.shp", "unit: mutant", int32_t(0x00000000), int32_t(0x74530905)},
    {"mutant2.shp", "-", int32_t(0x00000000), int32_t(0xFDAB6A03)},
    {"mutant3.shp", "unit: mutant sergent", int32_t(0x00000000), int32_t(0x36F7B9A6)},
    {"mutants.aud", "mutants", int32_t(0x00000000), int32_t(0xFE43CE9E)},
    {"mutants.ini", "", int32_t(0x00000000), int32_t(0x9E2AD4AD)},
    {"mutants.map", "-", int32_t(0x00000000), int32_t(0x8114ADDF)},
    {"mutate.shp", "", int32_t(0x00000000), int32_t(0x5881B39C)},
    {"mutcicon.shp", "icon: umagon, tratos, ghost stalker (group photo)", int32_t(0x00000000), int32_t(0xAC302C49)},
    {"muteicon.shp", "", int32_t(0x00000000), int32_t(0xDF2A55C3)},
    {"mw_a_e.vqa", "", int32_t(0xB1DA2944), int32_t(0x00000000)},
    {"mw_a_f.vqa", "", int32_t(0xB1DA2B44), int32_t(0x00000000)},
    {"mw_a_g.vqa", "", int32_t(0xB1DA2D44), int32_t(0x00000000)},
    {"mw_a_i.vqa", "", int32_t(0xB1DA3144), int32_t(0x00000000)},
    {"mw_a_s.vqa", "", int32_t(0xB1DA4544), int32_t(0x00000000)},
    {"mw_b01_e.vqa", "", int32_t(0xD58D15C3), int32_t(0x00000000)},
    {"mw_b01_f.vqa", "", int32_t(0xD78D15C3), int32_t(0x00000000)},
    {"mw_b01_s.vqa", "", int32_t(0xF18D15C3), int32_t(0x00000000)},
    {"mw_b02_e.vqa", "", int32_t(0xD58D17C3), int32_t(0x00000000)},
    {"mw_b02_f.vqa", "", int32_t(0xD78D17C3), int32_t(0x00000000)},
    {"mw_b02_s.vqa", "", int32_t(0xF18D17C3), int32_t(0x00000000)},
    {"mw_b03_e.vqa", "", int32_t(0xD58D19C3), int32_t(0x00000000)},
    {"mw_b03_f.vqa", "", int32_t(0xD78D19C3), int32_t(0x00000000)},
    {"mw_b03_s.vqa", "", int32_t(0xF18D19C3), int32_t(0x00000000)},
    {"mw_b04_e.vqa", "", int32_t(0xD58D1BC3), int32_t(0x00000000)},
    {"mw_b04_f.vqa", "", int32_t(0xD78D1BC3), int32_t(0x00000000)},
    {"mw_b04_g.vqa", "", int32_t(0xD98D1BC3), int32_t(0x00000000)},
    {"mw_b04_i.vqa", "", int32_t(0xDD8D1BC3), int32_t(0x00000000)},
    {"mw_b04_s.vqa", "", int32_t(0xF18D1BC3), int32_t(0x00000000)},
    {"mw_b05_e.vqa", "", int32_t(0xD58D1DC3), int32_t(0x00000000)},
    {"mw_b05_f.vqa", "", int32_t(0xD78D1DC3), int32_t(0x00000000)},
    {"mw_b05_g.vqa", "", int32_t(0xD98D1DC3), int32_t(0x00000000)},
    {"mw_b05_i.vqa", "", int32_t(0xDD8D1DC3), int32_t(0x00000000)},
    {"mw_b05_s.vqa", "", int32_t(0xF18D1DC3), int32_t(0x00000000)},
    {"mw_c01_e.vqa", "", int32_t(0xD98D15C3), int32_t(0x00000000)},
    {"mw_c01_f.vqa", "", int32_t(0xDB8D15C3), int32_t(0x00000000)},
    {"mw_c01_g.vqa", "", int32_t(0xDD8D15C3), int32_t(0x00000000)},
    {"mw_c01_i.vqa", "", int32_t(0xE18D15C3), int32_t(0x00000000)},
    {"mw_c01_s.vqa", "", int32_t(0xF58D15C3), int32_t(0x00000000)},
    {"mw_c02_e.vqa", "", int32_t(0xD98D17C3), int32_t(0x00000000)},
    {"mw_c02_f.vqa", "", int32_t(0xDB8D17C3), int32_t(0x00000000)},
    {"mw_c02_g.vqa", "", int32_t(0xDD8D17C3), int32_t(0x00000000)},
    {"mw_c02_i.vqa", "", int32_t(0xE18D17C3), int32_t(0x00000000)},
    {"mw_c02_s.vqa", "", int32_t(0xF58D17C3), int32_t(0x00000000)},
    {"mw_c03_e.vqa", "", int32_t(0xD98D19C3), int32_t(0x00000000)},
    {"mw_c03_f.vqa", "", int32_t(0xDB8D19C3), int32_t(0x00000000)},
    {"mw_c03_g.vqa", "", int32_t(0xDD8D19C3), int32_t(0x00000000)},
    {"mw_c03_i.vqa", "", int32_t(0xE18D19C3), int32_t(0x00000000)},
    {"mw_c03_s.vqa", "", int32_t(0xF58D19C3), int32_t(0x00000000)},
    {"mw_d_e.vqa", "", int32_t(0xBDDA2944), int32_t(0x00000000)},
    {"mw_d_f.vqa", "", int32_t(0xBDDA2B44), int32_t(0x00000000)},
    {"mw_d_g.vqa", "", int32_t(0xBDDA2D44), int32_t(0x00000000)},
    {"mw_d_i.vqa", "", int32_t(0xBDDA3144), int32_t(0x00000000)},
    {"mw_d_s.vqa", "", int32_t(0xBDDA4544), int32_t(0x00000000)},
    {"mwa-01.des", "", int32_t(0x00000000), int32_t(0x6BE63993)},
    {"mwa-01.sno", "", int32_t(0x00000000), int32_t(0xECC9769C)},
    {"mwa-01.tem", "", int32_t(0x00000000), int32_t(0x1DBE206B)},
    {"mwa-01.urb", "", int32_t(0x00000000), int32_t(0x659FA407)},
    {"mwa-02.des", "", int32_t(0x00000000), int32_t(0x5A0E230E)},
    {"mwa-02.sno", "", int32_t(0x00000000), int32_t(0xDD216C01)},
    {"mwa-02.tem", "", int32_t(0x00000000), int32_t(0x2C563AF6)},
    {"mwa-02.urb", "", int32_t(0x00000000), int32_t(0x5477BE9A)},
    {"mwa-03.des", "", int32_t(0x00000000), int32_t(0xFC7928BA)},
    {"mwa-03.sno", "", int32_t(0x00000000), int32_t(0x7B5667B5)},
    {"mwa-03.tem", "", int32_t(0x00000000), int32_t(0x8A213142)},
    {"mwa-03.urb", "", int32_t(0x00000000), int32_t(0xF200B52E)},
    {"mwa-04.des", "", int32_t(0x00000000), int32_t(0x39DE1634)},
    {"mwa-04.sno", "", int32_t(0x00000000), int32_t(0xBEF1593B)},
    {"mwa-04.tem", "", int32_t(0x00000000), int32_t(0x4F860FCC)},
    {"mwa-04.urb", "", int32_t(0x00000000), int32_t(0x37A78BA0)},
    {"mwar.shp", "-", int32_t(0x00000000), int32_t(0xCAC34613)},
    {"mwar_1.shp", "-", int32_t(0x00000000), int32_t(0x116AD62B)},
    {"mwar_2.shp", "-", int32_t(0x00000000), int32_t(0x2082CCB6)},
    {"mwar_a.shp", "-", int32_t(0x00000000), int32_t(0xFD020600)},
    {"mwar_b.shp", "-", int32_t(0x00000000), int32_t(0xCCEA1C9D)},
    {"mwar_c.shp", "-", int32_t(0x00000000), int32_t(0x6A9D1729)},
    {"mwar_d.shp", "-", int32_t(0x00000000), int32_t(0xAF3A29A7)},
    {"mwar_nod.hva", "-", int32_t(0x00000000), int32_t(0xB1519B67)},
    {"mwar_nod.vxl", "mobile war factory/fist of nod", int32_t(0x00000000), int32_t(0x47DB442E)},
    {"mwarbb.shp", "-", int32_t(0x00000000), int32_t(0x2B543867)},
    {"mwaricon.shp", "-", int32_t(0x00000000), int32_t(0x8E608916)},
    {"mwarmk.shp", "-", int32_t(0x00000000), int32_t(0x67EC6F18)},
    {"mwater01.des", "", int32_t(0x00000000), int32_t(0xDF4420A1)},
    {"mwater01.sno", "", int32_t(0x00000000), int32_t(0x31D810D0)},
    {"mwater01.tem", "", int32_t(0x00000000), int32_t(0x396DBEB2)},
    {"mwater01.urb", "", int32_t(0x00000000), int32_t(0xAD934D82)},
    {"mwater02.des", "", int32_t(0x00000000), int32_t(0x98E45A71)},
    {"mwater02.sno", "", int32_t(0x00000000), int32_t(0x76786A00)},
    {"mwater02.tem", "", int32_t(0x00000000), int32_t(0x7ECDC462)},
    {"mwater02.urb", "", int32_t(0x00000000), int32_t(0xEA333752)},
    {"mwater03.des", "", int32_t(0x00000000), int32_t(0xA58473C1)},
    {"mwater03.sno", "", int32_t(0x00000000), int32_t(0x4B1843B0)},
    {"mwater03.tem", "", int32_t(0x00000000), int32_t(0x43ADEDD2)},
    {"mwater03.urb", "", int32_t(0x00000000), int32_t(0xD7531EE2)},
    {"mwater04.des", "", int32_t(0x00000000), int32_t(0x17A4AFD1)},
    {"mwater04.sno", "", int32_t(0x00000000), int32_t(0xF9389FA0)},
    {"mwater04.tem", "", int32_t(0x00000000), int32_t(0xF18D31C2)},
    {"mwater04.urb", "", int32_t(0x00000000), int32_t(0x6573C2F2)},
    {"mwater05.des", "", int32_t(0x00000000), int32_t(0x2AC48661)},
    {"mwater05.sno", "", int32_t(0x00000000), int32_t(0xC458B610)},
    {"mwater05.tem", "", int32_t(0x00000000), int32_t(0xCCED1872)},
    {"mwater05.urb", "", int32_t(0x00000000), int32_t(0x5813EB42)},
    {"mwater06.des", "", int32_t(0x00000000), int32_t(0x6D64FCB1)},
    {"mwater06.sno", "", int32_t(0x00000000), int32_t(0x83F8CCC0)},
    {"mwater06.tem", "", int32_t(0x00000000), int32_t(0x8B4D62A2)},
    {"mwater06.urb", "", int32_t(0x00000000), int32_t(0x1FB39192)},
    {"mwater07.des", "", int32_t(0x00000000), int32_t(0x5004D501)},
    {"mwater07.sno", "", int32_t(0x00000000), int32_t(0xBE98E570)},
    {"mwater07.tem", "", int32_t(0x00000000), int32_t(0xB62D4B12)},
    {"mwater07.urb", "", int32_t(0x00000000), int32_t(0x22D3B822)},
    {"mwater08.des", "", int32_t(0x00000000), int32_t(0xD25442D0)},
    {"mwater08.sno", "", int32_t(0x00000000), int32_t(0x3CC872A1)},
    {"mwater08.tem", "", int32_t(0x00000000), int32_t(0x347DDCC3)},
    {"mwater08.urb", "", int32_t(0x00000000), int32_t(0xA0832FF3)},
    {"mwater09.des", "", int32_t(0x00000000), int32_t(0xEF346B60)},
    {"mwater09.sno", "", int32_t(0x00000000), int32_t(0x01A85B11)},
    {"mwater09.tem", "", int32_t(0x00000000), int32_t(0x091DF573)},
    {"mwater09.urb", "", int32_t(0x00000000), int32_t(0x9DE30643)},
    {"mwater10.des", "", int32_t(0x00000000), int32_t(0x2978DAB4)},
    {"mwater10.sno", "", int32_t(0x00000000), int32_t(0xC7E4EAC5)},
    {"mwater10.tem", "", int32_t(0x00000000), int32_t(0xCF5144A7)},
    {"mwater10.urb", "", int32_t(0x00000000), int32_t(0x5BAFB797)},
    {"mwater11.des", "", int32_t(0x00000000), int32_t(0x1418F304)},
    {"mwater11.sno", "", int32_t(0x00000000), int32_t(0xFA84C375)},
    {"mwater11.tem", "", int32_t(0x00000000), int32_t(0xF2316D17)},
    {"mwater11.urb", "", int32_t(0x00000000), int32_t(0x66CF9E27)},
    {"mwater12.des", "", int32_t(0x00000000), int32_t(0x53B889D4)},
    {"mwater12.sno", "", int32_t(0x00000000), int32_t(0xBD24B9A5)},
    {"mwater12.tem", "", int32_t(0x00000000), int32_t(0xB59117C7)},
    {"mwater12.urb", "", int32_t(0x00000000), int32_t(0x216FE4F7)},
    {"mwater13.des", "", int32_t(0x00000000), int32_t(0x6ED8A064)},
    {"mwater13.sno", "", int32_t(0x00000000), int32_t(0x80449015)},
    {"mwater13.tem", "", int32_t(0x00000000), int32_t(0x88F13E77)},
    {"mwater13.urb", "", int32_t(0x00000000), int32_t(0x1C0FCD47)},
    {"mwater14.des", "", int32_t(0x00000000), int32_t(0xDCF87C74)},
    {"mwater14.sno", "", int32_t(0x00000000), int32_t(0x32644C05)},
    {"mwater14.tem", "", int32_t(0x00000000), int32_t(0x3AD1E267)},
    {"mwater14.urb", "", int32_t(0x00000000), int32_t(0xAE2F1157)},
    {"mwb-01.des", "", int32_t(0x00000000), int32_t(0x80D18290)},
    {"mwb-01.sno", "", int32_t(0x00000000), int32_t(0x07FECD9F)},
    {"mwb-01.tem", "", int32_t(0x00000000), int32_t(0xF6899B68)},
    {"mwb-01.urb", "", int32_t(0x00000000), int32_t(0x8EA81F04)},
    {"mwb-02.des", "", int32_t(0x00000000), int32_t(0xB139980D)},
    {"mwb-02.sno", "", int32_t(0x00000000), int32_t(0x3616D702)},
    {"mwb-02.tem", "", int32_t(0x00000000), int32_t(0xC76181F5)},
    {"mwb-02.urb", "", int32_t(0x00000000), int32_t(0xBF400599)},
    {"mwb-03.des", "", int32_t(0x00000000), int32_t(0x174E93B9)},
    {"mwb-03.sno", "", int32_t(0x00000000), int32_t(0x9061DCB6)},
    {"mwb-03.tem", "", int32_t(0x00000000), int32_t(0x61168A41)},
    {"mwb-03.urb", "", int32_t(0x00000000), int32_t(0x19370E2D)},
    {"mwb-04.des", "", int32_t(0x00000000), int32_t(0xD2E9AD37)},
    {"mwb-04.sno", "", int32_t(0x00000000), int32_t(0x55C6E238)},
    {"mwb-04.tem", "", int32_t(0x00000000), int32_t(0xA4B1B4CF)},
    {"mwb-04.urb", "", int32_t(0x00000000), int32_t(0xDC9030A3)},
    {"mwc-01.des", "", int32_t(0x00000000), int32_t(0x6F13E9AE)},
    {"mwc-01.sno", "", int32_t(0x00000000), int32_t(0xE83CA6A1)},
    {"mwc-01.tem", "", int32_t(0x00000000), int32_t(0x194BF056)},
    {"mwc-01.urb", "", int32_t(0x00000000), int32_t(0x616A743A)},
    {"mwc-02.des", "", int32_t(0x00000000), int32_t(0x5EFBF333)},
    {"mwc-02.sno", "", int32_t(0x00000000), int32_t(0xD9D4BC3C)},
    {"mwc-02.tem", "", int32_t(0x00000000), int32_t(0x28A3EACB)},
    {"mwc-02.urb", "", int32_t(0x00000000), int32_t(0x50826EA7)},
    {"mwc-03.des", "", int32_t(0x00000000), int32_t(0xF88CF887)},
    {"mwc-03.sno", "", int32_t(0x00000000), int32_t(0x7FA3B788)},
    {"mwc-03.tem", "", int32_t(0x00000000), int32_t(0x8ED4E17F)},
    {"mwc-03.urb", "", int32_t(0x00000000), int32_t(0xF6F56513)},
    {"mwc-04.des", "", int32_t(0x00000000), int32_t(0x3D2BC609)},
    {"mwc-04.sno", "", int32_t(0x00000000), int32_t(0xBA048906)},
    {"mwc-04.tem", "", int32_t(0x00000000), int32_t(0x4B73DFF1)},
    {"mwc-04.urb", "", int32_t(0x00000000), int32_t(0x33525B9D)},
    {"mwcave01.des", "", int32_t(0x00000000), int32_t(0x6DAB632A)},
    {"mwcave01.tem", "", int32_t(0x00000000), int32_t(0x8B82FD39)},
    {"mwcave02.des", "", int32_t(0x00000000), int32_t(0x2A0B19FA)},
    {"mwcave02.tem", "", int32_t(0x00000000), int32_t(0xCC2287E9)},
    {"mwcave03.des", "", int32_t(0x00000000), int32_t(0x176B304A)},
    {"mwcave03.tem", "", int32_t(0x00000000), int32_t(0xF142AE59)},
    {"mwcave04.des", "", int32_t(0x00000000), int32_t(0xA54BEC5A)},
    {"mwcave04.tem", "", int32_t(0x00000000), int32_t(0x43627249)},
    {"mwcave05.des", "", int32_t(0x00000000), int32_t(0x982BC5EA)},
    {"mwcave06.des", "", int32_t(0x00000000), int32_t(0xDF8BBF3A)},
    {"mwcave07.des", "", int32_t(0x00000000), int32_t(0xE2EB968A)},
    {"mwcave08.des", "", int32_t(0x00000000), int32_t(0x60BB015B)},
    {"mwclfa01.urb", "", int32_t(0x00000000), int32_t(0x66C7FC66)},
    {"mwclfa02.urb", "", int32_t(0x00000000), int32_t(0x216786B6)},
    {"mwclfa03.urb", "", int32_t(0x00000000), int32_t(0x1C07AF06)},
    {"mwclfa04.urb", "", int32_t(0x00000000), int32_t(0xAE277316)},
    {"mwclfa05.urb", "", int32_t(0x00000000), int32_t(0x93475AA6)},
    {"mwclfa06.urb", "", int32_t(0x00000000), int32_t(0xD4E72076)},
    {"mwclfa07.urb", "", int32_t(0x00000000), int32_t(0xE98709C6)},
    {"mwclfa08.urb", "", int32_t(0x00000000), int32_t(0x6BD79E17)},
    {"mwclfa09.urb", "", int32_t(0x00000000), int32_t(0x56B7B7A7)},
    {"mwclfa10.urb", "", int32_t(0x00000000), int32_t(0x90FB0673)},
    {"mwclfa11.urb", "", int32_t(0x00000000), int32_t(0xAD9B2FC3)},
    {"mwclfa12.urb", "", int32_t(0x00000000), int32_t(0xEA3B5513)},
    {"mwclfa13.urb", "", int32_t(0x00000000), int32_t(0xD75B7CA3)},
    {"mwclfa14.urb", "", int32_t(0x00000000), int32_t(0x657BA0B3)},
    {"mwclfa15.urb", "", int32_t(0x00000000), int32_t(0x581B8903)},
    {"mwclfa16.urb", "", int32_t(0x00000000), int32_t(0x1FBBF3D3)},
    {"mwclfa17.urb", "", int32_t(0x00000000), int32_t(0x22DBDA63)},
    {"mwclfa18.urb", "", int32_t(0x00000000), int32_t(0xA08B4DB2)},
    {"mwclfa19.urb", "", int32_t(0x00000000), int32_t(0x9DEB6402)},
    {"mwclfa20.urb", "", int32_t(0x00000000), int32_t(0x166F74DD)},
    {"mwclfa21.urb", "", int32_t(0x00000000), int32_t(0x2B0F5D6D)},
    {"mwclfa22.urb", "", int32_t(0x00000000), int32_t(0x6CAF27BD)},
    {"mwclfa23.urb", "", int32_t(0x00000000), int32_t(0x51CF0E0D)},
    {"mwclfa24.urb", "", int32_t(0x00000000), int32_t(0xE3EFD21D)},
    {"mwclfa25.urb", "", int32_t(0x00000000), int32_t(0xDE8FFBAD)},
    {"mwclfa26.urb", "", int32_t(0x00000000), int32_t(0x992F817D)},
    {"mwclfb01.urb", "", int32_t(0x00000000), int32_t(0x572FE6FB)},
    {"mwclfb02.urb", "", int32_t(0x00000000), int32_t(0x108F9C2B)},
    {"mwclfb03.urb", "", int32_t(0x00000000), int32_t(0x2DEFB59B)},
    {"mwclfb04.urb", "", int32_t(0x00000000), int32_t(0x9FCF698B)},
    {"mwclfb05.urb", "", int32_t(0x00000000), int32_t(0xA2AF403B)},
    {"mwclfb06.urb", "", int32_t(0x00000000), int32_t(0xE50F3AEB)},
    {"mwclfb07.urb", "", int32_t(0x00000000), int32_t(0xD86F135B)},
    {"mwclfb08.urb", "", int32_t(0x00000000), int32_t(0x5A3F848A)},
    {"mwclfb09.urb", "", int32_t(0x00000000), int32_t(0x675FAD3A)},
    {"mwclfb10.urb", "", int32_t(0x00000000), int32_t(0xA1131CEE)},
    {"mwclfb11.urb", "", int32_t(0x00000000), int32_t(0x9C73355E)},
    {"mwclfb12.urb", "", int32_t(0x00000000), int32_t(0xDBD34F8E)},
    {"mwclfx01.sno", "", int32_t(0x00000000), int32_t(0x08CA7829)},
    {"mwclfx01.ubn", "", int32_t(0x00000000), int32_t(0xD7F57B01)},
    {"mwclfx02.sno", "", int32_t(0x00000000), int32_t(0x4F6A02F9)},
    {"mwclfx02.ubn", "", int32_t(0x00000000), int32_t(0x905501D1)},
    {"mwclfx03.sno", "", int32_t(0x00000000), int32_t(0x720A2B49)},
    {"mwclfx03.ubn", "", int32_t(0x00000000), int32_t(0xAD352861)},
    {"mwclfx04.sno", "", int32_t(0x00000000), int32_t(0xC02AF759)},
    {"mwclfx04.ubn", "", int32_t(0x00000000), int32_t(0x1F15F471)},
    {"mwclfx05.sno", "", int32_t(0x00000000), int32_t(0xFD4ADEE9)},
    {"mwclfx05.ubn", "", int32_t(0x00000000), int32_t(0x2275DDC1)},
    {"mwclfx06.sno", "", int32_t(0x00000000), int32_t(0xBAEAA439)},
    {"mwclfx06.ubn", "", int32_t(0x00000000), int32_t(0x65D5A711)},
    {"mwclfx07.sno", "", int32_t(0x00000000), int32_t(0x878A8D89)},
    {"mwclfx07.ubn", "", int32_t(0x00000000), int32_t(0x58B58EA1)},
    {"mwclfx08.sno", "", int32_t(0x00000000), int32_t(0x05DA1A58)},
    {"mwclfx08.ubn", "", int32_t(0x00000000), int32_t(0xDAE51970)},
    {"mwclfx09.sno", "", int32_t(0x00000000), int32_t(0x38BA33E8)},
    {"mwclfx09.ubn", "", int32_t(0x00000000), int32_t(0xE78530C0)},
    {"mwclfx10.sno", "", int32_t(0x00000000), int32_t(0xFEF6823C)},
    {"mwclfx10.ubn", "", int32_t(0x00000000), int32_t(0x21C98114)},
    {"mwclfx11.sno", "", int32_t(0x00000000), int32_t(0xC396AB8C)},
    {"mwclfx11.ubn", "", int32_t(0x00000000), int32_t(0x1CA9A8A4)},
    {"mwclfx12.sno", "", int32_t(0x00000000), int32_t(0x8436D15C)},
    {"mwclfx12.ubn", "", int32_t(0x00000000), int32_t(0x5B09D274)},
    {"mwclfx13.sno", "", int32_t(0x00000000), int32_t(0xB956F8EC)},
    {"mwclfx13.ubn", "", int32_t(0x00000000), int32_t(0x6669FBC4)},
    {"mwclfx14.sno", "", int32_t(0x00000000), int32_t(0x0B7624FC)},
    {"mwclfx14.ubn", "", int32_t(0x00000000), int32_t(0xD44927D4)},
    {"mwclfx15.sno", "", int32_t(0x00000000), int32_t(0x36160D4C)},
    {"mwclfx15.ubn", "", int32_t(0x00000000), int32_t(0xE9290E64)},
    {"mwclfx16.sno", "", int32_t(0x00000000), int32_t(0x71B6779C)},
    {"mwclfx16.ubn", "", int32_t(0x00000000), int32_t(0xAE8974B4)},
    {"mwclfx17.sno", "", int32_t(0x00000000), int32_t(0x4CD65E2C)},
    {"mwclfx17.ubn", "", int32_t(0x00000000), int32_t(0x93E95D04)},
    {"mwclfx18.sno", "", int32_t(0x00000000), int32_t(0xCE86C9FD)},
    {"mwclfx18.ubn", "", int32_t(0x00000000), int32_t(0x11B9CAD5)},
    {"mwclfx19.sno", "", int32_t(0x00000000), int32_t(0xF3E6E04D)},
    {"mwclfx19.ubn", "", int32_t(0x00000000), int32_t(0x2CD9E365)},
    {"mwclfx20.sno", "", int32_t(0x00000000), int32_t(0x7862F092)},
    {"mwclfx20.ubn", "", int32_t(0x00000000), int32_t(0xA75DF3BA)},
    {"mwclfx21.sno", "", int32_t(0x00000000), int32_t(0x4502D922)},
    {"mwclfx21.ubn", "", int32_t(0x00000000), int32_t(0x9A3DDA0A)},
    {"mwclfx22.sno", "", int32_t(0x00000000), int32_t(0x02A2A3F2)},
    {"mwclfx22.ubn", "", int32_t(0x00000000), int32_t(0xDD9DA0DA)},
    {"mwclfx23.sno", "", int32_t(0x00000000), int32_t(0x3FC28A42)},
    {"mwclfx23.ubn", "", int32_t(0x00000000), int32_t(0xE0FD896A)},
    {"mwclfx24.sno", "", int32_t(0x00000000), int32_t(0x8DE25652)},
    {"mwclfx24.ubn", "", int32_t(0x00000000), int32_t(0x52DD557A)},
    {"mwclfx25.sno", "", int32_t(0x00000000), int32_t(0xB0827FE2)},
    {"mwclfx25.ubn", "", int32_t(0x00000000), int32_t(0x6FBD7CCA)},
    {"mwclfx26.sno", "", int32_t(0x00000000), int32_t(0xF7220532)},
    {"mwclfx26.ubn", "", int32_t(0x00000000), int32_t(0x281D061A)},
    {"mwclfx27.sno", "", int32_t(0x00000000), int32_t(0xCA422C82)},
    {"mwclfx27.ubn", "", int32_t(0x00000000), int32_t(0x157D2FAA)},
    {"mwclfx28.sno", "", int32_t(0x00000000), int32_t(0x4812BB53)},
    {"mwclfx28.ubn", "", int32_t(0x00000000), int32_t(0x972DB87B)},
    {"mwclif01.des", "", int32_t(0x00000000), int32_t(0x0897BD67)},
    {"mwclif01.sno", "", int32_t(0x00000000), int32_t(0xE60B8D16)},
    {"mwclif01.tem", "", int32_t(0x00000000), int32_t(0xEEBE2374)},
    {"mwclif01.urb", "", int32_t(0x00000000), int32_t(0x7A40D044)},
    {"mwclif02.des", "", int32_t(0x00000000), int32_t(0x4F37C7B7)},
    {"mwclif02.sno", "", int32_t(0x00000000), int32_t(0xA1ABF7C6)},
    {"mwclif02.tem", "", int32_t(0x00000000), int32_t(0xA91E59A4)},
    {"mwclif02.urb", "", int32_t(0x00000000), int32_t(0x3DE0AA94)},
    {"mwclif03.des", "", int32_t(0x00000000), int32_t(0x7257EE07)},
    {"mwclif03.sno", "", int32_t(0x00000000), int32_t(0x9CCBDE76)},
    {"mwclif03.tem", "", int32_t(0x00000000), int32_t(0x947E7014)},
    {"mwclif03.urb", "", int32_t(0x00000000), int32_t(0x00808324)},
    {"mwclif04.des", "", int32_t(0x00000000), int32_t(0xC0773217)},
    {"mwclif04.sno", "", int32_t(0x00000000), int32_t(0x2EEB0266)},
    {"mwclif04.tem", "", int32_t(0x00000000), int32_t(0x265EAC04)},
    {"mwclif04.urb", "", int32_t(0x00000000), int32_t(0xB2A05F34)},
    {"mwclif05.des", "", int32_t(0x00000000), int32_t(0xFD171BA7)},
    {"mwclif05.sno", "", int32_t(0x00000000), int32_t(0x138B2BD6)},
    {"mwclif05.tem", "", int32_t(0x00000000), int32_t(0x1B3E85B4)},
    {"mwclif05.urb", "", int32_t(0x00000000), int32_t(0x8FC07684)},
    {"mwclif06.des", "", int32_t(0x00000000), int32_t(0xBAB76177)},
    {"mwclif06.sno", "", int32_t(0x00000000), int32_t(0x542B5106)},
    {"mwclif06.tem", "", int32_t(0x00000000), int32_t(0x5C9EFF64)},
    {"mwclif06.urb", "", int32_t(0x00000000), int32_t(0xC8600C54)},
    {"mwclif07.des", "", int32_t(0x00000000), int32_t(0x87D748C7)},
    {"mwclif07.sno", "", int32_t(0x00000000), int32_t(0x694B78B6)},
    {"mwclif07.tem", "", int32_t(0x00000000), int32_t(0x61FED6D4)},
    {"mwclif07.urb", "", int32_t(0x00000000), int32_t(0xF50025E4)},
    {"mwclif08.des", "", int32_t(0x00000000), int32_t(0x0587DF16)},
    {"mwclif08.sno", "", int32_t(0x00000000), int32_t(0xEB1BEF67)},
    {"mwclif08.tem", "", int32_t(0x00000000), int32_t(0xE3AE4105)},
    {"mwclif08.urb", "", int32_t(0x00000000), int32_t(0x7750B235)},
    {"mwclif09.des", "", int32_t(0x00000000), int32_t(0x38E7F6A6)},
    {"mwclif09.sno", "", int32_t(0x00000000), int32_t(0xD67BC6D7)},
    {"mwclif09.tem", "", int32_t(0x00000000), int32_t(0xDECE68B5)},
    {"mwclif09.urb", "", int32_t(0x00000000), int32_t(0x4A309B85)},
    {"mwclif10.des", "", int32_t(0x00000000), int32_t(0xFEAB4772)},
    {"mwclif10.sno", "", int32_t(0x00000000), int32_t(0x10377703)},
    {"mwclif10.tem", "", int32_t(0x00000000), int32_t(0x1882D961)},
    {"mwclif10.urb", "", int32_t(0x00000000), int32_t(0x8C7C2A51)},
    {"mwclif11.des", "", int32_t(0x00000000), int32_t(0xC3CB6EC2)},
    {"mwclif11.sno", "", int32_t(0x00000000), int32_t(0x2D575EB3)},
    {"mwclif11.tem", "", int32_t(0x00000000), int32_t(0x25E2F0D1)},
    {"mwclif11.urb", "", int32_t(0x00000000), int32_t(0xB11C03E1)},
    {"mwclif12.des", "", int32_t(0x00000000), int32_t(0x846B1412)},
    {"mwclif12.sno", "", int32_t(0x00000000), int32_t(0x6AF72463)},
    {"mwclif12.tem", "", int32_t(0x00000000), int32_t(0x62428A01)},
    {"mwclif12.urb", "", int32_t(0x00000000), int32_t(0xF6BC7931)},
    {"mwclif13.des", "", int32_t(0x00000000), int32_t(0xB90B3DA2)},
    {"mwclif13.sno", "", int32_t(0x00000000), int32_t(0x57970DD3)},
    {"mwclif13.tem", "", int32_t(0x00000000), int32_t(0x5F22A3B1)},
    {"mwclif13.urb", "", int32_t(0x00000000), int32_t(0xCBDC5081)},
    {"mwclif14.des", "", int32_t(0x00000000), int32_t(0x0B2BE1B2)},
    {"mwclif14.sno", "", int32_t(0x00000000), int32_t(0xE5B7D1C3)},
    {"mwclif14.tem", "", int32_t(0x00000000), int32_t(0xED027FA1)},
    {"mwclif14.urb", "", int32_t(0x00000000), int32_t(0x79FC8C91)},
    {"mwclif15.des", "", int32_t(0x00000000), int32_t(0x364BC802)},
    {"mwclif15.sno", "", int32_t(0x00000000), int32_t(0xD8D7F873)},
    {"mwclif15.tem", "", int32_t(0x00000000), int32_t(0xD0625611)},
    {"mwclif15.urb", "", int32_t(0x00000000), int32_t(0x449CA521)},
    {"mwclif16.des", "", int32_t(0x00000000), int32_t(0x71EBB2D2)},
    {"mwclif16.sno", "", int32_t(0x00000000), int32_t(0x9F7782A3)},
    {"mwclif16.tem", "", int32_t(0x00000000), int32_t(0x97C22CC1)},
    {"mwclif16.urb", "", int32_t(0x00000000), int32_t(0x033CDFF1)},
    {"mwclif17.des", "", int32_t(0x00000000), int32_t(0x4C8B9B62)},
    {"mwclif17.sno", "", int32_t(0x00000000), int32_t(0xA217AB13)},
    {"mwclif17.tem", "", int32_t(0x00000000), int32_t(0xAAA20571)},
    {"mwclif17.urb", "", int32_t(0x00000000), int32_t(0x3E5CF641)},
    {"mwclif18.des", "", int32_t(0x00000000), int32_t(0xCEDB0CB3)},
    {"mwclif18.sno", "", int32_t(0x00000000), int32_t(0x20473CC2)},
    {"mwclif18.tem", "", int32_t(0x00000000), int32_t(0x28F292A0)},
    {"mwclif18.urb", "", int32_t(0x00000000), int32_t(0xBC0C6190)},
    {"mwclif19.des", "", int32_t(0x00000000), int32_t(0xF3BB2503)},
    {"mwclif19.sno", "", int32_t(0x00000000), int32_t(0x1D271572)},
    {"mwclif19.tem", "", int32_t(0x00000000), int32_t(0x1592BB10)},
    {"mwclif19.urb", "", int32_t(0x00000000), int32_t(0x816C4820)},
    {"mwclif20.des", "", int32_t(0x00000000), int32_t(0x783F35DC)},
    {"mwclif20.sno", "", int32_t(0x00000000), int32_t(0x96A305AD)},
    {"mwclif20.tem", "", int32_t(0x00000000), int32_t(0x9E16ABCF)},
    {"mwclif20.urb", "", int32_t(0x00000000), int32_t(0x0AE858FF)},
    {"mwclif21.des", "", int32_t(0x00000000), int32_t(0x455F1C6C)},
    {"mwclif21.sno", "", int32_t(0x00000000), int32_t(0xABC32C1D)},
    {"mwclif21.tem", "", int32_t(0x00000000), int32_t(0xA376827F)},
    {"mwclif21.urb", "", int32_t(0x00000000), int32_t(0x3788714F)},
    {"mwclif22.des", "", int32_t(0x00000000), int32_t(0x02FF66BC)},
    {"mwclif22.sno", "", int32_t(0x00000000), int32_t(0xEC6356CD)},
    {"mwclif22.tem", "", int32_t(0x00000000), int32_t(0xE4D6F8AF)},
    {"mwclif22.urb", "", int32_t(0x00000000), int32_t(0x70280B9F)},
    {"mwclif23.des", "", int32_t(0x00000000), int32_t(0x3F9F4F0C)},
    {"mwclif23.sno", "", int32_t(0x00000000), int32_t(0xD1037F7D)},
    {"mwclif23.tem", "", int32_t(0x00000000), int32_t(0xD9B6D11F)},
    {"mwclif23.urb", "", int32_t(0x00000000), int32_t(0x4D48222F)},
    {"mwclif24.des", "", int32_t(0x00000000), int32_t(0x8DBF931C)},
    {"mwclif24.sno", "", int32_t(0x00000000), int32_t(0x6323A36D)},
    {"mwclif24.tem", "", int32_t(0x00000000), int32_t(0x6B960D0F)},
    {"mwclif24.urb", "", int32_t(0x00000000), int32_t(0xFF68FE3F)},
    {"mwclif25.des", "", int32_t(0x00000000), int32_t(0xB0DFBAAC)},
    {"mwclif25.sno", "", int32_t(0x00000000), int32_t(0x5E438ADD)},
    {"mwclif25.tem", "", int32_t(0x00000000), int32_t(0x56F624BF)},
    {"mwclif25.urb", "", int32_t(0x00000000), int32_t(0xC208D78F)},
    {"mwclif26.des", "", int32_t(0x00000000), int32_t(0xF77FC07C)},
    {"mwclif26.sno", "", int32_t(0x00000000), int32_t(0x19E3F00D)},
    {"mwclif26.tem", "", int32_t(0x00000000), int32_t(0x11565E6F)},
    {"mwclif26.urb", "", int32_t(0x00000000), int32_t(0x85A8AD5F)},
    {"mwclif27.des", "", int32_t(0x00000000), int32_t(0xCA1FE9CC)},
    {"mwclif27.sno", "", int32_t(0x00000000), int32_t(0x2483D9BD)},
    {"mwclif27.tem", "", int32_t(0x00000000), int32_t(0x2C3677DF)},
    {"mwclif27.urb", "", int32_t(0x00000000), int32_t(0xB8C884EF)},
    {"mwclif28.des", "", int32_t(0x00000000), int32_t(0x484F7E1D)},
    {"mwclif28.sno", "", int32_t(0x00000000), int32_t(0xA6D34E6C)},
    {"mwclif28.tem", "", int32_t(0x00000000), int32_t(0xAE66E00E)},
    {"mwclif28.urb", "", int32_t(0x00000000), int32_t(0x3A98133E)},
    {"mwd-01.des", "", int32_t(0x00000000), int32_t(0x8DCFF2D7)},
    {"mwd-01.sno", "", int32_t(0x00000000), int32_t(0x0AE0BDD8)},
    {"mwd-01.tem", "", int32_t(0x00000000), int32_t(0xFB97EB2F)},
    {"mwd-01.urb", "", int32_t(0x00000000), int32_t(0x83B66F43)},
    {"mwd-02.des", "", int32_t(0x00000000), int32_t(0xBC27E84A)},
    {"mwd-02.sno", "", int32_t(0x00000000), int32_t(0x3B08A745)},
    {"mwd-02.tem", "", int32_t(0x00000000), int32_t(0xCA7FF1B2)},
    {"mwd-02.urb", "", int32_t(0x00000000), int32_t(0xB25E75DE)},
    {"mwd-03.des", "", int32_t(0x00000000), int32_t(0x1A50E3FE)},
    {"mwd-03.sno", "", int32_t(0x00000000), int32_t(0x9D7FACF1)},
    {"mwd-03.tem", "", int32_t(0x00000000), int32_t(0x6C08FA06)},
    {"mwd-03.urb", "", int32_t(0x00000000), int32_t(0x14297E6A)},
    {"mwd-04.des", "", int32_t(0x00000000), int32_t(0xDFF7DD70)},
    {"mwd-04.sno", "", int32_t(0x00000000), int32_t(0x58D8927F)},
    {"mwd-04.tem", "", int32_t(0x00000000), int32_t(0xA9AFC488)},
    {"mwd-04.urb", "", int32_t(0x00000000), int32_t(0xD18E40E4)},
    {"mwmn.shp", "unit: mutant soldier/woman", int32_t(0x00000000), int32_t(0x1811FCEB)},
    {"mwrench1.aud", "mech: i'll get my wrench", int32_t(0xBC2F24FF), int32_t(0x00000000)},
    {"mwslop01.des", "", int32_t(0x00000000), int32_t(0xED589CFC)},
    {"mwslop02.des", "", int32_t(0x00000000), int32_t(0xAAF8E62C)},
    {"mwslop03.des", "", int32_t(0x00000000), int32_t(0x9798CF9C)},
    {"mwslop04.des", "", int32_t(0x00000000), int32_t(0x25B8138C)},
    {"myeehaw1.aud", "mech: yeee ha", int32_t(0xBC1928F3), int32_t(0x00000000)},
    {"myes1.aud", "yes", int32_t(0xF797C1DB), int32_t(0x00000000)},
    {"myessir1.aud", "medic: yes sir!", int32_t(0xF40F3909), int32_t(0x00000000)},
    {"myesyes1.aud", "yes yes yes", int32_t(0xF4113115), int32_t(0x00000000)},
    {"myriad1.aud", "", int32_t(0x81F042F8), int32_t(0x00000000)},
    {"mystitm1.aud", "", int32_t(0xF83D4EF5), int32_t(0x00000000)},
    {"n_logo_l.vqa", "-", int32_t(0x00000000), int32_t(0xB70BF689)},
    {"n_logo_w.vqa", "-", int32_t(0x00000000), int32_t(0xA03B501A)},
    {"naapwr.shp", "-", int32_t(0x00000000), int32_t(0x67FA6F18)},
    {"naapwr_a.shp", "-", int32_t(0x00000000), int32_t(0xB8555CC1)},
    {"naapwrmk.shp", "-", int32_t(0x00000000), int32_t(0xBCFBE7F0)},
    {"naback.pcx", "", int32_t(0x00000000), int32_t(0x34A11104)},
    {"nabackh.pcx", "", int32_t(0x00000000), int32_t(0xC8B9E343)},
    {"nabnkr.shp", "", int32_t(0x00000000), int32_t(0xC3DB699C)},
    {"nabnkrmk.shp", "", int32_t(0x00000000), int32_t(0x18DAE174)},
    {"naclon.shp", "", int32_t(0x00000000), int32_t(0x26DBD264)},
    {"naclon_a.shp", "", int32_t(0x00000000), int32_t(0xF974E1BD)},
    {"naclonmk.shp", "", int32_t(0x00000000), int32_t(0xFDDA5A8C)},
    {"nacnst.shp", "", int32_t(0x00000000), int32_t(0xE0971D06)},
    {"nacnst_a.shp", "", int32_t(0x00000000), int32_t(0x3F382EDF)},
    {"nacnst_b.shp", "", int32_t(0x00000000), int32_t(0x7898540F)},
    {"nacnst_c.shp", "", int32_t(0x00000000), int32_t(0x45F87DBF)},
    {"nacnstdm.shp", "", int32_t(0x00000000), int32_t(0x93D93186)},
    {"nacnstmk.shp", "", int32_t(0x00000000), int32_t(0x3B9695EE)},
    {"nadept.shp", "", int32_t(0x00000000), int32_t(0x0E919F41)},
    {"nadept_b.shp", "", int32_t(0x00000000), int32_t(0x969ED648)},
    {"nadept_c.shp", "", int32_t(0x00000000), int32_t(0xABFEFFF8)},
    {"nadeptbb.shp", "", int32_t(0x00000000), int32_t(0x29D6C70D)},
    {"nadeptmk.shp", "", int32_t(0x00000000), int32_t(0xD59017A9)},
    {"naflak.shp", "", int32_t(0x00000000), int32_t(0x874024B5)},
    {"naflakmk.shp", "", int32_t(0x00000000), int32_t(0x5C41AC5D)},
    {"nafnce.shp", "-", int32_t(0x00000000), int32_t(0xBBAC7013)},
    {"nagate_a.shp", "-", int32_t(0x00000000), int32_t(0x2206DF17)},
    {"nagate_b.shp", "-", int32_t(0x00000000), int32_t(0x65A6A5C7)},
    {"nagateza.shp", "-", int32_t(0x00000000), int32_t(0x72CB4EA4)},
    {"nagatezb.shp", "-", int32_t(0x00000000), int32_t(0x356B3474)},
    {"nagr01.shp", "", int32_t(0x00000000), int32_t(0x2462C803)},
    {"nagr02.shp", "", int32_t(0x00000000), int32_t(0x158AD29E)},
    {"nagr03.shp", "", int32_t(0x00000000), int32_t(0xB3FDD92A)},
    {"nagr04.shp", "", int32_t(0x00000000), int32_t(0x765AE7A4)},
    {"nagr05.shp", "", int32_t(0x00000000), int32_t(0xD02DEC10)},
    {"nagr06.shp", "", int32_t(0x00000000), int32_t(0xE1C5F68D)},
    {"nagr07.shp", "", int32_t(0x00000000), int32_t(0x47B2FD39)},
    {"nagr08.shp", "", int32_t(0x00000000), int32_t(0xB1FA8DD0)},
    {"nagr09.shp", "", int32_t(0x00000000), int32_t(0x178D8664)},
    {"nagr10.shp", "", int32_t(0x00000000), int32_t(0x4EBFC329)},
    {"nagr11.shp", "", int32_t(0x00000000), int32_t(0xE8C8C89D)},
    {"nagr12.shp", "", int32_t(0x00000000), int32_t(0xD920D200)},
    {"nagr13.shp", "", int32_t(0x00000000), int32_t(0x7F57D9B4)},
    {"nagr14.shp", "", int32_t(0x00000000), int32_t(0xBAF0E73A)},
    {"nagr15.shp", "", int32_t(0x00000000), int32_t(0x1C87EC8E)},
    {"nagr16.shp", "", int32_t(0x00000000), int32_t(0x2D6FF613)},
    {"nagr17.shp", "", int32_t(0x00000000), int32_t(0x8B18FDA7)},
    {"nagr18.shp", "", int32_t(0x00000000), int32_t(0x7D508D4E)},
    {"nagr19.shp", "", int32_t(0x00000000), int32_t(0xDB2786FA)},
    {"nagr20.shp", "", int32_t(0x00000000), int32_t(0xC030C4CA)},
    {"nagr21.shp", "", int32_t(0x00000000), int32_t(0x6647CF7E)},
    {"nagr22.shp", "", int32_t(0x00000000), int32_t(0x57AFD5E3)},
    {"nagr23.shp", "", int32_t(0x00000000), int32_t(0xF1D8DE57)},
    {"nagr24.shp", "", int32_t(0x00000000), int32_t(0x347FE0D9)},
    {"nagr25.shp", "", int32_t(0x00000000), int32_t(0x9208EB6D)},
    {"nagr26.shp", "", int32_t(0x00000000), int32_t(0xA3E0F1F0)},
    {"nagr27.shp", "", int32_t(0x00000000), int32_t(0x0597FA44)},
    {"nagr28.shp", "", int32_t(0x00000000), int32_t(0xF3DF8AAD)},
    {"nagr29.shp", "", int32_t(0x00000000), int32_t(0x55A88119)},
    {"nagr30.shp", "", int32_t(0x00000000), int32_t(0x0C9AC454)},
    {"nahand.shp", "-", int32_t(0x00000000), int32_t(0x47AE9114)},
    {"nahand_a.shp", "-", int32_t(0x00000000), int32_t(0x9801A2CD)},
    {"nahand_b.shp", "-", int32_t(0x00000000), int32_t(0xDFA1D81D)},
    {"nahandmk.shp", "-", int32_t(0x00000000), int32_t(0x9CAF19FC)},
    {"nahpad.shp", "-", int32_t(0x00000000), int32_t(0x2535D58A)},
    {"nahpad_a.shp", "-", int32_t(0x00000000), int32_t(0xFA9AE653)},
    {"nahpadbb.shp", "-", int32_t(0x00000000), int32_t(0x02728DC6)},
    {"nahpadmk.shp", "-", int32_t(0x00000000), int32_t(0xFE345D62)},
    {"naindp.shp", "", int32_t(0x00000000), int32_t(0x758491EE)},
    {"naindp_a.shp", "", int32_t(0x00000000), int32_t(0xAA2BA237)},
    {"naindp_b.shp", "", int32_t(0x00000000), int32_t(0xED8BD8E7)},
    {"naindpmk.shp", "", int32_t(0x00000000), int32_t(0xAE851906)},
    {"nairon.shp", "", int32_t(0x00000000), int32_t(0x55FBDB4E)},
    {"nairon_a.shp", "", int32_t(0x00000000), int32_t(0x8A54E897)},
    {"nairon_e.shp", "", int32_t(0x00000000), int32_t(0x7FD44E57)},
    {"nairon_f.shp", "", int32_t(0x00000000), int32_t(0x38743487)},
    {"nairon_h.shp", "", int32_t(0x00000000), int32_t(0x87448AE6)},
    {"naironmk.shp", "", int32_t(0x00000000), int32_t(0x8EFA53A6)},
    {"nalasr.shp", "-", int32_t(0x00000000), int32_t(0xADF5BC60)},
    {"nalasrmk.shp", "-", int32_t(0x00000000), int32_t(0x76F43488)},
    {"namisl.shp", "-", int32_t(0x00000000), int32_t(0xCE0E92D5)},
    {"namisl_a.shp", "-", int32_t(0x00000000), int32_t(0x11A1A10C)},
    {"namisl_b.shp", "-", int32_t(0x00000000), int32_t(0x5601DBDC)},
    {"namisl_e.shp", "", int32_t(0x00000000), int32_t(0xE42107CC)},
    {"namisl_f.shp", "", int32_t(0x00000000), int32_t(0xA3817D1C)},
    {"namisl_g.shp", "", int32_t(0x00000000), int32_t(0x9EE154AC)},
    {"namisl_h.shp", "", int32_t(0x00000000), int32_t(0x1CB1C37D)},
    {"namislmk.shp", "-", int32_t(0x00000000), int32_t(0x150F1A3D)},
    {"namntk.shp", "-", int32_t(0x00000000), int32_t(0x650DC88B)},
    {"namntk_a.shp", "-", int32_t(0x00000000), int32_t(0xBAA2FB52)},
    {"namtnk_a.shp", "-", int32_t(0x00000000), int32_t(0x6E371E5E)},
    {"nanr01.shp", "", int32_t(0x00000000), int32_t(0xD877E3C9)},
    {"nanr02.shp", "", int32_t(0x00000000), int32_t(0xE99FF954)},
    {"nanr03.shp", "", int32_t(0x00000000), int32_t(0x4FE8F2E0)},
    {"nanr04.shp", "", int32_t(0x00000000), int32_t(0x8A4FCC6E)},
    {"nanr05.shp", "", int32_t(0x00000000), int32_t(0x2C38C7DA)},
    {"nanr06.shp", "", int32_t(0x00000000), int32_t(0x1DD0DD47)},
    {"nanr07.shp", "", int32_t(0x00000000), int32_t(0xBBA7D6F3)},
    {"nanr08.shp", "", int32_t(0x00000000), int32_t(0x4DEFA61A)},
    {"nanr09.shp", "", int32_t(0x00000000), int32_t(0xEB98ADAE)},
    {"nanr10.shp", "", int32_t(0x00000000), int32_t(0xB2AAE8E3)},
    {"nanr11.shp", "", int32_t(0x00000000), int32_t(0x14DDE357)},
    {"nanr12.shp", "", int32_t(0x00000000), int32_t(0x2535F9CA)},
    {"nanr13.shp", "", int32_t(0x00000000), int32_t(0x8342F27E)},
    {"nanr14.shp", "", int32_t(0x00000000), int32_t(0x46E5CCF0)},
    {"nanr15.shp", "", int32_t(0x00000000), int32_t(0xE092C744)},
    {"nanr16.shp", "", int32_t(0x00000000), int32_t(0xD17ADDD9)},
    {"nanr17.shp", "", int32_t(0x00000000), int32_t(0x770DD66D)},
    {"nanr18.shp", "", int32_t(0x00000000), int32_t(0x8145A684)},
    {"nanr19.shp", "", int32_t(0x00000000), int32_t(0x2732AD30)},
    {"nanr20.shp", "", int32_t(0x00000000), int32_t(0x3C25EF00)},
    {"nanr21.shp", "", int32_t(0x00000000), int32_t(0x9A52E4B4)},
    {"nanr22.shp", "", int32_t(0x00000000), int32_t(0xABBAFE29)},
    {"nanr23.shp", "", int32_t(0x00000000), int32_t(0x0DCDF59D)},
    {"nanr24.shp", "", int32_t(0x00000000), int32_t(0xC86ACB13)},
    {"nanr25.shp", "", int32_t(0x00000000), int32_t(0x6E1DC0A7)},
    {"nanr26.shp", "", int32_t(0x00000000), int32_t(0x5FF5DA3A)},
    {"nanr27.shp", "", int32_t(0x00000000), int32_t(0xF982D18E)},
    {"nanr28.shp", "", int32_t(0x00000000), int32_t(0x0FCAA167)},
    {"nanr29.shp", "", int32_t(0x00000000), int32_t(0xA9BDAAD3)},
    {"nanr30.shp", "", int32_t(0x00000000), int32_t(0xF08FEF9E)},
    {"nanrct.shp", "", int32_t(0x00000000), int32_t(0x232616F8)},
    {"nanrct_a.shp", "", int32_t(0x00000000), int32_t(0xFC892521)},
    {"nanrctmk.shp", "", int32_t(0x00000000), int32_t(0xF8279E10)},
    {"naobel.shp", "-", int32_t(0x00000000), int32_t(0xF27AE499)},
    {"naobel_a.shp", "-", int32_t(0x00000000), int32_t(0x2DD5D740)},
    {"naobel_b.shp", "-", int32_t(0x00000000), int32_t(0x6A75AD90)},
    {"naobelmk.shp", "-", int32_t(0x00000000), int32_t(0x297B6C71)},
    {"napalm.vqa", "planes blowing up mobile hq", int32_t(0xB19DE122), int32_t(0x00000000)},
    {"napalm.vqp", "planes blowing up mobile hq", int32_t(0xB19DF022), int32_t(0x00000000)},
    {"napalm1.shp", "small fire", int32_t(0x61F3E824), int32_t(0x00000000)},
    {"napalm2.shp", "medium fire", int32_t(0x61F5E824), int32_t(0x00000000)},
    {"napalm3.shp", "large fire", int32_t(0x61F7E824), int32_t(0x00000000)},
    {"napost.shp", "-", int32_t(0x00000000), int32_t(0x3B7533AE)},
    {"napost_a.shp", "-", int32_t(0x00000000), int32_t(0xE4DA0077)},
    {"napost_b.shp", "-", int32_t(0x00000000), int32_t(0xA37A7AA7)},
    {"napost_d.shp", "-", int32_t(0x00000000), int32_t(0x2C3A8F07)},
    {"napostmk.shp", "-", int32_t(0x00000000), int32_t(0xE074BB46)},
    {"napowr.shp", "-", int32_t(0x00000000), int32_t(0xDCEF086E)},
    {"napowr_a.shp", "-", int32_t(0x00000000), int32_t(0x03403BB7)},
    {"napowrmk.shp", "-", int32_t(0x00000000), int32_t(0x07EE8086)},
    {"napsis.shp", "", int32_t(0x00000000), int32_t(0x595D91A6)},
    {"napsis_a.shp", "", int32_t(0x00000000), int32_t(0x86F2A27F)},
    {"napsismk.shp", "", int32_t(0x00000000), int32_t(0x825C194E)},
    {"napsya.shp", "", int32_t(0x00000000), int32_t(0xD5A72D6A)},
    {"napsya_a.shp", "", int32_t(0x00000000), int32_t(0x0A081EB3)},
    {"napsyb.shp", "", int32_t(0x00000000), int32_t(0xE44F37F7)},
    {"napsyb_a.shp", "", int32_t(0x00000000), int32_t(0x3BE0042E)},
    {"napsybmk.shp", "", int32_t(0x00000000), int32_t(0x3F4EBF1F)},
    {"napuls.shp", "-", int32_t(0x00000000), int32_t(0x62A7E648)},
    {"napuls_a.shp", "-", int32_t(0x00000000), int32_t(0xBD08D591)},
    {"napulsmk.shp", "-", int32_t(0x00000000), int32_t(0xB9A66EA0)},
    {"napyra.shp", "-", int32_t(0x00000000), int32_t(0x1DE3BBA2)},
    {"napyra_a.shp", "-", int32_t(0x00000000), int32_t(0xC24C887B)},
    {"naradr.shp", "-", int32_t(0x00000000), int32_t(0xE2EC3509)},
    {"naradr_a.shp", "-", int32_t(0x00000000), int32_t(0x3D4306D0)},
    {"naradrmk.shp", "-", int32_t(0x00000000), int32_t(0x39EDBDE1)},
    {"narefn.shp", "-", int32_t(0x00000000), int32_t(0x5D5B95C2)},
    {"narefn_a.shp", "-", int32_t(0x00000000), int32_t(0x82F4A61B)},
    {"narefn_ar.shp", "-", int32_t(0x00000000), int32_t(0x5C119AFF)},
    {"narefn_b.shp", "-", int32_t(0x00000000), int32_t(0xC554DCCB)},
    {"narefn_c.shp", "-", int32_t(0x00000000), int32_t(0xF834F57B)},
    {"narefnbb.shp", "-", int32_t(0x00000000), int32_t(0x7A1CCD8E)},
    {"narefnl1.shp", "", int32_t(0x00000000), int32_t(0xFE6436E1)},
    {"narefnl2.shp", "", int32_t(0x00000000), int32_t(0xB9C44C31)},
    {"narefnl3.shp", "", int32_t(0x00000000), int32_t(0x84A46581)},
    {"narefnl4.shp", "", int32_t(0x00000000), int32_t(0x3684B991)},
    {"narefnmk.shp", "-", int32_t(0x00000000), int32_t(0x865A1D2A)},
    {"narefnor.shp", "", int32_t(0x00000000), int32_t(0xA66249D2)},
    {"narrow.ini", "", int32_t(0x00000000), int32_t(0x8D5C9579)},
    {"narrow.map", "-", int32_t(0x00000000), int32_t(0xA3F7A681)},
    {"nasam.shp", "-", int32_t(0x00000000), int32_t(0xFA17DBB8)},
    {"nasammk.shp", "-", int32_t(0x00000000), int32_t(0x26229634)},
    {"nastlh.shp", "-", int32_t(0x00000000), int32_t(0xFB32813C)},
    {"nastlh_a.shp", "-", int32_t(0x00000000), int32_t(0x249DB2E5)},
    {"nastlhmk.shp", "-", int32_t(0x00000000), int32_t(0x203309D4)},
    {"natbnk.shp", "", int32_t(0x00000000), int32_t(0xB5F9BC5E)},
    {"natbnk_a.shp", "", int32_t(0x00000000), int32_t(0x6A568F87)},
    {"natbnk_b.shp", "", int32_t(0x00000000), int32_t(0x2DF6F557)},
    {"natbnkbb.shp", "", int32_t(0x00000000), int32_t(0x92BEE412)},
    {"natbnkmk.shp", "", int32_t(0x00000000), int32_t(0x6EF834B6)},
    {"natech.shp", "-", int32_t(0x00000000), int32_t(0x7B75DEDB)},
    {"natech_a.shp", "-", int32_t(0x00000000), int32_t(0xA4DAED02)},
    {"natechmk.shp", "-", int32_t(0x00000000), int32_t(0xA0745633)},
    {"natmpl.shp", "-", int32_t(0x00000000), int32_t(0xC6D66E18)},
    {"natmpl_a.shp", "-", int32_t(0x00000000), int32_t(0x19795DC1)},
    {"natmplmk.shp", "-", int32_t(0x00000000), int32_t(0x1DD7E6F0)},
    {"natoradr.shp", "misc: allies radar screen", int32_t(0x3221DB0B), int32_t(0x00000000)},
    {"natsla.shp", "", int32_t(0x00000000), int32_t(0xE817B25F)},
    {"natsla_a.shp", "", int32_t(0x00000000), int32_t(0x37B88186)},
    {"natsla_b.shp", "", int32_t(0x00000000), int32_t(0x7018FB56)},
    {"natsladm.shp", "", int32_t(0x00000000), int32_t(0x9B599EDF)},
    {"natslamk.shp", "", int32_t(0x00000000), int32_t(0x33163AB7)},
    {"navylst1.aud", "naval unit lost", int32_t(0x0C56ECFF), int32_t(0x00000000)},
    {"nawall.shp", "-", int32_t(0x00000000), int32_t(0xE0C1026B)},
    {"nawast.shp", "-", int32_t(0x00000000), int32_t(0x116BF345)},
    {"nawast_a.shp", "-", int32_t(0x00000000), int32_t(0xCEC4C09C)},
    {"nawast_b.shp", "-", int32_t(0x00000000), int32_t(0x8964BA4C)},
    {"nawastbb.shp", "-", int32_t(0x00000000), int32_t(0x362CAB09)},
    {"nawastmk.shp", "-", int32_t(0x00000000), int32_t(0xCA6A7BAD)},
    {"naweap.shp", "-", int32_t(0x00000000), int32_t(0x8656B00C)},
    {"naweap_1.shp", "-", int32_t(0x00000000), int32_t(0xA02B631A)},
    {"naweap_2.shp", "-", int32_t(0x00000000), int32_t(0xE78B19CA)},
    {"naweap_3.shp", "", int32_t(0x00000000), int32_t(0xDAEB307A)},
    {"naweap_4.shp", "", int32_t(0x00000000), int32_t(0x68CBEC6A)},
    {"naweap_a.shp", "-", int32_t(0x00000000), int32_t(0x59F983D5)},
    {"naweap_b.shp", "-", int32_t(0x00000000), int32_t(0x1E59F905)},
    {"naweapbb.shp", "-", int32_t(0x00000000), int32_t(0xA111E840)},
    {"naweapmk.shp", "-", int32_t(0x00000000), int32_t(0x5D5738E4)},
    {"nayard.shp", "", int32_t(0x00000000), int32_t(0xA4D65FA6)},
    {"nayard_a.shp", "", int32_t(0x00000000), int32_t(0x7B796C7F)},
    {"nayard_b.shp", "", int32_t(0x00000000), int32_t(0x3CD916AF)},
    {"nayard_c.shp", "", int32_t(0x00000000), int32_t(0x01B93F1F)},
    {"nayard_d.shp", "", int32_t(0x00000000), int32_t(0xB399E30F)},
    {"nayard_s.shp", "", int32_t(0x00000000), int32_t(0x6159A89D)},
    {"nayardmk.shp", "", int32_t(0x00000000), int32_t(0x7FD7D74E)},
    {"naylook.vqp", "???", int32_t(0x8E4BF52D), int32_t(0x00000000)},
    {"nc_ran11.aud", "", int32_t(0xF034EAE9), int32_t(0x00000000)},
    {"nchires.mix", "rmix: nchires.mix", int32_t(0x821FE12A), int32_t(0x00000000)},
    {"ndclon.shp", "", int32_t(0x00000000), int32_t(0x578C7E26)},
    {"ndclon_a.shp", "", int32_t(0x00000000), int32_t(0x88234DFF)},
    {"ndclonmk.shp", "", int32_t(0x00000000), int32_t(0x8C8DF6CE)},
    {"ndcnstmk.shp", "", int32_t(0x00000000), int32_t(0x4AC139AC)},
    {"nddeptmk.shp", "", int32_t(0x00000000), int32_t(0xA4C7BBEB)},
    {"ndflakmk.shp", "", int32_t(0x00000000), int32_t(0x2D16001F)},
    {"ndhandmk.shp", "", int32_t(0x00000000), int32_t(0xEDF8B5BE)},
    {"ndironmk.shp", "", int32_t(0x00000000), int32_t(0xFFADFFE4)},
    {"ndlasrmk.shp", "", int32_t(0x00000000), int32_t(0x07A398CA)},
    {"ndmislmk.shp", "", int32_t(0x00000000), int32_t(0x6458B67F)},
    {"ndnrctmk.shp", "", int32_t(0x00000000), int32_t(0x89703252)},
    {"ndpowrmk.shp", "", int32_t(0x00000000), int32_t(0x76B92CC4)},
    {"ndpsismk.shp", "", int32_t(0x00000000), int32_t(0xF30BB50C)},
    {"ndpsya.shp", "", int32_t(0x00000000), int32_t(0xA4F08128)},
    {"ndpsya_a.shp", "", int32_t(0x00000000), int32_t(0x7B5FB2F1)},
    {"ndpsybmk.shp", "", int32_t(0x00000000), int32_t(0x4E19135D)},
    {"ndradrmk.shp", "", int32_t(0x00000000), int32_t(0x48BA11A3)},
    {"ndrefnmk.shp", "", int32_t(0x00000000), int32_t(0xF70DB168)},
    {"ndsammk.shp", "", int32_t(0x00000000), int32_t(0x57753A76)},
    {"ndtbnkmk.shp", "", int32_t(0x00000000), int32_t(0x1FAF98F4)},
    {"ndtechmk.shp", "", int32_t(0x00000000), int32_t(0xD123FA71)},
    {"ndtslamk.shp", "", int32_t(0x00000000), int32_t(0x424196F5)},
    {"ndwall.shp", "", int32_t(0x00000000), int32_t(0x9196AE29)},
    {"ndweapmk.shp", "", int32_t(0x00000000), int32_t(0x2C0094A6)},
    {"ndyardmk.shp", "", int32_t(0x00000000), int32_t(0x0E807B0C)},
    {"nearoref.map", "", int32_t(0x00000000), int32_t(0x5E33E585)},
    {"needharv.aud", "need harvester", int32_t(0x020ED8F7), int32_t(0x00000000)},
    {"needl-lo.cps", "pict: tanya being interrogated", int32_t(0x02FDB2FF), int32_t(0x00000000)},
    {"needle.pcx", "pict: tanya being interrogated", int32_t(0xB171F814), int32_t(0x00000000)},
    {"negatv1.aud", "", int32_t(0x61C41722), int32_t(0x00000000)},
    {"neon5.aud", "", int32_t(0xE3BF71E7), int32_t(0x00000000)},
    {"neon6.aud", "", int32_t(0xE3BF71E9), int32_t(0x00000000)},
    {"neon7.aud", "", int32_t(0xE3BF71EB), int32_t(0x00000000)},
    {"neutral.mix", "", int32_t(0x00000000), int32_t(0x7B512B17)},
    {"newmenu.ini", "new menu settings file", int32_t(0x00000000), int32_t(0x02DCB64A)},
    {"newmorf1.aud", "", int32_t(0xDC3EFB05), int32_t(0x00000000)},
    {"newmorf2.aud", "", int32_t(0xDE3EFB05), int32_t(0x00000000)},
    {"newnick2.pal", "", int32_t(0x00000000), int32_t(0x0F1670A1)},
    {"newnick2.shp", "", int32_t(0x00000000), int32_t(0xC89329FE)},
    {"newopt1.aud", "new construction options", int32_t(0x9A04131A), int32_t(0x00000000)},
    {"newtarg1.aud", "new target", int32_t(0xF840FAE9), int32_t(0x00000000)},
    {"newy01.urb", "", int32_t(0x00000000), int32_t(0x6364688B)},
    {"newy02.urb", "", int32_t(0x00000000), int32_t(0x528C7216)},
    {"newy03.urb", "", int32_t(0x00000000), int32_t(0xF4FB79A2)},
    {"newy04.urb", "", int32_t(0x00000000), int32_t(0x315C472C)},
    {"newy05.urb", "", int32_t(0x00000000), int32_t(0x972B4C98)},
    {"newy06.urb", "", int32_t(0x00000000), int32_t(0xA6C35605)},
    {"newy07.urb", "", int32_t(0x00000000), int32_t(0x00B45DB1)},
    {"newy08.urb", "", int32_t(0x00000000), int32_t(0xF6FC2D58)},
    {"newy09.urb", "", int32_t(0x00000000), int32_t(0x508B26EC)},
    {"newy10.urb", "", int32_t(0x00000000), int32_t(0x09B963A1)},
    {"newy11.urb", "", int32_t(0x00000000), int32_t(0xAFCE6815)},
    {"newy12.urb", "", int32_t(0x00000000), int32_t(0x9E267288)},
    {"newy13.urb", "", int32_t(0x00000000), int32_t(0x3851793C)},
    {"newy14.urb", "", int32_t(0x00000000), int32_t(0xFDF647B2)},
    {"newy15.urb", "", int32_t(0x00000000), int32_t(0x5B814C06)},
    {"newy16.urb", "", int32_t(0x00000000), int32_t(0x6A69569B)},
    {"newy17.urb", "", int32_t(0x00000000), int32_t(0xCC1E5D2F)},
    {"newy18.urb", "", int32_t(0x00000000), int32_t(0x3A562DC6)},
    {"newy19.urb", "", int32_t(0x00000000), int32_t(0x9C212672)},
    {"newy20.urb", "", int32_t(0x00000000), int32_t(0x87366442)},
    {"newy21.urb", "", int32_t(0x00000000), int32_t(0x21416FF6)},
    {"newy22.urb", "", int32_t(0x00000000), int32_t(0x10A9756B)},
    {"newy23.urb", "", int32_t(0x00000000), int32_t(0xB6DE7EDF)},
    {"nga2icon.shp", "icon: nod gate", int32_t(0x00000000), int32_t(0x0B6B1E89)},
    {"ngaticon.shp", "icon: nod gate", int32_t(0x00000000), int32_t(0x2412E6A7)},
    {"ngbnkr.shp", "", int32_t(0x00000000), int32_t(0x2B6EA3DF)},
    {"ngbnkrmk.shp", "", int32_t(0x00000000), int32_t(0xF06F2B37)},
    {"ngclon.shp", "", int32_t(0x00000000), int32_t(0xCE6E1827)},
    {"ngclon_a.shp", "", int32_t(0x00000000), int32_t(0x11C12BFE)},
    {"ngclonmk.shp", "", int32_t(0x00000000), int32_t(0x156F90CF)},
    {"ngcnst.shp", "", int32_t(0x00000000), int32_t(0x0822D745)},
    {"ngcnst_a.shp", "", int32_t(0x00000000), int32_t(0xD78DE49C)},
    {"ngcnst_b.shp", "", int32_t(0x00000000), int32_t(0x902D9E4C)},
    {"ngcnst_c.shp", "", int32_t(0x00000000), int32_t(0xAD4DB7FC)},
    {"ngcnstdm.shp", "", int32_t(0x00000000), int32_t(0x7B6CFBC5)},
    {"ngdept.shp", "", int32_t(0x00000000), int32_t(0xE6245502)},
    {"ngdept_b.shp", "", int32_t(0x00000000), int32_t(0x7E2B1C0B)},
    {"ngdept_c.shp", "", int32_t(0x00000000), int32_t(0x434B35BB)},
    {"ngdeptbb.shp", "", int32_t(0x00000000), int32_t(0xC1630D4E)},
    {"ngflak.shp", "", int32_t(0x00000000), int32_t(0x6FF5EEF6)},
    {"nghand.shp", "", int32_t(0x00000000), int32_t(0xAF1B5B57)},
    {"nghand_a.shp", "", int32_t(0x00000000), int32_t(0x70B4688E)},
    {"nghand_b.shp", "", int32_t(0x00000000), int32_t(0x3714125E)},
    {"ngindp.shp", "", int32_t(0x00000000), int32_t(0x9D315BAD)},
    {"ngindp_a.shp", "", int32_t(0x00000000), int32_t(0x429E6874)},
    {"ngindp_b.shp", "", int32_t(0x00000000), int32_t(0x053E12A4)},
    {"ngindpmk.shp", "", int32_t(0x00000000), int32_t(0x4630D345)},
    {"ngiron.shp", "", int32_t(0x00000000), int32_t(0xBD4E110D)},
    {"ngiron_a.shp", "", int32_t(0x00000000), int32_t(0x62E122D4)},
    {"ngiron_e.shp", "", int32_t(0x00000000), int32_t(0x97618414)},
    {"ngiron_f.shp", "", int32_t(0x00000000), int32_t(0xD0C1FEC4)},
    {"ngiron_h.shp", "", int32_t(0x00000000), int32_t(0x6FF140A5)},
    {"nglasr.shp", "", int32_t(0x00000000), int32_t(0x45407623)},
    {"ngmisl.shp", "", int32_t(0x00000000), int32_t(0x26BB5896)},
    {"ngmisl_e.shp", "", int32_t(0x00000000), int32_t(0x0C94CD8F)},
    {"ngmisl_f.shp", "", int32_t(0x00000000), int32_t(0x4B34B75F)},
    {"ngmisl_g.shp", "", int32_t(0x00000000), int32_t(0x76549EEF)},
    {"ngmisl_h.shp", "", int32_t(0x00000000), int32_t(0xF404093E)},
    {"ngnrct.shp", "", int32_t(0x00000000), int32_t(0xCB93DCBB)},
    {"ngnrct_a.shp", "", int32_t(0x00000000), int32_t(0x143CEF62)},
    {"ngpowr.shp", "", int32_t(0x00000000), int32_t(0x345AC22D)},
    {"ngpowr_a.shp", "", int32_t(0x00000000), int32_t(0xEBF5F1F4)},
    {"ngpsis.shp", "", int32_t(0x00000000), int32_t(0xB1E85BE5)},
    {"ngpsis_a.shp", "", int32_t(0x00000000), int32_t(0x6E47683C)},
    {"ngpsismk.shp", "", int32_t(0x00000000), int32_t(0x6AE9D30D)},
    {"ngpsyb.shp", "", int32_t(0x00000000), int32_t(0x0CFAFDB4)},
    {"ngpsyb_a.shp", "", int32_t(0x00000000), int32_t(0xD355CE6D)},
    {"ngradr.shp", "", int32_t(0x00000000), int32_t(0x0A59FF4A)},
    {"ngradr_a.shp", "", int32_t(0x00000000), int32_t(0xD5F6CC93)},
    {"ngrefn.shp", "", int32_t(0x00000000), int32_t(0xB5EE5F81)},
    {"ngrefnbb.shp", "", int32_t(0x00000000), int32_t(0x92A907CD)},
    {"ngrefnl1.shp", "", int32_t(0x00000000), int32_t(0x16D1FCA2)},
    {"ngrefnl2.shp", "", int32_t(0x00000000), int32_t(0x51718672)},
    {"ngrefnl3.shp", "", int32_t(0x00000000), int32_t(0x6C11AFC2)},
    {"ngrefnl4.shp", "", int32_t(0x00000000), int32_t(0xDE3173D2)},
    {"ngrefnor.shp", "", int32_t(0x00000000), int32_t(0x4ED78391)},
    {"ngsam.shp", "", int32_t(0x00000000), int32_t(0x12A211FB)},
    {"ngtbnk.shp", "", int32_t(0x00000000), int32_t(0x5D4C761D)},
    {"ngtbnk_a.shp", "", int32_t(0x00000000), int32_t(0x82E345C4)},
    {"ngtbnk_b.shp", "", int32_t(0x00000000), int32_t(0xC5433F14)},
    {"ngtbnkbb.shp", "", int32_t(0x00000000), int32_t(0x7A0B2E51)},
    {"ngtbnkmk.shp", "", int32_t(0x00000000), int32_t(0x864DFEF5)},
    {"ngtech.shp", "", int32_t(0x00000000), int32_t(0x93C01498)},
    {"ngtsla.shp", "", int32_t(0x00000000), int32_t(0x00A2781C)},
    {"ngtsla_a.shp", "", int32_t(0x00000000), int32_t(0xDF0D4BC5)},
    {"ngtsla_b.shp", "", int32_t(0x00000000), int32_t(0x98AD3115)},
    {"ngtsladm.shp", "", int32_t(0x00000000), int32_t(0x73EC549C)},
    {"ngweap.shp", "", int32_t(0x00000000), int32_t(0x6EE37A4F)},
    {"ngweap_1.shp", "", int32_t(0x00000000), int32_t(0x489EA959)},
    {"ngweap_2.shp", "", int32_t(0x00000000), int32_t(0x0F3ED389)},
    {"ngweap_3.shp", "", int32_t(0x00000000), int32_t(0x325EFA39)},
    {"ngweap_4.shp", "", int32_t(0x00000000), int32_t(0x807E2629)},
    {"ngweap_a.shp", "", int32_t(0x00000000), int32_t(0xB14C4996)},
    {"ngweapbb.shp", "", int32_t(0x00000000), int32_t(0x49A42203)},
    {"ngyard.shp", "", int32_t(0x00000000), int32_t(0x4C6395E5)},
    {"ngyard_a.shp", "", int32_t(0x00000000), int32_t(0x93CCA63C)},
    {"ngyard_b.shp", "", int32_t(0x00000000), int32_t(0xD46CDCEC)},
    {"ngyard_c.shp", "", int32_t(0x00000000), int32_t(0xE90CF55C)},
    {"ngyard_d.shp", "", int32_t(0x00000000), int32_t(0x5B2C294C)},
    {"ngyard_s.shp", "", int32_t(0x00000000), int32_t(0x89EC62DE)},
    {"nhpdicon.shp", "icon: nod helipad", int32_t(0x00000000), int32_t(0xD346BAC6)},
    {"night.ini", "-", int32_t(0x00000000), int32_t(0x5EB14AA4)},
    {"nitejump.vqa", "soldiers infiltrating base", int32_t(0xF73D25FB), int32_t(0x00000000)},
    {"nitejump.vqp", "soldiers infiltrating base", int32_t(0x063D25FB), int32_t(0x00000000)},
    {"nkmsldn.shp", "", int32_t(0x00000000), int32_t(0x7623C1E2)},
    {"nkmslup.shp", "", int32_t(0x00000000), int32_t(0x8E563573)},
    {"nlclonmk.shp", "", int32_t(0x00000000), int32_t(0x364E178B)},
    {"nlcnstmk.shp", "", int32_t(0x00000000), int32_t(0xF002D8E9)},
    {"nldeptmk.shp", "", int32_t(0x00000000), int32_t(0x1E045AAE)},
    {"nlflakmk.shp", "", int32_t(0x00000000), int32_t(0x97D5E15A)},
    {"nlhandmk.shp", "", int32_t(0x00000000), int32_t(0x573B54FB)},
    {"nlironmk.shp", "", int32_t(0x00000000), int32_t(0x456E1EA1)},
    {"nllasrmk.shp", "", int32_t(0x00000000), int32_t(0xBD60798F)},
    {"nlmislmk.shp", "", int32_t(0x00000000), int32_t(0xDE9B573A)},
    {"nlnrctmk.shp", "", int32_t(0x00000000), int32_t(0x33B3D317)},
    {"nlpowrmk.shp", "", int32_t(0x00000000), int32_t(0xCC7ACD81)},
    {"nlpsismk.shp", "", int32_t(0x00000000), int32_t(0x49C85449)},
    {"nlpsya.shp", "", int32_t(0x00000000), int32_t(0x1E33606D)},
    {"nlpsya_a.shp", "", int32_t(0x00000000), int32_t(0xC19C53B4)},
    {"nlpsybmk.shp", "", int32_t(0x00000000), int32_t(0xF4DAF218)},
    {"nlradrmk.shp", "", int32_t(0x00000000), int32_t(0xF279F0E6)},
    {"nlrefnmk.shp", "", int32_t(0x00000000), int32_t(0x4DCE502D)},
    {"nlsammk.shp", "", int32_t(0x00000000), int32_t(0xEDB6DB33)},
    {"nltbnkmk.shp", "", int32_t(0x00000000), int32_t(0xA56C79B1)},
    {"nltechmk.shp", "", int32_t(0x00000000), int32_t(0x6BE01B34)},
    {"nltslamk.shp", "", int32_t(0x00000000), int32_t(0xF88277B0)},
    {"nlwall.shp", "", int32_t(0x00000000), int32_t(0x2B554F6C)},
    {"nlweapmk.shp", "", int32_t(0x00000000), int32_t(0x96C375E3)},
    {"nlyardmk.shp", "", int32_t(0x00000000), int32_t(0xB4439A49)},
    {"nnclon.shp", "", int32_t(0x00000000), int32_t(0xB52326A2)},
    {"nnclon_a.shp", "", int32_t(0x00000000), int32_t(0x6A8C157B)},
    {"nnclonmk.shp", "", int32_t(0x00000000), int32_t(0x6E22AE4A)},
    {"nncnstmk.shp", "", int32_t(0x00000000), int32_t(0xA86E6128)},
    {"nndeptmk.shp", "", int32_t(0x00000000), int32_t(0x4668E36F)},
    {"nnflakmk.shp", "", int32_t(0x00000000), int32_t(0xCFB9589B)},
    {"nnhandmk.shp", "", int32_t(0x00000000), int32_t(0x0F57ED3A)},
    {"nnironmk.shp", "", int32_t(0x00000000), int32_t(0x1D02A760)},
    {"nnlasrmk.shp", "", int32_t(0x00000000), int32_t(0xE50CC04E)},
    {"nnmislmk.shp", "", int32_t(0x00000000), int32_t(0x86F7EEFB)},
    {"nnnrctmk.shp", "", int32_t(0x00000000), int32_t(0x6BDF6AD6)},
    {"nnpowrmk.shp", "", int32_t(0x00000000), int32_t(0x94167440)},
    {"nnpsismk.shp", "", int32_t(0x00000000), int32_t(0x11A4ED88)},
    {"nnpsya.shp", "", int32_t(0x00000000), int32_t(0x465FD9AC)},
    {"nnpsya_a.shp", "", int32_t(0x00000000), int32_t(0x99F0EA75)},
    {"nnpsybmk.shp", "", int32_t(0x00000000), int32_t(0xACB64BD9)},
    {"nnradrmk.shp", "", int32_t(0x00000000), int32_t(0xAA154927)},
    {"nnrefnmk.shp", "", int32_t(0x00000000), int32_t(0x15A2E9EC)},
    {"nnsammk.shp", "", int32_t(0x00000000), int32_t(0xB5DA62F2)},
    {"nntbnkmk.shp", "", int32_t(0x00000000), int32_t(0xFD00C070)},
    {"nntechmk.shp", "", int32_t(0x00000000), int32_t(0x338CA2F5)},
    {"nntslamk.shp", "", int32_t(0x00000000), int32_t(0xA0EECE71)},
    {"nnwall.shp", "", int32_t(0x00000000), int32_t(0x7339F6AD)},
    {"nnweapmk.shp", "", int32_t(0x00000000), int32_t(0xCEAFCC22)},
    {"nnyardmk.shp", "", int32_t(0x00000000), int32_t(0xEC2F2388)},
    {"nobuild1.aud", "unable to build more", int32_t(0xFBE716F9), int32_t(0x00000000)},
    {"nocando.aud", "", int32_t(0x61F01B16), int32_t(0x133C449E)},
    {"nocash1.aud", "insufficient funds", int32_t(0x61B42320), int32_t(0x00000000)},
    {"nocomp1.aud", "audf:", int32_t(0x99B43314), int32_t(0x00000000)},
    {"nod-01.aud", "-", int32_t(0x00000000), int32_t(0x724378D7)},
    {"nod-02.aud", "-", int32_t(0x00000000), int32_t(0x43AB624A)},
    {"nod-03a.aud", "-", int32_t(0x00000000), int32_t(0xE1A82120)},
    {"nod-03b.aud", "-", int32_t(0x00000000), int32_t(0x673C538E)},
    {"nod-04a.aud", "-", int32_t(0x00000000), int32_t(0x240F1FAE)},
    {"nod-04b.aud", "-", int32_t(0x00000000), int32_t(0xA29B6D00)},
    {"nod-05.aud", "-", int32_t(0x00000000), int32_t(0x860C5CC4)},
    {"nod-06a.aud", "-", int32_t(0x00000000), int32_t(0xB3900E87)},
    {"nod-06b.aud", "-", int32_t(0x00000000), int32_t(0x35047C29)},
    {"nod-06c.aud", "-", int32_t(0x00000000), int32_t(0xFE58AF8C)},
    {"nod-07.aud", "-", int32_t(0x00000000), int32_t(0x11934DED)},
    {"nod-07a.aud", "-", int32_t(0x00000000), int32_t(0x15E70533)},
    {"nod-07b.aud", "-", int32_t(0x00000000), int32_t(0x9373779D)},
    {"nod-08.aud", "-", int32_t(0x00000000), int32_t(0xE7DB3D04)},
    {"nod-09a.aud", "-", int32_t(0x00000000), int32_t(0x45D87E6E)},
    {"nod-09b.aud", "-", int32_t(0x00000000), int32_t(0xC34C0CC0)},
    {"nod-10.aud", "-", int32_t(0x00000000), int32_t(0x189E73FD)},
    {"nod-11.aud", "-", int32_t(0x00000000), int32_t(0xBEE97849)},
    {"nod-12a.aud", "-", int32_t(0x00000000), int32_t(0x8B752A0A)},
    {"nod-12b.aud", "-", int32_t(0x00000000), int32_t(0x0DE158A4)},
    {"nod.aud", "", int32_t(0x5CCCF3DD), int32_t(0x458DDB81)},
    {"nod01_sb.vqa", "-", int32_t(0x00000000), int32_t(0xE0230471)},
    {"nod02_sb.vqa", "-", int32_t(0x00000000), int32_t(0x6EAC0392)},
    {"nod06abw.vqa", "-", int32_t(0x00000000), int32_t(0xBD8D2337)},
    {"nod1.vqa", "kill village chief", int32_t(0xA3D9F4CA), int32_t(0x00000000)},
    {"nod1.vqp", "kill village chief", int32_t(0xB2D9F4CA), int32_t(0x00000000)},
    {"nod10a.ini", "", int32_t(0x00000000), int32_t(0xE10AD879)},
    {"nod10a.map", "-", int32_t(0x00000000), int32_t(0xCFA1EB81)},
    {"nod10a.vqa", "kill scientist", int32_t(0x716E00EA), int32_t(0x00000000)},
    {"nod10a.vqp", "kill scientist", int32_t(0x716E0FEA), int32_t(0x00000000)},
    {"nod10b.vqa", "destroy mammoth tank", int32_t(0x716E02EA), int32_t(0x00000000)},
    {"nod10b.vqp", "destroy mammoth tank", int32_t(0x716E11EA), int32_t(0x00000000)},
    {"nod11.vqa", "recapture stealth tank", int32_t(0x67BD99DC), int32_t(0x00000000)},
    {"nod11.vqp", "recapture stealth tank", int32_t(0x67BD99EB), int32_t(0x00000000)},
    {"nod11a.ini", "", int32_t(0x00000000), int32_t(0x2DA0D8E7)},
    {"nod11a.map", "-", int32_t(0x00000000), int32_t(0x030BEB1F)},
    {"nod12.vqa", "capture communications center", int32_t(0x67BD99DE), int32_t(0x00000000)},
    {"nod12.vqp", "capture communications center", int32_t(0x67BD99ED), int32_t(0x00000000)},
    {"nod12a.ini", "", int32_t(0x00000000), int32_t(0xA32FDF04)},
    {"nod12a.map", "-", int32_t(0x00000000), int32_t(0x8D84ECFC)},
    {"nod12b.ini", "", int32_t(0x00000000), int32_t(0x92C7C599)},
    {"nod12b.map", "-", int32_t(0x00000000), int32_t(0xBC6CF661)},
    {"nod13.vqa", "remove gdi bases", int32_t(0x67BD99E0), int32_t(0x00000000)},
    {"nod13.vqp", "remove gdi bases", int32_t(0x67BD99EF), int32_t(0x00000000)},
    {"nod1a.ini", "", int32_t(0x00000000), int32_t(0x35687125)},
    {"nod1a.map", "-", int32_t(0x00000000), int32_t(0xFED3BD2F)},
    {"nod1pre.vqa", "static to nod logo", int32_t(0x21DD332F), int32_t(0x00000000)},
    {"nod1pre.vqp", "static to nod logo", int32_t(0x21EC332F), int32_t(0x00000000)},
    {"nod2.vqa", "setup a base", int32_t(0xA5D9F4CA), int32_t(0x00000000)},
    {"nod2.vqp", "setup a base", int32_t(0xB4D9F4CA), int32_t(0x00000000)},
    {"nod2a.ini", "", int32_t(0x00000000), int32_t(0x0CE54DE0)},
    {"nod2a.map", "-", int32_t(0x00000000), int32_t(0xC75E81EA)},
    {"nod3.vqa", "free the prisoners", int32_t(0xA7D9F4CA), int32_t(0x00000000)},
    {"nod3.vqp", "free the prisoners", int32_t(0xB6D9F4CA), int32_t(0x00000000)},
    {"nod3a.ini", "", int32_t(0x00000000), int32_t(0x1B9E59A3)},
    {"nod3a.map", "-", int32_t(0x00000000), int32_t(0xD02595A9)},
    {"nod3b.ini", "", int32_t(0x00000000), int32_t(0x95115E40)},
    {"nod3b.map", "-", int32_t(0x00000000), int32_t(0x5EAA924A)},
    {"nod4a.ini", "", int32_t(0x00000000), int32_t(0x7FFF346A)},
    {"nod4a.map", "-", int32_t(0x00000000), int32_t(0xB444F860)},
    {"nod4a.vqa", "destroy village", int32_t(0x73BD99FC), int32_t(0x00000000)},
    {"nod4a.vqp", "destroy village", int32_t(0x73BD9A0B), int32_t(0x00000000)},
    {"nod4b.ini", "", int32_t(0x00000000), int32_t(0xF1703389)},
    {"nod4b.map", "-", int32_t(0x00000000), int32_t(0x3ACBFF83)},
    {"nod4b.vqa", "eliminate the gdi", int32_t(0x73BD99FE), int32_t(0x00000000)},
    {"nod4b.vqp", "eliminate the gdi", int32_t(0x73BD9A0D), int32_t(0x00000000)},
    {"nod5.vqa", "destroy the airbase", int32_t(0xABD9F4CA), int32_t(0x00000000)},
    {"nod5.vqp", "destroy the airbase", int32_t(0xBAD9F4CA), int32_t(0x00000000)},
    {"nod5a.ini", "", int32_t(0x00000000), int32_t(0x68842029)},
    {"nod5a.map", "-", int32_t(0x00000000), int32_t(0xA33FEC23)},
    {"nod6.vqa", "get detonator", int32_t(0xADD9F4CA), int32_t(0x00000000)},
    {"nod6.vqp", "get detonator", int32_t(0xBCD9F4CA), int32_t(0x00000000)},
    {"nod6a.ini", "", int32_t(0x00000000), int32_t(0x51091CEC)},
    {"nod6a.map", "-", int32_t(0x00000000), int32_t(0x9AB2D0E6)},
    {"nod6b.ini", "", int32_t(0x00000000), int32_t(0xDF861B0F)},
    {"nod6b.map", "-", int32_t(0x00000000), int32_t(0x143DD705)},
    {"nod6c.ini", "", int32_t(0x00000000), int32_t(0x132C1B91)},
    {"nod6c.map", "-", int32_t(0x00000000), int32_t(0xD897D79B)},
    {"nod7a.ini", "", int32_t(0x00000000), int32_t(0x467208AF)},
    {"nod7a.map", "-", int32_t(0x00000000), int32_t(0x8DC9C4A5)},
    {"nod7a.vqa", "destroy village", int32_t(0x7FBD99FC), int32_t(0x00000000)},
    {"nod7a.vqp", "destroy village", int32_t(0x7FBD9A0B), int32_t(0x00000000)},
    {"nod7b.ini", "", int32_t(0x00000000), int32_t(0xC8FD0F4C)},
    {"nod7b.map", "-", int32_t(0x00000000), int32_t(0x0346C346)},
    {"nod7b.vqa", "capture orca", int32_t(0x7FBD99FE), int32_t(0x00000000)},
    {"nod7b.vqp", "capture orca", int32_t(0x7FBD9A0D), int32_t(0x00000000)},
    {"nod8.vqa", "capture gdi base", int32_t(0xB1D9F4CA), int32_t(0x00000000)},
    {"nod8.vqp", "capture gdi base", int32_t(0xC0D9F4CA), int32_t(0x00000000)},
    {"nod8a.ini", "", int32_t(0x00000000), int32_t(0x99CBC77E)},
    {"nod8a.map", "-", int32_t(0x00000000), int32_t(0x52700B74)},
    {"nod9.vqa", "reinforce base", int32_t(0xB3D9F4CA), int32_t(0x00000000)},
    {"nod9.vqp", "reinforce base", int32_t(0xC2D9F4CA), int32_t(0x00000000)},
    {"nod9a.ini", "", int32_t(0x00000000), int32_t(0x8EB0D33D)},
    {"nod9a.map", "-", int32_t(0x00000000), int32_t(0x450B1F37)},
    {"nod9b.ini", "", int32_t(0x00000000), int32_t(0x003FD4DE)},
    {"nod9b.map", "-", int32_t(0x00000000), int32_t(0xCB8418D4)},
    {"nod_finl.vqa", "-", int32_t(0x00000000), int32_t(0xC11AD45D)},
    {"nod_flag.vqa", "-", int32_t(0x00000000), int32_t(0x15A4783E)},
    {"nod_m02.vqa", "-", int32_t(0x00000000), int32_t(0x0346187F)},
    {"nod_m03.vqa", "-", int32_t(0x00000000), int32_t(0xC81ACBDA)},
    {"nod_m04.vqa", "-", int32_t(0x00000000), int32_t(0xD51FFB62)},
    {"nod_m05.vqa", "-", int32_t(0x00000000), int32_t(0x1E4328C7)},
    {"nod_m06.vqa", "-", int32_t(0x00000000), int32_t(0x98D75A69)},
    {"nod_m07.vqa", "-", int32_t(0x00000000), int32_t(0x538B89CC)},
    {"nod_m08.vqa", "-", int32_t(0x00000000), int32_t(0xA2DD3B19)},
    {"nod_m09.vqa", "-", int32_t(0x00000000), int32_t(0x6981E8BC)},
    {"nod_m10.vqa", "-", int32_t(0x00000000), int32_t(0xE8F9B2C0)},
    {"nod_m11.vqa", "-", int32_t(0x00000000), int32_t(0x23A56165)},
    {"nod_m12.vqa", "-", int32_t(0x00000000), int32_t(0xA53113CB)},
    {"nod_map1.aud", "", int32_t(0x24070101), int32_t(0x00000000)},
    {"nod_slct.aud", "brotherhood of nod selected", int32_t(0x69ED170C), int32_t(0x00000000)},
    {"nod_win1.aud", "", int32_t(0x24031115), int32_t(0x00000000)},
    {"nodamerica.pal", "", int32_t(0x00000000), int32_t(0xAB276B8C)},
    {"nodamerica.pcx", "", int32_t(0x00000000), int32_t(0xF40FC987)},
    {"nodamerica.vqa", "", int32_t(0x00000000), int32_t(0x61114A84)},
    {"nodbase2.aud", "", int32_t(0xB1F124E9), int32_t(0x00000000)},
    {"nodbase3.aud", "", int32_t(0xB3F124E9), int32_t(0x00000000)},
    {"nodbase4.aud", "", int32_t(0xB5F124E9), int32_t(0x00000000)},
    {"nodbase5.aud", "", int32_t(0xB7F124E9), int32_t(0x00000000)},
    {"nodbase6.aud", "", int32_t(0xB9F124E9), int32_t(0x00000000)},
    {"nodc.pcx", "-", int32_t(0x00000000), int32_t(0xF2595378)},
    {"nodcapt1.aud", "nod building captured", int32_t(0xB40F1EE9), int32_t(0x00000000)},
    {"nodch.pcx", "-", int32_t(0x00000000), int32_t(0xF9F725A7)},
    {"nodclk01.pcx", "-", int32_t(0x00000000), int32_t(0xA5C984B7)},
    {"nodclk02.pcx", "-", int32_t(0x00000000), int32_t(0xE269FE67)},
    {"nodclk03.pcx", "-", int32_t(0x00000000), int32_t(0xDF09D7D7)},
    {"nodclk04.pcx", "-", int32_t(0x00000000), int32_t(0x6D290BC7)},
    {"nodclk05.pcx", "-", int32_t(0x00000000), int32_t(0x50492277)},
    {"nodcrush.aud", "nod crush", int32_t(0x00000000), int32_t(0x94C69FA8)},
    {"noddead1.aud", "nod unit destroyed", int32_t(0xB7EF00F1), int32_t(0x00000000)},
    {"nodend1.vqa", "destroying the effiel tower", int32_t(0x71B5172B), int32_t(0x00000000)},
    {"nodend1.vqp", "destroying the effiel tower", int32_t(0x71C4172B), int32_t(0x00000000)},
    {"nodend2.vqa", "destroying the white house", int32_t(0x71B7172B), int32_t(0x00000000)},
    {"nodend2.vqp", "destroying the white house", int32_t(0x71C6172B), int32_t(0x00000000)},
    {"nodend3.vqa", "destroying big ben", int32_t(0x71B9172B), int32_t(0x00000000)},
    {"nodend3.vqp", "destroying big ben", int32_t(0x71C8172B), int32_t(0x00000000)},
    {"nodend4.vqa", "destroying the gate", int32_t(0x71BB172B), int32_t(0x00000000)},
    {"nodend4.vqp", "destroying the gate", int32_t(0x71CA172B), int32_t(0x00000000)},
    {"nodeply1.aud", "cannot deploy here", int32_t(0xBC191707), int32_t(0x00000000)},
    {"nodeurope.pal", "", int32_t(0x00000000), int32_t(0x792E8A52)},
    {"nodeurope.pcx", "", int32_t(0x00000000), int32_t(0xE8E11AD2)},
    {"nodeurope.vqa", "", int32_t(0x00000000), int32_t(0xF6E224E0)},
    {"nodfinal.vqa", "nod getting the ion cannon", int32_t(0xF2E52FF9), int32_t(0x00000000)},
    {"nodfinal.vqp", "nod getting the ion cannon", int32_t(0x01E52FF9), int32_t(0x00000000)},
    {"nodflees.vqa", "nod soldiers runnning away", int32_t(0x00ED1DFF), int32_t(0x00000000)},
    {"nodflees.vqp", "nod soldiers runnning away", int32_t(0x0FED1DFF), int32_t(0x00000000)},
    {"nodgen.inf", "inf: list for nod general.mix", int32_t(0xAF6E2011), int32_t(0x00000000)},
    {"nodi.pcx", "-", int32_t(0x00000000), int32_t(0xB8E94BD9)},
    {"nodlogo.pal", "", int32_t(0x00000000), int32_t(0xC6BE13ED)},
    {"nodlogo.shp", "", int32_t(0x00000000), int32_t(0x3DADDAD1)},
    {"nodlose.vqa", "nod logo turning into gdi logo", int32_t(0x8DDD352D), int32_t(0x00000000)},
    {"nodlose.vqp", "nod logo turning into gdi logo", int32_t(0x8DEC352D), int32_t(0x00000000)},
    {"nodmap01.pcx", "-", int32_t(0x00000000), int32_t(0x93D782C0)},
    {"nodmap01.vqa", "-", int32_t(0x00000000), int32_t(0x8BC52661)},
    {"nodmap02.pcx", "-", int32_t(0x00000000), int32_t(0xD477F810)},
    {"nodmap02.vqa", "-", int32_t(0x00000000), int32_t(0xCC655CB1)},
    {"nodmap03.pcx", "-", int32_t(0x00000000), int32_t(0xE917D1A0)},
    {"nodmap03.vqa", "-", int32_t(0x00000000), int32_t(0xF1057501)},
    {"nodmap04.pcx", "-", int32_t(0x00000000), int32_t(0x5B370DB0)},
    {"nodmap04.vqa", "-", int32_t(0x00000000), int32_t(0x4325A911)},
    {"nodmap05.pcx", "-", int32_t(0x00000000), int32_t(0x66572400)},
    {"nodmap05.vqa", "-", int32_t(0x00000000), int32_t(0x7E4580A1)},
    {"nodmov.inf", "inf: list for nod movies.mix", int32_t(0xC76E3025), int32_t(0x00000000)},
    {"nodsweep.vqa", "nod forces assaulting village", int32_t(0x2EED1E15), int32_t(0x00000000)},
    {"nodsweep.vqp", "nod forces assaulting village", int32_t(0x3DED1E15), int32_t(0x00000000)},
    {"nodtarget.pal", "-", int32_t(0x00000000), int32_t(0x5A3055F1)},
    {"nodtarget2.shp", "-", int32_t(0x00000000), int32_t(0x5ACD7E5A)},
    {"nofind1.aud", "audf:", int32_t(0x81C01B16), int32_t(0x00000000)},
    {"nofind2.aud", "audf:", int32_t(0x81C21B16), int32_t(0x00000000)},
    {"nofunds1.aud", "insufficent funds", int32_t(0xFC150703), int32_t(0x00000000)},
    {"nomercy.aud", "no mercy", int32_t(0x722C191E), int32_t(0x00000000)},
    {"nomercy.var", "", int32_t(0x723A0533), int32_t(0x00000000)},
    {"nopower1.aud", "no power", int32_t(0xE43B0915), int32_t(0x00000000)},
    {"nopowr1.aud", "insufficient power", int32_t(0x99E83728), int32_t(0x00000000)},
    {"noprblm1.aud", "no problem", int32_t(0xF03116EB), int32_t(0x00000000)},
    {"noprob.r01", "soviet #2 of course", int32_t(0xED9DF307), int32_t(0x00000000)},
    {"noprob.r03", "soviet #4 of course", int32_t(0xED9DF507), int32_t(0x00000000)},
    {"noprob.v01", "c&c #2 no problem", int32_t(0xF59DF307), int32_t(0x00000000)},
    {"noprob.v03", "c&c #4 no problem", int32_t(0xF59DF507), int32_t(0x00000000)},
    {"noredy1.aud", "not ready", int32_t(0x71F04502), int32_t(0x00000000)},
    {"notify.aud", "notification", int32_t(0x00000000), int32_t(0x8604B302)},
    {"nowcnot.vqa", "-", int32_t(0x00000000), int32_t(0xCF29D897)},
    {"nowimps.map", "", int32_t(0x00000000), int32_t(0x90FCD98B)},
    {"npsiicon.shp", "", int32_t(0x00000000), int32_t(0xDD0BC31C)},
    {"npwricon.shp", "icon: nod power plant", int32_t(0x00000000), int32_t(0xFA75BFCA)},
    {"nr01-min.set", "", int32_t(0xB59936C1), int32_t(0x00000000)},
    {"nr01.vqa", "", int32_t(0xA3B1FACA), int32_t(0x00000000)},
    {"nr01_0.vqa", "", int32_t(0x711DEB48), int32_t(0x00000000)},
    {"nr01_1.vqa", "", int32_t(0x711DED48), int32_t(0x00000000)},
    {"nr01_2.vqa", "", int32_t(0x711DEF48), int32_t(0x00000000)},
    {"nr01_3.vqa", "", int32_t(0x711DF148), int32_t(0x00000000)},
    {"nr02-min.set", "", int32_t(0xB99936C1), int32_t(0x00000000)},
    {"nr02.vqa", "", int32_t(0xA5B1FACA), int32_t(0x00000000)},
    {"nr02_0.vqa", "", int32_t(0x751DEB48), int32_t(0x00000000)},
    {"nr02_1.vqa", "", int32_t(0x751DED48), int32_t(0x00000000)},
    {"nr02_2.vqa", "", int32_t(0x751DEF48), int32_t(0x00000000)},
    {"nr02_3.vqa", "", int32_t(0x751DF148), int32_t(0x00000000)},
    {"nr03-min.set", "", int32_t(0xBD9936C1), int32_t(0x00000000)},
    {"nr03.vqa", "", int32_t(0xA7B1FACA), int32_t(0x00000000)},
    {"nr03_0.vqa", "", int32_t(0x791DEB48), int32_t(0x00000000)},
    {"nr03_1.vqa", "", int32_t(0x791DED48), int32_t(0x00000000)},
    {"nr03_2.vqa", "", int32_t(0x791DEF48), int32_t(0x00000000)},
    {"nr03_3.vqa", "", int32_t(0x791DF148), int32_t(0x00000000)},
    {"nr04-min.set", "", int32_t(0xC19936C1), int32_t(0x00000000)},
    {"nr04.vqa", "", int32_t(0xA9B1FACA), int32_t(0x00000000)},
    {"nr04_0.vqa", "", int32_t(0x7D1DEB48), int32_t(0x00000000)},
    {"nr04_1.vqa", "", int32_t(0x7D1DED48), int32_t(0x00000000)},
    {"nr04_2.vqa", "", int32_t(0x7D1DEF48), int32_t(0x00000000)},
    {"nr04_3.vqa", "", int32_t(0x7D1DF148), int32_t(0x00000000)},
    {"nr04over.vqa", "", int32_t(0xB69D4C05), int32_t(0x00000000)},
    {"nr05-min.set", "", int32_t(0xC59936C1), int32_t(0x00000000)},
    {"nr05.vqa", "", int32_t(0xABB1FACA), int32_t(0x00000000)},
    {"nr05_0.vqa", "", int32_t(0x811DEB48), int32_t(0x00000000)},
    {"nr05_1.vqa", "", int32_t(0x811DED48), int32_t(0x00000000)},
    {"nr05_2.vqa", "", int32_t(0x811DEF48), int32_t(0x00000000)},
    {"nr05_3.vqa", "", int32_t(0x811DF148), int32_t(0x00000000)},
    {"nr06-min.set", "", int32_t(0xC99936C1), int32_t(0x00000000)},
    {"nr06.vqa", "", int32_t(0xADB1FACA), int32_t(0x00000000)},
    {"nr060000.img", "", int32_t(0x806EF2C7), int32_t(0x00000000)},
    {"nr06_0.vqa", "", int32_t(0x851DEB48), int32_t(0x00000000)},
    {"nr06_1.vqa", "", int32_t(0x851DED48), int32_t(0x00000000)},
    {"nr06_2.vqa", "", int32_t(0x851DEF48), int32_t(0x00000000)},
    {"nr06_3.vqa", "", int32_t(0x851DF148), int32_t(0x00000000)},
    {"nr06esp1.vqa", "", int32_t(0x7CB345F1), int32_t(0x00000000)},
    {"nr06esp2.vqa", "", int32_t(0x7EB345F1), int32_t(0x00000000)},
    {"nr07-min.set", "", int32_t(0xCD9936C1), int32_t(0x00000000)},
    {"nr07.vqa", "", int32_t(0xAFB1FACA), int32_t(0x00000000)},
    {"nr070000.img", "", int32_t(0x846EF2C7), int32_t(0x00000000)},
    {"nr07_0.vqa", "", int32_t(0x891DEB48), int32_t(0x00000000)},
    {"nr07_1.vqa", "", int32_t(0x891DED48), int32_t(0x00000000)},
    {"nr07_2.vqa", "", int32_t(0x891DEF48), int32_t(0x00000000)},
    {"nr07_3.vqa", "", int32_t(0x891DF148), int32_t(0x00000000)},
    {"nr07esp1.vqa", "", int32_t(0x80B345F1), int32_t(0x00000000)},
    {"nr07esp2.vqa", "", int32_t(0x82B345F1), int32_t(0x00000000)},
    {"nr08-min.set", "", int32_t(0xD19936C1), int32_t(0x00000000)},
    {"nr08.vqa", "", int32_t(0xB1B1FACA), int32_t(0x00000000)},
    {"nr08_0.vqa", "", int32_t(0x8D1DEB48), int32_t(0x00000000)},
    {"nr08_1.vqa", "", int32_t(0x8D1DED48), int32_t(0x00000000)},
    {"nr08_2.vqa", "", int32_t(0x8D1DEF48), int32_t(0x00000000)},
    {"nr08_3.vqa", "", int32_t(0x8D1DF148), int32_t(0x00000000)},
    {"nr09-min.set", "", int32_t(0xD59936C1), int32_t(0x00000000)},
    {"nr09.vqa", "", int32_t(0xB3B1FACA), int32_t(0x00000000)},
    {"nr09_0.vqa", "", int32_t(0x911DEB48), int32_t(0x00000000)},
    {"nr09_1.vqa", "", int32_t(0x911DED48), int32_t(0x00000000)},
    {"nr09_2.vqa", "", int32_t(0x911DEF48), int32_t(0x00000000)},
    {"nr09_3.vqa", "", int32_t(0x911DF148), int32_t(0x00000000)},
    {"nr10-min.set", "", int32_t(0xB19D36C1), int32_t(0x00000000)},
    {"nr10.vqa", "", int32_t(0xA1B3FACA), int32_t(0x00000000)},
    {"nr10_0.vqa", "", int32_t(0x6D21EB48), int32_t(0x00000000)},
    {"nr10_1.vqa", "", int32_t(0x6D21ED48), int32_t(0x00000000)},
    {"nr10_2.vqa", "", int32_t(0x6D21EF48), int32_t(0x00000000)},
    {"nr10_3.vqa", "", int32_t(0x6D21F148), int32_t(0x00000000)},
    {"nr11-min.set", "", int32_t(0xB59D36C1), int32_t(0x00000000)},
    {"nr11.vqa", "", int32_t(0xA3B3FACA), int32_t(0x00000000)},
    {"nr11_0.vqa", "", int32_t(0x7121EB48), int32_t(0x00000000)},
    {"nr11_1.vqa", "", int32_t(0x7121ED48), int32_t(0x00000000)},
    {"nr11_2.vqa", "", int32_t(0x7121EF48), int32_t(0x00000000)},
    {"nr11_3.vqa", "", int32_t(0x7121F148), int32_t(0x00000000)},
    {"nr11over.vqa", "", int32_t(0xAAA14C05), int32_t(0x00000000)},
    {"nradar02.shp", "", int32_t(0x00000000), int32_t(0x8369F24A)},
    {"nradicon.shp", "icon: nod radar", int32_t(0x00000000), int32_t(0x5773CC5F)},
    {"nradrfrm.shp", "misc: allies radarmap background", int32_t(0xFBF2290B), int32_t(0x00000000)},
    {"nrcticon.shp", "", int32_t(0x00000000), int32_t(0xFF465E13)},
    {"nreficon.shp", "", int32_t(0x00000000), int32_t(0x706E44A3)},
    {"nrleg2.aud", "", int32_t(0x978DF21C), int32_t(0x00000000)},
    {"nstruc1.aud", "nod structure destroyed", int32_t(0xA5F82924), int32_t(0x00000000)},
    {"nsweep.aud", "-", int32_t(0x00000000), int32_t(0x34FCEF29)},
    {"ntapwr.shp", "-", int32_t(0x00000000), int32_t(0xB85B0791)},
    {"ntapwr_a.shp", "-", int32_t(0x00000000), int32_t(0x67F43448)},
    {"ntapwrmk.shp", "-", int32_t(0x00000000), int32_t(0x635A8F79)},
    {"ntchicon.shp", "icon: nod tech center", int32_t(0x00000000), int32_t(0x5D072535)},
    {"ntclonmk.shp", "", int32_t(0x00000000), int32_t(0x227B3205)},
    {"ntcnstmk.shp", "", int32_t(0x00000000), int32_t(0xE437FD67)},
    {"ntdeptmk.shp", "", int32_t(0x00000000), int32_t(0x0A317F20)},
    {"ntflakmk.shp", "", int32_t(0x00000000), int32_t(0x83E0C4D4)},
    {"ntfnce.shp", "-", int32_t(0x00000000), int32_t(0x640D189A)},
    {"ntgate_a.shp", "-", int32_t(0x00000000), int32_t(0xFDA7B79E)},
    {"ntgate_b.shp", "-", int32_t(0x00000000), int32_t(0xBA07CD4E)},
    {"ntgateza.shp", "-", int32_t(0x00000000), int32_t(0xAD6A262D)},
    {"ntgatezb.shp", "-", int32_t(0x00000000), int32_t(0xEACA5CFD)},
    {"nthand.shp", "-", int32_t(0x00000000), int32_t(0x980FF99D)},
    {"nthand_a.shp", "-", int32_t(0x00000000), int32_t(0x47A0CA44)},
    {"nthand_b.shp", "-", int32_t(0x00000000), int32_t(0x0000B094)},
    {"nthandmk.shp", "-", int32_t(0x00000000), int32_t(0x430E7175)},
    {"nthpad.shp", "-", int32_t(0x00000000), int32_t(0xFA94BD03)},
    {"nthpad_a.shp", "-", int32_t(0x00000000), int32_t(0x253B8EDA)},
    {"nthpadbb.shp", "-", int32_t(0x00000000), int32_t(0xDDD3E54F)},
    {"nthpadmk.shp", "-", int32_t(0x00000000), int32_t(0x219535EB)},
    {"ntironmk.shp", "", int32_t(0x00000000), int32_t(0x515B3B2F)},
    {"ntlasr.shp", "-", int32_t(0x00000000), int32_t(0x7254D4E9)},
    {"ntlasrmk.shp", "-", int32_t(0x00000000), int32_t(0xA9555C01)},
    {"ntmisl.shp", "-", int32_t(0x00000000), int32_t(0x11AFFA5C)},
    {"ntmisl_a.shp", "-", int32_t(0x00000000), int32_t(0xCE00C985)},
    {"ntmisl_b.shp", "-", int32_t(0x00000000), int32_t(0x89A0B355)},
    {"ntmislmk.shp", "-", int32_t(0x00000000), int32_t(0xCAAE72B4)},
    {"ntmntk.shp", "-", int32_t(0x00000000), int32_t(0xBAACA002)},
    {"ntmntk_a.shp", "-", int32_t(0x00000000), int32_t(0x650393DB)},
    {"ntmtnk_a.shp", "-", int32_t(0x00000000), int32_t(0xB19676D7)},
    {"ntnrctmk.shp", "", int32_t(0x00000000), int32_t(0x2786F699)},
    {"ntobel.shp", "-", int32_t(0x00000000), int32_t(0x2DDB8C10)},
    {"ntobel_a.shp", "-", int32_t(0x00000000), int32_t(0xF274BFC9)},
    {"ntobel_b.shp", "-", int32_t(0x00000000), int32_t(0xB5D4C519)},
    {"ntobelmk.shp", "-", int32_t(0x00000000), int32_t(0xF6DA04F8)},
    {"ntpost.shp", "-", int32_t(0x00000000), int32_t(0xE4D45B27)},
    {"ntpost_a.shp", "-", int32_t(0x00000000), int32_t(0x3B7B68FE)},
    {"ntpost_b.shp", "-", int32_t(0x00000000), int32_t(0x7CDB122E)},
    {"ntpost_d.shp", "-", int32_t(0x00000000), int32_t(0xF39BE78E)},
    {"ntpostmk.shp", "-", int32_t(0x00000000), int32_t(0x3FD5D3CF)},
    {"ntpowr.shp", "-", int32_t(0x00000000), int32_t(0x034E60E7)},
    {"ntpowr_a.shp", "-", int32_t(0x00000000), int32_t(0xDCE1533E)},
    {"ntpowrmk.shp", "-", int32_t(0x00000000), int32_t(0xD84FE80F)},
    {"ntpsismk.shp", "", int32_t(0x00000000), int32_t(0x5DFD71C7)},
    {"ntpsya.shp", "", int32_t(0x00000000), int32_t(0x0A0645E3)},
    {"ntpsya_a.shp", "", int32_t(0x00000000), int32_t(0xD5A9763A)},
    {"ntpsybmk.shp", "", int32_t(0x00000000), int32_t(0xE0EFD796)},
    {"ntpuls.shp", "-", int32_t(0x00000000), int32_t(0xBD068EC1)},
    {"ntpuls_a.shp", "-", int32_t(0x00000000), int32_t(0x62A9BD18)},
    {"ntpulsmk.shp", "-", int32_t(0x00000000), int32_t(0x66070629)},
    {"ntpyra.shp", "-", int32_t(0x00000000), int32_t(0xC242D32B)},
    {"ntpyra_a.shp", "-", int32_t(0x00000000), int32_t(0x1DEDE0F2)},
    {"ntradr.shp", "-", int32_t(0x00000000), int32_t(0x3D4D5D80)},
    {"ntradr_a.shp", "-", int32_t(0x00000000), int32_t(0xE2E26E59)},
    {"ntradrmk.shp", "-", int32_t(0x00000000), int32_t(0xE64CD568)},
    {"ntrefn.shp", "-", int32_t(0x00000000), int32_t(0x82FAFD4B)},
    {"ntrefn_a.shp", "-", int32_t(0x00000000), int32_t(0x5D55CE92)},
    {"ntrefn_ar.shp", "-", int32_t(0x00000000), int32_t(0x2BF4BB3B)},
    {"ntrefn_b.shp", "-", int32_t(0x00000000), int32_t(0x1AF5B442)},
    {"ntrefn_c.shp", "-", int32_t(0x00000000), int32_t(0x27959DF2)},
    {"ntrefnbb.shp", "-", int32_t(0x00000000), int32_t(0xA5BDA507)},
    {"ntrefnmk.shp", "-", int32_t(0x00000000), int32_t(0x59FB75A3)},
    {"ntrlmd.mix", "", int32_t(0x00000000), int32_t(0xC93B27A0)},
    {"ntsam.shp", "-", int32_t(0x00000000), int32_t(0x25B6B331)},
    {"ntsammk.shp", "-", int32_t(0x00000000), int32_t(0xF983FEBD)},
    {"ntstlh.shp", "-", int32_t(0x00000000), int32_t(0x2493E9B5)},
    {"ntstlh_a.shp", "-", int32_t(0x00000000), int32_t(0xFB3CDA6C)},
    {"ntstlhmk.shp", "-", int32_t(0x00000000), int32_t(0xFF92615D)},
    {"nttech.shp", "-", int32_t(0x00000000), int32_t(0xA4D4B652)},
    {"nttech_a.shp", "-", int32_t(0x00000000), int32_t(0x7B7B858B)},
    {"nttechmk.shp", "-", int32_t(0x00000000), int32_t(0x7FD53EBA)},
    {"nttmpl.shp", "-", int32_t(0x00000000), int32_t(0x19770691)},
    {"nttmpl_a.shp", "-", int32_t(0x00000000), int32_t(0xC6D83548)},
    {"nttmplmk.shp", "-", int32_t(0x00000000), int32_t(0xC2768E79)},
    {"nttslamk.shp", "", int32_t(0x00000000), int32_t(0xECB7523E)},
    {"ntwall.shp", "-", int32_t(0x00000000), int32_t(0x3F606AE2)},
    {"ntwast.shp", "-", int32_t(0x00000000), int32_t(0xCECA9BCC)},
    {"ntwast_a.shp", "-", int32_t(0x00000000), int32_t(0x1165A815)},
    {"ntwast_b.shp", "-", int32_t(0x00000000), int32_t(0x56C5D2C5)},
    {"ntwastbb.shp", "-", int32_t(0x00000000), int32_t(0xE98DC380)},
    {"ntwastmk.shp", "-", int32_t(0x00000000), int32_t(0x15CB1324)},
    {"ntweap.shp", "-", int32_t(0x00000000), int32_t(0x59F7D885)},
    {"ntweap_1.shp", "-", int32_t(0x00000000), int32_t(0x7F8A0B93)},
    {"ntweap_2.shp", "-", int32_t(0x00000000), int32_t(0x382A7143)},
    {"ntweap_a.shp", "-", int32_t(0x00000000), int32_t(0x8658EB5C)},
    {"ntweap_b.shp", "-", int32_t(0x00000000), int32_t(0xC1F8918C)},
    {"ntweapbb.shp", "-", int32_t(0x00000000), int32_t(0x7EB080C9)},
    {"ntweapmk.shp", "-", int32_t(0x00000000), int32_t(0x82F6506D)},
    {"ntyardmk.shp", "", int32_t(0x00000000), int32_t(0xA076BFC7)},
    {"nuclonmk.shp", "", int32_t(0x00000000), int32_t(0xE3F5EDC5)},
    {"nucnstmk.shp", "", int32_t(0x00000000), int32_t(0x25B922A7)},
    {"nudeptmk.shp", "", int32_t(0x00000000), int32_t(0xCBBFA0E0)},
    {"nuflakmk.shp", "", int32_t(0x00000000), int32_t(0x426E1B14)},
    {"nuhandmk.shp", "", int32_t(0x00000000), int32_t(0x8280AEB5)},
    {"nuironmk.shp", "", int32_t(0x00000000), int32_t(0x90D5E4EF)},
    {"nuk2.shp", "advanced power plant", int32_t(0xB4DEFDCA), int32_t(0x00000000)},
    {"nuk2icnh.des", "icon: advanced power plant", int32_t(0xAD0F1FF9), int32_t(0x00000000)},
    {"nuk2icnh.tem", "icon: advanced power plant", int32_t(0xA70F2FF9), int32_t(0x00000000)},
    {"nuk2icnh.win", "icon: advanced power plant", int32_t(0xA81332F9), int32_t(0x00000000)},
    {"nuk2icon.shp", "icon: advanced power plant", int32_t(0xB6142EF9), int32_t(0x00000000)},
    {"nuk2make.shp", "make: advanced power plant", int32_t(0xA40C2B01), int32_t(0x00000000)},
    {"nukavail.aud", "nuclear missile available", int32_t(0xE2151913), int32_t(0x00000000)},
    {"nuke.shp", "power plant", int32_t(0xDADEFDCA), int32_t(0x00000000)},
    {"nuke.vqa", "nuclear expolsion", int32_t(0xCBE800CA), int32_t(0x00000000)},
    {"nuke.vqp", "nuclear expolsion", int32_t(0xDAE800CA), int32_t(0x00000000)},
    {"nuke1.aud", "nuclear warhead approaching", int32_t(0xBFAFB1DF), int32_t(0x00000000)},
    {"nukeanim.shp", "", int32_t(0x00000000), int32_t(0x5DDABEEE)},
    {"nukeball.shp", "", int32_t(0x00000000), int32_t(0x48B071E7)},
    {"nukedie.shp", "", int32_t(0x00000000), int32_t(0x8092EF25)},
    {"nukefact.vqp", "", int32_t(0x0E052DF3), int32_t(0x00000000)},
    {"nukeicnh.des", "icon: power plant", int32_t(0xF90F1FF9), int32_t(0x00000000)},
    {"nukeicnh.tem", "icon: power plant", int32_t(0xF30F2FF9), int32_t(0x00000000)},
    {"nukeicnh.win", "icon: power plant", int32_t(0xF41332F9), int32_t(0x00000000)},
    {"nukeicon.shp", "icon: power plant", int32_t(0x02142EF9), int32_t(0x7E115D56)},
    {"nukemake.shp", "make: power plant", int32_t(0xF00C2B01), int32_t(0x00000000)},
    {"nukemisl.aud", "nuclear missile", int32_t(0xF2292901), int32_t(0x00000000)},
    {"nukemisl.juv", "nuclear missile", int32_t(0x04293201), int32_t(0x00000000)},
    {"nukepuff.shp", "", int32_t(0x00000000), int32_t(0x0E94C4AB)},
    {"nukestm.shp", "", int32_t(0x00000000), int32_t(0x1CB6A874)},
    {"nukestok.vqa", "nuclear mushroom cloud", int32_t(0xED1D540D), int32_t(0x00000000)},
    {"nukestok.vqp", "vqp: nuclear mushroom cloud", int32_t(0xFC1D540D), int32_t(0x00000000)},
    {"nuketo.shp", "", int32_t(0x00000000), int32_t(0x0026B54B)},
    {"nukexplo.aud", "nuke explosion", int32_t(0xF81B3717), int32_t(0x00000000)},
    {"nukexplo.juv", "nuke explosion", int32_t(0x0A1B4017), int32_t(0x00000000)},
    {"nuklnch1.aud", "nuclear missile lauched", int32_t(0xD8131D03), int32_t(0x00000000)},
    {"nukswep1.aud", "", int32_t(0xF4232115), int32_t(0x00000000)},
    {"nulasrmk.shp", "", int32_t(0x00000000), int32_t(0x68DB83C1)},
    {"null.shp", "-", int32_t(0x00000000), int32_t(0xB09D6AE4)},
    {"number0.pcx", "", int32_t(0x00000000), int32_t(0xCD486C74)},
    {"number1.pcx", "", int32_t(0x00000000), int32_t(0x0614BFD1)},
    {"number2.pcx", "", int32_t(0x00000000), int32_t(0x8080CD7F)},
    {"number3.pcx", "", int32_t(0x00000000), int32_t(0x4BDC1EDA)},
    {"number4.pcx", "", int32_t(0x00000000), int32_t(0x56D92E62)},
    {"number5.pcx", "", int32_t(0x00000000), int32_t(0x9D85FDC7)},
    {"number6.pcx", "", int32_t(0x00000000), int32_t(0x1B118F69)},
    {"number7.pcx", "", int32_t(0x00000000), int32_t(0xD04D5CCC)},
    {"number8.pcx", "", int32_t(0x00000000), int32_t(0x211BEE19)},
    {"number9.pcx", "", int32_t(0x00000000), int32_t(0xEA473DBC)},
    {"numbers.pcx", "", int32_t(0x00000000), int32_t(0x43281180)},
    {"numbers.shp", "", int32_t(0x662C4216), int32_t(0x00000000)},
    {"numislmk.shp", "", int32_t(0x00000000), int32_t(0x0B20AD74)},
    {"nunrctmk.shp", "", int32_t(0x00000000), int32_t(0xE6082959)},
    {"nupowrmk.shp", "", int32_t(0x00000000), int32_t(0x19C137CF)},
    {"nupsismk.shp", "", int32_t(0x00000000), int32_t(0x9C73AE07)},
    {"nupsya.shp", "", int32_t(0x00000000), int32_t(0xCB889A23)},
    {"nupsya_a.shp", "", int32_t(0x00000000), int32_t(0x1427A9FA)},
    {"nupsybmk.shp", "", int32_t(0x00000000), int32_t(0x21610856)},
    {"nuradrmk.shp", "", int32_t(0x00000000), int32_t(0x27C20AA8)},
    {"nurefnmk.shp", "", int32_t(0x00000000), int32_t(0x9875AA63)},
    {"nusammk.shp", "", int32_t(0x00000000), int32_t(0x380D217D)},
    {"nutechmk.shp", "", int32_t(0x00000000), int32_t(0xBE5BE17A)},
    {"nutslamk.shp", "", int32_t(0x00000000), int32_t(0x2D398DFE)},
    {"nuwall.shp", "", int32_t(0x00000000), int32_t(0xFEEEB522)},
    {"nuweapmk.shp", "", int32_t(0x00000000), int32_t(0x43788FAD)},
    {"nuyardmk.shp", "", int32_t(0x00000000), int32_t(0x61F86007)},
    {"nuyell1.aud", "death scream 1", int32_t(0x720C4312), int32_t(0x00000000)},
    {"nuyell10.aud", "death scream 10", int32_t(0xBA1D2EFF), int32_t(0x00000000)},
    {"nuyell11.aud", "death scream 11", int32_t(0xBC1D2EFF), int32_t(0x00000000)},
    {"nuyell12.aud", "death scream 12", int32_t(0xBE1D2EFF), int32_t(0x00000000)},
    {"nuyell3.aud", "death scream 3", int32_t(0x72104312), int32_t(0x00000000)},
    {"nuyell4.aud", "death scream 4", int32_t(0x72124312), int32_t(0x00000000)},
    {"nuyell5.aud", "death scream 5", int32_t(0x72144312), int32_t(0x00000000)},
    {"nuyell6.aud", "death scream 6", int32_t(0x72164312), int32_t(0x00000000)},
    {"nuyell7.aud", "death scream 7", int32_t(0x72184312), int32_t(0x00000000)},
    {"nwalicon.shp", "icon: nod wall", int32_t(0x00000000), int32_t(0x9DFCC205)},
    {"nwepicon.shp", "icon: nod war factory", int32_t(0x00000000), int32_t(0xDEE3D31A)},
    {"nwod2.img", "", int32_t(0xABCFB9E4), int32_t(0x00000000)},
    {"nwod2.lmf", "", int32_t(0xABD5B9E3), int32_t(0x00000000)},
    {"nwod2.lsv", "", int32_t(0xB7D5B9F3), int32_t(0x00000000)},
    {"nwod2.odf", "", int32_t(0x99DBB9E3), int32_t(0x00000000)},
    {"nwod2.pcx", "", int32_t(0x97DDB9F5), int32_t(0x00000000)},
    {"nwod2.ver", "", int32_t(0x9BE9B9EF), int32_t(0x00000000)},
    {"oapedie1.aud", "", int32_t(0xBC20D8F3), int32_t(0x00000000)},
    {"obel.vqa", "obelisk of light", int32_t(0xD9DBDACC), int32_t(0x00000000)},
    {"obel.vqp", "obelisk of light", int32_t(0xE8DBDACC), int32_t(0x00000000)},
    {"obelcor3.aud", "cabals obelisk firing", int32_t(0x00000000), int32_t(0xC26DCA61)},
    {"obelmod1.aud", "cabals obelisk firing", int32_t(0x00000000), int32_t(0x78A86AB5)},
    {"obelpowr.aud", "obelisk of light powering up", int32_t(0x1A18E90B), int32_t(0xC4C633E7)},
    {"obelray1.aud", "obelisk of light sound", int32_t(0xD81CCD0F), int32_t(0x3244232A)},
    {"obelray1.juv", "obelisk of light sound", int32_t(0xEA1CD60F), int32_t(0x00000000)},
    {"objmet1.aud", "objective met", int32_t(0x91D00708), int32_t(0x00000000)},
    {"objnmet1.aud", "objective not met", int32_t(0xE026D505), int32_t(0x00000000)},
    {"objnrch1.aud", "objective not reached", int32_t(0xE00ED10F), int32_t(0x00000000)},
    {"objrch1.aud", "objective reached", int32_t(0xA5CFEF04), int32_t(0x00000000)},
    {"obl1.shp", "-", int32_t(0x00000000), int32_t(0xDF0CEC44)},
    {"obl1_a.shp", "-", int32_t(0x00000000), int32_t(0x5E88C6C7)},
    {"obl1_b.shp", "-", int32_t(0x00000000), int32_t(0x6F60DC5A)},
    {"obl1_c.shp", "-", int32_t(0x00000000), int32_t(0xC917D7EE)},
    {"obl2.shp", "-", int32_t(0x00000000), int32_t(0x98AC9694)},
    {"obl2_a.shp", "-", int32_t(0x00000000), int32_t(0x6705FA02)},
    {"obl2_b.shp", "-", int32_t(0x00000000), int32_t(0x56EDE09F)},
    {"obl2_c.shp", "-", int32_t(0x00000000), int32_t(0xF09AEB2B)},
    {"obli.shp", "obelisk of light", int32_t(0xE2E0D7CC), int32_t(0x00000000)},
    {"obliicnh.des", "icon: obelisk of light", int32_t(0x0912D3FD), int32_t(0x00000000)},
    {"obliicnh.tem", "icon: obelisk of light", int32_t(0x0312E3FD), int32_t(0x00000000)},
    {"obliicnh.win", "icon: obelisk of light", int32_t(0x0416E6FD), int32_t(0x00000000)},
    {"obliicon.shp", "icon: obelisk of light", int32_t(0x1217E2FD), int32_t(0x6691281C)},
    {"oblimake.shp", "make: obelisk of light", int32_t(0x000FDF05), int32_t(0x00000000)},
    {"obmbicon.shp", "icon: orca bomber", int32_t(0x00000000), int32_t(0x0B06DDFF)},
    {"obmglw.shp", "", int32_t(0x00000000), int32_t(0xC4C9889A)},
    {"obs_alli.pcx", "", int32_t(0x00000000), int32_t(0x919EE3C0)},
    {"obs_sovi.pcx", "", int32_t(0x00000000), int32_t(0x3CA5EEF6)},
    {"obs_yuri.pcx", "", int32_t(0x00000000), int32_t(0xF55A73A8)},
    {"obsalli.shp", "", int32_t(0x00000000), int32_t(0x0370167B)},
    {"observer.pal", "", int32_t(0x00000000), int32_t(0x81399FC3)},
    {"obsi.pcx", "", int32_t(0x00000000), int32_t(0x0B4718A4)},
    {"obsi.shp", "", int32_t(0x00000000), int32_t(0xE42EF704)},
    {"obssovi.shp", "", int32_t(0x00000000), int32_t(0xCC67B8EF)},
    {"obstacle1.vqa", "", int32_t(0x5A777C21), int32_t(0x00000000)},
    {"obsyuri.shp", "", int32_t(0x00000000), int32_t(0x407D3B81)},
    {"oceanfar.aud", "", int32_t(0xEDECDB07), int32_t(0x00000000)},
    {"offensedefense.map", "", int32_t(0x00000000), int32_t(0x761156B3)},
    {"oh3atk2.aud", "", int32_t(0x61760D26), int32_t(0x00000000)},
    {"oilbubl1.aud", "", int32_t(0xB01EEB15), int32_t(0x00000000)},
    {"oilbubl2.aud", "", int32_t(0xB21EEB15), int32_t(0x00000000)},
    {"oilbubl3.aud", "", int32_t(0xB41EEB15), int32_t(0x00000000)},
    {"oilbubl4.aud", "", int32_t(0xB61EEB15), int32_t(0x00000000)},
    {"oildrum.vqa", "artillery blows up barrels", int32_t(0x6E0D2137), int32_t(0x00000000)},
    {"oildrum.vqp", "vqp: artillery blows up barrels", int32_t(0x6E1C2137), int32_t(0x00000000)},
    {"oilleak.shp", "", int32_t(0x00000000), int32_t(0x34EB77ED)},
    {"oldcc2t.vqp", "", int32_t(0x6A09E719), int32_t(0x00000000)},
    {"oldchest.aud", "", int32_t(0xFA0CFCFB), int32_t(0x00000000)},
    {"oldmorph.aud", "", int32_t(0x0A071709), int32_t(0x00000000)},
    {"olow3.img", "", int32_t(0xF7CF8DEA), int32_t(0x00000000)},
    {"olow3.lmf", "", int32_t(0xF7D58DE9), int32_t(0x00000000)},
    {"olow3.lsv", "", int32_t(0x03D58DF8), int32_t(0x00000000)},
    {"olow3.odf", "", int32_t(0xE5DB8DE9), int32_t(0x00000000)},
    {"olow3.pcx", "", int32_t(0xE3DD8DFB), int32_t(0x00000000)},
    {"olow3.ver", "", int32_t(0xE7E98DF5), int32_t(0x00000000)},
    {"onetime.aud", "", int32_t(0xADE42910), int32_t(0x00000000)},
    {"onhold1.aud", "on hold", int32_t(0x99C81716), int32_t(0x00000000)},
    {"onit1.aud", "commando im on it", int32_t(0xFBA795E3), int32_t(0x00000000)},
    {"onthprwl.vqa", "sub moving underwater", int32_t(0xFB51340B), int32_t(0x00000000)},
    {"onthprwl.vqp", "vqp: sub moving underwater", int32_t(0x0A51340B), int32_t(0x00000000)},
    {"ops.shp", "", int32_t(0x5CF6E8F1), int32_t(0x00000000)},
    {"opt_curs.shp", "", int32_t(0x743E3EF0), int32_t(0x00000000)},
    {"opt_sldr.shp", "", int32_t(0x72222D10), int32_t(0x00000000)},
    {"optbtn.shp", "", int32_t(0x00000000), int32_t(0xFE67E97E)},
    {"opterm1.aud", "operation control terminated", int32_t(0x71F83122), int32_t(0x00000000)},
    {"option1.pcx", "", int32_t(0x820C212B), int32_t(0x00000000)},
    {"option2.pcx", "", int32_t(0x820E212B), int32_t(0x00000000)},
    {"option3.pcx", "", int32_t(0x8210212B), int32_t(0x00000000)},
    {"option4.pcx", "", int32_t(0x8212212B), int32_t(0x00000000)},
    {"option5.pcx", "", int32_t(0x8214212B), int32_t(0x00000000)},
    {"option6.pcx", "", int32_t(0x8216212B), int32_t(0x00000000)},
    {"option7.pcx", "", int32_t(0x8218212B), int32_t(0x00000000)},
    {"option8.pcx", "", int32_t(0x821A212B), int32_t(0x00000000)},
    {"option9.pcx", "", int32_t(0x821C212B), int32_t(0x00000000)},
    {"option_h.fnt", "", int32_t(0x0A5E2409), int32_t(0x00000000)},
    {"option_l.fnt", "", int32_t(0x125E2409), int32_t(0x00000000)},
    {"options.aud", "", int32_t(0x00000000), int32_t(0xD7F39D45)},
    {"options.ini", "", int32_t(0x82412C24), int32_t(0x00000000)},
    {"options.shp", "window bits", int32_t(0x8248262E), int32_t(0x00000000)},
    {"options.tre", "", int32_t(0x823D302F), int32_t(0x00000000)},
    {"options.trf", "", int32_t(0x823E302F), int32_t(0x00000000)},
    {"options.trg", "", int32_t(0x823F302F), int32_t(0x00000000)},
    {"options.tri", "", int32_t(0x8241302F), int32_t(0x00000000)},
    {"options.trs", "", int32_t(0x824B302F), int32_t(0x00000000)},
    {"optionx.wav", "", int32_t(0x00000000), int32_t(0xAB9D1EBA)},
    {"opttext.trr", "", int32_t(0xAE4C441B), int32_t(0x00000000)},
    {"orbappr1.aud", "", int32_t(0xAC032B0B), int32_t(0x00000000)},
    {"orc1atk1.aud", "", int32_t(0x6BF932ED), int32_t(0x00000000)},
    {"orc1atk2.aud", "", int32_t(0x6DF932ED), int32_t(0x00000000)},
    {"orc1deth.aud", "", int32_t(0x9A0B14F3), int32_t(0x00000000)},
    {"orc1hit1.aud", "", int32_t(0x6C0B1CFB), int32_t(0x00000000)},
    {"orc1hit2.aud", "", int32_t(0x6E0B1CFB), int32_t(0x00000000)},
    {"orc1htsh.aud", "", int32_t(0x9A0932FB), int32_t(0x00000000)},
    {"orc1kilb.aud", "", int32_t(0x8DFB1D01), int32_t(0x00000000)},
    {"orc2atk1.aud", "", int32_t(0x6FF932ED), int32_t(0x00000000)},
    {"orc2atk2.aud", "", int32_t(0x71F932ED), int32_t(0x00000000)},
    {"orc2deth.aud", "", int32_t(0x9E0B14F3), int32_t(0x00000000)},
    {"orc2hit1.aud", "", int32_t(0x700B1CFB), int32_t(0x00000000)},
    {"orc2hit2.aud", "", int32_t(0x720B1CFB), int32_t(0x00000000)},
    {"orc2htsh.aud", "", int32_t(0x9E0932FB), int32_t(0x00000000)},
    {"orc2kilb.aud", "", int32_t(0x91FB1D01), int32_t(0x00000000)},
    {"orc3atk1.aud", "", int32_t(0x73F932ED), int32_t(0x00000000)},
    {"orc3atk2.aud", "", int32_t(0x75F932ED), int32_t(0x00000000)},
    {"orc3deth.aud", "", int32_t(0xA20B14F3), int32_t(0x00000000)},
    {"orc3hit1.aud", "", int32_t(0x740B1CFB), int32_t(0x00000000)},
    {"orc3hit2.aud", "", int32_t(0x760B1CFB), int32_t(0x00000000)},
    {"orc3htsh.aud", "", int32_t(0xA20932FB), int32_t(0x00000000)},
    {"orc3kilb.aud", "", int32_t(0x95FB1D01), int32_t(0x00000000)},
    {"orca.hva", "-", int32_t(0x00000000), int32_t(0x1ED4712C)},
    {"orca.shp", "orca", int32_t(0xD2CEF7CC), int32_t(0x00000000)},
    {"orca.vxl", "orca fighter", int32_t(0x00000000), int32_t(0xE85EAE65)},
    {"orcab.hva", "-", int32_t(0x00000000), int32_t(0xCF254EFA)},
    {"orcab.vxl", "orca bomber", int32_t(0x00000000), int32_t(0x70BC495D)},
    {"orcadwn1.aud", "orca lands", int32_t(0x00000000), int32_t(0xC0EAD38A)},
    {"orcaicnh.des", "icon: orca", int32_t(0xE8EF13FD), int32_t(0x00000000)},
    {"orcaicnh.tem", "icon: orca", int32_t(0xE2EF23FD), int32_t(0x00000000)},
    {"orcaicnh.win", "icon: orca", int32_t(0xE3F326FD), int32_t(0x00000000)},
    {"orcaicon.shp", "icon: orca", int32_t(0xF1F422FD), int32_t(0x82B41542)},
    {"orcamis1.aud", "orca fighter attack", int32_t(0x00000000), int32_t(0x570C3E77)},
    {"orcastrk.vqa", "-", int32_t(0x00000000), int32_t(0x4D654FD5)},
    {"orcatran.hva", "-", int32_t(0x00000000), int32_t(0x302B940E)},
    {"orcatran.vxl", "orca transport", int32_t(0x00000000), int32_t(0xC6A14B47)},
    {"orcaup1.aud", "orca takes off", int32_t(0x00000000), int32_t(0x6E93782C)},
    {"oregath.shp", "", int32_t(0x00000000), int32_t(0xF0444E48)},
    {"oretruk1.aud", "", int32_t(0xF801350F), int32_t(0x00000000)},
    {"organ1.aud", "", int32_t(0x8779F02E), int32_t(0x00000000)},
    {"organ2.aud", "", int32_t(0x8779F22E), int32_t(0x00000000)},
    {"otp.aud", "on the prowl", int32_t(0x5CE4FDDF), int32_t(0x00000000)},
    {"otrnicon.shp", "icon: carryall", int32_t(0x00000000), int32_t(0x7DD4FA06)},
    {"ottersrevenge.map", "", int32_t(0x00000000), int32_t(0x0C483112)},
    {"oudatk1.aud", "", int32_t(0x61B84126), int32_t(0x00000000)},
    {"out.vqa", "", int32_t(0x5CE9FBF4), int32_t(0x00000000)},
    {"outp.hva", "", int32_t(0x00000000), int32_t(0x9820C3B3)},
    {"outp.vxl", "", int32_t(0x00000000), int32_t(0x6EAA1CFA)},
    {"outtakes", "", int32_t(0xFBEDF5DF), int32_t(0x00000000)},
    {"outtakes.aud", "", int32_t(0x3C312CED), int32_t(0x00000000)},
    {"outtakes\\blade.vqa", "", int32_t(0x90FD8446), int32_t(0x00000000)},
    {"outtakes\\cem_apr.vqa", "", int32_t(0xFA769559), int32_t(0x00000000)},
    {"outtakes\\credit01.vqa", "", int32_t(0x4D6EFA8E), int32_t(0x00000000)},
    {"outtakes\\credit02.vqa", "", int32_t(0x4D6EFA90), int32_t(0x00000000)},
    {"outtakes\\credit03.vqa", "", int32_t(0x4D6EFA92), int32_t(0x00000000)},
    {"outtakes\\credit04.vqa", "", int32_t(0x4D6EFA94), int32_t(0x00000000)},
    {"outtakes\\credit05.vqa", "", int32_t(0x4D6EFA96), int32_t(0x00000000)},
    {"outtakes\\credit06.vqa", "", int32_t(0x4D6EFA98), int32_t(0x00000000)},
    {"outtakes\\credit07.vqa", "", int32_t(0x4D6EFA9A), int32_t(0x00000000)},
    {"outtakes\\credit08.vqa", "", int32_t(0x4D6EFA9C), int32_t(0x00000000)},
    {"outtakes\\credit09.vqa", "", int32_t(0x4D6EFA9E), int32_t(0x00000000)},
    {"outtakes\\credit10.vqa", "", int32_t(0x516EFA8C), int32_t(0x00000000)},
    {"outtakes\\credit11.vqa", "", int32_t(0x516EFA8E), int32_t(0x00000000)},
    {"outtakes\\credit12.vqa", "", int32_t(0x516EFA90), int32_t(0x00000000)},
    {"outtakes\\credit13.vqa", "", int32_t(0x516EFA92), int32_t(0x00000000)},
    {"outtakes\\credit14.vqa", "", int32_t(0x516EFA94), int32_t(0x00000000)},
    {"outtakes\\credit15.vqa", "", int32_t(0x516EFA96), int32_t(0x00000000)},
    {"outtakes\\credit16.vqa", "", int32_t(0x516EFA98), int32_t(0x00000000)},
    {"outtakes\\credit23.vqa", "", int32_t(0x556EFA92), int32_t(0x00000000)},
    {"outtakes\\credit35.vqa", "", int32_t(0x596EFA96), int32_t(0x00000000)},
    {"outtakes\\credit37.vqa", "", int32_t(0x596EFA9A), int32_t(0x00000000)},
    {"outtakes\\credit38.vqa", "", int32_t(0x596EFA9C), int32_t(0x00000000)},
    {"outtakes\\credit39.vqa", "", int32_t(0x596EFA9E), int32_t(0x00000000)},
    {"outtakes\\credit40.vqa", "", int32_t(0x5D6EFA8C), int32_t(0x00000000)},
    {"outtakes\\credit41.vqa", "", int32_t(0x5D6EFA8E), int32_t(0x00000000)},
    {"outtakes\\credit42.vqa", "", int32_t(0x5D6EFA90), int32_t(0x00000000)},
    {"outtakes\\e030e.vqa", "", int32_t(0x588D901E), int32_t(0x00000000)},
    {"outtakes\\e031e.vqa", "", int32_t(0x588D9020), int32_t(0x00000000)},
    {"outtakes\\gla_apr.vqa", "", int32_t(0xCA92A559), int32_t(0x00000000)},
    {"outtakes\\hv1-v-rl.vqa", "", int32_t(0x34F35668), int32_t(0x00000000)},
    {"outtakes\\lolg.vqa", "", int32_t(0xB3593D3C), int32_t(0x00000000)},
    {"outtakes\\mcredit1.vqa", "", int32_t(0x44CB3691), int32_t(0x00000000)},
    {"outtakes\\mcredit2.vqa", "", int32_t(0x44CB3693), int32_t(0x00000000)},
    {"outtakes\\mintro01.vqa", "", int32_t(0x95136ECE), int32_t(0x00000000)},
    {"outtakes\\mlogo.vqa", "", int32_t(0xC8FDC44C), int32_t(0x00000000)},
    {"outtakes\\msizzle.vqa", "", int32_t(0xD0A6EF4F), int32_t(0x00000000)},
    {"outtakes\\ruin_app.vqa", "", int32_t(0xED3BCAF4), int32_t(0x00000000)},
    {"outtakes\\sizzle_h.vqa", "", int32_t(0xB0EB8711), int32_t(0x00000000)},
    {"outtakes\\sizzle_l.vqa", "", int32_t(0xB0EB8719), int32_t(0x00000000)},
    {"outtakes\\title_e.vqa", "", int32_t(0xFCA4E133), int32_t(0x00000000)},
    {"outtakes\\tower_ap.vqa", "", int32_t(0x2183A6CF), int32_t(0x00000000)},
    {"outtakes\\tribute.vqa", "", int32_t(0xD0B3011F), int32_t(0x00000000)},
    {"outtakes\\wrm_stat.vqa", "", int32_t(0xD16FC340), int32_t(0x00000000)},
    {"overout.r01", "soviet #2 as you wish", int32_t(0xA5EF342D), int32_t(0x00000000)},
    {"overout.r03", "soviet #4 as you wish", int32_t(0xA5F1342D), int32_t(0x00000000)},
    {"overout.v01", "c&c #1 over and out", int32_t(0xA5EF3431), int32_t(0x00000000)},
    {"overout.v03", "c&c #3 over and out", int32_t(0xA5F13431), int32_t(0x00000000)},
    {"overrun.vqa", "soldiers nearly run over", int32_t(0xA5F35537), int32_t(0x00000000)},
    {"overrun.vqp", "vqp: soldiers nearly run over", int32_t(0xA6025537), int32_t(0x00000000)},
    {"ovrps01.des", "", int32_t(0x00000000), int32_t(0xCE3F25FC)},
    {"ovrps01.sno", "-", int32_t(0x00000000), int32_t(0xE9D3F866)},
    {"ovrps01.tem", "-", int32_t(0x00000000), int32_t(0x4A674DBC)},
    {"ovrps01.ubn", "", int32_t(0x00000000), int32_t(0xDCB96F9F)},
    {"ovrps01.urb", "", int32_t(0x00000000), int32_t(0x6C2A83E3)},
    {"ovrps01a.des", "", int32_t(0x00000000), int32_t(0xF7F75C13)},
    {"ovrps01a.sno", "-", int32_t(0x00000000), int32_t(0x196B6C62)},
    {"ovrps01a.tem", "-", int32_t(0x00000000), int32_t(0x11DEC200)},
    {"ovrps01a.ubn", "", int32_t(0x00000000), int32_t(0xC6546F4A)},
    {"ovrps01a.urb", "", int32_t(0x00000000), int32_t(0x85203130)},
    {"ovrps02.des", "", int32_t(0x00000000), int32_t(0x48AB5752)},
    {"ovrps02.sno", "-", int32_t(0x00000000), int32_t(0x6F478AC8)},
    {"ovrps02.tem", "-", int32_t(0x00000000), int32_t(0xCCF33F12)},
    {"ovrps02.ubn", "", int32_t(0x00000000), int32_t(0x5A2D1D31)},
    {"ovrps02.urb", "", int32_t(0x00000000), int32_t(0xEABEF14D)},
    {"ovrps02a.des", "", int32_t(0x00000000), int32_t(0x71632EBD)},
    {"ovrps02a.sno", "-", int32_t(0x00000000), int32_t(0x9FFF1ECC)},
    {"ovrps02a.tem", "-", int32_t(0x00000000), int32_t(0x974AB0AE)},
    {"ovrps02a.ubn", "", int32_t(0x00000000), int32_t(0x40C01DE4)},
    {"ovrps02a.urb", "", int32_t(0x00000000), int32_t(0x03B4439E)},
    {"ovrps03.des", "", int32_t(0x00000000), int32_t(0x83F784F7)},
    {"ovrps03.sno", "-", int32_t(0x00000000), int32_t(0xA41B596D)},
    {"ovrps03.tem", "-", int32_t(0x00000000), int32_t(0x07AFECB7)},
    {"ovrps03.ubn", "", int32_t(0x00000000), int32_t(0x9171CE94)},
    {"ovrps03.urb", "", int32_t(0x00000000), int32_t(0x21E222E8)},
    {"ovrps03a.des", "", int32_t(0x00000000), int32_t(0xBA3FFD18)},
    {"ovrps03a.sno", "-", int32_t(0x00000000), int32_t(0x54A3CD69)},
    {"ovrps03a.tem", "-", int32_t(0x00000000), int32_t(0x5C16630B)},
    {"ovrps03a.ubn", "", int32_t(0x00000000), int32_t(0x8B9CCE41)},
    {"ovrps03a.urb", "", int32_t(0x00000000), int32_t(0xC8E8903B)},
    {"ovrps04.des", "", int32_t(0x00000000), int32_t(0x9EF2B44F)},
    {"ovrps04.sno", "-", int32_t(0x00000000), int32_t(0xB91E69D5)},
    {"ovrps04.tem", "-", int32_t(0x00000000), int32_t(0x1AAADC0F)},
    {"ovrps04.ubn", "", int32_t(0x00000000), int32_t(0x8C74FE2C)},
    {"ovrps04.urb", "", int32_t(0x00000000), int32_t(0x3CE71250)},
    {"ovrps04a.des", "", int32_t(0x00000000), int32_t(0xA73ACDA0)},
    {"ovrps04a.sno", "-", int32_t(0x00000000), int32_t(0x49A6FDD1)},
    {"ovrps04a.tem", "-", int32_t(0x00000000), int32_t(0x411353B3)},
    {"ovrps04a.ubn", "", int32_t(0x00000000), int32_t(0x9699FEF9)},
    {"ovrps04a.urb", "", int32_t(0x00000000), int32_t(0xD5EDA083)},
    {"ovrps05.des", "", int32_t(0x00000000), int32_t(0x55AE67EA)},
    {"ovrps05.sno", "-", int32_t(0x00000000), int32_t(0x7242BA70)},
    {"ovrps05.tem", "-", int32_t(0x00000000), int32_t(0xD1F60FAA)},
    {"ovrps05.ubn", "", int32_t(0x00000000), int32_t(0x47282D89)},
    {"ovrps05.urb", "", int32_t(0x00000000), int32_t(0xF7BBC1F5)},
    {"ovrps05a.des", "", int32_t(0x00000000), int32_t(0x6C661E05)},
    {"ovrps05a.sno", "-", int32_t(0x00000000), int32_t(0x82FA2E74)},
    {"ovrps05a.tem", "-", int32_t(0x00000000), int32_t(0x8A4F8016)},
    {"ovrps05a.ubn", "", int32_t(0x00000000), int32_t(0x5DC52D5C)},
    {"ovrps05a.urb", "", int32_t(0x00000000), int32_t(0x1EB17326)},
    {"ovrps06.des", "", int32_t(0x00000000), int32_t(0xD33A1544)},
    {"ovrps06.sno", "-", int32_t(0x00000000), int32_t(0xF4D6C8DE)},
    {"ovrps06.tem", "-", int32_t(0x00000000), int32_t(0x57627D04)},
    {"ovrps06.ubn", "", int32_t(0x00000000), int32_t(0xC1BC5F27)},
    {"ovrps06.urb", "", int32_t(0x00000000), int32_t(0x712FB35B)},
    {"ovrps06a.des", "", int32_t(0x00000000), int32_t(0xEAF26CAB)},
    {"ovrps06a.sno", "-", int32_t(0x00000000), int32_t(0x046E5CDA)},
    {"ovrps06a.tem", "-", int32_t(0x00000000), int32_t(0x0CDBF2B8)},
    {"ovrps06a.ubn", "", int32_t(0x00000000), int32_t(0xDB515FF2)},
    {"ovrps06a.urb", "", int32_t(0x00000000), int32_t(0x98250188)},
    {"ovrps07.des", "", int32_t(0x00000000), int32_t(0x1866C6E1)},
    {"ovrps07.sno", "-", int32_t(0x00000000), int32_t(0x3F8A1B7B)},
    {"ovrps07.tem", "-", int32_t(0x00000000), int32_t(0x9C3EAEA1)},
    {"ovrps07.ubn", "", int32_t(0x00000000), int32_t(0x0AE08C82)},
    {"ovrps07.urb", "", int32_t(0x00000000), int32_t(0xBA7360FE)},
    {"ovrps08.des", "", int32_t(0x00000000), int32_t(0xE9307434)},
    {"ovrps08.sno", "-", int32_t(0x00000000), int32_t(0xCEDCA9AE)},
    {"ovrps08.tem", "-", int32_t(0x00000000), int32_t(0x6D681C74)},
    {"ovrps08.ubn", "", int32_t(0x00000000), int32_t(0xFBB63E57)},
    {"ovrps08.urb", "", int32_t(0x00000000), int32_t(0x4B25D22B)},
    {"ovrps09.des", "", int32_t(0x00000000), int32_t(0x226CA791)},
    {"ovrps09.sno", "-", int32_t(0x00000000), int32_t(0x05807A0B)},
    {"ovrps09.tem", "-", int32_t(0x00000000), int32_t(0xA634CFD1)},
    {"ovrps09.ubn", "", int32_t(0x00000000), int32_t(0x30EAEDF2)},
    {"ovrps09.urb", "", int32_t(0x00000000), int32_t(0x8079018E)},
    {"ovrps10.des", "", int32_t(0x00000000), int32_t(0xA314FDED)},
    {"ovrps10.sno", "-", int32_t(0x00000000), int32_t(0x84F82077)},
    {"ovrps10.tem", "-", int32_t(0x00000000), int32_t(0x274C95AD)},
    {"ovrps10.ubn", "", int32_t(0x00000000), int32_t(0xB192B78E)},
    {"ovrps10.urb", "", int32_t(0x00000000), int32_t(0x01015BF2)},
    {"ovrps11.des", "", int32_t(0x00000000), int32_t(0x68482E48)},
    {"ovrps11.sno", "-", int32_t(0x00000000), int32_t(0x4FA4F3D2)},
    {"ovrps11.tem", "-", int32_t(0x00000000), int32_t(0xEC104608)},
    {"ovrps11.ubn", "", int32_t(0x00000000), int32_t(0x7ACE642B)},
    {"ovrps11.urb", "", int32_t(0x00000000), int32_t(0xCA5D8857)},
    {"ovrps12.des", "", int32_t(0x00000000), int32_t(0xEEDC5CE6)},
    {"ovrps12.sno", "-", int32_t(0x00000000), int32_t(0xC930817C)},
    {"ovrps12.tem", "-", int32_t(0x00000000), int32_t(0x6A8434A6)},
    {"ovrps12.ubn", "", int32_t(0x00000000), int32_t(0xFC5A1685)},
    {"ovrps12.urb", "", int32_t(0x00000000), int32_t(0x4CC9FAF9)},
    {"ovrps13.des", "", int32_t(0x00000000), int32_t(0x25808F43)},
    {"ovrps13.sno", "-", int32_t(0x00000000), int32_t(0x026C52D9)},
    {"ovrps13.tem", "-", int32_t(0x00000000), int32_t(0xA1D8E703)},
    {"ovrps13.ubn", "", int32_t(0x00000000), int32_t(0x3706C520)},
    {"ovrps13.urb", "", int32_t(0x00000000), int32_t(0x8795295C)},
    {"ovrps14.des", "", int32_t(0x00000000), int32_t(0x3885BFFB)},
    {"ovrps14.sno", "-", int32_t(0x00000000), int32_t(0x1F696261)},
    {"ovrps14.tem", "-", int32_t(0x00000000), int32_t(0xBCDDD7BB)},
    {"ovrps14.ubn", "", int32_t(0x00000000), int32_t(0x2A03F598)},
    {"ovrps14.urb", "", int32_t(0x00000000), int32_t(0x9A9019E4)},
    {"ovrps15.des", "", int32_t(0x00000000), int32_t(0xF3D96C5E)},
    {"ovrps15.sno", "-", int32_t(0x00000000), int32_t(0xD435B1C4)},
    {"ovrps15.tem", "-", int32_t(0x00000000), int32_t(0x7781041E)},
    {"ovrps15.ubn", "", int32_t(0x00000000), int32_t(0xE15F263D)},
    {"ovrps15.urb", "", int32_t(0x00000000), int32_t(0x51CCCA41)},
    {"ovrps16.des", "", int32_t(0x00000000), int32_t(0x754D1EF0)},
    {"ovrps16.sno", "-", int32_t(0x00000000), int32_t(0x52A1C36A)},
    {"ovrps16.tem", "-", int32_t(0x00000000), int32_t(0xF11576B0)},
    {"ovrps16.ubn", "", int32_t(0x00000000), int32_t(0x67CB5493)},
    {"ovrps16.urb", "", int32_t(0x00000000), int32_t(0xD758B8EF)},
    {"ovrpsb01.des", "", int32_t(0x00000000), int32_t(0xBE8EAE7B)},
    {"ovrpsb01.lun", "", int32_t(0x00000000), int32_t(0x9959814B)},
    {"ovrpsb01.sno", "", int32_t(0x00000000), int32_t(0x50129E0A)},
    {"ovrpsb01.tem", "", int32_t(0x00000000), int32_t(0x58A73068)},
    {"ovrpsb01.ubn", "", int32_t(0x00000000), int32_t(0x8F2D9D22)},
    {"ovrpsb01.urb", "", int32_t(0x00000000), int32_t(0xCC59C358)},
    {"ovrpsb01a.des", "", int32_t(0x00000000), int32_t(0x7E3A773C)},
    {"ovrpsb01a.lun", "", int32_t(0x00000000), int32_t(0xCC90ED54)},
    {"ovrpsb01a.sno", "", int32_t(0x00000000), int32_t(0xFF809D3B)},
    {"ovrpsb01a.tem", "", int32_t(0x00000000), int32_t(0xE36457B7)},
    {"ovrpsb01a.ubn", "", int32_t(0x00000000), int32_t(0x3A89F595)},
    {"ovrpsb01a.urb", "", int32_t(0x00000000), int32_t(0xB5BCDE88)},
    {"ovrpsb02.des", "", int32_t(0x00000000), int32_t(0xF92ED4AB)},
    {"ovrpsb02.lun", "", int32_t(0x00000000), int32_t(0xDEF9FB9B)},
    {"ovrpsb02.sno", "", int32_t(0x00000000), int32_t(0x17B2E4DA)},
    {"ovrpsb02.tem", "", int32_t(0x00000000), int32_t(0x1F074AB8)},
    {"ovrpsb02.ubn", "", int32_t(0x00000000), int32_t(0xC88DE7F2)},
    {"ovrpsb02.urb", "", int32_t(0x00000000), int32_t(0x8BF9B988)},
    {"ovrpsb02a.des", "", int32_t(0x00000000), int32_t(0x47B74BF9)},
    {"ovrpsb02a.lun", "", int32_t(0x00000000), int32_t(0xF51DD191)},
    {"ovrpsb02a.sno", "", int32_t(0x00000000), int32_t(0xC60DA1FE)},
    {"ovrpsb02a.tem", "", int32_t(0x00000000), int32_t(0xDAE96B72)},
    {"ovrpsb02a.ubn", "", int32_t(0x00000000), int32_t(0x0304C950)},
    {"ovrpsb02a.urb", "", int32_t(0x00000000), int32_t(0x8C31E24D)},
    {"ovrpsb03.des", "", int32_t(0x00000000), int32_t(0xC44EFD1B)},
    {"ovrpsb03.lun", "", int32_t(0x00000000), int32_t(0xE399D22B)},
    {"ovrpsb03.sno", "", int32_t(0x00000000), int32_t(0x2AD2CD6A)},
    {"ovrpsb03.tem", "", int32_t(0x00000000), int32_t(0x22676308)},
    {"ovrpsb03.ubn", "", int32_t(0x00000000), int32_t(0xF5EDCE42)},
    {"ovrpsb03.urb", "", int32_t(0x00000000), int32_t(0xB6999038)},
    {"ovrpsb03a.des", "", int32_t(0x00000000), int32_t(0x50CC5FBA)},
    {"ovrpsb03a.lun", "", int32_t(0x00000000), int32_t(0xE266C5D2)},
    {"ovrpsb03a.sno", "", int32_t(0x00000000), int32_t(0xD176B5BD)},
    {"ovrpsb03a.tem", "", int32_t(0x00000000), int32_t(0xCD927F31)},
    {"ovrpsb03a.ubn", "", int32_t(0x00000000), int32_t(0x147FDD13)},
    {"ovrpsb03a.urb", "", int32_t(0x00000000), int32_t(0x9B4AF60E)},
    {"ovrpsb04.des", "", int32_t(0x00000000), int32_t(0x766E210B)},
    {"ovrpsb04.lun", "", int32_t(0x00000000), int32_t(0x51B90E3B)},
    {"ovrpsb04.sno", "", int32_t(0x00000000), int32_t(0x98F2117A)},
    {"ovrpsb04.tem", "", int32_t(0x00000000), int32_t(0x9047BF18)},
    {"ovrpsb04.ubn", "", int32_t(0x00000000), int32_t(0x47CD1252)},
    {"ovrpsb04.urb", "", int32_t(0x00000000), int32_t(0x04B94C28)},
    {"ovrpsb04a.des", "", int32_t(0x00000000), int32_t(0x34AD3273)},
    {"ovrpsb04a.lun", "", int32_t(0x00000000), int32_t(0x8607A81B)},
    {"ovrpsb04a.sno", "", int32_t(0x00000000), int32_t(0xB517D874)},
    {"ovrpsb04a.tem", "", int32_t(0x00000000), int32_t(0xA9F312F8)},
    {"ovrpsb04a.ubn", "", int32_t(0x00000000), int32_t(0x701EB0DA)},
    {"ovrpsb04a.urb", "", int32_t(0x00000000), int32_t(0xFF2B9BC7)},
    {"ovrpsb05.des", "", int32_t(0x00000000), int32_t(0x4B0E08BB)},
    {"ovrpsb05.lun", "", int32_t(0x00000000), int32_t(0x6CD9278B)},
    {"ovrpsb05.sno", "", int32_t(0x00000000), int32_t(0xA59238CA)},
    {"ovrpsb05.tem", "", int32_t(0x00000000), int32_t(0xAD2796A8)},
    {"ovrpsb05.ubn", "", int32_t(0x00000000), int32_t(0x7AAD3BE2)},
    {"ovrpsb05.urb", "", int32_t(0x00000000), int32_t(0x39D96598)},
    {"ovrpsb05a.des", "", int32_t(0x00000000), int32_t(0x23D62630)},
    {"ovrpsb05a.lun", "", int32_t(0x00000000), int32_t(0x917CBC58)},
    {"ovrpsb05a.sno", "", int32_t(0x00000000), int32_t(0xA26CCC37)},
    {"ovrpsb05a.tem", "", int32_t(0x00000000), int32_t(0xBE8806BB)},
    {"ovrpsb05a.ubn", "", int32_t(0x00000000), int32_t(0x6765A499)},
    {"ovrpsb05a.urb", "", int32_t(0x00000000), int32_t(0xE8508F84)},
    {"ovrpsb06.des", "", int32_t(0x00000000), int32_t(0x0CAE726B)},
    {"ovrpsb06.lun", "", int32_t(0x00000000), int32_t(0x2B795D5B)},
    {"ovrpsb06.sno", "", int32_t(0x00000000), int32_t(0xE232421A)},
    {"ovrpsb06.tem", "", int32_t(0x00000000), int32_t(0xEA87EC78)},
    {"ovrpsb06.ubn", "", int32_t(0x00000000), int32_t(0x3D0D4132)},
    {"ovrpsb06.urb", "", int32_t(0x00000000), int32_t(0x7E791F48)},
    {"ovrpsb06a.des", "", int32_t(0x00000000), int32_t(0x1A5B1AF5)},
    {"ovrpsb06a.lun", "", int32_t(0x00000000), int32_t(0xA8F1809D)},
    {"ovrpsb06a.sno", "", int32_t(0x00000000), int32_t(0x9BE1F0F2)},
    {"ovrpsb06a.tem", "", int32_t(0x00000000), int32_t(0x87053A7E)},
    {"ovrpsb06a.ubn", "", int32_t(0x00000000), int32_t(0x5EE8985C)},
    {"ovrpsb06a.urb", "", int32_t(0x00000000), int32_t(0xD1DDB341)},
    {"ovrpsb07.des", "", int32_t(0x00000000), int32_t(0x31CE5BDB)},
    {"ovrpsb07.lun", "", int32_t(0x00000000), int32_t(0x161974EB)},
    {"ovrpsb07.sno", "", int32_t(0x00000000), int32_t(0xDF526BAA)},
    {"ovrpsb07.tem", "", int32_t(0x00000000), int32_t(0xD7E7C5C8)},
    {"ovrpsb07.ubn", "", int32_t(0x00000000), int32_t(0x006D6882)},
    {"ovrpsb07.urb", "", int32_t(0x00000000), int32_t(0x431936F8)},
    {"ovrpsb08.des", "", int32_t(0x00000000), int32_t(0xB39ECC0A)},
    {"ovrpsb08.lun", "", int32_t(0x00000000), int32_t(0x9449E33A)},
    {"ovrpsb08.sno", "", int32_t(0x00000000), int32_t(0x5D02FC7B)},
    {"ovrpsb08.tem", "", int32_t(0x00000000), int32_t(0x55B75219)},
    {"ovrpsb08.ubn", "", int32_t(0x00000000), int32_t(0x823DFF53)},
    {"ovrpsb08.urb", "", int32_t(0x00000000), int32_t(0xC149A129)},
    {"ovrpsb09.des", "", int32_t(0x00000000), int32_t(0x8EFEE5BA)},
    {"ovrpsb09.lun", "", int32_t(0x00000000), int32_t(0xA929CA8A)},
    {"ovrpsb09.sno", "", int32_t(0x00000000), int32_t(0x6062D5CB)},
    {"ovrpsb09.tem", "", int32_t(0x00000000), int32_t(0x68D77BA9)},
    {"ovrpsb09.ubn", "", int32_t(0x00000000), int32_t(0xBF5DD6E3)},
    {"ovrpsb09.urb", "", int32_t(0x00000000), int32_t(0xFC298899)},
    {"ovrpsb10.des", "", int32_t(0x00000000), int32_t(0x48B2546E)},
    {"ovrpsb10.lun", "", int32_t(0x00000000), int32_t(0x6F657B5E)},
    {"ovrpsb10.sno", "", int32_t(0x00000000), int32_t(0xA62E641F)},
    {"ovrpsb10.tem", "", int32_t(0x00000000), int32_t(0xAE9BCA7D)},
    {"ovrpsb10.ubn", "", int32_t(0x00000000), int32_t(0x79116737)},
    {"ovrpsb10.urb", "", int32_t(0x00000000), int32_t(0x3A65394D)},
    {"ovrpsb11.des", "", int32_t(0x00000000), int32_t(0x75D27DDE)},
    {"ovrpsb11.lun", "", int32_t(0x00000000), int32_t(0x520552EE)},
    {"ovrpsb11.sno", "", int32_t(0x00000000), int32_t(0x9B4E4DAF)},
    {"ovrpsb11.tem", "", int32_t(0x00000000), int32_t(0x93FBE3CD)},
    {"ovrpsb11.ubn", "", int32_t(0x00000000), int32_t(0x44714E87)},
    {"ovrpsb11.urb", "", int32_t(0x00000000), int32_t(0x070510FD)},
    {"ovrpsb12.des", "", int32_t(0x00000000), int32_t(0x3272070E)},
    {"ovrpsb12.lun", "", int32_t(0x00000000), int32_t(0x15A5283E)},
    {"ovrpsb12.sno", "", int32_t(0x00000000), int32_t(0xDCEE377F)},
    {"ovrpsb12.tem", "", int32_t(0x00000000), int32_t(0xD45B991D)},
    {"ovrpsb12.ubn", "", int32_t(0x00000000), int32_t(0x03D13457)},
    {"ovrpsb12.urb", "", int32_t(0x00000000), int32_t(0x40A56A2D)},
    {"ovrpsb13.des", "", int32_t(0x00000000), int32_t(0x0F122EBE)},
    {"ovrpsb13.lun", "", int32_t(0x00000000), int32_t(0x28C5018E)},
    {"ovrpsb13.sno", "", int32_t(0x00000000), int32_t(0xE18E1ECF)},
    {"ovrpsb13.tem", "", int32_t(0x00000000), int32_t(0xE93BB0AD)},
    {"ovrpsb13.ubn", "", int32_t(0x00000000), int32_t(0x3EB11DE7)},
    {"ovrpsb13.urb", "", int32_t(0x00000000), int32_t(0x7DC5439D)},
    {"ovrpsb14.des", "", int32_t(0x00000000), int32_t(0xBD32F2AE)},
    {"ovrpsb14.lun", "", int32_t(0x00000000), int32_t(0x9AE5DD9E)},
    {"ovrpsb14.sno", "", int32_t(0x00000000), int32_t(0x53AEC2DF)},
    {"ovrpsb14.tem", "", int32_t(0x00000000), int32_t(0x5B1B6CBD)},
    {"ovrpsb14.ubn", "", int32_t(0x00000000), int32_t(0x8C91C1F7)},
    {"ovrpsb14.urb", "", int32_t(0x00000000), int32_t(0xCFE59F8D)},
    {"ovrpsb15.des", "", int32_t(0x00000000), int32_t(0x8052DB1E)},
    {"ovrpsb15.lun", "", int32_t(0x00000000), int32_t(0xA785F42E)},
    {"ovrpsb15.sno", "", int32_t(0x00000000), int32_t(0x6ECEEB6F)},
    {"ovrpsb15.tem", "", int32_t(0x00000000), int32_t(0x667B450D)},
    {"ovrpsb15.ubn", "", int32_t(0x00000000), int32_t(0xB1F1E847)},
    {"ovrpsb15.urb", "", int32_t(0x00000000), int32_t(0xF285B63D)},
    {"ovrpsb16.des", "", int32_t(0x00000000), int32_t(0xC7F2A1CE)},
    {"ovrpsb16.lun", "", int32_t(0x00000000), int32_t(0xE0258EFE)},
    {"ovrpsb16.sno", "", int32_t(0x00000000), int32_t(0x296E91BF)},
    {"ovrpsb16.tem", "", int32_t(0x00000000), int32_t(0x21DB3FDD)},
    {"ovrpsb16.ubn", "", int32_t(0x00000000), int32_t(0xF6519297)},
    {"ovrpsb16.urb", "", int32_t(0x00000000), int32_t(0xB525CCED)},
    {"owl1.aud", "", int32_t(0xA6EDEFCC), int32_t(0x00000000)},
    {"owl2.aud", "", int32_t(0xA8EDEFCC), int32_t(0x00000000)},
    {"owl3.aud", "", int32_t(0xAAEDEFCC), int32_t(0x00000000)},
    {"oxanna.shp", "unit: oxanna", int32_t(0x00000000), int32_t(0x7824EC89)},
    {"p01.des", "debris", int32_t(0x5CB5A5E4), int32_t(0x00000000)},
    {"p01.sno", "debris", int32_t(0x5CB1AEF3), int32_t(0x00000000)},
    {"p01.tem", "debris", int32_t(0x5CAFA5F4), int32_t(0x00000000)},
    {"p02.des", "debris", int32_t(0x5CB7A5E4), int32_t(0x00000000)},
    {"p02.sno", "debris", int32_t(0x5CB3AEF3), int32_t(0x00000000)},
    {"p02.tem", "debris", int32_t(0x5CB1A5F4), int32_t(0x00000000)},
    {"p03.des", "debris", int32_t(0x5CB9A5E4), int32_t(0x00000000)},
    {"p03.sno", "debris", int32_t(0x5CB5AEF3), int32_t(0x00000000)},
    {"p03.tem", "debris", int32_t(0x5CB3A5F4), int32_t(0x00000000)},
    {"p04.des", "debris", int32_t(0x5CBBA5E4), int32_t(0x00000000)},
    {"p04.sno", "debris", int32_t(0x5CB7AEF3), int32_t(0x00000000)},
    {"p04.tem", "debris", int32_t(0x5CB5A5F4), int32_t(0x00000000)},
    {"p05.des", "gray sand", int32_t(0x5CBDA5E4), int32_t(0x00000000)},
    {"p06.des", "gray sand", int32_t(0x5CBFA5E4), int32_t(0x00000000)},
    {"p07.des", "debris", int32_t(0x5CC1A5E4), int32_t(0x00000000)},
    {"p07.sno", "debris", int32_t(0x5CBDAEF3), int32_t(0x00000000)},
    {"p07.tem", "debris", int32_t(0x5CBBA5F4), int32_t(0x00000000)},
    {"p07.win", "debris", int32_t(0x5CBCA9F7), int32_t(0x00000000)},
    {"p08.sno", "debris", int32_t(0x5CBFAEF3), int32_t(0x00000000)},
    {"p08.tem", "debris", int32_t(0x5CBDA5F4), int32_t(0x00000000)},
    {"p08.win", "debris", int32_t(0x5CBEA9F7), int32_t(0x00000000)},
    {"p13.sno", "debris", int32_t(0x5CB5B0F3), int32_t(0x00000000)},
    {"p13.tem", "debris", int32_t(0x5CB3A7F4), int32_t(0x00000000)},
    {"p13.win", "debris", int32_t(0x5CB4ABF7), int32_t(0x00000000)},
    {"p14.sno", "debris", int32_t(0x5CB7B0F3), int32_t(0x00000000)},
    {"p14.tem", "debris", int32_t(0x5CB5A7F4), int32_t(0x00000000)},
    {"p14.win", "debris", int32_t(0x5CB6ABF7), int32_t(0x00000000)},
    {"p15.win", "snow", int32_t(0x5CB8ABF7), int32_t(0x00000000)},
    {"p16.win", "snow", int32_t(0x5CBAABF7), int32_t(0x00000000)},
    {"p17.win", "snow", int32_t(0x5CBCABF7), int32_t(0x00000000)},
    {"p18.win", "snow", int32_t(0x5CBEABF7), int32_t(0x00000000)},
    {"p19.win", "snow", int32_t(0x5CC0ABF7), int32_t(0x00000000)},
    {"p20.win", "snow", int32_t(0x5CAEADF7), int32_t(0x00000000)},
    {"p_beast.wsa", "", int32_t(0x71F3771A), int32_t(0x00000000)},
    {"p_end01.des", "", int32_t(0x00000000), int32_t(0x1CF052B4)},
    {"p_end01.sno", "-", int32_t(0x00000000), int32_t(0x3B1C8F2E)},
    {"p_end01.tem", "-", int32_t(0x00000000), int32_t(0x98A83AF4)},
    {"p_end01.ubn", "", int32_t(0x00000000), int32_t(0x0E7618D7)},
    {"p_end01.urb", "", int32_t(0x00000000), int32_t(0xBEE5F4AB)},
    {"p_end02.des", "", int32_t(0x00000000), int32_t(0x9A64201A)},
    {"p_end02.sno", "-", int32_t(0x00000000), int32_t(0xBD88FD80)},
    {"p_end02.tem", "-", int32_t(0x00000000), int32_t(0x1E3C485A)},
    {"p_end02.ubn", "", int32_t(0x00000000), int32_t(0x88E26A79)},
    {"p_end02.urb", "", int32_t(0x00000000), int32_t(0x38718605)},
    {"p_end03.des", "", int32_t(0x00000000), int32_t(0x5138F3BF)},
    {"p_end03.sno", "-", int32_t(0x00000000), int32_t(0x76D42E25)},
    {"p_end03.tem", "-", int32_t(0x00000000), int32_t(0xD5609BFF)},
    {"p_end03.ubn", "", int32_t(0x00000000), int32_t(0x43BEB9DC)},
    {"p_end03.urb", "", int32_t(0x00000000), int32_t(0xF32D55A0)},
    {"p_end04.des", "", int32_t(0x00000000), int32_t(0x4C3DC307)},
    {"p_end04.sno", "-", int32_t(0x00000000), int32_t(0x6BD11E9D)},
    {"p_end04.tem", "-", int32_t(0x00000000), int32_t(0xC865AB47)},
    {"p_end04.ubn", "", int32_t(0x00000000), int32_t(0x5EBB8964)},
    {"p_end04.urb", "", int32_t(0x00000000), int32_t(0xEE286518)},
    {"p_lizard.wsa", "", int32_t(0xEF295723), int32_t(0x00000000)},
    {"p_luther.wsa", "", int32_t(0x3B0F6517), int32_t(0x00000000)},
    {"page0001.cps", "pict: ???", int32_t(0xCACDA8CF), int32_t(0x00000000)},
    {"page0002.cps", "pict: sound card selection", int32_t(0xCCCDA8CF), int32_t(0x00000000)},
    {"page0003.cps", "pict: sound card selection", int32_t(0xCECDA8CF), int32_t(0x00000000)},
    {"page0004.cps", "pict: mouths", int32_t(0xD0CDA8CF), int32_t(0x00000000)},
    {"page0005.cps", "pict: bars", int32_t(0xD2CDA8CF), int32_t(0x00000000)},
    {"page0006.cps", "pict: port irq dma window", int32_t(0xD4CDA8CF), int32_t(0x00000000)},
    {"page00a4.cps", "pict: mouth", int32_t(0xD0EFA8CF), int32_t(0x00000000)},
    {"page01.cps", "pict: ???", int32_t(0x9B79BAF1), int32_t(0x00000000)},
    {"page0203.cps", "pict: sound card selection", int32_t(0xCECDACCF), int32_t(0x00000000)},
    {"page0204.cps", "pict: sound card selection", int32_t(0xD0CDACCF), int32_t(0x00000000)},
    {"page0205.cps", "pict: sound card selection", int32_t(0xD2CDACCF), int32_t(0x00000000)},
    {"page0206.cps", "pict: sound card selection", int32_t(0xD4CDACCF), int32_t(0x00000000)},
    {"page02a4.cps", "pict: sound card selection", int32_t(0xD0EFACCF), int32_t(0x00000000)},
    {"page0305.cps", "pict: sound card selection", int32_t(0xD2CDAECF), int32_t(0x00000000)},
    {"page0402.cps", "pict: mouths", int32_t(0xCCCDB0CF), int32_t(0x00000000)},
    {"page0403.cps", "pict: mouths", int32_t(0xCECDB0CF), int32_t(0x00000000)},
    {"page04a2.cps", "pict: mouth", int32_t(0xCCEFB0CF), int32_t(0x00000000)},
    {"page04a3.cps", "pict: mouth", int32_t(0xCEEFB0CF), int32_t(0x00000000)},
    {"page05.cps", "pict: single bar", int32_t(0x9B79C2F1), int32_t(0x00000000)},
    {"page0602.cps", "pict: port irq dma window", int32_t(0xCCCDB4CF), int32_t(0x00000000)},
    {"page0604.cps", "pict: port irq dma window", int32_t(0xD0CDB4CF), int32_t(0x00000000)},
    {"page06a4.cps", "pict: port irq dma window", int32_t(0xD0EFB4CF), int32_t(0x00000000)},
    {"page1.aud", "", int32_t(0xBF9F61E7), int32_t(0x00000000)},
    {"page2.aud", "", int32_t(0xBF9F61E9), int32_t(0x00000000)},
    {"page3.aud", "", int32_t(0xBF9F61EB), int32_t(0x00000000)},
    {"pagetrn1.aud", "", int32_t(0xBC0EEB17), int32_t(0x00000000)},
    {"pagetrn2.aud", "", int32_t(0xBE0EEB17), int32_t(0x00000000)},
    {"pageturn.aud", "", int32_t(0xF616F117), int32_t(0x00000000)},
    {"pain1.aud", "", int32_t(0xE3A761E7), int32_t(0x00000000)},
    {"pain2.aud", "", int32_t(0xE3A761E9), int32_t(0x00000000)},
    {"palet01.shp", "-", int32_t(0x00000000), int32_t(0x0CB096F3)},
    {"palet02.shp", "-", int32_t(0x00000000), int32_t(0x8A24E45D)},
    {"palet03.shp", "-", int32_t(0x00000000), int32_t(0x417837F8)},
    {"palet04.shp", "-", int32_t(0x00000000), int32_t(0x5C7D0740)},
    {"palette.col", "", int32_t(0x7207FD2C), int32_t(0x00000000)},
    {"palette.cps", "pict: redalert master palette", int32_t(0x720EFE2C), int32_t(0x00000000)},
    {"palette.pal", "", int32_t(0x7207EF39), int32_t(0x18E978EE)},
    {"palette.pcx", "", int32_t(0x7213F139), int32_t(0x00000000)},
    {"panel1.aud", "", int32_t(0x9795AC2E), int32_t(0x00000000)},
    {"panel2.aud", "", int32_t(0x9795AE2E), int32_t(0x00000000)},
    {"paneldn.aud", "", int32_t(0x00000000), int32_t(0x85085F1E)},
    {"panelup.aud", "", int32_t(0x00000000), int32_t(0x7D7DAB8F)},
    {"panopen.aud", "", int32_t(0x9A19E522), int32_t(0x00000000)},
    {"pantest1.aud", "", int32_t(0xF836ECF9), int32_t(0x00000000)},
    {"parabomb.shp", "misc: parabombs", int32_t(0xDA2BF6F3), int32_t(0x11B215FB)},
    {"parabox.shp", "crat: parabombs", int32_t(0x6249EC18), int32_t(0x00000000)},
    {"parach.shp", "misc: paratroopers", int32_t(0xABA5E60F), int32_t(0xCEAEC172)},
    {"paraicon.shp", "", int32_t(0x00000000), int32_t(0x03402FD3)},
    {"paratrop.vqa", "paratroopers", int32_t(0xE7390017), int32_t(0x00000000)},
    {"paratrop.vqp", "paratroopers", int32_t(0xF6390017), int32_t(0x00000000)},
    {"parchbak.pcx", "", int32_t(0xFC0ED9FF), int32_t(0x00000000)},
    {"parchmnt.aud", "", int32_t(0xFA3AE0FF), int32_t(0x00000000)},
    {"paris01.urb", "", int32_t(0x00000000), int32_t(0x9508D40C)},
    {"paris02.urb", "", int32_t(0x00000000), int32_t(0x139CA6A2)},
    {"paris03.urb", "", int32_t(0x00000000), int32_t(0xD8C07507)},
    {"paris04.urb", "", int32_t(0x00000000), int32_t(0xC5C545BF)},
    {"paris05.urb", "", int32_t(0x00000000), int32_t(0x0E99961A)},
    {"paris06.urb", "", int32_t(0x00000000), int32_t(0x880DE4B4)},
    {"paris07.urb", "", int32_t(0x00000000), int32_t(0x43513711)},
    {"paris08.urb", "", int32_t(0x00000000), int32_t(0xB20785C4)},
    {"paris09.urb", "", int32_t(0x00000000), int32_t(0x795B5661)},
    {"paris10.urb", "", int32_t(0x00000000), int32_t(0xF8230C1D)},
    {"paris11.urb", "", int32_t(0x00000000), int32_t(0x337FDFB8)},
    {"paris12.urb", "", int32_t(0x00000000), int32_t(0xB5EBAD16)},
    {"paris13.urb", "", int32_t(0x00000000), int32_t(0x7EB77EB3)},
    {"paris14.urb", "", int32_t(0x00000000), int32_t(0x63B24E0B)},
    {"passable.shp", "misc: passable", int32_t(0x282DDCF1), int32_t(0x00000000)},
    {"patriot.shp", "patriot missile", int32_t(0xA649EC26), int32_t(0x55CF6286)},
    {"pave01.des", "", int32_t(0x00000000), int32_t(0x9DDB6224)},
    {"pave01.sno", "-", int32_t(0x00000000), int32_t(0x1AF42D2B)},
    {"pave01.tem", "-", int32_t(0x00000000), int32_t(0xEB837BDC)},
    {"pave01.ubn", "", int32_t(0x00000000), int32_t(0xD716412F)},
    {"pave01.urb", "", int32_t(0x00000000), int32_t(0x93A2FFB0)},
    {"pave02.des", "", int32_t(0x00000000), int32_t(0xAC3378B9)},
    {"pave02.sno", "-", int32_t(0x00000000), int32_t(0x2B1C37B6)},
    {"pave02.tem", "-", int32_t(0x00000000), int32_t(0xDA6B6141)},
    {"pave02.ubn", "", int32_t(0x00000000), int32_t(0xE6FE5BB2)},
    {"pave02.urb", "", int32_t(0x00000000), int32_t(0xA24AE52D)},
    {"pave03.des", "", int32_t(0x00000000), int32_t(0x0A44730D)},
    {"pave03.sno", "-", int32_t(0x00000000), int32_t(0x8D6B3C02)},
    {"pave03.tem", "-", int32_t(0x00000000), int32_t(0x7C1C6AF5)},
    {"pave03.ubn", "", int32_t(0x00000000), int32_t(0x40895006)},
    {"pave03.urb", "", int32_t(0x00000000), int32_t(0x043DEE99)},
    {"pave04.des", "", int32_t(0x00000000), int32_t(0xCFE34D83)},
    {"pave04.sno", "-", int32_t(0x00000000), int32_t(0x48CC028C)},
    {"pave04.tem", "-", int32_t(0x00000000), int32_t(0xB9BB547B)},
    {"pave04.ubn", "", int32_t(0x00000000), int32_t(0x852E6E88)},
    {"pave04.urb", "", int32_t(0x00000000), int32_t(0xC19AD017)},
    {"pave05.des", "", int32_t(0x00000000), int32_t(0x69944637)},
    {"pave05.sno", "-", int32_t(0x00000000), int32_t(0xEEBB0938)},
    {"pave05.tem", "-", int32_t(0x00000000), int32_t(0x1FCC5FCF)},
    {"pave05.ubn", "", int32_t(0x00000000), int32_t(0x2359653C)},
    {"pave05.urb", "", int32_t(0x00000000), int32_t(0x67EDDBA3)},
    {"pave06.des", "", int32_t(0x00000000), int32_t(0x587C5CAA)},
    {"pave06.sno", "-", int32_t(0x00000000), int32_t(0xDF5313A5)},
    {"pave06.tem", "-", int32_t(0x00000000), int32_t(0x2E244552)},
    {"pave06.ubn", "", int32_t(0x00000000), int32_t(0x12B17FA1)},
    {"pave06.urb", "", int32_t(0x00000000), int32_t(0x5605C13E)},
    {"pave07.des", "", int32_t(0x00000000), int32_t(0xFE0B571E)},
    {"pave07.sno", "-", int32_t(0x00000000), int32_t(0x79241811)},
    {"pave07.tem", "-", int32_t(0x00000000), int32_t(0x88534EE6)},
    {"pave07.ubn", "", int32_t(0x00000000), int32_t(0xB4C67415)},
    {"pave07.urb", "", int32_t(0x00000000), int32_t(0xF072CA8A)},
    {"pave08.des", "", int32_t(0x00000000), int32_t(0x084327F7)},
    {"pave08.sno", "-", int32_t(0x00000000), int32_t(0x8F6C68F8)},
    {"pave08.tem", "-", int32_t(0x00000000), int32_t(0x7E1B3E0F)},
    {"pave08.ubn", "", int32_t(0x00000000), int32_t(0x428E04FC)},
    {"pave08.urb", "", int32_t(0x00000000), int32_t(0x063ABA63)},
    {"pave09.des", "", int32_t(0x00000000), int32_t(0xAE342C43)},
    {"pave09.sno", "-", int32_t(0x00000000), int32_t(0x291B634C)},
    {"pave09.tem", "-", int32_t(0x00000000), int32_t(0xD86C35BB)},
    {"pave09.ubn", "", int32_t(0x00000000), int32_t(0xE4F90F48)},
    {"pave09.urb", "", int32_t(0x00000000), int32_t(0xA04DB1D7)},
    {"pave10.des", "", int32_t(0x00000000), int32_t(0xF706690E)},
    {"pave10.sno", "-", int32_t(0x00000000), int32_t(0x70292601)},
    {"pave10.tem", "-", int32_t(0x00000000), int32_t(0x815E70F6)},
    {"pave10.ubn", "", int32_t(0x00000000), int32_t(0xBDCB4A05)},
    {"pave10.urb", "", int32_t(0x00000000), int32_t(0xF97FF49A)},
    {"pave11.des", "", int32_t(0x00000000), int32_t(0x517162BA)},
    {"pave11.sno", "-", int32_t(0x00000000), int32_t(0xD65E2DB5)},
    {"pave11.tem", "-", int32_t(0x00000000), int32_t(0x27297B42)},
    {"pave11.ubn", "", int32_t(0x00000000), int32_t(0x1BBC41B1)},
    {"pave11.urb", "", int32_t(0x00000000), int32_t(0x5F08FF2E)},
    {"pave12.des", "", int32_t(0x00000000), int32_t(0x60997827)},
    {"pave12.sno", "-", int32_t(0x00000000), int32_t(0xE7B63728)},
    {"pave12.tem", "-", int32_t(0x00000000), int32_t(0x16C161DF)},
    {"pave12.ubn", "", int32_t(0x00000000), int32_t(0x2A545B2C)},
    {"pave12.urb", "", int32_t(0x00000000), int32_t(0x6EE0E5B3)},
    {"pave13.des", "", int32_t(0x00000000), int32_t(0xC6EE7393)},
    {"pave13.sno", "-", int32_t(0x00000000), int32_t(0x41C13C9C)},
    {"pave13.tem", "-", int32_t(0x00000000), int32_t(0xB0B66A6B)},
    {"pave13.ubn", "", int32_t(0x00000000), int32_t(0x8C235098)},
    {"pave13.urb", "", int32_t(0x00000000), int32_t(0xC897EE07)},
    {"pave14.des", "", int32_t(0x00000000), int32_t(0x03494D1D)},
    {"pave14.sno", "-", int32_t(0x00000000), int32_t(0x84660212)},
    {"pave14.tem", "-", int32_t(0x00000000), int32_t(0x751154E5)},
    {"pave14.ubn", "", int32_t(0x00000000), int32_t(0x49846E16)},
    {"pave14.urb", "", int32_t(0x00000000), int32_t(0x0D30D089)},
    {"pavefx01.ubn", "", int32_t(0x00000000), int32_t(0x6E25656C)},
    {"pavefx01.urb", "", int32_t(0x00000000), int32_t(0x2D513B16)},
    {"pavefx02.ubn", "", int32_t(0x00000000), int32_t(0x29851FBC)},
    {"pavefx02.urb", "", int32_t(0x00000000), int32_t(0x6AF141C6)},
    {"pavefx03.ubn", "", int32_t(0x00000000), int32_t(0x14E5360C)},
    {"pavefx03.urb", "", int32_t(0x00000000), int32_t(0x57916876)},
    {"pavefx04.ubn", "", int32_t(0x00000000), int32_t(0xA6C5EA1C)},
    {"pavefx04.urb", "", int32_t(0x00000000), int32_t(0xE5B1B466)},
    {"pavefx05.ubn", "", int32_t(0x00000000), int32_t(0x9BA5C3AC)},
    {"pavefx05.urb", "", int32_t(0x00000000), int32_t(0xD8D19DD6)},
    {"pavefx06.ubn", "", int32_t(0x00000000), int32_t(0xDC05B97C)},
    {"pavefx06.urb", "", int32_t(0x00000000), int32_t(0x9F71E706)},
    {"pavefx07.ubn", "", int32_t(0x00000000), int32_t(0xE16590CC)},
    {"pavefx07.urb", "", int32_t(0x00000000), int32_t(0xA211CEB6)},
    {"pavefx08.ubn", "", int32_t(0x00000000), int32_t(0x6335071D)},
    {"pavefx08.urb", "", int32_t(0x00000000), int32_t(0x20415967)},
    {"paveicon.shp", "icon: pavement", int32_t(0x00000000), int32_t(0x5747DEA5)},
    {"pavfxb01.ubn", "", int32_t(0x00000000), int32_t(0xFD37B930)},
    {"pavfxb01.urb", "", int32_t(0x00000000), int32_t(0xBE43E74A)},
    {"pavfxb02.ubn", "", int32_t(0x00000000), int32_t(0xBA97C3E0)},
    {"pavfxb02.urb", "", int32_t(0x00000000), int32_t(0xF9E39D9A)},
    {"pavfxb03.ubn", "", int32_t(0x00000000), int32_t(0x87F7EA50)},
    {"pavfxb03.urb", "", int32_t(0x00000000), int32_t(0xC483B42A)},
    {"pavfxb04.ubn", "", int32_t(0x00000000), int32_t(0x35D73640)},
    {"pavfxb04.urb", "", int32_t(0x00000000), int32_t(0x76A3683A)},
    {"pavfxb05.ubn", "", int32_t(0x00000000), int32_t(0x08B71FF0)},
    {"pavfxb05.urb", "", int32_t(0x00000000), int32_t(0x4BC3418A)},
    {"pavfxb06.ubn", "", int32_t(0x00000000), int32_t(0x4F176520)},
    {"pavfxb06.urb", "", int32_t(0x00000000), int32_t(0x0C633B5A)},
    {"pavfxb07.ubn", "", int32_t(0x00000000), int32_t(0x72774C90)},
    {"pavfxb07.urb", "", int32_t(0x00000000), int32_t(0x310312EA)},
    {"pavfxb08.ubn", "", int32_t(0x00000000), int32_t(0xF027DB41)},
    {"pavfxb08.urb", "", int32_t(0x00000000), int32_t(0xB353853B)},
    {"pavfxc01.ubn", "", int32_t(0x00000000), int32_t(0x5B40B284)},
    {"pavfxc01.urb", "", int32_t(0x00000000), int32_t(0x1834ECFE)},
    {"pavfxc02.ubn", "", int32_t(0x00000000), int32_t(0x1CE0C854)},
    {"pavfxc02.urb", "", int32_t(0x00000000), int32_t(0x5F94962E)},
    {"pavfxc03.ubn", "", int32_t(0x00000000), int32_t(0x2180E1E4)},
    {"pavfxc03.urb", "", int32_t(0x00000000), int32_t(0x62F4BF9E)},
    {"pavfxc04.ubn", "", int32_t(0x00000000), int32_t(0x93A03DF4)},
    {"pavfxc04.urb", "", int32_t(0x00000000), int32_t(0xD0D4638E)},
    {"pbeacon.shp", "", int32_t(0x00000000), int32_t(0xA281ADD0)},
    {"pbmbicon.shp", "icon: parabombs", int32_t(0xF61BE301), int32_t(0x00000000)},
    {"pbox.shp", "bldg: pillbox", int32_t(0x00E6D7CE), int32_t(0x00000000)},
    {"pboxicon.shp", "icon: pillbox", int32_t(0x4E23E301), int32_t(0x00000000)},
    {"pboxmake.shp", "make: pillbox", int32_t(0x3C1BDF09), int32_t(0x00000000)},
    {"pcofdune.map", "", int32_t(0x00000000), int32_t(0x09E09A21)},
    {"pcv.hva", "", int32_t(0x00000000), int32_t(0xA73B34EA)},
    {"pcv.vxl", "", int32_t(0x00000000), int32_t(0xA8CD4701)},
    {"pdatk1.aud", "", int32_t(0xD361B82C), int32_t(0x00000000)},
    {"pddie1.aud", "", int32_t(0xA76DB820), int32_t(0x00000000)},
    {"pdfxcld.shp", "", int32_t(0x00000000), int32_t(0x31131141)},
    {"pdfxloc.shp", "", int32_t(0x00000000), int32_t(0xC4DE29C8)},
    {"pdhurt1.aud", "", int32_t(0xB1C80F26), int32_t(0x00000000)},
    {"pdhurt2.aud", "", int32_t(0xB1CA0F26), int32_t(0x00000000)},
    {"pdlaff1.aud", "", int32_t(0x61D7F30E), int32_t(0x00000000)},
    {"pdomicon.shp", "", int32_t(0x00000000), int32_t(0x46737ADD)},
    {"pdox.shp", "bldg: chronosphere", int32_t(0x00E6DBCE), int32_t(0x00000000)},
    {"pdoxicon.shp", "icon: chronosphere", int32_t(0x4E23EB01), int32_t(0x00000000)},
    {"pdoxmake.shp", "make: chronosphere", int32_t(0x3C1BE709), int32_t(0x00000000)},
    {"pdplane.hva", "", int32_t(0x00000000), int32_t(0x36104B96)},
    {"pdplane.vxl", "", int32_t(0x00000000), int32_t(0x39E6387D)},
    {"pebble1.aud", "", int32_t(0x65AFF51A), int32_t(0x00000000)},
    {"pebble2.aud", "", int32_t(0x65B1F51A), int32_t(0x00000000)},
    {"peepclo1.aud", "", int32_t(0xE808EEF5), int32_t(0x00000000)},
    {"peepopn1.aud", "", int32_t(0xE806F70D), int32_t(0x00000000)},
    {"pentagrm.ini", "", int32_t(0x00000000), int32_t(0x949E47DA)},
    {"pentagrm.map", "-", int32_t(0x00000000), int32_t(0x70645B09)},
    {"pentgen.shp", "", int32_t(0x00000000), int32_t(0xB537152E)},
    {"periscop.vqa", "sub firing on boat", int32_t(0x0738F215), int32_t(0x00000000)},
    {"periscop.vqp", "vqp: sub firing on boat", int32_t(0x1638F215), int32_t(0x00000000)},
    {"permfrst.ini", "", int32_t(0x00000000), int32_t(0x30E04EB0)},
    {"permfrst.map", "-", int32_t(0x00000000), int32_t(0xD41A5263)},
    {"petdead1.aud", "", int32_t(0xB82ED8F9), int32_t(0x00000000)},
    {"petdead3.aud", "", int32_t(0xBC2ED8F9), int32_t(0x00000000)},
    {"petdead4.aud", "", int32_t(0xBE2ED8F9), int32_t(0x00000000)},
    {"petdead5.aud", "", int32_t(0xC02ED8F9), int32_t(0x00000000)},
    {"phal.hva", "", int32_t(0x00000000), int32_t(0xCDB9F491)},
    {"phal.vxl", "", int32_t(0x00000000), int32_t(0x3B332BD8)},
    {"pharma.trr", "", int32_t(0xF161F62D), int32_t(0x00000000)},
    {"pharma1.aud", "", int32_t(0xA5ABF91C), int32_t(0x00000000)},
    {"pharotek.aud", "pharotek", int32_t(0x00000000), int32_t(0xD6A09DA7)},
    {"phatatta.wav", "", int32_t(0x00000000), int32_t(0xF7B6465F)},
    {"phone1.aud", "", int32_t(0xBB99C820), int32_t(0x00000000)},
    {"photos.shp", "", int32_t(0xF79A1827), int32_t(0x00000000)},
    {"pick.hva", "-", int32_t(0x00000000), int32_t(0x9426823E)},
    {"pick.vxl", "pickup truck", int32_t(0x00000000), int32_t(0x62AC5D77)},
    {"pickup2.aud", "", int32_t(0x89B61B2C), int32_t(0x00000000)},
    {"piece.hva", "-", int32_t(0x00000000), int32_t(0x15532E20)},
    {"piece.vxl", "debris", int32_t(0x00000000), int32_t(0xAACA2987)},
    {"pier1.aud", "", int32_t(0xF39781E7), int32_t(0x00000000)},
    {"piff.shp", "smoke", int32_t(0xDCD4E5CE), int32_t(0x92F98480)},
    {"piffpiff.shp", "smoke", int32_t(0xF5EE0B0F), int32_t(0x235CED8A)},
    {"pilar1.aud", "", int32_t(0x878DCC3A), int32_t(0x00000000)},
    {"pillar1.aud", "", int32_t(0x8DD81F04), int32_t(0x00000000)},
    {"pillar2.aud", "", int32_t(0x8DDA1F04), int32_t(0x00000000)},
    {"pillbox1.aud", "ranger firing sound", int32_t(0xD83704F3), int32_t(0x00000000)},
    {"pillicon.shp", "", int32_t(0x00000000), int32_t(0x71AB989A)},
    {"pilotlit.shp", "-", int32_t(0x00000000), int32_t(0xA5D99C72)},
    {"pinficon.shp", "icon: paratroopers", int32_t(0x061FFF01), int32_t(0x00000000)},
    {"pingg.pcx", "", int32_t(0x00000000), int32_t(0x6785026F)},
    {"pingr.pcx", "", int32_t(0x00000000), int32_t(0x53DE3D20)},
    {"pingy.pcx", "", int32_t(0x00000000), int32_t(0x0EB42176)},
    {"pintle.vqa", "helicopter being shot down", int32_t(0xFD95F12A), int32_t(0x00000000)},
    {"pintle.vqp", "helicopter being shot down", int32_t(0xFD96002A), int32_t(0x00000000)},
    {"pipbrd.shp", "", int32_t(0x00000000), int32_t(0x3EA4970E)},
    {"piper1.aud", "", int32_t(0x979DCC3A), int32_t(0x00000000)},
    {"pips.shp", "building messages", int32_t(0xF6E8E5CE), int32_t(0xEF767DF4)},
    {"pips2.shp", "more pips", int32_t(0x00000000), int32_t(0xB98C56D7)},
    {"pitplats.ini", "", int32_t(0x00000000), int32_t(0x02B87F25)},
    {"pitplats.map", "-", int32_t(0x00000000), int32_t(0xE64263F6)},
    {"placbldg.aud", "building placement sound", int32_t(0xDFE30AF3), int32_t(0x00000000)},
    {"place.shp", "-", int32_t(0x00000000), int32_t(0x0AE2CABB)},
    {"place2.aud", "place a building down", int32_t(0x00000000), int32_t(0xA958342F)},
    {"plane01.sno", "", int32_t(0x00000000), int32_t(0xC9498D00)},
    {"planecra.vqa", "transport plane crashing", int32_t(0xFCFB0DF9), int32_t(0x00000000)},
    {"planecra.vqp", "transport plane crashing", int32_t(0x0BFB0DF9), int32_t(0x00000000)},
    {"plankdwn.aud", "", int32_t(0x1A08FB05), int32_t(0x00000000)},
    {"plas_hit.flc", "", int32_t(0x38E4082D), int32_t(0x00000000)},
    {"plasma1.aud", "", int32_t(0xA9AC091C), int32_t(0x00000000)},
    {"plat01.des", "", int32_t(0x00000000), int32_t(0x2886E380)},
    {"plat01.lun", "", int32_t(0x00000000), int32_t(0x41A6DF99)},
    {"plat01.sno", "-", int32_t(0x00000000), int32_t(0xAFA9AC8F)},
    {"plat01.tem", "-", int32_t(0x00000000), int32_t(0x5EDEFA78)},
    {"plat01.ubn", "", int32_t(0x00000000), int32_t(0x624BC08B)},
    {"plat01.urb", "", int32_t(0x00000000), int32_t(0x26FF7E14)},
    {"plat01a.des", "", int32_t(0x00000000), int32_t(0x9EAE01F4)},
    {"plat01a.lun", "", int32_t(0x00000000), int32_t(0xB850E677)},
    {"plat01a.sno", "-", int32_t(0x00000000), int32_t(0xB942DC6E)},
    {"plat01a.tem", "-", int32_t(0x00000000), int32_t(0x1AF669B4)},
    {"plat01a.ubn", "", int32_t(0x00000000), int32_t(0x8C284B97)},
    {"plat01a.urb", "", int32_t(0x00000000), int32_t(0x3CBBA7EB)},
    {"plat02.des", "", int32_t(0x00000000), int32_t(0x196EF91D)},
    {"plat02.lun", "", int32_t(0x00000000), int32_t(0x704EC504)},
    {"plat02.sno", "-", int32_t(0x00000000), int32_t(0x9E41B612)},
    {"plat02.tem", "-", int32_t(0x00000000), int32_t(0x6F36E0E5)},
    {"plat02.ubn", "", int32_t(0x00000000), int32_t(0x53A3DA16)},
    {"plat02.urb", "", int32_t(0x00000000), int32_t(0x17176489)},
    {"plat02a.des", "", int32_t(0x00000000), int32_t(0xAF461B69)},
    {"plat02a.lun", "", int32_t(0x00000000), int32_t(0x89B8FCEA)},
    {"plat02a.sno", "-", int32_t(0x00000000), int32_t(0x88AAC6F3)},
    {"plat02a.tem", "-", int32_t(0x00000000), int32_t(0x2B1E7329)},
    {"plat02a.ubn", "", int32_t(0x00000000), int32_t(0xBDC0510A)},
    {"plat02a.urb", "", int32_t(0x00000000), int32_t(0x0D53BD76)},
    {"plat03.des", "", int32_t(0x00000000), int32_t(0xBF19F2A9)},
    {"plat03.lun", "", int32_t(0x00000000), int32_t(0xD639CEB0)},
    {"plat03.sno", "-", int32_t(0x00000000), int32_t(0x3836BDA6)},
    {"plat03.tem", "-", int32_t(0x00000000), int32_t(0xC941EB51)},
    {"plat03.ubn", "", int32_t(0x00000000), int32_t(0xF5D4D1A2)},
    {"plat03.urb", "", int32_t(0x00000000), int32_t(0xB1606F3D)},
    {"plat03a.des", "", int32_t(0x00000000), int32_t(0x093110DD)},
    {"plat03a.lun", "", int32_t(0x00000000), int32_t(0x2FCFF75E)},
    {"plat03a.sno", "-", int32_t(0x00000000), int32_t(0x2EDDCD47)},
    {"plat03a.tem", "-", int32_t(0x00000000), int32_t(0x8D69789D)},
    {"plat03a.ubn", "", int32_t(0x00000000), int32_t(0x1BB75ABE)},
    {"plat03a.urb", "", int32_t(0x00000000), int32_t(0xAB24B6C2)},
    {"plat04.des", "", int32_t(0x00000000), int32_t(0x7ABECC27)},
    {"plat04.lun", "", int32_t(0x00000000), int32_t(0x139EF03E)},
    {"plat04.sno", "-", int32_t(0x00000000), int32_t(0xFD918328)},
    {"plat04.tem", "-", int32_t(0x00000000), int32_t(0x0CE6D5DF)},
    {"plat04.ubn", "", int32_t(0x00000000), int32_t(0x3073EF2C)},
    {"plat04.urb", "", int32_t(0x00000000), int32_t(0x74C751B3)},
    {"plat04a.des", "", int32_t(0x00000000), int32_t(0xCC962E53)},
    {"plat04a.lun", "", int32_t(0x00000000), int32_t(0xEA68C9D0)},
    {"plat04a.sno", "-", int32_t(0x00000000), int32_t(0xEB7AF3C9)},
    {"plat04a.tem", "-", int32_t(0x00000000), int32_t(0x48CE4613)},
    {"plat04a.ubn", "", int32_t(0x00000000), int32_t(0xDE106430)},
    {"plat04a.urb", "", int32_t(0x00000000), int32_t(0x6E83884C)},
    {"plat05.des", "", int32_t(0x00000000), int32_t(0xDCC9C793)},
    {"plat05.lun", "", int32_t(0x00000000), int32_t(0xB5E9FB8A)},
    {"plat05.sno", "-", int32_t(0x00000000), int32_t(0x5BE6889C)},
    {"plat05.tem", "-", int32_t(0x00000000), int32_t(0xAA91DE6B)},
    {"plat05.ubn", "", int32_t(0x00000000), int32_t(0x9604E498)},
    {"plat05.urb", "", int32_t(0x00000000), int32_t(0xD2B05A07)},
    {"plat05a.des", "", int32_t(0x00000000), int32_t(0x6AE125E7)},
    {"plat05a.lun", "", int32_t(0x00000000), int32_t(0x4C1FC264)},
    {"plat05a.sno", "-", int32_t(0x00000000), int32_t(0x4D0DF87D)},
    {"plat05a.tem", "-", int32_t(0x00000000), int32_t(0xEEB94DA7)},
    {"plat05a.ubn", "", int32_t(0x00000000), int32_t(0x78676F84)},
    {"plat05a.urb", "", int32_t(0x00000000), int32_t(0xC8F483F8)},
    {"plat06.des", "", int32_t(0x00000000), int32_t(0xED21DD0E)},
    {"plat06.lun", "", int32_t(0x00000000), int32_t(0x8401E117)},
    {"plat06.sno", "-", int32_t(0x00000000), int32_t(0x6A0E9201)},
    {"plat06.tem", "-", int32_t(0x00000000), int32_t(0x9B79C4F6)},
    {"plat06.ubn", "", int32_t(0x00000000), int32_t(0xA7ECFE05)},
    {"plat06.urb", "", int32_t(0x00000000), int32_t(0xE358409A)},
    {"plat06a.des", "", int32_t(0x00000000), int32_t(0x5B093F7A)},
    {"plat06a.lun", "", int32_t(0x00000000), int32_t(0x7DF7D8F9)},
    {"plat06a.sno", "-", int32_t(0x00000000), int32_t(0x7CE5E2E0)},
    {"plat06a.tem", "-", int32_t(0x00000000), int32_t(0xDF51573A)},
    {"plat06a.ubn", "", int32_t(0x00000000), int32_t(0x498F7519)},
    {"plat06a.urb", "", int32_t(0x00000000), int32_t(0xF91C9965)},
    {"plat07.des", "", int32_t(0x00000000), int32_t(0x4B56D6BA)},
    {"plat07.lun", "", int32_t(0x00000000), int32_t(0x2276EAA3)},
    {"plat07.sno", "-", int32_t(0x00000000), int32_t(0xCC7999B5)},
    {"plat07.tem", "-", int32_t(0x00000000), int32_t(0x3D0ECF42)},
    {"plat07.ubn", "", int32_t(0x00000000), int32_t(0x019BF5B1)},
    {"plat07.urb", "", int32_t(0x00000000), int32_t(0x452F4B2E)},
    {"plat07a.des", "", int32_t(0x00000000), int32_t(0xFD7E34CE)},
    {"plat07a.lun", "", int32_t(0x00000000), int32_t(0xDB80D34D)},
    {"plat07a.sno", "-", int32_t(0x00000000), int32_t(0xDA92E954)},
    {"plat07a.tem", "-", int32_t(0x00000000), int32_t(0x79265C8E)},
    {"plat07a.ubn", "", int32_t(0x00000000), int32_t(0xEFF87EAD)},
    {"plat07a.urb", "", int32_t(0x00000000), int32_t(0x5F6B92D1)},
    {"plat08.des", "", int32_t(0x00000000), int32_t(0xBD1EA653)},
    {"plat08.lun", "", int32_t(0x00000000), int32_t(0xD43E9A4A)},
    {"plat08.sno", "-", int32_t(0x00000000), int32_t(0x3A31E95C)},
    {"plat08.tem", "-", int32_t(0x00000000), int32_t(0xCB46BFAB)},
    {"plat08.ubn", "", int32_t(0x00000000), int32_t(0xF7D38558)},
    {"plat08.urb", "", int32_t(0x00000000), int32_t(0xB3673BC7)},
    {"plat08a.des", "", int32_t(0x00000000), int32_t(0x0B364427)},
    {"plat08a.lun", "", int32_t(0x00000000), int32_t(0x2DC8A3A4)},
    {"plat08a.sno", "-", int32_t(0x00000000), int32_t(0x2CDA99BD)},
    {"plat08a.tem", "-", int32_t(0x00000000), int32_t(0x8F6E2C67)},
    {"plat08a.ubn", "", int32_t(0x00000000), int32_t(0x19B00E44)},
    {"plat08a.urb", "", int32_t(0x00000000), int32_t(0xA923E238)},
    {"plat09.des", "", int32_t(0x00000000), int32_t(0x1B69ADE7)},
    {"plat09.lun", "", int32_t(0x00000000), int32_t(0x724991FE)},
    {"plat09.sno", "-", int32_t(0x00000000), int32_t(0x9C46E2E8)},
    {"plat09.tem", "-", int32_t(0x00000000), int32_t(0x6D31B41F)},
    {"plat09.ubn", "", int32_t(0x00000000), int32_t(0x51A48EEC)},
    {"plat09.urb", "", int32_t(0x00000000), int32_t(0x15103073)},
    {"plat09a.des", "", int32_t(0x00000000), int32_t(0xAD414F93)},
    {"plat09a.lun", "", int32_t(0x00000000), int32_t(0x8BBFA810)},
    {"plat09a.sno", "-", int32_t(0x00000000), int32_t(0x8AAD9209)},
    {"plat09a.tem", "-", int32_t(0x00000000), int32_t(0x291927D3)},
    {"plat09a.ubn", "", int32_t(0x00000000), int32_t(0xBFC705F0)},
    {"plat09a.urb", "", int32_t(0x00000000), int32_t(0x0F54E98C)},
    {"plat10.des", "", int32_t(0x00000000), int32_t(0x425BE8AA)},
    {"plat10.lun", "", int32_t(0x00000000), int32_t(0x2B7BD4B3)},
    {"plat10.sno", "-", int32_t(0x00000000), int32_t(0xC574A7A5)},
    {"plat10.tem", "-", int32_t(0x00000000), int32_t(0x3403F152)},
    {"plat10.ubn", "", int32_t(0x00000000), int32_t(0x0896CBA1)},
    {"plat10.urb", "", int32_t(0x00000000), int32_t(0x4C22753E)},
    {"plat10a.des", "", int32_t(0x00000000), int32_t(0xF4730ADE)},
    {"plat10a.lun", "", int32_t(0x00000000), int32_t(0xD28DED5D)},
    {"plat10a.sno", "-", int32_t(0x00000000), int32_t(0xD39FD744)},
    {"plat10a.tem", "-", int32_t(0x00000000), int32_t(0x702B629E)},
    {"plat10a.ubn", "", int32_t(0x00000000), int32_t(0xE6F540BD)},
    {"plat10a.urb", "", int32_t(0x00000000), int32_t(0x5666ACC1)},
    {"plat11.des", "", int32_t(0x00000000), int32_t(0xE42CE31E)},
    {"plat11.lun", "", int32_t(0x00000000), int32_t(0x8D0CDF07)},
    {"plat11.sno", "-", int32_t(0x00000000), int32_t(0x6303AC11)},
    {"plat11.tem", "-", int32_t(0x00000000), int32_t(0x9274FAE6)},
    {"plat11.ubn", "", int32_t(0x00000000), int32_t(0xAEE1C015)},
    {"plat11.urb", "", int32_t(0x00000000), int32_t(0xEA557E8A)},
    {"plat11a.des", "", int32_t(0x00000000), int32_t(0x5204016A)},
    {"plat11a.lun", "", int32_t(0x00000000), int32_t(0x74FAE6E9)},
    {"plat11a.sno", "-", int32_t(0x00000000), int32_t(0x75E8DCF0)},
    {"plat11a.tem", "-", int32_t(0x00000000), int32_t(0xD65C692A)},
    {"plat11a.ubn", "", int32_t(0x00000000), int32_t(0x40824B09)},
    {"plat11a.urb", "", int32_t(0x00000000), int32_t(0xF011A775)},
    {"plat12.des", "", int32_t(0x00000000), int32_t(0xD5C4F983)},
    {"plat12.lun", "", int32_t(0x00000000), int32_t(0xBCE4C59A)},
    {"plat12.sno", "-", int32_t(0x00000000), int32_t(0x52EBB68C)},
    {"plat12.tem", "-", int32_t(0x00000000), int32_t(0xA39CE07B)},
    {"plat12.ubn", "", int32_t(0x00000000), int32_t(0x9F09DA88)},
    {"plat12.urb", "", int32_t(0x00000000), int32_t(0xDBBD6417)},
    {"plat12a.des", "", int32_t(0x00000000), int32_t(0x63EC1BF7)},
    {"plat12a.lun", "", int32_t(0x00000000), int32_t(0x4512FC74)},
    {"plat12a.sno", "-", int32_t(0x00000000), int32_t(0x4400C66D)},
    {"plat12a.tem", "-", int32_t(0x00000000), int32_t(0xE7B473B7)},
    {"plat12a.ubn", "", int32_t(0x00000000), int32_t(0x716A5194)},
    {"plat12a.urb", "", int32_t(0x00000000), int32_t(0xC1F9BDE8)},
    {"plat13.des", "", int32_t(0x00000000), int32_t(0x73B3F237)},
    {"plat13.lun", "", int32_t(0x00000000), int32_t(0x1A93CE2E)},
    {"plat13.sno", "-", int32_t(0x00000000), int32_t(0xF49CBD38)},
    {"plat13.tem", "-", int32_t(0x00000000), int32_t(0x05EBEBCF)},
    {"plat13.ubn", "", int32_t(0x00000000), int32_t(0x397ED13C)},
    {"plat13.urb", "", int32_t(0x00000000), int32_t(0x7DCA6FA3)},
    {"plat13a.des", "", int32_t(0x00000000), int32_t(0xC59B1043)},
    {"plat13a.lun", "", int32_t(0x00000000), int32_t(0xE365F7C0)},
    {"plat13a.sno", "-", int32_t(0x00000000), int32_t(0xE277CDD9)},
    {"plat13a.tem", "-", int32_t(0x00000000), int32_t(0x41C37803)},
    {"plat13a.ubn", "", int32_t(0x00000000), int32_t(0xD71D5A20)},
    {"plat13a.urb", "", int32_t(0x00000000), int32_t(0x678EB65C)},
    {"plat14.des", "", int32_t(0x00000000), int32_t(0xB614CCB9)},
    {"plat14.lun", "", int32_t(0x00000000), int32_t(0xDF34F0A0)},
    {"plat14.sno", "-", int32_t(0x00000000), int32_t(0x313B83B6)},
    {"plat14.tem", "-", int32_t(0x00000000), int32_t(0xC04CD541)},
    {"plat14.ubn", "", int32_t(0x00000000), int32_t(0xFCD9EFB2)},
    {"plat14.urb", "", int32_t(0x00000000), int32_t(0xB86D512D)},
    {"plat14a.des", "", int32_t(0x00000000), int32_t(0x003C2ECD)},
    {"plat14a.lun", "", int32_t(0x00000000), int32_t(0x26C2C94E)},
    {"plat14a.sno", "-", int32_t(0x00000000), int32_t(0x27D0F357)},
    {"plat14a.tem", "-", int32_t(0x00000000), int32_t(0x8464468D)},
    {"plat14a.ubn", "", int32_t(0x00000000), int32_t(0x12BA64AE)},
    {"plat14a.urb", "", int32_t(0x00000000), int32_t(0xA22988D2)},
    {"plat15.des", "", int32_t(0x00000000), int32_t(0x1063C70D)},
    {"plat15.lun", "", int32_t(0x00000000), int32_t(0x7943FB14)},
    {"plat15.sno", "-", int32_t(0x00000000), int32_t(0x974C8802)},
    {"plat15.tem", "-", int32_t(0x00000000), int32_t(0x663BDEF5)},
    {"plat15.ubn", "", int32_t(0x00000000), int32_t(0x5AAEE406)},
    {"plat15.urb", "", int32_t(0x00000000), int32_t(0x1E1A5A99)},
    {"plat15a.des", "", int32_t(0x00000000), int32_t(0xA64B2579)},
    {"plat15a.lun", "", int32_t(0x00000000), int32_t(0x80B5C2FA)},
    {"plat15a.sno", "-", int32_t(0x00000000), int32_t(0x81A7F8E3)},
    {"plat15a.tem", "-", int32_t(0x00000000), int32_t(0x22134D39)},
    {"plat15a.ubn", "", int32_t(0x00000000), int32_t(0xB4CD6F1A)},
    {"plat15a.urb", "", int32_t(0x00000000), int32_t(0x045E8366)},
    {"plat16.des", "", int32_t(0x00000000), int32_t(0x218BDD90)},
    {"plat16.lun", "", int32_t(0x00000000), int32_t(0x48ABE189)},
    {"plat16.sno", "-", int32_t(0x00000000), int32_t(0xA6A4929F)},
    {"plat16.tem", "-", int32_t(0x00000000), int32_t(0x57D3C468)},
    {"plat16.ubn", "", int32_t(0x00000000), int32_t(0x6B46FE9B)},
    {"plat16.urb", "", int32_t(0x00000000), int32_t(0x2FF24004)},
    {"plat16a.des", "", int32_t(0x00000000), int32_t(0x97A33FE4)},
    {"plat16a.lun", "", int32_t(0x00000000), int32_t(0xB15DD867)},
    {"plat16a.sno", "-", int32_t(0x00000000), int32_t(0xB04FE27E)},
    {"plat16a.tem", "-", int32_t(0x00000000), int32_t(0x13FB57A4)},
    {"plat16a.ubn", "", int32_t(0x00000000), int32_t(0x85257587)},
    {"plat16a.urb", "", int32_t(0x00000000), int32_t(0x35B699FB)},
    {"plsecan2.aud", "pulse cannon fires", int32_t(0x00000000), int32_t(0x71CF4413)},
    {"plticon.shp", "icon: laser turret", int32_t(0x00000000), int32_t(0x8343CE18)},
    {"plugicon.shp", "-", int32_t(0x00000000), int32_t(0x59120027)},
    {"pmatkmove.shp", "", int32_t(0x00000000), int32_t(0x323F6C4B)},
    {"pmgrdarea.shp", "", int32_t(0x00000000), int32_t(0xD1C18F80)},
    {"pneum1.aud", "", int32_t(0xD771E030), int32_t(0x00000000)},
    {"pneum2.aud", "", int32_t(0xD771E230), int32_t(0x00000000)},
    {"pneum5.aud", "", int32_t(0xD771E830), int32_t(0x00000000)},
    {"pockets.ini", "", int32_t(0x00000000), int32_t(0x4DF2A8A9)},
    {"pockets.map", "-", int32_t(0x00000000), int32_t(0x52CCD1DB)},
    {"pod.shp", "unit: droppod", int32_t(0x00000000), int32_t(0xECFC80FA)},
    {"pod_atk1.aud", "", int32_t(0x23FD26F1), int32_t(0x00000000)},
    {"pod_atk2.aud", "", int32_t(0x25FD26F1), int32_t(0x00000000)},
    {"pod_atk3.aud", "", int32_t(0x27FD26F1), int32_t(0x00000000)},
    {"pod_atk4.aud", "", int32_t(0x29FD26F1), int32_t(0x00000000)},
    {"pod_die1.aud", "", int32_t(0x23F110F7), int32_t(0x00000000)},
    {"pod_die2.aud", "", int32_t(0x25F110F7), int32_t(0x00000000)},
    {"pod_hit1.aud", "", int32_t(0x240F10FF), int32_t(0x00000000)},
    {"pod_hit2.aud", "", int32_t(0x260F10FF), int32_t(0x00000000)},
    {"pod_hit3.aud", "", int32_t(0x280F10FF), int32_t(0x00000000)},
    {"pod_loi1.aud", "", int32_t(0x23F91D07), int32_t(0x00000000)},
    {"pod_loi2.aud", "", int32_t(0x25F91D07), int32_t(0x00000000)},
    {"pod_stnd.aud", "", int32_t(0x4A032714), int32_t(0x00000000)},
    {"podasslt.vqa", "-", int32_t(0x00000000), int32_t(0xAA9CF2DB)},
    {"podium.vqa", "gdi person at press confrence", int32_t(0xD16E193C), int32_t(0x00000000)},
    {"podium.vqp", "gdi person at press confrence", int32_t(0xD16E283C), int32_t(0x00000000)},
    {"podring.shp", "droppod landing ring", int32_t(0x00000000), int32_t(0x0322B3E9)},
    {"podsicon.shp", "-", int32_t(0x00000000), int32_t(0xF9B09F8D)},
    {"poi_sh.flc", "", int32_t(0x09821132), int32_t(0x00000000)},
    {"poison.flc", "", int32_t(0xD9821D2B), int32_t(0x00000000)},
    {"polarb.shp", "", int32_t(0x00000000), int32_t(0xB1DE35D4)},
    {"pole01.des", "", int32_t(0x00000000), int32_t(0xFF215803)},
    {"pole01.lun", "", int32_t(0x00000000), int32_t(0x9601641A)},
    {"pole01.sno", "", int32_t(0x00000000), int32_t(0x780E170C)},
    {"pole01.tem", "", int32_t(0x00000000), int32_t(0x897941FB)},
    {"pole01.ubn", "", int32_t(0x00000000), int32_t(0xB5EC7B08)},
    {"pole01.urb", "", int32_t(0x00000000), int32_t(0xF158C597)},
    {"pole02.des", "", int32_t(0x00000000), int32_t(0xCEC9429E)},
    {"pole02.lun", "", int32_t(0x00000000), int32_t(0xA7E97E87)},
    {"pole02.sno", "", int32_t(0x00000000), int32_t(0x49E60D91)},
    {"pole02.tem", "", int32_t(0x00000000), int32_t(0xB8915B66)},
    {"pole02.ubn", "", int32_t(0x00000000), int32_t(0x84046195)},
    {"pole02.urb", "", int32_t(0x00000000), int32_t(0xC0B0DF0A)},
    {"pophelp.trr", "", int32_t(0x7E34281F), int32_t(0x00000000)},
    {"ports.shp", "", int32_t(0xE1EF9A37), int32_t(0x00000000)},
    {"potspl4.aud", "", int32_t(0xA9FE2B22), int32_t(0x00000000)},
    {"potspl5.aud", "", int32_t(0xAA002B22), int32_t(0x00000000)},
    {"pouroil1.aud", "", int32_t(0xF043110D), int32_t(0x00000000)},
    {"power.shp", "power requirement indicator", int32_t(0xA6039A35), int32_t(0xBCD41CAD)},
    {"power.wav", "", int32_t(0x00000000), int32_t(0xB00761A5)},
    {"powerbar.shp", "misc: powerbar", int32_t(0x0A281513), int32_t(0x00000000)},
    {"poweroff.shp", "-", int32_t(0x00000000), int32_t(0x1BFDC39D)},
    {"powerp.shp", "-", int32_t(0x00000000), int32_t(0xC33D9320)},
    {"powr.shp", "bldg: powerplant", int32_t(0xF4F6F1CE), int32_t(0x00000000)},
    {"powrdn1.aud", "power down", int32_t(0xA6042F0A), int32_t(0x00000000)},
    {"powrdn1.juv", "power down", int32_t(0xA6162F13), int32_t(0x00000000)},
    {"powrdwn2.aud", "", int32_t(0xF24F2CF7), int32_t(0x00000000)},
    {"powricon.shp", "icon: powerplant", int32_t(0x36441701), int32_t(0x2252B125)},
    {"powrmake.shp", "make: powerplant", int32_t(0x243C1309), int32_t(0x00000000)},
    {"ppaper.cps", "pict: allies paper", int32_t(0xC762391B), int32_t(0x00000000)},
    {"ppb_morf.wsa", "", int32_t(0x4B013708), int32_t(0x00000000)},
    {"ppl_morf.wsa", "", int32_t(0x4B293708), int32_t(0x00000000)},
    {"pppppwoosh2.wav", "", int32_t(0x1C7AB1BF), int32_t(0x00000000)},
    {"pppwetstep5.aud", "", int32_t(0x687EC95F), int32_t(0x00000000)},
    {"ppv1460003e.aud", "", int32_t(0xA84216F3), int32_t(0x00000000)},
    {"ppv1475103e.aud", "", int32_t(0xAC561AF3), int32_t(0x00000000)},
    {"ppvdirtwlk2.aud", "", int32_t(0xDCACB780), int32_t(0x00000000)},
    {"ppvforstwk5.aud", "", int32_t(0xE0AEB7AE), int32_t(0x00000000)},
    {"ppvgrvlwlk2.aud", "", int32_t(0xF48CC7A4), int32_t(0x00000000)},
    {"ppvhrddirt3.aud", "", int32_t(0xC46E91B0), int32_t(0x00000000)},
    {"ppvhrddirt7.aud", "", int32_t(0xC47691B0), int32_t(0x00000000)},
    {"ppvppjbird9.aud", "", int32_t(0x047289A7), int32_t(0x00000000)},
    {"prchunrl.pcx", "", int32_t(0x11F53619), int32_t(0x00000000)},
    {"prepick.cps", "pict: c&c demo info gdi", int32_t(0x9DFF2016), int32_t(0x00000000)},
    {"prepick.pcx", "", int32_t(0x9E041323), int32_t(0x00000000)},
    {"prepick2.cps", "pict: c&c demo info nod", int32_t(0xF8FC1301), int32_t(0x00000000)},
    {"pres.shp", "", int32_t(0x00000000), int32_t(0xD9B426E8)},
    {"pribldg1.aud", "primary building selected", int32_t(0xB0091307), int32_t(0x00000000)},
    {"prisamb1.aud", "", int32_t(0xF3FF24F1), int32_t(0x00000000)},
    {"prisamb3.aud", "", int32_t(0xF7FF24F1), int32_t(0x00000000)},
    {"prisicon.shp", "", int32_t(0x00000000), int32_t(0x692C9DF1)},
    {"prism.bmp", "", int32_t(0x00000000), int32_t(0x9AFA6208)},
    {"prism1.aud", "", int32_t(0xCF81F030), int32_t(0x00000000)},
    {"prisslm1.aud", "", int32_t(0xF4152315), int32_t(0x00000000)},
    {"prisslm2.aud", "", int32_t(0xF6152315), int32_t(0x00000000)},
    {"prisslm3.aud", "", int32_t(0xF8152315), int32_t(0x00000000)},
    {"private.pcx", "", int32_t(0x00000000), int32_t(0x45E853A0)},
    {"privgame.bmp", "", int32_t(0x340D0DFD), int32_t(0x00000000)},
    {"proad01.des", "", int32_t(0x00000000), int32_t(0x1FFF40AB)},
    {"proad01.sno", "-", int32_t(0x00000000), int32_t(0x38139D31)},
    {"proad01.tem", "-", int32_t(0x00000000), int32_t(0x9BA728EB)},
    {"proad01.ubn", "", int32_t(0x00000000), int32_t(0x0D790AC8)},
    {"proad01.urb", "", int32_t(0x00000000), int32_t(0xBDEAE6B4)},
    {"proad01a.des", "", int32_t(0x00000000), int32_t(0x26373944)},
    {"proad01a.sno", "-", int32_t(0x00000000), int32_t(0xC8AB0935)},
    {"proad01a.tem", "-", int32_t(0x00000000), int32_t(0xC01EA757)},
    {"proad01a.ubn", "", int32_t(0x00000000), int32_t(0x17940A1D)},
    {"proad01a.urb", "", int32_t(0x00000000), int32_t(0x54E05467)},
    {"proad01b.des", "", int32_t(0x00000000), int32_t(0x61974394)},
    {"proad01b.sno", "-", int32_t(0x00000000), int32_t(0x8F0B73E5)},
    {"proad01b.tem", "-", int32_t(0x00000000), int32_t(0x87BEDD87)},
    {"proad01b.ubn", "", int32_t(0x00000000), int32_t(0x503470CD)},
    {"proad01b.urb", "", int32_t(0x00000000), int32_t(0x13402EB7)},
    {"proad01c.des", "", int32_t(0x00000000), int32_t(0x5CF76A24)},
    {"proad01c.sno", "-", int32_t(0x00000000), int32_t(0xB26B5A55)},
    {"proad01c.tem", "-", int32_t(0x00000000), int32_t(0xBADEF437)},
    {"proad01c.ubn", "", int32_t(0x00000000), int32_t(0x6D54597D)},
    {"proad01c.urb", "", int32_t(0x00000000), int32_t(0x2E200707)},
    {"proad02.des", "", int32_t(0x00000000), int32_t(0x996B3205)},
    {"proad02.sno", "-", int32_t(0x00000000), int32_t(0xBE87EF9F)},
    {"proad02.tem", "-", int32_t(0x00000000), int32_t(0x1D335A45)},
    {"proad02.ubn", "", int32_t(0x00000000), int32_t(0x8BED7866)},
    {"proad02.urb", "", int32_t(0x00000000), int32_t(0x3B7E941A)},
    {"proad02a.des", "", int32_t(0x00000000), int32_t(0xA0A34BEA)},
    {"proad02a.sno", "-", int32_t(0x00000000), int32_t(0x4E3F7B9B)},
    {"proad02a.tem", "-", int32_t(0x00000000), int32_t(0x468AD5F9)},
    {"proad02a.ubn", "", int32_t(0x00000000), int32_t(0x910078B3)},
    {"proad02a.urb", "", int32_t(0x00000000), int32_t(0xD27426C9)},
    {"proad02b.des", "", int32_t(0x00000000), int32_t(0xE703313A)},
    {"proad02b.sno", "-", int32_t(0x00000000), int32_t(0x099F014B)},
    {"proad02b.tem", "-", int32_t(0x00000000), int32_t(0x012AAF29)},
    {"proad02b.ubn", "", int32_t(0x00000000), int32_t(0xD6A00263)},
    {"proad02b.urb", "", int32_t(0x00000000), int32_t(0x95D45C19)},
    {"proad02c.des", "", int32_t(0x00000000), int32_t(0xDA63188A)},
    {"proad02c.sno", "-", int32_t(0x00000000), int32_t(0x34FF28FB)},
    {"proad02c.tem", "-", int32_t(0x00000000), int32_t(0x3C4A8699)},
    {"proad02c.ubn", "", int32_t(0x00000000), int32_t(0xEBC02BD3)},
    {"proad02c.urb", "", int32_t(0x00000000), int32_t(0xA8B475A9)},
    {"proad03.des", "", int32_t(0x00000000), int32_t(0x5237E1A0)},
    {"proad03.sno", "-", int32_t(0x00000000), int32_t(0x75DB3C3A)},
    {"proad03.tem", "-", int32_t(0x00000000), int32_t(0xD66F89E0)},
    {"proad03.ubn", "", int32_t(0x00000000), int32_t(0x40B1ABC3)},
    {"proad03.urb", "", int32_t(0x00000000), int32_t(0xF02247BF)},
    {"proad04.des", "", int32_t(0x00000000), int32_t(0x4F32D118)},
    {"proad04.sno", "-", int32_t(0x00000000), int32_t(0x68DE0C82)},
    {"proad04.tem", "-", int32_t(0x00000000), int32_t(0xCB6AB958)},
    {"proad04.ubn", "", int32_t(0x00000000), int32_t(0x5DB49B7B)},
    {"proad04.urb", "", int32_t(0x00000000), int32_t(0xED277707)},
    {"proad05.des", "", int32_t(0x00000000), int32_t(0x846E02BD)},
    {"proad05.sno", "-", int32_t(0x00000000), int32_t(0xA382DF27)},
    {"proad05.tem", "-", int32_t(0x00000000), int32_t(0x00366AFD)},
    {"proad05.ubn", "", int32_t(0x00000000), int32_t(0x96E848DE)},
    {"proad05.urb", "", int32_t(0x00000000), int32_t(0x267BA4A2)},
    {"proad06.des", "", int32_t(0x00000000), int32_t(0x02FA7013)},
    {"proad06.sno", "-", int32_t(0x00000000), int32_t(0x2516AD89)},
    {"proad06.tem", "-", int32_t(0x00000000), int32_t(0x86A21853)},
    {"proad06.ubn", "", int32_t(0x00000000), int32_t(0x107C3A70)},
    {"proad06.urb", "", int32_t(0x00000000), int32_t(0xA0EFD60C)},
    {"proad07.des", "", int32_t(0x00000000), int32_t(0xC9A6A3B6)},
    {"proad07.sno", "-", int32_t(0x00000000), int32_t(0xEE4A7E2C)},
    {"proad07.tem", "-", int32_t(0x00000000), int32_t(0x4DFECBF6)},
    {"proad07.ubn", "", int32_t(0x00000000), int32_t(0xDB20E9D5)},
    {"proad07.urb", "", int32_t(0x00000000), int32_t(0x6BB305A9)},
    {"proad08.des", "", int32_t(0x00000000), int32_t(0x38F01163)},
    {"proad08.sno", "-", int32_t(0x00000000), int32_t(0x1F1CCCF9)},
    {"proad08.tem", "-", int32_t(0x00000000), int32_t(0xBCA87923)},
    {"proad08.ubn", "", int32_t(0x00000000), int32_t(0x2A765B00)},
    {"proad08.urb", "", int32_t(0x00000000), int32_t(0x9AE5B77C)},
    {"proad09.des", "", int32_t(0x00000000), int32_t(0xF3ACC2C6)},
    {"proad09.sno", "-", int32_t(0x00000000), int32_t(0xD4401F5C)},
    {"proad09.tem", "-", int32_t(0x00000000), int32_t(0x77F4AA86)},
    {"proad09.ubn", "", int32_t(0x00000000), int32_t(0xE12A88A5)},
    {"proad09.urb", "", int32_t(0x00000000), int32_t(0x51B964D9)},
    {"proad10.des", "", int32_t(0x00000000), int32_t(0x72D498BA)},
    {"proad10.sno", "-", int32_t(0x00000000), int32_t(0x55384520)},
    {"proad10.tem", "-", int32_t(0x00000000), int32_t(0xF68CF0FA)},
    {"proad10.ubn", "", int32_t(0x00000000), int32_t(0x6052D2D9)},
    {"proad10.urb", "", int32_t(0x00000000), int32_t(0xD0C13EA5)},
    {"proad11.des", "", int32_t(0x00000000), int32_t(0xB9884B1F)},
    {"proad11.sno", "-", int32_t(0x00000000), int32_t(0x9E649685)},
    {"proad11.tem", "-", int32_t(0x00000000), int32_t(0x3DD0235F)},
    {"proad11.ubn", "", int32_t(0x00000000), int32_t(0xAB0E017C)},
    {"proad11.urb", "", int32_t(0x00000000), int32_t(0x1B9DED00)},
    {"proad12.des", "", int32_t(0x00000000), int32_t(0x3F1C39B1)},
    {"proad12.sno", "-", int32_t(0x00000000), int32_t(0x18F0E42B)},
    {"proad12.tem", "-", int32_t(0x00000000), int32_t(0xBB4451F1)},
    {"proad12.ubn", "", int32_t(0x00000000), int32_t(0x2D9A73D2)},
    {"proad12.urb", "", int32_t(0x00000000), int32_t(0x9D099FAE)},
    {"proad13.des", "", int32_t(0x00000000), int32_t(0xF440EA14)},
    {"proad13.sno", "-", int32_t(0x00000000), int32_t(0xD3AC378E)},
    {"proad13.tem", "-", int32_t(0x00000000), int32_t(0x70188254)},
    {"proad13.ubn", "", int32_t(0x00000000), int32_t(0xE6C6A077)},
    {"proad13.urb", "", int32_t(0x00000000), int32_t(0x56554C0B)},
    {"proad14.des", "", int32_t(0x00000000), int32_t(0xE945DAAC)},
    {"proad14.sno", "-", int32_t(0x00000000), int32_t(0xCEA90736)},
    {"proad14.tem", "-", int32_t(0x00000000), int32_t(0x6D1DB2EC)},
    {"proad14.ubn", "", int32_t(0x00000000), int32_t(0xFBC390CF)},
    {"proad14.urb", "", int32_t(0x00000000), int32_t(0x4B507CB3)},
    {"proad15.des", "", int32_t(0x00000000), int32_t(0x22190909)},
    {"proad15.sno", "-", int32_t(0x00000000), int32_t(0x05F5D493)},
    {"proad15.tem", "-", int32_t(0x00000000), int32_t(0xA6416149)},
    {"proad15.ubn", "", int32_t(0x00000000), int32_t(0x309F436A)},
    {"proad15.urb", "", int32_t(0x00000000), int32_t(0x800CAF16)},
    {"proad16.des", "", int32_t(0x00000000), int32_t(0xA48D7BA7)},
    {"proad16.sno", "-", int32_t(0x00000000), int32_t(0x8361A63D)},
    {"proad16.tem", "-", int32_t(0x00000000), int32_t(0x20D513E7)},
    {"proad16.ubn", "", int32_t(0x00000000), int32_t(0xB60B31C4)},
    {"proad16.urb", "", int32_t(0x00000000), int32_t(0x0698DDB8)},
    {"proad17.des", "", int32_t(0x00000000), int32_t(0x6FD1A802)},
    {"proad17.sno", "-", int32_t(0x00000000), int32_t(0x483D7598)},
    {"proad17.tem", "-", int32_t(0x00000000), int32_t(0xEB89C042)},
    {"proad17.ubn", "", int32_t(0x00000000), int32_t(0x7D57E261)},
    {"proad17.urb", "", int32_t(0x00000000), int32_t(0xCDC40E1D)},
    {"proad18.des", "", int32_t(0x00000000), int32_t(0x9E871AD7)},
    {"proad18.sno", "-", int32_t(0x00000000), int32_t(0xB96BC74D)},
    {"proad18.tem", "-", int32_t(0x00000000), int32_t(0x1ADF7297)},
    {"proad18.ubn", "", int32_t(0x00000000), int32_t(0x8C0150B4)},
    {"proad18.urb", "", int32_t(0x00000000), int32_t(0x3C92BCC8)},
    {"proad19.des", "", int32_t(0x00000000), int32_t(0x55DBC972)},
    {"proad19.sno", "-", int32_t(0x00000000), int32_t(0x723714E8)},
    {"proad19.tem", "-", int32_t(0x00000000), int32_t(0xD183A132)},
    {"proad19.ubn", "", int32_t(0x00000000), int32_t(0x475D8311)},
    {"proad19.urb", "", int32_t(0x00000000), int32_t(0xF7CE6F6D)},
    {"proad20.des", "", int32_t(0x00000000), int32_t(0x433C8227)},
    {"proad20.sno", "-", int32_t(0x00000000), int32_t(0x64D05FBD)},
    {"proad20.tem", "-", int32_t(0x00000000), int32_t(0xC764EA67)},
    {"proad20.ubn", "", int32_t(0x00000000), int32_t(0x51BAC844)},
    {"proad20.urb", "", int32_t(0x00000000), int32_t(0xE1292438)},
    {"proad21.des", "", int32_t(0x00000000), int32_t(0x88605182)},
    {"proad21.sno", "-", int32_t(0x00000000), int32_t(0xAF8C8C18)},
    {"proad21.tem", "-", int32_t(0x00000000), int32_t(0x0C3839C2)},
    {"proad21.ubn", "", int32_t(0x00000000), int32_t(0x9AE61BE1)},
    {"proad21.urb", "", int32_t(0x00000000), int32_t(0x2A75F79D)},
    {"proadc01.des", "", int32_t(0x00000000), int32_t(0xC939C098)},
    {"proadc01.sno", "", int32_t(0x00000000), int32_t(0x27A5F0E9)},
    {"proadc01.tem", "-", int32_t(0x00000000), int32_t(0x2F105E8B)},
    {"proadc01.ubn", "", int32_t(0x00000000), int32_t(0xF89AF3C1)},
    {"proadc01.urb", "", int32_t(0x00000000), int32_t(0xBBEEADBB)},
    {"proadc02.des", "", int32_t(0x00000000), int32_t(0x8E99BA48)},
    {"proadc02.sno", "", int32_t(0x00000000), int32_t(0x60058A39)},
    {"proadc02.tem", "-", int32_t(0x00000000), int32_t(0x68B0245B)},
    {"proadc02.ubn", "", int32_t(0x00000000), int32_t(0xBF3A8911)},
    {"proadc02.urb", "", int32_t(0x00000000), int32_t(0xFC4ED76B)},
    {"proadc03.des", "", int32_t(0x00000000), int32_t(0xB3F993F8)},
    {"proadc03.sno", "", int32_t(0x00000000), int32_t(0x5D65A389)},
    {"proadc03.tem", "-", int32_t(0x00000000), int32_t(0x55D00DEB)},
    {"proadc03.ubn", "", int32_t(0x00000000), int32_t(0x825AA0A1)},
    {"proadc03.urb", "", int32_t(0x00000000), int32_t(0xC12EFEDB)},
    {"proadc04.des", "", int32_t(0x00000000), int32_t(0x01D94FE8)},
    {"proadc04.sno", "", int32_t(0x00000000), int32_t(0xEF457F99)},
    {"proadc04.tem", "-", int32_t(0x00000000), int32_t(0xE7F0D1FB)},
    {"proadc04.ubn", "", int32_t(0x00000000), int32_t(0x307A7CB1)},
    {"proadc04.urb", "", int32_t(0x00000000), int32_t(0x730E22CB)},
    {"proadc05.des", "", int32_t(0x00000000), int32_t(0x3CB96658)},
    {"proadc05.sno", "", int32_t(0x00000000), int32_t(0xD2255629)},
    {"proadc05.tem", "-", int32_t(0x00000000), int32_t(0xDA90F84B)},
    {"proadc05.ubn", "", int32_t(0x00000000), int32_t(0x0D1A5501)},
    {"proadc05.urb", "", int32_t(0x00000000), int32_t(0x4E6E0B7B)},
    {"proadc06.des", "", int32_t(0x00000000), int32_t(0x7B191C88)},
    {"proadc06.sno", "", int32_t(0x00000000), int32_t(0x95852CF9)},
    {"proadc06.tem", "-", int32_t(0x00000000), int32_t(0x9D30829B)},
    {"proadc06.ubn", "", int32_t(0x00000000), int32_t(0x4ABA2FD1)},
    {"proadc06.urb", "", int32_t(0x00000000), int32_t(0x09CE71AB)},
    {"proadc07.des", "", int32_t(0x00000000), int32_t(0x46793538)},
    {"proadc07.sno", "", int32_t(0x00000000), int32_t(0xA8E50549)},
    {"proadc07.tem", "-", int32_t(0x00000000), int32_t(0xA050AB2B)},
    {"proadc07.ubn", "", int32_t(0x00000000), int32_t(0x77DA0661)},
    {"proadc07.urb", "", int32_t(0x00000000), int32_t(0x34AE581B)},
    {"proadc08.des", "", int32_t(0x00000000), int32_t(0xC429A2E9)},
    {"proadc08.sno", "", int32_t(0x00000000), int32_t(0x2AB59298)},
    {"proadc08.tem", "-", int32_t(0x00000000), int32_t(0x22003CFA)},
    {"proadc08.ubn", "", int32_t(0x00000000), int32_t(0xF58A91B0)},
    {"proadc08.urb", "", int32_t(0x00000000), int32_t(0xB6FECFCA)},
    {"proadc09.des", "", int32_t(0x00000000), int32_t(0xF9498B59)},
    {"proadc09.sno", "", int32_t(0x00000000), int32_t(0x17D5BB28)},
    {"proadc09.tem", "-", int32_t(0x00000000), int32_t(0x1F60154A)},
    {"proadc09.ubn", "", int32_t(0x00000000), int32_t(0xC8EAB800)},
    {"proadc09.urb", "", int32_t(0x00000000), int32_t(0x8B9EE67A)},
    {"proadc10.des", "", int32_t(0x00000000), int32_t(0x3F053A8D)},
    {"proadc10.sno", "", int32_t(0x00000000), int32_t(0xD1990AFC)},
    {"proadc10.tem", "-", int32_t(0x00000000), int32_t(0xD92CA49E)},
    {"proadc10.ubn", "", int32_t(0x00000000), int32_t(0x0EA609D4)},
    {"proadc10.urb", "", int32_t(0x00000000), int32_t(0x4DD257AE)},
    {"proadc11.des", "", int32_t(0x00000000), int32_t(0x0265133D)},
    {"proadc11.sno", "", int32_t(0x00000000), int32_t(0xECF9234C)},
    {"proadc11.tem", "-", int32_t(0x00000000), int32_t(0xE44C8D2E)},
    {"proadc11.ubn", "", int32_t(0x00000000), int32_t(0x33C62064)},
    {"proadc11.urb", "", int32_t(0x00000000), int32_t(0x70B27E1E)},
    {"proadc12.des", "", int32_t(0x00000000), int32_t(0x45C569ED)},
    {"proadc12.sno", "", int32_t(0x00000000), int32_t(0xAB59599C)},
    {"proadc12.tem", "-", int32_t(0x00000000), int32_t(0xA3ECF7FE)},
    {"proadc12.ubn", "", int32_t(0x00000000), int32_t(0x74665AB4)},
    {"proadc12.urb", "", int32_t(0x00000000), int32_t(0x371204CE)},
    {"proadc13.des", "", int32_t(0x00000000), int32_t(0x78A5405D)},
    {"proadc13.sno", "", int32_t(0x00000000), int32_t(0x9639702C)},
    {"proadc13.tem", "-", int32_t(0x00000000), int32_t(0x9E8CDE4E)},
    {"proadc13.ubn", "", int32_t(0x00000000), int32_t(0x49067304)},
    {"proadc13.urb", "", int32_t(0x00000000), int32_t(0x0A722D7E)},
    {"proadc14.des", "", int32_t(0x00000000), int32_t(0xCA859C4D)},
    {"proadc14.sno", "", int32_t(0x00000000), int32_t(0x2419AC3C)},
    {"proadc14.tem", "-", int32_t(0x00000000), int32_t(0x2CAC025E)},
    {"proadc14.ubn", "", int32_t(0x00000000), int32_t(0xFB26AF14)},
    {"proadc14.urb", "", int32_t(0x00000000), int32_t(0xB852F16E)},
    {"probe.hva", "", int32_t(0x00000000), int32_t(0x98DDE925)},
    {"probe.vxl", "", int32_t(0x00000000), int32_t(0x2744EE82)},
    {"proc.shp", "refinery", int32_t(0xD6E6F7CE), int32_t(0x00000000)},
    {"procicnh.des", "icon: refinery", int32_t(0xF11F1401), int32_t(0x00000000)},
    {"procicnh.tem", "icon: refinery", int32_t(0xEB1F2401), int32_t(0x00000000)},
    {"procicnh.win", "icon: refinery", int32_t(0xEC232701), int32_t(0x00000000)},
    {"procicon.shp", "icon: refinery", int32_t(0xFA242301), int32_t(0x00000000)},
    {"procmake.shp", "make: refinery", int32_t(0xE81C1F09), int32_t(0x00000000)},
    {"progbar.shp", "-", int32_t(0x00000000), int32_t(0x80CE397B)},
    {"progbar2.shp", "-", int32_t(0x00000000), int32_t(0xDC81EF3F)},
    {"progbarm.shp", "-", int32_t(0x00000000), int32_t(0xA7039821)},
    {"progres1.aud", "unable to comply", int32_t(0xC4391513), int32_t(0x00000000)},
    {"proicon.shp", "icon: banshee", int32_t(0x00000000), int32_t(0xA08D5BCA)},
    {"prolog.cps", "pict: please stand by", int32_t(0xB79A2B2F), int32_t(0x00000000)},
    {"prolog.pcx", "pict: please stand by", int32_t(0xD19A3022), int32_t(0x00000000)},
    {"prolog.vqa", "einstien eliminating hitler", int32_t(0xDD9A1930), int32_t(0x00000000)},
    {"prolog.vqp", "vqp: einstien eliminating hitler", int32_t(0xDD9A2830), int32_t(0x00000000)},
    {"prompt.trr", "", int32_t(0xDD9A4433), int32_t(0x00000000)},
    {"propa.hva", "", int32_t(0x00000000), int32_t(0x9EA18D28)},
    {"propa.vxl", "", int32_t(0x00000000), int32_t(0x21388A8F)},
    {"prp.aud", "prepare for battle", int32_t(0x5CE4F9E1), int32_t(0x00000000)},
    {"prslpe01.des", "", int32_t(0x00000000), int32_t(0x9EC54C42)},
    {"prslpe01.sno", "-", int32_t(0x00000000), int32_t(0x70597C33)},
    {"prslpe01.tem", "-", int32_t(0x00000000), int32_t(0x78ECD251)},
    {"prslpe01.ubn", "", int32_t(0x00000000), int32_t(0xAF667F1B)},
    {"prslpe01.urb", "", int32_t(0x00000000), int32_t(0xEC122161)},
    {"prslpe02.des", "", int32_t(0x00000000), int32_t(0xD9653692)},
    {"prslpe02.sno", "-", int32_t(0x00000000), int32_t(0x37F906E3)},
    {"prslpe02.tem", "-", int32_t(0x00000000), int32_t(0x3F4CA881)},
    {"prslpe02.ubn", "", int32_t(0x00000000), int32_t(0xE8C605CB)},
    {"prslpe02.urb", "", int32_t(0x00000000), int32_t(0xABB25BB1)},
    {"prslpe03.des", "", int32_t(0x00000000), int32_t(0xE4051F22)},
    {"prslpe03.sno", "-", int32_t(0x00000000), int32_t(0x0A992F53)},
    {"prslpe03.tem", "-", int32_t(0x00000000), int32_t(0x022C8131)},
    {"prslpe03.ubn", "", int32_t(0x00000000), int32_t(0xD5A62C7B)},
    {"prslpe03.urb", "", int32_t(0x00000000), int32_t(0x96D27201)},
    {"prslpe04.des", "", int32_t(0x00000000), int32_t(0x5625C332)},
    {"prslpe04.sno", "-", int32_t(0x00000000), int32_t(0xB8B9F343)},
    {"prslpe04.tem", "-", int32_t(0x00000000), int32_t(0xB00C5D21)},
    {"prslpe04.ubn", "", int32_t(0x00000000), int32_t(0x6786F06B)},
    {"prslpe04.urb", "", int32_t(0x00000000), int32_t(0x24F2AE11)},
    {"ps01-min.set", "", int32_t(0xB5993AC9), int32_t(0x00000000)},
    {"ps01.vqa", "", int32_t(0xA3B1FCCE), int32_t(0x00000000)},
    {"ps01_0.vqa", "", int32_t(0x711DEF50), int32_t(0x00000000)},
    {"ps01_1.vqa", "", int32_t(0x711DF150), int32_t(0x00000000)},
    {"ps01_2.vqa", "", int32_t(0x711DF350), int32_t(0x00000000)},
    {"ps01_3.vqa", "", int32_t(0x711DF550), int32_t(0x00000000)},
    {"ps01spnr.vqa", "", int32_t(0xAAAF4415), int32_t(0x00000000)},
    {"ps02-min.set", "", int32_t(0xB9993AC9), int32_t(0x00000000)},
    {"ps02.vqa", "", int32_t(0xA5B1FCCE), int32_t(0x00000000)},
    {"ps02_0.vqa", "", int32_t(0x751DEF50), int32_t(0x00000000)},
    {"ps02_1.vqa", "", int32_t(0x751DF150), int32_t(0x00000000)},
    {"ps02_2.vqa", "", int32_t(0x751DF350), int32_t(0x00000000)},
    {"ps02_3.vqa", "", int32_t(0x751DF550), int32_t(0x00000000)},
    {"ps02elev.vqa", "", int32_t(0xB69D3BF9), int32_t(0x00000000)},
    {"ps03-min.set", "", int32_t(0xBD993AC9), int32_t(0x00000000)},
    {"ps03.vqa", "", int32_t(0xA7B1FCCE), int32_t(0x00000000)},
    {"ps03_0.vqa", "", int32_t(0x791DEF50), int32_t(0x00000000)},
    {"ps03_1.vqa", "", int32_t(0x791DF150), int32_t(0x00000000)},
    {"ps03_2.vqa", "", int32_t(0x791DF350), int32_t(0x00000000)},
    {"ps03_3.vqa", "", int32_t(0x791DF550), int32_t(0x00000000)},
    {"ps04-min.set", "", int32_t(0xC1993AC9), int32_t(0x00000000)},
    {"ps04.vqa", "", int32_t(0xA9B1FCCE), int32_t(0x00000000)},
    {"ps04_0.vqa", "", int32_t(0x7D1DEF50), int32_t(0x00000000)},
    {"ps04_1.vqa", "", int32_t(0x7D1DF150), int32_t(0x00000000)},
    {"ps04_2.vqa", "", int32_t(0x7D1DF350), int32_t(0x00000000)},
    {"ps04_3.vqa", "", int32_t(0x7D1DF550), int32_t(0x00000000)},
    {"ps05-min.set", "", int32_t(0xC5993AC9), int32_t(0x00000000)},
    {"ps05.vqa", "", int32_t(0xABB1FCCE), int32_t(0x00000000)},
    {"ps05_0.vqa", "", int32_t(0x811DEF50), int32_t(0x00000000)},
    {"ps05_1.vqa", "", int32_t(0x811DF150), int32_t(0x00000000)},
    {"ps05_2.vqa", "", int32_t(0x811DF350), int32_t(0x00000000)},
    {"ps05_3.vqa", "", int32_t(0x811DF550), int32_t(0x00000000)},
    {"ps05over.vqa", "", int32_t(0xBA9D500D), int32_t(0x00000000)},
    {"ps06-min.set", "", int32_t(0xC9993AC9), int32_t(0x00000000)},
    {"ps06.vqa", "", int32_t(0xADB1FCCE), int32_t(0x00000000)},
    {"ps06_0.vqa", "", int32_t(0x851DEF50), int32_t(0x00000000)},
    {"ps06_1.vqa", "", int32_t(0x851DF150), int32_t(0x00000000)},
    {"ps06_2.vqa", "", int32_t(0x851DF350), int32_t(0x00000000)},
    {"ps06_3.vqa", "", int32_t(0x851DF550), int32_t(0x00000000)},
    {"ps07-min.set", "", int32_t(0xCD993AC9), int32_t(0x00000000)},
    {"ps07.vqa", "", int32_t(0xAFB1FCCE), int32_t(0x00000000)},
    {"ps07_0.vqa", "", int32_t(0x891DEF50), int32_t(0x00000000)},
    {"ps07_1.vqa", "", int32_t(0x891DF150), int32_t(0x00000000)},
    {"ps07_2.vqa", "", int32_t(0x891DF350), int32_t(0x00000000)},
    {"ps07_3.vqa", "", int32_t(0x891DF550), int32_t(0x00000000)},
    {"ps09-min.set", "", int32_t(0xD5993AC9), int32_t(0x00000000)},
    {"ps09.vqa", "", int32_t(0xB3B1FCCE), int32_t(0x00000000)},
    {"ps09_0.vqa", "", int32_t(0x911DEF50), int32_t(0x00000000)},
    {"ps09_1.vqa", "", int32_t(0x911DF150), int32_t(0x00000000)},
    {"ps09_2.vqa", "", int32_t(0x911DF350), int32_t(0x00000000)},
    {"ps09_3.vqa", "", int32_t(0x911DF550), int32_t(0x00000000)},
    {"ps10-min.set", "", int32_t(0xB19D3AC9), int32_t(0x00000000)},
    {"ps10.vqa", "", int32_t(0xA1B3FCCE), int32_t(0x00000000)},
    {"ps10_0.vqa", "", int32_t(0x6D21EF50), int32_t(0x00000000)},
    {"ps10_1.vqa", "", int32_t(0x6D21F150), int32_t(0x00000000)},
    {"ps10_2.vqa", "", int32_t(0x6D21F350), int32_t(0x00000000)},
    {"ps10_3.vqa", "", int32_t(0x6D21F550), int32_t(0x00000000)},
    {"ps11-min.set", "", int32_t(0xB59D3AC9), int32_t(0x00000000)},
    {"ps11.vqa", "", int32_t(0xA3B3FCCE), int32_t(0x00000000)},
    {"ps11_0.vqa", "", int32_t(0x7121EF50), int32_t(0x00000000)},
    {"ps11_1.vqa", "", int32_t(0x7121F150), int32_t(0x00000000)},
    {"ps11_2.vqa", "", int32_t(0x7121F350), int32_t(0x00000000)},
    {"ps11_3.vqa", "", int32_t(0x7121F550), int32_t(0x00000000)},
    {"ps12-min.set", "", int32_t(0xB99D3AC9), int32_t(0x00000000)},
    {"ps12.vqa", "", int32_t(0xA5B3FCCE), int32_t(0x00000000)},
    {"ps12_0.vqa", "", int32_t(0x7521EF50), int32_t(0x00000000)},
    {"ps12_1.vqa", "", int32_t(0x7521F150), int32_t(0x00000000)},
    {"ps12_2.vqa", "", int32_t(0x7521F350), int32_t(0x00000000)},
    {"ps12_3.vqa", "", int32_t(0x7521F550), int32_t(0x00000000)},
    {"ps13-min.set", "", int32_t(0xBD9D3AC9), int32_t(0x00000000)},
    {"ps13.vqa", "", int32_t(0xA7B3FCCE), int32_t(0x00000000)},
    {"ps13_0.vqa", "", int32_t(0x7921EF50), int32_t(0x00000000)},
    {"ps13_1.vqa", "", int32_t(0x7921F150), int32_t(0x00000000)},
    {"ps13_2.vqa", "", int32_t(0x7921F350), int32_t(0x00000000)},
    {"ps13_3.vqa", "", int32_t(0x7921F550), int32_t(0x00000000)},
    {"ps14-min.set", "", int32_t(0xC19D3AC9), int32_t(0x00000000)},
    {"ps14.vqa", "", int32_t(0xA9B3FCCE), int32_t(0x00000000)},
    {"ps14_0.vqa", "", int32_t(0x7D21EF50), int32_t(0x00000000)},
    {"ps14_1.vqa", "", int32_t(0x7D21F150), int32_t(0x00000000)},
    {"ps14_2.vqa", "", int32_t(0x7D21F350), int32_t(0x00000000)},
    {"ps14_3.vqa", "", int32_t(0x7D21F550), int32_t(0x00000000)},
    {"ps15-min.set", "", int32_t(0xC59D3AC9), int32_t(0x00000000)},
    {"ps15.vqa", "", int32_t(0xABB3FCCE), int32_t(0x00000000)},
    {"ps15_0.vqa", "", int32_t(0x8121EF50), int32_t(0x00000000)},
    {"ps15_1.vqa", "", int32_t(0x8121F150), int32_t(0x00000000)},
    {"ps15_2.vqa", "", int32_t(0x8121F350), int32_t(0x00000000)},
    {"ps15_3.vqa", "", int32_t(0x8121F550), int32_t(0x00000000)},
    {"psamb6.aud", "", int32_t(0xB761FE1A), int32_t(0x00000000)},
    {"psdoor1.aud", "", int32_t(0x99B84720), int32_t(0x00000000)},
    {"psdoor2.aud", "", int32_t(0x99BA4720), int32_t(0x00000000)},
    {"pshora01.ubn", "", int32_t(0x00000000), int32_t(0x3E41C56F)},
    {"pshora01.urb", "", int32_t(0x00000000), int32_t(0x7D359B15)},
    {"pshora02.ubn", "", int32_t(0x00000000), int32_t(0x79E1BFBF)},
    {"pshora02.urb", "", int32_t(0x00000000), int32_t(0x3A95E1C5)},
    {"pshora03.ubn", "", int32_t(0x00000000), int32_t(0x4481960F)},
    {"pshora03.urb", "", int32_t(0x00000000), int32_t(0x07F5C875)},
    {"pshora04.ubn", "", int32_t(0x00000000), int32_t(0xF6A14A1F)},
    {"pshora04.urb", "", int32_t(0x00000000), int32_t(0xB5D51465)},
    {"pshore01.ubn", "", int32_t(0x00000000), int32_t(0xCA0EE17C)},
    {"pshore01.urb", "", int32_t(0x00000000), int32_t(0x897ABF06)},
    {"pshore02.ubn", "", int32_t(0x00000000), int32_t(0x8DAE9BAC)},
    {"pshore02.urb", "", int32_t(0x00000000), int32_t(0xCEDAC5D6)},
    {"pshore03.ubn", "", int32_t(0x00000000), int32_t(0xB0CEB21C)},
    {"pshore03.urb", "", int32_t(0x00000000), int32_t(0xF3BAEC66)},
    {"pshore04.ubn", "", int32_t(0x00000000), int32_t(0x02EE6E0C)},
    {"pshore04.urb", "", int32_t(0x00000000), int32_t(0x419A3076)},
    {"pshore05.ubn", "", int32_t(0x00000000), int32_t(0x3F8E47BC)},
    {"pshore05.urb", "", int32_t(0x00000000), int32_t(0x7CFA19C6)},
    {"pshore06.ubn", "", int32_t(0x00000000), int32_t(0x782E3D6C)},
    {"pshore06.urb", "", int32_t(0x00000000), int32_t(0x3B5A6316)},
    {"pshore07.ubn", "", int32_t(0x00000000), int32_t(0x454E14DC)},
    {"pshore07.urb", "", int32_t(0x00000000), int32_t(0x063A4AA6)},
    {"pshore08.ubn", "", int32_t(0x00000000), int32_t(0xC71E830D)},
    {"pshore08.urb", "", int32_t(0x00000000), int32_t(0x846ADD77)},
    {"psicicon.shp", "", int32_t(0x00000000), int32_t(0x04620040)},
    {"psicuico.shp", "", int32_t(0x00000000), int32_t(0xC1A492A1)},
    {"psisicon.shp", "", int32_t(0x00000000), int32_t(0xA8A24231)},
    {"psiticon.shp", "", int32_t(0x00000000), int32_t(0xCCC32FF8)},
    {"psituico.shp", "", int32_t(0x00000000), int32_t(0x0905BD19)},
    {"psiwarn.shp", "", int32_t(0x00000000), int32_t(0x4C3397DD)},
    {"psmasuk1.aud", "", int32_t(0xAC213915), int32_t(0x00000000)},
    {"pspa6.aud", "", int32_t(0xAFC3A9F1), int32_t(0x00000000)},
    {"pspa7.aud", "", int32_t(0xAFC3A9F3), int32_t(0x00000000)},
    {"pspa8.aud", "", int32_t(0xAFC3A9F5), int32_t(0x00000000)},
    {"psyricon.shp", "", int32_t(0x00000000), int32_t(0x9877D79A)},
    {"psyticon.shp", "", int32_t(0x00000000), int32_t(0xEB6DAE10)},
    {"pt.shp", "unit: gunboat", int32_t(0xA65CF8E8), int32_t(0x00000000)},
    {"pticon.shp", "icon: gunboat", int32_t(0xB3823E27), int32_t(0x00000000)},
    {"ptroop.shp", "", int32_t(0x00000000), int32_t(0xDA53B58F)},
    {"ptruck.hva", "", int32_t(0x00000000), int32_t(0x91D6D200)},
    {"ptruck.vxl", "", int32_t(0x00000000), int32_t(0x41B93284)},
    {"pudlgbga.shp", "", int32_t(0x00000000), int32_t(0x1B6E8258)},
    {"pudlgbgn.shp", "", int32_t(0x00000000), int32_t(0x993E1589)},
    {"pudlgbgs.shp", "", int32_t(0x00000000), int32_t(0x014E46BA)},
    {"pudlgbgy.shp", "", int32_t(0x00000000), int32_t(0x4BFE5E1B)},
    {"pulsball.shp", "emp ball", int32_t(0x00000000), int32_t(0x909F6F87)},
    {"pulscan.hva", "-", int32_t(0x00000000), int32_t(0xC9293B0C)},
    {"pulscan.vxl", "em pulse cannon turret", int32_t(0x00000000), int32_t(0xC6DF48E7)},
    {"pulse.shp", "misc: sonar pulse", int32_t(0xDDD7B21B), int32_t(0x00000000)},
    {"pulse03.flc", "", int32_t(0xA9DB0211), int32_t(0x00000000)},
    {"pulse1.aud", "sonar pulse available", int32_t(0xCF8DFC20), int32_t(0x00000000)},
    {"pulsefx1.shp", "emp hits", int32_t(0x00000000), int32_t(0xC6F83CE3)},
    {"pulsefx2.shp", "emp hits", int32_t(0x00000000), int32_t(0x81584633)},
    {"pulsicon.shp", "icon: em pulse", int32_t(0x00000000), int32_t(0xA63E4336)},
    {"pumpicon.shp", "icon: blank tile", int32_t(0x2E1C2F01), int32_t(0x00000000)},
    {"pumpmake.shp", "make: mcv to construction yard left cut", int32_t(0x1C142B09), int32_t(0x00000000)},
    {"punch1.aud", "", int32_t(0x8F95FC26), int32_t(0x00000000)},
    {"pupticon.shp", "", int32_t(0x00000000), int32_t(0xFFCD4F99)},
    {"push1.aud", "", int32_t(0xCBCFB1E7), int32_t(0x00000000)},
    {"putbuttn.aud", "", int32_t(0xEA4F3F19), int32_t(0x00000000)},
    {"pvclr01.des", "", int32_t(0x00000000), int32_t(0xFE810C5C)},
    {"pvclr01.lun", "", int32_t(0x00000000), int32_t(0xD87FEBDF)},
    {"pvclr01.sno", "-", int32_t(0x00000000), int32_t(0xD96DD1C6)},
    {"pvclr01.tem", "-", int32_t(0x00000000), int32_t(0x7AD9641C)},
    {"pvclr01.ubn", "", int32_t(0x00000000), int32_t(0xEC07463F)},
    {"pvclr01.urb", "", int32_t(0x00000000), int32_t(0x5C94AA43)},
    {"pvclr01a.des", "", int32_t(0x00000000), int32_t(0xC74975B3)},
    {"pvclr01a.lun", "", int32_t(0x00000000), int32_t(0xE09E5A83)},
    {"pvclr01a.sno", "-", int32_t(0x00000000), int32_t(0x29D545C2)},
    {"pvclr01a.tem", "-", int32_t(0x00000000), int32_t(0x2160EBA0)},
    {"pvclr01a.ubn", "", int32_t(0x00000000), int32_t(0xF6EA46EA)},
    {"pvclr01a.urb", "", int32_t(0x00000000), int32_t(0xB59E1890)},
    {"pvclr01b.des", "", int32_t(0x00000000), int32_t(0x80E90F63)},
    {"pvclr01b.lun", "", int32_t(0x00000000), int32_t(0xA73E2053)},
    {"pvclr01b.sno", "-", int32_t(0x00000000), int32_t(0x6E753F12)},
    {"pvclr01b.tem", "-", int32_t(0x00000000), int32_t(0x66C09170)},
    {"pvclr01b.ubn", "", int32_t(0x00000000), int32_t(0xB14A3C3A)},
    {"pvclr01b.urb", "", int32_t(0x00000000), int32_t(0xF23E6240)},
    {"pvclr01c.des", "", int32_t(0x00000000), int32_t(0xBD8926D3)},
    {"pvclr01c.lun", "", int32_t(0x00000000), int32_t(0x9A5E09E3)},
    {"pvclr01c.sno", "-", int32_t(0x00000000), int32_t(0x531516A2)},
    {"pvclr01c.tem", "-", int32_t(0x00000000), int32_t(0x5BA0B8C0)},
    {"pvclr01c.ubn", "", int32_t(0x00000000), int32_t(0x8C2A158A)},
    {"pvclr01c.urb", "", int32_t(0x00000000), int32_t(0xCF5E4BF0)},
    {"pvclr01d.des", "", int32_t(0x00000000), int32_t(0x0FA9FAC3)},
    {"pvclr01d.lun", "", int32_t(0x00000000), int32_t(0x287ED5F3)},
    {"pvclr01d.sno", "-", int32_t(0x00000000), int32_t(0xE135CAB2)},
    {"pvclr01d.tem", "-", int32_t(0x00000000), int32_t(0xE98064D0)},
    {"pvclr01d.ubn", "", int32_t(0x00000000), int32_t(0x3E0AC99A)},
    {"pvclr01d.urb", "", int32_t(0x00000000), int32_t(0x7D7E97E0)},
    {"pvclr01e.des", "", int32_t(0x00000000), int32_t(0x32C9D373)},
    {"pvclr01e.lun", "", int32_t(0x00000000), int32_t(0x151EFC43)},
    {"pvclr01e.sno", "-", int32_t(0x00000000), int32_t(0xDC55E302)},
    {"pvclr01e.tem", "-", int32_t(0x00000000), int32_t(0xD4E04D60)},
    {"pvclr01e.ubn", "", int32_t(0x00000000), int32_t(0x036AE02A)},
    {"pvclr01e.urb", "", int32_t(0x00000000), int32_t(0x401EBE50)},
    {"pvclr01f.des", "", int32_t(0x00000000), int32_t(0x7569A9A3)},
    {"pvclr01f.lun", "", int32_t(0x00000000), int32_t(0x52BE8693)},
    {"pvclr01f.sno", "-", int32_t(0x00000000), int32_t(0x9BF599D2)},
    {"pvclr01f.tem", "-", int32_t(0x00000000), int32_t(0x934037B0)},
    {"pvclr01f.ubn", "", int32_t(0x00000000), int32_t(0x44CA9AFA)},
    {"pvclr01f.urb", "", int32_t(0x00000000), int32_t(0x07BEC480)},
    {"pvclr01g.des", "", int32_t(0x00000000), int32_t(0x48098013)},
    {"pvclr01g.lun", "", int32_t(0x00000000), int32_t(0x6FDEAF23)},
    {"pvclr01g.sno", "-", int32_t(0x00000000), int32_t(0xA695B062)},
    {"pvclr01g.tem", "-", int32_t(0x00000000), int32_t(0xAE201E00)},
    {"pvclr01g.ubn", "", int32_t(0x00000000), int32_t(0x79AAB34A)},
    {"pvclr01g.urb", "", int32_t(0x00000000), int32_t(0x3ADEED30)},
    {"pvv1435103e.aud", "", int32_t(0xAC563AF3), int32_t(0x00000000)},
    {"pvvdirtwlk4.aud", "", int32_t(0xDCB0E780), int32_t(0x00000000)},
    {"pvvmlevel4a.wav", "", int32_t(0xDCE471A2), int32_t(0x00000000)},
    {"pvvpeepclo1.aud", "", int32_t(0xEC9ABB70), int32_t(0x00000000)},
    {"pvvvvtorch3.wav", "", int32_t(0x58ACD5B7), int32_t(0x00000000)},
    {"pwod3.img", "", int32_t(0xABCFB9EE), int32_t(0x00000000)},
    {"pwod3.lmf", "", int32_t(0xABD5B9ED), int32_t(0x00000000)},
    {"pwod3.lsv", "", int32_t(0xB7D5B9FD), int32_t(0x00000000)},
    {"pwod3.odf", "", int32_t(0x99DBB9ED), int32_t(0x00000000)},
    {"pwod3.pcx", "", int32_t(0x97DDB9FF), int32_t(0x00000000)},
    {"pwod3.ver", "", int32_t(0x9BE9B9F9), int32_t(0x00000000)},
    {"pwrlvl.shp", "", int32_t(0x00000000), int32_t(0xB9B633F1)},
    {"pyle.shp", "gdi barracks", int32_t(0xDAE105CE), int32_t(0x00000000)},
    {"pyleicnh.des", "icon: gdi barracks", int32_t(0xF9133001), int32_t(0x00000000)},
    {"pyleicnh.tem", "icon: gdi barracks", int32_t(0xF3134001), int32_t(0x00000000)},
    {"pyleicnh.win", "icon: gdi barracks", int32_t(0xF4174301), int32_t(0x00000000)},
    {"pyleicon.shp", "icon: gdi barracks", int32_t(0x02183F01), int32_t(0x00000000)},
    {"pylemake.shp", "make: gdi barracks", int32_t(0xF0103B09), int32_t(0x00000000)},
    {"qevent.trr", "", int32_t(0xBDB61033), int32_t(0x00000000)},
    {"qsand1.aud", "", int32_t(0xBB61F422), int32_t(0x00000000)},
    {"qsand2.aud", "", int32_t(0xBB61F622), int32_t(0x00000000)},
    {"qsand3.aud", "", int32_t(0xBB61F822), int32_t(0x00000000)},
    {"qsand4.aud", "", int32_t(0xBB61FA22), int32_t(0x00000000)},
    {"qsand5.aud", "", int32_t(0xBB61FC22), int32_t(0x00000000)},
    {"qsand6.aud", "", int32_t(0xBB61FE22), int32_t(0x00000000)},
    {"qsand7.aud", "", int32_t(0xBB620022), int32_t(0x00000000)},
    {"qsand8.aud", "", int32_t(0xBB620222), int32_t(0x00000000)},
    {"qtext.trr", "", int32_t(0x05BDAE3E), int32_t(0x00000000)},
    {"qtnk.shp", "unit: m.a.d. tank", int32_t(0xE6E4FBD0), int32_t(0x00000000)},
    {"qtnkicon.shp", "icon: m.a.d. tank", int32_t(0x1A202B05), int32_t(0x00000000)},
    {"quake1.aud", "", int32_t(0xAF61FC24), int32_t(0x00000000)},
    {"quake2.aud", "", int32_t(0xAF61FE24), int32_t(0x00000000)},
    {"quake3.aud", "", int32_t(0xAF620024), int32_t(0x00000000)},
    {"quake4.aud", "", int32_t(0xAF620224), int32_t(0x00000000)},
    {"quaker1.aud", "", int32_t(0x89AC4F10), int32_t(0x00000000)},
    {"quaker2.aud", "", int32_t(0x89AE4F10), int32_t(0x00000000)},
    {"quaker3.aud", "", int32_t(0x89B04F10), int32_t(0x00000000)},
    {"quee.shp", "unit: queen ant", int32_t(0xDAD2FDD0), int32_t(0x00000000)},
    {"quickmatch.pal", "", int32_t(0x00000000), int32_t(0x66518BDA)},
    {"quickmatch.shp", "", int32_t(0x00000000), int32_t(0x30195C30)},
    {"qvox1.aud", "", int32_t(0x0BBFB5EA), int32_t(0x00000000)},
    {"qvox2.aud", "", int32_t(0x0BBFB5EC), int32_t(0x00000000)},
    {"qwod0.img", "", int32_t(0xABCFB9EC), int32_t(0x00000000)},
    {"qwod0.lmf", "", int32_t(0xABD5B9EB), int32_t(0x00000000)},
    {"qwod0.lsv", "", int32_t(0xB7D5B9FB), int32_t(0x00000000)},
    {"qwod0.odf", "", int32_t(0x99DBB9EB), int32_t(0x00000000)},
    {"qwod0.pcx", "", int32_t(0x97DDB9FD), int32_t(0x00000000)},
    {"qwod0.ver", "", int32_t(0x9BE9B9F7), int32_t(0x00000000)},
    {"r-dn.shp", "-", int32_t(0x00000000), int32_t(0xD29D01C1)},
    {"r-up.shp", "-", int32_t(0x00000000), int32_t(0xC5C7F91C)},
    {"ra.col", "pal: setup program palette", int32_t(0x865CCEF3), int32_t(0x00000000)},
    {"ra.pal", "pal: red alert", int32_t(0xA05CCEE5), int32_t(0x00000000)},
    {"ra2-opt.wav", "", int32_t(0x00000000), int32_t(0xCB076AD4)},
    {"ra2-sco.wav", "", int32_t(0x00000000), int32_t(0xDF343ABB)},
    {"ra2.csf", "", int32_t(0x00000000), int32_t(0x7F6FBCDF)},
    {"ra2logo.shp", "", int32_t(0x00000000), int32_t(0x9D9EA475)},
    {"ra2md.csf", "", int32_t(0x00000000), int32_t(0xBD835079)},
    {"ra2ts_l.bik", "", int32_t(0x00000000), int32_t(0x33665128)},
    {"ra2ts_s.bik", "", int32_t(0x00000000), int32_t(0xC1E6E166)},
    {"rabeep1.aud", "map sound #7", int32_t(0x71AFFB14), int32_t(0x00000000)},
    {"rachel_e.vqa", "", int32_t(0xED1CF401), int32_t(0x00000000)},
    {"rad1icon.shp", "icon: threat rating node", int32_t(0x00000000), int32_t(0x35688336)},
    {"rad2icon.shp", "icon: seeker control", int32_t(0x00000000), int32_t(0x0CE5BFF3)},
    {"rad3icon.shp", "icon: ion cannon uplink", int32_t(0x00000000), int32_t(0x1B9EABB0)},
    {"radar.gdi", "gdi radar and logo", int32_t(0x8D9F6236), int32_t(0x00000000)},
    {"radar.jp", "jp radar and logo", int32_t(0xD2D2B0F6), int32_t(0x00000000)},
    {"radar.nod", "nod radar and logo", int32_t(0xA3AD6231), int32_t(0x00000000)},
    {"radar.pal", "", int32_t(0x00000000), int32_t(0xF0D13B39)},
    {"radar.shp", "-", int32_t(0x00000000), int32_t(0x93ECC2D3)},
    {"radar01.shp", "", int32_t(0x00000000), int32_t(0x68DF1013)},
    {"radar02.shp", "", int32_t(0x00000000), int32_t(0xEE4B62BD)},
    {"radard.shp", "", int32_t(0xAB6DDE35), int32_t(0x00000000)},
    {"radardn1.aud", "power down", int32_t(0xAC02CF1B), int32_t(0x6B7738D4)},
    {"radarfrm.shp", "misc: edges", int32_t(0xEFFDE51B), int32_t(0x00000000)},
    {"radaron2.aud", "power up", int32_t(0xAE02E51B), int32_t(0x00000000)},
    {"radary.shp", "", int32_t(0x00000000), int32_t(0x799D088D)},
    {"radaryuri.pal", "", int32_t(0x00000000), int32_t(0x0B8D57C4)},
    {"radiatr1.aud", "", int32_t(0xCC0AEEF9), int32_t(0x00000000)},
    {"radiatr2.aud", "", int32_t(0xCE0AEEF9), int32_t(0x00000000)},
    {"radiatr3.aud", "", int32_t(0xD00AEEF9), int32_t(0x00000000)},
    {"radiatr4.aud", "", int32_t(0xD20AEEF9), int32_t(0x00000000)},
    {"radio.aud", "radio", int32_t(0xCF93622B), int32_t(0x00000000)},
    {"radio2.aud", "radio 2", int32_t(0xA76DAE3C), int32_t(0x00000000)},
    {"radios.shp", "", int32_t(0x00000000), int32_t(0x818BD121)},
    {"radricon.shp", "icon: gdi radar", int32_t(0x00000000), int32_t(0x50863E57)},
    {"radrraid.vqa", "heavy tanks attacking base", int32_t(0x12F4DE1B), int32_t(0x00000000)},
    {"radrraid.vqp", "vqp: heavy tanks attacking base", int32_t(0x21F4DE1B), int32_t(0x00000000)},
    {"radtrans.shp", "", int32_t(0x00000000), int32_t(0xC6FEFB1F)},
    {"railbrdg.des", "", int32_t(0x00000000), int32_t(0x0FA0AF98)},
    {"railbrdg.lun", "", int32_t(0x00000000), int32_t(0x287780A8)},
    {"railbrdg.sno", "-", int32_t(0x00000000), int32_t(0xE13C9FE9)},
    {"railbrdg.tem", "-", int32_t(0x00000000), int32_t(0xE989318B)},
    {"railbrdg.ubn", "", int32_t(0x00000000), int32_t(0x3E039CC1)},
    {"railbrdg.urb", "", int32_t(0x00000000), int32_t(0x7D77C2BB)},
    {"railuse5.aud", "heavy mech railgun", int32_t(0x00000000), int32_t(0x583DA969)},
    {"rain.aud", "rain in the night", int32_t(0xE0E7C3D2), int32_t(0x00000000)},
    {"rain10.aud", "", int32_t(0xBB81AA00), int32_t(0x00000000)},
    {"rainaly1.aud", "", int32_t(0xE02CDEF9), int32_t(0x00000000)},
    {"rainawn1.aud", "", int32_t(0xE016F4F9), int32_t(0x00000000)},
    {"rainnite.aud", "-", int32_t(0x00000000), int32_t(0xA5EC5EE3)},
    {"raisen1.aud", "", int32_t(0xA9CBF714), int32_t(0x00000000)},
    {"raisey1.aud", "", int32_t(0xA9CC0D14), int32_t(0x00000000)},
    {"rambo1.aud", "got a present for ya", int32_t(0x8B91AC3C), int32_t(0x00000000)},
    {"rambo2.aud", "hahaha", int32_t(0x8B91AE3C), int32_t(0x00000000)},
    {"rambo3.aud", "real tough guy", int32_t(0x8B91B03C), int32_t(0x00000000)},
    {"ramenu1.aud", "map sound #8", int32_t(0x71DC0526), int32_t(0x00000000)},
    {"ramgun2.aud", "commando gun sound", int32_t(0x79DDF734), int32_t(0x00000000)},
    {"ramgun2.juv", "commando gun sound", int32_t(0x79EFF73D), int32_t(0x00000000)},
    {"ramp01.des", "", int32_t(0x00000000), int32_t(0x48F9819A)},
    {"ramp01.sno", "-", int32_t(0x00000000), int32_t(0xCFD6CE95)},
    {"ramp01.tem", "-", int32_t(0x00000000), int32_t(0x3EA19862)},
    {"ramp01.ubn", "", int32_t(0x00000000), int32_t(0x0234A291)},
    {"ramp01.urb", "", int32_t(0x00000000), int32_t(0x46801C0E)},
    {"ramp02.des", "", int32_t(0x00000000), int32_t(0x79119B07)},
    {"ramp02.sno", "-", int32_t(0x00000000), int32_t(0xFE3ED408)},
    {"ramp02.tem", "-", int32_t(0x00000000), int32_t(0x0F4982FF)},
    {"ramp02.ubn", "", int32_t(0x00000000), int32_t(0x33DCB80C)},
    {"ramp02.urb", "", int32_t(0x00000000), int32_t(0x77680693)},
    {"ramp03.des", "", int32_t(0x00000000), int32_t(0xDF6690B3)},
    {"ramp03.sno", "-", int32_t(0x00000000), int32_t(0x5849DFBC)},
    {"ramp03.tem", "-", int32_t(0x00000000), int32_t(0xA93E894B)},
    {"ramp03.ubn", "", int32_t(0x00000000), int32_t(0x95ABB3B8)},
    {"ramp03.urb", "", int32_t(0x00000000), int32_t(0xD11F0D27)},
    {"ramp04.des", "", int32_t(0x00000000), int32_t(0x1AC1AE3D)},
    {"ramp04.sno", "-", int32_t(0x00000000), int32_t(0x9DEEE132)},
    {"ramp04.tem", "-", int32_t(0x00000000), int32_t(0x6C99B7C5)},
    {"ramp04.ubn", "", int32_t(0x00000000), int32_t(0x500C8D36)},
    {"ramp04.urb", "", int32_t(0x00000000), int32_t(0x14B833A9)},
    {"ramp05.des", "", int32_t(0x00000000), int32_t(0xBCB6A589)},
    {"ramp05.sno", "-", int32_t(0x00000000), int32_t(0x3B99EA86)},
    {"ramp05.tem", "-", int32_t(0x00000000), int32_t(0xCAEEBC71)},
    {"ramp05.ubn", "", int32_t(0x00000000), int32_t(0xF67B8682)},
    {"ramp05.urb", "", int32_t(0x00000000), int32_t(0xB2CF381D)},
    {"ramp06.des", "", int32_t(0x00000000), int32_t(0x8D5EBF14)},
    {"ramp06.sno", "-", int32_t(0x00000000), int32_t(0x0A71F01B)},
    {"ramp06.tem", "-", int32_t(0x00000000), int32_t(0xFB06A6EC)},
    {"ramp06.ubn", "", int32_t(0x00000000), int32_t(0xC7939C1F)},
    {"ramp06.urb", "", int32_t(0x00000000), int32_t(0x83272280)},
    {"ramp07.des", "", int32_t(0x00000000), int32_t(0x2B29B4A0)},
    {"ramp07.sno", "-", int32_t(0x00000000), int32_t(0xAC06FBAF)},
    {"ramp07.tem", "-", int32_t(0x00000000), int32_t(0x5D71AD58)},
    {"ramp07.ubn", "", int32_t(0x00000000), int32_t(0x61E497AB)},
    {"ramp07.urb", "", int32_t(0x00000000), int32_t(0x25502934)},
    {"ramp08.des", "", int32_t(0x00000000), int32_t(0xDD61C449)},
    {"ramp08.sno", "-", int32_t(0x00000000), int32_t(0x5A4E8B46)},
    {"ramp08.tem", "-", int32_t(0x00000000), int32_t(0xAB39DDB1)},
    {"ramp08.ubn", "", int32_t(0x00000000), int32_t(0x97ACE742)},
    {"ramp08.urb", "", int32_t(0x00000000), int32_t(0xD31859DD)},
    {"ramp09.des", "", int32_t(0x00000000), int32_t(0x7B16CFFD)},
    {"ramp09.sno", "-", int32_t(0x00000000), int32_t(0xFC3980F2)},
    {"ramp09.tem", "-", int32_t(0x00000000), int32_t(0x0D4ED605)},
    {"ramp09.ubn", "", int32_t(0x00000000), int32_t(0x31DBECF6)},
    {"ramp09.urb", "", int32_t(0x00000000), int32_t(0x756F5269)},
    {"ramp10.des", "", int32_t(0x00000000), int32_t(0x22248AB0)},
    {"ramp10.sno", "-", int32_t(0x00000000), int32_t(0xA50BC5BF)},
    {"ramp10.tem", "-", int32_t(0x00000000), int32_t(0x547C9348)},
    {"ramp10.ubn", "", int32_t(0x00000000), int32_t(0x68E9A9BB)},
    {"ramp10.urb", "", int32_t(0x00000000), int32_t(0x2C5D1724)},
    {"ramp11.des", "", int32_t(0x00000000), int32_t(0x84538104)},
    {"ramp12.des", "", int32_t(0x00000000), int32_t(0xB5BB9B99)},
    {"ramp13.des", "", int32_t(0x00000000), int32_t(0x13CC902D)},
    {"ramp14.des", "", int32_t(0x00000000), int32_t(0xD66BAEA3)},
    {"ramp15.des", "", int32_t(0x00000000), int32_t(0x701CA517)},
    {"ramp16.des", "", int32_t(0x00000000), int32_t(0x41F4BF8A)},
    {"ramp17.des", "", int32_t(0x00000000), int32_t(0xE783B43E)},
    {"ramp18.des", "", int32_t(0x00000000), int32_t(0x11CBC4D7)},
    {"ramp19.des", "", int32_t(0x00000000), int32_t(0xB7BCCF63)},
    {"ramp20.des", "", int32_t(0x00000000), int32_t(0xACAB8D53)},
    {"rampx01.ubn", "", int32_t(0x00000000), int32_t(0x420C94F6)},
    {"rampx02.ubn", "", int32_t(0x00000000), int32_t(0xC498E658)},
    {"rampx03.ubn", "", int32_t(0x00000000), int32_t(0x0FC435FD)},
    {"rampx04.ubn", "", int32_t(0x00000000), int32_t(0x12C10545)},
    {"rampx05.ubn", "", int32_t(0x00000000), int32_t(0xD99DD6E0)},
    {"rampx06.ubn", "", int32_t(0x00000000), int32_t(0x5F09A44E)},
    {"rampx07.ubn", "", int32_t(0x00000000), int32_t(0x945577EB)},
    {"rampx08.ubn", "", int32_t(0x00000000), int32_t(0x6503C53E)},
    {"rampx09.ubn", "", int32_t(0x00000000), int32_t(0xAE5F169B)},
    {"rampx10.ubn", "", int32_t(0x00000000), int32_t(0x2F274CE7)},
    {"ramyell1.aud", "commando yell", int32_t(0x0C22DF01), int32_t(0x00000000)},
    {"rani.pcx", "", int32_t(0x00000000), int32_t(0x62593786)},
    {"rani.shp", "", int32_t(0x00000000), int32_t(0x8D30D826)},
    {"rank_am.shp", "", int32_t(0x8A23D05A), int32_t(0x00000000)},
    {"rank_ra.shp", "", int32_t(0x8A0BF25A), int32_t(0x00000000)},
    {"rapid.shp", "crat: red skull", int32_t(0xB5E76221), int32_t(0x00000000)},
    {"rapt.shp", "velociraptor", int32_t(0xF8E8D5D2), int32_t(0x00000000)},
    {"rapticnh.shp", "", int32_t(0x3225DF09), int32_t(0x00000000)},
    {"rapticnh.tem", "", int32_t(0x2F22E009), int32_t(0x00000000)},
    {"rashapes.shp", "curs: setup mouse cursors", int32_t(0x181FF8F9), int32_t(0x00000000)},
    {"rat1.aud", "", int32_t(0xA6FDC3D2), int32_t(0x00000000)},
    {"rat2.aud", "", int32_t(0xA8FDC3D2), int32_t(0x00000000)},
    {"rat3.aud", "", int32_t(0xAAFDC3D2), int32_t(0x00000000)},
    {"rat_die1.aud", "", int32_t(0x2430D8FF), int32_t(0x00000000)},
    {"rat_die2.aud", "", int32_t(0x2630D8FF), int32_t(0x00000000)},
    {"rat_die3.aud", "", int32_t(0x2830D8FF), int32_t(0x00000000)},
    {"rat_die4.aud", "", int32_t(0x2A30D8FF), int32_t(0x00000000)},
    {"rat_die5.aud", "", int32_t(0x2C30D8FF), int32_t(0x00000000)},
    {"rat_die6.aud", "", int32_t(0x2E30D8FF), int32_t(0x00000000)},
    {"rat_hit1.aud", "", int32_t(0x244ED907), int32_t(0x00000000)},
    {"rat_hit2.aud", "", int32_t(0x264ED907), int32_t(0x00000000)},
    {"rat_hit3.aud", "", int32_t(0x284ED907), int32_t(0x00000000)},
    {"rat_hit4.aud", "", int32_t(0x2A4ED907), int32_t(0x00000000)},
    {"rat_loi1.aud", "", int32_t(0x2438E50F), int32_t(0x00000000)},
    {"rat_loi2.aud", "", int32_t(0x2638E50F), int32_t(0x00000000)},
    {"rat_run1.aud", "", int32_t(0x2442F11B), int32_t(0x00000000)},
    {"rat_run2.aud", "", int32_t(0x2642F11B), int32_t(0x00000000)},
    {"rat_stn1.aud", "", int32_t(0x2442EF1D), int32_t(0x00000000)},
    {"rat_stn2.aud", "", int32_t(0x2642EF1D), int32_t(0x00000000)},
    {"ratty1.aud", "", int32_t(0xD3ADAC50), int32_t(0x00000000)},
    {"ratty2.aud", "", int32_t(0xD3ADAE50), int32_t(0x00000000)},
    {"ratty3.aud", "", int32_t(0xD3ADB050), int32_t(0x00000000)},
    {"ratty4.aud", "", int32_t(0xD3ADB250), int32_t(0x00000000)},
    {"ratty5.aud", "", int32_t(0xD3ADB450), int32_t(0x00000000)},
    {"ratty6.aud", "", int32_t(0xD3ADB650), int32_t(0x00000000)},
    {"ratty7.aud", "", int32_t(0xD3ADB850), int32_t(0x00000000)},
    {"ratty8.aud", "", int32_t(0xD3ADBA50), int32_t(0x00000000)},
    {"ratty9.aud", "", int32_t(0xD3ADBC50), int32_t(0x00000000)},
    {"rbccicon.shp", "", int32_t(0x00000000), int32_t(0x9003151D)},
    {"rbfix01.ubn", "", int32_t(0x00000000), int32_t(0x236DFD2A)},
    {"rbfix01.urb", "", int32_t(0x00000000), int32_t(0x93FE1156)},
    {"rbfix02.ubn", "", int32_t(0x00000000), int32_t(0xA5F98F84)},
    {"rbfix02.urb", "", int32_t(0x00000000), int32_t(0x156A63F8)},
    {"rbfix03.ubn", "", int32_t(0x00000000), int32_t(0x6EA55C21)},
    {"rbfix03.urb", "", int32_t(0x00000000), int32_t(0xDE36B05D)},
    {"rbfix04.ubn", "", int32_t(0x00000000), int32_t(0x73A06C99)},
    {"rbfix04.urb", "", int32_t(0x00000000), int32_t(0xC33380E5)},
    {"rbfix05.ubn", "", int32_t(0x00000000), int32_t(0xB8FCBF3C)},
    {"rbfix05.urb", "", int32_t(0x00000000), int32_t(0x086F5340)},
    {"rbfix06.ubn", "", int32_t(0x00000000), int32_t(0x3E68CD92)},
    {"rbfix06.urb", "", int32_t(0x00000000), int32_t(0x8EFB21EE)},
    {"rbfix07.ubn", "", int32_t(0x00000000), int32_t(0xF5341E37)},
    {"rbfix07.urb", "", int32_t(0x00000000), int32_t(0x45A7F24B)},
    {"rbfix08.ubn", "", int32_t(0x00000000), int32_t(0x0462ACE2)},
    {"rbfix08.urb", "", int32_t(0x00000000), int32_t(0xB4F1409E)},
    {"rboticon.shp", "icon: mobile repair vehicle", int32_t(0x00000000), int32_t(0x429EDA2B)},
    {"rc0.aud", "", int32_t(0x5CA4DBE5), int32_t(0x00000000)},
    {"rc01-min.set", "", int32_t(0xB598FAD1), int32_t(0x00000000)},
    {"rc01.sno", "river", int32_t(0xB1AED9D2), int32_t(0x00000000)},
    {"rc01.tem", "river", int32_t(0xAFA5DAD2), int32_t(0x00000000)},
    {"rc01.vqa", "", int32_t(0xA3B1DCD2), int32_t(0x00000000)},
    {"rc01_0.vqa", "", int32_t(0x711DAF58), int32_t(0x00000000)},
    {"rc01_1.vqa", "", int32_t(0x711DB158), int32_t(0x00000000)},
    {"rc01_2.vqa", "", int32_t(0x711DB358), int32_t(0x00000000)},
    {"rc01_3.vqa", "", int32_t(0x711DB558), int32_t(0x00000000)},
    {"rc01spnr.vqa", "", int32_t(0xAAAF041D), int32_t(0x00000000)},
    {"rc02-min.set", "", int32_t(0xB998FAD1), int32_t(0x00000000)},
    {"rc02.sno", "river", int32_t(0xB3AED9D2), int32_t(0x00000000)},
    {"rc02.tem", "river", int32_t(0xB1A5DAD2), int32_t(0x00000000)},
    {"rc02.vqa", "", int32_t(0xA5B1DCD2), int32_t(0x00000000)},
    {"rc02_0.vqa", "", int32_t(0x751DAF58), int32_t(0x00000000)},
    {"rc02_1.vqa", "", int32_t(0x751DB158), int32_t(0x00000000)},
    {"rc02_2.vqa", "", int32_t(0x751DB358), int32_t(0x00000000)},
    {"rc02_3.vqa", "", int32_t(0x751DB558), int32_t(0x00000000)},
    {"rc02_fa.img", "", int32_t(0x258AE750), int32_t(0x00000000)},
    {"rc02_ra.img", "", int32_t(0x258AFF50), int32_t(0x00000000)},
    {"rc02esp1.vqa", "", int32_t(0x6CB30A01), int32_t(0x00000000)},
    {"rc02esp2.vqa", "", int32_t(0x6EB30A01), int32_t(0x00000000)},
    {"rc02esp3.vqa", "", int32_t(0x70B30A01), int32_t(0x00000000)},
    {"rc02esp4.vqa", "", int32_t(0x72B30A01), int32_t(0x00000000)},
    {"rc02esp5.vqa", "", int32_t(0x74B30A01), int32_t(0x00000000)},
    {"rc02esp6.vqa", "", int32_t(0x76B30A01), int32_t(0x00000000)},
    {"rc02esp7.vqa", "", int32_t(0x78B30A01), int32_t(0x00000000)},
    {"rc03-min.set", "", int32_t(0xBD98FAD1), int32_t(0x00000000)},
    {"rc03.sno", "river", int32_t(0xB5AED9D2), int32_t(0x00000000)},
    {"rc03.tem", "river", int32_t(0xB3A5DAD2), int32_t(0x00000000)},
    {"rc03.vqa", "", int32_t(0xA7B1DCD2), int32_t(0x00000000)},
    {"rc03_0.vqa", "", int32_t(0x791DAF58), int32_t(0x00000000)},
    {"rc03_1.vqa", "", int32_t(0x791DB158), int32_t(0x00000000)},
    {"rc03_2.vqa", "", int32_t(0x791DB358), int32_t(0x00000000)},
    {"rc03_3.vqa", "", int32_t(0x791DB558), int32_t(0x00000000)},
    {"rc04-min.set", "", int32_t(0xC198FAD1), int32_t(0x00000000)},
    {"rc04.sno", "river", int32_t(0xB7AED9D2), int32_t(0x00000000)},
    {"rc04.tem", "river", int32_t(0xB5A5DAD2), int32_t(0x00000000)},
    {"rc04.vqa", "", int32_t(0xA9B1DCD2), int32_t(0x00000000)},
    {"rc04_0.vqa", "", int32_t(0x7D1DAF58), int32_t(0x00000000)},
    {"rc04_1.vqa", "", int32_t(0x7D1DB158), int32_t(0x00000000)},
    {"rc04_2.vqa", "", int32_t(0x7D1DB358), int32_t(0x00000000)},
    {"rc04_3.vqa", "", int32_t(0x7D1DB558), int32_t(0x00000000)},
    {"rc51-min.set", "", int32_t(0xB5ACFAD1), int32_t(0x00000000)},
    {"rc51.vqa", "", int32_t(0xA3BBDCD2), int32_t(0x00000000)},
    {"rc51_0.vqa", "", int32_t(0x7131AF58), int32_t(0x00000000)},
    {"rc51_1.vqa", "", int32_t(0x7131B158), int32_t(0x00000000)},
    {"rc51_2.vqa", "", int32_t(0x7131B358), int32_t(0x00000000)},
    {"rc51_3.vqa", "", int32_t(0x7131B558), int32_t(0x00000000)},
    {"rcamb1.aud", "", int32_t(0xB761B422), int32_t(0x00000000)},
    {"rcambr1.aud", "", int32_t(0x91AC070E), int32_t(0x00000000)},
    {"rccarby1.aud", "", int32_t(0xAC14D31B), int32_t(0x00000000)},
    {"rccarby2.aud", "", int32_t(0xAE14D31B), int32_t(0x00000000)},
    {"rccarby3.aud", "", int32_t(0xB014D31B), int32_t(0x00000000)},
    {"rclock2.shp", "-", int32_t(0x00000000), int32_t(0x334CF57E)},
    {"rcmtbg.shp", "", int32_t(0x00000000), int32_t(0x70E94B00)},
    {"rcmtbg2.shp", "", int32_t(0x00000000), int32_t(0xF9112806)},
    {"rcmtmd.shp", "", int32_t(0x00000000), int32_t(0x98214331)},
    {"rcmtmd2.shp", "", int32_t(0x00000000), int32_t(0x11D92037)},
    {"rcmtsm.shp", "", int32_t(0x00000000), int32_t(0x648825FB)},
    {"rcmtsm2.shp", "", int32_t(0x00000000), int32_t(0xED7046FD)},
    {"rcrain1.aud", "", int32_t(0x61EFFF1C), int32_t(0x00000000)},
    {"rcrdt.shp", "", int32_t(0x00000000), int32_t(0x6DC8C675)},
    {"rcrdt2.shp", "", int32_t(0x00000000), int32_t(0x0E081434)},
    {"rctalk1.aud", "", int32_t(0x61F7F922), int32_t(0x00000000)},
    {"rctalk2.aud", "", int32_t(0x61F9F922), int32_t(0x00000000)},
    {"rctalk3.aud", "", int32_t(0x61FBF922), int32_t(0x00000000)},
    {"rdrbeacn.shp", "", int32_t(0x00000000), int32_t(0x1053E5D6)},
    {"readme1.aud", "audf:", int32_t(0x6DABF524), int32_t(0x00000000)},
    {"ready.r01", "soviet #2 ready & waiting", int32_t(0x71A9722C), int32_t(0x00000000)},
    {"ready.r03", "soviet #4 ready & waiting", int32_t(0x71A9722E), int32_t(0x00000000)},
    {"ready.v01", "c&c #2 ready & waiting", int32_t(0x71B1722C), int32_t(0x00000000)},
    {"ready.v03", "c&c #4 ready & waiting", int32_t(0x71B1722E), int32_t(0x00000000)},
    {"reaper.shp", "-", int32_t(0x00000000), int32_t(0xE0AF8AB1)},
    {"reapicon.shp", "-", int32_t(0x00000000), int32_t(0x2880AE17)},
    {"recn226m.aud", "recon", int32_t(0x17CEBADB), int32_t(0x00000000)},
    {"record.bin", "info for map screens (population etc)", int32_t(0xC169EC36), int32_t(0x00000000)},
    {"redintro.vqa", "red alert intro sequence", int32_t(0x05071413), int32_t(0x00000000)},
    {"redintro.vqp", "vqp: red alert intro sequence", int32_t(0x14071413), int32_t(0x00000000)},
    {"redlite.shp", "", int32_t(0x00000000), int32_t(0xE7D28E9A)},
    {"redsky.aud", "red sky", int32_t(0x00000000), int32_t(0xE8FC172D)},
    {"reficon.shp", "-", int32_t(0x00000000), int32_t(0x376E3FD7)},
    {"refinery.vqa", "info on tiberium refinery", int32_t(0x190EF613), int32_t(0x00000000)},
    {"refinery.vqp", "info on tiberium refinery", int32_t(0x280EF613), int32_t(0x00000000)},
    {"refint.vqa", "interior of tiberium refinery", int32_t(0xD175FF36), int32_t(0x00000000)},
    {"refint.vqp", "interior of tiberium refinery", int32_t(0xD1760E36), int32_t(0x00000000)},
    {"refresh.shp", "", int32_t(0xA5FA0426), int32_t(0x00000000)},
    {"reg_sh.flc", "", int32_t(0x0979E93A), int32_t(0x00000000)},
    {"regcard.aud", "", int32_t(0x69EA0F0C), int32_t(0x00000000)},
    {"regcard1.aud", "audf:", int32_t(0xB3FAFAF9), int32_t(0x00000000)},
    {"registrationscreen.pal", "", int32_t(0x00000000), int32_t(0x1E6C9EA1)},
    {"registrationscreen.shp", "", int32_t(0x00000000), int32_t(0x4824494B)},
    {"reinfor1.aud", "reinforcements have arrived", int32_t(0xE01EF503), int32_t(0x00000000)},
    {"reload.shp", "", int32_t(0xE38DEE13), int32_t(0x00000000)},
    {"rendcap.shp", "", int32_t(0x00000000), int32_t(0xBC1580C2)},
    {"renegade.bik", "", int32_t(0x00000000), int32_t(0x2E440187)},
    {"repair.hva", "-", int32_t(0x00000000), int32_t(0x84CA5101)},
    {"repair.shp", "butt: repair", int32_t(0xAB9E0A23), int32_t(0xC4D7231A)},
    {"repair.vxl", "mobile repair tank", int32_t(0x00000000), int32_t(0x54A5B185)},
    {"repair1.aud", "repairing", int32_t(0x61E80F1C), int32_t(0x00000000)},
    {"repair11.aud", "repair vehicle", int32_t(0x00000000), int32_t(0x2A405159)},
    {"report1.r00", "soviet #1 reporting", int32_t(0x99D3EE3F), int32_t(0x00000000)},
    {"report1.r01", "soviet #2 reporting", int32_t(0x99D4EE3F), int32_t(0x00000000)},
    {"report1.r02", "soviet #3 reporting", int32_t(0x99D5EE3F), int32_t(0x00000000)},
    {"report1.r03", "soviet #4 reporting", int32_t(0x99D6EE3F), int32_t(0x00000000)},
    {"report1.v00", "c&c #1 reporting", int32_t(0x99D3EE43), int32_t(0x00000000)},
    {"report1.v01", "c&c #2 reporting", int32_t(0x99D4EE43), int32_t(0x00000000)},
    {"report1.v02", "c&c #3 reporting", int32_t(0x99D5EE43), int32_t(0x00000000)},
    {"report1.v03", "c&c #4 reporting", int32_t(0x99D6EE43), int32_t(0x00000000)},
    {"resprtr1.aud", "", int32_t(0xE846FF1B), int32_t(0x00000000)},
    {"retrbtn.vqa", "-", int32_t(0x00000000), int32_t(0xE42331D9)},
    {"retro.vqa", "rescue mission", int32_t(0xEBFD7228), int32_t(0x00000000)},
    {"retro.vqp", "rescue mission", int32_t(0xEBFD7237), int32_t(0x00000000)},
    {"returntoforestfires.map", "", int32_t(0x00000000), int32_t(0x5B521907)},
    {"reveal.shp", "crate: reveal whole map", int32_t(0x00000000), int32_t(0x7021FE77)},
    {"revvox1.aud", "audf:", int32_t(0xB6001B28), int32_t(0x00000000)},
    {"revvox2.aud", "audf:", int32_t(0xB6021B28), int32_t(0x00000000)},
    {"revvox3.aud", "audf:", int32_t(0xB6041B28), int32_t(0x00000000)},
    {"revvox4.aud", "audf:", int32_t(0xB6061B28), int32_t(0x00000000)},
    {"revvox5.aud", "audf:", int32_t(0xB6081B28), int32_t(0x00000000)},
    {"revvox6.aud", "audf:", int32_t(0xB60A1B28), int32_t(0x00000000)},
    {"revvox7.aud", "audf:", int32_t(0xB60C1B28), int32_t(0x00000000)},
    {"rf01.sno", "rocks", int32_t(0xB1AEDFD2), int32_t(0x00000000)},
    {"rf01.tem", "rocks", int32_t(0xAFA5E0D2), int32_t(0x00000000)},
    {"rf02.sno", "rocks", int32_t(0xB3AEDFD2), int32_t(0x00000000)},
    {"rf02.tem", "rocks", int32_t(0xB1A5E0D2), int32_t(0x00000000)},
    {"rf03.sno", "rocks", int32_t(0xB5AEDFD2), int32_t(0x00000000)},
    {"rf03.tem", "rocks", int32_t(0xB3A5E0D2), int32_t(0x00000000)},
    {"rf04.sno", "rocks", int32_t(0xB7AEDFD2), int32_t(0x00000000)},
    {"rf04.tem", "rocks", int32_t(0xB5A5E0D2), int32_t(0x00000000)},
    {"rf05.sno", "rocks", int32_t(0xB9AEDFD2), int32_t(0x00000000)},
    {"rf05.tem", "rocks", int32_t(0xB7A5E0D2), int32_t(0x00000000)},
    {"rf06.sno", "rocks", int32_t(0xBBAEDFD2), int32_t(0x00000000)},
    {"rf06.tem", "rocks", int32_t(0xB9A5E0D2), int32_t(0x00000000)},
    {"rf07.sno", "rocks", int32_t(0xBDAEDFD2), int32_t(0x00000000)},
    {"rf07.tem", "rocks", int32_t(0xBBA5E0D2), int32_t(0x00000000)},
    {"rf08.sno", "rocks", int32_t(0xBFAEDFD2), int32_t(0x00000000)},
    {"rf08.tem", "rocks", int32_t(0xBDA5E0D2), int32_t(0x00000000)},
    {"rf09.sno", "rocks", int32_t(0xC1AEDFD2), int32_t(0x00000000)},
    {"rf09.tem", "rocks", int32_t(0xBFA5E0D2), int32_t(0x00000000)},
    {"rf10.sno", "rocks", int32_t(0xAFB0DFD2), int32_t(0x00000000)},
    {"rf10.tem", "rocks", int32_t(0xADA7E0D2), int32_t(0x00000000)},
    {"rf11.sno", "rocks", int32_t(0xB1B0DFD2), int32_t(0x00000000)},
    {"rf11.tem", "rocks", int32_t(0xAFA7E0D2), int32_t(0x00000000)},
    {"rfixicon.shp", "", int32_t(0x00000000), int32_t(0x196D2AFA)},
    {"rg01a.shp", "", int32_t(0x00000000), int32_t(0x866CD86F)},
    {"rg02a.shp", "-", int32_t(0x00000000), int32_t(0xBFE1E4AA)},
    {"rg03a.shp", "-", int32_t(0x00000000), int32_t(0xA89AF0E9)},
    {"rg03ab.shp", "-", int32_t(0x00000000), int32_t(0x2732F283)},
    {"rg04a1.shp", "-", int32_t(0x00000000), int32_t(0x9ED355FC)},
    {"rg04a2.shp", "-", int32_t(0x00000000), int32_t(0xAF3B4F61)},
    {"rg05ab1.shp", "", int32_t(0x00000000), int32_t(0x5B449AA1)},
    {"rg05ab2.shp", "-", int32_t(0x00000000), int32_t(0xDDD0E80F)},
    {"rg05b1.shp", "", int32_t(0x00000000), int32_t(0x0727465C)},
    {"rg05b2.shp", "-", int32_t(0x00000000), int32_t(0x36CF5CC1)},
    {"rg06ab1.shp", "", int32_t(0x00000000), int32_t(0x62C9A664)},
    {"rg06ab2.shp", "", int32_t(0x00000000), int32_t(0xE45DD4CA)},
    {"rg06ab3.shp", "-", int32_t(0x00000000), int32_t(0x2F01076F)},
    {"rg06ab4.shp", "-", int32_t(0x00000000), int32_t(0x320437D7)},
    {"rg06b1.shp", "", int32_t(0x00000000), int32_t(0x3EAA7A99)},
    {"rg06b2.shp", "", int32_t(0x00000000), int32_t(0x0F426004)},
    {"rg06b3.shp", "", int32_t(0x00000000), int32_t(0xA9356BB0)},
    {"rg06b4.shp", "-", int32_t(0x00000000), int32_t(0x6C92553E)},
    {"rg07a.shp", "-", int32_t(0x00000000), int32_t(0xF576A1E5)},
    {"rg08a.shp", "-", int32_t(0x00000000), int32_t(0x2ACF6E34)},
    {"rg09abd.shp", "-", int32_t(0x00000000), int32_t(0xE69FF5C7)},
    {"rg09bd.shp", "-", int32_t(0x00000000), int32_t(0x5F434AC4)},
    {"rg09cd.shp", "", int32_t(0x00000000), int32_t(0x93E94A5A)},
    {"rg09d1.shp", "", int32_t(0x00000000), int32_t(0x277CBCCF)},
    {"rg09d2.shp", "", int32_t(0x00000000), int32_t(0x1694A652)},
    {"rg10ab1.shp", "-", int32_t(0x00000000), int32_t(0xFE11B4D0)},
    {"rg11a1.shp", "-", int32_t(0x00000000), int32_t(0x3B867B8D)},
    {"rg11a2.shp", "", int32_t(0x00000000), int32_t(0x0A6E6110)},
    {"rg12a1.shp", "-", int32_t(0x00000000), int32_t(0x020B4748)},
    {"rg12a2.shp", "", int32_t(0x00000000), int32_t(0x33E35DD5)},
    {"rgktbg.shp", "", int32_t(0x00000000), int32_t(0xCD2E48C5)},
    {"rgktbg2.shp", "", int32_t(0x00000000), int32_t(0x44D62BC3)},
    {"rgktmd.shp", "", int32_t(0x00000000), int32_t(0x25E640F4)},
    {"rgktmd2.shp", "", int32_t(0x00000000), int32_t(0xAC1E23F2)},
    {"rgktsm.shp", "", int32_t(0x00000000), int32_t(0xD94F263E)},
    {"rgktsm2.shp", "", int32_t(0x00000000), int32_t(0x50B74538)},
    {"rhit1.aud", "", int32_t(0xFBA77DEF), int32_t(0x00000000)},
    {"rhit2.aud", "", int32_t(0xFBA77DF1), int32_t(0x00000000)},
    {"rico1.aud", "", int32_t(0xE78F81EF), int32_t(0x00000000)},
    {"rico2.aud", "", int32_t(0xE78F81F1), int32_t(0x00000000)},
    {"rico3.aud", "", int32_t(0xE78F81F3), int32_t(0x00000000)},
    {"ricocht1.aud", "", int32_t(0xE40AF6FD), int32_t(0x00000000)},
    {"ricocht2.aud", "", int32_t(0xE60AF6FD), int32_t(0x00000000)},
    {"ricocht3.aud", "", int32_t(0xE80AF6FD), int32_t(0x00000000)},
    {"ricocht4.aud", "", int32_t(0xEA0AF6FD), int32_t(0x00000000)},
    {"ricocht5.aud", "", int32_t(0xEC0AF6FD), int32_t(0x00000000)},
    {"riftbit1.aud", "", int32_t(0xF816F8FB), int32_t(0x00000000)},
    {"riftbit2.aud", "", int32_t(0xFA16F8FB), int32_t(0x00000000)},
    {"riftbit3.aud", "", int32_t(0xFC16F8FB), int32_t(0x00000000)},
    {"riftdmg1.aud", "", int32_t(0xF7FD00FF), int32_t(0x00000000)},
    {"riftdmg2.aud", "", int32_t(0xF9FD00FF), int32_t(0x00000000)},
    {"rifthwl1.aud", "", int32_t(0xF8071507), int32_t(0x00000000)},
    {"rifthwl2.aud", "", int32_t(0xFA071507), int32_t(0x00000000)},
    {"riftmov1.aud", "", int32_t(0xF81B0511), int32_t(0x00000000)},
    {"riftmov2.aud", "", int32_t(0xFA1B0511), int32_t(0x00000000)},
    {"riftmov3.aud", "", int32_t(0xFC1B0511), int32_t(0x00000000)},
    {"right1.wsa", "anim: right mouth moving", int32_t(0xCF79C944), int32_t(0x00000000)},
    {"right16.aud", "right", int32_t(0x7DCDDD32), int32_t(0x00000000)},
    {"rightbar.pcx", "-", int32_t(0x00000000), int32_t(0x092677E3)},
    {"rimshot1.aud", "", int32_t(0xF4330507), int32_t(0x00000000)},
    {"rimshot2.aud", "", int32_t(0xF6330507), int32_t(0x00000000)},
    {"rimshot3.aud", "", int32_t(0xF8330507), int32_t(0x00000000)},
    {"rimshot4.aud", "", int32_t(0xFA330507), int32_t(0x00000000)},
    {"rimshot5.aud", "", int32_t(0xFC330507), int32_t(0x00000000)},
    {"ring.shp", "-", int32_t(0x00000000), int32_t(0x01EF2820)},
    {"ring1.shp", "ion cannon blast ring", int32_t(0x00000000), int32_t(0x13736D8D)},
    {"ritaway.r01", "soviet #2 at once", int32_t(0x6234D849), int32_t(0x00000000)},
    {"ritaway.r03", "soviet #4 at once", int32_t(0x6236D849), int32_t(0x00000000)},
    {"ritaway.v01", "c&c #2 right away sir", int32_t(0x6234D84D), int32_t(0x00000000)},
    {"ritaway.v03", "c&c #4 right away sir", int32_t(0x6236D84D), int32_t(0x00000000)},
    {"river1.aud", "", int32_t(0x97B5CC42), int32_t(0x00000000)},
    {"rivloop1.aud", "", int32_t(0xD84F0515), int32_t(0x00000000)},
    {"rivrrad4.ini", "", int32_t(0x00000000), int32_t(0x857593DE)},
    {"rivrrad4.map", "-", int32_t(0x00000000), int32_t(0x618F8F0D)},
    {"rketinf1.aud", "rocket infantry fire", int32_t(0x00000000), int32_t(0xE9BFFC0E)},
    {"rlat01.sno", "-", int32_t(0x00000000), int32_t(0x43923210)},
    {"rlat01a.sno", "-", int32_t(0x00000000), int32_t(0x557942F1)},
    {"rlat02.sno", "-", int32_t(0x00000000), int32_t(0x727A288D)},
    {"rlat02a.sno", "-", int32_t(0x00000000), int32_t(0x6491586C)},
    {"rlat03.sno", "-", int32_t(0x00000000), int32_t(0xD40D2339)},
    {"rlat03a.sno", "-", int32_t(0x00000000), int32_t(0xC2E653D8)},
    {"rlat04.sno", "-", int32_t(0x00000000), int32_t(0x11AA1DB7)},
    {"rlat04a.sno", "-", int32_t(0x00000000), int32_t(0x07416D56)},
    {"rlat05.sno", "-", int32_t(0x00000000), int32_t(0xB7DD1603)},
    {"rlat05a.sno", "-", int32_t(0x00000000), int32_t(0xA13666E2)},
    {"rlat06.sno", "-", int32_t(0x00000000), int32_t(0x86350C9E)},
    {"rlat06a.sno", "-", int32_t(0x00000000), int32_t(0x90DE7C7F)},
    {"rlat07.sno", "-", int32_t(0x00000000), int32_t(0x2042072A)},
    {"rlat07a.sno", "-", int32_t(0x00000000), int32_t(0x36A977CB)},
    {"rlat08.sno", "-", int32_t(0x00000000), int32_t(0xD60A77C3)},
    {"rlat08a.sno", "-", int32_t(0x00000000), int32_t(0xC0E10722)},
    {"rlat09.sno", "-", int32_t(0x00000000), int32_t(0x707D7C77)},
    {"rlat09a.sno", "-", int32_t(0x00000000), int32_t(0x66960C96)},
    {"rlat10.sno", "-", int32_t(0x00000000), int32_t(0x294F393A)},
    {"rlat10a.sno", "-", int32_t(0x00000000), int32_t(0x3FA449DB)},
    {"rlat11.sno", "-", int32_t(0x00000000), int32_t(0x8F38328E)},
    {"rlat11a.sno", "-", int32_t(0x00000000), int32_t(0x99D3426F)},
    {"rlat12.sno", "-", int32_t(0x00000000), int32_t(0xBED02813)},
    {"rlat12a.sno", "-", int32_t(0x00000000), int32_t(0xA83B58F2)},
    {"rlat13.sno", "-", int32_t(0x00000000), int32_t(0x18A723A7)},
    {"rlat13a.sno", "-", int32_t(0x00000000), int32_t(0x0E4C5346)},
    {"rlat14.sno", "-", int32_t(0x00000000), int32_t(0xDD001D29)},
    {"rlat14a.sno", "-", int32_t(0x00000000), int32_t(0xCBEB6DC8)},
    {"rlat15.sno", "-", int32_t(0x00000000), int32_t(0x7B77169D)},
    {"rlat15a.sno", "-", int32_t(0x00000000), int32_t(0x6D9C667C)},
    {"rlat16.sno", "-", int32_t(0x00000000), int32_t(0x4A9F0C00)},
    {"rlat16a.sno", "-", int32_t(0x00000000), int32_t(0x5C747CE1)},
    {"rleg1.aud", "", int32_t(0xC7978DEF), int32_t(0x00000000)},
    {"rleg2.aud", "", int32_t(0xC7978DF1), int32_t(0x00000000)},
    {"rleg3.aud", "", int32_t(0xC7978DF3), int32_t(0x00000000)},
    {"rloadlg.pcx", "", int32_t(0x00000000), int32_t(0xC1F500CB)},
    {"rloadmd.pcx", "", int32_t(0x00000000), int32_t(0xE11679D1)},
    {"rloadsm.pcx", "", int32_t(0x00000000), int32_t(0xF1F8CF8A)},
    {"rlogo.pal", "", int32_t(0x00000000), int32_t(0x5701D0B9)},
    {"rmblking.aud", "", int32_t(0x03FB090D), int32_t(0x00000000)},
    {"rmbo.shp", "commando", int32_t(0xEECCEDD2), int32_t(0x00000000)},
    {"rmboicnh.des", "icon: commando", int32_t(0x20EB0009), int32_t(0x00000000)},
    {"rmboicnh.tem", "icon: commando", int32_t(0x1AEB1009), int32_t(0x00000000)},
    {"rmboicnh.win", "icon: commando", int32_t(0x1BEF1309), int32_t(0x00000000)},
    {"rmboicon.shp", "icon: commando", int32_t(0x29F00F09), int32_t(0x00000000)},
    {"rmg.ini", "", int32_t(0x00000000), int32_t(0x1FFB8651)},
    {"rmgmd.ini", "", int32_t(0x00000000), int32_t(0xD156ED3F)},
    {"rmnv.shp", "", int32_t(0x00000000), int32_t(0xA820B201)},
    {"rmpfx01.des", "", int32_t(0x00000000), int32_t(0x571A7DF1)},
    {"rmpfx01.lun", "", int32_t(0x00000000), int32_t(0x71E49A72)},
    {"rmpfx01.sno", "-", int32_t(0x00000000), int32_t(0x70F6A06B)},
    {"rmpfx01.tem", "-", int32_t(0x00000000), int32_t(0xD34215B1)},
    {"rmpfx01.ubn", "", int32_t(0x00000000), int32_t(0x459C3792)},
    {"rmpfx01.urb", "", int32_t(0x00000000), int32_t(0xF50FDBEE)},
    {"rmpfx01a.des", "", int32_t(0x00000000), int32_t(0x6ED2041E)},
    {"rmpfx01a.lun", "", int32_t(0x00000000), int32_t(0x49052B2E)},
    {"rmpfx01a.sno", "-", int32_t(0x00000000), int32_t(0x804E346F)},
    {"rmpfx01a.tem", "-", int32_t(0x00000000), int32_t(0x88FB9A0D)},
    {"rmpfx01a.ubn", "", int32_t(0x00000000), int32_t(0x5F713747)},
    {"rmpfx01a.urb", "", int32_t(0x00000000), int32_t(0x1C05693D)},
    {"rmpfx01b.des", "", int32_t(0x00000000), int32_t(0x29727ECE)},
    {"rmpfx01b.lun", "", int32_t(0x00000000), int32_t(0x0EA551FE)},
    {"rmpfx01b.sno", "-", int32_t(0x00000000), int32_t(0xC7EE4EBF)},
    {"rmpfx01b.tem", "-", int32_t(0x00000000), int32_t(0xCF5BE0DD)},
    {"rmpfx01b.ubn", "", int32_t(0x00000000), int32_t(0x18D14D97)},
    {"rmpfx01b.urb", "", int32_t(0x00000000), int32_t(0x5BA513ED)},
    {"rmpfx01c.des", "", int32_t(0x00000000), int32_t(0x1412577E)},
    {"rmpfx01c.lun", "", int32_t(0x00000000), int32_t(0x33C5784E)},
    {"rmpfx01c.sno", "-", int32_t(0x00000000), int32_t(0xFA8E670F)},
    {"rmpfx01c.tem", "-", int32_t(0x00000000), int32_t(0xF23BC96D)},
    {"rmpfx01c.ubn", "", int32_t(0x00000000), int32_t(0x25B16427)},
    {"rmpfx01c.urb", "", int32_t(0x00000000), int32_t(0x66C53A5D)},
    {"rmpfx02.des", "", int32_t(0x00000000), int32_t(0xD18E0F5F)},
    {"rmpfx02.lun", "", int32_t(0x00000000), int32_t(0xF770E8DC)},
    {"rmpfx02.sno", "-", int32_t(0x00000000), int32_t(0xF662D2C5)},
    {"rmpfx02.tem", "-", int32_t(0x00000000), int32_t(0x55D6671F)},
    {"rmpfx02.ubn", "", int32_t(0x00000000), int32_t(0xC308453C)},
    {"rmpfx02.urb", "", int32_t(0x00000000), int32_t(0x739BA940)},
    {"rmpfx02a.des", "", int32_t(0x00000000), int32_t(0xE84676B0)},
    {"rmpfx02a.lun", "", int32_t(0x00000000), int32_t(0xCF915980)},
    {"rmpfx02a.sno", "-", int32_t(0x00000000), int32_t(0x06DA46C1)},
    {"rmpfx02a.tem", "-", int32_t(0x00000000), int32_t(0x0E6FE8A3)},
    {"rmpfx02a.ubn", "", int32_t(0x00000000), int32_t(0xD9E545E9)},
    {"rmpfx02a.urb", "", int32_t(0x00000000), int32_t(0x9A911B93)},
    {"rmpfx02b.des", "", int32_t(0x00000000), int32_t(0xAFE60C60)},
    {"rmpfx02b.lun", "", int32_t(0x00000000), int32_t(0x88312350)},
    {"rmpfx02b.sno", "-", int32_t(0x00000000), int32_t(0x417A3C11)},
    {"rmpfx02b.tem", "-", int32_t(0x00000000), int32_t(0x49CF9273)},
    {"rmpfx02b.ubn", "", int32_t(0x00000000), int32_t(0x9E453F39)},
    {"rmpfx02b.urb", "", int32_t(0x00000000), int32_t(0xDD316143)},
    {"rmpfx02c.des", "", int32_t(0x00000000), int32_t(0x928625D0)},
    {"rmpfx02c.lun", "", int32_t(0x00000000), int32_t(0xB5510AE0)},
    {"rmpfx02c.sno", "-", int32_t(0x00000000), int32_t(0x7C1A15A1)},
    {"rmpfx02c.tem", "-", int32_t(0x00000000), int32_t(0x74AFBBC3)},
    {"rmpfx02c.ubn", "", int32_t(0x00000000), int32_t(0xA3251689)},
    {"rmpfx02c.urb", "", int32_t(0x00000000), int32_t(0xE05148F3)},
    {"rmpfx03.des", "", int32_t(0x00000000), int32_t(0x1AD2DCFA)},
    {"rmpfx03.lun", "", int32_t(0x00000000), int32_t(0x3C2C3B79)},
    {"rmpfx03.sno", "-", int32_t(0x00000000), int32_t(0x3D3E0160)},
    {"rmpfx03.tem", "-", int32_t(0x00000000), int32_t(0x9E8AB4BA)},
    {"rmpfx03.ubn", "", int32_t(0x00000000), int32_t(0x08549699)},
    {"rmpfx03.urb", "", int32_t(0x00000000), int32_t(0xB8C77AE5)},
    {"rmpfx03a.des", "", int32_t(0x00000000), int32_t(0x231AA515)},
    {"rmpfx03a.lun", "", int32_t(0x00000000), int32_t(0x04CD8A25)},
    {"rmpfx03a.sno", "-", int32_t(0x00000000), int32_t(0xCD869564)},
    {"rmpfx03a.tem", "-", int32_t(0x00000000), int32_t(0xC5333B06)},
    {"rmpfx03a.ubn", "", int32_t(0x00000000), int32_t(0x12B9964C)},
    {"rmpfx03a.urb", "", int32_t(0x00000000), int32_t(0x51CDC836)},
    {"rmpfx03b.des", "", int32_t(0x00000000), int32_t(0x64BADFC5)},
    {"rmpfx03b.lun", "", int32_t(0x00000000), int32_t(0x436DF0F5)},
    {"rmpfx03b.sno", "-", int32_t(0x00000000), int32_t(0x8A26EFB4)},
    {"rmpfx03b.tem", "-", int32_t(0x00000000), int32_t(0x829341D6)},
    {"rmpfx03b.ubn", "", int32_t(0x00000000), int32_t(0x5519EC9C)},
    {"rmpfx03b.urb", "", int32_t(0x00000000), int32_t(0x166DB2E6)},
    {"rmpfx03c.des", "", int32_t(0x00000000), int32_t(0x59DAF675)},
    {"rmpfx03c.lun", "", int32_t(0x00000000), int32_t(0x7E0DD945)},
    {"rmpfx03c.sno", "-", int32_t(0x00000000), int32_t(0xB746C604)},
    {"rmpfx03c.tem", "-", int32_t(0x00000000), int32_t(0xBFF36866)},
    {"rmpfx03c.ubn", "", int32_t(0x00000000), int32_t(0x6879C52C)},
    {"rmpfx03c.urb", "", int32_t(0x00000000), int32_t(0x2B0D9B56)},
    {"rmpfx04.des", "", int32_t(0x00000000), int32_t(0x07D7EC42)},
    {"rmpfx04.lun", "", int32_t(0x00000000), int32_t(0x21290BC1)},
    {"rmpfx04.sno", "-", int32_t(0x00000000), int32_t(0x203B31D8)},
    {"rmpfx04.tem", "-", int32_t(0x00000000), int32_t(0x838F8402)},
    {"rmpfx04.ubn", "", int32_t(0x00000000), int32_t(0x1551A621)},
    {"rmpfx04.urb", "", int32_t(0x00000000), int32_t(0xA5C24A5D)},
    {"rmpfx04a.des", "", int32_t(0x00000000), int32_t(0x3E1F95AD)},
    {"rmpfx04a.lun", "", int32_t(0x00000000), int32_t(0x19C8BA9D)},
    {"rmpfx04a.sno", "-", int32_t(0x00000000), int32_t(0xD083A5DC)},
    {"rmpfx04a.tem", "-", int32_t(0x00000000), int32_t(0xD8360BBE)},
    {"rmpfx04a.ubn", "", int32_t(0x00000000), int32_t(0x0FBCA6F4)},
    {"rmpfx04a.urb", "", int32_t(0x00000000), int32_t(0x4CC8F88E)},
    {"rmpfx04b.des", "", int32_t(0x00000000), int32_t(0x79BFEF7D)},
    {"rmpfx04b.lun", "", int32_t(0x00000000), int32_t(0x5E68C04D)},
    {"rmpfx04b.sno", "-", int32_t(0x00000000), int32_t(0x9723DF0C)},
    {"rmpfx04b.tem", "-", int32_t(0x00000000), int32_t(0x9F96716E)},
    {"rmpfx04b.ubn", "", int32_t(0x00000000), int32_t(0x481CDC24)},
    {"rmpfx04b.urb", "", int32_t(0x00000000), int32_t(0x0B68825E)},
    {"rmpfx04c.des", "", int32_t(0x00000000), int32_t(0x44DFC6CD)},
    {"rmpfx04c.lun", "", int32_t(0x00000000), int32_t(0x6308E9FD)},
    {"rmpfx04c.sno", "-", int32_t(0x00000000), int32_t(0xAA43F6BC)},
    {"rmpfx04c.tem", "-", int32_t(0x00000000), int32_t(0xA2F658DE)},
    {"rmpfx04c.ubn", "", int32_t(0x00000000), int32_t(0x757CF594)},
    {"rmpfx04c.urb", "", int32_t(0x00000000), int32_t(0x3608ABEE)},
    {"rmpfx05.des", "", int32_t(0x00000000), int32_t(0xCC8B3FE7)},
    {"rmpfx05.lun", "", int32_t(0x00000000), int32_t(0xEA75D864)},
    {"rmpfx05.sno", "-", int32_t(0x00000000), int32_t(0xEB67E27D)},
    {"rmpfx05.tem", "-", int32_t(0x00000000), int32_t(0x48D357A7)},
    {"rmpfx05.ubn", "", int32_t(0x00000000), int32_t(0xDE0D7584)},
    {"rmpfx05.urb", "", int32_t(0x00000000), int32_t(0x6E9E99F8)},
    {"rmpfx05a.des", "", int32_t(0x00000000), int32_t(0xF5434608)},
    {"rmpfx05a.lun", "", int32_t(0x00000000), int32_t(0xD2946938)},
    {"rmpfx05a.sno", "-", int32_t(0x00000000), int32_t(0x1BDF7679)},
    {"rmpfx05a.tem", "-", int32_t(0x00000000), int32_t(0x136AD81B)},
    {"rmpfx05a.ubn", "", int32_t(0x00000000), int32_t(0xC4E07551)},
    {"rmpfx05a.urb", "", int32_t(0x00000000), int32_t(0x87942B2B)},
    {"rmpfx05b.des", "", int32_t(0x00000000), int32_t(0xB2E33CD8)},
    {"rmpfx05b.lun", "", int32_t(0x00000000), int32_t(0x953413E8)},
    {"rmpfx05b.sno", "-", int32_t(0x00000000), int32_t(0x5C7F0CA9)},
    {"rmpfx05b.tem", "-", int32_t(0x00000000), int32_t(0x54CAA2CB)},
    {"rmpfx05b.ubn", "", int32_t(0x00000000), int32_t(0x83400F81)},
    {"rmpfx05b.urb", "", int32_t(0x00000000), int32_t(0xC03451FB)},
    {"rmpfx05c.des", "", int32_t(0x00000000), int32_t(0x8F831568)},
    {"rmpfx05c.lun", "", int32_t(0x00000000), int32_t(0xA8543A58)},
    {"rmpfx05c.sno", "-", int32_t(0x00000000), int32_t(0x611F2519)},
    {"rmpfx05c.tem", "-", int32_t(0x00000000), int32_t(0x69AA8B7B)},
    {"rmpfx05c.ubn", "", int32_t(0x00000000), int32_t(0xBE202631)},
    {"rmpfx05c.urb", "", int32_t(0x00000000), int32_t(0xFD54784B)},
    {"rmpfx06.des", "", int32_t(0x00000000), int32_t(0x4A1F4D49)},
    {"rmpfx06.lun", "", int32_t(0x00000000), int32_t(0x6CE1AACA)},
    {"rmpfx06.sno", "-", int32_t(0x00000000), int32_t(0x6DF390D3)},
    {"rmpfx06.tem", "-", int32_t(0x00000000), int32_t(0xCE472509)},
    {"rmpfx06.ubn", "", int32_t(0x00000000), int32_t(0x5899072A)},
    {"rmpfx06.urb", "", int32_t(0x00000000), int32_t(0xE80AEB56)},
    {"rmpfx06a.des", "", int32_t(0x00000000), int32_t(0x73D734A6)},
    {"rmpfx06a.lun", "", int32_t(0x00000000), int32_t(0x54001B96)},
    {"rmpfx06a.sno", "-", int32_t(0x00000000), int32_t(0x9D4B04D7)},
    {"rmpfx06a.tem", "-", int32_t(0x00000000), int32_t(0x95FEAAB5)},
    {"rmpfx06a.ubn", "", int32_t(0x00000000), int32_t(0x427407FF)},
    {"rmpfx06a.urb", "", int32_t(0x00000000), int32_t(0x01005985)},
    {"rmpfx06b.des", "", int32_t(0x00000000), int32_t(0x34774E76)},
    {"rmpfx06b.lun", "", int32_t(0x00000000), int32_t(0x13A06146)},
    {"rmpfx06b.sno", "-", int32_t(0x00000000), int32_t(0xDAEB7E07)},
    {"rmpfx06b.tem", "-", int32_t(0x00000000), int32_t(0xD25ED065)},
    {"rmpfx06b.ubn", "", int32_t(0x00000000), int32_t(0x05D47D2F)},
    {"rmpfx06b.urb", "", int32_t(0x00000000), int32_t(0x46A02355)},
    {"rmpfx06c.des", "", int32_t(0x00000000), int32_t(0x091767C6)},
    {"rmpfx06c.lun", "", int32_t(0x00000000), int32_t(0x2EC048F6)},
    {"rmpfx06c.sno", "-", int32_t(0x00000000), int32_t(0xE78B57B7)},
    {"rmpfx06c.tem", "-", int32_t(0x00000000), int32_t(0xEF3EF9D5)},
    {"rmpfx06c.ubn", "", int32_t(0x00000000), int32_t(0x38B4549F)},
    {"rmpfx06c.urb", "", int32_t(0x00000000), int32_t(0x7BC00AE5)},
    {"rmpfx07.des", "", int32_t(0x00000000), int32_t(0x81439EEC)},
    {"rmpfx07.lun", "", int32_t(0x00000000), int32_t(0xA7BD796F)},
    {"rmpfx07.sno", "-", int32_t(0x00000000), int32_t(0xA6AF4376)},
    {"rmpfx07.tem", "-", int32_t(0x00000000), int32_t(0x051BF6AC)},
    {"rmpfx07.ubn", "", int32_t(0x00000000), int32_t(0x93C5D48F)},
    {"rmpfx07.urb", "", int32_t(0x00000000), int32_t(0x235638F3)},
    {"rmpfx07a.des", "", int32_t(0x00000000), int32_t(0xB88BE703)},
    {"rmpfx07a.lun", "", int32_t(0x00000000), int32_t(0x9F5CC833)},
    {"rmpfx07a.sno", "-", int32_t(0x00000000), int32_t(0x5617D772)},
    {"rmpfx07a.tem", "-", int32_t(0x00000000), int32_t(0x5EA27910)},
    {"rmpfx07a.ubn", "", int32_t(0x00000000), int32_t(0x8928D45A)},
    {"rmpfx07a.urb", "", int32_t(0x00000000), int32_t(0xCA5C8A20)},
    {"rmpfx07b.des", "", int32_t(0x00000000), int32_t(0xFF2B9DD3)},
    {"rmpfx07b.lun", "", int32_t(0x00000000), int32_t(0xD8FCB2E3)},
    {"rmpfx07b.sno", "-", int32_t(0x00000000), int32_t(0x11B7ADA2)},
    {"rmpfx07b.tem", "-", int32_t(0x00000000), int32_t(0x190203C0)},
    {"rmpfx07b.ubn", "", int32_t(0x00000000), int32_t(0xCE88AE8A)},
    {"rmpfx07b.urb", "", int32_t(0x00000000), int32_t(0x8DFCF0F0)},
    {"rmpfx07c.des", "", int32_t(0x00000000), int32_t(0xC24BB463)},
    {"rmpfx07c.lun", "", int32_t(0x00000000), int32_t(0xE59C9B53)},
    {"rmpfx07c.sno", "-", int32_t(0x00000000), int32_t(0x2CD78412)},
    {"rmpfx07c.tem", "-", int32_t(0x00000000), int32_t(0x24622A70)},
    {"rmpfx07c.ubn", "", int32_t(0x00000000), int32_t(0xF3E8873A)},
    {"rmpfx07c.urb", "", int32_t(0x00000000), int32_t(0xB09CD940)},
    {"rmpfx08.des", "", int32_t(0x00000000), int32_t(0x70152C39)},
    {"rmpfx08.lun", "", int32_t(0x00000000), int32_t(0x56EBCBBA)},
    {"rmpfx08.sno", "-", int32_t(0x00000000), int32_t(0x57F9F1A3)},
    {"rmpfx08.tem", "-", int32_t(0x00000000), int32_t(0xF44D4479)},
    {"rmpfx08.ubn", "", int32_t(0x00000000), int32_t(0x6293665A)},
    {"rmpfx08.urb", "", int32_t(0x00000000), int32_t(0xD2008A26)},
    {"rmpfx08a.des", "", int32_t(0x00000000), int32_t(0x49DD55D6)},
    {"rmpfx08a.lun", "", int32_t(0x00000000), int32_t(0x6E0A7AE6)},
    {"rmpfx08a.sno", "-", int32_t(0x00000000), int32_t(0xA74165A7)},
    {"rmpfx08a.tem", "-", int32_t(0x00000000), int32_t(0xAFF4CBC5)},
    {"rmpfx08a.ubn", "", int32_t(0x00000000), int32_t(0x787E668F)},
    {"rmpfx08a.urb", "", int32_t(0x00000000), int32_t(0x3B0A38F5)},
    {"rmpfx08b.des", "", int32_t(0x00000000), int32_t(0x0E7D2F06)},
    {"rmpfx08b.lun", "", int32_t(0x00000000), int32_t(0x29AA0036)},
    {"rmpfx08b.sno", "-", int32_t(0x00000000), int32_t(0xE0E11F77)},
    {"rmpfx08b.tem", "-", int32_t(0x00000000), int32_t(0xE854B115)},
    {"rmpfx08b.ubn", "", int32_t(0x00000000), int32_t(0x3FDE1C5F)},
    {"rmpfx08b.urb", "", int32_t(0x00000000), int32_t(0x7CAA4225)},
    {"rmpfx08c.des", "", int32_t(0x00000000), int32_t(0x331D06B6)},
    {"rmpfx08c.lun", "", int32_t(0x00000000), int32_t(0x14CA2986)},
    {"rmpfx08c.sno", "-", int32_t(0x00000000), int32_t(0xDD8136C7)},
    {"rmpfx08c.tem", "-", int32_t(0x00000000), int32_t(0xD53498A5)},
    {"rmpfx08c.ubn", "", int32_t(0x00000000), int32_t(0x02BE35EF)},
    {"rmpfx08c.urb", "", int32_t(0x00000000), int32_t(0x41CA6B95)},
    {"rmpfx09.des", "", int32_t(0x00000000), int32_t(0xBB49FF9C)},
    {"rmpfx09.lun", "", int32_t(0x00000000), int32_t(0x9DB7181F)},
    {"rmpfx09.sno", "-", int32_t(0x00000000), int32_t(0x9CA52206)},
    {"rmpfx09.tem", "-", int32_t(0x00000000), int32_t(0x3F1197DC)},
    {"rmpfx09.ubn", "", int32_t(0x00000000), int32_t(0xA9CFB5FF)},
    {"rmpfx09.urb", "", int32_t(0x00000000), int32_t(0x195C5983)},
    {"rmpfx09a.des", "", int32_t(0x00000000), int32_t(0x82818673)},
    {"rmpfx09a.lun", "", int32_t(0x00000000), int32_t(0xA556A943)},
    {"rmpfx09a.sno", "-", int32_t(0x00000000), int32_t(0x6C1DB602)},
    {"rmpfx09a.tem", "-", int32_t(0x00000000), int32_t(0x64A81860)},
    {"rmpfx09a.ubn", "", int32_t(0x00000000), int32_t(0xB322B52A)},
    {"rmpfx09a.urb", "", int32_t(0x00000000), int32_t(0xF056EB50)},
    {"rmpfx09b.des", "", int32_t(0x00000000), int32_t(0xC521FCA3)},
    {"rmpfx09b.lun", "", int32_t(0x00000000), int32_t(0xE2F6D393)},
    {"rmpfx09b.sno", "-", int32_t(0x00000000), int32_t(0x2BBDCCD2)},
    {"rmpfx09b.tem", "-", int32_t(0x00000000), int32_t(0x230862B0)},
    {"rmpfx09b.ubn", "", int32_t(0x00000000), int32_t(0xF482CFFA)},
    {"rmpfx09b.urb", "", int32_t(0x00000000), int32_t(0xB7F69180)},
    {"rmpfx09c.des", "", int32_t(0x00000000), int32_t(0xF841D513)},
    {"rmpfx09c.lun", "", int32_t(0x00000000), int32_t(0xDF96FA23)},
    {"rmpfx09c.sno", "-", int32_t(0x00000000), int32_t(0x16DDE562)},
    {"rmpfx09c.tem", "-", int32_t(0x00000000), int32_t(0x1E684B00)},
    {"rmpfx09c.ubn", "", int32_t(0x00000000), int32_t(0xC9E2E64A)},
    {"rmpfx09c.urb", "", int32_t(0x00000000), int32_t(0x8A96B830)},
    {"rmpfx10.des", "", int32_t(0x00000000), int32_t(0x3A31A5E0)},
    {"rmpfx10.lun", "", int32_t(0x00000000), int32_t(0x1CCF4263)},
    {"rmpfx10.sno", "-", int32_t(0x00000000), int32_t(0x1DDD787A)},
    {"rmpfx10.tem", "-", int32_t(0x00000000), int32_t(0xBE69CDA0)},
    {"rmpfx10.ubn", "", int32_t(0x00000000), int32_t(0x28B7EF83)},
    {"rmpfx10.urb", "", int32_t(0x00000000), int32_t(0x982403FF)},
    {"rmpfx10a.des", "", int32_t(0x00000000), int32_t(0x03F9DC0F)},
    {"rmpfx10a.lun", "", int32_t(0x00000000), int32_t(0x242EF33F)},
    {"rmpfx10a.sno", "-", int32_t(0x00000000), int32_t(0xED65EC7E)},
    {"rmpfx10a.tem", "-", int32_t(0x00000000), int32_t(0xE5D0421C)},
    {"rmpfx10a.ubn", "", int32_t(0x00000000), int32_t(0x325AEF56)},
    {"rmpfx10a.urb", "", int32_t(0x00000000), int32_t(0x712EB12C)},
    {"rmpfx10b.des", "", int32_t(0x00000000), int32_t(0x4459A6DF)},
    {"rmpfx10b.lun", "", int32_t(0x00000000), int32_t(0x638E89EF)},
    {"rmpfx10b.sno", "-", int32_t(0x00000000), int32_t(0xAAC596AE)},
    {"rmpfx10b.tem", "-", int32_t(0x00000000), int32_t(0xA27038CC)},
    {"rmpfx10b.ubn", "", int32_t(0x00000000), int32_t(0x75FA9586)},
    {"rmpfx10b.urb", "", int32_t(0x00000000), int32_t(0x368ECBFC)},
    {"rmpfx10c.des", "", int32_t(0x00000000), int32_t(0x79398F6F)},
    {"rmpfx10c.lun", "", int32_t(0x00000000), int32_t(0x5EEEA05F)},
    {"rmpfx10c.sno", "-", int32_t(0x00000000), int32_t(0x97A5BF1E)},
    {"rmpfx10c.tem", "-", int32_t(0x00000000), int32_t(0x9F10117C)},
    {"rmpfx10c.ubn", "", int32_t(0x00000000), int32_t(0x489ABC36)},
    {"rmpfx10c.urb", "", int32_t(0x00000000), int32_t(0x0BEEE24C)},
    {"rmpfx11.des", "", int32_t(0x00000000), int32_t(0xF16D7645)},
    {"rmpfx11.lun", "", int32_t(0x00000000), int32_t(0xD79391C6)},
    {"rmpfx11.sno", "-", int32_t(0x00000000), int32_t(0xD681ABDF)},
    {"rmpfx11.tem", "-", int32_t(0x00000000), int32_t(0x75351E05)},
    {"rmpfx11.ubn", "", int32_t(0x00000000), int32_t(0xE3EB3C26)},
    {"rmpfx11.urb", "", int32_t(0x00000000), int32_t(0x5378D05A)},
    {"rmpfx11a.des", "", int32_t(0x00000000), int32_t(0xC8A50FAA)},
    {"rmpfx11a.lun", "", int32_t(0x00000000), int32_t(0xEF72209A)},
    {"rmpfx11a.sno", "-", int32_t(0x00000000), int32_t(0x26393FDB)},
    {"rmpfx11a.tem", "-", int32_t(0x00000000), int32_t(0x2E8C91B9)},
    {"rmpfx11a.ubn", "", int32_t(0x00000000), int32_t(0xF9063CF3)},
    {"rmpfx11a.urb", "", int32_t(0x00000000), int32_t(0xBA726289)},
    {"rmpfx11b.des", "", int32_t(0x00000000), int32_t(0x8F05757A)},
    {"rmpfx11b.lun", "", int32_t(0x00000000), int32_t(0xA8D25A4A)},
    {"rmpfx11b.sno", "-", int32_t(0x00000000), int32_t(0x6199450B)},
    {"rmpfx11b.tem", "-", int32_t(0x00000000), int32_t(0x692CEB69)},
    {"rmpfx11b.ubn", "", int32_t(0x00000000), int32_t(0xBEA64623)},
    {"rmpfx11b.urb", "", int32_t(0x00000000), int32_t(0xFDD21859)},
    {"rmpfx11c.des", "", int32_t(0x00000000), int32_t(0xB2655CCA)},
    {"rmpfx11c.lun", "", int32_t(0x00000000), int32_t(0x95B273FA)},
    {"rmpfx11c.sno", "-", int32_t(0x00000000), int32_t(0x5CF96CBB)},
    {"rmpfx11c.tem", "-", int32_t(0x00000000), int32_t(0x544CC2D9)},
    {"rmpfx11c.ubn", "", int32_t(0x00000000), int32_t(0x83C66F93)},
    {"rmpfx11c.urb", "", int32_t(0x00000000), int32_t(0xC0B231E9)},
    {"rmpfx12.des", "", int32_t(0x00000000), int32_t(0x77F904EB)},
    {"rmpfx12.lun", "", int32_t(0x00000000), int32_t(0x5107E368)},
    {"rmpfx12.sno", "-", int32_t(0x00000000), int32_t(0x5015D971)},
    {"rmpfx12.tem", "-", int32_t(0x00000000), int32_t(0xF3A16CAB)},
    {"rmpfx12.ubn", "", int32_t(0x00000000), int32_t(0x657F4E88)},
    {"rmpfx12.urb", "", int32_t(0x00000000), int32_t(0xD5ECA2F4)},
    {"rmpfx12a.des", "", int32_t(0x00000000), int32_t(0x4E317D04)},
    {"rmpfx12a.lun", "", int32_t(0x00000000), int32_t(0x69E65234)},
    {"rmpfx12a.sno", "-", int32_t(0x00000000), int32_t(0xA0AD4D75)},
    {"rmpfx12a.tem", "-", int32_t(0x00000000), int32_t(0xA818E317)},
    {"rmpfx12a.ubn", "", int32_t(0x00000000), int32_t(0x7F924E5D)},
    {"rmpfx12a.urb", "", int32_t(0x00000000), int32_t(0x3CE61027)},
    {"rmpfx12b.des", "", int32_t(0x00000000), int32_t(0x099107D4)},
    {"rmpfx12b.lun", "", int32_t(0x00000000), int32_t(0x2E4628E4)},
    {"rmpfx12b.sno", "-", int32_t(0x00000000), int32_t(0xE70D37A5)},
    {"rmpfx12b.tem", "-", int32_t(0x00000000), int32_t(0xEFB899C7)},
    {"rmpfx12b.ubn", "", int32_t(0x00000000), int32_t(0x3832348D)},
    {"rmpfx12b.urb", "", int32_t(0x00000000), int32_t(0x7B466AF7)},
    {"rmpfx12c.des", "", int32_t(0x00000000), int32_t(0x34F12E64)},
    {"rmpfx12c.lun", "", int32_t(0x00000000), int32_t(0x13260154)},
    {"rmpfx12c.sno", "-", int32_t(0x00000000), int32_t(0xDA6D1E15)},
    {"rmpfx12c.tem", "-", int32_t(0x00000000), int32_t(0xD2D8B077)},
    {"rmpfx12c.ubn", "", int32_t(0x00000000), int32_t(0x05521D3D)},
    {"rmpfx12c.urb", "", int32_t(0x00000000), int32_t(0x46264347)},
    {"rmpx01.sno", "", int32_t(0x00000000), int32_t(0xAC44F412)},
    {"rmpx02.sno", "", int32_t(0x00000000), int32_t(0x9DACEE8F)},
    {"rmpx03.sno", "", int32_t(0x00000000), int32_t(0x3BDBE53B)},
    {"rmpx04.sno", "", int32_t(0x00000000), int32_t(0xFE7CDBB5)},
    {"rmpx05.sno", "", int32_t(0x00000000), int32_t(0x580BD001)},
    {"rmpx06.sno", "", int32_t(0x00000000), int32_t(0x69E3CA9C)},
    {"rmpx07.sno", "", int32_t(0x00000000), int32_t(0xCF94C128)},
    {"rmpx08.sno", "", int32_t(0x00000000), int32_t(0x39DCB1C1)},
    {"rmpx09.sno", "", int32_t(0x00000000), int32_t(0x9FABBA75)},
    {"rmpx10.sno", "", int32_t(0x00000000), int32_t(0xC699FF38)},
    {"rn01a.shp", "", int32_t(0x00000000), int32_t(0xFD21E6EA)},
    {"rn02a.shp", "-", int32_t(0x00000000), int32_t(0xC4ACDA2F)},
    {"rn03a.shp", "-", int32_t(0x00000000), int32_t(0xD3D7CE6C)},
    {"rn03ab.shp", "-", int32_t(0x00000000), int32_t(0x5C7FCC06)},
    {"rn04a1.shp", "-", int32_t(0x00000000), int32_t(0xE59E6B79)},
    {"rn04a2.shp", "-", int32_t(0x00000000), int32_t(0xD47671E4)},
    {"rn05ab1.shp", "", int32_t(0x00000000), int32_t(0x2009A424)},
    {"rn05ab2.shp", "-", int32_t(0x00000000), int32_t(0xA69DD68A)},
    {"rn05b1.shp", "", int32_t(0x00000000), int32_t(0x7C6A78D9)},
    {"rn05b2.shp", "-", int32_t(0x00000000), int32_t(0x4D826244)},
    {"rn06ab1.shp", "", int32_t(0x00000000), int32_t(0x198498E1)},
    {"rn06ab2.shp", "", int32_t(0x00000000), int32_t(0x9F10EA4F)},
    {"rn06ab3.shp", "-", int32_t(0x00000000), int32_t(0x544C39EA)},
    {"rn06ab4.shp", "-", int32_t(0x00000000), int32_t(0x49490952)},
    {"rn06b1.shp", "", int32_t(0x00000000), int32_t(0x45E7441C)},
    {"rn06b2.shp", "", int32_t(0x00000000), int32_t(0x740F5E81)},
    {"rn06b3.shp", "", int32_t(0x00000000), int32_t(0xD2785535)},
    {"rn06b4.shp", "-", int32_t(0x00000000), int32_t(0x17DF6BBB)},
    {"rn07a.shp", "-", int32_t(0x00000000), int32_t(0x8E3B9F60)},
    {"rn08a.shp", "-", int32_t(0x00000000), int32_t(0x518250B1)},
    {"rn09abd.shp", "-", int32_t(0x00000000), int32_t(0x9DD2CB42)},
    {"rn09bd.shp", "-", int32_t(0x00000000), int32_t(0x240E7441)},
    {"rn09cd.shp", "", int32_t(0x00000000), int32_t(0xE8A474DF)},
    {"rn09d1.shp", "", int32_t(0x00000000), int32_t(0x5C31824A)},
    {"rn09d2.shp", "", int32_t(0x00000000), int32_t(0x6DD998D7)},
    {"rn10ab1.shp", "-", int32_t(0x00000000), int32_t(0x855C8A55)},
    {"rn11a1.shp", "-", int32_t(0x00000000), int32_t(0x40CB4508)},
    {"rn11a2.shp", "", int32_t(0x00000000), int32_t(0x71235F95)},
    {"rn12a1.shp", "-", int32_t(0x00000000), int32_t(0x794679CD)},
    {"rn12a2.shp", "", int32_t(0x00000000), int32_t(0x48AE6350)},
    {"roachb1.aud", "", int32_t(0x69AC171A), int32_t(0x00000000)},
    {"roachd1.aud", "", int32_t(0x69AC1B1A), int32_t(0x00000000)},
    {"roachd2.aud", "", int32_t(0x69AE1B1A), int32_t(0x00000000)},
    {"roachm1.aud", "", int32_t(0x69AC2D1A), int32_t(0x00000000)},
    {"roachs1.aud", "", int32_t(0x69AC391A), int32_t(0x00000000)},
    {"road.shp", "icon: blank tile checkerboard", int32_t(0xD8CAF1D2), int32_t(0x00000000)},
    {"roadicon.shp", "icon: blank tile", int32_t(0xFDEC1709), int32_t(0x00000000)},
    {"roar1.aud", "", int32_t(0xF38799EF), int32_t(0x00000000)},
    {"roar2.aud", "", int32_t(0xF38799F1), int32_t(0x00000000)},
    {"roar3.aud", "", int32_t(0xF38799F3), int32_t(0x00000000)},
    {"roar5.aud", "", int32_t(0xF38799F7), int32_t(0x00000000)},
    {"robo.hva", "", int32_t(0x00000000), int32_t(0x8B0FC51C)},
    {"robo.vxl", "", int32_t(0x00000000), int32_t(0x7D851A55)},
    {"roboicon.shp", "", int32_t(0x00000000), int32_t(0x5261C030)},
    {"robotmv1.aud", "", int32_t(0xE40B191F), int32_t(0x00000000)},
    {"robotur.hva", "", int32_t(0x00000000), int32_t(0xAC8DFA05)},
    {"robotur.vxl", "", int32_t(0x00000000), int32_t(0xA37B89EE)},
    {"robouico.shp", "", int32_t(0x00000000), int32_t(0x97A752D1)},
    {"rock.shp", "", int32_t(0x00000000), int32_t(0x1B51E3C5)},
    {"rock01.sno", "-", int32_t(0x00000000), int32_t(0xADFC098C)},
    {"rock01a.sno", "-", int32_t(0x00000000), int32_t(0xBB17796D)},
    {"rock01b.sno", "-", int32_t(0x00000000), int32_t(0x3D830BC3)},
    {"rock01c.sno", "-", int32_t(0x00000000), int32_t(0xF6DFD866)},
    {"rock01d.sno", "-", int32_t(0x00000000), int32_t(0xEBDAE8DE)},
    {"rock01e.sno", "-", int32_t(0x00000000), int32_t(0x20863B7B)},
    {"rock01f.sno", "-", int32_t(0x00000000), int32_t(0xA61249D5)},
    {"rock01g.sno", "-", int32_t(0x00000000), int32_t(0x6D4E9A70)},
    {"rock1.des", "rock 1", int32_t(0xB79599FE), int32_t(0x00000000)},
    {"rock2.des", "rock 2", int32_t(0xB7959A00), int32_t(0x00000000)},
    {"rock3.des", "rock 3", int32_t(0xB7959A02), int32_t(0x00000000)},
    {"rock4.des", "rock 4", int32_t(0xB7959A04), int32_t(0x00000000)},
    {"rock5.des", "rock 5", int32_t(0xB7959A06), int32_t(0x00000000)},
    {"rock6.des", "rock 6", int32_t(0xB7959A08), int32_t(0x00000000)},
    {"rock7.des", "rock 7", int32_t(0xB7959A0A), int32_t(0x00000000)},
    {"rocket1.aud", "rocket 1", int32_t(0x89B43B14), int32_t(0x00000000)},
    {"rocket1.juv", "rocket 1", int32_t(0x89C63B1D), int32_t(0x00000000)},
    {"rocket2.aud", "rocket 2", int32_t(0x89B63B14), int32_t(0x00000000)},
    {"rocket2.juv", "rocket 2", int32_t(0x89C83B1D), int32_t(0x00000000)},
    {"rocks1.aud", "", int32_t(0xAF69E444), int32_t(0x00000000)},
    {"rocks2.aud", "", int32_t(0xAF69E644), int32_t(0x00000000)},
    {"rocks3.aud", "", int32_t(0xAF69E844), int32_t(0x00000000)},
    {"rocks4.aud", "", int32_t(0xAF69EA44), int32_t(0x00000000)},
    {"rocks5.aud", "", int32_t(0xAF69EC44), int32_t(0x00000000)},
    {"rocks6.aud", "", int32_t(0xAF69EE44), int32_t(0x00000000)},
    {"rocks7.aud", "", int32_t(0xAF69F044), int32_t(0x00000000)},
    {"roger.r01", "soviet #2 agreed", int32_t(0x75C19A1E), int32_t(0x00000000)},
    {"roger.r03", "soviet #4 agreed", int32_t(0x75C19A20), int32_t(0x00000000)},
    {"roger.v01", "c&c #2 roger", int32_t(0x75C99A1E), int32_t(0x00000000)},
    {"roger.v03", "c&c #2 roger", int32_t(0x75C99A20), int32_t(0x00000000)},
    {"rokroll1.aud", "commando time to rock and roll", int32_t(0xF01B1715), int32_t(0x00000000)},
    {"rollout.aud", "roll out", int32_t(0x8E1E3D28), int32_t(0x00000000)},
    {"romanov1.bmp", "", int32_t(0x00000000), int32_t(0x99053A0D)},
    {"romanov3.bmp", "", int32_t(0x00000000), int32_t(0xE3C5696D)},
    {"roofair1.aud", "", int32_t(0xC03710F9), int32_t(0x00000000)},
    {"rooflit1.aud", "", int32_t(0xC03B110F), int32_t(0x00000000)},
    {"roofran1.aud", "", int32_t(0xC02F011B), int32_t(0x00000000)},
    {"roofrmb1.aud", "", int32_t(0xC017191B), int32_t(0x00000000)},
    {"rooster1.aud", "", int32_t(0xF437091F), int32_t(0x00000000)},
    {"rooster2.aud", "", int32_t(0xF637091F), int32_t(0x00000000)},
    {"rotis2.aud", "", int32_t(0xA7ADE644), int32_t(0x00000000)},
    {"rough01.des", "", int32_t(0x00000000), int32_t(0x829F2A1C)},
    {"rough01.sno", "-", int32_t(0x00000000), int32_t(0xA573F786)},
    {"rough01.tem", "-", int32_t(0x00000000), int32_t(0x06C7425C)},
    {"rough01.ubn", "", int32_t(0x00000000), int32_t(0x9019607F)},
    {"rough01.urb", "", int32_t(0x00000000), int32_t(0x208A8C03)},
    {"rough02.des", "", int32_t(0x00000000), int32_t(0x040B58B2)},
    {"rough02.sno", "-", int32_t(0x00000000), int32_t(0x23E78528)},
    {"rough02.tem", "-", int32_t(0x00000000), int32_t(0x805330F2)},
    {"rough02.ubn", "", int32_t(0x00000000), int32_t(0x168D12D1)},
    {"rough02.urb", "", int32_t(0x00000000), int32_t(0xA61EFEAD)},
    {"rough03.des", "", int32_t(0x00000000), int32_t(0xCF578B17)},
    {"rough03.sno", "-", int32_t(0x00000000), int32_t(0xE8BB568D)},
    {"rough03.tem", "-", int32_t(0x00000000), int32_t(0x4B0FE357)},
    {"rough03.ubn", "", int32_t(0x00000000), int32_t(0xDDD1C174)},
    {"rough03.urb", "", int32_t(0x00000000), int32_t(0x6D422D08)},
    {"rough04.des", "", int32_t(0x00000000), int32_t(0xD252BBAF)},
    {"rough04.sno", "-", int32_t(0x00000000), int32_t(0xF5BE6635)},
    {"rough04.tem", "-", int32_t(0x00000000), int32_t(0x560AD3EF)},
    {"rough04.ubn", "", int32_t(0x00000000), int32_t(0xC0D4F1CC)},
    {"rough04.urb", "", int32_t(0x00000000), int32_t(0x70471DB0)},
    {"rough05.des", "", int32_t(0x00000000), int32_t(0x190E680A)},
    {"rough05.sno", "-", int32_t(0x00000000), int32_t(0x3EE2B590)},
    {"rough05.tem", "-", int32_t(0x00000000), int32_t(0x9D56004A)},
    {"rough05.ubn", "", int32_t(0x00000000), int32_t(0x0B882269)},
    {"rough05.urb", "", int32_t(0x00000000), int32_t(0xBB1BCE15)},
    {"rough06.des", "", int32_t(0x00000000), int32_t(0x9F9A1AA4)},
    {"rough06.sno", "-", int32_t(0x00000000), int32_t(0xB876C73E)},
    {"rough06.tem", "-", int32_t(0x00000000), int32_t(0x1BC272E4)},
    {"rough06.ubn", "", int32_t(0x00000000), int32_t(0x8D1C50C7)},
    {"rough06.urb", "", int32_t(0x00000000), int32_t(0x3D8FBCBB)},
    {"rough07.des", "", int32_t(0x00000000), int32_t(0x54C6C901)},
    {"rough07.sno", "-", int32_t(0x00000000), int32_t(0x732A149B)},
    {"rough07.tem", "-", int32_t(0x00000000), int32_t(0xD09EA141)},
    {"rough07.ubn", "", int32_t(0x00000000), int32_t(0x46408362)},
    {"rough07.urb", "", int32_t(0x00000000), int32_t(0xF6D36F1E)},
    {"rough08.des", "", int32_t(0x00000000), int32_t(0xA5907BD4)},
    {"rough08.sno", "-", int32_t(0x00000000), int32_t(0x827CA64E)},
    {"rough08.tem", "-", int32_t(0x00000000), int32_t(0x21C81394)},
    {"rough08.ubn", "", int32_t(0x00000000), int32_t(0xB71631B7)},
    {"rough08.urb", "", int32_t(0x00000000), int32_t(0x0785DDCB)},
    {"rough09.des", "", int32_t(0x00000000), int32_t(0x6ECCA871)},
    {"rough09.sno", "-", int32_t(0x00000000), int32_t(0x492075EB)},
    {"rough09.tem", "-", int32_t(0x00000000), int32_t(0xEA94C031)},
    {"rough09.ubn", "", int32_t(0x00000000), int32_t(0x7C4AE212)},
    {"rough09.urb", "", int32_t(0x00000000), int32_t(0xCCD90E6E)},
    {"rough10.des", "", int32_t(0x00000000), int32_t(0xEFB4F20D)},
    {"rough10.sno", "-", int32_t(0x00000000), int32_t(0xC8582F97)},
    {"rough10.tem", "-", int32_t(0x00000000), int32_t(0x6BEC9A4D)},
    {"rough10.ubn", "", int32_t(0x00000000), int32_t(0xFD32B86E)},
    {"rough10.urb", "", int32_t(0x00000000), int32_t(0x4DA15412)},
    {"rout.var", "reaching out sfx", int32_t(0xFAEBF4D2), int32_t(0x00000000)},
    {"rpart2.aud", "", int32_t(0xCB61EA46), int32_t(0x00000000)},
    {"rpt.aud", "mech man 2", int32_t(0x5CECF5E5), int32_t(0x00000000)},
    {"rrdrt.shp", "", int32_t(0x00000000), int32_t(0xF7DA172A)},
    {"rrdrt2.shp", "", int32_t(0x00000000), int32_t(0x941AC56B)},
    {"rrotor.shp", "rotor shadows", int32_t(0xF79A3E2F), int32_t(0xB587268E)},
    {"rt2stonwlk1.aud", "", int32_t(0x5372CBBB), int32_t(0x00000000)},
    {"rt_btn.shp", "", int32_t(0xAFDA3E39), int32_t(0x00000000)},
    {"rt_in.shp", "", int32_t(0xB623AE35), int32_t(0x00000000)},
    {"rt_out.shp", "", int32_t(0xE3DA4A3B), int32_t(0x00000000)},
    {"rt_spin.shp", "", int32_t(0xAA6A2C3C), int32_t(0x00000000)},
    {"rtarget.shp", "", int32_t(0x00000000), int32_t(0x16289340)},
    {"rtnk.hva", "", int32_t(0x00000000), int32_t(0x6C946B93)},
    {"rtnk.vxl", "", int32_t(0x00000000), int32_t(0x9A1EB4DA)},
    {"rtnkbarl.hva", "", int32_t(0x00000000), int32_t(0x39992EDB)},
    {"rtnkbarl.vxl", "", int32_t(0x00000000), int32_t(0xCF13F192)},
    {"rtnkicon.shp", "", int32_t(0x00000000), int32_t(0x9866323D)},
    {"rtnktur.hva", "", int32_t(0x00000000), int32_t(0x668A0808)},
    {"rtnktur.vxl", "", int32_t(0x00000000), int32_t(0x697C7BE3)},
    {"rtnkuico.shp", "", int32_t(0x00000000), int32_t(0x5DA0A0DC)},
    {"rtone3.aud", "", int32_t(0xBB99FC28), int32_t(0x00000000)},
    {"rubat1.aud", "", int32_t(0x8765FC46), int32_t(0x00000000)},
    {"ruff01.des", "", int32_t(0x00000000), int32_t(0x71ECF6DF)},
    {"ruff01.lun", "", int32_t(0x00000000), int32_t(0x18CCCAC6)},
    {"ruff01.sno", "-", int32_t(0x00000000), int32_t(0xF6C3B9D0)},
    {"ruff01.tem", "-", int32_t(0x00000000), int32_t(0x07B4EF27)},
    {"ruff01.ubn", "", int32_t(0x00000000), int32_t(0x3B21D5D4)},
    {"ruff01.urb", "", int32_t(0x00000000), int32_t(0x7F956B4B)},
    {"ruff01a.des", "", int32_t(0x00000000), int32_t(0xC7C414AB)},
    {"ruff01a.lun", "", int32_t(0x00000000), int32_t(0xE13AF328)},
    {"ruff01a.sno", "-", int32_t(0x00000000), int32_t(0xE028C931)},
    {"ruff01a.tem", "-", int32_t(0x00000000), int32_t(0x439C7CEB)},
    {"ruff01a.ubn", "", int32_t(0x00000000), int32_t(0xD5425EC8)},
    {"ruff01a.urb", "", int32_t(0x00000000), int32_t(0x65D1B2B4)},
    {"ruff01b.des", "", int32_t(0x00000000), int32_t(0x41506605)},
    {"ruff01b.lun", "", int32_t(0x00000000), int32_t(0x67AE8186)},
    {"ruff01b.sno", "-", int32_t(0x00000000), int32_t(0x66BCBB9F)},
    {"ruff01b.tem", "-", int32_t(0x00000000), int32_t(0xC5080E45)},
    {"ruff01b.ubn", "", int32_t(0x00000000), int32_t(0x53D62C66)},
    {"ruff01b.urb", "", int32_t(0x00000000), int32_t(0xE345C01A)},
    {"ruff01c.des", "", int32_t(0x00000000), int32_t(0x8A0CB5A0)},
    {"ruff01c.lun", "", int32_t(0x00000000), int32_t(0xACF25223)},
    {"ruff01c.sno", "-", int32_t(0x00000000), int32_t(0xADE0683A)},
    {"ruff01c.tem", "-", int32_t(0x00000000), int32_t(0x0E54DDE0)},
    {"ruff01c.ubn", "", int32_t(0x00000000), int32_t(0x988AFFC3)},
    {"ruff01c.urb", "", int32_t(0x00000000), int32_t(0x281913BF)},
    {"ruff01d.des", "", int32_t(0x00000000), int32_t(0x97098518)},
    {"ruff01d.lun", "", int32_t(0x00000000), int32_t(0xB1F7629B)},
    {"ruff01d.sno", "-", int32_t(0x00000000), int32_t(0xB0E55882)},
    {"ruff01d.tem", "-", int32_t(0x00000000), int32_t(0x1351ED58)},
    {"ruff01d.ubn", "", int32_t(0x00000000), int32_t(0x858FCF7B)},
    {"ruff01d.urb", "", int32_t(0x00000000), int32_t(0x351C2307)},
    {"ruff01e.des", "", int32_t(0x00000000), int32_t(0x5C5556BD)},
    {"ruff01e.lun", "", int32_t(0x00000000), int32_t(0x7AABB13E)},
    {"ruff01e.sno", "-", int32_t(0x00000000), int32_t(0x7BB98B27)},
    {"ruff01e.tem", "-", int32_t(0x00000000), int32_t(0xD80D3EFD)},
    {"ruff01e.ubn", "", int32_t(0x00000000), int32_t(0x4ED31CDE)},
    {"ruff01e.urb", "", int32_t(0x00000000), int32_t(0xFE40F0A2)},
    {"ruff01f.des", "", int32_t(0x00000000), int32_t(0xDAC12413)},
    {"ruff01f.lun", "", int32_t(0x00000000), int32_t(0xFC3FC390)},
    {"ruff01f.sno", "-", int32_t(0x00000000), int32_t(0xFD2DF989)},
    {"ruff01f.tem", "-", int32_t(0x00000000), int32_t(0x5E994C53)},
    {"ruff01f.ubn", "", int32_t(0x00000000), int32_t(0xC8476E70)},
    {"ruff01f.urb", "", int32_t(0x00000000), int32_t(0x78D4820C)},
    {"ruff01g.des", "", int32_t(0x00000000), int32_t(0x119DF7B6)},
    {"ruff01g.lun", "", int32_t(0x00000000), int32_t(0x37631035)},
    {"ruff01g.sno", "-", int32_t(0x00000000), int32_t(0x36712A2C)},
    {"ruff01g.tem", "-", int32_t(0x00000000), int32_t(0x95C59FF6)},
    {"ruff01g.ubn", "", int32_t(0x00000000), int32_t(0x031BBDD5)},
    {"ruff01g.urb", "", int32_t(0x00000000), int32_t(0xB38851A9)},
    {"ruin01.des", "", int32_t(0x00000000), int32_t(0x3B3F0F4A)},
    {"ruin01.sno", "-", int32_t(0x00000000), int32_t(0xBC104045)},
    {"ruin01.tem", "-", int32_t(0x00000000), int32_t(0x4D6716B2)},
    {"ruin_app.csv", "", int32_t(0x30191B35), int32_t(0x00000000)},
    {"ruin_app.lsv", "", int32_t(0x30192435), int32_t(0x00000000)},
    {"ruin_app.vqa", "", int32_t(0x1B172E35), int32_t(0x00000000)},
    {"ruin_app_e.vqa", "", int32_t(0x5FE87C1D), int32_t(0x00000000)},
    {"ruin_app_e.vqt", "", int32_t(0x5FE88F1D), int32_t(0x00000000)},
    {"ruin_app_h.pcx", "", int32_t(0x53E8990F), int32_t(0x00000000)},
    {"ruin_app_h.vqa", "", int32_t(0x5FE8821D), int32_t(0x00000000)},
    {"ruin_app_l.pcx", "", int32_t(0x53E8A10F), int32_t(0x00000000)},
    {"ruin_app_l.vqa", "", int32_t(0x5FE88A1D), int32_t(0x00000000)},
    {"rule01.ini", "ts main settings", int32_t(0x00000000), int32_t(0xF6B1E64D)},
    {"rule1.ini", "ts main settings", int32_t(0x00000000), int32_t(0x62EB0EAA)},
    {"rules.ini", "inif: game settings", int32_t(0xB1C3B238), int32_t(0xF025A96C)},
    {"rules01.ini", "ts main settings", int32_t(0x00000000), int32_t(0x5448D46D)},
    {"rules1.ini", "ts main settings", int32_t(0x00000000), int32_t(0xA8D54115)},
    {"rulesmd.ini", "", int32_t(0x00000000), int32_t(0x8218F9F4)},
    {"rulo226m.aud", "", int32_t(0x1BF2FADB), int32_t(0x00000000)},
    {"rumblel1.aud", "", int32_t(0xB023210F), int32_t(0x00000000)},
    {"rumloop1.aud", "", int32_t(0xD82B3515), int32_t(0x00000000)},
    {"run1226m.aud", "run for your life", int32_t(0xA3FAFADB), int32_t(0x00000000)},
    {"runaway1.aud", "", int32_t(0xAC411925), int32_t(0x00000000)},
    {"runedwn1.aud", "", int32_t(0xBC2B44FF), int32_t(0x00000000)},
    {"rupost1.aud", "", int32_t(0x99E85330), int32_t(0x00000000)},
    {"rupost1.xmi", "", int32_t(0x99ED4B47), int32_t(0x00000000)},
    {"rushhr.map", "", int32_t(0x00000000), int32_t(0x3A1B34DA)},
    {"rusi.pcx", "", int32_t(0x00000000), int32_t(0x4E809E1E)},
    {"rusi.shp", "", int32_t(0x00000000), int32_t(0xA1E971BE)},
    {"russ01.urb", "", int32_t(0x00000000), int32_t(0x584526D9)},
    {"russ02.urb", "", int32_t(0x00000000), int32_t(0x69AD3C44)},
    {"russ03.urb", "", int32_t(0x00000000), int32_t(0xCFDA37F0)},
    {"russ04.urb", "", int32_t(0x00000000), int32_t(0x0A7D097E)},
    {"russ05.urb", "", int32_t(0x00000000), int32_t(0xAC0A02CA)},
    {"russ06.urb", "", int32_t(0x00000000), int32_t(0x9DE21857)},
    {"russ07.urb", "", int32_t(0x00000000), int32_t(0x3B9513E3)},
    {"russ08.urb", "", int32_t(0x00000000), int32_t(0xCDDD630A)},
    {"russ09.urb", "", int32_t(0x00000000), int32_t(0x6BAA68BE)},
    {"russ10.urb", "", int32_t(0x00000000), int32_t(0x32982DF3)},
    {"russ11.urb", "", int32_t(0x00000000), int32_t(0x94EF2647)},
    {"russ12.urb", "", int32_t(0x00000000), int32_t(0xA5073CDA)},
    {"russ13.urb", "", int32_t(0x00000000), int32_t(0x0370376E)},
    {"russ14.urb", "", int32_t(0x00000000), int32_t(0xC6D709E0)},
    {"russ15.urb", "", int32_t(0x00000000), int32_t(0x60A00254)},
    {"russ16.urb", "", int32_t(0x00000000), int32_t(0x514818C9)},
    {"russ17.urb", "", int32_t(0x00000000), int32_t(0xF73F137D)},
    {"russian.mix", "russian.mix", int32_t(0xAA422128), int32_t(0x00000000)},
    {"rustle1.aud", "", int32_t(0xADF43522), int32_t(0x00000000)},
    {"ruwandr1.aud", "", int32_t(0xAC571F13), int32_t(0x00000000)},
    {"rv01.sno", "river", int32_t(0xB1AEFFD2), int32_t(0x00000000)},
    {"rv01.tem", "river w-e 1", int32_t(0xAFA600D2), int32_t(0x00000000)},
    {"rv01.win", "river w-e 1", int32_t(0xB0AA03D2), int32_t(0x00000000)},
    {"rv02.sno", "river", int32_t(0xB3AEFFD2), int32_t(0x00000000)},
    {"rv02.tem", "river w-e 2", int32_t(0xB1A600D2), int32_t(0x00000000)},
    {"rv02.win", "river w-e 2", int32_t(0xB2AA03D2), int32_t(0x00000000)},
    {"rv03.sno", "river", int32_t(0xB5AEFFD2), int32_t(0x00000000)},
    {"rv03.tem", "river wu-ed", int32_t(0xB3A600D2), int32_t(0x00000000)},
    {"rv03.win", "river wu-ed", int32_t(0xB4AA03D2), int32_t(0x00000000)},
    {"rv04.sno", "river", int32_t(0xB7AEFFD2), int32_t(0x00000000)},
    {"rv04.tem", "river wd-eu", int32_t(0xB5A600D2), int32_t(0x00000000)},
    {"rv04.win", "river wd-eu", int32_t(0xB6AA03D2), int32_t(0x00000000)},
    {"rv05.sno", "river", int32_t(0xB9AEFFD2), int32_t(0x00000000)},
    {"rv05.tem", "river n-s 1", int32_t(0xB7A600D2), int32_t(0x00000000)},
    {"rv05.win", "river n-s 1", int32_t(0xB8AA03D2), int32_t(0x00000000)},
    {"rv06.sno", "river", int32_t(0xBBAEFFD2), int32_t(0x00000000)},
    {"rv06.tem", "river n-s 2", int32_t(0xB9A600D2), int32_t(0x00000000)},
    {"rv06.win", "river n-s 2", int32_t(0xBAAA03D2), int32_t(0x00000000)},
    {"rv07.sno", "river", int32_t(0xBDAEFFD2), int32_t(0x00000000)},
    {"rv07.tem", "river n-s 3", int32_t(0xBBA600D2), int32_t(0x00000000)},
    {"rv07.win", "river n-s 3", int32_t(0xBCAA03D2), int32_t(0x00000000)},
    {"rv08.sno", "river", int32_t(0xBFAEFFD2), int32_t(0x00000000)},
    {"rv08.tem", "river corner s-e", int32_t(0xBDA600D2), int32_t(0x00000000)},
    {"rv08.win", "river corner s-e", int32_t(0xBEAA03D2), int32_t(0x00000000)},
    {"rv09.sno", "river", int32_t(0xC1AEFFD2), int32_t(0x00000000)},
    {"rv09.tem", "river corner w-s", int32_t(0xBFA600D2), int32_t(0x00000000)},
    {"rv09.win", "river corner w-s", int32_t(0xC0AA03D2), int32_t(0x00000000)},
    {"rv10.sno", "river", int32_t(0xAFB0FFD2), int32_t(0x00000000)},
    {"rv10.tem", "river corner n-e", int32_t(0xADA800D2), int32_t(0x00000000)},
    {"rv10.win", "river corner n-e", int32_t(0xAEAC03D2), int32_t(0x00000000)},
    {"rv11.sno", "river", int32_t(0xB1B0FFD2), int32_t(0x00000000)},
    {"rv11.tem", "river corner w-n", int32_t(0xAFA800D2), int32_t(0x00000000)},
    {"rv11.win", "river corner w-n", int32_t(0xB0AC03D2), int32_t(0x00000000)},
    {"rv12.sno", "river", int32_t(0xB3B0FFD2), int32_t(0x00000000)},
    {"rv12.tem", "river y n--w+s", int32_t(0xB1A800D2), int32_t(0x00000000)},
    {"rv12.win", "river y n--w+s", int32_t(0xB2AC03D2), int32_t(0x00000000)},
    {"rv13.sno", "river", int32_t(0xB5B0FFD2), int32_t(0x00000000)},
    {"rv13.tem", "river y eu--w+s", int32_t(0xB3A800D2), int32_t(0x00000000)},
    {"rv13.win", "river y eu--w+s", int32_t(0xB4AC03D2), int32_t(0x00000000)},
    {"rv14.des", "river w-e 3", int32_t(0xBBA7F0D2), int32_t(0x00000000)},
    {"rv14.sno", "river", int32_t(0xB7B0FFD2), int32_t(0x00000000)},
    {"rv14.tem", "river", int32_t(0xB5A800D2), int32_t(0x00000000)},
    {"rv15.des", "river w-e 4", int32_t(0xBDA7F0D2), int32_t(0x00000000)},
    {"rv15.sno", "river", int32_t(0xB9B0FFD2), int32_t(0x00000000)},
    {"rv15.tem", "river", int32_t(0xB7A800D2), int32_t(0x00000000)},
    {"rv16.des", "river wd-eu 2", int32_t(0xBFA7F0D2), int32_t(0x00000000)},
    {"rv17.des", "river wu-ed 2", int32_t(0xC1A7F0D2), int32_t(0x00000000)},
    {"rv18.des", "river n-s 4", int32_t(0xC3A7F0D2), int32_t(0x00000000)},
    {"rv19.des", "river n-s 4", int32_t(0xC5A7F0D2), int32_t(0x00000000)},
    {"rv20.des", "river nr-sl", int32_t(0xB3A9F0D2), int32_t(0x00000000)},
    {"rv21.des", "river nl-sr", int32_t(0xB5A9F0D2), int32_t(0x00000000)},
    {"rv22.des", "river corner e-s 2", int32_t(0xB7A9F0D2), int32_t(0x00000000)},
    {"rv23.des", "river corner w-s 2", int32_t(0xB9A9F0D2), int32_t(0x00000000)},
    {"rv24.des", "river corner n-e 2", int32_t(0xBBA9F0D2), int32_t(0x00000000)},
    {"rv25.des", "river corner n-w 2", int32_t(0xBDA9F0D2), int32_t(0x00000000)},
    {"rvol0.img", "", int32_t(0xCBCFB5F0), int32_t(0x00000000)},
    {"rvol0.lmf", "", int32_t(0xCBD5B5EF), int32_t(0x00000000)},
    {"rvol0.lsv", "", int32_t(0xD7D5B5FF), int32_t(0x00000000)},
    {"rvol0.odf", "", int32_t(0xB9DBB5EF), int32_t(0x00000000)},
    {"rvol0.pcx", "", int32_t(0xB7DDB601), int32_t(0x00000000)},
    {"rvol0.ver", "", int32_t(0xBBE9B5FB), int32_t(0x00000000)},
    {"s-gdiin2.wsa", "anim: gdi score screen", int32_t(0xB70C9F0D), int32_t(0x00000000)},
    {"s01.des", "cliff left edge south", int32_t(0x5CB5A5EA), int32_t(0x00000000)},
    {"s01.sno", "clifs", int32_t(0x5CB1AEF9), int32_t(0x00000000)},
    {"s01.tem", "cliff left edge south", int32_t(0x5CAFA5FA), int32_t(0x00000000)},
    {"s01.win", "cliff left edge south", int32_t(0x5CB0A9FD), int32_t(0x00000000)},
    {"s01_f00e.bik", "", int32_t(0x00000000), int32_t(0x123E3175)},
    {"s01_p01.wav", "", int32_t(0x00000000), int32_t(0x2C780A53)},
    {"s01_p01e.bik", "", int32_t(0x00000000), int32_t(0x63B6DA7C)},
    {"s01_p02e.bik", "", int32_t(0x00000000), int32_t(0xE522A8D2)},
    {"s01_p03.wav", "", int32_t(0x00000000), int32_t(0x61B0AB58)},
    {"s01_p03e.bik", "", int32_t(0x00000000), int32_t(0x2E7E7B77)},
    {"s02.des", "cliff wu-wd south", int32_t(0x5CB7A5EA), int32_t(0x00000000)},
    {"s02.sno", "clifs", int32_t(0x5CB3AEF9), int32_t(0x00000000)},
    {"s02.tem", "cliff wu-wd south", int32_t(0x5CB1A5FA), int32_t(0x00000000)},
    {"s02.win", "cliff wu-wd south", int32_t(0x5CB2A9FD), int32_t(0x00000000)},
    {"s02_f00e.bik", "", int32_t(0x00000000), int32_t(0xF9098A76)},
    {"s02_p01.wav", "", int32_t(0x00000000), int32_t(0xC74FB150)},
    {"s02_p01e.bik", "", int32_t(0x00000000), int32_t(0x8881617F)},
    {"s02_p02e.bik", "", int32_t(0x00000000), int32_t(0x0E1513D1)},
    {"s02_p03e.bik", "", int32_t(0x00000000), int32_t(0xC549C074)},
    {"s03.des", "cliff w-e 1 south", int32_t(0x5CB9A5EA), int32_t(0x00000000)},
    {"s03.sno", "clifs", int32_t(0x5CB5AEF9), int32_t(0x00000000)},
    {"s03.tem", "cliff w-e 1 south", int32_t(0x5CB3A5FA), int32_t(0x00000000)},
    {"s03.win", "cliff w-e 1 south", int32_t(0x5CB4A9FD), int32_t(0x00000000)},
    {"s03_f00e.bik", "", int32_t(0x00000000), int32_t(0x16CBE148)},
    {"s03_p01.wav", "", int32_t(0x00000000), int32_t(0x288DDA6E)},
    {"s03_p01e.bik", "", int32_t(0x00000000), int32_t(0x67430A41)},
    {"s03_p02e.bik", "", int32_t(0x00000000), int32_t(0xE1D778EF)},
    {"s03_p03e.bik", "", int32_t(0x00000000), int32_t(0x2A8BAB4A)},
    {"s04.des", "cliff w-e 2 south", int32_t(0x5CBBA5EA), int32_t(0x00000000)},
    {"s04.sno", "clifs", int32_t(0x5CB7AEF9), int32_t(0x00000000)},
    {"s04.tem", "cliff w-e 2 south", int32_t(0x5CB5A5FA), int32_t(0x00000000)},
    {"s04.win", "cliff w-e 2 south", int32_t(0x5CB6A9FD), int32_t(0x00000000)},
    {"s04_f00e.bik", "", int32_t(0x00000000), int32_t(0xF417FA31)},
    {"s04_p01.wav", "", int32_t(0x00000000), int32_t(0xCA51C117)},
    {"s04_p01e.bik", "", int32_t(0x00000000), int32_t(0x859F1138)},
    {"s04_p02e.bik", "", int32_t(0x00000000), int32_t(0x030B6396)},
    {"s04_p03e.bik", "", int32_t(0x00000000), int32_t(0xC857B033)},
    {"s05.des", "cliff w-e 3 south", int32_t(0x5CBDA5EA), int32_t(0x00000000)},
    {"s05.sno", "clifs", int32_t(0x5CB9AEF9), int32_t(0x00000000)},
    {"s05.tem", "cliff w-e 3 south", int32_t(0x5CB7A5FA), int32_t(0x00000000)},
    {"s05.win", "cliff w-e 3 south", int32_t(0x5CB8A9FD), int32_t(0x00000000)},
    {"s05_f00e.bik", "", int32_t(0x00000000), int32_t(0x1BD5910F)},
    {"s05_p01.wav", "", int32_t(0x00000000), int32_t(0x2593AA29)},
    {"s05_p01e.bik", "", int32_t(0x00000000), int32_t(0x6A5D7A06)},
    {"s05_p02e.bik", "", int32_t(0x00000000), int32_t(0xECC908A8)},
    {"s06.des", "cliff wd-eu south", int32_t(0x5CBFA5EA), int32_t(0x00000000)},
    {"s06.sno", "clifs", int32_t(0x5CBBAEF9), int32_t(0x00000000)},
    {"s06.tem", "cliff wd-eu south", int32_t(0x5CB9A5FA), int32_t(0x00000000)},
    {"s06.win", "cliff wd-eu south", int32_t(0x5CBAA9FD), int32_t(0x00000000)},
    {"s06_f00e.bik", "", int32_t(0x00000000), int32_t(0xF0E22A0C)},
    {"s06_p01e.bik", "", int32_t(0x00000000), int32_t(0x816AC105)},
    {"s06_p02.wav", "", int32_t(0x00000000), int32_t(0x48306384)},
    {"s06_p02e.bik", "", int32_t(0x00000000), int32_t(0x07FEB3AB)},
    {"s06_p03e.bik", "", int32_t(0x00000000), int32_t(0xCCA2600E)},
    {"s07.des", "cliff right edge south", int32_t(0x5CC1A5EA), int32_t(0x00000000)},
    {"s07.sno", "clifs", int32_t(0x5CBDAEF9), int32_t(0x00000000)},
    {"s07.tem", "cliff right edge south", int32_t(0x5CBBA5FA), int32_t(0x00000000)},
    {"s07.win", "cliff right edge south", int32_t(0x5CBCA9FD), int32_t(0x00000000)},
    {"s07_f00e.bik", "", int32_t(0x00000000), int32_t(0x1F204132)},
    {"s07_p01.wav", "", int32_t(0x00000000), int32_t(0x21667A14)},
    {"s07_p01e.bik", "", int32_t(0x00000000), int32_t(0x6EA8AA3B)},
    {"s07_p02e.bik", "", int32_t(0x00000000), int32_t(0xE83CD895)},
    {"s08.des", "cliff top edge west", int32_t(0x5CC3A5EA), int32_t(0x00000000)},
    {"s08.sno", "clifs", int32_t(0x5CBFAEF9), int32_t(0x00000000)},
    {"s08.tem", "cliff top edge west", int32_t(0x5CBDA5FA), int32_t(0x00000000)},
    {"s08.win", "cliff top edge west", int32_t(0x5CBEA9FD), int32_t(0x00000000)},
    {"s08_f00e.bik", "", int32_t(0x00000000), int32_t(0xEE2B1ABF)},
    {"s08_p01e.bik", "", int32_t(0x00000000), int32_t(0x9FA3F1B6)},
    {"s09.des", "cliff nl-sr west", int32_t(0x5CC5A5EA), int32_t(0x00000000)},
    {"s09.sno", "clifs", int32_t(0x5CC1AEF9), int32_t(0x00000000)},
    {"s09.tem", "cliff nl-sr west", int32_t(0x5CBFA5FA), int32_t(0x00000000)},
    {"s09.win", "cliff nl-sr west", int32_t(0x5CC0A9FD), int32_t(0x00000000)},
    {"s09_f00e.bik", "", int32_t(0x00000000), int32_t(0x01E97181)},
    {"s09_p01e.bik", "", int32_t(0x00000000), int32_t(0x70619A88)},
    {"s10.des", "cliff n-s 1 west", int32_t(0x5CB3A7EA), int32_t(0x00000000)},
    {"s10.sno", "clifs", int32_t(0x5CAFB0F9), int32_t(0x00000000)},
    {"s10.tem", "cliff n-s 1 west", int32_t(0x5CADA7FA), int32_t(0x00000000)},
    {"s10.win", "cliff n-s 1 west", int32_t(0x5CAEABFD), int32_t(0x00000000)},
    {"s10_f00e.bik", "", int32_t(0x00000000), int32_t(0x3C72858B)},
    {"s10_p01e.bik", "", int32_t(0x00000000), int32_t(0x4DFA6E82)},
    {"s10_p02e.bik", "", int32_t(0x00000000), int32_t(0xCB6E1C2C)},
    {"s10_p03e.bik", "", int32_t(0x00000000), int32_t(0x0032CF89)},
    {"s11.des", "cliff n-s 2 west", int32_t(0x5CB5A7EA), int32_t(0x00000000)},
    {"s11.sno", "clifs", int32_t(0x5CB1B0F9), int32_t(0x00000000)},
    {"s11.tem", "cliff n-s 2 west", int32_t(0x5CAFA7FA), int32_t(0x00000000)},
    {"s11.win", "cliff n-s 2 west", int32_t(0x5CB0ABFD), int32_t(0x00000000)},
    {"s11_f00e.bik", "", int32_t(0x00000000), int32_t(0xD3B0EEB5)},
    {"s11_p01e.bik", "", int32_t(0x00000000), int32_t(0xA23805BC)},
    {"s11_p03e.bik", "", int32_t(0x00000000), int32_t(0xEFF0A4B7)},
    {"s11_p04e.bik", "", int32_t(0x00000000), int32_t(0xF2F5940F)},
    {"s12.des", "cliff n-s 3 west", int32_t(0x5CB7A7EA), int32_t(0x00000000)},
    {"s12.sno", "clifs", int32_t(0x5CB3B0F9), int32_t(0x00000000)},
    {"s12.tem", "cliff n-s 3 west", int32_t(0x5CB1A7FA), int32_t(0x00000000)},
    {"s12.win", "cliff n-s 3 west", int32_t(0x5CB2ABFD), int32_t(0x00000000)},
    {"s12_f00e.bik", "", int32_t(0x00000000), int32_t(0x388755B6)},
    {"s12_p01e.bik", "", int32_t(0x00000000), int32_t(0x490FBEBF)},
    {"s13.des", "cliff sl-nr west", int32_t(0x5CB9A7EA), int32_t(0x00000000)},
    {"s13.sno", "clifs", int32_t(0x5CB5B0F9), int32_t(0x00000000)},
    {"s13.tem", "cliff sl-nr west", int32_t(0x5CB3A7FA), int32_t(0x00000000)},
    {"s13.win", "cliff sl-nr west", int32_t(0x5CB4ABFD), int32_t(0x00000000)},
    {"s13_f00e.bik", "", int32_t(0x00000000), int32_t(0xD7453E88)},
    {"s13_f01e.bik", "", int32_t(0x00000000), int32_t(0x1C19ED2D)},
    {"s14.des", "cliff bottom edge west", int32_t(0x5CBBA7EA), int32_t(0x00000000)},
    {"s14.sno", "clifs", int32_t(0x5CB7B0F9), int32_t(0x00000000)},
    {"s14.tem", "cliff bottom edge west", int32_t(0x5CB5A7FA), int32_t(0x00000000)},
    {"s14.win", "cliff bottom edge west", int32_t(0x5CB6ABFD), int32_t(0x00000000)},
    {"s15.des", "cliff left edge north", int32_t(0x5CBDA7EA), int32_t(0x00000000)},
    {"s15.sno", "clifs", int32_t(0x5CB9B0F9), int32_t(0x00000000)},
    {"s15.tem", "cliff left edge north", int32_t(0x5CB7A7FA), int32_t(0x00000000)},
    {"s15.win", "cliff left edge north", int32_t(0x5CB8ABFD), int32_t(0x00000000)},
    {"s16.des", "cliff wu-ed north", int32_t(0x5CBFA7EA), int32_t(0x00000000)},
    {"s16.sno", "clifs", int32_t(0x5CBBB0F9), int32_t(0x00000000)},
    {"s16.tem", "cliff wu-ed north", int32_t(0x5CB9A7FA), int32_t(0x00000000)},
    {"s16.win", "cliff wu-ed north", int32_t(0x5CBAABFD), int32_t(0x00000000)},
    {"s17.des", "cliff w-e 1 north", int32_t(0x5CC1A7EA), int32_t(0x00000000)},
    {"s17.sno", "clifs", int32_t(0x5CBDB0F9), int32_t(0x00000000)},
    {"s17.tem", "cliff w-e 1 north", int32_t(0x5CBBA7FA), int32_t(0x00000000)},
    {"s17.win", "cliff w-e 1 north", int32_t(0x5CBCABFD), int32_t(0x00000000)},
    {"s18.des", "cliff w-e 2 north", int32_t(0x5CC3A7EA), int32_t(0x00000000)},
    {"s18.sno", "clifs", int32_t(0x5CBFB0F9), int32_t(0x00000000)},
    {"s18.tem", "cliff w-e 2 north", int32_t(0x5CBDA7FA), int32_t(0x00000000)},
    {"s18.win", "cliff w-e 2 north", int32_t(0x5CBEABFD), int32_t(0x00000000)},
    {"s19.des", "cliff w-e 3 north", int32_t(0x5CC5A7EA), int32_t(0x00000000)},
    {"s19.sno", "clifs", int32_t(0x5CC1B0F9), int32_t(0x00000000)},
    {"s19.tem", "cliff w-e 3 north", int32_t(0x5CBFA7FA), int32_t(0x00000000)},
    {"s19.win", "cliff w-e 3 north", int32_t(0x5CC0ABFD), int32_t(0x00000000)},
    {"s20.des", "cliff wu-ed north", int32_t(0x5CB3A9EA), int32_t(0x00000000)},
    {"s20.sno", "clifs", int32_t(0x5CAFB2F9), int32_t(0x00000000)},
    {"s20.tem", "cliff wu-ed north", int32_t(0x5CADA9FA), int32_t(0x00000000)},
    {"s20.win", "cliff wu-ed north", int32_t(0x5CAEADFD), int32_t(0x00000000)},
    {"s21.des", "cliff right edge north", int32_t(0x5CB5A9EA), int32_t(0x00000000)},
    {"s21.sno", "clifs", int32_t(0x5CB1B2F9), int32_t(0x00000000)},
    {"s21.tem", "cliff right edge north", int32_t(0x5CAFA9FA), int32_t(0x00000000)},
    {"s21.win", "cliff right edge north", int32_t(0x5CB0ADFD), int32_t(0x00000000)},
    {"s22.des", "cliff top edge east", int32_t(0x5CB7A9EA), int32_t(0x00000000)},
    {"s22.sno", "clifs", int32_t(0x5CB3B2F9), int32_t(0x00000000)},
    {"s22.tem", "cliff top edge east", int32_t(0x5CB1A9FA), int32_t(0x00000000)},
    {"s22.win", "cliff top edge east", int32_t(0x5CB2ADFD), int32_t(0x00000000)},
    {"s23.des", "cliff sl-nr east", int32_t(0x5CB9A9EA), int32_t(0x00000000)},
    {"s23.sno", "clifs", int32_t(0x5CB5B2F9), int32_t(0x00000000)},
    {"s23.tem", "cliff sl-nr east", int32_t(0x5CB3A9FA), int32_t(0x00000000)},
    {"s23.win", "cliff sl-nr east", int32_t(0x5CB4ADFD), int32_t(0x00000000)},
    {"s24.des", "cliff n-s 1 east", int32_t(0x5CBBA9EA), int32_t(0x00000000)},
    {"s24.sno", "clifs", int32_t(0x5CB7B2F9), int32_t(0x00000000)},
    {"s24.tem", "cliff n-s 1 east", int32_t(0x5CB5A9FA), int32_t(0x00000000)},
    {"s24.win", "cliff n-s 1 east", int32_t(0x5CB6ADFD), int32_t(0x00000000)},
    {"s25.des", "cliff n-s 2 east", int32_t(0x5CBDA9EA), int32_t(0x00000000)},
    {"s25.sno", "clifs", int32_t(0x5CB9B2F9), int32_t(0x00000000)},
    {"s25.tem", "cliff n-s 2 east", int32_t(0x5CB7A9FA), int32_t(0x00000000)},
    {"s25.win", "cliff n-s 2 east", int32_t(0x5CB8ADFD), int32_t(0x00000000)},
    {"s26.des", "cliff n-s 3 east", int32_t(0x5CBFA9EA), int32_t(0x00000000)},
    {"s26.sno", "clifs", int32_t(0x5CBBB2F9), int32_t(0x00000000)},
    {"s26.tem", "cliff n-s 3 east", int32_t(0x5CB9A9FA), int32_t(0x00000000)},
    {"s26.win", "cliff n-s 3 east", int32_t(0x5CBAADFD), int32_t(0x00000000)},
    {"s27.des", "cliff nl-sr east", int32_t(0x5CC1A9EA), int32_t(0x00000000)},
    {"s27.sno", "clifs", int32_t(0x5CBDB2F9), int32_t(0x00000000)},
    {"s27.tem", "cliff nl-sr east", int32_t(0x5CBBA9FA), int32_t(0x00000000)},
    {"s27.win", "cliff nl-sr east", int32_t(0x5CBCADFD), int32_t(0x00000000)},
    {"s28.des", "cliff bottom edge east", int32_t(0x5CC3A9EA), int32_t(0x00000000)},
    {"s28.sno", "clifs", int32_t(0x5CBFB2F9), int32_t(0x00000000)},
    {"s28.tem", "cliff bottom edge east", int32_t(0x5CBDA9FA), int32_t(0x00000000)},
    {"s28.win", "cliff bottom edge east", int32_t(0x5CBEADFD), int32_t(0x00000000)},
    {"s29.des", "cliff corner n-e external", int32_t(0x5CC5A9EA), int32_t(0x00000000)},
    {"s29.sno", "clifs", int32_t(0x5CC1B2F9), int32_t(0x00000000)},
    {"s29.tem", "cliff corner n-e external", int32_t(0x5CBFA9FA), int32_t(0x00000000)},
    {"s29.win", "cliff corner n-e external", int32_t(0x5CC0ADFD), int32_t(0x00000000)},
    {"s30.des", "cliff corner s-e external", int32_t(0x5CB3ABEA), int32_t(0x00000000)},
    {"s30.sno", "clifs", int32_t(0x5CAFB4F9), int32_t(0x00000000)},
    {"s30.tem", "cliff corner s-e external", int32_t(0x5CADABFA), int32_t(0x00000000)},
    {"s30.win", "cliff corner s-e external", int32_t(0x5CAEAFFD), int32_t(0x00000000)},
    {"s31.des", "cliff corner w-s external", int32_t(0x5CB5ABEA), int32_t(0x00000000)},
    {"s31.sno", "clifs", int32_t(0x5CB1B4F9), int32_t(0x00000000)},
    {"s31.tem", "cliff corner w-s external", int32_t(0x5CAFABFA), int32_t(0x00000000)},
    {"s31.win", "cliff corner w-s external", int32_t(0x5CB0AFFD), int32_t(0x00000000)},
    {"s32.des", "cliff corner n-w external", int32_t(0x5CB7ABEA), int32_t(0x00000000)},
    {"s32.sno", "clifs", int32_t(0x5CB3B4F9), int32_t(0x00000000)},
    {"s32.tem", "cliff corner n-w external", int32_t(0x5CB1ABFA), int32_t(0x00000000)},
    {"s32.win", "cliff corner n-w external", int32_t(0x5CB2AFFD), int32_t(0x00000000)},
    {"s33.des", "cliff corner n-e internal", int32_t(0x5CB9ABEA), int32_t(0x00000000)},
    {"s33.sno", "clifs", int32_t(0x5CB5B4F9), int32_t(0x00000000)},
    {"s33.tem", "cliff corner n-e internal", int32_t(0x5CB3ABFA), int32_t(0x00000000)},
    {"s33.win", "cliff corner n-e internal", int32_t(0x5CB4AFFD), int32_t(0x00000000)},
    {"s34.des", "cliff corner s-e internal", int32_t(0x5CBBABEA), int32_t(0x00000000)},
    {"s34.sno", "clifs", int32_t(0x5CB7B4F9), int32_t(0x00000000)},
    {"s34.tem", "cliff corner s-e internal", int32_t(0x5CB5ABFA), int32_t(0x00000000)},
    {"s34.win", "cliff corner s-e internal", int32_t(0x5CB6AFFD), int32_t(0x00000000)},
    {"s35.des", "cliff corner w-s internal", int32_t(0x5CBDABEA), int32_t(0x00000000)},
    {"s35.sno", "clifs", int32_t(0x5CB9B4F9), int32_t(0x00000000)},
    {"s35.tem", "cliff corner w-s internal", int32_t(0x5CB7ABFA), int32_t(0x00000000)},
    {"s35.win", "cliff corner w-s internal", int32_t(0x5CB8AFFD), int32_t(0x00000000)},
    {"s36.des", "cliff corner w-n internal", int32_t(0x5CBFABEA), int32_t(0x00000000)},
    {"s36.sno", "clifs", int32_t(0x5CBBB4F9), int32_t(0x00000000)},
    {"s36.tem", "cliff corner w-n internal", int32_t(0x5CB9ABFA), int32_t(0x00000000)},
    {"s36.win", "cliff corner w-n internal", int32_t(0x5CBAAFFD), int32_t(0x00000000)},
    {"s37.des", "cliff junction nw-se", int32_t(0x5CC1ABEA), int32_t(0x00000000)},
    {"s37.sno", "clifs", int32_t(0x5CBDB4F9), int32_t(0x00000000)},
    {"s37.tem", "cliff junction nw-se", int32_t(0x5CBBABFA), int32_t(0x00000000)},
    {"s37.win", "cliff junction nw-se", int32_t(0x5CBCAFFD), int32_t(0x00000000)},
    {"s38.des", "cliff junction sw-ne", int32_t(0x5CC3ABEA), int32_t(0x00000000)},
    {"s38.sno", "clifs", int32_t(0x5CBFB4F9), int32_t(0x00000000)},
    {"s38.tem", "cliff junction sw-ne", int32_t(0x5CBDABFA), int32_t(0x00000000)},
    {"s38.win", "cliff junction sw-ne", int32_t(0x5CBEAFFD), int32_t(0x00000000)},
    {"s_africa.wsa", "anim: zoom on south africa", int32_t(0xDCDF671F), int32_t(0x00000000)},
    {"s_armgd1.aud", "", int32_t(0xEFE34D15), int32_t(0x00000000)},
    {"s_armor1.aud", "", int32_t(0xEFFF5D15), int32_t(0x00000000)},
    {"s_bang16.shp", "small explosion (bang/pop type)", int32_t(0x00000000), int32_t(0xA9F079B3)},
    {"s_bang24.shp", "medium explosion (bang/pop type)", int32_t(0x00000000), int32_t(0x55A4587D)},
    {"s_bang34.shp", "large explosion (bang/pop type)", int32_t(0x00000000), int32_t(0x9EF88BD8)},
    {"s_bang38.shp", "-", int32_t(0x00000000), int32_t(0x5B0866D9)},
    {"s_bang48.shp", "", int32_t(0x00000000), int32_t(0x460D5661)},
    {"s_brnl20.shp", "small explosion (burning type)", int32_t(0x00000000), int32_t(0x376ED4F3)},
    {"s_brnl30.shp", "medium explosion (burning type)", int32_t(0x00000000), int32_t(0xFC320756)},
    {"s_brnl40.shp", "large explosion (burning type)", int32_t(0x00000000), int32_t(0xE13737EE)},
    {"s_brnl58.shp", "x-large explosion (burning type)", int32_t(0x00000000), int32_t(0x1A1BAF8A)},
    {"s_clsn16.shp", "tiny explosion (cannon/missile impact)", int32_t(0x00000000), int32_t(0xC55B94F3)},
    {"s_clsn22.shp", "small explosion (cannon/missile impact)", int32_t(0x00000000), int32_t(0xB64F409D)},
    {"s_clsn30.shp", "medium explosion (cannon/missile impact)", int32_t(0x00000000), int32_t(0x07D3C058)},
    {"s_clsn42.shp", "large explosion (cannon/missile impact)", int32_t(0x00000000), int32_t(0x6016A380)},
    {"s_clsn58.shp", "x-large explosion (cannon/missile impact)", int32_t(0x00000000), int32_t(0xE1FA6884)},
    {"s_drk1.aud", "", int32_t(0xCB6E2438), int32_t(0x00000000)},
    {"s_heal1.aud", "", int32_t(0x71C86B10), int32_t(0x00000000)},
    {"s_hello1.aud", "", int32_t(0xBC155713), int32_t(0x00000000)},
    {"s_ion1.aud", "", int32_t(0xBF82243E), int32_t(0x00000000)},
    {"s_loser1.aud", "", int32_t(0xE42B4921), int32_t(0x00000000)},
    {"s_mapup1.aud", "", int32_t(0xAC2B691B), int32_t(0x00000000)},
    {"s_megaa1.aud", "", int32_t(0xBC0D4109), int32_t(0x00000000)},
    {"s_megarr.aud", "", int32_t(0xFE2F4109), int32_t(0x00000000)},
    {"s_megas1.aud", "", int32_t(0xBC314109), int32_t(0x00000000)},
    {"s_megaw1.aud", "", int32_t(0xBC394109), int32_t(0x00000000)},
    {"s_mgarng.aud", "", int32_t(0xF02762FD), int32_t(0x00000000)},
    {"s_nuke1.aud", "", int32_t(0xB1E05D24), int32_t(0x00000000)},
    {"s_radar1.aud", "", int32_t(0xAC434103), int32_t(0x00000000)},
    {"s_range1.aud", "", int32_t(0xAC294D17), int32_t(0x00000000)},
    {"s_rapid1.aud", "", int32_t(0xAC27511B), int32_t(0x00000000)},
    {"s_s.flc", "", int32_t(0x5CEA0AEC), int32_t(0x00000000)},
    {"s_sorry1.aud", "", int32_t(0xE455631F), int32_t(0x00000000)},
    {"s_speed1.aud", "", int32_t(0xE82B4905), int32_t(0x00000000)},
    {"s_stlall.aud", "", int32_t(0x2E3B4113), int32_t(0x00000000)},
    {"s_stltha.aud", "", int32_t(0x18336713), int32_t(0x00000000)},
    {"s_stlthd.aud", "", int32_t(0x1E336713), int32_t(0x00000000)},
    {"s_telep1.aud", "", int32_t(0xBC474913), int32_t(0x00000000)},
    {"s_tumu22.shp", "small explosion (vehicle blows up)", int32_t(0x00000000), int32_t(0x7FB6C50B)},
    {"s_tumu30.shp", "medium explosion (vehicle blows up)", int32_t(0x00000000), int32_t(0xCE2A45CE)},
    {"s_tumu42.shp", "large explosion (vehicle blows up)", int32_t(0x00000000), int32_t(0xA9EF2616)},
    {"s_tumu60.shp", "x-large explosion (vehicle blows up)", int32_t(0x00000000), int32_t(0x9EE7D47D)},
    {"s_unit1.aud", "", int32_t(0x95FC7B20), int32_t(0x00000000)},
    {"s_weapn1.aud", "", int32_t(0xBC4F5EFD), int32_t(0x00000000)},
    {"sabotage.vqa", "sabotage", int32_t(0x08E8DE23), int32_t(0x00000000)},
    {"sabotage.vqp", "sabotage", int32_t(0x17E8DE23), int32_t(0x00000000)},
    {"saffirm1.aud", "thief: affirmative!", int32_t(0xC008EB0D), int32_t(0x00000000)},
    {"saharami.map", "", int32_t(0x00000000), int32_t(0xCA8E987E)},
    {"saharamimw.map", "", int32_t(0x00000000), int32_t(0x07F4F798)},
    {"sam-e.shp", "-", int32_t(0x00000000), int32_t(0x3875EFF4)},
    {"sam-n.shp", "-", int32_t(0x00000000), int32_t(0x651FF3A2)},
    {"sam-ne.shp", "-", int32_t(0x00000000), int32_t(0x2F10CF46)},
    {"sam-nw.shp", "-", int32_t(0x00000000), int32_t(0xDF5142A1)},
    {"sam-s.shp", "-", int32_t(0x00000000), int32_t(0x82A1D758)},
    {"sam-se.shp", "-", int32_t(0x00000000), int32_t(0xC8AEEBBC)},
    {"sam-sw.shp", "-", int32_t(0x00000000), int32_t(0x38EF665B)},
    {"sam-w.shp", "-", int32_t(0x00000000), int32_t(0x06EBD9A2)},
    {"sam.hva", "", int32_t(0x00000000), int32_t(0xD73AD078)},
    {"sam.shp", "sam site", int32_t(0x5CEACAF9), int32_t(0x00000000)},
    {"sam.vxl", "", int32_t(0x00000000), int32_t(0xD8CCA393)},
    {"samdie.vqa", "sam site being blown up", int32_t(0xBD91D130), int32_t(0x00000000)},
    {"samdie.vqp", "sam site being blown up", int32_t(0xBD91E030), int32_t(0x00000000)},
    {"samfire.shp", "sam site smoke", int32_t(0x760FF232), int32_t(0x00000000)},
    {"samicnh.des", "icon: sam site", int32_t(0x8218E717), int32_t(0x00000000)},
    {"samicnh.tem", "icon: sam site", int32_t(0x8212E727), int32_t(0x00000000)},
    {"samicnh.win", "icon: sam site", int32_t(0x8213EB2A), int32_t(0x00000000)},
    {"samicon.shp", "icon: sam site", int32_t(0x8221EC26), int32_t(0xE4F2FBCD)},
    {"sammake.shp", "make: sam site", int32_t(0x920FE422), int32_t(0x00000000)},
    {"sammotr2.aud", "sam site motor", int32_t(0xDE2EEF19), int32_t(0x00000000)},
    {"sammotr2.juv", "sam site motor", int32_t(0xF02EF819), int32_t(0x00000000)},
    {"samshot1.aud", "sam site missile", int32_t(0x00000000), int32_t(0xC3C06D62)},
    {"samsite.vqa", "sam site firing", int32_t(0xAA00FF35), int32_t(0x00000000)},
    {"samsite.vqp", "sam site firing", int32_t(0xAA0FFF35), int32_t(0x00000000)},
    {"sandbag1.aud", "sandbag being run over", int32_t(0x00000000), int32_t(0xA4EBEE79)},
    {"sandbag2.aud", "barrier over", int32_t(0xBA1CC8FF), int32_t(0x00000000)},
    {"sandy01.des", "", int32_t(0x00000000), int32_t(0x1D9E3A1A)},
    {"sandy01.lun", "", int32_t(0x00000000), int32_t(0x3B60DD99)},
    {"sandy01.sno", "", int32_t(0x00000000), int32_t(0x3A72E780)},
    {"sandy01.tem", "-", int32_t(0x00000000), int32_t(0x99C6525A)},
    {"sandy01.ubn", "", int32_t(0x00000000), int32_t(0x0F187079)},
    {"sandy01.urb", "", int32_t(0x00000000), int32_t(0xBF8B9C05)},
    {"sandy01a.des", "", int32_t(0x00000000), int32_t(0x245643F5)},
    {"sandy01a.lun", "", int32_t(0x00000000), int32_t(0x03816CC5)},
    {"sandy01a.sno", "", int32_t(0x00000000), int32_t(0xCACA7384)},
    {"sandy01a.tem", "-", int32_t(0x00000000), int32_t(0xC27FDDE6)},
    {"sandy01a.ubn", "", int32_t(0x00000000), int32_t(0x15F570AC)},
    {"sandy01a.urb", "", int32_t(0x00000000), int32_t(0x56812ED6)},
    {"sandy01b.des", "", int32_t(0x00000000), int32_t(0x63F63925)},
    {"sandy01b.lun", "", int32_t(0x00000000), int32_t(0x44211615)},
    {"sandy01b.sno", "", int32_t(0x00000000), int32_t(0x8D6A0954)},
    {"sandy01b.tem", "-", int32_t(0x00000000), int32_t(0x85DFA736)},
    {"sandy01b.ubn", "", int32_t(0x00000000), int32_t(0x52550A7C)},
    {"sandy01b.urb", "", int32_t(0x00000000), int32_t(0x11215406)},
    {"sandy01c.des", "", int32_t(0x00000000), int32_t(0x5E961095)},
    {"sandy01c.lun", "", int32_t(0x00000000), int32_t(0x79413FA5)},
    {"sandy01c.sno", "", int32_t(0x00000000), int32_t(0xB00A20E4)},
    {"sandy01c.tem", "-", int32_t(0x00000000), int32_t(0xB8BF8E86)},
    {"sandy01c.ubn", "", int32_t(0x00000000), int32_t(0x6F3523CC)},
    {"sandy01c.urb", "", int32_t(0x00000000), int32_t(0x2C417DB6)},
    {"sandy01d.des", "", int32_t(0x00000000), int32_t(0xECB6CC85)},
    {"sandy01d.lun", "", int32_t(0x00000000), int32_t(0xCB61E3B5)},
    {"sandy01d.sno", "", int32_t(0x00000000), int32_t(0x022AFCF4)},
    {"sandy01d.tem", "-", int32_t(0x00000000), int32_t(0x0A9F5296)},
    {"sandy01d.ubn", "", int32_t(0x00000000), int32_t(0xDD15FFDC)},
    {"sandy01d.urb", "", int32_t(0x00000000), int32_t(0x9E61A1A6)},
    {"sandy01e.des", "", int32_t(0x00000000), int32_t(0xD1D6E535)},
    {"sandy01e.lun", "", int32_t(0x00000000), int32_t(0xF601CA05)},
    {"sandy01e.sno", "", int32_t(0x00000000), int32_t(0x3F4AD544)},
    {"sandy01e.tem", "-", int32_t(0x00000000), int32_t(0x37FF7B26)},
    {"sandy01e.ubn", "", int32_t(0x00000000), int32_t(0xE075D66C)},
    {"sandy01e.urb", "", int32_t(0x00000000), int32_t(0xA3018816)},
    {"sandy01f.des", "", int32_t(0x00000000), int32_t(0x96769FE5)},
    {"sandy01f.lun", "", int32_t(0x00000000), int32_t(0xB1A1B0D5)},
    {"sandy01f.sno", "", int32_t(0x00000000), int32_t(0x78EAAF94)},
    {"sandy01f.tem", "-", int32_t(0x00000000), int32_t(0x705F01F6)},
    {"sandy01f.ubn", "", int32_t(0x00000000), int32_t(0xA7D5ACBC)},
    {"sandy01f.urb", "", int32_t(0x00000000), int32_t(0xE4A1F2C6)},
    {"sandy01g.des", "", int32_t(0x00000000), int32_t(0xAB16B655)},
    {"sandy01g.lun", "", int32_t(0x00000000), int32_t(0x8CC19965)},
    {"sandy01g.sno", "", int32_t(0x00000000), int32_t(0x458A8624)},
    {"sandy01g.tem", "-", int32_t(0x00000000), int32_t(0x4D3F2846)},
    {"sandy01g.ubn", "", int32_t(0x00000000), int32_t(0x9AB5850C)},
    {"sandy01g.urb", "", int32_t(0x00000000), int32_t(0xD9C1DB76)},
    {"sapc.hva", "-", int32_t(0x00000000), int32_t(0x9C74F04E)},
    {"sapc.vxl", "subterranian apc", int32_t(0x00000000), int32_t(0x6AFE2F07)},
    {"sapcicon.shp", "icon: subterrainean apc", int32_t(0x00000000), int32_t(0x5EDD0598)},
    {"sapicon.shp", "", int32_t(0x00000000), int32_t(0x36A2F195)},
    {"satellitemap.bmp", "", int32_t(0x00000000), int32_t(0xE1FC930C)},
    {"satlnch1.aud", "gps sattelite launched", int32_t(0xD836CD17), int32_t(0x00000000)},
    {"satsel.cps", "pict: satellite selection screen", int32_t(0xD3ADF127), int32_t(0x00000000)},
    {"satsel.pal", "pal: ???", int32_t(0xEDADEA18), int32_t(0x00000000)},
    {"satselin.pal", "pal: ???", int32_t(0x3624EE05), int32_t(0x00000000)},
    {"sattact2.aud", "", int32_t(0xFA4ECCFD), int32_t(0x00000000)},
    {"savage.aud", "", int32_t(0x87B5D430), int32_t(0x00000000)},
    {"savage.xmi", "", int32_t(0xB5B5D928), int32_t(0x00000000)},
    {"save1.aud", "mission saved", int32_t(0xBFDB61F3), int32_t(0x00000000)},
    {"savegame.end", "", int32_t(0xE441CD09), int32_t(0x00000000)},
    {"sb_psh_d.pcx", "-", int32_t(0x00000000), int32_t(0xEA0ACA23)},
    {"sb_psh_u.pcx", "-", int32_t(0x00000000), int32_t(0xB78A7411)},
    {"sb_rel_d.pcx", "-", int32_t(0x00000000), int32_t(0x8A67FE1A)},
    {"sb_rel_u.pcx", "-", int32_t(0x00000000), int32_t(0xD7E74028)},
    {"sbag.shp", "sandbags", int32_t(0xDECAD7D4), int32_t(0x00000000)},
    {"sbagicnh.des", "icon: sandbags", int32_t(0x00E6D40D), int32_t(0x00000000)},
    {"sbagicnh.tem", "icon: sandbags", int32_t(0xFAE6E40D), int32_t(0x00000000)},
    {"sbagicnh.win", "icon: sandbags", int32_t(0xFBEAE70D), int32_t(0x00000000)},
    {"sbagicon.shp", "icon: sandbags", int32_t(0x09EBE30D), int32_t(0x52BFD843)},
    {"sbgripb.pcx", "-", int32_t(0x00000000), int32_t(0xE50A2B3A)},
    {"sbgripm.pcx", "-", int32_t(0x00000000), int32_t(0x145C99EF)},
    {"sbgript.pcx", "-", int32_t(0x00000000), int32_t(0x3085CABC)},
    {"sc-000.inf", "inf: list for sc-000.mix", int32_t(0x5311B3FB), int32_t(0x00000000)},
    {"sc-001.inf", "inf: list for sc-001.mix", int32_t(0x5311B5FB), int32_t(0x00000000)},
    {"sc1.des", "scorch mark 1", int32_t(0x5CB5CBEA), int32_t(0x00000000)},
    {"sc1.sno", "misc: scorch mark", int32_t(0x5CB1D4F9), int32_t(0x00000000)},
    {"sc1.tem", "scorch mark 1", int32_t(0x5CAFCBFA), int32_t(0x00000000)},
    {"sc1.win", "scorch mark 1", int32_t(0x5CB0CFFD), int32_t(0x00000000)},
    {"sc2.des", "scorch mark 2", int32_t(0x5CB7CBEA), int32_t(0x00000000)},
    {"sc2.sno", "misc: scorch mark", int32_t(0x5CB3D4F9), int32_t(0x00000000)},
    {"sc2.tem", "scorch mark 2", int32_t(0x5CB1CBFA), int32_t(0x00000000)},
    {"sc2.win", "scorch mark 2", int32_t(0x5CB2CFFD), int32_t(0x00000000)},
    {"sc3.des", "scorch mark 3", int32_t(0x5CB9CBEA), int32_t(0x00000000)},
    {"sc3.sno", "misc: scorch mark", int32_t(0x5CB5D4F9), int32_t(0x00000000)},
    {"sc3.tem", "scorch mark 3", int32_t(0x5CB3CBFA), int32_t(0x00000000)},
    {"sc3.win", "scorch mark 3", int32_t(0x5CB4CFFD), int32_t(0x00000000)},
    {"sc4.des", "scorch mark 4", int32_t(0x5CBBCBEA), int32_t(0x00000000)},
    {"sc4.sno", "misc: scorch mark", int32_t(0x5CB7D4F9), int32_t(0x00000000)},
    {"sc4.tem", "scorch mark 4", int32_t(0x5CB5CBFA), int32_t(0x00000000)},
    {"sc4.win", "scorch mark 4", int32_t(0x5CB6CFFD), int32_t(0x00000000)},
    {"sc5.des", "scorch mark 5", int32_t(0x5CBDCBEA), int32_t(0x00000000)},
    {"sc5.sno", "misc: scorch mark", int32_t(0x5CB9D4F9), int32_t(0x00000000)},
    {"sc5.tem", "scorch mark 5", int32_t(0x5CB7CBFA), int32_t(0x00000000)},
    {"sc5.win", "scorch mark 5", int32_t(0x5CB8CFFD), int32_t(0x00000000)},
    {"sc6.des", "scorch mark 6", int32_t(0x5CBFCBEA), int32_t(0x00000000)},
    {"sc6.sno", "misc: scorch mark", int32_t(0x5CBBD4F9), int32_t(0x00000000)},
    {"sc6.tem", "scorch mark 6", int32_t(0x5CB9CBFA), int32_t(0x00000000)},
    {"sc6.win", "scorch mark 6", int32_t(0x5CBACFFD), int32_t(0x00000000)},
    {"sca01ea.ini", "inif: it came from ra! 1", int32_t(0x1DD0E5F8), int32_t(0x00000000)},
    {"sca02ea.ini", "inif: it came from ra! 2", int32_t(0x1DD0E5FA), int32_t(0x00000000)},
    {"sca03ea.ini", "inif: it came from ra! 3", int32_t(0x1DD0E5FC), int32_t(0x00000000)},
    {"sca04ea.ini", "inif: it came from ra! 4", int32_t(0x1DD0E5FE), int32_t(0x00000000)},
    {"scandy1.aud", "", int32_t(0x95AC1516), int32_t(0x00000000)},
    {"scanner1.aud", "", int32_t(0xDFFED917), int32_t(0x00000000)},
    {"scanner2.aud", "", int32_t(0xE1FED917), int32_t(0x00000000)},
    {"scanner3.aud", "", int32_t(0xE3FED917), int32_t(0x00000000)},
    {"scanner4.aud", "", int32_t(0xE5FED917), int32_t(0x00000000)},
    {"scanner5.aud", "", int32_t(0xE7FED917), int32_t(0x00000000)},
    {"scanner6.aud", "", int32_t(0xE9FED917), int32_t(0x00000000)},
    {"scanner7.aud", "", int32_t(0xEBFED917), int32_t(0x00000000)},
    {"scarey1.aud", "", int32_t(0xA5AC1518), int32_t(0x00000000)},
    {"scarwnd2.aud", "", int32_t(0xF1E2EB29), int32_t(0x00000000)},
    {"scary1.aud", "", int32_t(0xCB61B454), int32_t(0x00000000)},
    {"scary2.aud", "", int32_t(0xCB61B654), int32_t(0x00000000)},
    {"scary3.aud", "", int32_t(0xCB61B854), int32_t(0x00000000)},
    {"scary4.aud", "", int32_t(0xCB61BA54), int32_t(0x00000000)},
    {"scary5.aud", "", int32_t(0xCB61BC54), int32_t(0x00000000)},
    {"scary6.aud", "", int32_t(0xCB61BE54), int32_t(0x00000000)},
    {"scary7.aud", "", int32_t(0xCB61C054), int32_t(0x00000000)},
    {"scavat1a.aud", "", int32_t(0x1FBCF6FD), int32_t(0x00000000)},
    {"scavat1b.aud", "", int32_t(0x21BCF6FD), int32_t(0x00000000)},
    {"scavat2a.aud", "", int32_t(0x1FBEF6FD), int32_t(0x00000000)},
    {"scavat2b.aud", "", int32_t(0x21BEF6FD), int32_t(0x00000000)},
    {"scavat2c.aud", "", int32_t(0x23BEF6FD), int32_t(0x00000000)},
    {"scavat2d.aud", "", int32_t(0x25BEF6FD), int32_t(0x00000000)},
    {"scavat2e.aud", "", int32_t(0x27BEF6FD), int32_t(0x00000000)},
    {"scavdie1.aud", "", int32_t(0xFFE4E103), int32_t(0x00000000)},
    {"scaveggs.aud", "", int32_t(0x43E8DD05), int32_t(0x00000000)},
    {"scavhit1.aud", "", int32_t(0x0002E10B), int32_t(0x00000000)},
    {"scavhit2.aud", "", int32_t(0x0202E10B), int32_t(0x00000000)},
    {"scavloi1.aud", "", int32_t(0xFFECED13), int32_t(0x00000000)},
    {"scavloi2.aud", "", int32_t(0x01ECED13), int32_t(0x00000000)},
    {"scavpck1.aud", "", int32_t(0xFFF0D51B), int32_t(0x00000000)},
    {"scavpck2.aud", "", int32_t(0x01F0D51B), int32_t(0x00000000)},
    {"scavrun1.aud", "", int32_t(0xFFF6F91F), int32_t(0x00000000)},
    {"scavwlk1.aud", "", int32_t(0xFFF0E729), int32_t(0x00000000)},
    {"scavwlk2.aud", "", int32_t(0x01F0E729), int32_t(0x00000000)},
    {"scavwlk3.aud", "", int32_t(0x03F0E729), int32_t(0x00000000)},
    {"scavwlk4.aud", "", int32_t(0x05F0E729), int32_t(0x00000000)},
    {"scb01ea.bin", "bin: nod mission 1", int32_t(0x1DD9E0F1), int32_t(0x00000000)},
    {"scb01ea.cps", "", int32_t(0x1DDEE7F2), int32_t(0x00000000)},
    {"scb01ea.ini", "inif: nod mission 1", int32_t(0x1DD4E5F8), int32_t(0x00000000)},
    {"scb01eb.cps", "", int32_t(0x1DE0E7F2), int32_t(0x00000000)},
    {"scb02ea.bin", "bin: nod mission 2", int32_t(0x1DD9E0F3), int32_t(0x00000000)},
    {"scb02ea.cps", "", int32_t(0x1DDEE7F4), int32_t(0x00000000)},
    {"scb02ea.ini", "inif: nod mission 2", int32_t(0x1DD4E5FA), int32_t(0x00000000)},
    {"scb02eb.bin", "bin: nod mission 2b", int32_t(0x1DDBE0F3), int32_t(0x00000000)},
    {"scb02eb.cps", "", int32_t(0x1DE0E7F4), int32_t(0x00000000)},
    {"scb02eb.ini", "inif: nod mission 2b", int32_t(0x1DD6E5FA), int32_t(0x00000000)},
    {"scb03ea.bin", "bin: nod mission 3", int32_t(0x1DD9E0F5), int32_t(0x00000000)},
    {"scb03ea.cps", "", int32_t(0x1DDEE7F6), int32_t(0x00000000)},
    {"scb03ea.ini", "inif: nod mission 3", int32_t(0x1DD4E5FC), int32_t(0x00000000)},
    {"scb03eb.bin", "bin: nod mission 3b", int32_t(0x1DDBE0F5), int32_t(0x00000000)},
    {"scb03eb.cps", "", int32_t(0x1DE0E7F6), int32_t(0x00000000)},
    {"scb03eb.ini", "inif: nod mission 3b", int32_t(0x1DD6E5FC), int32_t(0x00000000)},
    {"scb04ea.bin", "bin: nod mission 4", int32_t(0x1DD9E0F7), int32_t(0x00000000)},
    {"scb04ea.cps", "", int32_t(0x1DDEE7F8), int32_t(0x00000000)},
    {"scb04ea.ini", "inif: nod mission 4", int32_t(0x1DD4E5FE), int32_t(0x00000000)},
    {"scb04eb.bin", "bin: nod mission 4b", int32_t(0x1DDBE0F7), int32_t(0x00000000)},
    {"scb04eb.cps", "", int32_t(0x1DE0E7F8), int32_t(0x00000000)},
    {"scb04eb.ini", "inif: nod mission 4b", int32_t(0x1DD6E5FE), int32_t(0x00000000)},
    {"scb05ea.bin", "bin: nod mission 5", int32_t(0x1DD9E0F9), int32_t(0x00000000)},
    {"scb05ea.cps", "", int32_t(0x1DDEE7FA), int32_t(0x00000000)},
    {"scb05ea.ini", "inif: nod mission 5", int32_t(0x1DD4E600), int32_t(0x00000000)},
    {"scb05eb.cps", "", int32_t(0x1DE0E7FA), int32_t(0x00000000)},
    {"scb06ea.bin", "bin: nod mission 6", int32_t(0x1DD9E0FB), int32_t(0x00000000)},
    {"scb06ea.cps", "", int32_t(0x1DDEE7FC), int32_t(0x00000000)},
    {"scb06ea.ini", "inif: nod mission 6", int32_t(0x1DD4E602), int32_t(0x00000000)},
    {"scb06eb.bin", "bin: nod mission 6b", int32_t(0x1DDBE0FB), int32_t(0x00000000)},
    {"scb06eb.cps", "", int32_t(0x1DE0E7FC), int32_t(0x00000000)},
    {"scb06eb.ini", "inif: nod mission 6b", int32_t(0x1DD6E602), int32_t(0x00000000)},
    {"scb06ec.bin", "bin: nod mission 6c", int32_t(0x1DDDE0FB), int32_t(0x00000000)},
    {"scb06ec.cps", "", int32_t(0x1DE2E7FC), int32_t(0x00000000)},
    {"scb06ec.ini", "inif: nod mission 6c", int32_t(0x1DD8E602), int32_t(0x00000000)},
    {"scb07ea.bin", "bin: nod mission 7", int32_t(0x1DD9E0FD), int32_t(0x00000000)},
    {"scb07ea.cps", "", int32_t(0x1DDEE7FE), int32_t(0x00000000)},
    {"scb07ea.ini", "inif: nod mission 7", int32_t(0x1DD4E604), int32_t(0x00000000)},
    {"scb07eb.bin", "bin: nod mission 7b", int32_t(0x1DDBE0FD), int32_t(0x00000000)},
    {"scb07eb.cps", "", int32_t(0x1DE0E7FE), int32_t(0x00000000)},
    {"scb07eb.ini", "inif: nod mission 7b", int32_t(0x1DD6E604), int32_t(0x00000000)},
    {"scb07ec.bin", "bin: nod mission 7c", int32_t(0x1DDDE0FD), int32_t(0x00000000)},
    {"scb07ec.cps", "", int32_t(0x1DE2E7FE), int32_t(0x00000000)},
    {"scb07ec.ini", "inif: nod mission 7c", int32_t(0x1DD8E604), int32_t(0x00000000)},
    {"scb08ea.bin", "bin: nod mission 8", int32_t(0x1DD9E0FF), int32_t(0x00000000)},
    {"scb08ea.cps", "", int32_t(0x1DDEE800), int32_t(0x00000000)},
    {"scb08ea.ini", "inif: nod mission 8", int32_t(0x1DD4E606), int32_t(0x00000000)},
    {"scb08eb.bin", "bin: nod mission 8b", int32_t(0x1DDBE0FF), int32_t(0x00000000)},
    {"scb08eb.cps", "", int32_t(0x1DE0E800), int32_t(0x00000000)},
    {"scb08eb.ini", "inif: nod mission 8b", int32_t(0x1DD6E606), int32_t(0x00000000)},
    {"scb09ea.bin", "bin: nod mission 9", int32_t(0x1DD9E101), int32_t(0x00000000)},
    {"scb09ea.cps", "", int32_t(0x1DDEE802), int32_t(0x00000000)},
    {"scb09ea.ini", "inif: nod mission 9", int32_t(0x1DD4E608), int32_t(0x00000000)},
    {"scb09eb.cps", "", int32_t(0x1DE0E802), int32_t(0x00000000)},
    {"scb10ea.bin", "bin: nod mission 10", int32_t(0x21D9E0EF), int32_t(0x00000000)},
    {"scb10ea.cps", "", int32_t(0x21DEE7F0), int32_t(0x00000000)},
    {"scb10ea.ini", "inif: nod mission 10", int32_t(0x21D4E5F6), int32_t(0x00000000)},
    {"scb10eb.bin", "bin: nod mission 10b", int32_t(0x21DBE0EF), int32_t(0x00000000)},
    {"scb10eb.cps", "", int32_t(0x21E0E7F0), int32_t(0x00000000)},
    {"scb10eb.ini", "inif: nod mission 10b", int32_t(0x21D6E5F6), int32_t(0x00000000)},
    {"scb11ea.bin", "bin: nod mission 11", int32_t(0x21D9E0F1), int32_t(0x00000000)},
    {"scb11ea.cps", "", int32_t(0x21DEE7F2), int32_t(0x00000000)},
    {"scb11ea.ini", "inif: nod mission 11", int32_t(0x21D4E5F8), int32_t(0x00000000)},
    {"scb11eb.bin", "bin: nod mission 11b", int32_t(0x21DBE0F1), int32_t(0x00000000)},
    {"scb11eb.cps", "", int32_t(0x21E0E7F2), int32_t(0x00000000)},
    {"scb11eb.ini", "inif: nod mission 11b", int32_t(0x21D6E5F8), int32_t(0x00000000)},
    {"scb12ea.bin", "bin: nod mission 12", int32_t(0x21D9E0F3), int32_t(0x00000000)},
    {"scb12ea.cps", "", int32_t(0x21DEE7F4), int32_t(0x00000000)},
    {"scb12ea.ini", "inif: nod mission 12", int32_t(0x21D4E5FA), int32_t(0x00000000)},
    {"scb12eb.cps", "", int32_t(0x21E0E7F4), int32_t(0x00000000)},
    {"scb13ea.bin", "bin: nod mission 13", int32_t(0x21D9E0F5), int32_t(0x00000000)},
    {"scb13ea.cps", "", int32_t(0x21DEE7F6), int32_t(0x00000000)},
    {"scb13ea.ini", "inif: nod mission 13", int32_t(0x21D4E5FC), int32_t(0x00000000)},
    {"scb13eb.bin", "bin: nod mission 13b", int32_t(0x21DBE0F5), int32_t(0x00000000)},
    {"scb13eb.cps", "", int32_t(0x21E0E7F6), int32_t(0x00000000)},
    {"scb13eb.ini", "inif: nod mission 13b", int32_t(0x21D6E5FC), int32_t(0x00000000)},
    {"scb13ec.bin", "bin: nod mission 13c", int32_t(0x21DDE0F5), int32_t(0x00000000)},
    {"scb13ec.cps", "", int32_t(0x21E2E7F6), int32_t(0x00000000)},
    {"scb13ec.ini", "inif: nod mission 13c", int32_t(0x21D8E5FC), int32_t(0x00000000)},
    {"scb20ea.bin", "bin: bad neighbourhood", int32_t(0x25D9E0EF), int32_t(0x00000000)},
    {"scb20ea.ini", "inif: bad neighbourhood", int32_t(0x25D4E5F6), int32_t(0x00000000)},
    {"scb21ea.bin", "bin: decit", int32_t(0x25D9E0F1), int32_t(0x00000000)},
    {"scb21ea.ini", "inif: decit", int32_t(0x25D4E5F8), int32_t(0x00000000)},
    {"scb30ea.bin", "bin: eviction notice", int32_t(0x29D9E0EF), int32_t(0x00000000)},
    {"scb30ea.ini", "inif: eviction notice", int32_t(0x29D4E5F6), int32_t(0x00000000)},
    {"scb31ea.bin", "bin: the tiberium strain", int32_t(0x29D9E0F1), int32_t(0x00000000)},
    {"scb31ea.ini", "inif: the tiberium strain", int32_t(0x29D4E5F8), int32_t(0x00000000)},
    {"scb32ea.bin", "bin: cloak and dagger", int32_t(0x29D9E0F3), int32_t(0x00000000)},
    {"scb32ea.ini", "inif: cloak and dagger", int32_t(0x29D4E5FA), int32_t(0x00000000)},
    {"scb33ea.bin", "bin: hostile takeover", int32_t(0x29D9E0F5), int32_t(0x00000000)},
    {"scb33ea.ini", "inif: hostile takeover", int32_t(0x29D4E5FC), int32_t(0x00000000)},
    {"scb35ea.bin", "bin: under siege", int32_t(0x29D9E0F9), int32_t(0x00000000)},
    {"scb35ea.ini", "inif: under siege", int32_t(0x29D4E600), int32_t(0x00000000)},
    {"scb37ea.bin", "bin: nod death squad", int32_t(0x29D9E0FD), int32_t(0x00000000)},
    {"scb37ea.ini", "inif: nod death squad", int32_t(0x29D4E604), int32_t(0x00000000)},
    {"scg01ea.bin", "bin: gdi mission 1", int32_t(0x1DEDE0F1), int32_t(0x00000000)},
    {"scg01ea.cps", "", int32_t(0x1DF2E7F2), int32_t(0x00000000)},
    {"scg01ea.ini", "inif: gdi mission 1", int32_t(0x1DE8E5F8), int32_t(0x00000000)},
    {"scg02ea.bin", "bin: gdi mission 2", int32_t(0x1DEDE0F3), int32_t(0x00000000)},
    {"scg02ea.cps", "", int32_t(0x1DF2E7F4), int32_t(0x00000000)},
    {"scg02ea.ini", "inif: gdi mission 2", int32_t(0x1DE8E5FA), int32_t(0x00000000)},
    {"scg03ea.bin", "bin: gdi mission 3", int32_t(0x1DEDE0F5), int32_t(0x00000000)},
    {"scg03ea.cps", "", int32_t(0x1DF2E7F6), int32_t(0x00000000)},
    {"scg03ea.ini", "inif: gdi mission 3", int32_t(0x1DE8E5FC), int32_t(0x00000000)},
    {"scg03eb.cps", "", int32_t(0x1DF4E7F6), int32_t(0x00000000)},
    {"scg03eb.ini", "inif: allied mission 3b", int32_t(0x1DEAE5FC), int32_t(0x00000000)},
    {"scg04ea.bin", "bin: gdi mission 4", int32_t(0x1DEDE0F7), int32_t(0x00000000)},
    {"scg04ea.cps", "", int32_t(0x1DF2E7F8), int32_t(0x00000000)},
    {"scg04ea.ini", "inif: gdi mission 4", int32_t(0x1DE8E5FE), int32_t(0x00000000)},
    {"scg04wa.bin", "bin: gdi mission 4wa", int32_t(0x1DEE04F7), int32_t(0x00000000)},
    {"scg04wa.cps", "", int32_t(0x1DF30BF8), int32_t(0x00000000)},
    {"scg04wa.ini", "inif: gdi mission 4wa", int32_t(0x1DE909FE), int32_t(0x00000000)},
    {"scg04wb.bin", "bin: gdi mission 4wb", int32_t(0x1DF004F7), int32_t(0x00000000)},
    {"scg04wb.cps", "", int32_t(0x1DF50BF8), int32_t(0x00000000)},
    {"scg04wb.ini", "inif: gdi mission 4wb", int32_t(0x1DEB09FE), int32_t(0x00000000)},
    {"scg05ea.bin", "bin: gdi mission 5", int32_t(0x1DEDE0F9), int32_t(0x00000000)},
    {"scg05ea.cps", "", int32_t(0x1DF2E7FA), int32_t(0x00000000)},
    {"scg05ea.ini", "inif: gdi mission 5", int32_t(0x1DE8E600), int32_t(0x00000000)},
    {"scg05eb.bin", "bin: gdi mission 5b", int32_t(0x1DEFE0F9), int32_t(0x00000000)},
    {"scg05eb.cps", "", int32_t(0x1DF4E7FA), int32_t(0x00000000)},
    {"scg05eb.ini", "inif: gdi mission 5b", int32_t(0x1DEAE600), int32_t(0x00000000)},
    {"scg05ec.ini", "inif: allied mission 5c", int32_t(0x1DECE600), int32_t(0x00000000)},
    {"scg05wa.bin", "bin: gdi mission 5wa", int32_t(0x1DEE04F9), int32_t(0x00000000)},
    {"scg05wa.cps", "", int32_t(0x1DF30BFA), int32_t(0x00000000)},
    {"scg05wa.ini", "inif: gdi mission 5wa", int32_t(0x1DE90A00), int32_t(0x00000000)},
    {"scg05wb.bin", "bin: gdi mission 5wb", int32_t(0x1DF004F9), int32_t(0x00000000)},
    {"scg05wb.cps", "", int32_t(0x1DF50BFA), int32_t(0x00000000)},
    {"scg05wb.ini", "inif: gdi mission 5wb", int32_t(0x1DEB0A00), int32_t(0x00000000)},
    {"scg06ea.bin", "bin: gdi mission 6", int32_t(0x1DEDE0FB), int32_t(0x00000000)},
    {"scg06ea.cps", "", int32_t(0x1DF2E7FC), int32_t(0x00000000)},
    {"scg06ea.ini", "inif: gdi mission 6", int32_t(0x1DE8E602), int32_t(0x00000000)},
    {"scg06eb.ini", "inif: allied mission 6b", int32_t(0x1DEAE602), int32_t(0x00000000)},
    {"scg07ea.bin", "bin: gdi mission 7", int32_t(0x1DEDE0FD), int32_t(0x00000000)},
    {"scg07ea.cps", "", int32_t(0x1DF2E7FE), int32_t(0x00000000)},
    {"scg07ea.ini", "inif: gdi mission 7", int32_t(0x1DE8E604), int32_t(0x00000000)},
    {"scg07wa.ini", "", int32_t(0x1DE90A04), int32_t(0x00000000)},
    {"scg08ea.bin", "bin: gdi mission 8", int32_t(0x1DEDE0FF), int32_t(0x00000000)},
    {"scg08ea.cps", "", int32_t(0x1DF2E800), int32_t(0x00000000)},
    {"scg08ea.ini", "inif: gdi mission 8", int32_t(0x1DE8E606), int32_t(0x00000000)},
    {"scg08eb.bin", "bin: gdi mission 8b", int32_t(0x1DEFE0FF), int32_t(0x00000000)},
    {"scg08eb.cps", "", int32_t(0x1DF4E800), int32_t(0x00000000)},
    {"scg08eb.ini", "inif: gdi mission 8b", int32_t(0x1DEAE606), int32_t(0x00000000)},
    {"scg09ea.bin", "bin: gdi mission 9", int32_t(0x1DEDE101), int32_t(0x00000000)},
    {"scg09ea.cps", "", int32_t(0x1DF2E802), int32_t(0x00000000)},
    {"scg09ea.ini", "inif: gdi mission 9", int32_t(0x1DE8E608), int32_t(0x00000000)},
    {"scg09eb.ini", "inif: allied mission 9b", int32_t(0x1DEAE608), int32_t(0x00000000)},
    {"scg10ea.bin", "bin: gdi mission 10", int32_t(0x21EDE0EF), int32_t(0x00000000)},
    {"scg10ea.cps", "", int32_t(0x21F2E7F0), int32_t(0x00000000)},
    {"scg10ea.ini", "inif: gdi mission 10", int32_t(0x21E8E5F6), int32_t(0x00000000)},
    {"scg10eb.bin", "bin: gdi mission 10b", int32_t(0x21EFE0EF), int32_t(0x00000000)},
    {"scg10eb.cps", "", int32_t(0x21F4E7F0), int32_t(0x00000000)},
    {"scg10eb.ini", "inif: gdi mission 10b", int32_t(0x21EAE5F6), int32_t(0x00000000)},
    {"scg11ea.bin", "bin: gdi mission 11", int32_t(0x21EDE0F1), int32_t(0x00000000)},
    {"scg11ea.cps", "", int32_t(0x21F2E7F2), int32_t(0x00000000)},
    {"scg11ea.ini", "inif: gdi mission 11", int32_t(0x21E8E5F8), int32_t(0x00000000)},
    {"scg11eb.ini", "inif: allied mission 11b", int32_t(0x21EAE5F8), int32_t(0x00000000)},
    {"scg12ea.bin", "bin: gdi mission 12", int32_t(0x21EDE0F3), int32_t(0x00000000)},
    {"scg12ea.cps", "", int32_t(0x21F2E7F4), int32_t(0x00000000)},
    {"scg12ea.ini", "inif: gdi mission 12", int32_t(0x21E8E5FA), int32_t(0x00000000)},
    {"scg12eb.bin", "bin: gdi mission 12b", int32_t(0x21EFE0F3), int32_t(0x00000000)},
    {"scg12eb.cps", "", int32_t(0x21F4E7F4), int32_t(0x00000000)},
    {"scg12eb.ini", "inif: gdi mission 12b", int32_t(0x21EAE5FA), int32_t(0x00000000)},
    {"scg13ea.bin", "bin: gdi mission 13", int32_t(0x21EDE0F5), int32_t(0x00000000)},
    {"scg13ea.cps", "", int32_t(0x21F2E7F6), int32_t(0x00000000)},
    {"scg13ea.ini", "inif: gdi mission 13", int32_t(0x21E8E5FC), int32_t(0x00000000)},
    {"scg13eb.bin", "bin: gdi mission 13b", int32_t(0x21EFE0F5), int32_t(0x00000000)},
    {"scg13eb.cps", "", int32_t(0x21F4E7F6), int32_t(0x00000000)},
    {"scg13eb.ini", "inif: gdi mission 13b", int32_t(0x21EAE5FC), int32_t(0x00000000)},
    {"scg14ea.bin", "bin: gdi mission 14", int32_t(0x21EDE0F7), int32_t(0x00000000)},
    {"scg14ea.cps", "", int32_t(0x21F2E7F8), int32_t(0x00000000)},
    {"scg14ea.ini", "inif: gdi mission 14", int32_t(0x21E8E5FE), int32_t(0x00000000)},
    {"scg15ea.bin", "bin: gdi mission 15", int32_t(0x21EDE0F9), int32_t(0x00000000)},
    {"scg15ea.cps", "", int32_t(0x21F2E7FA), int32_t(0x00000000)},
    {"scg15ea.ini", "inif: gdi mission 15", int32_t(0x21E8E600), int32_t(0x00000000)},
    {"scg15eb.bin", "bin: gdi mission 15b", int32_t(0x21EFE0F9), int32_t(0x00000000)},
    {"scg15eb.cps", "", int32_t(0x21F4E7FA), int32_t(0x00000000)},
    {"scg15eb.ini", "inif: gdi mission 15b", int32_t(0x21EAE600), int32_t(0x00000000)},
    {"scg15ec.bin", "bin: gdi mission 15c", int32_t(0x21F1E0F9), int32_t(0x00000000)},
    {"scg15ec.cps", "", int32_t(0x21F6E7FA), int32_t(0x00000000)},
    {"scg15ec.ini", "inif: gdi mission 15c", int32_t(0x21ECE600), int32_t(0x00000000)},
    {"scg20ea.ini", "inif: sarin gas 1", int32_t(0x25E8E5F6), int32_t(0x00000000)},
    {"scg21ea.ini", "inif: sarin gas 2", int32_t(0x25E8E5F8), int32_t(0x00000000)},
    {"scg22ea.bin", "bin: blackout", int32_t(0x25EDE0F3), int32_t(0x00000000)},
    {"scg22ea.ini", "inif: blackout", int32_t(0x25E8E5FA), int32_t(0x00000000)},
    {"scg23ea.bin", "bin: hells fury", int32_t(0x25EDE0F5), int32_t(0x00000000)},
    {"scg23ea.ini", "inif: hells fury", int32_t(0x25E8E5FC), int32_t(0x00000000)},
    {"scg24ea.ini", "inif: fall of greece 2", int32_t(0x25E8E5FE), int32_t(0x00000000)},
    {"scg26ea.ini", "inif: siberian conflict 1", int32_t(0x25E8E602), int32_t(0x00000000)},
    {"scg27ea.ini", "inif: siberian conflict 2", int32_t(0x25E8E604), int32_t(0x00000000)},
    {"scg28ea.ini", "inif: siberian conflict 3", int32_t(0x25E8E606), int32_t(0x00000000)},
    {"scg36ea.bin", "bin: infiltrated", int32_t(0x29EDE0FB), int32_t(0x00000000)},
    {"scg36ea.ini", "inif: infiltrated", int32_t(0x29E8E602), int32_t(0x00000000)},
    {"scg38ea.bin", "bin: elemental imperitive", int32_t(0x29EDE0FF), int32_t(0x00000000)},
    {"scg38ea.ini", "inif: elemental imperitive", int32_t(0x29E8E606), int32_t(0x00000000)},
    {"scg40ea.bin", "bin: ground zero", int32_t(0x2DEDE0EF), int32_t(0x00000000)},
    {"scg40ea.ini", "inif: ground zero", int32_t(0x2DE8E5F6), int32_t(0x00000000)},
    {"scg41ea.bin", "bin: twist of fate", int32_t(0x2DEDE0F1), int32_t(0x00000000)},
    {"scg41ea.ini", "inif: twist of fate", int32_t(0x2DE8E5F8), int32_t(0x00000000)},
    {"scg42ea.ini", "production disruption", int32_t(0x2DE8E5FA), int32_t(0x00000000)},
    {"scg43ea.ini", "harbor reclamation", int32_t(0x2DE8E5FC), int32_t(0x00000000)},
    {"scg44ea.ini", "time flies", int32_t(0x2DE8E5FE), int32_t(0x00000000)},
    {"scg45ea.ini", "monster tank madness", int32_t(0x2DE8E600), int32_t(0x00000000)},
    {"scg46ea.ini", "pawn", int32_t(0x2DE8E602), int32_t(0x00000000)},
    {"scg47ea.ini", "negotations", int32_t(0x2DE8E604), int32_t(0x00000000)},
    {"scg48ea.ini", "abslout m.a.d.ness", int32_t(0x2DE8E606), int32_t(0x00000000)},
    {"scg50ea.bin", "bin: blindsided", int32_t(0x31EDE0EF), int32_t(0x00000000)},
    {"scg50ea.ini", "inif: blindsided", int32_t(0x31E8E5F6), int32_t(0x00000000)},
    {"schd.hva", "", int32_t(0x00000000), int32_t(0x564EBD81)},
    {"schd.vxl", "", int32_t(0x00000000), int32_t(0xA0C462C8)},
    {"schdtur.hva", "", int32_t(0x00000000), int32_t(0xA8452AB9)},
    {"schdtur.vxl", "", int32_t(0x00000000), int32_t(0xA7B35952)},
    {"schp.hva", "", int32_t(0x00000000), int32_t(0xC32E8CC3)},
    {"schp.vxl", "", int32_t(0x00000000), int32_t(0x35A4538A)},
    {"schpdepl.shp", "", int32_t(0x00000000), int32_t(0xD710C034)},
    {"schpicon.shp", "", int32_t(0x00000000), int32_t(0xA78503F1)},
    {"schpuico.shp", "", int32_t(0x00000000), int32_t(0x62439110)},
    {"scj01ea.bin", "bin: jurassic mission 1", int32_t(0x1DF9E0F1), int32_t(0x00000000)},
    {"scj01ea.ini", "inif: jurassic mission 1", int32_t(0x1DF4E5F8), int32_t(0x00000000)},
    {"scj02ea.bin", "bin: jurassic mission 2", int32_t(0x1DF9E0F3), int32_t(0x00000000)},
    {"scj02ea.ini", "inif: jurassic mission 2", int32_t(0x1DF4E5FA), int32_t(0x00000000)},
    {"scj03ea.bin", "bin: jurassic mission 3", int32_t(0x1DF9E0F5), int32_t(0x00000000)},
    {"scj03ea.ini", "inif: jurassic mission 3", int32_t(0x1DF4E5FC), int32_t(0x00000000)},
    {"scj04ea.bin", "bin: jurassic mission 4", int32_t(0x1DF9E0F7), int32_t(0x00000000)},
    {"scj04ea.ini", "inif: jurassic mission 4", int32_t(0x1DF4E5FE), int32_t(0x00000000)},
    {"scj05ea.bin", "bin: jurassic mission 5", int32_t(0x1DF9E0F9), int32_t(0x00000000)},
    {"scj05ea.ini", "inif: jurassic mission 5", int32_t(0x1DF4E600), int32_t(0x00000000)},
    {"sclean1.aud", "", int32_t(0x71D7FF10), int32_t(0x00000000)},
    {"scm01ea.bin", "bin: green acres", int32_t(0x1E05E0F1), int32_t(0x00000000)},
    {"scm01ea.ini", "inif: green acres", int32_t(0x1E00E5F8), int32_t(0x00000000)},
    {"scm02ea.bin", "bin: sand trap", int32_t(0x1E05E0F3), int32_t(0x00000000)},
    {"scm02ea.ini", "inif: sand trap", int32_t(0x1E00E5FA), int32_t(0x00000000)},
    {"scm03ea.bin", "bin: lost arena", int32_t(0x1E05E0F5), int32_t(0x00000000)},
    {"scm03ea.ini", "inif: lost arena", int32_t(0x1E00E5FC), int32_t(0x00000000)},
    {"scm04ea.bin", "bin: river raid", int32_t(0x1E05E0F7), int32_t(0x00000000)},
    {"scm04ea.ini", "inif: river raid", int32_t(0x1E00E5FE), int32_t(0x00000000)},
    {"scm05ea.bin", "bin: eye of the storm", int32_t(0x1E05E0F9), int32_t(0x00000000)},
    {"scm05ea.ini", "inif: eye of the storm", int32_t(0x1E00E600), int32_t(0x00000000)},
    {"scm06ea.bin", "bin: lakefront clash", int32_t(0x1E05E0FB), int32_t(0x00000000)},
    {"scm06ea.ini", "inif: lakefront clash", int32_t(0x1E00E602), int32_t(0x00000000)},
    {"scm07ea.bin", "bin: desert madness", int32_t(0x1E05E0FD), int32_t(0x00000000)},
    {"scm07ea.ini", "inif: desert madness", int32_t(0x1E00E604), int32_t(0x00000000)},
    {"scm08ea.bin", "bin: pitfall", int32_t(0x1E05E0FF), int32_t(0x00000000)},
    {"scm08ea.ini", "inif: pitfall", int32_t(0x1E00E606), int32_t(0x00000000)},
    {"scm09ea.bin", "bin: moosehead barrons", int32_t(0x1E05E101), int32_t(0x00000000)},
    {"scm09ea.ini", "inif: moosehead barrons", int32_t(0x1E00E608), int32_t(0x00000000)},
    {"scm100ea.ini", "inif: tiger core", int32_t(0x910DB6DB), int32_t(0x00000000)},
    {"scm101ea.ini", "inif: terrainspotting", int32_t(0x910DB8DB), int32_t(0x00000000)},
    {"scm102ea.ini", "inif: glenboig", int32_t(0x910DBADB), int32_t(0x00000000)},
    {"scm103ea.ini", "inif: kabalo", int32_t(0x910DBCDB), int32_t(0x00000000)},
    {"scm104ea.ini", "inif: zambezi", int32_t(0x910DBEDB), int32_t(0x00000000)},
    {"scm105ea.ini", "inif: so near so far", int32_t(0x910DC0DB), int32_t(0x00000000)},
    {"scm106ea.ini", "inif: no way out", int32_t(0x910DC2DB), int32_t(0x00000000)},
    {"scm107ea.ini", "inif: tropical storm", int32_t(0x910DC4DB), int32_t(0x00000000)},
    {"scm108ea.ini", "inif: pips ice tea", int32_t(0x910DC6DB), int32_t(0x00000000)},
    {"scm109ea.ini", "inif: pilgrim fathers 2", int32_t(0x910DC8DB), int32_t(0x00000000)},
    {"scm10ea.bin", "bin: red sands", int32_t(0x2205E0EF), int32_t(0x00000000)},
    {"scm10ea.ini", "inif: red sands", int32_t(0x2200E5F6), int32_t(0x00000000)},
    {"scm110ea.ini", "inif: docklands", int32_t(0x910DB6DD), int32_t(0x00000000)},
    {"scm111ea.ini", "inif: eastern seaboard", int32_t(0x910DB8DD), int32_t(0x00000000)},
    {"scm112ea.ini", "inif: hell frozen over", int32_t(0x910DBADD), int32_t(0x00000000)},
    {"scm113ea.ini", "inif: 4 corners", int32_t(0x910DBCDD), int32_t(0x00000000)},
    {"scm114ea.ini", "inif: antartica", int32_t(0x910DBEDD), int32_t(0x00000000)},
    {"scm115ea.ini", "inif: water works", int32_t(0x910DC0DD), int32_t(0x00000000)},
    {"scm116ea.ini", "inif: flood lands", int32_t(0x910DC2DD), int32_t(0x00000000)},
    {"scm117ea.ini", "inif: world map", int32_t(0x910DC4DD), int32_t(0x00000000)},
    {"scm118ea.ini", "inif: all that glitters", int32_t(0x910DC6DD), int32_t(0x00000000)},
    {"scm119ea.ini", "inif: forest under fire", int32_t(0x910DC8DD), int32_t(0x00000000)},
    {"scm11ea.ini", "inif: island hoppers", int32_t(0x2200E5F8), int32_t(0x00000000)},
    {"scm120ea.ini", "inif: island wars 2", int32_t(0x910DB6DF), int32_t(0x00000000)},
    {"scm121ea.ini", "inif: king of the hills", int32_t(0x910DB8DF), int32_t(0x00000000)},
    {"scm122ea.ini", "inif: bullsie", int32_t(0x910DBADF), int32_t(0x00000000)},
    {"scm123ea.ini", "inif: things to come", int32_t(0x910DBCDF), int32_t(0x00000000)},
    {"scm124ea.ini", "inif: polar panic", int32_t(0x910DBEDF), int32_t(0x00000000)},
    {"scm125ea.ini", "inif: barrier to entry", int32_t(0x910DC0DF), int32_t(0x00000000)},
    {"scm126ea.ini", "inif: tundra trouble", int32_t(0x910DC2DF), int32_t(0x00000000)},
    {"scm127ea.ini", "inif: disaster central", int32_t(0x910DC4DF), int32_t(0x00000000)},
    {"scm128ea.ini", "inif: alaska anarchy", int32_t(0x910DC6DF), int32_t(0x00000000)},
    {"scm129ea.ini", "inif: lunar battlefield", int32_t(0x910DC8DF), int32_t(0x00000000)},
    {"scm12ea.ini", "inif: raraku", int32_t(0x2200E5FA), int32_t(0x00000000)},
    {"scm130ea.ini", "inif: lunar battlefield", int32_t(0x910DB6E1), int32_t(0x00000000)},
    {"scm13ea.ini", "inif: central conflict", int32_t(0x2200E5FC), int32_t(0x00000000)},
    {"scm14ea.ini", "inif: combat ally", int32_t(0x2200E5FE), int32_t(0x00000000)},
    {"scm15ea.ini", "inif: island wars", int32_t(0x2200E600), int32_t(0x00000000)},
    {"scm16ea.ini", "inif: desloation", int32_t(0x2200E602), int32_t(0x00000000)},
    {"scm17ea.ini", "inif: no escape", int32_t(0x2200E604), int32_t(0x00000000)},
    {"scm18ea.ini", "inif: no mans land", int32_t(0x2200E606), int32_t(0x00000000)},
    {"scm19ea.ini", "inif: normandy", int32_t(0x2200E608), int32_t(0x00000000)},
    {"scm20ea.ini", "inif: pond skirmish", int32_t(0x2600E5F6), int32_t(0x00000000)},
    {"scm21ea.ini", "inif: ridge war", int32_t(0x2600E5F8), int32_t(0x00000000)},
    {"scm22ea.ini", "inif: a path beyond", int32_t(0x2600E5FA), int32_t(0x00000000)},
    {"scm23ea.ini", "inif: dugout isle", int32_t(0x2600E5FC), int32_t(0x00000000)},
    {"scm24ea.ini", "inif: treasure isle", int32_t(0x2600E5FE), int32_t(0x00000000)},
    {"scm25ea.ini", "inif: bavarian blast", int32_t(0x2600E600), int32_t(0x00000000)},
    {"scm26ea.ini", "inif: undiscovered country", int32_t(0x2600E602), int32_t(0x00000000)},
    {"scm27ea.ini", "inif: tournament hills", int32_t(0x2600E604), int32_t(0x00000000)},
    {"scm28ea.ini", "inif: sleepy valley", int32_t(0x2600E606), int32_t(0x00000000)},
    {"scm29ea.ini", "inif: indirect fire", int32_t(0x2600E608), int32_t(0x00000000)},
    {"scm30ea.ini", "inif: snake river", int32_t(0x2A00E5F6), int32_t(0x00000000)},
    {"scm31ea.ini", "inif: snowy island", int32_t(0x2A00E5F8), int32_t(0x00000000)},
    {"scm32ea.ini", "inif: frostbit fijords", int32_t(0x2A00E5FA), int32_t(0x00000000)},
    {"scm33ea.ini", "inif: czech mate", int32_t(0x2A00E5FC), int32_t(0x00000000)},
    {"scm34ea.ini", "inif: siberian slaughter", int32_t(0x2A00E5FE), int32_t(0x00000000)},
    {"scm35ea.ini", "inif: brother stalin", int32_t(0x2A00E600), int32_t(0x00000000)},
    {"scm36ea.ini", "inif: c&c", int32_t(0x2A00E602), int32_t(0x00000000)},
    {"scm37ea.ini", "inif: d day", int32_t(0x2A00E604), int32_t(0x00000000)},
    {"scm38ea.ini", "inif: land ladder", int32_t(0x2A00E606), int32_t(0x00000000)},
    {"scm39ea.ini", "inif: lotsa larks", int32_t(0x2A00E608), int32_t(0x00000000)},
    {"scm40ea.ini", "inif: mylai delta", int32_t(0x2E00E5F6), int32_t(0x00000000)},
    {"scm41ea.ini", "inif: oz", int32_t(0x2E00E5F8), int32_t(0x00000000)},
    {"scm42ea.ini", "inif: ring of land", int32_t(0x2E00E5FA), int32_t(0x00000000)},
    {"scm43ea.ini", "inif: star", int32_t(0x2E00E5FC), int32_t(0x00000000)},
    {"scm44ea.ini", "inif: united kingdom", int32_t(0x2E00E5FE), int32_t(0x00000000)},
    {"scm45ea.ini", "inif: united states", int32_t(0x2E00E600), int32_t(0x00000000)},
    {"scm46ea.ini", "inif: armourgarden", int32_t(0x2E00E602), int32_t(0x00000000)},
    {"scm47ea.ini", "inif: australia", int32_t(0x2E00E604), int32_t(0x00000000)},
    {"scm48ea.ini", "inif: bearing straits", int32_t(0x2E00E606), int32_t(0x00000000)},
    {"scm49ea.ini", "inif: blow holes", int32_t(0x2E00E608), int32_t(0x00000000)},
    {"scm50ea.bin", "bin: emerald highlands", int32_t(0x3205E0EF), int32_t(0x00000000)},
    {"scm50ea.ini", "inif: emerald highlands", int32_t(0x3200E5F6), int32_t(0x00000000)},
    {"scm51ea.bin", "bin: four corners", int32_t(0x3205E0F1), int32_t(0x00000000)},
    {"scm51ea.ini", "inif: four corners", int32_t(0x3200E5F8), int32_t(0x00000000)},
    {"scm52ea.bin", "bin: cactus valley", int32_t(0x3205E0F3), int32_t(0x00000000)},
    {"scm52ea.ini", "inif: cactus valley", int32_t(0x3200E5FA), int32_t(0x00000000)},
    {"scm53ea.ini", "inif: camos crossing", int32_t(0x3200E5FC), int32_t(0x00000000)},
    {"scm54ea.ini", "inif: camos cross", int32_t(0x3200E5FE), int32_t(0x00000000)},
    {"scm55ea.ini", "inif: canyon river", int32_t(0x3200E600), int32_t(0x00000000)},
    {"scm56ea.ini", "inif: east coast", int32_t(0x3200E602), int32_t(0x00000000)},
    {"scm57ea.ini", "inif: fjords", int32_t(0x3200E604), int32_t(0x00000000)},
    {"scm58ea.ini", "inif: india", int32_t(0x3200E606), int32_t(0x00000000)},
    {"scm59ea.ini", "inif: italy", int32_t(0x3200E608), int32_t(0x00000000)},
    {"scm60ea.bin", "bin: monkey in the middle", int32_t(0x3605E0EF), int32_t(0x00000000)},
    {"scm60ea.ini", "inif: monkey in the middle", int32_t(0x3600E5F6), int32_t(0x00000000)},
    {"scm61ea.bin", "bin: king of the mountain", int32_t(0x3605E0F1), int32_t(0x00000000)},
    {"scm61ea.ini", "inif: king of the mountain", int32_t(0x3600E5F8), int32_t(0x00000000)},
    {"scm62ea.bin", "bin: surgical incision", int32_t(0x3605E0F3), int32_t(0x00000000)},
    {"scm62ea.ini", "inif: surgical incision", int32_t(0x3600E5FA), int32_t(0x00000000)},
    {"scm63ea.ini", "inif: malibu fields", int32_t(0x3600E5FC), int32_t(0x00000000)},
    {"scm64ea.ini", "inif: marshland", int32_t(0x3600E5FE), int32_t(0x00000000)},
    {"scm65ea.ini", "inif: the mississippi", int32_t(0x3600E600), int32_t(0x00000000)},
    {"scm66ea.ini", "inif: normandy landings", int32_t(0x3600E602), int32_t(0x00000000)},
    {"scm67ea.ini", "inif: ore wars", int32_t(0x3600E604), int32_t(0x00000000)},
    {"scm68ea.ini", "inif: ponds", int32_t(0x3600E606), int32_t(0x00000000)},
    {"scm69ea.ini", "inif: putney", int32_t(0x3600E608), int32_t(0x00000000)},
    {"scm70ea.bin", "bin: winter waterland", int32_t(0x3A05E0EF), int32_t(0x00000000)},
    {"scm70ea.ini", "inif: winter waterland", int32_t(0x3A00E5F6), int32_t(0x00000000)},
    {"scm71ea.bin", "bin: one pass fits all", int32_t(0x3A05E0F1), int32_t(0x00000000)},
    {"scm71ea.ini", "inif: one pass fits all", int32_t(0x3A00E5F8), int32_t(0x00000000)},
    {"scm72ea.bin", "bin: straight and narrow", int32_t(0x3A05E0F3), int32_t(0x00000000)},
    {"scm72ea.ini", "inif: straight and narrow", int32_t(0x3A00E5FA), int32_t(0x00000000)},
    {"scm73ea.bin", "bin: king takes pawn", int32_t(0x3A05E0F5), int32_t(0x00000000)},
    {"scm73ea.ini", "inif: king takes pawn", int32_t(0x3A00E5FC), int32_t(0x00000000)},
    {"scm74ea.bin", "bin: nowhere to hide", int32_t(0x3A05E0F7), int32_t(0x00000000)},
    {"scm74ea.ini", "inif: nowhere to hide", int32_t(0x3A00E5FE), int32_t(0x00000000)},
    {"scm75ea.bin", "bin: vilage of the unfortunate", int32_t(0x3A05E0F9), int32_t(0x00000000)},
    {"scm75ea.ini", "inif: vilage of the unfortunate", int32_t(0x3A00E600), int32_t(0x00000000)},
    {"scm76ea.ini", "inif: snowball fight", int32_t(0x3A00E602), int32_t(0x00000000)},
    {"scm77ea.bin", "bin: marooned", int32_t(0x3A05E0FD), int32_t(0x00000000)},
    {"scm77ea.ini", "inif: marooned", int32_t(0x3A00E604), int32_t(0x00000000)},
    {"scm78ea.ini", "inif: spring line", int32_t(0x3A00E606), int32_t(0x00000000)},
    {"scm79ea.ini", "inif: straighter and narrower", int32_t(0x3A00E608), int32_t(0x00000000)},
    {"scm80ea.ini", "inif: the bay", int32_t(0x3E00E5F6), int32_t(0x00000000)},
    {"scm81ea.ini", "inif: the great lakes", int32_t(0x3E00E5F8), int32_t(0x00000000)},
    {"scm82ea.ini", "inif: the linked lands", int32_t(0x3E00E5FA), int32_t(0x00000000)},
    {"scm83ea.ini", "inif: the valley", int32_t(0x3E00E5FC), int32_t(0x00000000)},
    {"scm84ea.ini", "inif: to the core", int32_t(0x3E00E5FE), int32_t(0x00000000)},
    {"scm85ea.ini", "inif: volcano", int32_t(0x3E00E600), int32_t(0x00000000)},
    {"scm86ea.ini", "inif: wastelands", int32_t(0x3E00E602), int32_t(0x00000000)},
    {"scm87ea.ini", "inif: apres peace", int32_t(0x3E00E604), int32_t(0x00000000)},
    {"scm88ea.ini", "inif: return to zion", int32_t(0x3E00E606), int32_t(0x00000000)},
    {"scm89ea.ini", "inif: africa", int32_t(0x3E00E608), int32_t(0x00000000)},
    {"scm90ea.bin", "bin: a long way from home", int32_t(0x4205E0EF), int32_t(0x00000000)},
    {"scm90ea.ini", "inif: a long way from home", int32_t(0x4200E5F6), int32_t(0x00000000)},
    {"scm91ea.ini", "inif: the ice arena", int32_t(0x4200E5F8), int32_t(0x00000000)},
    {"scm92ea.ini", "inif: the lake district", int32_t(0x4200E5FA), int32_t(0x00000000)},
    {"scm93ea.ini", "inif: the woods today", int32_t(0x4200E5FC), int32_t(0x00000000)},
    {"scm94ea.ini", "inif: be shore", int32_t(0x4200E5FE), int32_t(0x00000000)},
    {"scm95ea.ini", "inif: the garden", int32_t(0x4200E600), int32_t(0x00000000)},
    {"scm96ea.bin", "bin: tiberium garden", int32_t(0x4205E0FB), int32_t(0x00000000)},
    {"scm96ea.ini", "inif: tiberium garden", int32_t(0x4200E602), int32_t(0x00000000)},
    {"scm97ea.bin", "bin: northern explosion", int32_t(0x4205E0FD), int32_t(0x00000000)},
    {"scm97ea.ini", "inif: northern explosion", int32_t(0x4200E604), int32_t(0x00000000)},
    {"scm98ea.bin", "bin: diverse reigon", int32_t(0x4205E0FF), int32_t(0x00000000)},
    {"scm98ea.ini", "inif: diverse reigon", int32_t(0x4200E606), int32_t(0x00000000)},
    {"scm99ea.ini", "inif: finger lake", int32_t(0x4200E608), int32_t(0x00000000)},
    {"scmd0ea.ini", "inif: around the rim", int32_t(0x6E00E5F6), int32_t(0x00000000)},
    {"scmd1ea.ini", "inif: conflict cove", int32_t(0x6E00E5F8), int32_t(0x00000000)},
    {"scmd2ea.ini", "inif: elysium", int32_t(0x6E00E5FA), int32_t(0x00000000)},
    {"scmd3ea.ini", "inif: gettysburg", int32_t(0x6E00E5FC), int32_t(0x00000000)},
    {"scmd4ea.ini", "inif: glacial valley", int32_t(0x6E00E5FE), int32_t(0x00000000)},
    {"scmd5ea.ini", "inif: hadyes frosen over", int32_t(0x6E00E600), int32_t(0x00000000)},
    {"scmd6ea.ini", "inif: hastings", int32_t(0x6E00E602), int32_t(0x00000000)},
    {"scmd7ea.ini", "inif: lepizip", int32_t(0x6E00E604), int32_t(0x00000000)},
    {"scmd8ea.ini", "inif: river crossing", int32_t(0x6E00E606), int32_t(0x00000000)},
    {"scmd9ea.ini", "inif: snow garden", int32_t(0x6E00E608), int32_t(0x00000000)},
    {"scme0ea.ini", "inif: stalingrad", int32_t(0x7200E5F6), int32_t(0x00000000)},
    {"scme1ea.ini", "inif: the buldge", int32_t(0x7200E5F8), int32_t(0x00000000)},
    {"scme2ea.ini", "inif: twin rivers", int32_t(0x7200E5FA), int32_t(0x00000000)},
    {"scme3ea.ini", "inif: warlords lake", int32_t(0x7200E5FC), int32_t(0x00000000)},
    {"scme4ea.ini", "inif: zama", int32_t(0x7200E5FE), int32_t(0x00000000)},
    {"scme5ea.ini", "inif: badajoz", int32_t(0x7200E600), int32_t(0x00000000)},
    {"scme6ea.ini", "inif: cold front", int32_t(0x7200E602), int32_t(0x00000000)},
    {"scme7ea.ini", "inif: cold pass", int32_t(0x7200E604), int32_t(0x00000000)},
    {"scme8ea.ini", "inif: culloden moor", int32_t(0x7200E606), int32_t(0x00000000)},
    {"scme9ea.ini", "inif: frozen valley", int32_t(0x7200E608), int32_t(0x00000000)},
    {"scmf0ea.ini", "inif: gold coast", int32_t(0x7600E5F6), int32_t(0x00000000)},
    {"scmf1ea.ini", "inif: hells pass", int32_t(0x7600E5F8), int32_t(0x00000000)},
    {"scmf2ea.ini", "inif: iceberg", int32_t(0x7600E5FA), int32_t(0x00000000)},
    {"scmf3ea.ini", "inif: in the sun", int32_t(0x7600E5FC), int32_t(0x00000000)},
    {"scmf4ea.ini", "inif: islands", int32_t(0x7600E5FE), int32_t(0x00000000)},
    {"scmf5ea.ini", "inif: kananga", int32_t(0x7600E600), int32_t(0x00000000)},
    {"scmf6ea.ini", "inif: lanes", int32_t(0x7600E602), int32_t(0x00000000)},
    {"scmf7ea.ini", "inif: mekong", int32_t(0x7600E604), int32_t(0x00000000)},
    {"scmf8ea.ini", "inif: middle ground", int32_t(0x7600E606), int32_t(0x00000000)},
    {"scmf9ea.ini", "inif: on your marks", int32_t(0x7600E608), int32_t(0x00000000)},
    {"scmg0ea.ini", "inif: puddles", int32_t(0x7A00E5F6), int32_t(0x00000000)},
    {"scmg1ea.ini", "inif: revenge", int32_t(0x7A00E5F8), int32_t(0x00000000)},
    {"scmg2ea.ini", "inif: seaside", int32_t(0x7A00E5FA), int32_t(0x00000000)},
    {"scmg3ea.ini", "inif: shades", int32_t(0x7A00E5FC), int32_t(0x00000000)},
    {"scmg4ea.ini", "inif: sticks and stones", int32_t(0x7A00E5FE), int32_t(0x00000000)},
    {"scmg5ea.ini", "inif: switch", int32_t(0x7A00E600), int32_t(0x00000000)},
    {"scmg6ea.ini", "inif: the boyne", int32_t(0x7A00E602), int32_t(0x00000000)},
    {"scmg7ea.ini", "inif: the keyes", int32_t(0x7A00E604), int32_t(0x00000000)},
    {"scmg8ea.ini", "inif: the lakes", int32_t(0x7A00E606), int32_t(0x00000000)},
    {"scmg9ea.ini", "inif: the neck", int32_t(0x7A00E608), int32_t(0x00000000)},
    {"scmh0ea.ini", "inif: a pattern of islands", int32_t(0x7E00E5F6), int32_t(0x00000000)},
    {"scmh1ea.ini", "inif: ashes to ashes", int32_t(0x7E00E5F8), int32_t(0x00000000)},
    {"scmh2ea.ini", "inif: baptisim of fire", int32_t(0x7E00E5FA), int32_t(0x00000000)},
    {"scmh3ea.ini", "inif: big fish small pond", int32_t(0x7E00E5FC), int32_t(0x00000000)},
    {"scmh4ea.ini", "inif: bridge head", int32_t(0x7E00E5FE), int32_t(0x00000000)},
    {"scmh5ea.ini", "inif: bridge head", int32_t(0x7E00E600), int32_t(0x00000000)},
    {"scmh6ea.ini", "inif: butterfly bay", int32_t(0x7E00E602), int32_t(0x00000000)},
    {"scmh7ea.ini", "inif: equal shares", int32_t(0x7E00E604), int32_t(0x00000000)},
    {"scmh8ea.ini", "inif: gold rush", int32_t(0x7E00E606), int32_t(0x00000000)},
    {"scmh9ea.ini", "inif: habitat", int32_t(0x7E00E608), int32_t(0x00000000)},
    {"scmi0ea.ini", "inif: ice queen", int32_t(0x8200E5F6), int32_t(0x00000000)},
    {"scmi1ea.ini", "inif: ice station", int32_t(0x8200E5F8), int32_t(0x00000000)},
    {"scmi2ea.ini", "inif: island platau", int32_t(0x8200E5FA), int32_t(0x00000000)},
    {"scmi3ea.ini", "inif: lakeland", int32_t(0x8200E5FC), int32_t(0x00000000)},
    {"scmi4ea.ini", "inif: land locked", int32_t(0x8200E5FE), int32_t(0x00000000)},
    {"scmi5ea.ini", "inif: meander", int32_t(0x8200E600), int32_t(0x00000000)},
    {"scmi6ea.ini", "inif: ore garden", int32_t(0x8200E602), int32_t(0x00000000)},
    {"scmi7ea.ini", "inif: rias", int32_t(0x8200E604), int32_t(0x00000000)},
    {"scmi8ea.ini", "inif: river rapids", int32_t(0x8200E606), int32_t(0x00000000)},
    {"scmi9ea.ini", "inif: rorkes drift", int32_t(0x8200E608), int32_t(0x00000000)},
    {"scmj0ea.ini", "inif: smugglers cove", int32_t(0x8600E5F6), int32_t(0x00000000)},
    {"scmj1ea.ini", "inif: strathearn valley", int32_t(0x8600E5F8), int32_t(0x00000000)},
    {"scmj2ea.ini", "inif: the cauldren", int32_t(0x8600E5FA), int32_t(0x00000000)},
    {"scmj3ea.ini", "inif: the finger", int32_t(0x8600E5FC), int32_t(0x00000000)},
    {"scmj4ea.ini", "inif: the web", int32_t(0x8600E5FE), int32_t(0x00000000)},
    {"scmj5ea.ini", "inif: to the core", int32_t(0x8600E600), int32_t(0x00000000)},
    {"scmj6ea.ini", "inif: trafalger", int32_t(0x8600E602), int32_t(0x00000000)},
    {"scmj7ea.ini", "inif: umboto gorge", int32_t(0x8600E604), int32_t(0x00000000)},
    {"scmj8ea.ini", "inif: waterfalls", int32_t(0x8600E606), int32_t(0x00000000)},
    {"scmj9ea.ini", "inif: waterloo revisited", int32_t(0x8600E608), int32_t(0x00000000)},
    {"scmk0ea.ini", "inif: arena valley", int32_t(0x8A00E5F6), int32_t(0x00000000)},
    {"scmk1ea.ini", "inif: arctic wasteland", int32_t(0x8A00E5F8), int32_t(0x00000000)},
    {"scmk2ea.ini", "inif: booby traps", int32_t(0x8A00E5FA), int32_t(0x00000000)},
    {"scmk3ea.ini", "inif: central conflict", int32_t(0x8A00E5FC), int32_t(0x00000000)},
    {"scmk4ea.ini", "inif: circles of death", int32_t(0x8A00E5FE), int32_t(0x00000000)},
    {"scmk5ea.ini", "inif: combat zones", int32_t(0x8A00E600), int32_t(0x00000000)},
    {"scmk6ea.ini", "inif: damnation alley", int32_t(0x8A00E602), int32_t(0x00000000)},
    {"scmk7ea.ini", "inif: death valley", int32_t(0x8A00E604), int32_t(0x00000000)},
    {"scmk8ea.ini", "inif: deep six", int32_t(0x8A00E606), int32_t(0x00000000)},
    {"scmk9ea.ini", "inif: destruction derby", int32_t(0x8A00E608), int32_t(0x00000000)},
    {"scml0ea.ini", "inif: diamonds arnt forever", int32_t(0x8E00E5F6), int32_t(0x00000000)},
    {"scml1ea.ini", "inif: frostbitten", int32_t(0x8E00E5F8), int32_t(0x00000000)},
    {"scml2ea.ini", "inif: hamburger hill", int32_t(0x8E00E5FA), int32_t(0x00000000)},
    {"scml3ea.ini", "inif: holy grounds", int32_t(0x8E00E5FC), int32_t(0x00000000)},
    {"scml4ea.ini", "inif: innocents", int32_t(0x8E00E5FE), int32_t(0x00000000)},
    {"scml5ea.ini", "inif: island wars", int32_t(0x8E00E600), int32_t(0x00000000)},
    {"scml6ea.ini", "inif: king of the hills", int32_t(0x8E00E602), int32_t(0x00000000)},
    {"scml7ea.ini", "inif: naval conquests", int32_t(0x8E00E604), int32_t(0x00000000)},
    {"scml8ea.ini", "inif: open warfare", int32_t(0x8E00E606), int32_t(0x00000000)},
    {"scml9ea.ini", "inif: potholes", int32_t(0x8E00E608), int32_t(0x00000000)},
    {"scmm0ea.ini", "inif: random violence", int32_t(0x9200E5F6), int32_t(0x00000000)},
    {"scmm1ea.ini", "inif: river rampage", int32_t(0x9200E5F8), int32_t(0x00000000)},
    {"scmm2ea.ini", "inif: rivers wild", int32_t(0x9200E5FA), int32_t(0x00000000)},
    {"scmm3ea.ini", "inif: super bridgehead", int32_t(0x9200E5FC), int32_t(0x00000000)},
    {"scmm4ea.ini", "inif: super mekong", int32_t(0x9200E5FE), int32_t(0x00000000)},
    {"scmm5ea.ini", "inif: super ore garden", int32_t(0x9200E600), int32_t(0x00000000)},
    {"scmm6ea.ini", "inif: the berg", int32_t(0x9200E602), int32_t(0x00000000)},
    {"scmm7ea.ini", "inif: the hills have eyes", int32_t(0x9200E604), int32_t(0x00000000)},
    {"scmm8ea.ini", "inif: watch your step", int32_t(0x9200E606), int32_t(0x00000000)},
    {"scmm9ea.ini", "inif: water werks", int32_t(0x9200E608), int32_t(0x00000000)},
    {"scold.aud", "", int32_t(0xDBBF6A19), int32_t(0x00000000)},
    {"scold1.aud", "???", int32_t(0xB399B42A), int32_t(0x00000000)},
    {"scold2.aud", "???", int32_t(0xB399B62A), int32_t(0x00000000)},
    {"scold2.juv", "???", int32_t(0xC599C82A), int32_t(0x00000000)},
    {"scold8.aud", "cant push button sound", int32_t(0x00000000), int32_t(0xE494B2AB)},
    {"scoldsfx.aud", "", int32_t(0x00000000), int32_t(0xC1CDDC67)},
    {"scoldy1.aud", "map sound #9", int32_t(0x8DE41516), int32_t(0x00000000)},
    {"scomnd1.aud", "spy: commander?", int32_t(0x91E3EB2A), int32_t(0x00000000)},
    {"score.aud", "mission accomplished tune", int32_t(0xF3BF6A1B), int32_t(0x7697B94F)},
    {"score.pal", "pal: score", int32_t(0xCBDD6A23), int32_t(0x00000000)},
    {"score.pcx", "-", int32_t(0x00000000), int32_t(0xB904E366)},
    {"score.tre", "", int32_t(0xEDE56A1C), int32_t(0x00000000)},
    {"score.trf", "", int32_t(0xEDE56A1D), int32_t(0x00000000)},
    {"score.trg", "", int32_t(0xEDE56A1E), int32_t(0x00000000)},
    {"score.tri", "", int32_t(0xEDE56A20), int32_t(0x00000000)},
    {"score.trs", "", int32_t(0xEDE56A2A), int32_t(0x00000000)},
    {"score.vqa", "", int32_t(0xEBE96A18), int32_t(0xA707DD54)},
    {"scorefnt.fnt", "score", int32_t(0x4627E005), int32_t(0x00000000)},
    {"scorers.dat", "", int32_t(0xA637F31B), int32_t(0x00000000)},
    {"scorers.tre", "", int32_t(0xA629042B), int32_t(0x00000000)},
    {"scorers.trf", "", int32_t(0xA62A042B), int32_t(0x00000000)},
    {"scorers.trg", "", int32_t(0xA62B042B), int32_t(0x00000000)},
    {"scorers.tri", "", int32_t(0xA62D042B), int32_t(0x00000000)},
    {"scorers.trs", "", int32_t(0xA637042B), int32_t(0x00000000)},
    {"scores.inf", "inf: list for scores.mix", int32_t(0xDB99FA25), int32_t(0x00000000)},
    {"scores.mix", "scores.mix", int32_t(0xE39A0C20), int32_t(0x00000000)},
    {"scorex.wav", "", int32_t(0x00000000), int32_t(0xF22966BA)},
    {"scorpal1.pal", "pal: ???", int32_t(0xF816E01B), int32_t(0x00000000)},
    {"scout.aud", "scout", int32_t(0x00000000), int32_t(0xA2E7E533)},
    {"scrate.shp", "steel crate", int32_t(0xABA5E83D), int32_t(0x00000000)},
    {"screen0.bmp", "", int32_t(0x00000000), int32_t(0x3351F7EE)},
    {"screen01.bmp", "", int32_t(0xC7F6EC05), int32_t(0xA6439469)},
    {"screen02.bmp", "", int32_t(0xC9F6EC05), int32_t(0xE1E3EEB9)},
    {"screen03.bmp", "", int32_t(0xCBF6EC05), int32_t(0xDC83C709)},
    {"screen04.bmp", "", int32_t(0xCDF6EC05), int32_t(0x6EA31B19)},
    {"screen05.bmp", "", int32_t(0xCFF6EC05), int32_t(0x53C332A9)},
    {"screen06.bmp", "", int32_t(0xD1F6EC05), int32_t(0x14634879)},
    {"screen09.bmp", "", int32_t(0xD7F6EC05), int32_t(0x9633DFA8)},
    {"screen1.bmp", "", int32_t(0x00000000), int32_t(0xF80D244B)},
    {"screen2b.bmp", "", int32_t(0x00000000), int32_t(0x55F9AF7D)},
    {"screen3a.bmp", "", int32_t(0x00000000), int32_t(0xD9050608)},
    {"screen3b.bmp", "", int32_t(0x00000000), int32_t(0x9EA57CD8)},
    {"scrin.hva", "-", int32_t(0x00000000), int32_t(0x8D54A80D)},
    {"scrin.vxl", "banshee fighter", int32_t(0x00000000), int32_t(0x32CDAFAA)},
    {"scrin01.des", "", int32_t(0x00000000), int32_t(0xFF513DD8)},
    {"scrin01.tem", "-", int32_t(0x00000000), int32_t(0x7B095598)},
    {"scrin02.des", "", int32_t(0x00000000), int32_t(0x79C54F76)},
    {"scrin02.tem", "-", int32_t(0x00000000), int32_t(0xFD9D2736)},
    {"scrin03.des", "", int32_t(0x00000000), int32_t(0xB2999CD3)},
    {"scrin03.tem", "-", int32_t(0x00000000), int32_t(0x36C1F493)},
    {"scrin04.des", "", int32_t(0x00000000), int32_t(0xAF9CAC6B)},
    {"scrin04.tem", "-", int32_t(0x00000000), int32_t(0x2BC4C42B)},
    {"scrin05.des", "", int32_t(0x00000000), int32_t(0x64C07FCE)},
    {"scrin05.tem", "-", int32_t(0x00000000), int32_t(0xE098178E)},
    {"scrin06.des", "", int32_t(0x00000000), int32_t(0xE2540D60)},
    {"scrin06.tem", "-", int32_t(0x00000000), int32_t(0x660C6520)},
    {"scrin5b.aud", "banshee fires", int32_t(0x00000000), int32_t(0x0EA4BAC4)},
    {"scrnsh00.pcx", "", int32_t(0xF1ECEE21), int32_t(0x00000000)},
    {"scrolinv.aud", "", int32_t(0x2E3AE113), int32_t(0x00000000)},
    {"scrscn1.wsa", "anim: nod score screen", int32_t(0xA9ECFD2A), int32_t(0x00000000)},
    {"scs00ea.bin", "", int32_t(0x1E1DE0EF), int32_t(0x00000000)},
    {"scs00ea.ini", "", int32_t(0x1E18E5F6), int32_t(0x00000000)},
    {"scs01ea.bin", "", int32_t(0x1E1DE0F1), int32_t(0x00000000)},
    {"scs01ea.ini", "", int32_t(0x1E18E5F8), int32_t(0x00000000)},
    {"scs02ea.bin", "", int32_t(0x1E1DE0F3), int32_t(0x00000000)},
    {"scs02ea.ini", "", int32_t(0x1E18E5FA), int32_t(0x00000000)},
    {"scs03ea.bin", "", int32_t(0x1E1DE0F5), int32_t(0x00000000)},
    {"scs03ea.ini", "", int32_t(0x1E18E5FC), int32_t(0x00000000)},
    {"scs04ea.bin", "", int32_t(0x1E1DE0F7), int32_t(0x00000000)},
    {"scs04ea.ini", "", int32_t(0x1E18E5FE), int32_t(0x00000000)},
    {"scs05ea.bin", "", int32_t(0x1E1DE0F9), int32_t(0x00000000)},
    {"scs05ea.ini", "", int32_t(0x1E18E600), int32_t(0x00000000)},
    {"scs06ea.bin", "", int32_t(0x1E1DE0FB), int32_t(0x00000000)},
    {"scs06ea.ini", "", int32_t(0x1E18E602), int32_t(0x00000000)},
    {"scs07ea.bin", "", int32_t(0x1E1DE0FD), int32_t(0x00000000)},
    {"scs07ea.ini", "", int32_t(0x1E18E604), int32_t(0x00000000)},
    {"scs08ea.bin", "", int32_t(0x1E1DE0FF), int32_t(0x00000000)},
    {"scs08ea.ini", "", int32_t(0x1E18E606), int32_t(0x00000000)},
    {"scs09ea.bin", "", int32_t(0x1E1DE101), int32_t(0x00000000)},
    {"scs09ea.ini", "", int32_t(0x1E18E608), int32_t(0x00000000)},
    {"scs10ea.bin", "", int32_t(0x221DE0EF), int32_t(0x00000000)},
    {"scs10ea.ini", "", int32_t(0x2218E5F6), int32_t(0x00000000)},
    {"scs11ea.bin", "", int32_t(0x221DE0F1), int32_t(0x00000000)},
    {"scs11ea.ini", "", int32_t(0x2218E5F8), int32_t(0x00000000)},
    {"scs12ea.bin", "", int32_t(0x221DE0F3), int32_t(0x00000000)},
    {"scs12ea.ini", "", int32_t(0x2218E5FA), int32_t(0x00000000)},
    {"scs13ea.bin", "", int32_t(0x221DE0F5), int32_t(0x00000000)},
    {"scs13ea.ini", "", int32_t(0x2218E5FC), int32_t(0x00000000)},
    {"scs14ea.bin", "", int32_t(0x221DE0F7), int32_t(0x00000000)},
    {"scs14ea.ini", "", int32_t(0x2218E5FE), int32_t(0x00000000)},
    {"scs15ea.bin", "", int32_t(0x221DE0F9), int32_t(0x00000000)},
    {"scs15ea.ini", "", int32_t(0x2218E600), int32_t(0x00000000)},
    {"scs16ea.bin", "", int32_t(0x221DE0FB), int32_t(0x00000000)},
    {"scs16ea.ini", "", int32_t(0x2218E602), int32_t(0x00000000)},
    {"scs17ea.bin", "", int32_t(0x221DE0FD), int32_t(0x00000000)},
    {"scs17ea.ini", "", int32_t(0x2218E604), int32_t(0x00000000)},
    {"scs18ea.bin", "", int32_t(0x221DE0FF), int32_t(0x00000000)},
    {"scs18ea.ini", "", int32_t(0x2218E606), int32_t(0x00000000)},
    {"scs19ea.bin", "", int32_t(0x221DE101), int32_t(0x00000000)},
    {"scs19ea.ini", "", int32_t(0x2218E608), int32_t(0x00000000)},
    {"scs20ea.bin", "", int32_t(0x261DE0EF), int32_t(0x00000000)},
    {"scs20ea.ini", "", int32_t(0x2618E5F6), int32_t(0x00000000)},
    {"scs21ea.bin", "", int32_t(0x261DE0F1), int32_t(0x00000000)},
    {"scs21ea.ini", "", int32_t(0x2618E5F8), int32_t(0x00000000)},
    {"scs22ea.bin", "", int32_t(0x261DE0F3), int32_t(0x00000000)},
    {"scs22ea.ini", "", int32_t(0x2618E5FA), int32_t(0x00000000)},
    {"scs23ea.bin", "", int32_t(0x261DE0F5), int32_t(0x00000000)},
    {"scs23ea.ini", "", int32_t(0x2618E5FC), int32_t(0x00000000)},
    {"scs24ea.bin", "", int32_t(0x261DE0F7), int32_t(0x00000000)},
    {"scs24ea.ini", "", int32_t(0x2618E5FE), int32_t(0x00000000)},
    {"scs25ea.bin", "", int32_t(0x261DE0F9), int32_t(0x00000000)},
    {"scs25ea.ini", "", int32_t(0x2618E600), int32_t(0x00000000)},
    {"scs26ea.bin", "", int32_t(0x261DE0FB), int32_t(0x00000000)},
    {"scs26ea.ini", "", int32_t(0x2618E602), int32_t(0x00000000)},
    {"scs27ea.bin", "", int32_t(0x261DE0FD), int32_t(0x00000000)},
    {"scs27ea.ini", "", int32_t(0x2618E604), int32_t(0x00000000)},
    {"scs28ea.bin", "", int32_t(0x261DE0FF), int32_t(0x00000000)},
    {"scs28ea.ini", "", int32_t(0x2618E606), int32_t(0x00000000)},
    {"scs29ea.bin", "", int32_t(0x261DE101), int32_t(0x00000000)},
    {"scs29ea.ini", "", int32_t(0x2618E608), int32_t(0x00000000)},
    {"scs30ea.bin", "", int32_t(0x2A1DE0EF), int32_t(0x00000000)},
    {"scs30ea.ini", "", int32_t(0x2A18E5F6), int32_t(0x00000000)},
    {"scs31ea.bin", "", int32_t(0x2A1DE0F1), int32_t(0x00000000)},
    {"scs31ea.ini", "", int32_t(0x2A18E5F8), int32_t(0x00000000)},
    {"scs32ea.bin", "", int32_t(0x2A1DE0F3), int32_t(0x00000000)},
    {"scs32ea.ini", "", int32_t(0x2A18E5FA), int32_t(0x00000000)},
    {"scs33ea.bin", "", int32_t(0x2A1DE0F5), int32_t(0x00000000)},
    {"scs33ea.ini", "", int32_t(0x2A18E5FC), int32_t(0x00000000)},
    {"scs34ea.bin", "", int32_t(0x2A1DE0F7), int32_t(0x00000000)},
    {"scs34ea.ini", "", int32_t(0x2A18E5FE), int32_t(0x00000000)},
    {"scs35ea.bin", "", int32_t(0x2A1DE0F9), int32_t(0x00000000)},
    {"scs35ea.ini", "", int32_t(0x2A18E600), int32_t(0x00000000)},
    {"scs36ea.bin", "", int32_t(0x2A1DE0FB), int32_t(0x00000000)},
    {"scs36ea.ini", "", int32_t(0x2A18E602), int32_t(0x00000000)},
    {"scs37ea.bin", "", int32_t(0x2A1DE0FD), int32_t(0x00000000)},
    {"scs37ea.ini", "", int32_t(0x2A18E604), int32_t(0x00000000)},
    {"scs38ea.bin", "", int32_t(0x2A1DE0FF), int32_t(0x00000000)},
    {"scs38ea.ini", "", int32_t(0x2A18E606), int32_t(0x00000000)},
    {"scs39ea.bin", "", int32_t(0x2A1DE101), int32_t(0x00000000)},
    {"scs39ea.ini", "", int32_t(0x2A18E608), int32_t(0x00000000)},
    {"scs40ea.bin", "", int32_t(0x2E1DE0EF), int32_t(0x00000000)},
    {"scs40ea.ini", "", int32_t(0x2E18E5F6), int32_t(0x00000000)},
    {"scs41ea.bin", "", int32_t(0x2E1DE0F1), int32_t(0x00000000)},
    {"scs41ea.ini", "", int32_t(0x2E18E5F8), int32_t(0x00000000)},
    {"scs42ea.bin", "", int32_t(0x2E1DE0F3), int32_t(0x00000000)},
    {"scs42ea.ini", "", int32_t(0x2E18E5FA), int32_t(0x00000000)},
    {"scs43ea.bin", "", int32_t(0x2E1DE0F5), int32_t(0x00000000)},
    {"scs43ea.ini", "", int32_t(0x2E18E5FC), int32_t(0x00000000)},
    {"scs44ea.bin", "", int32_t(0x2E1DE0F7), int32_t(0x00000000)},
    {"scs44ea.ini", "", int32_t(0x2E18E5FE), int32_t(0x00000000)},
    {"scs45ea.bin", "", int32_t(0x2E1DE0F9), int32_t(0x00000000)},
    {"scs45ea.ini", "", int32_t(0x2E18E600), int32_t(0x00000000)},
    {"scs46ea.bin", "", int32_t(0x2E1DE0FB), int32_t(0x00000000)},
    {"scs46ea.ini", "", int32_t(0x2E18E602), int32_t(0x00000000)},
    {"scs47ea.bin", "", int32_t(0x2E1DE0FD), int32_t(0x00000000)},
    {"scs47ea.ini", "", int32_t(0x2E18E604), int32_t(0x00000000)},
    {"scs48ea.bin", "", int32_t(0x2E1DE0FF), int32_t(0x00000000)},
    {"scs48ea.ini", "", int32_t(0x2E18E606), int32_t(0x00000000)},
    {"scs49ea.bin", "", int32_t(0x2E1DE101), int32_t(0x00000000)},
    {"scs49ea.ini", "", int32_t(0x2E18E608), int32_t(0x00000000)},
    {"scs50ea.bin", "", int32_t(0x321DE0EF), int32_t(0x00000000)},
    {"scs50ea.ini", "", int32_t(0x3218E5F6), int32_t(0x00000000)},
    {"scs51ea.bin", "", int32_t(0x321DE0F1), int32_t(0x00000000)},
    {"scs51ea.ini", "", int32_t(0x3218E5F8), int32_t(0x00000000)},
    {"scs60ea.bin", "", int32_t(0x361DE0EF), int32_t(0x00000000)},
    {"scs60ea.ini", "", int32_t(0x3618E5F6), int32_t(0x00000000)},
    {"scs61ea.bin", "", int32_t(0x361DE0F1), int32_t(0x00000000)},
    {"scs61ea.ini", "", int32_t(0x3618E5F8), int32_t(0x00000000)},
    {"scs62ea.bin", "", int32_t(0x361DE0F3), int32_t(0x00000000)},
    {"scs62ea.ini", "", int32_t(0x3618E5FA), int32_t(0x00000000)},
    {"scs63ea.bin", "", int32_t(0x361DE0F5), int32_t(0x00000000)},
    {"scs63ea.ini", "", int32_t(0x3618E5FC), int32_t(0x00000000)},
    {"scu01ea.ini", "inif: soviet mission 1", int32_t(0x1E20E5F8), int32_t(0x00000000)},
    {"scu01eb.ini", "", int32_t(0x1E22E5F8), int32_t(0x00000000)},
    {"scu02ea.ini", "inif: soviet mission 2", int32_t(0x1E20E5FA), int32_t(0x00000000)},
    {"scu02eb.ini", "inif: soviet mission 2b", int32_t(0x1E22E5FA), int32_t(0x00000000)},
    {"scu03ea.ini", "inif: soviet mission 3", int32_t(0x1E20E5FC), int32_t(0x00000000)},
    {"scu04ea.ini", "inif: soviet mission 4", int32_t(0x1E20E5FE), int32_t(0x00000000)},
    {"scu04eb.ini", "inif: soviet mission 4b", int32_t(0x1E22E5FE), int32_t(0x00000000)},
    {"scu05ea.ini", "inif: soviet mission 5", int32_t(0x1E20E600), int32_t(0x00000000)},
    {"scu06ea.ini", "inif: soviet mission 6", int32_t(0x1E20E602), int32_t(0x00000000)},
    {"scu06eb.ini", "inif: soviet mission 6b", int32_t(0x1E22E602), int32_t(0x00000000)},
    {"scu07ea.ini", "inif: soviet mission 7", int32_t(0x1E20E604), int32_t(0x00000000)},
    {"scu08ea.ini", "inif: soviet mission 8", int32_t(0x1E20E606), int32_t(0x00000000)},
    {"scu08eb.ini", "inif: soviet mission 8b", int32_t(0x1E22E606), int32_t(0x00000000)},
    {"scu09ea.ini", "inif: soviet mission 9", int32_t(0x1E20E608), int32_t(0x00000000)},
    {"scu10ea.ini", "inif: soviet mission 10", int32_t(0x2220E5F6), int32_t(0x00000000)},
    {"scu11ea.ini", "inif: soviet mission 11", int32_t(0x2220E5F8), int32_t(0x00000000)},
    {"scu11eb.ini", "inif: soviet mission 11b", int32_t(0x2222E5F8), int32_t(0x00000000)},
    {"scu12ea.ini", "inif: soviet mission 12", int32_t(0x2220E5FA), int32_t(0x00000000)},
    {"scu13ea.ini", "inif: soviet mission 13", int32_t(0x2220E5FC), int32_t(0x00000000)},
    {"scu13eb.ini", "inif: soviet mission 13b", int32_t(0x2222E5FC), int32_t(0x00000000)},
    {"scu14ea.ini", "inif: soviet mission 14", int32_t(0x2220E5FE), int32_t(0x00000000)},
    {"scu31ea.ini", "inif: proving grounds", int32_t(0x2A20E5F8), int32_t(0x00000000)},
    {"scu32ea.ini", "inif: beseiged", int32_t(0x2A20E5FA), int32_t(0x00000000)},
    {"scu33ea.ini", "inif: mousetrap", int32_t(0x2A20E5FC), int32_t(0x00000000)},
    {"scu34ea.ini", "inif: legacy of tesla", int32_t(0x2A20E5FE), int32_t(0x00000000)},
    {"scu35ea.ini", "inif: sov. sold'r vol. & chit.", int32_t(0x2A20E600), int32_t(0x00000000)},
    {"scu36ea.ini", "inif: top o' the world", int32_t(0x2A20E602), int32_t(0x00000000)},
    {"scu37ea.ini", "inif: paradox equation", int32_t(0x2A20E604), int32_t(0x00000000)},
    {"scu38ea.ini", "inif: nulcear escalation", int32_t(0x2A20E606), int32_t(0x00000000)},
    {"scu40ea.ini", "shock therapy", int32_t(0x2E20E5F6), int32_t(0x00000000)},
    {"scu41ea.ini", "test drive", int32_t(0x2E20E5F8), int32_t(0x00000000)},
    {"scu42ea.ini", "lets make a steal", int32_t(0x2E20E5FA), int32_t(0x00000000)},
    {"scu43ea.ini", "testing grounds", int32_t(0x2E20E5FC), int32_t(0x00000000)},
    {"scu44ea.ini", "situation critical", int32_t(0x2E20E5FE), int32_t(0x00000000)},
    {"scu45ea.ini", "don't drink the water", int32_t(0x2E20E600), int32_t(0x00000000)},
    {"scu46ea.ini", "brothers in arms", int32_t(0x2E20E602), int32_t(0x00000000)},
    {"scu47ea.ini", "deus ex machina", int32_t(0x2E20E604), int32_t(0x00000000)},
    {"scu48ea.ini", "grunyev revolution", int32_t(0x2E20E606), int32_t(0x00000000)},
    {"scytatk1.aud", "", int32_t(0xF850F6FD), int32_t(0x00000000)},
    {"scytatk2.aud", "", int32_t(0xFA50F6FD), int32_t(0x00000000)},
    {"scytcwk1.aud", "", int32_t(0xF850FD01), int32_t(0x00000000)},
    {"scytcwk2.aud", "", int32_t(0xFA50FD01), int32_t(0x00000000)},
    {"scytdef1.aud", "", int32_t(0xF846D903), int32_t(0x00000000)},
    {"scytdef2.aud", "", int32_t(0xFA46D903), int32_t(0x00000000)},
    {"scytdie1.aud", "", int32_t(0xF844E103), int32_t(0x00000000)},
    {"scytdie2.aud", "", int32_t(0xFA44E103), int32_t(0x00000000)},
    {"scytfor1.aud", "", int32_t(0xF85EED07), int32_t(0x00000000)},
    {"scytfor2.aud", "", int32_t(0xFA5EED07), int32_t(0x00000000)},
    {"scytfor3.aud", "", int32_t(0xFC5EED07), int32_t(0x00000000)},
    {"scythit1.aud", "", int32_t(0xF862E10B), int32_t(0x00000000)},
    {"scythit2.aud", "", int32_t(0xFA62E10B), int32_t(0x00000000)},
    {"scytloi1.aud", "", int32_t(0xF84CED13), int32_t(0x00000000)},
    {"scytloi2.aud", "", int32_t(0xFA4CED13), int32_t(0x00000000)},
    {"scytspl1.aud", "", int32_t(0xF852EF21), int32_t(0x00000000)},
    {"scytspl2.aud", "", int32_t(0xFA52EF21), int32_t(0x00000000)},
    {"scytspl3.aud", "", int32_t(0xFC52EF21), int32_t(0x00000000)},
    {"scytstn1.aud", "", int32_t(0xF856F721), int32_t(0x00000000)},
    {"scytstn2.aud", "", int32_t(0xFA56F721), int32_t(0x00000000)},
    {"scytwlk1.aud", "", int32_t(0xF850E729), int32_t(0x00000000)},
    {"scytwlk2.aud", "", int32_t(0xFA50E729), int32_t(0x00000000)},
    {"sdbtm.shp", "", int32_t(0x00000000), int32_t(0x37CC7600)},
    {"sdbtnanm.pal", "", int32_t(0x00000000), int32_t(0x12533FAD)},
    {"sdbtnanm.shp", "", int32_t(0x00000000), int32_t(0xD5D666F2)},
    {"sdbtnbkgd.shp", "", int32_t(0x00000000), int32_t(0x64459F0D)},
    {"sdmpbtn.shp", "", int32_t(0x00000000), int32_t(0x3CB56B0F)},
    {"sdtp.shp", "", int32_t(0x00000000), int32_t(0xDC1F2311)},
    {"sdwrnanm.shp", "", int32_t(0x00000000), int32_t(0x674B55D4)},
    {"sdwrntmp.shp", "", int32_t(0x00000000), int32_t(0x4C49C720)},
    {"se2kmix.inf", "sun edit 2000 mix information", int32_t(0x00000000), int32_t(0xF9FBC6CC)},
    {"seal.shp", "", int32_t(0x00000000), int32_t(0x8C63C10E)},
    {"seala.shp", "", int32_t(0x00000000), int32_t(0x5DC2E7E5)},
    {"sealicon.shp", "", int32_t(0x00000000), int32_t(0xF9D1531D)},
    {"sealuico.shp", "", int32_t(0x00000000), int32_t(0x3C17C1FC)},
    {"search.aud", "search", int32_t(0xCB61EA28), int32_t(0x00000000)},
    {"search.vqa", "intruders detceted", int32_t(0xF561E724), int32_t(0x00000000)},
    {"search.vqp", "vqp: intruders detceted", int32_t(0xF561F624), int32_t(0x00000000)},
    {"sedonapass.map", "", int32_t(0x00000000), int32_t(0xA07F0051)},
    {"sedonapassmw.map", "", int32_t(0x00000000), int32_t(0xC21019C4)},
    {"seedhit1.aud", "", int32_t(0xB812E90B), int32_t(0x00000000)},
    {"seedkil1.aud", "", int32_t(0xB802E911), int32_t(0x00000000)},
    {"seekicon.shp", "icon: hunter seeker", int32_t(0x00000000), int32_t(0x945B9EAE)},
    {"seige.vqa", "siege on base", int32_t(0xBFD17218), int32_t(0x00000000)},
    {"seige.vqp", "siege on base", int32_t(0xBFD17227), int32_t(0x00000000)},
    {"seismic.ini", "", int32_t(0x00000000), int32_t(0x0EC3B65D)},
    {"seismic.map", "-", int32_t(0x00000000), int32_t(0x11FDCF2F)},
    {"seldrv1.aud", "audf:", int32_t(0x6DD81732), int32_t(0x00000000)},
    {"select.shp", "repairing", int32_t(0xBB8E0E1B), int32_t(0xCD1C76ED)},
    {"select1.aud", "selection", int32_t(0x71D81314), int32_t(0x00000000)},
    {"sell.shp", "butt: sell", int32_t(0xE8E0DDD4), int32_t(0x30FDD2D0)},
    {"sergeant.pcx", "", int32_t(0x00000000), int32_t(0x7948406B)},
    {"servod1.aud", "", int32_t(0xB5EFF32C), int32_t(0x00000000)},
    {"servou1.aud", "", int32_t(0xB5F0152C), int32_t(0x00000000)},
    {"sethpre.vqa", "background on the brotherhood", int32_t(0x7E1D0B43), int32_t(0x00000000)},
    {"sethpre.vqp", "background on the brotherhood", int32_t(0x7E2C0B43), int32_t(0x00000000)},
    {"setup.dip", "setup program strings", int32_t(0xE7D9723D), int32_t(0x00000000)},
    {"setup.pal", "pal: setup", int32_t(0xD7F17239), int32_t(0x00000000)},
    {"setupmix.aud", "", int32_t(0x4A38F11A), int32_t(0x00000000)},
    {"sexyad2.aud", "", int32_t(0xC209F310), int32_t(0x00000000)},
    {"sfbrdg01.ubn", "", int32_t(0x00000000), int32_t(0x05D7476F)},
    {"sfbrdg01a.ubn", "", int32_t(0x00000000), int32_t(0x30D7A69A)},
    {"sfrozen.vqa", "frozen soviet soldier", int32_t(0x9A26F557), int32_t(0x00000000)},
    {"sfrozen.vqp", "vqp: frozen soviet soldier", int32_t(0x9A35F557), int32_t(0x00000000)},
    {"sfx1.aud", "sound effects 1", int32_t(0xA705CDD4), int32_t(0x00000000)},
    {"sfx2.aud", "sound effects 2", int32_t(0xA905CDD4), int32_t(0x00000000)},
    {"sfx3.aud", "sound effects 3", int32_t(0xAB05CDD4), int32_t(0x00000000)},
    {"sfx4.aud", "sound effects 4", int32_t(0xAD05CDD4), int32_t(0x00000000)},
    {"sfxbed2.aud", "audf:", int32_t(0x6609F718), int32_t(0x00000000)},
    {"sgbript.pcx", "", int32_t(0x00000000), int32_t(0xA7FBADBA)},
    {"sgen.hva", "-", int32_t(0x00000000), int32_t(0x542F92ED)},
    {"sgen.vxl", "mobile stealth generator", int32_t(0x00000000), int32_t(0xA2A54DA4)},
    {"sgl_btn.shp", "", int32_t(0xDA1E0E24), int32_t(0x00000000)},
    {"sgl_in.shp", "", int32_t(0x238E0A26), int32_t(0x00000000)},
    {"sgl_out.shp", "", int32_t(0xDA2A103E), int32_t(0x00000000)},
    {"sgl_spin.shp", "", int32_t(0x6A0C1120), int32_t(0x00000000)},
    {"sgrysmk1.shp", "-", int32_t(0x00000000), int32_t(0xD624B4BF)},
    {"sh01.sno", "coast", int32_t(0xB1AEE3D4), int32_t(0x00000000)},
    {"sh01.tem", "coast", int32_t(0xAFA5E4D4), int32_t(0x00000000)},
    {"sh02.sno", "coast", int32_t(0xB3AEE3D4), int32_t(0x00000000)},
    {"sh02.tem", "coast", int32_t(0xB1A5E4D4), int32_t(0x00000000)},
    {"sh03.sno", "coast", int32_t(0xB5AEE3D4), int32_t(0x00000000)},
    {"sh03.tem", "coast", int32_t(0xB3A5E4D4), int32_t(0x00000000)},
    {"sh04.sno", "coast", int32_t(0xB7AEE3D4), int32_t(0x00000000)},
    {"sh04.tem", "coast", int32_t(0xB5A5E4D4), int32_t(0x00000000)},
    {"sh05.sno", "coast", int32_t(0xB9AEE3D4), int32_t(0x00000000)},
    {"sh05.tem", "coast", int32_t(0xB7A5E4D4), int32_t(0x00000000)},
    {"sh06.sno", "coast", int32_t(0xBBAEE3D4), int32_t(0x00000000)},
    {"sh06.tem", "coast", int32_t(0xB9A5E4D4), int32_t(0x00000000)},
    {"sh07.sno", "coast", int32_t(0xBDAEE3D4), int32_t(0x00000000)},
    {"sh07.tem", "coast", int32_t(0xBBA5E4D4), int32_t(0x00000000)},
    {"sh08.sno", "coast", int32_t(0xBFAEE3D4), int32_t(0x00000000)},
    {"sh08.tem", "coast", int32_t(0xBDA5E4D4), int32_t(0x00000000)},
    {"sh09.sno", "coast", int32_t(0xC1AEE3D4), int32_t(0x00000000)},
    {"sh09.tem", "coast", int32_t(0xBFA5E4D4), int32_t(0x00000000)},
    {"sh1.tem", "coast wd", int32_t(0x5CAFD5FA), int32_t(0x00000000)},
    {"sh1.win", "coast wd", int32_t(0x5CB0D9FD), int32_t(0x00000000)},
    {"sh10.sno", "coast", int32_t(0xAFB0E3D4), int32_t(0x00000000)},
    {"sh10.tem", "coast corner n-e ext", int32_t(0xADA7E4D4), int32_t(0x00000000)},
    {"sh10.win", "coast corner n-e ext", int32_t(0xAEABE7D4), int32_t(0x00000000)},
    {"sh11.sno", "coast", int32_t(0xB1B0E3D4), int32_t(0x00000000)},
    {"sh11.tem", "fjord wd", int32_t(0xAFA7E4D4), int32_t(0x00000000)},
    {"sh11.win", "fjord wd", int32_t(0xB0ABE7D4), int32_t(0x00000000)},
    {"sh12.sno", "coast", int32_t(0xB3B0E3D4), int32_t(0x00000000)},
    {"sh12.tem", "coast wu", int32_t(0xB1A7E4D4), int32_t(0x00000000)},
    {"sh12.win", "coast wu", int32_t(0xB2ABE7D4), int32_t(0x00000000)},
    {"sh13.sno", "coast", int32_t(0xB5B0E3D4), int32_t(0x00000000)},
    {"sh13.tem", "coast wu", int32_t(0xB3A7E4D4), int32_t(0x00000000)},
    {"sh13.win", "coast wu", int32_t(0xB4ABE7D4), int32_t(0x00000000)},
    {"sh14.sno", "coast", int32_t(0xB7B0E3D4), int32_t(0x00000000)},
    {"sh14.tem", "coast wu", int32_t(0xB5A7E4D4), int32_t(0x00000000)},
    {"sh14.win", "coast wu", int32_t(0xB6ABE7D4), int32_t(0x00000000)},
    {"sh15.sno", "coast", int32_t(0xB9B0E3D4), int32_t(0x00000000)},
    {"sh15.tem", "coast wu", int32_t(0xB7A7E4D4), int32_t(0x00000000)},
    {"sh15.win", "coast wu", int32_t(0xB8ABE7D4), int32_t(0x00000000)},
    {"sh16.sno", "coast", int32_t(0xBBB0E3D4), int32_t(0x00000000)},
    {"sh16.tem", "coast wu", int32_t(0xB9A7E4D4), int32_t(0x00000000)},
    {"sh16.win", "fjord wu", int32_t(0xBAABE7D4), int32_t(0x00000000)},
    {"sh17.des", "water", int32_t(0xC1A7D4D4), int32_t(0x00000000)},
    {"sh17.sno", "coast", int32_t(0xBDB0E3D4), int32_t(0x00000000)},
    {"sh17.tem", "water", int32_t(0xBBA7E4D4), int32_t(0x00000000)},
    {"sh17.win", "water", int32_t(0xBCABE7D4), int32_t(0x00000000)},
    {"sh18.des", "water", int32_t(0xC3A7D4D4), int32_t(0x00000000)},
    {"sh18.sno", "coast", int32_t(0xBFB0E3D4), int32_t(0x00000000)},
    {"sh18.tem", "water", int32_t(0xBDA7E4D4), int32_t(0x00000000)},
    {"sh18.win", "water", int32_t(0xBEABE7D4), int32_t(0x00000000)},
    {"sh19.des", "coast wd", int32_t(0xC5A7D4D4), int32_t(0x00000000)},
    {"sh19.sno", "coast", int32_t(0xC1B0E3D4), int32_t(0x00000000)},
    {"sh19.tem", "coast", int32_t(0xBFA7E4D4), int32_t(0x00000000)},
    {"sh2.tem", "coast wd", int32_t(0x5CB1D5FA), int32_t(0x00000000)},
    {"sh2.win", "coast wd", int32_t(0x5CB2D9FD), int32_t(0x00000000)},
    {"sh20.des", "coast wd", int32_t(0xB3A9D4D4), int32_t(0x00000000)},
    {"sh20.sno", "coast", int32_t(0xAFB2E3D4), int32_t(0x00000000)},
    {"sh20.tem", "coast", int32_t(0xADA9E4D4), int32_t(0x00000000)},
    {"sh21.des", "coast wd", int32_t(0xB5A9D4D4), int32_t(0x00000000)},
    {"sh21.sno", "coast", int32_t(0xB1B2E3D4), int32_t(0x00000000)},
    {"sh21.tem", "coast", int32_t(0xAFA9E4D4), int32_t(0x00000000)},
    {"sh22.des", "coast wd", int32_t(0xB7A9D4D4), int32_t(0x00000000)},
    {"sh22.sno", "coast", int32_t(0xB3B2E3D4), int32_t(0x00000000)},
    {"sh22.tem", "coast", int32_t(0xB1A9E4D4), int32_t(0x00000000)},
    {"sh23.des", "coast wd", int32_t(0xB9A9D4D4), int32_t(0x00000000)},
    {"sh23.sno", "coast", int32_t(0xB5B2E3D4), int32_t(0x00000000)},
    {"sh23.tem", "coast", int32_t(0xB3A9E4D4), int32_t(0x00000000)},
    {"sh24.des", "fjord wd", int32_t(0xBBA9D4D4), int32_t(0x00000000)},
    {"sh24.sno", "coast", int32_t(0xB7B2E3D4), int32_t(0x00000000)},
    {"sh24.tem", "coast", int32_t(0xB5A9E4D4), int32_t(0x00000000)},
    {"sh25.des", "coast wu", int32_t(0xBDA9D4D4), int32_t(0x00000000)},
    {"sh25.sno", "coast", int32_t(0xB9B2E3D4), int32_t(0x00000000)},
    {"sh25.tem", "coast", int32_t(0xB7A9E4D4), int32_t(0x00000000)},
    {"sh26.des", "coast wu", int32_t(0xBFA9D4D4), int32_t(0x00000000)},
    {"sh26.sno", "coast", int32_t(0xBBB2E3D4), int32_t(0x00000000)},
    {"sh26.tem", "coast", int32_t(0xB9A9E4D4), int32_t(0x00000000)},
    {"sh27.des", "coast wu", int32_t(0xC1A9D4D4), int32_t(0x00000000)},
    {"sh27.sno", "coast", int32_t(0xBDB2E3D4), int32_t(0x00000000)},
    {"sh27.tem", "coast", int32_t(0xBBA9E4D4), int32_t(0x00000000)},
    {"sh28.des", "coast wu", int32_t(0xC3A9D4D4), int32_t(0x00000000)},
    {"sh28.sno", "coast", int32_t(0xBFB2E3D4), int32_t(0x00000000)},
    {"sh28.tem", "coast", int32_t(0xBDA9E4D4), int32_t(0x00000000)},
    {"sh29.des", "coast wu", int32_t(0xC5A9D4D4), int32_t(0x00000000)},
    {"sh29.sno", "coast", int32_t(0xC1B2E3D4), int32_t(0x00000000)},
    {"sh29.tem", "coast", int32_t(0xBFA9E4D4), int32_t(0x00000000)},
    {"sh3.tem", "rock in water", int32_t(0x5CB3D5FA), int32_t(0x00000000)},
    {"sh3.win", "rock in water", int32_t(0x5CB4D9FD), int32_t(0x00000000)},
    {"sh30.des", "coast wu", int32_t(0xB3ABD4D4), int32_t(0x00000000)},
    {"sh30.sno", "coast", int32_t(0xAFB4E3D4), int32_t(0x00000000)},
    {"sh30.tem", "coast", int32_t(0xADABE4D4), int32_t(0x00000000)},
    {"sh31.des", "fjord wu", int32_t(0xB5ABD4D4), int32_t(0x00000000)},
    {"sh31.sno", "coast", int32_t(0xB1B4E3D4), int32_t(0x00000000)},
    {"sh31.tem", "coast", int32_t(0xAFABE4D4), int32_t(0x00000000)},
    {"sh32.sno", "coast", int32_t(0xB3B4E3D4), int32_t(0x00000000)},
    {"sh32.tem", "coast corner n-w int", int32_t(0xB1ABE4D4), int32_t(0x00000000)},
    {"sh32.win", "coast corner n-w int", int32_t(0xB2AFE7D4), int32_t(0x00000000)},
    {"sh33.sno", "coast", int32_t(0xB5B4E3D4), int32_t(0x00000000)},
    {"sh33.tem", "coast corner n-e int", int32_t(0xB3ABE4D4), int32_t(0x00000000)},
    {"sh33.win", "coast corner n-e int", int32_t(0xB4AFE7D4), int32_t(0x00000000)},
    {"sh34.sno", "coast", int32_t(0xB7B4E3D4), int32_t(0x00000000)},
    {"sh34.tem", "coast wr", int32_t(0xB5ABE4D4), int32_t(0x00000000)},
    {"sh34.win", "coast wr", int32_t(0xB6AFE7D4), int32_t(0x00000000)},
    {"sh35.sno", "coast", int32_t(0xB9B4E3D4), int32_t(0x00000000)},
    {"sh35.tem", "coast wl", int32_t(0xB7ABE4D4), int32_t(0x00000000)},
    {"sh35.win", "coast wl", int32_t(0xB8AFE7D4), int32_t(0x00000000)},
    {"sh36.des", "coast corner s-e int", int32_t(0xBFABD4D4), int32_t(0x00000000)},
    {"sh36.sno", "coast", int32_t(0xBBB4E3D4), int32_t(0x00000000)},
    {"sh36.tem", "coast", int32_t(0xB9ABE4D4), int32_t(0x00000000)},
    {"sh37.des", "coast corner w-s int", int32_t(0xC1ABD4D4), int32_t(0x00000000)},
    {"sh37.sno", "coast", int32_t(0xBDB4E3D4), int32_t(0x00000000)},
    {"sh37.tem", "coast", int32_t(0xBBABE4D4), int32_t(0x00000000)},
    {"sh38.des", "coast corner n-e int", int32_t(0xC3ABD4D4), int32_t(0x00000000)},
    {"sh38.sno", "coast", int32_t(0xBFB4E3D4), int32_t(0x00000000)},
    {"sh38.tem", "coast", int32_t(0xBDABE4D4), int32_t(0x00000000)},
    {"sh39.des", "coast corner n-w int", int32_t(0xC5ABD4D4), int32_t(0x00000000)},
    {"sh39.sno", "coast", int32_t(0xC1B4E3D4), int32_t(0x00000000)},
    {"sh39.tem", "coast", int32_t(0xBFABE4D4), int32_t(0x00000000)},
    {"sh4.tem", "rock in water", int32_t(0x5CB5D5FA), int32_t(0x00000000)},
    {"sh4.win", "rock in water", int32_t(0x5CB6D9FD), int32_t(0x00000000)},
    {"sh40.des", "coast corner s-e int", int32_t(0xB3ADD4D4), int32_t(0x00000000)},
    {"sh40.sno", "coast", int32_t(0xAFB6E3D4), int32_t(0x00000000)},
    {"sh40.tem", "coast", int32_t(0xADADE4D4), int32_t(0x00000000)},
    {"sh41.des", "coast corner n-w int", int32_t(0xB5ADD4D4), int32_t(0x00000000)},
    {"sh41.sno", "coast", int32_t(0xB1B6E3D4), int32_t(0x00000000)},
    {"sh41.tem", "coast", int32_t(0xAFADE4D4), int32_t(0x00000000)},
    {"sh42.des", "coast wl", int32_t(0xB7ADD4D4), int32_t(0x00000000)},
    {"sh42.sno", "coast", int32_t(0xB3B6E3D4), int32_t(0x00000000)},
    {"sh42.tem", "coast", int32_t(0xB1ADE4D4), int32_t(0x00000000)},
    {"sh43.des", "coast wl", int32_t(0xB9ADD4D4), int32_t(0x00000000)},
    {"sh43.sno", "coast", int32_t(0xB5B6E3D4), int32_t(0x00000000)},
    {"sh43.tem", "coast", int32_t(0xB3ADE4D4), int32_t(0x00000000)},
    {"sh44.des", "coast wr", int32_t(0xBBADD4D4), int32_t(0x00000000)},
    {"sh44.sno", "coast", int32_t(0xB7B6E3D4), int32_t(0x00000000)},
    {"sh44.tem", "coast", int32_t(0xB5ADE4D4), int32_t(0x00000000)},
    {"sh45.des", "coast wr", int32_t(0xBDADD4D4), int32_t(0x00000000)},
    {"sh45.sno", "coast", int32_t(0xB9B6E3D4), int32_t(0x00000000)},
    {"sh45.tem", "coast", int32_t(0xB7ADE4D4), int32_t(0x00000000)},
    {"sh46.des", "coast corner s-e int", int32_t(0xBFADD4D4), int32_t(0x00000000)},
    {"sh46.sno", "coast", int32_t(0xBBB6E3D4), int32_t(0x00000000)},
    {"sh46.tem", "coast", int32_t(0xB9ADE4D4), int32_t(0x00000000)},
    {"sh47.des", "coast corner s-e int", int32_t(0xC1ADD4D4), int32_t(0x00000000)},
    {"sh47.sno", "coast", int32_t(0xBDB6E3D4), int32_t(0x00000000)},
    {"sh47.tem", "coast", int32_t(0xBBADE4D4), int32_t(0x00000000)},
    {"sh48.des", "coast corner n-e int", int32_t(0xC3ADD4D4), int32_t(0x00000000)},
    {"sh48.sno", "coast", int32_t(0xBFB6E3D4), int32_t(0x00000000)},
    {"sh48.tem", "coast", int32_t(0xBDADE4D4), int32_t(0x00000000)},
    {"sh49.des", "coast corner n-w int", int32_t(0xC5ADD4D4), int32_t(0x00000000)},
    {"sh49.sno", "coast", int32_t(0xC1B6E3D4), int32_t(0x00000000)},
    {"sh49.tem", "coast", int32_t(0xBFADE4D4), int32_t(0x00000000)},
    {"sh5.tem", "coast wd", int32_t(0x5CB7D5FA), int32_t(0x00000000)},
    {"sh5.win", "coast wd", int32_t(0x5CB8D9FD), int32_t(0x00000000)},
    {"sh50.des", "coast corner s-e ext", int32_t(0xB3AFD4D4), int32_t(0x00000000)},
    {"sh50.sno", "coast", int32_t(0xAFB8E3D4), int32_t(0x00000000)},
    {"sh50.tem", "coast", int32_t(0xADAFE4D4), int32_t(0x00000000)},
    {"sh51.des", "coast corner w-s ext", int32_t(0xB5AFD4D4), int32_t(0x00000000)},
    {"sh51.sno", "coast", int32_t(0xB1B8E3D4), int32_t(0x00000000)},
    {"sh51.tem", "coast", int32_t(0xAFAFE4D4), int32_t(0x00000000)},
    {"sh52.des", "coast corner n-e ext", int32_t(0xB7AFD4D4), int32_t(0x00000000)},
    {"sh52.sno", "coast", int32_t(0xB3B8E3D4), int32_t(0x00000000)},
    {"sh52.tem", "coast", int32_t(0xB1AFE4D4), int32_t(0x00000000)},
    {"sh53.des", "coast corner n-w ext", int32_t(0xB9AFD4D4), int32_t(0x00000000)},
    {"sh53.sno", "coast", int32_t(0xB5B8E3D4), int32_t(0x00000000)},
    {"sh53.tem", "coast", int32_t(0xB3AFE4D4), int32_t(0x00000000)},
    {"sh54.des", "coast wd", int32_t(0xBBAFD4D4), int32_t(0x00000000)},
    {"sh54.sno", "coast", int32_t(0xB7B8E3D4), int32_t(0x00000000)},
    {"sh54.tem", "coast", int32_t(0xB5AFE4D4), int32_t(0x00000000)},
    {"sh55.des", "coast wd", int32_t(0xBDAFD4D4), int32_t(0x00000000)},
    {"sh55.sno", "coast", int32_t(0xB9B8E3D4), int32_t(0x00000000)},
    {"sh55.tem", "coast", int32_t(0xB7AFE4D4), int32_t(0x00000000)},
    {"sh56.des", "coast wu", int32_t(0xBFAFD4D4), int32_t(0x00000000)},
    {"sh56.sno", "coast", int32_t(0xBBB8E3D4), int32_t(0x00000000)},
    {"sh56.tem", "coast", int32_t(0xB9AFE4D4), int32_t(0x00000000)},
    {"sh57.des", "coast wu", int32_t(0xC1AFD4D4), int32_t(0x00000000)},
    {"sh58.des", "coast wr", int32_t(0xC3AFD4D4), int32_t(0x00000000)},
    {"sh59.des", "coast wr", int32_t(0xC5AFD4D4), int32_t(0x00000000)},
    {"sh6.tem", "coast wd", int32_t(0x5CB9D5FA), int32_t(0x00000000)},
    {"sh6.win", "coast wd", int32_t(0x5CBAD9FD), int32_t(0x00000000)},
    {"sh60.des", "coast wl", int32_t(0xB3B1D4D4), int32_t(0x00000000)},
    {"sh61.des", "coast wl", int32_t(0xB5B1D4D4), int32_t(0x00000000)},
    {"sh62.des", "coast wd", int32_t(0xB7B1D4D4), int32_t(0x00000000)},
    {"sh63.des", "coast wd", int32_t(0xB9B1D4D4), int32_t(0x00000000)},
    {"sh7.tem", "coast corner w-n external", int32_t(0x5CBBD5FA), int32_t(0x00000000)},
    {"sh7.win", "coast corner w-n external", int32_t(0x5CBCD9FD), int32_t(0x00000000)},
    {"sh8.tem", "coast corner s-e ext", int32_t(0x5CBDD5FA), int32_t(0x00000000)},
    {"sh8.win", "coast corner s-e ext", int32_t(0x5CBED9FD), int32_t(0x00000000)},
    {"sh9.tem", "coast corner w-s ext", int32_t(0x5CBFD5FA), int32_t(0x00000000)},
    {"sh9.win", "coast corner w-s ext", int32_t(0x5CC0D9FD), int32_t(0x00000000)},
    {"shad.hva", "", int32_t(0x00000000), int32_t(0x7346B8B3)},
    {"shad.vxl", "", int32_t(0x00000000), int32_t(0x85CC67FA)},
    {"shadicon.shp", "", int32_t(0x00000000), int32_t(0x899DBC02)},
    {"shadow.shp", "map shadows", int32_t(0xB7622033), int32_t(0x824AABCB)},
    {"shaduico.shp", "", int32_t(0x00000000), int32_t(0x4C5B2EE3)},
    {"shapes.pal", "", int32_t(0xE1621418), int32_t(0x40A15787)},
    {"shapes.shp", "", int32_t(0xE762181F), int32_t(0x16E9806D)},
    {"shapes1.shp", "", int32_t(0x00000000), int32_t(0x198591C5)},
    {"shapes2.shp", "", int32_t(0x00000000), int32_t(0x9F11E36B)},
    {"shardglo.aud", "", int32_t(0x2BF2F103), int32_t(0x00000000)},
    {"shell.pal", "", int32_t(0x00000000), int32_t(0x6785E6A3)},
    {"shell2.pal", "", int32_t(0x00000000), int32_t(0x31301AE2)},
    {"shellbttnoff.pcx", "", int32_t(0x00000000), int32_t(0xDC2AFF88)},
    {"shellbttnon.pcx", "", int32_t(0x00000000), int32_t(0x5934C809)},
    {"shellbttnpress.pcx", "", int32_t(0x00000000), int32_t(0xC9B33942)},
    {"shimmer1.aud", "", int32_t(0xDC1EED15), int32_t(0x00000000)},
    {"ship.shp", "-", int32_t(0x00000000), int32_t(0xA4F75820)},
    {"shipsink.vqa", "ship sinking", int32_t(0x19130A21), int32_t(0x00000000)},
    {"shipsink.vqp", "vqp: ship sinking", int32_t(0x28130A21), int32_t(0x00000000)},
    {"shipyard.vqa", "ship sinking", int32_t(0x0B1AFA2D), int32_t(0x00000000)},
    {"shipyard.vqp", "vqp: ship sinking", int32_t(0x1A1AFA2D), int32_t(0x00000000)},
    {"shk.shp", "", int32_t(0x00000000), int32_t(0x56820B42)},
    {"shkicon.shp", "", int32_t(0x00000000), int32_t(0x92A1B50F)},
    {"shktrop1.aud", "shock troop", int32_t(0xF823011F), int32_t(0x00000000)},
    {"shkuico.shp", "", int32_t(0x00000000), int32_t(0x4569A173)},
    {"shldblu1.aud", "", int32_t(0xB830FAFF), int32_t(0x00000000)},
    {"shldgrn1.aud", "", int32_t(0xB8230709), int32_t(0x00000000)},
    {"shldred1.aud", "", int32_t(0xB80EED1F), int32_t(0x00000000)},
    {"shok.shp", "unit: shock trooper", int32_t(0xE6E6E3D4), int32_t(0x00000000)},
    {"shokicon.shp", "icon: shock trooper", int32_t(0x1A23FB0D), int32_t(0x00000000)},
    {"shorbom1.vqa", "ships attatking base", int32_t(0xED2915FF), int32_t(0x00000000)},
    {"shorbom1.vqp", "vqp: ships attatking base", int32_t(0xFC2915FF), int32_t(0x00000000)},
    {"shorbom2.vqa", "ships attatking base again", int32_t(0xEF2915FF), int32_t(0x00000000)},
    {"shorbom2.vqp", "vqp: ships attatking base again", int32_t(0xFE2915FF), int32_t(0x00000000)},
    {"shorbomb.vqa", "ships attatking another base", int32_t(0x0F2915FF), int32_t(0x00000000)},
    {"shorbomb.vqp", "vqp: ships attatking another base", int32_t(0x1E2915FF), int32_t(0x00000000)},
    {"shore01.des", "", int32_t(0x00000000), int32_t(0x7DDF703E)},
    {"shore01.sno", "-", int32_t(0x00000000), int32_t(0x5A33ADA4)},
    {"shore01.tem", "-", int32_t(0x00000000), int32_t(0xF987187E)},
    {"shore01.ubn", "", int32_t(0x00000000), int32_t(0x6F593A5D)},
    {"shore01.urb", "", int32_t(0x00000000), int32_t(0xDFCAD621)},
    {"shore02.des", "", int32_t(0x00000000), int32_t(0xFB4B0290)},
    {"shore02.sno", "-", int32_t(0x00000000), int32_t(0xDCA7DF0A)},
    {"shore02.tem", "-", int32_t(0x00000000), int32_t(0x7F136AD0)},
    {"shore02.ubn", "", int32_t(0x00000000), int32_t(0xE9CD48F3)},
    {"shore02.urb", "", int32_t(0x00000000), int32_t(0x595EA48F)},
    {"shore03.des", "", int32_t(0x00000000), int32_t(0x3017D135)},
    {"shore03.sno", "-", int32_t(0x00000000), int32_t(0x17FB0CAF)},
    {"shore03.tem", "-", int32_t(0x00000000), int32_t(0xB44FB975)},
    {"shore03.ubn", "", int32_t(0x00000000), int32_t(0x22919B56)},
    {"shore03.urb", "", int32_t(0x00000000), int32_t(0x9202772A)},
    {"shore04.des", "", int32_t(0x00000000), int32_t(0x2D12E18D)},
    {"shore04.sno", "-", int32_t(0x00000000), int32_t(0x0AFE3C17)},
    {"shore04.tem", "-", int32_t(0x00000000), int32_t(0xA94A89CD)},
    {"shore04.ubn", "", int32_t(0x00000000), int32_t(0x3F94ABEE)},
    {"shore04.urb", "", int32_t(0x00000000), int32_t(0x8F074792)},
    {"shore05.des", "", int32_t(0x00000000), int32_t(0xE64E3228)},
    {"shore05.sno", "-", int32_t(0x00000000), int32_t(0xC1A2EFB2)},
    {"shore05.tem", "-", int32_t(0x00000000), int32_t(0x62165A68)},
    {"shore05.ubn", "", int32_t(0x00000000), int32_t(0xF4C8784B)},
    {"shore05.urb", "", int32_t(0x00000000), int32_t(0x445B9437)},
    {"shore06.des", "", int32_t(0x00000000), int32_t(0x60DA4086)},
    {"shore06.sno", "-", int32_t(0x00000000), int32_t(0x47369D1C)},
    {"shore06.tem", "-", int32_t(0x00000000), int32_t(0xE48228C6)},
    {"shore06.ubn", "", int32_t(0x00000000), int32_t(0x725C0AE5)},
    {"shore06.urb", "", int32_t(0x00000000), int32_t(0xC2CFE699)},
    {"shore07.des", "", int32_t(0x00000000), int32_t(0xAB869323)},
    {"shore07.sno", "-", int32_t(0x00000000), int32_t(0x8C6A4EB9)},
    {"shore07.tem", "-", int32_t(0x00000000), int32_t(0x2FDEFB63)},
    {"shore07.ubn", "", int32_t(0x00000000), int32_t(0xB900D940)},
    {"shore07.urb", "", int32_t(0x00000000), int32_t(0x0993353C)},
    {"shore08.des", "", int32_t(0x00000000), int32_t(0x5AD021F6)},
    {"shore08.sno", "-", int32_t(0x00000000), int32_t(0x7D3CFC6C)},
    {"shore08.tem", "-", int32_t(0x00000000), int32_t(0xDE8849B6)},
    {"shore08.ubn", "", int32_t(0x00000000), int32_t(0x48566B95)},
    {"shore08.urb", "", int32_t(0x00000000), int32_t(0xF8C587E9)},
    {"shore09.des", "", int32_t(0x00000000), int32_t(0x918CF253)},
    {"shore09.sno", "-", int32_t(0x00000000), int32_t(0xB6602FC9)},
    {"shore09.tem", "-", int32_t(0x00000000), int32_t(0x15D49A13)},
    {"shore09.ubn", "", int32_t(0x00000000), int32_t(0x830AB830)},
    {"shore09.urb", "", int32_t(0x00000000), int32_t(0x3399544C)},
    {"shore10.des", "", int32_t(0x00000000), int32_t(0x10F4A82F)},
    {"shore10.sno", "-", int32_t(0x00000000), int32_t(0x371875B5)},
    {"shore10.tem", "-", int32_t(0x00000000), int32_t(0x94ACC06F)},
    {"shore10.ubn", "", int32_t(0x00000000), int32_t(0x0272E24C)},
    {"shore10.urb", "", int32_t(0x00000000), int32_t(0xB2E10E30)},
    {"shore11.des", "", int32_t(0x00000000), int32_t(0xDBA87B8A)},
    {"shore11.sno", "-", int32_t(0x00000000), int32_t(0xFC44A610)},
    {"shore11.tem", "-", int32_t(0x00000000), int32_t(0x5FF013CA)},
    {"shore11.ubn", "", int32_t(0x00000000), int32_t(0xC92E31E9)},
    {"shore11.urb", "", int32_t(0x00000000), int32_t(0x79BDDD95)},
    {"shore12.des", "", int32_t(0x00000000), int32_t(0x5D3C0924)},
    {"shore12.sno", "-", int32_t(0x00000000), int32_t(0x7AD0D4BE)},
    {"shore12.tem", "-", int32_t(0x00000000), int32_t(0xD9646164)},
    {"shore12.ubn", "", int32_t(0x00000000), int32_t(0x4FBA4347)},
    {"shore12.urb", "", int32_t(0x00000000), int32_t(0xFF29AF3B)},
    {"shore13.des", "", int32_t(0x00000000), int32_t(0x9660DA81)},
    {"shore13.sno", "-", int32_t(0x00000000), int32_t(0xB18C071B)},
    {"shore13.tem", "-", int32_t(0x00000000), int32_t(0x1238B2C1)},
    {"shore13.ubn", "", int32_t(0x00000000), int32_t(0x84E690E2)},
    {"shore13.urb", "", int32_t(0x00000000), int32_t(0x34757C9E)},
    {"shore14.des", "", int32_t(0x00000000), int32_t(0x8B65EA39)},
    {"shore14.sno", "-", int32_t(0x00000000), int32_t(0xAC8937A3)},
    {"shore14.tem", "-", int32_t(0x00000000), int32_t(0x0F3D8279)},
    {"shore14.ubn", "", int32_t(0x00000000), int32_t(0x99E3A05A)},
    {"shore14.urb", "", int32_t(0x00000000), int32_t(0x29704C26)},
    {"shore15.des", "", int32_t(0x00000000), int32_t(0x4039399C)},
    {"shore15.sno", "-", int32_t(0x00000000), int32_t(0x67D5E406)},
    {"shore15.tem", "-", int32_t(0x00000000), int32_t(0xC46151DC)},
    {"shore15.ubn", "", int32_t(0x00000000), int32_t(0x52BF73FF)},
    {"shore15.urb", "", int32_t(0x00000000), int32_t(0xE22C9F83)},
    {"shore16.des", "", int32_t(0x00000000), int32_t(0xC6AD4B32)},
    {"shore16.sno", "-", int32_t(0x00000000), int32_t(0xE14196A8)},
    {"shore16.tem", "-", int32_t(0x00000000), int32_t(0x42F52372)},
    {"shore16.ubn", "", int32_t(0x00000000), int32_t(0xD42B0151)},
    {"shore16.urb", "", int32_t(0x00000000), int32_t(0x64B8ED2D)},
    {"shore17.des", "", int32_t(0x00000000), int32_t(0x0DF19897)},
    {"shore17.sno", "-", int32_t(0x00000000), int32_t(0x2A1D450D)},
    {"shore17.tem", "-", int32_t(0x00000000), int32_t(0x89A9F0D7)},
    {"shore17.ubn", "", int32_t(0x00000000), int32_t(0x1F77D2F4)},
    {"shore17.urb", "", int32_t(0x00000000), int32_t(0xAFE43E88)},
    {"shore18.des", "", int32_t(0x00000000), int32_t(0xFCA72A42)},
    {"shore18.sno", "-", int32_t(0x00000000), int32_t(0xDB4BF7D8)},
    {"shore18.tem", "-", int32_t(0x00000000), int32_t(0x78FF4202)},
    {"shore18.ubn", "", int32_t(0x00000000), int32_t(0xEE216021)},
    {"shore18.urb", "", int32_t(0x00000000), int32_t(0x5EB28C5D)},
    {"shore19.des", "", int32_t(0x00000000), int32_t(0x37FBF9E7)},
    {"shore19.sno", "-", int32_t(0x00000000), int32_t(0x1017247D)},
    {"shore19.tem", "-", int32_t(0x00000000), int32_t(0xB3A391A7)},
    {"shore19.ubn", "", int32_t(0x00000000), int32_t(0x257DB384)},
    {"shore19.urb", "", int32_t(0x00000000), int32_t(0x95EE5FF8)},
    {"shore20.des", "", int32_t(0x00000000), int32_t(0x211CB2B2)},
    {"shore20.sno", "-", int32_t(0x00000000), int32_t(0x06F06F28)},
    {"shore20.tem", "-", int32_t(0x00000000), int32_t(0xA544DAF2)},
    {"shore20.ubn", "", int32_t(0x00000000), int32_t(0x339AF8D1)},
    {"shore20.urb", "", int32_t(0x00000000), int32_t(0x830914AD)},
    {"shore21.des", "", int32_t(0x00000000), int32_t(0xEA406117)},
    {"shore21.sno", "-", int32_t(0x00000000), int32_t(0xCDACBC8D)},
    {"shore21.tem", "-", int32_t(0x00000000), int32_t(0x6E180957)},
    {"shore21.ubn", "", int32_t(0x00000000), int32_t(0xF8C62B74)},
    {"shore21.urb", "", int32_t(0x00000000), int32_t(0x4855C708)},
    {"shore22.des", "", int32_t(0x00000000), int32_t(0x6CD413B9)},
    {"shore22.sno", "-", int32_t(0x00000000), int32_t(0x4B38CE23)},
    {"shore22.tem", "-", int32_t(0x00000000), int32_t(0xE88C7BF9)},
    {"shore22.ubn", "", int32_t(0x00000000), int32_t(0x7E5259DA)},
    {"shore22.urb", "", int32_t(0x00000000), int32_t(0xCEC1B5A6)},
    {"shore23.des", "", int32_t(0x00000000), int32_t(0xA788C01C)},
    {"shore23.sno", "-", int32_t(0x00000000), int32_t(0x80641D86)},
    {"shore23.tem", "-", int32_t(0x00000000), int32_t(0x23D0A85C)},
    {"shore23.ubn", "", int32_t(0x00000000), int32_t(0xB50E8A7F)},
    {"shore23.urb", "", int32_t(0x00000000), int32_t(0x059D6603)},
    {"shore24.des", "", int32_t(0x00000000), int32_t(0xBA8DF0A4)},
    {"shore24.sno", "-", int32_t(0x00000000), int32_t(0x9D612D3E)},
    {"shore24.tem", "-", int32_t(0x00000000), int32_t(0x3ED598E4)},
    {"shore24.ubn", "", int32_t(0x00000000), int32_t(0xA80BBAC7)},
    {"shore24.urb", "", int32_t(0x00000000), int32_t(0x189856BB)},
    {"shore25.des", "", int32_t(0x00000000), int32_t(0x71D12301)},
    {"shore25.sno", "-", int32_t(0x00000000), int32_t(0x563DFE9B)},
    {"shore25.tem", "-", int32_t(0x00000000), int32_t(0xF5894B41)},
    {"shore25.ubn", "", int32_t(0x00000000), int32_t(0x63576962)},
    {"shore25.urb", "", int32_t(0x00000000), int32_t(0xD3C4851E)},
    {"shore26.des", "", int32_t(0x00000000), int32_t(0xF74551AF)},
    {"shore26.sno", "-", int32_t(0x00000000), int32_t(0xD0A98C35)},
    {"shore26.tem", "-", int32_t(0x00000000), int32_t(0x731D39EF)},
    {"shore26.ubn", "", int32_t(0x00000000), int32_t(0xE5C31BCC)},
    {"shore26.urb", "", int32_t(0x00000000), int32_t(0x5550F7B0)},
    {"shore27.des", "", int32_t(0x00000000), int32_t(0x3C19820A)},
    {"shore27.sno", "-", int32_t(0x00000000), int32_t(0x1BF55F90)},
    {"shore27.tem", "-", int32_t(0x00000000), int32_t(0xB841EA4A)},
    {"shore27.ubn", "", int32_t(0x00000000), int32_t(0x2E9FC869)},
    {"shore27.urb", "", int32_t(0x00000000), int32_t(0x9E0C2415)},
    {"shore28.des", "", int32_t(0x00000000), int32_t(0xCD4F30DF)},
    {"shore28.sno", "-", int32_t(0x00000000), int32_t(0xEAA3ED45)},
    {"shore28.tem", "-", int32_t(0x00000000), int32_t(0x4917589F)},
    {"shore28.ubn", "", int32_t(0x00000000), int32_t(0xDFC97ABC)},
    {"shore28.urb", "", int32_t(0x00000000), int32_t(0x6F5A96C0)},
    {"shore29.des", "", int32_t(0x00000000), int32_t(0x0613E37A)},
    {"shore29.sno", "-", int32_t(0x00000000), int32_t(0x21FF3EE0)},
    {"shore29.tem", "-", int32_t(0x00000000), int32_t(0x824B8B3A)},
    {"shore29.ubn", "", int32_t(0x00000000), int32_t(0x1495A919)},
    {"shore29.urb", "", int32_t(0x00000000), int32_t(0xA4064565)},
    {"shore30.des", "", int32_t(0x00000000), int32_t(0x876BB906)},
    {"shore30.sno", "-", int32_t(0x00000000), int32_t(0xA087649C)},
    {"shore30.tem", "-", int32_t(0x00000000), int32_t(0x0333D146)},
    {"shore30.ubn", "", int32_t(0x00000000), int32_t(0x95EDF365)},
    {"shore30.urb", "", int32_t(0x00000000), int32_t(0x257E1F19)},
    {"shore31.des", "", int32_t(0x00000000), int32_t(0x4C376AA3)},
    {"shore31.sno", "-", int32_t(0x00000000), int32_t(0x6BDBB739)},
    {"shore31.tem", "-", int32_t(0x00000000), int32_t(0xC86F02E3)},
    {"shore31.ubn", "", int32_t(0x00000000), int32_t(0x5EB120C0)},
    {"shore31.urb", "", int32_t(0x00000000), int32_t(0xEE22CCBC)},
    {"shore32.des", "", int32_t(0x00000000), int32_t(0xCAA3180D)},
    {"shore32.sno", "-", int32_t(0x00000000), int32_t(0xED4FC597)},
    {"shore32.tem", "-", int32_t(0x00000000), int32_t(0x4EFB704D)},
    {"shore32.ubn", "", int32_t(0x00000000), int32_t(0xD825526E)},
    {"shore32.urb", "", int32_t(0x00000000), int32_t(0x68B6BE12)},
    {"shore33.des", "", int32_t(0x00000000), int32_t(0x01FFCBA8)},
    {"shore33.sno", "-", int32_t(0x00000000), int32_t(0x26131632)},
    {"shore33.tem", "-", int32_t(0x00000000), int32_t(0x85A7A3E8)},
    {"shore33.ubn", "", int32_t(0x00000000), int32_t(0x137981CB)},
    {"shore33.urb", "", int32_t(0x00000000), int32_t(0xA3EA6DB7)},
    {"shore34.des", "", int32_t(0x00000000), int32_t(0x1CFAFB10)},
    {"shore34.sno", "-", int32_t(0x00000000), int32_t(0x3B16268A)},
    {"shore34.tem", "-", int32_t(0x00000000), int32_t(0x98A29350)},
    {"shore34.ubn", "", int32_t(0x00000000), int32_t(0x0E7CB173)},
    {"shore34.urb", "", int32_t(0x00000000), int32_t(0xBEEF5D0F)},
    {"shore35.des", "", int32_t(0x00000000), int32_t(0xD7A628B5)},
    {"shore35.sno", "-", int32_t(0x00000000), int32_t(0xF04AF52F)},
    {"shore35.tem", "-", int32_t(0x00000000), int32_t(0x53FE40F5)},
    {"shore35.ubn", "", int32_t(0x00000000), int32_t(0xC52062D6)},
    {"shore35.urb", "", int32_t(0x00000000), int32_t(0x75B38EAA)},
    {"shore36.des", "", int32_t(0x00000000), int32_t(0x51325A1B)},
    {"shore36.sno", "-", int32_t(0x00000000), int32_t(0x76DE8781)},
    {"shore36.tem", "-", int32_t(0x00000000), int32_t(0xD56A325B)},
    {"shore36.ubn", "", int32_t(0x00000000), int32_t(0x43B41078)},
    {"shore36.urb", "", int32_t(0x00000000), int32_t(0xF327FC04)},
    {"shore37.des", "", int32_t(0x00000000), int32_t(0x9A6E89BE)},
    {"shore37.sno", "-", int32_t(0x00000000), int32_t(0xBD825424)},
    {"shore37.tem", "-", int32_t(0x00000000), int32_t(0x1E36E1FE)},
    {"shore37.ubn", "", int32_t(0x00000000), int32_t(0x88E8C3DD)},
    {"shore37.urb", "", int32_t(0x00000000), int32_t(0x387B2FA1)},
    {"shore38.des", "", int32_t(0x00000000), int32_t(0x6B383B6B)},
    {"shore38.sno", "-", int32_t(0x00000000), int32_t(0x4CD4E6F1)},
    {"shore38.tem", "-", int32_t(0x00000000), int32_t(0xEF60532B)},
    {"shore38.ubn", "", int32_t(0x00000000), int32_t(0x79BE7108)},
    {"shore38.urb", "", int32_t(0x00000000), int32_t(0xC92D9D74)},
    {"shore39.des", "", int32_t(0x00000000), int32_t(0xA064E8CE)},
    {"shore39.sno", "-", int32_t(0x00000000), int32_t(0x87883554)},
    {"shore39.tem", "-", int32_t(0x00000000), int32_t(0x243C808E)},
    {"shore39.ubn", "", int32_t(0x00000000), int32_t(0xB2E2A2AD)},
    {"shore39.urb", "", int32_t(0x00000000), int32_t(0x02714ED1)},
    {"shore40.des", "", int32_t(0x00000000), int32_t(0x42CC8788)},
    {"shore40.sno", "-", int32_t(0x00000000), int32_t(0x65205A12)},
    {"shore40.tem", "-", int32_t(0x00000000), int32_t(0xC694EFC8)},
    {"shore40.ubn", "", int32_t(0x00000000), int32_t(0x504ACDEB)},
    {"shore40.urb", "", int32_t(0x00000000), int32_t(0xE0D92197)},
    {"shore41.des", "", int32_t(0x00000000), int32_t(0x8990542D)},
    {"shore41.sno", "-", int32_t(0x00000000), int32_t(0xAE7C89B7)},
    {"shore41.tem", "-", int32_t(0x00000000), int32_t(0x0DC83C6D)},
    {"shore41.ubn", "", int32_t(0x00000000), int32_t(0x9B161E4E)},
    {"shore41.urb", "", int32_t(0x00000000), int32_t(0x2B85F232)},
    {"shore42.des", "", int32_t(0x00000000), int32_t(0x0F042683)},
    {"shore42.sno", "-", int32_t(0x00000000), int32_t(0x28E8FB19)},
    {"shore42.tem", "-", int32_t(0x00000000), int32_t(0x8B5C4EC3)},
    {"shore42.ubn", "", int32_t(0x00000000), int32_t(0x1D826CE0)},
    {"shore42.urb", "", int32_t(0x00000000), int32_t(0xAD11809C)},
    {"shotcok1.aud", "", int32_t(0xF8290101), int32_t(0x00000000)},
    {"shotgun1.aud", "", int32_t(0xF82F0D09), int32_t(0x00000000)},
    {"shotgun9.aud", "", int32_t(0x082F0D09), int32_t(0x00000000)},
    {"shroud.shp", "-", int32_t(0x00000000), int32_t(0x77CBA44D)},
    {"shroudx.shp", "crate: shroud whole map", int32_t(0x00000000), int32_t(0x575CEB77)},
    {"shut_it.aud", "shut_it", int32_t(0xAE42094C), int32_t(0x00000000)},
    {"shutdown.aud", "", int32_t(0x32590103), int32_t(0x00000000)},
    {"sidbar1c.aud", "sidebar 1", int32_t(0xD3C90AFD), int32_t(0x00000000)},
    {"sidbar1c.juv", "sidebar 1", int32_t(0xE5C913FD), int32_t(0x00000000)},
    {"sidbar2c.aud", "sidebar 2", int32_t(0xD3CB0AFD), int32_t(0x00000000)},
    {"sidbar2c.juv", "sidebar 2", int32_t(0xE5CB13FD), int32_t(0x00000000)},
    {"side1.shp", "-", int32_t(0x00000000), int32_t(0xB10299AD)},
    {"side1na.shp", "misc: allies radarmap background", int32_t(0x71E40A02), int32_t(0x00000000)},
    {"side1us.shp", "misc: soviet radarmap background", int32_t(0x72081802), int32_t(0x00000000)},
    {"side2.shp", "-", int32_t(0x00000000), int32_t(0x3F8D9E4E)},
    {"side2b.shp", "", int32_t(0x00000000), int32_t(0xB0259C24)},
    {"side2na.shp", "misc: allies sidebar #1", int32_t(0x71E40A04), int32_t(0x00000000)},
    {"side2us.shp", "misc: soviet sidebar #1", int32_t(0x72081804), int32_t(0x00000000)},
    {"side3.shp", "-", int32_t(0x00000000), int32_t(0xF3279ED0)},
    {"side3na.shp", "misc: allies sidebar #2", int32_t(0x71E40A06), int32_t(0x00000000)},
    {"side3us.shp", "misc: soviet sidebar #2", int32_t(0x72081806), int32_t(0x00000000)},
    {"sidebar.pal", "sidebar palette", int32_t(0x00000000), int32_t(0x5782B249)},
    {"sidebar.shp", "misc: sidebar", int32_t(0x7205F024), int32_t(0x00000000)},
    {"sidebttn.shp", "", int32_t(0x00000000), int32_t(0x2F43F08B)},
    {"sidec01.mix", "-", int32_t(0x00000000), int32_t(0xDD991D13)},
    {"sidec02.mix", "-", int32_t(0x00000000), int32_t(0x5B0D6FBD)},
    {"sidec02md.mix", "", int32_t(0x00000000), int32_t(0xA9817776)},
    {"sidefnt3.pal", "-", int32_t(0x00000000), int32_t(0xAE6040D0)},
    {"sidegdi1.shp", "-", int32_t(0x00000000), int32_t(0xC4B7047A)},
    {"sidegdi2.shp", "-", int32_t(0x00000000), int32_t(0x83177EAA)},
    {"sidegdi3.shp", "-", int32_t(0x00000000), int32_t(0xBE77571A)},
    {"sidenc01.mix", "-", int32_t(0x00000000), int32_t(0x330A4ADF)},
    {"sidenc02.mix", "-", int32_t(0x00000000), int32_t(0x74AA300F)},
    {"sides.pal", "pal: ???", int32_t(0x97B1823F), int32_t(0x00000000)},
    {"sign01.des", "", int32_t(0x00000000), int32_t(0x1ABF259A)},
    {"sign01.lun", "", int32_t(0x00000000), int32_t(0x739F1983)},
    {"sign01.sno", "", int32_t(0x00000000), int32_t(0x9D906A95)},
    {"sign01.tem", "", int32_t(0x00000000), int32_t(0x6CE73C62)},
    {"sign01.ubn", "", int32_t(0x00000000), int32_t(0x50720691)},
    {"sign01.urb", "", int32_t(0x00000000), int32_t(0x14C6B80E)},
    {"sign02.des", "", int32_t(0x00000000), int32_t(0x2B573F07)},
    {"sign02.lun", "", int32_t(0x00000000), int32_t(0x4277031E)},
    {"sign02.sno", "", int32_t(0x00000000), int32_t(0xAC787008)},
    {"sign02.tem", "", int32_t(0x00000000), int32_t(0x5D0F26FF)},
    {"sign02.ubn", "", int32_t(0x00000000), int32_t(0x619A1C0C)},
    {"sign02.urb", "", int32_t(0x00000000), int32_t(0x252EA293)},
    {"sign03.des", "", int32_t(0x00000000), int32_t(0x8D2034B3)},
    {"sign03.lun", "", int32_t(0x00000000), int32_t(0xE40008AA)},
    {"sign03.sno", "", int32_t(0x00000000), int32_t(0x0A0F7BBC)},
    {"sign03.tem", "", int32_t(0x00000000), int32_t(0xFB782D4B)},
    {"sign03.ubn", "", int32_t(0x00000000), int32_t(0xC7ED17B8)},
    {"sign03.urb", "", int32_t(0x00000000), int32_t(0x8359A927)},
    {"sign04.des", "", int32_t(0x00000000), int32_t(0x48870A3D)},
    {"sign04.lun", "", int32_t(0x00000000), int32_t(0x21A73624)},
    {"sign04.sno", "", int32_t(0x00000000), int32_t(0xCFA84532)},
    {"sign04.tem", "", int32_t(0x00000000), int32_t(0x3EDF13C5)},
    {"sign04.ubn", "", int32_t(0x00000000), int32_t(0x024A2936)},
    {"sign04.urb", "", int32_t(0x00000000), int32_t(0x46FE97A9)},
    {"sign05.des", "", int32_t(0x00000000), int32_t(0xEEF00189)},
    {"sign05.lun", "", int32_t(0x00000000), int32_t(0x87D03D90)},
    {"sign05.sno", "", int32_t(0x00000000), int32_t(0x69DF4E86)},
    {"sign05.tem", "", int32_t(0x00000000), int32_t(0x98A81871)},
    {"sign05.ubn", "", int32_t(0x00000000), int32_t(0xA43D2282)},
    {"sign05.urb", "", int32_t(0x00000000), int32_t(0xE0899C1D)},
    {"sign06.des", "", int32_t(0x00000000), int32_t(0xDF181B14)},
    {"sign06.lun", "", int32_t(0x00000000), int32_t(0xB638270D)},
    {"sign06.sno", "", int32_t(0x00000000), int32_t(0x5837541B)},
    {"sign06.tem", "", int32_t(0x00000000), int32_t(0xA94002EC)},
    {"sign06.ubn", "", int32_t(0x00000000), int32_t(0x95D5381F)},
    {"sign06.urb", "", int32_t(0x00000000), int32_t(0xD1618680)},
    {"silence.aud", "", int32_t(0x7200012A), int32_t(0x00000000)},
    {"silencer.aud", "tanya silenced shoot", int32_t(0xFE10ED17), int32_t(0x5ECC63B2)},
    {"silo.shp", "silo", int32_t(0xEEE0E5D4), int32_t(0x00000000)},
    {"siloicnh.des", "icon: silo", int32_t(0x2112F00D), int32_t(0x00000000)},
    {"siloicnh.tem", "icon: silo", int32_t(0x1B13000D), int32_t(0x00000000)},
    {"siloicnh.win", "icon: silo", int32_t(0x1C17030D), int32_t(0x00000000)},
    {"siloicon.shp", "icon: silo", int32_t(0x2A17FF0D), int32_t(0x3FB876AF)},
    {"silomake.shp", "make: silo", int32_t(0x180FFB15), int32_t(0x00000000)},
    {"silond1.aud", "silos needed", int32_t(0x99D8032A), int32_t(0x00000000)},
    {"silos1.aud", "silos needed", int32_t(0xBF8DCC48), int32_t(0x00000000)},
    {"sim1atk1.aud", "", int32_t(0x6C210EFD), int32_t(0x00000000)},
    {"sim1die1.aud", "", int32_t(0x6C14F903), int32_t(0x00000000)},
    {"sim1die2.aud", "", int32_t(0x6E14F903), int32_t(0x00000000)},
    {"sim1hit1.aud", "", int32_t(0x6C32F90B), int32_t(0x00000000)},
    {"sim1hit2.aud", "", int32_t(0x6E32F90B), int32_t(0x00000000)},
    {"sim1loi1.aud", "", int32_t(0x6C1D0513), int32_t(0x00000000)},
    {"sim1loi2.aud", "", int32_t(0x6E1D0513), int32_t(0x00000000)},
    {"sim1stn1.aud", "", int32_t(0x6C270F21), int32_t(0x00000000)},
    {"sim1stn2.aud", "", int32_t(0x6E270F21), int32_t(0x00000000)},
    {"sim1wlk1.aud", "", int32_t(0x6C20FF29), int32_t(0x00000000)},
    {"sim2at1a.aud", "", int32_t(0x8FED0EFD), int32_t(0x00000000)},
    {"sim2at1b.aud", "", int32_t(0x91ED0EFD), int32_t(0x00000000)},
    {"sim2die1.aud", "", int32_t(0x7014F903), int32_t(0x00000000)},
    {"sim2die2.aud", "", int32_t(0x7214F903), int32_t(0x00000000)},
    {"sim2hit1.aud", "", int32_t(0x7032F90B), int32_t(0x00000000)},
    {"sim2loi1.aud", "", int32_t(0x701D0513), int32_t(0x00000000)},
    {"sim2loi2.aud", "", int32_t(0x721D0513), int32_t(0x00000000)},
    {"sim2stn1.aud", "", int32_t(0x70270F21), int32_t(0x00000000)},
    {"sim2stn2.aud", "", int32_t(0x72270F21), int32_t(0x00000000)},
    {"sim2wk1a.aud", "", int32_t(0x8FECFD29), int32_t(0x00000000)},
    {"sim2wk1b.aud", "", int32_t(0x91ECFD29), int32_t(0x00000000)},
    {"sim2wk2a.aud", "", int32_t(0x8FEEFD29), int32_t(0x00000000)},
    {"sim2wk2b.aud", "", int32_t(0x91EEFD29), int32_t(0x00000000)},
    {"sindeed1.aud", "spy: indeed", int32_t(0xB816F105), int32_t(0x00000000)},
    {"sinkhole.ini", "", int32_t(0x00000000), int32_t(0xBF6FF72B)},
    {"sinkhole.map", "-", int32_t(0x00000000), int32_t(0x5B95EBF8)},
    {"siren2.aud", "", int32_t(0x97A5CE3E), int32_t(0x00000000)},
    {"sitduck.vqa", "ship blowing up", int32_t(0x6E28FD4D), int32_t(0x00000000)},
    {"sitduck.vqp", "vqp: ship blowing up", int32_t(0x6E37FD4D), int32_t(0x00000000)},
    {"sizzle.csv", "", int32_t(0xEFC60638), int32_t(0x00000000)},
    {"sizzle.lsv", "", int32_t(0x01C60637), int32_t(0x00000000)},
    {"sizzle.vqa", "", int32_t(0x15C5F135), int32_t(0x00000000)},
    {"sizzle1.vqa", "", int32_t(0xC60D013B), int32_t(0xFEDA4786)},
    {"sizzle1.vqp", "", int32_t(0xC61C013B), int32_t(0x00000000)},
    {"sizzle2.vqa", "", int32_t(0xC60F013B), int32_t(0x00000000)},
    {"sizzle2.vqp", "", int32_t(0xC61E013B), int32_t(0x00000000)},
    {"sizzle_h.pcx", "", int32_t(0x526B0013), int32_t(0x00000000)},
    {"sizzle_h.vqa", "", int32_t(0x3B790613), int32_t(0x00000000)},
    {"sizzle_l.pcx", "", int32_t(0x5A6B0012), int32_t(0x00000000)},
    {"sizzle_l.vqa", "", int32_t(0x43790612), int32_t(0x00000000)},
    {"skclaw1.aud", "", int32_t(0x8DB43110), int32_t(0x00000000)},
    {"skclaw2.aud", "", int32_t(0x8DB63110), int32_t(0x00000000)},
    {"skel226m.aud", "", int32_t(0x0FD6D2DF), int32_t(0x00000000)},
    {"skelatk1.aud", "", int32_t(0xD80116FD), int32_t(0x00000000)},
    {"skelatk2.aud", "", int32_t(0xDA0116FD), int32_t(0x00000000)},
    {"skelatk3.aud", "", int32_t(0xDC0116FD), int32_t(0x00000000)},
    {"skelbat1.aud", "", int32_t(0xD812F0FF), int32_t(0x00000000)},
    {"skeldie1.aud", "", int32_t(0xD7F50103), int32_t(0x00000000)},
    {"skeldie2.aud", "", int32_t(0xD9F50103), int32_t(0x00000000)},
    {"skeleton.vqa", "", int32_t(0x0F052C05), int32_t(0x00000000)},
    {"skelhit1.aud", "", int32_t(0xD813010B), int32_t(0x00000000)},
    {"skelhit2.aud", "", int32_t(0xDA13010B), int32_t(0x00000000)},
    {"skelkey1.aud", "", int32_t(0xD81CF911), int32_t(0x00000000)},
    {"skelkey2.aud", "", int32_t(0xDA1CF911), int32_t(0x00000000)},
    {"skelton1.aud", "", int32_t(0xD8070D23), int32_t(0x00000000)},
    {"skelwlk1.aud", "", int32_t(0xD8010729), int32_t(0x00000000)},
    {"skelwlk3.aud", "", int32_t(0xDC010729), int32_t(0x00000000)},
    {"skelwlk4.aud", "", int32_t(0xDE010729), int32_t(0x00000000)},
    {"skelwlk5.aud", "", int32_t(0xE0010729), int32_t(0x00000000)},
    {"skelwlk6.aud", "", int32_t(0xE2010729), int32_t(0x00000000)},
    {"skelwlk7.aud", "", int32_t(0xE4010729), int32_t(0x00000000)},
    {"skinbed1.aud", "", int32_t(0xE002F8FF), int32_t(0x00000000)},
    {"sking1.aud", "spy: for king and country", int32_t(0xBB81D430), int32_t(0x00000000)},
    {"sklatk1.aud", "", int32_t(0x61D81936), int32_t(0x00000000)},
    {"sklhurt1.aud", "", int32_t(0xC82F1325), int32_t(0x00000000)},
    {"sklrise1.aud", "", int32_t(0xF011150D), int32_t(0x00000000)},
    {"skulfade.flc", "", int32_t(0xFF29F607), int32_t(0x00000000)},
    {"skwalk1.aud", "", int32_t(0x62041926), int32_t(0x00000000)},
    {"skwalk2.aud", "", int32_t(0x62061926), int32_t(0x00000000)},
    {"slat01.tem", "-", int32_t(0x00000000), int32_t(0x29402888)},
    {"slat01a.tem", "-", int32_t(0x00000000), int32_t(0x6D68BB44)},
    {"slat02.tem", "-", int32_t(0x00000000), int32_t(0x18A83215)},
    {"slat02a.tem", "-", int32_t(0x00000000), int32_t(0x5C80A1D9)},
    {"slat03.tem", "-", int32_t(0x00000000), int32_t(0xBEDF39A1)},
    {"slat03a.tem", "-", int32_t(0x00000000), int32_t(0xFAF7AA6D)},
    {"slat04.tem", "-", int32_t(0x00000000), int32_t(0x7B78072F)},
    {"slat04a.tem", "-", int32_t(0x00000000), int32_t(0x3F5094E3)},
    {"slat05.tem", "-", int32_t(0x00000000), int32_t(0xDD0F0C9B)},
    {"slat05a.tem", "-", int32_t(0x00000000), int32_t(0x99279F57)},
    {"slat06.tem", "-", int32_t(0x00000000), int32_t(0xECE71606)},
    {"slat06a.tem", "-", int32_t(0x00000000), int32_t(0xA8CF85CA)},
    {"slat07.tem", "-", int32_t(0x00000000), int32_t(0x4A901DB2)},
    {"slat07a.tem", "-", int32_t(0x00000000), int32_t(0x0EB88E7E)},
    {"slat08.tem", "-", int32_t(0x00000000), int32_t(0xBCD86D5B)},
    {"slat08a.tem", "-", int32_t(0x00000000), int32_t(0xF8F0FE97)},
    {"slat09.tem", "-", int32_t(0x00000000), int32_t(0x1AAF66EF)},
    {"slat09a.tem", "-", int32_t(0x00000000), int32_t(0x5E87F523)},
    {"slat10.tem", "-", int32_t(0x00000000), int32_t(0x439D23A2)},
    {"slat10a.tem", "-", int32_t(0x00000000), int32_t(0x07B5B06E)},
    {"slat11.tem", "-", int32_t(0x00000000), int32_t(0xE5EA2816)},
    {"slat11a.tem", "-", int32_t(0x00000000), int32_t(0xA1C2BBDA)},
    {"slat12.tem", "-", int32_t(0x00000000), int32_t(0xD402328B)},
    {"slat12a.tem", "-", int32_t(0x00000000), int32_t(0x902AA147)},
    {"slat13.tem", "-", int32_t(0x00000000), int32_t(0x7275393F)},
    {"slat13a.tem", "-", int32_t(0x00000000), int32_t(0x365DAAF3)},
    {"slat14.tem", "-", int32_t(0x00000000), int32_t(0xB7D207B1)},
    {"slat14a.tem", "-", int32_t(0x00000000), int32_t(0xF3FA947D)},
    {"slat15.tem", "-", int32_t(0x00000000), int32_t(0x11A50C05)},
    {"slat15a.tem", "-", int32_t(0x00000000), int32_t(0x558D9FC9)},
    {"slat16.tem", "-", int32_t(0x00000000), int32_t(0x204D1698)},
    {"slat16a.tem", "-", int32_t(0x00000000), int32_t(0x64658554)},
    {"slav.shp", "unit: slavick", int32_t(0x00000000), int32_t(0x33AB0BFE)},
    {"slavesys.aud", "-", int32_t(0x00000000), int32_t(0x3CE8513C)},
    {"slcttgt1.aud", "select target", int32_t(0xF80B0123), int32_t(0x00000000)},
    {"slidechg.aud", "", int32_t(0x00000000), int32_t(0x973D078D)},
    {"slideout.aud", "", int32_t(0xFE251105), int32_t(0xC89591EE)},
    {"slntsrvc.vqa", "sub on sea bed", int32_t(0x19372C21), int32_t(0x00000000)},
    {"slntsrvc.vqp", "vqp: sub on sea bed", int32_t(0x28372C21), int32_t(0x00000000)},
    {"slop01z.des", "", int32_t(0x00000000), int32_t(0xC30440E3)},
    {"slop01z.lun", "", int32_t(0x00000000), int32_t(0xE5FAA760)},
    {"slop01z.sno", "-", int32_t(0x00000000), int32_t(0xE4E89D79)},
    {"slop01z.tem", "-", int32_t(0x00000000), int32_t(0x475C28A3)},
    {"slop01z.ubn", "", int32_t(0x00000000), int32_t(0xD1820A80)},
    {"slop01z.urb", "", int32_t(0x00000000), int32_t(0x6111E6FC)},
    {"slop02z.des", "", int32_t(0x00000000), int32_t(0xF2EC5A7E)},
    {"slop02z.lun", "", int32_t(0x00000000), int32_t(0xD412BDFD)},
    {"slop02z.sno", "-", int32_t(0x00000000), int32_t(0xD50087E4)},
    {"slop02z.tem", "-", int32_t(0x00000000), int32_t(0x76B4323E)},
    {"slop02z.ubn", "", int32_t(0x00000000), int32_t(0xE06A101D)},
    {"slop02z.urb", "", int32_t(0x00000000), int32_t(0x50F9FC61)},
    {"slop03z.des", "", int32_t(0x00000000), int32_t(0x549B51CA)},
    {"slop03z.lun", "", int32_t(0x00000000), int32_t(0x7265B649)},
    {"slop03z.sno", "-", int32_t(0x00000000), int32_t(0x73778C50)},
    {"slop03z.tem", "-", int32_t(0x00000000), int32_t(0xD0C3398A)},
    {"slop03z.ubn", "", int32_t(0x00000000), int32_t(0x461D1BA9)},
    {"slop03z.urb", "", int32_t(0x00000000), int32_t(0xF68EF7D5)},
    {"slop04z.des", "", int32_t(0x00000000), int32_t(0x913C6F44)},
    {"slop04z.lun", "", int32_t(0x00000000), int32_t(0xB7C288C7)},
    {"slop04z.sno", "-", int32_t(0x00000000), int32_t(0xB6D0B2DE)},
    {"slop04z.tem", "-", int32_t(0x00000000), int32_t(0x15640704)},
    {"slop04z.ubn", "", int32_t(0x00000000), int32_t(0x83BA2527)},
    {"slop04z.urb", "", int32_t(0x00000000), int32_t(0x3329C95B)},
    {"slope01.des", "", int32_t(0x00000000), int32_t(0xE3F02B3A)},
    {"slope01.lun", "", int32_t(0x00000000), int32_t(0xC50ECCB9)},
    {"slope01.sno", "-", int32_t(0x00000000), int32_t(0xC41CF6A0)},
    {"slope01.tem", "-", int32_t(0x00000000), int32_t(0x67A8437A)},
    {"slope01.ubn", "", int32_t(0x00000000), int32_t(0xF1766159)},
    {"slope01.urb", "", int32_t(0x00000000), int32_t(0x41E58D25)},
    {"slope01a.des", "", int32_t(0x00000000), int32_t(0xDA3852D5)},
    {"slope01a.lun", "", int32_t(0x00000000), int32_t(0xFDEF7DE5)},
    {"slope01a.sno", "-", int32_t(0x00000000), int32_t(0x34A462A4)},
    {"slope01a.tem", "-", int32_t(0x00000000), int32_t(0x3C11CCC6)},
    {"slope01a.ubn", "", int32_t(0x00000000), int32_t(0xEB9B618C)},
    {"slope01a.urb", "", int32_t(0x00000000), int32_t(0xA8EF3FF6)},
    {"slope01b.des", "", int32_t(0x00000000), int32_t(0x9D982805)},
    {"slope01b.lun", "", int32_t(0x00000000), int32_t(0xBA4F0735)},
    {"slope01b.sno", "-", int32_t(0x00000000), int32_t(0x73041874)},
    {"slope01b.tem", "-", int32_t(0x00000000), int32_t(0x7BB1B616)},
    {"slope01b.ubn", "", int32_t(0x00000000), int32_t(0xAC3B1B5C)},
    {"slope01b.urb", "", int32_t(0x00000000), int32_t(0xEF4F4526)},
    {"slope01c.des", "", int32_t(0x00000000), int32_t(0xA0F801B5)},
    {"slope01c.lun", "", int32_t(0x00000000), int32_t(0x872F2E85)},
    {"slope01c.sno", "-", int32_t(0x00000000), int32_t(0x4E6431C4)},
    {"slope01c.tem", "-", int32_t(0x00000000), int32_t(0x46D19FA6)},
    {"slope01c.ubn", "", int32_t(0x00000000), int32_t(0x915B32EC)},
    {"slope01c.urb", "", int32_t(0x00000000), int32_t(0xD22F6C96)},
    {"slope02.des", "", int32_t(0x00000000), int32_t(0x65645994)},
    {"slope02.lun", "", int32_t(0x00000000), int32_t(0x439ABE17)},
    {"slope02.sno", "-", int32_t(0x00000000), int32_t(0x4288840E)},
    {"slope02.tem", "-", int32_t(0x00000000), int32_t(0xE13C31D4)},
    {"slope02.ubn", "", int32_t(0x00000000), int32_t(0x77E213F7)},
    {"slope02.urb", "", int32_t(0x00000000), int32_t(0xC771FF8B)},
    {"slope02a.des", "", int32_t(0x00000000), int32_t(0x5CAC207B)},
    {"slope02a.lun", "", int32_t(0x00000000), int32_t(0x7B7B0F4B)},
    {"slope02a.sno", "-", int32_t(0x00000000), int32_t(0xB230100A)},
    {"slope02a.tem", "-", int32_t(0x00000000), int32_t(0xBA85BE68)},
    {"slope02a.ubn", "", int32_t(0x00000000), int32_t(0x6D0F1322)},
    {"slope02a.urb", "", int32_t(0x00000000), int32_t(0x2E7B4D58)},
    {"slope02b.des", "", int32_t(0x00000000), int32_t(0x1B0C5AAB)},
    {"slope02b.lun", "", int32_t(0x00000000), int32_t(0x3CDB759B)},
    {"slope02b.sno", "-", int32_t(0x00000000), int32_t(0xF5906ADA)},
    {"slope02b.tem", "-", int32_t(0x00000000), int32_t(0xFD25C4B8)},
    {"slope02b.ubn", "", int32_t(0x00000000), int32_t(0x2AAF69F2)},
    {"slope02b.urb", "", int32_t(0x00000000), int32_t(0x69DB3788)},
    {"slope02c.des", "", int32_t(0x00000000), int32_t(0x266C731B)},
    {"slope02c.lun", "", int32_t(0x00000000), int32_t(0x01BB5C2B)},
    {"slope02c.sno", "-", int32_t(0x00000000), int32_t(0xC8F0436A)},
    {"slope02c.tem", "-", int32_t(0x00000000), int32_t(0xC045ED08)},
    {"slope02c.ubn", "", int32_t(0x00000000), int32_t(0x17CF4042)},
    {"slope02c.urb", "", int32_t(0x00000000), int32_t(0x54BB1E38)},
    {"slope03.des", "", int32_t(0x00000000), int32_t(0xAE388A31)},
    {"slope03.lun", "", int32_t(0x00000000), int32_t(0x88C66DB2)},
    {"slope03.sno", "-", int32_t(0x00000000), int32_t(0x89D457AB)},
    {"slope03.tem", "-", int32_t(0x00000000), int32_t(0x2A60E271)},
    {"slope03.ubn", "", int32_t(0x00000000), int32_t(0xBCBEC052)},
    {"slope03.urb", "", int32_t(0x00000000), int32_t(0x0C2D2C2E)},
    {"slope03a.des", "", int32_t(0x00000000), int32_t(0x97F0F3DE)},
    {"slope03a.lun", "", int32_t(0x00000000), int32_t(0xB027DCEE)},
    {"slope03a.sno", "-", int32_t(0x00000000), int32_t(0x796CC3AF)},
    {"slope03a.tem", "-", int32_t(0x00000000), int32_t(0x71D96DCD)},
    {"slope03a.ubn", "", int32_t(0x00000000), int32_t(0xA653C087)},
    {"slope03a.urb", "", int32_t(0x00000000), int32_t(0xE5279EFD)},
    {"slope03b.des", "", int32_t(0x00000000), int32_t(0xD050890E)},
    {"slope03b.lun", "", int32_t(0x00000000), int32_t(0xF787A63E)},
    {"slope03b.sno", "-", int32_t(0x00000000), int32_t(0x3ECCB97F)},
    {"slope03b.tem", "-", int32_t(0x00000000), int32_t(0x3679171D)},
    {"slope03b.ubn", "", int32_t(0x00000000), int32_t(0xE1F3BA57)},
    {"slope03b.urb", "", int32_t(0x00000000), int32_t(0xA287E42D)},
    {"slope03c.des", "", int32_t(0x00000000), int32_t(0xED30A0BE)},
    {"slope03c.lun", "", int32_t(0x00000000), int32_t(0xCAE78F8E)},
    {"slope03c.sno", "-", int32_t(0x00000000), int32_t(0x03AC90CF)},
    {"slope03c.tem", "-", int32_t(0x00000000), int32_t(0x0B193EAD)},
    {"slope03c.ubn", "", int32_t(0x00000000), int32_t(0xDC9393E7)},
    {"slope03c.urb", "", int32_t(0x00000000), int32_t(0x9FE7CD9D)},
    {"slope04.des", "", int32_t(0x00000000), int32_t(0xB33DBA89)},
    {"slope04.lun", "", int32_t(0x00000000), int32_t(0x95C35D0A)},
    {"slope04.sno", "-", int32_t(0x00000000), int32_t(0x94D16713)},
    {"slope04.tem", "-", int32_t(0x00000000), int32_t(0x3765D2C9)},
    {"slope04.ubn", "", int32_t(0x00000000), int32_t(0xA1BBF0EA)},
    {"slope04.urb", "", int32_t(0x00000000), int32_t(0x11281C96)},
    {"slope04a.des", "", int32_t(0x00000000), int32_t(0x8AF5C366)},
    {"slope04a.lun", "", int32_t(0x00000000), int32_t(0xAD22EC56)},
    {"slope04a.sno", "-", int32_t(0x00000000), int32_t(0x6469F317)},
    {"slope04a.tem", "-", int32_t(0x00000000), int32_t(0x6CDC5D75)},
    {"slope04a.ubn", "", int32_t(0x00000000), int32_t(0xBB56F03F)},
    {"slope04a.urb", "", int32_t(0x00000000), int32_t(0xF822AE45)},
    {"slope04b.des", "", int32_t(0x00000000), int32_t(0xCD55B9B6)},
    {"slope04b.lun", "", int32_t(0x00000000), int32_t(0xEA829686)},
    {"slope04b.sno", "-", int32_t(0x00000000), int32_t(0x23C989C7)},
    {"slope04b.tem", "-", int32_t(0x00000000), int32_t(0x2B7C27A5)},
    {"slope04b.ubn", "", int32_t(0x00000000), int32_t(0xFCF68AEF)},
    {"slope04b.urb", "", int32_t(0x00000000), int32_t(0xBF82D495)},
    {"slope04c.des", "", int32_t(0x00000000), int32_t(0xF0359006)},
    {"slope04c.lun", "", int32_t(0x00000000), int32_t(0xD7E2BF36)},
    {"slope04c.sno", "-", int32_t(0x00000000), int32_t(0x1EA9A077)},
    {"slope04c.tem", "-", int32_t(0x00000000), int32_t(0x161C0E15)},
    {"slope04c.ubn", "", int32_t(0x00000000), int32_t(0xC196A35F)},
    {"slope04c.urb", "", int32_t(0x00000000), int32_t(0x82E2FD25)},
    {"slope05.des", "", int32_t(0x00000000), int32_t(0x7861692C)},
    {"slope05.lun", "", int32_t(0x00000000), int32_t(0x5E9F8EAF)},
    {"slope05.sno", "-", int32_t(0x00000000), int32_t(0x5F8DB4B6)},
    {"slope05.tem", "-", int32_t(0x00000000), int32_t(0xFC39016C)},
    {"slope05.ubn", "", int32_t(0x00000000), int32_t(0x6AE7234F)},
    {"slope05.urb", "", int32_t(0x00000000), int32_t(0xDA74CF33)},
    {"slope05a.des", "", int32_t(0x00000000), int32_t(0x41A910C3)},
    {"slope05a.lun", "", int32_t(0x00000000), int32_t(0x667E3FF3)},
    {"slope05a.sno", "-", int32_t(0x00000000), int32_t(0xAF3520B2)},
    {"slope05a.tem", "-", int32_t(0x00000000), int32_t(0xA7808ED0)},
    {"slope05a.ubn", "", int32_t(0x00000000), int32_t(0x700A239A)},
    {"slope05a.urb", "", int32_t(0x00000000), int32_t(0x337E7DE0)},
    {"slope05b.des", "", int32_t(0x00000000), int32_t(0x06096A13)},
    {"slope05b.lun", "", int32_t(0x00000000), int32_t(0x21DE4523)},
    {"slope05b.sno", "-", int32_t(0x00000000), int32_t(0xE8955A62)},
    {"slope05b.tem", "-", int32_t(0x00000000), int32_t(0xE020F400)},
    {"slope05b.ubn", "", int32_t(0x00000000), int32_t(0x37AA594A)},
    {"slope05b.urb", "", int32_t(0x00000000), int32_t(0x74DE0730)},
    {"slope05c.des", "", int32_t(0x00000000), int32_t(0x3B6943A3)},
    {"slope05c.lun", "", int32_t(0x00000000), int32_t(0x1CBE6C93)},
    {"slope05c.sno", "-", int32_t(0x00000000), int32_t(0xD5F573D2)},
    {"slope05c.tem", "-", int32_t(0x00000000), int32_t(0xDD40DDB0)},
    {"slope05c.ubn", "", int32_t(0x00000000), int32_t(0x0ACA70FA)},
    {"slope05c.urb", "", int32_t(0x00000000), int32_t(0x49BE2E80)},
    {"slope06.des", "", int32_t(0x00000000), int32_t(0xFEF51B82)},
    {"slope06.lun", "", int32_t(0x00000000), int32_t(0xD80BFC01)},
    {"slope06.sno", "-", int32_t(0x00000000), int32_t(0xD919C618)},
    {"slope06.tem", "-", int32_t(0x00000000), int32_t(0x7AAD73C2)},
    {"slope06.ubn", "", int32_t(0x00000000), int32_t(0xEC7351E1)},
    {"slope06.urb", "", int32_t(0x00000000), int32_t(0x5CE0BD9D)},
    {"slope06a.des", "", int32_t(0x00000000), int32_t(0xC73D626D)},
    {"slope06a.lun", "", int32_t(0x00000000), int32_t(0xE0EA4D5D)},
    {"slope06a.sno", "-", int32_t(0x00000000), int32_t(0x29A1521C)},
    {"slope06a.tem", "-", int32_t(0x00000000), int32_t(0x2114FC7E)},
    {"slope06a.ubn", "", int32_t(0x00000000), int32_t(0xF69E5134)},
    {"slope06a.urb", "", int32_t(0x00000000), int32_t(0xB5EA0F4E)},
    {"slope06b.des", "", int32_t(0x00000000), int32_t(0x809D18BD)},
    {"slope06b.lun", "", int32_t(0x00000000), int32_t(0xA74A378D)},
    {"slope06b.sno", "-", int32_t(0x00000000), int32_t(0x6E0128CC)},
    {"slope06b.tem", "-", int32_t(0x00000000), int32_t(0x66B486AE)},
    {"slope06b.ubn", "", int32_t(0x00000000), int32_t(0xB13E2BE4)},
    {"slope06b.urb", "", int32_t(0x00000000), int32_t(0xF24A759E)},
    {"slope06c.des", "", int32_t(0x00000000), int32_t(0xBDFD310D)},
    {"slope06c.lun", "", int32_t(0x00000000), int32_t(0x9A2A1E3D)},
    {"slope06c.sno", "-", int32_t(0x00000000), int32_t(0x5361017C)},
    {"slope06c.tem", "-", int32_t(0x00000000), int32_t(0x5BD4AF1E)},
    {"slope06c.ubn", "", int32_t(0x00000000), int32_t(0x8C5E0254)},
    {"slope06c.urb", "", int32_t(0x00000000), int32_t(0xCF2A5C2E)},
    {"slope07.des", "", int32_t(0x00000000), int32_t(0x35A9C827)},
    {"slope07.lun", "", int32_t(0x00000000), int32_t(0x13572FA4)},
    {"slope07.sno", "-", int32_t(0x00000000), int32_t(0x124515BD)},
    {"slope07.tem", "-", int32_t(0x00000000), int32_t(0xB1F1A067)},
    {"slope07.ubn", "", int32_t(0x00000000), int32_t(0x272F8244)},
    {"slope07.urb", "", int32_t(0x00000000), int32_t(0x97BC6E38)},
    {"slope07a.des", "", int32_t(0x00000000), int32_t(0x0C61B1C8)},
    {"slope07a.lun", "", int32_t(0x00000000), int32_t(0x2BB69EF8)},
    {"slope07a.sno", "-", int32_t(0x00000000), int32_t(0xE2FD81B9)},
    {"slope07a.tem", "-", int32_t(0x00000000), int32_t(0xEA482FDB)},
    {"slope07a.ubn", "", int32_t(0x00000000), int32_t(0x3DC28291)},
    {"slope07a.urb", "", int32_t(0x00000000), int32_t(0x7EB6DCEB)},
    {"slope07b.des", "", int32_t(0x00000000), int32_t(0x4BC1CB18)},
    {"slope07b.lun", "", int32_t(0x00000000), int32_t(0x6C16E428)},
    {"slope07b.sno", "-", int32_t(0x00000000), int32_t(0xA55DFB69)},
    {"slope07b.tem", "-", int32_t(0x00000000), int32_t(0xADE8550B)},
    {"slope07b.ubn", "", int32_t(0x00000000), int32_t(0x7A62F841)},
    {"slope07b.urb", "", int32_t(0x00000000), int32_t(0x3916A63B)},
    {"slope07c.des", "", int32_t(0x00000000), int32_t(0x76A1E2A8)},
    {"slope07c.lun", "", int32_t(0x00000000), int32_t(0x5176CD98)},
    {"slope07c.sno", "-", int32_t(0x00000000), int32_t(0x983DD2D9)},
    {"slope07c.tem", "-", int32_t(0x00000000), int32_t(0x90887CBB)},
    {"slope07c.ubn", "", int32_t(0x00000000), int32_t(0x4702D1F1)},
    {"slope07c.urb", "", int32_t(0x00000000), int32_t(0x04768F8B)},
    {"slope08.des", "", int32_t(0x00000000), int32_t(0xC4FF7AF2)},
    {"slope08.lun", "", int32_t(0x00000000), int32_t(0xE2019D71)},
    {"slope08.sno", "-", int32_t(0x00000000), int32_t(0xE313A768)},
    {"slope08.tem", "-", int32_t(0x00000000), int32_t(0x40A712B2)},
    {"slope08.ubn", "", int32_t(0x00000000), int32_t(0xD6793091)},
    {"slope08.urb", "", int32_t(0x00000000), int32_t(0x66EADCED)},
    {"slope08a.des", "", int32_t(0x00000000), int32_t(0xFD37031D)},
    {"slope08a.lun", "", int32_t(0x00000000), int32_t(0xDAE02C2D)},
    {"slope08a.sno", "-", int32_t(0x00000000), int32_t(0x13AB336C)},
    {"slope08a.tem", "-", int32_t(0x00000000), int32_t(0x1B1E9D0E)},
    {"slope08a.ubn", "", int32_t(0x00000000), int32_t(0xCC943044)},
    {"slope08a.urb", "", int32_t(0x00000000), int32_t(0x8FE06E3E)},
    {"slope08b.des", "", int32_t(0x00000000), int32_t(0xBA9779CD)},
    {"slope08b.lun", "", int32_t(0x00000000), int32_t(0x9D4056FD)},
    {"slope08b.sno", "-", int32_t(0x00000000), int32_t(0x540B49BC)},
    {"slope08b.tem", "-", int32_t(0x00000000), int32_t(0x5CBEE7DE)},
    {"slope08b.ubn", "", int32_t(0x00000000), int32_t(0x8B344A94)},
    {"slope08b.urb", "", int32_t(0x00000000), int32_t(0xC84014EE)},
    {"slope08c.des", "", int32_t(0x00000000), int32_t(0x87F7507D)},
    {"slope08c.lun", "", int32_t(0x00000000), int32_t(0xA0207F4D)},
    {"slope08c.sno", "-", int32_t(0x00000000), int32_t(0x696B600C)},
    {"slope08c.tem", "-", int32_t(0x00000000), int32_t(0x61DECE6E)},
    {"slope08c.ubn", "", int32_t(0x00000000), int32_t(0xB6546324)},
    {"slope08c.urb", "", int32_t(0x00000000), int32_t(0xF5203D5E)},
    {"slope09.des", "", int32_t(0x00000000), int32_t(0x0FA3A957)},
    {"slope09.lun", "", int32_t(0x00000000), int32_t(0x295D4ED4)},
    {"slope09.sno", "-", int32_t(0x00000000), int32_t(0x284F74CD)},
    {"slope09.tem", "-", int32_t(0x00000000), int32_t(0x8BFBC117)},
    {"slope09.ubn", "", int32_t(0x00000000), int32_t(0x1D25E334)},
    {"slope09.urb", "", int32_t(0x00000000), int32_t(0xADB60F48)},
    {"slope09a.des", "", int32_t(0x00000000), int32_t(0x366BD0B8)},
    {"slope09a.lun", "", int32_t(0x00000000), int32_t(0x11BCFF88)},
    {"slope09a.sno", "-", int32_t(0x00000000), int32_t(0xD8F7E0C9)},
    {"slope09a.tem", "-", int32_t(0x00000000), int32_t(0xD0424EAB)},
    {"slope09a.ubn", "", int32_t(0x00000000), int32_t(0x07C8E3E1)},
    {"slope09a.urb", "", int32_t(0x00000000), int32_t(0x44BCBD9B)},
    {"slope09b.des", "", int32_t(0x00000000), int32_t(0x71CBAA68)},
    {"slope09b.lun", "", int32_t(0x00000000), int32_t(0x561C8558)},
    {"slope09b.sno", "-", int32_t(0x00000000), int32_t(0x9F579A19)},
    {"slope09b.tem", "-", int32_t(0x00000000), int32_t(0x97E2347B)},
    {"slope09b.ubn", "", int32_t(0x00000000), int32_t(0x40689931)},
    {"slope09b.urb", "", int32_t(0x00000000), int32_t(0x031CC74B)},
    {"slope09c.des", "", int32_t(0x00000000), int32_t(0x4CAB83D8)},
    {"slope09c.lun", "", int32_t(0x00000000), int32_t(0x6B7CACE8)},
    {"slope09c.sno", "-", int32_t(0x00000000), int32_t(0xA237B3A9)},
    {"slope09c.tem", "-", int32_t(0x00000000), int32_t(0xAA821DCB)},
    {"slope09c.ubn", "", int32_t(0x00000000), int32_t(0x7D08B081)},
    {"slope09c.urb", "", int32_t(0x00000000), int32_t(0x3E7CEEFB)},
    {"slope10.des", "", int32_t(0x00000000), int32_t(0x8EDBF32B)},
    {"slope10.lun", "", int32_t(0x00000000), int32_t(0xA82514A8)},
    {"slope10.sno", "-", int32_t(0x00000000), int32_t(0xA9372EB1)},
    {"slope10.tem", "-", int32_t(0x00000000), int32_t(0x0A839B6B)},
    {"slope10.ubn", "", int32_t(0x00000000), int32_t(0x9C5DB948)},
    {"slope10.urb", "", int32_t(0x00000000), int32_t(0x2CCE5534)},
    {"slope10a.des", "", int32_t(0x00000000), int32_t(0xB7138AC4)},
    {"slope10a.lun", "", int32_t(0x00000000), int32_t(0x90C4A5F4)},
    {"slope10a.sno", "-", int32_t(0x00000000), int32_t(0x598FBAB5)},
    {"slope10a.tem", "-", int32_t(0x00000000), int32_t(0x513A14D7)},
    {"slope10a.ubn", "", int32_t(0x00000000), int32_t(0x86B0B99D)},
    {"slope10a.urb", "", int32_t(0x00000000), int32_t(0xC5C4E7E7)},
    {"slope10b.des", "", int32_t(0x00000000), int32_t(0xF0B3F014)},
    {"slope10b.lun", "", int32_t(0x00000000), int32_t(0xD764DF24)},
    {"slope10b.sno", "-", int32_t(0x00000000), int32_t(0x1E2FC065)},
    {"slope10b.tem", "-", int32_t(0x00000000), int32_t(0x169A6E07)},
    {"slope10b.ubn", "", int32_t(0x00000000), int32_t(0xC110C34D)},
    {"slope10b.urb", "", int32_t(0x00000000), int32_t(0x82649D37)},
    {"slope10c.des", "", int32_t(0x00000000), int32_t(0xCDD3D9A4)},
    {"slope10c.lun", "", int32_t(0x00000000), int32_t(0xEA04F694)},
    {"slope10c.sno", "-", int32_t(0x00000000), int32_t(0x234FE9D5)},
    {"slope10c.tem", "-", int32_t(0x00000000), int32_t(0x2BFA47B7)},
    {"slope10c.ubn", "", int32_t(0x00000000), int32_t(0xFC70EAFD)},
    {"slope10c.urb", "", int32_t(0x00000000), int32_t(0xBF04B487)},
    {"slope11.des", "", int32_t(0x00000000), int32_t(0x4587208E)},
    {"slope11.lun", "", int32_t(0x00000000), int32_t(0x6379C70D)},
    {"slope11.sno", "-", int32_t(0x00000000), int32_t(0x626BFD14)},
    {"slope11.tem", "-", int32_t(0x00000000), int32_t(0xC1DF48CE)},
    {"slope11.ubn", "", int32_t(0x00000000), int32_t(0x57016AED)},
    {"slope11.urb", "", int32_t(0x00000000), int32_t(0xE7928691)},
    {"slope11a.des", "", int32_t(0x00000000), int32_t(0x7C4F5961)},
    {"slope11a.lun", "", int32_t(0x00000000), int32_t(0x5B987651)},
    {"slope11a.sno", "-", int32_t(0x00000000), int32_t(0x92D36910)},
    {"slope11a.tem", "-", int32_t(0x00000000), int32_t(0x9A66C772)},
    {"slope11a.ubn", "", int32_t(0x00000000), int32_t(0x4DEC6A38)},
    {"slope11a.urb", "", int32_t(0x00000000), int32_t(0x0E983442)},
    {"slope11b.des", "", int32_t(0x00000000), int32_t(0x3BEF23B1)},
    {"slope11b.lun", "", int32_t(0x00000000), int32_t(0x1C380C81)},
    {"slope11b.sno", "-", int32_t(0x00000000), int32_t(0xD57313C0)},
    {"slope11b.tem", "-", int32_t(0x00000000), int32_t(0xDDC6BDA2)},
    {"slope11b.ubn", "", int32_t(0x00000000), int32_t(0x0A4C10E8)},
    {"slope11b.urb", "", int32_t(0x00000000), int32_t(0x49384E92)},
    {"slope11c.des", "", int32_t(0x00000000), int32_t(0x068F0A01)},
    {"slope11c.lun", "", int32_t(0x00000000), int32_t(0x21582531)},
    {"slope11c.sno", "-", int32_t(0x00000000), int32_t(0xE8133A70)},
    {"slope11c.tem", "-", int32_t(0x00000000), int32_t(0xE0A69412)},
    {"slope11c.ubn", "", int32_t(0x00000000), int32_t(0x372C3958)},
    {"slope11c.urb", "", int32_t(0x00000000), int32_t(0x74586722)},
    {"slope12.des", "", int32_t(0x00000000), int32_t(0xC3135220)},
    {"slope12.lun", "", int32_t(0x00000000), int32_t(0xE5EDB5A3)},
    {"slope12.sno", "-", int32_t(0x00000000), int32_t(0xE4FF8FBA)},
    {"slope12.tem", "-", int32_t(0x00000000), int32_t(0x474B3A60)},
    {"slope12.ubn", "", int32_t(0x00000000), int32_t(0xD1951843)},
    {"slope12.urb", "", int32_t(0x00000000), int32_t(0x6106F43F)},
    {"slope12a.des", "", int32_t(0x00000000), int32_t(0xFADB2BCF)},
    {"slope12a.lun", "", int32_t(0x00000000), int32_t(0xDD0C04FF)},
    {"slope12a.sno", "-", int32_t(0x00000000), int32_t(0x14471BBE)},
    {"slope12a.tem", "-", int32_t(0x00000000), int32_t(0x1CF2B5DC)},
    {"slope12a.ubn", "", int32_t(0x00000000), int32_t(0xCB781896)},
    {"slope12a.urb", "", int32_t(0x00000000), int32_t(0x880C46EC)},
    {"slope12b.des", "", int32_t(0x00000000), int32_t(0xBD7B511F)},
    {"slope12b.lun", "", int32_t(0x00000000), int32_t(0x9AAC7E2F)},
    {"slope12b.sno", "-", int32_t(0x00000000), int32_t(0x53E7616E)},
    {"slope12b.tem", "-", int32_t(0x00000000), int32_t(0x5B52CF0C)},
    {"slope12b.ubn", "", int32_t(0x00000000), int32_t(0x8CD86246)},
    {"slope12b.urb", "", int32_t(0x00000000), int32_t(0xCFAC3C3C)},
    {"slope12c.des", "", int32_t(0x00000000), int32_t(0x801B78AF)},
    {"slope12c.lun", "", int32_t(0x00000000), int32_t(0xA7CC579F)},
    {"slope12c.sno", "-", int32_t(0x00000000), int32_t(0x6E8748DE)},
    {"slope12c.tem", "-", int32_t(0x00000000), int32_t(0x6632E6BC)},
    {"slope12c.ubn", "", int32_t(0x00000000), int32_t(0xB1B84BF6)},
    {"slope12c.urb", "", int32_t(0x00000000), int32_t(0xF2CC158C)},
    {"slope13.des", "", int32_t(0x00000000), int32_t(0x084F8185)},
    {"slope13.lun", "", int32_t(0x00000000), int32_t(0x2EB16606)},
    {"slope13.sno", "-", int32_t(0x00000000), int32_t(0x2FA35C1F)},
    {"slope13.tem", "-", int32_t(0x00000000), int32_t(0x8C17E9C5)},
    {"slope13.ubn", "", int32_t(0x00000000), int32_t(0x1AC9CBE6)},
    {"slope13.urb", "", int32_t(0x00000000), int32_t(0xAA5A279A)},
    {"slope13a.des", "", int32_t(0x00000000), int32_t(0x3187F86A)},
    {"slope13a.lun", "", int32_t(0x00000000), int32_t(0x1650D75A)},
    {"slope13a.sno", "-", int32_t(0x00000000), int32_t(0xDF1BC81B)},
    {"slope13a.tem", "-", int32_t(0x00000000), int32_t(0xD7AE6679)},
    {"slope13a.ubn", "", int32_t(0x00000000), int32_t(0x0024CB33)},
    {"slope13a.urb", "", int32_t(0x00000000), int32_t(0x43509549)},
    {"slope13b.des", "", int32_t(0x00000000), int32_t(0x762782BA)},
    {"slope13b.lun", "", int32_t(0x00000000), int32_t(0x51F0AD8A)},
    {"slope13b.sno", "-", int32_t(0x00000000), int32_t(0x98BBB2CB)},
    {"slope13b.tem", "-", int32_t(0x00000000), int32_t(0x900E1CA9)},
    {"slope13b.ubn", "", int32_t(0x00000000), int32_t(0x4784B1E3)},
    {"slope13b.urb", "", int32_t(0x00000000), int32_t(0x04F0EF99)},
    {"slope13c.des", "", int32_t(0x00000000), int32_t(0x4B47AB0A)},
    {"slope13c.lun", "", int32_t(0x00000000), int32_t(0x6C90843A)},
    {"slope13c.sno", "-", int32_t(0x00000000), int32_t(0xA5DB9B7B)},
    {"slope13c.tem", "-", int32_t(0x00000000), int32_t(0xAD6E3519)},
    {"slope13c.ubn", "", int32_t(0x00000000), int32_t(0x7AE49853)},
    {"slope13c.urb", "", int32_t(0x00000000), int32_t(0x3990C629)},
    {"slope14.des", "", int32_t(0x00000000), int32_t(0x154AB13D)},
    {"slope14.lun", "", int32_t(0x00000000), int32_t(0x33B456BE)},
    {"slope14.sno", "-", int32_t(0x00000000), int32_t(0x32A66CA7)},
    {"slope14.tem", "-", int32_t(0x00000000), int32_t(0x9112D97D)},
    {"slope14.ubn", "", int32_t(0x00000000), int32_t(0x07CCFB5E)},
    {"slope14.urb", "", int32_t(0x00000000), int32_t(0xB75F1722)},
    {"slope14a.des", "", int32_t(0x00000000), int32_t(0x2C82C8D2)},
    {"slope14a.lun", "", int32_t(0x00000000), int32_t(0x0B55E7E2)},
    {"slope14a.sno", "-", int32_t(0x00000000), int32_t(0xC21EF8A3)},
    {"slope14a.tem", "-", int32_t(0x00000000), int32_t(0xCAAB56C1)},
    {"slope14a.ubn", "", int32_t(0x00000000), int32_t(0x1D21FB8B)},
    {"slope14a.urb", "", int32_t(0x00000000), int32_t(0x5E55A5F1)},
    {"slope14b.des", "", int32_t(0x00000000), int32_t(0x6B22B202)},
    {"slope14b.lun", "", int32_t(0x00000000), int32_t(0x4CF59D32)},
    {"slope14b.sno", "-", int32_t(0x00000000), int32_t(0x85BE8273)},
    {"slope14b.tem", "-", int32_t(0x00000000), int32_t(0x8D0B2C11)},
    {"slope14b.ubn", "", int32_t(0x00000000), int32_t(0x5A81815B)},
    {"slope14b.urb", "", int32_t(0x00000000), int32_t(0x19F5DF21)},
    {"slope14c.des", "", int32_t(0x00000000), int32_t(0x56429BB2)},
    {"slope14c.lun", "", int32_t(0x00000000), int32_t(0x7195B482)},
    {"slope14c.sno", "-", int32_t(0x00000000), int32_t(0xB8DEABC3)},
    {"slope14c.tem", "-", int32_t(0x00000000), int32_t(0xB06B05A1)},
    {"slope14c.ubn", "", int32_t(0x00000000), int32_t(0x67E1A8EB)},
    {"slope14c.urb", "", int32_t(0x00000000), int32_t(0x2495F691)},
    {"slope15.des", "", int32_t(0x00000000), int32_t(0xDE166298)},
    {"slope15.lun", "", int32_t(0x00000000), int32_t(0xF8E8851B)},
    {"slope15.sno", "-", int32_t(0x00000000), int32_t(0xF9FABF02)},
    {"slope15.tem", "-", int32_t(0x00000000), int32_t(0x5A4E0AD8)},
    {"slope15.ubn", "", int32_t(0x00000000), int32_t(0xCC9028FB)},
    {"slope15.urb", "", int32_t(0x00000000), int32_t(0x7C03C487)},
    {"slope15a.des", "", int32_t(0x00000000), int32_t(0xE7DE1B77)},
    {"slope15a.lun", "", int32_t(0x00000000), int32_t(0xC0093447)},
    {"slope15a.sno", "-", int32_t(0x00000000), int32_t(0x09422B06)},
    {"slope15a.tem", "-", int32_t(0x00000000), int32_t(0x01F78564)},
    {"slope15a.ubn", "", int32_t(0x00000000), int32_t(0xD67D282E)},
    {"slope15a.urb", "", int32_t(0x00000000), int32_t(0x95097654)},
    {"slope15b.des", "", int32_t(0x00000000), int32_t(0xA07E61A7)},
    {"slope15b.lun", "", int32_t(0x00000000), int32_t(0x87A94E97)},
    {"slope15b.sno", "-", int32_t(0x00000000), int32_t(0x4EE251D6)},
    {"slope15b.tem", "-", int32_t(0x00000000), int32_t(0x4657FFB4)},
    {"slope15b.ubn", "", int32_t(0x00000000), int32_t(0x91DD52FE)},
    {"slope15b.urb", "", int32_t(0x00000000), int32_t(0xD2A90C84)},
    {"slope15c.des", "", int32_t(0x00000000), int32_t(0x9D1E4817)},
    {"slope15c.lun", "", int32_t(0x00000000), int32_t(0xBAC96727)},
    {"slope15c.sno", "-", int32_t(0x00000000), int32_t(0x73827866)},
    {"slope15c.tem", "-", int32_t(0x00000000), int32_t(0x7B37D604)},
    {"slope15c.ubn", "", int32_t(0x00000000), int32_t(0xACBD7B4E)},
    {"slope15c.urb", "", int32_t(0x00000000), int32_t(0xEFC92534)},
    {"slope16.des", "", int32_t(0x00000000), int32_t(0x58821036)},
    {"slope16.lun", "", int32_t(0x00000000), int32_t(0x7E7CF7B5)},
    {"slope16.sno", "-", int32_t(0x00000000), int32_t(0x7F6ECDAC)},
    {"slope16.tem", "-", int32_t(0x00000000), int32_t(0xDCDA7876)},
    {"slope16.ubn", "", int32_t(0x00000000), int32_t(0x4A045A55)},
    {"slope16.urb", "", int32_t(0x00000000), int32_t(0xFA97B629)},
    {"slope16a.des", "", int32_t(0x00000000), int32_t(0x614A69D9)},
    {"slope16a.lun", "", int32_t(0x00000000), int32_t(0x469D46E9)},
    {"slope16a.sno", "-", int32_t(0x00000000), int32_t(0x8FD659A8)},
    {"slope16a.tem", "-", int32_t(0x00000000), int32_t(0x8763F7CA)},
    {"slope16a.ubn", "", int32_t(0x00000000), int32_t(0x50E95A80)},
    {"slope16a.urb", "", int32_t(0x00000000), int32_t(0x139D04FA)},
    {"slope16b.des", "", int32_t(0x00000000), int32_t(0x26EA1309)},
    {"slope16b.lun", "", int32_t(0x00000000), int32_t(0x013D3C39)},
    {"slope16b.sno", "-", int32_t(0x00000000), int32_t(0xC8762378)},
    {"slope16b.tem", "-", int32_t(0x00000000), int32_t(0xC0C38D1A)},
    {"slope16b.ubn", "", int32_t(0x00000000), int32_t(0x17492050)},
    {"slope16b.urb", "", int32_t(0x00000000), int32_t(0x543D7E2A)},
    {"slope16c.des", "", int32_t(0x00000000), int32_t(0x1B8A3AB9)},
    {"slope16c.lun", "", int32_t(0x00000000), int32_t(0x3C5D1589)},
    {"slope16c.sno", "-", int32_t(0x00000000), int32_t(0xF5160AC8)},
    {"slope16c.tem", "-", int32_t(0x00000000), int32_t(0xFDA3A4AA)},
    {"slope16c.ubn", "", int32_t(0x00000000), int32_t(0x2A2909E0)},
    {"slope16c.urb", "", int32_t(0x00000000), int32_t(0x695D579A)},
    {"slope17.des", "", int32_t(0x00000000), int32_t(0x93DEC393)},
    {"slope17.lun", "", int32_t(0x00000000), int32_t(0xB5202410)},
    {"slope17.sno", "-", int32_t(0x00000000), int32_t(0xB4321E09)},
    {"slope17.tem", "-", int32_t(0x00000000), int32_t(0x1786ABD3)},
    {"slope17.ubn", "", int32_t(0x00000000), int32_t(0x815889F0)},
    {"slope17.urb", "", int32_t(0x00000000), int32_t(0x31CB658C)},
    {"slope18.des", "", int32_t(0x00000000), int32_t(0x62887146)},
    {"slope18.lun", "", int32_t(0x00000000), int32_t(0x447696C5)},
    {"slope18.sno", "-", int32_t(0x00000000), int32_t(0x4564ACDC)},
    {"slope18.tem", "-", int32_t(0x00000000), int32_t(0xE6D01906)},
    {"slope18.ubn", "", int32_t(0x00000000), int32_t(0x700E3B25)},
    {"slope18.urb", "", int32_t(0x00000000), int32_t(0xC09DD759)},
    {"slope19.des", "", int32_t(0x00000000), int32_t(0xA9D4A2E3)},
    {"slope19.lun", "", int32_t(0x00000000), int32_t(0x8F2A4560)},
    {"slope19.sno", "-", int32_t(0x00000000), int32_t(0x8E387F79)},
    {"slope19.tem", "-", int32_t(0x00000000), int32_t(0x2D8CCAA3)},
    {"slope19.ubn", "", int32_t(0x00000000), int32_t(0xBB52E880)},
    {"slope19.urb", "", int32_t(0x00000000), int32_t(0x0BC104FC)},
    {"slope20.des", "", int32_t(0x00000000), int32_t(0xBF33E9B6)},
    {"slope20.lun", "", int32_t(0x00000000), int32_t(0x99CD0E35)},
    {"slope20.sno", "-", int32_t(0x00000000), int32_t(0x98DF342C)},
    {"slope20.tem", "-", int32_t(0x00000000), int32_t(0x3B6B81F6)},
    {"slope20.ubn", "", int32_t(0x00000000), int32_t(0xADB5A3D5)},
    {"slope20.urb", "", int32_t(0x00000000), int32_t(0x1D264FA9)},
    {"slpex01.ubn", "", int32_t(0x00000000), int32_t(0x263A98F8)},
    {"slpex01a.ubn", "", int32_t(0x00000000), int32_t(0x3CD7982D)},
    {"slpex01b.ubn", "", int32_t(0x00000000), int32_t(0x7B77E2FD)},
    {"slpex01c.ubn", "", int32_t(0x00000000), int32_t(0x4617CB4D)},
    {"slpex02.ubn", "", int32_t(0x00000000), int32_t(0xA0AEEA56)},
    {"slpex02a.ubn", "", int32_t(0x00000000), int32_t(0xBA43EA83)},
    {"slpex02b.ubn", "", int32_t(0x00000000), int32_t(0xFDE39053)},
    {"slpex02c.ubn", "", int32_t(0x00000000), int32_t(0xC083B9E3)},
    {"slpex03.ubn", "", int32_t(0x00000000), int32_t(0x6BF239F3)},
    {"slpex03a.ubn", "", int32_t(0x00000000), int32_t(0x711F3926)},
    {"slpex03b.ubn", "", int32_t(0x00000000), int32_t(0x36BF43F6)},
    {"slpex03c.ubn", "", int32_t(0x00000000), int32_t(0x0BDF6A46)},
    {"slpex04.ubn", "", int32_t(0x00000000), int32_t(0x76F7094B)},
    {"slpex04a.ubn", "", int32_t(0x00000000), int32_t(0x6C1A099E)},
    {"slpex04b.ubn", "", int32_t(0x00000000), int32_t(0x2BBA734E)},
    {"slpex04c.ubn", "", int32_t(0x00000000), int32_t(0x16DA5AFE)},
    {"slpex05.ubn", "", int32_t(0x00000000), int32_t(0xBDABDAEE)},
    {"slpex05a.ubn", "", int32_t(0x00000000), int32_t(0xA746DA3B)},
    {"slpex05b.ubn", "", int32_t(0x00000000), int32_t(0xE0E6A0EB)},
    {"slpex05c.ubn", "", int32_t(0x00000000), int32_t(0xDD86895B)},
    {"slpex06.ubn", "", int32_t(0x00000000), int32_t(0x3B3FA840)},
    {"slpex06a.ubn", "", int32_t(0x00000000), int32_t(0x21D2A895)},
    {"slpex06b.ubn", "", int32_t(0x00000000), int32_t(0x6672D245)},
    {"slpex06c.ubn", "", int32_t(0x00000000), int32_t(0x5B12FBF5)},
    {"slpex07.ubn", "", int32_t(0x00000000), int32_t(0xF0637BE5)},
    {"slpex07a.ubn", "", int32_t(0x00000000), int32_t(0xEA8E7B30)},
    {"slpex07b.ubn", "", int32_t(0x00000000), int32_t(0xAD2E01E0)},
    {"slpex07c.ubn", "", int32_t(0x00000000), int32_t(0x904E2850)},
    {"slpex08.ubn", "", int32_t(0x00000000), int32_t(0x0135C930)},
    {"slpex08a.ubn", "", int32_t(0x00000000), int32_t(0x1BD8C9E5)},
    {"slpex08b.ubn", "", int32_t(0x00000000), int32_t(0x5C78B335)},
    {"slpex08c.ubn", "", int32_t(0x00000000), int32_t(0x61189A85)},
    {"slpex09.ubn", "", int32_t(0x00000000), int32_t(0xCA691A95)},
    {"slpex09a.ubn", "", int32_t(0x00000000), int32_t(0xD0841A40)},
    {"slpex09b.ubn", "", int32_t(0x00000000), int32_t(0x97246090)},
    {"slpex09c.ubn", "", int32_t(0x00000000), int32_t(0xAA444920)},
    {"slpex10.ubn", "", int32_t(0x00000000), int32_t(0x4B1140E9)},
    {"slpex10a.ubn", "", int32_t(0x00000000), int32_t(0x51FC403C)},
    {"slpex10b.ubn", "", int32_t(0x00000000), int32_t(0x165C3AEC)},
    {"slpex10c.ubn", "", int32_t(0x00000000), int32_t(0x2B3C135C)},
    {"slpex11.ubn", "", int32_t(0x00000000), int32_t(0x804D934C)},
    {"slpex11a.ubn", "", int32_t(0x00000000), int32_t(0x9AA09399)},
    {"slpex11b.ubn", "", int32_t(0x00000000), int32_t(0xDD00E949)},
    {"slpex11c.ubn", "", int32_t(0x00000000), int32_t(0xE060C0F9)},
    {"slpex12.ubn", "", int32_t(0x00000000), int32_t(0x06D9E1E2)},
    {"slpex12a.ubn", "", int32_t(0x00000000), int32_t(0x1C34E137)},
    {"slpex12b.ubn", "", int32_t(0x00000000), int32_t(0x5B949BE7)},
    {"slpex12c.ubn", "", int32_t(0x00000000), int32_t(0x66F4B257)},
    {"slpex13.ubn", "", int32_t(0x00000000), int32_t(0xCD853247)},
    {"slpex13a.ubn", "", int32_t(0x00000000), int32_t(0xD7683292)},
    {"slpex13b.ubn", "", int32_t(0x00000000), int32_t(0x90C84842)},
    {"slpex13c.ubn", "", int32_t(0x00000000), int32_t(0xADA861F2)},
    {"slpex14.ubn", "", int32_t(0x00000000), int32_t(0xD08002FF)},
    {"slpex14a.ubn", "", int32_t(0x00000000), int32_t(0xCA6D022A)},
    {"slpex14b.ubn", "", int32_t(0x00000000), int32_t(0x8DCD78FA)},
    {"slpex14c.ubn", "", int32_t(0x00000000), int32_t(0xB0AD514A)},
    {"slpex15.ubn", "", int32_t(0x00000000), int32_t(0x1BDCD15A)},
    {"slpex15a.ubn", "", int32_t(0x00000000), int32_t(0x0131D18F)},
    {"slpex15b.ubn", "", int32_t(0x00000000), int32_t(0x4691AB5F)},
    {"slpex15c.ubn", "", int32_t(0x00000000), int32_t(0x7BF182EF)},
    {"slpex16.ubn", "", int32_t(0x00000000), int32_t(0x9D48A3F4)},
    {"slpex16a.ubn", "", int32_t(0x00000000), int32_t(0x87A5A321)},
    {"slpex16b.ubn", "", int32_t(0x00000000), int32_t(0xC005D9F1)},
    {"slpex16c.ubn", "", int32_t(0x00000000), int32_t(0xFD65F041)},
    {"slpex17.ubn", "", int32_t(0x00000000), int32_t(0x56147051)},
    {"slpex18.ubn", "", int32_t(0x00000000), int32_t(0xA742C284)},
    {"slpex19.ubn", "", int32_t(0x00000000), int32_t(0x6C1E1121)},
    {"slpex20.ubn", "", int32_t(0x00000000), int32_t(0x7AF95A74)},
    {"sludge.flc", "", int32_t(0x9DB1FF27), int32_t(0x00000000)},
    {"slvkgun1.aud", "slavik gun", int32_t(0x00000000), int32_t(0x78C14AC2)},
    {"smbttn.shp", "", int32_t(0x00000000), int32_t(0x677D0A9B)},
    {"smcal1.aud", "", int32_t(0x8769DC3A), int32_t(0x00000000)},
    {"smcal2.aud", "", int32_t(0x8769DE3A), int32_t(0x00000000)},
    {"smcal3.aud", "", int32_t(0x8769E03A), int32_t(0x00000000)},
    {"smcal4.aud", "", int32_t(0x8769E23A), int32_t(0x00000000)},
    {"smchicon.shp", "icon: wolverine", int32_t(0x00000000), int32_t(0x1A0B3369)},
    {"smcv.hva", "", int32_t(0x00000000), int32_t(0x7696F2FD)},
    {"smcv.vxl", "", int32_t(0x00000000), int32_t(0x801C2DB4)},
    {"smcvicon.shp", "", int32_t(0x00000000), int32_t(0x7E09AA8A)},
    {"smcvuico.shp", "", int32_t(0x00000000), int32_t(0xBBCF386B)},
    {"smech.shp", "unit: wolverine", int32_t(0x00000000), int32_t(0x2E1C7220)},
    {"smig.shp", "unit: spyplane", int32_t(0xDEDAEDD4), int32_t(0x00000000)},
    {"smigicon.shp", "icon: spy plane", int32_t(0x0A0C0F0D), int32_t(0x00000000)},
    {"smin.hva", "", int32_t(0x00000000), int32_t(0x879D0DD8)},
    {"smin.vxl", "", int32_t(0x00000000), int32_t(0x7117D291)},
    {"sminicon.shp", "", int32_t(0x00000000), int32_t(0x7E33DA2A)},
    {"smintur.hva", "", int32_t(0x00000000), int32_t(0x80DFE01F)},
    {"smintur.vxl", "", int32_t(0x00000000), int32_t(0x8F2993F4)},
    {"sminuico.shp", "", int32_t(0x00000000), int32_t(0xBBF548CB)},
    {"smkpuff.shp", "", int32_t(0x00000000), int32_t(0x208A1275)},
    {"smlhurt1.aud", "", int32_t(0xC82F1B25), int32_t(0x00000000)},
    {"smlogo.shp", "-", int32_t(0x00000000), int32_t(0x0362DBF8)},
    {"smoke_m.shp", "smoke", int32_t(0x8A283C2A), int32_t(0x00000000)},
    {"smokey.shp", "smoke cloud", int32_t(0xD39A381F), int32_t(0xF3929F7E)},
    {"smokey2.shp", "-", int32_t(0x00000000), int32_t(0x7A6AFC78)},
    {"smokland.shp", "flare", int32_t(0x06220B13), int32_t(0x67293B6B)},
    {"smout1.aud", "thief: moving out!", int32_t(0xD799DC4A), int32_t(0x00000000)},
    {"smsh226m.aud", "smash", int32_t(0x000EDADF), int32_t(0x00000000)},
    {"snake.aud", "snake", int32_t(0xD787961B), int32_t(0x00000000)},
    {"snake1.aud", "", int32_t(0xAF61E02C), int32_t(0x00000000)},
    {"snake9.aud", "", int32_t(0xAF61F02C), int32_t(0x00000000)},
    {"sndinit1.aud", "audf:", int32_t(0xCC0F0D17), int32_t(0x00000000)},
    {"sndtst.wsa", "anim:", int32_t(0xFF6E2346), int32_t(0x00000000)},
    {"snipe.shp", "", int32_t(0x00000000), int32_t(0xA38A9FCA)},
    {"snipicon.shp", "", int32_t(0x00000000), int32_t(0x83D325C8)},
    {"snipuico.shp", "", int32_t(0x00000000), int32_t(0x4615B729)},
    {"sno.mix", "-", int32_t(0x00000000), int32_t(0xD71EBCFD)},
    {"snodpal1.pal", "pal: ???", int32_t(0xC0170C1B), int32_t(0x00000000)},
    {"snore1.aud", "", int32_t(0xCB99E02C), int32_t(0x00000000)},
    {"snotspew.aud", "", int32_t(0x441D1B21), int32_t(0x00000000)},
    {"snow.ini", "ts snow theater settings", int32_t(0x00000000), int32_t(0x80DE7BF7)},
    {"snow.mix", "snow.mix", int32_t(0x06E7E9D4), int32_t(0xA226651E)},
    {"snow.pal", "pal: snow", int32_t(0xFADFECD4), int32_t(0x64DB0B48)},
    {"snow01.des", "", int32_t(0x00000000), int32_t(0x203084C7)},
    {"snow01.sno", "-", int32_t(0x00000000), int32_t(0xA71FCBC8)},
    {"snow01.tem", "-", int32_t(0x00000000), int32_t(0x56689D3F)},
    {"snow01a.des", "", int32_t(0x00000000), int32_t(0x961866B3)},
    {"snow01a.sno", "-", int32_t(0x00000000), int32_t(0xB1F4BB29)},
    {"snow01a.tem", "-", int32_t(0x00000000), int32_t(0x12400EF3)},
    {"snow01b.des", "", int32_t(0x00000000), int32_t(0x108C141D)},
    {"snow01b.sno", "-", int32_t(0x00000000), int32_t(0x3760C987)},
    {"snow01b.tem", "-", int32_t(0x00000000), int32_t(0x94D47C5D)},
    {"snow01c.des", "", int32_t(0x00000000), int32_t(0xDBD0C7B8)},
    {"snow01c.sno", "-", int32_t(0x00000000), int32_t(0xFC3C1A22)},
    {"snow01c.tem", "-", int32_t(0x00000000), int32_t(0x5F88AFF8)},
    {"snow02.des", "", int32_t(0x00000000), int32_t(0x11D89E5A)},
    {"snow02.sno", "-", int32_t(0x00000000), int32_t(0x96F7D155)},
    {"snow02.tem", "-", int32_t(0x00000000), int32_t(0x678087A2)},
    {"snow03.des", "", int32_t(0x00000000), int32_t(0xB7AF95EE)},
    {"snow03.sno", "-", int32_t(0x00000000), int32_t(0x3080DAE1)},
    {"snow03.tem", "-", int32_t(0x00000000), int32_t(0xC1F78C16)},
    {"snow04.des", "", int32_t(0x00000000), int32_t(0x7208AB60)},
    {"snow04.sno", "-", int32_t(0x00000000), int32_t(0xF527E46F)},
    {"snow04.tem", "-", int32_t(0x00000000), int32_t(0x0450B298)},
    {"snowbase.vqa", "base being blown up in the snow", int32_t(0x293511FF), int32_t(0x00000000)},
    {"snowbase.vqp", "vqp: base being blown up in the snow", int32_t(0x383511FF), int32_t(0x00000000)},
    {"snowbomb.vqa", "base being blown up in the snow", int32_t(0x23292DFF), int32_t(0x00000000)},
    {"snowbomb.vqp", "vqp: base being blown up in the snow", int32_t(0x32292DFF), int32_t(0x00000000)},
    {"snowfild.vqa", "", int32_t(0x27272207), int32_t(0x00000000)},
    {"snowhit1.aud", "", int32_t(0x043B0D0B), int32_t(0x00000000)},
    {"snowmd.ini", "", int32_t(0x00000000), int32_t(0x00C74394)},
    {"snowmd.mix", "", int32_t(0x00000000), int32_t(0xEB108109)},
    {"snstrafe.vqa", "planes strafing vilage", int32_t(0x1D2B121F), int32_t(0x00000000)},
    {"snstrafe.vqp", "vqp: planes strafing vilage", int32_t(0x2C2B121F), int32_t(0x00000000)},
    {"sokay1.aud", "thief: ok!", int32_t(0x8789E454), int32_t(0x00000000)},
    {"sonarbox.shp", "crat: sonar pulse", int32_t(0x0620151F), int32_t(0x00000000)},
    {"sonic.hva", "-", int32_t(0x00000000), int32_t(0x21D94E7D)},
    {"sonic.vxl", "sonic tank", int32_t(0x00000000), int32_t(0x9E4049DA)},
    {"sonic4.aud", "sonic weapon fire", int32_t(0x00000000), int32_t(0x86BE6D70)},
    {"sonicbarl.hva", "-", int32_t(0x00000000), int32_t(0xB85D0B75)},
    {"sonictur.hva", "-", int32_t(0x00000000), int32_t(0x3A84A311)},
    {"sonictur.vxl", "sonic tank turret", int32_t(0x00000000), int32_t(0xCC0E7C58)},
    {"soniicon.shp", "icon: disruptor", int32_t(0x00000000), int32_t(0xA0E2155B)},
    {"sonpulse.aud", "sonar pulse", int32_t(0x10351725), int32_t(0x00000000)},
    {"sonricon.shp", "icon: sonar pulse", int32_t(0x3620170D), int32_t(0x00000000)},
    {"sonway1.aud", "spy: on my way", int32_t(0xB9E04510), int32_t(0x00000000)},
    {"soulamb1.aud", "", int32_t(0xD82F18FD), int32_t(0x00000000)},
    {"soulmix1.aud", "", int32_t(0xD85B1115), int32_t(0x00000000)},
    {"sound.ini", "ts sound settings", int32_t(0x00000000), int32_t(0x08497581)},
    {"sound01.ini", "fs sound settings", int32_t(0x00000000), int32_t(0xAC240880)},
    {"soundmd.ini", "", int32_t(0x00000000), int32_t(0x7A742519)},
    {"sounds.efx", "", int32_t(0xC3B23C1B), int32_t(0x00000000)},
    {"sounds.inf", "inf: list for sounds.mix", int32_t(0xCBB22A23), int32_t(0x00000000)},
    {"sounds.mix", "sounds.mix", int32_t(0xD3B23C1E), int32_t(0xA74702A9)},
    {"sounds.ver", "", int32_t(0xE5B2361A), int32_t(0x00000000)},
    {"sounds01.mix", "-", int32_t(0x00000000), int32_t(0x67987491)},
    {"sov-tran.wsa", "anim: soviet score screen", int32_t(0x932F3923), int32_t(0x00000000)},
    {"sov01t.map", "", int32_t(0x00000000), int32_t(0x907AF1F2)},
    {"sov01umd.map", "", int32_t(0x00000000), int32_t(0x73220E81)},
    {"sov02smd.map", "", int32_t(0x00000000), int32_t(0x9E7D3C58)},
    {"sov02t.map", "", int32_t(0x00000000), int32_t(0x1EF5F611)},
    {"sov03u.map", "", int32_t(0x00000000), int32_t(0x7428FD3B)},
    {"sov03umd.map", "", int32_t(0x00000000), int32_t(0x310709FC)},
    {"sov04dmd.map", "", int32_t(0x00000000), int32_t(0xFA6B979F)},
    {"sov04s.map", "", int32_t(0x00000000), int32_t(0x1D3DC118)},
    {"sov05u.map", "", int32_t(0x00000000), int32_t(0xB247F4BC)},
    {"sov05umd.map", "", int32_t(0x00000000), int32_t(0xF768007B)},
    {"sov06lmd.map", "", int32_t(0x00000000), int32_t(0x8BA1DE85)},
    {"sov06t.map", "", int32_t(0x00000000), int32_t(0x9ABFF8EB)},
    {"sov07s.map", "", int32_t(0x00000000), int32_t(0x93B2C6FB)},
    {"sov07tmd.map", "", int32_t(0x00000000), int32_t(0x133A0CB2)},
    {"sov08u.map", "", int32_t(0x00000000), int32_t(0x2942E16D)},
    {"sov09t.map", "", int32_t(0x00000000), int32_t(0x439FEA47)},
    {"sov09u.map", "", int32_t(0x00000000), int32_t(0xE5E8E1F3)},
    {"sov10t.map", "", int32_t(0x00000000), int32_t(0x4BABE52F)},
    {"sov11s.map", "", int32_t(0x00000000), int32_t(0x42A6DB3F)},
    {"sov12s.map", "", int32_t(0x00000000), int32_t(0xCC29DCDC)},
    {"sov1u.map", "", int32_t(0x00000000), int32_t(0xB7CE3F39)},
    {"sov2-lo.cps", "pict: guard", int32_t(0x264B25EA), int32_t(0x00000000)},
    {"sov2.pcx", "pict: guard", int32_t(0xBCEFEED4), int32_t(0x00000000)},
    {"sovbackh.pcx", "pict: soviet score screen picture", int32_t(0xF23313FD), int32_t(0x00000000)},
    {"sovbase.vqa", "soviet base with teslas truck drives in", int32_t(0x66253525), int32_t(0x00000000)},
    {"sovbase.vqp", "vqp: soviet base with teslas truck drives in", int32_t(0x66343525), int32_t(0x00000000)},
    {"sovbatl.vqa", "destroyed soviet vechicles", int32_t(0x66333725), int32_t(0x00000000)},
    {"sovbatl.vqp", "vqp: destroyed soviet vechicles", int32_t(0x66423725), int32_t(0x00000000)},
    {"sovcemet.vqa", "graveyard", int32_t(0xF7352E05), int32_t(0x00000000)},
    {"sovcemet.vqp", "vqp: graveyard", int32_t(0x06352E05), int32_t(0x00000000)},
    {"sovefal1.aud", "soviet empire has fallen", int32_t(0xBC470107), int32_t(0x00000000)},
    {"sovemp1.aud", "soviet empire selected", int32_t(0x72003328), int32_t(0x00000000)},
    {"sovfapp1.aud", "soviet forces approaching", int32_t(0xC04F1EFD), int32_t(0x00000000)},
    {"sovfinal.vqa", "stalin in london", int32_t(0xF32D300D), int32_t(0x00000000)},
    {"sovfinal.vqp", "vqp: stalin in london", int32_t(0x022D300D), int32_t(0x00000000)},
    {"sovforc1.aud", "soviet forces have fallen", int32_t(0xC0352319), int32_t(0x00000000)},
    {"soviet1.vqa", "kill the civillians", int32_t(0x81FD372D), int32_t(0x00000000)},
    {"soviet1.vqp", "vqp: kill the civillians", int32_t(0x820C372D), int32_t(0x00000000)},
    {"soviet10.vqa", "keep the convoy safe", int32_t(0xC70D3C05), int32_t(0x00000000)},
    {"soviet10.vqp", "vqp: keep the convoy safe", int32_t(0xD60D3C05), int32_t(0x00000000)},
    {"soviet11.vqa", "cut off the boats", int32_t(0xC90D3C05), int32_t(0x00000000)},
    {"soviet11.vqp", "vqp: cut off the boats", int32_t(0xD80D3C05), int32_t(0x00000000)},
    {"soviet12.vqa", "capture the chronosphere", int32_t(0xCB0D3C05), int32_t(0x00000000)},
    {"soviet12.vqp", "vqp: capture the chronosphere", int32_t(0xDA0D3C05), int32_t(0x00000000)},
    {"soviet13.vqa", "do not loose the chronosphere", int32_t(0xCD0D3C05), int32_t(0x00000000)},
    {"soviet13.vqp", "vqp: do not loose the chronosphere", int32_t(0xDC0D3C05), int32_t(0x00000000)},
    {"soviet14.vqa", "final assult on london", int32_t(0xCF0D3C05), int32_t(0x00000000)},
    {"soviet14.vqp", "vqp: final assult on london", int32_t(0xDE0D3C05), int32_t(0x00000000)},
    {"soviet2.vqa", "guard the base", int32_t(0x81FF372D), int32_t(0x00000000)},
    {"soviet2.vqp", "vqp: guard the base", int32_t(0x820E372D), int32_t(0x00000000)},
    {"soviet3.vqa", "kill the spy", int32_t(0x8201372D), int32_t(0x00000000)},
    {"soviet3.vqp", "vqp: kill the spy", int32_t(0x8210372D), int32_t(0x00000000)},
    {"soviet4.vqa", "cut the communications", int32_t(0x8203372D), int32_t(0x00000000)},
    {"soviet4.vqp", "vqp: cut the communications", int32_t(0x8212372D), int32_t(0x00000000)},
    {"soviet5.vqa", "capture communications centre", int32_t(0x8205372D), int32_t(0x00000000)},
    {"soviet5.vqp", "vqp: capture communications centre", int32_t(0x8214372D), int32_t(0x00000000)},
    {"soviet6.vqa", "guard the convoy", int32_t(0x8207372D), int32_t(0x00000000)},
    {"soviet6.vqp", "vqp: guard the convoy", int32_t(0x8216372D), int32_t(0x00000000)},
    {"soviet7.vqa", "infiltrate the reactor", int32_t(0x8209372D), int32_t(0x00000000)},
    {"soviet7.vqp", "vqp: infiltrate the reactor", int32_t(0x8218372D), int32_t(0x00000000)},
    {"soviet8.vqa", "capture the island", int32_t(0x820B372D), int32_t(0x00000000)},
    {"soviet8.vqp", "vqp: capture the island", int32_t(0x821A372D), int32_t(0x00000000)},
    {"soviet9.vqa", "reclaim the truck", int32_t(0x820D372D), int32_t(0x00000000)},
    {"soviet9.vqp", "vqp: reclaim the truck", int32_t(0x821C372D), int32_t(0x00000000)},
    {"sovietinvasion.bmp", "", int32_t(0x00000000), int32_t(0x05261870)},
    {"sovietlogo.shp", "", int32_t(0x00000000), int32_t(0x38A13B8E)},
    {"sovietmcv.bmp", "", int32_t(0x00000000), int32_t(0x6F53AFF5)},
    {"soviettransport.bmp", "", int32_t(0x00000000), int32_t(0x12B97E9C)},
    {"sovmcv.vqa", "soviet mcv drives up", int32_t(0xE1B62B24), int32_t(0x00000000)},
    {"sovmcv.vqp", "vqp: soviet mcv drives up", int32_t(0xE1B63A24), int32_t(0x00000000)},
    {"sovpaper.cps", "pict: soviet logo", int32_t(0x393420FD), int32_t(0x00000000)},
    {"sovpaper.pcx", "pict: soviet logo", int32_t(0x3E272DFD), int32_t(0x00000000)},
    {"sovrein1.aud", "soviet reinforcements have arived", int32_t(0xF04B1105), int32_t(0x00000000)},
    {"sovtstar.vqa", "soviets logo", int32_t(0x372D3C21), int32_t(0x00000000)},
    {"sovtstar.vqp", "vqp: soviets logo", int32_t(0x462D3C21), int32_t(0x00000000)},
    {"spark3a.aud", "", int32_t(0xA5CBFD24), int32_t(0x00000000)},
    {"sparks1.aud", "audf:", int32_t(0xA5AC3D24), int32_t(0x00000000)},
    {"sparky1.aud", "", int32_t(0xA5AC4924), int32_t(0x00000000)},
    {"sparky10.aud", "", int32_t(0xEDBD3511), int32_t(0x00000000)},
    {"sparky2.aud", "", int32_t(0xA5AE4924), int32_t(0x00000000)},
    {"sparky3.aud", "", int32_t(0xA5B04924), int32_t(0x00000000)},
    {"sparky4.aud", "", int32_t(0xA5B24924), int32_t(0x00000000)},
    {"sparky5.aud", "", int32_t(0xA5B44924), int32_t(0x00000000)},
    {"sparky6.aud", "", int32_t(0xA5B64924), int32_t(0x00000000)},
    {"sparky7.aud", "", int32_t(0xA5B84924), int32_t(0x00000000)},
    {"sparky8.aud", "", int32_t(0xA5BA4924), int32_t(0x00000000)},
    {"sparky9.aud", "", int32_t(0xA5BC4924), int32_t(0x00000000)},
    {"spchsfx.tlk", "", int32_t(0x7E091A47), int32_t(0x00000000)},
    {"speech.inf", "inf: list for speech.mix", int32_t(0xA7721821), int32_t(0x00000000)},
    {"speech.mix", "rmix: speech.mix", int32_t(0xAF722A1C), int32_t(0x00000000)},
    {"speech01.mix", "-", int32_t(0x00000000), int32_t(0x90719A84)},
    {"speech02.mix", "-", int32_t(0x00000000), int32_t(0xD7D1E054)},
    {"speed.shp", "crat: unit speed upgrade", int32_t(0xA5BB9E25), int32_t(0x6FCB9729)},
    {"speficon.shp", "icon: sub pen fake", int32_t(0x05FC1B0D), int32_t(0x00000000)},
    {"spelgone.aud", "", int32_t(0x00072109), int32_t(0x00000000)},
    {"spell.odf", "", int32_t(0xB9B39E2B), int32_t(0x00000000)},
    {"spell.ver", "", int32_t(0xBBC19E37), int32_t(0x00000000)},
    {"spells.csv", "", int32_t(0xB7723E38), int32_t(0x00000000)},
    {"spelpwr1.aud", "", int32_t(0xD80F311B), int32_t(0x00000000)},
    {"spen.shp", "bldg: sub pen", int32_t(0xECD2F3D4), int32_t(0x00000000)},
    {"spenicon.shp", "icon: sub pen", int32_t(0x25FC1B0D), int32_t(0x00000000)},
    {"spenmake.shp", "make: sub pen", int32_t(0x13F41715), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\0410401e.vqa", "", int32_t(0x2CE04261), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\ck03.vqa", "", int32_t(0x688202A5), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\e030e.vqa", "", int32_t(0xACF90CB1), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\e031e.vqa", "", int32_t(0xACF90EB1), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\explode.vqa", "", int32_t(0x944443F4), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\gg01.vqa", "", int32_t(0x5891FEA5), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\gg03.vqa", "", int32_t(0x589202A5), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\gg11.vqa", "", int32_t(0x5891FEA7), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\gg15.vqa", "", int32_t(0x589206A7), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\l1_dc.map", "", int32_t(0xB1202500), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\l1_dc.odf", "", int32_t(0xB1162802), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\l1_dc.te_", "", int32_t(0xB12F2907), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\l1_dc.tex", "", int32_t(0xB1282907), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\l1_dc.ver", "", int32_t(0xB1222909), int32_t(0x00000000)},
    {"sphere1\\l1_dc\\orc-diee.vqa", "", int32_t(0x821836D0), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\bicorp-1.vqa", "", int32_t(0x55E8B6C8), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\hrglass.vqa", "", int32_t(0xA0246414), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\l3_dh.map", "", int32_t(0xB92A3514), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\l3_dh.odf", "", int32_t(0xB9203816), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\l3_dh.te_", "", int32_t(0xB939391B), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\l3_dh.tex", "", int32_t(0xB932391B), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\l3_dh.ver", "", int32_t(0xB92C391D), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\portal.vqa", "", int32_t(0xA62D69DA), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\sg01.vqa", "", int32_t(0x58C20EB9), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\skltrise.vqa", "", int32_t(0x4A70F338), int32_t(0x00000000)},
    {"sphere1\\l3_dh\\wrm-port.vqa", "", int32_t(0x9A88753A), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\86604e.vqa", "", int32_t(0x53B329AA), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\bc02.vqa", "", int32_t(0x687E18C1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\di01.vqa", "", int32_t(0x808616C1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e042e.vqa", "", int32_t(0xCCF928CF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e043e.vqa", "", int32_t(0xCCF92ACF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e044e.vqa", "", int32_t(0xCCF92CCF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e045e.vqa", "", int32_t(0xCCF92ECF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e046e.vqa", "", int32_t(0xCCF930CF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e047e.vqa", "", int32_t(0xCCF932CF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e048e.vqa", "", int32_t(0xCCF934CF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e049e.vqa", "", int32_t(0xCCF936CF), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e050e.vqa", "", int32_t(0xCCF924D1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e051e.vqa", "", int32_t(0xCCF926D1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e052e.vqa", "", int32_t(0xCCF928D1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e053e.vqa", "", int32_t(0xCCF92AD1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e054e.vqa", "", int32_t(0xCCF92CD1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e055e.vqa", "", int32_t(0xCCF92ED1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e056e.vqa", "", int32_t(0xCCF930D1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e057e.vqa", "", int32_t(0xCCF932D1), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e065e.vqa", "", int32_t(0xCCF92ED3), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e065pt2e.vqa", "", int32_t(0xDDF886AD), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e077e.vqa", "", int32_t(0xCCF932D5), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e080e.vqa", "", int32_t(0xCCF924D7), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e081e.vqa", "", int32_t(0xCCF926D7), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e085e.vqa", "", int32_t(0xCCF92ED7), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\e103e.vqa", "", int32_t(0xD0F92AC7), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\gg18.vqa", "", int32_t(0x789224C3), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\l4_hj.map", "", int32_t(0xDD2E451C), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\l4_hj.odf", "", int32_t(0xDD24481E), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\l4_hj.te_", "", int32_t(0xDD3D4923), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\l4_hj.tex", "", int32_t(0xDD364923), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\l4_hj.ver", "", int32_t(0xDD304925), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\wo12.vqa", "", int32_t(0x98D218C3), int32_t(0x00000000)},
    {"sphere1\\l4_hj\\wo14.vqa", "", int32_t(0x98D21CC3), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\e070e.vqa", "", int32_t(0xCCF92CB9), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\ex01.vqa", "", int32_t(0xBC8A1EA7), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\ex04.vqa", "", int32_t(0xBC8A24A7), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\ex05.vqa", "", int32_t(0xBC8A26A7), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\ex11.vqa", "", int32_t(0xBC8A1EA9), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\ex12.vqa", "", int32_t(0xBC8A20A9), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\hw06.vqa", "", int32_t(0xB89628A7), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\hw07.vqa", "", int32_t(0xB8962AA7), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\hw13.vqa", "", int32_t(0xB89622A9), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\hw15.vqa", "", int32_t(0xB89626A9), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\l5_hc.map", "", int32_t(0xE1204D00), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\l5_hc.odf", "", int32_t(0xE1165002), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\l5_hc.te_", "", int32_t(0xE12F5107), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\l5_hc.tex", "", int32_t(0xE1285107), int32_t(0x00000000)},
    {"sphere1\\l5_hc\\l5_hc.ver", "", int32_t(0xE1225109), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\e122e.vqa", "", int32_t(0xB0F940C3), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\e123e.vqa", "", int32_t(0xB0F942C3), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\l7_dh.map", "", int32_t(0xC92A5514), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\l7_dh.odf", "", int32_t(0xC9205816), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\l7_dh.te_", "", int32_t(0xC939591B), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\l7_dh.tex", "", int32_t(0xC932591B), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\l7_dh.ver", "", int32_t(0xC92C591D), int32_t(0x00000000)},
    {"sphere1\\l7_dh\\sd01.vqa", "", int32_t(0x4CC22EB9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\4720710e.vqa", "", int32_t(0xA7CE6889), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\47garble.vqa", "", int32_t(0x1412F4AA), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\appr.vqa", "", int32_t(0xC806E8F0), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\explsion.vqa", "", int32_t(0xA0511F3E), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\garble.vqa", "", int32_t(0xD9F793C5), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\l10_dc.map", "", int32_t(0xC2590B90), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\l10_dc.odf", "", int32_t(0xC85D0B86), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\l10_dc.te_", "", int32_t(0xCA670B9F), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\l10_dc.tex", "", int32_t(0xCA670B98), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\l10_dc.ver", "", int32_t(0xCA6B0B92), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\pd01.vqa", "", int32_t(0x03C4A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\slvrbush.vqa", "", int32_t(0xCC5D3F26), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud01.vqa", "", int32_t(0x17C4A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud02.vqa", "", int32_t(0x17C6A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud03.vqa", "", int32_t(0x17C8A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud04.vqa", "", int32_t(0x17CAA8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud05.vqa", "", int32_t(0x17CCA8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud06.vqa", "", int32_t(0x17CEA8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud07.vqa", "", int32_t(0x17D0A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud08.vqa", "", int32_t(0x17D2A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud09.vqa", "", int32_t(0x17D4A8D9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud10.vqa", "", int32_t(0x17C2AAD9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud11.vqa", "", int32_t(0x17C4AAD9), int32_t(0x00000000)},
    {"sphere2\\l10_dc\\ud12.vqa", "", int32_t(0x17C6AAD9), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\6230112e.vqa", "", int32_t(0x9FEEC06D), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\ap01.vqa", "", int32_t(0xC7D4D0EC), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\bc09.vqa", "", int32_t(0xCBE4D0D2), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\citadel.vqa", "", int32_t(0xA3C468EB), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e195e.vqa", "", int32_t(0x46ECE787), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e196e.vqa", "", int32_t(0x46EEE787), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e197e.vqa", "", int32_t(0x46F0E787), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e198e.vqa", "", int32_t(0x46F2E787), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e199e.vqa", "", int32_t(0x46F4E787), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e200e.vqa", "", int32_t(0x46E2D589), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e201e.vqa", "", int32_t(0x46E4D589), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\e202e.vqa", "", int32_t(0x46E6D589), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\gg16.vqa", "", int32_t(0xDFDED2DA), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\l12_cm.map", "", int32_t(0xBE79639C), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\l12_cm.odf", "", int32_t(0xC47D6392), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\l12_cm.te_", "", int32_t(0xC68763AB), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\l12_cm.tex", "", int32_t(0xC68763A4), int32_t(0x00000000)},
    {"sphere2\\l12_cm\\l12_cm.ver", "", int32_t(0xC68B639E), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\5597513e.vqa", "", int32_t(0xA81A8AF1), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\5597613e.vqa", "", int32_t(0xAC1A8AF1), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\hv1-v-rl.vqa", "", int32_t(0xC400A96E), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l01.vqa", "", int32_t(0x43959AE4), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l07.vqa", "", int32_t(0x4395A6E4), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l08.vqa", "", int32_t(0x4395A8E4), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l09.vqa", "", int32_t(0x4395AAE4), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l13_rc.map", "", int32_t(0xFA891800), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l13_rc.odf", "", int32_t(0x008D17F7), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l13_rc.te_", "", int32_t(0x02971810), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l13_rc.tex", "", int32_t(0x02971809), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\l13_rc.ver", "", int32_t(0x029B1803), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\rl01.vqa", "", int32_t(0x0BDCA921), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\rl07.vqa", "", int32_t(0x0BE8A921), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\rl08.vqa", "", int32_t(0x0BEAA921), int32_t(0x00000000)},
    {"sphere2\\l13_rc\\rl09.vqa", "", int32_t(0x0BECA921), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\5601215e.vqa", "", int32_t(0x9C12F2A5), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\h201.vqa", "", int32_t(0xE3E4ECC4), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\h204.vqa", "", int32_t(0xE3EAECC4), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l01.vqa", "", int32_t(0x439DDEBC), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l14_ht.map", "", int32_t(0xD299A3D2), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l14_ht.odf", "", int32_t(0xD89DA3C8), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l14_ht.te_", "", int32_t(0xDAA7A3E1), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l14_ht.tex", "", int32_t(0xDAA7A3DA), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\l14_ht.ver", "", int32_t(0xDAABA3D4), int32_t(0x00000000)},
    {"sphere2\\l14_ht\\ll01.vqa", "", int32_t(0xF3E4ECF8), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\0115408e.vqa", "", int32_t(0x0500C6A6), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\13cutdwn.vqa", "", int32_t(0x6589592C), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\1e.vqa", "", int32_t(0x4F481FB7), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\3.vqa", "", int32_t(0xE03C1ADE), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\4195tle.vqa", "", int32_t(0x6BF057D0), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\4297911e.vqa", "", int32_t(0x1134CEB8), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\cem_apr.vqa", "", int32_t(0x1C1D003D), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\da02.vqa", "", int32_t(0xB89638C3), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\e.vqa", "", int32_t(0xE0601ADE), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\e143e.vqa", "", int32_t(0x29094ACE), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\gla_apr.vqa", "", int32_t(0x543D000D), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\kk02.vqa", "", int32_t(0xE0B238C3), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l04.vqa", "", int32_t(0x6B05EFB9), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l8_sj.map", "", int32_t(0x453E7B1B), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l8_sj.odf", "", int32_t(0x45347E1D), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l8_sj.te_", "", int32_t(0x454D7F22), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l8_sj.tex", "", int32_t(0x45467F22), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\l8_sj.ver", "", int32_t(0x45407F24), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\lh01.vqa", "", int32_t(0xD4B636C3), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\ruin_app.vqa", "", int32_t(0x6ABD4139), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\wf01.vqa", "", int32_t(0xCCE236C3), int32_t(0x00000000)},
    {"sphere2\\l8_sj\\wo14.vqa", "", int32_t(0xF0E23CC5), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\6730009e.vqa", "", int32_t(0x4520C2F1), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\67loit.vqa", "", int32_t(0x55E58FF6), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\ex12.vqa", "", int32_t(0x9C9A40E3), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\l9_dr.map", "", int32_t(0xD14E653C), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\l9_dr.odf", "", int32_t(0xD144683E), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\l9_dr.te_", "", int32_t(0xD15D6943), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\l9_dr.tex", "", int32_t(0xD1566943), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\l9_dr.ver", "", int32_t(0xD1506945), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\loit.vqa", "", int32_t(0x78B68513), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\sa13.vqa", "", int32_t(0x40D242E3), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\sb01.vqa", "", int32_t(0x44D23EE1), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\ss01.vqa", "", int32_t(0x88D23EE1), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\tower_ap.vqa", "", int32_t(0xC2992D90), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\watrwall.vqa", "", int32_t(0xDAC55999), int32_t(0x00000000)},
    {"sphere2\\l9_dr\\wrm_stat.vqa", "", int32_t(0xAEB59D68), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\1320016e.vqa", "", int32_t(0x744E6471), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\1320516e.vqa", "", int32_t(0x884E6471), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\bc04.vqa", "", int32_t(0xCC0AA0D2), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\h301.vqa", "", int32_t(0xE404A0B2), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\l16_ca.map", "", int32_t(0xBED91384), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\l16_ca.odf", "", int32_t(0xC4DD137A), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\l16_ca.te_", "", int32_t(0xC6E71393), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\l16_ca.tex", "", int32_t(0xC6E7138C), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\l16_ca.ver", "", int32_t(0xC6EB1386), int32_t(0x00000000)},
    {"sphere3\\l16_ca\\ud07.vqa", "", int32_t(0x1810A0D5), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\hw01.vqa", "", int32_t(0xE40CA90E), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\hw12.vqa", "", int32_t(0xE40EAB0E), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\hw14.vqa", "", int32_t(0xE412AB0E), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\l17_hc.map", "", int32_t(0xD2E927B0), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\l17_hc.odf", "", int32_t(0xD8ED27A6), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\l17_hc.te_", "", int32_t(0xDAF727BF), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\l17_hc.tex", "", int32_t(0xDAF727B8), int32_t(0x00000000)},
    {"sphere3\\l17_hc\\l17_hc.ver", "", int32_t(0xDAFB27B2), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\dn03.vqa", "", int32_t(0xD420A8E4), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\e223e.vqa", "", int32_t(0x4730B185), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\e224e.vqa", "", int32_t(0x4732B185), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\l19_bc.map", "", int32_t(0xBB092F80), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\l19_bc.odf", "", int32_t(0xC10D2F76), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\l19_bc.te_", "", int32_t(0xC3172F8F), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\l19_bc.tex", "", int32_t(0xC3172F88), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\l19_bc.ver", "", int32_t(0xC31B2F82), int32_t(0x00000000)},
    {"sphere3\\l19_bc\\sm01.vqa", "", int32_t(0x101CA8E3), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\3000988e.vqa", "", int32_t(0xA7EE786B), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\3340820e.vqa", "", int32_t(0xA3EE786B), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\4e.vqa", "", int32_t(0xD9DD57BD), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\5970320e.vqa", "", int32_t(0x9FEE8483), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\6e.vqa", "", int32_t(0xE1DD57BD), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\9306e.vqa", "", int32_t(0x16EEB186), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\b231411e.vqa", "", int32_t(0x0BF27664), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\bb07.vqa", "", int32_t(0xCBE0ACCC), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\bi01.vqa", "", int32_t(0xCBD4ACDA), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\bi03.vqa", "", int32_t(0xCBD8ACDA), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\dd01.vqa", "", int32_t(0xD3D4ACD0), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e226e.vqa", "", int32_t(0x46EEB585), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e232e.vqa", "", int32_t(0x46E6B785), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e233e.vqa", "", int32_t(0x46E8B785), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e242e.vqa", "", int32_t(0x46E6B985), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e243e.vqa", "", int32_t(0x46E8B985), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e244e.vqa", "", int32_t(0x46EAB985), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\e245e.vqa", "", int32_t(0x46ECB985), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f007747e.vqa", "", int32_t(0x380A7662), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f007748e.vqa", "", int32_t(0x380A7862), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f008798e.vqa", "", int32_t(0x380E786C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009744e.vqa", "", int32_t(0x38127062), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009745e.vqa", "", int32_t(0x38127262), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009746e.vqa", "", int32_t(0x38127462), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009747e.vqa", "", int32_t(0x38127662), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009748e.vqa", "", int32_t(0x38127862), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009749e.vqa", "", int32_t(0x38127A62), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009754e.vqa", "", int32_t(0x38127064), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009755e.vqa", "", int32_t(0x38127264), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009846e.vqa", "", int32_t(0x3C127462), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009847e.vqa", "", int32_t(0x3C127662), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009848e.vqa", "", int32_t(0x3C127862), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009849e.vqa", "", int32_t(0x3C127A62), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009856e.vqa", "", int32_t(0x3C127464), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f009857e.vqa", "", int32_t(0x3C127664), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f010898e.vqa", "", int32_t(0x3BEE7C6C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f010899e.vqa", "", int32_t(0x3BEE7E6C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f018798e.vqa", "", int32_t(0x380E7C6C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f018799e.vqa", "", int32_t(0x380E7E6C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f019748e.vqa", "", int32_t(0x38127C62), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f019848e.vqa", "", int32_t(0x3C127C62), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f019849e.vqa", "", int32_t(0x3C127E62), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f028798e.vqa", "", int32_t(0x380E806C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f029748e.vqa", "", int32_t(0x38128062), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f029848e.vqa", "", int32_t(0x3C128062), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f029849e.vqa", "", int32_t(0x3C128262), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f038798e.vqa", "", int32_t(0x380E846C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\f238750e.vqa", "", int32_t(0x380E746C), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\l20_bb.map", "", int32_t(0xBA791382), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\l20_bb.odf", "", int32_t(0xC07D1378), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\l20_bb.te_", "", int32_t(0xC2871391), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\l20_bb.tex", "", int32_t(0xC287138A), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\l20_bb.ver", "", int32_t(0xC28B1384), int32_t(0x00000000)},
    {"sphere3\\l20_bb\\placenta.vqa", "", int32_t(0xC032F508), int32_t(0x00000000)},
    {"spiddie1.aud", "reaper death", int32_t(0x00000000), int32_t(0x910708E0)},
    {"spin1a.aud", "", int32_t(0xBB820804), int32_t(0x00000000)},
    {"spin2a.aud", "", int32_t(0xBB820806), int32_t(0x00000000)},
    {"spin2b.aud", "", int32_t(0xBB820A06), int32_t(0x00000000)},
    {"spin3a.aud", "", int32_t(0xBB820808), int32_t(0x00000000)},
    {"spinamb2.aud", "", int32_t(0xE1FF1CFD), int32_t(0x00000000)},
    {"spincls1.aud", "", int32_t(0xE0211B01), int32_t(0x00000000)},
    {"spindest.tre", "", int32_t(0x271E2003), int32_t(0x00000000)},
    {"spindest.trf", "", int32_t(0x281E2003), int32_t(0x00000000)},
    {"spindest.trg", "", int32_t(0x291E2003), int32_t(0x00000000)},
    {"spindest.tri", "", int32_t(0x2B1E2003), int32_t(0x00000000)},
    {"spindest.trs", "", int32_t(0x351E2003), int32_t(0x00000000)},
    {"spinmon1.aud", "", int32_t(0xE0172115), int32_t(0x00000000)},
    {"spinner.shp", "", int32_t(0x961A143C), int32_t(0x00000000)},
    {"spinner.vqa", "", int32_t(0x960B1D3F), int32_t(0x00000000)},
    {"spinny1.aud", "", int32_t(0x95CC492A), int32_t(0x00000000)},
    {"spinopn3.aud", "", int32_t(0xE4172319), int32_t(0x00000000)},
    {"spinopn4.aud", "", int32_t(0xE6172319), int32_t(0x00000000)},
    {"spinup1.aud", "", int32_t(0x95CC3738), int32_t(0x00000000)},
    {"spirtalt.aud", "", int32_t(0x36130523), int32_t(0x00000000)},
    {"spkr01.urb", "", int32_t(0x00000000), int32_t(0x91B513AB)},
    {"splash.img", "", int32_t(0x978E1940), int32_t(0x00000000)},
    {"splash9.aud", "missile in water", int32_t(0x61E82734), int32_t(0x00000000)},
    {"splat1.aud", "", int32_t(0x878DE84A), int32_t(0x00000000)},
    {"spldbr.pal", "", int32_t(0x00000000), int32_t(0xFCF4E869)},
    {"spldbr.shp", "", int32_t(0x00000000), int32_t(0xAABC3F83)},
    {"spldbrl.shp", "", int32_t(0x00000000), int32_t(0x126C3034)},
    {"spldbrs.shp", "", int32_t(0x00000000), int32_t(0xE0EC807A)},
    {"splfail2.aud", "", int32_t(0xC21F14FD), int32_t(0x00000000)},
    {"split2.tem", "blossom tree", int32_t(0xCD8DF33A), int32_t(0x00000000)},
    {"split2.win", "blossom tree", int32_t(0xD38DF43E), int32_t(0x00000000)},
    {"split3.des", "blossom tree", int32_t(0xAD8DFB3A), int32_t(0x00000000)},
    {"split3.tem", "blossom tree", int32_t(0xCD8DF53A), int32_t(0x00000000)},
    {"split3.win", "blossom tree", int32_t(0xD38DF63E), int32_t(0x00000000)},
    {"spmfail.flc", "", int32_t(0x76112015), int32_t(0x00000000)},
    {"spmorphm.flc", "", int32_t(0x1B12281F), int32_t(0x00000000)},
    {"spnamb1.aud", "", int32_t(0x61E01B28), int32_t(0x00000000)},
    {"spnbeep2.aud", "", int32_t(0xB22F0D05), int32_t(0x00000000)},
    {"spnbeep3.aud", "", int32_t(0xB42F0D05), int32_t(0x00000000)},
    {"spnbeep4.aud", "", int32_t(0xB62F0D05), int32_t(0x00000000)},
    {"spnbeep5.aud", "", int32_t(0xB82F0D05), int32_t(0x00000000)},
    {"spnbeep6.aud", "", int32_t(0xBA2F0D05), int32_t(0x00000000)},
    {"spnbeep7.aud", "", int32_t(0xBC2F0D05), int32_t(0x00000000)},
    {"spnbeep8.aud", "", int32_t(0xBE2F0D05), int32_t(0x00000000)},
    {"spnbeep9.aud", "", int32_t(0xC02F0D05), int32_t(0x00000000)},
    {"spook1.aud", "", int32_t(0xBF99E838), int32_t(0x00000000)},
    {"spook2.aud", "", int32_t(0xBF99EA38), int32_t(0x00000000)},
    {"spook3.aud", "", int32_t(0xBF99EC38), int32_t(0x00000000)},
    {"spook4.aud", "", int32_t(0xBF99EE38), int32_t(0x00000000)},
    {"spook5.aud", "", int32_t(0xBF99F038), int32_t(0x00000000)},
    {"spook6.aud", "", int32_t(0xBF99F238), int32_t(0x00000000)},
    {"spook7.aud", "", int32_t(0xBF99F438), int32_t(0x00000000)},
    {"spoticon.shp", "icon: spotlight tower", int32_t(0x00000000), int32_t(0x2FA1EB4E)},
    {"spotter.vqa", "soldiers being viewed through binoculars", int32_t(0xAE231D4B), int32_t(0x00000000)},
    {"spotter.vqp", "vqp: soldiers being viewed through binoculars", int32_t(0xAE321D4B), int32_t(0x00000000)},
    {"springs.ini", "", int32_t(0x00000000), int32_t(0xEAA41201)},
    {"springs.map", "-", int32_t(0x00000000), int32_t(0xF59A6B73)},
    {"sprkhit2.aud", "", int32_t(0xD647150B), int32_t(0x00000000)},
    {"sprksp3b.aud", "", int32_t(0xF6052321), int32_t(0x00000000)},
    {"sprkspl2.aud", "", int32_t(0xD6372321), int32_t(0x00000000)},
    {"sprkspl3.aud", "", int32_t(0xD8372321), int32_t(0x00000000)},
    {"sprkspl4.aud", "", int32_t(0xDA372321), int32_t(0x00000000)},
    {"sprkspl5.aud", "", int32_t(0xDC372321), int32_t(0x00000000)},
    {"spsyread.wav", "", int32_t(0x00000000), int32_t(0xEE6FBA49)},
    {"sputdoor.shp", "misc: gps satellite launching", int32_t(0x463C3303), int32_t(0x00000000)},
    {"sputnik.shp", "misc: gps satellite flying", int32_t(0xAE3C1C3C), int32_t(0x00000000)},
    {"sputnik.vqp", "", int32_t(0xAE3C253F), int32_t(0x00000000)},
    {"spy-lo.cps", "pict: spy infiltrating building", int32_t(0x3BC23335), int32_t(0x00000000)},
    {"spy.pcx", "pict: spy infiltrating building", int32_t(0x5D0AE3F6), int32_t(0x00000000)},
    {"spy.shp", "unit: spy", int32_t(0x5D02E8F9), int32_t(0x4CAD7A7B)},
    {"spy.vqa", "spy infiltrating building", int32_t(0x5CF3F1FC), int32_t(0x00000000)},
    {"spy.vqp", "vqp: spy infiltrating building", int32_t(0x5D02F1FC), int32_t(0x00000000)},
    {"spycrash.vqa", "spyplane crash", int32_t(0xDF5D1A1F), int32_t(0x00000000)},
    {"spycrash.vqp", "spyplane crash", int32_t(0xEE5D1A1F), int32_t(0x00000000)},
    {"spyicon.shp", "icon: spy", int32_t(0x82522826), int32_t(0xA5CFC154)},
    {"spyp.hva", "", int32_t(0x00000000), int32_t(0x5D92DBAE)},
    {"spyp.vxl", "", int32_t(0x00000000), int32_t(0xAB1804E7)},
    {"spypicon.shp", "", int32_t(0x00000000), int32_t(0x58FD4BED)},
    {"spypln1.aud", "spyplane ready", int32_t(0x9E0C3326), int32_t(0x00000000)},
    {"spyuico.shp", "", int32_t(0x00000000), int32_t(0x7207D528)},
    {"sqbite1.aud", "", int32_t(0x81B02536), int32_t(0x00000000)},
    {"sqd.shp", "", int32_t(0x00000000), int32_t(0x5592608A)},
    {"sqdg.shp", "", int32_t(0x00000000), int32_t(0x38EFD971)},
    {"sqdg_e.shp", "", int32_t(0x00000000), int32_t(0x04AF1AC8)},
    {"sqdg_n.shp", "", int32_t(0x00000000), int32_t(0x06A84E32)},
    {"sqdg_ne.shp", "", int32_t(0x00000000), int32_t(0x9977104D)},
    {"sqdg_nw.shp", "", int32_t(0x00000000), int32_t(0xD769B3DD)},
    {"sqdg_s.shp", "", int32_t(0x00000000), int32_t(0x00A1B33C)},
    {"sqdg_se.shp", "", int32_t(0x00000000), int32_t(0x9F7EED43)},
    {"sqdg_sw.shp", "", int32_t(0x00000000), int32_t(0xD1604ED3)},
    {"sqdg_w.shp", "", int32_t(0x00000000), int32_t(0xF4EE972F)},
    {"sqdicon.shp", "", int32_t(0x00000000), int32_t(0xB61114CC)},
    {"sqdp.shp", "", int32_t(0x00000000), int32_t(0xEA2F92E3)},
    {"sqdwake.shp", "", int32_t(0x00000000), int32_t(0x0EBE5E82)},
    {"sqhurt1.aud", "", int32_t(0xB1C84332), int32_t(0x00000000)},
    {"sqhurt2.aud", "", int32_t(0xB1CA4332), int32_t(0x00000000)},
    {"sqshhit1.aud", "", int32_t(0xC84B190B), int32_t(0x00000000)},
    {"sqshhit2.aud", "", int32_t(0xCA4B190B), int32_t(0x00000000)},
    {"sqshhit3.aud", "", int32_t(0xCC4B190B), int32_t(0x00000000)},
    {"sqshhit4.aud", "", int32_t(0xCE4B190B), int32_t(0x00000000)},
    {"squeak1.aud", "", int32_t(0x71FC3110), int32_t(0x00000000)},
    {"squeak2.aud", "", int32_t(0x71FE3110), int32_t(0x00000000)},
    {"squeak3.aud", "", int32_t(0x72003110), int32_t(0x00000000)},
    {"squeak4.aud", "", int32_t(0x72023110), int32_t(0x00000000)},
    {"squeak5.aud", "", int32_t(0x72043110), int32_t(0x00000000)},
    {"squelch.shp", "", int32_t(0x72361438), int32_t(0x00000000)},
    {"squish.shp", "squished body", int32_t(0xCBB2263B), int32_t(0x00000000)},
    {"squish2.aud", "squish", int32_t(0x81FE2B34), int32_t(0x00000000)},
    {"squish2.juv", "squish", int32_t(0x82102B3D), int32_t(0x00000000)},
    {"squish6.aud", "guy squish", int32_t(0x00000000), int32_t(0xE0500671)},
    {"squishy2.aud", "man being squashed", int32_t(0xCE5D1721), int32_t(0x7FE9DAA7)},
    {"squrl1.aud", "", int32_t(0xCBB1EC3A), int32_t(0x00000000)},
    {"squrl2.aud", "", int32_t(0xCBB1EE3A), int32_t(0x00000000)},
    {"sr1.tem", "dirt", int32_t(0x5CAFE9FA), int32_t(0x00000000)},
    {"sr1.win", "dirt", int32_t(0x5CB0EDFD), int32_t(0x00000000)},
    {"sr2.tem", "dirt", int32_t(0x5CB1E9FA), int32_t(0x00000000)},
    {"sr2.win", "dirt", int32_t(0x5CB2EDFD), int32_t(0x00000000)},
    {"sradar.shp", "sole survivor radar and logo", int32_t(0xB7623E17), int32_t(0x00000000)},
    {"srchtlk1.aud", "", int32_t(0xC7F92323), int32_t(0x00000000)},
    {"sredsmk1.shp", "-", int32_t(0x00000000), int32_t(0x9178E381)},
    {"sref.hva", "", int32_t(0x00000000), int32_t(0x51B96A45)},
    {"sref.vxl", "", int32_t(0x00000000), int32_t(0xA733B50C)},
    {"sreficon.shp", "", int32_t(0x00000000), int32_t(0xE2D9A8B1)},
    {"sreftur.hva", "", int32_t(0x00000000), int32_t(0x1C359284)},
    {"sreftur.vxl", "", int32_t(0x00000000), int32_t(0x13C3E16F)},
    {"sreftur1.hva", "", int32_t(0x00000000), int32_t(0x6B211058)},
    {"sreftur1.vxl", "", int32_t(0x00000000), int32_t(0x9DABCF11)},
    {"sreftur2.hva", "", int32_t(0x00000000), int32_t(0x2C816A88)},
    {"sreftur2.vxl", "", int32_t(0x00000000), int32_t(0xDA0BB5C1)},
    {"sreftur3.hva", "", int32_t(0x00000000), int32_t(0x11E14338)},
    {"sreftur3.vxl", "", int32_t(0x00000000), int32_t(0xE76B9C71)},
    {"srefuico.shp", "", int32_t(0x00000000), int32_t(0x271F3A50)},
    {"srock01.des", "", int32_t(0x00000000), int32_t(0x9FB7A871)},
    {"srock01.lun", "", int32_t(0x00000000), int32_t(0xB9494FF2)},
    {"srock01.sno", "-", int32_t(0x00000000), int32_t(0xB85B75EB)},
    {"srock01.tem", "-", int32_t(0x00000000), int32_t(0x1BEFC031)},
    {"srock01.ubn", "", int32_t(0x00000000), int32_t(0x8D31E212)},
    {"srock01.urb", "", int32_t(0x00000000), int32_t(0x3DA20E6E)},
    {"srock02.des", "", int32_t(0x00000000), int32_t(0x1923DADF)},
    {"srock02.lun", "", int32_t(0x00000000), int32_t(0x3FDD3D5C)},
    {"srock02.sno", "-", int32_t(0x00000000), int32_t(0x3ECF0745)},
    {"srock02.tem", "-", int32_t(0x00000000), int32_t(0x9D7BB29F)},
    {"srock02.ubn", "", int32_t(0x00000000), int32_t(0x0BA590BC)},
    {"srock02.urb", "", int32_t(0x00000000), int32_t(0xBB367CC0)},
    {"srock03.des", "", int32_t(0x00000000), int32_t(0xD27F097A)},
    {"srock03.lun", "", int32_t(0x00000000), int32_t(0xF481EEF9)},
    {"srock03.sno", "-", int32_t(0x00000000), int32_t(0xF593D4E0)},
    {"srock03.tem", "-", int32_t(0x00000000), int32_t(0x5627613A)},
    {"srock03.ubn", "", int32_t(0x00000000), int32_t(0xC0F94319)},
    {"srock03.urb", "", int32_t(0x00000000), int32_t(0x706AAF65)},
    {"srock04.des", "", int32_t(0x00000000), int32_t(0xCF7A39C2)},
    {"srock04.lun", "", int32_t(0x00000000), int32_t(0xE984DE41)},
    {"srock04.sno", "-", int32_t(0x00000000), int32_t(0xE896E458)},
    {"srock04.tem", "-", int32_t(0x00000000), int32_t(0x4B225182)},
    {"srock04.ubn", "", int32_t(0x00000000), int32_t(0xDDFC73A1)},
    {"srock04.urb", "", int32_t(0x00000000), int32_t(0x6D6F9FDD)},
    {"srock05.des", "", int32_t(0x00000000), int32_t(0x0426EA67)},
    {"srock05.lun", "", int32_t(0x00000000), int32_t(0x22D80DE4)},
    {"srock05.sno", "-", int32_t(0x00000000), int32_t(0x23CA37FD)},
    {"srock05.tem", "-", int32_t(0x00000000), int32_t(0x807E8227)},
    {"srock05.ubn", "", int32_t(0x00000000), int32_t(0x16A0A004)},
    {"srock05.urb", "", int32_t(0x00000000), int32_t(0xA6334C78)},
    {"srrwndchim1.aud", "", int32_t(0x384693A5), int32_t(0x00000000)},
    {"ss-0310919e_e.vqa", "", int32_t(0xEC18005D), int32_t(0x00000000)},
    {"ss-0310919e_e.vqt", "", int32_t(0xEC180070), int32_t(0x00000000)},
    {"ss-0311219e_e.vqa", "", int32_t(0xB420005D), int32_t(0x00000000)},
    {"ss-0311219e_e.vqt", "", int32_t(0xB4200070), int32_t(0x00000000)},
    {"ss-0377804e_e.vqa", "", int32_t(0xE4501C59), int32_t(0x00000000)},
    {"ss-0377804e_e.vqt", "", int32_t(0xE4501C6C), int32_t(0x00000000)},
    {"ss-0656001e_e.vqa", "", int32_t(0xA4480071), int32_t(0x00000000)},
    {"ss-0656001e_e.vqt", "", int32_t(0xA4480084), int32_t(0x00000000)},
    {"ss-10e.csv", "", int32_t(0x4B122E00), int32_t(0x00000000)},
    {"ss-10e.lsv", "", int32_t(0x5D122E00), int32_t(0x00000000)},
    {"ss-10e.vqa", "", int32_t(0x711218FE), int32_t(0x00000000)},
    {"ss-10e_e.vqa", "", int32_t(0x90C52DDB), int32_t(0x00000000)},
    {"ss-10e_e.vqt", "", int32_t(0xA3C52DDB), int32_t(0x00000000)},
    {"ss-10e_h.pcx", "", int32_t(0xADB727DB), int32_t(0x00000000)},
    {"ss-10e_h.vqa", "", int32_t(0x96C52DDB), int32_t(0x00000000)},
    {"ss-10e_l.pcx", "", int32_t(0xB5B727DB), int32_t(0x00000000)},
    {"ss-10e_l.vqa", "", int32_t(0x9EC52DDB), int32_t(0x00000000)},
    {"ss-11e.csv", "", int32_t(0x4B122E02), int32_t(0x00000000)},
    {"ss-11e.lsv", "", int32_t(0x5D122E02), int32_t(0x00000000)},
    {"ss-11e.vqa", "", int32_t(0x71121900), int32_t(0x00000000)},
    {"ss-11e_e.vqa", "", int32_t(0x90C52DDD), int32_t(0x00000000)},
    {"ss-11e_e.vqt", "", int32_t(0xA3C52DDD), int32_t(0x00000000)},
    {"ss-11e_h.pcx", "", int32_t(0xADB727DD), int32_t(0x00000000)},
    {"ss-11e_h.vqa", "", int32_t(0x96C52DDD), int32_t(0x00000000)},
    {"ss-11e_l.pcx", "", int32_t(0xB5B727DD), int32_t(0x00000000)},
    {"ss-11e_l.vqa", "", int32_t(0x9EC52DDD), int32_t(0x00000000)},
    {"ss-12e.csv", "", int32_t(0x4B122E04), int32_t(0x00000000)},
    {"ss-12e.lsv", "", int32_t(0x5D122E04), int32_t(0x00000000)},
    {"ss-12e.vqa", "", int32_t(0x71121902), int32_t(0x00000000)},
    {"ss-12e_e.vqa", "", int32_t(0x90C52DDF), int32_t(0x00000000)},
    {"ss-12e_e.vqt", "", int32_t(0xA3C52DDF), int32_t(0x00000000)},
    {"ss-12e_h.pcx", "", int32_t(0xADB727DF), int32_t(0x00000000)},
    {"ss-12e_h.vqa", "", int32_t(0x96C52DDF), int32_t(0x00000000)},
    {"ss-12e_l.pcx", "", int32_t(0xB5B727DF), int32_t(0x00000000)},
    {"ss-12e_l.vqa", "", int32_t(0x9EC52DDF), int32_t(0x00000000)},
    {"ss-1320516e_e.vqa", "", int32_t(0xDC17FC5D), int32_t(0x00000000)},
    {"ss-1320516e_e.vqt", "", int32_t(0xDC17FC70), int32_t(0x00000000)},
    {"ss-1372504e_e.vqa", "", int32_t(0xDC281C59), int32_t(0x00000000)},
    {"ss-1372504e_e.vqt", "", int32_t(0xDC281C6C), int32_t(0x00000000)},
    {"ss-1380612e_e.vqa", "", int32_t(0xE4181C5D), int32_t(0x00000000)},
    {"ss-1380612e_e.vqt", "", int32_t(0xE4181C70), int32_t(0x00000000)},
    {"ss-1386904e_e.vqa", "", int32_t(0xFC482459), int32_t(0x00000000)},
    {"ss-1386904e_e.vqt", "", int32_t(0xFC48246C), int32_t(0x00000000)},
    {"ss-1e.csv", "", int32_t(0x6B3BAA2D), int32_t(0x00000000)},
    {"ss-1e.lsv", "", int32_t(0x6B4DAA2D), int32_t(0x00000000)},
    {"ss-1e.vqa", "", int32_t(0x6761AA18), int32_t(0x00000000)},
    {"ss-1e_e.vqa", "", int32_t(0x21815D2D), int32_t(0x00000000)},
    {"ss-1e_e.vqt", "", int32_t(0x21945D2D), int32_t(0x00000000)},
    {"ss-1e_h.pcx", "", int32_t(0x219E4F27), int32_t(0x00000000)},
    {"ss-1e_h.vqa", "", int32_t(0x21875D2D), int32_t(0x00000000)},
    {"ss-1e_l.pcx", "", int32_t(0x21A64F27), int32_t(0x00000000)},
    {"ss-1e_l.vqa", "", int32_t(0x218F5D2D), int32_t(0x00000000)},
    {"ss-2730706e_e.vqa", "", int32_t(0xFC180479), int32_t(0x00000000)},
    {"ss-2730706e_e.vqt", "", int32_t(0xFC18048C), int32_t(0x00000000)},
    {"ss-2e.csv", "", int32_t(0x6F3BAA2D), int32_t(0x00000000)},
    {"ss-2e.lsv", "", int32_t(0x6F4DAA2D), int32_t(0x00000000)},
    {"ss-2e.vqa", "", int32_t(0x6B61AA18), int32_t(0x00000000)},
    {"ss-2e_e.vqa", "", int32_t(0x25815D2D), int32_t(0x00000000)},
    {"ss-2e_e.vqt", "", int32_t(0x25945D2D), int32_t(0x00000000)},
    {"ss-2e_h.pcx", "", int32_t(0x259E4F27), int32_t(0x00000000)},
    {"ss-2e_h.vqa", "", int32_t(0x25875D2D), int32_t(0x00000000)},
    {"ss-2e_l.pcx", "", int32_t(0x25A64F27), int32_t(0x00000000)},
    {"ss-2e_l.vqa", "", int32_t(0x258F5D2D), int32_t(0x00000000)},
    {"ss-3e.csv", "", int32_t(0x733BAA2D), int32_t(0x00000000)},
    {"ss-3e.lsv", "", int32_t(0x734DAA2D), int32_t(0x00000000)},
    {"ss-3e.vqa", "", int32_t(0x6F61AA18), int32_t(0x00000000)},
    {"ss-3e_e.vqa", "", int32_t(0x29815D2D), int32_t(0x00000000)},
    {"ss-3e_e.vqt", "", int32_t(0x29945D2D), int32_t(0x00000000)},
    {"ss-3e_h.pcx", "", int32_t(0x299E4F27), int32_t(0x00000000)},
    {"ss-3e_h.vqa", "", int32_t(0x29875D2D), int32_t(0x00000000)},
    {"ss-3e_l.pcx", "", int32_t(0x29A64F27), int32_t(0x00000000)},
    {"ss-3e_l.vqa", "", int32_t(0x298F5D2D), int32_t(0x00000000)},
    {"ss-4025108e_e.vqa", "", int32_t(0xEC400441), int32_t(0x00000000)},
    {"ss-4025108e_e.vqt", "", int32_t(0xEC400454), int32_t(0x00000000)},
    {"ss-4e.csv", "", int32_t(0x773BAA2D), int32_t(0x00000000)},
    {"ss-4e.lsv", "", int32_t(0x774DAA2D), int32_t(0x00000000)},
    {"ss-4e.vqa", "", int32_t(0x7361AA18), int32_t(0x00000000)},
    {"ss-4e_e.vqa", "", int32_t(0x2D815D2D), int32_t(0x00000000)},
    {"ss-4e_e.vqt", "", int32_t(0x2D945D2D), int32_t(0x00000000)},
    {"ss-4e_h.pcx", "", int32_t(0x2D9E4F27), int32_t(0x00000000)},
    {"ss-4e_h.vqa", "", int32_t(0x2D875D2D), int32_t(0x00000000)},
    {"ss-4e_l.pcx", "", int32_t(0x2DA64F27), int32_t(0x00000000)},
    {"ss-4e_l.vqa", "", int32_t(0x2D8F5D2D), int32_t(0x00000000)},
    {"ss-5e.csv", "", int32_t(0x7B3BAA2D), int32_t(0x00000000)},
    {"ss-5e.lsv", "", int32_t(0x7B4DAA2D), int32_t(0x00000000)},
    {"ss-5e.vqa", "", int32_t(0x7761AA18), int32_t(0x00000000)},
    {"ss-5e_e.vqa", "", int32_t(0x31815D2D), int32_t(0x00000000)},
    {"ss-5e_e.vqt", "", int32_t(0x31945D2D), int32_t(0x00000000)},
    {"ss-5e_h.pcx", "", int32_t(0x319E4F27), int32_t(0x00000000)},
    {"ss-5e_h.vqa", "", int32_t(0x31875D2D), int32_t(0x00000000)},
    {"ss-5e_l.pcx", "", int32_t(0x31A64F27), int32_t(0x00000000)},
    {"ss-5e_l.vqa", "", int32_t(0x318F5D2D), int32_t(0x00000000)},
    {"ss-6e.csv", "", int32_t(0x7F3BAA2D), int32_t(0x00000000)},
    {"ss-6e.lsv", "", int32_t(0x7F4DAA2D), int32_t(0x00000000)},
    {"ss-6e.vqa", "", int32_t(0x7B61AA18), int32_t(0x00000000)},
    {"ss-6e_e.vqa", "", int32_t(0x35815D2D), int32_t(0x00000000)},
    {"ss-6e_e.vqt", "", int32_t(0x35945D2D), int32_t(0x00000000)},
    {"ss-6e_h.pcx", "", int32_t(0x359E4F27), int32_t(0x00000000)},
    {"ss-6e_h.vqa", "", int32_t(0x35875D2D), int32_t(0x00000000)},
    {"ss-6e_l.pcx", "", int32_t(0x35A64F27), int32_t(0x00000000)},
    {"ss-6e_l.vqa", "", int32_t(0x358F5D2D), int32_t(0x00000000)},
    {"ss-7e.csv", "", int32_t(0x833BAA2D), int32_t(0x00000000)},
    {"ss-7e.lsv", "", int32_t(0x834DAA2D), int32_t(0x00000000)},
    {"ss-7e.vqa", "", int32_t(0x7F61AA18), int32_t(0x00000000)},
    {"ss-7e_e.vqa", "", int32_t(0x39815D2D), int32_t(0x00000000)},
    {"ss-7e_e.vqt", "", int32_t(0x39945D2D), int32_t(0x00000000)},
    {"ss-7e_h.pcx", "", int32_t(0x399E4F27), int32_t(0x00000000)},
    {"ss-7e_h.vqa", "", int32_t(0x39875D2D), int32_t(0x00000000)},
    {"ss-7e_l.pcx", "", int32_t(0x39A64F27), int32_t(0x00000000)},
    {"ss-7e_l.vqa", "", int32_t(0x398F5D2D), int32_t(0x00000000)},
    {"ss-8e.csv", "", int32_t(0x873BAA2D), int32_t(0x00000000)},
    {"ss-8e.lsv", "", int32_t(0x874DAA2D), int32_t(0x00000000)},
    {"ss-8e.vqa", "", int32_t(0x8361AA18), int32_t(0x00000000)},
    {"ss-8e_e.vqa", "", int32_t(0x3D815D2D), int32_t(0x00000000)},
    {"ss-8e_e.vqt", "", int32_t(0x3D945D2D), int32_t(0x00000000)},
    {"ss-8e_h.pcx", "", int32_t(0x3D9E4F27), int32_t(0x00000000)},
    {"ss-8e_h.vqa", "", int32_t(0x3D875D2D), int32_t(0x00000000)},
    {"ss-8e_l.pcx", "", int32_t(0x3DA64F27), int32_t(0x00000000)},
    {"ss-8e_l.vqa", "", int32_t(0x3D8F5D2D), int32_t(0x00000000)},
    {"ss-9e.csv", "", int32_t(0x8B3BAA2D), int32_t(0x00000000)},
    {"ss-9e.lsv", "", int32_t(0x8B4DAA2D), int32_t(0x00000000)},
    {"ss-9e.vqa", "", int32_t(0x8761AA18), int32_t(0x00000000)},
    {"ss-9e_e.vqa", "", int32_t(0x41815D2D), int32_t(0x00000000)},
    {"ss-9e_e.vqt", "", int32_t(0x41945D2D), int32_t(0x00000000)},
    {"ss-9e_h.pcx", "", int32_t(0x419E4F27), int32_t(0x00000000)},
    {"ss-9e_h.vqa", "", int32_t(0x41875D2D), int32_t(0x00000000)},
    {"ss-9e_l.pcx", "", int32_t(0x41A64F27), int32_t(0x00000000)},
    {"ss-9e_l.vqa", "", int32_t(0x418F5D2D), int32_t(0x00000000)},
    {"ss-a_cam_e.vqa", "", int32_t(0xEACC7426), int32_t(0x00000000)},
    {"ss-a_cam_e.vqt", "", int32_t(0xEACC8726), int32_t(0x00000000)},
    {"ss-arenaapr_e.vqa", "", int32_t(0x3D3CFD95), int32_t(0x00000000)},
    {"ss-arenaapr_e.vqt", "", int32_t(0x3D3CFDA8), int32_t(0x00000000)},
    {"ss-b_cam_e.vqa", "", int32_t(0xF2CC7426), int32_t(0x00000000)},
    {"ss-b_cam_e.vqt", "", int32_t(0xF2CC8726), int32_t(0x00000000)},
    {"ss-bb_brth_e.vqa", "", int32_t(0x2683FE79), int32_t(0x00000000)},
    {"ss-bb_brth_e.vqt", "", int32_t(0x3983FE79), int32_t(0x00000000)},
    {"ss-bc-vs-sb_e.vqa", "", int32_t(0xDD3C48CB), int32_t(0x00000000)},
    {"ss-bc-vs-sb_e.vqt", "", int32_t(0xDD3C48DE), int32_t(0x00000000)},
    {"ss-bchm_apr_e.vqa", "", int32_t(0x3D35151C), int32_t(0x00000000)},
    {"ss-bchm_apr_e.vqt", "", int32_t(0x3D35152F), int32_t(0x00000000)},
    {"ss-beli_e.vqa", "", int32_t(0x313C2879), int32_t(0x00000000)},
    {"ss-beli_e.vqt", "", int32_t(0x313C288C), int32_t(0x00000000)},
    {"ss-bst-die_e.vqa", "", int32_t(0xEE2FCCA7), int32_t(0x00000000)},
    {"ss-bst-die_e.vqt", "", int32_t(0x012FCCA7), int32_t(0x00000000)},
    {"ss-cem_apr_e.vqa", "", int32_t(0xEAF7CA7D), int32_t(0x00000000)},
    {"ss-cem_apr_e.vqt", "", int32_t(0xFDF7CA7D), int32_t(0x00000000)},
    {"ss-citadel_e.vqa", "", int32_t(0xF67FDA77), int32_t(0x00000000)},
    {"ss-citadel_e.vqt", "", int32_t(0x097FDA77), int32_t(0x00000000)},
    {"ss-crazy_e.vqa", "", int32_t(0x2B306BF1), int32_t(0x00000000)},
    {"ss-crazy_e.vqt", "", int32_t(0x2B307EF1), int32_t(0x00000000)},
    {"ss-curse_e.vqa", "", int32_t(0xDB14AFFE), int32_t(0x00000000)},
    {"ss-curse_e.vqt", "", int32_t(0xDB14C2FE), int32_t(0x00000000)},
    {"ss-door_e.vqa", "", int32_t(0x416034A1), int32_t(0x00000000)},
    {"ss-door_e.vqt", "", int32_t(0x416034B4), int32_t(0x00000000)},
    {"ss-dragon5_e.vqa", "", int32_t(0x2A9760AD), int32_t(0x00000000)},
    {"ss-dragon5_e.vqt", "", int32_t(0x3D9760AD), int32_t(0x00000000)},
    {"ss-dragon7_e.vqa", "", int32_t(0x2A9764AD), int32_t(0x00000000)},
    {"ss-dragon7_e.vqt", "", int32_t(0x3D9764AD), int32_t(0x00000000)},
    {"ss-dragon8_e.vqa", "", int32_t(0x2A9766AD), int32_t(0x00000000)},
    {"ss-dragon8_e.vqt", "", int32_t(0x3D9766AD), int32_t(0x00000000)},
    {"ss-drgnflgt_e.vqa", "", int32_t(0x9544E9C1), int32_t(0x00000000)},
    {"ss-drgnflgt_e.vqt", "", int32_t(0x9544E9D4), int32_t(0x00000000)},
    {"ss-drmrmapr_e.vqa", "", int32_t(0xCD5D3D93), int32_t(0x00000000)},
    {"ss-drmrmapr_e.vqt", "", int32_t(0xCD5D3DA6), int32_t(0x00000000)},
    {"ss-e029e_e.vqa", "", int32_t(0xEAAC2F6A), int32_t(0x00000000)},
    {"ss-e029e_e.vqt", "", int32_t(0xEAAC426A), int32_t(0x00000000)},
    {"ss-e030e_e.vqa", "", int32_t(0xEA88336A), int32_t(0x00000000)},
    {"ss-e030e_e.vqt", "", int32_t(0xEA88466A), int32_t(0x00000000)},
    {"ss-e031e_e.vqa", "", int32_t(0xEA8C336A), int32_t(0x00000000)},
    {"ss-e031e_e.vqt", "", int32_t(0xEA8C466A), int32_t(0x00000000)},
    {"ss-e032e_e.vqa", "", int32_t(0xEA90336A), int32_t(0x00000000)},
    {"ss-e032e_e.vqt", "", int32_t(0xEA90466A), int32_t(0x00000000)},
    {"ss-e033e_e.vqa", "", int32_t(0xEA94336A), int32_t(0x00000000)},
    {"ss-e033e_e.vqt", "", int32_t(0xEA94466A), int32_t(0x00000000)},
    {"ss-e068e_e.vqa", "", int32_t(0xEAA83F6A), int32_t(0x00000000)},
    {"ss-e068e_e.vqt", "", int32_t(0xEAA8526A), int32_t(0x00000000)},
    {"ss-e069e_e.vqa", "", int32_t(0xEAAC3F6A), int32_t(0x00000000)},
    {"ss-e069e_e.vqt", "", int32_t(0xEAAC526A), int32_t(0x00000000)},
    {"ss-e125e_e.vqa", "", int32_t(0xEA9C2F6E), int32_t(0x00000000)},
    {"ss-e125e_e.vqt", "", int32_t(0xEA9C426E), int32_t(0x00000000)},
    {"ss-e198e_e.vqa", "", int32_t(0xEAA84B6E), int32_t(0x00000000)},
    {"ss-e198e_e.vqt", "", int32_t(0xEAA85E6E), int32_t(0x00000000)},
    {"ss-e232e_e.vqa", "", int32_t(0xEA903372), int32_t(0x00000000)},
    {"ss-e232e_e.vqt", "", int32_t(0xEA904672), int32_t(0x00000000)},
    {"ss-e233e_e.vqa", "", int32_t(0xEA943372), int32_t(0x00000000)},
    {"ss-e233e_e.vqt", "", int32_t(0xEA944672), int32_t(0x00000000)},
    {"ss-e242e_e.vqa", "", int32_t(0xEA903772), int32_t(0x00000000)},
    {"ss-e242e_e.vqt", "", int32_t(0xEA904A72), int32_t(0x00000000)},
    {"ss-e243e_e.vqa", "", int32_t(0xEA943772), int32_t(0x00000000)},
    {"ss-e243e_e.vqt", "", int32_t(0xEA944A72), int32_t(0x00000000)},
    {"ss-e244e_e.vqa", "", int32_t(0xEA983772), int32_t(0x00000000)},
    {"ss-e244e_e.vqt", "", int32_t(0xEA984A72), int32_t(0x00000000)},
    {"ss-elevator_e.vqa", "", int32_t(0x7D7CF9B1), int32_t(0x00000000)},
    {"ss-elevator_e.vqt", "", int32_t(0x7D7CF9C4), int32_t(0x00000000)},
    {"ss-fishdeth_e.vqa", "", int32_t(0xA4E57D5B), int32_t(0x00000000)},
    {"ss-fishdeth_e.vqt", "", int32_t(0xA4E57D6E), int32_t(0x00000000)},
    {"ss-flood_e.vqa", "", int32_t(0xEF04A3DA), int32_t(0x00000000)},
    {"ss-flood_e.vqt", "", int32_t(0xEF04B6DA), int32_t(0x00000000)},
    {"ss-gla_apr_e.vqa", "", int32_t(0x0AF79A99), int32_t(0x00000000)},
    {"ss-gla_apr_e.vqt", "", int32_t(0x1DF79A99), int32_t(0x00000000)},
    {"ss-hut-fire_e.vqa", "", int32_t(0xD4017DCB), int32_t(0x00000000)},
    {"ss-hut-fire_e.vqt", "", int32_t(0xD4017DDE), int32_t(0x00000000)},
    {"ss-hv1-v-rl_e.vqa", "", int32_t(0x541C6564), int32_t(0x00000000)},
    {"ss-hv1-v-rl_e.vqt", "", int32_t(0x541C6577), int32_t(0x00000000)},
    {"ss-hvwm_apr_e.vqa", "", int32_t(0x9D358DB4), int32_t(0x00000000)},
    {"ss-hvwm_apr_e.vqt", "", int32_t(0x9D358DC7), int32_t(0x00000000)},
    {"ss-hw-brdge_e.vqa", "", int32_t(0x34A819C8), int32_t(0x00000000)},
    {"ss-hw-brdge_e.vqt", "", int32_t(0x34A819DB), int32_t(0x00000000)},
    {"ss-larkvskn_e.vqa", "", int32_t(0x95155154), int32_t(0x00000000)},
    {"ss-larkvskn_e.vqt", "", int32_t(0x95155167), int32_t(0x00000000)},
    {"ss-liz-die_e.vqa", "", int32_t(0x3E2FE47F), int32_t(0x00000000)},
    {"ss-liz-die_e.vqt", "", int32_t(0x512FE47F), int32_t(0x00000000)},
    {"ss-lolg_e.vqa", "", int32_t(0x813428A1), int32_t(0x00000000)},
    {"ss-lolg_e.vqt", "", int32_t(0x813428B4), int32_t(0x00000000)},
    {"ss-luthrdie_e.vqa", "", int32_t(0x74D959B8), int32_t(0x00000000)},
    {"ss-luthrdie_e.vqt", "", int32_t(0x74D959CB), int32_t(0x00000000)},
    {"ss-ruin_app_e.vqa", "", int32_t(0x3D351DA7), int32_t(0x00000000)},
    {"ss-ruin_app_e.vqt", "", int32_t(0x3D351DBA), int32_t(0x00000000)},
    {"ss-sizzle_e.vqa", "", int32_t(0x27A0139E), int32_t(0x00000000)},
    {"ss-sizzle_e.vqt", "", int32_t(0x27B3139E), int32_t(0x00000000)},
    {"ss-ss-10e_e.vqa", "", int32_t(0xB6FB5FC7), int32_t(0x00000000)},
    {"ss-ss-10e_e.vqt", "", int32_t(0xB70E5FC7), int32_t(0x00000000)},
    {"ss-ss-11e_e.vqa", "", int32_t(0xBAFB5FC7), int32_t(0x00000000)},
    {"ss-ss-11e_e.vqt", "", int32_t(0xBB0E5FC7), int32_t(0x00000000)},
    {"ss-ss-12e_e.vqa", "", int32_t(0xBEFB5FC7), int32_t(0x00000000)},
    {"ss-ss-12e_e.vqt", "", int32_t(0xBF0E5FC7), int32_t(0x00000000)},
    {"ss-ss-1e_e.vqa", "", int32_t(0x5A8C1BF5), int32_t(0x00000000)},
    {"ss-ss-1e_e.vqt", "", int32_t(0x5A8C2EF5), int32_t(0x00000000)},
    {"ss-ss-2e_e.vqa", "", int32_t(0x5A901BF5), int32_t(0x00000000)},
    {"ss-ss-2e_e.vqt", "", int32_t(0x5A902EF5), int32_t(0x00000000)},
    {"ss-ss-3e_e.vqa", "", int32_t(0x5A941BF5), int32_t(0x00000000)},
    {"ss-ss-3e_e.vqt", "", int32_t(0x5A942EF5), int32_t(0x00000000)},
    {"ss-ss-4e_e.vqa", "", int32_t(0x5A981BF5), int32_t(0x00000000)},
    {"ss-ss-4e_e.vqt", "", int32_t(0x5A982EF5), int32_t(0x00000000)},
    {"ss-ss-5e_e.vqa", "", int32_t(0x5A9C1BF5), int32_t(0x00000000)},
    {"ss-ss-5e_e.vqt", "", int32_t(0x5A9C2EF5), int32_t(0x00000000)},
    {"ss-ss-6e_e.vqa", "", int32_t(0x5AA01BF5), int32_t(0x00000000)},
    {"ss-ss-6e_e.vqt", "", int32_t(0x5AA02EF5), int32_t(0x00000000)},
    {"ss-ss-7e_e.vqa", "", int32_t(0x5AA41BF5), int32_t(0x00000000)},
    {"ss-ss-7e_e.vqt", "", int32_t(0x5AA42EF5), int32_t(0x00000000)},
    {"ss-ss-8e_e.vqa", "", int32_t(0x5AA81BF5), int32_t(0x00000000)},
    {"ss-ss-8e_e.vqt", "", int32_t(0x5AA82EF5), int32_t(0x00000000)},
    {"ss-ss-9e_e.vqa", "", int32_t(0x5AAC1BF5), int32_t(0x00000000)},
    {"ss-ss-9e_e.vqt", "", int32_t(0x5AAC2EF5), int32_t(0x00000000)},
    {"ss-stat_wlk_e.vqa", "", int32_t(0x4D50CDF7), int32_t(0x00000000)},
    {"ss-stat_wlk_e.vqt", "", int32_t(0x4D50CE0A), int32_t(0x00000000)},
    {"ss-tavern_e.vqa", "", int32_t(0x474C0390), int32_t(0x00000000)},
    {"ss-tavern_e.vqt", "", int32_t(0x475F0390), int32_t(0x00000000)},
    {"ss-tmpl_apr_e.vqa", "", int32_t(0x5D2D5567), int32_t(0x00000000)},
    {"ss-tmpl_apr_e.vqt", "", int32_t(0x5D2D557A), int32_t(0x00000000)},
    {"ss-tmplcr_e_e.vqa", "", int32_t(0x7CF991B0), int32_t(0x00000000)},
    {"ss-tmplcr_e_e.vqt", "", int32_t(0x7CF991C3), int32_t(0x00000000)},
    {"ss-tower_ap_e.vqa", "", int32_t(0xF4ED51F4), int32_t(0x00000000)},
    {"ss-tower_ap_e.vqt", "", int32_t(0xF4ED5207), int32_t(0x00000000)},
    {"ss-voices_e.vqa", "", int32_t(0x2343CFD2), int32_t(0x00000000)},
    {"ss-voices_e.vqt", "", int32_t(0x2356CFD2), int32_t(0x00000000)},
    {"ss-wrm_eat_e.vqa", "", int32_t(0x9AF7CE92), int32_t(0x00000000)},
    {"ss-wrm_eat_e.vqt", "", int32_t(0xADF7CE92), int32_t(0x00000000)},
    {"ss-wrm_stat_e.vqa", "", int32_t(0x2DCD01DB), int32_t(0x00000000)},
    {"ss-wrm_stat_e.vqt", "", int32_t(0x2DCD01EE), int32_t(0x00000000)},
    {"ss.shp", "unit: submarine", int32_t(0xA65CF6EE), int32_t(0x00000000)},
    {"ssam.shp", "misc: destroyer turret", int32_t(0xEACAF9D4), int32_t(0x00000000)},
    {"ssarbat1.aud", "", int32_t(0xF00310FF), int32_t(0x00000000)},
    {"ssarcav1.aud", "", int32_t(0xF0071101), int32_t(0x00000000)},
    {"ssarpit1.aud", "", int32_t(0xF003211B), int32_t(0x00000000)},
    {"ssatk1.aud", "", int32_t(0xD361F438), int32_t(0x00000000)},
    {"sscore.pal", "", int32_t(0x00000000), int32_t(0xC88AD853)},
    {"sscramd.shp", "", int32_t(0x00000000), int32_t(0x56155FEA)},
    {"sscrasm.shp", "", int32_t(0x00000000), int32_t(0x46FBE9B1)},
    {"sscrbkmd.shp", "", int32_t(0x00000000), int32_t(0xB698FFD0)},
    {"sscrbksm.shp", "", int32_t(0x00000000), int32_t(0x8254FE4A)},
    {"sscrtmd.shp", "", int32_t(0x00000000), int32_t(0x624E60A5)},
    {"sscrtsm.shp", "", int32_t(0x00000000), int32_t(0x72A0D6FE)},
    {"ssdie1.aud", "", int32_t(0xA76DF42C), int32_t(0x00000000)},
    {"sshurt1.aud", "", int32_t(0xB1C84B32), int32_t(0x00000000)},
    {"sshurt2.aud", "", int32_t(0xB1CA4B32), int32_t(0x00000000)},
    {"ssicon.shp", "icon: submarine", int32_t(0xB3823A33), int32_t(0x00000000)},
    {"ssloitr1.aud", "", int32_t(0xE42B370D), int32_t(0x00000000)},
    {"ssloitr2.aud", "", int32_t(0xE62B370D), int32_t(0x00000000)},
    {"ssplash1.aud", "small water splash", int32_t(0x00000000), int32_t(0x5F56B8E1)},
    {"ssplash2.aud", "small water splash", int32_t(0x00000000), int32_t(0x18F6C231)},
    {"ssplash3.aud", "small water splash", int32_t(0x00000000), int32_t(0x2596EB81)},
    {"ssrv.shp", "", int32_t(0x00000000), int32_t(0x277F97EC)},
    {"ssswndchim4.aud", "", int32_t(0x38549BA5), int32_t(0x00000000)},
    {"ssteal1.aud", "", int32_t(0x71F83B10), int32_t(0x00000000)},
    {"staffup1.aud", "", int32_t(0xBFFB3D07), int32_t(0x00000000)},
    {"staghit1.aud", "", int32_t(0xC403250B), int32_t(0x00000000)},
    {"staghit2.aud", "", int32_t(0xC603250B), int32_t(0x00000000)},
    {"stagup1.aud", "", int32_t(0x79AC4738), int32_t(0x00000000)},
    {"stalag1.aud", "", int32_t(0x8DAC3510), int32_t(0x00000000)},
    {"stalin.bmp", "", int32_t(0x00000000), int32_t(0xB36335CA)},
    {"stalin.pcx", "pict: stalin", int32_t(0xD1624622), int32_t(0x00000000)},
    {"staln-lo.cps", "pict: stalin", int32_t(0x22EDEF17), int32_t(0x00000000)},
    {"standby1.aud", "audf:", int32_t(0xE00D1703), int32_t(0x00000000)},
    {"stang.hva", "", int32_t(0x00000000), int32_t(0xBD2E354C)},
    {"stang.vxl", "", int32_t(0x00000000), int32_t(0x02B732EB)},
    {"stargen.pcx", "", int32_t(0x00000000), int32_t(0xF9F934D5)},
    {"staricon.flc", "", int32_t(0x28F01E0D), int32_t(0x00000000)},
    {"startbut.shp", "", int32_t(0x00000000), int32_t(0x3B7F5065)},
    {"startup.vqa", "-", int32_t(0x00000000), int32_t(0xF4067CE2)},
    {"stat.csv", "", int32_t(0xFED5EBD4), int32_t(0x00000000)},
    {"stat_wlk.csv", "", int32_t(0x3DF14339), int32_t(0x00000000)},
    {"stat_wlk.lsv", "", int32_t(0x3DF14C39), int32_t(0x00000000)},
    {"stat_wlk.vqa", "", int32_t(0x28EF5639), int32_t(0x00000000)},
    {"stat_wlk_e.vqa", "", int32_t(0x7B98CC25), int32_t(0x00000000)},
    {"stat_wlk_e.vqt", "", int32_t(0x7B98DF25), int32_t(0x00000000)},
    {"stat_wlk_h.pcx", "", int32_t(0x6F98E917), int32_t(0x00000000)},
    {"stat_wlk_h.vqa", "", int32_t(0x7B98D225), int32_t(0x00000000)},
    {"stat_wlk_l.pcx", "", int32_t(0x6F98F117), int32_t(0x00000000)},
    {"stat_wlk_l.vqa", "", int32_t(0x7B98DA25), int32_t(0x00000000)},
    {"statdisp.shp", "", int32_t(0x41F43703), int32_t(0x00000000)},
    {"static.shp", "-", int32_t(0x00000000), int32_t(0xDF980EEC)},
    {"statmov1.aud", "", int32_t(0xF8073115), int32_t(0x00000000)},
    {"statmov2.aud", "", int32_t(0xFA073115), int32_t(0x00000000)},
    {"statmov3.aud", "", int32_t(0xFC073115), int32_t(0x00000000)},
    {"stattab.shp", "", int32_t(0xADDA1C48), int32_t(0x00000000)},
    {"stavcmdr.aud", "stavros: commander?", int32_t(0x41E32D01), int32_t(0x00000000)},
    {"stavcrse.aud", "stavros: of course!", int32_t(0x28013701), int32_t(0x00000000)},
    {"stavmov.aud", "stavros: move out!", int32_t(0xB5F64528), int32_t(0x00000000)},
    {"stavyes.aud", "stavros: yes", int32_t(0xB5F03140), int32_t(0x00000000)},
    {"std6p.fnt", "", int32_t(0x759DAE41), int32_t(0x00000000)},
    {"std8p.fnt", "", int32_t(0x7D9DAE41), int32_t(0x00000000)},
    {"stdmrb01.urb", "", int32_t(0x00000000), int32_t(0x26B28EF3)},
    {"stealth.vqa", "stealth tank", int32_t(0x61E74B3B), int32_t(0x00000000)},
    {"stealth.vqp", "stealth tank", int32_t(0x61F64B3B), int32_t(0x00000000)},
    {"stealth2.shp", "crat: stealth", int32_t(0xB9EE4D13), int32_t(0x00000000)},
    {"steam1.aud", "", int32_t(0x8771F83C), int32_t(0x00000000)},
    {"steam2.aud", "", int32_t(0x8771FA3C), int32_t(0x00000000)},
    {"steam3.aud", "", int32_t(0x8771FC3C), int32_t(0x00000000)},
    {"steam6a.aud", "", int32_t(0x61DC1328), int32_t(0x00000000)},
    {"steambed.aud", "", int32_t(0xD1F51715), int32_t(0x00000000)},
    {"steampuf.shp", "-", int32_t(0x00000000), int32_t(0x2E4CEDAE)},
    {"steamsm1.aud", "", int32_t(0xAC053915), int32_t(0x00000000)},
    {"steamy1.aud", "", int32_t(0x61BC5928), int32_t(0x00000000)},
    {"steamy2.aud", "", int32_t(0x61BE5928), int32_t(0x00000000)},
    {"steg.shp", "stegosaurus", int32_t(0xDED2FBD4), int32_t(0x00000000)},
    {"stegicnh.shp", "", int32_t(0xFDFA2B0D), int32_t(0x00000000)},
    {"stegicnh.tem", "", int32_t(0xFAF72C0D), int32_t(0x00000000)},
    {"stek.shp", "bldg: soviet tech center", int32_t(0xE6D2FBD4), int32_t(0x00000000)},
    {"stekicon.shp", "icon: techcenter", int32_t(0x19FC2B0D), int32_t(0x00000000)},
    {"stekmake.shp", "make: soviet tech center", int32_t(0x07F42715), int32_t(0x00000000)},
    {"sticky1.aud", "", int32_t(0x69CC5924), int32_t(0x00000000)},
    {"sticky2.aud", "", int32_t(0x69CE5924), int32_t(0x00000000)},
    {"sticky3.aud", "", int32_t(0x69D05924), int32_t(0x00000000)},
    {"sticky4.aud", "", int32_t(0x69D25924), int32_t(0x00000000)},
    {"sticky5.aud", "", int32_t(0x69D45924), int32_t(0x00000000)},
    {"sticky6.aud", "", int32_t(0x69D65924), int32_t(0x00000000)},
    {"stl01.urb", "", int32_t(0x00000000), int32_t(0xF0D724BE)},
    {"stl02.urb", "", int32_t(0x00000000), int32_t(0x7E58235D)},
    {"stl03.urb", "", int32_t(0x00000000), int32_t(0xB2F223C3)},
    {"stl04.urb", "", int32_t(0x00000000), int32_t(0xB8372ADA)},
    {"stln.shp", "", int32_t(0x00000000), int32_t(0x8B9416CA)},
    {"stmloop7.aud", "", int32_t(0xE42B3119), int32_t(0x00000000)},
    {"stmston1.aud", "", int32_t(0xF4273123), int32_t(0x00000000)},
    {"stmston2.aud", "", int32_t(0xF6273123), int32_t(0x00000000)},
    {"stnelv2.aud", "", int32_t(0x71E25326), int32_t(0x00000000)},
    {"stnk.hva", "-", int32_t(0x00000000), int32_t(0xA03E6B0D)},
    {"stnk.shp", "stealth tank", int32_t(0xE6E4FBD4), int32_t(0x00000000)},
    {"stnk.vxl", "stealth tank", int32_t(0x00000000), int32_t(0x56B4B444)},
    {"stnkicnh.des", "icon: stealth tank", int32_t(0x111B1C0D), int32_t(0x00000000)},
    {"stnkicnh.tem", "icon: stealth tank", int32_t(0x0B1B2C0D), int32_t(0x00000000)},
    {"stnkicnh.win", "icon: stealth tank", int32_t(0x0C1F2F0D), int32_t(0x00000000)},
    {"stnkicon.shp", "icon: stealth tank", int32_t(0x1A202B0D), int32_t(0x03C37E52)},
    {"stondor1.aud", "", int32_t(0xE0373103), int32_t(0x00000000)},
    {"stondor2.aud", "", int32_t(0xE2373103), int32_t(0x00000000)},
    {"stone1.aud", "", int32_t(0xBB99F82C), int32_t(0x00000000)},
    {"stone10.aud", "", int32_t(0x95E20918), int32_t(0x00000000)},
    {"stone11.aud", "", int32_t(0x95E40918), int32_t(0x00000000)},
    {"stone2.aud", "", int32_t(0xBB99FA2C), int32_t(0x00000000)},
    {"stone3.aud", "", int32_t(0xBB99FC2C), int32_t(0x00000000)},
    {"stone4.aud", "", int32_t(0xBB99FE2C), int32_t(0x00000000)},
    {"stone5.aud", "", int32_t(0xBB9A002C), int32_t(0x00000000)},
    {"stone6.aud", "", int32_t(0xBB9A022C), int32_t(0x00000000)},
    {"stone7.aud", "", int32_t(0xBB9A042C), int32_t(0x00000000)},
    {"stone8.aud", "", int32_t(0xBB9A062C), int32_t(0x00000000)},
    {"stone9.aud", "", int32_t(0xBB9A082C), int32_t(0x00000000)},
    {"stoned1.aud", "", int32_t(0x95E42F18), int32_t(0x00000000)},
    {"stonel1.aud", "", int32_t(0x95E43F18), int32_t(0x00000000)},
    {"stonplt1.aud", "", int32_t(0xE03B2B1B), int32_t(0x00000000)},
    {"stonplt2.aud", "", int32_t(0xE23B2B1B), int32_t(0x00000000)},
    {"stonsl~1.aud", "", int32_t(0xE08F2B21), int32_t(0x00000000)},
    {"stonsl~2.aud", "", int32_t(0xE28F2B21), int32_t(0x00000000)},
    {"stonwlk1.aud", "", int32_t(0xE0292B29), int32_t(0x00000000)},
    {"stonwlk2.aud", "", int32_t(0xE2292B29), int32_t(0x00000000)},
    {"stonwlk3.aud", "", int32_t(0xE4292B29), int32_t(0x00000000)},
    {"stonwlk4.aud", "", int32_t(0xE6292B29), int32_t(0x00000000)},
    {"stonwlk5.aud", "", int32_t(0xE8292B29), int32_t(0x00000000)},
    {"stonwlk6.aud", "", int32_t(0xEA292B29), int32_t(0x00000000)},
    {"stonwlk7.aud", "", int32_t(0xEC292B29), int32_t(0x00000000)},
    {"stopthem.aud", "deception", int32_t(0x201D2323), int32_t(0x00000000)},
    {"stopthem.var", "", int32_t(0x2E093823), int32_t(0x00000000)},
    {"storm.aud", "ion storm", int32_t(0x00000000), int32_t(0x22BF73B2)},
    {"storms.ini", "", int32_t(0x00000000), int32_t(0xA47038D4)},
    {"storms.map", "-", int32_t(0x00000000), int32_t(0x8ADB0B2C)},
    {"stpmrph1.aud", "", int32_t(0xDC27331F), int32_t(0x00000000)},
    {"strafe.vqa", "strafe of tanks", int32_t(0xB1A61D2A), int32_t(0x00000000)},
    {"strafe.vqp", "vqp: strafe of tanks", int32_t(0xB1A62C2A), int32_t(0x00000000)},
    {"strckil1.aud", "structure destroyed", int32_t(0xB4372511), int32_t(0x00000000)},
    {"strclost.aud", "structure lost", int32_t(0xFA453113), int32_t(0x00000000)},
    {"strike1.aud", "", int32_t(0x81F03124), int32_t(0x00000000)},
    {"strike2.aud", "", int32_t(0x81F23124), int32_t(0x00000000)},
    {"strike3.aud", "", int32_t(0x81F43124), int32_t(0x00000000)},
    {"strike4.aud", "", int32_t(0x81F63124), int32_t(0x00000000)},
    {"strike5.aud", "", int32_t(0x81F83124), int32_t(0x00000000)},
    {"strike6.aud", "", int32_t(0x81FA3124), int32_t(0x00000000)},
    {"strip.shp", "icon: blank tile", int32_t(0xB5EFAE3D), int32_t(0x00000000)},
    {"strip1.aud", "", int32_t(0xA7A5F842), int32_t(0x00000000)},
    {"stripdn.shp", "butt: scroll down", int32_t(0x82362240), int32_t(0x00000000)},
    {"stripna.shp", "misc: allies sidebar background", int32_t(0x821C3640), int32_t(0x00000000)},
    {"stripup.shp", "butt: scroll up", int32_t(0x823A4440), int32_t(0x00000000)},
    {"stripus.shp", "misc: soviet sidebar background", int32_t(0x82404440), int32_t(0x00000000)},
    {"strkatk1.aud", "", int32_t(0xD4353AFD), int32_t(0x00000000)},
    {"strkatk2.aud", "", int32_t(0xD6353AFD), int32_t(0x00000000)},
    {"strkatk3.aud", "", int32_t(0xD8353AFD), int32_t(0x00000000)},
    {"strkatk4.aud", "", int32_t(0xDA353AFD), int32_t(0x00000000)},
    {"strkatk5.aud", "", int32_t(0xDC353AFD), int32_t(0x00000000)},
    {"strkatk6.aud", "", int32_t(0xDE353AFD), int32_t(0x00000000)},
    {"strkhit1.aud", "", int32_t(0xD447250B), int32_t(0x00000000)},
    {"strkhit2.aud", "", int32_t(0xD647250B), int32_t(0x00000000)},
    {"strkloi1.aud", "", int32_t(0xD4313113), int32_t(0x00000000)},
    {"strkloi2.aud", "", int32_t(0xD6313113), int32_t(0x00000000)},
    {"strkloi3.aud", "", int32_t(0xD8313113), int32_t(0x00000000)},
    {"strkrun1.aud", "", int32_t(0xD43B3D1F), int32_t(0x00000000)},
    {"strkrun2.aud", "", int32_t(0xD63B3D1F), int32_t(0x00000000)},
    {"strkrun3.aud", "", int32_t(0xD83B3D1F), int32_t(0x00000000)},
    {"strkrun4.aud", "", int32_t(0xDA3B3D1F), int32_t(0x00000000)},
    {"strkwlk1.aud", "", int32_t(0xD4352B29), int32_t(0x00000000)},
    {"strkwlk2.aud", "", int32_t(0xD6352B29), int32_t(0x00000000)},
    {"strmyvly.ini", "", int32_t(0x00000000), int32_t(0x73C2F420)},
    {"strmyvly.map", "-", int32_t(0x00000000), int32_t(0x9738E8F3)},
    {"strngalt.aud", "", int32_t(0x26371509), int32_t(0x00000000)},
    {"stroke01.flc", "", int32_t(0xE2F62211), int32_t(0x00000000)},
    {"strp0001.int", "green with yellow stripe", int32_t(0xF7F7FADB), int32_t(0x00000000)},
    {"strp0002.int", "green with yellow stripe", int32_t(0xF9F7FADB), int32_t(0x00000000)},
    {"strp0003.int", "green with yellow stripe", int32_t(0xFBF7FADB), int32_t(0x00000000)},
    {"strp0004.int", "green with yellow stripe", int32_t(0xFDF7FADB), int32_t(0x00000000)},
    {"strp0005.int", "green with yellow stripe", int32_t(0xFFF7FADB), int32_t(0x00000000)},
    {"strp0006.int", "green with yellow stripe", int32_t(0x01F7FADB), int32_t(0x00000000)},
    {"strp0007.int", "green with yellow stripe", int32_t(0x03F7FADB), int32_t(0x00000000)},
    {"strp0008.int", "green with yellow stripe", int32_t(0x05F7FADB), int32_t(0x00000000)},
    {"strp0009.int", "green with yellow stripe", int32_t(0x07F7FADB), int32_t(0x00000000)},
    {"strp0010.int", "green with yellow stripe", int32_t(0xF5F9FADB), int32_t(0x00000000)},
    {"strp0011.int", "green with yellow stripe", int32_t(0xF7F9FADB), int32_t(0x00000000)},
    {"strucap1.aud", "structure captured", int32_t(0xFC3F1501), int32_t(0x00000000)},
    {"struggle.aud", "static sounds", int32_t(0x24372109), int32_t(0x00000000)},
    {"strusld1.aud", "structure sold", int32_t(0xFC272B21), int32_t(0x00000000)},
    {"sub.bmp", "", int32_t(0x00000000), int32_t(0x99EA5595)},
    {"sub.hva", "", int32_t(0x00000000), int32_t(0xB5FDDA70)},
    {"sub.vxl", "", int32_t(0x00000000), int32_t(0xBA0BA99B)},
    {"subdril1.aud", "subterrian drill", int32_t(0x00000000), int32_t(0x856B3631)},
    {"subicon.shp", "", int32_t(0x00000000), int32_t(0x0BD61709)},
    {"subshow1.aud", "sub uncloaking", int32_t(0xF40D350B), int32_t(0x00000000)},
    {"subt.hva", "", int32_t(0x00000000), int32_t(0x933BA091)},
    {"subt.vxl", "", int32_t(0x00000000), int32_t(0x65B17FD8)},
    {"subtank.hva", "-", int32_t(0x00000000), int32_t(0x20BF52A1)},
    {"subtank.vxl", "devils tongue flame tank", int32_t(0x00000000), int32_t(0x2F49214A)},
    {"subticon.shp", "icon: devil's tongue flame tank", int32_t(0x00000000), int32_t(0xAB08CCBC)},
    {"subway1.aud", "", int32_t(0xB9B05D10), int32_t(0x00000000)},
    {"sucrate.shp", "", int32_t(0xA5E84622), int32_t(0x00000000)},
    {"sunbem06.flc", "", int32_t(0xB8E63605), int32_t(0x00000000)},
    {"sundial.vqa", "sundial being blown up", int32_t(0x6E132935), int32_t(0x00000000)},
    {"sundial.vqp", "sundial being blown up", int32_t(0x6E222935), int32_t(0x00000000)},
    {"sunray3.aud", "", int32_t(0xA5E45D10), int32_t(0x00000000)},
    {"sunray4.aud", "", int32_t(0xA5E65D10), int32_t(0x00000000)},
    {"sunroom1.aud", "", int32_t(0xF0293519), int32_t(0x00000000)},
    {"sunroom2.aud", "", int32_t(0xF2293519), int32_t(0x00000000)},
    {"sunroom3.aud", "", int32_t(0xF4293519), int32_t(0x00000000)},
    {"sunroom4.aud", "", int32_t(0xF6293519), int32_t(0x00000000)},
    {"sup_bh_r.ini", "", int32_t(0x00000000), int32_t(0xD02D1AE0)},
    {"sup_bh_r.map", "-", int32_t(0x00000000), int32_t(0x34D70633)},
    {"suvb.hva", "", int32_t(0x00000000), int32_t(0xE4DC823E)},
    {"suvb.vxl", "", int32_t(0x00000000), int32_t(0x12565D77)},
    {"suvw.hva", "", int32_t(0x00000000), int32_t(0x4CDC9ACC)},
    {"suvw.vxl", "", int32_t(0x00000000), int32_t(0xBA564585)},
    {"swamp01.tem", "-", int32_t(0x00000000), int32_t(0x9D62AA2F)},
    {"swamp01a.tem", "-", int32_t(0x00000000), int32_t(0xC6DB2593)},
    {"swamp01b.tem", "-", int32_t(0x00000000), int32_t(0x817B5F43)},
    {"swamp01c.tem", "-", int32_t(0x00000000), int32_t(0xBC1B76F3)},
    {"swamp01d.tem", "-", int32_t(0x00000000), int32_t(0x0E3BAAE3)},
    {"swamp01e.tem", "-", int32_t(0x00000000), int32_t(0x335B8353)},
    {"swamp01f.tem", "-", int32_t(0x00000000), int32_t(0x74FBF983)},
    {"swamp01g.tem", "-", int32_t(0x00000000), int32_t(0x499BD033)},
    {"swamp02.tem", "-", int32_t(0x00000000), int32_t(0x1BF6D881)},
    {"swamp03.tem", "-", int32_t(0x00000000), int32_t(0xD0AA0B24)},
    {"swamp04.tem", "-", int32_t(0x00000000), int32_t(0xCDAF3B9C)},
    {"swamp05.tem", "-", int32_t(0x00000000), int32_t(0x06F3E839)},
    {"swamp06.tem", "-", int32_t(0x00000000), int32_t(0x80679A97)},
    {"swamp07.tem", "-", int32_t(0x00000000), int32_t(0x4B3B4932)},
    {"swamp08.tem", "-", int32_t(0x00000000), int32_t(0xBA6DFBE7)},
    {"swamp09.tem", "-", int32_t(0x00000000), int32_t(0x71312842)},
    {"swdflm1.aud", "", int32_t(0x75B84D26), int32_t(0x00000000)},
    {"swdhit1.aud", "", int32_t(0x7DB85B20), int32_t(0x00000000)},
    {"sweep2.aud", "", int32_t(0x97720642), int32_t(0x00000000)},
    {"sweep3.aud", "", int32_t(0x97720842), int32_t(0x00000000)},
    {"sweep4.aud", "", int32_t(0x97720A42), int32_t(0x00000000)},
    {"swhat1.aud", "thief: what?", int32_t(0x877E044A), int32_t(0x00000000)},
    {"swing1.aud", "", int32_t(0xBB820430), int32_t(0x00000000)},
    {"swing2.aud", "", int32_t(0xBB820630), int32_t(0x00000000)},
    {"swing4.aud", "", int32_t(0xBB820A30), int32_t(0x00000000)},
    {"swish1.aud", "", int32_t(0xCF820432), int32_t(0x00000000)},
    {"swish12.aud", "", int32_t(0xA9CE151E), int32_t(0x00000000)},
    {"swish15.aud", "", int32_t(0xA9D4151E), int32_t(0x00000000)},
    {"swish17.aud", "", int32_t(0xA9D8151E), int32_t(0x00000000)},
    {"swish18.aud", "", int32_t(0xA9DA151E), int32_t(0x00000000)},
    {"swish2.aud", "", int32_t(0xCF820632), int32_t(0x00000000)},
    {"swish25.aud", "", int32_t(0xA9D4171E), int32_t(0x00000000)},
    {"swish29.aud", "", int32_t(0xA9DC171E), int32_t(0x00000000)},
    {"swish3.aud", "", int32_t(0xCF820832), int32_t(0x00000000)},
    {"swish34.aud", "", int32_t(0xA9D2191E), int32_t(0x00000000)},
    {"swish4.aud", "", int32_t(0xCF820A32), int32_t(0x00000000)},
    {"switch9.aud", "", int32_t(0xADDC4314), int32_t(0x00000000)},
    {"switchy1.aud", "", int32_t(0xF82D2F01), int32_t(0x00000000)},
    {"switchy2.aud", "", int32_t(0xFA2D2F01), int32_t(0x00000000)},
    {"swngbeas.aud", "", int32_t(0x081128FF), int32_t(0x00000000)},
    {"swngliz.aud", "", int32_t(0x7A324526), int32_t(0x00000000)},
    {"swod4.img", "", int32_t(0xABCFB9FC), int32_t(0x00000000)},
    {"swod4.lmf", "", int32_t(0xABD5B9FB), int32_t(0x00000000)},
    {"swod4.lsv", "", int32_t(0xB7D5BA0B), int32_t(0x00000000)},
    {"swod4.odf", "", int32_t(0x99DBB9FB), int32_t(0x00000000)},
    {"swod4.pcx", "", int32_t(0x97DDBA0D), int32_t(0x00000000)},
    {"swod4.ver", "", int32_t(0x9BE9BA07), int32_t(0x00000000)},
    {"swoosh01.flc", "", int32_t(0xE2EA3421), int32_t(0x00000000)},
    {"swordft1.aud", "", int32_t(0xF03B2B03), int32_t(0x00000000)},
    {"swordft2.aud", "", int32_t(0xF23B2B03), int32_t(0x00000000)},
    {"swordft3.aud", "", int32_t(0xF43B2B03), int32_t(0x00000000)},
    {"swordft4.aud", "", int32_t(0xF63B2B03), int32_t(0x00000000)},
    {"swordft5.aud", "", int32_t(0xF83B2B03), int32_t(0x00000000)},
    {"swordlg1.aud", "", int32_t(0xF0213703), int32_t(0x00000000)},
    {"swordsm1.aud", "", int32_t(0xF02D4503), int32_t(0x00000000)},
    {"sycramd.shp", "", int32_t(0x00000000), int32_t(0xB4BA076E)},
    {"sycrbkmd.shp", "", int32_t(0x00000000), int32_t(0x5437A754)},
    {"sycrtmd.pal", "", int32_t(0x00000000), int32_t(0x7BF2F11D)},
    {"sycrtmd.shp", "", int32_t(0x00000000), int32_t(0x80E13821)},
    {"syeah1.aud", "thief: yeah!", int32_t(0x87720C32), int32_t(0x00000000)},
    {"syessir1.aud", "spy: yes sir!", int32_t(0xF40F3921), int32_t(0x00000000)},
    {"sylook.vqp", "???", int32_t(0xE98E4C3C), int32_t(0x00000000)},
    {"syrd.shp", "bldg: naval yard", int32_t(0xD8ED05D4), int32_t(0x00000000)},
    {"syrdicon.shp", "icon: naval yard", int32_t(0xFE303F0D), int32_t(0x00000000)},
    {"syrdmake.shp", "make: naval yard", int32_t(0xEC283B15), int32_t(0x00000000)},
    {"syrficon.shp", "icon: naval yard fake", int32_t(0x06303F0D), int32_t(0x00000000)},
    {"t01.sno", "misc: tree #1", int32_t(0x5CB1AEFB), int32_t(0x00000000)},
    {"t01.tem", "tree #1", int32_t(0x5CAFA5FC), int32_t(0x00000000)},
    {"t01.win", "tree #1", int32_t(0x5CB0A9FF), int32_t(0x00000000)},
    {"t02.sno", "misc: tree #2", int32_t(0x5CB3AEFB), int32_t(0x00000000)},
    {"t02.tem", "tree #2", int32_t(0x5CB1A5FC), int32_t(0x00000000)},
    {"t02.win", "tree #2", int32_t(0x5CB2A9FF), int32_t(0x00000000)},
    {"t03.sno", "misc: tree #3", int32_t(0x5CB5AEFB), int32_t(0x00000000)},
    {"t03.tem", "tree #3", int32_t(0x5CB3A5FC), int32_t(0x00000000)},
    {"t03.win", "tree #3", int32_t(0x5CB4A9FF), int32_t(0x00000000)},
    {"t04.des", "tree #4", int32_t(0x5CBBA5EC), int32_t(0x00000000)},
    {"t04.sno", "misc: tree #4", int32_t(0x5CB7AEFB), int32_t(0x00000000)},
    {"t04.tem", "misc: tree #4", int32_t(0x5CB5A5FC), int32_t(0x00000000)},
    {"t05.sno", "misc: tree #5", int32_t(0x5CB9AEFB), int32_t(0x00000000)},
    {"t05.tem", "tree #5", int32_t(0x5CB7A5FC), int32_t(0x00000000)},
    {"t05.win", "tree #5", int32_t(0x5CB8A9FF), int32_t(0x00000000)},
    {"t06.sno", "misc: tree #6", int32_t(0x5CBBAEFB), int32_t(0x00000000)},
    {"t06.tem", "tree #6", int32_t(0x5CB9A5FC), int32_t(0x00000000)},
    {"t06.win", "tree #6", int32_t(0x5CBAA9FF), int32_t(0x00000000)},
    {"t07.sno", "misc: tree #7", int32_t(0x5CBDAEFB), int32_t(0x00000000)},
    {"t07.tem", "tree #7", int32_t(0x5CBBA5FC), int32_t(0x00000000)},
    {"t07.win", "tree #7", int32_t(0x5CBCA9FF), int32_t(0x00000000)},
    {"t08.des", "tree #8", int32_t(0x5CC3A5EC), int32_t(0x00000000)},
    {"t08.sno", "misc: tree #8", int32_t(0x5CBFAEFB), int32_t(0x00000000)},
    {"t08.tem", "tree #8", int32_t(0x5CBDA5FC), int32_t(0x00000000)},
    {"t08.win", "tree #8", int32_t(0x5CBEA9FF), int32_t(0x00000000)},
    {"t09.des", "tree #9", int32_t(0x5CC5A5EC), int32_t(0x00000000)},
    {"t09.sno", "misc: tree #9", int32_t(0x5CC1AEFB), int32_t(0x00000000)},
    {"t09.tem", "misc: tree #9", int32_t(0x5CBFA5FC), int32_t(0x00000000)},
    {"t1.aud", "", int32_t(0x825CA6FD), int32_t(0x00000000)},
    {"t1.bmp", "", int32_t(0x845CB2F5), int32_t(0x00000000)},
    {"t1.wav", "", int32_t(0xAE5CB8E9), int32_t(0x00000000)},
    {"t10.sno", "misc: tree #10", int32_t(0x5CAFB0FB), int32_t(0x00000000)},
    {"t10.tem", "tree #10", int32_t(0x5CADA7FC), int32_t(0x00000000)},
    {"t10.win", "tree #10", int32_t(0x5CAEABFF), int32_t(0x00000000)},
    {"t11.sno", "misc: tree #11", int32_t(0x5CB1B0FB), int32_t(0x00000000)},
    {"t11.tem", "tree #11", int32_t(0x5CAFA7FC), int32_t(0x00000000)},
    {"t11.win", "tree #11", int32_t(0x5CB0ABFF), int32_t(0x00000000)},
    {"t12.sno", "misc: tree #12", int32_t(0x5CB3B0FB), int32_t(0x00000000)},
    {"t12.tem", "tree #12", int32_t(0x5CB1A7FC), int32_t(0x00000000)},
    {"t12.win", "tree #12", int32_t(0x5CB2ABFF), int32_t(0x00000000)},
    {"t13.sno", "misc: tree #13", int32_t(0x5CB5B0FB), int32_t(0x00000000)},
    {"t13.tem", "tree #13", int32_t(0x5CB3A7FC), int32_t(0x00000000)},
    {"t13.win", "tree #13", int32_t(0x5CB4ABFF), int32_t(0x00000000)},
    {"t14.sno", "misc: tree #14", int32_t(0x5CB7B0FB), int32_t(0x00000000)},
    {"t14.tem", "tree #14", int32_t(0x5CB5A7FC), int32_t(0x00000000)},
    {"t14.win", "tree #14", int32_t(0x5CB6ABFF), int32_t(0x00000000)},
    {"t15.sno", "misc: tree #15", int32_t(0x5CB9B0FB), int32_t(0x00000000)},
    {"t15.tem", "tree #15", int32_t(0x5CB7A7FC), int32_t(0x00000000)},
    {"t15.win", "tree #15", int32_t(0x5CB8ABFF), int32_t(0x00000000)},
    {"t16.sno", "misc: tree #16", int32_t(0x5CBBB0FB), int32_t(0x00000000)},
    {"t16.tem", "tree #16", int32_t(0x5CB9A7FC), int32_t(0x00000000)},
    {"t16.win", "tree #16", int32_t(0x5CBAABFF), int32_t(0x00000000)},
    {"t17.sno", "misc: tree #17", int32_t(0x5CBDB0FB), int32_t(0x00000000)},
    {"t17.tem", "tree #17", int32_t(0x5CBBA7FC), int32_t(0x00000000)},
    {"t17.win", "tree #17", int32_t(0x5CBCABFF), int32_t(0x00000000)},
    {"t18.des", "tree #18", int32_t(0x5CC3A7EC), int32_t(0x00000000)},
    {"t1a.aud", "", int32_t(0x5CC6B7E9), int32_t(0x00000000)},
    {"t1b.aud", "", int32_t(0x5CC8B7E9), int32_t(0x00000000)},
    {"t2.bmp", "", int32_t(0x845CB4F5), int32_t(0x00000000)},
    {"t2a.aud", "", int32_t(0x5CC6B9E9), int32_t(0x00000000)},
    {"t2b.aud", "", int32_t(0x5CC8B9E9), int32_t(0x00000000)},
    {"t3a.aud", "", int32_t(0x5CC6BBE9), int32_t(0x00000000)},
    {"t3a.bmp", "", int32_t(0x5CD2B3EA), int32_t(0x00000000)},
    {"t3b.aud", "", int32_t(0x5CC8BBE9), int32_t(0x00000000)},
    {"t3b.bmp", "", int32_t(0x5CD4B3EA), int32_t(0x00000000)},
    {"t3c.aud", "", int32_t(0x5CCABBE9), int32_t(0x00000000)},
    {"t3c.bmp", "", int32_t(0x5CD6B3EA), int32_t(0x00000000)},
    {"t4.bmp", "", int32_t(0x845CB8F5), int32_t(0x00000000)},
    {"t4.wav", "", int32_t(0xAE5CBEE9), int32_t(0x00000000)},
    {"t4_ib.shp", "", int32_t(0x00000000), int32_t(0xEB8970AE)},
    {"t4a.aud", "", int32_t(0x5CC6BDE9), int32_t(0x00000000)},
    {"t4b.aud", "", int32_t(0x5CC8BDE9), int32_t(0x00000000)},
    {"t5.aud", "", int32_t(0x825CAEFD), int32_t(0x00000000)},
    {"t5.bmp", "", int32_t(0x845CBAF5), int32_t(0x00000000)},
    {"t6.aud", "", int32_t(0x825CB0FD), int32_t(0x00000000)},
    {"t6.bmp", "", int32_t(0x845CBCF5), int32_t(0x00000000)},
    {"t7.bmp", "", int32_t(0x845CBEF5), int32_t(0x00000000)},
    {"t7a.aud", "", int32_t(0x5CC6C3E9), int32_t(0x00000000)},
    {"t7b.aud", "", int32_t(0x5CC8C3E9), int32_t(0x00000000)},
    {"t_garden.ini", "", int32_t(0x00000000), int32_t(0x5B2CA8B8)},
    {"t_garden.map", "-", int32_t(0x00000000), int32_t(0xBFD6B46B)},
    {"tab00.shp", "", int32_t(0x00000000), int32_t(0x04D96724)},
    {"tab01.shp", "", int32_t(0x00000000), int32_t(0xC87367BA)},
    {"tab02.shp", "", int32_t(0x00000000), int32_t(0x46FC6059)},
    {"tab03.shp", "", int32_t(0x00000000), int32_t(0x8A5660C7)},
    {"tab_fbl.pcx", "-", int32_t(0x00000000), int32_t(0x0C7D769C)},
    {"tab_fbm.pcx", "-", int32_t(0x00000000), int32_t(0xC721A539)},
    {"tab_fbr.pcx", "-", int32_t(0x00000000), int32_t(0x35A11577)},
    {"tab_fml.pcx", "-", int32_t(0x00000000), int32_t(0xFA350675)},
    {"tab_fmr.pcx", "-", int32_t(0x00000000), int32_t(0xC3E9659E)},
    {"tab_ftl.pcx", "-", int32_t(0x00000000), int32_t(0x0873DF68)},
    {"tab_ftm.pcx", "-", int32_t(0x00000000), int32_t(0xC32F0CCD)},
    {"tab_ftr.pcx", "-", int32_t(0x00000000), int32_t(0x31AFBC83)},
    {"tab_tld.pcx", "-", int32_t(0x00000000), int32_t(0x8E8FB9FA)},
    {"tab_tlu.pcx", "-", int32_t(0x00000000), int32_t(0x460568C4)},
    {"tab_tmd.pcx", "-", int32_t(0x00000000), int32_t(0x28F8B24E)},
    {"tab_tmu.pcx", "-", int32_t(0x00000000), int32_t(0xE0726370)},
    {"tab_trd.pcx", "-", int32_t(0x00000000), int32_t(0xB96E5E69)},
    {"tab_tru.pcx", "-", int32_t(0x00000000), int32_t(0x71E48F57)},
    {"tabam.shp", "", int32_t(0x95AF623B), int32_t(0x00000000)},
    {"tabcs.shp", "", int32_t(0x9DAF6247), int32_t(0x00000000)},
    {"tabra.shp", "", int32_t(0xD9AF6223), int32_t(0x00000000)},
    {"tabs.shp", "options bar", int32_t(0xF6CCD5D6), int32_t(0x16CD9EF9)},
    {"tabus.shp", "", int32_t(0xE5AF6247), int32_t(0x00000000)},
    {"tactical.ini", "", int32_t(0x00000000), int32_t(0x4D37E2B4)},
    {"tactical.map", "-", int32_t(0x00000000), int32_t(0xA9CDFE67)},
    {"tactics.wav", "", int32_t(0x00000000), int32_t(0xECEDEB70)},
    {"taffy2.aud", "", int32_t(0x9B75AE58), int32_t(0x00000000)},
    {"taffy3.aud", "", int32_t(0x9B75B058), int32_t(0x00000000)},
    {"taffy4.aud", "", int32_t(0x9B75B258), int32_t(0x00000000)},
    {"tahoma18.fon", "", int32_t(0xFBD2CE19), int32_t(0x00000000)},
    {"tahoma24.fon", "", int32_t(0xF3D4CE19), int32_t(0x00000000)},
    {"take_off.vqa", "helicopter taking off", int32_t(0xE30AFA3D), int32_t(0x00000000)},
    {"take_off.vqp", "vqp: helicopter taking off", int32_t(0xF20AFA3D), int32_t(0x00000000)},
    {"takeeye1.aud", "", int32_t(0xBC0CF909), int32_t(0x00000000)},
    {"takegun1.aud", "", int32_t(0xBC1EF10D), int32_t(0x00000000)},
    {"talkbubl.shp", "-", int32_t(0x00000000), int32_t(0x3335DA75)},
    {"tandeth1.aud", "tanya death", int32_t(0xB81EEF09), int32_t(0x00000000)},
    {"tank01.aud", "m.a.d. tank deployed!", int32_t(0xAF95AC06), int32_t(0x00000000)},
    {"tank5.aud", "artillery", int32_t(0xD7BB61FF), int32_t(0x00000000)},
    {"tank6.aud", "cruiser 8 inch cannon", int32_t(0xD7BB6201), int32_t(0x00000000)},
    {"tankdestroyer.bmp", "", int32_t(0x00000000), int32_t(0xE173E21A)},
    {"tanker01.des", "", int32_t(0x00000000), int32_t(0x8AC42F69)},
    {"tanker01.sno", "-", int32_t(0x00000000), int32_t(0x64581F18)},
    {"tanker01.tem", "-", int32_t(0x00000000), int32_t(0x6CEDB17A)},
    {"tankfight.bmp", "", int32_t(0x00000000), int32_t(0x8FC08AB1)},
    {"tankgo.vqa", "tanks rolling through the desert", int32_t(0xD995E530), int32_t(0x00000000)},
    {"tankgo.vqp", "tanks rolling through the desert", int32_t(0xD995F430), int32_t(0x00000000)},
    {"tankkill.vqa", "tank being blown up", int32_t(0x0722EE15), int32_t(0x00000000)},
    {"tankkill.vqp", "tank being blown up", int32_t(0x1622EE15), int32_t(0x00000000)},
    {"tany.shp", "", int32_t(0x00000000), int32_t(0x2BBF4623)},
    {"tanya1.vqa", "tanya being interrogated", int32_t(0x1195A923), int32_t(0x00000000)},
    {"tanya1.vqp", "vqp: tanya being interrogated", int32_t(0x1195B823), int32_t(0x00000000)},
    {"tanya2.vqa", "tanya has been rescued", int32_t(0x1195AB23), int32_t(0x00000000)},
    {"tanya2.vqp", "vqp: tanya has been rescued", int32_t(0x1195BA23), int32_t(0x00000000)},
    {"tanyaf1.aud", "tanya freed", int32_t(0xC1DFE714), int32_t(0x00000000)},
    {"tanyar1.aud", "tanya rescued", int32_t(0xC1DFFF14), int32_t(0x00000000)},
    {"tanyicon.shp", "", int32_t(0x00000000), int32_t(0x2ACC95A3)},
    {"tanyuico.shp", "", int32_t(0x00000000), int32_t(0xEF0A0742)},
    {"tapstry1.aud", "", int32_t(0xF448EB27), int32_t(0x00000000)},
    {"tapstry2.aud", "", int32_t(0xF648EB27), int32_t(0x00000000)},
    {"tapstry3.aud", "", int32_t(0xF848EB27), int32_t(0x00000000)},
    {"target.aud", "mechanical man", int32_t(0x9FA5F230), int32_t(0x00000000)},
    {"target1.aud", "target 1", int32_t(0x79F0031C), int32_t(0x00000000)},
    {"target1.shp", "-", int32_t(0x00000000), int32_t(0xD7CF6D12)},
    {"target2.aud", "target 2", int32_t(0x79F2031C), int32_t(0x00000000)},
    {"target2.shp", "-", int32_t(0x00000000), int32_t(0x515B1FBC)},
    {"target3.aud", "target 3", int32_t(0x79F4031C), int32_t(0x00000000)},
    {"targfre1.aud", "target freed", int32_t(0xC428EB0B), int32_t(0x00000000)},
    {"targres1.aud", "target rescued", int32_t(0xC444D123), int32_t(0x00000000)},
    {"targup1.aud", "", int32_t(0x79EFFB3C), int32_t(0x00000000)},
    {"targup2.aud", "", int32_t(0x79F1FB3C), int32_t(0x00000000)},
    {"targup3.aud", "", int32_t(0x79F3FB3C), int32_t(0x00000000)},
    {"targup4.aud", "", int32_t(0x79F5FB3C), int32_t(0x00000000)},
    {"targup5.aud", "", int32_t(0x79F7FB3C), int32_t(0x00000000)},
    {"targup6.aud", "", int32_t(0x79F9FB3C), int32_t(0x00000000)},
    {"targup7.aud", "", int32_t(0x79FBFB3C), int32_t(0x00000000)},
    {"tavern.csv", "", int32_t(0x9BB5F848), int32_t(0x00000000)},
    {"tavern.lsv", "", int32_t(0xADB5F848), int32_t(0x00000000)},
    {"tavern.vqa", "", int32_t(0xC1B5E346), int32_t(0x00000000)},
    {"tavern1.aud", "", int32_t(0x71FFF736), int32_t(0x00000000)},
    {"tavern_e.vqa", "", int32_t(0xE168F823), int32_t(0x00000000)},
    {"tavern_e.vqt", "", int32_t(0xF468F823), int32_t(0x00000000)},
    {"tavern_h.pcx", "", int32_t(0xFE5AF223), int32_t(0x00000000)},
    {"tavern_h.vqa", "", int32_t(0xE768F823), int32_t(0x00000000)},
    {"tavern_l.pcx", "", int32_t(0x065AF223), int32_t(0x00000000)},
    {"tavern_l.vqa", "", int32_t(0xEF68F823), int32_t(0x00000000)},
    {"taxi.hva", "", int32_t(0x00000000), int32_t(0x3052639B)},
    {"taxi.vxl", "", int32_t(0x00000000), int32_t(0xC6D8BCD2)},
    {"tb01nc-h.pcx", "-", int32_t(0x00000000), int32_t(0x93C5D87D)},
    {"tb01nc.pcx", "-", int32_t(0x00000000), int32_t(0xE199BF5E)},
    {"tb02-min.set", "", int32_t(0xB998F6D9), int32_t(0x00000000)},
    {"tb02.vqa", "", int32_t(0xA5B1DAD6), int32_t(0x00000000)},
    {"tb02_0.vqa", "", int32_t(0x751DAB60), int32_t(0x00000000)},
    {"tb02_1.vqa", "", int32_t(0x751DAD60), int32_t(0x00000000)},
    {"tb02_2.vqa", "", int32_t(0x751DAF60), int32_t(0x00000000)},
    {"tb02_3.vqa", "", int32_t(0x751DB160), int32_t(0x00000000)},
    {"tb02lm-g.pcx", "-", int32_t(0x00000000), int32_t(0x3A020F49)},
    {"tb02lm-h.pcx", "-", int32_t(0x00000000), int32_t(0xB8529898)},
    {"tb02lm.pcx", "-", int32_t(0x00000000), int32_t(0xCA0EFFBB)},
    {"tb03-min.set", "", int32_t(0xBD98F6D9), int32_t(0x00000000)},
    {"tb03.vqa", "", int32_t(0xA7B1DAD6), int32_t(0x00000000)},
    {"tb03_0.vqa", "", int32_t(0x791DAB60), int32_t(0x00000000)},
    {"tb03_1.vqa", "", int32_t(0x791DAD60), int32_t(0x00000000)},
    {"tb03_2.vqa", "", int32_t(0x791DAF60), int32_t(0x00000000)},
    {"tb03_3.vqa", "", int32_t(0x791DB160), int32_t(0x00000000)},
    {"tb03l-h.pcx", "-", int32_t(0x00000000), int32_t(0xAADB555A)},
    {"tb03l.pcx", "-", int32_t(0x00000000), int32_t(0x5F0785F0)},
    {"tb04i-h.pcx", "-", int32_t(0x00000000), int32_t(0x865A36F7)},
    {"tb04i.pcx", "-", int32_t(0x00000000), int32_t(0x7386E65D)},
    {"tb05-min.set", "", int32_t(0xC598F6D9), int32_t(0x00000000)},
    {"tb05.vqa", "", int32_t(0xABB1DAD6), int32_t(0x00000000)},
    {"tb05_0.vqa", "", int32_t(0x811DAB60), int32_t(0x00000000)},
    {"tb05_1.vqa", "", int32_t(0x811DAD60), int32_t(0x00000000)},
    {"tb05_2.vqa", "", int32_t(0x811DAF60), int32_t(0x00000000)},
    {"tb05_3.vqa", "", int32_t(0x811DB160), int32_t(0x00000000)},
    {"tb05sm-h.pcx", "-", int32_t(0x00000000), int32_t(0x79A8D6D6)},
    {"tb05sm.pcx", "-", int32_t(0x00000000), int32_t(0x0BF4B1F5)},
    {"tb06-min.set", "", int32_t(0xC998F6D9), int32_t(0x00000000)},
    {"tb06.vqa", "", int32_t(0xADB1DAD6), int32_t(0x00000000)},
    {"tb060000.img", "", int32_t(0x806EB2DF), int32_t(0x00000000)},
    {"tb06_0.vqa", "", int32_t(0x851DAB60), int32_t(0x00000000)},
    {"tb06_1.vqa", "", int32_t(0x851DAD60), int32_t(0x00000000)},
    {"tb06_2.vqa", "", int32_t(0x851DAF60), int32_t(0x00000000)},
    {"tb06_3.vqa", "", int32_t(0x851DB160), int32_t(0x00000000)},
    {"tb06esp1.vqa", "", int32_t(0x7CB30609), int32_t(0x00000000)},
    {"tb06esp2.vqa", "", int32_t(0x7EB30609), int32_t(0x00000000)},
    {"tb06esp3.vqa", "", int32_t(0x80B30609), int32_t(0x00000000)},
    {"tb06esp4.vqa", "", int32_t(0x82B30609), int32_t(0x00000000)},
    {"tb06s-h.pcx", "-", int32_t(0x00000000), int32_t(0x45D73392)},
    {"tb06s.pcx", "-", int32_t(0x00000000), int32_t(0xB00BE338)},
    {"tb07-min.set", "", int32_t(0xCD98F6D9), int32_t(0x00000000)},
    {"tb07.vqa", "", int32_t(0xAFB1DAD6), int32_t(0x00000000)},
    {"tb07_0.vqa", "", int32_t(0x891DAB60), int32_t(0x00000000)},
    {"tb07_1.vqa", "", int32_t(0x891DAD60), int32_t(0x00000000)},
    {"tb07_2.vqa", "", int32_t(0x891DAF60), int32_t(0x00000000)},
    {"tb07_3.vqa", "", int32_t(0x891DB160), int32_t(0x00000000)},
    {"tb07o-h.pcx", "-", int32_t(0x00000000), int32_t(0x79B803B5)},
    {"tb07o.pcx", "-", int32_t(0x00000000), int32_t(0x8C64D31F)},
    {"tb08b-h.pcx", "-", int32_t(0x00000000), int32_t(0x3D04D9B5)},
    {"tb08b.pcx", "-", int32_t(0x00000000), int32_t(0xC8D8091F)},
    {"tb09e-h.pcx", "-", int32_t(0x00000000), int32_t(0x20BAC4EF)},
    {"tb09e.pcx", "-", int32_t(0x00000000), int32_t(0xD5661445)},
    {"tb10isp-h.pcx", "-", int32_t(0x00000000), int32_t(0x4BBC6A58)},
    {"tb10isp.pcx", "-", int32_t(0x00000000), int32_t(0x67A62745)},
    {"tb5loop1.aud", "", int32_t(0xD7CAE91D), int32_t(0x00000000)},
    {"tb5loop2.aud", "", int32_t(0xD9CAE91D), int32_t(0x00000000)},
    {"tb_fly_e.vqa", "", int32_t(0xE58D1217), int32_t(0x00000000)},
    {"tb_fly_f.vqa", "", int32_t(0xE78D1217), int32_t(0x00000000)},
    {"tb_fly_g.vqa", "", int32_t(0xE98D1217), int32_t(0x00000000)},
    {"tb_fly_i.vqa", "", int32_t(0xED8D1217), int32_t(0x00000000)},
    {"tb_fly_s.vqa", "", int32_t(0x018D1217), int32_t(0x00000000)},
    {"tbalarm.aud", "", int32_t(0x8DE40314), int32_t(0x00000000)},
    {"tbbeep1.aud", "", int32_t(0x71AFFF1C), int32_t(0x00000000)},
    {"tbdoor1.aud", "", int32_t(0x99B80330), int32_t(0x00000000)},
    {"tbdoor2.aud", "", int32_t(0x99BA0330), int32_t(0x00000000)},
    {"tbloop1.aud", "", int32_t(0x99D7FF30), int32_t(0x00000000)},
    {"tbnkicon.shp", "", int32_t(0x00000000), int32_t(0x31189955)},
    {"tbrinfo1.vqa", "tiberium info 1", int32_t(0xC938EC1B), int32_t(0x00000000)},
    {"tbrinfo1.vqp", "tiberium info 1", int32_t(0xD838EC1B), int32_t(0x00000000)},
    {"tbrinfo2.vqa", "tiberium info 2", int32_t(0xCB38EC1B), int32_t(0x00000000)},
    {"tbrinfo2.vqp", "tiberium info 2", int32_t(0xDA38EC1B), int32_t(0x00000000)},
    {"tbrinfo3.vqa", "tiberium info 3", int32_t(0xCD38EC1B), int32_t(0x00000000)},
    {"tbrinfo3.vqp", "tiberium info 3", int32_t(0xDC38EC1B), int32_t(0x00000000)},
    {"tc01.sno", "misc: trees #1", int32_t(0xB1AED9D6), int32_t(0x00000000)},
    {"tc01.tem", "trees #1", int32_t(0xAFA5DAD6), int32_t(0x00000000)},
    {"tc01.win", "trees #1", int32_t(0xB0A9DDD6), int32_t(0x00000000)},
    {"tc02.sno", "misc: trees #2", int32_t(0xB3AED9D6), int32_t(0x00000000)},
    {"tc02.tem", "trees #2", int32_t(0xB1A5DAD6), int32_t(0x00000000)},
    {"tc02.win", "trees #2", int32_t(0xB2A9DDD6), int32_t(0x00000000)},
    {"tc03.sno", "misc: trees #3", int32_t(0xB5AED9D6), int32_t(0x00000000)},
    {"tc03.tem", "trees #3", int32_t(0xB3A5DAD6), int32_t(0x00000000)},
    {"tc03.win", "trees #3", int32_t(0xB4A9DDD6), int32_t(0x00000000)},
    {"tc04.sno", "misc: trees #4", int32_t(0xB7AED9D6), int32_t(0x00000000)},
    {"tc04.tem", "trees #4", int32_t(0xB5A5DAD6), int32_t(0x00000000)},
    {"tc04.win", "trees #4", int32_t(0xB6A9DDD6), int32_t(0x00000000)},
    {"tc05.sno", "misc: trees #5", int32_t(0xB9AED9D6), int32_t(0x00000000)},
    {"tc05.tem", "trees #5", int32_t(0xB7A5DAD6), int32_t(0x00000000)},
    {"tc05.win", "trees #5", int32_t(0xB8A9DDD6), int32_t(0x00000000)},
    {"tclock.mrf", "???", int32_t(0xD78DEA29), int32_t(0x00000000)},
    {"techicon.shp", "icon: gdi tech center", int32_t(0x00000000), int32_t(0xD4503BA3)},
    {"tele.hva", "", int32_t(0x00000000), int32_t(0x99AAEA04)},
    {"tele.vxl", "", int32_t(0x00000000), int32_t(0x6F20354D)},
    {"telefx.shp", "", int32_t(0xBB8E1625), int32_t(0x00000000)},
    {"teleicon.shp", "", int32_t(0x00000000), int32_t(0xD4148779)},
    {"teletur.hva", "", int32_t(0x00000000), int32_t(0x2AF8BD4C)},
    {"teletur.vxl", "", int32_t(0x00000000), int32_t(0x250ECEA7)},
    {"teleuico.shp", "", int32_t(0x00000000), int32_t(0x11D21598)},
    {"telpad.shp", "", int32_t(0xE78DEE1B), int32_t(0x00000000)},
    {"tem.mix", "-", int32_t(0x00000000), int32_t(0x92144015)},
    {"temperat.des", "", int32_t(0x00000000), int32_t(0x6E131D1D)},
    {"temperat.inf", "inf: list for temperat.mix", int32_t(0x30060309), int32_t(0x00000000)},
    {"temperat.ini", "ts temperate theater settings", int32_t(0x00000000), int32_t(0x785DAEFF)},
    {"temperat.mix", "temperat.mix", int32_t(0x42010709), int32_t(0x5AA5B016)},
    {"temperat.pal", "pal: temperate", int32_t(0x35F90A09), int32_t(0x9C58DE40)},
    {"temperatmd.ini", "", int32_t(0x00000000), int32_t(0xEDF92D06)},
    {"tempicnh.inf", "inf: list for tempicnh.mix", int32_t(0x181FE511), int32_t(0x00000000)},
    {"tempicon.shp", "", int32_t(0x00000000), int32_t(0xDD81EB79)},
    {"temple1.aud", "", int32_t(0x9DDBF52A), int32_t(0x00000000)},
    {"tenevict.vqa", "-", int32_t(0x00000000), int32_t(0x7BE32FD4)},
    {"tension.wav", "", int32_t(0x00000000), int32_t(0xB54305BA)},
    {"tent-lo.cps", "pict: people at table", int32_t(0xAE2AFDEE), int32_t(0x00000000)},
    {"tent.pcx", "pict: people at table", int32_t(0x00DFDAD6), int32_t(0x00000000)},
    {"tent.shp", "bldg: allied tent barracks", int32_t(0xF8E4DDD6), int32_t(0x00000000)},
    {"tenticon.shp", "icon: barracks", int32_t(0x3E1FEF11), int32_t(0x00000000)},
    {"tentmake.shp", "make: allied tent barracks", int32_t(0x2C17EB19), int32_t(0x00000000)},
    {"terminat.aud", "terminate", int32_t(0x2220F311), int32_t(0x00000000)},
    {"terrace.ini", "", int32_t(0x00000000), int32_t(0x97E89892)},
    {"terrace.map", "-", int32_t(0x00000000), int32_t(0x88D6E1E0)},
    {"terrordrone.bmp", "", int32_t(0x00000000), int32_t(0xA0CC5310)},
    {"tesla.vqa", "tesla coil destroying tank", int32_t(0xD3F97214), int32_t(0x00000000)},
    {"tesla.vqp", "vqp: tesla coil destroying tank", int32_t(0xD3F97223), int32_t(0x00000000)},
    {"tesla1.aud", "tesla shot", int32_t(0xB3A9BC28), int32_t(0x00000000)},
    {"teslaicon.shp", "", int32_t(0x00000000), int32_t(0x5D84F22C)},
    {"teslatank.bmp", "", int32_t(0x00000000), int32_t(0x63E2EFB4)},
    {"test.ubn", "", int32_t(0x00000000), int32_t(0x9C451E9F)},
    {"test1.hmi", "", int32_t(0xEBDD71FC), int32_t(0x00000000)},
    {"texs01.urb", "", int32_t(0x00000000), int32_t(0xE16EBC05)},
    {"texs02.urb", "", int32_t(0x00000000), int32_t(0xD086A698)},
    {"texs03.urb", "", int32_t(0x00000000), int32_t(0x76F1AD2C)},
    {"texs04.urb", "", int32_t(0x00000000), int32_t(0xB35693A2)},
    {"texs05.urb", "", int32_t(0x00000000), int32_t(0x15219816)},
    {"texs06.urb", "", int32_t(0x00000000), int32_t(0x24C9828B)},
    {"texs07.urb", "", int32_t(0x00000000), int32_t(0x82BE893F)},
    {"text1.aud", "text", int32_t(0xFBE371F7), int32_t(0x74C8E6F2)},
    {"text2.aud", "text", int32_t(0xFBE371F9), int32_t(0xFA47E111)},
    {"text3.aud", "", int32_t(0xFBE371FB), int32_t(0x36EDE18F)},
    {"texty1.aud", "audf:", int32_t(0xD3BDBC58), int32_t(0x00000000)},
    {"tg01a.shp", "", int32_t(0x00000000), int32_t(0x69517D8F)},
    {"tg02a.shp", "-", int32_t(0x00000000), int32_t(0x50DC414A)},
    {"tg03a.shp", "-", int32_t(0x00000000), int32_t(0x47A75509)},
    {"tg03ab.shp", "-", int32_t(0x00000000), int32_t(0xC80F5763)},
    {"tg04a1.shp", "", int32_t(0x00000000), int32_t(0x71EEF01C)},
    {"tg04a2.shp", "-", int32_t(0x00000000), int32_t(0x4006EA81)},
    {"tg04ab1.shp", "-", int32_t(0x00000000), int32_t(0xA3022B02)},
    {"tg04ab2.shp", "-", int32_t(0x00000000), int32_t(0x259659AC)},
    {"tg05a.shp", "-", int32_t(0x00000000), int32_t(0x34BD2C83)},
    {"tg06a1.shp", "-", int32_t(0x00000000), int32_t(0x5F18D89A)},
    {"tg06a2.shp", "-", int32_t(0x00000000), int32_t(0x6EF0C207)},
    {"tg06bc.shp", "-", int32_t(0x00000000), int32_t(0xAA601E7B)},
    {"tg07a1.shp", "-", int32_t(0x00000000), int32_t(0x4863CCD9)},
    {"tg07a2.shp", "", int32_t(0x00000000), int32_t(0x798BD644)},
    {"tg07ab1.shp", "-", int32_t(0x00000000), int32_t(0x9A8F17C7)},
    {"tg07ab2.shp", "", int32_t(0x00000000), int32_t(0x1C1B6569)},
    {"tg08a.shp", "-", int32_t(0x00000000), int32_t(0xC5F2CBD4)},
    {"tg09ab.shp", "-", int32_t(0x00000000), int32_t(0x5D21DDFD)},
    {"tg10a1.shp", "-", int32_t(0x00000000), int32_t(0xC3C0CA2E)},
    {"tg10a2.shp", "-", int32_t(0x00000000), int32_t(0xF228D0B3)},
    {"tg11a1.shp", "", int32_t(0x00000000), int32_t(0xD4BBDE6D)},
    {"tg11a2.shp", "-", int32_t(0x00000000), int32_t(0xE553C4F0)},
    {"tg12a1.shp", "", int32_t(0x00000000), int32_t(0xED36E2A8)},
    {"tg12a2.shp", "-", int32_t(0x00000000), int32_t(0xDCDEF835)},
    {"tg12ab1.shp", "", int32_t(0x00000000), int32_t(0x3FDA39B6)},
    {"tg12ab2.shp", "-", int32_t(0x00000000), int32_t(0xB94E4B18)},
    {"tgdead1.aud", "", int32_t(0x71B7FB14), int32_t(0x00000000)},
    {"tghiss1.aud", "", int32_t(0x81C81938), int32_t(0x00000000)},
    {"tghurt1.aud", "", int32_t(0xB1C81B36), int32_t(0x00000000)},
    {"tgmove1.aud", "", int32_t(0x99DBFD3E), int32_t(0x00000000)},
    {"tgmove2.aud", "", int32_t(0x99DDFD3E), int32_t(0x00000000)},
    {"tgmove3.aud", "", int32_t(0x99DFFD3E), int32_t(0x00000000)},
    {"tgreen.mrf", "???", int32_t(0xAFA6002D), int32_t(0x00000000)},
    {"tgroar1.aud", "", int32_t(0x99F01714), int32_t(0x00000000)},
    {"tgroar2.aud", "", int32_t(0x99F21714), int32_t(0x00000000)},
    {"tgroar3.aud", "", int32_t(0x99F41714), int32_t(0x00000000)},
    {"tgroar4.aud", "", int32_t(0x99F61714), int32_t(0x00000000)},
    {"tgroar5.aud", "", int32_t(0x99F81714), int32_t(0x00000000)},
    {"thanku1.aud", "audf:", int32_t(0x95AC2128), int32_t(0x00000000)},
    {"theme.ini", "ts music theme settings", int32_t(0x00000000), int32_t(0x8763343E)},
    {"theme01.ini", "fs music theme settings", int32_t(0x00000000), int32_t(0x230E493F)},
    {"thememd.ini", "", int32_t(0x00000000), int32_t(0xF55E64A6)},
    {"thf.shp", "unit: thief", int32_t(0x5CDCD8FB), int32_t(0x00000000)},
    {"thficon.shp", "icon: thief", int32_t(0x8206082A), int32_t(0x00000000)},
    {"thief.aud", "", int32_t(0xBFA77E21), int32_t(0x00000000)},
    {"thnder1.aud", "", int32_t(0x6DE01B1C), int32_t(0x00000000)},
    {"thnder2.aud", "", int32_t(0x6DE21B1C), int32_t(0x00000000)},
    {"thnder3.aud", "", int32_t(0x6DE41B1C), int32_t(0x00000000)},
    {"thnder4.aud", "", int32_t(0x6DE61B1C), int32_t(0x00000000)},
    {"thnder5.aud", "", int32_t(0x6DE81B1C), int32_t(0x00000000)},
    {"thnder6.aud", "", int32_t(0x6DEA1B1C), int32_t(0x00000000)},
    {"thnder7.aud", "", int32_t(0x6DEC1B1C), int32_t(0x00000000)},
    {"thnder8.aud", "", int32_t(0x6DEE1B1C), int32_t(0x00000000)},
    {"thndr1.aud", "", int32_t(0x9395C84A), int32_t(0x00000000)},
    {"thndr2.aud", "", int32_t(0x9395CA4A), int32_t(0x00000000)},
    {"thndr3.aud", "", int32_t(0x9395CC4A), int32_t(0x00000000)},
    {"thoswd2.aud", "", int32_t(0xA9E5FF40), int32_t(0x00000000)},
    {"thumb.shp", "", int32_t(0xC5FB7E25), int32_t(0x00000000)},
    {"ti1.des", "tiberium 1", int32_t(0x5CB5D7EC), int32_t(0x00000000)},
    {"ti1.tem", "tiberium 1", int32_t(0x5CAFD7FC), int32_t(0x00000000)},
    {"ti1.win", "tiberium 1", int32_t(0x5CB0DBFF), int32_t(0x00000000)},
    {"ti10.des", "tiberium 10", int32_t(0xB3A7D6D6), int32_t(0x00000000)},
    {"ti10.tem", "tiberium 10", int32_t(0xADA7E6D6), int32_t(0x00000000)},
    {"ti10.win", "tiberium 10", int32_t(0xAEABE9D6), int32_t(0x00000000)},
    {"ti11.des", "tiberium 11", int32_t(0xB5A7D6D6), int32_t(0x00000000)},
    {"ti11.tem", "tiberium 11", int32_t(0xAFA7E6D6), int32_t(0x00000000)},
    {"ti11.win", "tiberium 11", int32_t(0xB0ABE9D6), int32_t(0x00000000)},
    {"ti12.des", "tiberium 12", int32_t(0xB7A7D6D6), int32_t(0x00000000)},
    {"ti12.tem", "tiberium 12", int32_t(0xB1A7E6D6), int32_t(0x00000000)},
    {"ti12.win", "tiberium 12", int32_t(0xB2ABE9D6), int32_t(0x00000000)},
    {"ti2.des", "tiberium 2", int32_t(0x5CB7D7EC), int32_t(0x00000000)},
    {"ti2.tem", "tiberium 2", int32_t(0x5CB1D7FC), int32_t(0x00000000)},
    {"ti2.win", "tiberium 2", int32_t(0x5CB2DBFF), int32_t(0x00000000)},
    {"ti3.des", "tiberium 3", int32_t(0x5CB9D7EC), int32_t(0x00000000)},
    {"ti3.tem", "tiberium 3", int32_t(0x5CB3D7FC), int32_t(0x00000000)},
    {"ti3.win", "tiberium 3", int32_t(0x5CB4DBFF), int32_t(0x00000000)},
    {"ti4.des", "tiberium 4", int32_t(0x5CBBD7EC), int32_t(0x00000000)},
    {"ti4.tem", "tiberium 4", int32_t(0x5CB5D7FC), int32_t(0x00000000)},
    {"ti4.win", "tiberium 4", int32_t(0x5CB6DBFF), int32_t(0x00000000)},
    {"ti5.des", "tiberium 5", int32_t(0x5CBDD7EC), int32_t(0x00000000)},
    {"ti5.tem", "tiberium 5", int32_t(0x5CB7D7FC), int32_t(0x00000000)},
    {"ti5.win", "tiberium 5", int32_t(0x5CB8DBFF), int32_t(0x00000000)},
    {"ti6.des", "tiberium 6", int32_t(0x5CBFD7EC), int32_t(0x00000000)},
    {"ti6.tem", "tiberium 6", int32_t(0x5CB9D7FC), int32_t(0x00000000)},
    {"ti6.win", "tiberium 6", int32_t(0x5CBADBFF), int32_t(0x00000000)},
    {"ti7.des", "tiberium 7", int32_t(0x5CC1D7EC), int32_t(0x00000000)},
    {"ti7.tem", "tiberium 7", int32_t(0x5CBBD7FC), int32_t(0x00000000)},
    {"ti7.win", "tiberium 7", int32_t(0x5CBCDBFF), int32_t(0x00000000)},
    {"ti8.des", "tiberium 8", int32_t(0x5CC3D7EC), int32_t(0x00000000)},
    {"ti8.tem", "tiberium 8", int32_t(0x5CBDD7FC), int32_t(0x00000000)},
    {"ti8.win", "tiberium 8", int32_t(0x5CBEDBFF), int32_t(0x00000000)},
    {"ti9.des", "tiberium 9", int32_t(0x5CC5D7EC), int32_t(0x00000000)},
    {"ti9.tem", "tiberium 9", int32_t(0x5CBFD7FC), int32_t(0x00000000)},
    {"ti9.win", "tiberium 9", int32_t(0x5CC0DBFF), int32_t(0x00000000)},
    {"tib01.des", "", int32_t(0x00000000), int32_t(0x3462DDFA)},
    {"tib01.lun", "", int32_t(0x00000000), int32_t(0x86C84792)},
    {"tib01.sno", "-", int32_t(0x00000000), int32_t(0xB5D837FD)},
    {"tib01.tem", "-", int32_t(0x00000000), int32_t(0xA93CFD71)},
    {"tib01.ubn", "", int32_t(0x00000000), int32_t(0x70D15F53)},
    {"tib01.urb", "", int32_t(0x00000000), int32_t(0xFFE4744E)},
    {"tib02.des", "", int32_t(0x00000000), int32_t(0xBAEDDA19)},
    {"tib02.lun", "", int32_t(0x00000000), int32_t(0x08474071)},
    {"tib02.sno", "-", int32_t(0x00000000), int32_t(0x3B57301E)},
    {"tib02.tem", "-", int32_t(0x00000000), int32_t(0x27B3FA92)},
    {"tib02.ubn", "", int32_t(0x00000000), int32_t(0xFE5E58B0)},
    {"tib02.urb", "", int32_t(0x00000000), int32_t(0x716B73AD)},
    {"tib03.des", "", int32_t(0x00000000), int32_t(0x7647DA87)},
    {"tib03.lun", "", int32_t(0x00000000), int32_t(0xC4ED40EF)},
    {"tib03.sno", "-", int32_t(0x00000000), int32_t(0xF7FD3080)},
    {"tib03.tem", "-", int32_t(0x00000000), int32_t(0xEB19FA0C)},
    {"tib03.ubn", "", int32_t(0x00000000), int32_t(0x32F4582E)},
    {"tib03.urb", "", int32_t(0x00000000), int32_t(0xBDC17333)},
    {"tib04.des", "", int32_t(0x00000000), int32_t(0x7C82D39E)},
    {"tib04.lun", "", int32_t(0x00000000), int32_t(0xCE2849F6)},
    {"tib04.sno", "-", int32_t(0x00000000), int32_t(0xFD383999)},
    {"tib04.tem", "-", int32_t(0x00000000), int32_t(0xE1DCF315)},
    {"tib04.ubn", "", int32_t(0x00000000), int32_t(0x38315137)},
    {"tib04.urb", "", int32_t(0x00000000), int32_t(0xB7047A2A)},
    {"tib05.des", "", int32_t(0x00000000), int32_t(0xB028D300)},
    {"tib05.lun", "", int32_t(0x00000000), int32_t(0x02824968)},
    {"tib05.sno", "-", int32_t(0x00000000), int32_t(0x31923907)},
    {"tib05.tem", "-", int32_t(0x00000000), int32_t(0x2D76F38B)},
    {"tib05.ubn", "", int32_t(0x00000000), int32_t(0xF49B51A9)},
    {"tib05.urb", "", int32_t(0x00000000), int32_t(0x7BAE7AB4)},
    {"tib06.des", "", int32_t(0x00000000), int32_t(0x3EA7D4E3)},
    {"tib06.lun", "", int32_t(0x00000000), int32_t(0x8C0D4E8B)},
    {"tib06.sno", "-", int32_t(0x00000000), int32_t(0xBF1D3EE4)},
    {"tib06.tem", "-", int32_t(0x00000000), int32_t(0xA3F9F468)},
    {"tib06.ubn", "", int32_t(0x00000000), int32_t(0x7A14564A)},
    {"tib06.urb", "", int32_t(0x00000000), int32_t(0xF5217D57)},
    {"tib07.des", "", int32_t(0x00000000), int32_t(0xF20DD47D)},
    {"tib07.lun", "", int32_t(0x00000000), int32_t(0x40A74E15)},
    {"tib07.sno", "-", int32_t(0x00000000), int32_t(0x73B73E7A)},
    {"tib07.tem", "-", int32_t(0x00000000), int32_t(0x6F53F4F6)},
    {"tib07.ubn", "", int32_t(0x00000000), int32_t(0xB6BE56D4)},
    {"tib07.urb", "", int32_t(0x00000000), int32_t(0x398B7DC9)},
    {"tib08.des", "", int32_t(0x00000000), int32_t(0x2B2DC6D1)},
    {"tib08.lun", "", int32_t(0x00000000), int32_t(0x99875CB9)},
    {"tib08.sno", "-", int32_t(0x00000000), int32_t(0xAA972CD6)},
    {"tib08.tem", "-", int32_t(0x00000000), int32_t(0xB673E65A)},
    {"tib08.ubn", "", int32_t(0x00000000), int32_t(0x6F9E4478)},
    {"tib08.urb", "", int32_t(0x00000000), int32_t(0xE0AB6F65)},
    {"tib09.des", "", int32_t(0x00000000), int32_t(0xE787C64F)},
    {"tib09.lun", "", int32_t(0x00000000), int32_t(0x552D5C27)},
    {"tib09.sno", "-", int32_t(0x00000000), int32_t(0x663D2C48)},
    {"tib09.tem", "-", int32_t(0x00000000), int32_t(0x7AD9E6C4)},
    {"tib09.ubn", "", int32_t(0x00000000), int32_t(0xA33444E6)},
    {"tib09.urb", "", int32_t(0x00000000), int32_t(0x2C016FFB)},
    {"tib10.des", "", int32_t(0x00000000), int32_t(0xEFB3C927)},
    {"tib10.lun", "", int32_t(0x00000000), int32_t(0x5D19534F)},
    {"tib10.sno", "-", int32_t(0x00000000), int32_t(0x6E092320)},
    {"tib10.tem", "-", int32_t(0x00000000), int32_t(0x72EDE9AC)},
    {"tib10.ubn", "", int32_t(0x00000000), int32_t(0xAB004B8E)},
    {"tib10.urb", "", int32_t(0x00000000), int32_t(0x24356093)},
    {"tib11.des", "", int32_t(0x00000000), int32_t(0x2319C9B9)},
    {"tib11.lun", "", int32_t(0x00000000), int32_t(0x91B353D1)},
    {"tib11.sno", "-", int32_t(0x00000000), int32_t(0xA2A323BE)},
    {"tib11.tem", "-", int32_t(0x00000000), int32_t(0xBE47E932)},
    {"tib11.ubn", "", int32_t(0x00000000), int32_t(0x67AA4B10)},
    {"tib11.urb", "", int32_t(0x00000000), int32_t(0xE89F600D)},
    {"tib12.des", "", int32_t(0x00000000), int32_t(0xAD96CE5A)},
    {"tib12.lun", "", int32_t(0x00000000), int32_t(0x1F3C5432)},
    {"tib12.sno", "-", int32_t(0x00000000), int32_t(0x2C2C245D)},
    {"tib12.tem", "-", int32_t(0x00000000), int32_t(0x30C8EED1)},
    {"tib12.ubn", "", int32_t(0x00000000), int32_t(0xE9254CF3)},
    {"tib12.urb", "", int32_t(0x00000000), int32_t(0x661067EE)},
    {"tib13.des", "", int32_t(0x00000000), int32_t(0x613CCEC4)},
    {"tib13.lun", "", int32_t(0x00000000), int32_t(0xD39654AC)},
    {"tib13.sno", "-", int32_t(0x00000000), int32_t(0xE08624C3)},
    {"tib13.tem", "-", int32_t(0x00000000), int32_t(0xFC62EE4F)},
    {"tib13.ubn", "", int32_t(0x00000000), int32_t(0x258F4C6D)},
    {"tib13.urb", "", int32_t(0x00000000), int32_t(0xAABA6770)},
    {"tib14.des", "", int32_t(0x00000000), int32_t(0x6BF9C7DD)},
    {"tib14.lun", "", int32_t(0x00000000), int32_t(0xD9535DB5)},
    {"tib14.sno", "-", int32_t(0x00000000), int32_t(0xEA432DDA)},
    {"tib14.tem", "-", int32_t(0x00000000), int32_t(0xF6A7E756)},
    {"tib14.ubn", "", int32_t(0x00000000), int32_t(0x2F4A4574)},
    {"tib14.urb", "", int32_t(0x00000000), int32_t(0xA07F6E69)},
    {"tib15.des", "", int32_t(0x00000000), int32_t(0xA753C743)},
    {"tib15.lun", "", int32_t(0x00000000), int32_t(0x15F95D2B)},
    {"tib15.sno", "-", int32_t(0x00000000), int32_t(0x26E92D44)},
    {"tib15.tem", "-", int32_t(0x00000000), int32_t(0x3A0DE7C8)},
    {"tib15.ubn", "", int32_t(0x00000000), int32_t(0xE3E045EA)},
    {"tib15.urb", "", int32_t(0x00000000), int32_t(0x6CD56EF7)},
    {"tib16.des", "", int32_t(0x00000000), int32_t(0x29DCC0A0)},
    {"tib16.lun", "", int32_t(0x00000000), int32_t(0x9B765AC8)},
    {"tib16.sno", "-", int32_t(0x00000000), int32_t(0xA8662AA7)},
    {"tib16.tem", "-", int32_t(0x00000000), int32_t(0xB482E02B)},
    {"tib16.ubn", "", int32_t(0x00000000), int32_t(0x6D6F4209)},
    {"tib16.urb", "", int32_t(0x00000000), int32_t(0xE25A6914)},
    {"tib17.des", "", int32_t(0x00000000), int32_t(0xE576C03E)},
    {"tib17.lun", "", int32_t(0x00000000), int32_t(0x57DC5A56)},
    {"tib17.sno", "-", int32_t(0x00000000), int32_t(0x64CC2A39)},
    {"tib17.tem", "-", int32_t(0x00000000), int32_t(0x7828E0B5)},
    {"tib17.ubn", "", int32_t(0x00000000), int32_t(0xA1C54297)},
    {"tib17.urb", "", int32_t(0x00000000), int32_t(0x2EF0698A)},
    {"tib18.des", "", int32_t(0x00000000), int32_t(0x3C56D292)},
    {"tib18.lun", "", int32_t(0x00000000), int32_t(0x8EFC48FA)},
    {"tib18.sno", "-", int32_t(0x00000000), int32_t(0xBDEC3895)},
    {"tib18.tem", "-", int32_t(0x00000000), int32_t(0xA108F219)},
    {"tib18.ubn", "", int32_t(0x00000000), int32_t(0x78E5503B)},
    {"tib18.urb", "", int32_t(0x00000000), int32_t(0xF7D07B26)},
    {"tib19.des", "", int32_t(0x00000000), int32_t(0xF0FCD20C)},
    {"tib19.lun", "", int32_t(0x00000000), int32_t(0x42564864)},
    {"tib19.sno", "-", int32_t(0x00000000), int32_t(0x7146380B)},
    {"tib19.tem", "-", int32_t(0x00000000), int32_t(0x6DA2F287)},
    {"tib19.ubn", "", int32_t(0x00000000), int32_t(0xB44F50A5)},
    {"tib19.urb", "", int32_t(0x00000000), int32_t(0x3B7A7BB8)},
    {"tib20.des", "", int32_t(0x00000000), int32_t(0xD63EF5E2)},
    {"tib20.lun", "", int32_t(0x00000000), int32_t(0x64946F8A)},
    {"tib20.sno", "-", int32_t(0x00000000), int32_t(0x57841FE5)},
    {"tib20.tem", "-", int32_t(0x00000000), int32_t(0x4B60D569)},
    {"tib20.ubn", "", int32_t(0x00000000), int32_t(0x928D774B)},
    {"tib20.urb", "", int32_t(0x00000000), int32_t(0x1DB85C56)},
    {"tiberfx.vqa", "the effects of tiberium", int32_t(0x71FB034B), int32_t(0x00000000)},
    {"tiberfx.vqp", "the effects of tiberium", int32_t(0x720A034B), int32_t(0x00000000)},
    {"tibtre01.des", "", int32_t(0x00000000), int32_t(0x8D453970)},
    {"tibtre01.lun", "", int32_t(0x00000000), int32_t(0xAA921640)},
    {"tibtre01.sno", "-", int32_t(0x00000000), int32_t(0x63D90901)},
    {"tibtre01.tem", "-", int32_t(0x00000000), int32_t(0x6B6CA763)},
    {"tibtre01.ubn", "", int32_t(0x00000000), int32_t(0xBCE60A29)},
    {"tibtre01.urb", "", int32_t(0x00000000), int32_t(0xFF925453)},
    {"tibtre02.des", "", int32_t(0x00000000), int32_t(0xCAE543A0)},
    {"tibtre02.lun", "", int32_t(0x00000000), int32_t(0xED326C90)},
    {"tibtre02.sno", "-", int32_t(0x00000000), int32_t(0x247973D1)},
    {"tibtre02.tem", "-", int32_t(0x00000000), int32_t(0x2CCCDDB3)},
    {"tibtre02.ubn", "", int32_t(0x00000000), int32_t(0xFB4670F9)},
    {"tibtre02.urb", "", int32_t(0x00000000), int32_t(0xB8322E83)},
    {"tibtre03.des", "", int32_t(0x00000000), int32_t(0xF7856A10)},
    {"tibtre03.lun", "", int32_t(0x00000000), int32_t(0xD0524520)},
    {"tibtre03.sno", "-", int32_t(0x00000000), int32_t(0x19195A61)},
    {"tibtre03.tem", "-", int32_t(0x00000000), int32_t(0x11ACF403)},
    {"tibtre03.ubn", "", int32_t(0x00000000), int32_t(0xC6265949)},
    {"tibtre03.urb", "", int32_t(0x00000000), int32_t(0x85520733)},
    {"tickicon.shp", "icon: tick tank", int32_t(0x00000000), int32_t(0xE7C795A1)},
    {"tiers.ini", "", int32_t(0x00000000), int32_t(0x8F405EF2)},
    {"tiers.map", "-", int32_t(0x00000000), int32_t(0x44FB92F8)},
    {"tigtail1.aud", "", int32_t(0xF80AF901), int32_t(0x00000000)},
    {"tilefal1.aud", "", int32_t(0xBC1EE90B), int32_t(0x00000000)},
    {"tilefal2.aud", "", int32_t(0xBE1EE90B), int32_t(0x00000000)},
    {"tilefal3.aud", "", int32_t(0xC01EE90B), int32_t(0x00000000)},
    {"time.shp", "score screen clock", int32_t(0xDAE2E5D6), int32_t(0x00000000)},
    {"time01.shp", "-", int32_t(0x00000000), int32_t(0xA70D93AA)},
    {"timebomb.aud", "time bomb", int32_t(0x00000000), int32_t(0xD92A8BD7)},
    {"timehr.shp", "misc: score: red alert", int32_t(0xBB921A29), int32_t(0x00000000)},
    {"timeqk2.shp", "", int32_t(0x71EA0446), int32_t(0x00000000)},
    {"timeqked.shp", "", int32_t(0xEE080F21), int32_t(0x00000000)},
    {"timergo1.aud", "timer started", int32_t(0xBC28F523), int32_t(0x00000000)},
    {"timerno1.aud", "timer stopped", int32_t(0xBC290323), int32_t(0x00000000)},
    {"tire.hva", "-", int32_t(0x00000000), int32_t(0x67D6E39B)},
    {"tire.vxl", "debris", int32_t(0x00000000), int32_t(0x915C3CD2)},
    {"title.cps", "pict: title screen", int32_t(0xD1D7822E), int32_t(0x00000000)},
    {"title.pcx", "pict: red alert tilescreen", int32_t(0xB7F18233), int32_t(0x947FB191)},
    {"title.vqa", "", int32_t(0xD3FD821C), int32_t(0x00000000)},
    {"titlelg.pcx", "", int32_t(0x00000000), int32_t(0xBD3494BF)},
    {"titlemd.pcx", "", int32_t(0x00000000), int32_t(0x9DD7EDA5)},
    {"titlesm.pcx", "", int32_t(0x00000000), int32_t(0x8D395BFE)},
    {"tlight.mrf", "???", int32_t(0xB7822033), int32_t(0x00000000)},
    {"tmap.aud", "", int32_t(0xE4D7DBD6), int32_t(0x00000000)},
    {"tmap.bmp", "", int32_t(0xF0CFDCD6), int32_t(0x00000000)},
    {"tmbttn.shp", "", int32_t(0x00000000), int32_t(0x13E5E314)},
    {"tmcj4f.ini", "-", int32_t(0x00000000), int32_t(0x8E8E1220)},
    {"tmouse.mrf", "???", int32_t(0xEF9A0649), int32_t(0x00000000)},
    {"tmpl.shp", "temple of nod", int32_t(0xE8E8EDD6), int32_t(0x00000000)},
    {"tmpl_apr.csv", "", int32_t(0x2C34FB3D), int32_t(0x00000000)},
    {"tmpl_apr.lsv", "", int32_t(0x2C35043D), int32_t(0x00000000)},
    {"tmpl_apr.vqa", "", int32_t(0x17330E3D), int32_t(0x00000000)},
    {"tmpl_apr_e.vqa", "", int32_t(0x58203C2D), int32_t(0x00000000)},
    {"tmpl_apr_e.vqt", "", int32_t(0x58204F2D), int32_t(0x00000000)},
    {"tmpl_apr_h.pcx", "", int32_t(0x4C20591F), int32_t(0x00000000)},
    {"tmpl_apr_h.vqa", "", int32_t(0x5820422D), int32_t(0x00000000)},
    {"tmpl_apr_l.pcx", "", int32_t(0x4C20611F), int32_t(0x00000000)},
    {"tmpl_apr_l.vqa", "", int32_t(0x58204A2D), int32_t(0x00000000)},
    {"tmplcr_e.csv", "", int32_t(0x12531D05), int32_t(0x00000000)},
    {"tmplcr_e.lsv", "", int32_t(0x12532605), int32_t(0x00000000)},
    {"tmplcr_e.vqa", "", int32_t(0xFD513005), int32_t(0x00000000)},
    {"tmplcr_e_e.vqa", "", int32_t(0x245C7FBD), int32_t(0x00000000)},
    {"tmplcr_e_e.vqt", "", int32_t(0x245C92BD), int32_t(0x00000000)},
    {"tmplcr_e_h.pcx", "", int32_t(0x185C9CAF), int32_t(0x00000000)},
    {"tmplcr_e_h.vqa", "", int32_t(0x245C85BD), int32_t(0x00000000)},
    {"tmplcr_e_l.pcx", "", int32_t(0x185CA4AF), int32_t(0x00000000)},
    {"tmplcr_e_l.vqa", "", int32_t(0x245C8DBD), int32_t(0x00000000)},
    {"tmplicnh.des", "icon: temple of nod", int32_t(0x15230011), int32_t(0x00000000)},
    {"tmplicnh.tem", "icon: temple of nod", int32_t(0x0F231011), int32_t(0x00000000)},
    {"tmplicnh.win", "icon: temple of nod", int32_t(0x10271311), int32_t(0x00000000)},
    {"tmplicon.shp", "icon: temple of nod", int32_t(0x1E280F11), int32_t(0xFFE6B101)},
    {"tmplmake.shp", "make: temple of nod", int32_t(0x0C200B19), int32_t(0x00000000)},
    {"tn01a.shp", "", int32_t(0x00000000), int32_t(0x121C430A)},
    {"tn01mw.map", "", int32_t(0x00000000), int32_t(0x24F9398B)},
    {"tn01t2.map", "", int32_t(0x00000000), int32_t(0x9E8370C9)},
    {"tn02a.shp", "-", int32_t(0x00000000), int32_t(0x2B917FCF)},
    {"tn02mw.map", "", int32_t(0x00000000), int32_t(0x1D74054E)},
    {"tn02s4.map", "", int32_t(0x00000000), int32_t(0xCE1B702F)},
    {"tn03a.shp", "-", int32_t(0x00000000), int32_t(0x3CEA6B8C)},
    {"tn03ab.shp", "-", int32_t(0x00000000), int32_t(0xB34269E6)},
    {"tn03mw.map", "", int32_t(0x00000000), int32_t(0x0A0F110D)},
    {"tn03t8.map", "", int32_t(0x00000000), int32_t(0x14050701)},
    {"tn04a1.shp", "", int32_t(0x00000000), int32_t(0x0AA3CE99)},
    {"tn04a2.shp", "-", int32_t(0x00000000), int32_t(0x3B4BD404)},
    {"tn04ab1.shp", "-", int32_t(0x00000000), int32_t(0xD84F1587)},
    {"tn04ab2.shp", "-", int32_t(0x00000000), int32_t(0x5EDB6729)},
    {"tn04mw.map", "", int32_t(0x00000000), int32_t(0x6E6E7CC4)},
    {"tn04t2.map", "", int32_t(0x00000000), int32_t(0xD4143586)},
    {"tn05a.shp", "-", int32_t(0x00000000), int32_t(0x4FF01206)},
    {"tn06a1.shp", "-", int32_t(0x00000000), int32_t(0x2455E61F)},
    {"tn06a2.shp", "-", int32_t(0x00000000), int32_t(0x15BDFC82)},
    {"tn06bc.shp", "-", int32_t(0x00000000), int32_t(0xD12D20FE)},
    {"tn07a1.shp", "-", int32_t(0x00000000), int32_t(0x332EF25C)},
    {"tn07a2.shp", "", int32_t(0x00000000), int32_t(0x02C6E8C1)},
    {"tn07ab1.shp", "-", int32_t(0x00000000), int32_t(0xE1C22942)},
    {"tn07ab2.shp", "", int32_t(0x00000000), int32_t(0x67565BEC)},
    {"tn08a.shp", "-", int32_t(0x00000000), int32_t(0xBEBFF551)},
    {"tn09ab.shp", "-", int32_t(0x00000000), int32_t(0x266CE378)},
    {"tn10a1.shp", "-", int32_t(0x00000000), int32_t(0xB88DF4AB)},
    {"tn10a2.shp", "-", int32_t(0x00000000), int32_t(0x8965EE36)},
    {"tn11a1.shp", "", int32_t(0x00000000), int32_t(0xAFF6E0E8)},
    {"tn11a2.shp", "-", int32_t(0x00000000), int32_t(0x9E1EFA75)},
    {"tn12a1.shp", "", int32_t(0x00000000), int32_t(0x967BDC2D)},
    {"tn12a2.shp", "-", int32_t(0x00000000), int32_t(0xA793C6B0)},
    {"tn12ab1.shp", "", int32_t(0x00000000), int32_t(0x44970733)},
    {"tn12ab2.shp", "-", int32_t(0x00000000), int32_t(0xC203759D)},
    {"tnkd.hva", "", int32_t(0x00000000), int32_t(0xBBC8A7F6)},
    {"tnkd.vxl", "", int32_t(0x00000000), int32_t(0x4D4278BF)},
    {"tnkdicon.shp", "", int32_t(0x00000000), int32_t(0x02920F07)},
    {"tnkduico.shp", "", int32_t(0x00000000), int32_t(0xC7549DE6)},
    {"tnkfire2.aud", "tank fire", int32_t(0xC20D1F11), int32_t(0x00000000)},
    {"tnkfire2.juv", "tank fire", int32_t(0xD40D2811), int32_t(0x00000000)},
    {"tnkfire3.aud", "tank fire", int32_t(0xC40D1F11), int32_t(0x00000000)},
    {"tnkfire3.juv", "tank fire", int32_t(0xD60D2811), int32_t(0x00000000)},
    {"tnkfire4.aud", "tank fire", int32_t(0xC60D1F11), int32_t(0x00000000)},
    {"tnkfire4.juv", "tank fire", int32_t(0xD80D2811), int32_t(0x00000000)},
    {"tnkfire6.aud", "tank fire", int32_t(0xCA0D1F11), int32_t(0x00000000)},
    {"tnkfire6.juv", "tank fire", int32_t(0xDC0D2811), int32_t(0x00000000)},
    {"toggle.shp", "", int32_t(0x00000000), int32_t(0x95B49141)},
    {"toilet1.aud", "", int32_t(0x8DCC3B1C), int32_t(0x00000000)},
    {"tone15.aud", "tone", int32_t(0x9795EC08), int32_t(0x00000000)},
    {"tone15.juv", "tone", int32_t(0xA995FE08), int32_t(0x00000000)},
    {"tone16.aud", "tone", int32_t(0x9795EE08), int32_t(0x00000000)},
    {"tone16.juv", "tone", int32_t(0xA9960008), int32_t(0x00000000)},
    {"tone2.aud", "tone", int32_t(0xBFBB99F9), int32_t(0x00000000)},
    {"tone2.juv", "tone", int32_t(0xBFCD9A0B), int32_t(0x00000000)},
    {"tone5.aud", "tone", int32_t(0xBFBB99FF), int32_t(0x00000000)},
    {"tone5.juv", "tone", int32_t(0xBFCD9A11), int32_t(0x00000000)},
    {"toney10.aud", "tone", int32_t(0x71DDF544), int32_t(0x00000000)},
    {"toney11.aud", "audf:", int32_t(0x71DFF544), int32_t(0x00000000)},
    {"toney4.aud", "tone", int32_t(0x9795EA58), int32_t(0x00000000)},
    {"toney5.aud", "audf:", int32_t(0x9795EC58), int32_t(0x00000000)},
    {"toney6.aud", "audf:", int32_t(0x9795EE58), int32_t(0x00000000)},
    {"toney7.aud", "tone", int32_t(0x9795F058), int32_t(0x00000000)},
    {"toofar.vqa", "bridge being blown up", int32_t(0xC59A2324), int32_t(0x00000000)},
    {"toofar.vqp", "vqp: bridge being blown up", int32_t(0xC59A3224), int32_t(0x00000000)},
    {"tooltip.shp", "", int32_t(0x8E2E184C), int32_t(0x00000000)},
    {"tooltip.trr", "", int32_t(0x8E30224D), int32_t(0x00000000)},
    {"top.shp", "", int32_t(0x00000000), int32_t(0xF0F1CE8D)},
    {"topothehill.map", "", int32_t(0x00000000), int32_t(0x15FFFA37)},
    {"topsecretweapons.bmp", "", int32_t(0x00000000), int32_t(0x911D262E)},
    {"torch1.aud", "", int32_t(0x8FA5E436), int32_t(0x00000000)},
    {"torch2.aud", "", int32_t(0x8FA5E636), int32_t(0x00000000)},
    {"torch2.wav", "", int32_t(0xBBA5F822), int32_t(0x00000000)},
    {"torch3.aud", "", int32_t(0x8FA5E836), int32_t(0x00000000)},
    {"torpedo.shp", "proton torpedo", int32_t(0x00000000), int32_t(0x1BEE99D3)},
    {"torpedo1.aud", "torpedoes", int32_t(0xE83D0709), int32_t(0x00000000)},
    {"toss.aud", "", int32_t(0xEAFBDFD6), int32_t(0x00000000)},
    {"toss1.aud", "???", int32_t(0xF7CF99F7), int32_t(0x00000000)},
    {"toss1.juv", "???", int32_t(0xF7E19A09), int32_t(0x00000000)},
    {"tourgame.bmp", "", int32_t(0x243D020D), int32_t(0x00000000)},
    {"tourofegypt.map", "", int32_t(0x00000000), int32_t(0xA172B8BC)},
    {"tovrps01.des", "", int32_t(0x00000000), int32_t(0x7E8405A2)},
    {"tovrps01.sno", "-", int32_t(0x00000000), int32_t(0x901835D3)},
    {"tovrps01.tem", "-", int32_t(0x00000000), int32_t(0x98AD9BB1)},
    {"tovrps01a.sno", "-", int32_t(0x00000000), int32_t(0x107AF393)},
    {"tovrps01a.tem", "-", int32_t(0x00000000), int32_t(0x0C9E391F)},
    {"tovrps02.des", "", int32_t(0x00000000), int32_t(0x39247F72)},
    {"tovrps02.sno", "-", int32_t(0x00000000), int32_t(0xD7B84F03)},
    {"tovrps02.tem", "-", int32_t(0x00000000), int32_t(0xDF0DE161)},
    {"tovrps02a.sno", "-", int32_t(0x00000000), int32_t(0x29F7CF56)},
    {"tovrps02a.tem", "-", int32_t(0x00000000), int32_t(0x351305DA)},
    {"tovrps03.des", "", int32_t(0x00000000), int32_t(0x044456C2)},
    {"tovrps03.sno", "-", int32_t(0x00000000), int32_t(0xEAD866B3)},
    {"tovrps03.tem", "-", int32_t(0x00000000), int32_t(0xE26DC8D1)},
    {"tovrps03a.sno", "-", int32_t(0x00000000), int32_t(0x3E8CDB15)},
    {"tovrps03a.tem", "-", int32_t(0x00000000), int32_t(0x22681199)},
    {"tovrps04.des", "", int32_t(0x00000000), int32_t(0xB6648AD2)},
    {"tovrps04.sno", "-", int32_t(0x00000000), int32_t(0x58F8BAA3)},
    {"tovrps04.tem", "-", int32_t(0x00000000), int32_t(0x504D14C1)},
    {"tovrps04a.sno", "-", int32_t(0x00000000), int32_t(0x5AEDB6DC)},
    {"tovrps04a.tem", "-", int32_t(0x00000000), int32_t(0x46097C50)},
    {"tovrps05.des", "", int32_t(0x00000000), int32_t(0x8B04A362)},
    {"tovrps05.sno", "-", int32_t(0x00000000), int32_t(0x65989313)},
    {"tovrps05.tem", "-", int32_t(0x00000000), int32_t(0x6D2D3D71)},
    {"tovrps05a.sno", "-", int32_t(0x00000000), int32_t(0x4D96A29F)},
    {"tovrps05a.tem", "-", int32_t(0x00000000), int32_t(0x51726813)},
    {"tovrps06.des", "", int32_t(0x00000000), int32_t(0xCCA4D9B2)},
    {"tovrps06.sno", "-", int32_t(0x00000000), int32_t(0x2238E9C3)},
    {"tovrps06.tem", "-", int32_t(0x00000000), int32_t(0x2A8D47A1)},
    {"tovrps06a.sno", "-", int32_t(0x00000000), int32_t(0x741B9E5A)},
    {"tovrps06a.tem", "-", int32_t(0x00000000), int32_t(0x68FF54D6)},
    {"tovrps07.des", "", int32_t(0x00000000), int32_t(0xF1C4F002)},
    {"tovrps07.sno", "-", int32_t(0x00000000), int32_t(0x1F58C073)},
    {"tovrps07.tem", "-", int32_t(0x00000000), int32_t(0x17ED6E11)},
    {"tovrps08.des", "", int32_t(0x00000000), int32_t(0x739467D3)},
    {"tovrps08.sno", "-", int32_t(0x00000000), int32_t(0x9D0857A2)},
    {"tovrps08.tem", "-", int32_t(0x00000000), int32_t(0x95BDF9C0)},
    {"tovrps09.des", "", int32_t(0x00000000), int32_t(0x4EF44E63)},
    {"tovrps09.sno", "-", int32_t(0x00000000), int32_t(0xA0687E12)},
    {"tovrps09.tem", "-", int32_t(0x00000000), int32_t(0xA8DDD070)},
    {"tovrps10.des", "", int32_t(0x00000000), int32_t(0x88B8FFB7)},
    {"tovrps10.sno", "-", int32_t(0x00000000), int32_t(0x6624CFC6)},
    {"tovrps10.tem", "-", int32_t(0x00000000), int32_t(0x6E9161A4)},
    {"tovrps11.des", "", int32_t(0x00000000), int32_t(0xB5D8D607)},
    {"tovrps11.sno", "-", int32_t(0x00000000), int32_t(0x5B44E676)},
    {"tovrps11.tem", "-", int32_t(0x00000000), int32_t(0x53F14814)},
    {"tovrps12.des", "", int32_t(0x00000000), int32_t(0xF278ACD7)},
    {"tovrps12.sno", "-", int32_t(0x00000000), int32_t(0x1CE49CA6)},
    {"tovrps12.tem", "-", int32_t(0x00000000), int32_t(0x145132C4)},
    {"tovrps13.des", "", int32_t(0x00000000), int32_t(0xCF188567)},
    {"tovrps13.sno", "-", int32_t(0x00000000), int32_t(0x2184B516)},
    {"tovrps13.tem", "-", int32_t(0x00000000), int32_t(0x29311B74)},
    {"tovrps14.des", "", int32_t(0x00000000), int32_t(0x7D385977)},
    {"tovrps14.sno", "-", int32_t(0x00000000), int32_t(0x93A46906)},
    {"tovrps14.tem", "-", int32_t(0x00000000), int32_t(0x9B11C764)},
    {"tovrps15.des", "", int32_t(0x00000000), int32_t(0x405870C7)},
    {"tovrps15.sno", "-", int32_t(0x00000000), int32_t(0xAEC440B6)},
    {"tovrps15.tem", "-", int32_t(0x00000000), int32_t(0xA671EED4)},
    {"tovrps16.des", "", int32_t(0x00000000), int32_t(0x07F80A17)},
    {"tovrps16.sno", "-", int32_t(0x00000000), int32_t(0xE9643A66)},
    {"tovrps16.tem", "-", int32_t(0x00000000), int32_t(0xE1D19404)},
    {"tower_ap.csv", "", int32_t(0x0C333F23), int32_t(0x00000000)},
    {"tower_ap.lsv", "", int32_t(0x0C334823), int32_t(0x00000000)},
    {"tower_ap.vqa", "", int32_t(0xF7315223), int32_t(0x00000000)},
    {"tower_ap_e.vqa", "", int32_t(0x181CC3F9), int32_t(0x00000000)},
    {"tower_ap_e.vqt", "", int32_t(0x181CD6F9), int32_t(0x00000000)},
    {"tower_ap_h.pcx", "", int32_t(0x0C1CE0EB), int32_t(0x00000000)},
    {"tower_ap_h.vqa", "", int32_t(0x181CC9F9), int32_t(0x00000000)},
    {"tower_ap_l.pcx", "", int32_t(0x0C1CE8EB), int32_t(0x00000000)},
    {"tower_ap_l.vqa", "", int32_t(0x181CD1F9), int32_t(0x00000000)},
    {"towricon.shp", "icon: component tower", int32_t(0x00000000), int32_t(0x21548A5A)},
    {"towrkey1.aud", "", int32_t(0xF0650915), int32_t(0x00000000)},
    {"tquake.shp", "crat: time quake", int32_t(0xABB2202F), int32_t(0x00000000)},
    {"tr-1to2.cps", "pict:", int32_t(0x216D383C), int32_t(0x00000000)},
    {"tr-1to2.wsa", "anim:", int32_t(0x215B3B50), int32_t(0x00000000)},
    {"tr-1to2w.cps", "pict:", int32_t(0xC66A2B27), int32_t(0x00000000)},
    {"tr-1to2w.wsa", "anim:", int32_t(0xB46D3F27), int32_t(0x00000000)},
    {"tr-1to4.cps", "pict:", int32_t(0x2171383C), int32_t(0x00000000)},
    {"tr-1to4.wsa", "anim:", int32_t(0x215F3B50), int32_t(0x00000000)},
    {"tr-1to4w.cps", "pict:", int32_t(0xC66E2B27), int32_t(0x00000000)},
    {"tr-1to4w.wsa", "anim:", int32_t(0xB4713F27), int32_t(0x00000000)},
    {"tr-2to1.cps", "pict:", int32_t(0x256B383C), int32_t(0x00000000)},
    {"tr-2to1.wsa", "anim:", int32_t(0x25593B50), int32_t(0x00000000)},
    {"tr-2to1w.cps", "pict:", int32_t(0xCA682B27), int32_t(0x00000000)},
    {"tr-2to1w.wsa", "anim:", int32_t(0xB86B3F27), int32_t(0x00000000)},
    {"tr-2to3.cps", "pict:", int32_t(0x256F383C), int32_t(0x00000000)},
    {"tr-2to3.wsa", "anim:", int32_t(0x255D3B50), int32_t(0x00000000)},
    {"tr-3to2.cps", "pict:", int32_t(0x296D383C), int32_t(0x00000000)},
    {"tr-3to2.wsa", "anim:", int32_t(0x295B3B50), int32_t(0x00000000)},
    {"tr-3to4.cps", "pict:", int32_t(0x2971383C), int32_t(0x00000000)},
    {"tr-3to4.wsa", "anim:", int32_t(0x295F3B50), int32_t(0x00000000)},
    {"tr-4to1.cps", "pict:", int32_t(0x2D6B383C), int32_t(0x00000000)},
    {"tr-4to1.wsa", "anim:", int32_t(0x2D593B50), int32_t(0x00000000)},
    {"tr-4to1w.cps", "pict:", int32_t(0xD2682B27), int32_t(0x00000000)},
    {"tr-4to1w.wsa", "anim:", int32_t(0xC06B3F27), int32_t(0x00000000)},
    {"tr-4to5.cps", "pict:", int32_t(0x2D73383C), int32_t(0x00000000)},
    {"tr-4to5.wsa", "anim:", int32_t(0x2D613B50), int32_t(0x00000000)},
    {"tr-6to5.cps", "pict:", int32_t(0x3573383C), int32_t(0x00000000)},
    {"tr-6to5.wsa", "anim:", int32_t(0x35613B50), int32_t(0x00000000)},
    {"tr_exit.cps", "pict: large bar", int32_t(0x72792C44), int32_t(0x00000000)},
    {"tr_exit.wsa", "anim: installation complete", int32_t(0x72672F58), int32_t(0x00000000)},
    {"tracks01.des", "", int32_t(0x00000000), int32_t(0x44FE6DB0)},
    {"tracks01.lun", "", int32_t(0x00000000), int32_t(0x63294280)},
    {"tracks01.sno", "-", int32_t(0x00000000), int32_t(0xAA625DC1)},
    {"tracks01.tem", "-", int32_t(0x00000000), int32_t(0xA2D7F3A3)},
    {"tracks01.ubn", "", int32_t(0x00000000), int32_t(0x755D5EE9)},
    {"tracks01.urb", "", int32_t(0x00000000), int32_t(0x36290093)},
    {"tracks02.des", "", int32_t(0x00000000), int32_t(0x035E1760)},
    {"tracks02.lun", "", int32_t(0x00000000), int32_t(0x24893850)},
    {"tracks02.sno", "-", int32_t(0x00000000), int32_t(0xEDC22711)},
    {"tracks02.tem", "-", int32_t(0x00000000), int32_t(0xE5778973)},
    {"tracks02.ubn", "", int32_t(0x00000000), int32_t(0x32FD2439)},
    {"tracks02.urb", "", int32_t(0x00000000), int32_t(0x71897A43)},
    {"tracks03.des", "", int32_t(0x00000000), int32_t(0x3E3E3ED0)},
    {"tracks03.lun", "", int32_t(0x00000000), int32_t(0x19E911E0)},
    {"tracks03.sno", "-", int32_t(0x00000000), int32_t(0xD0A20EA1)},
    {"tracks03.tem", "-", int32_t(0x00000000), int32_t(0xD817A0C3)},
    {"tracks03.ubn", "", int32_t(0x00000000), int32_t(0x0F9D0D89)},
    {"tracks03.urb", "", int32_t(0x00000000), int32_t(0x4CE953F3)},
    {"tracks04.des", "", int32_t(0x00000000), int32_t(0x8C1EE2C0)},
    {"tracks04.lun", "", int32_t(0x00000000), int32_t(0xABC9CDF0)},
    {"tracks04.sno", "-", int32_t(0x00000000), int32_t(0x6282D2B1)},
    {"tracks04.tem", "-", int32_t(0x00000000), int32_t(0x6A377CD3)},
    {"tracks04.ubn", "", int32_t(0x00000000), int32_t(0xBDBDD199)},
    {"tracks04.urb", "", int32_t(0x00000000), int32_t(0xFEC98FE3)},
    {"tracks05.des", "", int32_t(0x00000000), int32_t(0xB17ECB70)},
    {"tracks05.lun", "", int32_t(0x00000000), int32_t(0x96A9E440)},
    {"tracks05.sno", "-", int32_t(0x00000000), int32_t(0x5FE2FB01)},
    {"tracks05.tem", "-", int32_t(0x00000000), int32_t(0x57575563)},
    {"tracks05.ubn", "", int32_t(0x00000000), int32_t(0x80DDF829)},
    {"tracks05.urb", "", int32_t(0x00000000), int32_t(0xC3A9A653)},
    {"tracks06.des", "", int32_t(0x00000000), int32_t(0xF6DEB1A0)},
    {"tracks06.lun", "", int32_t(0x00000000), int32_t(0xD1099E90)},
    {"tracks06.sno", "-", int32_t(0x00000000), int32_t(0x184281D1)},
    {"tracks06.tem", "-", int32_t(0x00000000), int32_t(0x10F72FB3)},
    {"tracks06.ubn", "", int32_t(0x00000000), int32_t(0xC77D82F9)},
    {"tracks06.urb", "", int32_t(0x00000000), int32_t(0x8409DC83)},
    {"tracks07.des", "", int32_t(0x00000000), int32_t(0xCBBE9810)},
    {"tracks07.lun", "", int32_t(0x00000000), int32_t(0xEC69B720)},
    {"tracks07.sno", "-", int32_t(0x00000000), int32_t(0x2522A861)},
    {"tracks07.tem", "-", int32_t(0x00000000), int32_t(0x2D970603)},
    {"tracks07.ubn", "", int32_t(0x00000000), int32_t(0xFA1DAB49)},
    {"tracks07.urb", "", int32_t(0x00000000), int32_t(0xB969F533)},
    {"tracks08.des", "", int32_t(0x00000000), int32_t(0x49EE0FC1)},
    {"tracks08.lun", "", int32_t(0x00000000), int32_t(0x6E3920F1)},
    {"tracks08.sno", "-", int32_t(0x00000000), int32_t(0xA7723FB0)},
    {"tracks08.tem", "-", int32_t(0x00000000), int32_t(0xAFC791D2)},
    {"tracks08.ubn", "", int32_t(0x00000000), int32_t(0x784D3C98)},
    {"tracks08.urb", "", int32_t(0x00000000), int32_t(0x3B3962E2)},
    {"tracks09.des", "", int32_t(0x00000000), int32_t(0x748E2671)},
    {"tracks09.lun", "", int32_t(0x00000000), int32_t(0x53590941)},
    {"tracks09.sno", "-", int32_t(0x00000000), int32_t(0x9A121600)},
    {"tracks09.tem", "-", int32_t(0x00000000), int32_t(0x92A7B862)},
    {"tracks09.ubn", "", int32_t(0x00000000), int32_t(0x452D1528)},
    {"tracks09.urb", "", int32_t(0x00000000), int32_t(0x06594B52)},
    {"tracks10.des", "", int32_t(0x00000000), int32_t(0xB2C297A5)},
    {"tracks10.lun", "", int32_t(0x00000000), int32_t(0x9515B895)},
    {"tracks10.sno", "-", int32_t(0x00000000), int32_t(0x5C5EA7D4)},
    {"tracks10.tem", "-", int32_t(0x00000000), int32_t(0x54EB09B6)},
    {"tracks10.ubn", "", int32_t(0x00000000), int32_t(0x8361A4FC)},
    {"tracks10.urb", "", int32_t(0x00000000), int32_t(0xC015FA86)},
    {"tracks11.des", "", int32_t(0x00000000), int32_t(0x8FA2BE15)},
    {"tracks11.lun", "", int32_t(0x00000000), int32_t(0xA8759125)},
    {"tracks11.sno", "-", int32_t(0x00000000), int32_t(0x613E8E64)},
    {"tracks11.tem", "-", int32_t(0x00000000), int32_t(0x698B2006)},
    {"tracks11.ubn", "", int32_t(0x00000000), int32_t(0xBE018D4C)},
    {"tracks11.urb", "", int32_t(0x00000000), int32_t(0xFD75D336)},
    {"tracks12.des", "", int32_t(0x00000000), int32_t(0xC802C4C5)},
    {"tracks12.lun", "", int32_t(0x00000000), int32_t(0xEFD5EBF5)},
    {"tracks12.sno", "-", int32_t(0x00000000), int32_t(0x269EF4B4)},
    {"tracks12.tem", "-", int32_t(0x00000000), int32_t(0x2E2B5AD6)},
    {"tracks12.ubn", "", int32_t(0x00000000), int32_t(0xF9A1F79C)},
    {"tracks12.urb", "", int32_t(0x00000000), int32_t(0xBAD5A9E6)},
    {"tracks13.des", "", int32_t(0x00000000), int32_t(0xF562ED75)},
    {"tracks13.lun", "", int32_t(0x00000000), int32_t(0xD2B5C245)},
    {"tracks13.sno", "-", int32_t(0x00000000), int32_t(0x1BFEDD04)},
    {"tracks13.tem", "-", int32_t(0x00000000), int32_t(0x134B7366)},
    {"tracks13.ubn", "", int32_t(0x00000000), int32_t(0xC4C1DE2C)},
    {"tracks13.urb", "", int32_t(0x00000000), int32_t(0x87B58056)},
    {"tracks14.des", "", int32_t(0x00000000), int32_t(0x47423165)},
    {"tracks14.lun", "", int32_t(0x00000000), int32_t(0x60951E55)},
    {"tracks14.sno", "-", int32_t(0x00000000), int32_t(0xA9DE0114)},
    {"tracks14.tem", "-", int32_t(0x00000000), int32_t(0xA16BAF76)},
    {"tracks14.ubn", "", int32_t(0x00000000), int32_t(0x76E1023C)},
    {"tracks14.urb", "", int32_t(0x00000000), int32_t(0x35955C46)},
    {"tracks15.des", "", int32_t(0x00000000), int32_t(0x7A2218D5)},
    {"tracks15.lun", "", int32_t(0x00000000), int32_t(0x5DF537E5)},
    {"tracks15.sno", "-", int32_t(0x00000000), int32_t(0x94BE28A4)},
    {"tracks15.tem", "-", int32_t(0x00000000), int32_t(0x9C0B86C6)},
    {"tracks15.ubn", "", int32_t(0x00000000), int32_t(0x4B812B8C)},
    {"tracks15.urb", "", int32_t(0x00000000), int32_t(0x08F575F6)},
    {"tracks16.des", "", int32_t(0x00000000), int32_t(0x3D826205)},
    {"tracks16.lun", "", int32_t(0x00000000), int32_t(0x1A554D35)},
    {"tracks16.sno", "-", int32_t(0x00000000), int32_t(0xD31E5274)},
    {"tracks16.tem", "-", int32_t(0x00000000), int32_t(0xDBABFC16)},
    {"tracks16.ubn", "", int32_t(0x00000000), int32_t(0x0C21515C)},
    {"tracks16.urb", "", int32_t(0x00000000), int32_t(0x4F550F26)},
    {"traction.aud", "traction", int32_t(0xEDF91D27), int32_t(0x00000000)},
    {"tractor.hva", "", int32_t(0x00000000), int32_t(0xE87F5DBE)},
    {"tractor.vxl", "", int32_t(0x00000000), int32_t(0xE7892E55)},
    {"trailer.vqa", "red alert preview", int32_t(0x81EB253F), int32_t(0x00000000)},
    {"trailer.vqp", "red alert preview", int32_t(0x81FA253F), int32_t(0x00000000)},
    {"trailerpark.map", "", int32_t(0x00000000), int32_t(0x1C2075D0)},
    {"train1.aud", "training", int32_t(0xA761F042), int32_t(0x00000000)},
    {"traincar-1.vqa", "", int32_t(0x3F6C4385), int32_t(0x00000000)},
    {"traincar.vqa", "", int32_t(0x0AD9261B), int32_t(0x00000000)},
    {"trainrob.vqa", "-", int32_t(0x00000000), int32_t(0xB9F416F6)},
    {"trakgrip.pcx", "-", int32_t(0x00000000), int32_t(0x5C26A605)},
    {"tran.hva", "-", int32_t(0x00000000), int32_t(0xF09D6A8B)},
    {"tran.shp", "chinook", int32_t(0xECCAF7D6), int32_t(0x00000000)},
    {"tran.vxl", "chinnook", int32_t(0x00000000), int32_t(0x0617B5C2)},
    {"tran0203.wsa", "anim: sound card selection", int32_t(0xE0B904DF), int32_t(0x00000000)},
    {"tran0204.wsa", "anim: sound card selection to mouths", int32_t(0xE2B904DF), int32_t(0x00000000)},
    {"tran0205.wsa", "anim: sound card selection to bars", int32_t(0xE4B904DF), int32_t(0x00000000)},
    {"tran0206.wsa", "anim: sound card selection to port irq dma window", int32_t(0xE6B904DF), int32_t(0x00000000)},
    {"tran02a4.wsa", "anim: sound card selection to mouths", int32_t(0xE2DB04DF), int32_t(0x00000000)},
    {"tran0305.wsa", "anim: mouth to bars", int32_t(0xE4B906DF), int32_t(0x00000000)},
    {"tran0402.wsa", "anim: mouths to sound card selection", int32_t(0xDEB908DF), int32_t(0x00000000)},
    {"tran0403.wsa", "anim: mouths to sound card selection", int32_t(0xE0B908DF), int32_t(0x00000000)},
    {"tran04a2.wsa", "anim: mouth to sound card selection", int32_t(0xDEDB08DF), int32_t(0x00000000)},
    {"tran04a3.wsa", "anim: mouth to sound card selection", int32_t(0xE0DB08DF), int32_t(0x00000000)},
    {"tran0602.wsa", "anim: port irq dma window to sound card selection", int32_t(0xDEB90CDF), int32_t(0x00000000)},
    {"tran0604.wsa", "anim: port irq dma window to mouths", int32_t(0xE2B90CDF), int32_t(0x00000000)},
    {"tran06a4.wsa", "anim: port irq dma window to mouth", int32_t(0xE2DB0CDF), int32_t(0x00000000)},
    {"trancelv.wav", "", int32_t(0x00000000), int32_t(0x3FCE72E3)},
    {"tranicnh.des", "icon: chinook", int32_t(0x1CE71411), int32_t(0x00000000)},
    {"tranicnh.tem", "icon: chinook", int32_t(0x16E72411), int32_t(0x00000000)},
    {"tranicnh.win", "icon: chinook", int32_t(0x17EB2711), int32_t(0x00000000)},
    {"tranicon.shp", "icon: chinook", int32_t(0x25EC2311), int32_t(0x00000000)},
    {"tranload.aud", "", int32_t(0x05DD2917), int32_t(0x00000000)},
    {"trans.icn", "bulding placement tiles", int32_t(0xBF97A645), int32_t(0x00000000)},
    {"trans1.aud", "???", int32_t(0xBB61F04C), int32_t(0x00000000)},
    {"trans1.juv", "???", int32_t(0xCD62024C), int32_t(0x00000000)},
    {"transit.inf", "inf: list for transit.mix", int32_t(0x95F42A40), int32_t(0x00000000)},
    {"translg.shp", "", int32_t(0x00000000), int32_t(0xB37F47B1)},
    {"transmd.shp", "", int32_t(0x00000000), int32_t(0x939C3EAB)},
    {"transsee.aud", "", int32_t(0x07E53125), int32_t(0x00000000)},
    {"transsm.shp", "", int32_t(0x00000000), int32_t(0x837288F0)},
    {"tratos.shp", "unit: tratos", int32_t(0x00000000), int32_t(0xE204B869)},
    {"tread_l.ini", "", int32_t(0x00000000), int32_t(0x8F8B04E9)},
    {"tread_l.map", "-", int32_t(0x00000000), int32_t(0x90B57D9B)},
    {"tred.mrf", "???", int32_t(0xCEDCF1D6), int32_t(0x00000000)},
    {"tree01.des", "", int32_t(0x00000000), int32_t(0x6550C17A)},
    {"tree01.lun", "", int32_t(0x00000000), int32_t(0x0C70FD63)},
    {"tree01.sno", "-", int32_t(0x00000000), int32_t(0xE27F8E75)},
    {"tree01.tem", "-", int32_t(0x00000000), int32_t(0x1308D882)},
    {"tree01.ubn", "", int32_t(0x00000000), int32_t(0x2F9DE271)},
    {"tree01.urb", "", int32_t(0x00000000), int32_t(0x6B295CEE)},
    {"tree02.des", "", int32_t(0x00000000), int32_t(0x54B8DBE7)},
    {"tree02.lun", "", int32_t(0x00000000), int32_t(0x3D98E7FE)},
    {"tree02.sno", "-", int32_t(0x00000000), int32_t(0xD39794E8)},
    {"tree02.tem", "-", int32_t(0x00000000), int32_t(0x22E0C21F)},
    {"tree02.ubn", "", int32_t(0x00000000), int32_t(0x1E75F8EC)},
    {"tree02.urb", "", int32_t(0x00000000), int32_t(0x5AC14673)},
    {"tree03.des", "", int32_t(0x00000000), int32_t(0xF2CFD053)},
    {"tree03.lun", "", int32_t(0x00000000), int32_t(0x9BEFEC4A)},
    {"tree03.sno", "-", int32_t(0x00000000), int32_t(0x75E09F5C)},
    {"tree03.tem", "-", int32_t(0x00000000), int32_t(0x8497C9AB)},
    {"tree03.ubn", "", int32_t(0x00000000), int32_t(0xB802F358)},
    {"tree03.urb", "", int32_t(0x00000000), int32_t(0xFCB64DC7)},
    {"tree04.des", "", int32_t(0x00000000), int32_t(0x3768EEDD)},
    {"tree04.lun", "", int32_t(0x00000000), int32_t(0x5E48D2C4)},
    {"tree04.sno", "-", int32_t(0x00000000), int32_t(0xB047A1D2)},
    {"tree04.tem", "-", int32_t(0x00000000), int32_t(0x4130F725)},
    {"tree04.ubn", "", int32_t(0x00000000), int32_t(0x7DA5CDD6)},
    {"tree04.urb", "", int32_t(0x00000000), int32_t(0x39117349)},
    {"tree05.des", "", int32_t(0x00000000), int32_t(0x911FE569)},
    {"tree05.lun", "", int32_t(0x00000000), int32_t(0xF83FD970)},
    {"tree05.sno", "-", int32_t(0x00000000), int32_t(0x1630AA66)},
    {"tree05.tem", "-", int32_t(0x00000000), int32_t(0xE747FC91)},
    {"tree05.ubn", "", int32_t(0x00000000), int32_t(0xDBD2C662)},
    {"tree05.urb", "", int32_t(0x00000000), int32_t(0x9F6678FD)},
    {"tree06.des", "", int32_t(0x00000000), int32_t(0xA0F7FFF4)},
    {"tree06.lun", "", int32_t(0x00000000), int32_t(0xC9D7C3ED)},
    {"tree06.sno", "-", int32_t(0x00000000), int32_t(0x27D8B0FB)},
    {"tree06.tem", "-", int32_t(0x00000000), int32_t(0xD6AFE60C)},
    {"tree06.ubn", "", int32_t(0x00000000), int32_t(0xEA3ADCFF)},
    {"tree06.urb", "", int32_t(0x00000000), int32_t(0xAE8E6260)},
    {"tree07.des", "", int32_t(0x00000000), int32_t(0x0680F440)},
    {"tree07.lun", "", int32_t(0x00000000), int32_t(0x6FA0C859)},
    {"tree07.sno", "-", int32_t(0x00000000), int32_t(0x81AFBB4F)},
    {"tree07.tem", "-", int32_t(0x00000000), int32_t(0x70D8EDB8)},
    {"tree07.ubn", "", int32_t(0x00000000), int32_t(0x4C4DD74B)},
    {"tree07.urb", "", int32_t(0x00000000), int32_t(0x08F969D4)},
    {"tree08.des", "", int32_t(0x00000000), int32_t(0xF0C884A9)},
    {"tree08.lun", "", int32_t(0x00000000), int32_t(0x99E8B8B0)},
    {"tree08.sno", "-", int32_t(0x00000000), int32_t(0x77E7CBA6)},
    {"tree08.tem", "-", int32_t(0x00000000), int32_t(0x86909D51)},
    {"tree08.ubn", "", int32_t(0x00000000), int32_t(0xBA05A7A2)},
    {"tree08.urb", "", int32_t(0x00000000), int32_t(0xFEB1193D)},
    {"tree09.des", "", int32_t(0x00000000), int32_t(0x56BF8F1D)},
    {"tree09.lun", "", int32_t(0x00000000), int32_t(0x3F9FB304)},
    {"tree09.sno", "-", int32_t(0x00000000), int32_t(0xD190C012)},
    {"tree09.tem", "-", int32_t(0x00000000), int32_t(0x20E796E5)},
    {"tree09.ubn", "", int32_t(0x00000000), int32_t(0x1C72AC16)},
    {"tree09.urb", "", int32_t(0x00000000), int32_t(0x58C61289)},
    {"tree10.des", "", int32_t(0x00000000), int32_t(0x0F8DCA50)},
    {"tree10.lun", "", int32_t(0x00000000), int32_t(0x66ADF649)},
    {"tree10.sno", "-", int32_t(0x00000000), int32_t(0x88A2855F)},
    {"tree10.tem", "-", int32_t(0x00000000), int32_t(0x79D5D3A8)},
    {"tree10.ubn", "", int32_t(0x00000000), int32_t(0x4540E95B)},
    {"tree10.urb", "", int32_t(0x00000000), int32_t(0x01F457C4)},
    {"tree11.des", "", int32_t(0x00000000), int32_t(0xA9FAC1E4)},
    {"tree11.lun", "", int32_t(0x00000000), int32_t(0xC0DAFDFD)},
    {"tree11.sno", "-", int32_t(0x00000000), int32_t(0x2ED58EEB)},
    {"tree11.tem", "-", int32_t(0x00000000), int32_t(0xDFA2D81C)},
    {"tree11.ubn", "", int32_t(0x00000000), int32_t(0xE337E2EF)},
    {"tree11.urb", "", int32_t(0x00000000), int32_t(0xA7835C70)},
    {"tree12.des", "", int32_t(0x00000000), int32_t(0x9812DB79)},
    {"tree12.lun", "", int32_t(0x00000000), int32_t(0xF132E760)},
    {"tree12.sno", "-", int32_t(0x00000000), int32_t(0x1F3D9476)},
    {"tree12.tem", "-", int32_t(0x00000000), int32_t(0xEE4AC281)},
    {"tree12.ubn", "", int32_t(0x00000000), int32_t(0xD2DFF872)},
    {"tree12.urb", "", int32_t(0x00000000), int32_t(0x966B46ED)},
    {"tree13.des", "", int32_t(0x00000000), int32_t(0x3E65D0CD)},
    {"tree13.lun", "", int32_t(0x00000000), int32_t(0x5745ECD4)},
    {"tree13.sno", "-", int32_t(0x00000000), int32_t(0xB94A9FC2)},
    {"tree13.tem", "-", int32_t(0x00000000), int32_t(0x483DC935)},
    {"tree13.ubn", "", int32_t(0x00000000), int32_t(0x74A8F3C6)},
    {"tree13.urb", "", int32_t(0x00000000), int32_t(0x301C4D59)},
    {"tree14.des", "", int32_t(0x00000000), int32_t(0xFBC2EE43)},
    {"tree14.lun", "", int32_t(0x00000000), int32_t(0x92E2D25A)},
    {"tree14.sno", "-", int32_t(0x00000000), int32_t(0x7CEDA14C)},
    {"tree14.tem", "-", int32_t(0x00000000), int32_t(0x8D9AF7BB)},
    {"tree14.ubn", "", int32_t(0x00000000), int32_t(0xB10FCD48)},
    {"tree14.urb", "", int32_t(0x00000000), int32_t(0xF5BB73D7)},
    {"tree15.des", "", int32_t(0x00000000), int32_t(0x5DB5E5F7)},
    {"tree15.lun", "", int32_t(0x00000000), int32_t(0x3495D9EE)},
    {"tree15.sno", "-", int32_t(0x00000000), int32_t(0xDA9AAAF8)},
    {"tree15.tem", "-", int32_t(0x00000000), int32_t(0x2BEDFC0F)},
    {"tree15.ubn", "", int32_t(0x00000000), int32_t(0x1778C6FC)},
    {"tree15.urb", "", int32_t(0x00000000), int32_t(0x53CC7863)},
    {"tree16.des", "", int32_t(0x00000000), int32_t(0x6C5DFF6A)},
    {"tree16.lun", "", int32_t(0x00000000), int32_t(0x057DC373)},
    {"tree16.sno", "-", int32_t(0x00000000), int32_t(0xEB72B065)},
    {"tree16.tem", "-", int32_t(0x00000000), int32_t(0x1A05E692)},
    {"tree16.ubn", "", int32_t(0x00000000), int32_t(0x2690DC61)},
    {"tree16.urb", "", int32_t(0x00000000), int32_t(0x622462FE)},
    {"tree17.des", "", int32_t(0x00000000), int32_t(0xCA2AF4DE)},
    {"tree17.lun", "", int32_t(0x00000000), int32_t(0xA30AC8C7)},
    {"tree17.sno", "-", int32_t(0x00000000), int32_t(0x4D05BBD1)},
    {"tree17.tem", "-", int32_t(0x00000000), int32_t(0xBC72ED26)},
    {"tree17.ubn", "", int32_t(0x00000000), int32_t(0x80E7D7D5)},
    {"tree17.urb", "", int32_t(0x00000000), int32_t(0xC453694A)},
    {"tree18.des", "", int32_t(0x00000000), int32_t(0x3C628437)},
    {"tree18.lun", "", int32_t(0x00000000), int32_t(0x5542B82E)},
    {"tree18.sno", "-", int32_t(0x00000000), int32_t(0xBB4DCB38)},
    {"tree18.tem", "-", int32_t(0x00000000), int32_t(0x4A3A9DCF)},
    {"tree18.ubn", "", int32_t(0x00000000), int32_t(0x76AFA73C)},
    {"tree18.urb", "", int32_t(0x00000000), int32_t(0x321B19A3)},
    {"tree19.des", "", int32_t(0x00000000), int32_t(0x9A158F83)},
    {"tree19.lun", "", int32_t(0x00000000), int32_t(0xF335B39A)},
    {"tree19.sno", "-", int32_t(0x00000000), int32_t(0x1D3AC08C)},
    {"tree19.tem", "-", int32_t(0x00000000), int32_t(0xEC4D967B)},
    {"tree19.ubn", "", int32_t(0x00000000), int32_t(0xD0D8AC88)},
    {"tree19.urb", "", int32_t(0x00000000), int32_t(0x946C1217)},
    {"tree20.des", "", int32_t(0x00000000), int32_t(0x8102CDB3)},
    {"tree20.lun", "", int32_t(0x00000000), int32_t(0xE822F1AA)},
    {"tree20.sno", "-", int32_t(0x00000000), int32_t(0x062D82BC)},
    {"tree20.tem", "-", int32_t(0x00000000), int32_t(0xF75AD44B)},
    {"tree20.ubn", "", int32_t(0x00000000), int32_t(0xCBCFEEB8)},
    {"tree20.urb", "", int32_t(0x00000000), int32_t(0x8F7B5027)},
    {"tree21.des", "", int32_t(0x00000000), int32_t(0x2775C607)},
    {"tree21.lun", "", int32_t(0x00000000), int32_t(0x4E55FA1E)},
    {"tree21.sno", "-", int32_t(0x00000000), int32_t(0xA05A8908)},
    {"tree21.tem", "-", int32_t(0x00000000), int32_t(0x512DDFFF)},
    {"tree21.ubn", "", int32_t(0x00000000), int32_t(0x6DB8E50C)},
    {"tree21.urb", "", int32_t(0x00000000), int32_t(0x290C5B93)},
    {"tree22.des", "", int32_t(0x00000000), int32_t(0x169DDC9A)},
    {"tree22.lun", "", int32_t(0x00000000), int32_t(0x7FBDE083)},
    {"tree22.sno", "-", int32_t(0x00000000), int32_t(0x91B29395)},
    {"tree22.tem", "-", int32_t(0x00000000), int32_t(0x60C5C562)},
    {"tree22.ubn", "", int32_t(0x00000000), int32_t(0x5C50FF91)},
    {"tree22.urb", "", int32_t(0x00000000), int32_t(0x18E4410E)},
    {"tree23.des", "", int32_t(0x00000000), int32_t(0xB0EAD72E)},
    {"tree23.lun", "", int32_t(0x00000000), int32_t(0xD9CAEB37)},
    {"tree23.sno", "-", int32_t(0x00000000), int32_t(0x37C59821)},
    {"tree23.tem", "-", int32_t(0x00000000), int32_t(0xC6B2CED6)},
    {"tree23.ubn", "", int32_t(0x00000000), int32_t(0xFA27F425)},
    {"tree23.urb", "", int32_t(0x00000000), int32_t(0xBE934ABA)},
    {"tree24.des", "", int32_t(0x00000000), int32_t(0x754DE9A0)},
    {"tree24.lun", "", int32_t(0x00000000), int32_t(0x1C6DD5B9)},
    {"tree24.sno", "-", int32_t(0x00000000), int32_t(0xF262A6AF)},
    {"tree24.tem", "-", int32_t(0x00000000), int32_t(0x0315F058)},
    {"tree24.ubn", "", int32_t(0x00000000), int32_t(0x3F80CAAB)},
    {"tree24.urb", "", int32_t(0x00000000), int32_t(0x7B347434)},
    {"tree25.des", "", int32_t(0x00000000), int32_t(0xD33AE214)},
    {"tree25.lun", "", int32_t(0x00000000), int32_t(0xBA1ADE0D)},
    {"tree25.sno", "-", int32_t(0x00000000), int32_t(0x5415AD1B)},
    {"tree25.tem", "-", int32_t(0x00000000), int32_t(0xA562FBEC)},
    {"tree25.ubn", "", int32_t(0x00000000), int32_t(0x99F7C11F)},
    {"tree25.urb", "", int32_t(0x00000000), int32_t(0xDD437F80)},
    {"tree26.des", "", int32_t(0x00000000), int32_t(0xE2D2F889)},
    {"tree26.lun", "", int32_t(0x00000000), int32_t(0x8BF2C490)},
    {"tree26.sno", "", int32_t(0x00000000), int32_t(0x65FDB786)},
    {"tree26.tem", "", int32_t(0x00000000), int32_t(0x948AE171)},
    {"tree26.ubn", "", int32_t(0x00000000), int32_t(0xA81FDB82)},
    {"tree26.urb", "", int32_t(0x00000000), int32_t(0xECAB651D)},
    {"tree27.des", "", int32_t(0x00000000), int32_t(0x44A5F33D)},
    {"tree27.lun", "", int32_t(0x00000000), int32_t(0x2D85CF24)},
    {"tree27.sno", "", int32_t(0x00000000), int32_t(0xC38ABC32)},
    {"tree27.tem", "", int32_t(0x00000000), int32_t(0x32FDEAC5)},
    {"tree27.ubn", "", int32_t(0x00000000), int32_t(0x0E68D036)},
    {"tree27.urb", "", int32_t(0x00000000), int32_t(0x4ADC6EA9)},
    {"tree28.des", "", int32_t(0x00000000), int32_t(0xB2ED83D4)},
    {"tree28.lun", "", int32_t(0x00000000), int32_t(0xDBCDBFCD)},
    {"tree28.sno", "", int32_t(0x00000000), int32_t(0x35C2CCDB)},
    {"tree28.tem", "", int32_t(0x00000000), int32_t(0xC4B59A2C)},
    {"tree28.ubn", "", int32_t(0x00000000), int32_t(0xF820A0DF)},
    {"tree28.urb", "", int32_t(0x00000000), int32_t(0xBC941E40)},
    {"tree29.des", "", int32_t(0x00000000), int32_t(0x149A8860)},
    {"tree29.lun", "", int32_t(0x00000000), int32_t(0x7DBAB479)},
    {"tree29.ubn", "", int32_t(0x00000000), int32_t(0x5E57AB6B)},
    {"tree30.des", "", int32_t(0x00000000), int32_t(0x4DA8CD2D)},
    {"tree30.lun", "", int32_t(0x00000000), int32_t(0x2488F134)},
    {"tree30.ubn", "", int32_t(0x00000000), int32_t(0x0765EE26)},
    {"tree31.des", "", int32_t(0x00000000), int32_t(0xEBDFC699)},
    {"tree31.lun", "", int32_t(0x00000000), int32_t(0x82FFFA80)},
    {"tree31.ubn", "", int32_t(0x00000000), int32_t(0xA112E592)},
    {"tree32.des", "", int32_t(0x00000000), int32_t(0xDA37DC04)},
    {"tree32.lun", "", int32_t(0x00000000), int32_t(0xB317E01D)},
    {"tree32.ubn", "", int32_t(0x00000000), int32_t(0x90FAFF0F)},
    {"tree33.des", "", int32_t(0x00000000), int32_t(0x7C40D7B0)},
    {"tree33.lun", "", int32_t(0x00000000), int32_t(0x1560EBA9)},
    {"tree33.ubn", "", int32_t(0x00000000), int32_t(0x368DF4BB)},
    {"tree34.des", "", int32_t(0x00000000), int32_t(0xB9E7E93E)},
    {"tree34.lun", "", int32_t(0x00000000), int32_t(0xD0C7D527)},
    {"tree34.ubn", "", int32_t(0x00000000), int32_t(0xF32ACA35)},
    {"tree35.des", "", int32_t(0x00000000), int32_t(0x1F90E28A)},
    {"tree35.lun", "", int32_t(0x00000000), int32_t(0x76B0DE93)},
    {"tree35.ubn", "", int32_t(0x00000000), int32_t(0x555DC181)},
    {"tree36.des", "", int32_t(0x00000000), int32_t(0x2E78F817)},
    {"tree36.lun", "", int32_t(0x00000000), int32_t(0x4758C40E)},
    {"tree36.ubn", "", int32_t(0x00000000), int32_t(0x64B5DB1C)},
    {"treebrn1.aud", "tree burn", int32_t(0xBC072F03), int32_t(0x00000000)},
    {"treebrn1.juv", "tree burn", int32_t(0xCE073803), int32_t(0x00000000)},
    {"treesprd.shp", "blossom tree spreading spores", int32_t(0x00000000), int32_t(0xE179DFAF)},
    {"tren226m.aud", "trenches", int32_t(0x17D6EEE3), int32_t(0x00000000)},
    {"trex.shp", "tyrannosaurus rex", int32_t(0x00D2F7D6), int32_t(0x00000000)},
    {"trexicnh.shp", "", int32_t(0x41FA2311), int32_t(0x00000000)},
    {"trexicnh.tem", "", int32_t(0x3EF72411), int32_t(0x00000000)},
    {"trexit.cps", "pict: bars", int32_t(0xE7724533), int32_t(0x00000000)},
    {"trexit.wsa", "anim: installation complete", int32_t(0x0F723335), int32_t(0x00000000)},
    {"trff01.des", "", int32_t(0x00000000), int32_t(0xB7EA46BC)},
    {"trff01.lun", "", int32_t(0x00000000), int32_t(0xDECA7AA5)},
    {"trff01.sno", "", int32_t(0x00000000), int32_t(0x30C509B3)},
    {"trff01.tem", "", int32_t(0x00000000), int32_t(0xC1B25F44)},
    {"trff01.ubn", "", int32_t(0x00000000), int32_t(0xFD2765B7)},
    {"trff01.urb", "", int32_t(0x00000000), int32_t(0xB993DB28)},
    {"trff02.des", "", int32_t(0x00000000), int32_t(0x86025C21)},
    {"trff02.lun", "", int32_t(0x00000000), int32_t(0xEF226038)},
    {"trff02.sno", "", int32_t(0x00000000), int32_t(0x012D132E)},
    {"trff02.tem", "", int32_t(0x00000000), int32_t(0xF05A45D9)},
    {"trff02.ubn", "", int32_t(0x00000000), int32_t(0xCCCF7F2A)},
    {"trff02.urb", "", int32_t(0x00000000), int32_t(0x887BC1B5)},
    {"trff03.des", "", int32_t(0x00000000), int32_t(0x20755795)},
    {"trff03.lun", "", int32_t(0x00000000), int32_t(0x49556B8C)},
    {"trff03.sno", "", int32_t(0x00000000), int32_t(0xA75A189A)},
    {"trff03.tem", "", int32_t(0x00000000), int32_t(0x562D4E6D)},
    {"trff03.ubn", "", int32_t(0x00000000), int32_t(0x6AB8749E)},
    {"trff03.urb", "", int32_t(0x00000000), int32_t(0x2E0CCA01)},
    {"trff04.des", "", int32_t(0x00000000), int32_t(0xE5D2691B)},
    {"trff04.lun", "", int32_t(0x00000000), int32_t(0x8CF25502)},
    {"trff04.sno", "", int32_t(0x00000000), int32_t(0x62FD2614)},
    {"trff04.tem", "", int32_t(0x00000000), int32_t(0x938A70E3)},
    {"trff04.ubn", "", int32_t(0x00000000), int32_t(0xAF1F4A10)},
    {"trff04.urb", "", int32_t(0x00000000), int32_t(0xEBABF48F)},
    {"trgspin1.aud", "", int32_t(0xF40F1D1F), int32_t(0x00000000)},
    {"trgspin2.aud", "", int32_t(0xF60F1D1F), int32_t(0x00000000)},
    {"trgspin3.aud", "", int32_t(0xF80F1D1F), int32_t(0x00000000)},
    {"tric.shp", "triceratops", int32_t(0xD6DAF7D6), int32_t(0x00000000)},
    {"tricicnh.shp", "", int32_t(0xEE0A2311), int32_t(0x00000000)},
    {"tricicnh.tem", "", int32_t(0xEB072411), int32_t(0x00000000)},
    {"trinity.vqa", "paris being nuked", int32_t(0x96194339), int32_t(0x00000000)},
    {"trinity.vqp", "vqp: paris being nuked", int32_t(0x96284339), int32_t(0x00000000)},
    {"triplecrossed.map", "", int32_t(0x00000000), int32_t(0x08DDE9EB)},
    {"trkaicon.shp", "", int32_t(0x00000000), int32_t(0xECE91C44)},
    {"trn01t.map", "", int32_t(0x00000000), int32_t(0xB5F950AD)},
    {"trn02t.map", "", int32_t(0x00000000), int32_t(0x3B76574E)},
    {"trnsport.hva", "-", int32_t(0x00000000), int32_t(0x17383059)},
    {"trnsport.vxl", "carryall", int32_t(0x00000000), int32_t(0xE1B2EF10)},
    {"trock01.des", "", int32_t(0x00000000), int32_t(0xEB2F41FE)},
    {"trock01.lun", "", int32_t(0x00000000), int32_t(0xCDD1A67D)},
    {"trock01.sno", "-", int32_t(0x00000000), int32_t(0xCCC39C64)},
    {"trock01.tem", "-", int32_t(0x00000000), int32_t(0x6F7729BE)},
    {"trock01.ubn", "", int32_t(0x00000000), int32_t(0xF9A90B9D)},
    {"trock01.urb", "", int32_t(0x00000000), int32_t(0x493AE7E1)},
    {"trock02.des", "", int32_t(0x00000000), int32_t(0x6DBB3350)},
    {"trock02.lun", "", int32_t(0x00000000), int32_t(0x4B45D4D3)},
    {"trock02.sno", "-", int32_t(0x00000000), int32_t(0x4A57EECA)},
    {"trock02.tem", "-", int32_t(0x00000000), int32_t(0xE9E35B10)},
    {"trock02.ubn", "", int32_t(0x00000000), int32_t(0x7F3D7933)},
    {"trock02.urb", "", int32_t(0x00000000), int32_t(0xCFAE954F)},
    {"trock03.des", "", int32_t(0x00000000), int32_t(0xA6E7E0F5)},
    {"trock03.lun", "", int32_t(0x00000000), int32_t(0x80190776)},
    {"trock03.sno", "-", int32_t(0x00000000), int32_t(0x810B3D6F)},
    {"trock03.tem", "-", int32_t(0x00000000), int32_t(0x22BF88B5)},
    {"trock03.ubn", "", int32_t(0x00000000), int32_t(0xB461AA96)},
    {"trock03.urb", "", int32_t(0x00000000), int32_t(0x04F246EA)},
    {"trock04.des", "", int32_t(0x00000000), int32_t(0xBBE2D04D)},
    {"trock04.lun", "", int32_t(0x00000000), int32_t(0x9D1C37CE)},
    {"trock04.sno", "-", int32_t(0x00000000), int32_t(0x9C0E0DD7)},
    {"trock04.tem", "-", int32_t(0x00000000), int32_t(0x3FBAB80D)},
    {"trock04.ubn", "", int32_t(0x00000000), int32_t(0xA9649A2E)},
    {"trock04.urb", "", int32_t(0x00000000), int32_t(0x19F77652)},
    {"trock05.des", "", int32_t(0x00000000), int32_t(0x70BE03E8)},
    {"trock05.lun", "", int32_t(0x00000000), int32_t(0x5640E46B)},
    {"trock05.sno", "-", int32_t(0x00000000), int32_t(0x5752DE72)},
    {"trock05.tem", "-", int32_t(0x00000000), int32_t(0xF4E66BA8)},
    {"trock05.ubn", "", int32_t(0x00000000), int32_t(0x6238498B)},
    {"trock05.urb", "", int32_t(0x00000000), int32_t(0xD2ABA5F7)},
    {"trofl.pcx", "-", int32_t(0x00000000), int32_t(0x4C8719B4)},
    {"trofm.pcx", "-", int32_t(0x00000000), int32_t(0x802D192A)},
    {"trofnew.pcx", "", int32_t(0x00000000), int32_t(0xB1A77CAF)},
    {"trofr.pcx", "-", int32_t(0x00000000), int32_t(0x25B63AAD)},
    {"trouble.aud", "looks like trouble", int32_t(0xB20C3716), int32_t(0x00000000)},
    {"trouble.var", "looks like trouble sfx", int32_t(0xB21A232B), int32_t(0x00000000)},
    {"trpdoor1.aud", "", int32_t(0xB83B291D), int32_t(0x00000000)},
    {"trpdorc.aud", "", int32_t(0x6E0C4330), int32_t(0x00000000)},
    {"trpdoro.aud", "", int32_t(0x6E244330), int32_t(0x00000000)},
    {"trs.hva", "", int32_t(0x00000000), int32_t(0xB2153CD9)},
    {"trs.vxl", "", int32_t(0x00000000), int32_t(0xBDE34F32)},
    {"trst.shp", "", int32_t(0x00000000), int32_t(0x3A511584)},
    {"trsticon.shp", "", int32_t(0x00000000), int32_t(0x3EC7DA66)},
    {"trstuico.shp", "", int32_t(0x00000000), int32_t(0xFB014887)},
    {"trtkil_d.vqa", "turret being blown up in the desert", int32_t(0xF7613811), int32_t(0x00000000)},
    {"trtkil_d.vqp", "turret being blown up in the desert", int32_t(0x06613811), int32_t(0x00000000)},
    {"trtunn01.des", "", int32_t(0x00000000), int32_t(0x144AEF8D)},
    {"trtunn01.lun", "", int32_t(0x00000000), int32_t(0x339DC0BD)},
    {"trtunn01.sno", "-", int32_t(0x00000000), int32_t(0xFAD6DFFC)},
    {"trtunn01.tem", "-", int32_t(0x00000000), int32_t(0xF263719E)},
    {"trtunn01.ubn", "", int32_t(0x00000000), int32_t(0x25E9DCD4)},
    {"trtunn01.urb", "", int32_t(0x00000000), int32_t(0x669D82AE)},
    {"trtunn02.des", "", int32_t(0x00000000), int32_t(0x53EA955D)},
    {"trtunn02.lun", "", int32_t(0x00000000), int32_t(0x743DBA6D)},
    {"trtunn02.sno", "-", int32_t(0x00000000), int32_t(0xBD76A52C)},
    {"trtunn02.tem", "-", int32_t(0x00000000), int32_t(0xB5C30B4E)},
    {"trtunn02.ubn", "", int32_t(0x00000000), int32_t(0x6249A604)},
    {"trtunn02.urb", "", int32_t(0x00000000), int32_t(0x213DF87E)},
    {"trtunn03.des", "", int32_t(0x00000000), int32_t(0x6E8ABCED)},
    {"trtunn03.lun", "", int32_t(0x00000000), int32_t(0x495D93DD)},
    {"trtunn03.sno", "-", int32_t(0x00000000), int32_t(0x80168C9C)},
    {"trtunn03.tem", "-", int32_t(0x00000000), int32_t(0x88A322FE)},
    {"trtunn03.ubn", "", int32_t(0x00000000), int32_t(0x5F298FB4)},
    {"trtunn03.urb", "", int32_t(0x00000000), int32_t(0x1C5DD1CE)},
    {"trtunn04.des", "", int32_t(0x00000000), int32_t(0xDCAA60FD)},
    {"trtunn04.lun", "", int32_t(0x00000000), int32_t(0xFB7D4FCD)},
    {"trtunn04.sno", "-", int32_t(0x00000000), int32_t(0x3236508C)},
    {"trtunn04.tem", "-", int32_t(0x00000000), int32_t(0x3A83FEEE)},
    {"trtunn04.ubn", "", int32_t(0x00000000), int32_t(0xED0953A4)},
    {"trtunn04.urb", "", int32_t(0x00000000), int32_t(0xAE7D0DDE)},
    {"truck2.hva", "-", int32_t(0x00000000), int32_t(0xED768DF3)},
    {"truck2.vxl", "-", int32_t(0x00000000), int32_t(0x3D196D77)},
    {"trucka.hva", "-", int32_t(0x00000000), int32_t(0x30F64745)},
    {"trucka.vxl", "truck", int32_t(0x00000000), int32_t(0xE099A7C1)},
    {"truckb.hva", "-", int32_t(0x00000000), int32_t(0x011E5DD8)},
    {"truckb.vxl", "loaded truck", int32_t(0x00000000), int32_t(0xD171BD5C)},
    {"truckby1.aud", "", int32_t(0xB45D0F15), int32_t(0x00000000)},
    {"truk.hva", "-", int32_t(0x00000000), int32_t(0xA03AA576)},
    {"truk.shp", "unit: convoy truck", int32_t(0xE6F2F7D6), int32_t(0x00000000)},
    {"truk.vxl", "convoy truck", int32_t(0x00000000), int32_t(0x56B07A3F)},
    {"trukicon.shp", "icon: supply truck", int32_t(0x1A3C2311), int32_t(0x00000000)},
    {"ts_title.vqa", "-", int32_t(0x00000000), int32_t(0x41334FD6)},
    {"tsc1465003e.aud", "", int32_t(0xA7BE2F13), int32_t(0x00000000)},
    {"tscredit.txt", "tiberian sun credits", int32_t(0x00000000), int32_t(0x8D1C7AF6)},
    {"tsgun4.aud", "wolverene gun", int32_t(0x00000000), int32_t(0x7B2E5D8D)},
    {"tshade.mrf", "???", int32_t(0x9F7E1E2B), int32_t(0x00000000)},
    {"tshadow.mrf", "???", int32_t(0x62163E26), int32_t(0x00000000)},
    {"tsla.shp", "bldg: tesla coil", int32_t(0xD2E0F9D6), int32_t(0x00000000)},
    {"tslachg2.aud", "tesla charge", int32_t(0xAE151F05), int32_t(0x00000000)},
    {"tslaicon.shp", "icon: tesla coil", int32_t(0xF2182711), int32_t(0xCFBBD8FD)},
    {"tslamake.shp", "make: tesla coil", int32_t(0xE0102319), int32_t(0x00000000)},
    {"tslbarnc.shp", "", int32_t(0x00000000), int32_t(0xD7B67FE3)},
    {"tslope01.des", "", int32_t(0x00000000), int32_t(0xB3654E5D)},
    {"tslope01.sno", "-", int32_t(0x00000000), int32_t(0x5DF97E2C)},
    {"tslope01.tem", "-", int32_t(0x00000000), int32_t(0x554CD04E)},
    {"tslope01.urb", "", int32_t(0x00000000), int32_t(0xC1B2237E)},
    {"tslope02.des", "", int32_t(0x00000000), int32_t(0xF4C5348D)},
    {"tslope02.sno", "-", int32_t(0x00000000), int32_t(0x1A5904FC)},
    {"tslope02.tem", "-", int32_t(0x00000000), int32_t(0x12ECAA9E)},
    {"tslope02.urb", "", int32_t(0x00000000), int32_t(0x861259AE)},
    {"tslope03.des", "", int32_t(0x00000000), int32_t(0xC9A51D3D)},
    {"tslope03.sno", "-", int32_t(0x00000000), int32_t(0x27392D4C)},
    {"tslope03.tem", "-", int32_t(0x00000000), int32_t(0x2F8C832E)},
    {"tslope03.urb", "", int32_t(0x00000000), int32_t(0xBB72701E)},
    {"tslope04.des", "", int32_t(0x00000000), int32_t(0x7B85C12D)},
    {"tslope04.sno", "-", int32_t(0x00000000), int32_t(0x9519F15C)},
    {"tslope04.tem", "-", int32_t(0x00000000), int32_t(0x9DAC5F3E)},
    {"tslope04.urb", "", int32_t(0x00000000), int32_t(0x0952AC0E)},
    {"tstback.pcx", "-", int32_t(0x00000000), int32_t(0x3C6F6D0A)},
    {"tstimpct.shp", "", int32_t(0x00000000), int32_t(0xCFF47C08)},
    {"tstlexp.shp", "", int32_t(0x00000000), int32_t(0xAA164809)},
    {"tstwnd.cps", "pict:", int32_t(0xE3AE293D), int32_t(0x00000000)},
    {"ttlbr640.shp", "", int32_t(0x00000000), int32_t(0x678B80E6)},
    {"ttlbr800.shp", "", int32_t(0x00000000), int32_t(0xAC25B9AD)},
    {"ttnk.hva", "-", int32_t(0x00000000), int32_t(0xAAFB6214)},
    {"ttnk.shp", "unit: tesla tank", int32_t(0xE6E4FBD6), int32_t(0x00000000)},
    {"ttnk.vxl", "tick tank", int32_t(0x00000000), int32_t(0x5C71BD5D)},
    {"ttnkbarl.hva", "-", int32_t(0x00000000), int32_t(0xD6A48B3B)},
    {"ttnkbarl.vxl", "tick tank barrel", int32_t(0x00000000), int32_t(0x202E5472)},
    {"ttnkicon.shp", "icon: tesla tank", int32_t(0x1A202B11), int32_t(0x775B97DD)},
    {"ttnktur.hva", "-", int32_t(0x00000000), int32_t(0x89B7ADE8)},
    {"ttnktur.vxl", "tick tank turret", int32_t(0x00000000), int32_t(0x8641DE03)},
    {"ttnkuico.shp", "", int32_t(0x00000000), int32_t(0xB29D053C)},
    {"ttrans.mrf", "???", int32_t(0x9FA63E3F), int32_t(0x00000000)},
    {"tube1.vqa", "", int32_t(0xB7B5B1F4), int32_t(0x00000000)},
    {"tubes1.aud", "", int32_t(0x9765FC4C), int32_t(0x00000000)},
    {"tubes2.aud", "", int32_t(0x9765FE4C), int32_t(0x00000000)},
    {"tubes3.aud", "", int32_t(0x9766004C), int32_t(0x00000000)},
    {"tubes4.aud", "", int32_t(0x9766024C), int32_t(0x00000000)},
    {"tuffguy1.aud", "commando real tough guy", int32_t(0xC021410D), int32_t(0x00000000)},
    {"tug.hva", "", int32_t(0x00000000), int32_t(0xEFF542DA)},
    {"tug.vxl", "", int32_t(0x00000000), int32_t(0xE0033131)},
    {"tunits.mrf", "???", int32_t(0xBF96424B), int32_t(0x00000000)},
    {"tunnel.ini", "", int32_t(0x00000000), int32_t(0xF6232352)},
    {"tunnel.map", "-", int32_t(0x00000000), int32_t(0xD88810AA)},
    {"tunnel01.des", "", int32_t(0x00000000), int32_t(0xE99D3AFC)},
    {"tunnel01.sno", "-", int32_t(0x00000000), int32_t(0x07010A8D)},
    {"tunnel01.tem", "-", int32_t(0x00000000), int32_t(0x0FB4A4EF)},
    {"tunnel01.ubn", "", int32_t(0x00000000), int32_t(0xD83E09A5)},
    {"tunnel01.urb", "", int32_t(0x00000000), int32_t(0x9B4A57DF)},
    {"tunnel02.des", "", int32_t(0x00000000), int32_t(0xAE3D402C)},
    {"tunnel02.sno", "-", int32_t(0x00000000), int32_t(0x40A1705D)},
    {"tunnel02.tem", "-", int32_t(0x00000000), int32_t(0x4814DE3F)},
    {"tunnel02.ubn", "", int32_t(0x00000000), int32_t(0x9F9E7375)},
    {"tunnel02.urb", "", int32_t(0x00000000), int32_t(0xDCEA2D0F)},
    {"tunnel03.des", "", int32_t(0x00000000), int32_t(0x935D699C)},
    {"tunnel03.sno", "-", int32_t(0x00000000), int32_t(0x7DC159ED)},
    {"tunnel03.tem", "-", int32_t(0x00000000), int32_t(0x7574F78F)},
    {"tunnel03.ubn", "", int32_t(0x00000000), int32_t(0xA2FE5AC5)},
    {"tunnel03.urb", "", int32_t(0x00000000), int32_t(0xE18A04BF)},
    {"tunnel04.des", "", int32_t(0x00000000), int32_t(0x217DB58C)},
    {"tunnel04.sno", "-", int32_t(0x00000000), int32_t(0xCFE185FD)},
    {"tunnel04.tem", "-", int32_t(0x00000000), int32_t(0xC7542B9F)},
    {"tunnel04.ubn", "", int32_t(0x00000000), int32_t(0x10DE86D5)},
    {"tunnel04.urb", "", int32_t(0x00000000), int32_t(0x53AAD8AF)},
    {"tunnet01.des", "", int32_t(0x00000000), int32_t(0xBDACE855)},
    {"tunnet01.sno", "-", int32_t(0x00000000), int32_t(0x5330D824)},
    {"tunnet01.tem", "-", int32_t(0x00000000), int32_t(0x5B857646)},
    {"tunnet02.des", "", int32_t(0x00000000), int32_t(0xFA0C9285)},
    {"tunnet02.sno", "-", int32_t(0x00000000), int32_t(0x1490A2F4)},
    {"tunnet02.tem", "-", int32_t(0x00000000), int32_t(0x1C250C96)},
    {"tunnet03.des", "", int32_t(0x00000000), int32_t(0xC76CBB35)},
    {"tunnet03.sno", "-", int32_t(0x00000000), int32_t(0x29F08B44)},
    {"tunnet03.tem", "-", int32_t(0x00000000), int32_t(0x21452526)},
    {"tunnet04.des", "", int32_t(0x00000000), int32_t(0x754C6725)},
    {"tunnet04.sno", "-", int32_t(0x00000000), int32_t(0x9BD05754)},
    {"tunnet04.tem", "-", int32_t(0x00000000), int32_t(0x9365F936)},
    {"tunnex01.des", "", int32_t(0x00000000), int32_t(0x7A0C8221)},
    {"tunnex01.sno", "-", int32_t(0x00000000), int32_t(0x9490B250)},
    {"tunnex01.tem", "-", int32_t(0x00000000), int32_t(0x9C251C32)},
    {"tunnex01.ubn", "", int32_t(0x00000000), int32_t(0x4BAFB178)},
    {"tunnex01.urb", "", int32_t(0x00000000), int32_t(0x08DBEF02)},
    {"tunnex02.des", "", int32_t(0x00000000), int32_t(0x3DACF8F1)},
    {"tunnex02.sno", "-", int32_t(0x00000000), int32_t(0xD330C880)},
    {"tunnex02.tem", "-", int32_t(0x00000000), int32_t(0xDB8566E2)},
    {"tunnex02.ubn", "", int32_t(0x00000000), int32_t(0x0C0FCBA8)},
    {"tunnex02.urb", "", int32_t(0x00000000), int32_t(0x4F7B95D2)},
    {"tuntop01.des", "", int32_t(0x00000000), int32_t(0xE1CD1861)},
    {"tuntop01.sno", "-", int32_t(0x00000000), int32_t(0x0F512810)},
    {"tuntop01.tem", "-", int32_t(0x00000000), int32_t(0x07E48672)},
    {"tuntop01.urb", "", int32_t(0x00000000), int32_t(0x931A7542)},
    {"tuntop02.des", "", int32_t(0x00000000), int32_t(0xA66D62B1)},
    {"tuntop02.sno", "-", int32_t(0x00000000), int32_t(0x48F152C0)},
    {"tuntop02.tem", "-", int32_t(0x00000000), int32_t(0x4044FCA2)},
    {"tuntop02.urb", "", int32_t(0x00000000), int32_t(0xD4BA0F92)},
    {"tuntop03.des", "", int32_t(0x00000000), int32_t(0x9B0D4B01)},
    {"tuntop03.sno", "-", int32_t(0x00000000), int32_t(0x75917B70)},
    {"tuntop03.tem", "-", int32_t(0x00000000), int32_t(0x7D24D512)},
    {"tuntop03.urb", "", int32_t(0x00000000), int32_t(0xE9DA2622)},
    {"tuntop04.des", "", int32_t(0x00000000), int32_t(0x292D9711)},
    {"tuntop04.sno", "-", int32_t(0x00000000), int32_t(0xC7B1A760)},
    {"tuntop04.tem", "-", int32_t(0x00000000), int32_t(0xCF040902)},
    {"tuntop04.urb", "", int32_t(0x00000000), int32_t(0x5BFAFA32)},
    {"turbicon.shp", "icon: power turbine", int32_t(0x00000000), int32_t(0x27E49F20)},
    {"turfwar.map", "", int32_t(0x00000000), int32_t(0xE4942DF0)},
    {"turning.shp", "", int32_t(0x00000000), int32_t(0x2C395413)},
    {"turr.shp", "misc: cruiser turret", int32_t(0xF4ECFDD6), int32_t(0x00000000)},
    {"turret1.aud", "destroyer shot", int32_t(0xA5F0531C), int32_t(0x00000000)},
    {"turrfir5.aud", "turret fire", int32_t(0xF843290B), int32_t(0x00000000)},
    {"turrfir5.juv", "turret fire", int32_t(0x0A43320B), int32_t(0x00000000)},
    {"turtkill.vqa", "turret being blown up in the forest", int32_t(0x2B333E15), int32_t(0x00000000)},
    {"turtkill.vqp", "turret being blown up in the forest", int32_t(0x3A333E15), int32_t(0x00000000)},
    {"tutorial.ini", "inif: generic text", int32_t(0x1F223123), int32_t(0x3D5E61F3)},
    {"tvfloor1.aud", "", int32_t(0xD813391D), int32_t(0x00000000)},
    {"tvoff1.aud", "", int32_t(0x9B9A0032), int32_t(0x00000000)},
    {"tvoratk1.aud", "", int32_t(0xF0294301), int32_t(0x00000000)},
    {"tvoratk2.aud", "", int32_t(0xF2294301), int32_t(0x00000000)},
    {"tvordeth.aud", "", int32_t(0x1E3B2507), int32_t(0x00000000)},
    {"tvorhit1.aud", "", int32_t(0xF03B2D0F), int32_t(0x00000000)},
    {"tvorhit2.aud", "", int32_t(0xF23B2D0F), int32_t(0x00000000)},
    {"tvorhtsh.aud", "", int32_t(0x1E39430F), int32_t(0x00000000)},
    {"tvorkilb.aud", "", int32_t(0x122B2D15), int32_t(0x00000000)},
    {"twhite.mrf", "???", int32_t(0xBF7E2E4B), int32_t(0x00000000)},
    {"twig1.aud", "", int32_t(0xC7A7B9F7), int32_t(0x00000000)},
    {"twig2.aud", "", int32_t(0xC7A7B9F9), int32_t(0x00000000)},
    {"twig3.aud", "", int32_t(0xC7A7B9FB), int32_t(0x00000000)},
    {"twig4.aud", "", int32_t(0xC7A7B9FD), int32_t(0x00000000)},
    {"twin.aud", "twin", int32_t(0xE0E7EFD6), int32_t(0x00000000)},
    {"twinkle1.shp", "misc: ???", int32_t(0xEBF84915), int32_t(0x28868C06)},
    {"twinkle2.shp", "misc: ???", int32_t(0xEDF84915), int32_t(0x6F26F6D6)},
    {"twinkle3.shp", "misc: ???", int32_t(0xEFF84915), int32_t(0x5246DF66)},
    {"twinmix1.aud", "twinmix1", int32_t(0xE02B3119), int32_t(0x00000000)},
    {"twlt026.shp", "small explosion (white)", int32_t(0x00000000), int32_t(0x2C757AE6)},
    {"twlt036.shp", "medium explosion (white)", int32_t(0x00000000), int32_t(0x8A027152)},
    {"twlt050.shp", "large explosion (white)", int32_t(0x00000000), int32_t(0x3F8BA775)},
    {"twlt070.shp", "x-large explosion (white)", int32_t(0x00000000), int32_t(0xA814B65C)},
    {"twlt070t.shp", "-", int32_t(0x00000000), int32_t(0xE229E2F5)},
    {"twlt100.shp", "biggest explosion in the game", int32_t(0x00000000), int32_t(0xA119884C)},
    {"twlt100i.shp", "-", int32_t(0x00000000), int32_t(0x73548FD6)},
    {"twnk1.shp", "", int32_t(0x00000000), int32_t(0xE6FAD4B4)},
    {"twr1icon.shp", "icon: vulcan cannon add-on", int32_t(0x00000000), int32_t(0xB6A6D9F1)},
    {"twr2icon.shp", "icon: rpg add-on", int32_t(0x00000000), int32_t(0x8F2BE534)},
    {"twr3icon.shp", "icon: sam add-on", int32_t(0x00000000), int32_t(0x9850F177)},
    {"twrd01_e.vqa", "", int32_t(0xDD5915DF), int32_t(0x00000000)},
    {"twrd02_e.vqa", "", int32_t(0xDD5917DF), int32_t(0x00000000)},
    {"twrd03_e.vqa", "", int32_t(0xDD5919DF), int32_t(0x00000000)},
    {"twrlite1.aud", "", int32_t(0xD8294711), int32_t(0x00000000)},
    {"twrlite2.aud", "", int32_t(0xDA294711), int32_t(0x00000000)},
    {"twrlite3.aud", "", int32_t(0xDC294711), int32_t(0x00000000)},
    {"twrlite4.aud", "", int32_t(0xDE294711), int32_t(0x00000000)},
    {"txgasg.shp", "", int32_t(0x00000000), int32_t(0x53670B2D)},
    {"txgasr.shp", "", int32_t(0x00000000), int32_t(0x6681B844)},
    {"tyellow.mrf", "???", int32_t(0x8E0A5636), int32_t(0x00000000)},
    {"type.aud", "-", int32_t(0x00000000), int32_t(0x1956429D)},
    {"type.fnt", "type", int32_t(0xDEEEF8D6), int32_t(0x00000000)},
    {"u2.shp", "unit: spyplane", int32_t(0xA65CB4F2), int32_t(0x00000000)},
    {"u2icon.shp", "icon: spy plane", int32_t(0xB381B63B), int32_t(0x00000000)},
    {"ubn.mix", "", int32_t(0x00000000), int32_t(0x1D8D0CAB)},
    {"ucall3.shp", "", int32_t(0x00000000), int32_t(0x04F84462)},
    {"ucblood.shp", "", int32_t(0x00000000), int32_t(0x1E0BCF07)},
    {"uccons.shp", "", int32_t(0x00000000), int32_t(0xF013E302)},
    {"ucelec.shp", "", int32_t(0x00000000), int32_t(0xFE342F18)},
    {"ucflash.shp", "", int32_t(0x00000000), int32_t(0xD5D64B8E)},
    {"ucinit.shp", "", int32_t(0x00000000), int32_t(0x3F28501F)},
    {"udatk1.aud", "", int32_t(0xD361B840), int32_t(0x00000000)},
    {"uddie1.aud", "", int32_t(0xA76DB834), int32_t(0x00000000)},
    {"udhurt1.aud", "", int32_t(0xB1C80F3A), int32_t(0x00000000)},
    {"udhurt2.aud", "", int32_t(0xB1CA0F3A), int32_t(0x00000000)},
    {"udloitr1.aud", "", int32_t(0xE42AFB15), int32_t(0x00000000)},
    {"udloitr2.aud", "", int32_t(0xE62AFB15), int32_t(0x00000000)},
    {"ufo.tem", "-", int32_t(0x00000000), int32_t(0x3120FC78)},
    {"ufoguard.vqa", "-", int32_t(0x00000000), int32_t(0xAD9A493A)},
    {"ug01-min.set", "", int32_t(0xB5990ADD), int32_t(0x00000000)},
    {"ug01.vqa", "", int32_t(0xA3B1E4D8), int32_t(0x00000000)},
    {"ug01_0.vqa", "", int32_t(0x711DBF64), int32_t(0x00000000)},
    {"ug01_1.vqa", "", int32_t(0x711DC164), int32_t(0x00000000)},
    {"ug01_2.vqa", "", int32_t(0x711DC364), int32_t(0x00000000)},
    {"ug01_3.vqa", "", int32_t(0x711DC564), int32_t(0x00000000)},
    {"ug02-min.set", "", int32_t(0xB9990ADD), int32_t(0x00000000)},
    {"ug02.vqa", "", int32_t(0xA5B1E4D8), int32_t(0x00000000)},
    {"ug02_0.vqa", "", int32_t(0x751DBF64), int32_t(0x00000000)},
    {"ug02_1.vqa", "", int32_t(0x751DC164), int32_t(0x00000000)},
    {"ug02_2.vqa", "", int32_t(0x751DC364), int32_t(0x00000000)},
    {"ug02_3.vqa", "", int32_t(0x751DC564), int32_t(0x00000000)},
    {"ug03-min.set", "", int32_t(0xBD990ADD), int32_t(0x00000000)},
    {"ug03.vqa", "", int32_t(0xA7B1E4D8), int32_t(0x00000000)},
    {"ug03_0.vqa", "", int32_t(0x791DBF64), int32_t(0x00000000)},
    {"ug03_1.vqa", "", int32_t(0x791DC164), int32_t(0x00000000)},
    {"ug03_2.vqa", "", int32_t(0x791DC364), int32_t(0x00000000)},
    {"ug03_3.vqa", "", int32_t(0x791DC564), int32_t(0x00000000)},
    {"ug04-min.set", "", int32_t(0xC1990ADD), int32_t(0x00000000)},
    {"ug04.vqa", "", int32_t(0xA9B1E4D8), int32_t(0x00000000)},
    {"ug04_0.vqa", "", int32_t(0x7D1DBF64), int32_t(0x00000000)},
    {"ug04_1.vqa", "", int32_t(0x7D1DC164), int32_t(0x00000000)},
    {"ug04_2.vqa", "", int32_t(0x7D1DC364), int32_t(0x00000000)},
    {"ug04_3.vqa", "", int32_t(0x7D1DC564), int32_t(0x00000000)},
    {"ug05-min.set", "", int32_t(0xC5990ADD), int32_t(0x00000000)},
    {"ug05.vqa", "", int32_t(0xABB1E4D8), int32_t(0x00000000)},
    {"ug05_0.vqa", "", int32_t(0x811DBF64), int32_t(0x00000000)},
    {"ug05_1.vqa", "", int32_t(0x811DC164), int32_t(0x00000000)},
    {"ug05_2.vqa", "", int32_t(0x811DC364), int32_t(0x00000000)},
    {"ug05_3.vqa", "", int32_t(0x811DC564), int32_t(0x00000000)},
    {"ug06-min.set", "", int32_t(0xC9990ADD), int32_t(0x00000000)},
    {"ug06.vqa", "", int32_t(0xADB1E4D8), int32_t(0x00000000)},
    {"ug06_0.vqa", "", int32_t(0x851DBF64), int32_t(0x00000000)},
    {"ug06_1.vqa", "", int32_t(0x851DC164), int32_t(0x00000000)},
    {"ug06_2.vqa", "", int32_t(0x851DC364), int32_t(0x00000000)},
    {"ug06_3.vqa", "", int32_t(0x851DC564), int32_t(0x00000000)},
    {"ug07-min.set", "", int32_t(0xCD990ADD), int32_t(0x00000000)},
    {"ug07.vqa", "", int32_t(0xAFB1E4D8), int32_t(0x00000000)},
    {"ug07_0.vqa", "", int32_t(0x891DBF64), int32_t(0x00000000)},
    {"ug07_1.vqa", "", int32_t(0x891DC164), int32_t(0x00000000)},
    {"ug07_2.vqa", "", int32_t(0x891DC364), int32_t(0x00000000)},
    {"ug07_3.vqa", "", int32_t(0x891DC564), int32_t(0x00000000)},
    {"ug08-min.set", "", int32_t(0xD1990ADD), int32_t(0x00000000)},
    {"ug08.vqa", "", int32_t(0xB1B1E4D8), int32_t(0x00000000)},
    {"ug08_0.vqa", "", int32_t(0x8D1DBF64), int32_t(0x00000000)},
    {"ug08_1.vqa", "", int32_t(0x8D1DC164), int32_t(0x00000000)},
    {"ug08_2.vqa", "", int32_t(0x8D1DC364), int32_t(0x00000000)},
    {"ug08_3.vqa", "", int32_t(0x8D1DC564), int32_t(0x00000000)},
    {"ug09-min.set", "", int32_t(0xD5990ADD), int32_t(0x00000000)},
    {"ug09.vqa", "", int32_t(0xB3B1E4D8), int32_t(0x00000000)},
    {"ug09_0.vqa", "", int32_t(0x911DBF64), int32_t(0x00000000)},
    {"ug09_1.vqa", "", int32_t(0x911DC164), int32_t(0x00000000)},
    {"ug09_2.vqa", "", int32_t(0x911DC364), int32_t(0x00000000)},
    {"ug09_3.vqa", "", int32_t(0x911DC564), int32_t(0x00000000)},
    {"ug10-min.set", "", int32_t(0xB19D0ADD), int32_t(0x00000000)},
    {"ug10.vqa", "", int32_t(0xA1B3E4D8), int32_t(0x00000000)},
    {"ug10_0.vqa", "", int32_t(0x6D21BF64), int32_t(0x00000000)},
    {"ug10_1.vqa", "", int32_t(0x6D21C164), int32_t(0x00000000)},
    {"ug10_2.vqa", "", int32_t(0x6D21C364), int32_t(0x00000000)},
    {"ug10_3.vqa", "", int32_t(0x6D21C564), int32_t(0x00000000)},
    {"ug12-min.set", "", int32_t(0xB99D0ADD), int32_t(0x00000000)},
    {"ug12.vqa", "", int32_t(0xA5B3E4D8), int32_t(0x00000000)},
    {"ug12_0.vqa", "", int32_t(0x7521BF64), int32_t(0x00000000)},
    {"ug12_1.vqa", "", int32_t(0x7521C164), int32_t(0x00000000)},
    {"ug12_2.vqa", "", int32_t(0x7521C364), int32_t(0x00000000)},
    {"ug12_3.vqa", "", int32_t(0x7521C564), int32_t(0x00000000)},
    {"ug13-min.set", "", int32_t(0xBD9D0ADD), int32_t(0x00000000)},
    {"ug13.vqa", "", int32_t(0xA7B3E4D8), int32_t(0x00000000)},
    {"ug13_0.vqa", "", int32_t(0x7921BF64), int32_t(0x00000000)},
    {"ug13_1.vqa", "", int32_t(0x7921C164), int32_t(0x00000000)},
    {"ug13_2.vqa", "", int32_t(0x7921C364), int32_t(0x00000000)},
    {"ug13_3.vqa", "", int32_t(0x7921C564), int32_t(0x00000000)},
    {"ug14-min.set", "", int32_t(0xC19D0ADD), int32_t(0x00000000)},
    {"ug14.vqa", "", int32_t(0xA9B3E4D8), int32_t(0x00000000)},
    {"ug14_0.vqa", "", int32_t(0x7D21BF64), int32_t(0x00000000)},
    {"ug14_1.vqa", "", int32_t(0x7D21C164), int32_t(0x00000000)},
    {"ug14_2.vqa", "", int32_t(0x7D21C364), int32_t(0x00000000)},
    {"ug14_3.vqa", "", int32_t(0x7D21C564), int32_t(0x00000000)},
    {"ug14over.vqa", "", int32_t(0xB6A12021), int32_t(0x00000000)},
    {"ug15-min.set", "", int32_t(0xC59D0ADD), int32_t(0x00000000)},
    {"ug15.vqa", "", int32_t(0xABB3E4D8), int32_t(0x00000000)},
    {"ug15_0.vqa", "", int32_t(0x8121BF64), int32_t(0x00000000)},
    {"ug15_1.vqa", "", int32_t(0x8121C164), int32_t(0x00000000)},
    {"ug15_2.vqa", "", int32_t(0x8121C364), int32_t(0x00000000)},
    {"ug15_3.vqa", "", int32_t(0x8121C564), int32_t(0x00000000)},
    {"ug15over.vqa", "", int32_t(0xBAA12021), int32_t(0x00000000)},
    {"ug16-min.set", "", int32_t(0xC99D0ADD), int32_t(0x00000000)},
    {"ug16.vqa", "", int32_t(0xADB3E4D8), int32_t(0x00000000)},
    {"ug16_0.vqa", "", int32_t(0x8521BF64), int32_t(0x00000000)},
    {"ug16_1.vqa", "", int32_t(0x8521C164), int32_t(0x00000000)},
    {"ug16_2.vqa", "", int32_t(0x8521C364), int32_t(0x00000000)},
    {"ug16_3.vqa", "", int32_t(0x8521C564), int32_t(0x00000000)},
    {"ug17-min.set", "", int32_t(0xCD9D0ADD), int32_t(0x00000000)},
    {"ug17.vqa", "", int32_t(0xAFB3E4D8), int32_t(0x00000000)},
    {"ug17_0.vqa", "", int32_t(0x8921BF64), int32_t(0x00000000)},
    {"ug17_1.vqa", "", int32_t(0x8921C164), int32_t(0x00000000)},
    {"ug17_2.vqa", "", int32_t(0x8921C364), int32_t(0x00000000)},
    {"ug17_3.vqa", "", int32_t(0x8921C564), int32_t(0x00000000)},
    {"ug17over.vqa", "", int32_t(0xC2A12021), int32_t(0x00000000)},
    {"ug18-min.set", "", int32_t(0xD19D0ADD), int32_t(0x00000000)},
    {"ug18.vqa", "", int32_t(0xB1B3E4D8), int32_t(0x00000000)},
    {"ug18_0.vqa", "", int32_t(0x8D21BF64), int32_t(0x00000000)},
    {"ug18_1.vqa", "", int32_t(0x8D21C164), int32_t(0x00000000)},
    {"ug18_2.vqa", "", int32_t(0x8D21C364), int32_t(0x00000000)},
    {"ug18_3.vqa", "", int32_t(0x8D21C564), int32_t(0x00000000)},
    {"ug18over.vqa", "", int32_t(0xC6A12021), int32_t(0x00000000)},
    {"ug18ovr2.vqa", "", int32_t(0x86BB2021), int32_t(0x00000000)},
    {"ug19-min.set", "", int32_t(0xD59D0ADD), int32_t(0x00000000)},
    {"ug19.vqa", "", int32_t(0xB3B3E4D8), int32_t(0x00000000)},
    {"ug19_0.vqa", "", int32_t(0x9121BF64), int32_t(0x00000000)},
    {"ug19_1.vqa", "", int32_t(0x9121C164), int32_t(0x00000000)},
    {"ug19_2.vqa", "", int32_t(0x9121C364), int32_t(0x00000000)},
    {"ug19_3.vqa", "", int32_t(0x9121C564), int32_t(0x00000000)},
    {"ug19ovr1.vqa", "", int32_t(0x88BB2021), int32_t(0x00000000)},
    {"ugbed1.aud", "", int32_t(0x9765C432), int32_t(0x00000000)},
    {"ugbed2.aud", "", int32_t(0x9765C632), int32_t(0x00000000)},
    {"uglever1.aud", "", int32_t(0xBC2AE92F), int32_t(0x00000000)},
    {"ugotit.r01", "soviet #2 very well", int32_t(0xF599F717), int32_t(0x00000000)},
    {"ugotit.r03", "soviet #4 very well", int32_t(0xF599F917), int32_t(0x00000000)},
    {"ugotit.v01", "c&c #2 you got it", int32_t(0xFD99F717), int32_t(0x00000000)},
    {"ugotit.v03", "c&c #2 you got it", int32_t(0xFD99F917), int32_t(0x00000000)},
    {"ui.ini", "", int32_t(0x00000000), int32_t(0x66E0DB4B)},
    {"uibkgd.pal", "", int32_t(0x00000000), int32_t(0x4BECEF35)},
    {"uibkgdy.pal", "", int32_t(0x00000000), int32_t(0x0D7C6D7C)},
    {"uimd.ini", "", int32_t(0x00000000), int32_t(0xE99E00A7)},
    {"umagicon.shp", "icon: umagon", int32_t(0x00000000), int32_t(0x2E7A8965)},
    {"umagon.shp", "unit: umagon", int32_t(0x00000000), int32_t(0xD7EB47B1)},
    {"un_flag.vqa", "", int32_t(0x764D0D43), int32_t(0x00000000)},
    {"un_flag.vqp", "", int32_t(0x765C0D43), int32_t(0x00000000)},
    {"un_red.vqa", "", int32_t(0xF5DA0330), int32_t(0x00000000)},
    {"un_red.vqp", "", int32_t(0xF5DA1230), int32_t(0x00000000)},
    {"uncloakd.shp", "", int32_t(0x09EC0F21), int32_t(0x00000000)},
    {"under3.aud", "under3", int32_t(0x976DE44E), int32_t(0x00000000)},
    {"underbed.aud", "", int32_t(0xE1F0FF27), int32_t(0x00000000)},
    {"unexp.shp", "", int32_t(0xF1BB9645), int32_t(0x00000000)},
    {"unit1.v00", "c&c #1 unit reporting", int32_t(0xB1D195E7), int32_t(0x00000000)},
    {"unit1.v02", "c&c #3 unit reporting", int32_t(0xB1D195E9), int32_t(0x00000000)},
    {"unitdes.pal", "", int32_t(0x00000000), int32_t(0x26BD2199)},
    {"unitful1.aud", "unit full", int32_t(0xF813250F), int32_t(0x00000000)},
    {"unitlost.aud", "unit lost", int32_t(0x3E21191B), int32_t(0x00000000)},
    {"unitlst1.aud", "unit lost", int32_t(0xF823211B), int32_t(0x00000000)},
    {"unitlun.pal", "", int32_t(0x00000000), int32_t(0x2DCEB7A7)},
    {"unitrdy1.aud", "unit ready", int32_t(0xF82D0327), int32_t(0x00000000)},
    {"unitredy.aud", "unit ready", int32_t(0x48030526), int32_t(0x00000000)},
    {"unitrep1.aud", "unit repaired", int32_t(0xF81B0527), int32_t(0x00000000)},
    {"unitsld1.aud", "unit sold", int32_t(0xF8031329), int32_t(0x00000000)},
    {"unitsno.pal", "snow unit palette", int32_t(0x00000000), int32_t(0x26D08FB1)},
    {"unitspd1.aud", "unit speed upgraded", int32_t(0xF8031B29), int32_t(0x00000000)},
    {"unittem.pal", "temperate unit palette", int32_t(0x00000000), int32_t(0x63DA7359)},
    {"unitubn.pal", "", int32_t(0x00000000), int32_t(0xEC433FE7)},
    {"uniturb.pal", "", int32_t(0x00000000), int32_t(0xFC5F6352)},
    {"unlok1.aud", "", int32_t(0xBF8DE040), int32_t(0x00000000)},
    {"unroll1.aud", "", int32_t(0x99F0272E), int32_t(0x00000000)},
    {"unstpble.vqa", "-", int32_t(0x00000000), int32_t(0xC232E90F)},
    {"uparrow.pcx", "-", int32_t(0x00000000), int32_t(0x12EFD1E5)},
    {"uparrowp.pcx", "-", int32_t(0x00000000), int32_t(0x9402062B)},
    {"uparrowr.pcx", "-", int32_t(0x00000000), int32_t(0xEEC2554B)},
    {"update.inf", "inf: list for update.mix", int32_t(0x976E124B), int32_t(0x00000000)},
    {"updtop.cps", "pict:", int32_t(0xD76E3543), int32_t(0x00000000)},
    {"uptarg3.aud", "", int32_t(0x61FC253A), int32_t(0x00000000)},
    {"uradrfrm.shp", "misc: soviet radarmap background", int32_t(0xFBF22927), int32_t(0x00000000)},
    {"urb.mix", "", int32_t(0x00000000), int32_t(0x0D91501E)},
    {"urban.ini", "", int32_t(0x00000000), int32_t(0x091D1025)},
    {"urban.mix", "", int32_t(0x00000000), int32_t(0xF160BD3B)},
    {"urban.pal", "", int32_t(0x00000000), int32_t(0x9557245F)},
    {"urbanmd.ini", "", int32_t(0x00000000), int32_t(0x7B2040BD)},
    {"urbann.mix", "", int32_t(0x00000000), int32_t(0xA01A9A03)},
    {"urbann.pal", "", int32_t(0x00000000), int32_t(0xE82A6241)},
    {"urbannmd.ini", "", int32_t(0x00000000), int32_t(0xC4B38372)},
    {"usai.pcx", "", int32_t(0x00000000), int32_t(0x698B01AD)},
    {"usai.shp", "", int32_t(0x00000000), int32_t(0x86E2EE0D)},
    {"usertype.aud", "", int32_t(0x180B412B), int32_t(0x661268B6)},
    {"ussrradr.shp", "misc: soviet radar screen", int32_t(0x3E1E2327), int32_t(0x00000000)},
    {"utnk.hva", "-", int32_t(0x00000000), int32_t(0x6651628A)},
    {"utnk.vxl", "another version of the devils tongue", int32_t(0x00000000), int32_t(0x90DBBDC3)},
    {"v01.sno", "bldg: church", int32_t(0x5CB1AEFF), int32_t(0x00000000)},
    {"v01.tem", "church", int32_t(0x5CAFA600), int32_t(0x00000000)},
    {"v01.win", "church", int32_t(0x5CB0AA03), int32_t(0x00000000)},
    {"v0100324e.aud", "", int32_t(0xFCD4AC40), int32_t(0x00000000)},
    {"v02.sno", "bldg: civilian building #1", int32_t(0x5CB3AEFF), int32_t(0x00000000)},
    {"v02.tem", "civilian building #1", int32_t(0x5CB1A600), int32_t(0x00000000)},
    {"v02.win", "civilian building #1", int32_t(0x5CB2AA03), int32_t(0x00000000)},
    {"v03.sno", "bldg: civilian building #2", int32_t(0x5CB5AEFF), int32_t(0x00000000)},
    {"v03.tem", "civilian building #2", int32_t(0x5CB3A600), int32_t(0x00000000)},
    {"v03.win", "civilian building #2", int32_t(0x5CB4AA03), int32_t(0x00000000)},
    {"v04.sno", "bldg: civilian building #3", int32_t(0x5CB7AEFF), int32_t(0x00000000)},
    {"v04.tem", "civilian building #3", int32_t(0x5CB5A600), int32_t(0x00000000)},
    {"v04.win", "civilian building #3", int32_t(0x5CB6AA03), int32_t(0x00000000)},
    {"v05.sno", "bldg: civilian building #4", int32_t(0x5CB9AEFF), int32_t(0x00000000)},
    {"v05.tem", "civilian building #4", int32_t(0x5CB7A600), int32_t(0x00000000)},
    {"v05.win", "civilian building #4", int32_t(0x5CB8AA03), int32_t(0x00000000)},
    {"v06.sno", "bldg: civilian building #5", int32_t(0x5CBBAEFF), int32_t(0x00000000)},
    {"v06.tem", "civilian building #5", int32_t(0x5CB9A600), int32_t(0x00000000)},
    {"v06.win", "civilian building #5", int32_t(0x5CBAAA03), int32_t(0x00000000)},
    {"v07.sno", "bldg: civilian building #6", int32_t(0x5CBDAEFF), int32_t(0x00000000)},
    {"v07.tem", "civilian building #6", int32_t(0x5CBBA600), int32_t(0x00000000)},
    {"v07.win", "civilian building #6", int32_t(0x5CBCAA03), int32_t(0x00000000)},
    {"v08.sno", "bldg: civilian building #7", int32_t(0x5CBFAEFF), int32_t(0x00000000)},
    {"v08.tem", "civilian building #7", int32_t(0x5CBDA600), int32_t(0x00000000)},
    {"v08.win", "civilian building #7", int32_t(0x5CBEAA03), int32_t(0x00000000)},
    {"v09.sno", "bldg: civilian building #8", int32_t(0x5CC1AEFF), int32_t(0x00000000)},
    {"v09.tem", "civilian building #8", int32_t(0x5CBFA600), int32_t(0x00000000)},
    {"v09.win", "civilian building #8", int32_t(0x5CC0AA03), int32_t(0x00000000)},
    {"v10.sno", "bldg: civilian building #9", int32_t(0x5CAFB0FF), int32_t(0x00000000)},
    {"v10.tem", "civilian building #9", int32_t(0x5CADA800), int32_t(0x00000000)},
    {"v10.win", "civilian building #9", int32_t(0x5CAEAC03), int32_t(0x00000000)},
    {"v11.sno", "bldg: civilian building #10", int32_t(0x5CB1B0FF), int32_t(0x00000000)},
    {"v11.tem", "civilian building #10", int32_t(0x5CAFA800), int32_t(0x00000000)},
    {"v11.win", "civilian building #10", int32_t(0x5CB0AC03), int32_t(0x00000000)},
    {"v12.sno", "bldg: civilian building #11", int32_t(0x5CB3B0FF), int32_t(0x00000000)},
    {"v12.tem", "civilian building #11", int32_t(0x5CB1A800), int32_t(0x00000000)},
    {"v12.win", "civilian building #11", int32_t(0x5CB2AC03), int32_t(0x00000000)},
    {"v13.sno", "bldg: civilian building #12", int32_t(0x5CB5B0FF), int32_t(0x00000000)},
    {"v13.tem", "civilian building #12", int32_t(0x5CB3A800), int32_t(0x00000000)},
    {"v13.win", "civilian building #12", int32_t(0x5CB4AC03), int32_t(0x00000000)},
    {"v14.sno", "misc: field", int32_t(0x5CB7B0FF), int32_t(0x00000000)},
    {"v14.tem", "field", int32_t(0x5CB5A800), int32_t(0x00000000)},
    {"v14.win", "field", int32_t(0x5CB6AC03), int32_t(0x00000000)},
    {"v15.sno", "misc: field", int32_t(0x5CB9B0FF), int32_t(0x00000000)},
    {"v15.tem", "field", int32_t(0x5CB7A800), int32_t(0x00000000)},
    {"v15.win", "field", int32_t(0x5CB8AC03), int32_t(0x00000000)},
    {"v16.shp", "-", int32_t(0x00000000), int32_t(0xD02E8EC1)},
    {"v16.sno", "misc: field", int32_t(0x5CBBB0FF), int32_t(0x00000000)},
    {"v16.tem", "field", int32_t(0x5CB9A800), int32_t(0x00000000)},
    {"v16.win", "field", int32_t(0x5CBAAC03), int32_t(0x00000000)},
    {"v17.shp", "-", int32_t(0x00000000), int32_t(0x1B725D64)},
    {"v17.sno", "misc: field", int32_t(0x5CBDB0FF), int32_t(0x00000000)},
    {"v17.tem", "field", int32_t(0x5CBBA800), int32_t(0x00000000)},
    {"v17.win", "field", int32_t(0x5CBCAC03), int32_t(0x00000000)},
    {"v18.shp", "-", int32_t(0x00000000), int32_t(0xEA24EFB1)},
    {"v18.sno", "misc: field", int32_t(0x5CBFB0FF), int32_t(0x00000000)},
    {"v18.tem", "field", int32_t(0x5CBDA800), int32_t(0x00000000)},
    {"v18.win", "field", int32_t(0x5CBEAC03), int32_t(0x00000000)},
    {"v19.shp", "oil pump", int32_t(0x5CC2AAFF), int32_t(0x00000000)},
    {"v2.shp", "misc: v2 rocket", int32_t(0xA65CB4F4), int32_t(0x00000000)},
    {"v20.des", "civilian building #13", int32_t(0x5CB3A9F0), int32_t(0x00000000)},
    {"v21.des", "civilian building #14", int32_t(0x5CB5A9F0), int32_t(0x00000000)},
    {"v22.des", "civilian building #15", int32_t(0x5CB7A9F0), int32_t(0x00000000)},
    {"v23.des", "civilian building #16", int32_t(0x5CB9A9F0), int32_t(0x00000000)},
    {"v24.des", "civilian building #17", int32_t(0x5CBBA9F0), int32_t(0x00000000)},
    {"v25.des", "civilian building #18", int32_t(0x5CBDA9F0), int32_t(0x00000000)},
    {"v26.des", "civilian building #19", int32_t(0x5CBFA9F0), int32_t(0x00000000)},
    {"v27.des", "civilian building #20", int32_t(0x5CC1A9F0), int32_t(0x00000000)},
    {"v28.des", "civilian building #21", int32_t(0x5CC3A9F0), int32_t(0x00000000)},
    {"v29.des", "civilian building #22", int32_t(0x5CC5A9F0), int32_t(0x00000000)},
    {"v2rl.shp", "unit: v2 rocket launcher", int32_t(0xE8ECB7DA), int32_t(0x00000000)},
    {"v2rlicon.shp", "icon: v2 rocket launcher", int32_t(0x1E2FA319), int32_t(0x00000000)},
    {"v2rocket.vqa", "v2 rocket launcher launching", int32_t(0x2724B60D), int32_t(0x00000000)},
    {"v2rocket.vqp", "vqp: v2 rocket launcher launching", int32_t(0x3624B60D), int32_t(0x00000000)},
    {"v3.hva", "", int32_t(0x00000000), int32_t(0x15C5CCE3)},
    {"v3.vxl", "", int32_t(0x00000000), int32_t(0xC5AA2C67)},
    {"v30.des", "civilian building #23", int32_t(0x5CB3ABF0), int32_t(0x00000000)},
    {"v31.des", "civilian building #24", int32_t(0x5CB5ABF0), int32_t(0x00000000)},
    {"v32.des", "civilian building #25", int32_t(0x5CB7ABF0), int32_t(0x00000000)},
    {"v33.des", "civilian building #26", int32_t(0x5CB9ABF0), int32_t(0x00000000)},
    {"v34.des", "civilian building #27", int32_t(0x5CBBABF0), int32_t(0x00000000)},
    {"v35.des", "civilian building #28", int32_t(0x5CBDABF0), int32_t(0x00000000)},
    {"v36.des", "civilian building #29", int32_t(0x5CBFABF0), int32_t(0x00000000)},
    {"v37.des", "civilian building #30", int32_t(0x5CC1ABF0), int32_t(0x00000000)},
    {"v3final.bmp", "", int32_t(0x00000000), int32_t(0x4A63A18E)},
    {"v3icon.shp", "", int32_t(0x00000000), int32_t(0x421AFD4C)},
    {"v3rocket.hva", "", int32_t(0x00000000), int32_t(0x059717C5)},
    {"v3rocket.vxl", "", int32_t(0x00000000), int32_t(0xF31DC88C)},
    {"v3takoff.shp", "", int32_t(0x00000000), int32_t(0xD5D76646)},
    {"v3trail.shp", "", int32_t(0x00000000), int32_t(0x430C822D)},
    {"v3uico.shp", "", int32_t(0x00000000), int32_t(0x1B7E084F)},
    {"v3wo.hva", "", int32_t(0x00000000), int32_t(0x7796E291)},
    {"v3wo.vxl", "", int32_t(0x00000000), int32_t(0x811C3DD8)},
    {"valkyrie.aud", "valkyrie", int32_t(0xFC18EB39), int32_t(0x00000000)},
    {"valves1b.aud", "valves", int32_t(0x00000000), int32_t(0x2306D39E)},
    {"vasebrk1.aud", "", int32_t(0xBC38EB0B), int32_t(0x00000000)},
    {"vasebrk2.aud", "", int32_t(0xBE38EB0B), int32_t(0x00000000)},
    {"vasesmsh.aud", "", int32_t(0xEA48E12D), int32_t(0x00000000)},
    {"vatk1.aud", "", int32_t(0xD7D361FF), int32_t(0x00000000)},
    {"vcr.fnt", "vcr", int32_t(0x5CF8D4F2), int32_t(0x00000000)},
    {"vcut1.aud", "", int32_t(0xFBD769FF), int32_t(0x00000000)},
    {"vdie1.aud", "", int32_t(0xBFA76DFF), int32_t(0x00000000)},
    {"vector1a.aud", "vector", int32_t(0x17C4FB25), int32_t(0x00000000)},
    {"vegawin.vqa", "-", int32_t(0x00000000), int32_t(0x8CA38CB8)},
    {"veh-hit1.shp", "small explosion", int32_t(0x6811FB17), int32_t(0x00000000)},
    {"veh-hit2.shp", "explosion", int32_t(0x6A11FB17), int32_t(0x00000000)},
    {"veh-hit3.shp", "very small explosion", int32_t(0x6C11FB17), int32_t(0x00000000)},
    {"vehic1.r00", "soviet #1 veicle reporting", int32_t(0xC97DA80F), int32_t(0x00000000)},
    {"vehic1.r02", "soviet #3 comrad?!", int32_t(0xC97DAA0F), int32_t(0x00000000)},
    {"vehic1.v00", "c&c #1 veicle reporting", int32_t(0xD17DA80F), int32_t(0x00000000)},
    {"vehic1.v02", "c&c #3 veicle reporting", int32_t(0xD17DAA0F), int32_t(0x00000000)},
    {"veinatac.sno", "-", int32_t(0x00000000), int32_t(0x3407FA38)},
    {"veinatac.tem", "-", int32_t(0x00000000), int32_t(0x3CB2545A)},
    {"veinhole.des", "", int32_t(0x00000000), int32_t(0x93D3FF28)},
    {"veinhole.lun", "", int32_t(0x00000000), int32_t(0xB404D018)},
    {"veinhole.sno", "-", int32_t(0x00000000), int32_t(0x7D4FCF59)},
    {"veinhole.tem", "-", int32_t(0x00000000), int32_t(0x75FA613B)},
    {"veinhole.ubn", "", int32_t(0x00000000), int32_t(0xA270CC71)},
    {"veinhole.urb", "", int32_t(0x00000000), int32_t(0xE104920B)},
    {"veins.des", "", int32_t(0x00000000), int32_t(0x800C95D4)},
    {"veins.lun", "", int32_t(0x00000000), int32_t(0x32A60FBC)},
    {"veins.sno", "-", int32_t(0x00000000), int32_t(0x01B67FD3)},
    {"veins.tem", "-", int32_t(0x00000000), int32_t(0x1D52B55F)},
    {"veins.ubn", "", int32_t(0x00000000), int32_t(0xC4BF177D)},
    {"veins.urb", "", int32_t(0x00000000), int32_t(0x4B8A3C60)},
    {"vescam01.flc", "", int32_t(0xB2F9F609), int32_t(0x00000000)},
    {"vescam02.flc", "", int32_t(0xB4F9F609), int32_t(0x00000000)},
    {"veteran.shp", "crate: veteran upgrade", int32_t(0x00000000), int32_t(0x1129EC81)},
    {"vhurt1.aud", "", int32_t(0xCBB1C856), int32_t(0x00000000)},
    {"vial000.pcx", "", int32_t(0x8DBDC909), int32_t(0x00000000)},
    {"vial001.pcx", "", int32_t(0x8DBFC909), int32_t(0x00000000)},
    {"vicbatl1.aud", "", int32_t(0xAFFB0F09), int32_t(0x00000000)},
    {"vice.shp", "visceroid", int32_t(0xDACEE5DA), int32_t(0x00000000)},
    {"viceicnh.shp", "", int32_t(0xF5F1FF19), int32_t(0x00000000)},
    {"viceicnh.tem", "", int32_t(0xF2EF0019), int32_t(0x00000000)},
    {"vicer1.aud", "two viceroids combine", int32_t(0x00000000), int32_t(0x074BB695)},
    {"vidfone1.aud", "", int32_t(0xBFF10325), int32_t(0x00000000)},
    {"virus.shp", "", int32_t(0x00000000), int32_t(0x3D1FFAA5)},
    {"virusd.shp", "", int32_t(0x00000000), int32_t(0xD167CDF5)},
    {"visc_lrg.shp", "-", int32_t(0x00000000), int32_t(0x694E13BF)},
    {"visc_sml.shp", "-", int32_t(0x00000000), int32_t(0x7D887EC7)},
    {"vislgatk.shp", "adult visroid attack animation", int32_t(0x00000000), int32_t(0x6BD7992C)},
    {"vislrg.shp", "unit: adult visroid", int32_t(0x00000000), int32_t(0xC38448E2)},
    {"visor.vqa", "change of plan", int32_t(0xDFF9823E), int32_t(0x00000000)},
    {"visor.vqp", "change of plan", int32_t(0xDFF9824D), int32_t(0x00000000)},
    {"vissml.shp", "unit: baby visroid", int32_t(0x00000000), int32_t(0x1761B23F)},
    {"vk.dat", "", int32_t(0x885CEAED), int32_t(0x00000000)},
    {"vk.shp", "", int32_t(0xA65CE6F4), int32_t(0x00000000)},
    {"vk.tre", "", int32_t(0xA85CDBFE), int32_t(0x00000000)},
    {"vk.trf", "", int32_t(0xA85CDCFE), int32_t(0x00000000)},
    {"vk.trg", "", int32_t(0xA85CDDFE), int32_t(0x00000000)},
    {"vk.tri", "", int32_t(0xA85CDFFE), int32_t(0x00000000)},
    {"vk.trs", "", int32_t(0xA85CE9FE), int32_t(0x00000000)},
    {"vk.vqa", "", int32_t(0xAC5CD7FD), int32_t(0x00000000)},
    {"vkbeep1.aud", "", int32_t(0x71B02324), int32_t(0x00000000)},
    {"vkbeep2.aud", "", int32_t(0x71B22324), int32_t(0x00000000)},
    {"vkbob.vqa", "", int32_t(0xDFB58A1E), int32_t(0x00000000)},
    {"vkdekt.vqa", "", int32_t(0xC16E1740), int32_t(0x00000000)},
    {"vkkash.vqa", "", int32_t(0xB189FF50), int32_t(0x00000000)},
    {"vklucy.vqa", "", int32_t(0x018E212F), int32_t(0x00000000)},
    {"vkrunc.vqa", "", int32_t(0x01A5F545), int32_t(0x00000000)},
    {"vlad.hva", "", int32_t(0x00000000), int32_t(0xCFE992C4)},
    {"vlad.vxl", "", int32_t(0x00000000), int32_t(0x39634D8D)},
    {"vladimir.shp", "", int32_t(0x00000000), int32_t(0x82915A53)},
    {"vladwo.hva", "", int32_t(0x00000000), int32_t(0x11422575)},
    {"vladwo.vxl", "", int32_t(0x00000000), int32_t(0xC12DC5F1)},
    {"vloitr1.aud", "", int32_t(0x81E42B42), int32_t(0x00000000)},
    {"voic226m.aud", "voices", int32_t(0xEBE6E2EB), int32_t(0x00000000)},
    {"voice.bmp", "", int32_t(0xA7A99A33), int32_t(0x00000000)},
    {"voices.csv", "", int32_t(0x93823A36), int32_t(0x00000000)},
    {"voices.lsv", "", int32_t(0xA5823A36), int32_t(0x00000000)},
    {"voices.vqa", "", int32_t(0xB9822534), int32_t(0x00000000)},
    {"voices_e.vqa", "", int32_t(0xD9353A11), int32_t(0x00000000)},
    {"voices_e.vqt", "", int32_t(0xEC353A11), int32_t(0x00000000)},
    {"voices_h.pcx", "", int32_t(0xF6273411), int32_t(0x00000000)},
    {"voices_h.vqa", "", int32_t(0xDF353A11), int32_t(0x00000000)},
    {"voices_l.pcx", "", int32_t(0xFE273411), int32_t(0x00000000)},
    {"voices_l.vqa", "", int32_t(0xE7353A11), int32_t(0x00000000)},
    {"volcano1.aud", "", int32_t(0xB4251B09), int32_t(0x00000000)},
    {"volcbed1.aud", "", int32_t(0xB40F090B), int32_t(0x00000000)},
    {"volcbed2.aud", "", int32_t(0xB60F090B), int32_t(0x00000000)},
    {"volcrdm1.aud", "", int32_t(0xB421072B), int32_t(0x00000000)},
    {"volcrdm2.aud", "", int32_t(0xB621072B), int32_t(0x00000000)},
    {"volcrdm3.aud", "", int32_t(0xB821072B), int32_t(0x00000000)},
    {"volcrdm4.aud", "", int32_t(0xBA21072B), int32_t(0x00000000)},
    {"volcrdm5.aud", "", int32_t(0xBC21072B), int32_t(0x00000000)},
    {"volcrdm6.aud", "", int32_t(0xBE21072B), int32_t(0x00000000)},
    {"volcrdm7.aud", "", int32_t(0xC021072B), int32_t(0x00000000)},
    {"voxels.vpl", "-", int32_t(0x00000000), int32_t(0xDECF668B)},
    {"vpp1445203e.aud", "", int32_t(0xB0260F23), int32_t(0x00000000)},
    {"vpp1455103e.aud", "", int32_t(0xAC261323), int32_t(0x00000000)},
    {"vppforstwk6.aud", "", int32_t(0xE080B7DE), int32_t(0x00000000)},
    {"vpphrddirt5.aud", "", int32_t(0xC44291E0), int32_t(0x00000000)},
    {"vppicewalk3.aud", "", int32_t(0xAC8A8398), int32_t(0x00000000)},
    {"vr2.aud", "vr2", int32_t(0x5CA8F9ED), int32_t(0x00000000)},
    {"vrusicon.shp", "", int32_t(0x00000000), int32_t(0xBB835977)},
    {"vrusuico.shp", "", int32_t(0x00000000), int32_t(0x7E45CB96)},
    {"vtexplod.shp", "", int32_t(0x00000000), int32_t(0x29C1CE49)},
    {"vtmuzzle.shp", "", int32_t(0x00000000), int32_t(0xE56387C8)},
    {"vulture1.aud", "", int32_t(0xF8113B31), int32_t(0x00000000)},
    {"vulture2.aud", "", int32_t(0xFA113B31), int32_t(0x00000000)},
    {"vvbigfoot1.wav", "", int32_t(0x35AC84B7), int32_t(0x00000000)},
    {"vvp1480003e.aud", "", int32_t(0xA8124F23), int32_t(0x00000000)},
    {"vvphrddirt1.aud", "", int32_t(0xC43AC1E0), int32_t(0x00000000)},
    {"vvstonwlk3.aud", "", int32_t(0x565496D9), int32_t(0x00000000)},
    {"vvv1410003e.aud", "", int32_t(0xA8423323), int32_t(0x00000000)},
    {"vvv1410103e.aud", "", int32_t(0xAC423323), int32_t(0x00000000)},
    {"vvv1410203e.aud", "", int32_t(0xB0423323), int32_t(0x00000000)},
    {"vvv1415103e.aud", "", int32_t(0xAC563323), int32_t(0x00000000)},
    {"vvv1415303e.aud", "", int32_t(0xB4563323), int32_t(0x00000000)},
    {"vvv1415403e.aud", "", int32_t(0xB8563323), int32_t(0x00000000)},
    {"vvv1420103e.aud", "", int32_t(0xAC423723), int32_t(0x00000000)},
    {"vvv1420303e.aud", "", int32_t(0xB4423723), int32_t(0x00000000)},
    {"vvv1425003e.aud", "", int32_t(0xA8563723), int32_t(0x00000000)},
    {"vvv1425303e.aud", "", int32_t(0xB4563723), int32_t(0x00000000)},
    {"vvv1430103e.aud", "", int32_t(0xAC423B23), int32_t(0x00000000)},
    {"vvv1440003e.aud", "", int32_t(0xA8423F23), int32_t(0x00000000)},
    {"vvv1445103e.aud", "", int32_t(0xAC563F23), int32_t(0x00000000)},
    {"vvv1450103e.aud", "", int32_t(0xAC424323), int32_t(0x00000000)},
    {"vvv1450303e.aud", "", int32_t(0xB4424323), int32_t(0x00000000)},
    {"vvv1465103e.aud", "", int32_t(0xAC564723), int32_t(0x00000000)},
    {"vvv1485103e.aud", "", int32_t(0xAC564F23), int32_t(0x00000000)},
    {"vvvforstwk1.aud", "", int32_t(0xE0A6E7DE), int32_t(0x00000000)},
    {"vvvforstwk2.aud", "", int32_t(0xE0A8E7DE), int32_t(0x00000000)},
    {"vvvforstwk3.aud", "", int32_t(0xE0AAE7DE), int32_t(0x00000000)},
    {"vvvgrvlwlk4.aud", "", int32_t(0xF490F7D4), int32_t(0x00000000)},
    {"vvvgrvlwlk7.aud", "", int32_t(0xF496F7D4), int32_t(0x00000000)},
    {"vvvhrddirt2.aud", "", int32_t(0xC46CC1E0), int32_t(0x00000000)},
    {"vvvicewalk2.aud", "", int32_t(0xACB8B398), int32_t(0x00000000)},
    {"vvvicewalk5.aud", "", int32_t(0xACBEB398), int32_t(0x00000000)},
    {"vvvicewalk7.aud", "", int32_t(0xACC2B398), int32_t(0x00000000)},
    {"vvvmlevel1a.wav", "", int32_t(0xDCE46BD2), int32_t(0x00000000)},
    {"vvvmlevel2a.wav", "", int32_t(0xDCE46DD2), int32_t(0x00000000)},
    {"vvvmrblwlk1.aud", "", int32_t(0x248AA7D3), int32_t(0x00000000)},
    {"vvvmrblwlk3.aud", "", int32_t(0x248EA7D3), int32_t(0x00000000)},
    {"vvvmrblwlk5.aud", "", int32_t(0x2492A7D3), int32_t(0x00000000)},
    {"vvvmrblwlk7.aud", "", int32_t(0x2496A7D3), int32_t(0x00000000)},
    {"vvvputbuttn.wav", "", int32_t(0x34AEEE05), int32_t(0x00000000)},
    {"vvvrivloop1.aud", "", int32_t(0x2C8B01B5), int32_t(0x00000000)},
    {"vvvstonwlk2.aud", "", int32_t(0x5494DBDB), int32_t(0x00000000)},
    {"vvvstonwlk5.aud", "", int32_t(0x549ADBDB), int32_t(0x00000000)},
    {"vvvstonwlk6.aud", "", int32_t(0x549CDBDB), int32_t(0x00000000)},
    {"vvvtwig4.aud", "", int32_t(0xFE3D2D35), int32_t(0x00000000)},
    {"vvvvftwood2.aud", "", int32_t(0x4CB8E1A9), int32_t(0x00000000)},
    {"vvvvftwood3.aud", "", int32_t(0x4CBAE1A9), int32_t(0x00000000)},
    {"vvvvftwood6.aud", "", int32_t(0x4CC0E1A9), int32_t(0x00000000)},
    {"vvvvgloop10.aud", "", int32_t(0x4C949BAF), int32_t(0x00000000)},
    {"vvvvgloop11.aud", "", int32_t(0x4C969BAF), int32_t(0x00000000)},
    {"vvvvhuman11.aud", "", int32_t(0x148EBFAF), int32_t(0x00000000)},
    {"vvvvjbird11.aud", "", int32_t(0x587E73A3), int32_t(0x00000000)},
    {"vvvvpebble2.aud", "", int32_t(0x1864A7CB), int32_t(0x00000000)},
    {"vvvvvgloop3.aud", "", int32_t(0x4C8EC5E9), int32_t(0x00000000)},
    {"vvvvvgloop4.aud", "", int32_t(0x4C90C5E9), int32_t(0x00000000)},
    {"vvvvvgloop6.aud", "", int32_t(0x4C94C5E9), int32_t(0x00000000)},
    {"vvvvvgloop7.aud", "", int32_t(0x4C96C5E9), int32_t(0x00000000)},
    {"vvvvvgloop9.aud", "", int32_t(0x4C9AC5E9), int32_t(0x00000000)},
    {"vvvvvhuman1.aud", "", int32_t(0x44AEC5CD), int32_t(0x00000000)},
    {"vvvvvhuman3.aud", "", int32_t(0x44B2C5CD), int32_t(0x00000000)},
    {"vvvvvhuman4.aud", "", int32_t(0x44B4C5CD), int32_t(0x00000000)},
    {"vvvvvhuman5.aud", "", int32_t(0x44B6C5CD), int32_t(0x00000000)},
    {"vvvvvhuman6.aud", "", int32_t(0x44B8C5CD), int32_t(0x00000000)},
    {"vvvvvhuman8.aud", "", int32_t(0x44BCC5CD), int32_t(0x00000000)},
    {"vvvvvhuman9.aud", "", int32_t(0x44BEC5CD), int32_t(0x00000000)},
    {"vvvvvjbird2.aud", "", int32_t(0x3464B9EF), int32_t(0x00000000)},
    {"vvvvvjbird4.aud", "", int32_t(0x3468B9EF), int32_t(0x00000000)},
    {"vvvvvjbird5.aud", "", int32_t(0x346AB9EF), int32_t(0x00000000)},
    {"vvvvvjbird6.aud", "", int32_t(0x346CB9EF), int32_t(0x00000000)},
    {"vvvvvjbird8.aud", "", int32_t(0x3470B9EF), int32_t(0x00000000)},
    {"vvvvvppain2.aud", "", int32_t(0x149CE5DD), int32_t(0x00000000)},
    {"vvvvvqsand2.aud", "", int32_t(0x14A8D5E7), int32_t(0x00000000)},
    {"vvvvvqsand5.aud", "", int32_t(0x14AED5E7), int32_t(0x00000000)},
    {"vvvvvqsand6.aud", "", int32_t(0x14B0D5E7), int32_t(0x00000000)},
    {"vvvvvqsand8.aud", "", int32_t(0x14B4D5E7), int32_t(0x00000000)},
    {"vvvvvtorch1.wav", "", int32_t(0x58A8D5E7), int32_t(0x00000000)},
    {"vvvvvvmenu6.wav", "", int32_t(0x24AAF7FD), int32_t(0x00000000)},
    {"vvvvvvmnky2.aud", "", int32_t(0x489113E1), int32_t(0x00000000)},
    {"vvvvvvmnky3.aud", "", int32_t(0x489313E1), int32_t(0x00000000)},
    {"vvvvvvtwig2.aud", "", int32_t(0x6CACEFDB), int32_t(0x00000000)},
    {"vvvvvvtwig3.aud", "", int32_t(0x6CAEEFDB), int32_t(0x00000000)},
    {"vvvvvvwall1.aud", "", int32_t(0x14B6F9E3), int32_t(0x00000000)},
    {"vvvvvwoosh2.aud", "", int32_t(0x4C98F5F1), int32_t(0x00000000)},
    {"vvvwetstep2.aud", "", int32_t(0x68A8F98F), int32_t(0x00000000)},
    {"vvvwetstep3.aud", "", int32_t(0x68AAF98F), int32_t(0x00000000)},
    {"vvvwetstep6.aud", "", int32_t(0x68B0F98F), int32_t(0x00000000)},
    {"vvvwoodwlk1.aud", "", int32_t(0x746ADBC5), int32_t(0x00000000)},
    {"vvvwoodwlk3.aud", "", int32_t(0x746EDBC5), int32_t(0x00000000)},
    {"vvvwoodwlk5.aud", "", int32_t(0x7472DBC5), int32_t(0x00000000)},
    {"vvvwoodwlk7.aud", "", int32_t(0x7476DBC5), int32_t(0x00000000)},
    {"w-a-01.des", "", int32_t(0x00000000), int32_t(0x91443679)},
    {"w-a-01.sno", "-", int32_t(0x00000000), int32_t(0x166B7976)},
    {"w-a-01.tem", "-", int32_t(0x00000000), int32_t(0xE71C2F81)},
    {"w-a-01.ubn", "", int32_t(0x00000000), int32_t(0xDB891572)},
    {"w-a-01.urb", "", int32_t(0x00000000), int32_t(0x9F3DABED)},
    {"w-a-02.des", "", int32_t(0x00000000), int32_t(0xA0AC2CE4)},
    {"w-a-02.sno", "-", int32_t(0x00000000), int32_t(0x278363EB)},
    {"w-a-02.tem", "-", int32_t(0x00000000), int32_t(0xD6F4351C)},
    {"w-a-02.ubn", "", int32_t(0x00000000), int32_t(0xEA610FEF)},
    {"w-a-02.urb", "", int32_t(0x00000000), int32_t(0xAED5B170)},
    {"w-a-03.des", "", int32_t(0x00000000), int32_t(0x06DB2750)},
    {"w-a-03.sno", "-", int32_t(0x00000000), int32_t(0x81F4685F)},
    {"w-a-03.tem", "-", int32_t(0x00000000), int32_t(0x70833EA8)},
    {"w-a-03.ubn", "", int32_t(0x00000000), int32_t(0x4C16045B)},
    {"w-a-03.urb", "", int32_t(0x00000000), int32_t(0x08A2BAC4)},
    {"w-a-04.des", "", int32_t(0x00000000), int32_t(0xC37C19DE)},
    {"w-a-04.sno", "-", int32_t(0x00000000), int32_t(0x445356D1)},
    {"w-a-04.tem", "-", int32_t(0x00000000), int32_t(0xB5240026)},
    {"w-a-04.ubn", "", int32_t(0x00000000), int32_t(0x89B13AD5)},
    {"w-a-04.urb", "", int32_t(0x00000000), int32_t(0xCD05844A)},
    {"w-b-01.des", "", int32_t(0x00000000), int32_t(0x7A738D7A)},
    {"w-b-01.sno", "-", int32_t(0x00000000), int32_t(0xFD5CC275)},
    {"w-b-01.tem", "-", int32_t(0x00000000), int32_t(0x0C2B9482)},
    {"w-b-01.ubn", "", int32_t(0x00000000), int32_t(0x30BEAE71)},
    {"w-b-01.urb", "", int32_t(0x00000000), int32_t(0x740A10EE)},
    {"w-b-02.des", "", int32_t(0x00000000), int32_t(0x4B9B97E7)},
    {"w-b-02.sno", "-", int32_t(0x00000000), int32_t(0xCCB4D8E8)},
    {"w-b-02.tem", "-", int32_t(0x00000000), int32_t(0x3DC38E1F)},
    {"w-b-02.ubn", "", int32_t(0x00000000), int32_t(0x0156B4EC)},
    {"w-b-02.urb", "", int32_t(0x00000000), int32_t(0x45E20A73)},
    {"w-b-03.des", "", int32_t(0x00000000), int32_t(0xEDEC9C53)},
    {"w-b-03.sno", "-", int32_t(0x00000000), int32_t(0x6AC3D35C)},
    {"w-b-03.tem", "-", int32_t(0x00000000), int32_t(0x9BB485AB)},
    {"w-b-03.ubn", "", int32_t(0x00000000), int32_t(0xA721BF58)},
    {"w-b-03.urb", "", int32_t(0x00000000), int32_t(0xE39501C7)},
    {"w-b-04.des", "", int32_t(0x00000000), int32_t(0x284BA2DD)},
    {"w-b-04.sno", "-", int32_t(0x00000000), int32_t(0xAF64EDD2)},
    {"w-b-04.tem", "-", int32_t(0x00000000), int32_t(0x5E13BB25)},
    {"w-b-04.ubn", "", int32_t(0x00000000), int32_t(0x628681D6)},
    {"w-b-04.urb", "", int32_t(0x00000000), int32_t(0x26323F49)},
    {"w-c-01.des", "", int32_t(0x00000000), int32_t(0x95B1E644)},
    {"w-c-01.sno", "-", int32_t(0x00000000), int32_t(0x129EA94B)},
    {"w-c-01.tem", "-", int32_t(0x00000000), int32_t(0xE3E9FFBC)},
    {"w-c-01.ubn", "", int32_t(0x00000000), int32_t(0xDF7CC54F)},
    {"w-c-01.urb", "", int32_t(0x00000000), int32_t(0x9BC87BD0)},
    {"w-c-02.des", "", int32_t(0x00000000), int32_t(0xA459FCD9)},
    {"w-c-02.sno", "-", int32_t(0x00000000), int32_t(0x2376B3D6)},
    {"w-c-02.tem", "-", int32_t(0x00000000), int32_t(0xD201E521)},
    {"w-c-02.ubn", "", int32_t(0x00000000), int32_t(0xEE94DFD2)},
    {"w-c-02.urb", "", int32_t(0x00000000), int32_t(0xAA20614D)},
    {"w-c-03.des", "", int32_t(0x00000000), int32_t(0x022EF76D)},
    {"w-c-03.sno", "-", int32_t(0x00000000), int32_t(0x8501B862)},
    {"w-c-03.tem", "-", int32_t(0x00000000), int32_t(0x7476EE95)},
    {"w-c-03.ubn", "", int32_t(0x00000000), int32_t(0x48E3D466)},
    {"w-c-03.urb", "", int32_t(0x00000000), int32_t(0x0C576AF9)},
    {"w-c-04.des", "", int32_t(0x00000000), int32_t(0xC789C9E3)},
    {"w-c-04.sno", "-", int32_t(0x00000000), int32_t(0x40A686EC)},
    {"w-c-04.tem", "-", int32_t(0x00000000), int32_t(0xB1D1D01B)},
    {"w-c-04.ubn", "", int32_t(0x00000000), int32_t(0x8D44EAE8)},
    {"w-c-04.urb", "", int32_t(0x00000000), int32_t(0xC9F05477)},
    {"w-d-01.des", "", int32_t(0x00000000), int32_t(0x776DFD3D)},
    {"w-d-01.sno", "-", int32_t(0x00000000), int32_t(0xF042B232)},
    {"w-d-01.tem", "-", int32_t(0x00000000), int32_t(0x0135E4C5)},
    {"w-d-01.ubn", "", int32_t(0x00000000), int32_t(0x3DA0DE36)},
    {"w-d-01.urb", "", int32_t(0x00000000), int32_t(0x791460A9)},
    {"w-d-02.des", "", int32_t(0x00000000), int32_t(0x4685E7A0)},
    {"w-d-02.sno", "-", int32_t(0x00000000), int32_t(0xC1AAA8AF)},
    {"w-d-02.tem", "-", int32_t(0x00000000), int32_t(0x30DDFE58)},
    {"w-d-02.ubn", "", int32_t(0x00000000), int32_t(0x0C48C4AB)},
    {"w-d-02.urb", "", int32_t(0x00000000), int32_t(0x48FC7A34)},
    {"w-d-03.des", "", int32_t(0x00000000), int32_t(0xE0F2EC14)},
    {"w-d-03.sno", "-", int32_t(0x00000000), int32_t(0x67DDA31B)},
    {"w-d-03.tem", "-", int32_t(0x00000000), int32_t(0x96AAF5EC)},
    {"w-d-03.ubn", "", int32_t(0x00000000), int32_t(0xAA3FCF1F)},
    {"w-d-03.urb", "", int32_t(0x00000000), int32_t(0xEE8B7180)},
    {"w-d-04.des", "", int32_t(0x00000000), int32_t(0x2555D29A)},
    {"w-d-04.sno", "-", int32_t(0x00000000), int32_t(0xA27A9D95)},
    {"w-d-04.tem", "-", int32_t(0x00000000), int32_t(0x530DCB62)},
    {"w-d-04.ubn", "", int32_t(0x00000000), int32_t(0x6F98F191)},
    {"w-d-04.urb", "", int32_t(0x00000000), int32_t(0x2B2C4F0E)},
    {"w1.des", "water", int32_t(0x885CB5F3), int32_t(0x00000000)},
    {"w1.sno", "water", int32_t(0xA65CB1FC), int32_t(0x00000000)},
    {"w1.tem", "water", int32_t(0xA85CAFF3), int32_t(0x00000000)},
    {"w1.win", "water", int32_t(0xAE5CB0F7), int32_t(0x00000000)},
    {"w2.sno", "water", int32_t(0xA65CB3FC), int32_t(0x00000000)},
    {"w2.tem", "water", int32_t(0xA85CB1F3), int32_t(0x00000000)},
    {"w2.win", "water", int32_t(0xAE5CB2F7), int32_t(0x00000000)},
    {"w_piff.shp", "-", int32_t(0x00000000), int32_t(0xE144C02C)},
    {"w_piffs.shp", "-", int32_t(0x00000000), int32_t(0xAB147FD5)},
    {"wa01x.des", "", int32_t(0x00000000), int32_t(0xD35C1439)},
    {"wa01x.sno", "-", int32_t(0x00000000), int32_t(0x52E6FE3E)},
    {"wa01x.tem", "-", int32_t(0x00000000), int32_t(0x4E0234B2)},
    {"wa01x.urb", "", int32_t(0x00000000), int32_t(0x18DABD8D)},
    {"wa02x.des", "", int32_t(0x00000000), int32_t(0xEAD128FC)},
    {"wa02x.sno", "-", int32_t(0x00000000), int32_t(0x6B6BC2FB)},
    {"wa02x.tem", "-", int32_t(0x00000000), int32_t(0x778F0877)},
    {"wa02x.urb", "", int32_t(0x00000000), int32_t(0x21578148)},
    {"wa03x.des", "", int32_t(0x00000000), int32_t(0xFDAA3CBF)},
    {"wa03x.sno", "-", int32_t(0x00000000), int32_t(0x7C10D6B8)},
    {"wa03x.tem", "-", int32_t(0x00000000), int32_t(0x60F41C34)},
    {"wa03x.urb", "", int32_t(0x00000000), int32_t(0x362C950B)},
    {"wa04x.des", "", int32_t(0x00000000), int32_t(0x99CB5176)},
    {"wa04x.sno", "-", int32_t(0x00000000), int32_t(0x1871BB71)},
    {"wa04x.tem", "-", int32_t(0x00000000), int32_t(0x049571FD)},
    {"wa04x.urb", "", int32_t(0x00000000), int32_t(0x524DF8C2)},
    {"waitcylo.pal", "", int32_t(0x00000000), int32_t(0x60DE6674)},
    {"waitcylo.shp", "", int32_t(0x00000000), int32_t(0xA75B3F2B)},
    {"wake.shp", "gunboat wakes", int32_t(0xDADED5DC), int32_t(0x00000000)},
    {"wake1.shp", "-", int32_t(0x00000000), int32_t(0xF9CC181A)},
    {"wake2.shp", "-", int32_t(0x00000000), int32_t(0x77431FF9)},
    {"wall0001.int", "blank tile", int32_t(0xE7DFAEEB), int32_t(0x00000000)},
    {"wall0002.int", "grey wall", int32_t(0xE9DFAEEB), int32_t(0x00000000)},
    {"wall0003.int", "grey wall", int32_t(0xEBDFAEEB), int32_t(0x00000000)},
    {"wall0004.int", "grey wall", int32_t(0xEDDFAEEB), int32_t(0x00000000)},
    {"wall0005.int", "grey wall", int32_t(0xEFDFAEEB), int32_t(0x00000000)},
    {"wall0006.int", "grey wall", int32_t(0xF1DFAEEB), int32_t(0x00000000)},
    {"wall0007.int", "grey wall", int32_t(0xF3DFAEEB), int32_t(0x00000000)},
    {"wall0008.int", "grey wall", int32_t(0xF5DFAEEB), int32_t(0x00000000)},
    {"wall0009.int", "grey wall", int32_t(0xF7DFAEEB), int32_t(0x00000000)},
    {"wall0010.int", "grey wall", int32_t(0xE5E1AEEB), int32_t(0x00000000)},
    {"wall0011.int", "grey wall", int32_t(0xE7E1AEEB), int32_t(0x00000000)},
    {"wall0012.int", "grey wall", int32_t(0xE9E1AEEB), int32_t(0x00000000)},
    {"wall0013.int", "grey wall", int32_t(0xEBE1AEEB), int32_t(0x00000000)},
    {"wall0014.int", "grey wall", int32_t(0xEDE1AEEB), int32_t(0x00000000)},
    {"wall0015.int", "grey wall", int32_t(0xEFE1AEEB), int32_t(0x00000000)},
    {"wall0016.int", "grey wall", int32_t(0xF1E1AEEB), int32_t(0x00000000)},
    {"wall0017.int", "grey wall", int32_t(0xF3E1AEEB), int32_t(0x00000000)},
    {"wall0018.int", "grey wall", int32_t(0xF5E1AEEB), int32_t(0x00000000)},
    {"wall0019.int", "grey wall", int32_t(0xF7E1AEEB), int32_t(0x00000000)},
    {"wall0020.int", "grey wall", int32_t(0xE5E3AEEB), int32_t(0x00000000)},
    {"wall0021.int", "grey wall", int32_t(0xE7E3AEEB), int32_t(0x00000000)},
    {"wall0022.int", "grey wall", int32_t(0xE9E3AEEB), int32_t(0x00000000)},
    {"wall0023.int", "grey wall", int32_t(0xEBE3AEEB), int32_t(0x00000000)},
    {"wall0024.int", "grey wall", int32_t(0xEDE3AEEB), int32_t(0x00000000)},
    {"wall0025.int", "grey wall", int32_t(0xEFE3AEEB), int32_t(0x00000000)},
    {"wall0026.int", "grey wall", int32_t(0xF1E3AEEB), int32_t(0x00000000)},
    {"wall0027.int", "grey wall", int32_t(0xF3E3AEEB), int32_t(0x00000000)},
    {"wall0028.int", "grey wall", int32_t(0xF5E3AEEB), int32_t(0x00000000)},
    {"wall0029.int", "grey wall", int32_t(0xF7E3AEEB), int32_t(0x00000000)},
    {"wall0030.int", "grey wall", int32_t(0xE5E5AEEB), int32_t(0x00000000)},
    {"wall0031.int", "grey wall", int32_t(0xE7E5AEEB), int32_t(0x00000000)},
    {"wall0032.int", "grey wall", int32_t(0xE9E5AEEB), int32_t(0x00000000)},
    {"wall0033.int", "grey wall", int32_t(0xEBE5AEEB), int32_t(0x00000000)},
    {"wall0034.int", "grey wall", int32_t(0xEDE5AEEB), int32_t(0x00000000)},
    {"wall0035.int", "grey wall", int32_t(0xEFE5AEEB), int32_t(0x00000000)},
    {"wall0036.int", "grey wall", int32_t(0xF1E5AEEB), int32_t(0x00000000)},
    {"wall0037.int", "grey wall", int32_t(0xF3E5AEEB), int32_t(0x00000000)},
    {"wall0038.int", "grey wall", int32_t(0xF5E5AEEB), int32_t(0x00000000)},
    {"wall0039.int", "grey wall", int32_t(0xF7E5AEEB), int32_t(0x00000000)},
    {"wall0040.int", "grey wall", int32_t(0xE5E7AEEB), int32_t(0x00000000)},
    {"wall0041.int", "grey wall", int32_t(0xE7E7AEEB), int32_t(0x00000000)},
    {"wall0042.int", "grey wall", int32_t(0xE9E7AEEB), int32_t(0x00000000)},
    {"wall0043.int", "grey wall", int32_t(0xEBE7AEEB), int32_t(0x00000000)},
    {"wall0044.int", "grey wall", int32_t(0xEDE7AEEB), int32_t(0x00000000)},
    {"wall0045.int", "grey wall", int32_t(0xEFE7AEEB), int32_t(0x00000000)},
    {"wall0046.int", "grey wall", int32_t(0xF1E7AEEB), int32_t(0x00000000)},
    {"wall0047.int", "grey wall", int32_t(0xF3E7AEEB), int32_t(0x00000000)},
    {"wall0048.int", "grey wall", int32_t(0xF5E7AEEB), int32_t(0x00000000)},
    {"wall0049.int", "grey wall", int32_t(0xF7E7AEEB), int32_t(0x00000000)},
    {"wall1.aud", "", int32_t(0xDBB36203), int32_t(0x00000000)},
    {"wallicon.shp", "icon: concrete wall", int32_t(0x00000000), int32_t(0xBFF09050)},
    {"wallkil2.aud", "fence over", int32_t(0xDA1ED921), int32_t(0x00000000)},
    {"warfare.aud", "warfare", int32_t(0x7617FF20), int32_t(0x00000000)},
    {"warninggauge.shp", "", int32_t(0x00000000), int32_t(0xAF3CB1F6)},
    {"warninginout.shp", "", int32_t(0x00000000), int32_t(0x6EEEA6EA)},
    {"warpaway.shp", "", int32_t(0x00000000), int32_t(0x64DD19E4)},
    {"warpicon.shp", "icon: chronoshift", int32_t(0x2E2FDF1D), int32_t(0x00000000)},
    {"warpin.shp", "", int32_t(0x00000000), int32_t(0xF39D573D)},
    {"warpout.shp", "", int32_t(0x00000000), int32_t(0x077E19CF)},
    {"warub01.des", "", int32_t(0x00000000), int32_t(0xB9601B4C)},
    {"warub01.lun", "", int32_t(0x00000000), int32_t(0x9F9EFCCF)},
    {"warub01.sno", "", int32_t(0x00000000), int32_t(0x9E8CC6D6)},
    {"warub01.tem", "", int32_t(0x00000000), int32_t(0x3D38730C)},
    {"warub01.ubn", "", int32_t(0x00000000), int32_t(0xABE6512F)},
    {"warub01.urb", "", int32_t(0x00000000), int32_t(0x1B75BD53)},
    {"warub02.des", "", int32_t(0x00000000), int32_t(0x3FF469E2)},
    {"warub02.lun", "", int32_t(0x00000000), int32_t(0x190A8E61)},
    {"warub02.sno", "", int32_t(0x00000000), int32_t(0x1818B478)},
    {"warub02.tem", "", int32_t(0x00000000), int32_t(0xBBAC01A2)},
    {"warub02.ubn", "", int32_t(0x00000000), int32_t(0x2D722381)},
    {"warub02.urb", "", int32_t(0x00000000), int32_t(0x9DE1CFFD)},
    {"warub03.des", "", int32_t(0x00000000), int32_t(0xF4A8BA47)},
    {"warub03.lun", "", int32_t(0x00000000), int32_t(0xD2565DC4)},
    {"warub03.sno", "", int32_t(0x00000000), int32_t(0xD34467DD)},
    {"warub03.tem", "", int32_t(0x00000000), int32_t(0x70F0D207)},
    {"warub03.ubn", "", int32_t(0x00000000), int32_t(0xE62EF024)},
    {"warub03.urb", "", int32_t(0x00000000), int32_t(0x56BD1C58)},
    {"warub04.des", "", int32_t(0x00000000), int32_t(0xE9AD8AFF)},
    {"warub04.lun", "", int32_t(0x00000000), int32_t(0xCF536D7C)},
    {"warub04.sno", "", int32_t(0x00000000), int32_t(0xCE415765)},
    {"warub04.tem", "", int32_t(0x00000000), int32_t(0x6DF5E2BF)},
    {"warub04.ubn", "", int32_t(0x00000000), int32_t(0xFB2BC09C)},
    {"warub04.urb", "", int32_t(0x00000000), int32_t(0x4BB82CE0)},
    {"warub05.des", "", int32_t(0x00000000), int32_t(0x22F1595A)},
    {"warub05.lun", "", int32_t(0x00000000), int32_t(0x040FBED9)},
    {"warub05.sno", "", int32_t(0x00000000), int32_t(0x051D84C0)},
    {"warub05.tem", "", int32_t(0x00000000), int32_t(0xA6A9311A)},
    {"warub05.ubn", "", int32_t(0x00000000), int32_t(0x30771339)},
    {"warub05.urb", "", int32_t(0x00000000), int32_t(0x80E4FF45)},
    {"warub06.des", "", int32_t(0x00000000), int32_t(0xA4652BF4)},
    {"warub06.lun", "", int32_t(0x00000000), int32_t(0x829BCC77)},
    {"warub06.sno", "", int32_t(0x00000000), int32_t(0x8389F66E)},
    {"warub06.tem", "", int32_t(0x00000000), int32_t(0x203D43B4)},
    {"warub06.ubn", "", int32_t(0x00000000), int32_t(0xB6E36197)},
    {"warub06.urb", "", int32_t(0x00000000), int32_t(0x06708DEB)},
    {"warub07.des", "", int32_t(0x00000000), int32_t(0x6F39F851)},
    {"warub07.lun", "", int32_t(0x00000000), int32_t(0x49C71FD2)},
    {"warub07.sno", "", int32_t(0x00000000), int32_t(0x48D525CB)},
    {"warub07.tem", "", int32_t(0x00000000), int32_t(0xEB619011)},
    {"warub07.ubn", "", int32_t(0x00000000), int32_t(0x7DBFB232)},
    {"warub07.urb", "", int32_t(0x00000000), int32_t(0xCD2C5E4E)},
    {"warub08.des", "", int32_t(0x00000000), int32_t(0x9E6F4A84)},
    {"warub08.lun", "", int32_t(0x00000000), int32_t(0xB891AD07)},
    {"warub08.sno", "", int32_t(0x00000000), int32_t(0xB983971E)},
    {"warub08.tem", "", int32_t(0x00000000), int32_t(0x1A3722C4)},
    {"warub08.ubn", "", int32_t(0x00000000), int32_t(0x8CE900E7)},
    {"warub08.urb", "", int32_t(0x00000000), int32_t(0x3C7AEC9B)},
    {"warub09.des", "", int32_t(0x00000000), int32_t(0x55339921)},
    {"warub09.lun", "", int32_t(0x00000000), int32_t(0x73CD7EA2)},
    {"warub09.sno", "", int32_t(0x00000000), int32_t(0x72DF44BB)},
    {"warub09.tem", "", int32_t(0x00000000), int32_t(0xD16BF161)},
    {"warub09.ubn", "", int32_t(0x00000000), int32_t(0x47B5D342)},
    {"warub09.urb", "", int32_t(0x00000000), int32_t(0xF7263F3E)},
    {"warub10.des", "", int32_t(0x00000000), int32_t(0xD44BC35D)},
    {"warub10.lun", "", int32_t(0x00000000), int32_t(0xF2B524DE)},
    {"warub10.sno", "", int32_t(0x00000000), int32_t(0xF3A71EC7)},
    {"warub10.tem", "", int32_t(0x00000000), int32_t(0x5013AB1D)},
    {"warub10.ubn", "", int32_t(0x00000000), int32_t(0xC6CD893E)},
    {"warub10.urb", "", int32_t(0x00000000), int32_t(0x765E6542)},
    {"warub11.des", "", int32_t(0x00000000), int32_t(0x1F1710F8)},
    {"warub11.lun", "", int32_t(0x00000000), int32_t(0x39E9F77B)},
    {"warub11.sno", "", int32_t(0x00000000), int32_t(0x38FBCD62)},
    {"warub11.tem", "", int32_t(0x00000000), int32_t(0x9B4F78B8)},
    {"warub11.ubn", "", int32_t(0x00000000), int32_t(0x0D915A9B)},
    {"warub11.urb", "", int32_t(0x00000000), int32_t(0xBD02B6E7)},
    {"warub12.des", "", int32_t(0x00000000), int32_t(0x99836256)},
    {"warub12.lun", "", int32_t(0x00000000), int32_t(0xBF7D85D5)},
    {"warub12.sno", "", int32_t(0x00000000), int32_t(0xBE6FBFCC)},
    {"warub12.tem", "", int32_t(0x00000000), int32_t(0x1DDB0A16)},
    {"warub12.ubn", "", int32_t(0x00000000), int32_t(0x8B052835)},
    {"warub12.urb", "", int32_t(0x00000000), int32_t(0x3B96C449)},
    {"warub13.des", "", int32_t(0x00000000), int32_t(0x52DFB1F3)},
    {"warub13.lun", "", int32_t(0x00000000), int32_t(0x74215670)},
    {"warub13.sno", "", int32_t(0x00000000), int32_t(0x75336C69)},
    {"warub13.tem", "", int32_t(0x00000000), int32_t(0xD687D9B3)},
    {"warub13.ubn", "", int32_t(0x00000000), int32_t(0x4059FB90)},
    {"warub13.urb", "", int32_t(0x00000000), int32_t(0xF0CA17EC)},
    {"warubb01.urb", "", int32_t(0x00000000), int32_t(0xBB06FDE8)},
    {"warubb02.urb", "", int32_t(0x00000000), int32_t(0xFCA68738)},
    {"warubb03.urb", "", int32_t(0x00000000), int32_t(0xC1C6AE88)},
    {"warubb04.urb", "", int32_t(0x00000000), int32_t(0x73E67298)},
    {"warubb05.urb", "", int32_t(0x00000000), int32_t(0x4E865B28)},
    {"warubb06.urb", "", int32_t(0x00000000), int32_t(0x092621F8)},
    {"warubb07.urb", "", int32_t(0x00000000), int32_t(0x34460848)},
    {"warubb08.urb", "", int32_t(0x00000000), int32_t(0xB6169F99)},
    {"warubb09.urb", "", int32_t(0x00000000), int32_t(0x8B76B629)},
    {"wash01.ubn", "", int32_t(0x00000000), int32_t(0xB4E884B3)},
    {"wash01.urb", "", int32_t(0x00000000), int32_t(0xF05C3A2C)},
    {"wash02.ubn", "", int32_t(0x00000000), int32_t(0x85009E2E)},
    {"wash02.urb", "", int32_t(0x00000000), int32_t(0xC1B420B1)},
    {"wash1.aud", "", int32_t(0xCBCF6203), int32_t(0x00000000)},
    {"wastelnd.aud", "wasteland", int32_t(0x1E3EDF15), int32_t(0x00000000)},
    {"wasticon.shp", "icon: tiberium waste facility", int32_t(0x00000000), int32_t(0x7E4DAA5C)},
    {"water01.des", "", int32_t(0x00000000), int32_t(0x64051851)},
    {"water01.sno", "-", int32_t(0x00000000), int32_t(0x43E9C5CB)},
    {"water01.tem", "-", int32_t(0x00000000), int32_t(0xE05D7011)},
    {"water01.ubn", "", int32_t(0x00000000), int32_t(0x76835232)},
    {"water01.urb", "", int32_t(0x00000000), int32_t(0xC610BE4E)},
    {"water02.des", "", int32_t(0x00000000), int32_t(0xE2916AFF)},
    {"water02.sno", "-", int32_t(0x00000000), int32_t(0xC57DB765)},
    {"water02.tem", "-", int32_t(0x00000000), int32_t(0x66C902BF)},
    {"water02.ubn", "", int32_t(0x00000000), int32_t(0xF017209C)},
    {"water02.urb", "", int32_t(0x00000000), int32_t(0x4084CCE0)},
    {"water03.des", "", int32_t(0x00000000), int32_t(0x29CDB95A)},
    {"water03.sno", "-", int32_t(0x00000000), int32_t(0x0E2164C0)},
    {"water03.tem", "-", int32_t(0x00000000), int32_t(0xAD95D11A)},
    {"water03.ubn", "", int32_t(0x00000000), int32_t(0x3B4BF339)},
    {"water03.urb", "", int32_t(0x00000000), int32_t(0x8BD81F45)},
    {"water04.des", "", int32_t(0x00000000), int32_t(0x34C889E2)},
    {"water04.sno", "-", int32_t(0x00000000), int32_t(0x13245478)},
    {"water04.tem", "-", int32_t(0x00000000), int32_t(0xB090E1A2)},
    {"water04.ubn", "", int32_t(0x00000000), int32_t(0x264EC381)},
    {"water04.urb", "", int32_t(0x00000000), int32_t(0x96DD2FFD)},
    {"water05.des", "", int32_t(0x00000000), int32_t(0xFF945A47)},
    {"water05.sno", "-", int32_t(0x00000000), int32_t(0xD87887DD)},
    {"water05.tem", "-", int32_t(0x00000000), int32_t(0x7BCC3207)},
    {"water05.ubn", "", int32_t(0x00000000), int32_t(0xED121024)},
    {"water05.urb", "", int32_t(0x00000000), int32_t(0x5D81FC58)},
    {"water06.des", "", int32_t(0x00000000), int32_t(0x790028E9)},
    {"water06.sno", "-", int32_t(0x00000000), int32_t(0x5EECF573)},
    {"water06.tem", "-", int32_t(0x00000000), int32_t(0xFD5840A9)},
    {"water06.ubn", "", int32_t(0x00000000), int32_t(0x6B86628A)},
    {"water06.urb", "", int32_t(0x00000000), int32_t(0xDB158EF6)},
    {"water07.des", "", int32_t(0x00000000), int32_t(0xB25CFB4C)},
    {"water07.sno", "-", int32_t(0x00000000), int32_t(0x95B026D6)},
    {"water07.tem", "-", int32_t(0x00000000), int32_t(0x3604930C)},
    {"water07.ubn", "", int32_t(0x00000000), int32_t(0xA0DAB12F)},
    {"water07.urb", "", int32_t(0x00000000), int32_t(0x10495D53)},
    {"water08.des", "", int32_t(0x00000000), int32_t(0x430A4999)},
    {"water08.sno", "-", int32_t(0x00000000), int32_t(0x64E69403)},
    {"water08.tem", "-", int32_t(0x00000000), int32_t(0xC75221D9)},
    {"water08.ubn", "", int32_t(0x00000000), int32_t(0x518C03FA)},
    {"water08.urb", "", int32_t(0x00000000), int32_t(0xE11FEF86)},
    {"water09.des", "", int32_t(0x00000000), int32_t(0x88569A3C)},
    {"water09.sno", "-", int32_t(0x00000000), int32_t(0xAFBA47A6)},
    {"water09.tem", "-", int32_t(0x00000000), int32_t(0x0C0EF27C)},
    {"water09.ubn", "", int32_t(0x00000000), int32_t(0x9AD0D05F)},
    {"water09.urb", "", int32_t(0x00000000), int32_t(0x2A433C23)},
    {"water10.des", "", int32_t(0x00000000), int32_t(0x092EC040)},
    {"water10.sno", "-", int32_t(0x00000000), int32_t(0x2EC21DDA)},
    {"water10.tem", "-", int32_t(0x00000000), int32_t(0x8D76A800)},
    {"water10.ubn", "", int32_t(0x00000000), int32_t(0x1BA88A23)},
    {"water10.urb", "", int32_t(0x00000000), int32_t(0xAB3B665F)},
    {"water11.des", "", int32_t(0x00000000), int32_t(0xC27213E5)},
    {"water11.sno", "-", int32_t(0x00000000), int32_t(0xE59ECE7F)},
    {"water11.tem", "-", int32_t(0x00000000), int32_t(0x462A7BA5)},
    {"water11.ubn", "", int32_t(0x00000000), int32_t(0xD0F45986)},
    {"water11.urb", "", int32_t(0x00000000), int32_t(0x6067B5FA)},
    {"water12.des", "", int32_t(0x00000000), int32_t(0x44E6614B)},
    {"water12.sno", "-", int32_t(0x00000000), int32_t(0x630ABCD1)},
    {"water12.tem", "-", int32_t(0x00000000), int32_t(0xC0BE090B)},
    {"water12.ubn", "", int32_t(0x00000000), int32_t(0x56602B28)},
    {"water12.urb", "", int32_t(0x00000000), int32_t(0xE6F3C754)},
    {"water13.des", "", int32_t(0x00000000), int32_t(0x8FBAB2EE)},
    {"water13.sno", "-", int32_t(0x00000000), int32_t(0xA8566F74)},
    {"water13.tem", "-", int32_t(0x00000000), int32_t(0x0BE2DAAE)},
    {"water13.ubn", "", int32_t(0x00000000), int32_t(0x9D3CF88D)},
    {"water13.urb", "", int32_t(0x00000000), int32_t(0x2DAF14F1)},
    {"water14.des", "", int32_t(0x00000000), int32_t(0x92BF8256)},
    {"water14.sno", "-", int32_t(0x00000000), int32_t(0xB5535FCC)},
    {"water14.tem", "-", int32_t(0x00000000), int32_t(0x16E7EA16)},
    {"water14.ubn", "", int32_t(0x00000000), int32_t(0x8039C835)},
    {"water14.urb", "", int32_t(0x00000000), int32_t(0x30AA2449)},
    {"wayp.shp", "-", int32_t(0x00000000), int32_t(0xB6F31192)},
    {"waypoint.pal", "waypoint palette", int32_t(0x00000000), int32_t(0x70153889)},
    {"wb01x.des", "", int32_t(0x00000000), int32_t(0x4ABE7238)},
    {"wb01x.sno", "-", int32_t(0x00000000), int32_t(0xCB04983F)},
    {"wb01x.tem", "-", int32_t(0x00000000), int32_t(0xD7E052B3)},
    {"wb01x.urb", "", int32_t(0x00000000), int32_t(0x8138DB8C)},
    {"wb02x.des", "", int32_t(0x00000000), int32_t(0x73334EFD)},
    {"wb02x.sno", "-", int32_t(0x00000000), int32_t(0xF289A4FA)},
    {"wb02x.tem", "-", int32_t(0x00000000), int32_t(0xEE6D6E76)},
    {"wb02x.urb", "", int32_t(0x00000000), int32_t(0xB8B5E749)},
    {"wb03x.des", "", int32_t(0x00000000), int32_t(0x64485ABE)},
    {"wb03x.sno", "-", int32_t(0x00000000), int32_t(0xE5F2B0B9)},
    {"wb03x.tem", "-", int32_t(0x00000000), int32_t(0xF9167A35)},
    {"wb03x.urb", "", int32_t(0x00000000), int32_t(0xAFCEF30A)},
    {"wb04x.des", "", int32_t(0x00000000), int32_t(0x00293777)},
    {"wb04x.sno", "-", int32_t(0x00000000), int32_t(0x8193DD70)},
    {"wb04x.tem", "-", int32_t(0x00000000), int32_t(0x9D7717FC)},
    {"wb04x.urb", "", int32_t(0x00000000), int32_t(0xCBAF9EC3)},
    {"wbrdge01.des", "", int32_t(0x00000000), int32_t(0x66CF9012)},
    {"wbrdge01.sno", "", int32_t(0x00000000), int32_t(0x8853A063)},
    {"wbrdge01.tem", "", int32_t(0x00000000), int32_t(0x80E60E01)},
    {"wbrdge01.ubn", "", int32_t(0x00000000), int32_t(0x576CA34B)},
    {"wbrdge01.urb", "", int32_t(0x00000000), int32_t(0x1418FD31)},
    {"wbrdge02.des", "", int32_t(0x00000000), int32_t(0x216FEAC2)},
    {"wbrdge02.sno", "", int32_t(0x00000000), int32_t(0xCFF3DAB3)},
    {"wbrdge02.tem", "", int32_t(0x00000000), int32_t(0xC74674D1)},
    {"wbrdge02.ubn", "", int32_t(0x00000000), int32_t(0x10CCD99B)},
    {"wbrdge02.urb", "", int32_t(0x00000000), int32_t(0x53B887E1)},
    {"wc01.sno", "coast", int32_t(0xB1AED9DC), int32_t(0x00000000)},
    {"wc01.tem", "coast", int32_t(0xAFA5DADC), int32_t(0x00000000)},
    {"wc01x.des", "", int32_t(0x00000000), int32_t(0x8B30ADF8)},
    {"wc01x.sno", "-", int32_t(0x00000000), int32_t(0x0A8A47FF)},
    {"wc01x.tem", "-", int32_t(0x00000000), int32_t(0x166E8D73)},
    {"wc01x.urb", "", int32_t(0x00000000), int32_t(0x40B6044C)},
    {"wc02.sno", "coast", int32_t(0xB3AED9DC), int32_t(0x00000000)},
    {"wc02.tem", "coast", int32_t(0xB1A5DADC), int32_t(0x00000000)},
    {"wc02x.des", "", int32_t(0x00000000), int32_t(0xB2BD913D)},
    {"wc02x.sno", "-", int32_t(0x00000000), int32_t(0x33077B3A)},
    {"wc02x.tem", "-", int32_t(0x00000000), int32_t(0x2FE3B1B6)},
    {"wc02x.urb", "", int32_t(0x00000000), int32_t(0x793B3889)},
    {"wc03.sno", "coast", int32_t(0xB5AED9DC), int32_t(0x00000000)},
    {"wc03.tem", "coast", int32_t(0xB3A5DADC), int32_t(0x00000000)},
    {"wc03x.des", "", int32_t(0x00000000), int32_t(0xA5C6857E)},
    {"wc03x.sno", "-", int32_t(0x00000000), int32_t(0x247C6F79)},
    {"wc03x.tem", "-", int32_t(0x00000000), int32_t(0x3898A5F5)},
    {"wc03x.urb", "", int32_t(0x00000000), int32_t(0x6E402CCA)},
    {"wc04.sno", "coast", int32_t(0xB7AED9DC), int32_t(0x00000000)},
    {"wc04.tem", "coast", int32_t(0xB5A5DADC), int32_t(0x00000000)},
    {"wc04x.des", "", int32_t(0x00000000), int32_t(0xC1A7E8B7)},
    {"wc04x.sno", "-", int32_t(0x00000000), int32_t(0x401D02B0)},
    {"wc04x.tem", "-", int32_t(0x00000000), int32_t(0x5CF9C83C)},
    {"wc04x.urb", "", int32_t(0x00000000), int32_t(0x0A214103)},
    {"wc05.sno", "coast", int32_t(0xB9AED9DC), int32_t(0x00000000)},
    {"wc05.tem", "coast", int32_t(0xB7A5DADC), int32_t(0x00000000)},
    {"wc06.sno", "coast", int32_t(0xBBAED9DC), int32_t(0x00000000)},
    {"wc06.tem", "coast", int32_t(0xB9A5DADC), int32_t(0x00000000)},
    {"wc07.sno", "coast", int32_t(0xBDAED9DC), int32_t(0x00000000)},
    {"wc07.tem", "coast", int32_t(0xBBA5DADC), int32_t(0x00000000)},
    {"wc08.sno", "coast", int32_t(0xBFAED9DC), int32_t(0x00000000)},
    {"wc08.tem", "coast", int32_t(0xBDA5DADC), int32_t(0x00000000)},
    {"wc09.sno", "coast", int32_t(0xC1AED9DC), int32_t(0x00000000)},
    {"wc09.tem", "coast", int32_t(0xBFA5DADC), int32_t(0x00000000)},
    {"wc10.sno", "coast", int32_t(0xAFB0D9DC), int32_t(0x00000000)},
    {"wc10.tem", "coast", int32_t(0xADA7DADC), int32_t(0x00000000)},
    {"wc11.sno", "coast", int32_t(0xB1B0D9DC), int32_t(0x00000000)},
    {"wc11.tem", "coast", int32_t(0xAFA7DADC), int32_t(0x00000000)},
    {"wc12.sno", "coast", int32_t(0xB3B0D9DC), int32_t(0x00000000)},
    {"wc12.tem", "coast", int32_t(0xB1A7DADC), int32_t(0x00000000)},
    {"wc13.sno", "coast", int32_t(0xB5B0D9DC), int32_t(0x00000000)},
    {"wc13.tem", "coast", int32_t(0xB3A7DADC), int32_t(0x00000000)},
    {"wc14.sno", "coast", int32_t(0xB7B0D9DC), int32_t(0x00000000)},
    {"wc14.tem", "coast", int32_t(0xB5A7DADC), int32_t(0x00000000)},
    {"wc15.sno", "coast", int32_t(0xB9B0D9DC), int32_t(0x00000000)},
    {"wc15.tem", "coast", int32_t(0xB7A7DADC), int32_t(0x00000000)},
    {"wc16.sno", "coast", int32_t(0xBBB0D9DC), int32_t(0x00000000)},
    {"wc16.tem", "coast", int32_t(0xB9A7DADC), int32_t(0x00000000)},
    {"wc17.sno", "coast", int32_t(0xBDB0D9DC), int32_t(0x00000000)},
    {"wc17.tem", "coast", int32_t(0xBBA7DADC), int32_t(0x00000000)},
    {"wc18.sno", "coast", int32_t(0xBFB0D9DC), int32_t(0x00000000)},
    {"wc18.tem", "coast", int32_t(0xBDA7DADC), int32_t(0x00000000)},
    {"wc19.sno", "coast", int32_t(0xC1B0D9DC), int32_t(0x00000000)},
    {"wc19.tem", "coast", int32_t(0xBFA7DADC), int32_t(0x00000000)},
    {"wc20.sno", "coast", int32_t(0xAFB2D9DC), int32_t(0x00000000)},
    {"wc20.tem", "coast", int32_t(0xADA9DADC), int32_t(0x00000000)},
    {"wc21.sno", "coast", int32_t(0xB1B2D9DC), int32_t(0x00000000)},
    {"wc21.tem", "coast", int32_t(0xAFA9DADC), int32_t(0x00000000)},
    {"wc22.sno", "coast", int32_t(0xB3B2D9DC), int32_t(0x00000000)},
    {"wc22.tem", "coast", int32_t(0xB1A9DADC), int32_t(0x00000000)},
    {"wc23.sno", "coast", int32_t(0xB5B2D9DC), int32_t(0x00000000)},
    {"wc23.tem", "coast", int32_t(0xB3A9DADC), int32_t(0x00000000)},
    {"wc24.sno", "coast", int32_t(0xB7B2D9DC), int32_t(0x00000000)},
    {"wc24.tem", "coast", int32_t(0xB5A9DADC), int32_t(0x00000000)},
    {"wc25.sno", "coast", int32_t(0xB9B2D9DC), int32_t(0x00000000)},
    {"wc25.tem", "coast", int32_t(0xB7A9DADC), int32_t(0x00000000)},
    {"wc26.sno", "coast", int32_t(0xBBB2D9DC), int32_t(0x00000000)},
    {"wc26.tem", "coast", int32_t(0xB9A9DADC), int32_t(0x00000000)},
    {"wc27.sno", "coast", int32_t(0xBDB2D9DC), int32_t(0x00000000)},
    {"wc27.tem", "coast", int32_t(0xBBA9DADC), int32_t(0x00000000)},
    {"wc28.sno", "coast", int32_t(0xBFB2D9DC), int32_t(0x00000000)},
    {"wc28.tem", "coast", int32_t(0xBDA9DADC), int32_t(0x00000000)},
    {"wc29.sno", "coast", int32_t(0xC1B2D9DC), int32_t(0x00000000)},
    {"wc29.tem", "coast", int32_t(0xBFA9DADC), int32_t(0x00000000)},
    {"wc30.sno", "coast", int32_t(0xAFB4D9DC), int32_t(0x00000000)},
    {"wc30.tem", "coast", int32_t(0xADABDADC), int32_t(0x00000000)},
    {"wc31.sno", "coast", int32_t(0xB1B4D9DC), int32_t(0x00000000)},
    {"wc31.tem", "coast", int32_t(0xAFABDADC), int32_t(0x00000000)},
    {"wc32.sno", "coast", int32_t(0xB3B4D9DC), int32_t(0x00000000)},
    {"wc32.tem", "coast", int32_t(0xB1ABDADC), int32_t(0x00000000)},
    {"wc33.sno", "coast", int32_t(0xB5B4D9DC), int32_t(0x00000000)},
    {"wc33.tem", "coast", int32_t(0xB3ABDADC), int32_t(0x00000000)},
    {"wc34.sno", "coast", int32_t(0xB7B4D9DC), int32_t(0x00000000)},
    {"wc34.tem", "coast", int32_t(0xB5ABDADC), int32_t(0x00000000)},
    {"wc35.sno", "coast", int32_t(0xB9B4D9DC), int32_t(0x00000000)},
    {"wc35.tem", "coast", int32_t(0xB7ABDADC), int32_t(0x00000000)},
    {"wc36.sno", "coast", int32_t(0xBBB4D9DC), int32_t(0x00000000)},
    {"wc36.tem", "coast", int32_t(0xB9ABDADC), int32_t(0x00000000)},
    {"wc37.sno", "coast", int32_t(0xBDB4D9DC), int32_t(0x00000000)},
    {"wc37.tem", "coast", int32_t(0xBBABDADC), int32_t(0x00000000)},
    {"wc38.sno", "coast", int32_t(0xBFB4D9DC), int32_t(0x00000000)},
    {"wc38.tem", "coast", int32_t(0xBDABDADC), int32_t(0x00000000)},
    {"wcave01.des", "", int32_t(0x00000000), int32_t(0x1EDDADBA)},
    {"wcave01.tem", "-", int32_t(0x00000000), int32_t(0x9A85C5FA)},
    {"wcave01.ubn", "", int32_t(0x00000000), int32_t(0x0C5BE7D9)},
    {"wcave02.des", "", int32_t(0x00000000), int32_t(0x9849DF14)},
    {"wcave02.tem", "-", int32_t(0x00000000), int32_t(0x1C11B754)},
    {"wcave02.ubn", "", int32_t(0x00000000), int32_t(0x8ACF9577)},
    {"wcave03.des", "", int32_t(0x00000000), int32_t(0x53150CB1)},
    {"wcave03.tem", "-", int32_t(0x00000000), int32_t(0xD74D64F1)},
    {"wcave03.ubn", "", int32_t(0x00000000), int32_t(0x419346D2)},
    {"wcave04.des", "", int32_t(0x00000000), int32_t(0x4E103C09)},
    {"wcave04.tem", "-", int32_t(0x00000000), int32_t(0xCA485449)},
    {"wcave04.ubn", "", int32_t(0x00000000), int32_t(0x5C96766A)},
    {"wcave05.des", "", int32_t(0x00000000), int32_t(0x854CEFAC)},
    {"wcave05.tem", "-", int32_t(0x00000000), int32_t(0x011487EC)},
    {"wcave06.des", "", int32_t(0x00000000), int32_t(0x03D89D02)},
    {"wcave06.tem", "-", int32_t(0x00000000), int32_t(0x8780F542)},
    {"wcave07.des", "", int32_t(0x00000000), int32_t(0xC8844EA7)},
    {"wcave07.tem", "-", int32_t(0x00000000), int32_t(0x4CDC26E7)},
    {"wcave08.des", "", int32_t(0x00000000), int32_t(0x39D2FC72)},
    {"wcave08.tem", "-", int32_t(0x00000000), int32_t(0xBD8A9432)},
    {"wccloud1.shp", "", int32_t(0x00000000), int32_t(0xC5B355B2)},
    {"wccloud2.shp", "", int32_t(0x00000000), int32_t(0x82132F62)},
    {"wccloud3.shp", "", int32_t(0x00000000), int32_t(0xBF7306D2)},
    {"wclbolt1.shp", "", int32_t(0x00000000), int32_t(0x0DEA0E2B)},
    {"wclbolt2.shp", "", int32_t(0x00000000), int32_t(0x4A4A74FB)},
    {"wclbolt3.shp", "", int32_t(0x00000000), int32_t(0x772A5D4B)},
    {"wclifa01.ubn", "", int32_t(0x00000000), int32_t(0x662F0E0A)},
    {"wclifa01.urb", "", int32_t(0x00000000), int32_t(0x255B5070)},
    {"wclifa02.ubn", "", int32_t(0x00000000), int32_t(0x218F74DA)},
    {"wclifa02.urb", "", int32_t(0x00000000), int32_t(0x62FB2AA0)},
    {"wclifa03.ubn", "", int32_t(0x00000000), int32_t(0x1CEF5D6A)},
    {"wclifa03.urb", "", int32_t(0x00000000), int32_t(0x5F9B0310)},
    {"wclifa04.ubn", "", int32_t(0x00000000), int32_t(0xAECF817A)},
    {"wclifa04.urb", "", int32_t(0x00000000), int32_t(0xEDBBDF00)},
    {"wclifa05.ubn", "", int32_t(0x00000000), int32_t(0x93AFA8CA)},
    {"wclifa05.urb", "", int32_t(0x00000000), int32_t(0xD0DBF6B0)},
    {"wclifa06.ubn", "", int32_t(0x00000000), int32_t(0xD40FD21A)},
    {"wclifa06.urb", "", int32_t(0x00000000), int32_t(0x977B8C60)},
    {"wclifa07.ubn", "", int32_t(0x00000000), int32_t(0xE96FFBAA)},
    {"wclifa07.urb", "", int32_t(0x00000000), int32_t(0xAA1BA5D0)},
    {"wclifa08.ubn", "", int32_t(0x00000000), int32_t(0x6B3F6C7B)},
    {"wclifa08.urb", "", int32_t(0x00000000), int32_t(0x284B3201)},
    {"wclifa09.ubn", "", int32_t(0x00000000), int32_t(0x565F45CB)},
    {"wclifa09.urb", "", int32_t(0x00000000), int32_t(0x152B1BB1)},
    {"wclifa10.ubn", "", int32_t(0x00000000), int32_t(0x9013F41F)},
    {"wclifa10.urb", "", int32_t(0x00000000), int32_t(0xD367AA65)},
    {"wclifa11.ubn", "", int32_t(0x00000000), int32_t(0xAD73DDAF)},
    {"wclifa11.urb", "", int32_t(0x00000000), int32_t(0xEE0783D5)},
    {"wclifa12.ubn", "", int32_t(0x00000000), int32_t(0xEAD3A77F)},
    {"wclifa12.urb", "", int32_t(0x00000000), int32_t(0xA9A7F905)},
    {"wclifa13.ubn", "", int32_t(0x00000000), int32_t(0xD7B38ECF)},
    {"wclifa13.urb", "", int32_t(0x00000000), int32_t(0x94C7D0B5)},
    {"wclifa14.ubn", "", int32_t(0x00000000), int32_t(0x659352DF)},
    {"wclifa14.urb", "", int32_t(0x00000000), int32_t(0x26E70CA5)},
    {"wclifa15.urb", "", int32_t(0x00000000), int32_t(0x1B872515)},
    {"wclifa16.urb", "", int32_t(0x00000000), int32_t(0x5C275FC5)},
    {"wclifa17.urb", "", int32_t(0x00000000), int32_t(0x61477675)},
    {"wclifa18.urb", "", int32_t(0x00000000), int32_t(0xE317E1A4)},
    {"wclifa19.urb", "", int32_t(0x00000000), int32_t(0xDE77C814)},
    {"wclifa20.urb", "", int32_t(0x00000000), int32_t(0x55F3D8CB)},
    {"wclifa21.urb", "", int32_t(0x00000000), int32_t(0x6893F17B)},
    {"wclifa22.urb", "", int32_t(0x00000000), int32_t(0x2F338BAB)},
    {"wclifa23.urb", "", int32_t(0x00000000), int32_t(0x1253A21B)},
    {"wclifa24.urb", "", int32_t(0x00000000), int32_t(0xA0737E0B)},
    {"wclifa25.urb", "", int32_t(0x00000000), int32_t(0x9D1357BB)},
    {"wclifa26.urb", "", int32_t(0x00000000), int32_t(0xDAB32D6B)},
    {"wclifb01.ubn", "", int32_t(0x00000000), int32_t(0x57C71497)},
    {"wclifb01.urb", "", int32_t(0x00000000), int32_t(0x14B34AED)},
    {"wclifb02.ubn", "", int32_t(0x00000000), int32_t(0x10676E47)},
    {"wclifb02.urb", "", int32_t(0x00000000), int32_t(0x5313303D)},
    {"wclifb03.ubn", "", int32_t(0x00000000), int32_t(0x2D0747F7)},
    {"wclifb03.urb", "", int32_t(0x00000000), int32_t(0x6E73198D)},
    {"wclifb04.ubn", "", int32_t(0x00000000), int32_t(0x9F279BE7)},
    {"wclifb04.urb", "", int32_t(0x00000000), int32_t(0xDC53C59D)},
    {"wclifb05.ubn", "", int32_t(0x00000000), int32_t(0xA247B257)},
    {"wclifb05.urb", "", int32_t(0x00000000), int32_t(0xE133EC2D)},
    {"wclifb06.ubn", "", int32_t(0x00000000), int32_t(0xE5E7C887)},
    {"wclifb06.urb", "", int32_t(0x00000000), int32_t(0xA69396FD)},
    {"wclifb07.ubn", "", int32_t(0x00000000), int32_t(0xD887E137)},
    {"wclifb07.urb", "", int32_t(0x00000000), int32_t(0x9BF3BF4D)},
    {"wclifb08.ubn", "", int32_t(0x00000000), int32_t(0x5AD776E6)},
    {"wclifb08.urb", "", int32_t(0x00000000), int32_t(0x19A3289C)},
    {"wclifb09.ubn", "", int32_t(0x00000000), int32_t(0x67B75F56)},
    {"wclifb09.urb", "", int32_t(0x00000000), int32_t(0x24C3012C)},
    {"wclifb10.ubn", "", int32_t(0x00000000), int32_t(0xA1FBEE82)},
    {"wclifb10.urb", "", int32_t(0x00000000), int32_t(0xE28FB0F8)},
    {"wclifb11.ubn", "", int32_t(0x00000000), int32_t(0x9C9BC732)},
    {"wclifb11.urb", "", int32_t(0x00000000), int32_t(0xDFEF9948)},
    {"wclifb12.ubn", "", int32_t(0x00000000), int32_t(0xDB3BBDE2)},
    {"wclifb12.urb", "", int32_t(0x00000000), int32_t(0x984FE398)},
    {"wclifc01.ubn", "", int32_t(0x00000000), int32_t(0xF1B01F23)},
    {"wclifc01.urb", "", int32_t(0x00000000), int32_t(0xB2C44159)},
    {"wclifc02.ubn", "", int32_t(0x00000000), int32_t(0xB61065F3)},
    {"wclifc02.urb", "", int32_t(0x00000000), int32_t(0xF5643B89)},
    {"wclifc03.ubn", "", int32_t(0x00000000), int32_t(0x8B704C43)},
    {"wclifc03.urb", "", int32_t(0x00000000), int32_t(0xC8041239)},
    {"wclifc04.ubn", "", int32_t(0x00000000), int32_t(0x39509053)},
    {"wclifc04.urb", "", int32_t(0x00000000), int32_t(0x7A24CE29)},
    {"wcliff01.des", "", int32_t(0x00000000), int32_t(0x922B03DD)},
    {"wcliff01.sno", "-", int32_t(0x00000000), int32_t(0x7CB733AC)},
    {"wcliff01.tem", "-", int32_t(0x00000000), int32_t(0x74029DCE)},
    {"wcliff01.ubn", "", int32_t(0x00000000), int32_t(0xA3883084)},
    {"wcliff01.urb", "", int32_t(0x00000000), int32_t(0xE0FC6EFE)},
    {"wcliff02.des", "", int32_t(0x00000000), int32_t(0xD58B790D)},
    {"wcliff02.sno", "-", int32_t(0x00000000), int32_t(0x3B17497C)},
    {"wcliff02.tem", "-", int32_t(0x00000000), int32_t(0x33A2E71E)},
    {"wcliff02.ubn", "", int32_t(0x00000000), int32_t(0xE4284A54)},
    {"wcliff02.urb", "", int32_t(0x00000000), int32_t(0xA75C142E)},
    {"wcliff03.des", "", int32_t(0x00000000), int32_t(0xE8EB50BD)},
    {"wcliff03.sno", "-", int32_t(0x00000000), int32_t(0x067760CC)},
    {"wcliff03.tem", "-", int32_t(0x00000000), int32_t(0x0EC2CEAE)},
    {"wcliff03.ubn", "", int32_t(0x00000000), int32_t(0xD94863E4)},
    {"wcliff03.urb", "", int32_t(0x00000000), int32_t(0x9A3C3D9E)},
    {"wcliff04.des", "", int32_t(0x00000000), int32_t(0x5ACB8CAD)},
    {"wcliff04.sno", "-", int32_t(0x00000000), int32_t(0xB457BCDC)},
    {"wcliff04.tem", "-", int32_t(0x00000000), int32_t(0xBCE212BE)},
    {"wcliff04.ubn", "", int32_t(0x00000000), int32_t(0x6B68BFF4)},
    {"wcliff04.urb", "", int32_t(0x00000000), int32_t(0x281CE18E)},
    {"wcliff05.des", "", int32_t(0x00000000), int32_t(0x67ABA51D)},
    {"wcliff05.sno", "-", int32_t(0x00000000), int32_t(0x8937956C)},
    {"wcliff05.tem", "-", int32_t(0x00000000), int32_t(0x81823B0E)},
    {"wcliff05.ubn", "", int32_t(0x00000000), int32_t(0x56089644)},
    {"wcliff05.urb", "", int32_t(0x00000000), int32_t(0x157CC83E)},
    {"wcliff06.des", "", int32_t(0x00000000), int32_t(0x200BDFCD)},
    {"wcliff06.sno", "-", int32_t(0x00000000), int32_t(0xCE97EFBC)},
    {"wcliff06.tem", "-", int32_t(0x00000000), int32_t(0xC62241DE)},
    {"wcliff06.ubn", "", int32_t(0x00000000), int32_t(0x11A8EC94)},
    {"wcliff06.urb", "", int32_t(0x00000000), int32_t(0x52DCB2EE)},
    {"wcliff07.des", "", int32_t(0x00000000), int32_t(0x1D6BF67D)},
    {"wcliff07.sno", "-", int32_t(0x00000000), int32_t(0xF3F7C60C)},
    {"wcliff07.tem", "-", int32_t(0x00000000), int32_t(0xFB42686E)},
    {"wcliff07.ubn", "", int32_t(0x00000000), int32_t(0x2CC8C524)},
    {"wcliff07.urb", "", int32_t(0x00000000), int32_t(0x6FBC9B5E)},
    {"wcliff08.des", "", int32_t(0x00000000), int32_t(0x9F3B61AC)},
    {"wcliff08.sno", "-", int32_t(0x00000000), int32_t(0x71A751DD)},
    {"wcliff08.tem", "-", int32_t(0x00000000), int32_t(0x7912FFBF)},
    {"wcliff08.ubn", "", int32_t(0x00000000), int32_t(0xAE9852F5)},
    {"wcliff08.urb", "", int32_t(0x00000000), int32_t(0xEDEC0C8F)},
    {"wcliff09.des", "", int32_t(0x00000000), int32_t(0xA25B481C)},
    {"wcliff09.sno", "-", int32_t(0x00000000), int32_t(0x4CC7786D)},
    {"wcliff09.tem", "-", int32_t(0x00000000), int32_t(0x4472D60F)},
    {"wcliff09.ubn", "", int32_t(0x00000000), int32_t(0x93F87B45)},
    {"wcliff09.urb", "", int32_t(0x00000000), int32_t(0xD08C253F)},
    {"wcliff10.des", "", int32_t(0x00000000), int32_t(0x6417F9C8)},
    {"wcliff10.sno", "-", int32_t(0x00000000), int32_t(0x8A8BC9B9)},
    {"wcliff10.tem", "-", int32_t(0x00000000), int32_t(0x823E67DB)},
    {"wcliff10.ubn", "", int32_t(0x00000000), int32_t(0x55B4CA91)},
    {"wcliff10.urb", "", int32_t(0x00000000), int32_t(0x16C094EB)},
    {"wcliff11.des", "", int32_t(0x00000000), int32_t(0x5977D078)},
    {"wcliff11.sno", "-", int32_t(0x00000000), int32_t(0xB7EBE009)},
    {"wcliff11.tem", "-", int32_t(0x00000000), int32_t(0xBF5E4E6B)},
    {"wcliff11.ubn", "", int32_t(0x00000000), int32_t(0x68D4E321)},
    {"wcliff11.urb", "", int32_t(0x00000000), int32_t(0x2BA0BD5B)},
    {"wcliff12.des", "", int32_t(0x00000000), int32_t(0x1ED7AAA8)},
    {"wcliff12.sno", "-", int32_t(0x00000000), int32_t(0xF04B9AD9)},
    {"wcliff12.tem", "-", int32_t(0x00000000), int32_t(0xF8FE34BB)},
    {"wcliff12.ubn", "", int32_t(0x00000000), int32_t(0x2F7499F1)},
    {"wcliff12.urb", "", int32_t(0x00000000), int32_t(0x6C00C78B)},
    {"wcliff13.des", "", int32_t(0x00000000), int32_t(0x23B78318)},
    {"wcliff13.sno", "-", int32_t(0x00000000), int32_t(0xCD2BB369)},
    {"wcliff13.tem", "-", int32_t(0x00000000), int32_t(0xC59E1D0B)},
    {"wcliff13.ubn", "", int32_t(0x00000000), int32_t(0x1214B041)},
    {"wcliff13.urb", "", int32_t(0x00000000), int32_t(0x5160EE3B)},
    {"wcliff14.des", "", int32_t(0x00000000), int32_t(0x91975F08)},
    {"wcliff14.sno", "-", int32_t(0x00000000), int32_t(0x7F0B6F79)},
    {"wcliff14.tem", "-", int32_t(0x00000000), int32_t(0x77BEC11B)},
    {"wcliff14.ubn", "", int32_t(0x00000000), int32_t(0xA0346C51)},
    {"wcliff14.urb", "", int32_t(0x00000000), int32_t(0xE340322B)},
    {"wcliff15.des", "", int32_t(0x00000000), int32_t(0xACF776B8)},
    {"wcliff15.sno", "-", int32_t(0x00000000), int32_t(0x426B46C9)},
    {"wcliff15.tem", "-", int32_t(0x00000000), int32_t(0x4ADEE8AB)},
    {"wcliff15.ubn", "", int32_t(0x00000000), int32_t(0x9D5445E1)},
    {"wcliff15.urb", "", int32_t(0x00000000), int32_t(0xDE201B9B)},
    {"wcliff16.des", "", int32_t(0x00000000), int32_t(0xEB570C68)},
    {"wcliff16.sno", "-", int32_t(0x00000000), int32_t(0x05CB3C19)},
    {"wcliff16.tem", "-", int32_t(0x00000000), int32_t(0x0D7E927B)},
    {"wcliff16.ubn", "", int32_t(0x00000000), int32_t(0xDAF43F31)},
    {"wcliff16.urb", "", int32_t(0x00000000), int32_t(0x9980614B)},
    {"wcliff17.des", "", int32_t(0x00000000), int32_t(0xD63725D8)},
    {"wcliff17.sno", "-", int32_t(0x00000000), int32_t(0x38AB15A9)},
    {"wcliff17.tem", "-", int32_t(0x00000000), int32_t(0x301EBBCB)},
    {"wcliff17.ubn", "", int32_t(0x00000000), int32_t(0xE7941681)},
    {"wcliff17.urb", "", int32_t(0x00000000), int32_t(0xA4E048FB)},
    {"wcliff18.des", "", int32_t(0x00000000), int32_t(0x5467B209)},
    {"wcliff18.sno", "-", int32_t(0x00000000), int32_t(0xBAFB8278)},
    {"wcliff18.tem", "-", int32_t(0x00000000), int32_t(0xB24E2C1A)},
    {"wcliff18.ubn", "", int32_t(0x00000000), int32_t(0x65C48150)},
    {"wcliff18.urb", "", int32_t(0x00000000), int32_t(0x26B0DF2A)},
    {"wcliff19.des", "", int32_t(0x00000000), int32_t(0x69079BB9)},
    {"wcliff19.sno", "-", int32_t(0x00000000), int32_t(0x879BABC8)},
    {"wcliff19.tem", "-", int32_t(0x00000000), int32_t(0x8F2E05AA)},
    {"wcliff19.ubn", "", int32_t(0x00000000), int32_t(0x58A4A8E0)},
    {"wcliff19.urb", "", int32_t(0x00000000), int32_t(0x1BD0F69A)},
    {"wcliff20.des", "", int32_t(0x00000000), int32_t(0xE2838B66)},
    {"wcliff20.sno", "-", int32_t(0x00000000), int32_t(0x0C1FBB17)},
    {"wcliff20.tem", "-", int32_t(0x00000000), int32_t(0x04AA1575)},
    {"wcliff20.ubn", "", int32_t(0x00000000), int32_t(0xD320B83F)},
    {"wcliff20.urb", "", int32_t(0x00000000), int32_t(0x9054E645)},
    {"wcliff21.des", "", int32_t(0x00000000), int32_t(0xDFE3A2D6)},
    {"wcliff21.sno", "-", int32_t(0x00000000), int32_t(0x317F92A7)},
    {"wcliff21.tem", "-", int32_t(0x00000000), int32_t(0x39CA3CC5)},
    {"wcliff21.ubn", "", int32_t(0x00000000), int32_t(0xEE40918F)},
    {"wcliff21.urb", "", int32_t(0x00000000), int32_t(0xAD34CFF5)},
    {"wcliff22.des", "", int32_t(0x00000000), int32_t(0x9843D806)},
    {"wcliff22.sno", "-", int32_t(0x00000000), int32_t(0x76DFE877)},
    {"wcliff22.tem", "-", int32_t(0x00000000), int32_t(0x7E6A4615)},
    {"wcliff22.ubn", "", int32_t(0x00000000), int32_t(0xA9E0EB5F)},
    {"wcliff22.urb", "", int32_t(0x00000000), int32_t(0xEA94B525)},
    {"wcliff23.des", "", int32_t(0x00000000), int32_t(0xA523F1B6)},
    {"wcliff23.sno", "-", int32_t(0x00000000), int32_t(0x4BBFC1C7)},
    {"wcliff23.tem", "-", int32_t(0x00000000), int32_t(0x430A6FA5)},
    {"wcliff23.ubn", "", int32_t(0x00000000), int32_t(0x9480C2EF)},
    {"wcliff23.urb", "", int32_t(0x00000000), int32_t(0xD7F49C95)},
    {"wcliff24.des", "", int32_t(0x00000000), int32_t(0x17032DA6)},
    {"wcliff24.sno", "-", int32_t(0x00000000), int32_t(0xF99F1DD7)},
    {"wcliff24.tem", "-", int32_t(0x00000000), int32_t(0xF12AB3B5)},
    {"wcliff24.ubn", "", int32_t(0x00000000), int32_t(0x26A01EFF)},
    {"wcliff24.urb", "", int32_t(0x00000000), int32_t(0x65D44085)},
    {"wcliff25.des", "", int32_t(0x00000000), int32_t(0x2A630416)},
    {"wcliff25.sno", "-", int32_t(0x00000000), int32_t(0xC4FF3467)},
    {"wcliff25.tem", "-", int32_t(0x00000000), int32_t(0xCC4A9A05)},
    {"wcliff25.ubn", "", int32_t(0x00000000), int32_t(0x1BC0374F)},
    {"wcliff25.urb", "", int32_t(0x00000000), int32_t(0x58B46935)},
    {"wcliff26.des", "", int32_t(0x00000000), int32_t(0x6DC37EC6)},
    {"wcliff26.sno", "-", int32_t(0x00000000), int32_t(0x835F4EB7)},
    {"wcliff26.tem", "-", int32_t(0x00000000), int32_t(0x8BEAE0D5)},
    {"wcliff26.ubn", "", int32_t(0x00000000), int32_t(0x5C604D9F)},
    {"wcliff26.urb", "", int32_t(0x00000000), int32_t(0x1F1413E5)},
    {"wcliff27.des", "", int32_t(0x00000000), int32_t(0x50A35776)},
    {"wcliff27.sno", "-", int32_t(0x00000000), int32_t(0xBE3F6707)},
    {"wcliff27.tem", "-", int32_t(0x00000000), int32_t(0xB68AC965)},
    {"wcliff27.ubn", "", int32_t(0x00000000), int32_t(0x6100642F)},
    {"wcliff27.urb", "", int32_t(0x00000000), int32_t(0x22743A55)},
    {"wcliff28.des", "", int32_t(0x00000000), int32_t(0xD2F3C0A7)},
    {"wcliff28.sno", "-", int32_t(0x00000000), int32_t(0x3C6FF0D6)},
    {"wcliff28.tem", "-", int32_t(0x00000000), int32_t(0x34DA5EB4)},
    {"wcliff28.ubn", "", int32_t(0x00000000), int32_t(0xE350F3FE)},
    {"wcliff28.urb", "", int32_t(0x00000000), int32_t(0xA024AD84)},
    {"wclifx01.sno", "", int32_t(0x00000000), int32_t(0x4B56D43F)},
    {"wclifx01.ubn", "", int32_t(0x00000000), int32_t(0x9469D717)},
    {"wclifx02.sno", "", int32_t(0x00000000), int32_t(0x0CF6AEEF)},
    {"wclifx02.ubn", "", int32_t(0x00000000), int32_t(0xD3C9ADC7)},
    {"wclifx03.sno", "", int32_t(0x00000000), int32_t(0x3196875F)},
    {"wclifx03.ubn", "", int32_t(0x00000000), int32_t(0xEEA98477)},
    {"wclifx04.sno", "", int32_t(0x00000000), int32_t(0x83B65B4F)},
    {"wclifx04.ubn", "", int32_t(0x00000000), int32_t(0x5C895867)},
    {"wclifx05.sno", "", int32_t(0x00000000), int32_t(0xBED672FF)},
    {"wclifx05.ubn", "", int32_t(0x00000000), int32_t(0x61E971D7)},
    {"wclifx06.sno", "", int32_t(0x00000000), int32_t(0xF976082F)},
    {"wclifx06.ubn", "", int32_t(0x00000000), int32_t(0x26490B07)},
    {"wclifx07.sno", "", int32_t(0x00000000), int32_t(0xC416219F)},
    {"wclifx07.ubn", "", int32_t(0x00000000), int32_t(0x1B2922B7)},
    {"wclifx08.sno", "", int32_t(0x00000000), int32_t(0x4646B64E)},
    {"wclifx08.ubn", "", int32_t(0x00000000), int32_t(0x9979B566)},
    {"wclifx09.sno", "", int32_t(0x00000000), int32_t(0x7B269FFE)},
    {"wclifx09.ubn", "", int32_t(0x00000000), int32_t(0xA4199CD6)},
    {"wclifx10.sno", "", int32_t(0x00000000), int32_t(0xBD6A2E2A)},
    {"wclifx10.ubn", "", int32_t(0x00000000), int32_t(0x62552D02)},
    {"wclifx11.sno", "", int32_t(0x00000000), int32_t(0x800A079A)},
    {"wclifx11.ubn", "", int32_t(0x00000000), int32_t(0x5F3504B2)},
    {"wclifx12.sno", "", int32_t(0x00000000), int32_t(0xC7AA7D4A)},
    {"wclifx12.ubn", "", int32_t(0x00000000), int32_t(0x18957E62)},
    {"wclifx13.sno", "", int32_t(0x00000000), int32_t(0xFACA54FA)},
    {"wclifx13.ubn", "", int32_t(0x00000000), int32_t(0x25F557D2)},
    {"wclifx14.sno", "", int32_t(0x00000000), int32_t(0x48EA88EA)},
    {"wclifx14.ubn", "", int32_t(0x00000000), int32_t(0x97D58BC2)},
    {"wclifx15.sno", "", int32_t(0x00000000), int32_t(0x758AA15A)},
    {"wclifx15.ubn", "", int32_t(0x00000000), int32_t(0xAAB5A272)},
    {"wclifx16.sno", "", int32_t(0x00000000), int32_t(0x322ADB8A)},
    {"wclifx16.ubn", "", int32_t(0x00000000), int32_t(0xED15D8A2)},
    {"wclifx17.sno", "", int32_t(0x00000000), int32_t(0x0F4AF23A)},
    {"wclifx17.ubn", "", int32_t(0x00000000), int32_t(0xD075F112)},
    {"wclifx18.sno", "", int32_t(0x00000000), int32_t(0x8D1A65EB)},
    {"wclifx18.ubn", "", int32_t(0x00000000), int32_t(0x522566C3)},
    {"wclifx19.sno", "", int32_t(0x00000000), int32_t(0xB07A4C5B)},
    {"wclifx19.ubn", "", int32_t(0x00000000), int32_t(0x6F454F73)},
    {"wclifx20.sno", "", int32_t(0x00000000), int32_t(0x3BFE5C84)},
    {"wclifx20.ubn", "", int32_t(0x00000000), int32_t(0xE4C15FAC)},
    {"wclifx21.sno", "", int32_t(0x00000000), int32_t(0x069E7534)},
    {"wclifx21.ubn", "", int32_t(0x00000000), int32_t(0xD9A1761C)},
    {"wclifx22.sno", "", int32_t(0x00000000), int32_t(0x413E0FE4)},
    {"wclifx22.ubn", "", int32_t(0x00000000), int32_t(0x9E010CCC)},
    {"wclifx23.sno", "", int32_t(0x00000000), int32_t(0x7C5E2654)},
    {"wclifx23.ubn", "", int32_t(0x00000000), int32_t(0xA361257C)},
    {"wclifx24.sno", "", int32_t(0x00000000), int32_t(0xCE7EFA44)},
    {"wclifx24.ubn", "", int32_t(0x00000000), int32_t(0x1141F96C)},
    {"wclifx25.sno", "", int32_t(0x00000000), int32_t(0xF31ED3F4)},
    {"wclifx25.ubn", "", int32_t(0x00000000), int32_t(0x2C21D0DC)},
    {"wclifx26.sno", "", int32_t(0x00000000), int32_t(0xB4BEA924)},
    {"wclifx26.ubn", "", int32_t(0x00000000), int32_t(0x6B81AA0C)},
    {"wclifx27.sno", "", int32_t(0x00000000), int32_t(0x89DE8094)},
    {"wclifx27.ubn", "", int32_t(0x00000000), int32_t(0x56E183BC)},
    {"wclifx28.sno", "", int32_t(0x00000000), int32_t(0x0B8E1745)},
    {"wclifx28.ubn", "", int32_t(0x00000000), int32_t(0xD4B1146D)},
    {"wclock.mrf", "???", int32_t(0xD78DEA35), int32_t(0x00000000)},
    {"wcrate.des", "", int32_t(0x00000000), int32_t(0xA9AE9965)},
    {"wcrate.lun", "", int32_t(0x00000000), int32_t(0xC08EA57C)},
    {"wcrate.shp", "wood crate", int32_t(0xABA5E84D), int32_t(0x00000000)},
    {"wcrate.sno", "", int32_t(0x00000000), int32_t(0x2E81D66A)},
    {"wcrate.tem", "", int32_t(0x00000000), int32_t(0xDFF6809D)},
    {"wcrate.ubn", "", int32_t(0x00000000), int32_t(0xE363BA6E)},
    {"wcrate.urb", "", int32_t(0x00000000), int32_t(0xA7D704F1)},
    {"wd01x.des", "", int32_t(0x00000000), int32_t(0xA20BB87B)},
    {"wd01x.sno", "-", int32_t(0x00000000), int32_t(0x23B1527C)},
    {"wd01x.tem", "-", int32_t(0x00000000), int32_t(0x3F5598F0)},
    {"wd01x.urb", "", int32_t(0x00000000), int32_t(0x698D11CF)},
    {"wd02x.des", "", int32_t(0x00000000), int32_t(0x9B8684BE)},
    {"wd02x.sno", "-", int32_t(0x00000000), int32_t(0x1A3C6EB9)},
    {"wd02x.tem", "-", int32_t(0x00000000), int32_t(0x06D8A435)},
    {"wd02x.urb", "", int32_t(0x00000000), int32_t(0x50002D0A)},
    {"wd03x.des", "", int32_t(0x00000000), int32_t(0x8CFD90FD)},
    {"wd03x.sno", "-", int32_t(0x00000000), int32_t(0x0D477AFA)},
    {"wd03x.tem", "-", int32_t(0x00000000), int32_t(0x11A3B076)},
    {"wd03x.urb", "", int32_t(0x00000000), int32_t(0x477B3949)},
    {"wd04x.des", "", int32_t(0x00000000), int32_t(0xE89CFD34)},
    {"wd04x.sno", "-", int32_t(0x00000000), int32_t(0x69261733)},
    {"wd04x.tem", "-", int32_t(0x00000000), int32_t(0x75C2DDBF)},
    {"wd04x.urb", "", int32_t(0x00000000), int32_t(0x231A5480)},
    {"wdoma01.wav", "", int32_t(0x00000000), int32_t(0xBB22FE34)},
    {"wdoma02.wav", "", int32_t(0x00000000), int32_t(0x3DB68C9A)},
    {"wdoma03.wav", "", int32_t(0x00000000), int32_t(0xF6EA5F3F)},
    {"wdoma04.wav", "", int32_t(0x00000000), int32_t(0xEBEF6F87)},
    {"wdoma05.wav", "", int32_t(0x00000000), int32_t(0x20B3BC22)},
    {"wdoma06.wav", "", int32_t(0x00000000), int32_t(0xA627CE8C)},
    {"wdoma07.wav", "", int32_t(0x00000000), int32_t(0x6D7B1D29)},
    {"wdoma08.wav", "", int32_t(0x00000000), int32_t(0x9C2DAFFC)},
    {"wdoma09.wav", "", int32_t(0x00000000), int32_t(0x57717C59)},
    {"wdoma10.wav", "", int32_t(0x00000000), int32_t(0xD6092625)},
    {"wdoma11.wav", "", int32_t(0x00000000), int32_t(0x1D55F580)},
    {"wdoma12.wav", "", int32_t(0x00000000), int32_t(0x9BC1872E)},
    {"wdoma13.wav", "", int32_t(0x00000000), int32_t(0x509D548B)},
    {"wdoma14.wav", "", int32_t(0x00000000), int32_t(0x4D986433)},
    {"wdoma15.wav", "", int32_t(0x00000000), int32_t(0x86C4B796)},
    {"wdoma16.wav", "", int32_t(0x00000000), int32_t(0x0050C538)},
    {"wdoma17.wav", "", int32_t(0x00000000), int32_t(0xCB0C169D)},
    {"wdoma18.wav", "", int32_t(0x00000000), int32_t(0x3A5AA448)},
    {"wdoma19.wav", "", int32_t(0x00000000), int32_t(0xF10677ED)},
    {"wdoma20.wav", "", int32_t(0x00000000), int32_t(0xE7E13CB8)},
    {"wdoma21.wav", "", int32_t(0x00000000), int32_t(0x2CBDEF1D)},
    {"wdoma22.wav", "", int32_t(0x00000000), int32_t(0xAA299DB3)},
    {"wdoma23.wav", "", int32_t(0x00000000), int32_t(0x61754E16)},
    {"wdoma24.wav", "", int32_t(0x00000000), int32_t(0x7C707EAE)},
    {"wdoma25.wav", "", int32_t(0x00000000), int32_t(0xB72CAD0B)},
    {"wdoma26.wav", "", int32_t(0x00000000), int32_t(0x31B8DFA5)},
    {"wdoms01.wav", "", int32_t(0x00000000), int32_t(0x85BCC862)},
    {"wdoms02.wav", "", int32_t(0x00000000), int32_t(0x0328BACC)},
    {"wdoms03.wav", "", int32_t(0x00000000), int32_t(0xC8746969)},
    {"wdoms04.wav", "", int32_t(0x00000000), int32_t(0xD57159D1)},
    {"wdoms05.wav", "", int32_t(0x00000000), int32_t(0x1E2D8A74)},
    {"wdoms06.wav", "", int32_t(0x00000000), int32_t(0x98B9F8DA)},
    {"wdoms07.wav", "", int32_t(0x00000000), int32_t(0x53E52B7F)},
    {"wdoms08.wav", "", int32_t(0x00000000), int32_t(0xA2B399AA)},
    {"wdoms09.wav", "", int32_t(0x00000000), int32_t(0x69EF4A0F)},
    {"wdoms10.wav", "", int32_t(0x00000000), int32_t(0xE8971073)},
    {"wdoms11.wav", "", int32_t(0x00000000), int32_t(0x23CBC3D6)},
    {"wdoms12.wav", "", int32_t(0x00000000), int32_t(0xA55FB178)},
    {"wdoms13.wav", "", int32_t(0x00000000), int32_t(0x6E0362DD)},
    {"wdoms14.wav", "", int32_t(0x00000000), int32_t(0x73065265)},
    {"wdoms15.wav", "", int32_t(0x00000000), int32_t(0xB85A81C0)},
    {"wdoms16.wav", "", int32_t(0x00000000), int32_t(0x3ECEF36E)},
    {"wdoms17.wav", "", int32_t(0x00000000), int32_t(0xF59220CB)},
    {"wdoms18.wav", "", int32_t(0x00000000), int32_t(0x04C4921E)},
    {"wdoms19.wav", "", int32_t(0x00000000), int32_t(0xCF9841BB)},
    {"wdoms20.wav", "", int32_t(0x00000000), int32_t(0xD97F0AEE)},
    {"wdoms21.wav", "", int32_t(0x00000000), int32_t(0x1223D94B)},
    {"wdoms22.wav", "", int32_t(0x00000000), int32_t(0x94B7ABE5)},
    {"wdoms23.wav", "", int32_t(0x00000000), int32_t(0x5FEB7840)},
    {"wdoms24.wav", "", int32_t(0x00000000), int32_t(0x42EE48F8)},
    {"wdoms25.wav", "", int32_t(0x00000000), int32_t(0x89B29B5D)},
    {"wdt.pal", "", int32_t(0x00000000), int32_t(0x1CFB16BE)},
    {"wdtbkbtn.pcx", "", int32_t(0x00000000), int32_t(0x503637AD)},
    {"wdtbtm640.pcx", "", int32_t(0x00000000), int32_t(0x5F402B34)},
    {"wdtchoice.ini", "-", int32_t(0x00000000), int32_t(0xA91DA00A)},
    {"wdtfc.pcx", "-", int32_t(0x00000000), int32_t(0x7B34AD7F)},
    {"wdtfc.vqa", "", int32_t(0x00000000), int32_t(0x6537934D)},
    {"wdtfs.pal", "", int32_t(0x00000000), int32_t(0x96400CD4)},
    {"wdtfsasm.pcx", "", int32_t(0x00000000), int32_t(0xC9C91CCA)},
    {"wdtfsbsm.pcx", "", int32_t(0x00000000), int32_t(0xF8210657)},
    {"wdtfsssm.pcx", "", int32_t(0x00000000), int32_t(0x3988912D)},
    {"wdthist.ini", "-", int32_t(0x00000000), int32_t(0x69B97B4F)},
    {"wdtmap.ini", "-", int32_t(0x00000000), int32_t(0xC3F03F0D)},
    {"wdtsd640.pcx", "", int32_t(0x00000000), int32_t(0x649CD6FF)},
    {"wdttarget1.shp", "", int32_t(0x00000000), int32_t(0xE83FCE15)},
    {"wdttrgt.pal", "", int32_t(0x00000000), int32_t(0xCA37F4E7)},
    {"weaficon.shp", "icon: war factory fake", int32_t(0x05EBEF1D), int32_t(0x00000000)},
    {"weap.shp", "war factory", int32_t(0xF0CADDDC), int32_t(0x00000000)},
    {"weap2.shp", "war factory base", int32_t(0xD1AB7211), int32_t(0x00000000)},
    {"weapicnh.des", "icon: war factory", int32_t(0x24E6E01D), int32_t(0x00000000)},
    {"weapicnh.tem", "icon: war factory", int32_t(0x1EE6F01D), int32_t(0x00000000)},
    {"weapicnh.win", "icon: war factory", int32_t(0x1FEAF31D), int32_t(0x00000000)},
    {"weapicon.shp", "icon: war factory", int32_t(0x2DEBEF1D), int32_t(0xB023D907)},
    {"weapmake.shp", "make: war factory", int32_t(0x1BE3EB25), int32_t(0x00000000)},
    {"weaticon.shp", "icon: ?", int32_t(0x00000000), int32_t(0xEDCF880B)},
    {"web.shp", "-", int32_t(0x00000000), int32_t(0x941035B0)},
    {"webguy.shp", "-", int32_t(0x00000000), int32_t(0x25260CCB)},
    {"webshot1.aud", "", int32_t(0xF406F51B), int32_t(0x00000000)},
    {"webtear1.aud", "", int32_t(0xF802D915), int32_t(0x00000000)},
    {"webtear2.aud", "", int32_t(0xFA02D915), int32_t(0x00000000)},
    {"webtear3.aud", "", int32_t(0xFC02D915), int32_t(0x00000000)},
    {"webtear4.aud", "", int32_t(0xFE02D915), int32_t(0x00000000)},
    {"webtear5.aud", "", int32_t(0x0002D915), int32_t(0x00000000)},
    {"weed.hva", "-", int32_t(0x00000000), int32_t(0x0D4A959F)},
    {"weed.shp", "unit: ?", int32_t(0x00000000), int32_t(0xA3C8C623)},
    {"weed.vxl", "weedeater", int32_t(0x00000000), int32_t(0xFBC04AD6)},
    {"weedicon.shp", "icon: weed eater", int32_t(0x00000000), int32_t(0x48E46A00)},
    {"welcome.cps", "pict:", int32_t(0x6A0F003E), int32_t(0x00000000)},
    {"westlogo.bik", "", int32_t(0x00000000), int32_t(0x1E7D27F9)},
    {"wetfoot1.aud", "", int32_t(0xC04EF529), int32_t(0x00000000)},
    {"wetfoot2.aud", "", int32_t(0xC24EF529), int32_t(0x00000000)},
    {"wetfoot3.aud", "", int32_t(0xC44EF529), int32_t(0x00000000)},
    {"wetfoot4.aud", "", int32_t(0xC64EF529), int32_t(0x00000000)},
    {"wetfoot5.aud", "", int32_t(0xC84EF529), int32_t(0x00000000)},
    {"wetfoot6.aud", "", int32_t(0xCA4EF529), int32_t(0x00000000)},
    {"wethb.shp", "", int32_t(0x00000000), int32_t(0x4C20C0D9)},
    {"wethicon.shp", "", int32_t(0x00000000), int32_t(0x66BC73C2)},
    {"wetstep1.aud", "", int32_t(0xF446E133), int32_t(0x00000000)},
    {"wetstep2.aud", "", int32_t(0xF646E133), int32_t(0x00000000)},
    {"wetstep3.aud", "", int32_t(0xF846E133), int32_t(0x00000000)},
    {"wetstep4.aud", "", int32_t(0xFA46E133), int32_t(0x00000000)},
    {"wetstep5.aud", "", int32_t(0xFC46E133), int32_t(0x00000000)},
    {"wetstep6.aud", "", int32_t(0xFE46E133), int32_t(0x00000000)},
    {"wgreen.mrf", "???", int32_t(0xAFA60039), int32_t(0x00000000)},
    {"whatlurk.aud", "what lurks", int32_t(0x00000000), int32_t(0xE70933D6)},
    {"whatthe1.aud", "", int32_t(0xF7E4F333), int32_t(0x00000000)},
    {"whistle1.aud", "", int32_t(0xF404FB33), int32_t(0x00000000)},
    {"whistle2.aud", "", int32_t(0xF604FB33), int32_t(0x00000000)},
    {"whistle3.aud", "", int32_t(0xF804FB33), int32_t(0x00000000)},
    {"whistle4.aud", "", int32_t(0xFA04FB33), int32_t(0x00000000)},
    {"whistle5.aud", "", int32_t(0xFC04FB33), int32_t(0x00000000)},
    {"whistle6.aud", "", int32_t(0xFE04FB33), int32_t(0x00000000)},
    {"whitlite.shp", "", int32_t(0x00000000), int32_t(0xC7DD179B)},
    {"whooshy3.aud", "", int32_t(0xE844F331), int32_t(0x00000000)},
    {"whtdoor1.aud", "", int32_t(0xB84B0129), int32_t(0x00000000)},
    {"whtdoor2.aud", "", int32_t(0xBA4B0129), int32_t(0x00000000)},
    {"wildbat1.aud", "", int32_t(0xB82EE90F), int32_t(0x00000000)},
    {"wildcat1.aud", "", int32_t(0xB82EE911), int32_t(0x00000000)},
    {"wildcat2.aud", "", int32_t(0xBA2EE911), int32_t(0x00000000)},
    {"wildcat3.aud", "", int32_t(0xBC2EE911), int32_t(0x00000000)},
    {"wildcat4.aud", "", int32_t(0xBE2EE911), int32_t(0x00000000)},
    {"wildcat5.aud", "", int32_t(0xC02EE911), int32_t(0x00000000)},
    {"wildcat6.aud", "", int32_t(0xC22EE911), int32_t(0x00000000)},
    {"win1.aud", "great shot!", int32_t(0xA6F1D3DC), int32_t(0x00000000)},
    {"win1.var", "great shot! sfx", int32_t(0xB4DDE8DC), int32_t(0x00000000)},
    {"wind1r.aud", "", int32_t(0x93960E14), int32_t(0x00000000)},
    {"wind2r.aud", "", int32_t(0x93960E16), int32_t(0x00000000)},
    {"wind3r.aud", "", int32_t(0x93960E18), int32_t(0x00000000)},
    {"wind4r.aud", "", int32_t(0x93960E1A), int32_t(0x00000000)},
    {"wind5r.aud", "", int32_t(0x93960E1C), int32_t(0x00000000)},
    {"wind6r.aud", "", int32_t(0x93960E1E), int32_t(0x00000000)},
    {"windin1.aud", "", int32_t(0x6DE01730), int32_t(0x00000000)},
    {"windin2.aud", "", int32_t(0x6DE21730), int32_t(0x00000000)},
    {"windloop.aud", "", int32_t(0xF62D0523), int32_t(0x00000000)},
    {"windlop8.aud", "", int32_t(0xC62F0523), int32_t(0x00000000)},
    {"windowc1.aud", "", int32_t(0xB8151529), int32_t(0x00000000)},
    {"windowo1.aud", "", int32_t(0xB82D1529), int32_t(0x00000000)},
    {"windy1.aud", "", int32_t(0x9395CC64), int32_t(0x00000000)},
    {"windy2.aud", "", int32_t(0x9395CE64), int32_t(0x00000000)},
    {"windy3.aud", "", int32_t(0x9395D064), int32_t(0x00000000)},
    {"wini.hva", "-", int32_t(0x00000000), int32_t(0x58BDCB99)},
    {"wini.vxl", "rv", int32_t(0x00000000), int32_t(0xAE3714D0)},
    {"winter.inf", "inf: list for winter.mix", int32_t(0xE3961035), int32_t(0x00000000)},
    {"winter.pal", "pal: winter", int32_t(0xF1961628), int32_t(0x00000000)},
    {"winticnh.inf", "inf: list for winticnh.mix", int32_t(0x2823F51D), int32_t(0x00000000)},
    {"wipe.aud", "-", int32_t(0x00000000), int32_t(0xF007D9B0)},
    {"wldboar1.aud", "", int32_t(0xB00AF529), int32_t(0x00000000)},
    {"wldboar2.aud", "", int32_t(0xB20AF529), int32_t(0x00000000)},
    {"wlight.mrf", "???", int32_t(0xB782203F), int32_t(0x00000000)},
    {"wlkcrek1.aud", "", int32_t(0xB418FD2F), int32_t(0x00000000)},
    {"wlkcrek2.aud", "", int32_t(0xB618FD2F), int32_t(0x00000000)},
    {"wlkcrek3.aud", "", int32_t(0xB818FD2F), int32_t(0x00000000)},
    {"wlkcrek4.aud", "", int32_t(0xBA18FD2F), int32_t(0x00000000)},
    {"wlkcrek5.aud", "", int32_t(0xBC18FD2F), int32_t(0x00000000)},
    {"wlkcrek6.aud", "", int32_t(0xBE18FD2F), int32_t(0x00000000)},
    {"wlkcrek7.aud", "", int32_t(0xC018FD2F), int32_t(0x00000000)},
    {"wlkduct1.aud", "", int32_t(0xB82AF935), int32_t(0x00000000)},
    {"wlkduct2.aud", "", int32_t(0xBA2AF935), int32_t(0x00000000)},
    {"wlkduct3.aud", "", int32_t(0xBC2AF935), int32_t(0x00000000)},
    {"wlkduct4.aud", "", int32_t(0xBE2AF935), int32_t(0x00000000)},
    {"wlkduct5.aud", "", int32_t(0xC02AF935), int32_t(0x00000000)},
    {"wlkduct6.aud", "", int32_t(0xC22AF935), int32_t(0x00000000)},
    {"wlkduct7.aud", "", int32_t(0xC42AF935), int32_t(0x00000000)},
    {"wmouse.mrf", "???", int32_t(0xEF9A0655), int32_t(0x00000000)},
    {"wndchim1.aud", "", int32_t(0xB4010D1B), int32_t(0x00000000)},
    {"wndchim2.aud", "", int32_t(0xB6010D1B), int32_t(0x00000000)},
    {"wndchim3.aud", "", int32_t(0xB8010D1B), int32_t(0x00000000)},
    {"wndchim4.aud", "", int32_t(0xBA010D1B), int32_t(0x00000000)},
    {"wndloop2.aud", "", int32_t(0xDA071929), int32_t(0x00000000)},
    {"wndmill1.aud", "", int32_t(0xDBFF131D), int32_t(0x00000000)},
    {"wodact.pcx", "-", int32_t(0x00000000), int32_t(0x6BEE710F)},
    {"wodban.pcx", "-", int32_t(0x00000000), int32_t(0xD3E88937)},
    {"wodclan.pcx", "-", int32_t(0x00000000), int32_t(0x839FE916)},
    {"woddcon.pcx", "-", int32_t(0x00000000), int32_t(0x6EE1ED2E)},
    {"wodfgame.pcx", "-", int32_t(0x00000000), int32_t(0x3C1B0D9D)},
    {"wodfind.pcx", "-", int32_t(0x00000000), int32_t(0xD63BF1B2)},
    {"wodhelp.pcx", "-", int32_t(0x00000000), int32_t(0x468E6ECB)},
    {"wodkick.pcx", "-", int32_t(0x00000000), int32_t(0xB7F5C5F0)},
    {"wodleave.pcx", "-", int32_t(0x00000000), int32_t(0x82017226)},
    {"wodopt.pcx", "-", int32_t(0x00000000), int32_t(0x51189C55)},
    {"wodref.pcx", "-", int32_t(0x00000000), int32_t(0xC88D8BDB)},
    {"wodsqlch.pcx", "-", int32_t(0x00000000), int32_t(0xC3D5F60E)},
    {"wodtrny.pcx", "-", int32_t(0x00000000), int32_t(0xCA94A77D)},
    {"wolacpt.pcx", "-", int32_t(0x00000000), int32_t(0x047A254F)},
    {"wolclan.pcx", "-", int32_t(0x00000000), int32_t(0x9048A9E2)},
    {"woldclan.pcx", "", int32_t(0x00000000), int32_t(0xE4B5FBBF)},
    {"woldpriv.pcx", "", int32_t(0x00000000), int32_t(0x9DA374CA)},
    {"woldrslkob.pcx", "", int32_t(0x00000000), int32_t(0xA83CBEE8)},
    {"wolhost.pcx", "-", int32_t(0x00000000), int32_t(0xCE9E9CC6)},
    {"wolnob.pcx", "", int32_t(0x00000000), int32_t(0xF4214291)},
    {"wolob.pcx", "", int32_t(0x00000000), int32_t(0x0C655DE2)},
    {"woloper.pcx", "-", int32_t(0x00000000), int32_t(0xDD339861)},
    {"woloptions.pal", "", int32_t(0x00000000), int32_t(0x631B25F0)},
    {"woloptions.shp", "", int32_t(0x00000000), int32_t(0x3553F21A)},
    {"wolpriv.pcx", "-", int32_t(0x00000000), int32_t(0xB05E3ADE)},
    {"wolreslk.pcx", "", int32_t(0x00000000), int32_t(0x18E8B94A)},
    {"wolrslknob.pcx", "", int32_t(0x00000000), int32_t(0xB23EE5BB)},
    {"wolrslkob.pcx", "", int32_t(0x00000000), int32_t(0x4A7AFAC8)},
    {"wolsoundoptions.pal", "", int32_t(0x00000000), int32_t(0xF7289AED)},
    {"wolsoundoptions.shp", "", int32_t(0x00000000), int32_t(0x0C3B53D1)},
    {"wolsqlch.pcx", "-", int32_t(0x00000000), int32_t(0xD002B6FA)},
    {"woltrny.pcx", "-", int32_t(0x00000000), int32_t(0xD943E789)},
    {"woluclan.pcx", "", int32_t(0x00000000), int32_t(0x5F0EAD8D)},
    {"wolupriv.pcx", "", int32_t(0x00000000), int32_t(0x261822F8)},
    {"wolurslkob.pcx", "", int32_t(0x00000000), int32_t(0xC1ADC1B7)},
    {"woluser.pcx", "-", int32_t(0x00000000), int32_t(0x6A52576D)},
    {"wolvoice.pcx", "-", int32_t(0x00000000), int32_t(0x590C3BBA)},
    {"womatk1.aud", "", int32_t(0x61DC2946), int32_t(0x00000000)},
    {"womdie1.aud", "", int32_t(0x6DDC1D30), int32_t(0x00000000)},
    {"womhurt1.aud", "", int32_t(0xC8332335), int32_t(0x00000000)},
    {"womhurt2.aud", "", int32_t(0xCA332335), int32_t(0x00000000)},
    {"woms\\altar\\altar_.vqa", "", int32_t(0xA50240E2), int32_t(0x00000000)},
    {"woms\\altar_.wom", "", int32_t(0x48A77403), int32_t(0x00000000)},
    {"woms\\arena\\arena_.vqa", "", int32_t(0x71957D5F), int32_t(0x00000000)},
    {"woms\\arena_.wom", "", int32_t(0x0CBF521D), int32_t(0x00000000)},
    {"woms\\balcony\\balcony_.vqa", "", int32_t(0x5A50C271), int32_t(0x00000000)},
    {"woms\\balcony_.wom", "", int32_t(0x9AC6A26C), int32_t(0x00000000)},
    {"woms\\can\\0162706e.aud", "", int32_t(0x828ADD1E), int32_t(0x00000000)},
    {"woms\\can\\0162806e.aud", "", int32_t(0x828AE11E), int32_t(0x00000000)},
    {"woms\\can\\0163406e.aud", "", int32_t(0x828AD122), int32_t(0x00000000)},
    {"woms\\can\\0164006e.aud", "", int32_t(0x828AC126), int32_t(0x00000000)},
    {"woms\\can\\0164106e.aud", "", int32_t(0x828AC526), int32_t(0x00000000)},
    {"woms\\can\\0164206e.aud", "", int32_t(0x828AC926), int32_t(0x00000000)},
    {"woms\\can\\0164606e.aud", "", int32_t(0x828AD926), int32_t(0x00000000)},
    {"woms\\can\\0165606e.aud", "", int32_t(0x828AD92A), int32_t(0x00000000)},
    {"woms\\can\\1362506e.vqa", "", int32_t(0x7AC4DD1B), int32_t(0x00000000)},
    {"woms\\can\\1362606e.vqa", "", int32_t(0x7AC4E11B), int32_t(0x00000000)},
    {"woms\\can\\1362906e.vqa", "", int32_t(0x7AC4ED1B), int32_t(0x00000000)},
    {"woms\\can\\1363006e.vqa", "", int32_t(0x7AC4C91F), int32_t(0x00000000)},
    {"woms\\can\\1363106e.vqa", "", int32_t(0x7AC4CD1F), int32_t(0x00000000)},
    {"woms\\can\\1363206e.vqa", "", int32_t(0x7AC4D11F), int32_t(0x00000000)},
    {"woms\\can\\1363506e.vqa", "", int32_t(0x7AC4DD1F), int32_t(0x00000000)},
    {"woms\\can\\1363606e.vqa", "", int32_t(0x7AC4E11F), int32_t(0x00000000)},
    {"woms\\can\\1364306e.vqa", "", int32_t(0x7AC4D523), int32_t(0x00000000)},
    {"woms\\can\\1364406e.vqa", "", int32_t(0x7AC4D923), int32_t(0x00000000)},
    {"woms\\can\\1364506e.vqa", "", int32_t(0x7AC4DD23), int32_t(0x00000000)},
    {"woms\\can\\1364706e.vqa", "", int32_t(0x7AC4E523), int32_t(0x00000000)},
    {"woms\\can\\1364806e.vqa", "", int32_t(0x7AC4E923), int32_t(0x00000000)},
    {"woms\\can\\1365706e.vqa", "", int32_t(0x7AC4E527), int32_t(0x00000000)},
    {"woms\\can\\1399906e.vqa", "", int32_t(0x92C4ED37), int32_t(0x00000000)},
    {"woms\\can\\can_.aud", "", int32_t(0x8A667AC7), int32_t(0x00000000)},
    {"woms\\can\\can_.vqa", "", int32_t(0x82907AC4), int32_t(0x00000000)},
    {"woms\\can_.wom", "", int32_t(0x721DE535), int32_t(0x00000000)},
    {"woms\\cave\\cave_.vqa", "", int32_t(0x48EC5D6B), int32_t(0x00000000)},
    {"woms\\cave_.wom", "", int32_t(0xA1CC9403), int32_t(0x00000000)},
    {"woms\\cfall\\cfall_.vqa", "", int32_t(0x6CCDE51F), int32_t(0x00000000)},
    {"woms\\cfall_.wom", "", int32_t(0xFC8F701A), int32_t(0x00000000)},
    {"woms\\chut\\chut_.vqa", "", int32_t(0x5D247BA5), int32_t(0x00000000)},
    {"woms\\chut_.wom", "", int32_t(0x9DE89421), int32_t(0x00000000)},
    {"woms\\chv\\chv_.vqa", "", int32_t(0xE2E47AC4), int32_t(0x00000000)},
    {"woms\\chv_.wom", "", int32_t(0x9239E535), int32_t(0x00000000)},
    {"woms\\daniel\\daniel_.vqa", "", int32_t(0xB25949E3), int32_t(0x00000000)},
    {"woms\\daniel_.wom", "", int32_t(0xDF576DEA), int32_t(0x00000000)},
    {"woms\\dragon\\0190003e.aud", "", int32_t(0xF0E11130), int32_t(0x00000000)},
    {"woms\\dragon\\0190103e.aud", "", int32_t(0xF0E11132), int32_t(0x00000000)},
    {"woms\\dragon\\6890503e.vqa", "", int32_t(0xEDDD4252), int32_t(0x00000000)},
    {"woms\\dragon\\6890603e.vqa", "", int32_t(0xEDDD4254), int32_t(0x00000000)},
    {"woms\\dragon\\6890703e.vqa", "", int32_t(0xEDDD4256), int32_t(0x00000000)},
    {"woms\\dragon\\6890903e.vqa", "", int32_t(0xEDDD425A), int32_t(0x00000000)},
    {"woms\\dragon\\dragon7.vqa", "", int32_t(0xDAF5E1E6), int32_t(0x00000000)},
    {"woms\\dragon\\dragon8.vqa", "", int32_t(0xDAF7E1E6), int32_t(0x00000000)},
    {"woms\\dragon\\dragon_.aud", "", int32_t(0xDB48E5D1), int32_t(0x00000000)},
    {"woms\\dragon\\dragon_.vqa", "", int32_t(0xDB45E1E6), int32_t(0x00000000)},
    {"woms\\dragon\\drgbrth7.aud", "", int32_t(0x1D43DDC4), int32_t(0x00000000)},
    {"woms\\dragon\\drgbrth8.aud", "", int32_t(0x1F43DDC4), int32_t(0x00000000)},
    {"woms\\dragon\\drgnflgt.vqa", "", int32_t(0x843DE2AD), int32_t(0x00000000)},
    {"woms\\dragon\\drgstir1.aud", "", int32_t(0x5557C7C9), int32_t(0x00000000)},
    {"woms\\dragon\\drgstir4.aud", "", int32_t(0x5B57C7C9), int32_t(0x00000000)},
    {"woms\\dragon_.wom", "", int32_t(0xAB9F81E6), int32_t(0x00000000)},
    {"woms\\dslave\\dslave_.vqa", "", int32_t(0x733A0BC5), int32_t(0x00000000)},
    {"woms\\dslave_.wom", "", int32_t(0xD7918FDA), int32_t(0x00000000)},
    {"woms\\empt\\empt_.vqa", "", int32_t(0x49548B9B), int32_t(0x00000000)},
    {"woms\\empt_.wom", "", int32_t(0x89FC9C21), int32_t(0x00000000)},
    {"woms\\herb\\herb_.vqa", "", int32_t(0x39207F57), int32_t(0x00000000)},
    {"woms\\herb_.wom", "", int32_t(0x91DCA7FD), int32_t(0x00000000)},
    {"woms\\hive1\\hive1_.vqa", "", int32_t(0x78E1B0F6), int32_t(0x00000000)},
    {"woms\\hive1_.wom", "", int32_t(0x509B4E0B), int32_t(0x00000000)},
    {"woms\\hive2\\hive2_.vqa", "", int32_t(0x7CE1B8F6), int32_t(0x00000000)},
    {"woms\\hive2_.wom", "", int32_t(0x509B500B), int32_t(0x00000000)},
    {"woms\\hive3\\hive3_.vqa", "", int32_t(0x80E1C0F6), int32_t(0x00000000)},
    {"woms\\hive3_.wom", "", int32_t(0x509B520B), int32_t(0x00000000)},
    {"woms\\hive4\\hive4_.vqa", "", int32_t(0x84E1C8F6), int32_t(0x00000000)},
    {"woms\\hive4_.wom", "", int32_t(0x509B540B), int32_t(0x00000000)},
    {"woms\\hut1\\hut1_.vqa", "", int32_t(0x89A05D17), int32_t(0x00000000)},
    {"woms\\hut1_.wom", "", int32_t(0x9A1CA7DB), int32_t(0x00000000)},
    {"woms\\hut2\\hut2_.vqa", "", int32_t(0x89A05F1B), int32_t(0x00000000)},
    {"woms\\hut2_.wom", "", int32_t(0x9A1CA7DD), int32_t(0x00000000)},
    {"woms\\liz\\liz_.vqa", "", int32_t(0x12F0E6BF), int32_t(0x00000000)},
    {"woms\\liz_.wom", "", int32_t(0xA23E0933), int32_t(0x00000000)},
    {"woms\\magic\\magic_.vqa", "", int32_t(0xF87254F5), int32_t(0x00000000)},
    {"woms\\magic_.wom", "", int32_t(0x147B8613), int32_t(0x00000000)},
    {"woms\\mcel\\mcel_.vqa", "", int32_t(0xC924BB64), int32_t(0x00000000)},
    {"woms\\mcel_.wom", "", int32_t(0x5DD4BC11), int32_t(0x00000000)},
    {"woms\\ment\\ment_.vqa", "", int32_t(0x1934CB97), int32_t(0x00000000)},
    {"woms\\ment_.wom", "", int32_t(0x81DCBC21), int32_t(0x00000000)},
    {"woms\\mgar\\mgar_.vqa", "", int32_t(0xB944C774), int32_t(0x00000000)},
    {"woms\\mgar_.wom", "", int32_t(0x4DE4BC1D), int32_t(0x00000000)},
    {"woms\\mlib\\mlib_.vqa", "", int32_t(0x0D6CA745), int32_t(0x00000000)},
    {"woms\\mlib_.wom", "", int32_t(0x6DF8BBFD), int32_t(0x00000000)},
    {"woms\\moff\\moff_.vqa", "", int32_t(0x0184AF4F), int32_t(0x00000000)},
    {"woms\\moff_.wom", "", int32_t(0x6204BC05), int32_t(0x00000000)},
    {"woms\\pool\\pool_.vqa", "", int32_t(0x4990D379), int32_t(0x00000000)},
    {"woms\\pool_.wom", "", int32_t(0x8604C811), int32_t(0x00000000)},
    {"woms\\runecl\\runecl_.vqa", "", int32_t(0xA39A69F7), int32_t(0x00000000)},
    {"woms\\runecl_.wom", "", int32_t(0xDFA7A1E2), int32_t(0x00000000)},
    {"woms\\runes\\runes_.vqa", "", int32_t(0xD1A34126), int32_t(0x00000000)},
    {"woms\\runes_.wom", "", int32_t(0x30CBBA0B), int32_t(0x00000000)},
    {"woms\\settle1\\settle1_.vqa", "", int32_t(0x7A3F2FC3), int32_t(0x00000000)},
    {"woms\\settle1_.wom", "", int32_t(0x3AC31EB0), int32_t(0x00000000)},
    {"woms\\settle2\\settle2_.vqa", "", int32_t(0x8E3F2FC3), int32_t(0x00000000)},
    {"woms\\settle2_.wom", "", int32_t(0x3EC31EB0), int32_t(0x00000000)},
    {"woms\\settle3\\settle3_.vqa", "", int32_t(0xA23F2FC3), int32_t(0x00000000)},
    {"woms\\settle3_.wom", "", int32_t(0x42C31EB0), int32_t(0x00000000)},
    {"woms\\settle4\\settle4_.vqa", "", int32_t(0xB63F2FC5), int32_t(0x00000000)},
    {"woms\\settle4_.wom", "", int32_t(0x46C31EB0), int32_t(0x00000000)},
    {"woms\\sever\\sever_.vqa", "", int32_t(0x54A368E5), int32_t(0x00000000)},
    {"woms\\sever_.wom", "", int32_t(0x508BBC0B), int32_t(0x00000000)},
    {"woms\\shaman\\shaman_.vqa", "", int32_t(0xF2A63A36), int32_t(0x00000000)},
    {"woms\\shaman_.wom", "", int32_t(0xAB77A1F2), int32_t(0x00000000)},
    {"woms\\shbak\\shbak_.vqa", "", int32_t(0xF8C2E0D1), int32_t(0x00000000)},
    {"woms\\shbak_.wom", "", int32_t(0x0097AE03), int32_t(0x00000000)},
    {"woms\\skel\\skel_.vqa", "", int32_t(0xE97CEB64), int32_t(0x00000000)},
    {"woms\\skel_.wom", "", int32_t(0x5DF4D411), int32_t(0x00000000)},
    {"woms\\slaves\\slaves_.vqa", "", int32_t(0x170E7487), int32_t(0x00000000)},
    {"woms\\slaves_.wom", "", int32_t(0xAB91AA04), int32_t(0x00000000)},
    {"woms\\stat\\0120009e.aud", "", int32_t(0x4B8F92D8), int32_t(0x00000000)},
    {"woms\\stat\\stat_.vqa", "", int32_t(0xEDC4FB7C), int32_t(0x00000000)},
    {"woms\\stat_.wom", "", int32_t(0x4E18D421), int32_t(0x00000000)},
    {"woms\\tcel_.wom", "", int32_t(0x5DD4D811), int32_t(0x00000000)},
    {"woms\\tdoor_.wom", "", int32_t(0x3487C01F), int32_t(0x00000000)},
    {"woms\\text_.wom", "", int32_t(0xA9DCD821), int32_t(0x00000000)},
    {"woms\\tint_.wom", "", int32_t(0x81ECD821), int32_t(0x00000000)},
    {"woms\\tmpldor\\tmplcr_e.vqa", "", int32_t(0xA452B2EF), int32_t(0x00000000)},
    {"woms\\tmpldor\\tmpldor_.vqa", "", int32_t(0x7046B725), int32_t(0x00000000)},
    {"woms\\tmpldor_.wom", "", int32_t(0x9F2B0690), int32_t(0x00000000)},
    {"woms\\village\\tavern.vqa", "", int32_t(0x0E5CA25B), int32_t(0x00000000)},
    {"woms\\village\\village_.aud", "", int32_t(0xD2DCCB28), int32_t(0x00000000)},
    {"woms\\village\\village_.vqa", "", int32_t(0xCB06CB25), int32_t(0x00000000)},
    {"woms\\village_.wom", "", int32_t(0x4AEB0A90), int32_t(0x00000000)},
    {"woms\\wpn\\0130604e.aud", "", int32_t(0x637C1916), int32_t(0x00000000)},
    {"woms\\wpn\\2550004e.vqa", "", int32_t(0x6BC61113), int32_t(0x00000000)},
    {"woms\\wpn\\2599804e.vqa", "", int32_t(0x8BC63137), int32_t(0x00000000)},
    {"woms\\wpn\\2599904e.vqa", "", int32_t(0x8BC63537), int32_t(0x00000000)},
    {"woms\\wpn\\wpn_.aud", "", int32_t(0x8B1B6AC7), int32_t(0x00000000)},
    {"woms\\wpn\\wpn_.vqa", "", int32_t(0x83456AC4), int32_t(0x00000000)},
    {"woms\\wpn\\wpnshape.shp", "", int32_t(0x92DD99B1), int32_t(0x00000000)},
    {"woms\\wpn_.wom", "", int32_t(0x725A3535), int32_t(0x00000000)},
    {"woms\\wpnext\\weapnshp.vqa", "", int32_t(0x543934F8), int32_t(0x00000000)},
    {"woms\\wpnext\\wpnext_.aud", "", int32_t(0xA38E6220), int32_t(0x00000000)},
    {"woms\\wpnext\\wpnext_.vqa", "", int32_t(0xA38B5E35), int32_t(0x00000000)},
    {"woms\\wpnext_.wom", "", int32_t(0xDFA3DFE2), int32_t(0x00000000)},
    {"wood.shp", "wood fence", int32_t(0xD8E6F1DC), int32_t(0xA623BA0B)},
    {"woodc1.aud", "", int32_t(0x9399E438), int32_t(0x00000000)},
    {"woodc10.aud", "", int32_t(0x6DE1F524), int32_t(0x00000000)},
    {"woodc2.aud", "", int32_t(0x9399E638), int32_t(0x00000000)},
    {"woodc4.aud", "", int32_t(0x9399EA38), int32_t(0x00000000)},
    {"woodc6.aud", "", int32_t(0x9399EE38), int32_t(0x00000000)},
    {"woodc7.aud", "", int32_t(0x9399F038), int32_t(0x00000000)},
    {"woodcrt1.aud", "", int32_t(0xB83B2311), int32_t(0x00000000)},
    {"woodelev.aud", "", int32_t(0x021D1715), int32_t(0x00000000)},
    {"woodicnh.des", "icon: wood fence", int32_t(0xF51F081D), int32_t(0x00000000)},
    {"woodicnh.tem", "icon: wood fence", int32_t(0xEF1F181D), int32_t(0x00000000)},
    {"woodicnh.win", "icon: wood fence", int32_t(0xF0231B1D), int32_t(0x00000000)},
    {"woodicon.shp", "icon: wood fence", int32_t(0xFE24171D), int32_t(0x00000000)},
    {"woodl1.aud", "", int32_t(0x9399E44A), int32_t(0x00000000)},
    {"woodl2.aud", "", int32_t(0x9399E64A), int32_t(0x00000000)},
    {"woodl3.aud", "", int32_t(0x9399E84A), int32_t(0x00000000)},
    {"woodl4.aud", "", int32_t(0x9399EA4A), int32_t(0x00000000)},
    {"woodl5.aud", "", int32_t(0x9399EC4A), int32_t(0x00000000)},
    {"woodo1.aud", "", int32_t(0x9399E450), int32_t(0x00000000)},
    {"woodo4.aud", "", int32_t(0x9399EA50), int32_t(0x00000000)},
    {"woodr1.aud", "", int32_t(0x9399E456), int32_t(0x00000000)},
    {"woodr2.aud", "", int32_t(0x9399E656), int32_t(0x00000000)},
    {"woodr3.aud", "", int32_t(0x9399E856), int32_t(0x00000000)},
    {"woodr4.aud", "", int32_t(0x9399EA56), int32_t(0x00000000)},
    {"woodr5.aud", "", int32_t(0x9399EC56), int32_t(0x00000000)},
    {"woodwlk1.aud", "", int32_t(0xB8291739), int32_t(0x00000000)},
    {"woodwlk2.aud", "", int32_t(0xBA291739), int32_t(0x00000000)},
    {"woodwlk3.aud", "", int32_t(0xBC291739), int32_t(0x00000000)},
    {"woodwlk4.aud", "", int32_t(0xBE291739), int32_t(0x00000000)},
    {"woodwlk5.aud", "", int32_t(0xC0291739), int32_t(0x00000000)},
    {"woodwlk6.aud", "", int32_t(0xC2291739), int32_t(0x00000000)},
    {"woodwlk7.aud", "", int32_t(0xC4291739), int32_t(0x00000000)},
    {"woody1.aud", "", int32_t(0x9399E464), int32_t(0x00000000)},
    {"woody2.aud", "", int32_t(0x9399E664), int32_t(0x00000000)},
    {"woody3.aud", "", int32_t(0x9399E864), int32_t(0x00000000)},
    {"woody4.aud", "", int32_t(0x9399EA64), int32_t(0x00000000)},
    {"woody5.aud", "", int32_t(0x9399EC64), int32_t(0x00000000)},
    {"woody6.aud", "", int32_t(0x9399EE64), int32_t(0x00000000)},
    {"woody7.aud", "", int32_t(0x9399F064), int32_t(0x00000000)},
    {"woody8.aud", "", int32_t(0x9399F264), int32_t(0x00000000)},
    {"woody9.aud", "", int32_t(0x9399F464), int32_t(0x00000000)},
    {"woosh1.aud", "", int32_t(0xCF99E442), int32_t(0x00000000)},
    {"woosh1.wav", "", int32_t(0xFB99F62E), int32_t(0x00000000)},
    {"woosh2.aud", "", int32_t(0xCF99E642), int32_t(0x00000000)},
    {"work226m.aud", "workmen", int32_t(0x0C0AE2EF), int32_t(0x00000000)},
    {"workremx.aud", "", int32_t(0x2239092F), int32_t(0x00000000)},
    {"world2.aud", "world", int32_t(0xB3A5E63A), int32_t(0x00000000)},
    {"worm1.aud", "", int32_t(0xDFCB9A03), int32_t(0x00000000)},
    {"worm2.aud", "", int32_t(0xDFCB9A05), int32_t(0x00000000)},
    {"worm3.aud", "", int32_t(0xDFCB9A07), int32_t(0x00000000)},
    {"wormdie.aud", "", int32_t(0x92182526), int32_t(0x00000000)},
    {"wormdie2.aud", "", int32_t(0xDE291113), int32_t(0x00000000)},
    {"wormhit1.aud", "", int32_t(0xDC47111B), int32_t(0x00000000)},
    {"wormspit.aud", "", int32_t(0x22311F31), int32_t(0x00000000)},
    {"wouact.pcx", "-", int32_t(0x00000000), int32_t(0xA3829BD9)},
    {"wouban.pcx", "-", int32_t(0x00000000), int32_t(0x1B8463E1)},
    {"wouclan.pcx", "-", int32_t(0x00000000), int32_t(0x4BF303C0)},
    {"woudcon.pcx", "-", int32_t(0x00000000), int32_t(0xA68D07F8)},
    {"woufgame.pcx", "-", int32_t(0x00000000), int32_t(0xF477E74B)},
    {"woufind.pcx", "-", int32_t(0x00000000), int32_t(0x1E571B64)},
    {"wouhelp.pcx", "-", int32_t(0x00000000), int32_t(0x8EE2841D)},
    {"woukick.pcx", "-", int32_t(0x00000000), int32_t(0x7F992F26)},
    {"wouleave.pcx", "-", int32_t(0x00000000), int32_t(0x4A6D98F0)},
    {"wouopt.pcx", "-", int32_t(0x00000000), int32_t(0x99747683)},
    {"wouref.pcx", "-", int32_t(0x00000000), int32_t(0x00E1610D)},
    {"wousqlch.pcx", "-", int32_t(0x00000000), int32_t(0x0BB91CD8)},
    {"woutrny.pcx", "-", int32_t(0x00000000), int32_t(0x02F84DAB)},
    {"wowatk1.aud", "", int32_t(0x62042946), int32_t(0x00000000)},
    {"wowdie1.aud", "", int32_t(0x6E041D30), int32_t(0x00000000)},
    {"wowhurt1.aud", "", int32_t(0xC85B2335), int32_t(0x00000000)},
    {"wowhurt2.aud", "", int32_t(0xCA5B2335), int32_t(0x00000000)},
    {"wred.mrf", "???", int32_t(0xCEDCF1DC), int32_t(0x00000000)},
    {"wrench.shp", "-", int32_t(0x00000000), int32_t(0x97E9DF77)},
    {"write.cps", "pict:", int32_t(0xF1ABA63A), int32_t(0x00000000)},
    {"wrm_eat.csv", "", int32_t(0xDA341F2A), int32_t(0x00000000)},
    {"wrm_eat.lsv", "", int32_t(0xDA341F33), int32_t(0x00000000)},
    {"wrm_eat.vqa", "", int32_t(0xDA1F1D3D), int32_t(0x00000000)},
    {"wrm_eat_e.vqa", "", int32_t(0x1A67F498), int32_t(0x00000000)},
    {"wrm_eat_e.vqt", "", int32_t(0x1A67F4AB), int32_t(0x00000000)},
    {"wrm_eat_h.pcx", "", int32_t(0xFE5BF4B4), int32_t(0x00000000)},
    {"wrm_eat_h.vqa", "", int32_t(0x1A67F49E), int32_t(0x00000000)},
    {"wrm_eat_l.pcx", "", int32_t(0xFE5BF4BC), int32_t(0x00000000)},
    {"wrm_eat_l.vqa", "", int32_t(0x1A67F4A6), int32_t(0x00000000)},
    {"wrm_stat.csv", "", int32_t(0x7C0B3530), int32_t(0x00000000)},
    {"wrm_stat.lsv", "", int32_t(0x7C0B3E30), int32_t(0x00000000)},
    {"wrm_stat.vqa", "", int32_t(0x67094830), int32_t(0x00000000)},
    {"wrm_stat_e.vqa", "", int32_t(0xF7CCB013), int32_t(0x00000000)},
    {"wrm_stat_e.vqt", "", int32_t(0xF7CCC313), int32_t(0x00000000)},
    {"wrm_stat_h.pcx", "", int32_t(0xEBCCCD05), int32_t(0x00000000)},
    {"wrm_stat_h.vqa", "", int32_t(0xF7CCB613), int32_t(0x00000000)},
    {"wrm_stat_l.pcx", "", int32_t(0xEBCCD505), int32_t(0x00000000)},
    {"wrm_stat_l.vqa", "", int32_t(0xF7CCBE13), int32_t(0x00000000)},
    {"wrmn.hva", "", int32_t(0x00000000), int32_t(0x09D0AD13)},
    {"wrmn.vxl", "", int32_t(0x00000000), int32_t(0xFF5A725A)},
    {"wrong1.aud", "build queue full", int32_t(0x00000000), int32_t(0xBD0BF869)},
    {"wshade.mrf", "???", int32_t(0x9F7E1E37), int32_t(0x00000000)},
    {"wshadow.mrf", "???", int32_t(0x62163E32), int32_t(0x00000000)},
    {"wslope01.des", "", int32_t(0x00000000), int32_t(0xC4FB9CAD)},
    {"wslope01.sno", "-", int32_t(0x00000000), int32_t(0x2A67ACDC)},
    {"wslope01.tem", "-", int32_t(0x00000000), int32_t(0x22D202BE)},
    {"wslope02.des", "", int32_t(0x00000000), int32_t(0x835BE67D)},
    {"wslope02.sno", "-", int32_t(0x00000000), int32_t(0x6DC7D60C)},
    {"wslope02.tem", "-", int32_t(0x00000000), int32_t(0x6572786E)},
    {"wslope03.des", "", int32_t(0x00000000), int32_t(0xBE3BCFCD)},
    {"wslope03.sno", "-", int32_t(0x00000000), int32_t(0x50A7FFBC)},
    {"wslope03.tem", "-", int32_t(0x00000000), int32_t(0x581251DE)},
    {"wslope04.des", "", int32_t(0x00000000), int32_t(0x0C1B13DD)},
    {"wslope04.sno", "-", int32_t(0x00000000), int32_t(0xE28723AC)},
    {"wslope04.tem", "-", int32_t(0x00000000), int32_t(0xEA328DCE)},
    {"wstlgo_e.vqa", "", int32_t(0xFD614219), int32_t(0x00000000)},
    {"wtrans.mrf", "???", int32_t(0x9FA63E4B), int32_t(0x00000000)},
    {"wunits.mrf", "???", int32_t(0xBF964257), int32_t(0x00000000)},
    {"wwcrate.shp", "misc: watercrate", int32_t(0xA5E84E32), int32_t(0x00000000)},
    {"wwhite.mrf", "???", int32_t(0xBF7E2E57), int32_t(0x00000000)},
    {"wwlogo.vqa", "-", int32_t(0x00000000), int32_t(0xD0438A2A)},
    {"wyellow.mrf", "???", int32_t(0x8E0A5642), int32_t(0x00000000)},
    {"xa1ev01.wav", "", int32_t(0x00000000), int32_t(0x9DC7E206)},
    {"xa1ev02.wav", "", int32_t(0x00000000), int32_t(0x1B5390A8)},
    {"xa1ev03.wav", "", int32_t(0x00000000), int32_t(0xD00F430D)},
    {"xa1ev04.wav", "", int32_t(0x00000000), int32_t(0xCD0A73B5)},
    {"xa1ev05.wav", "", int32_t(0x00000000), int32_t(0x0656A010)},
    {"xa1ev06.wav", "", int32_t(0x00000000), int32_t(0x80C2D2BE)},
    {"xa1ev07.wav", "", int32_t(0x00000000), int32_t(0x4B9E011B)},
    {"xa1ta01.wav", "", int32_t(0x00000000), int32_t(0x50028C06)},
    {"xa1ta02.wav", "", int32_t(0x00000000), int32_t(0xD696FEA8)},
    {"xa2ar01.wav", "", int32_t(0x00000000), int32_t(0xAF5606F3)},
    {"xa2ca01.wav", "", int32_t(0x00000000), int32_t(0x739418BD)},
    {"xa2ca02.wav", "", int32_t(0x00000000), int32_t(0xF5006A13)},
    {"xa2ev01.wav", "", int32_t(0x00000000), int32_t(0x76F05905)},
    {"xa2ev02.wav", "", int32_t(0x00000000), int32_t(0xF0642BAB)},
    {"xa2ev03.wav", "", int32_t(0x00000000), int32_t(0x3B38F80E)},
    {"xa2ev04.wav", "", int32_t(0x00000000), int32_t(0x263DC8B6)},
    {"xa2ev05.wav", "", int32_t(0x00000000), int32_t(0xED611B13)},
    {"xa2ev06.wav", "", int32_t(0x00000000), int32_t(0x6BF569BD)},
    {"xa2gg01.wav", "", int32_t(0x00000000), int32_t(0xE8174036)},
    {"xa2sl01.wav", "", int32_t(0x00000000), int32_t(0x44514F1D)},
    {"xa2yu01.wav", "", int32_t(0x00000000), int32_t(0xB28BEF83)},
    {"xa3ev01.wav", "", int32_t(0x00000000), int32_t(0x9932323B)},
    {"xa3ev02.wav", "", int32_t(0x00000000), int32_t(0x1FA64095)},
    {"xa3ev03.wav", "", int32_t(0x00000000), int32_t(0xD4FA9330)},
    {"xa3ev04.wav", "", int32_t(0x00000000), int32_t(0xC9FFA388)},
    {"xa3ev05.wav", "", int32_t(0x00000000), int32_t(0x02A3702D)},
    {"xa3ev06.wav", "", int32_t(0x00000000), int32_t(0x84370283)},
    {"xa3yu01.wav", "", int32_t(0x00000000), int32_t(0x5D4984BD)},
    {"xa4ei01.wav", "", int32_t(0x00000000), int32_t(0xDE750AC5)},
    {"xa4ei02.wav", "", int32_t(0x00000000), int32_t(0x58E1786B)},
    {"xa4ev01.wav", "", int32_t(0x00000000), int32_t(0x7BEE2942)},
    {"xa4ev02.wav", "", int32_t(0x00000000), int32_t(0xFD7A5BEC)},
    {"xa4ev03.wav", "", int32_t(0x00000000), int32_t(0x36268849)},
    {"xa4ev04.wav", "", int32_t(0x00000000), int32_t(0x2B23B8F1)},
    {"xa4ev05.wav", "", int32_t(0x00000000), int32_t(0xE07F6B54)},
    {"xa4ev06.wav", "", int32_t(0x00000000), int32_t(0x66EB19FA)},
    {"xa4ta01.wav", "", int32_t(0x00000000), int32_t(0xB62B4742)},
    {"xa4ta02.wav", "", int32_t(0x00000000), int32_t(0x30BF35EC)},
    {"xa4yu01.wav", "", int32_t(0x00000000), int32_t(0xBF959FC4)},
    {"xa5ev01.wav", "", int32_t(0x00000000), int32_t(0x942C427C)},
    {"xa5ev02.wav", "", int32_t(0x00000000), int32_t(0x12B830D2)},
    {"xa5ev03.wav", "", int32_t(0x00000000), int32_t(0xD9E4E377)},
    {"xa5ev04.wav", "", int32_t(0x00000000), int32_t(0xC4E1D3CF)},
    {"xa5ev05.wav", "", int32_t(0x00000000), int32_t(0x0FBD006A)},
    {"xa6ca01.wav", "", int32_t(0x00000000), int32_t(0x7A7FB8C7)},
    {"xa6ca02.wav", "", int32_t(0x00000000), int32_t(0xFCEBCA69)},
    {"xa6ca03.wav", "", int32_t(0x00000000), int32_t(0x37B719CC)},
    {"xa6ca04.wav", "", int32_t(0x00000000), int32_t(0x2AB22974)},
    {"xa6ca05.wav", "", int32_t(0x00000000), int32_t(0xE1EEFAD1)},
    {"xa7ev01.wav", "", int32_t(0x00000000), int32_t(0x90D99241)},
    {"xa7ev02.wav", "", int32_t(0x00000000), int32_t(0x164DE0EF)},
    {"xa7ev03.wav", "", int32_t(0x00000000), int32_t(0xDD11334A)},
    {"xa7ev04.wav", "", int32_t(0x00000000), int32_t(0xC01403F2)},
    {"xa7ev05.wav", "", int32_t(0x00000000), int32_t(0x0B48D057)},
    {"xa7ev06.wav", "", int32_t(0x00000000), int32_t(0x8DDCA2F9)},
    {"xa7yu01.wav", "", int32_t(0x00000000), int32_t(0x54A224C7)},
    {"xamazon01.map", "", int32_t(0x00000000), int32_t(0x94B8CBB6)},
    {"xarena.map", "", int32_t(0x00000000), int32_t(0x40D7684F)},
    {"xbarrel.map", "", int32_t(0x00000000), int32_t(0xDE95D133)},
    {"xbayopigs.map", "", int32_t(0x00000000), int32_t(0x0C51FD17)},
    {"xbermuda.map", "", int32_t(0x00000000), int32_t(0x63382E26)},
    {"xbreak.map", "", int32_t(0x00000000), int32_t(0xA46543AC)},
    {"xc0ev01.wav", "", int32_t(0x00000000), int32_t(0x2A6930F9)},
    {"xc0in01.wav", "", int32_t(0x00000000), int32_t(0x6303E973)},
    {"xc0so01.wav", "", int32_t(0x00000000), int32_t(0x96472102)},
    {"xc1ev01.wav", "", int32_t(0x00000000), int32_t(0xC5AB5BC7)},
    {"xc1in01.wav", "", int32_t(0x00000000), int32_t(0x8CC1824D)},
    {"xc1so01.wav", "", int32_t(0x00000000), int32_t(0x79854A3C)},
    {"xc2ev01.wav", "", int32_t(0x00000000), int32_t(0x2E9CE0C4)},
    {"xc2in02.wav", "", int32_t(0x00000000), int32_t(0xE1624BE0)},
    {"xc2so01.wav", "", int32_t(0x00000000), int32_t(0x92B2F13F)},
    {"xc3ev01.wav", "", int32_t(0x00000000), int32_t(0xC15E8BFA)},
    {"xc3in01.wav", "", int32_t(0x00000000), int32_t(0x88345270)},
    {"xc3so01.wav", "", int32_t(0x00000000), int32_t(0x7D709A01)},
    {"xcapades.ini", "", int32_t(0x00000000), int32_t(0x262BF0BB)},
    {"xcapades.map", "-", int32_t(0x00000000), int32_t(0xC2D1EC68)},
    {"xcarville.map", "", int32_t(0x00000000), int32_t(0xC8C1D94A)},
    {"xdeadman.map", "", int32_t(0x00000000), int32_t(0x87235531)},
    {"xdeath.map", "", int32_t(0x00000000), int32_t(0xD1FD67A0)},
    {"xdisaster.map", "", int32_t(0x00000000), int32_t(0x6772C6AA)},
    {"xdustbowl.map", "", int32_t(0x00000000), int32_t(0xE4BFD9FD)},
    {"xdustbowlmw.map", "", int32_t(0x00000000), int32_t(0xC7454C28)},
    {"xeb1.map", "", int32_t(0x00000000), int32_t(0x91A5BEBB)},
    {"xeb1mw.map", "", int32_t(0x00000000), int32_t(0xF06EA6EB)},
    {"xeb2.map", "", int32_t(0x00000000), int32_t(0xD605C46B)},
    {"xeb3.map", "", int32_t(0x00000000), int32_t(0xEB65EDDB)},
    {"xeb4.map", "", int32_t(0x00000000), int32_t(0x594531CB)},
    {"xeb5.map", "", int32_t(0x00000000), int32_t(0x6425187B)},
    {"xgoldst.map", "", int32_t(0x00000000), int32_t(0x8456C58F)},
    {"xgrinder.map", "", int32_t(0x00000000), int32_t(0x5AB26A37)},
    {"xgrymed1.shp", "medium explosion (high explosives)", int32_t(0x00000000), int32_t(0x0C3ECF1A)},
    {"xgrymed2.shp", "medium explosion (high explosives)", int32_t(0x00000000), int32_t(0x4B9EB5CA)},
    {"xgrysml1.shp", "small explosion (high explosives)", int32_t(0x00000000), int32_t(0xBAB32009)},
    {"xgrysml2.shp", "small explosion (high explosives)", int32_t(0x00000000), int32_t(0xFD135AD9)},
    {"xhailmary.map", "", int32_t(0x00000000), int32_t(0xA9E526E5)},
    {"xhills.map", "", int32_t(0x00000000), int32_t(0xFA131014)},
    {"xinvasion.map", "", int32_t(0x00000000), int32_t(0x8FF409D7)},
    {"xkaliforn.map", "", int32_t(0x00000000), int32_t(0x7682075A)},
    {"xkiller.map", "", int32_t(0x00000000), int32_t(0x82E07653)},
    {"xlostlake.map", "", int32_t(0x00000000), int32_t(0x86B74276)},
    {"xmp01du.map", "", int32_t(0x00000000), int32_t(0x2B5E99BE)},
    {"xmp01t4.map", "", int32_t(0x00000000), int32_t(0x8F28D98F)},
    {"xmp02t2.map", "", int32_t(0x00000000), int32_t(0xD7FE3D71)},
    {"xmp03t4.map", "", int32_t(0x00000000), int32_t(0xCD0DDEF2)},
    {"xmp04t8.map", "", int32_t(0x00000000), int32_t(0xB00A1790)},
    {"xmp05du.map", "", int32_t(0x00000000), int32_t(0xAF149744)},
    {"xmp05mw.map", "", int32_t(0x00000000), int32_t(0x7744739C)},
    {"xmp05t4.map", "", int32_t(0x00000000), int32_t(0x0B62D775)},
    {"xmp06mw.map", "", int32_t(0x00000000), int32_t(0xF9CB747F)},
    {"xmp06t2.map", "", int32_t(0x00000000), int32_t(0x53B4338B)},
    {"xmp07t4.map", "", int32_t(0x00000000), int32_t(0x4947D008)},
    {"xmp08mw.map", "", int32_t(0x00000000), int32_t(0xEC41664D)},
    {"xmp08t2.map", "", int32_t(0x00000000), int32_t(0x463E21B9)},
    {"xmp09du.map", "", int32_t(0x00000000), int32_t(0xF8BB820B)},
    {"xmp09t3.map", "", int32_t(0x00000000), int32_t(0x41C8F282)},
    {"xmp10s4.map", "", int32_t(0x00000000), int32_t(0x915EF3DC)},
    {"xmp11t2.map", "", int32_t(0x00000000), int32_t(0x4E0A2ED1)},
    {"xmp12s4.map", "", int32_t(0x00000000), int32_t(0xD37BF4A1)},
    {"xmp13du.map", "", int32_t(0x00000000), int32_t(0x7E008A80)},
    {"xmp13mw.map", "", int32_t(0x00000000), int32_t(0xA6506E58)},
    {"xmp13s4.map", "", int32_t(0x00000000), int32_t(0x1FD1F43F)},
    {"xmp14mw.map", "", int32_t(0x00000000), int32_t(0xAC956741)},
    {"xmp14t2.map", "", int32_t(0x00000000), int32_t(0x06EA20B5)},
    {"xmp15du.map", "", int32_t(0x00000000), int32_t(0xB86F8307)},
    {"xmp15mw.map", "", int32_t(0x00000000), int32_t(0x603F67DF)},
    {"xmp15s4.map", "", int32_t(0x00000000), int32_t(0xD9BEFDB8)},
    {"xmp16mw.map", "", int32_t(0x00000000), int32_t(0xEEB0603C)},
    {"xmp16s4.map", "", int32_t(0x00000000), int32_t(0x5731FA5B)},
    {"xmp17du.map", "", int32_t(0x00000000), int32_t(0xFA4A847A)},
    {"xmp17mw.map", "", int32_t(0x00000000), int32_t(0x221A60A2)},
    {"xmp17t6.map", "", int32_t(0x00000000), int32_t(0x13F46540)},
    {"xmp18du.map", "", int32_t(0x00000000), int32_t(0x236A96D6)},
    {"xmp18s3.map", "", int32_t(0x00000000), int32_t(0x5FBED8D1)},
    {"xmp19t4.map", "", int32_t(0x00000000), int32_t(0x4BB6D679)},
    {"xmp20mw.map", "", int32_t(0x00000000), int32_t(0x1152557E)},
    {"xmp20t6.map", "", int32_t(0x00000000), int32_t(0x20BC509C)},
    {"xmp21s2.map", "", int32_t(0x00000000), int32_t(0xB2202C9A)},
    {"xmp22mw.map", "", int32_t(0x00000000), int32_t(0x53775203)},
    {"xmp22s8.map", "", int32_t(0x00000000), int32_t(0x9D34081F)},
    {"xmp22s8mw.map", "", int32_t(0x00000000), int32_t(0x61B60AB4)},
    {"xmp23mw.map", "", int32_t(0x00000000), int32_t(0x9FDD529D)},
    {"xmp23t4.map", "", int32_t(0x00000000), int32_t(0xE3FBF674)},
    {"xmp24du.map", "", int32_t(0x00000000), int32_t(0x4D48BF5C)},
    {"xmp24t2.map", "", int32_t(0x00000000), int32_t(0x3F671C70)},
    {"xmp25du.map", "", int32_t(0x00000000), int32_t(0x81E2BFC2)},
    {"xmp25mw.map", "", int32_t(0x00000000), int32_t(0x59B25B1A)},
    {"xmp25t6.map", "", int32_t(0x00000000), int32_t(0x685C5EF8)},
    {"xmp26s6.map", "", int32_t(0x00000000), int32_t(0x23746795)},
    {"xmp27du.map", "", int32_t(0x00000000), int32_t(0xC3C7B8BF)},
    {"xmp27mw.map", "", int32_t(0x00000000), int32_t(0x1B975C67)},
    {"xmp27t8.map", "", int32_t(0x00000000), int32_t(0x107338F5)},
    {"xmp28u4.map", "", int32_t(0x00000000), int32_t(0x18E6E196)},
    {"xmp29mw.map", "", int32_t(0x00000000), int32_t(0x0E1D4E55)},
    {"xmp29u2.map", "", int32_t(0x00000000), int32_t(0x02150215)},
    {"xmp30mw.map", "", int32_t(0x00000000), int32_t(0x0629413D)},
    {"xmp30s6.map", "", int32_t(0x00000000), int32_t(0xF2607A51)},
    {"xmp30s8.map", "", int32_t(0x00000000), int32_t(0xC86A1B21)},
    {"xmp31s2.map", "", int32_t(0x00000000), int32_t(0xA55B38D9)},
    {"xmp32du.map", "", int32_t(0x00000000), int32_t(0x9C5CA298)},
    {"xmp32mw.map", "", int32_t(0x00000000), int32_t(0x440C4640)},
    {"xmp32s8.map", "", int32_t(0x00000000), int32_t(0x8A4F1C5C)},
    {"xmp33u4.map", "", int32_t(0x00000000), int32_t(0x52F7E983)},
    {"xmp34u4.map", "", int32_t(0x00000000), int32_t(0x5832E09A)},
    {"xmp35u4.map", "", int32_t(0x00000000), int32_t(0x9498E004)},
    {"xnewhghts.map", "", int32_t(0x00000000), int32_t(0x2334FA15)},
    {"xnorest.map", "", int32_t(0x00000000), int32_t(0x57B36277)},
    {"xoceansid.map", "", int32_t(0x00000000), int32_t(0xA40D9AC5)},
    {"xpacific.map", "", int32_t(0x00000000), int32_t(0x33D06D73)},
    {"xpacificmw.map", "", int32_t(0x00000000), int32_t(0xA6C8A41C)},
    {"xplobig4.aud", "explosion", int32_t(0xEA151513), int32_t(0x00000000)},
    {"xplobig4.juv", "explosion", int32_t(0xFC151E13), int32_t(0x00000000)},
    {"xplobig6.aud", "explosion", int32_t(0xEE151513), int32_t(0x00000000)},
    {"xplobig6.juv", "explosion", int32_t(0x00151E13), int32_t(0x00000000)},
    {"xplobig7.aud", "explosion", int32_t(0xF0151513), int32_t(0x00000000)},
    {"xplobig7.juv", "explosion", int32_t(0x02151E13), int32_t(0x00000000)},
    {"xplode.aud", "explosion", int32_t(0xBF8E103E), int32_t(0x00000000)},
    {"xplode.juv", "explosion", int32_t(0xD18E223E), int32_t(0x00000000)},
    {"xplolrg.shp", "-", int32_t(0x00000000), int32_t(0x9EE6E816)},
    {"xploplc1.aud", "explosive charge placed", int32_t(0xE40D1B2F), int32_t(0x00000000)},
    {"xplos.aud", "explosion", int32_t(0xE7B39E4B), int32_t(0x00000000)},
    {"xplos.juv", "explosion", int32_t(0xE7C59E5D), int32_t(0x00000000)},
    {"xplosml2.aud", "explosion", int32_t(0xE61F1D35), int32_t(0x00000000)},
    {"xplosml2.juv", "explosion", int32_t(0xF81F2635), int32_t(0x00000000)},
    {"xpotomac.map", "", int32_t(0x00000000), int32_t(0xCD83AD68)},
    {"xpowdrkeg.map", "", int32_t(0x00000000), int32_t(0x2AC4505C)},
    {"xrockets.map", "", int32_t(0x00000000), int32_t(0xD9107F26)},
    {"xroulette.map", "", int32_t(0x00000000), int32_t(0x4CE4781A)},
    {"xround.map", "", int32_t(0x00000000), int32_t(0x5B6BAD0B)},
    {"xs1bo01.wav", "", int32_t(0x00000000), int32_t(0x6CC8D8C5)},
    {"xs1bo02.wav", "", int32_t(0x00000000), int32_t(0xEA5CAA6B)},
    {"xs1bo03.wav", "", int32_t(0x00000000), int32_t(0x210079CE)},
    {"xs1so01.wav", "", int32_t(0x00000000), int32_t(0xD7738EF7)},
    {"xs1so02.wav", "", int32_t(0x00000000), int32_t(0x51E7FC59)},
    {"xs1so03.wav", "", int32_t(0x00000000), int32_t(0x9ABB2FFC)},
    {"xs1so04.wav", "", int32_t(0x00000000), int32_t(0x87BE1F44)},
    {"xs1so05.wav", "", int32_t(0x00000000), int32_t(0x4CE2CCE1)},
    {"xs1so06.wav", "", int32_t(0x00000000), int32_t(0xCA76BE4F)},
    {"xs1so07.wav", "", int32_t(0x00000000), int32_t(0x012A6DEA)},
    {"xs1so08.wav", "", int32_t(0x00000000), int32_t(0xF07CDF3F)},
    {"xs1so09.wav", "", int32_t(0x00000000), int32_t(0x3B200C9A)},
    {"xs1so10.wav", "", int32_t(0x00000000), int32_t(0xBA5856E6)},
    {"xs1so11.wav", "", int32_t(0x00000000), int32_t(0x71048543)},
    {"xs1so12.wav", "", int32_t(0x00000000), int32_t(0xF790F7ED)},
    {"xs1so13.wav", "", int32_t(0x00000000), int32_t(0x3CCC2448)},
    {"xs1so14.wav", "", int32_t(0x00000000), int32_t(0x21C914F0)},
    {"xs1so15.wav", "", int32_t(0x00000000), int32_t(0xEA95C755)},
    {"xs1so16.wav", "", int32_t(0x00000000), int32_t(0x6C01B5FB)},
    {"xs1so17.wav", "", int32_t(0x00000000), int32_t(0xA75D665E)},
    {"xs1so18.wav", "", int32_t(0x00000000), int32_t(0x560BD48B)},
    {"xs1so19.wav", "", int32_t(0x00000000), int32_t(0x9D57072E)},
    {"xs1so20.wav", "", int32_t(0x00000000), int32_t(0x8BB04C7B)},
    {"xs1so21.wav", "", int32_t(0x00000000), int32_t(0x40EC9FDE)},
    {"xs1so22.wav", "", int32_t(0x00000000), int32_t(0xC678ED70)},
    {"xs1so23.wav", "", int32_t(0x00000000), int32_t(0x0D243ED5)},
    {"xs1so24.wav", "", int32_t(0x00000000), int32_t(0x10210E6D)},
    {"xs1so25.wav", "", int32_t(0x00000000), int32_t(0xDB7DDDC8)},
    {"xs2so01.wav", "", int32_t(0x00000000), int32_t(0x3C4435F4)},
    {"xs2so02.wav", "", int32_t(0x00000000), int32_t(0xBAD0475A)},
    {"xs2so03.wav", "", int32_t(0x00000000), int32_t(0x718C94FF)},
    {"xs2so04.wav", "", int32_t(0x00000000), int32_t(0x6C89A447)},
    {"xs2so05.wav", "", int32_t(0x00000000), int32_t(0xA7D577E2)},
    {"xs2so06.wav", "", int32_t(0x00000000), int32_t(0x2141054C)},
    {"xs2so07.wav", "", int32_t(0x00000000), int32_t(0xEA1DD6E9)},
    {"xs3so01.wav", "", int32_t(0x00000000), int32_t(0xD3865ECA)},
    {"xs3so02.wav", "", int32_t(0x00000000), int32_t(0x55122C64)},
    {"xs3so03.wav", "", int32_t(0x00000000), int32_t(0x9E4EFFC1)},
    {"xs3so04.wav", "", int32_t(0x00000000), int32_t(0x834BCF79)},
    {"xs3so05.wav", "", int32_t(0x00000000), int32_t(0x48171CDC)},
    {"xs3so06.wav", "", int32_t(0x00000000), int32_t(0xCE836E72)},
    {"xs3so07.wav", "", int32_t(0x00000000), int32_t(0x05DFBDD7)},
    {"xs3so08.wav", "", int32_t(0x00000000), int32_t(0xF4890F02)},
    {"xs3so09.wav", "", int32_t(0x00000000), int32_t(0x3FD5DCA7)},
    {"xs3so10.wav", "", int32_t(0x00000000), int32_t(0xBEAD86DB)},
    {"xs3so11.wav", "", int32_t(0x00000000), int32_t(0x75F1557E)},
    {"xs3ta01.wav", "", int32_t(0x00000000), int32_t(0xA26D2131)},
    {"xs3ta02.wav", "", int32_t(0x00000000), int32_t(0x24F9539F)},
    {"xs3yu01.wav", "", int32_t(0x00000000), int32_t(0xABD3F9B7)},
    {"xs3yu02.wav", "", int32_t(0x00000000), int32_t(0x2D478B19)},
    {"xs3yu03.wav", "", int32_t(0x00000000), int32_t(0xE61B58BC)},
    {"xs3yu04.wav", "", int32_t(0x00000000), int32_t(0xFB1E6804)},
    {"xs3yu05.wav", "", int32_t(0x00000000), int32_t(0x3042BBA1)},
    {"xs3yu06.wav", "", int32_t(0x00000000), int32_t(0xB6D6C90F)},
    {"xs3yu07.wav", "", int32_t(0x00000000), int32_t(0x7D8A1AAA)},
    {"xs4ro01.wav", "", int32_t(0x00000000), int32_t(0x262151F0)},
    {"xs4ro02.wav", "", int32_t(0x00000000), int32_t(0xA0B5235E)},
    {"xs4ro03.wav", "", int32_t(0x00000000), int32_t(0x6BE9F0FB)},
    {"xs4ro04.wav", "", int32_t(0x00000000), int32_t(0x76ECC043)},
    {"xs4ro05.wav", "", int32_t(0x00000000), int32_t(0xBDB013E6)},
    {"xs4so01.wav", "", int32_t(0x00000000), int32_t(0x315A45B3)},
    {"xs4so02.wav", "", int32_t(0x00000000), int32_t(0xB7CE371D)},
    {"xs4so03.wav", "", int32_t(0x00000000), int32_t(0x7C92E4B8)},
    {"xs4so04.wav", "", int32_t(0x00000000), int32_t(0x6197D400)},
    {"xs4so05.wav", "", int32_t(0x00000000), int32_t(0xAACB07A5)},
    {"xs4so06.wav", "", int32_t(0x00000000), int32_t(0x2C5F750B)},
    {"xs4yu01.wav", "", int32_t(0x00000000), int32_t(0x490FE2CE)},
    {"xs4yu02.wav", "", int32_t(0x00000000), int32_t(0xCF9B9060)},
    {"xs4yu03.wav", "", int32_t(0x00000000), int32_t(0x04C743C5)},
    {"xs4yu04.wav", "", int32_t(0x00000000), int32_t(0x19C2737D)},
    {"xs4yu05.wav", "", int32_t(0x00000000), int32_t(0xD29EA0D8)},
    {"xs5so01.wav", "", int32_t(0x00000000), int32_t(0xDE982E8D)},
    {"xs5so02.wav", "", int32_t(0x00000000), int32_t(0x580C5C23)},
    {"xs5so03.wav", "", int32_t(0x00000000), int32_t(0x93508F86)},
    {"xs5so04.wav", "", int32_t(0x00000000), int32_t(0x8E55BF3E)},
    {"xs5so05.wav", "", int32_t(0x00000000), int32_t(0x45096C9B)},
    {"xs5so06.wav", "", int32_t(0x00000000), int32_t(0xC39D1E35)},
    {"xs5so07.wav", "", int32_t(0x00000000), int32_t(0x08C1CD90)},
    {"xs5so08.wav", "", int32_t(0x00000000), int32_t(0xF9977F45)},
    {"xs5so09.wav", "", int32_t(0x00000000), int32_t(0x32CBACE0)},
    {"xs5so10.wav", "", int32_t(0x00000000), int32_t(0xB3B3F69C)},
    {"xs5so11.wav", "", int32_t(0x00000000), int32_t(0x78EF2539)},
    {"xs5so12.wav", "", int32_t(0x00000000), int32_t(0xFE7B5797)},
    {"xs5so13.wav", "", int32_t(0x00000000), int32_t(0x35278432)},
    {"xs5so14.wav", "", int32_t(0x00000000), int32_t(0x2822B48A)},
    {"xs5yu01.wav", "", int32_t(0x00000000), int32_t(0xA6CD89F0)},
    {"xs5yu02.wav", "", int32_t(0x00000000), int32_t(0x2059FB5E)},
    {"xs6so01.wav", "", int32_t(0x00000000), int32_t(0x35AF958E)},
    {"xs6so02.wav", "", int32_t(0x00000000), int32_t(0xB33BE720)},
    {"xs6so03.wav", "", int32_t(0x00000000), int32_t(0x78673485)},
    {"xs6so04.wav", "", int32_t(0x00000000), int32_t(0x6562043D)},
    {"xs6yu01.wav", "", int32_t(0x00000000), int32_t(0x4DFA32F3)},
    {"xs6yu02.wav", "", int32_t(0x00000000), int32_t(0xCB6E405D)},
    {"xs7so01.wav", "", int32_t(0x00000000), int32_t(0xDA6DFEB0)},
    {"xs7so02.wav", "", int32_t(0x00000000), int32_t(0x5CF98C1E)},
    {"xs7so03.wav", "", int32_t(0x00000000), int32_t(0x97A55FBB)},
    {"xs7so04.wav", "", int32_t(0x00000000), int32_t(0x8AA06F03)},
    {"xs7yu01.wav", "", int32_t(0x00000000), int32_t(0xA23859CD)},
    {"xs7yu02.wav", "", int32_t(0x00000000), int32_t(0x24AC2B63)},
    {"xseaofiso.map", "", int32_t(0x00000000), int32_t(0x9A1B7A8D)},
    {"xshrapnel.map", "", int32_t(0x00000000), int32_t(0x38D73A35)},
    {"xtanyas.map", "", int32_t(0x00000000), int32_t(0x8987E6D5)},
    {"xterritor.map", "", int32_t(0x00000000), int32_t(0x76823890)},
    {"xtn01mw.map", "", int32_t(0x00000000), int32_t(0x1FD23673)},
    {"xtn01t2.map", "", int32_t(0x00000000), int32_t(0xB5AD7187)},
    {"xtn02mw.map", "", int32_t(0x00000000), int32_t(0x915D3190)},
    {"xtn02s4.map", "", int32_t(0x00000000), int32_t(0x28DCABF7)},
    {"xtn03mw.map", "", int32_t(0x00000000), int32_t(0x5DF7310E)},
    {"xtn03t8.map", "", int32_t(0x00000000), int32_t(0x5613559C)},
    {"xtn04mw.map", "", int32_t(0x00000000), int32_t(0x57323817)},
    {"xtn04t2.map", "", int32_t(0x00000000), int32_t(0xFD4D7FE3)},
    {"xtower.map", "", int32_t(0x00000000), int32_t(0xC44CFA6C)},
    {"xtowermw.map", "", int32_t(0x00000000), int32_t(0xA623E3F9)},
    {"xtra0001.int", "wall corners on grey floor", int32_t(0xBBF7FAEF), int32_t(0x00000000)},
    {"xtra0002.int", "wall corners on grey floor", int32_t(0xBDF7FAEF), int32_t(0x00000000)},
    {"xtra0003.int", "wall corners on grey floor", int32_t(0xBFF7FAEF), int32_t(0x00000000)},
    {"xtra0004.int", "wall corners on grey floor", int32_t(0xC1F7FAEF), int32_t(0x00000000)},
    {"xtra0005.int", "wall corners on green floor", int32_t(0xC3F7FAEF), int32_t(0x00000000)},
    {"xtra0006.int", "wall corners on green floor", int32_t(0xC5F7FAEF), int32_t(0x00000000)},
    {"xtra0007.int", "wall corners on green floor", int32_t(0xC7F7FAEF), int32_t(0x00000000)},
    {"xtra0008.int", "wall corners on green floor", int32_t(0xC9F7FAEF), int32_t(0x00000000)},
    {"xtra0009.int", "wall with fittings", int32_t(0xCBF7FAEF), int32_t(0x00000000)},
    {"xtra0010.int", "wall with fittings", int32_t(0xB9F9FAEF), int32_t(0x00000000)},
    {"xtra0011.int", "wall with fittings", int32_t(0xBBF9FAEF), int32_t(0x00000000)},
    {"xtra0012.int", "computer", int32_t(0xBDF9FAEF), int32_t(0x00000000)},
    {"xtra0013.int", "computer", int32_t(0xBFF9FAEF), int32_t(0x00000000)},
    {"xtra0014.int", "generator", int32_t(0xC1F9FAEF), int32_t(0x00000000)},
    {"xtra0015.int", "equipment", int32_t(0xC3F9FAEF), int32_t(0x00000000)},
    {"xtra0016.int", "nuke sign tile", int32_t(0xC5F9FAEF), int32_t(0x00000000)},
    {"xtsunami.map", "", int32_t(0x00000000), int32_t(0x61CB19FF)},
    {"xvalley.map", "", int32_t(0x00000000), int32_t(0x9E924FA8)},
    {"xvalleymw.map", "", int32_t(0x00000000), int32_t(0xF592AD07)},
    {"xxicon.shp", "icon: blank", int32_t(0x00000000), int32_t(0xD8DE3F2E)},
    {"xxmas.map", "", int32_t(0x00000000), int32_t(0xA813FA32)},
    {"xxxx.vqa", "", int32_t(0xF20206DE), int32_t(0x00000000)},
    {"xxxx_0.vqa", "", int32_t(0x0DBE036F), int32_t(0x00000000)},
    {"xxxx_1.vqa", "", int32_t(0x0DBE056F), int32_t(0x00000000)},
    {"xxxx_2.vqa", "", int32_t(0x0DBE076F), int32_t(0x00000000)},
    {"xxxx_3.vqa", "", int32_t(0x0DBE096F), int32_t(0x00000000)},
    {"xyuriplot.map", "", int32_t(0x00000000), int32_t(0xB6190DD7)},
    {"y3.bmp", "", int32_t(0x00000000), int32_t(0x96CC16DB)},
    {"yabrck.shp", "", int32_t(0x00000000), int32_t(0xD00C1E22)},
    {"yabrck_a.shp", "", int32_t(0x00000000), int32_t(0x0FA32DFB)},
    {"yabrckmk.shp", "", int32_t(0x00000000), int32_t(0x0B0D96CA)},
    {"yacnst.shp", "", int32_t(0x00000000), int32_t(0x98171975)},
    {"yacnst_a.shp", "", int32_t(0x00000000), int32_t(0x47B82AAC)},
    {"yacnst_b.shp", "", int32_t(0x00000000), int32_t(0x0018507C)},
    {"yacnst_c.shp", "", int32_t(0x00000000), int32_t(0x3D7879CC)},
    {"yacnstmk.shp", "", int32_t(0x00000000), int32_t(0x4316919D)},
    {"yacomd.shp", "", int32_t(0x00000000), int32_t(0x8183B2E1)},
    {"yaggun.hva", "", int32_t(0x00000000), int32_t(0x7883B748)},
    {"yaggun.shp", "", int32_t(0x00000000), int32_t(0x389EC553)},
    {"yaggun.vxl", "", int32_t(0x00000000), int32_t(0xA8EC57CC)},
    {"yaggunmk.shp", "", int32_t(0x00000000), int32_t(0xE39F4DBB)},
    {"yagntc.shp", "", int32_t(0x00000000), int32_t(0x39401256)},
    {"yagntc_e.shp", "", int32_t(0x00000000), int32_t(0x136F874F)},
    {"yagntc_f.shp", "", int32_t(0x00000000), int32_t(0x54CFFD9F)},
    {"yagntc_h.shp", "", int32_t(0x00000000), int32_t(0xEBFF43FE)},
    {"yagntcmk.shp", "", int32_t(0x00000000), int32_t(0xE2419ABE)},
    {"yagrnd.shp", "", int32_t(0x00000000), int32_t(0x5B68B05E)},
    {"yagrnd_a.shp", "", int32_t(0x00000000), int32_t(0x84C78387)},
    {"yagrnd_b.shp", "", int32_t(0x00000000), int32_t(0xC367F957)},
    {"yagrnd_c.shp", "", int32_t(0x00000000), int32_t(0xFE07D0E7)},
    {"yagrndmk.shp", "", int32_t(0x00000000), int32_t(0x806938B6)},
    {"yak.shp", "unit: yak", int32_t(0x5CE6CB05), int32_t(0x00000000)},
    {"yakicon.shp", "icon: yak", int32_t(0x8219EC3E), int32_t(0x00000000)},
    {"yapowr.shp", "", int32_t(0x00000000), int32_t(0xA46F0C1D)},
    {"yapowr_a.shp", "", int32_t(0x00000000), int32_t(0x7BC03FC4)},
    {"yapowr_b.shp", "", int32_t(0x00000000), int32_t(0x3C604514)},
    {"yapowr_c.shp", "", int32_t(0x00000000), int32_t(0x01006CA4)},
    {"yapowrmk.shp", "", int32_t(0x00000000), int32_t(0x7F6E84F5)},
    {"yappet.shp", "", int32_t(0x00000000), int32_t(0x8A5882D1)},
    {"yappet_a.shp", "", int32_t(0x00000000), int32_t(0x55F7B108)},
    {"yappet_e.shp", "", int32_t(0x00000000), int32_t(0xA07717C8)},
    {"yappet_f.shp", "", int32_t(0x00000000), int32_t(0xE7D76D18)},
    {"yappet_g.shp", "", int32_t(0x00000000), int32_t(0xDAB744A8)},
    {"yappet_h.shp", "", int32_t(0x00000000), int32_t(0x58E7D379)},
    {"yappetmk.shp", "", int32_t(0x00000000), int32_t(0x51590A39)},
    {"yapppt.shp", "", int32_t(0x00000000), int32_t(0xBE03BD9E)},
    {"yapsyt.shp", "", int32_t(0x00000000), int32_t(0x98C19A70)},
    {"yapsyt_a.shp", "", int32_t(0x00000000), int32_t(0x476EA9A9)},
    {"yapsyt_b.shp", "", int32_t(0x00000000), int32_t(0x00CED379)},
    {"yapsytmk.shp", "", int32_t(0x00000000), int32_t(0x43C01298)},
    {"yardicon.shp", "", int32_t(0x00000000), int32_t(0xD47E500D)},
    {"yarefn.shp", "", int32_t(0x00000000), int32_t(0x25DB91B1)},
    {"yarefn_a.shp", "", int32_t(0x00000000), int32_t(0xFA74A268)},
    {"yarefnmk.shp", "", int32_t(0x00000000), int32_t(0xFEDA1959)},
    {"yarock.shp", "", int32_t(0x00000000), int32_t(0xAA2D3AEC)},
    {"yarock_a.shp", "", int32_t(0x00000000), int32_t(0x75820935)},
    {"yatech.shp", "", int32_t(0x00000000), int32_t(0x03F5DAA8)},
    {"yatech_a.shp", "", int32_t(0x00000000), int32_t(0xDC5AE971)},
    {"yatechmk.shp", "", int32_t(0x00000000), int32_t(0xD8F45240)},
    {"yawall.shp", "", int32_t(0x00000000), int32_t(0x98410618)},
    {"yaweap.shp", "", int32_t(0x00000000), int32_t(0xFED6B47F)},
    {"yaweap_1.shp", "", int32_t(0x00000000), int32_t(0xD8AB6769)},
    {"yaweap_2.shp", "", int32_t(0x00000000), int32_t(0x9F0B1DB9)},
    {"yaweap_3.shp", "", int32_t(0x00000000), int32_t(0xA26B3409)},
    {"yaweap_4.shp", "", int32_t(0x00000000), int32_t(0x104BE819)},
    {"yaweap_a.shp", "", int32_t(0x00000000), int32_t(0x217987A6)},
    {"yaweap_ad.shp", "", int32_t(0x00000000), int32_t(0xF1A00C97)},
    {"yaweapad.shp", "", int32_t(0x00000000), int32_t(0xD0456B3D)},
    {"yaweapbb.shp", "", int32_t(0x00000000), int32_t(0xD991EC33)},
    {"yaweapmk.shp", "", int32_t(0x00000000), int32_t(0x25D73C97)},
    {"yayard.shp", "", int32_t(0x00000000), int32_t(0xDC565BD5)},
    {"yayard_a.shp", "", int32_t(0x00000000), int32_t(0x03F9680C)},
    {"yayard_c.shp", "", int32_t(0x00000000), int32_t(0x79393B6C)},
    {"yayard_d.shp", "", int32_t(0x00000000), int32_t(0xCB19E77C)},
    {"yayard_s.shp", "", int32_t(0x00000000), int32_t(0x19D9ACEE)},
    {"yayardmk.shp", "", int32_t(0x00000000), int32_t(0x0757D33D)},
    {"ycab.hva", "", int32_t(0x00000000), int32_t(0x6FC10521)},
    {"ycab.vxl", "", int32_t(0x00000000), int32_t(0x994BDA68)},
    {"yclnicon.shp", "", int32_t(0x00000000), int32_t(0x205BD209)},
    {"yclnuico.shp", "", int32_t(0x00000000), int32_t(0xE59D40E8)},
    {"yconicon.shp", "", int32_t(0x00000000), int32_t(0xCB6C690A)},
    {"ydggun.shp", "", int32_t(0x00000000), int32_t(0x49C96911)},
    {"ydggunmk.shp", "", int32_t(0x00000000), int32_t(0x92C8E1F9)},
    {"ydpppt.shp", "", int32_t(0x00000000), int32_t(0xCF5411DC)},
    {"yeah1.aud", "commando yeah", int32_t(0xCB87720B), int32_t(0x00000000)},
    {"yell1.aud", "yell", int32_t(0xDBB3720B), int32_t(0x00000000)},
    {"yell1m1.aud", "", int32_t(0x8DD80508), int32_t(0x00000000)},
    {"yell1m2.aud", "", int32_t(0x8DDA0508), int32_t(0x00000000)},
    {"yell1m3.aud", "", int32_t(0x8DDC0508), int32_t(0x00000000)},
    {"yengicon.shp", "", int32_t(0x00000000), int32_t(0x60B87E2C)},
    {"yenguico.shp", "", int32_t(0x00000000), int32_t(0xA57EECCD)},
    {"yes1.aud", "commando yes sir!", int32_t(0xA6FBCBE0), int32_t(0x00000000)},
    {"yessir1.r00", "soviet #1 yes sir?!", int32_t(0xA9DFEA49), int32_t(0x00000000)},
    {"yessir1.r01", "soviet #2 yes sir?!", int32_t(0xA9E0EA49), int32_t(0x00000000)},
    {"yessir1.r02", "soviet #3 yes sir?!", int32_t(0xA9E1EA49), int32_t(0x00000000)},
    {"yessir1.r03", "soviet #4 yes sir?!", int32_t(0xA9E2EA49), int32_t(0x00000000)},
    {"yessir1.v00", "c&c #1 yes sir!", int32_t(0xA9DFEA4D), int32_t(0x00000000)},
    {"yessir1.v01", "c&c #2 yes sir!", int32_t(0xA9E0EA4D), int32_t(0x00000000)},
    {"yessir1.v02", "c&c #3 yes sir!", int32_t(0xA9E1EA4D), int32_t(0x00000000)},
    {"yessir1.v03", "c&c #4 yes sir!", int32_t(0xA9E2EA4D), int32_t(0x00000000)},
    {"ygbrck.shp", "", int32_t(0x00000000), int32_t(0x38B9D461)},
    {"ygbrck_a.shp", "", int32_t(0x00000000), int32_t(0xE716E7B8)},
    {"ygbrckmk.shp", "", int32_t(0x00000000), int32_t(0xE3B85C89)},
    {"ygcnst.shp", "", int32_t(0x00000000), int32_t(0x70A2D336)},
    {"ygcnst_a.shp", "", int32_t(0x00000000), int32_t(0xAF0DE0EF)},
    {"ygcnst_b.shp", "", int32_t(0x00000000), int32_t(0xE8AD9A3F)},
    {"ygcnst_c.shp", "", int32_t(0x00000000), int32_t(0xD5CDB38F)},
    {"ygcnstmk.shp", "", int32_t(0x00000000), int32_t(0xABA35BDE)},
    {"ygcomd.shp", "", int32_t(0x00000000), int32_t(0x693678A2)},
    {"ygggun.shp", "", int32_t(0x00000000), int32_t(0xD02B0F10)},
    {"ygggunmk.shp", "", int32_t(0x00000000), int32_t(0x0B2A87F8)},
    {"yggntc.shp", "", int32_t(0x00000000), int32_t(0xD1F5D815)},
    {"yggntc_e.shp", "", int32_t(0x00000000), int32_t(0xFBDA4D0C)},
    {"yggntc_f.shp", "", int32_t(0x00000000), int32_t(0xBC7A37DC)},
    {"yggntc_h.shp", "", int32_t(0x00000000), int32_t(0x034A89BD)},
    {"yggntcmk.shp", "", int32_t(0x00000000), int32_t(0x0AF450FD)},
    {"yggrnd.shp", "", int32_t(0x00000000), int32_t(0xB3DD7A1D)},
    {"yggrnd_a.shp", "", int32_t(0x00000000), int32_t(0x6C7249C4)},
    {"yggrnd_b.shp", "", int32_t(0x00000000), int32_t(0x2BD23314)},
    {"yggrnd_c.shp", "", int32_t(0x00000000), int32_t(0x16B21AA4)},
    {"yggrndmk.shp", "", int32_t(0x00000000), int32_t(0x68DCF2F5)},
    {"ygpowr.shp", "", int32_t(0x00000000), int32_t(0x4CDAC65E)},
    {"ygpowr_a.shp", "", int32_t(0x00000000), int32_t(0x9375F587)},
    {"ygpowr_b.shp", "", int32_t(0x00000000), int32_t(0xD4D58F57)},
    {"ygpowr_c.shp", "", int32_t(0x00000000), int32_t(0xE9B5A6E7)},
    {"ygpowrmk.shp", "", int32_t(0x00000000), int32_t(0x97DB4EB6)},
    {"ygppet.shp", "", int32_t(0x00000000), int32_t(0x62ED4892)},
    {"ygppet_a.shp", "", int32_t(0x00000000), int32_t(0xBD427B4B)},
    {"ygppet_e.shp", "", int32_t(0x00000000), int32_t(0x48C2DD8B)},
    {"ygppet_f.shp", "", int32_t(0x00000000), int32_t(0x0F62A75B)},
    {"ygppet_g.shp", "", int32_t(0x00000000), int32_t(0x32028EEB)},
    {"ygppet_h.shp", "", int32_t(0x00000000), int32_t(0xB052193A)},
    {"ygppetmk.shp", "", int32_t(0x00000000), int32_t(0xB9ECC07A)},
    {"ygpsyt.shp", "", int32_t(0x00000000), int32_t(0x70745033)},
    {"ygpsyt_a.shp", "", int32_t(0x00000000), int32_t(0xAFDB63EA)},
    {"ygpsyt_b.shp", "", int32_t(0x00000000), int32_t(0xE87B193A)},
    {"ygpsytmk.shp", "", int32_t(0x00000000), int32_t(0xAB75D8DB)},
    {"ygrefn.shp", "", int32_t(0x00000000), int32_t(0xCD6E5BF2)},
    {"ygrefn_a.shp", "", int32_t(0x00000000), int32_t(0x12C1682B)},
    {"ygrefnmk.shp", "", int32_t(0x00000000), int32_t(0x166FD31A)},
    {"ygrock.shp", "", int32_t(0x00000000), int32_t(0x4298F0AF)},
    {"ygrock_a.shp", "", int32_t(0x00000000), int32_t(0x9D37C376)},
    {"ygtech.shp", "", int32_t(0x00000000), int32_t(0xEB4010EB)},
    {"ygtech_a.shp", "", int32_t(0x00000000), int32_t(0x34EF2332)},
    {"ygtechmk.shp", "", int32_t(0x00000000), int32_t(0x30419803)},
    {"ygwall.shp", "", int32_t(0x00000000), int32_t(0x70F4CC5B)},
    {"ygweap.shp", "", int32_t(0x00000000), int32_t(0x16637E3C)},
    {"ygweap_1.shp", "", int32_t(0x00000000), int32_t(0x301EAD2A)},
    {"ygweap_2.shp", "", int32_t(0x00000000), int32_t(0x77BED7FA)},
    {"ygweap_3.shp", "", int32_t(0x00000000), int32_t(0x4ADEFE4A)},
    {"ygweap_4.shp", "", int32_t(0x00000000), int32_t(0xF8FE225A)},
    {"ygweap_a.shp", "", int32_t(0x00000000), int32_t(0xC9CC4DE5)},
    {"ygweap_ad.shp", "", int32_t(0x00000000), int32_t(0xD35AD865)},
    {"ygweapad.shp", "", int32_t(0x00000000), int32_t(0x38F0A17E)},
    {"ygweapbb.shp", "", int32_t(0x00000000), int32_t(0x31242670)},
    {"ygweapmk.shp", "", int32_t(0x00000000), int32_t(0xCD62F6D4)},
    {"ygyard.shp", "", int32_t(0x00000000), int32_t(0x34E39196)},
    {"ygyard_a.shp", "", int32_t(0x00000000), int32_t(0xEB4CA24F)},
    {"ygyard_c.shp", "", int32_t(0x00000000), int32_t(0x918CF12F)},
    {"ygyard_d.shp", "", int32_t(0x00000000), int32_t(0x23AC2D3F)},
    {"ygyard_s.shp", "", int32_t(0x00000000), int32_t(0xF16C66AD)},
    {"ygyardmk.shp", "", int32_t(0x00000000), int32_t(0xEFE2197E)},
    {"yhvr.hva", "", int32_t(0x00000000), int32_t(0x13F5F47A)},
    {"yhvr.vxl", "", int32_t(0x00000000), int32_t(0xE57F2B33)},
    {"yhvricon.shp", "", int32_t(0x00000000), int32_t(0x7902F509)},
    {"yhvruico.shp", "", int32_t(0x00000000), int32_t(0xBCC467E8)},
    {"ylcomd.shp", "", int32_t(0x00000000), int32_t(0x4A17FFE6)},
    {"ylggun.shp", "", int32_t(0x00000000), int32_t(0xF30A8854)},
    {"ylggunmk.shp", "", int32_t(0x00000000), int32_t(0x280B00BC)},
    {"ylpppt.shp", "", int32_t(0x00000000), int32_t(0x7597F099)},
    {"ynpppt.shp", "", int32_t(0x00000000), int32_t(0x2DFB4958)},
    {"yo1.aud", "commando yo", int32_t(0x5CA6F3F3), int32_t(0x00000000)},
    {"ypcvicon.shp", "", int32_t(0x00000000), int32_t(0xF15CCB27)},
    {"ypcvuico.shp", "", int32_t(0x00000000), int32_t(0x349A59C6)},
    {"ypwricon.shp", "", int32_t(0x00000000), int32_t(0x82F5BBB9)},
    {"yrii.pal", "", int32_t(0x00000000), int32_t(0x5CEC2BC4)},
    {"yrii.pcx", "", int32_t(0x00000000), int32_t(0x74009D3B)},
    {"yrii.shp", "", int32_t(0x00000000), int32_t(0x9B69729B)},
    {"yscore.pal", "", int32_t(0x00000000), int32_t(0x22BD3032)},
    {"yscrbkl.pal", "", int32_t(0x00000000), int32_t(0x463DCE03)},
    {"yscrbkmd.shp", "", int32_t(0x00000000), int32_t(0x5CAF17B1)},
    {"yscrbksm.pal", "", int32_t(0x00000000), int32_t(0xAFE64F74)},
    {"ytchicon.shp", "", int32_t(0x00000000), int32_t(0x25872146)},
    {"ytnk.hva", "", int32_t(0x00000000), int32_t(0x31FE77C5)},
    {"ytnk.vxl", "", int32_t(0x00000000), int32_t(0xC774A88C)},
    {"ytnkicon.shp", "", int32_t(0x00000000), int32_t(0xE9F49633)},
    {"ytnktur.hva", "", int32_t(0x00000000), int32_t(0x1718AC06)},
    {"ytnktur.vxl", "", int32_t(0x00000000), int32_t(0x18EEDFED)},
    {"ytnkuico.shp", "", int32_t(0x00000000), int32_t(0x2C3204D2)},
    {"ytpppt.shp", "", int32_t(0x00000000), int32_t(0x61A2D517)},
    {"yuggun.shp", "", int32_t(0x00000000), int32_t(0x26B1721A)},
    {"yuggunmk.shp", "", int32_t(0x00000000), int32_t(0xFDB0FAF2)},
    {"yupppt.shp", "", int32_t(0x00000000), int32_t(0xA02C0AD7)},
    {"yuri.bmp", "", int32_t(0x00000000), int32_t(0x574C834F)},
    {"yuri.shp", "", int32_t(0x00000000), int32_t(0x37DFBE4D)},
    {"yuricntl.shp", "", int32_t(0x00000000), int32_t(0xD8D8DC23)},
    {"yuridie.shp", "", int32_t(0x00000000), int32_t(0xC59DB260)},
    {"yuriicon.shp", "", int32_t(0x00000000), int32_t(0x3B1E0013)},
    {"yuripr.shp", "", int32_t(0x00000000), int32_t(0xC76A1BFA)},
    {"yuriuico.shp", "", int32_t(0x00000000), int32_t(0xFED892F2)},
    {"yurix.shp", "", int32_t(0x00000000), int32_t(0xFCF99EEB)},
    {"yurpicon.shp", "", int32_t(0x00000000), int32_t(0x3B7DF439)},
    {"yurpuico.shp", "", int32_t(0x00000000), int32_t(0xFEBB66D8)},
    {"ywepicon.shp", "", int32_t(0x00000000), int32_t(0xA663D769)},
    {"yypricon.shp", "", int32_t(0x00000000), int32_t(0x1B649E45)},
    {"yypruico.shp", "", int32_t(0x00000000), int32_t(0xDEA20CA4)},
    {"yyrdicon.shp", "", int32_t(0x00000000), int32_t(0xC04B7583)},
    {"zbomb.hva", "", int32_t(0x00000000), int32_t(0x09600347)},
    {"zbomb.vxl", "", int32_t(0x00000000), int32_t(0xB6F904E0)},
    {"zep.hva", "", int32_t(0x00000000), int32_t(0x8372FE05)},
    {"zep.vxl", "", int32_t(0x00000000), int32_t(0x8C848DEE)},
    {"zepicon.shp", "", int32_t(0x00000000), int32_t(0x1BD2B886)},
    {"zepuico.shp", "", int32_t(0x00000000), int32_t(0xCC1AACFA)},
    {"zombatk1.aud", "", int32_t(0xB0212719), int32_t(0x00000000)},
    {"zombatk2.aud", "", int32_t(0xB2212719), int32_t(0x00000000)},
    {"zombdie1.aud", "", int32_t(0xB015111F), int32_t(0x00000000)},
    {"zombdie2.aud", "", int32_t(0xB215111F), int32_t(0x00000000)},
    {"zombdie3.aud", "", int32_t(0xB415111F), int32_t(0x00000000)},
    {"zombhit1.aud", "", int32_t(0xB0331127), int32_t(0x00000000)},
    {"zombhit2.aud", "", int32_t(0xB2331127), int32_t(0x00000000)},
    {"zombhit3.aud", "", int32_t(0xB4331127), int32_t(0x00000000)},
    {"zombie1.aud", "", int32_t(0x65DC1D3C), int32_t(0x00000000)},
    {"zombie2.aud", "", int32_t(0x65DE1D3C), int32_t(0x00000000)},
    {"zombinc1.aud", "", int32_t(0xB0111B29), int32_t(0x00000000)},
    {"zombinc2.aud", "", int32_t(0xB2111B29), int32_t(0x00000000)},
    {"zombloi1.aud", "", int32_t(0xB01D1D2F), int32_t(0x00000000)},
    {"zombloi2.aud", "", int32_t(0xB21D1D2F), int32_t(0x00000000)},
    {"zombloi3.aud", "", int32_t(0xB41D1D2F), int32_t(0x00000000)},
    {"zombpck1.aud", "", int32_t(0xB0210537), int32_t(0x00000000)},
    {"zombpck2.aud", "", int32_t(0xB2210537), int32_t(0x00000000)},
    {"zombwlk1.aud", "", int32_t(0xB0211745), int32_t(0x00000000)},
    {"zombwlk2.aud", "", int32_t(0xB2211745), int32_t(0x00000000)},
    {"zoom.vqa", "", int32_t(0xDBEFF4E2), int32_t(0x00000000)},
    {"zounds.inf", "inf: list for zounds.mix", int32_t(0xCBB22A3F), int32_t(0x00000000)},
    {"zubdead1.aud", "", int32_t(0xB7E71921), int32_t(0x00000000)},
    {"zubland1.aud", "", int32_t(0xD7E73319), int32_t(0x00000000)},
    {"zubwlk1.aud", "", int32_t(0xB9B04142), int32_t(0x00000000)},
    {"zubwlk2.aud", "", int32_t(0xB9B24142), int32_t(0x00000000)},
    {"zubwlk3.aud", "", int32_t(0xB9B44142), int32_t(0x00000000)},
    {"zubwlk4.aud", "", int32_t(0xB9B64142), int32_t(0x00000000)},
    {"", "", int32_t(0x00000000), int32_t(0x00000000)},
};
